CRYSTALS CODE FOR CHARACTER
CODE FOR KCCEQL
      FUNCTION KCCEQL ( CDATA , ISTART , CMATCH )
C
C -- LOCATE SUBSTRING IN STRING
C
C -- THIS FUNCTION IS SIMILAR TO FORTRAN 'INDEX'
C
C      CDATA       STRING IN WHICH TO SEARCH
C      ISTART      STARTING POSITION IN 'CDATA'
C      CMATCH      STRING TO SEARCH FOR
C
C      KCCEQL      -1      NO MATCH
C                  +VE     POSITION IN 'CDATA' OF CMATCH
C
C
      CHARACTER*(*) CDATA , CMATCH
C
C
      KCCEQL = -1
C
      LENMAT = LEN ( CMATCH )
      LENDAT = LEN ( CDATA )
      IFINSH = LENDAT - LENMAT + 1
C
      IF ( ISTART .LE. 0 ) RETURN
      IF ( ISTART .GT. IFINSH ) RETURN
C
      IPOS = INDEX ( CDATA(ISTART:) , CMATCH )
      IF ( IPOS .LE. 0 ) RETURN
C
      KCCEQL = ISTART + IPOS - 1
      RETURN
      END
C
C
C
C
C
CODE FOR KCCNEQ
      FUNCTION KCCNEQ ( CDATA , ISTART , CMATCH )
C
C -- FIND FIRST POSITION IN STRING NOT CORRESPONDING TO SUBSTRING
C
C -- THIS FUNCTION IS SIMILAR TO FORTRAN 'INDEX'
C
C      CDATA       STRING IN WHICH TO SEARCH
C      ISTART      STARTING POSITION IN 'CDATA'
C      CMATCH      STRING TO SEARCH FOR ( USUALLY LENGTH = 1 )
C
C      KCCNEQ      -1      NO MATCH
C                  +VE     POSITION IN 'CDATA' OF FIRST MISMATCH
C
C
      CHARACTER*(*) CDATA , CMATCH
C
C
      KCCNEQ = -1
C
      LENMAT = LEN ( CMATCH )
      LENDAT = LEN ( CDATA )
      IFINSH = LENDAT - LENMAT + 1
C
      IF ( ISTART .LE. 0 ) RETURN
      IF ( ISTART .GT. IFINSH ) RETURN
C
      DO 1100 I = ISTART , IFINSH
        IF ( CDATA(I:I+LENMAT-1) .EQ. CMATCH ) GO TO 1100
        KCCNEQ = I
        RETURN
1100  CONTINUE
C
      RETURN
      END
C
C
C
C
C
CODE FOR KCCARG
      FUNCTION KCCARG ( CINPUT , ISTART , IFUNC , IPOS1 , IPOS2 )
C
C -- IDENTIFY NEXT ARGUMENT FROM CHARACTER INPUT
C
C      CINPUT      INPUT STRING
C      ISTART      STARTING POSITION IN CINPUT ( ISTART IS UPDATED BY
C                  THIS ROUTINE TO POINT TO NEXT NON-SPACE CHARACTER
C                  AFTER ARGUMENT FOUND )
C      IFUNC       FUNCTION REQUIRED
C                    1      ARGUMENT DELIMITTED BY SPACES
C                    2      ARGUMENT DELIMITTED BY NEXT NON-SPACE
C                           CHARACTER
C                    3      ARGUMENT DELIMITTED BY SPACE, OR COMMA
C                           FOLLOWED BY NON-SPACE CHARACTER
C
C      IPOS1       STARTING POSITION OF ARGUMENT FOUND
C      IPOS2       END OF ARGUMENT FOUND
C
C      KCCARG      -VE      NO ARGUMENT
C                  +VE      LENGTH OF ARGUMENT FOUND
C
C
C
      CHARACTER*(*) CINPUT
      CHARACTER*1 CDEL1 , CDEL2
C
      KCCARG = -1
      IF ( ISTART .GT. LEN ( CINPUT ) ) RETURN
C
      IPOS1 = KCCNEQ ( CINPUT , ISTART , ' ' )
      IF ( IPOS1 .LE. 0 ) RETURN
C
      IF ( IFUNC .EQ. 1 ) THEN
        IPOS2 = KCCEQL ( CINPUT , IPOS1 , ' ' )
      ELSE IF ( IFUNC .EQ. 2 ) THEN
        CDEL2 = CINPUT(IPOS1:IPOS1)
        IPOS2 = KCCEQL ( CINPUT , IPOS1 + 1 , CDEL2 )
        IPOS1 = IPOS1 + 1
      ELSE IF ( IFUNC .EQ. 3 ) THEN
      ICOMMA = KCCEQL ( CINPUT , IPOS1 , ',' )
      IF ( ICOMMA .LE. 0 ) ICOMMA = LEN ( CINPUT ) + 1
      ISPACE = KCCEQL ( CINPUT , IPOS1 , ' ' )
      IF ( ISPACE .LE. 0 ) ISPACE = LEN ( CINPUT ) + 1
        IPOS2 = MIN0 ( ICOMMA , ISPACE )
C -- IF ',' WAS THE DELIMITTER, CHECK THAT IT IS FOLLOWED BY ANOTHER
C    ARGUMENT
        IF ( IPOS2 .EQ. ICOMMA ) THEN
          IF ( KCCNEQ ( CINPUT , IPOS2 + 1 , ' ' ) .LE. 0 ) RETURN
        ENDIF
      ENDIF
C
      IF ( IPOS2 .LE. 0 ) RETURN
C
      ISTART = KCCNEQ ( CINPUT , IPOS2 + 1 , ' ' )
      IPOS2 = IPOS2 - 1
C
C
      KCCARG = IPOS2 - IPOS1 + 1
      RETURN
      END
C
C
C
C
C
CODE FOR KCCOMP
      FUNCTION KCCOMP ( CMATCH , CKEYS , NKEYS , IEXACT )
C
C -- MATCH CHARACTER STRINGS
C
C      CMATCH      STRING TO BE MATCHED
C      CKEYS       CHARACTER ARRAY OF STRINGS TO BE MATCHED WITH
C      NKEYS       NUMBER OF KEYS
C      IEXACT      MATCH TYPE
C                    1      EXACT MATCH
C                    2      FIRST ABBREVIATED MATCH
C                    3      UNAMBIGUOUS ABBREVIATED MATCH
C
C
C      KCCOMP      +VE      POSITION IN 'CKEYS' OF MATCHED STRING
C                  -VE      NO MATCH
C
C
      CHARACTER*(*) CMATCH
      CHARACTER*(*) CKEYS(NKEYS)
C
C
      LENMAT = LEN ( CMATCH )
      LENKEY = LEN ( CKEYS(1) )
C
C
      IF ( IEXACT .EQ. 1 ) THEN
        IF ( LENMAT .GT. LENKEY ) GO TO 9900
        LENMAT = MIN0 ( LENMAT , LENKEY )
      ELSE IF ( ( IEXACT .EQ. 2 ) .OR. ( IEXACT .EQ. 3 ) ) THEN
        IF ( LENMAT .GT. LENKEY ) GO TO 9900
        LENKEY = MIN0 ( LENMAT , LENKEY )
      ENDIF
C
      NMATCH = 0
      LMATCH = 0
C
      DO 2000 I = 1 , NKEYS
        IF ( CMATCH(1:LENMAT) .NE. CKEYS(I)(1:LENKEY) ) GO TO 2000
C
        LMATCH = I
        IF ( IEXACT .EQ. 3 ) THEN
          IF ( NMATCH .GT. 0 ) GO TO 9910
        ELSE
          GO TO 9000
        ENDIF
        NMATCH = NMATCH + 1
2000  CONTINUE
C
      IF ( NMATCH .EQ. 1 ) GO TO 9000
      GO TO 9900
C
C
9000  CONTINUE
      KCCOMP = LMATCH
      RETURN
C
C
9900  CONTINUE
9910  CONTINUE
      KCCOMP = -1
      RETURN
C
C
      END
C
C
C
C
C
CODE FOR XCCUPC
      SUBROUTINE XCCUPC ( CLOWER , CUPPER )
C
C -- CONVERT STRING TO UPPERCASE
C
C      CLOWER      SOURCE STRING TO BE CONVERTED
C      CUPPER      RESULTANT STRING
C
C
      CHARACTER*(*) CLOWER , CUPPER
C
      CHARACTER*26 CALPHA , CEQUIV
C
      DATA CALPHA / 'abcdefghijklmnopqrstuvwxyz' /
      DATA CEQUIV / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' /
C
C
C -- MOVE WHOLE STRING.
      CUPPER = CLOWER
C
      LENGTH = MIN0 ( LEN ( CLOWER ) , LEN ( CUPPER ) )
C
C -- SEARCH FOR LOWERCASE CHARACTERS AND CONVERT TO UPPERCASE
      DO 2000 I = 1 , LENGTH
        IPOS = INDEX ( CALPHA , CLOWER(I:I) )
        IF ( IPOS .GT. 0 ) CUPPER(I:I) = CEQUIV(IPOS:IPOS)
2000  CONTINUE
C
C
      RETURN
      END
C
C
C
C
C
C
CODE FOR XCCLWC
      SUBROUTINE XCCLWC ( CSOURC, CLOWER )
C
C -- CONVERT STRING TO LOWERCASE
C
C      CSOURC      SOURCE STRING TO BE CONVERTED
C      CLOWER      RESULTANT STRING
C
C
      CHARACTER*(*) CSOURC,  CLOWER
C
      CHARACTER*26 CALPHA , CEQUIV
C
      DATA CALPHA / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' /
      DATA CEQUIV / 'abcdefghijklmnopqrstuvwxyz' /
C
C
C -- MOVE WHOLE STRING.
      CLOWER = CSOURC
C
      LENGTH = MIN0 ( LEN ( CSOURC) , LEN ( CLOWER ) )
C
C -- SEARCH FOR UPPERCASE CHARACTERS AND CONVERT TO LOWERCASE
      DO 2000 I = 1 , LENGTH
        IPOS = INDEX ( CALPHA , CSOURC(I:I) )
        IF ( IPOS .GT. 0 ) CLOWER(I:I) = CEQUIV(IPOS:IPOS)
2000  CONTINUE
C
C
      RETURN
      END
C
CODE FOR KHKIBM
      FUNCTION KHKIBM (CSOURC)
C----- REMOVE ANY NULL CHARACTERS AND LEFT ADJUST THE REMAINDER
      CHARACTER *1 CNULL, CBUFF
      CHARACTER *(*) CSOURC
      KHKIBM = 0
&VAX      IF (CSOURC .NE. 'ZZZZZX') RETURN
      CNULL = CHAR(0)
      K = LEN (CSOURC)
      IF (K .GE. 1 ) THEN
        J = 0
        DO 20 I = 1,K
          CBUFF = CSOURC(I:I)
          IF ( CBUFF .NE. CNULL) THEN
            J = J + 1
            CSOURC(J:J) = CBUFF
          ENDIF
20      CONTINUE
        IF (J+1 .LE. K) CSOURC(J+1:K) = ' '
      ENDIF
      RETURN
      END
C
C
CODE FOR XCTRIM
      SUBROUTINE XCTRIM( CSOURC, NCHAR)
C------ TRIM OFF TRAILING SPACES
C      CSOURC - SOURCE STRING
C      NCHAR   - LAST NON-SPACE CHARACTER
      CHARACTER *(*) CSOURC
      CHARACTER *1 CBLANK
      DATA CBLANK /' '/
C
      LENGTH = LEN (CSOURC)
      DO 100 I = LENGTH, 1, -1
      IF (CSOURC(I:I) .NE. CBLANK) GOTO 200
100   CONTINUE
      I = 0
200   CONTINUE
      NCHAR = I + 1
      RETURN
      END
C
CODE FOR XCREMS
      SUBROUTINE XCREMS( CSOURC, COUT, LENFIL)
C
C----- REMOVE EXTRA SPACES BY LEFT ADJUSTING STRING
C----- ROUTINE EXITS WHEN OUT STRING FULL
C      LENFIL      USEFUL LENGTH OF RETURNED STRING
C
      CHARACTER *(*) CSOURC, COUT
      CHARACTER *1 CBUF
C
      LIN = LEN (CSOURC)
      LOUT = LEN (COUT)
      J = 0
      IFLAG = 0
      DO 1500 I = 1, LIN
      CBUF = CSOURC(I:I)
      IF (CBUF .EQ. ' ') THEN
            IF (IFLAG .EQ. 1) THEN
                  GOTO 1500
            ELSE
                  IFLAG = 1
            ENDIF
      ELSE
            IFLAG = 0
      ENDIF
      IF (J .LT. LOUT) THEN
            J = J + 1
            COUT(J:J) = CBUF
      ELSE
            GOTO 1600
      ENDIF
1500  CONTINUE
1600  CONTINUE
      LENFIL = J
      IF (LENFIL .LT. LOUT) COUT(LENFIL+1:LOUT) = ' '
C
      RETURN
      END
C
CODE FOR XCRAS
      SUBROUTINE XCRAS ( CSOURC, LENNAM )
C
C----- REMOVE ALL SPACES BY LEFT ADJUSTING STRING
C
C      CSOURC      SOURCE STRING TO BE CONVERTED
C      LENNAM      USEFUL LENGTH
C
C
      CHARACTER *(*) CSOURC
      CHARACTER *1  CBUF
C
      LENFIL=  LEN(CSOURC)
      K = 1
      DO 100 I = 1 , LENFIL
       CBUF = CSOURC(I:I)
       IF (CBUF .NE. ' ') THEN
           CSOURC(K:K) = CBUF
         K = K + 1
       ENDIF
100   CONTINUE
      LENNAM = MAX (1, K-1)
      IF (LENNAM .LT. LENFIL) CSOURC(LENNAM+1:LENFIL) = ' '
      RETURN
      END
C
C
CODE FOR KGTNUM
      FUNCTION KGTNUM( CTEXT, CTERM, NCHAR)
C
C----- GET AN INTEGER NUMBER FROM A TEXT STRING
C
C      CTEXT TEXT STRING
C      CTERM TERMINATOR FOUND
C      NCHAR NUMBER OF CHARACTERS IN NUMBER
C
      CHARACTER *(*) CTEXT
      CHARACTER *1 CTERM
      CHARACTER *9 CNUM
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
C
      DATA CNUM / '123456789' /
C
      LENGTH = LEN (CTEXT)
      KGTNUM = 0
      NCHAR = 0
      CTERM = ' '
C
      DO 1000 I = 1, LENGTH
      IVAL = INDEX (CNUM, CTEXT(I:I))
      IF (IVAL .GT. 0) THEN
            KGTNUM = 10 * KGTNUM + IVAL
            NCHAR = NCHAR + 1
      ELSE
            CTERM = CTEXT(I:I)
            GOTO 1200
      ENDIF
1000  CONTINUE
1200  CONTINUE
      RETURN
      END
C
C
CODE FOR KCCNUM
      FUNCTION KCCNUM ( CINPUT , IRESLT , ITYPE )
C
C -- CONVERT STRING TO NUMERIC VALUE IF POSSIBLE
C
C      CINPUT      STRING TO BE CONVERTED
C      IRESLT      RESULT OF CONVERSION ( MAY BE REAL OR INTEGER )
C      ITYPE       TYPE OF NUMBER
C                    1      INTEGER
C                    2      REAL
C
C      KCCNUM      SUCCESS/FAILURE
C                    -1      FAILURE
C                    +1      SUCCESS
C
      CHARACTER*(*) CINPUT
      CHARACTER*11 CNUMER
      CHARACTER *1 CDOT
      CHARACTER*12 CBUFF1
      CHARACTER*20 CBUFF2
C
      PARAMETER (CDOT = '.')
      PARAMETER ( CNUMER = '0123456789.' )
C
      EQUIVALENCE ( XVALUE , IVALUE )
C
      KCCNUM = -1
      LENC = LEN (CINPUT)
C
C----- LOOK FOR A DECIMAL POINT, SINCE IBM COMPILERS STILL DONT STOP
C      EXECUTION ON A READ ERROR
      IF ( INDEX ( CNUMER , CINPUT(1:1) ) .LE. 0 ) RETURN
      IF ( INDEX ( CINPUT , CDOT ) .GT. 0 ) GOTO 1100
C
C----- TRY AS INTEGER
      ITYPE = 1
      CBUFF1 = CINPUT
      READ ( CBUFF1 , '(BN,I12)' , ERR = 1100 ) IVALUE
C
      IRESLT = IVALUE
      KCCNUM = 1
      RETURN
C
C----- TRY AS REAL
1100  CONTINUE
      ITYPE = 2
      CBUFF2 = CINPUT
      READ ( CBUFF2 , '(BN,F20.0)' , ERR = 1200 ) XVALUE
      CALL XMOVE ( IVALUE , IRESLT , 1 )
      KCCNUM = 1
      RETURN
C
1200  CONTINUE
      RETURN
C
C
      END
C
C
C
C
C
CODE FOR KCCINT
      FUNCTION    KCCINT (CTEXT, IVALUE)
C
C -- CONVERT TEXT TO INTEGER VALUE
C
C*************** MACHINE OR COMPILER SENSITIVE ********************
C
C      CTEXT       TEXT TO BE CONVERTED ( UP TO 20 CHARACTERS )
C      IVALUE      RESULTANT VALUE
C
C      KCCINT      -1      FAILURE
C                  +1      SUCCESS
C
C THE PARTIAL PRE-CHECKING BEFORE LABEL 100 IS NECESSARY FOR THOSE
C COMPILERS (EG IBM) WHICH DO NOT USE THE ERROR LABEL FOR TYPE
C MIS-MATCHES DURING INTERNAL READS.
C
      CHARACTER*(*) CTEXT
C
      CHARACTER *3 CSIGN
      CHARACTER *11 CNUMER
      CHARACTER *20 CBUFF1
C
      PARAMETER ( CNUMER = '0123456789.' )
C
      KCCINT = 1
C
      CBUFF1 = CTEXT
C
C
      DO 10 I = 1,20
        IF ((CBUFF1(I:I) .EQ. ' ') .OR. (CBUFF1(I:I) .EQ. '+')
     1      .OR. (CBUFF1(I:I) .EQ. '-') ) GOTO 5
        GOTO 15
5       CONTINUE
10    CONTINUE
C---- TREAT ALL SPACES AS AN INTEGER
      IF (CBUFF1(20:20) .EQ. ' ') GOTO 100
      GOTO 9900
C
15    CONTINUE
      DO 30 I = 1,20
        IF (INDEX(CNUMER, CBUFF1(I:I)) .LE. 0) GOTO 9900
30    CONTINUE
C
C----- NO CHARACTERS FOUND, TRY TO READ AS INTEGER
100   CONTINUE
      READ ( CBUFF1 ,'(BN,I20)', ERR=9900) IVALUE
      RETURN
C
9900  IVALUE = 0
      KCCINT = -1
      RETURN
C
      END
CODE FOR KCCREA
      FUNCTION KCCREA ( CTEXT , VALUE )
C
C -- CONVERT TEXT TO REAL VALUE
C
C      CTEXT       TEXT TO BE CONVERTED ( UP TO 20 CHARACTERS )
C      VALUE       RESULTANT VALUE
C
C      KCCREA      -1      FAILURE
C                  +1      SUCCESS
C
      CHARACTER*(*) CTEXT
C
      CHARACTER*20 CBUFF1
C
      KCCREA = 1
C
      CBUFF1 = CTEXT
      READ ( CBUFF1 , '(BN,F20.0)' , ERR = 9900 ) VALUE
      RETURN
C
9900  CONTINUE
      VALUE = 0
      KCCREA = -1
      RETURN
C
      END
CODE FOR KCCTRM
      FUNCTION KCCTRM ( IFUNC , CTEXT , ISTART , IEND )
C
C -- TRIM TEXT
C
C -- FIND, USING THE METHOD SPECIFIED, THE USEFUL PART OF 'CTEXT'
C
C
C      INPUTS :-
C
C            IFUNC       FUNCTION REQUIRED
C                        0      NO TRIMMING. ISTART AND IEND SET TO
C                               LIMITS OF 'CTEXT'
C                        1      TRIM TO ONE WORD. ISTART IS FIRST
C                               NON-SPACE CHARACTER. IEND IS AT END OF
C                               FIRST WORD
C
C            CTEXT       INPUT TEXT TO BE TRIMMED
C
C      OUTPUTS :-
C            ISTART      START OF USEFUL TEXT IN 'CTEXT'
C            IEND        END OF USEFUL TEXT IN 'CTEXT'
C
C      RETURN VALUE :-
C            -VE         FAILURE. THERE IS NOT ENOUGH TEXT TO TRIM
C            +VE         SUCCESS
C
      CHARACTER*(*) CTEXT
C
C
      ISTART = 1
      IEND = LEN ( CTEXT )
      KCCTRM = 1
C
      IF ( IFUNC .LE. 0 ) THEN
      ELSE IF ( IFUNC .EQ. 1 ) THEN
        ISTART = KCCNEQ ( CTEXT , ISTART , ' ' )
        IF ( ISTART .LE. 0 ) GO TO 9900
        IEND = KCCEQL ( CTEXT , ISTART , ' ' ) - 1
        IF ( IEND .LE. 0 ) IEND = LEN ( CTEXT )
      ENDIF
C
C
      RETURN
C
C
9900  CONTINUE
      KSCTRM = -1
      RETURN
C
C
      END
CODE FOR KCCAPP
      FUNCTION KCCAPP ( CTEXT , IPOS, CNEW )
C
C -- APPEND 'CNEW' TO 'CTEXT', STARTING AT POSITION IPOS+1, AND CHECKING
C    FOR EXCESSIVE LENGTH. IPOS IS UPDATED BY THIS ROUTINE
C
C
      CHARACTER*(*) CTEXT , CNEW
C
C
      MAXLEN = LEN ( CTEXT )
      NEWLEN = IPOS + LEN ( CNEW )
C
      IF ( IPOS .LT. MAXLEN ) THEN
        CTEXT(IPOS+1:) = CNEW
      ENDIF
C
      IF ( NEWLEN .GT. MAXLEN ) THEN
        IPOS = MAXLEN
        KCCAPP = -1
      ELSE
        IPOS = NEWLEN
        KCCAPP = 1
      ENDIF
C
C
      RETURN
      END
C
CODE FOR KCRVAL
      FUNCTION KCRVAL (CBUFF, ISIZE,  ISTART, IPOS1, IPOS2, VALUE)
C
C----- TRY TO PROCESS  THE NEXT ARGUMENT AS A REAL NUMBER
C
C       CBUFF   - INPUT STRING
C       ISIZE   - USED PART OF CBUFF
C       ISTART  - STARTING POSITION FOR SEARCH
C-----  RETURN VALUES:
C            +1 SUCESS, VALUE RETURNED IN 'VALUE'
C            -1 NOT A NUMBER
C       IPOS1   - START OF ARGUMENT
C       IPOS2   - END OF ARGUMENT
C
      CHARACTER CBUFF *(*)
C
      VALUE = 0.0
      KCRVAL = -1
      IF(KCCARG (CBUFF(1:ISIZE), ISTART,1, IPOS1, IPOS2) .LE. 0)THEN
        IPOS2 = ISIZE
      END IF
C----- TRY TO PROCESS AS NUMBER
      IF (KCCNUM(CBUFF(IPOS1:IPOS2), IRESLT, ITYPE) .LE. 0) THEN
C----- NOT A NUMBER
        RETURN
      ELSE
C      A NUMBER
        IF (ITYPE .EQ. 1) THEN
            VALUE = FLOAT(IRESLT)
        ELSE
            CALL XMOVE( IRESLT, VALUE, 1)
        END IF
      END IF
      KCRVAL = +1
      RETURN
      END
C
C
CODE FOR CIAPP
       SUBROUTINE CIAPP (CVAR,IVAR,IEND)
C
C APPENDS AN INTEGER, IVAR, FOLLOWED BY A COMMA, TO A
C CHARACTER VARIABLE, CVAR, FROM THE POSITION IEND+1
C ONWARDS.  IEND IS UPDATED TO THE LAST OCCUPIED POSITION
C IN CVAR (I.E. THE POSITION OF THE COMMA).
C
       CHARACTER*(*) CVAR
C
C SAVE IVAR
       ITEMP = IVAR
C
C ACCOUNT FOR NEGATIVE OR ZERO ITEMP.
C
       IF (ITEMP .LT. 0) THEN
        CVAR(IEND+1:IEND+1) = '-'
        IEND = IEND+1
        ITEMP = (-ITEMP)
       ELSE IF (ITEMP .EQ. 0) THEN
        CVAR(IEND+1:IEND+2) = CHAR(48)//','
        IEND = IEND+2
        RETURN
       ENDIF
C
C
       LITEMP = INT(LOG10(REAL(ITEMP)))+1
C
       I = LITEMP
C
100       CONTINUE
       IF (I .EQ. 0) GOTO 200
       IFIRST = ITEMP/(10**(I-1))
       CVAR(IEND+1:IEND+1) = CHAR(IFIRST+48)
       IEND = IEND+1
       ITEMP = ITEMP-(IFIRST*(10**(I-1)))
       I=I-1
       GOTO 100
C
200       CONTINUE
C
       CVAR(IEND+1:IEND+1)=','
       IEND = IEND+1
C
       RETURN
       END
C
CODE FOR CATSTR
       SUBROUTINE CATSTR (ATOM, SERIAL, IS, NPLI, ITX, ITY, ITZ,
     +                    CASTR, LASTR)
C
C WRITES THE INFORMATION ON THE ATOM CATOM(ILABEL) TO THE CHARACTER
C VARIABLE CASTR OF LENGTH LASTR IN THE FORM ATOM(LABEL,IS,NPLI,ITX,
C ITY,ITZ).  THIS IS THEN ABBREVIATED TO THE LAST NON-DEFAULT SYMMETRY
C OPERATOR, E.G. C(9,1,1,0,0,0) IS TRIMMED TO C(9); N(2,1,1,2,0,0) IS
C TRIMMED TO N(2,1,1,2).
C---------------------------------------------------------------------
C        IS...ITX - SYMMETRY OPERATORS (MAY BE FOUND AT POSITIONS
C                   J+2...J+6 OF A DISTANCE STACK CREATED BY KDIST).
C                   (J = ADDRESS OF THE FIRST ENTRY OF AN ATOM IN THE
C                    STACK)
C        ATOM     - ATOM TYPE HELD AS REAL VARIABLE
C        SERIAL   - ATOM SERIAL NUMBER
C        CASTR    - CHARACTER - OUTPUT AS ABOVE
C        ILAST    - POSITION IN CASTR OF THE MOST RECENT NON-DEFAULT
C                   SYMMETRY OPERATOR.
C
       CHARACTER*(*) CASTR
       CHARACTER*4 CATOM
      DIMENSION ISTORE(131072)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C CLEAN OUT CASTR.
       CASTR =' '
C
C PLACE THE ATOM TYPE IN CASTR
C
       WRITE(CASTR(1:4), '(A4)') ATOM
C
C TRIM CASTR TO THE LAST NON-SPACE CHARACTER (POSITION IEND).
C
       NCCTRM=KCCTRM(1, CASTR(1:4),ISTART,IEND)
       IF (NCCTRM .LT. 0) THEN
       CALL XIVHT ('CATSTR')
       RETURN
       ENDIF
C
       CASTR(IEND+1:IEND+1)='('
       IEND=IEND+1
C
C APPEND SERIAL
C
       CALL CIAPP (CASTR, NINT(SERIAL), IEND)
       ILAST=IEND
C
C APPEND SYMMETRY OPERATORS
C
       CALL CIAPP (CASTR,IS,IEND)
       IF (IS .NE. 1) THEN
       ILAST=IEND
       ENDIF
C
       CALL CIAPP (CASTR,NPLI,IEND)
             IF (NPLI .NE. 1) THEN
       ILAST=IEND
       ENDIF
C
       CALL CIAPP (CASTR,ITX,IEND)
       IF (ITX .NE. 0) THEN
       ILAST=IEND
       ENDIF
C
       CALL CIAPP (CASTR,ITY,IEND)
       IF (ITY .NE. 0) THEN
       ILAST=IEND
       ENDIF
C
       CALL CIAPP (CASTR,ITZ,IEND)
       IF (ITZ .NE. 0) THEN
       ILAST=IEND
       ENDIF
C
C ONLY USE CASTR UP TO THE LAST NON-DEFAULT SYMMETRY OPERATOR.
C
       IEND=ILAST
       CASTR(IEND:IEND)=')'
C
C FILL UP REST OF CASTR WITH SPACES.
       LENSTR = LEN (CASTR)
       CASTR(IEND+1:LENSTR)=' '
       LASTR=IEND
       IEND=0
       RETURN
       END
C
C
CODE FOR XIVHT
      SUBROUTINE XIVHT (CTYPE)
C
C----- ERROR MESSAGE FROM HNN WRITER
      CHARACTER *(*) CTYPE
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,100) 'Unable to get atom type in routine', CTYPE
      ENDIF
      WRITE(NCAWU,100) 'Unable to get atom type in routine', CTYPE
100   FORMAT( 3X,A,A)
      RETURN
      END
C
C
CRYSTALS CODE FOR CONTROL
CODE FOR XFRGN1
      SUBROUTINE XFRGN1
C--SUBROUTINE TO INITIALISE THE CALL TO A FOREIGN PROGRAM.
C
C--THIS ROUTINE ALSO SEARCHES THE INPUT STREAM FOR THE NEXT '#INSTRUCTIO
C  CARD, AND CHECKS THAT THE SYSTEM REQUEST QUEUE IS EMPTY.
C
C--
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C--LOAD THE NEXT '#INSTRUCTION' CARD
      J=KFNHF(LSTOP,LSTNO,ICLASS)
C--CHECK THAT THE SYSTEM REQUEST QUEUE IS EMPTY
      IF(KPSRQ(-1))1000,1100,1000
C--THE QUEUE IS NOT EMPTY
1000  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)
      ENDIF
1050  FORMAT(37H System request queue should be empty)
      CALL XERHND ( IERPRG )
C--AND NOW RETURN
1100  CONTINUE
      RETURN
      END
C
CODE FOR XFRGN2
      SUBROUTINE XFRGN2(ICOM)
C--THIS ROUTINE TERMINATES THE OUTPUT TO THE SYSTEM REQUEST QUEUE AND LO
C  THE PROGRAM REQUIRED FOR THE COMMAND STORED IN 'ICOM'.
C
C  ICOM   A FOUR CHARACTER COMMAND NAME, DEFINING THE NEXT OPERATION
C        TO BE PERFORMED.
C
C--
C
      DIMENSION ICOM(4)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XPRGNM/PROGNM(17)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--TERMINATE THE SYSTEM REQUEST QUEUE
      WRITE(NUSRQ,1000)(IH,IB,(IH,I=1,78),J=1,5)
1000  FORMAT(80A1)
C--WRITE OUT A '#END'
      WRITE(NUSRQ,1050)IH,(IH,I=1,76)
1050  FORMAT(A1,3HEND,76A1)
C--WRITE THE NEXT PROGRAM NAME TO BE LOADED
      MR64=LR64+19
      WRITE(NUSRQ,1100)(ISTORE(I),I=LR64,MR64)
1100  FORMAT(2I4,18A4)
      ENDFILENUSRQ
      REWINDNUSRQ
C--PRESERVE THE CURRENT DETAILS OF THE COMMON BLOCKS
      NILAST=NI
C--COPY THE PROGRAM NAME THAT WE WILL ENTER AFTER THE FOREIGN CALL
      CALL XMOVE(STORE(LR64+2),PROGNM(1),MDR64-2)
C--OUTPUT THE COMMON BLOCK DETAILS
      CALL XSYSDC(0,0)
C--BLANK OUT THE CURRENT COMMAND
      CALL XMVSPD(IB,IMAGE(2),LASTCH-1)
C--ADD IN THE REQUIRED COMMAND
      CALL XMOVE(ICOM(1),IMAGE(2),4)
C--LOAD THE DETAILS
      I=KFNHF(LSTOP,LSTNO,ICLASS)
C--LOAD THE PROGRAM
      CALL XCONT1(ISTORE(MR64),MDR64)
      RETURN
      END
C
CODE FOR XFRGN3
      SUBROUTINE XFRGN3(NRU,NWU)
C--ROUTINE TO RETURN FROM A FOREIGN LINK
C
C  NRU   DEVICE NUMBER OF THE SYSTEM REQUEST QUEUE FOR THIS LINK.
C  NWU  LINE PRINTER DEVICE NUMBER.
C
C--
C
      DIMENSION IBUFF(20),ICON(2)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
      DATA ICON(1)/'#'/,ICON(2)/'END '/
C
C--SET THE UNIT NUMBER FOR THE L/P
      NCWU=NWU
C--CHECK FOR UNUSED CARDS
      I=0
C--READ THE NEXT CARD
1000  CONTINUE
      READ(NRU,1050)(IBUFF(J),J=1,2)
1050  FORMAT(A1,A3)
C--CHECK FOR A '#' IN COLUMN 1
      IF(KCOMP(1,IBUFF(1),ICON(1),1,2))1100,1100,1150
C--INCREMENT THE UNUSED COUNT
1100  CONTINUE
      I=I+1
      GOTO 1000
C--CHECK FOR ANY UNUSED CARDS
1150  CONTINUE
      IF(I)1300,1300,1200
C--PRINT THE UNUSED CARD COUNT
1200  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1250)I
      ENDIF
1250  FORMAT(1H ,I4,42H  Card(s) ignored by the last program link)
C--PRINT THE TIME USED
1300  CONTINUE
      CALL XTIME2(2)
C--FIND THE '#END' CARD
1350  CONTINUE
      IF(KCOMP(2,IBUFF,ICON(1),1,2))1400,1400,1450
C--READ ANOTHER CARD
1400  CONTINUE
      READ(NRU,1050)(IBUFF(J),J=1,2)
      GOTO 1350
C--READ THE LOAD DETAILS FOR THE NEXT PROGRAM LINK
1450  CONTINUE
      READ(NRU,1500)(IBUFF(I),I=1,20)
1500  FORMAT(2I4,18A4)
C--REWIND THE SYSTEM REQUEST QUEU
      REWINDNRU
C--LOAD THE NEXT PROGRAM
      CALL XCONT1(IBUFF,20)
      RETURN
      END
C
CODE FOR KNXTOP
      FUNCTION KNXTOP(LSTOP,LSTNO,ICLASS)
C--THIS FUNCTION FINDS THE NEXT '#INSTRUCTION' CARD AND LOADS THE PROGRA
C  SHOULD EXECUTE THE INSTRUCTION. IF THE PROGRAM IS ALREADY LOADED,
C  AS HAPPENS WHEN A PROGRAM IS FIRST ENTERED, THIS ROUTINE SIMPLY RETUR
C  WITHOUT CHANGING PROGRAM.
C
C  LSTOP   THIS PARAMETER IS SET ONLY WHEN A LIST OPERATION IS INDICATED
C          AND IS SET IN THIS CASE TO THE OPERATION REQUIRED. VALUES AVA
C          AT PRESENT ARE :
C
C          0  NO LIST OPERATION.
C          1  INPUT, VIA A '#LIST' INSTRUCTION.
C          2  PRINT, VIA A '#PRINT' INSTRUCTION.
C          3  PUNCH, VIA A '#PUNCH' INSTRUCTION.
C
C  LSTNO   WHEN A LIST OPERATION IS INDICATED, THIS VARIABLE IS SET TO T
C          LIST NUMBER ON RETURN. IN ALL OTHER CASES, THIS VARIABLE IS S
C          ZERO.
C
C  ICLASS  WHEN A LIST OPERATION IS INDICATED, THIS VARIABLE IS SET TO T
C          OPERATION CLASS ON RETURN. IN ALL OTHER CASES, THIS VARIABLE
C          SET TO ZERO.
C
C--THE RETURN VALUES OF 'KNXTOP' ARE :
C
C  -1  THE CURRENT INSTRUCTION CANNOT BE EXECUTED BY THIS PROGRAM. THIS
C      IS USED BY THIS VERSION OF THE ROUTINE.
C  >0  THE VALUE EXPECTED BY THE CALLING PROGRAM FOR THIS OPERATION.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XPRGNM/PROGNM(17)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C----- WE COULD COME HERE AFTER AN ERROR - TRY A RESTART.
C--CHECK FOR A '#INSTRUCTION' CARD
      I=KFNHF(LSTOP,LSTNO,ICLASS)
C--CHECK IF WE MUST CHANGE PROGRAMS
      MR64=KCOMP(MDR64-2,PROGNM,STORE(LR64+2),NR64,MDR64)
      IF(MR64)1050,1050,1000
C--THIS ROUTINE CAN PROCESS THIS '#INSTRUCTION'  -  SET THE RETURN VALUE
1000  CONTINUE
C
C----- COPY THE INSTRUCTION TO THE SNOOPER
      CALL XSPY ( 2 )
C
      MR64=LR64+(MR64-1)*MDR64
      KNXTOP=ISTORE(MR64)
      RETURN
C--STORE THE NEW FILE NAME AWAY
1050  CONTINUE
      CALL XMOVE(STORE(LR64+2),PROGNM(1),MDR64-2)
C--MARK THE '#INSTRUCTION' AS READY FOR PROCESSING
      IHFLAG=0
C--CHECK THAT THIS IS NOT THE SAME CARD THAT WE FOUND ON ENTERING
      NILAST=NI
C--DUMP THE COMMON BLOCK VALUES
      CALL XSYSDC(0,0)
C--LOAD THE NEXT PROGRAM
      CALL XCONT1(ISTORE(LR64),MDR64)
      KNXTOP=-1
      RETURN
      END
C
CODE FOR XCONT1
      SUBROUTINE XCONT1(LOAD,IDIMN)
C--THIS SUBROUTINE LOADS THE NEXT PROGRAM
C
C  LOAD    THE LOAD DETAILS :
C
C          1  THE ENTRY NUMBER FOR THE CURRENT OPERATION.
C          2  THE CORE SIZE REQUIRED.
C          3  THE FIRST WORD OF THE LOAD DETAILS.
C          4  THE SECOND WORD OF THE LOAD DETAILS, ETC.
C
C  IDIMN    THE DIMENSION OF 'LOAD'.
C
C--
C
      DIMENSION LOAD(IDIMN)
      DIMENSION MESS(11)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON /XSIZES/ ISIZST,ISIZ11
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XPRGNM/PROGNM(17)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
#ICL      EQUIVALENCE (ITEMP,ISIZST)
&ICL      EQUIVALENCE (ITEMP,STORE(1))
C
      DATA MESS(1)/'CRYS'/,MESS(2)/'TALS'/,MESS(3)/'LOAD'/
      DATA MESS(4)/'NAME'/,MESS(5)/':= "'/,MESS(11)/'"   '/
C
C--CHECK THE CORE SIZE FOR THE NEW PROGRAM
      J=KORE(ITEMP)
      IF(LOAD(2)-J)1100,1100,1000
C--NOT ENOUGH CORE
1000  CONTINUE
      CALL XMONTR(0)
      CALL XERHDR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)LOAD(2),J
      ENDIF
      WRITE(NCAWU,1050) LOAD(2),J
1050  FORMAT(23H Next program requires ,I8,20H  words of core  -  ,I8,
     2 21H  words is too little)
      CALL XERHND ( IERSEV )

1100  CONTINUE
      CALL XMOVE(LOAD(3),MESS(6),5)
      CALL XFCCS(MESS(1),MESS(1),9)
C--OUTPUT THE MESSAGE
      IF(KIGC(11,MESS(1)))1150,1250,1250

C--ERROR DURING THE ASSIGN
1150  CONTINUE
      CALL XMONTR(0)
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)
      ENDIF
      WRITE(NCAWU,1200)
1200  FORMAT(32H Error on assigning next program)
      CALL XERHND ( IERPRG )
C--LOAD THE NEXT PROGRAM
1250  CONTINUE
      CALL XQUIT
      RETURN
      END
C
CODE FOR XSYSDC
      SUBROUTINE XSYSDC(IN,IND)
C--INITIALISE OR TERMINATE THE DATA AREAS FOR A CRYSTALS PROGRAM.
C
C  IN      PROGRAM START/END CONTROL :
C          -1  START OF A PROGRAM.
C           0  END OF A PROGRAM, BEFORE CONTROL PASSES TO ANOTHER PROGRA
C
C  IND     THE TYPE OF INITIALISATION REQUIRED :
C
C          -1  JOB TO INITIALISE A DISC FILE.
C           0  FIRST LOAD OF A JOB.
C          +1  ANY BUT THE FIRST LOAD OF A JOB.
C
C--
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON /XSIZES/ ISIZST,ISIZ11
      COMMON/XTIMES/Q(4),QQ(4)
      COMMON/XDISC/NU
      COMMON/XDISCB/IACC,MLSS,IADD1,NFWD,NWD,NV,NWB,NWR,I,J,K,L,M,N,NNN
      COMMON/XDISCS/NCDFU,NCIFU,NCLDU , NCNDU
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
      COMMON/XCOMPD/TITLE(20)
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLIMIT/NFLMIN,LFLMAX,NULMAX,IENDC
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XSYSHF/NWHF,NHF,LHF,IHF(68)
      COMMON/XSYSDR/NWSPD,NSPD,LSPD,ISPD(13,2)
      COMMON/XDIRTP/IDTYPE(3,4)
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XPRGNM/PROGNM(17)
      COMMON/XLEXCH/KS,KE,KN,KV,KB(13),KC(13)
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XERCNT/ IERDMP(9) , IERCNT(9) , IERMSG(9) ,
     2 IERLIM(9) , IERSTF(9) , IERCOU(9) , IERMAX
C
#ICL      EQUIVALENCE (ITEMP,ISIZST)
&ICL      EQUIVALENCE (ITEMP,STORE(1))


C
C
C--CHECK IF THIS IS THE START OR END FOR THE CALLING PROGRAM
      IF(IN)1000,1500,1500
C--CHECK IF THIS IS AN INITIAL CALL OR A RECALL LATER
1000  CONTINUE
      IF(IND)1050,1050,1100
C--AN INITIAL CALL
1050  CONTINUE
      CALL XTIME1(0)
      GOTO 1350
C
1100  CONTINUE
C -- NOT AN INITIAL CALL. IF THE PROGRAM IS SEGMENTED, READ IN DATA
      IF ( ISSSEG .LE. 0 ) GO TO 1600
      REWINDNCCBU
C--READ THE TIME CONTROL CONSTANTS
      READ(NCCBU,1550)Q,QQ
C--READ THE DISC UNITS
      READ(NCCBU,1150)NCDFU,NCIFU,NCLDU
1150  FORMAT(16I5)
C--READ THE BASIC PERIPHERAL UNIT NUMBERS AND CONSTANTS
      READ(NCCBU,1150)NCRU,NCRRU,NCWU,NCPU,IPAGE,NCARU,NCAWU
      READ(NCCBU,1155) IQUN,JQUN
1155  FORMAT(2I5)
C--READ THE CURRENT CARD IN
      READ(NCCBU,1200)IMAGE
      READ ( NCCBU , 1200 ) LCMAGE
1200  FORMAT(80A1)
C--READ THE CARD CONSTANTS
      READ(NCCBU,1250)NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,IEOF,IHFLAG,
     2 NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,MAPS
1250  FORMAT(8I10)
C--READ THE M/T FILE NUMBERS
      READ(NCCBU,1150)MTA,MTB,MT1,MT2,MT3,MTE
C--READ THE NAME OF THE CURRENT PROGRAM
      READ(NCCBU,1300)PROGNM
1300  FORMAT(20A4)
C -- READ THE ERROR CONTROL FLAGS
      READ ( NCCBU , 1305 ) IERCNT
      READ ( NCCBU , 1305 ) IERLIM , IERCOU , IERMAX
1305  FORMAT ( 19I4 )
C--COMPUTE THE REST OF THE CONSTANTS
1350  CONTINUE
      PI=ACOS(-1.0)
      TWOPI=2.*PI
      TWOPIS=TWOPI*PI
      RTD=180./PI
      DTR=PI/180.
      ZEROSQ=ZERO*ZERO
      VALUSQ=VALUE*VALUE
C--ASSIGN THE DATA FILE UNIT NUMBER
      NU=NCDFU
C--ALLOCATE SOME CORE BUFFERS
      CALL XGIVE
C
C -- SET LIMITS OF ARRAY 'STORE'
C
      NFL = 1
      LFL=KORE(ITEMP)
      NUL=LFL-NFL+1
C--SET THE CORE LIMITS
      CALL XSSL(NFL,LFL,NUL)
C--CHECK IF THIS IS TO ESTABLISH A DISC OR A NORMAL LOAD
      IF(IND)1450,1400,1400
C--LOAD THE LIST CONTROL DATA
1400  CONTINUE
      CALL XLC
C--SET UP THE CORE CHAIN POINTERS
1450  CONTINUE
      L0=NOWT
      M0=NOWT
C--REPOSITION THE SYSTEM REQUEST QUEUE
      CALL XRPSRQ
      GOTO 1600
C
C
1500  CONTINUE
C -- 'PROGRAM' TERMINATION. IF SYSTEM IS SEGMENTED , WRITE OUT DATA
      IF ( ISSSEG .LE. 0 ) GO TO 1600
      REWINDNCCBU
C--WRITE THE CURRENT TIME OUT TO THE CONTROL FILE
      WRITE(NCCBU,1550)Q,QQ
1550  FORMAT(4E20.10)
C--WRITE THE DISC UNITS
      WRITE(NCCBU,1150)NCDFU,NCIFU,NCLDU
C--WRITE THE BASIC PERIPHERAL UNIT NUMBERS AND CONSTANTS
      WRITE(NCCBU,1150)NCRU,NCRRU,NCWU,NCPU,IPAGE,NCARU,NCAWU
      WRITE(NCCBU,1155) IQUN,JQUN
C--WRITE THE CURRENT CARD OUT
      WRITE(NCCBU,1200)IMAGE
      WRITE ( NCCBU , 1200 ) LCMAGE
C--WRITE THE CARD CONSTANTS
      WRITE(NCCBU,1250)NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,IEOF,IHFLAG,
     2 NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,MAPS
C--WRITE THE M/T FILE NUMBERS
      REWINDMTA
      REWINDMTB
      REWINDMTE
      WRITE(NCCBU,1150)MTA,MTB,MT1,MT2,MT3,MTE
C--WRITE THE NAME OF THE CURRENT PROGRAM
      WRITE(NCCBU,1300)PROGNM
C -- WRITE ERROR CONTROLS
      WRITE ( NCCBU , 1305 ) IERCNT
      WRITE ( NCCBU , 1305 ) IERLIM , IERCOU , IERMAX
      REWINDNCCBU
C--REPOSITION THE SYSTEM REQUEST QUEUE
      REWINDNUSRQ
C--AND NOW RETURN
1600  CONTINUE
      RETURN
      END
C
CODE FOR KFNHF
      FUNCTION KFNHF(LSTOP,LSTNO,ICLASS)
C--THIS ROUTINE FINDS THE NEXT '#INSTRUCTION' CARD.
C
C  LSTOP   THIS PARAMETER IS SET ONLY WHEN A LIST OPERATION IS INDICATED
C          AND IS SET IN THIS CASE TO THE OPERATION REQUIRED. VALUES AVA
C          AT PRESENT ARE :
C
C          0  NO LIST OPERATION.
C          1  INPUT, VIA A '#LIST' INSTRUCTION.
C          2  PRINT, VIA A '#PRINT' INSTRUCTION.
C          3  PUNCH, VIA A '#PUNCH' INSTRUCTION.
C
C  LSTNO   WHEN A LIST OPERATION IS INDICATED, THIS VARIABLE IS SET TO T
C          LIST NUMBER ON RETURN. IN ALL OTHER CASES, THIS VARIABLE IS S
C          ZERO.
C
C  ICLASS  WHEN A LIST OPERATION IS INDICATED, THIS VARIABLE IS SET TO T
C          OPERATION CLASS ON RETURN. IN ALL OTHER CASES, THIS VARIABLE
C          SET TO ZERO.
C
C--THE RETURN VALUE OF 'KFNHF' IS THE NUMBER OF THE '#INSTRUCTION'
C  WHICH THE CALLING PROGRAM CAN USE. THIS NUMBER IS IN THE RANGE
C  1 TO N, WHERE 'N' IS THE MAXIMUM NUMBER OF '#INSTRUCTIONS' THAT
C  THE GIVEN PROGRAM CAN PROCESS.
C
C--THERE ARE NO ERROR RETURNS FROM THIS ROUTINE  -  ERRORS LEAD TO
C  PROGRAM TERMINATION.
C
C--ON EXIT THE CONTROL RECORDS (60 ONWARDS) FOR THE '#INSTRUCTION'
C  FOUND ARE LOADED AT THE TOP OF CORE, WITH 'NFL' AND 'LFL' SET
C  CORRECTLY. 'XRSL' MUST BE CALLED BEFORE THE WHOLE OF CORE BECOMES
C  AVAILABLE AGAIN.
C
C--WITHIN LIST 50, SEVERAL TYPES OF DATA RECORD ARE USED :
C
C  50  RECORD TYPE 50 CONTAINS THE NAMES OF THE INSTRUCTIONS, EACH ONE
C      FOLLOWING DIRECTLY AFTER THE ONE BEFORE IT. THE FORMAT IS
C      ONE CHARACTER PER WORD, AND MAY BE REPRESENTED AS :
C
C      0  MAXIMUM NUMBER OF CHARACTERS IN THIS NAME
C      1  NAME 1, WORD 1.
C      2  NAME 1, WORD 2.
C
C -51  RECORD TYPE 51 CONTAINS A SET OF DISC POINTERS TO
C      RECORDS 60, 61, 62, 63 AND 64 FOR EACH INSTRUCTION. THE
C      FORMAT OF EACH ENTRY IS AS FOLLOWS :
C
C      0  DISC ADDRESS OF THE RECORD HEADER PRECEDING RECORD 60.
C      1  DISC ADDRESS OF THE RECORD HEADER FOR RECORD TYPE 60.
C      3  DISC ADDRESS OF THE RECORD HEADER PRECEDING RECORD 61.
C
C      THIS FORMAT IS REPEATED FOR EACH RECORD TYPE FOR A INSTRUCTION,
C      AND THEN FOR EACH INSTRUCTION. THIS RECORD IS USED TO RAPIDLY
C      ACCESS DATA FOR A GIVEN INSTRUCTION.
C
C  52  THIS RECORD IS PRESENT ONCE IN THE LIST, AND CONTAINS THE
C      NECESSARY INSTRUCTIONS TO GENERATE LISTS INTERNALLY. THESE
C      INSTRUCTIONS CONTAIN THEIR '#' DELIMITERS, AND STORED IN
C      THE FOLLOWING FORMAT :
C
C      0  THE LIST TYPE NUMBER TO BE GENERATED.
C      1  THE FIRST WORD OF THE COMMAND  -  FORMAT 19A4.
C      2  THE SECOND WORD OF THE COMMAND.
C
C  60  EACH TYPE 60 RECORD CONTAINS THE NAMES OF THE DIRECTIVES
C      THAT ARE AVAILABLE WITH ONE '#' INSTRUCTION, IN THE SAME FORMAT
C      AS A TYPE 50 RECORD. EACH INSTRUCTION CAN HAVE A TYPE 60 RECORD.
C
C  61  EACH TYPE 61 RECORD CONTAINS THE DETAILS FOR THE DIRECTIVES
C      ASSOCIATED WITH ONE '#' INSTRUCTION. THE DETAILS IN A TYPE 61
C      RECORD ARE USED TO ACCESS THE PARAMETER DETAILS WHICH ARE
C      STORED IN A TYPE 62 RECORD. THE DATA IN TYPE 61 RECORDS IS
C      ARRANGED SERIALLY, AND THE ENTRY FOR EACH DIRECTIVE IS AS
C      FOLLOWS :
C
C       0  RELATIVE ADDRESS OF THE DETAILS OF THE PARAMETERS FOR THIS
C          DIRECTIVE.
C       1  NUMBER OF WORDS PER PARAMETER NAME.
C       2  NUMBER OF WORDS REQUIRED FOR THE COMPLETE PARAMETER ENTRY.
C       3  NUMBER OF PARAMETERS FOR THIS DIRECTIVE.
C       4  RELATIVE ADDRESS OF THE DIRECTIVES EXCLUDED FROM INPUT WHEN
C          THIS DIRECTIVE HAS BEEN FOUND.
C       5  NUMBER OF WORDS PER EXCLUDED DIRECTIVE.
C       6  NUMBER OF EXCLUDED DIRECTIVES.
C          THIS VALUE IS SET NEGATIVE WHEN THIS DIRECTIVE HAS BEEN
C          EXCLUDED. THE ABSOLUTE VALUE GIVES THE DIRECTIVE THAT HAS
C          EXCLUDED IT.
C       7  NUMBER OF TIMES THIS DIRECTIVE MAY APPEAR.
C          THIS VALUE IS SET FROM THE GROUP REPEAT COUNT FOR
C          DIRECTIVES THAT DEFINE DATA RECORDS.
C       8  NUMBER OF TIMES THIS DIRECTIVE HAS APPEARED.
C          DURING PROCESSING THIS LOCATION MAY BE SET AS FOLLOWS :
C
C          NEGATIVE  THIS DIRECTIVE HAS ALREADY GENERATED ERRORS.
C          OTHER     THE NUMBER OF TIMES THE DIRECTIVE HAS APPEARED.
C
C       9  THE NUMBER OF WORDS PER GROUP FOR THE RECORD DEFINED BY
C          THIS DIRECTIVE, IF THERE IS ONE.
C      10  THE NUMBER OF GROUPS FOR THE RECORD DEFINED BY THIS DIRECTIVE
C          IF THERE IS ONE.
C      11  THE RECORD TYPE DEFINED BY THIS DIRECTIVE.
C      12  THE COMMON BLOCK OFFSET FOR THE RECORD DEFINED BY THIS DIRECT
C      13  THE LIST TYPE FOR THE RECORD TO BE CREATED.
C      14  THE NUMBER OF WORDS OCCUPIED BY THE TITLE OF THIS RECORD.
C      15  THE NUMBER OF TIMES THE TITLE SHOULD BE PRINTED PER LINE.
C      16  THE RELATIVE ADDRESS IN RECORD TYPE 62 OF THE TITLE.
C      17  THE NUMBER OF WORDS OCCUPIED BY THE PRINT FORMAT FOR THE
C          PARAMETER KEYWORDS FOR THIS RECORD.
C      18  THE NUMBER OF TIMES THE PARAMETER KEYWORDS ARE TO BE PRINTED
C          PER LINE.
C      19  THE RELATIVE ADDRESS IN RECORD TYPE 62 OF THE PRINT FORMAT
C          FOR THE KEYWORDS FOR THIS RECORD.
C      20  THE NUMBER OF WORDS OCCUPIED BY THE PRINT FORMAT FOR THE
C          ELEMENTS OF THIS RECORD.
C      21  THE NUMBER OF GROUPS TO BE PRINTED PER LINE.
C      22  THE RELATIVE ADDRESS IN RECORD TYPE 62 OF THE PRINT FORMAT
C          FOR THE ELEMENTS IN THIS RECORD.
C      23  THE NUMBER OF WORDS OCCUPIED BY THE PUNCH FORMAT FOR THE
C          PARAMETER KEYWORDS FOR THIS RECORD.
C      24  THE NUMBER OF TIMES THE PARAMETER KEYWORDS ARE TO BE PUNCHED
C          PER LINE.
C      25  THE RELATIVE ADDRESS IN RECORD TYPE 62 OF THE PUNCH FORMAT
C          FOR THE KEYWORDS FOR THIS RECORD.
C      26  THE NUMBER OF WORDS OCCUPIED BY THE PUNCH FORMAT FOR THE
C          ELEMENTS OF THIS RECORD.
C      27  THE NUMBER OF GROUPS TO BE PUNCHED PER LINE.
C      28  THE RELATIVE ADDRESS IN RECORD TYPE 62 OF THE PUNCH FORMAT
C          FOR THE ELEMENTS IN THIS RECORD.
C      29  THE RELATIVE ADDRESS OF THE ENABLING DATA FOR THIS
C          DIRECTIVE.
C      30  THE NUMBER OF WORDS PER ENABLING DIRECTIVE.
C      31  THE NUMBER OF ENABLING DIRECTIVES.
C
C      THE BLOCK ABOVE IS REPEATED FOR EACH DIRECTIVE FOR THE CURRENT
C      '#' INSTRUCTION, AND ALL THE ADDRESSES ARE RELATIVE TO THE START
C      OF THE DATA STORED IN RECORD TYPE 62.
C
C  62  ASSOCIATED WITH EACH TYPE 61 RECORD IS A TYPE 62 RECORD, WHICH
C      CONTAINS DETAILS OF THE PARAMETERS FOR EACH DIRECTIVE. EACH
C      DIRECTIVE HAS A POINTER IN RECORD TYPE 61 INDICATING THE START
C      OF ITS PARAMETERS, WHICH ARE STORED SERIALLY AND
C      FORM THE FIRST PART OF THIS RECORD. THE REST OF THE
C      RECORD IS TAKEN WITH FURTHER DATA ADDRESSED VIA THE PARAMETER
C      INFORMATION. THE FORMAT OF AN ENTRY FOR A PARAMETER STARTS
C      WITH THE PARAMETER NAME AS FOLLOWS :
C
C      0  NAME 1, WORD 1.
C      1  NAME 1, WORD 2.
C
C      AFTER THE NAME, THE REST OF THE PARAMETER INFORMATION IS STORED,
C      ATTHE OFFSET GIVEN IN WORD 2 ABOVE, RELATIVE TO THE START OF THE
C      CURRENT PARAMETER. THE NUMBER OF WORDS OF ADDITIONAL DATA
C      IS GIVEN BY WORD 2 MINUS WORD 1 ABOVE.
C      THE FORMAT OF THE REST OF THE DATA FOR EACH PARAMETER IS :
C
C       0  PARAMETER TYPE ON INPUT :
C
C          +1  FIXED POINT NUMBER.
C          +2  FLOATING POINT NUMBER.
C          +3  CHARACTER STRING.
C          +4  STRING TO BE INTERPRETED BY THE CALLING ROUTINE.
C
C       1  RELATIVE ADDRESS OF THE PERMITTED VALUES FOR THIS PARAMETER
C          ON INPUT.
C       2  NUMBER OF WORDS PER PERMISSABLE VALUE.
C       3  NUMBER OF PERMISSABLE VALUES.
C       4  COMMON BLOCK OFFSET FOR THIS PARAMETER.
C       5  TYPE OF ARGUMENT TO BE STORED IN THE COMMON BLOCK. IF THE
C          NUMBER OF PERMISSABLE VALUES IS ZERO, WORD 5 IS SET EQUAL
C          TO WORD 0. IF PERMISSABLE VALUES ARE ALLOWED, WORD 5 IS SET T
C          1, INDICATING AN INTEGER WHICH CAN GIVE THE POSITION OF THE
C          FOUND PERMISSABLE VALUE.
C          NUMBER OF PERMISSABLE VALUES IS ZERO, WORD 5 MUST EQUAL WORD
C          0. IF THE NUMBER OF PERMISSABLE VALUES IS NOT ZERO, THE
C          VALUE FOUND MAY BE STORED (WORD 0 EQUALS WORD 5), OR
C          ANOTHER TYPE OF ARGUMENT MAY BE STORED. THE MOST COMMON
C          EXAMPLE OF THIS IS TO STORE AN INTEGER TO INDICATE THE
C          POSITION OF THE PERMISSABLE VALUE FOUND ON INPUT.
C          IN THIS CASE, WORD 0 WOULD BE 3 AND WORD 5 WOULD BE 1.
C       6  VALUE TO BE ASSIGNED IF THE FIRST PERMISSABLE VALUE
C          IS FOUND. THIS IS AN INTEGER, AND SUCCESSIVE PERMISSABLE
C          VALUES ARE INCREMENTED ACCORDINGLY FROM THIS VALUE.
C       7  DEFAULT INDICATOR :
C
C          -1  NO DEFAULT AVAILABLE.
C           0  DEFAULT VALUE STORED.
C
C       8  DEFAULT VALUE, TYPE GIVEN BY WORD 5.
C       9  NUMBER OF TIMES THIS PARAMETER MAY OCCUR.
C      10  THE NUMBER OF TIMES THIS PARAMETER HAS BEEN INPUT.
C
C      THE REST OF THE TYPE 62 RECORD IS DATA POINTED TO BY THE FIRST
C      PART OF THE RECORD.
C
C  63  THIS RECORD CONTAINS A LIST OF THE LISTS THAT THE '#' INSTRUCTION
C      REQUIRES. THE LISTS ARE STORED BY NUMBER, ONE AFTER THE OTHER.
C
C  64  THIS RECORD CONTAINS THE LOAD DETAILS, WHICH ARE SPECIFIC TO
C      EACH MACHINE. ON THE ICL 1906A, THE FORMAT IS :
C
C      0  THE INSTRUCTION NUMBER FOR THE GIVEN PROGRAM.
C      1  MINIMUM CORE SIZE REQUIRED.
C      2  WORD 1 OF THE FILE NAME TO 'CONT'.
C      3  WORD 2.
C
C--RECORD TYPE 50 IS STORED AS ABOVE, BUT AS EACH INSTRUCTION
C  REQUIRES A RECORD OF TYPE 60, 61, 62, 63 AND 64, THESE ARE STORED
C  WITH RECORD NUMBERS OF -(10000*N + M). 'N' IS THE NUMBER OF THE
C  CURRENT INSTRUCTION IN THE INPUT STREAM, AND M IS THE 60 VALUE.
C  THIS MEANS THAT ONLY RECORD 50 IS LOADED IMMEDIATELY, BUT THAT
C  POINTERS ARE SET UP TO THE REST.
C
C--
C
C
      CHARACTER CFORM*9, CFMND*8, CFMRQ*6, CEND*3
      CHARACTER CIMAGE*80
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ISTORE(131072)
      DIMENSION ICOM50(32)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (LR50,ICOM50(1))
C
C
C
      DATA CFORM / '(19A4,4X)'/, CFMND / '(A4,76X)' /
      DATA CFMRQ / '(20A4)'/, CEND / 'END' /
C
900   CONTINUE
C----- WE COULD COME BACK HERE AFTER AN ERROR - RESET FLAG
C--INITIAL SCAN  -  LAST CARD WAS OKAY
1000  CONTINUE
      I=-1
C--SET THE LIST FLAGS TO ZERO INITIALLY
      LSTOP=0
      LSTNO=0
      ITYPFL = 1
      INSTR = 0
      ICLASS=-1
      IDIRFL=-1
      IPARAM=-1
C--CHECK IF THE CURRENT CARD CONTAINS A '#INSTRUCTION' CARD
1050  CONTINUE
      IF(IHFLAG)1100,1150,1150
C--NO '#INSTRUCTION'  -  READ THE NEXT RECORD
1100  CONTINUE
      CALL XMONTR(I)
C--ALL SUBSEQUENT CARDS ARE IN ERROR
      I=0
      IF(KRDREC(I))1100,1050,1050
C--'#' CARD FOUND  -  CHECK FOR END OF FILE
1150  CONTINUE
      IF(IEOF)1100,1200,1200
C--'#INSTRUCTION' CARD FOUND  -  SET THE CHARACTER POINTERS
1200  CONTINUE
      NC=2
      ND=KEQUAL(NC,IB)
C--CLEAR THE ERROR INDICATORS
      IERFLG = 1
      LEF=0
      LSTLEF=LEF
C--CLEAR CORE
      CALL XCSAE
      CALL XRSL
C--LOAD PART OF LIST 50
      CALL XFAL50
C--SEARCH FOR THE FOUND '#INSTRUCTION' IN LIST 50
      ITYPFL=1
      INSTR=KCNXTS(MDR50-1,ISTORE(LR50),NR50,MDR50)
C--CHECK IF WE HAVE FOUND ANYTHING
      IF(INSTR)1250,1250,1350
C--ILLEGAL OR UNKNOWN INSTRUCTION
1250  CONTINUE
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1300)IH
      ENDIF
      WRITE(NCAWU,1300) IH
1300  FORMAT(21H Unknown or illegal ',A1,
     2 29HInstruction' on the last card)
      CALL XERHND ( IERERR )
C -- CLEAR INDICATION OF INSTRUCTION, TO STOP LOOPING
      IHFLAG = -1
      GO TO 900
C--SUCCESS  -  CHECK FOR '#LIST', '#PRINT' OR '#PUNCH'
1350  CONTINUE
      LFL=LR52-1
      IF(INSTR-LSTOFF)1400,1400,1410
1410  CONTINUE
C----- CHECK FOR 'CONCEALED' LIST, EXCEPT SFLS
      I= INSTR - LSTOFF
      IF ((I .GT. 49) .OR. (I .EQ. 33)) GOTO 1700
      LSTNO = I
      LSTOP = 1
      ICLASS = -1
      GOTO 1700
C--THIS IS A LIST CALL  -  PROCESS THE LIST TYPE
1400  CONTINUE
      JB=LFL
      CALL XLL50R(INSTR)
      CALL XZEROF(IBUFF(1),4)
C--READ THE DIRECTIVE
      IF(KRDNDC(IBUFF(1),4)-1)1250,1450,1250
C--LOOP OVER THE INPUT PARAMETERS ON THIS DIRECTIVE
1450  CONTINUE
      DO 1550 I=1,NR62D
C--FIND THE PARAMETER
      IF(KFNDNP(I))1250,1550,1500
C--READ THE VALUE
1500  CONTINUE
      IF(KRDPV(IBUFF(1),4))1250,1550,1550
1550  CONTINUE
C--CHECK THAT THERE ARE NO MORE PARAMETERS ON THIS CARD
      IF(KCHKUP(IBUFF(1),4))1250,1600,1600
C--INSERT ANY NECESSARY DEFAULTS
1600  CONTINUE
      IF(KCHKPV(1,IBUFF(1),4,-1))1250,1650,1650
C--ALTER 'INSTR' TO REFLECT THIS CHANGE
1650  CONTINUE
      LSTOP=INSTR
      LSTNO=IBUFF(1)
      INSTR=IBUFF(1)+LSTOFF
C--RESET THE CORE LIMIT
      LFL=JB
C--SET THE CLASS TYPE
      ICLASS=IBUFF(2)
C -- CHECK THAT THE REQUESTED LIST NUMBER IS ALLOWED
      ISTAT = KLSCHK ( LSTNO , 0 , 0 , ILSCLN , ILSMSG , I , IERNOP )
      IF ( ISTAT .LE. 0 ) GO TO 1250
C--SUCCESS  -  LOAD THE DETAILS FOR THIS COMMAND
1700  CONTINUE
      CALL XLL50R(INSTR)
C--CHECK IF THERE IS A LIST OF LISTS TO BE USED
      IF(NR63)2800,2800,1750
C--LISTS TO BE USED ARE GIVEN  -  CHECK FOR ANY LIST GENERATION CALLS
1750  CONTINUE
      NLIST=0
      MR63=LR63
C--INDICATE THAT WE HAVE NOT EMPTIED THE SYSTEM REQUEST QUEUE
      KA=0
C--LOOP OVER THE LISTS TO BE USED FOR THIS '#INSTRUCTION'
      DO 2600 I=1,NR63
      MR52=LR52
C--CHECK AGAINST THOSE LISTS PROVIDED FOR INTERNAL GENERATION
      DO 2500 K=1,NR52
      IF(ISTORE(MR52)-ISTORE(MR63))2450,1800,2450
C--AGREEMENT  -  CHECK IF THE LIST EXISTS
1800  CONTINUE
      CALL XRLIND(ISTORE(MR52),NA,NB,NC,ND,NE,IBUFF(1))
      IF(NB)2200,2200,1850
C--CHECK THE WRITE/OVERWRITE STATUS
1850  CONTINUE
      IF(ND)2200,1900,2200
C--CHECK THE ERROR STATUS
1900  CONTINUE
      IF(NE)2200,1950,1950
C--LIST IS OKAY  -  FIND ITS INTERDEPENDENCIES RECORD
1950  CONTINUE
      IF(KFNDRI(ISTORE(MR52),1,IADDR,IBUFF))2550,2000,2000
C--RECORD FOUND  -  PRESERVE THE CORE LIMITS
2000  CONTINUE
      JA=NFL
      JB=LFL
C--MAKE SPACE FOR THE DATA IN THE RECORD
      KK=IBUFF(5)*IBUFF(6)
      L=KCHLFL(KK)
C--BRING DOWN THE DATA
      CALL XDOWNF(IBUFF(4),STORE(L),KK)
C--RESET THE CORE POINTERS
      NFL=JA
      LFL=JB
      N=IBUFF(5)
C--LOOP OVER EACH LIST TYPE FOR THIS ONE ON DISC
2050  CONTINUE
      IF(N)2450,2450,2100
C--READ THE DATA FOR THIS LIST
2100  CONTINUE
      CALL XRLIND(ISTORE(L),NA,NB,NC,ND,NE,IBUFF(1))
C--CHECK IF THIS LIST EXISTS
      IF(NB)2400,2400,2150
C--CHECK IF THE CURRENT VERSION IS THE ONE USED TO MAKE THIS LIST
2150  CONTINUE
      M=L+IBUFF(5)
      IF(IABS(NE)-ISTORE(M))2200,2400,2200
C--COMMAND TO BE ISSUED  -  CHECK IF THERE IS DATA IN THE S.R.Q.
2200  CONTINUE
      IF(NLIST)2250,2250,2350
C--WE HAVE NOT EMPTIED THE QUEUE YET  -  CHECK IF WE SHOULD
2250  CONTINUE
      IF(NREC)2350,2350,2300
C--EMPTY THE SYSTEM REQUEST QUEUE
2300  CONTINUE
      KA=NREC
      KB=20
      KC=KA*KB
C--ALLOCATE A BUFFER TO HOLD THE RECORDS
      KD=KCHLFL(KC)
C--READ THE RECORDS
      KC=KD+KC-1
      READ(NUSRQ,CFMRQ) (ISTORE(KE), KE=KD, KC)
C--SORT THE QUEUE OUT
      NREC=0
      IEOF=NREC
      IPOSRQ=0
      REWIND NUSRQ
C--NEW LIST IS REQUIRED OF THIS TYPE  -  ISSUE A COMMAND
2350  CONTINUE
      WRITE (CIMAGE, CFORM) (ISTORE(IZ), IZ= MR52+1, MR52+MDR52-2)
      CALL XISRC (CIMAGE)
C--ADD AN 'END' CARD
      CALL XISRC (CEND)
      NLIST=NLIST+1
      GOTO 2550
C--UPDATE FOR THE NEXT LIST STORED HERE
2400  CONTINUE
      L=L+1
      N=N-1
      GOTO 2050
C--UPDATE FOR THE NEXT LIST ON THE GENERATION STACK
2450  CONTINUE
      MR52=MR52+MDR52
2500  CONTINUE
C--UPDATE FOR THE NEXT LIST TO BE USED BY THIS '#INSTRUCTION'
2550  CONTINUE
      MR63=MR63+MDR63
2600  CONTINUE
C--CHECK IF ANY REQUEST HAVE BEEN ISSUED
      IF(NLIST)2800,2800,2650
C--PROCESS SOME MORE REQUESTS
2650  CONTINUE
      I=KPSRQ(1)
C--CHECK IF WE MUST ADD THE REQUESTS WE HAVE STORED IN CORE
      IF(KA)1000,1000,2700
C--LOOP OVER EACH REQUEST
2700  CONTINUE
      DO 2750 I=1,KA
      WRITE(CIMAGE,CFMRQ) (ISTORE(IZ), IZ= KD, KD+KB-1)
      CALL XISRC (CIMAGE)
      KD=KD+KB
2750  CONTINUE
      GOTO 1000
C--CLEAR CORE AND RELOAD THE DETAILS FOR THIS COMMAND
2800  CONTINUE
      CALL XRSL
      CALL XCSAE
      CALL XLL50R(INSTR)
C--ASSIGN THE RETURN VALUES
      KFNHF=ISTORE(LR64)
C--RESET THE DIRECTIVE POINTERS
      IDIRFL=-1
      IPARAM=-1
      IPARAD=NOWT
      RETURN
      END
C
CODE FOR KRDDPV
      FUNCTION KRDDPV(ICOMMN,IDIMN)
C--THIS ROUTINE READS A SET OF DIRECTIVES, TOGETHER WITH THE PARAMETERS
C  OFF THE DIRECTIVE CARDS.
C
C  ICOMMN  THE COMMON BLOCK FOR THIS INPUT OPERATION.
C  IDIMN    THE DIMENSION OF THE COMMON BLOCK.
C----- IDIM SET IN XRDLN, CURRENTLY TO 512
C
C--RETURN VALUES OF 'KRDDPV' ARE :
C
C  -1  ERRORS.
C   0  ALL PROCESSED OKAY.
C
C--
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C--ZERO THE COMMON BLOCK INITIALLY
      CALL XZEROF(ICOMMN,IDIMN)
C--READ THE NEXT DIRECTIVE
1000  CONTINUE
      IF(KRDNDC(ICOMMN,IDIMN))1250,1050,1050
C--FIND THE NEXT PARAMETER
1050  CONTINUE
      IF(KFNDNP(I))1000,1000,1100
C--READ THE PARAMETER VALUE
1100  CONTINUE
      IF(KRDPV(ICOMMN,IDIMN))1000,1050,1150
C--STRING FOR INTERPRETATION  -  NOT BY US!
1150  CONTINUE
      CALL XMONTR(0)
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)
      ENDIF
      WRITE(NCAWU,1200)
1200  FORMAT(39H Parameter type is illegal for 'KRDDPV')
      CALL XERHND ( IERPRG )
C--END OF THE DATA  -  CHECK FOR ERRORS
1250  CONTINUE
      KRDDPV=0
      IF(LEF)1300,1350,1300
C--ERRORS FOUND
1300  CONTINUE
      KRDDPV=-1
1350  CONTINUE
      RETURN
      END
C
CODE FOR KRDNDC
      FUNCTION KRDNDC(ICOMMN,IDIMN)
C--READ THE NEXT DIRECTIVE CARD.
C
C  ICOMMN  THE DATA OR COMMON BLOCK AREA BEING SET UP FOR THIS
C          INSTRUCTION.
C  IDIMN    THE SIZE OF 'ICOMMN'.
C
C--THE COMMON BLOCK 'XCARDS' IS USED BY THIS AND OTHER ROUTINES
C  FOR CARD I/O CONTROL. THE VARIABLES ARE :
C
C  IMAGE   THE INPUT CARD BUFFER.
C  NC      THE CURRENT PROCESSING POSITION IN 'IMAGE'.
C  ND      EITHER 'NC' OR THE END OF THE CURRENT INFORMATION TO BE
C          PROCESSED IN 'IMAGE'.
C  LASTCH  THE LAST CHARACTER ON THE CURRENT INPUT RECORD TO BE USED.
C  NI      THE NUMBER OF THE CURRENT INPUT CARD.
C  NILAST  THE NUMBER OF THE CARD FOR THE LAST '#INSTRUCTION' FOUND.
C  NS      THE INCREMENT BETWEEN SUCCESSIVE INPUT RECORDS. THIS IS ONE
C          FOR DATA FROM THE USER AND 10000 FOR DATA ON THE SYSTEM
C          REQUEST QUEUE.
C  MON     THE NUMBER OF THE LAST CARD PRINTED BY 'XMONTR'.
C  ICAT    THE TYPE OF LISTING REQUEST FOR THE CARDS THAT ARE
C          PROCESSED. THIS VARIABLE IS USED BY 'XMONTR'.
C  IEOF    END OF FILE AND SYSTEM REQUEST QUEUE FLAG :
C
C          -1  LAST STATEMENT READ END OF FILE, AND THUS THE NEXT WILL
C              CALL WILL FAIL THE JOB.
C           0  NORMAL READING FROM THE CONTROL STREAM.
C          >0  READING FROM THE SYSTEM REQUEST QUEUE.
C
C  IHFLAG  THIS VARIABLE INDICATES WHETHER THE LAST CARD CONTAINED
C          A '#INSTRUCTION' WHICH HAS NOT YET BEEN PROCESSE :
C
C          -1  NO '#INSTRUCTION' ON THE LAST CARD.
C           0  UNPROCESSED '#INSTRUCTION' ON THE LAST CARD.
C          +1    PROCESSED '#INSTRUCTION' ON THE LAST CARD.
C
C  NUSRQ   THE UNIT TO BE USED FOR THE SYSTEM REQUEST QUEUE.
C  NREC    THE NUMBER OF REQUESTS OUTSTANDING ON THE SYSTEM REQUEST
C          QUEUE.
C  IPOSRQ  THE CURRENT POSITION OF THE REQUEST QUEUE.
C  ITYPFL  THIS VARIBLE INDICATES THE TYPE OF KEYWORD BEING PROCESSED
C          AT PRESENT :
C
C          1  INSTRUCTION.
C          2  DIRECTIVE.
C          3  PARAMETER.
C          4  REQUIRED INPUT VALUE.
C
C  INSTR   THE NUMBER OF THE CURRENT INSTRUCTION.
C  IDIRFL  THIS CONTAINS THE NUMBER OF THE CURRENT DIRECTIVE, OR
C          -1  IF NO DIRECTIVE IS BEING PROCESSED.
C  IPARAM  THIS CONTAINS THE NUMBER OF THE CURRENT PARAMETER, OR
C          -1  IF NO PARAMETER IS BEING PROCESSED.
C  IPARAD  THIS CONTAINS THE ADDRESS OF THE CURRENT GROUP IN THE
C          DATA AREA FOR THE CURRENT DIRECTIVE OR 'NOWT'.
C
C--RETURN VALUES OF 'KRDNDC' ARE :
C
C  -1  END OF DIRECTIVES FOR THIS '#INSTRUCTION'
C   0  CONTINUATION CARD.
C  >0  THE DIRECTIVE FOUND.
C
C--THIS ROUTINE EXPECTS THAT TYPE 60 RECORDS WILL ALREADY BE
C  LOADED.
C
C--
      DIMENSION ICOM50(32)
      DIMENSION ISTORE(131072)
C
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XSYSHF/NWHF,NHF,LHF,IHF(68)
      COMMON/XSYSDR/NWSPD,NSPD,LSPD,ISPD(13,2)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (LR50,ICOM50(1))
C
C--PRESERVE THE PARAMETER POINTERS
      JPARAM=IPARAM
      JPARAD=IPARAD
C--INDICATE THAT NO PARAMETERS ARE BEING PROCESSED
      IPARAM=-1
      IPARAD=NOWT
C--SET THE TYPE OF CHARACTER STRING WE ARE SEARCHING FOR
      ITYPFL=2
C--CHECK IF WE ARE PROCESSING A '#INSTRUCTION' CARD STILL
      IF(IHFLAG)1100,1000,1000
C--'#INSTRUCTION' CARD  -  CHECK FOR THE NAME AMONGST THE DIRECTIVES
1000  CONTINUE
      IHFLAG=-1
      IF(NR60)1100,1100,1050
C--SOME TO USE  -  MAKE THE COMPARISON
1050  CONTINUE
      NC=2
      ND=KEQUAL(NC,IB)
      NUM=KCNXTS(MDR60-1,ISTORE(LR60),NR60,MDR60)
C--CHECK THE REPLY
      NC=ND
      IF(NUM)1100,1100,1850
C--END OF THE LAST CARD  -  CHECK FOR UNACCESSED PARAMETERS
1100  CONTINUE
      IF(KCHKUP(ICOMMN,IDIMN))1300,1150,1150
C--READ THE NEXT CARD FROM THE APPROPIATE STREAM
1150  CONTINUE
      IF(KRDREC(I))2600,1200,2600
C--THIS IS A NORMAL CARD WITHOUT A '#' IN COLUMN ONE
1200  CONTINUE
      IF(IMAGE(1).NE.IB)GOTO 1350
C--THIS CARD HAS NOTHING IN COLUMN ONE  -  THIS IS AN ERROR
      I=KCHKPV(IDIRFL,ICOMMN,IDIMN,1)
C--NOW PRINT SOME ERROR MESSAGE
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1250)
      ENDIF
      WRITE(NCAWU,1250)
1250  FORMAT(/36H The user directive has been omitted,
     2 32H or does not begin in column one/)
C--GENERAL ERROR AREA
1300  CONTINUE
      LEF=LEF+1
      IDIRFL=-1
      CALL XMONTR(0)
      GOTO 1150
C--FIND THE NEXT BLANK TO TERMINATE THE USER DIRECTIVE
1350  CONTINUE
      ND=KEQUAL(NC,IB)
C--CHECK FOR SYSTEM DEFINED DIRECTIVE
      I=KCNXTS(NWSPD,ISPD,NSPD,LSPD)
C--CHECK THE REPLY
      IF(I)1150,1700,1400
C--SUCCESS  -  CHECK THAT THERE IS NOT AN IDENTITY CLASH
1400  CONTINUE
      NC=1
      IF(NR60)1500,1500,1420
1420  CONTINUE
      IF(KCNXTS(MDR60-1,ISTORE(LR60),NR60,MDR60))1150,1500,1450
C--DIRECTIVE NAME CLASH  -  ERROR
1450  CONTINUE
      I=KCHKPV(IDIRFL,ICOMMN,IDIMN,1)
      CALL XMDCS
      GOTO 1150
C--A SYSTEM DEFINED DIRECTIVE HAS BEEN FOUND  -  BRANCH ON ITS TYPE
1500  CONTINUE
      IF(I-1)1550,1550,2600
C--THIS IS A 'CONTINUE' DIRECTIVE  -  CHECK FOR A DIRECTIVE
1550  CONTINUE
      IF(IDIRFL)1300,1600,1600
C--DIRECTIVE OKAY  -  CARRY ON
1600  CONTINUE
      KRDNDC=0
      IPARAM=JPARAM
      IPARAD=JPARAD
C--RESET THE CURRENT POSITION
1650  CONTINUE
      NC=ND
      RETURN
C
1700  CONTINUE
C -- NOT A SYSTEM DIRECTIVE. CHECK FOR A DIRECTIVE FROM THE COMMAND
C    FILE, IF THERE ARE ANY
      IF ( NR60 .LE. 0 ) GO TO 1750
      NUM=KCNXTS(MDR60-1,ISTORE(LR60),NR60,MDR60)
      IF(NUM)1150,1750,1850
C--NOT A USER DIRECTIVE EITHER  -  PRINT AN ERROR MESSAGE
1750  CONTINUE
      I=KCHKPV(IDIRFL,ICOMMN,IDIMN,1)
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1800)IH
      ENDIF
      WRITE ( NCAWU,1800 ) IH
1800  FORMAT(/42H The directive on the last card is illegal,
     2 12H with this ',A1,12HInstruction')
      GOTO 1300
C--ENSURE THAT THE LAST USER DIRECTIVE TERMINATED OKAY
1850  CONTINUE
      I=KCHKPV(IDIRFL,ICOMMN,IDIMN,1)
C--SET UP THE REST OF THE POINTERS FOR THIS DIRECTIVE
      CALL XDIRFL(NUM,ICOMMN,IDIMN)
      IDIRFL=NUM
C--CHECK IF THIS DIRECTIVE HAS BEEN ENABLED
      IF(KINCLD(ICOMMN,IDIMN))1900,2000,2000
C--THIS DIRECTIVE HAS NOT BEEN ENABLED FOR INPUT FOR CREATION
1900  CONTINUE
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1950)
      ENDIF
      WRITE ( NCAWU,1950 )
1950  FORMAT(/42H At least one other directive or parameter,
     2 46H has been omitted, so that the directive above,
     3 20H cannot be processed)
      GOTO 1300
C--CREATE ANY DATA AREAS THAT ARE REQUIRED
2000  CONTINUE
      IF(KCDRFI(ICOMMN,IDIMN,-1))1150,2050,2050
C--CHECK IF THIS DIRECTIVE IS VALID HERE
2050  CONTINUE
      IF(ISTORE(MR61+6))2100,2200,2200
C--THIS DIRECTIVE HAS BEEN DISALLOWED BY ANOTHER DIRECTIVE
2100  CONTINUE
      J=LR60+(IABS(ISTORE(MR61+6))-1)*MDR60
      K=J+MDR60-2
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2150)(STORE(I+1),I=J,K)
      ENDIF
      WRITE(NCAWU,2150) (STORE(I+1),I=J,K)
2150  FORMAT(/35H The directive above may not follow,
     2 35H a card containing the directive : ,40A1)
      GOTO 1300
C--CHECK IF THIS DIRECTIVE CAN BE INPUT HERE
2200  CONTINUE
      IF(ISTORE(MR61+8))2250,2350,2350
C--NOT ALLOWED ANY MORE
2250  CONTINUE
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2300)
      ENDIF
      WRITE(NCAWU,2300)
2300  FORMAT(/47H The last directive should have appeared before,
     2 25H and will be ignored here)
      GOTO 1300
C--CHECK IF THIS DIRECTIVE HAS ALREADY BEEN DEFAULTED
2350  CONTINUE
      IF(ISTORE(MR61+8)-1000000)2400,2400,2250
C--CHECK IF THIS DIRECTIVE HAS BEEN REPEATED TOO MANY TIMES
2400  CONTINUE
      ISTORE(MR61+8)=ISTORE(MR61+8)+1
      IF(ISTORE(MR61+7)-ISTORE(MR61+8))2450,2550,2550
C--THIS DIRECTIVE HAS APPEARED TOO MANY TIMES
2450  CONTINUE
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2500)
      ENDIF
      WRITE ( NCAWU,2500 )
2500  FORMAT(/48H The last directive has appeared too many times,,
     2 35H or should not have appeared at all)
C -- MARK DIRECTIVE AS BEING IN ERROR
      ISTORE(MR61+8) = -1
      GOTO 1300
C--CHECK IF THIS DIRECTIVE EXCLUDES ANY OTHER DIRECTIVES
2550  CONTINUE
      CALL XCLUDE(NUM)
C--SET THE RETURN VALUES AT THIS POINT
      KRDNDC=NUM
C--SET THE POINTERS UP AGAIN FOR THE BENEFIT OF THE DATA RECORD POINTER
      CALL XDIRFL(IDIRFL,ICOMMN,IDIMN)
C--ZERO THE PARAMETER REPEAT COUNTS IF NECESSARY
      CALL XZROPC
      GOTO 1650
C
C--'#INSTRUCTION' OR 'END' DIRECTIVE  -  CHECK THE LAST IF NECCESSARY
2600  CONTINUE
      I=KCHKPV(IDIRFL,ICOMMN,IDIMN,1)
C--CHECK IF THERE IS AN 'END' CARD TO PRINT
      IF(IHFLAG)2650,2700,2700
C--PRINT THE LAST CARD
2650  CONTINUE
      CALL XMONTR(-1)
C--CHECK IF THERE ARE ANY DIRECTIVES FOR THIS INSTRUCTION
2700  CONTINUE
      IF(NR60)3450,3450,2750
C--LOOP OVER EACH DIRECTIVE, CHECKING IF IT HAS BEEN INPUT
2750  CONTINUE
      DO 3400 I=1,NR60
      CALL XDIRFL(I,ICOMMN,IDIMN)
      IDIRFL=I
C--CHECK IF THIS DIRECTIVE HAS BEEN INPUT
      IF(ISTORE(MR61+8))3400,2950,2800
C--DIRECTIVE INPUT  -  CHECK IF IT DEFINED A DATA RECORD
2800  CONTINUE
      IF(ISTORE(MR61+11))3400,3400,2850
C--RECORD DEFINED  -  CHECK IF ALL THE DATA HAS BEEN INPUT
2850  CONTINUE
      IF(ISTORE(MR61+7)-ISTORE(MR61+8))2900,3400,2900
C--ALL THE DATA IS NOT THERE  -  SET UP SOME DEFAULTS
2900  CONTINUE
      ISTORE(MR61+8)=ISTORE(MR61+8)+1
      GOTO 3100
C--CREATE ANY ASSOCIATED DATA AREAS
2950  CONTINUE
      IF(KINCLD(ICOMMN,IDIMN))3400,3000,3000
C--AND NOW THE DATA RECORD
3000  CONTINUE
      IF(KCDRFI(ICOMMN,IDIMN,0))3400,3050,3050
C--SET UP THE NUMBER OF PASSES
3050  CONTINUE
      ISTORE(MR61+8)=1
C--EXCLUDE ANY DIRECTIVES FOR THIS ONE
      CALL XCLUDE(I)
C--NOW SET UP THE DEFAULTS FOR ONE GROUP
3100  CONTINUE
      CALL XZROPC
      IF(KCHKPV(I,ICOMMN,IDIMN,0))3400,3150,3150
C--CHECK IF THIS DIRECTIVE DEFINED A DATA RECORD
3150  CONTINUE
      IF(ISTORE(MR61+11))3400,3400,3200
C--DATA RECORD IN CORE  -  CHECK IF ALL THE GROUPS HAVE BEEN SET
3200  CONTINUE
      N=ISTORE(MR61+7)-ISTORE(MR61+8)
      IF(N)3400,3400,3250
C--CHECK IF THERE ANY PARAMETERS FROM WHICH TO FIND DEFAULTS
3250  CONTINUE
      IF(NR62D)3400,3400,3300
C--SET UP THE REST OF THE GROUPS IN THE RECORD
3300  CONTINUE
      L=IPARAD
      DO 3350 J=1,N
      L=L+ISTORE(MR61+9)
      CALL XMOVE(STORE(IPARAD),STORE(L),ISTORE(MR61+9))
3350  CONTINUE
3400  CONTINUE
C--INDICATE END OF DIRECTIVES FOR THIS '#INSTRUCTION'
3450  CONTINUE
      KRDNDC=-1
      IDIRFL=-1
      GOTO 1650
      END
C
CODE FOR KCHKUP
      FUNCTION KCHKUP(ICOMMN,IDIMN)
C--CHECK THE LAST DIRECTIVE FOR UNACCESSED PARAMETERS
C
C  ICOMMN  THE COMMON BLOCK FOR TIS INPUT.
C  IDIMN    THE DIMENSION OF THE COMON BLOCK.
C
C--THIS ROUTINE RETURNS VALUES OF :
C
C  -1  THE LAST CARD CONTAINED UNACCESSED PARAMETERS.
C   0  THE LAST CARD WAS PROCESSED CORRECTLY
C
C--
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
C
C--SET AN OKAY RETURN VALUE
      KCHKUP=0
C--CHECK IF THE LAST CARD CONTAINS A DIRECTIVE
      IF(IDIRFL)1000,1000,1050
1000  CONTINUE
      RETURN
C--DIRECTIVE TO LOOK AT
1050  CONTINUE
      NC=KNEQUL(NC,IB)
      IF(NC)1000,1000,1100
C--UNACCESSED PARAMETERS
1100  CONTINUE
      CALL XMONTR(0)
      J=NC-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1150)J
      ENDIF
      WRITE(NCAWU,1150)J
1150  FORMAT(/23H The last card contains,
     2 39H unaccessed parameter(s) beyond column ,I4)
C--NOW CHECK THE LAST RECORD INPUT
      I=KCHKPV(IDIRFL,ICOMMN,IDIMN,-1)
      IDIRFL=-1
      LEF=LEF+1
      KCHKUP=-1
      GOTO 1000
      END
C
CODE FOR XCLUDE
      SUBROUTINE XCLUDE(NUM)
C--CHECK IF THIS DIRECTIVE EXCLUDES ANY OTHER DIRECTIVES
C
C  NUM     THE NUMBER OF THE DIRECTIVE TO EXCLUDE.
C
C--THIS ROUTINE EXPECTS THE LIST 50 POINTERS TO BE SET UP.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF THIS DIRECTIVE EXCLUDES ANY OTHER DIRECTIVES
      IF(ISTORE(MR61+6))1100,1100,1000
C--MARK THE DIRECTIVES TO BE EXCLUDED
1000  CONTINUE
      J=ISTORE(MR61+4)+LR62
      N=ISTORE(MR61+6)
C--LOOP OVER EACH DIRECTIVE TO BE EXCLUDED
      DO 1050 I=1,N
      K=LR61+(ISTORE(J)-1)*MDR61
      ISTORE(K+6)=-NUM
      J=J+ISTORE(MR61+5)
1050  CONTINUE
C--AND NOW RETURN
1100  CONTINUE
      RETURN
      END
C
CODE FOR KINCLD
      FUNCTION KINCLD(ICOMMN,IDIMN)
C -- CHECK IF THE CURRENT DIRECTIVE HAS BEEN ENABLED
C
C  ICOMMN  THE CURRENT COMMON BLOCK.
C  IDIMN    THE DIMENSION OF THE COMMON BLOCK.
C
C--RETURN VALUES ARE :
C
C  -1  THIS DIRECTIVE REQUIRES OTHER DIRECTIVES BEFORE IT CAN INCLUDED,
C      AND THESE HAVE NOT YET BEEN GIVEN.
C   0  ALL OKAY TO INCLUDE THIS DIRECTIVE.
C
C--
      DIMENSION ISTORE(131072)
C
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--ASSIGN THE INITIAL OKAY RETURN VALUE
      KINCLD=0
C--CHECK IF THIS DIRECTIVE DEFINES A DATA RECORD
C--CHECK IF THERE ARE ANY ENABLING DIRECTIVES FOR THIS DIRECTIVE
      IF(ISTORE(MR61+31))1500,1500,1050
C--THERE ARE ENABLING DIRECTIVES GIVEN  -  LOOP OVER THEM
1050  CONTINUE
      N=ISTORE(MR61+31)
      M=ISTORE(MR61+29)+LR62
      DO 1450 I=1,N
C--COMPUTE THE ADDRESS OF THE CURRENT DIRECTIVE
      L=LR61+(ISTORE(M)-1)*MDR61
C--CHECK IF THE GIVEN DIRECTIVE HAS BEEN INPUT
      IF(ISTORE(L+8))1400,1400,1100
C--THIS DIRECTIVE HAS BEEN INPUT  -  CHECK IF A PARAMETER VALUE IS REQUI
1100  CONTINUE
      IF(ISTORE(M+1))1150,1150,1200
C--NO VALUE IS REQUIRED  -  ALLOW THIS DIRECTIVE
1150  CONTINUE
      KINCLD=0
      GOTO 1500
C--A VALUE IS REQUIRED  -  CHECK THE PARAMETER VALUE GIVEN
1200  CONTINUE
      IF(ISTORE(M+1)-ISTORE(L+3))1250,1250,1400
C--CHECK IF WE ARE IN A DATA RECORD FOR THIS DIRECTIVE
1250  CONTINUE
      IF(ISTORE(L+11))1400,1300,1350
C--COMMON BLOCK DATA  -  FIND THE COMMON BLOCK ADDRESS
1300  CONTINUE
      K=LR62+ISTORE(L)+ISTORE(L+1)+(ISTORE(M+1)-1)*ISTORE(L+2)
      IF(KVALCM(ISTORE(K+4),ICOMMN,IDIMN)-ISTORE(M+2))1400,1150,1400
C--IN A DATA RECORD  -  HUNT FOR THE RECORD
1350  CONTINUE
      J=KHUNTR(ISTORE(L+13),ISTORE(L+11),IADDL,IADDR,IADDD,0)
      K=ISTORE(M+1)+IADDD
      IF(ISTORE(K-1)-ISTORE(M+2))1400,1150,1400
C--UPDATE FOR THE NEXT ENABLING DIRECTIVE
1400  CONTINUE
      M=M+ISTORE(MR61+30)
1450  CONTINUE
      KINCLD=-1
C--AND NOW RETURN
1500  CONTINUE
      RETURN
      END
C
CODE FOR XZROPC
      SUBROUTINE XZROPC
C--ZERO THE REPEAT COUNTS FOR THE PARAMETERS OF THE CURRENT DIRECTIVE
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF THERE ARE ANY PARAMETERS FOR THIS DIRECTIVE
      IF(NR62D)1100,1100,1000
C--THERE ARE SOME PARAMETERS  -  ZERO THEIR INPUT COUNTS
1000  CONTINUE
      MR62D=LR62D
C--PASS OVER EACH PARAMETER
      DO 1050 I=1,NR62D
      ISTORE(MR62D+10)=0
      MR62D=MR62D+MDR62D
1050  CONTINUE
1100  CONTINUE
      RETURN
      END
C
CODE FOR KFNDNP
      FUNCTION KFNDNP(IN)
C--THIS FUNCTION FINDS THE NEXT PARAMETER ON A DIRECTIVE CARD
C
C  IN  A DUMMY ARGUMENT.
C
C--RETURN VALUES OF 'KFNDNP' ARE :
C
C  -1  NO MATCH OR ANY OTHER TYPE OF ERROR.
C   0  END OF CARD FOUND, OR THIS DIRECTIVE HAS NO PARAMETERS.
C  >0  THE PARAMETER THAT HAS BEEN FOUND.
C
C--THIS ROUTINE SETS 'IPARAM' AND THE POINTERS IN LIST 50 WHEN
C  A SUCCESSFUL FIND IS MADE.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET THE TYPE OF ARGUMENT FLAG
      ITYPFL=3
      KFNDNP=0
C--CHECK FOR SOME PARAMETERS TO SEARCH FOR
      IF(NR62D)1300,1300,1000
C--FIND THE NEXT NON-BLANK CHARACTER
1000  CONTINUE
      NC=KNEQUL(NC,IB)
C--CHECK FOR THE END OF THE CARD
      ND=NC
      IF(ND)1300,1300,1050
C--CHECK IF THE NEXT CHARACTER IS A BLANK
1050  CONTINUE
      IF(IMAGE(ND).EQ.IB)GOTO 1400
C--CHECK FOR A COMMA
      IF(IMAGE(ND).EQ.ICOMMA)GOTO 1500
C--CHECK FOR AN EQUALS SIGN TO TERMINATE THE PARAMETER KEYWORD
      NND=ND
      IF(IMAGE(ND).EQ.IEQUAL)GOTO 1100
C--UPDATE FOR THE NEXT CHARACTER
      ND=ND+1
C--CHECK FOR THE END OF THE CARD
      IF(ND-LASTCH)1050,1050,1500
C--EQUALS SIGN  -  SEARCH FOR THE KEYWORD
1100  CONTINUE
      IPARAM=KCNXTS(MDR62N-1,ISTORE(LR62N),NR62N,MDR62D)
C--CHECK FOR SUCCESS
      IF(IPARAM)1250,1150,1350
C--NO MATCH  -  ERROR MESSAGE
1150  CONTINUE
      CALL XMONTR(0)
      ND=ND-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)(IMAGE(I),I=NC,ND)
      ENDIF
      WRITE(NCAWU,1200) (IMAGE(I),I=NC,ND)
1200  FORMAT(/29H Unknown parameter keyword : ,80A1)
C--ERROR RETURN
1250  CONTINUE
      IDIRFL=-1
      LEF=LEF+1
      KFNDNP=-1
C--AND NOW RETURN
1300  CONTINUE
      RETURN
C--KEYWORD FOUND  -  UPDATE THE CHARACTER COUNT
1350  CONTINUE
      NC=NND+1
      NC=KNEQUL(NC,IB)
      GOTO 1550
C--BLANK FOUND  -  SEARCH FOR '=' AFTER IT
1400  CONTINUE
      NND=ND+1
      NND=KNEQUL(NND,IB)
      IF(NND)1500,1500,1450
C--ANOTHER CHARACTER  -  CHECK IT
1450  CONTINUE
      IF(IMAGE(NND).EQ.IEQUAL)GOTO 1100
C--CHARACTER FOUND THAT CANNOT BE PART OF A KEYWORD  -  THUS NO KEYWORD
1500  CONTINUE
      IPARAM=MIN0(IPARAM+1,NR62D)
C--SET UP THE POINTERS IN LIST 50
1550  CONTINUE
      I=(IPARAM-1)*MDR62D
      MR62D=LR62D+I
      MR62N=LR62N+I
C--UPDATE THE NUMBER OF TIMES WE HAVE FOUND THIS PARAMETER
      ISTORE(MR62D+10)=ISTORE(MR62D+10)+1
C--CHECK THAT WE HAVE NOT READ THIS TOO MANY TIMES
      IF(ISTORE(MR62D+10)-ISTORE(MR62D+9))1700,1700,1600
C--PARAMETER GIVEN TOO MANY TIMES
1600  CONTINUE
      CALL XMONTR(0)
      J=MR62N+MDR62N-2
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1650)IPARAM,(ISTORE(I+1),I=MR62N,J)
      ENDIF
      WRITE(NCAWU,1650)IPARAM,(ISTORE(I+1),I=MR62N,J)
1650  FORMAT(/11H Parameter ,I5,29H  has appeared too many times,
     2 25H  -  parameter keyword : ,40A1)
      GOTO 1250
C--ASSIGN THE RETURN VALUE
1700  CONTINUE
      KFNDNP=IPARAM
      GOTO 1300
      END
C
CODE FOR KRDPV
      FUNCTION KRDPV(ICOMMN,IDIMN)
C--THIS ROUTINE READS THE NEXT PARAMETER VALUE, WHICH SHOULD HAVE BEEN
C  FOUND BY 'KFNDNP'.
C
C  ICOMMN  THE COMMON BLOCK FOR THE CURRENT INPUT.
C  IDIMN    THE DIMENSION OF THE COMMON BLOCK.
C
C--RETURN VALUES OF 'KRDPV' ARE :
C
C  -1  ERROR.
C   0  PARAMETER READ OKAY.
C  +1  PARAMETER IS NOT A NUMBER OF SIMPLE CHARACTER STRING  -  MUST
C      READ BY THE CALLING ROUTINE.
C
C--
      DIMENSION ISTORE(131072)
C
C
      DIMENSION ICOMMN(IDIMN)
      DIMENSION AA(1)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
      EQUIVALENCE (AA(1),A),(AA(1),IAA)
C
C--SET THE TYPE OF ARGUMENT WE ARE PROCESSING
      ITYPFL=4
C--CHECK IF THIS ROUTNE CAN PROCESS THE INPUT ARGUMENT VALUE
      KRDPV=1
      IF (ISTORE(MR62D) .EQ. 5) THEN
            GOTO 1000
      ENDIF
      IF(ISTORE(MR62D)-4)1000,1200,1200
C--VALUE CAN BE PROCESSED HERE  -  CHECK THAT THERE IS AN ARGUMENT
1000  CONTINUE
      ND=KNEQUL(NC,IB)
      IF(ND)1050,1050,1250
C--NO ARGUMENT  -  THIS IS AN ERROR
1050  CONTINUE
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)LASTCH
      ENDIF
      WRITE(NCAWU,1100)LASTCH
1100  FORMAT(/41H Missing parameter value at about column ,I4)
C--ERROR RETURN
1150  CONTINUE
      IDIRFL=-1
      LEF=LEF+1
      KRDPV=-1
C--AND NOW RETURN
1200  CONTINUE
      RETURN
C--CHECK THE TYPE OF ARGUMENT TO READ
1250  CONTINUE
      KRDPV=0
      NNC=NC
C----- CHECK NUMBER OR STRING
      IF(ISTORE(MR62D)-3)1300,2100,2100
C--NUMBER TO BE READ  -  INPUT IT
1300  CONTINUE
      IF(KINPUT(A))1350,1400,1350
C--ERROR DURING THE NUMBER
1350  CONTINUE
      CALL XSPCH
      GOTO 1150
C--CHECK IF WE ARE READING AN INTEGER OR FLOATING POINT NUMBER
1400  CONTINUE
      IF(ISTORE(MR62D)-1)1500,1450,1500
C--AN INTEGER
1450  CONTINUE
      IAA=NINT(A)
C--CHECK IF THERE ARE ANY PERMITTED VALUES FOR THIS ARGUMENT
1500  CONTINUE
      IF(ISTORE(MR62D+3))1950,1950,1550
C--CHECK THE ALLOWED VALUES
1550  CONTINUE
      N=ISTORE(MR62D+3)
      M=ISTORE(MR62D+1)+LR62
C--CHECK EACH VALUE IN TURN
      DO 1800 I=1,N
C--CHECK THE TYPE OF ARGUMENT
      IF(ISTORE(MR62D)-1)1600,1600,1700
C--AN INTEGER TO BE COMPARED
1600  CONTINUE
      IF(IAA-ISTORE(M))1750,1650,1750
C--A MATCH  -  SET THE POINTER
1650  CONTINUE
      IAA=I+ISTORE(MR62D+6)-1
      GOTO 1950
C--CHECK FOR FLOATING POINT MATCH
1700  CONTINUE
      IF(ABS(A-STORE(M))-ZERO)1650,1750,1750
C--UPDATE FOR THE NEXT PERMITTED  VALUE
1750  CONTINUE
      M=M+ISTORE(MR62D+2)
1800  CONTINUE
C--NO MATCH  -  THIS IS AN ERROR
1850  CONTINUE
      CALL XMONTR(0)
      J=MR62N+MDR62N-2
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1900)NNC,(ISTORE(I+1),I=MR62N,J)
      ENDIF
      WRITE(NCAWU,1900) NNC,(ISTORE(I+1),I=MR62N,J)
1900  FORMAT(/32H Value provided at about column ,I4,
     2 55H  is not one of those expected  -  parameter keyword : ,20A1)
      GOTO 1150
C--CHECK IF THIS VALUE IS TO BE STORED IN A DATA RECORD
1950  CONTINUE
      IF(ISTORE(MR61+11))2000,2050,2000
C--TO BE STORED IN A DATA RECORD
2000  CONTINUE
      J=IPARAD+IPARAM
      CALL XMOVE(AA(1),STORE(J-1),1)
      GOTO 1200
C--TO BE STORED IN THE COMMON BLOCK  -  CHECK THE ADDRESS
2050  CONTINUE
      J=ISTORE(MR62D+4)
      K=KVALCM(J,ICOMMN,IDIMN)
      CALL XMOVE(AA(1),ICOMMN(J),1)
      GOTO 1200
C--CHARACTER STRING TO BE READ  -  SEARCH FOR THE NEXT BLANK
2100  CONTINUE
      IF (ISTORE(MR62D ) .EQ. 5) THEN
C----- LONG TEXT STRING - GET UP TO 4 CHARACTERS, INCLUDING BLANK
        I = MIN0( NC, LASTCH)
        J = MIN0( NC+4, LASTCH)
        ND = J
        IF ( J .EQ. I) GOTO 1350
C----- PACK THE CHARACTERS
        CALL XFA4CS(IMAGE(NC),AA(1),MIN0(4,ND-NC))
C----- UPDATE POINTERS
        NC = ND
        GOTO 1950
      ENDIF
      I=KEQUAL(NC,IB)
C--CHECK FOR END OF CARD
      IF(I)2150,2150,2200
C--ADJUST FOR END OF CARD
2150  CONTINUE
      I=LASTCH
C--SEARCH FOR THE NEXT COMMA
2200  CONTINUE
      J=KEQUAL(NC,ICOMMA)
C--CHECK FOR END OF CARD
      IF(J)2250,2250,2300
C--ADJUST FOR END OF CARD
2250  CONTINUE
      J=LASTCH
C--COMPUTE THE PARAMETER VALUE LENGTH
2300  CONTINUE
      ND=MIN0(I,J)
      IF(ND)1350,1350,2310
C--CHECK FOR SOME ALLOWED VALUES
2310  CONTINUE
      IF(ISTORE(MR62D+3))2350,2350,2450
C--STRING ITELF IS REQUIRED  -  PACK THE CHARACTERS UP
2350  CONTINUE
      CALL XFA4CS(IMAGE(NC),AA(1),MIN0(4,ND-NC))
C--UPDATE THE POINTER
2400  CONTINUE
      NC=ND+1
      GOTO 1950
C--PERMITTED VALUE TO BE FOUND
2450  CONTINUE
      J=LR62+ISTORE(MR62D+1)
      I=KCNXTS(ISTORE(MR62D+2)-1,ISTORE(J),ISTORE(MR62D+3),
     2 ISTORE(MR62D+2))
C--CHECK FOR SUCCESS
      IF(I)1150,1850,2500
C--SUCCESS  -  COMPUTE THE STORED VALUE
2500  CONTINUE
      IAA=I+ISTORE(MR62D+6)-1
      GOTO 2400
      END
C
CODE FOR KCDRFI
      FUNCTION KCDRFI(ICOMMN,IDIMN,ITYPE)
C--THIS ROUTINE CREATES A DATA RECORD SUITABLE FOR INPUT,
C  AND THEN SETS UP THE DATA RECORD REPEAT COUNT AREA.
C
C  ICOMMN  THE COMMON BLOCK BEING USED.
C  IDIMN    THE DIMENSION OF 'ICOMMN'.
C  ITYPE   SOURCE OF DATA FLAG :
C
C          -1  DATA HAS JUST BEEN INPUT FROM CARDS FOR THIS DIRECTIVE.
C           0  NO DATA HAS BEEN INPUT  -  CHECK NO DEFAULTS ARE MISSING.
C          +1  DATA CONTEXT IS ALREADY KNOWN  -  NO OUTPUT REQUIRED FOR
C
C--RETURN VALUES OF 'KCDRFI' ARE :
C
C  -1  ERRORS FOUND.
C   0  ALL OKAY.
C
C--THIS ROUTINE EXPECTS THE POINTERS SET UP BY 'XDIRFL' TO BE
C  CORRECT.
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM50(32)
C
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (LR50,ICOM50(1))
C
C--SET AN INITIAL RETURN VALUE
      KCDRFI=0
C--CHECK IF THE DIRECTIVE FOUND USES A DATA RECORD
      IF(ISTORE(MR61+11))1000,1100,1000
C--DATA RECORD USED  -  CHECK IF THIS IS THE FIRST TIME FOR THIS RECORD
1000  CONTINUE
      IF(ISTORE(MR61+8))1100,1150,1100
C--ERROR  -  RECORD CANNOT BE SET UP
1050  CONTINUE
      KCDRFI=-1
1100  CONTINUE
      RETURN
C--FIND THE NUMBER OF ELEMENTS PER REPEAT GROUP
1150  CONTINUE
      IF(KINVAL(ISTORE(MR61+9),I,ICOMMN,IDIMN))1200,1400,1400
C--ERROR IN FINDING THIS PARAMETER
1200  CONTINUE
      IF(ITYPE)1250,1350,1350
C--CARD INPUT  -  PRINT THE CARD AND AN ERROR MESSAGE
1250  CONTINUE
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1300)
      ENDIF
1300  FORMAT(/37H Previous error(s) prevent processing,
     2 22H of the last directive)
1350  CONTINUE
      IDIRFL=-1
      LEF=LEF+1
      GOTO 1050
C--FIND THE NUMBER OF GROUPS
1400  CONTINUE
      IF(KINVAL(ISTORE(MR61+10),J,ICOMMN,IDIMN))1200,1450,1450
C--PARAMETERS FOUND  -  SET THE REPEAT COUNT FOR THE DIRECTIVE
1450  CONTINUE
      ISTORE(MR61+7)=J
C--SET THE GROUP PARAMETERS
      ISTORE(MR61+9)=I
      ISTORE(MR61+10)=J
      K=J
C--CHECK IF WE SHOULD CREATE A DATA AREA
      IF(ISTORE(MR61+11))1500,1550,1550
C--NO DATA AREA REQUIRED
1500  CONTINUE
      K=0
C--CREATE THE DATA RECORD AND UPDATE ITS PROPERTIES
1550  CONTINUE
      L=KCEDR(ISTORE(MR61+13),1,ISTORE(MR61+11),I,K,ISTORE(MR61+12))
      CALL XUDRH(ISTORE(MR61+13),ISTORE(MR61+11),I,J)
C--FIND THE COMMON BLOCK OFFSET
      M=ISTORE(MR61+12)
C--CHECK THAT THE OFFSET IS VALID
      N=KVALCM(M,ICOMMN,IDIMN)
C--SET UP THE PARAMETER STORAGE POINTERS
      IPARAM=0
      IPARAD=L
C--SET UP THE COMMON BLOCK
      ICOMMN(M)=L
      ICOMMN(M+1)=L
      ICOMMN(M+2)=I
      ICOMMN(M+3)=J
C--CHECK IF THIS RECORD IS IN CORE
      IF(ISTORE(MR61+11))1600,1650,1650
C--NOT IN CORE
1600  CONTINUE
      ICOMMN(M)=NOWT
      GOTO 1750
C--RECORD IS IN CORE  -  ZERO IT INITIALLY
1650  CONTINUE
      N=I*J
      IF(N)1750,1750,1700
C--SPACE TO ZERO
1700  CONTINUE
      CALL XZEROF(STORE(L),N)
C--CHECK IF THIS DIRECTIVE HAS ONE PARAMETER KEYWORD ONLY
1750  CONTINUE
      IF(ISTORE(MR61+3)-1)2100,1800,2100
C--ONLY ONE PARAMETER KEYWORD  -  SUBSCRIPTION IS POSSIBLE
1800  CONTINUE
      NW=5
C--FIND THE POINTERS TO THE ORIGINAL SET OF PARAMETER KEYWORDS
      L=ISTORE(MR61)+LR62
      M=ISTORE(MR61+1)
      N=ISTORE(MR61+2)
C--INCREMENT THE PARAMETER LENGTHS TO ALLOW FOR THE SUBSCRIPT
      ISTORE(MR61+1)=ISTORE(MR61+1)+NW
      ISTORE(MR61+2)=ISTORE(MR61+2)+NW
C--RESET THE NUMBER OF ALLOWED KEYWORDS
      ISTORE(MR61+3)=ISTORE(MR61+9)
C--CHECK THE NUMBER OF PARAMETERS BEING USED NOW
      ISTORE(MR61)=NOWT
      IF(ISTORE(MR61+3))2100,2100,1850
C--FIND THE LOCATION FOR THE NEW KEYWORD CONTROL BLOCK
1850  CONTINUE
      LR62N=KCHLFL(ISTORE(MR61+2)*ISTORE(MR61+3))
      ISTORE(MR61)=LR62N-LR62
C--RESET ALL THE CONTROL VALUES
      I=(MR61-LR61)/MDR61+1
      CALL XDIRFL(I,ICOMMN,IDIMN)
C--LOOP OVER THE CURRENT NUMBER OF KEYWORDS, GENERATING INDEXED NAMES
      DO 2050 I=1,NR62D
C--MOVE THE CURRENT NAME ACROSS
      CALL XMOVE(STORE(L),STORE(MR62N),M)
C--BLANK OUT THE REST OF THE NAME
      J=MR62N+M
      CALL XMVSPD(IB,ISTORE(J),NW)
C--FIND THE END OF THE CURRENT NAME
      K=MR62N+ISTORE(MR62N)
C--INSERT A '('
      ISTORE(K+1)=ILB
C--ZERO THE INCLUDE ZEROES FLAG
      NUM2=0
C--ASSIGN THE CURRENT INDEX
      NUM=I
C--COMPUTE THE DIVISOR
      NUMDVD=10**(NW-3)
C--INSERT A MAXIMUM OF 'NW-2' INDEX CHARACTERS
      DO 2000 J=3,NW
      NUM1=NUM/NUMDVD
      NUM=NUM-NUM1*NUMDVD
      NUM1=MOD(NUM1,10)
      NUMDVD=NUMDVD/10
C--CHECK IF ALL NUMBERS MUST BE INCLUDED
      IF(NUM2)1900,1900,1950
C--NO NUMBERS IN YET  -  CHECK FOR LEADING ZEROES
1900  CONTINUE
      IF(NUM1)2000,2000,1950
C--INCLUDE THIS NUMBER
1950  CONTINUE
      NUM2=1
      ISTORE(K+2)=NUMB(NUM1+1)
C--UPDATE THE ADDRESS AND COUNTS
      K=K+1
      ISTORE(MR62N)=ISTORE(MR62N)+1
2000  CONTINUE
C--INSERT A ')'
      ISTORE(K+2)=IRB
      ISTORE(MR62N)=ISTORE(MR62N)+2
C--FIND THE ADDRESS OF THE REST OF THE DATA
      K=L+M
C--MOVE IT ACROSS
      CALL XMOVE(STORE(K),STORE(MR62D),MDR62D-MDR62N)
C--UPDATE FOR THE NEXT
      MR62N=MR62N+MDR62D
      MR62D=MR62D+MDR62D
2050  CONTINUE
C--AND NOW EXIT
2100  CONTINUE
      ISTORE(MR61+3)=MIN0(ISTORE(MR61+3),ISTORE(MR61+9))
      NR62D=ISTORE(MR61+3)
      GOTO 1100
      END
C
CODE FOR KINVAL
      FUNCTION KINVAL(IADD,IANS,ICOMMN,IDIMN)
C--FETCH THE VALUE STORED IN A COMMON BLOCK OR DATA AREA.
C
C  IADD    THE INITIAL POINTER :
C
C          <0  THE ABSOLUTE VALUE OF 'IADD' POINTS TO AN ADDRESS IN
C              'ICOMMN' WHICH CONTAINS THE NEXT ADDRESS OR THE REQUIRED
C              VALUE.
C          >0  (OR EQUAL TO 0) THIS IS THE VALUE REQUIRED.
C
C  IANS    THE REQUURED ANSWER IS RETURNED HERE.
C  ICOMMN  THE COMMON BLOCK.
C  IDIMN    THE DIMENSION OF 'ICOMMN'.
C
C--THE RETURN VALUES OF 'KINVAL' ARE :
C
C  -1  AN ERROR HAS OCCURRED  -  NO VALUE GIVEN.
C   0  ALL OKAY.
C
C--
      DIMENSION ISTORE(131072)
C
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--INITIAL ASSIGNMENT
      IANS=IADD
      KINVAL=0
C--CHECK IF WE HAVE A VALUE YET
1000  CONTINUE
      IF(IANS)1050,1020,1020
1020  CONTINUE
      RETURN
C--FIND THE NEXT POINT ALONG THE CHAIN
1050  CONTINUE
      JANS=IABS(IANS)
      KANS=KVALCM(JANS,ICOMMN,IDIMN)
C--SEARCH FOR THIS ADDRESS AMONGST THE POSSIBLE INPUT VALUES
      JB=LR61
C--CHECK IF THIS INSTRUCTION HAS ANY DIRECTIVES
      IF(NR61)1650,1650,1100
C--LOOP OVER EACH DIRECTIVE
1100  CONTINUE
      DO 1600 JA=1,NR61
C--CHECK IF THIS DIRECTIVE CONTAINS SIMPLE PARAMETERS
      IF(ISTORE(JB+11))1550,1150,1550
C--CHECK IF THERE ARE ANY PARAMETERS FOR THIS DIRECTIVE
1150  CONTINUE
      IF(ISTORE(JB+3))1550,1550,1200
C--THERE ARE SOME PARAMETERS  -  SCAN ALONG THEM
1200  CONTINUE
      JE=ISTORE(JB)+LR62
      JF=ISTORE(JB+1)+JE
      JD=ISTORE(JB+3)
C--LOOP OVER THE PARAMETERS
      DO 1500 JC=1,JD
C--CHECK IF THE STORAGE POINT HERE EQUALS THE INPUT ADDRESS
      IF(ISTORE(JF+4)-JANS)1450,1250,1450
C--THIS IS THE PARAMETER  -  CHECK IF IT HAS BEEN INPUT
1250  CONTINUE
      IF(KCHKPV(JA,ICOMMN,IDIMN,0))1300,1400,1400
C--NO PROCESSING IS POSSIBLE
1300  CONTINUE
      KINVAL=-1
      RETURN
C--PARAMETER SET OKAY  -  STOP ANY FURTHER INPUT OF THIS DIRECTIVE
1400  CONTINUE
      ISTORE(JB+8)=1000001
C--FIND THE VALUE THAT IS NOW PRESENT IN THE COMMON BLOCK
      KANS=KVALCM(JANS,ICOMMN,IDIMN)
      GOTO 1650
C--UPDATE FOR THE NEXT PARAMETER
1450  CONTINUE
      JE=JE+ISTORE(JB+2)
      JF=JF+ISTORE(JB+2)
1500  CONTINUE
C--UPDATE FOR THE NEXT DIRECTIVE
1550  CONTINUE
      JB=JB+MDR61
1600  CONTINUE
C--ASSIGN THE NEXT VALUE IN THE CHAIN
1650  CONTINUE
      IANS=KANS
      GOTO 1000
      END
C
CODE FOR KCHKPV
      FUNCTION KCHKPV(IDIR,ICOMMN,IDIMN,ITYPE)
C--THIS ROUTINE CHECKS THAT THE DIRECTIVE INDICATED BY THE
C  VALUE OF 'IDIR' HAS BEEN PROPERLY INPUT.
C
C  IDIR    THE DIRECTIVE NUMBER.
C  ICOMMN  THE COMMON BLOCK BEING FILLED BY THIS PROCESS.
C  IDIMN    THE DIMENSION OF THE COMMON BLOCK.
C  ITYPE   SOURCE OF DATA FLAG :
C
C          -1  DATA HAS JUST BEEN INPUT FROM CARDS FOR THIS DIRECTIVE.
C           0  NO DATA HAS BEEN INPUT  -  CHECK NO DEFAULTS ARE MISSING.
C          +1  DATA CONTEXT IS ALREADY KNOWN  -  NO OUTPUT REQUIRED FOR
C
C--RETURN VALUES OF 'KCHKPV' ARE :
C
C  -1  AN ERROR HAS BEEN FOUND.
C   0  ALL OKAY.
C
C--
      DIMENSION ISTORE(131072)
C
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      JTYPE=ITYPE
C--RECORD THE NUMBER OF ERRORS SO FAR
      MYLEF=LEF
C--CHECK IF A DIRECTIVE IS BEING PROCESSED
      IF(IDIR)2050,2050,1000
C--SET UP THE POINTERS FOR THIS DIRECTIVE
1000  CONTINUE
      CALL XDIRFL(IDIR,ICOMMN,IDIMN)
C--CHECK IF THIS DIRECTIVE HAS ALREADY GENERATED ERRORS
      KCHKPV=-1
      IF(ISTORE(MR61+8))2050,1050,1050
C--DIRECTIVE BEING PROCESSED  -  CHECK IF IT HAS ANY PARAMETERS
1050  CONTINUE
      KCHKPV=0
C--CHECK IF THIS DIRECTIVE HAS ALREADY BEEN DEFAULTED
      IF(ISTORE(MR61+8)-1000000)1100,1100,2050
C--NOW CHECK THE NUMBER OF PARAMETERS
1100  CONTINUE
      IF(NR62D)2050,2050,1150
C--PARAMETERS REQUIRED  -  CHECK FOR A DATA RECORD
1150  CONTINUE
      IF(ISTORE(MR61+11))2050,1250,1200
C--CHECK FOR A NON-ZERO REPEAT COUNT  -  I.E. SOMEWHERE TO PUT THE DATA
1200  CONTINUE
      IF(ISTORE(MR61+10))2050,2050,1250
C--LOOP OVER EACH PARAMETER FOR THIS DIRECTIVE
1250  CONTINUE
      DO 2000 I=1,NR62D
C--CHECK IF THIS PARAMETER HAS BEEN INPUT
      IF(ISTORE(MR62D+10))1300,1300,1950
C--PARAMETER NOT INPUT  -  CHECK FOR A DEFAULT VALUE
1300  CONTINUE
      IF(ISTORE(MR62D+7))1350,1800,1800
C--NO DEFAULT VALUE  -  CHECK IF THIS PARAMETER SHOULD BE INPUT
1350  CONTINUE
      IF(ISTORE(MR62D+9))1950,1950,1400
C--NO DEFAULT VALUE  -  CHECK FOR AN EXCLUDED DIRECTIVE
1400  CONTINUE
      IF(ISTORE(MR61+6))1950,1450,1450
C--ERROR  -  CHECK ON THE TYPE OF STATEMENT PRINT REQUIRED
1450  CONTINUE
      IF(JTYPE)1600,1500,1650
C--NOT A READ  -  SIMPLY A CHECK
1500  CONTINUE
      L=MR60+MDR60-2
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1550)(ISTORE(J+1),J=MR60,L)
      ENDIF
      WRITE(NCAWU,1550) (ISTORE(J+1),J=MR60,L)
1550  FORMAT(//29H A directive has been omitted,
     2 41H leaving the parameter(s) below undefined,
     3 17H  -  directive : ,20A1)
C--MARK THIS DIRECTIVE AS TOO LATE
      ISTORE(MR61+8)=-1
      GOTO 1650
C--INPUT FROM CARDS  -  PRINT THE LAST CARD IF NECESSARY
1600  CONTINUE
      CALL XMONTR(0)
C--JUMP ON THE TYPE OF ERROR GENERATED
1650  CONTINUE
      JTYPE=1
      K=MR62N+MDR62N-2
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1700)I,(ISTORE(J+1),J=MR62N,K)
      ENDIF
      WRITE(NCAWU,1700) I,(ISTORE(J+1),J=MR62N,K)
1700  FORMAT(/11H Parameter ,I3,
     2 43H  has no default value and has been omitted,
     3 25H  -  parameter keyword : ,20A1)
C--UPDATE THE ERROR COUNTER
      LEF=LEF+1
      KCHKPV=-1
      GOTO 1950
C--CHECK IF THIS IS A DATA AREA OR A COMMON BLOCK
1800  CONTINUE
      IF(ISTORE(MR61+11))1850,1900,1850
C--THIS IS A DATA AREA  -  INSERT THE DEFAULT VALUE
1850  CONTINUE
      CALL XMOVE(STORE(MR62D+8),STORE(IPARAD),1)
      GOTO 1950
C--ASSIGN THE DEFAULT VALUE
1900  CONTINUE
      J=ISTORE(MR62D+4)
C--CHECK THAT THE COMMON BLOCK ADDRESS IS VALID
      K=KVALCM(J,ICOMMN,IDIMN)
C--MOVE THE DEFAULT VALUE OVER
      CALL XMOVE(STORE(MR62D+8),ICOMMN(J),1)
C--UPDATE FOR THE NEXT PARAMETER
1950  CONTINUE
      MR62N=MR62N+MDR62D
      MR62D=MR62D+MDR62D
      IPARAD=IPARAD+1
2000  CONTINUE
C--AND NOW RETURN
2050  CONTINUE
      CALL XDIRFL(IDIRFL,ICOMMN,IDIMN)
C--CHECK IF WE GENERATED ANY ERRORS
      IF(LEF-MYLEF)2100,2200,2100
C--ERRORS  -  PRINT A BLANK LINE
2100  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2150)
      ENDIF
2150  FORMAT(1H )
C--AND NOW RETURN
2200  CONTINUE
      RETURN
      END
C
CODE FOR XDIRFL
      SUBROUTINE XDIRFL(NUM,ICOMMN,IDIMN)
C--SET UP THE POINTERS TO THE TYPE 60 RECORDS FOR A DIRECTIVE.
C
C  NUM     THE NUMBER OF THE DIRECTIVE.
C  ICOMMN  THE COMMON BLOCK BEING USED FOR THIS INPUT.
C  IDIMN    THE DIMENSION OF THE COMMON BLOCK.
C
C--
      DIMENSION ISTORE(131072)
C
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF A DIRECTIVE IS INDICATED
      IF(NUM)1100,1100,1000
1000  CONTINUE
C--POINTERS TO THE DIRECTIVE NAME
      MR60=LR60+(NUM-1)*MDR60
C--POINTER TO THE DIRECTIVE DETAILS
      MR61=LR61+(NUM-1)*MDR61
C--POINTERS TO THE PARAMETER NAMES AND DETAILS
      LR62N=ISTORE(MR61)+LR62
      MR62N=LR62N
      LR62D=LR62N+ISTORE(MR61+1)
      MR62D=LR62D
C--INCREMENTS OVER THE PARAMETERS
      MDR62N=ISTORE(MR61+1)
      MDR62D=ISTORE(MR61+2)
C--NUMBER OF PARAMETERS
      NR62N=ISTORE(MR61+3)
      NR62D=NR62N
C--SET UP THE POINTERS TO THE DATA AREA IF NECESSARY
      IPARAM=0
      IPARAD=NOWT
C--CHECK IF THIS INPUT IS FOR A DATA AREA
      IF(ISTORE(MR61+11))1050,1100,1050
C--DATA AREA  -  SET THE POINTERS
1050  CONTINUE
      IPARAD=KVALCM(ISTORE(MR61+12),ICOMMN,IDIMN)+MAX0(0,ISTORE(MR61+8)
     2 -1)*ISTORE(MR61+9)
C--AND NOW RETURN
1100  CONTINUE
      RETURN
      END
C
CODE FOR KVALCM
      FUNCTION KVALCM(IADD,ICOMMN,IDIMN)
C--THIS ROUTINE FETCHES THE VALUE FROM 'ICOMMN(IADD)', AFTER CHECKING TH
C  'IADD' IS A VALID ADDRESS.
C
C  IADD    THE ADDRESS IN THE COMMON BLOCK.
C  ICOMMN  THE COMMON BLOCK.
C  IDIMN    THE DIMENSION OF 'ICOMMN'.
C
C--THE RETURN VALUE OF 'KVALCM' IS THE CONTENTS OF THE REQUIRED LOCATION
C
C--
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C--CHECK IF THE LOCATION GIVEN IS VALID
      IF(KVALID(1,IADD,IDIMN))1000,1100,1100
C--INVALID LOCATION
1000  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)IADD,LN,IREC
      ENDIF
      WRITE(NCAWU,1050)IADD,LN,IREC
1050  FORMAT(30H Invalid common block address ,I8,5X,10HList type ,I5,
     2 5X,12HRecord type ,I8)
      CALL XERHND ( IERPRG )
C--FETCH THE CONTENTS
1100  CONTINUE
      KVALCM=ICOMMN(IADD)
      RETURN
      END
C
CODE FOR XFAL50
      SUBROUTINE XFAL50
C--LOAD THE CONTROL RECORDS FOR LIST 50  -  THE INPUT AND LIST FORMAT LI
C
C--
C
      DIMENSION IRECS(3)
      DIMENSION ICOM50(32)
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ISTORE(131072)
C
      COMMON/XDISCS/NCDFU,NCIFU,NCLDU , NCNDU
      COMMON/XDISC/NU
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (LR50,ICOM50(1))
C
C
      DATA IRECS(1)/52/,IRECS(2)/-51/,IRECS(3)/50/
C
C--SWITCH TO THE INSTRUCTION DEFINITION DISC
      KA = KSWPDU ( NCIFU )
C--ZERO THE COMMON BLOCK
      CALL XZEROF(ICOM50(1),IDIM50)
C--SET UP THE LIST TYPE
      LN=50
C--LOAD THE CONTROL RECORDS ONE BY ONE
      DO 1150 I=1,3
      IF(KFNDRI(LN,IRECS(I),IADDR,IBUFF))1000,1100,1100
C--NO SUCH RECORD
1000  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)IRECS(I)
      ENDIF
      WRITE(NCAWU,1050) IRECS(I)
1050  FORMAT(24H Missing control record ,I8)
      CALL XERHND ( IERPRG )
C--LOAD THE RECORD
1100  CONTINUE
      CALL XLDREC(LN,1,IBUFF,ICOM50,IDIM50,0)
1150  CONTINUE
C--SWITCH DISCS AGAIN
      N = KSWPDU ( KA )
      RETURN
      END
C
CODE FOR XLL50R
      SUBROUTINE XLL50R(NUMB)
C--LOAD RECORDS FROM LIST 50 FOR INSTRUCTION NUMBER 'NUMB'.
C
C  NUMB  THE NUMBER OF THE INSTRUCTION WHOSE DETAILS ARE TO BE LOADED
C
C--
      DIMENSION ICOM50(32)
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ISTORE(131072)
C
      COMMON/XDISCS/NCDFU,NCIFU,NCLDU , NCNDU
      COMMON/XDISC/NU
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (LR50,ICOM50(1))
C
C--SWITCH TO THE INSTRUCTION DEFINITION DISC
      KA = KSWPDU ( NCIFU )
C--BLANK OUT THE COMMON BLOCK
      DO 1000 I=LCOM,MCOM,MDCOM
      ICOM50(I)=NOWT
      ICOM50(I+2)=0
      ICOM50(I+3)=0
1000  CONTINUE
C--MOVE THE COMMON BLOCK DETAILS INTO THE COMMON BLOCK
      LN=50
      IREC=51
C--ALLOCATE SPACE FOR THE LOAD DETAILS
      MR51=KCHLFL(MDR51)
C--FIND THE DISC ADDRESS
      J=LR51+KINCRF((NUMB-1)*MDR51)
C--LOAD THIS SET OF LOAD DETAILS
      CALL XDOWNF(J,STORE(MR51),MDR51)
      J=MR51+MDR51-2
C--LOOP OVER EACH AVAILABLE RECORD TYPE
      DO 1100 K=MR51,J,2
C--CHECK IF THE RECORD EXISTS
      IF(ISTORE(K+1))1100,1100,1050
C--FIND THE DETAILS OF THIS RECORD
1050  CONTINUE
      L=ISTORE(K)
      M=ISTORE(K+1)
      N=KLDDRH(L,M,IBUFF)
C--MAKE THIS RECORD A RECORD THAT CAN BE LOADED
      IBUFF(7)=IABS(IBUFF(7))
      CALL XLDREC(LN,1,IBUFF,ICOM50,IDIM50,0)
1100  CONTINUE
C--SET UP A THE REST OF THE POINTERS
      DO 1150 I=LCOM,MCOM,MDCOM
      ICOM50(I+1)=ICOM50(I)
1150  CONTINUE
C--SWITCH BACK TO THE ORIGINAL DISC
      N = KSWPDU ( KA )
      RETURN
      END
CRYSTALS CODE FOR DISC
CODE FOR XUPF
      SUBROUTINE XUPF(I,A,J)
C--TRANSFER FLOATING POINT NUMBERS FROM STORE TO THE DISC
C
C  I  ADDRESS OF THE FIRST WORD ON THE DISC (24 BIT WORD)
C  A  ARRAY HOLDING THE DATA
C  J  NUMBER OF WORDS TO TRANSFER
C
C--
C
      DIMENSION A(J)
C
C
      DATA K/0/,L/0/
C
      K=I
      L=KINCRF(J)
      CALL XUP(K,A,L)
      RETURN
      END
C
CODE FOR XDOWNF
      SUBROUTINE XDOWNF(I,A,J)
C--TRANSFER FLOATING POINT NUMBERS FROM THE DISC TO STORE
C
C  I  ADDRESS OF THE FIRST WORD ON THE DISC (24 BIT WORDS)
C  A  ARRAY TO HOLD THE DATA
C  J  NUMBER OF WORDS TO TRANSFER
C
C--
C
      DIMENSION A(J)
C
C
      DATA K/0/,L/0/
C
      K=I
      L=KINCRF(J)
      CALL XDOWN(K,A,L)
      RETURN
      END
C
CODE FOR XDOWN
      SUBROUTINE XDOWN(NFW,IADD,NW)
C--TRANSFER FROM DISC TO STORE
C
C  NFW   ADDRESS OF FIRST WORD TO BE USED ON DISC
C  IADD  ADDRESS OF FIRST WORD IN CORE
C  NW    NUMBER OF WORDS TO TRANSFER
C
C--DISC ROUTINES VERSION 4, USING ONLY 'XDATA' OR SIMILAR ARRAYS AS STOR
C  THE BUFFERS.
C
C--RECORD 0 CONTAINS WORDS  0   - (NWR-1)
C  RECORD 1 CONTAINS WORDS  NWR - (2*NWR-1)
C  AND SUBSEQUENT RECORDS ARE THE SAME
C
C--
C
      DIMENSION IADD(NW)
C
      COMMON/XBUFFD/LINK(3200)
      COMMON/XDISCB/IACC,MLSS,IADD1,NFWD,NWD,NV,NWB,NWR,I,J,K,L,M,N,NNN
C
C
C--TRANSFER THE ARGUMENTS TO THE COMMON BLOCK
      NFWD=NFW
      NWD=NW
      NV=1
C--CHECK IF THERE ARE ANY MORE WORDS TO TRANSFER
1000  CONTINUE
      IF(NWD)1050,1050,1100
1050  CONTINUE
      RETURN
C--CALCULATE THE RECORD NUMBER ETC. FOR THIS TRANSFER
1100  CONTINUE
      CALL XFINDB
C--READ SOME NUMBERS
      CALL XMOVE(LINK(J),IADD(NV),K)
      NV=NV+K
      GOTO 1000
      END
C
CODE FOR XUP
      SUBROUTINE XUP(NFW,IADD,NW)
C--TRANSFER FROM STORE TO DISC
C
C  NFW   ADDRESS OF FIRST WORD TO BE USED ON DISC
C  IADD  ADDRESS OF FIRST WORD IN CORE
C  NW    NUMBER OF WORDS TO TRANSFER
C
C--DISC ROUTINES VERSION 4, USING ONLY 'XDATA' OR SIMILAR ARRAYS AS STOR
C  THE BUFFERS.
C
C--RECORD 0 CONTAINS WORDS  0   - (NWR-1)
C  RECORD 1 CONTAINS WORDS  NWR - (2*NWR-1)
C  AND SUBSEQUENT RECORDS ARE THE SAME
C
C--
C
      DIMENSION IADD(NW)
C
      COMMON/XBUFFD/LINK(3200)
      COMMON/XDISCB/IACC,MLSS,IADD1,NFWD,NWD,NV,NWB,NWR,I,J,K,L,M,N,NNN
C
C
C--TRANSFER THE ARGUMENTS TO THE COMMON BLOCK
      NFWD=NFW
      NWD=NW
      NV=1
C--CHECK IF THERE ARE ANY MORE WORDS TO TRANSFER
1000  CONTINUE
      IF(NWD)1050,1050,1100
1050  CONTINUE
      RETURN
C--CALCULATE THE RECORD NUMBER ETC. FOR THIS TRANSFER
1100  CONTINUE
      CALL XFINDB
C--WRITE SOME NUMBERS
      LINK(I+3)=-1
      CALL XMOVE(IADD(NV),LINK(J),K)
      NV=NV+K
      GOTO 1000
      END
C
CODE FOR XGIVE
      SUBROUTINE XGIVE
C--SET UP THE USER DEFINED BUFFERS
C
C
C
C -- THIS ROUTINE SETS UP THE BUFFERS REQUIRED BY THE DISC ROUTINES.
C    EACH BUFFER IS THE SIZE OF A RECORD IN THE DIRECT ACCESS FILE AND
C    IS DESCRIBED BY A HEADER. THE HEADERS FORM A LINKED LIST. FOR
C    PERFORMANCE REASONS UNDER VMS THE HEADERS HAVE BEEN PLACED AT
C    THE BEGINNING OF THE ARRAY AND THE BUFFERS HAVE BEEN PAGE-ALIGNED
C
C -- THE FORMAT OF THE HEADERS IS :-
C
C      WORD       CONTENTS
C      0          UNIT NUMBER FOR THIS RECORD
C      1          LINK FORWARD ( -10000000 AT END )
C      2          RECORD NUMBER
C      3          READ/WRITE INDICATOR
C                        0      READ ONLY
C                        1      WRITE PENDING
C      4          ADDRESS OF CORRESPONDING BUFFER
C
C      THE SPACE AVAILABLE FOR DISC BUFFERING AND THE NUMBER OF
C      BUFFERS REQUIRED CAN BE SPECIFIED USING THE VARIABLES
C      'ISSBFS' AND 'ISSNBF' IN COMMON BLOCK /XSSVAL/
C
C--
      COMMON/XBUFFD/LINK(3200)
      COMMON/XDISCB/IACC,MLSS,IADD1,NFWD,NWD,NV,NWB,NWR,I,J,K,L,M,N,NNN
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      DATA IHDRLN / 5 /
C
C
C--SET THE NUMBER OF WORDS PER BLOCK EQUAL TO THE NUMBER PER RECORD
C
      CALL XDACVI ( NWR , NWDBLI , NBYWDI )
      NWB = NWR
C
C -- ASSIGN NEXT FREE ADDRESS IN ARRAY AND ADDRESS OF FIRST LINK
      IFREE = 1
      ILINK1 = 1
C -- CALCULATE THE SPACE REQUIRED FOR THE HEADERS IN WORDS AND PAGES
      IHDRSP = ( ISSNBF + 1 ) * IHDRLN
      IHDRPG = ( IHDRSP + ISSPAG - 1 ) / ISSPAG
      IFREE = IFREE + ( IHDRPG * ISSPAG )
C -- CALCULATE SPACE REQUIRED FOR BUFFERS IN WORDS
      IBUFPG = ( NWB + ISSPAG - 1 ) / ISSPAG
      IBUFSZ = IBUFPG * ISSPAG
      IBUFSP = ( ISSNBF ) * IBUFSZ
C
      IF ( ( IFREE+IBUFSP-1 ) .GT. ISSBFS ) GO TO 9910
C -- BEGIN CREATING HEADERS
      I = ILINK1 + IHDRLN
      J = ILINK1
      LINK(J) = NOWT
C
      DO 1100 ICOUNT = 1, ISSNBF
C
      LINK(J+1) = I
C
      LINK(I) = NOWT
      LINK(I+2) = NOWT
      LINK(I+3) = 0
      LINK(I+4) = IFREE
      IFREE = IFREE + IBUFSZ
      J = I
      I = I + IHDRLN
1100  CONTINUE
C
      LINK(J+1) = NOWT
      IACC = 1
      LLU = IFREE
C
      IADD1 = ILINK1
C
      RETURN
C
9910  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 )
      ENDIF
      WRITE ( NCAWU , 9915 )
9915  FORMAT ( 1X , 'Insufficient space allocated for disc buffers' )
      CALL XERHND ( IERPRG )
      RETURN
C
C
      END
C
CODE FOR XFINDB
      SUBROUTINE XFINDB
C--FIND THE REQUIRED DISC BUFFER
C
C--ARGUMENTS ARE IN THE COMMON BLOCK 'XDISC' :
C
C  IADD1  FIRST BUFFER WORD IN 'LINK'
C  NFWD   CURRENT DISC ADDRESS
C  NWD    NUMBER OF WORDS LEFT TO TRANSFER
C  NV     CURRENT POSITION IN THE INPUT OR OUTPUT ARRAY
C
C--THE ABOVE VARIABLES ARE SET ON ENTRY, AND RESET AS NECESSARY ON EXIT.
C
C--THE FOLLOWING VARIABLES ARE ALSO SET ON EXIT :
C
C  I  ADDRESS OF THE CURRENT BUFFER
C  J  ADDRESS OF THE FIRST WORD IN THE BUFFER FOR DATA
C  K  NUMBER OF WORDS TO BE TRANSFERED.
C
C--THE FOLLOWING VARIABLES MUST NOT BE CHANGED :
C
C  L
C  M
C  N
C--
      COMMON/XBUFFD/LINK(3200)
      COMMON/XDISC/NU
      COMMON/XDISCB/IACC,MLSS,IADD1,NFWD,NWD,NV,NWB,NWR,I,J,K,L,M,N,NNN
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XSTATS/ IPREAD , IPWRIT , ICACHE , NCACHE(6),
     2 OLDCPU,OLDELP,FSTCPU,JMODE,NCALL,JHASH(8)
C
C
C--CHECK IF THE BUFFERS HAVE BEEN ALLOCATED
      IF ( IACC .LT. 0 ) GO TO 9910
C--CALCULATE THE RECORD NUMBER ETC. OF TRANSFERS TO BE MADE
      NR=NFWD/NWB
      N=NFWD-NR*NWB
C--SEARCH THROUGH THE BUFFER LIST FOR FREE BUFFERS AND/OR THE BUFFER
C  CONTAINING THIS RECORD
      I=LINK(IADD1+1)
      J=IADD1
      NBUFFR = 0
C--CHECK IF THIS BUFFER IS FOR THE CORRECT UNIT
1150  CONTINUE
      NBUFFR = NBUFFR + 1
      IF(LINK(I)-NU)1250,1200,1250
C--CHECK IF THIS IS THE CORRECT BUFFER
1200  CONTINUE
      IF ( LINK(I+2) .NE. NR ) GO TO 1250
      ICACHE = ICACHE + 1
      NCACHE(NBUFFR) = NCACHE(NBUFFR) + 1
      GO TO 1550
C
C--CHECK FOR A FREE BUFFER WHICH ALSO INDICATES THE END OF THE STACK
1250  CONTINUE
      IF(LINK(I+2))1500,1300,1300
C--CHECK IF THIS IS THE LAST BUFFER
1300  CONTINUE
      IF(LINK(I+1))1400,1400,1350
C--PICK UP THE NEXT BUFFER
1350  CONTINUE
      J=I
      I=LINK(I+1)
      GOTO 1150
C--REWRITE THE CONTENTS OF THE LAST BUFFER TO THE DISC IF NEC.
1400  CONTINUE
      IF(LINK(I+3))1450,1500,1500
1450  CONTINUE
      M=LINK(I+2)
      IPWRIT = IPWRIT + 1
      IBUFFR = LINK(I+4)
C -- TRANSFER DATA AND CHECK FOR ERRORS
      ISTAT = KSTORE ( LINK(I) , M , LINK(IBUFFR) , ISSRLI )
      IF ( ISTAT .LT. 0 ) GO TO 9920
      LINK(I+3)=0
C--FETCH THE RECORD OF INTEREST
1500  CONTINUE
      LINK(I)=NU
      LINK(I+2)=NR
      IPREAD = IPREAD + 1
      IBUFFR = LINK(I+4)
C -- TRANSFER DATA AND CHECK FOR ERRORS
      ISTAT = KFETCH ( LINK(I) , NR , LINK(IBUFFR) , ISSRLI )
      IF ( ISTAT .LT. 0 ) GO TO 9920
C--SWITCH THIS BUFFER TO THE TOP OF THE BUFFER STACK
C  ALL OTHER BUFFERS ARE FORCED ONE DOWN THE STACK , SO THAT THE
C  LEAST USED ONE ENDS UP AT THE END
1550  CONTINUE
      LINK(J+1)=LINK(I+1)
      LINK(I+1)=LINK(IADD1+1)
      LINK(IADD1+1)=I
C--CALCULATE THE NUMBER OF WORDS THAT CAN BE TRANFERED FROM THIS BUFFER
      J = LINK(I+4) + N
C
      K=MIN0(NWD,NWB-N)
      NWD=NWD-K
      NFWD=NFWD+K
      RETURN
C
9910  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 )
      ENDIF
      WRITE ( NCAWU , 9915 )
9915  FORMAT ( 1X , 'No buffers allocated to disc routines' )
      CALL XERHND ( IERPRG )
      RETURN
9920  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 )
      ENDIF
      WRITE ( NCAWU , 9925 )
9925  FORMAT ( 1X , 'Disc transfer ended in error' )
      CALL XERHND ( IERSEV )
      RETURN
C
      END
C
CODE FOR XDUMP
      SUBROUTINE XDUMP
C
C -- THIS ROUTINE PROVIDES A LINK TO THE NEW ROUTINE 'KDUMP'
C
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      DATA IN / 0 /
C
      ISTAT = KDUMP ( IN )
      IF ( ISTAT .LT. 0 ) CALL XERHND ( IERSEV )
C
      RETURN
C
      END
C
C
C
CODE FOR KDUMP
      FUNCTION KDUMP ( IN )
C
C--REWRITE ALL BUFFERS MARKED FOR WRITING TO THE DISC
C
C      IN      DUMMY VALUE ( IGNORED )
C
C -- RETURN VALUES :-
C
C      -VE      ERROR REWRITING DISC BUFFERS
C      +VE      SUCCESS
C
      COMMON/XBUFFD/LINK(3200)
      COMMON/XDISCB/IACC,MLSS,IADD1,NFWD,NWD,NV,NWB,NWR,I,J,K,L,M,N,NNN
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XSTATS/ IPREAD , IPWRIT , ICACHE , NCACHE(6),
     2 OLDCPU,OLDELP,FSTCPU,JMODE,NCALL,JHASH(8)
C
C
C -- SET ERROR FLAG CLEAR
      IERROR = 1
C
C--CHECK IF ANY BUFFERS ARE ALLOCATED
      IF(IACC)1250,1000,1000
C--LINK INTO THE FIRST BUFFER
1000  CONTINUE
      I=LINK(IADD1+1)
      J=-1
C--CHECK IF THE BUFFER REQUIRED WRITING
1050  CONTINUE
      IF(LINK(I+3))1100,1150,1150
C--WRITE THE BUFFER OUT
1100  CONTINUE
      J=LINK(I+2)
      IBUFFR = LINK(I+4)
C
      IPWRIT = IPWRIT + 1
      ISTAT = KSTORE ( LINK(I) , J , LINK(IBUFFR)  , ISSRLI )
      IF ( ISTAT .LT. 0 ) IERROR = ISTAT
      LINK(I+3)=0
C--CHECK IF THIS IS THE LAST BUFFER
1150  CONTINUE
      IF(LINK(I+1))1250,1250,1200
1200  CONTINUE
      I=LINK(I+1)
      GOTO 1050
1250  CONTINUE
C -- SET RETURN VALUE
      KDUMP = IERROR
      RETURN
      END
C
CODE FOR KNWR
      FUNCTION KNWR(IN)
C--NUMBER OF WORDS PER RECORD
C
C
C--
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      KNWR = ISSRLI
C
      RETURN
      END
C
CODE FOR KNWRF
      FUNCTION KNWRF(IN)
C--NUMBER OF FLOATING POINT NUMBERS PER RECORD
C
C
C--
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      KNWRF = ISSRLF
C
      RETURN
      END
C
CODE FOR XFETCH
      SUBROUTINE XFETCH(NU,I,J,K)
C
C -- **** DUMMY ROUTINE ****
C
      STOP 'XFETCH'
C
      END
C
C
C
CODE FOR KFETCH
      FUNCTION KFETCH ( NU , I , J , NWORD )
C
C -- THIS ROUTINE TRANSFERS DATA FROM A DIRECT ACCESS FILE
C--FETCH DATA FROM THE DISC  -  THIS LINK CONTROLS THE DISC
C
C  NU UNIT TO BE USED FOR THE TRANSFER
C  I  DISC ADDRESS OF THE INFORMATION IN USER RECORDS
C  J  INTEGER ARRAY INTO WHICH THE DATA GOES
C   NWORD  NUMBER OF WORDS TO TRANSFER
C
C
C
C -- RETURN VALUES :-
C
C      -VE ERROR DURING TRANSFER . MESSAGE PRINTED
C      +VE SUCCESS
C
C
C**THIS LINK IS MACHINE SPECIFIC AS IT RELATES THE
C  THE LENGTH OF RECORDS SEEN BY THE USER TO THE LENGTH
C  OF HARDWARE BLOCKS ON THE DISC
C
C--
C
C -- VARIABLES USED TO CONTROL AUTOMATIC DISC EXTENSION :-
C
C      STORED IN COMMON BLOCK /XDAVAL/ . INITIAL VALUES SET IN 'CRYBLK'
C      ALL DISC SIZES ARE IN RECORDS.
C
C      IDAINI      INITIAL DISC SIZE
C      IDATOT      CURRENT TOTAL DISC SIZE ( -1 IF NOT KNOWN )
C      IDAMAX      MAXIMUM DISC SIZE ( 0 - NO MAXIMUM )
C      IDAMIN      MINIMUM DISC SIZE
C
C      IDAAUT      AUTOMATIC EXTENSION CONTROL
C                        0      NO AUTOMATIC EXTENSION
C                        1      AUTOMATIC EXTENSION ENABLED
C      IDAQUA      EXTENSION QUANTITY ( IF 0 , EXTEND TO REQUIRED SIZE)
C      IDATRY      NUMBER OF TRIES AT EXTENSION BEFORE ERROR SIGNALLED.
C                  A VALUE OF ZERO WILL STOP EXTENSION
C
C -- VARIABLES LOCAL TO THIS ROUTINE :-
C
C      IDAERR      NUMBER OF RETRIES REMAINING. WHEN THIS BECOMES ZERO
C                  AN ERROR IS SIGNALLED.
C
C
C
      DIMENSION J(NWORD)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XDAVAL/ IDAINI,IDATOT,IDAMAX,IDAMIN,IDAAUT,IDAQUA,IDATRY
C
C
C
C
      KFETCH = 1
C
      N = I + 1
C
      IDAERR = IDATRY
      IF ( IDAAUT .LE. 0 ) IDAERR = 0
C
C
1000  CONTINUE
C
          READ ( NU, REC = N, ERR = 2000, IOSTAT = IOS ) J
          IF (IOS .NE. ISSOKF) GOTO 2000
      RETURN
C
C--TRANSFER ERROR
2000  CONTINUE
C
      IF ( IDAERR .LE. 0 ) GO TO 9900
      IDAERR = IDAERR - 1
C
      CALL XDAEND ( NU , INEXT )
C
      IF ( IDAQUA .GT. 0 ) GO TO 2020
      IREQ = ( N - INEXT ) + 1
      IDAERR = 0
      GO TO 2030
C
2020  CONTINUE
      IREQ = IDAQUA
C
2030  CONTINUE
C
      CALL XDAXTN ( NU , INEXT , IREQ )
      IDATOT = INEXT + IREQ - 1
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2110) NU , IREQ
      ENDIF
      WRITE ( NCAWU , 2110 ) NU , IREQ
2110  FORMAT ( 1X , '**** Disc file on unit ' , I3 , ' extended by ' ,
     1 I5 , ' records ' )
C
      GO TO 1000
C
C
9900  CONTINUE
C
C -- REPEATED READ ERROR ON THIS UNIT
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU,9910 ) NU , N
      ENDIF
      WRITE ( NCAWU,9910 ) NU , N
9910  FORMAT ( 1X , 'Fatal read error on unit ' , I3 ,
     1 ' -- record ', I8, //, ' You may need to extend your .DSC file')
      CALL XERIOM ( NU , IOS )
      GO TO 9990
C
9990  CONTINUE
C -- ERROR EXIT FROM THIS ROUTINE
      KFETCH = ISIGN ( IOS , -1 )
      RETURN
C
      END
C
CODE FOR XSTORE
      SUBROUTINE XSTORE(NU,I,J,K)
C
C -- **** DUMMY ROUTINE ****
C
      STOP 'XSTORE'
C
      END
C
C
C
CODE FOR KSTORE
      FUNCTION KSTORE ( NU , I , J , NWORD )
C
C -- THIS ROUTINE WRITES DATA TO A DIRECT ACCESS FILE
C
C
C    NU    UNIT NUMBER FOR TRANSFER
C     I    RECORD NUMBER FOR TRANSFER ( 0 - END )
C     J    INTEGER ARRAY FROM WHICH DATA IS READ
C     NWORD NUMBER OF WORDS TO TRANSFER
C
C      RETURN VALUES :-
C
C      -VE      ERROR DURING TRANSFER - MESSAGE HAS BEEN PRINTED
C      +VE      SUCCESS
C
C**THIS LINK IS MACHINE SPECIFIC AS IT RELATES THE
C  THE LENGTH OF RECORDS SEEN BY THE USER TO THE LENGTH
C  OF HARDWARE BLOCKS ON THE DISC
C
C--THE TRANSFER IS ROUNDED UP TO FILL ONE OR MORE DISC BLOCKS
C
C
C
      DIMENSION J(NWORD)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
      KSTORE = 1
C
      N = I + 1
C
      WRITE ( NU , REC = N , ERR = 100 , IOSTAT = IOS ) J
      IF (IOS .NE. ISSOKF) GOTO 100
      RETURN
100   CONTINUE
       WRITE(NCAWU,200) NU,N
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,200) NU,N
      ENDIF
200   FORMAT(15H Write to unit ,I5,18H fails for record ,I8)
      CALL XERIOM ( NU , IOS )
C
C
      KSTORE = ISIGN ( IOS , -1 )
      RETURN
C
      END
C
CODE FOR KINCRS
      FUNCTION KINCRS(IN)
C--CALCULATE THE INCREMENT FOR WRITING 'IN' 24 BIT WORDS
C
C**MACHINE SPECIFIC  -  INCREMENT FOR INTEGER WORDS
C
C--
      KINCRS=IN
      RETURN
      END
C
CODE FOR KINCRF
      FUNCTION KINCRF(IN)
C--CALCULATE THE INCREMENT FOR WRITING 'IN' FLOATING POINT WORDS
C
C**MACHINE SPECIFIC  -  INCREMENT FOR FLOATING POINT NUMBERS
C
C--
      KINCRF=IN
      RETURN
      END
C
C
C
C
CODE FOR KSWPDU
      FUNCTION KSWPDU ( IUNIT )
C
C -- ALTER DIRECT ACCESS FILE UNIT TO 'IUNIT' . THE PREVIOUS UNIT IS
C    RETURNED AS 'KSWPDU'
C
      COMMON/XDISC/NU
C
C -- DUMP DATA MARKED TO BE REWRITTEN
C
      CALL XDUMP
C
      KSWPDU = NU
      NU = IUNIT
C
      RETURN
      END
C
C --
C
C
CODE FOR XDAINI
      SUBROUTINE XDAINI ( IDUNIT )
C
C -- INITIALISE THE NEW DIRECT ACCESS FILE ON UNIT 'IDUNIT'
C
C
      COMMON/XDISC/NU
      CHARACTER*10 NEWNAM
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XDAVAL/ IDAINI,IDATOT,IDAMAX,IDAMIN,IDAAUT,IDAQUA,IDATRY
C
      IDATOT = -1
      IREQ = MIN0 ( IDAINI , IDAQUA )
      IREQ = MAX0 ( IREQ , IDAMIN )
      IRECNO = 1
C
C -- WRITE A FEW RECORDS TO THE FILE
C
      CALL XDAXTN ( IDUNIT , IRECNO , IREQ )
      IDATOT = IRECNO + IREQ -  1
C
C -- INITIALISE FILE AND CURRENT LIST INDEXES
C
      NSAVEU = KSWPDU ( IDUNIT )
C
      CALL XSETFI
      CALL XSETLI
C
      N = KSWPDU ( NSAVEU )
C
      CALL XDANAM ( IDUNIT , NEWNAM )
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1010 ) IDUNIT , NEWNAM
      ENDIF
      WRITE ( NCAWU , 1010 ) IDUNIT , NEWNAM
1010  FORMAT ( // , 1X , 72 ( '*' ) , / ,
     2 1X , 'A new direct access file has been created ' ,
     3 'on unit ' , I3 , ' -- ' , A10 , ' file' , / ,
     4 1X , 72 ( '*' ) , // )
C
      RETURN
      END
C
C --
C
CODE FOR XDAXTN
      SUBROUTINE XDAXTN ( IUNIT,IBEGIN,ICOUNT )
C
C -- WRITE 'ICOUNT' RECORDS TO DISC FILE ON UNIT 'IUNIT'
C    STARTING AT RECORD 'IBEGIN'
C
C
C
C -- IF IT IS NOT POSSIBLE TO WRITE NEW RECORDS TO A DIRECT ACCESS
C    FILE, REPLACE THIS ROUTINE WITH A SUITABLE DUMMY. IT WILL BE
C    NECESSARY IN THIS CASE TO PROVIDE A METHOD OF EXTENDING DISC
C    FILES MANUALLY, AS WELL AS A MEANS OF CREATING NEW DIRECT ACCESS
C    FILES. THIS MIGHT BE DONE BY APPENDING A NEW SMALL FILE ONTO THE
C    EXISTING ONE.
C
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XDAVAL/ IDAINI,IDATOT,IDAMAX,IDAMIN,IDAAUT,IDAQUA,IDATRY
C
C    IF IBEGIN IS LESS THAN OR EQUAL TO 0, THE END OF FILE WILL
C    BE SEARCHED FOR.
C
C -- IBEGIN MAY BE A CONSTANT AND SO SHOULD NOT BE MODIFIED
C
      ISTART = IBEGIN
C
      IF ( ISTART .LT. 0 ) CALL XDAEND ( IUNIT,ISTART )
C
C -- NO OPERATION
      IF ( ICOUNT .LE. 0 ) GO TO 8000
C
      IEND = ISTART + ICOUNT - 1
      IF ( IDAMAX .LE. 0 ) GO TO 1900
      IF ( IEND .GT. IDAMAX ) GO TO 9920
1900  CONTINUE
C
      DO 2000 I=ISTART,IEND
      WRITE ( IUNIT , REC = I , ERR = 9900 , IOSTAT = IOS ) I
      IF (IOS .NE. ISSOKF) GOTO 9900
2000  CONTINUE
C
8000  CONTINUE
      RETURN
C
9900  CONTINUE
C -- ERROR WHILE EXTENDING DISC FILE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9910 ) IUNIT
      ENDIF
      WRITE ( NCAWU , 9910 ) IUNIT
9910  FORMAT ( 1X , 'An error has occured while extending file ' ,
     1 'on unit ' , I3 )
      CALL XERIOM ( IUNIT , IOS )
      CALL XERHND ( IERCAT )
9920  CONTINUE
C -- SIZE TOO GREAT
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 ) IUNIT
      ENDIF
      WRITE ( NCAWU , 9925 ) IUNIT
9925  FORMAT ( 1X , 'The maximum size of the file on unit ' , I3 ,
     2 ' has been exceeded' )
      CALL XERHND ( IERCAT )
      GO TO 9900
      END
C
C
C
CODE FOR KDAFRE
      FUNCTION KDAFRE ( IUNIT , IEND , IFREE )
C
C -- THIS ROUTINE EXSURES THAT THE DISC FILE ON UNIT 'IUNIT' HAS
C    AT LEAST 'IFREE' RECORDS FREE
C
C    IF 'IFREE' IS LESS THAN OR EQUAL TO 0,CONTROL RETURNS IMMEDIATELY
C    IF IEND IS LESS THAN OR EQUAL TO 0 , THE END OF FILE IS DETERMINED
C      USING 'XDAEND'
C
C      RETURN VALUE IS NUMBER OF RECORDS ADDED
C
      IADD = 0
      IF ( IFREE .LE. 0 ) GO TO 9000
      LAST = IEND
      IF ( LAST .LE. 0 ) CALL XDAEND ( IUNIT , LAST )
C -- CALCULATE PRESENT USAGE IN RECORDS
      CALL XDACVI ( NWDRCI , NWDBLI , NBYWDI )
      ILASTU = ( KNEXTF ( IN ) / NWDRCI ) + 1
      IUNUSE = LAST - ILASTU - 1
      IADD = MAX0 ( ( IFREE - IUNUSE ) , 0 )
C -- ADD REQUIRED EXTRA RECORDS TO FILE
      IF ( IADD .GT. 0 ) CALL XDAXTN ( IUNIT , LAST , IADD )
C
9000  CONTINUE
      KDAFRE = IADD
      RETURN
      END
C
C
CODE FOR XDANAM
      SUBROUTINE XDANAM ( IDUNIT , NAME )
C
C -- RETURNS A CHARACTER STRING 'NAME' WHICH IS THE TYPE OF THE FILE
C    ON UNIT 'IDUNIT'
C
      INTEGER IDUNIT
      CHARACTER*10 NAME
C
C
      CHARACTER*10 UNITNM(5)
C
      COMMON /XUNTNM/ IUNITN(5)
C
      DATA UNITNM / 'Unknown   ' , 'Data      ' , 'Command   ' ,
     2              'New data  ' , 'Command   ' /
C
      NUNITS = 5
C
      NAME = UNITNM(1)
C
      DO 2000 I = 1 , NUNITS
      IF (IUNITN(I) .EQ. IDUNIT ) NAME = UNITNM(I)
2000  CONTINUE
C
      RETURN
      END
C
C
C
CODE FOR XDAEXC
      SUBROUTINE XDAEXC
C
C -- INITIALISE CONTROL AREA FOR DIRECT ACCESS FILES
C
C
      COMMON /XDAVAL/ IDAINI,IDATOT,IDAMAX,IDAMIN,IDAAUT,IDAQUA,IDATRY
C
      IDATOT = -1
C
      RETURN
      END
C
C
C
CODE FOR XDASUM
      SUBROUTINE XDASUM
C
C -- PRINT A SUMMARY OF DISC USAGE
C
      CHARACTER*8 CPLACE(3)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XCBVAL / ICBHDR(9) , ICBDIM,ICBLDD,ICBDAD,
     2 ICBNFL,ICBMRN,ICBFIN,ICBDEQ,ICBCIN,ICBMAX,ICBTTL,ICBAUT,ICBLNF
C
      DATA CPLACE / ' In use ' , ' In file' , ' Free   ' /
C
      CALL XDACVI ( NWDRCI , NWDBLI , NBYWDI )
C
C -- **** TEMP ****
C
      NWDUSE = KNEXTF ( IN )
      NRCFIL = -1
C
C      NWDUSE = KCBRDH ( ICBNFL )
C      NRCFIL = KCBRDH ( ICBMRN )
C
C -- **** TEMP ENDS ****
C
      NRCUSE = ( NWDUSE / NWDRCI ) + 1
      NBLUSE = ( NWDUSE / NWDBLI ) + 1
      NBYUSE = ( NWDUSE * NBYWDI )
      NKBUSE = ( NBYUSE / 1000 ) + 1
C
      NWDFIL = ( NRCFIL * NWDRCI )
      NBLFIL = ( NWDFIL / NWDBLI )
      NBYFIL = ( NWDFIL * NBYWDI )
      NKBFIL = ( NBYFIL / 1000 )
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1005 ) NWDUSE
      ENDIF
      WRITE ( NCAWU , 1005 ) NWDUSE
1005  FORMAT ( / , 1X , 'Next free disc address is ' , I7 , / ,
     1 11X , 'Records' , 5X, 'Blocks' , 7X , 'Kbytes' )
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1010 ) CPLACE(1) , NRCUSE , NBLUSE , NKBUSE
      ENDIF
      WRITE ( NCAWU , 1010 ) CPLACE(1) , NRCUSE , NBLUSE , NKBUSE
1010  FORMAT ( 1X , A , 4X , I5 , 5X , I5 , 8X , I5 )
C
      IF ( NRCFIL .LE. 0 ) GO TO 9000
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1010 ) CPLACE(2) , NRCFIL , NBLFIL , NKBFIL
      ENDIF
      WRITE ( NCAWU , 1010 ) CPLACE(2) , NRCFIL , NBLFIL , NKBFIL
C
9000  CONTINUE
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9005 )
      ENDIF
      WRITE ( NCAWU , 9005 )
9005  FORMAT ( / )
C
      RETURN
      END
C
C
C
CODE FOR XDACVF
      SUBROUTINE XDACVF ( NWDRCF , NWDBLF , NBYWDF )
C -- THIS ROUTINE RETURNS THE FOLLOWING CONVERSION FACTORS :-
C
C      NWDRCF   NUMBER OF FLOATING POINT WORDS PER DISC RECORD
C      NWDBLF   NUMBER OF FLOATING POINT WORDS PER DISC BLOCK
C      NBYWDF   NUMBER OF BYTES PER FLOATING POINT WORD
C
C
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
      NWDRCF = ISSRLF
      NWDBLF = ISSBLF
      NBYWDF = ISSWLF
C
      RETURN
      END
C
C --
C
CODE FOR XDACVI
      SUBROUTINE XDACVI ( NWDRCI , NWDBLI , NBYWDI )
C -- THIS ROUTINE RETURNS THE FOLLOWING CONVERSION FACTORS :-
C
C      NWDRCI   NUMBER OF INTEGER WORDS PER DISC RECORD
C      NWDBLI   NUMBER OF INTEGER WORDS PER DISC BLOCK
C      NBYWDI   NUMBER OF BYTES PER INTEGER WORD
C
C
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
      NWDRCI = ISSRLI
      NWDBLI = ISSBLI
      NBYWDI = ISSWLI
C
      RETURN
      END
C
C
C
CODE FOR KCBRDH
      FUNCTION KCBRDH ( IOFF )
C
C
C -- READ VALUE AT OFFSET 'IOFF' IN DISC CONTROL BLOCK
C
C      VARIABLES USED :-
C
C      ICBHDR(N)   CONTAINS FIRST N WORDS OF CONTROL BLOCK. THE HEADER
C      ICBDIM      THE LENGTH OF THE HEADER ( = 9 )
C      ICBLDD      THE LOAD FLAG. -VE HEADER IS NOT LOADED. +VE HAS
C                  BEEN LOADED.
C      ICBDAD      DISK ADDRESS OF CONTROL BLOCK. ( = 0 )
C
C      VARIABLES CONTAINING OFFSETS IN DISC CONTROL BLOCK HEADER :-
C
C      ICBNFL      NEXT FREE DISC LOCATION
C      ICBMRN      HIGHEST RECORD NUMBER IN FILE
C      ICBFIN      DISC ADDRESS OF FIRST FILE INDEX BLOCK
C      ICBDEQ      DEFAULT EXTENSION QUANTITY
C      ICBCIN      DISC ADDRESS OF CURRENT LIST INDEX
C      ICBMAX      MAXIMUM SIZE OF FILE ( RECORDS )
C      ICBTTL      DISC ADDRESS OF TITLE
C      ICBAUT      AUTOMATIC EXTENSION FLAG
C      ICBLNF      LENGTH OF FILE INDEX BLOCK
C
      COMMON/XDISC/NU
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XCBVAL / ICBHDR(9) , ICBDIM,ICBLDD,ICBDAD,
     2 ICBNFL,ICBMRN,ICBFIN,ICBDEQ,ICBCIN,ICBMAX,ICBTTL,ICBAUT,ICBLNF
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      IF ( ICBLDD .GE. 0 ) GO TO 2000
C -- LOAD CONTROL BLOCK HEADER
      CALL XDOWN ( ICBDAD , ICBHDR(1) , ICBDIM )
C -- CHECK VALUES
      DO 1990 I = 1 , ICBDIM , 2
      IF ( ICBHDR(I) .LE. 0 ) GO TO 9910
1990   CONTINUE
      ICBLDD = 1
C
      IF ( ICBHDR(ICBMRN) .GT. 0 ) GO TO 2000
      CALL XDAEND ( NU , NEXTRC )
      ICBHDR(ICBMRN) = NEXTRC - 1
C
2000  CONTINUE
C -- CHECK THAT REQUEST WAS VALID
      IF ( IOFF .LE. 0 ) GO TO 9920
      IF ( IOFF .GT. ICBDIM ) GO TO 9920
      KCBRDH = ICBHDR(IOFF)
      RETURN
C
9910  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 )
      ENDIF
      WRITE ( NCAWU , 9915 )
9915  FORMAT ( 1X , 'Disc file is corrupt or is not a system file' )
      CALL XERHND ( IERPRG )
9920  CONTINUE
      CALL XOPMSG ( IOPCRY , IOPINT , 0 )
      RETURN
      END



CRYSTALS CODE FOR HARWELL
CODE FOR SOLVEN
      SUBROUTINE SOLVEN
C     *****************
C----- THE ROUTINES IN THIS FILE ARE FROM THE HARWELL SUBROUTINE
C      LIBRARY, AND HAVE BEEN INCORPORATED INTO CRYSTALS IN
C      CONJUNCTION WITH THE DIFABS ROUTINE OF NIGEL WALKER
C
C
      LOGICAL TCOR
      REAL VEC(44,44),EIG(44),UM1(44),WORK(220),RDASH(44),SDASH(44)
      COMMON /NORMAL/ ANORM(44,44),ATB(44),ROWJ(88),TERMS(44)
      COMMON /SOLVE/ NSIZE,FILTER,FILSTA,FILDEC,FILEND
      COMMON /DRVR/ LI,LD,LO,LF,LP,NCY,NSHAPE,NACOEF,NBCOEF,SFMU,TCOR
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
C   FOLLOWING EQUIVALENCING TO SAVE SOME SPACE
      EQUIVALENCE (WORK(1),RDASH(1)),(WORK(45),SDASH(1))
      EQUIVALENCE (ROWJ(1),EIG(1)),(ROWJ(45),UM1(1))
C
C Pre-scale normal matrix.
C Invert normal matrix using HARWELL s/r for eigenvalue inversion.
C
C Get inverse diagonal scaling matrix UM1 (U**-1) from normal matrix.
C The elements are SQRT(diagonal element of normal matrix)
C
C
      AINFL=FILSTA - (NCY-1)*FILDEC
      IF(AINFL.LT.FILEND)AINFL=FILEND
C      WRITE(LP,1030)FILTER,AINFL
C1030  FORMAT(/' Eigenvalue filtering; filter value=',F10.6,
C     +',  inflation constant=',F10.6)
C
      DO 10 I=1,NSHAPE
      UM1(I)=1.0
      IF(ANORM(I,I).NE.0.0) UM1(I)=1.0/SQRT(ANORM(I,I))
10    CONTINUE
C
C Scale matrix and vector(ATB) by UM1
C
      DO 20 J=1,NSHAPE
      UM1J=UM1(J)
      ATB(J)=ATB(J)*UM1J
      DO 30 K=1,J
      ANORM(J,K)=ANORM(J,K)*UM1(K)*UM1J
30    CONTINUE
20    CONTINUE
C
C Solve normal equations, EA06C returns eigenvectors and eigenvalues
C
      CALL EA06C(ANORM,EIG,VEC,NSHAPE,NSIZE,NSIZE,WORK)
C
C Write eigenvalues
C
C      WRITE(LP,1000)
C1000  FORMAT(/,' Eigenvalues')
C      WRITE(LP,1010)(EIG(I),I=1,NSHAPE)
C1010  FORMAT(10F8.4)
C
C To diagonalize, premultiply by column eigenvectors
C  VEC is matrix of eignvectors.
C
      DO 40 I=1,NSHAPE
      SUM=0.0
      DO 50 J=1,NSHAPE
      SUM=SUM+VEC(J,I)*ATB(J)
50    CONTINUE
      RDASH(I)=SUM
40    CONTINUE
C
C Solve diagonalization with inflated eigenvalue weighting & filtering
C
      DO 60 I=1,NSHAPE
      SDASH(I)=0.0
      IF(EIG(I).GT.FILTER)SDASH(I)=RDASH(I)/(EIG(I)+AINFL)
60    CONTINUE
C
C Rotate shifts back and rescale using UM1
C
      DO 70 J=1,NSHAPE
      SUM=0.0
      DO 80 I=1,NSHAPE
      SUM=SUM+VEC(J,I)*SDASH(I)
80    CONTINUE
      ATB(J)=SUM*UM1(J)
70    CONTINUE
C
C
C Write coefficient shifts
C
      WRITE(LP,1040)
1040  FORMAT(/,' Coefficient shifts')
      WRITE(LP,1050)(ATB(I),I=1,NSHAPE)
1050  FORMAT(1X,10F8.5)
C
C Apply shifts to original defining variables
      DO 90 J=1,NSHAPE
      TERMS(J)=TERMS(J)+ATB(J)
90    CONTINUE
C
C Write coefficients of absorption factor expansion
C
C      WRITE(LP,1020)
C1020  FORMAT(/,' New coefficients')
C      WRITE(LP,*)(TERMS(I),I=1,NSHAPE)
      RETURN
      END
C
C
C
C
C
C
C
CODE FOR AMI3
      SUBROUTINE AMI3 (A,B,DET)
C     *************************
C
C.... INVERTS ASYMMETRIC 3X3 MATRIX
C
      REAL A(3,3),B(3,3)
C
      B(1,1)=A(2,2)*A(3,3)-A(3,2)*A(2,3)
      B(2,1)=A(2,1)*A(3,3)-A(3,1)*A(2,3)
      B(3,1)=A(2,1)*A(3,2)-A(3,1)*A(2,2)
      DET=A(1,1)*B(1,1)-A(1,2)*B(2,1)+A(1,3)*B(3,1)
      IF (DET) 12,16,12
12    B(1,2)=A(1,2)*A(3,3)-A(3,2)*A(1,3)
      B(2,2)=A(1,1)*A(3,3)-A(3,1)*A(1,3)
      B(3,2)=A(1,1)*A(3,2)-A(3,1)*A(1,2)
      B(1,3)=A(1,2)*A(2,3)-A(2,2)*A(1,3)
      B(2,3)=A(1,1)*A(2,3)-A(2,1)*A(1,3)
      B(3,3)=A(1,1)*A(2,2)-A(2,1)*A(1,2)
      DO 14 I=1,3
      DO 14 J=1,3
      B(I,J)=(-1.)**(I+J)*B(I,J)/DET
14    CONTINUE
C
16    RETURN
      END
C
C
C
C
C
CODE FOR EA06C
      SUBROUTINE EA06C(A,VALUE,VECTOR,M,IA,IV,W)
C     ******************************************
C
C**  18/03/70 LAST LIBRARY UPDATE
C
C  Given a real mXm symmetric matrix A = {aij} this routine finds all it
C  eigenvalues (lambda)i i=1,2,.....,m and eigenvectors xj i=1,2,...,m.
C  i.e. finds the non-trivial solutions of Ax=(lambda)x
C
C  Argument list
C  -------------
C
C  SUBROUTINE EA06C(A,VALUE,X,M,IA,IX,W)
C
C  Arguments set by the user -
C
C  A  is a REAL 2-dimensional array with first dimension IA. The user mu
C     store the lower triangle of matrix A into the lower triangle of th
C     array A. i.e. put a(ij) into A(I,J) for i>=j and I>=J.
C
C  M  is an INTEGER and should be set to the order m of the matrix
C
C  IA is an INTEGER set to the first dimension of the array A, i.e. if t
C     allocation for the array A was specified by
C
C            DIMENSION A(100,50)
C
C     then IA would be set to 100
C
C  IX is an INTEGER set to the first dimension of the 2-dimensional arra
C
C
C  Arguments set by the routine -
C
C  A  the space above the diagonal of the array A is used by the routine
C     work space, the lower triangle set by the user will remain unchang
C     on return.
C
C  VALUE is a REAL array in which the routine puts the eigenvalues (lamb
C     i=1,2,...,m. These are not necessarily in any order.
C
C  X  is a REAL 2-dimensional array, with first dimension IX, containing
C     eigenvectors. The components of the eigenvector x(i) corresponding
C     eigenvalue (lambda)i (in VALUE(I)) are placed in X(J,I) J=1,2,...,
C     The eigenvectors are normalized so that xT(i)x(i)=1 i=1,2,...,m.
C
C  W  is a REAL array used by the routine for work space. It must have
C     dimension at least 5*M.
C
C                                    ------------
C
C
      DIMENSION A(IA,M) , VALUE(M) , VECTOR(IV,M) , W(*)
C
      M1=M+1
      W(1)=A(1,1)
      IF(M-2)30,10,20
   10 W(2)=A(2,2)
      W(4)=A(2,1)
      GO TO 30
C
   20 CALL MC04B(A,W,W(M1),M,IA,W(M+M1))
C
   30 CALL EA08C(W,W(M1),VALUE,VECTOR,M,IV,W(M+M1))
C
      IF(M.LE.2)RETURN
      DO 70 L=1,M
      DO 70 II=3,M
      I=M-II+1
      IF(W(M1+I))40,70,40
   40 PP=0.
      I1=I+1
      DO 50 K=I1,M
   50 PP=PP+A(I,K)*VECTOR(K,L)
      PP=PP/(A(I,I+1)*W(M1+I))
      DO 60 K=I1,M
   60 VECTOR(K,L)=VECTOR(K,L)+PP*A(I,K)
   70 CONTINUE
      RETURN
      END
C
C
C***  *  *  *  *  *  *  *  *  *  *  *  *  *
C
CODE FOR MC04B
      SUBROUTINE MC04B(A,ALPHA,BETA,M,IA,Q)
C     *************************************
C
      DIMENSION A(IA,*) , ALPHA(*) , BETA(*) , Q(*)
C
      ALPHA(1)=A(1,1)
      DO 20 J=2,M
      J1=J-1
      DO 10 I=1,J1
      A(I,J)=A(J,I)
   10 CONTINUE
      ALPHA(J)=A(J,J)
   20 CONTINUE
      M1=M-1
      M2=M-2
      DO 170 I=1,M2
      PP=0.0
      I1=I+1
      DO 30 J=I1,M
      PP=PP+A(I,J)**2
   30 CONTINUE
      PP1=SQRT(PP)
      IF(A(I,I+1))50,40,40
   40 BETA(I+1)=-PP1
      GO TO 60
   50 BETA(I+1)=PP1
   60 IF(PP)170,170,70
   70 H=PP-BETA(I+1)*A(I,I+1)
      A(I,I+1)=A(I,I+1)-BETA(I+1)
      DO 120 KI=I1,M
      QJ=0.0
      DO 80 KJ=I1,KI
      QJ=QJ+A(KJ,KI)*A(I,KJ)
   80 CONTINUE
      IF(KI-M)90,110,110
   90 I2=KI+1
      DO 100 KJ=I2,M
      QJ=QJ+A(KI,KJ)*A(I,KJ)
  100 CONTINUE
  110 Q(KI)=QJ/H
  120 CONTINUE
      BIGK=0.0
      DO 130 KJ=I1,M
      BIGK=BIGK+A(I,KJ)*Q(KJ)
  130 CONTINUE
      BIGK=BIGK/(2.0*H)
      DO 140 KJ=I1,M
      Q(KJ)=Q(KJ)-BIGK*A(I,KJ)
  140 CONTINUE
      DO 160 KI=I1,M
      DO 150 KJ=KI,M
      A(KI,KJ)=A(KI,KJ)-Q(KI)*A(I,KJ)-Q(KJ)*A(I,KI)
  150 CONTINUE
  160 CONTINUE
  170 CONTINUE
      DO 180 I=2,M
      H=ALPHA(I)
      ALPHA(I)=A(I,I)
      A(I,I)=H
  180 CONTINUE
      BETA(M)=A(M-1,M)
      RETURN
      END
C
C
C  *  *  *  *  *  *  *  *  *  *  *  *  *  *
C
CODE FOR EA08C
      SUBROUTINE EA08C(A,B,VALUE,VEC,M,IV,W)
C     **************************************
C
C    19/03/70 LAST LIBRARY UPDATE
C
C  THIS USES QR ITERATION TO FIND THE EIGENVALUES AND EIGENVECTORS
C  OF THE SYMMETRIC TRIDIAGONAL MATRIX WHOSE DIAGONAL ELEMENTS ARE
C  A(I),I=1,M AND OFF-DIAGONAL ELEMENTS ARE B(I),I=2,M.  THE ARRAY
C  W IS USED FOR WORKSPACE AND MUST HAVE DIMENSION AT LEAST 2*M.
C  WE TREAT VEC AS IF IT HAD DIMENSIONS (IV,M).
C
C
      DIMENSION A(M) , B(M) , VALUE(M) , VEC(*) , W(*)
      DATA EPS/  1E-5/,A34/0./
C
      CALL EA09C(A,B,W(M+1),M,W)
C
C  SET VEC TO THE IDENTITY MATRIX.
      DO 20 I=1,M
      VALUE(I)=A(I)
      W(I)=B(I)
      K=(I-1)*IV+1
      L=K+M-1
      DO 10 J=K,L
   10 VEC(J)=0.
   20 VEC(K+I-1)=1.
      ITER=0
      IF(M.EQ.1)RETURN
      N2=M
C  EACH QR ITERATION IS PERFORMED OF ROWS AND COLUMNS N1 TO N2
   30 DO 40 II=2,N2
      N1=2+N2-II
      IF(ABS(W(N1)).LE.(ABS(VALUE(N1-1))+ABS(VALUE(N1)))*EPS)GO TO 50
   40 CONTINUE
      N1=1
   50 IF(N2.NE.N1) GO TO 60
      N2=N2-1
      IF(N2-1)90,90,30
   60 ROOT=W(M+N2)
      ITER=ITER+1
      N2M1=N2-1
      A22=VALUE(N1)
      A12=A22-ROOT
      A23=W(N1+1)
      A13=A23
      DO 80 I=N1,N2M1
      A33=VALUE(I+1)
      IF(I.NE.N2M1)A34=W  (I+2)
      S=SIGN(SQRT(A12*A12+A13*A13),A12)
      SI=A13/S
      CO=A12/S
      JK=I*IV+1
      J1=JK-IV
      J2=J1+MIN0(M,I+ITER)-1
      DO 70 JI=J1,J2
      V1=VEC(JI)
      V2=VEC(JK)
      VEC(JI)=V1*CO+V2*SI
      VEC(JK)=V2*CO-V1*SI
   70 JK=JK+1
      IF(I.NE.N1)  W(I)=S
      A11=CO*A22+SI*A23
      A12=CO*A23+SI*A33
      A13=SI*A34
      A21=CO*A23-SI*A22
      A22=CO*A33-SI*A23
      A23=CO*A34
      VALUE(I)=A11*CO+A12*SI
      A12=-A11*SI+A12*CO
      W(I+1)=A12
   80 A22=A22*CO-A21*SI
      VALUE(N2)=A22
      GO TO 30
C  RAYLEIGH QUOTIENT
   90 DO 110 J=1,M
      K=(J-1)*IV
      XX=VEC(K+1)**2
      XAX=XX*A(1)
      DO 100 I=2,M
      XX=XX+VEC(K+I)**2
  100 XAX=XAX+VEC(K+I)*(2.*B(I)*VEC(K+I-1)+A(I)*VEC(K+I))
  110 VALUE(J)=XAX/XX
      RETURN
      END
C
C
C  *  *  *  *  *  *  *  *  *  *  *  *  *  *
C
CODE FOR EA09C
      SUBROUTINE EA09C(A,B,VALUE,M,OFF)
C     *********************************
C
C    18/03/70 LAST LIBRARY UPDATE
C
C
      REAL A(M),B(M),VALUE(M),OFF(M)
      DATA A34/0./,EPS/0.6E-7/
C
      VALUE(1)=A(1)
      IF(M.EQ.1)RETURN
      DO 10 I=2,M
      VALUE(I)=A(I)
   10 OFF(I)=B(I)
C  EACH QR ITERATION IS PERFORMED OF ROWS AND COLUMNS N1 TO N2
      N2=M
   20 IF(N2.LE.1)RETURN
      DO 30 II=2,N2
      N1=2+N2-II
      IF(ABS(OFF(N1)).LE.(ABS(VALUE(N1-1))+ABS(VALUE(N1)))*EPS)GO TO 40
   30 CONTINUE
      N1=1
   40 IF(N2.NE.N1) GO TO 50
      N2=N2-1
      GO TO 20
C  ROOT  IS THE EIGENVALUE OF THE BOTTOM 2*2 MATRIX THAT IS NEAREST
C  TO THE LAST MATRIX ELEMENT AND IS USED TO ACCELERATE THE
C  CONVERGENCE
   50 BB=(VALUE(N2)-VALUE(N2-1))*0.5
      CC=OFF(N2)*OFF(N2)
      SBB=1.
      IF(BB.LT.0.)SBB=-1.
      ROOT=VALUE(N2)+CC/(BB+SBB*SQRT(BB*BB+CC))
      N2M1=N2-1
      A22=VALUE(N1)
      A12=A22-ROOT
      A23=OFF(N1+1)
      A13=A23
      DO 60 I=N1,N2M1
      A33=VALUE(I+1)
      IF(I.NE.N2M1)A34=OFF(I+2)
      S=SQRT(A12*A12+A13*A13)
      SI=A13/S
      CO=A12/S
      IF(I.NE.N1)OFF(I)=S
      A11=CO*A22+SI*A23
      A12=CO*A23+SI*A33
      A13=SI*A34
      A21=CO*A23-SI*A22
      A22=CO*A33-SI*A23
      A23=CO*A34
      VALUE(I)=A11*CO+A12*SI
      A12=-A11*SI+A12*CO
      OFF(I+1)=A12
   60 A22=A22*CO-A21*SI
      VALUE(N2)=A22
      GO TO 20
      END
CRYSTALS CODE FOR LEXICAL
CODE FOR XILEXP
      SUBROUTINE XILEXP(IULN,IFIRST)
C--INITIATE LEXICAL SCANNER PROCESSING, BY SETTING VARIOUS CONSTANTS
C  AFTER THE SCANNER OUTPUT HAS BEEN STORED ON THE DISC.
C
C  IULN    THE LIST TYPE BEING PROCESSED
C  IFIRST  THE DISC ADDRESS OF THE FIRST RECORD HEADER.
C
C--THIS ROUTINE USES AND SETS WHERE NECESSARY THE FOLLOWING VARIABLES :
C
C  LK      THE LENGTH OF THE STORED ARGUMENT DETAILS IN WORDS.
C  LK1     THE LENGTH OF THE COMPLETE ARGUMENT IN WORDS MINUS ONE.
C  LK2     THE LENGTH OF THE COMPLETE ARGUMENT PRODUCED BY THE LEXICAL
C          SCANNER. THE FORMAT OF THIS IS AS FOLLOWS :
C
C          0  THE ARGUMENT TYPE :
C
C             -1  A VARIABLE, STORED AS 'LK' WORDS OF A4 CHARACTER DATA.
C              0  A NUMBER, WHOSE VALUE IS GIVEN IN WORD 2.
C             >0  AN OPERATOR, WHOSE TYPE IS GIVEN BY THE NUMBER IN THIS
C                 LOCATION. ALLOWED VALUES ARE :
C
C                 1  +
C                 2  -
C                 3  *
C                 4  /
C                 5  **
C                 6  (
C                 7  )
C                 8  ,
C                 9  =
C
C          1  THE CHARACTER NUMBER ON THE CARD WHERE THIS ARGUMENT ENDED
C          2  THE FIRST WORD OF THE ARGUMENT. FOR A NUMBER THIS IS THE
C             VALUE, WHILE FOR THE OTHERS IT IS THE START OF OF 'LK' WOR
C             CONTAINING THE ARGUMENT IN CHARACTER FORM.
C          3  THE SECOND WORD OF THE ARGUMENT.
C
C  NWCARD  THE NUMBER OF WORDS PER CARD WHEN IT IS STORED IN A4 FORMAT.
C  LARG    THE DISC ADDRESS OF THENEXT DATA RECORD HEADER BLOCK TO
C          BE PROCESSED.
C  MARG    THE DISC ADDRESS OF THE LAST DATA RECORD HEADER BLOCK
C          LOOKED AT BY 'KLDNLR'.
C  MDARG   THE NUMBER OF WORDS PER ARGUMENT, EQUAL TO 'LK2'.
C  NARG    THE NUMBER OF ARGUMENTS CURRENTLY IN CORE, EQUAL TO 'ME'.
C  MA      THE DISC ADDRESS OF THE NEXT DATA RECORD HEADER BLOCK TO
C          BE PROCESSED BY THE PRINT ROUTINE 'XPCLNN'.
C  MB      THE DISC ADDRESS OF THE LAST DATA RECORD HEADER BLOCK
C          PROCESSED BY THE PRINT ROUTINE 'XPCLNN'.
C  MC      THE NUMBER OF CARDS PRINTED MINUS ONE.
C  MD      THE ADDRESS IN CORE OF THE CURRENT SET OF ARGUMENTS.
C  ME      THE NUMBER OF ARGUMENTS ON THE CURRENT CARD.
C  MF      THE ADDRESS IN CORE OF THE CURREN ARGUMENT.
C  MG      THE FUNCTION OF THIS CARD, IN THE RANGE 1 TO N.
C
C  MQ      THE ADDRESS IN CORE AT WHICH ATOM AND PARAMETER HEADER BLOCKS
C          ARE SET UP.
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON/XCNTRL/LC,ISTAT2,ICNTR1,ICNTR2,LCG,MCG,MDCG,NCG,
     2 LCA,MCA,MDCA,NCA,LCS,MCS,MDCS,NCS
C
C--SET THE LIST AND RECORD TYPE
      LN=IULN
      IREC=0
C--SET THE DISC ADDRESS POINTERS
      LARG=IFIRST
      MARG=0
C--SET THE OTHER CONSTANTS
      MDARG=LK2
      NARG=0
C--SET THE PRINT VALUES
      MA=LARG
      MB=MARG
      MC=0
      MD=NFL
      ISTAT2=0
      RETURN
      END
C
CODE FOR KLDNLR
      FUNCTION KLDNLR(IN)
C--LOAD THE NXT LEXICAL RECORD FROM THE DISC FOR PROCESSING
C
C  IN      A DUMMY ARGUMENT.
C
C--RETURN VALUES ARE :
C
C  -1  END OF THE LEXICAL DATA
C   0  NEXT RECORD LOADED OKAY.
C  +1  AN ERROR PREVENTS AN MORE PROCESSING.
C
C--
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET AN INITIAL RETURN VALUE
      KLDNLR=-1
C--LOAD THE NEXT DATA RECORD HEADER
1000  CONTINUE
      IF(KLDDRH(MARG,LARG,IBUFF))1050,1100,1100
C--AND NOW RETURN
1050  CONTINUE
      RETURN
C--CHECK IF THIS RECORD IS CORE LOADABLE
1100  CONTINUE
      IF(IBUFF(7))1000,1150,1150
C--ALLOCATE SOME CORE FOR THIS RECORD  -  COMPUTE ITS LENGTH
1150  CONTINUE
      I=IBUFF(5)*IBUFF(6)
C--ASSIGN THE PARAMETER HEADER LOCATION
      MQ=MD+I
C--ASSIGN 'NFL'
      NFL=MQ+200
C--CHECK THE CORE LIMITS
      IF(NFL-LFL)1250,1250,1200
C--NOT ENOUGH CORE
1200  CONTINUE
      CALL XPCLNN(LN)
      CALL XICA
      KLDNLR=1
      GOTO 1050
C--BRING THE RECORD DOWN
1250  CONTINUE
      IF(I)1350,1350,1300
C--THERE IS SOME DATA TO LOAD
1300  CONTINUE
      CALL XDOWNF(IBUFF(4),STORE(MD),I)
C--SET THE CONTRL POINTERS
1350  CONTINUE
      ME=IBUFF(6)
      MF=MD
      NARG=ME
      IREC=IBUFF(7)
      MG=MOD(IREC,100)
      KLDNLR=0
      GOTO 1050
      END
C
C
C
C
CODE FOR KLXRDD
      FUNCTION KLXRDD ( ICOMMN , IDIMN , IADARG , IADCRD , NARGCD ,
     2 NCARD , ILAST )
C
C -- THIS ROUTINE READS A SINGLE DIRECTIVE FROM THE INPUT STREAM
C    AND SETS UP THE APPROPRIATE INTERNAL REPRESENTATIONS FOR THE
C    LEXICAL SCANNER.
C
C      ICOMMN      'COMMON BLOCK' FOR READ
C      IDIMN       DIMENSION OF 'ICOMMN'
C      IADARG      ( OUTPUT ) ADDRESS OF DATA
C      IADCRD      ( OUTPUT ) ADDRESS OF CARD IMAGES
C      NARGCD      ( OUTPUT ) NUMBER OF ARGUMENTS FOUND
C      NCARD       ( OUTPUT ) NUMBER OF CARDS READ
C      ILAST       NUMBER OF LAST DIRECTIVE READ. THIS SHOULD BE SET TO
C                  -1 BEFORE THE FIRST CALL TO THIS ROUTINE
C
C
C
C            VERSION 1      AUGUST 1983
C
C
C--RETURN VALUES ARE :
C
C      -1      ERROR(S) IN DATA
C       0      END
C      >1      DIRECTIVE NUMBER READ
C
C--
      DIMENSION ICOMMN(IDIMN)
C
      DIMENSION ISTORE(131072)
      DIMENSION KCHAR(10)
C
C      DIMENSION BLANK(1)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XLEXCH/KS,KE,KN,KV,KB(13),KC(13)
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (KCHAR(1),IPLUS)
C
C      EQUIVALENCE ( BLANK , IB )
C
C
      DATA NXA/9/,LXA/1/
C
      IADARG = MD
      NCHRRD = 0
      NXTCDI = KSTALH ( NWCARD )
      IADCRD = NXTCDI
      NARGCD = 0
C
C -- MC IS THE ADDRESS OF THE CURRENT ARGUMENT GROUP ( UPDATED BEFORE
C    USE )
      MC = IADARG - LK2
      NCARD = 0
      NBRACK = 0
C
C
      IF ( ILAST .LT. 0 ) GO TO 7000
      IF ( ILAST .EQ. 0 ) GO TO 8000
C
1400  CONTINUE
C -- IF THIS IS THE FIRST DIRECTIVE, SET DIRECTIVE NUMBER
      IF ( ILAST .LE. 0 ) ILAST = IDIRNM
C
C -- RESTORE DIRECTIVE POINTERS
C
      CALL XDIRFL ( ILAST , ICOMMN , IDIMN )
C
C -- CHECK FOR A 'DATA RECORD' TYPE DIRECTIVE
      IF ( ISTORE(MR61+11) .NE. 0 ) GO TO 1600
C
1500  CONTINUE
C--NOT A DATA RECORD  -  PROCESS THIS RECORD NORMALLY
C
      ISTAT = KFNDNP ( I )
      IF ( ISTAT .LT. 0 ) GO TO 9900
      IF ( ISTAT .EQ. 0 ) GO TO 7000
C
      ISTAT = KRDPV ( ICOMMN , IDIMN )
      IF ( ISTAT .LT. 0 ) GO TO 9900
      IF ( ISTAT .GT. 0 ) GO TO 9900
C
      GO TO 1500
C
C
1600  CONTINUE
C
C -- A DATA RECORD. STORE CARD IMAGE
C
C -- IF CARDS HAVE BEEN READ IN PREVIOUSLY THESE MUST BE MOVED NOW
      IF ( NCARD .LE. 0 ) GO TO 1610
C -- MOVE PREVIOUS CARDS READ
      I = IADCRD
      IADCRD = KSTALH ( NWCARD )
      CALL XMOVE ( STORE(I) , STORE(IADCRD) , NCHRRD )
C
1610  CONTINUE
C -- STORE CURRENT CARD IMAGE
      CALL XFA4CS( IMAGE(1) , STORE(NXTCDI) , LASTCH )
C -- UPDATE COUNTERS
      NCARD = NCARD + 1
      NCHRRD = NCHRRD + NWCARD
C
C----- INITIALISE THE OPERATOR STATUS
      MA = 0
1750  CONTINUE
C
C -- **** ARGUMENT PROCESSING LOOP STARTS HERE ****
C
C -- CHECK IF THERE ARE ANY MORE ARGUMENTS TO PROCESS ON THIS CARD
C
      NC = KNEQUL ( NC , IB )
      IF ( NC .LE. 0 ) GO TO 7000
C
C -- AN ARGUMENT HAS BEEN FOUND. MAKE SPACE. UPDATE COUNTER. SET
C    CHARACTER PART OF DATA TO BLANKS
C
      MC = MC + LK2
C -- CHECK DATA HAS NOT OVERRUN ALLOWED AREA
      LIMIT = MG
      IF ( MG .LE. 0 ) LIMIT = LFL
      IF ( MC .GE. LIMIT ) GO TO 9910
      NARGCD = NARGCD + 1
      CALL XMVSPD ( IB , STORE(MC+2) , LK2 )
C
C -- CHECK FOR AN OPERATOR AND IF FOUND BRANCH ON ITS TYPE
C
      I = KCOMP ( 1 , IMAGE(NC) , KCHAR(1) , NXA , LXA )
      IF ( I .LE. 0 ) GO TO 2600
C
      GO TO ( 2300 , 2300 , 2000 , 2300 , 2300 ,
     2 2150 , 2200 , 2300 , 2300 , 9920 ) , I
      GO TO 9920
C
C
2000  CONTINUE
C -- OPERATOR  FOUND IS '*'  -  CHECK FOR '**'
C -- LOCATE NEXT NON-BLANK CHARACTER AND CHECK FOR A SECOND '*'
C -- IF IT IS FOUND CHANGE OPERATOR NUMBER AND CHARACTER POSITION
C
      N = NC + 1
      N =  KNEQUL ( N , IB )
      IF ( N .LE. 0 ) GO TO 2300
C
      IF (   KCOMP ( 1,IMAGE(N),KCHAR(3),1,1 )  .LE.   0  ) GO TO 2300
C
      I=5
      NC=N
C
      GOTO 2300
C
2150  CONTINUE
C -- '(' FOUND. UPDATE COUNTER
      NBRACK = NBRACK + 1
      GOTO 2300
C -- ')' FOUND. DECREMENT COUNTER AND CHECK FOR UNDERFLOW
2200  CONTINUE
      NBRACK = NBRACK - 1
      IF ( NBRACK .LT. 0 ) GO TO 9930
C
2300  CONTINUE
C -- THIS IS THE GENERAL OPERATOR PROCESSING SECTION. THE OPERATOR
C    NUMBER AND THE CHARACTERS FOR THE OPERATOR ARE STORED AS THE
C    ARGUMENT AND THE POINTER MOVED.
C
      ISTORE(MC) = I
      CALL XMOVE ( KCHAR(I) , STORE(MC+2) , 1 )
      NC = NC + 1
C
2350  CONTINUE
C--SUNDRY TERMINATION OPERATIONS AFTER EACH OPERATOR, NUMBER OR
C    VARIABLE
C
C -- STORE CHARACTER POSITION FOR THE ARGUMENT FOUND. CHECK FOR ILLEGAL
C    COMBINATIONS OF ARGUMENTS
      ISTORE(MC+1)=NC+ME-1
C--CHECK THAT THE LAST OPERAND IS ALLOWED
      IF(KBITS(MA,KB(I)))2400,2550,2400
2400  CONTINUE
      J=NC-1
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2450)J
      ENDIF
      WRITE(NCAWU,2450)J
2450  FORMAT(/47H Illegal combination of arguments or characters,
     2 21H at or before column ,I5)
C--ERROR TERMINATION FOR THIS DIRECTIVE
      LEF=LEF+1
      IDIRFL=-1
      MB=-1000000
      GOTO 7000
C--SET THE LAST ARGUMENT CHECK VALUE
2550  CONTINUE
      MA=KC(I)
      GOTO 1750
C
C--CHECK IF THE NEXT OPERAND IS A NUMBER
2600  CONTINUE
      IF(KINPUT(T))2650,2650,2750
C--END OF NUMBER FOUND  -  NON-NUMERIC CHARACTER WHICH IS NOT '.'
2650  CONTINUE
      ISTORE(MC)=0
      STORE(MC+2)=T
C--CHECK IF THE TERMINATOR WAS A ','
      IF(IMAGE(NC-1).EQ.ICOMMA)NC=NC-1
      I=KN
C--CHECK THAT THE NUMBER TERMINATED PROPERLY
      IF(NC)2350,2350,2700
C--CHECK FOR A BLANK
2700  CONTINUE
      IF(IMAGE(NC).EQ.IB)GOTO 2350
C--CHECK FOR AN OPERATOR
      IF(KCOMP(1,IMAGE(NC),KCHAR(1),NXA,LXA))2400,2400,2350
C
C--THE NEXT SEQUENCE OF CHARACTERS IS NOT AN OPERATOR OR A NUMBER
C  ACCORDINGLY IT IS TREATED AS A VARIABLE, TO BE TERMINATED
C  BY AN OPERATOR OR A BLANK SPACE
2750  CONTINUE
      I=KV
      ISTORE(MC)=-1
      ND=NC
C--BEGIN SEARCH FOR THE TERMINATING CHARACTER
2800  CONTINUE
      ND=ND+1
      IF(ND-LASTCH)2850,2850,2900
C--THERE IS ANOTHER CHARACTER ON THE CARD  -  CHECK IF IT IS A BLANK
2850  CONTINUE
      IF(IMAGE(ND).EQ.IB)GOTO 2900
C--CHECK THE CHARACTER AGAINST THE OPERATOR LIST
      M=KCOMP(1,IMAGE(ND),KCHAR(1),NXA,LXA)
      IF(M)2800,2800,2900
C--READ THE VARIABLE TERMINATED BY AN OPERATOR
2900  CONTINUE
      CALL XFA4CS(IMAGE(NC),STORE(MC+2),MIN0(LK*4,ND-NC))
      NC=ND
      GOTO 2350
C
C
7000  CONTINUE
C -- READ THE NEXT DIRECTIVE FROM THE INPUT STREAM
C
      IDIRNM = KRDNDC ( ICOMMN , IDIMN )
C
C -- IF THIS IS A CONTINUATION OF THE PREVIOUS DIRECTIVE RETURN TO
C    PROCESS PARAMETERS
      IF ( IDIRNM .EQ. 0 ) GO TO 1400
C
C
8000  CONTINUE
C
C -- **** TERMINATION ROUTINES ****
C
C -- FINAL SYNTAX CHECK
      IF ( NBRACK .NE. 0 ) GO TO 9930
C
C -- SET RETURN VALUE
      KLXRDD = ILAST
      ILAST = IDIRNM
C -- CHANGE NUMBER FOR 'END' TO 0
      IF ( ILAST .LT. 0 ) ILAST = 0
C
      RETURN
C
C
9900  CONTINUE
C
C -- **** ERROR HANDLING ****
C
      KLXRDD = -1
      ILAST = -1
      RETURN
C
9910  CONTINUE
C -- INSUFFICIENT SPACE AVAILABLE
      CALL XOPMSG ( IOPCRY , IOPSPC , 0 )
      GO TO 9900
9920  CONTINUE
C -- INTERNAL ERROR
      CALL XOPMSG ( IOPCRY , IOPINT , 0 )
      GO TO 9900
9930  CONTINUE
      WRITE ( NCAWU , 9935 )
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9935 )
      ENDIF
9935  FORMAT ( 1X , 'The numbers of ( and ) do not match ' )
      GO TO 9900
C
      END
C
C
C
CODE FOR KLXSNG
      FUNCTION KLXSNG ( ICOMMN , IDIMN , ILAST )
C
C -- THIS ROUTINE READS A SINGLE ITEM FROM THE INPUT STREAM USING
C    'KLXRDD' AND SETS UP THE POINTERS FOR IMMEDIATE PROCESSING
C
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
      IDIR = KLXRDD ( ICOMMN,IDIMN,IARGC,ICARD,NARGC,NCARD,ILAST )
C
      LARG = 0
C
      MA = 0
      ME = NARGC
      MF = IARGC
C
C
      KLXSNG = IDIR
      RETURN
      END
C
C
C
CODE FOR XLXINI
      SUBROUTINE XLXINI ( ILAST , ICHNG )
C
C -- FIX UP DIRECTIVES ETC. FOR LEXICAL SCANNER INPUT
C----- ICHNG  SWITCH TO CAUSE MODIFICATION OF READ COUNTS
C             0      DO NOT MODIFY
C             1      MODIFY
C
C
      LOGICAL INSTR
      LOGICAL DATREC
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
C -- FIX UP EACH DIRECTIVE IN AN APPROPRIATE WAY
C
      IF ( NR60 .LE. 0 ) GO TO 1400
C
      MR60 = LR60
      MR61 = LR61
C
C -- EACH DIRECTIVE MUST APPEAR TO HAVE BEEN READ ONCE EXCEPT FOR THOSE
C    WHICH WILL APPEAR ONCE ONLY, SUCH AS NON DATA RECORD DIRECTIVES
C    WHICH ARE ALSO INSTRUCTION NAMES ( E.G. 'MODIFY' , BUT NOT 'HELP')
C
      DO 1300 I = 1 , NR61
C
      IDATA = ISTORE(MR61+11)
      IF ( IDATA .LT. 0 ) GO TO 9910
C --
      DATREC = ( IDATA .GT. 0 )
      INSTR = ( I .EQ. NR61 )
C
C -- CHECK FOR AN INSTRUCTION WHICH IS NOT A DATA RECORD
      IF ( INSTR .AND. ( .NOT. DATREC ) ) GO TO 1250
      IF (  ( ICHNG .LE. 0 ) .AND. ( .NOT. DATREC )  ) GO TO 1250
C
      ISTORE(MR61+8) = 1
      ISTORE(MR61+9) = LK2
      ISTORE(MR61+12) = 5
C
1250  CONTINUE
      MR60 = MR60 + MDR60
      MR61 = MR61 + MDR61
C
1300  CONTINUE
C
C
C
1400  CONTINUE
C
C -- ALLOCATE A BUFFER FOR COMMAND PROCESSING
C -- 'MD' IS BEGINNING AND 'MG' IS THE END
      MD = KSTALL ( 4000 )
      MG = MD + 4000
C -- SET DIRECTIVE TYPE FLAG
      ILAST = -1
C
      RETURN
C
9910  CONTINUE
      CALL XOPMSG ( IOPCRY , IOPINT , 0 )
      STOP
      END
C
C
C
CODE FOR KATOMU
      FUNCTION KATOMU(IN)
C--PROCESS THE OUTPUT FROM THE LEXICAL SCANNER TO FIND
C  ONE OR MORE LINKED ATOM NAMES, AND THEN FIND THE ATOMS IN LIST 5.
C
C--RETURN VALUES :
C
C  -1  END OF CARD FOUND.
C   0  ERROR IN ATOM DEFINITION.
C  >0  NEXT FREE LOCATION
C
C--LIST 5 IS SEARCHED IF L5 IS GREATER THAN ZERO. LIST 12 IS SEARCHED
C  IF L12A IS GREATER THAN ZERO AND L5 IS GREATER THAN ZERO.
C
C--OTHER IMPORTANT VARIABLES :
C
C  MQ   SET TO THE ADDRESS OF THE FIRST ATOM HEADER (BEFORE ENTRY)
C  M5A  LOCATION OF THE FIRST ATOM IN LIST 5
C  N5A  NUMBER OF ATOMS FOUND
C  L12A ADDRESS OF THE FIRST ATOM IN LIST 12  (L12 NEG. IF NOT NEC.)
C
C--THE FORMAT OF THE OUTPUT ATOMS IS IN STANDARD FORMAT.
C  THE SECOND OF AN 'UNTIL' SEQUENCE IS LINKED TO THE FIRST
C  IN TERMS OF ABSOLUTE ADDRESSES
C
C--THE FORMAT OF THE ATOM INFORMATION IS :
C
C   0  LINK LOCATION OR 'NOWT'
C   1  LENGTH OF THE ENTRY  (NOT SET HERE)
C   1  TYPE
C   3  SERIAL
C   4  NOT USED ('NOWT')
C   5  NUMBER OF PARAMETERS
C   6  ADDRESS OF THE FIRST PARAMETER REL. TO MQ OR 'NOWT'
C   7  S
C   8  L
C   9  T(X)
C  10  T(Y)
C  11  T(Z)
C  12  ADDRESS OF THE ATOM IN LIST 5 ('NOWT')
C  13  ADDRESS OF THE ATOM IN LIST 12 ('NOWT')
C  14  NOT USED ('NOWT')
C  15  ADDRESS OF THE GENERATED PARAMETERS ('NOWT')
C  16  ADDRESS OF THE PARAMETERS TO BE USED ('NOWT')
C
C--FOR EACH PARAMETER :
C
C  0  LINK TO NEXT PARAMETER REL. TO MQ OR 'NOWT'
C  1  POSITION IN THE ARGUMENT LIST
C  2  NOT USED (PARTIAL DERIVATIVE)
C
C--
      DIMENSION ISTORE(131072)
C
      DIMENSION OPS(1)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XAPK/NWKA,NKA,LKA,COORD(2,14)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
&HOL      DATA NOPS/1/,LOPS/1/,OPS(1)/4HUNTI/
#HOL      DATA NOPS/1/,LOPS/1/,OPS(1)/'UNTI'/
C
      II=KATOMH(MQ)
C--CHECK THAT AN ATOM HAS BEEN FOUND CORRECTLY
      IF(II)1000,1050,1200
C--END OF CARD  -  BACKSPACE ONE ARGUMENT
1000  CONTINUE
      MF=MF-LK2
C--ERROR IN ATOM DEFINITION
1050  CONTINUE
      CALL XADE(ISTORE(MF+1))
C--SET THE RETURN VALUE AND EXIT
1100  CONTINUE
      KATOMU=II
1150  CONTINUE
      RETURN
C--CHECK IF WE SHOULD LOOK FOR THIS ATOM IN LIST 5
1200  CONTINUE
      IF(L5)1400,1400,1250
C--SEARCH FOR THE ATOM IN LIST 5
1250  CONTINUE
      M5A=L5
      N5A=N5
      L12A=L12
      IF(KATOMF(STORE(MQ+2),M5A,N5A,MD5A,L12A))1300,1400,1300
C--ATOM NOT IN LIST 5
1300  CONTINUE
      II=MQ+2
      CALL XPCLNN(LN)
      CALL XMISL5(1,ISTORE(MQ+1),II)
C--SET THE ERROR FLAG
1350  CONTINUE
      KATOMU=0
      GOTO 1150
C--CHECK IF THIS IS AN 'UNTIL' TYPE OF COMMAND
1400  CONTINUE
      IF(ME)1450,1450,1500
C--NOT AN 'UNTIL' SEQUENCE
1450  CONTINUE
      N5A=1
      GOTO 1100
C--CHECK THE TYPE OF THE NEXT ARGUMENT
1500  CONTINUE
      IF(ISTORE(MF))1550,1450,1450
C--SEARCH FOR THE 'UNTIL' COMMAND
1550  CONTINUE
      JJ=KCOMP(1,STORE(MF+2),OPS,NOPS,LOPS)
      IF(JJ)1450,1450,1600
C--CHECK FOR AN END OF CARD AFTER 'UNTIL'
1600  CONTINUE
      ME=ME-1
      IF(ME)1700,1700,1800
C--ERROR IN AN 'UNTIL' SEQUENCE
1650  CONTINUE
      MF=MF-LK2
1700  CONTINUE
      CALL XPCLNN(LN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1750)ISTORE(MF+1)
      ENDIF
      WRITE(NCAWU,1750) ISTORE(MF+1)
1750  FORMAT(/41H Illegal 'UNTIL' sequence at about column,I5)
      LEF=LEF+1
      GOTO 1350
C--COMPILE THE DATA FOR THE SECOND ATOM
1800  CONTINUE
      MF=MF+LK2
      JJ=MQ
      ISTORE(MQ+1)=STORE(MQ+1)+1024
      MQ=II
      II=KATOMH(MQ)
C--CHECK THE REPLY
      IF(II)1000,1050,1850
C--CHECK THAT NO PARAMETERS HAVE BEEN READ FOR THIS ATOM
1850  CONTINUE
      IF(ISTORE(MQ+5))1650,1900,1650
C--LINK THE ATOM HEADERS AND CHECK IF WE MUST SEARCH THROUGH LIST 5
1900  CONTINUE
      ISTORE(JJ)=MQ
      IF(L5)2050,2050,1950
C--SEARCH FOR THE ATOM IN LIST 5
1950  CONTINUE
      KK=M5A
      LL=N5A
      NN=L12A
      IF(KATOMF(STORE(MQ+2),KK,LL,MD5A,NN))1300,2000,1300
C--COMPUTE THE NUMBER OF ATOMS
2000  CONTINUE
      N5A=N5A-LL+1
C--UPDATE AND RETURN
2050  CONTINUE
      MQ=JJ
      GOTO 1100
      END
C
CODE FOR KATOMH
      FUNCTION KATOMH(IN)
C--GENERATE THE ATOM INFORMATION FROM THE RESULTS OF THE LEXICAL SCAN
C
C  IN      A DUMMY ARGUMENT.
C
C--RETURN VALUES ARE :
C
C  -1   END OF CARD DETECTED.
C   0   ERROR DURING THE PROCESSING.
C  >0   THE NEXT FREE ADDRESS AFTER THE LAST PIECE OF ATOM INFORMATION.
C
C--RETURNS WITH 'ME' AND 'MF' SET TO THE NEXT ELEMENT ON THE
C  CARD TO BE PROCESSED, AND CHECKS FOR THE END OF CARD
C  AT THE START OF THE SCAN.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK FOR END OF CARD
      IF(ME)1000,1000,1050
C--END OF CARD FOUND
1000  CONTINUE
      KATOMH=-1
      GOTO 1200
C--CALL 'KATOMG' TO PROCESS THE ARGUMENT LIST
1050  CONTINUE
      KA=KATOMG(MQ)
C--CHECK THE REPLY
      IF(KA)1100,1100,1150
C--ERROR DURING THE PROCESSING
1100  CONTINUE
      KATOMH=0
      GOTO 1200
C--ATOM HEADER OUTPUT OKAY
1150  CONTINUE
      ME=ME-1
      MF=MF+LK2
      KATOMH=KA
1200  CONTINUE
      RETURN
      END
C
CODE FOR KATOMG
      FUNCTION KATOMG(IN)
C--GENERATE THE ATOM INFORMATION FROM THE RESULTS OF THE LEXICAL SCAN
C
C  IN      A DUMMY ARGUMENT.
C
C--RETURN VALUES ARE :
C
C  <1  ERROR
C  >0  THE NEXT FREE ADDRESS AFTER THE LAST PIECE OF ATOM INFORMATION.
C
C--RETURNS WITH 'ME' AND 'MF' SET TO THE LAST ELEMENT ON THE
C  CARD PROCESSED, NOT THE NEXT ONE TO BE PROCESSED.
C  THIS IS SO THAT DIAGNOSTICS CAN BE ACCURATELY POSITIONED.
C
C--THE FORMAT OF THE ATOM INFORMATION IS :
C
C   0  LINK LOCATION OR 'NOWT'
C   1  LENGTH OF THE ENTRY  (NOT SET HERE)
C   2  TYPE
C   3  SERIAL
C   4  NOT USED ('NOWT')
C   5  NUMBER OF PARAMETERS
C   6  ADDRESS OF THE FIRST PARAMETER REL. TO MQ OR 'NOWT'
C   7  S
C   8  L
C   9  T(X)
C  10  T(Y)
C  11  T(Z)
C  12  ADDRESS OF THE ATOM IN LIST 5 ('NOWT')
C  13  ADDRESS OF THE ATOM IN LIST 12 ('NOWT')
C  14  NOT USED ('NOWT')
C  15  ADDRESS OF THE GENERATED PARAMETERS ('NOWT')
C  16  ADDRESS OF THE PARAMETERS TO BE USED ('NOWT')
C
C--FOR EACH PARAMETER :
C
C  0  LINK TO NEXT PARAMETER REL. TO MQ OR 'NOWT'
C  1  POSITION IN THE ARGUMENT LIST
C  2  NOT USED (PARTIAL DERIVATIVE)
C
C--DOES NOT CHECK FOR THE END OF THE CARD AT THE START
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON/XSCALE/NWSC,NSC,LSC,SCALE(2,8)
      COMMON/XFIRST/IFIRST(2)
      COMMON/XAPK/NWKA,NKA,LKA,COORD(2,14)
      COMMON/XSHORT/NWXS,NXS,LXS,MXS(2,5)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK THAT THE FIRST OPERAND IS A VARIABLE
C  THIS VARIABLE IS THE ATOM NAME
      KA=0
      IF(ISTORE(MF))1100,1000,1000
C--GENERAL ERROR ROUTINE
1000  CONTINUE
      KATOMG=-1
1050  CONTINUE
      RETURN
C--START TO FORM THE ATOM HEADER BLOCK  -  CHECK FOR 'FIRST' OR 'LAST'
1100  CONTINUE
      IF(KCOMP(1,STORE(MF+2),IFIRST(1),2,1))1200,1200,1150
C--THIS IS 'FIRST' OR 'LAST'
1150  CONTINUE
      KA=-1
C--SET UP THE HEADER LINK INFORMATION
1200  CONTINUE
      J=MQ+2
      ISTORE(MQ)=NOWT
      ISTORE(MQ+1)=0
C--SET UP THE ATOM TYPE
      CALL XMOVE(STORE(MF+2),STORE(J),1)
      ME=ME-1
      MF=MF+LK2
C--UPDATE THE HEADER POINTER AND INSERT A DUMMY SERIAL NUMBER
      K=J+1
      STORE(K)=0.
C--CHECK THAT AFTER THE ATOM NAME THERE IS A '('
      IF(KOP(6))1250,1350,1300
1250  CONTINUE
C--END OF CARD  -  CHECK IF 'FIRST' OR 'LAST' WHEN THIS IS ALLOWED
      IF ( KA .LT. 0 ) GO TO 1300
C -- ERROR. BACKSPACE ONE ARGUMENT AND RETURN
      ME = ME + 1
      MF = MF - LK2
      GO TO 1000
1300  CONTINUE
      KA=-KA
      IF(KA)1450,1000,1450
C--A '(' HAS BEEN FOUND  -  CHECK IF A SERIAL NUMBER IS EXPECTED
1350  CONTINUE
      IF(KA)1450,1400,1450
C--READ THE SERIAL NUMBER OF THIS ATOM
1400  CONTINUE
      IF(KNUMBR(STORE(K)))1000,1450,1000
C--SET UP THE ATOM HEADER BLOCK
1450  CONTINUE
      ISTORE(K+1)=NOWT
      ISTORE(K+2)=0
      ISTORE(K+3)=NOWT
      M=K+3
      K=K+4
C--SET UP THE DEFAULT VALUES FOR THE SYMMETRY OPERATORS
      ISTORE(K)=1
      ISTORE(K+1)=1
      ISTORE(K+2)=0
      ISTORE(K+3)=0
      ISTORE(K+4)=0
      L=0
C--SET THE STORE ADDRESSES AS NOT SET
      ISTORE(K+5)=NOWT
      ISTORE(K+6)=NOWT
      ISTORE(K+7)=NOWT
      ISTORE(K+8)=NOWT
      ISTORE(K+9)=NOWT
C--CHECK IF 'FIRST' OR 'LAST' WAS FOLLOWED BY A '('
      IF(KA)1550,1500,1800
C--MAIN LOOP FOR READING THE SYMMETRY OPERATORS
C  IF ANY ARE OMITTED OR LEFT BLANK THE DEFAULT VALUES ARE ASSUMED
1500  CONTINUE
C--CHECK THAT THE LAST PIECE OF INFORMATION ENDED WITH A ','
      IF(KOP(8))1000,1550,1750
C--READ THE SYMMETRY OPERATOR
1550  CONTINUE
      IF(KSYNUM(STORE(K)))1900,1600,1650
C--STORE THE OPERATOR AS AN INTEGER
1600  CONTINUE
      ISTORE(K)=NINT(STORE(K))
      ME=ME-1
      MF=MF+LK2
C--UPDATE THE NUMBER OF SYMMETRY OPERATORS FOUND
      K=K+1
      L=L+1
C--CHECK THAT TOO MANY OPERATORS HAVE NOT BEEN INPUT
      IF(L-6)1500,1000,1000
C--OPERATOR IS FOUND INSTEAD OF A NUMBER  -  CHECK IF ',' OR ')'
1650  CONTINUE
      IF(KOP(8))1000,1700,1750
1700  CONTINUE
      K=K+1
      L=L+1
      IF(L-6)1550,1000,1000
C--CHECK IF THE OPERATOR IS AN ')'
1750  CONTINUE
      IF(ISTORE(MF)-7)1000,1850,1000
C--'FIRST' OR 'LAST' BY ITSELF  -  CORRECT THE CARD POINTERS POSITIONS
1800  CONTINUE
      ME=ME+1
      MF=MF-LK2
C--SUCCESSFUL EXIT
1850  CONTINUE
      L=J+15
      KATOMG=MAX0(K,L)
      GOTO 1050
C--PROCESS THE PARAMETERS
1900  CONTINUE
      K=J+15
1950  CONTINUE
      IF(ISTORE(MF))2000,1000,1750
2000  CONTINUE
      L=KCOMP(NWKA,ISTORE(MF+2),COORD,NKA,LKA)
C--IS IT A PARAMETER
      N=1
      IF(L)2050,2050,2300
C--CHECK TO SEE IF IT IS ONE OF THE SHORT FORMS
2050  CONTINUE
      L=KCOMP(NWXS,ISTORE(MF+2),MXS,NXS,LXS)
      IF(L)1000,1000,2100
C--THIS IS A SHORT FORM
2100  CONTINUE
      N=3
      GOTO (2150,2200,2250,2500,1000,1000),L
C--ALL THE U'S
2150  CONTINUE
      L=8
      N=6
      GOTO 2300
C--ONLY THE U(II)'S
2200  CONTINUE
      L=8
      GOTO 2300
C--ONLY THE U(IJ)'S
2250  CONTINUE
      L=11
      GOTO 2300
2500  CONTINUE
C----- POSITIONS
      L=5
2300  CONTINUE
      DO 2350 I=1,N
      ISTORE(M)=K-MQ
      M=K
      ISTORE(K)=NOWT
      ISTORE(K+1)=L
      K=K+3
      L=L+1
2350  CONTINUE
      MF=MF+LK2
      ME=ME-1
      ISTORE(J+3)=ISTORE(J+3)+N
      IF(ISTORE(MF)-8)1750,2400,1750
2400  CONTINUE
      MF=MF+LK2
      ME=ME-1
      GOTO 1950
      END
C
CODE FOR KATOMF
      FUNCTION KATOMF(ARG,M5F,N5F,MD5F,M12F)
C--FIND AN ATOM IN LIST 5
C
C  M5F     FIRST LOCATION AT WHICH TO START LOOKING
C  N5F     NUMBER OF ATOMS THROUGH WHICH TO PASS
C  MD5F    STEP BETWEEN ATOMS
C  M12F    LIST 12 ADDRESS  -  NOT USED IF SET NEGATIVE INITIALLY
C
C--RETURN VALUES :
C
C  -1  NO MATCH  -  NO ERROR MESSAGE EITHER.
C   0  OKAY  -  ALL RETURN VALUES SET.
C--
      DIMENSION ISTORE(131072)
C
      DIMENSION ARG(2)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XFIRST/IFIRST(2)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      IATOMF=-1
C--CHECK IF ANY ATOMS HAVE BEEN GIVEN
      IF(N5F)1200,1200,1450
C--CHECK IF THERE ARE MORE ATOMS TO PROCESS
1000  CONTINUE
      IF(N5F)1100,1100,1250
C--SUCCESSFUL FIND  -  RESET 'IATOMF'
1050  CONTINUE
      IATOMF=0
C--TIME TO RETURN  -  CHECK IF WE HAVE BEEN SUCCESSFUL
1100  CONTINUE
      IF(IATOMF)1200,1150,1150
C--SUCCESS  -  MOVE THE ATOM NAME ACROSS
1150  CONTINUE
      CALL XMOVE(STORE(M5F),ARG(1),2)
C--UPDATE THE NUMBER OF ATOMS LEFT
      N5F=MAX0(N5F,IATOMF)
C--AND NOW RETURN
1200  CONTINUE
      KATOMF=MIN0(0,IATOMF)
      RETURN
C--CHECK THE SERIAL NUMBERS
1250  CONTINUE
      IF(ABS(STORE(M5F+1)-ARG(2))-0.0005)1400,1300,1300
C--UPDATE FOR THE NEXT ATOM
1300  CONTINUE
      M5F=M5F+MD5F
      N5F=N5F-1
C--CHECK IF WE ARE USING LIST 12
      IF(M12F)1000,1000,1350
C--USING LIST 12  -  UPDATE THE POINTERS
1350  CONTINUE
      M12F=ISTORE(M12F)
      GOTO 1000
C--CHECK THE ATOM TYPES
1400  CONTINUE
      IF(KCOMP(1,ARG,STORE(M5F),1,1))1300,1300,1050
C
C--ATOMS PROVIDED  -  CHECK FOR 'FIRST' AND 'LAST' INITIALLY
1450  CONTINUE
      J=KCOMP(1,ARG(1),IFIRST(1),2,1)
C--CHECK THE REPLY
      IF(J-1)1250,1500,1550
C--THE ARGUMENT IS 'FIRST'  -  CHECK THAT WE CAN ACCESS THE FIRST ATOM
1500  CONTINUE
      IF(L5-M5F)1200,1050,1200
C--THE ARGUMENT IS 'LAST'  -  CHECK THE ADDRESSING
1550  CONTINUE
      J=L5+(N5-1)*MD5
      IF(J-M5F)1200,1600,1600
C--RESET THE REPLY
1600  CONTINUE
      IATOMF=1
      N5F=N5F-1
      GOTO 1000
      END
C
CODE FOR KCORCH
      FUNCTION KCORCH(IN)
C--CHECK IF THE NEXT ARGUMENT OUTPUT BY THE LEXICAL ANALYZER IS
C  A PARAMETER SPECIFICATION OF THE FORM 'X' ETC. , INDICATING THE
C  X PARAMETER OF ALL THE ATOMS IN LIST 5.
C
C    IF THE PARAMETER SPECIFICATION IS FOLLOWED BY A LEFT PARENTHESIS,
C    IT IS NOT TREATED AS AN OVERALL PARAMETER. THIS ALLOWS ATOM NAMES
C    SUCH AS X(1) TO BE SPECIFIED WITHOUT INTERFERENCE BY THIS ROUTINE
C
C
C
C  IN  A DUMMY ARGUEMNT
C
C--RETURN VALUES ARE :
C
C  -1  END OF CARD FOUND
C  0   NOT AN ATOMIC PARAMETER
C  >1  THE NEXT FREE ADDRESS AFTER THE HEADER SET UP FOR
C      ATOMIC PARAMETER.
C
C--ON RETURN THE FOLLOWING VARIABLES ARE SET :
C
C  M5A  ADDRESS OF THE FIRST ATOM
C  N5A  THE NUMBER OF ATOMS
C  L12A THE ADDRESS OF THE FIRST ATOM GROUP HEADER
C
C--'MQ' IS ASSUMED TO HAVE BEEN SET, AND TWO LINKED HEADER BLOCKS ARE
C  SET UP THERE. THE TYPE OF THE FIRST IS 'FIRST' AND THAT OF THE SECOND
C  IS 'LAST', AND THE 'UNTIL' BIT OF THE FIRST HEADER IS SET.
C
C   0  LINK LOCATION OR 'NOWT'
C   1  LENGTH OF THE ENTRY  (NOT SET HERE)
C   2  TYPE  'FIRST' OR 'LAST', DEPENDING ON THE HEADER.
C   3  SERIAL  -  SET TO 0.0.
C   4  NOT USED ('NOWT')
C   5  NUMBER OF PARAMETERS
C   6  ADDRESS OF THE FIRST PARAMETER REL. TO MQ OR 'NOWT'
C   7  S (ALL SYMMETRY OPERATORS TAKE ON DEFAULT VALUES)
C   8  L
C   9  T(X)
C  10  T(Y)
C  11  T(Z)
C  12  ADDRESS OF THE ATOM IN LIST 5 ('NOWT')
C  13  ADDRESS OF THE ATOM IN LIST 12 ('NOWT')
C  14  NOT USED ('NOWT')
C  15  ADDRESS OF THE GENERATED PARAMETERS ('NOWT')
C  16  ADDRESS OF THE PARAMETERS TO BE USED ('NOWT')
C
C--FOR EACH PARAMETER :
C
C  0  LINK TO NEXT PARAMETER REL. TO MQ OR 'NOWT'
C  1  POSITION IN THE ARGUMENT LIST
C  2  NOT USED (PARTIAL DERIVATIVE)
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XAPK/NWKA,NKA,LKA,COORD(2,14)
      COMMON/XSHORT/NWXS,NXS,LXS,MXS(2,5)
      COMMON/XFIRST/IFIRST(2)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK FOR END OF CARD
      IF(ME)1050,1050,1150
C--EXIT BECAUSE THIS IS NOT AN ATOMIC PARAMETER
1000  CONTINUE
      KCORCH=0
      GOTO 1100
C--END OF CARD FOUND
1050  CONTINUE
      KCORCH=-1
1100  CONTINUE
      RETURN
C--CHECK THE TYPE OF THE NEXT ARGUMENT
1150  CONTINUE
      IF ( ISTORE(MF) .GE. 0 ) GO TO 1000
C
C -- IF THERE IS ANOTHER ARGUMENT ON THE CARD, CHECK THAT IT IS NOT A
C    LEFT PARENTHESIS, AS THIS INDICATES THAT AN ATOM NAME HAS BEEN
C    GIVEN
      IF ( ME .LE. 1 ) GO TO 1200
      IF ( ISTORE(MF+LK2) .EQ. 6 ) GO TO 1000
C
C--SEARCH FOR THE ATOMIC PARAMETER
1200  CONTINUE
C----- CHECK FOR SHORT FORM
      N=3
      J=KCOMP(NWXS,STORE(MF+2),MXS,NXS,LXS)
      IF(J)1400,1400,1220
1220  CONTINUE
      GOTO(1250,1300,1350,1600,1000,1000),J
C--ALL THE U'S ARE REQUIRED
1250  CONTINUE
      N=6
      I=8
      GOTO 1450
C----- U(II)'S ONLY
1300  CONTINUE
      I=8
      GOTO 1450
C--THIS IS THE U(IJ)'S
1350  CONTINUE
      I=11
      GOTO 1450
1600  CONTINUE
C----- POSITIONS
      I=5
      GOTO 1450
C--CHECK IF THIS IS A NORMAL PARAMETER
1400  CONTINUE
      N=1
      I=KCOMP(NWKA,STORE(MF+2),COORD,NKA,LKA)
      IF(I)1000,1000,1450
C--SET UP A DUMMY ATOM HEADER
1450  CONTINUE
      L12A=L12
      N5A=N5
      M5A=L5
C--SPREAD THIS OVER THE WHOLE HEADER
      CALL XFILL(NOWT,ISTORE(MQ),17)
      ISTORE(MQ+1)=0
      STORE(MQ+3)=0.0
C--SET UP THE DEFAULT SYMMETRY OPERATORS
      ISTORE(MQ+7)=1
      ISTORE(MQ+8)=1
      ISTORE(MQ+9)=0
      ISTORE(MQ+10)=0
      ISTORE(MQ+11)=0
C--SET UP THE SECOND HEADER BLOCK
      J=MQ+17
      CALL XMOVE(ISTORE(MQ),STORE(J),17)
C--LINK THE TWO HEADER BLOCKS
      ISTORE(MQ)=J
      ISTORE(MQ+1)=ISTORE(MQ+1)+1024
C--SET UP THE TYPES PROPERLY
      CALL XMOVE(IFIRST(1),ISTORE(MQ+2),1)
      CALL XMOVE(IFIRST(2),ISTORE(J+2),1)
C--SET UP THE PARAMETER ADDRESSES
      ISTORE(MQ+5)=N
      ISTORE(MQ+6)=J+17-MQ
C--SET UP THE ADDRESSES TO INSERT THE PARAMETERS
      J=ISTORE(MQ+6)+MQ
      L=J
C--LOOP ROUND ADDING THE SPECIFIED PARAMETER(S)
      DO 1500 K=1,N
      ISTORE(J)=L-MQ
      J=L
      L=L+3
      ISTORE(J)=NOWT
      ISTORE(J+1)=I
      I=I+1
1500  CONTINUE
C--SET THE LAST ADDRESS USED
      KCORCH=L
      ME=ME-1
      MF=MF+LK2
      GOTO 1100
      END
C
CODE FOR KOVPCH
      FUNCTION KOVPCH(IN)
C--CHECK THE OUTPUT FROM THE LEXICAL ANALYZER FOR AN OVERALL
C  PARAMETER OR GROUP OF PARAMETERS.
C
C  IN  A DUMMY ARGUMENT
C
C--THE RETURN VALUES OF 'KOVPCH' ARE :
C
C  -1  AN ERROR DURING THE PROCESSING OF THE OVERALL VARIABLES
C   0  NO OVERALL VARIABLE FOUND
C  >0  OVERALL VARIABLE FOUND.
C
C--IF THE RETURN VALUE IS GREATER THAN ZERO, ITS MAGNITUDE
C  INDICATES THE TYPE OF OVERALL PARAMETER FOUND :
C
C  1  SCALE, DU[ISO] OR OU[ISO]
C  2  LAYER SCALES
C  3  ELEMENT SCALES
C
C--UPON RETURN, THE FOLLOWING VARIABLES ARE SET :
C
C  M5A   ADDRESS OF THE FIRST VARIABLE IN LIST 5
C  N5A   NUMBER OF VARIABLE FOUND
C  L12A  ADDRESS OF THE GROUP HEADER IN LIST 12
C  M5O   NUMBER OF THE FIRST VARIABLE FOUND (IN THE RANGE 1 TO N).
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--READ THE OVERALL PARAMETERS IF IT IS POSSIBLE
      I=KOVPMU(IN)
C--CHECK THE REPLY
      IF(I)1050,1050,1000
C--PROCESSING WAS OKAY  -  FIND THE TYPE OF PARAMETER
1000  CONTINUE
      I=ISTORE(MQ+1)-(ISTORE(MQ+1)/1024)*1024
C--ASSIGN THE VALUE AND RETURN
1050  CONTINUE
      KOVPCH=I
      RETURN
      END
C
CODE FOR KOVPMU
      FUNCTION KOVPMU(IN)
C--PROCESS THE OUTPUT FROM THE LEXICAL SCANNER FOR AN OVERALL PARAMETER,
C  AND FIND THE PARAMETERS IN LIST 5 IF NECESSARY.
C
C  IN  A DUMMY ARGUMENT.
C
C--RETURN VALUES OF 'KOVPMU' ARE :
C
C
C  -1  ERROR IN PROCESSING AN OVERALL PARAMETER  -  MESSAGE PRINTED.
C   0  NOT AN OVERALL PARAMETER.
C  >0  NEXT FREE LOCATION AFTER THE OVERALL PARAMETER HEADER BLOCK.
C
C--RETURNS WITH 'ME' AND 'MF' SET TO THE NEXT ELEMENT ON THE
C  CARD TO BE PROCESSED, AND CHECKS FOR THE END OF CARD
C  AT THE START OF THE SCAN.
C
C--IF 'L5' IS GREATER THAN ZERO, THE ATOMS ARE LOCATED IN LIST 5,
C  AND THE FOLLOWING VARIABLES ARE SET UPON RETURN :
C
C  M5O   THE POSITION OF THE FIRST PARAMETER IN ITS GROUP (1 TO N).
C  M5A   ADDRESS OF THE FIRST PARAMETER IN LIST 5.
C  N5A   THE NUMBER OF PARAMETERS FOUND.
C  L12A  ADDRESS OF THE GROUP HEADER IN LIST 12.
C
C--THIS ROUTINE WILL PROCESS 2 OVERALL PARAMETERS SEPARATED BY 'UNTIL'
C  AND SET THE VARIABLES ABOVE CORRECTLY IF NECESSARY.
C
C--
      DIMENSION ISTORE(131072)
C
      DIMENSION OPS(1)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XOPK/NWKO,NKO,LKO,OVP(2,6)
      COMMON/XSCALE/NWSC,NSC,LSC,SCALE(2,8)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
&HOL      DATA OPS(1)/4HUNTI/,NOPS/1/,LOPS/1/,NWOPS/1/
#HOL      DATA OPS(1)/'UNTI'/,NOPS/1/,LOPS/1/,NWOPS/1/
C
C--READ THE FIRST OVERALL PARAMETER DEFINITION IF POSSIBLE
      I=KOVPMH(IN)
C--CHECK THE REPLY
      IF(I)1000,1050,1100
C--ERROR DURING THE PROCESSING OF AN OVERALL PARAMETER
1000  CONTINUE
      MF=MF-LK2
      CALL XSFDE(ISTORE(MF+1))
C--ASSIGN THE VALUE AND RETURN
1050  CONTINUE
      KOVPMU=I
      RETURN
C--CHECK IF WE SHOULD FIND THE PARAMETER IN LIST 5
1100  CONTINUE
      IF(L5)1250,1250,1150
C--WE CAN FIND THE PARAMETER IN LIST 5
1150  CONTINUE
      IF(KOVPMF(MQ,M5O,M5A,N5A,L12A))1200,1300,1050
C--THE PARAMETER IS NOT IN LIST 5
1200  CONTINUE
      CALL XPCLNN(LN)
      CALL XMISL5(1,ISTORE(MQ+1),ISTORE(MQ+2))
      I=-1
      GOTO 1050
C--PARAMETER NEED NOT BE FOUND  -  CHECK IF IT DEFINES MORE THAN ONE PAR
1250  CONTINUE
      IF(ISTORE(MQ+2))1050,1050,1300
C--ONE PARAMETER THUS FAR  -  CHECK FOR A SIMPLE PARAMETER
1300  CONTINUE
      IF(ISTORE(MQ+1)-1)1350,1050,1350
C--NOT A SIMPLE PARAMETER  -  LOOK FOR 'UNTIL'
1350  CONTINUE
      IF(ME)1050,1050,1400
C--CHECK THE TYPE OF THE ARGUMENT
1400  CONTINUE
      IF(ISTORE(MF))1450,1050,1050
C--COMPARE THE VARIABLE
1450  CONTINUE
      IF(KCOMP(NWOPS,ISTORE(MF+2),OPS(1),NOPS,LOPS))1050,1050,1500
C--THIS IS AN 'UNTIL' SEQUENCE  -  UPDATE THE CARD POINTERS
1500  CONTINUE
      ME=ME-1
      MF=MF+LK2
C--SET THE POINTERS SO THAT WE CAN READ THE NEXT PARAMETER
      J=MQ
      MQ=I
      I=KOVPMH(IN)
C--CHECK THE REPLY
      IF(I)1000,1000,1550
C--CHECK THAT THE READ SCALE DOES NOT DEFINE A GROUP
1550  CONTINUE
      IF(ISTORE(MQ+2))1600,1600,1700
C--'UNTIL' SEQUENCE ERROR
1600  CONTINUE
      LEF=LEF+1
      MF=MF-LK2
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1650)ISTORE(MF+1)
      ENDIF
      WRITE(NCAWU,1650) ISTORE(MF+1)
1650  FORMAT(/44H Illegal 'UNTIL' sequence for a scale factor,
     2 16H at about column,I5/)
      GOTO 1200
C--CHECK THAT THE PARAMETER READ IS OF THE SAME TYPE AS THE FIRST
1700  CONTINUE
      IF(ISTORE(J+1)-ISTORE(MQ+1))1600,1750,1600
C--CHECK THAT THE ORDER OF THE PARAMETERS IS CORRECT
1750  CONTINUE
      IF(ISTORE(J+2)-ISTORE(MQ+2))1800,1800,1600
C--CHECK IF WE SHOULD SEARCH FOR THIS PARAMETER
1800  CONTINUE
      IF(L5)1950,1950,1850
C--FIND THE PARAMETER
1850  CONTINUE
      IF(KOVPMF(MQ,K,L,M,N))1200,1900,1600
C--COMPUTE THE NUMBER OF PARAMETERS FOUND
1900  CONTINUE
      N5A=K-M5O+1
C--RESET THE LINK ADDRESSES
1950  CONTINUE
      ISTORE(J)=MQ
      MQ=J
      ISTORE(MQ+1)=ISTORE(MQ+1)+1024
      GOTO 1050
      END
C
CODE FOR KOVPMH
      FUNCTION KOVPMH(IN)
C--PROCESS AN OVERALL PARAMETER FROM THE OUTPUT OF THE LEXICAL SCANNER
C
C  IN  A DUMMY ARGUMENT.
C
C--RETURN VALUES ARE :
C
C  -1  ERROR IN PROCESSING AN OVERALL PARAMETER  -  MESSAGE PRINTED.
C   0  NOT AN OVERALL PARAMETER.
C  >0  NEXT FREE LOCATION AFTER THE OVERALL PARAMETER HEADER BLOCK.
C
C--RETURNS WITH 'ME' AND 'MF' SET TO THE NEXT ELEMENT ON THE
C  CARD TO BE PROCESSED, AND CHECKS FOR THE END OF CARD
C  AT THE START OF THE SCAN.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CALL THE FUNCTION TO READ THE PARAMETERS
      KA=KOVPMG(IN)
C--CHECK THE REPLY
      IF(KA)1050,1050,1000
C--CORRECTLY PROCESSED  -  UPDATE THE POINTERS
1000  CONTINUE
      ME=ME-1
      MF=MF+LK2
C--RETURN
1050  CONTINUE
      KOVPMH=KA
      RETURN
      END
C
CODE FOR KOVPMG
      FUNCTION KOVPMG(IN)
C--CHECK THE OUTPUT FROM THE LEXICAL SCANNER FOR AN OVERALL PARAMETER
C
C  IN  A DUMMY ARGUMENT.
C
C--RETURN VALUES OF 'KOVPMG' ARE :
C
C  -1  ERROR IN PROCESSING AN OVERALL PARAMETER  -  MESSAGE PRINTED.
C   0  NOT AN OVERALL PARAMETER.
C  >0  NEXT FREE LOCATION AFTER THE OVERALL PARAMETER HEADER BLOCK.
C
C--THIS ROUTINE SETS UP ONE HEADER BLOCK FOR ONE OVERALL PARAMETER OR
C  SCALE FACTOR, UNLESS THE SCALE FACTOR IS GIVEN AS 'LAYER OR ELEMENT S
C  WHEN TWO HEADER BLOCKS ARE SET UP WITH THE 'UNTIL' BIT SET AND WORD 2
C  AS 'NOWT'.
C
C--THE FORMAT OF THE HEADER BLOCK IS AS FOLLOWS :
C
C  0   ADDR. OF NEXT HEADER BLOCK OR 'NOWT'.
C  1   TYPE OF OVERALL PARAMETER :
C
C      1  OVERALL PARAMETER
C      2  LAYER SCALE
C      3  ELEMENT SCALE
C      4  BATCH SCALE.
C
C      5  CELL PARAMETER
C      6  PROFILE PARAMETER
C      7  ANISOTROPIC EXTINCTION PARAMETER
C      (THIS WORD MAY HAVE 1024 ADDED TO IT FOR AN 'UNTIL' TYPE).
C  2   THE POSITION OF THE PARAMETER IN ITS GROUP (1 TO N)..
C      (IF THIS IS SPECIAL FORM OF SCALE INPUT, TERMINATING WITH 'SCALES
C       THIS WORD WILL BE SET TO 'NOWT' AND 1024 WILL BE ADDED TO WORD
C  3   0.0
C  4   NOT USED
C  5   THE NUMBER OF PARAMETERS ON THE CHAIN GIVEN AT WORD 6.
C  6   ADDRESS OF THE PARAMETER CHAIN REL. TO 'MQ' (STARTS AT WORD 7).
C  7   'NOWT'  LINK TO THE NEXT PARAMETER ON THE CHAIN
C  8   THE POSITION OF THE PARAMETER IN ITS GROUP - AS WORD 2.
C  9   NOT USED
C  10  'NOWT'
C  11  'NOWT'
C  12  'NOWT'
C  13  'NOWT'
C  14  'NOWT'
C  15  'NOWT'
C  16  'NOWT'
C
C--THIS ROUTINE CHECKS FOR END OF CARD, RETURNS WITH 'ME' AND 'MF'
C  POINTING TO THE LAST ARGUMENT PROCESSED.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON/XOPK/NWKO,NKO,LKO,OVP(2,6)
      COMMON/XSCALE/NWSC,NSC,LSC,SCALE(2,8)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK FOR THE START OF THE CARD
      IF(ME)1050,1050,1000
C--CHECK THE TYPE OF THE NEXT ARGUMENT
1000  CONTINUE
      IF(ISTORE(MF))1150,1050,1050
C--THE NEXT ARGUMENT CANNOT BE AN OVERALL PARAMETER
1050  CONTINUE
      KOVPMG=0
1100  CONTINUE
      RETURN
C--CHECK IF THE NEXT ARGUMENT IS A SIMPLE OVERALL PARAMETER
1150  CONTINUE
      KA=1
      KB=KCOMP(LK,ISTORE(MF+2),OVP,NKO,LKO)
C--CHECK THE REPLY
      IF(KB)1200,1200,1300
C----- NOT A SIMPLE PARAMETER - CHECK THE REST
1200  CONTINUE
      KA=KCOMP( LK, ISTORE(MF+2), SCALE(1,3), NSC, LSC)
C--CHECK THE REPLY AGAIN
      IF(KA)1050,1050,1250
C--UPDATE THE TYPE OF PARAMETER POINTER
1250  CONTINUE
      KA=KA+1
C--SET UP THE HEADER BLOCK
1300  CONTINUE
      ISTORE(MQ)=NOWT
C--BLANK OUT THE REST OF THE HEADER
      CALL XFILL(NOWT,ISTORE(MQ),17)
      ISTORE(MQ+1)=KA
      STORE(MQ+3)=0.0
C--SET UP THE RETURN VALUE
      I=MQ+17
C--CHECK IF THIS IS A SIMPLE PARAMETER
      IF(KA-1)1550,1550,1350
C----- NOT SIMPLE
1350  CONTINUE
      KB=NOWT
      ME=ME-1
      MF=MF+LK2
C--CHECK FOR A '(' AFTER THE TYPE OF SCALE
      IF(KOP(6))1400,1600,1450
C--NO MORE ON THE CARD  -  THIS IS AN ERROR
1400  CONTINUE
      LEF=LEF+1
      KOVPMG=-1
      GOTO 1100
C----- NO '(' FOUND - MUST BE 'SCALES' OR 'PARAMETER'
1450  CONTINUE
      IF(KCOMP(LK,ISTORE(MF+2),SCALE(1,1),1,LSC))1460,1460,1500
1460  CONTINUE
C----- 'PARAMETER'
      IF(KCOMP(LK,ISTORE(MF+2),SCALE(1,2),1,LSC))1400,1400,1500
C--IT IS 'SCALES'  -  SET UP A SECOND HEADER BLOCK AND ADD IN 1024 TO WO
1500  CONTINUE
      CALL XMOVE(ISTORE(MQ),ISTORE(I),17)
C--LINK THE TWO HEADERS
      ISTORE(MQ)=I
      ISTORE(MQ+1)=ISTORE(MQ+1)+1024
      I=I+17
C--INSERT THE PARAMETER TYPE AND ITS BLOCK
1550  CONTINUE
      ISTORE(MQ+5)=1
      ISTORE(MQ+6)=7
      ISTORE(MQ+8)=KB
C--SET WORD TWO
      ISTORE(MQ+2)=KB
      KOVPMG=I
      GOTO 1100
C--'(' FOUND SUCCESSFULLY  -  READ THE NUMBER
1600  CONTINUE
      IF(KNUMBR(ZZ))1400,1650,1400
C--FIX THE NUMBER AND CHECK ITS VALUE
1650  CONTINUE
      KB=NINT(ZZ)
      IF(KB)1400,1400,1700
C--CHECK FOR END OF CARD
1700  CONTINUE
      IF(ME)1400,1400,1750
C--CHECK THAT THE NEXT ARGUMENT IS ')'
1750  CONTINUE
      IF(ISTORE(MF)-7)1400,1550,1400
      END
C
CODE FOR KOVPMF
      FUNCTION KOVPMF(IADD,M5OF,M5AF,N5AF,M12F)
C--FIND THE ADDRESS OF AN OVERALL PARAMETER IN LIST 5
C
C  IADD  THE ADDRESS OF THE HEADER BLOCK IN WHICH THE PARAMETER IS DEFIN
C  M5OF  THE NUMBER OF THE PARAMETER WITHIN ITS GROUP (1 TO N).
C  M5AF  ADDRESS OF THE PARAMETER IN LIST 5 (OR ADDRESS OF THE FIRST PAR
C  N5AF  NUMBER OF PARAMETERS FOUND  -  NOT ONE ONLY FOR 'SCALES' SEQUEN
C  M12F  ADDRESS IN LIST 12 OF THE HEADER BLOCK FOR THE RELEVANT GROUP.
C
C--THE RETURN VALUES OF 'KOVPMF' ARE :
C
C  -1  AN ERROR HAS BEEN FOUND.
C   0  ONE OVERALL PARAMETER HAS BEEN LOCATED SUCCESSFULLY.
C  >0  A LAYER OR ELEMENT 'SCALES' SEQUENCE HAS BEEN FOUND, AND THIS
C      RETURN VALUE IS THE ADDRESS OF THE SECOND HEADER BLOCK PROCESSED.
C      IN THIS LATER CASE, INDICATED BY THE 'UNTIL' BIT BEING SET
C      AND WORD 2 BEING 'NOWT', N5AF IS SET TO THE NUMBER OF PARAMETER
C      IN THE GROUP.
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM05(40)
      DIMENSION ICOM12(40)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XOPK/NWKO,NKO,LKO,OVP(2,6)
      COMMON/XSCALE/NWSC,NSC,LSC,SCALE(2,8)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (L5,ICOM05(1))
      EQUIVALENCE (L12,ICOM12(1))
C--SET THE LENGTH OF THE COMMON BLOCK FOR LIST 5
      IDIM05=40
C
C--ASSIGN THE INITIAL RETURN VALUE AND FIND THE TYPE OF PARAMETER
      KOVPMF=0
      I = ISTORE(IADD+1) - (ISTORE(IADD+1)/1024) * 1024
C--ASSIGN THE PARAMETER NUMBER
      M5OF=ISTORE(IADD+2)
C--COMPUTE THE ADDRESS IN LIST 5 AND 12
      K=I*4
      IF (K+12 - IDIM05) 1000, 1000, 1050
1000  CONTINUE
C--FIND THE ADDRESS OF THE PARAMETERS
      M5AF=ICOM05(K+9)
C--FIND THE NUMBER OF PARAMETERS
      J=ICOM05(K+11)
C--FIND THE ADDRESS IN LIST 12
      M12F=ICOM12(K+9)
C--CHECK IF THERE ARE ANY SCALES OF THIS TYPE STORED
      IF(J)1050,1050,1150
C--SET THE ERROR FLAG AND RETURN
1050  CONTINUE
      LEF=LEF+1
      KOVPMF=-1
1100  CONTINUE
      RETURN
C--CHECK IF THIS IS A GROUP OF SCALE FACTORS TERMINATED BY 'SCALES'
1150  CONTINUE
      N5AF=1
      IF(M5OF)1200,1200,1250
C--THIS IS A GROUP  -  SET UP THE PARTS OF THE GROUP
1200  CONTINUE
      M5OF=1
      ISTORE(IADD+2)=1
C--ALTER THE SECOND HEADER BLOCK OF THIS LINKED SEQUENCE
      N5AF=J
      K=ISTORE(IADD)
      ISTORE(K+2)=J
      KOVPMF=J
C--CHECK IF THE SCALE IS IN LIST 5
1250  CONTINUE
      IF(M5OF-J)1300,1300,1050
C--COMPUTE THE FIRST ADDRESS
1300  CONTINUE
      M5AF=M5AF+M5OF-1
      GOTO 1100
      END
C
CODE FOR XMISL5
      SUBROUTINE XMISL5(IADV,ITYPE,IPOINT)
C--SUBROUTINE TO PRINT A MESSAGE ABOUT AN ITEM MISSING FROM LIST 5
C
C  IADV    THE NUMBER OF LINES TO INSERT BEFORE THE MESSAGE.
C  ITYPE   THE TYPE OF MISSING ITEM :
C
C          0  AN ATOM.
C          1  AN OVERALL PARAMETER.
C          2  A LAYER SCALE FACTOR.
C          3  AN ELEMENT SCALE FACTOR.
C          4  A BATCH SCALE FACTOR.
C
C  IPOINT  A POINTER TO THE MISSING ITEM, AS FOLLOWS :
C
C          'ITYPE' = 0, THEN 'IPOINT' IS THE ADDRESS IN 'STORE' OF THE
C                       ATOM NAME AND SERIAL NUMBER.
C          'ITYPE' > 0, THEN 'IPOINT' IS THE PARAMETER NUMBER THAT IS
C                       MISSING. IF 'IPOINT' IS LESS THAN ONE, THEN THE
C                       GROUP INVOLVED IS ASSUMED TO BE MISSING FROM
C          LIST 5.
C
C--THIS ROUTINE FINDS THE REAL TYPE FROM 'ITYPE' BY EXPRESSING THE INPUT
C  VALUE MODULO 1024, TO ALLOW FOR 'UNTIL' SEQUENCES.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XUSLST/LN5,LN6
      COMMON/XOPK/NWKO,NKO,LKO,OVP(2,6)
      COMMON/XSCALE/NWSC,NSC,LSC,SCALE(2,8)
      COMMON/XFIRST/IFIRST(2)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF A ANY LINES SHOULD BE OUTPUT
      IF(IADV)1150,1150,1000
C--OUTPUT SOME BLANK LINES
1000  CONTINUE
      DO 1100 I=1,IADV
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)
      ENDIF
1050  FORMAT(1H )
1100  CONTINUE
C--UPDATE THE ERROR COUNTER
1150  CONTINUE
      LEF=LEF+1
C--COMPUTE THE TRUE TYPE
      JTYPE=ITYPE-ITYPE/1024*1024
C--BRANCH ON THE TYPE OF DATA STORED
      IF(JTYPE-1)1200,1450,1550
C--AN ATOM IS MISSING  -  CHECK IF THE DATA INDICATES 'FIRST' OR 'LAST'
1200  CONTINUE
      IF(KCOMP(1,STORE(IPOINT),IFIRST,2,1))1350,1350,1250
C--SOME FORM OF ILLEGAL 'FIRST' OR 'LAST' DIRECTIVE
1250  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1300)(IFIRST(I),I=1,2)
      ENDIF
      WRITE(NCAWU,1300)(IFIRST(I),I=1,2)
1300  FORMAT(12H Misplaced ',A4,7HT' or ',A4,
     2 33H' directive in an atom definition)
      GOTO 1800
C--A SPECIFIC ATOM IS MISSING FROM LIST 5
1350  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1400)LN5
      ENDIF
      WRITE(NCAWU,1400)LN5
1400  FORMAT(18H Atom not in list ,I5,
     2 41H  or out of order for an 'UNTIL' sequence)
      CALL XPRTCO(2,IPOINT,1)
      GOTO 1800
C--SIMPLE OVERALL PARAMETER NOT IN LIST 5
1450  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1500)LN5,(OVP(J,IPOINT),J=1,NWKO)
      ENDIF
      WRITE(NCAWU,1500)LN5,(OVP(J,IPOINT),J=1,NWKO)
1500  FORMAT(31H Overall parameter not in list ,I5,5X,2H: ,5A4)
      GOTO 1800
C--SOME FORM LAYER, ELEMENT OR BATCH SCALE FACTOR MISSING  -  CHECK FOR
1550  CONTINUE
C----- INCREMENT TO FIRST REAL PARAMETER
      JTYPE = JTYPE +1
      IF(IPOINT)1600,1600,1700
C--THE COMPLETE GROUP IS MISSING
1600  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1650)(SCALE(J,JTYPE),J=1,2),LN5
      ENDIF
      WRITE(NCAWU,1650) (SCALE(J,JTYPE),J=1,2),LN5
1650  FORMAT(4H No ,2A4,15HScales in list ,I5)
      GOTO 1800
C--AN INDIVIDUAL SCALE FACTOR IS MISSING
1700  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1750)(SCALE(J,JTYPE),J=1,2),IPOINT,LN5
      ENDIF
      WRITE(NCAWU,1750) (SCALE(J,JTYPE),J=1,2),IPOINT,LN5
1750  FORMAT(1H ,2A4,20HScale factor number ,I3,17H  is not in list ,
     2 I5)
C--AND NOW RETURN
1800  CONTINUE
      RETURN
      END
C
CODE FOR XPRTCO
      SUBROUTINE XPRTCO(IN,MQ,MT)
C--PRINT THE PARAMETERS SPECIFIED BY 'IN'
C
C  MQ  DETERMINES THE POSITION OF THE ATOM
C  MT  DETERMINES THE PARAMETER POISITION IN COORD
C
C--VALUES OF IN :
C
C  1  PRINT TYPE
C  2  PRINT TYPE AND SERIAL
C  3  PRINT TYPE, SERIAL AND PARAMETER
C  4  PRINT PARAMETER
C
C--
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XAPK/NWKA,NKA,LKA,COORD(2,14)
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--BRANCH ON THE TYPE OF PRINT
      GOTO(1050,1150,1200,1250,1000),IN
1000  CONTINUE
      CALL XERHND ( IERCAT )
1050  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)STORE(MQ)
      ENDIF
      WRITE(NCAWU,1100) STORE(MQ)
1100  FORMAT(/13H Atom type : ,A4,A4,13Hserial no. : ,F6.0,A4,
     2 12HParameter : ,5A4)
      GOTO 1350
1150  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)STORE(MQ),IB,STORE(MQ+1)
      ENDIF
      WRITE(NCAWU,1100) STORE(MQ),IB,STORE(MQ+1)
      GOTO 1350
1200  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)STORE(MQ),IB,STORE(MQ+1),IB,(COORD(I,MT),I=1,
     2 NWKA)
      ENDIF
      WRITE(NCAWU,1100) STORE(MQ),IB,STORE(MQ+1),IB,
     2 (COORD(I,MT),I=1,NWKA)
      GOTO 1350
1250  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1300)(COORD(I,MT),I=1,NWKA)
      ENDIF
      WRITE(NCAWU,1300) (COORD(I,MT),I=1,NWKA)
1300  FORMAT(/20H Atomic parameter : ,5A4)
C
1350  CONTINUE
      RETURN
      END
C
CODE FOR XPRTOP
      SUBROUTINE XPRTOP(IN)
C--PRINT THE OVERALL PARAMETER DEFINED BY IN
C
C--
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XOPK/NWKO,NKO,LKO,OVP(2,6)
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)(OVP(I,IN),I=1,NWKO)
      ENDIF
      WRITE(NCAWU,1000) (OVP(I,IN),I=1,NWKO)
1000  FORMAT(/21H Overall parameter : ,5A4)
      RETURN
      END
C
CODE FOR KFDARG
      FUNCTION KFDARG(IN)
C--CHECK THAT THERE ARE SOME ARGUMENTS ON THE CURRENT CARD PRODUCED
C  BY THE LEXICAL SCANNER.
C
C  IN  DUMMY ARGUMENT.
C
C--THE RETURN VALUES ARE :
C
C  -1  NO ARGUMENTS ON THE CARD  -  ERROR MESSAGE PRINTED.
C  >0  OKAY.
C
C--
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
C
      KFDARG=1
C--CHECK FOR SOME ARGUMENTS
      IF(ME)1000,1000,1100
C--NO ARGUMENTS FOUND
1000  CONTINUE
      KFDARG=-1
      CALL XPCLNN(LN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)
      ENDIF
      WRITE(NCAWU,1050)
1050  FORMAT(/19H No arguments found)
      LEF=LEF+1
1100  CONTINUE
      RETURN
      END
C
CODE FOR KFDNUM
      FUNCTION KFDNUM(ZZ)
C--CHECK THE CURRENT POSITION OF THE LEXICAL SCANNER OUTPUT FOR
C  A NUMBER, AND REPORT AN ERROR IF THERE IS NOT ONE.
C
C  ZZ  THE NUMBER THAT HAS BEEN FOUND.
C
C--RETURN VALUES ARE :
C
C  -1  NOT A NUMBER  -  ERROR MESSAGE PRINTED.
C  >0  NUMBER FOUND AND PLACED IN 'ZZ'.
C
C--FOR A SUCCESSFUL RETURN, 'ME' AND 'MF' WILL HAVE BEEN UPDATED. AT THE
C  START THEY ARE CHECKED FOR END OF CARD.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      KFDNUM=-1
C--CHECK FOR END OF CARD
      IF(ME)1000,1000,1050
C--END OF CARD FOUND
1000  CONTINUE
      MF=MF-LK2
      CALL XILARG(ISTORE(MF+1))
      GOTO 1250
C--CHECK THE TYPE OF THE NEXT ARGUMENT(S)
1050  CONTINUE
      IF(KSYNUM(ZZ))1100,1200,1150
C--ILLEGAL VARIABLE
1100  CONTINUE
      CALL XILOPD(ISTORE(MF+1))
      GOTO 1250
C--ILLEGAL OPERATOR
1150  CONTINUE
      CALL XILOP(ISTORE(MF+1))
      GOTO 1250
C--NUMBER FOUND OKAY
1200  CONTINUE
      ME=ME-1
      MF=MF+LK2
      KFDNUM=1
1250  CONTINUE
      RETURN
      END
C
CODE FOR KFDOPD
      FUNCTION KFDOPD(NCIARG,NWIARG,IARG,NIARG,LIARG)
C--CHECK THE CURRENT POSITION OF THE LEXICAL SCANNER OUTPUT FOR A
C  VARIABLE AND REPORT AN ERROR IF ONE IS NOT FOUND. IF ONE
C  IS FOUND AND 'NCIARG' IS GREATER THAN ZERO, IT IS COMPARED WITH
C  THE ARGUMENTS IN 'IARG' AND AN ERROR REPORTED IF NO MATCH IS MADE.
C
C  NCIARG  POSITIVE IF VARIABLE COMPARISON IS REQUIRED, ELSE
C          LESS THAN OR EQUAL TO ZERO.
C  NWIARG  NUMBERS OF WORDS PER ARGUMENT IN 'IARG'.
C  IARG    LIST OF ARGUMENTS TO BE CHECKED FOR.
C  NIARG   NUMBER OF ARGUMENTS TO CHECK FOR.
C  LIARG   NUMBER OF WORDS BETWEEN SUCCESSIVE ARGUMENTS IN 'IARG'.
C
C--THE RETURN VALUES ARE :
C
C  -1  A VARIABLE HAS NOT BEEN FOUND  -  ERROR MESSAGE PRINTED.
C      (ALTERNATIVELY, IF 'NCIARG' IS GREATER THAN ZERO, NO MATCH HAS
C       BEEN FOUND).
C  >0  A VARIABLE HAS BEEN FOUND. IF 'NIARG' IS GREATER THAN ZERO,
C      THE RETURN VALUE INDICATES THE POSITION OF THE ARGUMENT THAT
C      HAS BEEN FOUND, AND 'ME' AND 'MF' WILL BE UPDATED IN THIS
C      CASE.
C
C--
C
      DIMENSION IARG(LIARG,NIARG)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      KFDOPD=-1
C--CHECK FOR END OF CARD
      IF(ME)1000,1000,1100
C--END OF CARD FOUND
1000  CONTINUE
      MF=MF-LK2
1050  CONTINUE
      KFDOPD=-1
      CALL XILARG(ISTORE(MF+1))
      GOTO 1400
C--CHECK THE TYPE OF THE NEXT ARGUMENT(S)
1100  CONTINUE
      IF(ISTORE(MF))1250,1150,1200
C--ILLEGAL NUMBER
1150  CONTINUE
      CALL XILNUM(ISTORE(MF+1))
      GOTO 1400
C--ILLEGAL OPERATOR
1200  CONTINUE
      CALL XILOP(ISTORE(MF+1))
      GOTO 1400
C--VARIABLE FOUND OKAY
1250  CONTINUE
      KFDOPD=1
C--CHECK IF THERE ARE ANY ARGUMENTS
      IF(NCIARG)1400,1400,1300
C--COMPARE THE ARGUMENTS
1300  CONTINUE
      I=KCOMP(NWIARG,ISTORE(MF+2),IARG,NIARG,LIARG)
      IF(I)1050,1050,1350
C--UPDATE AND RETURN
1350  CONTINUE
      ME=ME-1
      MF=MF+LK2
      KFDOPD=I
1400  CONTINUE
      RETURN
      END
C
CODE FOR KNUMBR
      FUNCTION KNUMBR(ARG)
C--READ THE OUTPUT FROM THE LEXICAL SCANNER, AND CHECK IF
C  THE NEXT ARGUMENTS INDICATE A NUMBER.
C  IF A NUMBER IS FOUND, IT IS PUT INTO 'ARG' ON RETURN.
C
C--RETURNS WITH 'ME' AND 'MF' SET TO THE NEXT ELEMENT ON THE
C  CARD TO BE PROCESSED, AND CHECKS FOR THE END OF CARD
C  AT THE START OF THE PROCESSING.
C
C--RETURN VALUES ARE :
C
C  -1  END OF CARD DETECTED.
C   0  NUMBER FOUND CORRECTLY
C  >0  NOT A NUMBER IN THIS POSITION.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK FOR THE END OF THE CARD
      IF(ME)1100,1100,1000
C--CALL THE NUMBER FINDING FUNCTION
1000  CONTINUE
      IF(KSYNUM(ARG))1050,1150,1050
C--A NUMBER IS NOT THERE
1050  CONTINUE
      KNUMBR=1
      GOTO 1200
C--END OF CARD FOUND
1100  CONTINUE
      KNUMBR=-1
      GOTO 1200
C--NUMBER READ CORRECTLY  -  UPDATE ME AND MF
1150  CONTINUE
      ME=ME-1
      MF=MF+LK2
      KNUMBR=0
1200  CONTINUE
      RETURN
      END
C
CODE FOR KSYNUM
      FUNCTION KSYNUM(ARG)
C--READ THE OUTPUT FROM THE LEXICAL SCANNER, AND CHECK IF
C  THE NEXT ARGUMENTS INDICATE A NUMBER.
C  IF A NUMBER IS FOUND, IT IS PUT INTO 'ARG' ON RETURN.
C
C--RETURNS WITH 'ME' AND 'MF' SET TO THE LAST ELEMENT ON THE
C  CARD PROCESSED, NOT THE NEXT ELEMENT TO BE PROCESSED.
C  THIS IS SO THAT DIAGNOSTICS CAN BE ACCURATELY POSITIONED.
C
C--DOES NOT CHECK FOR END OF CARD AT THE START
C
C--RETURN VALUES ARE :
C
C  <0  OPERAND FOUND INSTEAD OF A NUMBER
C   0  NUMBER FOUND CORRECTLY
C  >0  OPERATOR FOUND
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      T=1.
      KSYNUM=0
C--CHECK THE TYPE OF THE NEXT ARGUMENT
      IF(ISTORE(MF))1100,1000,1150
C--APPLY THE SIGN AND RETURN
1000  CONTINUE
      ARG=STORE(MF+2)*T
1050  CONTINUE
      RETURN
1100  CONTINUE
      KSYNUM=-1
      GOTO 1050
1150  CONTINUE
C--FIRST ARGUMENT IS AN OPERATOR  -  CHECK FOR A '+' OR A '-'
      IF(ISTORE(MF)-2)1300,1250,1200
C--THE OPERATOR IS NOT PART OF A NUMBER
1200  CONTINUE
      KSYNUM=ISTORE(MF)
      GOTO 1050
C--'-' FOUND  -  ALTER THE SIGN WORD
1250  CONTINUE
      T=-T
C--UPDATE AND CHECK FOR END OF CARD
1300  CONTINUE
      MF=MF+LK2
      ME=ME-1
      IF(ME)1350,1350,1400
C--END OF CARD  -  NOT A NUMBER BUT ONLY AN OPERATOR
1350  CONTINUE
      ME=ME+1
      MF=MF-LK2
      GOTO 1200
C--CHECK ON THE TYPE OF THE NEXT ARGUMENT
1400  CONTINUE
      IF(ISTORE(MF))1350,1000,1350
      END
C
CODE FOR KNPAR
      FUNCTION KNPAR(IN)
C--CHECK THAT THE CURRENT ATOM HEADER AT 'MQ' HAS ONLY 'IN' PARAMETERS
C  ASSOCIATED WITH IT.
C
C  IN  THE NUMBER OF PARAMETERS ALLOWED.
C
C--THE RETURN VALUES ARE :
C
C  -1  NUMBER OF PARAMETERS IS WRONG  -  ERROR MESSAGE PRINTED.
C  >0  OKAY.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      KNPAR=1
C--CHECK THE NUMBER OF PARAMETERS
      IF(ISTORE(MQ+5)-IN)1000,1100,1000
C--THE NUMBER OF PARAMETERS IS WRONG
1000  CONTINUE
      KNPAR=-1
      MF=MF-LK2
      CALL XPCLNN(LN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)ISTORE(MF+1)
      ENDIF
      WRITE(NCAWU,1050) ISTORE(MF+1)
1050  FORMAT(/44H Incorrect number of atomic parameters given,
     2 16H at about column,I5)
      LEF=LEF+1
1100  CONTINUE
      RETURN
      END
C
CODE FOR KOP
      FUNCTION KOP(IN)
C--CHECK IF THE NEXT OPERATOR IS 'IN'
C
C--RETURN VALUES ARE :
C  -1  END OF CARD
C   0  YES
C   1  NO
C
C--CHECKS FOR END OF CARD IMAGE AT THE START
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      IF(ME)1000,1000,1100
1000  CONTINUE
      KOP=-1
1050  CONTINUE
      RETURN
1100  CONTINUE
      IF(ISTORE(MF)-IN)1150,1200,1150
1150  CONTINUE
      KOP=1
      GOTO 1050
1200  CONTINUE
      ME=ME-1
      MF=MF+LK2
      KOP=0
      GOTO 1050
      END
C
CODE FOR XSFDE
      SUBROUTINE XSFDE(IN)
C--SCALE FACTOR DEFINITION ERROR AT COLUMN 'IN'
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      CALL XPCLNN(LN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)IN
      ENDIF
      WRITE(NCAWU,1000) IN
1000  FORMAT(/33H Error in scale factor definition,16H at about column,
     2 I5)
      LEF=LEF+1
      RETURN
      END
C
CODE FOR XADE
      SUBROUTINE XADE(IN)
C--ATOM DEFINITION ERROR AT COLUMN 'IN'
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      CALL XPCLNN(LN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)IN
      ENDIF
      WRITE(NCAWU,1000)IN
1000  FORMAT(/41H Error in atom definition at about column,I5)
      LEF=LEF+1
      RETURN
      END
C
CODE FOR XCSO
      SUBROUTINE XCSO(IN)
C--COMPILER STACK OVERFLOW
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      CALL XPCLNN(LN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)IN
      ENDIF
      WRITE(NCAWU,1000)IN
1000  FORMAT(/44H Compiler requires more core at about column,I5)
      LEF=LEF+1
      RETURN
      END
C
C
CODE FOR XPCA
      SUBROUTINE XPCA(IN)
C--PROCESSING OF THE LAST CARD ABANDONED.
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      CALL XPCLNN(LN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)
      ENDIF
      WRITE(NCAWU,1000)
1000  FORMAT(/48H Processing of the card above has been abandoned)
      LEF=LEF+1
      RETURN
      END
C
CODE FOR XILNUM
      SUBROUTINE XILNUM(IN)
C--ERROR BECAUSE OF AN ILLEGAL NUMBER AT COLUMN IN
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      CALL XPCLNN(LN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)IN
      ENDIF
      WRITE(NCAWU,1000) IN
1000  FORMAT(/31H Illegal number at about column,I5)
      LEF=LEF+1
      RETURN
      END
C
CODE FOR XILOP
      SUBROUTINE XILOP(IN)
C--ERROR BECAUSE OF AN ILLEGAL OPERATOR AC COLUMN IN
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      CALL XPCLNN(LN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)IN
      ENDIF
      WRITE(NCAWU,1000) IN
1000  FORMAT(/33H Illegal operator at about column,I5)
      LEF=LEF+1
      RETURN
      END
C
CODE FOR XILOPD
      SUBROUTINE XILOPD(IN)
C--ERROR DURING THE PROCESSING OF THE LEXICAL SCANNER OUTPUT BECAUSE
C  THE LAST ARGUMENT WAS AN ILLEGAL OPERAND.
C
C  IN  COLUMN WHERE THE ERROR OCCURRED.
C
C--
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      CALL XPCLNN(LN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)IN
      ENDIF
      WRITE(NCAWU,1000) IN
1000  FORMAT(/44H Illegal operand or variable at about column,I5)
      LEF=LEF+1
      RETURN
      END
C
CODE FOR XILARG
      SUBROUTINE XILARG(IN)
C--ERROR DURING THE PROCESSING OF THE LEXICAL SCANNER OUTPUT BECAUSE
C  THE PARAMETER FOUND IS OF THE WRONG TYPE.
C
C  IN  COLUMN WHERE THE ERROR OCCURRED.
C
C--
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      CALL XPCLNN(LN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)IN
      ENDIF
      WRITE(NCAWU,1000) IN
1000  FORMAT(/37H An argument is incorrect or has been,
     2 32H omitted at or just after column,I5)
      LEF=LEF+1
      RETURN
      END
C
CODE FOR XMISOP
      SUBROUTINE XMISOP(OP,IN)
C--OPERATOR 'OP' IS MISSING AT COLUMN 'IN'
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      CALL XPCLNN(LN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)OP,IN
      ENDIF
      WRITE(NCAWU,1000) OP,IN
1000  FORMAT(/11H Operator ',A1,27H' not found at about column,I5)
      LEF=LEF+1
      RETURN
      END
C
CODE FOR XPCLNN
      SUBROUTINE XPCLNN(IN)
C--PRINT LIST 'IN'  -  THIS SUBROUTINE PRINTS UP TO AND INCLUDING THE
C  PRESENT CARD
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION IBUFF(8) , JBUFF(8)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF THIS CARD IMAGE HAS ALREADY BEEN PRINTED
      IF(MA-LARG)1000,1350,1000
C--CHECK IF IT IS NECESSARY TO PRINT THE HEADING
1000  CONTINUE
      IF(MB)1050,1050,1150
C--PRINT THE INITIAL HEADING
1050  CONTINUE
      CALL XPRTCN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)IN
      ENDIF
      WRITE(NCAWU,1100) IN
1100  FORMAT(21H Print symbolic list ,I5//)
C--LOAD THE NEXT DATA RECORD HEADER
1150  CONTINUE
      IF(KLDDRH(MB,MA,IBUFF))1350,1200,1200
C--CHECK IF THIS RECORD SHOULD BE PRINTED
1200  CONTINUE
      IF(IBUFF(7))1250,1300,1300
C--PRINT THE RECORD
1250  CONTINUE
      CALL XPRTLC(MC,IBUFF(4),IBUFF(5),IBUFF(6))
      MC=MC+1
C--CHECK FR END OF THE PRINT
1300  CONTINUE
      IF(LARG-MA)1150,1350,1150
C--AND NOW EXIT
1350  CONTINUE
      RETURN
      END
C
C
C --
C
CODE FOR XLXRDV
      FUNCTION XLXRDV(DEFVAL)
C -- RETURNS THE NEXT NUMBER IN THE LEXICAL SCANNER OUTPUT
C    IF THE NEXT ITEM IS NOT A NUMBER THEN ERROR.(CALLS XERHND)
C    IF END OF CARD THEN RETURN VALUE IS DEFVAL
C --
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C --
      VALUE=DEFVAL
      IF (KOP(8)) 3000,9500,2000
2000  CONTINUE
      IF (KFDNUM(VALUE)) 9500,3000,3000
3000  CONTINUE
      XLXRDV=VALUE
      RETURN
9500  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,9510)
      ENDIF
      WRITE (NCAWU,9510)
9510  FORMAT ( 32H The item given is not a number  )
      CALL XERHND(4)
      RETURN
      END
C
C --
C
CODE FOR XLXRVN
      FUNCTION XLXRVN(DUMMY)
C -- READS A VALUE FROM THE LEXICAL SCANNER OUTPUT WHICH HAS NO
C    DEFAULT. THE ONLY POSSIBLE RESULT NOT AVAILIBLE IS -98765.
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C --
C -- READ A VALUE
      VALUE=XLXRDV(-98765.)
      IF (ABS(VALUE+98765.) .LT. 0.0001) GO TO 9500
      XLXRVN=VALUE
      RETURN
9500  CONTINUE
C -- ERROR NO VALUE HAS BEEN GIVEN
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,9510)
      ENDIF
      WRITE (NCAWU,9510)
9510  FORMAT ( 45H No default value is availible for parameter  )
      CALL XERHND(4)
      RETURN
      END
C
C --
C
CODE FOR XLXRDA
      SUBROUTINE XLXRDA(VALUE,NVALUE,DEFVAL)
C -- READS AN ARRAY OF VALUES FROM THE LEXICAL SCANNER OUTPUT.ANY VALUES
C    REMAINING UNFILLED AT THE END OF THE CARD AND GIVEN THE VALUE DEFVA
C --
      DIMENSION VALUE(NVALUE)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C --
      DO 3000 I=1,NVALUE
      VALUE(I)=DEFVAL
      IF (KOP(8)) 3000,9500,2000
2000  CONTINUE
      IF ( KFDNUM(VALUE(I)) .LT. 0 ) GO TO 9500
3000  CONTINUE
      RETURN
9500  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,9510)
      ENDIF
      WRITE (NCAWU,9510)
9510  FORMAT ( 32H The item given is not a number  )
      CALL XERHND(4)
      RETURN
      END



CRYSTALS CODE FOR LIST50
CODE FOR XRDHI
      SUBROUTINE XRDHI(IFIRST)
C--THIS ROUTINE READS A CARD FILE CONTAINING A SPECIFICATION OF EACH
C  '#' INSTRUCTION AND ITS ASSOCIATED DIRECTIVES AND PARAMETERS, AND
C  OUTPUTS THE RESULTS IN AN INTERNAL FORMAT TO THE DISC AS A LIST 50.
C  WITHIN THIS LIST, SEVERAL TYPES OF DATA RECORD ARE USED :
C
C  IFIRST  THE NUMBER OF THE FIRST COMMAND ADDED IN THIS RUN. THIS IS 1
C          FOR A COMPLETELY NEW FILE AND THE NUMBER OF THE FIRST NEW
C          COMMAND FOR AN APPEND.
C
C  50  RECORD TYPE 50 CONTAINS THE NAMES OF THE INSTRUCTIONS, EACH ONE
C      FOLLOWING DIRECTLY AFTER THE ONE BEFORE IT. THE FORMAT IS
C      ONE CHARACTER PER WORD, AND MAY BE REPRESENTED AS :
C
C          0  THE NUMBER OF CHARACTERS IN THE COMPLETE NAME.
C      1  NAME 1, WORD 1.
C      2  NAME 1, WORD 2.
C
C -51  RECORD TYPE 51 CONTAINS A SET OF DISC POINTERS TO
C      RECORDS 60, 61, 62, 63 AND 64 FOR EACH INSTRUCTION. THE
C      FORMAT OF EACH ENTRY IS AS FOLLOWS :
C
C      0  DISC ADDRESS OF THE RECORD HEADER PRECEDING RECORD 60.
C      1  DISC ADDRESS OF THE RECORD HEADER FOR RECORD TYPE 60.
C      3  DISC ADDRESS OF THE RECORD HEADER PRECEDING RECORD 61.
C
C      THIS FORMAT IS REPEATED FOR EACH RECORD TYPE FOR A INSTRUCTION,
C      AND THEN FOR EACH INSTRUCTION. THIS RECORD IS USED TO RAPIDLY
C      ACCESS DATA FOR A GIVEN INSTRUCTION.
C
C  52  THIS RECORD IS PRESENT ONCE IN THE LIST, AND CONTAINS THE
C      NECESSARY INSTRUCTIONS TO GENERATE LISTS INTERNALLY. THESE
C      INSTRUCTIONS CONTAIN THEIR '#' DELIMITERS, AND STORED IN
C      THE FOLLOWING FORMAT :
C
C      0  THE LIST TYPE NUMBER TO BE GENERATED.
C      1  THE FIRST WORD OF THE COMMAND  -  FORMAT 19A4.
C      2  THE SECOND WORD OF THE COMMAND.
C
C  60  EACH TYPE 60 RECORD CONTAINS THE NAMES OF THE DIRECTIVES
C      THAT ARE AVAILABLE WITH ONE '#' INSTRUCTION, IN THE SAME FORMAT
C      AS A TYPE 50 RECORD. EACH INSTRUCTION CAN HAVE A TYPE 60 RECORD.
C
C  61  EACH TYPE 61 RECORD CONTAINS THE DETAILS FOR THE DIRECTIVES
C      ASSOCIATED WITH ONE '#' INSTRUCTION. THE DETAILS IN A TYPE 61
C      RECORD ARE USED TO ACCESS THE PARAMETER DETAILS WHICH ARE
C      STORED IN A TYPE 62 RECORD. THE DATA IN TYPE 61 RECORDS IS
C      ARRANGED SERIALLY, AND THE ENTRY FOR EACH DIRECTIVE IS AS
C      FOLLOWS :
C
C       0  RELATIVE ADDRESS OF THE DETAILS OF THE PARAMETERS FOR THIS
C          DIRECTIVE.
C       1  NUMBER OF WORDS PER PARAMETER NAME.
C       2  NUMBER OF WORDS REQUIRED FOR THE COMPLETE PARAMETER ENTRY.
C       3  NUMBER OF PARAMETERS FOR THIS DIRECTIVE.
C       4  RELATIVE ADDRESS OF THE DIRECTIVES EXCLUDED FROM INPUT WHEN
C          THIS DIRECTIVE HAS BEEN FOUND.
C       5  NUMBER OF WORDS PER EXCLUDED DIRECTIVE.
C       6  NUMBER OF EXCLUDED DIRECTIVES.
C          THIS VALUE IS SET NEGATIVE WHEN THIS DIRECTIVE HAS BEEN
C          EXCLUDED. THE ABSOLUTE VALUE GIVES THE DIRECTIVE THAT HAS
C          EXCLUDED IT.
C       7  NUMBER OF TIMES THIS DIRECTIVE MAY APPEAR.
C          THIS VALUE IS SET FROM THE GROUP REPEAT COUNT FOR
C          DIRECTIVES THAT DEFINE DATA RECORDS.
C       8  NUMBER OF TIMES THIS DIRECTIVE HAS APPEARED.
C          DURING PROCESSING THIS LOCATION MAY BE SET AS FOLLOWS :
C
C          NEGATIVE  THIS DIRECTIVE HAS ALREADY GENERATED ERRORS.
C          OTHER     THE NUMBER OF TIMES THE DIRECTIVE HAS APPEARED.
C
C       9  THE NUMBER OF WORDS PER GROUP FOR THE RECORD DEFINED BY
C          THIS DIRECTIVE, IF THERE IS ONE.
C      10  THE NUMBER OF GROUPS FOR THE RECORD DEFINED BY THIS DIRECTIVE
C          IF THERE IS ONE.
C      11  THE RECORD TYPE DEFINED BY THIS DIRECTIVE.
C      12  THE COMMON BLOCK OFFSET FOR THE RECORD DEFINED BY THIS DIRECT
C      13  THE LIST TYPE FOR THE RECORD TO BE CREATED.
C      14  THE NUMBER OF WORDS OCCUPIED BY THE TITLE OF THIS RECORD.
C      15  THE NUMBER OF TIMES THE TITLE SHOULD BE PRINTED PER LINE.
C      16  THE RELATIVE ADDRESS IN RECORD TYPE 62 OF THE TITLE.
C      17  THE NUMBER OF WORDS OCCUPIED BY THE PRINT FORMAT FOR THE
C          PARAMETER KEYWORDS FOR THIS RECORD.
C      18  THE NUMBER OF TIMES THE PARAMETER KEYWORDS ARE TO BE PRINTED
C          PER LINE.
C      19  THE RELATIVE ADDRESS IN RECORD TYPE 62 OF THE PRINT FORMAT
C          FOR THE KEYWORDS FOR THIS RECORD.
C      20  THE NUMBER OF WORDS OCCUPIED BY THE PRINT FORMAT FOR THE
C          ELEMENTS OF THIS RECORD.
C      21  THE NUMBER OF GROUPS TO BE PRINTED PER LINE.
C      22  THE RELATIVE ADDRESS IN RECORD TYPE 62 OF THE PRINT FORMAT
C          FOR THE ELEMENTS IN THIS RECORD.
C      23  THE NUMBER OF WORDS OCCUPIED BY THE PUNCH FORMAT FOR THE
C          PARAMETER KEYWORDS FOR THIS RECORD.
C      24  THE NUMBER OF TIMES THE PARAMETER KEYWORDS ARE TO BE PUNCHED
C          PER LINE.
C      25  THE RELATIVE ADDRESS IN RECORD TYPE 62 OF THE PUNCH FORMAT
C          FOR THE KEYWORDS FOR THIS RECORD.
C      26  THE NUMBER OF WORDS OCCUPIED BY THE PUNCH FORMAT FOR THE
C          ELEMENTS OF THIS RECORD.
C      27  THE NUMBER OF GROUPS TO BE PUNCHED PER LINE.
C      28  THE RELATIVE ADDRESS IN RECORD TYPE 62 OF THE PUNCH FORMAT
C          FOR THE ELEMENTS IN THIS RECORD.
C      29  THE RELATIVE ADDRESS OF THE ENABLING DATA FOR THIS
C          DIRECTIVE.
C      30  THE NUMBER OF WORDS PER ENABLING DIRECTIVE.
C      31  THE NUMBER OF ENABLING DIRECTIVES.
C
C      THE BLOCK ABOVE IS REPEATED FOR EACH DIRECTIVE FOR THE CURRENT
C      '#' INSTRUCTION, AND ALL THE ADDRESSES ARE RELATIVE TO THE START
C      OF THE DATA STORED IN RECORD TYPE 62.
C
C  62  ASSOCIATED WITH EACH TYPE 61 RECORD IS A TYPE 62 RECORD, WHICH
C      CONTAINS DETAILS OF THE PARAMETERS FOR EACH DIRECTIVE. EACH
C      DIRECTIVE HAS A POINTER IN RECORD TYPE 61 INDICATING THE START
C      OF ITS PARAMETERS, WHICH ARE STORED SERIALLY AND
C      FORM THE FIRST PART OF THIS RECORD. THE REST OF THE
C      RECORD IS TAKEN WITH FURTHER DATA ADDRESSED VIA THE PARAMETER
C      INFORMATION. THE FORMAT OF AN ENTRY FOR A PARAMETER STARTS
C      WITH THE PARAMETER NAME AS FOLLOWS :
C
C      0  NAME 1, WORD 1.
C      1  NAME 1, WORD 2.
C
C      AFTER THE NAME, THE REST OF THE PARAMETER INFORMATION IS STORED,
C      ATTHE OFFSET GIVEN IN WORD 2 ABOVE, RELATIVE TO THE START OF THE
C      CURRENT PARAMETER. THE NUMBER OF WORDS OF ADDITIONAL DATA
C      IS GIVEN BY WORD 2 MINUS WORD 1 ABOVE.
C      THE FORMAT OF THE REST OF THE DATA FOR EACH PARAMETER IS :
C
C       0  PARAMETER TYPE ON INPUT :
C
C          +1  FIXED POINT NUMBER.
C          +2  FLOATING POINT NUMBER.
C          +3  CHARACTER STRING.
C          +4  STRING TO BE INTERPRETED BY THE CALLING ROUTINE.
C            +5  LONG CHARACTER STRING STORED AS BYTES
C
C       1  RELATIVE ADDRESS OF THE PERMITTED VALUES FOR THIS PARAMETER
C          ON INPUT.
C       2  NUMBER OF WORDS PER PERMISSABLE VALUE.
C       3  NUMBER OF PERMISSABLE VALUES.
C       4  COMMON BLOCK OFFSET FOR THIS PARAMETER.
C       5  TYPE OF ARGUMENT TO BE STORED IN THE COMMON BLOCK. IF THE
C          NUMBER OF PERMISSABLE VALUES IS ZERO, WORD 5 IS SET EQUAL
C          TO WORD 0. IF PERMISSABLE VALUES ARE ALLOWED, WORD 5 IS SET T
C          1, INDICATING AN INTEGER WHICH CAN GIVE THE POSITION OF THE
C          FOUND PERMISSABLE VALUE.
C          NUMBER OF PERMISSABLE VALUES IS ZERO, WORD 5 MUST EQUAL WORD
C          0. IF THE NUMBER OF PERMISSABLE VALUES IS NOT ZERO, THE
C          VALUE FOUND MAY BE STORED (WORD 0 EQUALS WORD 5), OR
C          ANOTHER TYPE OF ARGUMENT MAY BE STORED. THE MOST COMMON
C          EXAMPLE OF THIS IS TO STORE AN INTEGER TO INDICATE THE
C          POSITION OF THE PERMISSABLE VALUE FOUND ON INPUT.
C          IN THIS CASE, WORD 0 WOULD BE 3 AND WORD 5 WOULD BE 1.
C       6  VALUE TO BE ASSIGNED IF THE FIRST PERMISSABLE VALUE
C          IS FOUND. THIS IS AN INTEGER, AND SUCCESSIVE PERMISSABLE
C          VALUES ARE INCREMENTED ACCORDINGLY FROM THIS VALUE.
C       7  DEFAULT INDICATOR :
C
C          -1  NO DEFAULT AVAILABLE.
C           0  DEFAULT VALUE STORED.
C
C       8  DEFAULT VALUE, TYPE GIVEN BY WORD 5.
C       9  NUMBER OF TIMES THIS PARAMETER MAY OCCUR.
C      10  THE NUMBER OF TIMES THIS PARAMETER HAS BEEN INPUT.
C
C      THE REST OF THE TYPE 62 RECORD IS DATA POINTED TO BY THE FIRST
C      PART OF THE RECORD.
C
C  63  THIS RECORD CONTAINS A LIST OF THE LISTS THAT THE '#' INSTRUCTION
C      REQUIRES. THE LISTS ARE STORED BY NUMBER, ONE AFTER THE OTHER.
C
C  64  THIS RECORD CONTAINS THE LOAD DETAILS, WHICH ARE SPECIFIC TO
C      EACH MACHINE. ON THE ICL 1906A, THE FORMAT IS :
C
C      0  THE INSTRUCTION NUMBER FOR THE GIVEN PROGRAM.
C      1  MINIMUM CORE SIZE REQUIRED.
C      2  WORD 1 OF THE FILE NAME TO 'CONT'.
C      3  WORD 2.
C
C--RECORD TYPE 50 IS STORED AS ABOVE, BUT AS EACH INSTRUCTION
C  REQUIRES A RECORD OF TYPE 60, 61, 62, 63 AND 64, THESE ARE STORED
C  WITH RECORD NUMBERS OF -(10000*N + M). 'N' IS THE NUMBER OF THE
C  CURRENT INSTRUCTION IN THE INPUT STREAM, AND M IS THE 60 VALUE.
C  THIS MEANS THAT ONLY RECORD 50 IS LOADED IMMEDIATELY, BUT THAT
C  POINTERS ARE SET UP TO THE REST.
C
C
C
C --            THE FORMAT OF THE INPUT FILE
C               --- ------ -- --- ----- ----
C
C    1   NEW FILE/APPEND FLAG
C            A SPACE IN COLUMN ONE OF THE FIRST CARD INDICATES A NEW
C        FILE. OTHERWISE AN EXISTING LIST 50 IS EXTENDED - IF AN
C        INSTRUCTION IS SPECIFIED IN THE INPUT FILE WHICH IS ALREADY
C        DEFINED IN THE LIST 50, THE OLD DEFINITION IS REPLACED BY THE
C        NEW ONE.
C
C            THE FIRST RECORD OF THE INPUT FOR A NEW COMMAND FILE IS
C        USED AS A TITLE FOR THAT FILE.
C
C
C
C    2   LIST CREATION INSTRUCTIONS
C            THESE GIVE THE INSTRUCTIONS USED TO CREATE CERTAIN LISTS.
C        THE INPUT FILE SHOULD CONTAIN THE FOLLOWING :-
C
C       A     1 RECORD ( FORMAT : I3 ) SPECIFING THE NUMBER OF DEFINITIO
C                                     RECORDS FOLLOWING ( = NR52 )
C
C       B     NR52 RECORDS ( FORMAT : I3,1X,19A4 ) SPECIFYING THE LIST
C                                     NUMBER AND THE INSTRUCTION WHICH
C                                     GENERATES IT.
C
C
C
C    3    #INSTRUCTION DEFINITIONS
C             THESE DEFINE THE #INSTRUCTIONS AVAILABLE.
C
C       A    1 RECORD ( FORMAT : 12A1 , 3X , 3I5 )
C            12A1 : INSTRUCTION NAME
C            I5   : NUMBER OF DIRECTIVES FOR THIS INSTRUCTION ( = NR60 )
C            I5   : NUMBER OF LISTS REQUIRED ( = NR63 )
C            I5   : NUMBER OF 'LOAD DETAIL' RECORDS ( = NR64 )
C
C       B    NR64 RECORDS ( FORMAT : I4 , I8 , 68A1 )
C            I4   : JUMP NUMBER - RETURNED BY 'KNXTOP' FOR THIS
C                   #INSTRUCTION
C            I8   : CORE SIZE REQUIRED
C            68A1 : NAME OF PROGRAM WHICH EXECUTES THIS #INSTRUCTION
C
C
C
C       C    1 RECORD ( FORMAT : 20I5 ) -- IF NR60 IS GREATER THAN ZERO
C            I5   : LIST NUMBERS TO BE USED
C
C
C
C       DIRECTIVE DEFINTIONS : - ( NR60 TIMES )
C
C       D    1 RECORD ( FORMAT : I4 , 1X , 12A1 , 3X , 12I5 )
C            I4   : DIRECTIVE SEQUENCE NUMBER - IF THIS VALUE IS NEGATIV
C                   THIS DIRECTIVE IS DEFINED BY A PREVIOUS ONE, GIVEN B
C                   THE ABSOLUTE VALUE
C            12A1 : DIRECTIVE NAME
C            I5   : NUMBER OF PARAMETERS
C            I5   : REPEAT COUNT FOR THIS DIRECTIVE - IF NEGATIVE, COUNT
C                   IS GIVEN BY COMMON BLOCK OFFSET OF ABSOLUTE VALUE
C            I5   : NUMBER OF EXCLUDED DIRECTIVES
C            I5   : NUMBER OF ENABLING DIRECTIVES
C            I5   : LENGRP            -- DATA RECORD DEFINITIONS ONLY
C                   IF NEGATIVE, AS FOR REPEAT COUNT ABOVE
C            I5   : NGRP              -- DATA RECORD DEFINITIONS ONLY
C                   IF NEGATIVE, AS FOR REPEAT COUNT ABOVE
C            I5   : RECORD NUMBER     -- DATA RECORD DEFINITIONS ONLY
C            I5   : COMMON BLOCK OFFSET  -- DATA RECORD DEFINITIONS ONLY
C                   THERE MUST BE FOUR SLOTS AVAILABLE IN THE COMMON
C                   BLOCK FOR EACH DATA RECORD TYPE
C            I5   : LIST TYPE NUMBER  -- DATA RECORD DEFINITIONS ONLY
C
C
C
C     E      FORMAT SPECIFICATION FLAGS ( FORMAT : 5X , 18I5 )
C                         -- DATA RECORD DEFINITIONS ONLY
C            I5   : TITLE PRINTER 1     0 = NO PRINT / 1 = PRINT
C            I5   : TITLE PRINTER 2     0 = NO PRINT / 1 = PRINT
C            I5   : KEY WORD PRINTER 1  0 = NO PRINT / 1 = PRINT
C            I5   : KEY WORD PRINTER 2  0 = NO PRINT / 1 = PRINT
C            I5   : VALUES PRINTER 1    0 = NO PRINT / 1 = PRINT
C            I5   : VALUES PRINTER 2    0 = NO PRINT / 1 = PRINT
C            I5   : VALUES PRINTER 1    0 = NO PRINT / 1 = PRINT
C            I5   : KEY WORD PUNCH   1  0 = NO PUNCH / 1 = PUNCH
C            I5   : KEY WORD PUNCH   2  0 = NO PUNCH / 1 = PUNCH
C            I5   : VALUES PUNCH   1    0 = NO PUNCH / 1 = PUNCH
C            I5   : VALUES PUNCH   2    0 = NO PUNCH / 1 = PUNCH
C
C
C
C     F      TITLE/FORMAT SPECIFICATIONS ( FORMAT : 20A4 )
C                        -- AS REQUIRED BY PREVIOUS RECORD
C
C
C
C     G      EXCLUDED DIRECTIVES ( FORMAT : 5X , 19I5 )
C                        -- IF REQUIRED
C            I5   : NUMBER OF EXCLUDED DIRECTIVE 1 ...
C
C
C
C     H      ENABLING DIRECTIVES ( FORMAT : 5X , 18I5 )
C                        -- IF REQUIRED
C            I5   : NUMBER OF ENABLING DIRECTIVE 1
C            I5   : NUMBER OF ENABLING PARAMETER 1 -- IF 0, WHOLE
C                   DIRECTIVE IS ENABLING
C            I5   : VALUE 1
C            ( ... AS REQUIRED )
C
C
C
C     I      PARAMETER TYPE SPECIFICATION ( FORMAT : 5X , 19I5 )
C                        -- IF THERE ARE PARAMETERS
C            I5   : TYPE OF PARAMETER 1 : -
C                                                1 INTEGER
C                                                2 FLOATING
C                                                3 CHARACTER
C                                                4 SPECIAL
C            ( ... AS REQUIRED )
C
C
C
C     PARAMETER DEFINITIONS ( AS MANY AS REQUIRED FOR EACH DIRECTIVE )
C
C
C
C     J      PARAMETER DEFINITION ( FORMAT : 5X , 12A1 , 3X , 5I5 , * )
C                                       * DEPENDS ON TYPE OF PARAMETER
C            12A1 : PARAMETER KEYWORD
C            I5   : COMMON BLOCK OFFSET -- NOT FOR DATA RECORDS
C            I5   : DEFAULT VALUE FLAG -- -1 NO DEFAULT
C                                          0 DEFAULT PROVIDED
C            I5   : REPEAT COUNT
C            I5   : NUMBER OF ALLOWED VALUES -- 0 MEANS ANY VALUE IS
C                                                 ALLOWED
C                                            -- -VE MEANS DEFINED BY
C                                               PREVIOUS DIRECTIVE
C            I5   : VALUE ASSOCIATED WITH FIRST ALLOWED VALUE
C            *    : DEFAULT VALUE ( AS REQUIRED -- DEPENDS ON TYPE )
C                                    INTEGER   I10
C                                    FLOATING  F20.10
C                                    CHARACTER 1X , A4
C
C
C
C     K     ALLOWED VALUE SPECIFICATION ( FORMAT : 5X , * )
C                                    * DEPENDS ON PARAMETER TYPE
C                                    INTEGER   7I10
C                                    FLOATING  5E15.5
C                                    CHARACTER 5 ( 13A1 , 2X )
C
C
C
C     END OF PARAMETER DEFINITION
C
C
C
C     END OF DIRECTIVE DEFINITION
C
C
C
C     END OF INSTRUCTION DEFINITION
C
C
C
C
C--
C
      DIMENSION IICHAR(12)
      DIMENSION ISTORE(131072)
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ICOM50(32)
C
      COMMON/XDISC/NU
      COMMON/XDISCS/NCDFU,NCIFU,NCLDU , NCNDU
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCOMPD/TITLE(20)
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C
C
      EQUIVALENCE (NWPAR,MDR62N),(NWPART,MDR62D)
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (LR50,ICOM50(1))
C
C--SET UP SOME STRING LENGTH POINTERS
      LKW=12
      LKW1=13
      MAXKWT = 5
C--CLEAR THE STORE
      CALL XCSAE
      CALL XRSL
C--NUMBER OF WORDS PER PARAMETER IDENTIFIER IN RECORD 62
      NWPAR=LKW1
C--NUMBER OF WORDS PER COMPLETE PARAMETER ENTRY IN RECORD 62
      NWPART=NWPAR+11
C--LENGTH OF PARAMETER FOR INPUT HERE
      NWPAR1=NWPAR-2
C--ASSUME A NEW FILE INITIALLY
      IRPLCE=-1
      IFIRST=1
C--SWITCH TO THE COMMAND FILE DISC
      NUDUMP = KSWPDU ( NCIFU )
C--READ THE FIRST CARD
      READ ( NUCOM,950 ) ( LCMAGE(I),I=1,80 )
950   FORMAT ( 80A1 )
C
C -- CHECK FIRST CHARACTER. IF BLANK THEN THIS WILL BE A NEW FILE
C    OTHERWISE, THIS IS AN APPEND
C
      IF ( LCMAGE(1) .EQ. IB ) GO TO 1220
C
C--APPEND ACTION  -  LOAD THE OLD LIST 50
      IRPLCE=0
      CALL XLOADF
      CALL XLOADL
      CALL XFAL50
C--CREATE A DATA RECORD TO HOLD RECORD 52
      CALL XCSAE
      L=LR52
      LR52=KCEDR(LN,1,52,MDR52,NR52,9)
C--MOVE THE DATA INTO THE ARRAY
      CALL XMOVE(STORE(L),STORE(LR52),MDR52*NR52)
C--MOVE RECORD 50 DOWN TO THE BOTTOM OF CORE
      L=LR50
      LR50=NFL
      CALL XRSL
C--ALLOCATE SPACE FOR RECORD 50
      NFL=LR50
      IREC=50
      N=MDR50*NR50
      MR50=KCHNFL(N)
C--MOVE THE DATA
      CALL XMOVE(STORE(L),STORE(LR50),N)
      IFIRST=NR50+1
C--LOAD RECORD 51 INTO CORE
      IREC=51
      N=MDR51*NR51
      L=LR51
C--ALLOCATE SPACE
      LR51=KCHLFL(N)
C--BRING IT DOWN
      CALL XDOWNF(L,STORE(LR51),N)
C--SET THE OTHER POINTER
      MR51=LR51+(NR51-1)*MDR51
C--READ THE DETAILS FOR THIS LIST
      CALL XRLIND(LN,I,IADDI,LENGTH,K,L,STORE(NFL))
      IADDR=IADDI
      IADDL=0
C--SEARCH FOR RECORD 52
1000  CONTINUE
      IADD1=IADDL
      IADD2=IADDR
      IF(KLDDRH(IADDL,IADDR,IBUFF))1250,1050,1050
C--CHECK FOR RECORD 52
1050  CONTINUE
      IF(IBUFF(7)-52)1000,1100,1000
C--SET THE OTHER POINTER FOR RECORD 52
1100  CONTINUE
      IADD3=IBUFF(1)
C--MOVE TO THE END OF THE CHAIN
1150  CONTINUE
      IF(KLDDRH(IADDL,IADDR,IBUFF))1200,1150,1150
C--END OF THE CHAIN  -  ASSIGN THE NEW FREE ADDRESS
1200  CONTINUE
      IADDR=KNEXTF(I)
      GOTO 1500
C
1220  CONTINUE
C -- STORE THE FIRST LINE AS A TITLE FOR THE COMMAND FILE
C -- FILL TITLE WITH SPACES
      CALL XMVSPD ( IB,TITLE(1),20 )
C -- PACK TITLE
      CALL XFA4CS ( LCMAGE(1),TITLE(1),80 )
C -- WRITE TITLE TO DISC
      CALL XWTTLE
C
C--NUMBER OF WORDS PER '#' INSTRUCTION
1250  CONTINUE
      MDR50=LKW1
C--NUMBER OF WORDS PER DIRECTIVE NAME
      MDR60=LKW1
C--INITIALISE THE DISC
      CALL XSETFI
      CALL XSETLI
C--SET UP THE OUTPUT LIST TYPES
      LN=50
      IREC=0
C--SET ASIDE AN AREA TO STORE THE INSTRUCTION NAMES
      LR50=NFL
      MR50=LR50
      NR50=0
C--FIND THE NEXT FREE DISC ADDRESS
      IADDI=KNEXTF(I)
C--SET THE POINTERS FOR THE RECORD TRANSFERS
      IADDR=IADDI
      IADDL=0
      LENGTH=0
C--SET UP THE DISC ADDRESS RECORD TYPE 51
      MDR51=2*NCOM
      NR51=0
      LR51=LFL+1
      MR51=LR51-MDR51
C--READ THE LIST GENERATION COMMANDS
      MDR52=20
      READ(NUCOM,1300)NR52
1300  FORMAT(I3,1X,19A4)
C--CREATE A DATA RECORD FOR THE DATA  -  EVEN IF THERE IS NONE
      LR52=KCEDR(LN,1,52,MDR52,NR52,9)
C--CHECK IF THERE ARE ANY LIST GENERATION COMMANDS TO BE READ
      IF(NR52)1450,1450,1350
C--READ THE COMMANDS
1350  CONTINUE
      DO 1400 I=1,NR52
      MR52=LR52+MDR52-1
      READ(NUCOM,1300)(ISTORE(J),J=LR52,MR52)
      LR52=LR52+MDR52
1400  CONTINUE
C--UPDATE THE DATA RECORD HEADER DATA
1450  CONTINUE
      CALL XUDRH(LN,52,MDR52,NR52)
C--RECORD THE DISC ADDRESSES AND WRITE THE RECORD TO DISC
      IADD1=IADDL
      IADD2=IADDR
      CALL XWDRTD(LN,52,IADDL,IADDR,LENGTH,ICOM50,IDIM50,0,IBUFF)
      IADD3=IADDR
C--INSERT ANOTHER UNUSED RECORD BETWEEN THE CONTROL RECORDS AND THE STAR
      CALL XWDRTD(LN,52,IADDL,IADDR,LENGTH,ICOM50,IDIM50,0,IBUFF)
C--INITIAL CAPTION
1500  CONTINUE
      CALL XPRTCN
C--NUMBER OF WORDS PER DIRECTIVE NAME
      MDR60=LKW1
C--SET SOME USEFUL POINTERS FOR READING
      MDR501=MDR50-2
      MDR601=MDR60-2
C--NUMBER OF WORDS NEEDED TO STORE DETAILS FOR EACH DIRECTIVE
      MDR61=32
C--NUMBER OF WORDS PER ENTRY IN RECORD 62  -  A DUMMY VALUE
      MDR62=1
C--NUMBER OF WORDS PER LIST IN THE LISTS TO BE USED RECORD
      MDR63=1
C--VALUES FOR THE LOAD DETAILS
      MDR64=19
C
C--START OF THE LOOP TO READ THE NEXT '#' INSTRUCTION
1550  CONTINUE
      CALL XCSAE
      CALL XRSL
C--MOVE RECORD TYPE 51 DOWN CORE TO ACCOMMODATE THE NEW ENTRY
      I=LR51
      LFL=LR51-1
C--ALLOCATE SPACE FOR THE NEW ENTRY
      LR51=KCHLFL(MDR51)
C--CHECK IF THERE IS DATA TO MOVE
      IF(NR51)1650,1650,1600
C--MOVE THE DATA DOWN
1600  CONTINUE
      CALL XMOVE(STORE(I),STORE(LR51),MDR51*NR51)
C--ZERO THE NEW ENTRIES
1650  CONTINUE
      CALL XZEROF(STORE(MR51),MDR51)
C--ZERO THE RECORD TYPE
      IREC=0
C--SET UP 'NFL' AND 'LFL' TO AVOID THE INSTRUCTION NAMES AND DETAILS
      NFL=MR50
C--PREPARE AN AREA INTO WHICH THE NEXT INSTRUCTION NAME CAN BE READ
      I=KCHNFL(MDR50)
C--INITIALISE THE COMMON BLOCK POINTERS
      DO 1700 I=LCOM,MCOM,MDCOM
      ICOM50(I)=NOWT
1700  CONTINUE
C--READ THE NEXT INSTRUCTION NAME
      J=MR50+MDR501
      READ(NUCOM,1750,END=6200)(ISTORE(I+1),I=MR50,J),NR60,NR63,NR64
1750  FORMAT(12A1,3X,3I5)
C--COMPUTE THE MAXIMUM LENGTH FOR THIS NAME
      CALL XMAXCH(STORE(MR50),MDR50)
      JRPLCE=1
C--CHECK FOR AN APPEND
      IF(IRPLCE)1900,1800,1800
C--APPEND  -  SEARCH FOR THIS DIRECTIVE
1800  CONTINUE
      I=KCOMP(MDR50-1,STORE(MR50+1),STORE(LR50+1),NR50,MDR50)
C--CHECK FOR SUCCESS
      IF(I)1900,1900,1850
C--BLANK OUT THE PREVIOUS ENTRY
1850  CONTINUE
      I=LR50+(I-1)*MDR50
      CALL XMVSPD(IB,ISTORE(I+1),MDR50-1)
      JRPLCE=2
C--UPDATE AFTER THE READ
1900  CONTINUE
      MR50=NFL
      NR50=NR50+1
      NR51=NR50
      IRF=NR50*MULT50
C--SET UP A RECORD TO RECEIVE THE LOAD DETAILS
      NR64=MAX0(NR64,1)
      LR64=KCEDR(LN,1,-(IRF+64),MDR64,NR64,LCOM+4*MDCOM)
      MR64=LR64
C--READ THE DETAILS
      J=NFL
      K=KCHNFL(68)-1
C--LOOP OVER EACH INPUT LOAD DETAIL
      DO 2150 N=1,NR64
      READ(NUCOM,1950)ISTORE(MR64),ISTORE(MR64+1),(STORE(I),I=J,K)
1950  FORMAT(I4,I8,68A1)
C--BLANK OUT THE TRUE RECORD
      L=MR64+MDR64-3
      DO 2000 I=MR64,L
      ISTORE(I+2)=IB
2000  CONTINUE
C--SEARCH FOR THE FIRST NON-BLANK CHARACTER
      DO 2050 I=J,K
      IF(ISTORE(I).EQ.IB)GOTO 2050
C--NON-BLANK  -  COMPRESS TO A4 AND STORE
      CALL XFA4CS(STORE(I),STORE(MR64+2),K-I+1)
      GOTO 2100
2050  CONTINUE
C--UPDATE FOR THE NEXT LOAD DETAIL
2100  CONTINUE
      MR64=MR64+MDR64
2150  CONTINUE
C--CHECK IF THERE ARE ANY LISTS REQUIRED BY THIS INSTRUCTION
      IF(NR63)2350,2350,2200
C--LIST TO BE INPUT  -  CREATE A RECORD TO RECEIVE THEM
2200  CONTINUE
      LR63=KCEDR(LN,1,-(IRF+63),MDR63,NR63,LCOM+3*MDCOM)
      MR63=LR63
C--READ THE REQUIRED LISTS
      J=MR63+MDR63*NR63-1
      READ(NUCOM,2250)(ISTORE(I),I=MR63,J)
2250  FORMAT(16I5)
C--CHECK THAT THE INPUT LIST TYPES ARE VALID
      DO 2300 I=MR63,J
      ISTAT = KLSCHK ( LN , 0 , 0 , ILSCLN , ILSMSG , I , IERSEV )
2300  CONTINUE
C
C--CHECK IF THERE ARE ANY DIRECTIVES TO BE READ FOR THIS INSTRUCTION
2350  CONTINUE
      IF(NR60)5900,5900,2400
C--DIRECTIVES TO BE READ  -  SET RECORD TYPE 60 TO RECEIVE THE NAMES
2400  CONTINUE
      LR60=KCEDR(LN,1,-(IRF+60),MDR60,NR60,LCOM)
      MR60=LR60
C--SET UP A TYPE 61 RECORD TO RECEIVE THE DIRECTIVE POINTERS
      NR61=NR60
      LR61=KCEDR(LN,1,-(IRF+61),MDR61,NR61,LCOM+MDCOM)
      MR61=LR61
C--ZERO THIS AREA
      CALL XZEROF(STORE(MR61),MDR61*NR61)
C--SET UP AN AREA TO RECEIVE THE PARAMETER NAMES AND DETAILS
      LR62=KCEDR(LN,1,-(IRF+62),MDR62,0,LCOM+2*MDCOM)
      MR62=LR62
C--PRESERVE THE BASE ADDRESS OF THIS RECORD FOR RELATIVE ADDRESSING
      IBASE=MR62
C--LOOP OVER EACH EXPECTED INPUT DIRECTIVE
      DO 5850 JA=1,NR60
C--READ THE DIRECTIVE NAME
      J=MR60+MDR601
      JC=MR61+9
      JD=JC+4
      READ(NUCOM,2450)K,(ISTORE(I+1),I=MR60,J),ISTORE(MR61+3),
     2 ISTORE(MR61+7),ISTORE(MR61+6),ISTORE(MR61+31),(ISTORE(I),I=JC,
     3 JD)
2450  FORMAT(I4,1X,12A1,3X,10I5)
C--COMPUTE THE MAXIMUM LENGTH FOR THIS NAME
      CALL XMAXCH(STORE(MR60),MDR60)
C--CHECK IF THIS DIRECTIVE IS DEFINED BY ONE GIVEN PREVIOUSLY
      IF(K)2500,2600,2600
C--THIS DIRECTIVE IS DEFINED BY A PREVIOUS ONE
2500  CONTINUE
      K=IABS(K)
C--CHECK THAT THE INDICATED DIRECTIVE HAS BEEN READ IN
      IF(K-JA)2550,2650,2650
C--SET THE POINTERS
2550  CONTINUE
      K=LR61+(K-1)*MDR61
      CALL XMOVE(STORE(K),STORE(MR61),MDR61)
      GOTO 5800
C--CHECK THE DIRECTIVE SEQUENCE NUMBER
2600  CONTINUE
      IF(K-JA)2650,2750,2650
C--NOT THE CORRECT NUMBER
2650  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2700)K,(ISTORE(I+1),I=MR60,J)
      ENDIF
2700  FORMAT(28H Directive sequence error : ,I4,1X,12A1)
      CALL XERHND ( IERSEV )
C--CHECK IF THIS DIRECTIVE DEFINES A RECORD
2750  CONTINUE
      IF(ISTORE(MR61+11))2800,3100,2800
C--A RECORD IS DEFINED HERE  -  READ THE TITLE AND FORMATS
2800  CONTINUE
      JE=MR61+14
      JG=3
      JF=JE+4*JG
C--READ THE CONSTANTS FOR THE TITLE AND FORMATS
      READ(NUCOM,3700)(ISTORE(I),ISTORE(I+1),I=JE,JF,JG)
C--LOOP OVER THE TITLE AND FORMATS, READING WHERE NECESSARY
      DO 2950 I=JE,JF,JG
C--CHECK IF THIS ITEM IS DEFINED
      ISTORE(I+2)=NOWT
      IF(ISTORE(I))2950,2950,2850
C--DEFINED  -  COMPUTE THE LENGTH TO BE STORED
2850  CONTINUE
      ISTORE(I)=ISTORE(I)*20
      ISTORE(I+1)=MAX0(1,ISTORE(I+1))
C--SET UP AN AREA TO RECEIVE THE DATA
      J=NFL
      ISTORE(I+2)=J-IBASE
      K=KCHNFL(ISTORE(I))-1
      READ(NUCOM,2900)(STORE(L),L=J,K)
2900  FORMAT(20A4)
C--CHECK THE VALUE STORED FOR THE COMMON BLOCK OFFSET
2950  CONTINUE
      IF(ISTORE(MR61+12))3000,3000,3150
C--ILLEGAL COMMON BLOCK OFFSET
3000  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3050)
      ENDIF
3050  FORMAT(44H Illegal common block offset for data record)
      CALL XERHND ( IERSEV )
C--NORMAL DIRECTIVE  -  ENSURE A MINIMUM OF ZERO REPEATS
3100  CONTINUE
      ISTORE(MR61+7)=MAX0(0,ISTORE(MR61+7))
C--CHECK IF THERE IS A LIST OF DIRECTIVES TO BE EXCLUDED IF THIS IS FOUN
3150  CONTINUE
      IF(ISTORE(MR61+6))3300,3300,3200
C--EXCLUDED DIRECTIVES GIVEN  -  PREPARE AN AREA FOR THEM
3200  CONTINUE
      ISTORE(MR61+5)=1
C--PREPARE AN AREA TO RECEIVE THE EXCLUDED DIRECTIVES
      J=NFL
      K=KCHNFL(ISTORE(MR61+5)*ISTORE(MR61+6))-1
C--SET THE RELATIVE ADDRESS
      ISTORE(MR61+4)=J-IBASE
C--READ THE EXCLUDED DIRECTIVES
      READ(NUCOM,3250)(ISTORE(I),I=J,K)
3250  FORMAT(5X,15I5)
C--CHECK IF THERE IS A LIST OF ENABLING DIRECTIVES GIVEN
3300  CONTINUE
      IF(ISTORE(MR61+31))3400,3400,3350
C--ENABLING DIRECTIVES GIVEN  -  PREPARE AN AREA FOR THEM
3350  CONTINUE
      ISTORE(MR61+30)=3
C--PREPARE AN AREA TO RECEIVE THE ENABLING DIRECTIVES
      J=NFL
      K=KCHNFL(ISTORE(MR61+30)*ISTORE(MR61+31))-1
C--SET THE RELATIVE ADDRESS
      ISTORE(MR61+29)=J-IBASE
C--READ THE ENABLING DIRECTIVES
      READ(NUCOM,3250)(ISTORE(I),I=J,K)
C--CHECK IF THIS DIRECTIVE HAS ANY PARAMETERS ASSOCIATED WITH IT
3400  CONTINUE
      IF(ISTORE(MR61+3))3450,5800,3650
C--PARAMETERS ARE DEFINED BY A PREVIOUS DIRECTIVE
3450  CONTINUE
      K=IABS(ISTORE(MR61+3))
C--CHECK THAT THE DIRECTIVE HAS BEEN READ IN
      IF(K-JA)3600,3500,3500
C--ILLEGAL REFERENCE
3500  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3550)
      ENDIF
3550  FORMAT(32H Illegal parameter set reference)
      CALL XERHND ( IERSEV )
C--MOVE THE POINTERS ACROSS
3600  CONTINUE
      K=LR61+(K-1)*MDR61
      CALL XMOVE(STORE(K),STORE(MR61),4)
      GOTO 5800
C--PARAMETERS TO BE READ  -  SET UP THE LENGTH POINTERS
3650  CONTINUE
      NPARAM=ISTORE(MR61+3)
      ISTORE(MR61+2)=NWPART
      ISTORE(MR61+1)=NWPAR
C--CREATE AN AREA TO RECEIVE THAT PARAMETER NAMES AND DETAILS
      J=NFL
      L=ISTORE(MR61+2)*ISTORE(MR61+3)
      K=KCHNFL(L)-ISTORE(MR61+2)
C--ZERO THE APPOINTED AREA
      CALL XZEROF(STORE(J),L)
C--SET THE RELATIVE ADDRESS
      ISTORE(MR61)=J-IBASE
C--READ THE INPUT AND STORED PARAMETER TYPES
      L=K+NWPAR
      K=J+NWPAR
      READ(NUCOM,3700)(ISTORE(I),I=K,L,NWPART)
3700  FORMAT(5X,15I5)
C--CHECK THE PARAMETER TYPES PROVIDED
      DO 3850 I=K,L,NWPART
C--INPUT PARAMETER TYPE
      IF(ISTORE(I))3900,3900,3750
3750  CONTINUE
      IF(ISTORE(I)-MAXKWT)3800,3800,3900
C--SET THE TYPE TO BE STORED
3800  CONTINUE
      ISTORE(I+5)=ISTORE(I)
3850  CONTINUE
      GOTO 4000
C--SOME TYPE OF ERROR
3900  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3950)
      ENDIF
3950  FORMAT(23H Illegal parameter type)
      CALL XERHND ( IERSEV )
C
C--LOOP OVER EACH PARAMETER FOR THIS DIRECTIVE AND INPUT ITS DETAILS
4000  CONTINUE
      DO 5750 JB=1,NPARAM
      K=J+NWPAR1
      L=J+NWPAR
C--FIND THE PARAMETER TYPE
      ITYPEI=ISTORE(L)
      ITYPES=ISTORE(L+5)
C--CHECK ON THE TYPE OF DATA TO BE STORED FOR THIS PARAMETER
      GOTO(4300, 4200, 4100, 4100, 4100, 4050),ITYPES
4050  STOP600
C--CHARACTER STRING  -  READ THE PARAMETER KEYWORD AND DEFAULT VALUE
4100  CONTINUE
      READ(NUCOM,4150)(ISTORE(I+1),I=J,K),ISTORE(L+4),ISTORE(L+7),
     2 ISTORE(L+9),ISTORE(L+3),ISTORE(L+6),IICHAR
4150  FORMAT(5X,12A1,3X,5I5,1X,12A1)
      CALL XFA4CS(IICHAR(1),ISTORE(L+8),4)
      GOTO 4400
C--FLOATING POINT NUMBER  -  READ THE PARAMETER KEYWORD AND DEFAULT VALU
4200  CONTINUE
      READ(NUCOM,4250)(ISTORE(I+1),I=J,K),ISTORE(L+4),ISTORE(L+7),
     2 ISTORE(L+9),ISTORE(L+3),ISTORE(L+6),STORE(L+8)
4250  FORMAT(5X,12A1,3X,5I5,E20.10)
      GOTO 4400
C--FIXED POINT NUMBER  -  READ THE PARAMETER KEYWORD AND DEFAULT VALUE
4300  CONTINUE
      READ(NUCOM,4350)(ISTORE(I+1),I=J,K),ISTORE(L+4),ISTORE(L+7),
     2 ISTORE(L+9),ISTORE(L+3),ISTORE(L+6),ISTORE(L+8)
4350  FORMAT(5X,12A1,3X,5I5,I10)
C--COMPUTE THE MAXIMUM LENGTH FOR THIS KEYWORD
4400  CONTINUE
      CALL XMAXCH(STORE(J),NWPAR)
C--SET THE REPEAT COUNT UP PROPERLY
      ISTORE(L+9)=MIN0(MAX0(ISTORE(L+9),0),1)
C--CHECK IF WE ARE FORMING A DATA RECORD FROM THIS DIRECTIVE
      IF(ISTORE(MR61+11))4450,4500,4450
C--DATA RECORD TO BE FORMED  -  NO OFFSET IS REQUIRED
4450  CONTINUE
      ISTORE(L+4)=0
      GOTO 4650
C--SIMPLE DATA ON THIS DIRECTIVE  -  CHECK THE COMMON BLOCK OFFSET
4500  CONTINUE
      IF(ISTORE(L+4))4550,4550,4650
C--ILLEGAL OFFSET
4550  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4600)ISTORE(L+4)
      ENDIF
4600  FORMAT(31H Illegal common block offset : ,I5)
      CALL XERHND ( IERSEV )
C--CHECK IF A SET OF PERMISSABLE VALUES IS INCLUDED FOR THIS PARAMETER
4650  CONTINUE
      IF(ISTORE(L+3))4700,5700,4950
C--THE ALLOWED VALUES HAVE BEEN READ IN FOR A PREVIOUS DIRECTIVE
4700  CONTINUE
      K=IABS(ISTORE(L+3))
C--CHECK THAT THE DIRECTIVE HAS BEEN INPUT
      IF(K-JA)4850,4850,4750
C--ILLEGAL REFERENCE
4750  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4800)
      ENDIF
4800  FORMAT(30H Illegal allowed set reference)
      CALL XERHND ( IERSEV )
C--COMPUTE THE DIRECTIVE ADDRESS AND CHECK THE PARAMETER NUMBER
4850  CONTINUE
      K=LR61+(K-1)*MDR61
      IF(ISTORE(L+6)-ISTORE(K+3))4900,4900,4750
C--COMPUTE THE ADDRESS OF THE PARAMETER
4900  CONTINUE
      K=LR62+ISTORE(K)+(ISTORE(L+6)-1)*NWPART+NWPAR
C--MOVE ALL THE DETAILS, INCLUDING DEFAULT DATA, ACROSS
      CALL XMOVE(STORE(K),STORE(L),4)
      CALL XMOVE(STORE(K+5),STORE(L+5),4)
      GOTO 5700
C--PERMISSABLE VALUES TO BE READ  -  SET UP AN AREA
4950  CONTINUE
      ISTORE(L+5)=1
C--CHECK THAT THE INPUT TYPE ALLOWS PERMISSABLE VALUES
      IF(ISTORE(L)-4)5000,3900,3900
C--NOW SET THE AREA UP
5000  CONTINUE
      M=NFL
      ISTORE(L+1)=M-IBASE
      ISTORE(L+2)=1
C--CHECK ON THE TYPE OF INPUT PARAMETER
      IF(ITYPEI-3)5100,5050,5100
C--CHARACTER STRING  -  ALTER THE LENGTH OF EACH ARGUMENT
5050  CONTINUE
      ISTORE(L+2)=NWPAR
C--ALLOCATE THE SPACE
5100  CONTINUE
      N=KCHNFL(ISTORE(L+2)*ISTORE(L+3))-1
C--CHECK THE TYPE OF INPUT PARAMETER AGAIN
      GOTO(5550, 5350, 5200, 5200, 5200, 5150),ITYPEI
5150  STOP601
C--CHARACTER STRING
5200  CONTINUE
      READ(NUCOM,5250)(ISTORE(I+1),I=M,N)
5250  FORMAT((5X,5(13A1,2X)))
C--CHECK FOR A DEFAULT VALUE
      ISTORE(L+8)=KCOMP(NWPAR-1,IICHAR(1),ISTORE(M+1),ISTORE(L+3),
     2 ISTORE(L+2))
C--LOOP OVER EACH VALUE, SETTING THE MAXIMUM LENGTH
      N=ISTORE(L+3)
      DO 5300 I=1,N
      CALL XMAXCH(STORE(M),ISTORE(L+2))
      M=M+ISTORE(L+2)
5300  CONTINUE
      GOTO 5650
C--FLOATING POINT NUMBER
5350  CONTINUE
      READ(NUCOM,5400)(STORE(I),I=M,N)
5400  FORMAT(5X,5E15.5)
      DO 5500 I=M,N
      IF(ABS(STORE(I)-STORE(L+8))-ZERO)5450,5500,5500
C--A MATCH  -  SET THE DEFAULT POINTER
5450  CONTINUE
      ISTORE(L+8)=I-M+1
      GOTO 5650
5500  CONTINUE
      ISTORE(L+8)=-1
      GOTO 5650
C--FIXED POINT NUMBER
5550  CONTINUE
      READ(NUCOM,5600)(ISTORE(I),I=M,N)
5600  FORMAT(5X,7I10)
      ISTORE(L+8)=KCOMP(1,ISTORE(L+8),ISTORE(M),ISTORE(L+3),ISTORE(L+2)
     2 )
C--SET THE DEFAULT VALUE POINTERS
5650  CONTINUE
      ISTORE(L+7)=ISTORE(L+8)-1
      ISTORE(L+8)=ISTORE(L+8)+ISTORE(L+6)-1
C--UPDATE FOR THE NEXT PARAMETER FOR THIS DIRECTIVE
5700  CONTINUE
      J=J+NWPART
5750  CONTINUE
C--ALL PARAMETERS READ FOR THIS DIRECTIVE  -  UPDATE FOR THE NEXT
5800  CONTINUE
      MR60=MR60+MDR60
      MR61=MR61+MDR61
5850  CONTINUE
C--END OF THIS INSTRUCTION  -  OUTPUT THE VARIOUS RECORDS TO DISC
      NR62=NFL-IBASE
C--OUTPUT THE PARAMETER DETAILS TO DISC
5900  CONTINUE
      IREC=-(IRF+60)
      L=MR51
      DO 6100 I=LCOM,MCOM,MDCOM
C--CHECK IF SUCH A RECORD EXISTS
      IF(ICOM50(I)-NOWT)5950,6050,5950
C--SUCH A RECORD DOES EXIST  -  UPDATE ITS HEADER BLOCK
5950  CONTINUE
      CALL XUDRH(LN,IREC,ICOM50(I+2),ICOM50(I+3))
C--PRESERVE THE DATA ADDRESS
      K=ICOM50(I)
C--RECORD THE DISC ADDRESSES
      ISTORE(L)=IADDL
      ISTORE(L+1)=IADDR
C--OUTPUT THE RECORD HEADER BLOCK
      CALL XWDRTD(LN,IREC,IADDL,IADDR,LENGTH,ICOM50,IDIM50,0,IBUFF)
C--CHECK IF THERE IS SOME DATA TO OUTPUT
      M=ICOM50(I+2)*ICOM50(I+3)
      IF(M)6050,6050,6000
C--NOW WRITE THE RECORD ITSELF
6000  CONTINUE
      CALL XUPF(ICOM50(I),ISTORE(K),M)
C--UPDATE FOR THE NEXT RECORD
6050  CONTINUE
      IREC=IREC-1
      L=L+2
6100  CONTINUE
C--PRINT A MESSAGE TO INDICATE THE END OF THIS INSTRUCTION
      J=MR50-MDR50
      K=J+MDR50-2
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,6150)(ISTORE(I+1),I=J,K),(IB,I=1,JRPLCE)
      ENDIF
6150  FORMAT(25H Instruction processed : ,14A1,11HReplacement)
      GOTO 1550
C
C--END OF THE DATA  -  CREATE RECORD TYPE 50 NOW
6200  CONTINUE
      I=KCEDR(LN,1,50,MDR50,NR50,1)
C--MOVE THE DATA ACROSS
      CALL XMOVE(STORE(LR50),STORE(I),MDR50*NR50)
C--UPDATE THE RECORD HEADER
      CALL XUDRH ( LN , 50 , MDR50 , NR50 )
C--WRITE THE RECORD TO THE DISC
      IADD4=IADDL
      IADD5=IADDR
      CALL XWDRTD(LN,50,IADDL,IADDR,LENGTH,ICOM50,IDIM50,0,IBUFF)
      IADD6=IADDR
C--CLEAR THE STORE
      CALL XCSAE
      CALL XRSL
      LFL=LR51-1
C--CREATE A RECORD TYPE 51
      IREC=-51
      I=KCEDR(LN,1,IREC,MDR51,0,5)
C--UPDATE THE RECORD HEADER
      CALL XUDRH(LN,IREC,MDR51,NR51)
C--WRITE THE RECORD TO THE DISC
      I=LR51
      CALL XWDRTD(LN,IREC,IADDL,IADDR,LENGTH,ICOM50,IDIM50,0,IBUFF)
C--OUTPUT THE DATA TO THE DISC
      CALL XUPF(LR51,STORE(I),MDR51*NR51)
C--NOW SWITCH RECORDS 50 AND 51 SO THAT THEY ARE AFTER RECORD 52
      IBUFF(1)=IADD5
      CALL XUPF(IADD2,IBUFF(1),1)
C--ALTER THE BACKWARD POINTER FOR RECORD 50
      L=KINCRF(1)
      IBUFF(1)=IADD2
      CALL XUPF(IADD5+L,IBUFF(1),1)
C--NOW THE FORWARD POINTER OF RECORD 51
      IBUFF(1)=IADD3
      CALL XUPF(IADD6,IBUFF(1),1)
C--NOW THE BACKWARD POINTER FOR THE RECORD ORIGINALLY AFTER 52
      IBUFF(1)=IADD6
      CALL XUPF(IADD3+L,IBUFF(1),1)
C--AND NOW THE END OF CHAIN POINTER
      IBUFF(1)=0
      CALL XUPF(IADD4,IBUFF(1),1)
C--WRITE THE INFORMATION TO THE DISC ABOUT THIS LIST
      CALL XWLIND(LN,IADDI,LENGTH,0,0)
C--SWITCH BACK TO THE ORIGINAL DISC
      N = KSWPDU ( NUDUMP )
      RETURN
      END
C
CODE FOR XMAXCH
      SUBROUTINE XMAXCH(IN,N)
C--SET THE MAXIMUM LENGTH ALLOWED FOR A CHARACTER STRING.
C
C  IN      THE ARRAY CONTAINING THE STRING  -  IN WORDS 2 TO 'N'.
C          THE MAXIMUM LENGTH IS SET IN WORD 1.
C  N       THE NUMBER OF POSSIBLE CHARACTERS PLUS THE LENGTH WORD.
C
C--
C
      DIMENSION IN(N)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C--CHECK IF THE FIRST CHARACTER IS BLANK
      IF(IN(2).EQ.IB)GOTO 1050
C--INITIALISE
      J=N
      IN(1)=N-1
C--LOOP OVER EACH OF THE CHARACTERS, STARTING WITH THE LAST
      DO 1000 I=2,N
      IF(IN(J).NE.IB)RETURN
C--DECREMENT THE COUNT
      IN(1)=IN(1)-1
C--UPDATE THE CURRENT POSITION
      J=J-1
1000  CONTINUE
C--A COMPLETE SET OF BLANKS OR A LEADING BLANK
1050  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)
      ENDIF
1100  FORMAT(33H Keywords that start with a blank,
     2 34H or contain all blanks are illegal)
      CALL XERHND ( IERSEV )
      RETURN
      END
C
CODE FOR XPRTHI
      SUBROUTINE XPRTHI(ITYPE,ISTART,ISTOP)
C--LIST THE INSTRUCTIONS DETAILS STORED IN LIST 50 TO THE LINE
C  PRINTER.
C
C  ITYPE   THE TYPE OF PRINT REQUIRED :
C
C          -1  PRINT DETAILS OF ALL DIRECTIVES AND DATA RECORDS.
C           0  PRINT DETAILS OF USER DIRECTIVES ONLY.
C
C  ISTART  THE DIRECTIVE NUMBER AT WHICH TO START PRINTING.
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM50(32)
C
      CHARACTER*1 CCONT(4)
      CHARACTER*8 CFM(5)
      CHARACTER*4 CNONE
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (LR50,ICOM50(1))
C
C
      DATA CCONT / ' ' , ' ' , '(' , ')' /
      DATA CFM / 'Title   ' , 'Key prt ' , 'Print   ' , 'Key prt ' ,
     2           'Punch   ' /
      DATA CNONE / 'None' /
C
C--CLEAR THE CORE
      CALL XCSAE
      CALL XRSL
C--LOAD THE INITIAL PART OF LIST 50
      CALL XFAL50
C--ASSIGN A POINTER TO THE INSTRUCTION NAMES
      MR50=LR50
      MDR501=MDR50-2
C -- IF A FINAL INSTRUCTION NUMBER HAS BEEN GIVEN, DON'T PRINT LIST
C    GENERATION COMMANDS. THESE ARE ONLY OUTPUT IF ALL INSTRUCTIONS ARE
C    REQUIRED.
      IF ( ISTOP .GT. 0 ) GO TO 1100
C--CHECK IF THERE ARE ANY LIST GENERATION COMMANDS
      IF(NR52)1100,1100,1000
C--PRINT THE LIST GENERATION COMMANDS
1000  CONTINUE
      CALL XPRTCN
      MR52=LR52+MDR52*NR52-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)(ISTORE(I),I=LR52,MR52)
      ENDIF
1050  FORMAT(25H List generation commands//10H List type,5X,
     2 11HInstruction//(1H ,I8,5X,19A4))
C--RECORD 'NFL' AND 'LFL'
1100  CONTINUE
      JA=NFL
      JB=LFL
C
C--LOOP OVER EACH INSTRUCTION
      CALL XPRTCN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1150)
      ENDIF
1150  FORMAT(25H Available instruction(s)//)
      JSTOP=ISTOP
      IF(JSTOP)1152,1152,1153
1152  CONTINUE
C----- PRINT EVERYTHING
      JSTOP = NR50
      GOTO 1155
1153  CONTINUE
      JSTOP=ISTART+JSTOP-1
1155  CONTINUE
      JSTOP=MIN(JSTOP,NR50)
      DO 4700 JZ=1,JSTOP
C--CHECK IF WE SHOULD DETAILS OF THIS INSTRUCTION
      IF(JZ-ISTART)4650,1200,1200
C--CLEAR STORE AND RE-ALLOCATE IT
1200  CONTINUE
      CALL XCSAE
      CALL XRSL
      NFL=JA
      LFL=JB
C--LOAD THE DETAILS FOR THE CURRENT INSTRUCTION
      CALL XLL50R(JZ)
      MDR601=MDR60-2
C--PRINT THE INSTRUCTION NAME AND NUMBER OF DIRECTIVES
      J=MR50+MDR501
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1250)IH,(ISTORE(I+1),I=MR50,J),NR60
      ENDIF
      IF(IQUN.NE.JQUN) WRITE(NCAWU,1250)IH,(ISTORE(I+1),I=MR50,J),NR60
1250  FORMAT(1H ,13A1,5X,I3,14H  Directive(s)/)
C--PRINT THE LOAD DETAILS
      DO 1350 K=1,NR64
      J=MR64+MDR64-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1300)(ISTORE(I),I=MR64,J)
      ENDIF
      WRITE(NCAWU,1300)(ISTORE(I),I=MR64,J)
1300  FORMAT(6H Link ,I2,5X,15HMin. core size ,I8,5X,20A4)
      MR64=MR64+MDR64
1350  CONTINUE
C--CHECK IF THERE IS ANY LIST INFORMATION STORED
      IF(NR63)1500,1500,1400
C--PRINT THE LISTS TO BE USED
1400  CONTINUE
      MR63=LR63+(NR63-1)*MDR63
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)(ISTORE(I),I=LR63,MR63,MDR63)
      ENDIF
      WRITE(NCAWU,1450)(ISTORE(I),I=LR63,MR63,MDR63)
1450  FORMAT(/18H  Uses list(s) :  ,25I4)
C--CHECK IF THERE ARE ANY DIRECTIVES FOR THIS INSTRUCTION
1500  CONTINUE
      IF(NR60)4650,4650,1550
C
C--LOOP OVER EACH DIRECTIVE FOR THIS INSTRUCTION
1550  CONTINUE
      DO 4600 JY=1,NR60
C--CHECK IF ALL DIRECTIVES SHOULD BE PRINTED
      IF(ITYPE)1650,1600,1600
C--USER DIRECTIVES ONLY  -  CHECK THE NUMBER OF REPEATS ALLOWED
1600  CONTINUE
      IF(ISTORE(MR61+7))1650,3350,1650
C--FIND THE LAST WORD OF THE DIRECTIVE NAME
1650  CONTINUE
      J=MR60+MDR601
C--FIND THE ABSOLUTE VALUE OF THE REPEAT COUNT
      M=IABS(ISTORE(MR61+7))
      N=1
C--CHECK IF THE REPEAT COUNT OR ITS ADDRESS IS GIVEN
      IF(ISTORE(MR61+7))1700,1750,1750
C--ITS ADDRESS IS GIVEN
1700  CONTINUE
      N=3
C--PRINT THE DIRECTIVE AND ITS DETAILS
1750  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1800)JY,(ISTORE(I+1),I=MR60,J),ISTORE(MR61+3),
     2 CCONT(N),M,CCONT(N+1),ISTORE(MR61+6),ISTORE(MR61+31)
      ENDIF
      WRITE(NCAWU,1801)JY,(ISTORE(I+1),I=MR60,J),ISTORE(MR61+3)
1801  FORMAT(/5X,I3,2H. ,12A1,5X,I3,22H  Parameter keyword(s))
1800  FORMAT(/5X,I3,2H. ,12A1,5X,I3,22H  Parameter keyword(s),5X,A1,I4,
     2 A1,11H  Repeat(s),5X,I2,15H  excluded and ,I2,
     3 23H  enabling directive(s)/)
C--CHECK IF THERE ARE ANY PARAMETERS FOR THIS DIRECTIVE
      IF(ISTORE(MR61+3))3350,3350,1850
C--SET UP THE ADDRESS POINTERS TO THE PARAMETER RECORD
1850  CONTINUE
      JS=ISTORE(MR61)+LR62
      JW=ISTORE(MR61+3)
C
C--LOOP OVER EACH OF THE PARAMETER KEYWORDS
      DO 3300 JX=1,JW
C--COMPUTE THE ADDRESS OF THE REST OF THE DATA FOR THIS PARAMETER
      JT=JS+ISTORE(MR61+1)
C--COMPUTE THE ADDRESS OF THE FINAL WORD OF THE NAME
      JU=JT-2
C--SET UP THE PARAMETER TYPE
      ITYPEI=ISTORE(JT)
      ITYPES=ISTORE(JT+5)
C--CHECK IF THERE ARE ANY PERMISSABLE VALUES STORED
      IF(ISTORE(JT+3))1900,1900,2400
C--NO PERMISSABLE VALUES  -  CHECK FOR A DEFAULT VALUE
1900  CONTINUE
      IF(ISTORE(JT+7))1950,2000,2000
C--NO DEFAULT GIVEN
1950  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1955)(ISTORE(I+1),I=JS,JU),ISTORE(JT+4),ISTORE(JT+9),
     2 CNONE
      ENDIF
      WRITE(NCAWU,1965)(ISTORE(I+1),I=JS,JU),CNONE
1965  FORMAT(11X,12A1,5X,16HDefault value = ,A4)
1955  FORMAT(34X,12A1,5X,4HL = ,I3,I13,6X,16HDefault value = ,A4)
      GOTO 3250
C--CHECK THE TYPE OF PARAMETER STORED
2000  CONTINUE
      GOTO(2300, 2200, 2100, 1950, 2100, 2050),ITYPES
2050  STOP604
C--CHARACTER STRING
2100  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2150)(ISTORE(I+1),I=JS,JU),ISTORE(JT+4),ISTORE(JT+9),
     2 ISTORE(JT+8)
      ENDIF
      WRITE(NCAWU,2151)(ISTORE(I+1),I=JS,JU),      ISTORE(JT+8)
2151  FORMAT(11X,12A1,5X,16HDefault value = ,A4)
2150  FORMAT(34X,12A1,5X,4HL = ,I3,I13,6X,16HDefault value = ,A4)
      GOTO 3250
C--FLOATING POINT NUMBER
2200  CONTINUE
      WRITE(NCAWU,2251)(ISTORE(I+1),I=JS,JU),STORE(JT+8)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2250)(ISTORE(I+1),I=JS,JU),ISTORE(JT+4),ISTORE(JT+9),
     2 STORE(JT+8)
      ENDIF
2251  FORMAT(11X,12A1,5X,16HDefault value = ,E15.5)
2250  FORMAT(34X,12A1,5X,4HL = ,I3,I13,6X,16HDefault value = ,E15.5)
      GOTO 3250
C--FIXED POINT NUMBER
2300  CONTINUE
      WRITE(NCAWU,2351)(ISTORE(I+1),I=JS,JU),ISTORE(JT+8)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2350)(ISTORE(I+1),I=JS,JU),ISTORE(JT+4),ISTORE(JT+9),
     2 ISTORE(JT+8)
      ENDIF
2351  FORMAT(11X,12A1,5X,16HDefault value = ,I10)
2350  FORMAT(34X,12A1,5X,4HL = ,I3,I13,6X,16HDefault value = ,I10)
      GOTO 3250
C--PERMISSABLE VALUES STORED  -  CHECK FOR A DEFAULT VALUE
2400  CONTINUE
      JC=0
      IF(ISTORE(JT+7))2600,2450,2450
C--DEFAULT VALUE INDICATED  -  COMPUTE ITS POSITION IN THE PERMISSABLE V
2450  CONTINUE
      J=ISTORE(JT+8)-ISTORE(JT+6)
      IF(J)2600,2500,2500
C--DEFAULT IS PARTLY IN RANGE  -  CHECK THE MAXIMUM
2500  CONTINUE
      IF(J-ISTORE(JT+3))2550,2600,2600
C--DEFAULT VALUE IS IN RANGE  -  PRINT THE PERMISSABLE VALUES
2550  CONTINUE
      JC=J+1
C--PRINT THE KEYWORD AND NUMBER OF VALUES
2600  CONTINUE
      WRITE(NCAWU,2651)(ISTORE(I+1),I=JS,JU),ISTORE(JT+3)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2650)(ISTORE(I+1),I=JS,JU),ISTORE(JT+4),ISTORE(JT+9),
     2 ISTORE(JT+3)
      ENDIF
2651  FORMAT(11X,12A1,5Hwith ,I5,
     2 22H  permissable value(s)/)
2650  FORMAT(34X,12A1,5X,4HL = ,I3,I13,6X,5Hwith ,I5,
     2 22H  permissable value(s)/)
C--PREPARE TO LOOP OVER THE PERMISSABLE VALUES
      JR=ISTORE(JT+3)
      JQ=ISTORE(JT+1)+LR62
      JO=ISTORE(JT+6)
C--LOOP OVER THE PERMISSABLE VALUES
      DO 3200 JP=1,JR
      JV=1
C--CHECK IF THIS IS THE DEFAULT VALUE
      IF(JP-JC)2750,2700,2750
C--THIS IS THE DEFAULT VALUE
2700  CONTINUE
      JV=2
C--BRANCH ON THE INPUT TYPE
2750  CONTINUE
      GOTO(3050, 2950, 2850, 2850, 2850, 2800),ITYPEI
2800  STOP605
C--CHARACTER STRING
2850  CONTINUE
      J=JQ+ISTORE(JT+2)-2
      WRITE(NCAWU,2901)JO,(ISTORE(I+1),I=JQ,J),(IB,I=1,JV)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2900)JO,(ISTORE(I+1),I=JQ,J),(IB,I=1,JV)
      ENDIF
2901  FORMAT(22X,I4,1X,14A1,13HDefault value)
2900  FORMAT(86X,I4,1X,14A1,13HDefault value)
      GOTO 3150
C--FLOATING POINT NUMBER
2950  CONTINUE
      WRITE(NCAWU,3001)JO,STORE(JQ),(IB,I=1,JV)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3000)JO,STORE(JQ),(IB,I=1,JV)
      ENDIF
3001  FORMAT(22X,I4,1X,E15.5,2A1,13HDefault value)
3000  FORMAT(86X,I4,1X,E15.5,2A1,13HDefault value)
      GOTO 3150
C--FIXED POINT NUMBER
3050  CONTINUE
      WRITE(NCAWU,3101)JO,ISTORE(JQ),(IB,I=1,JV)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3100)JO,ISTORE(JQ),(IB,I=1,JV)
      ENDIF
3101  FORMAT(22X,I4,1X,I10,2A1,13HDefault value)
3100  FORMAT(86X,I4,1X,I10,2A1,13HDefault value)
C--UPDATE FOR THE NEXT PERMISSABLE VALUE
3150  CONTINUE
      JQ=JQ+ISTORE(JT+2)
      JO=JO+1
3200  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3500)
      ENDIF
C--UPDATE FOR THE NEXT PARAMETER
3250  CONTINUE
      JS=JS+ISTORE(MR61+2)
3300  CONTINUE
C
C--CHECK IF THERE ARE ANY EXCLUDED DIRECTIVES FOR THIS DIRECTIVE
3350  CONTINUE
      IF(ISTORE(MR61+6))3600,3600,3400
C--EXCLUDED DIRECTIVES TO BE PRINTED  -  SET UP THE ADDRESS POINTERS
3400  CONTINUE
      WRITE(NCAWU,3450)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3450)
      ENDIF
3450  FORMAT(/10X,10HExcludes :)
      N=ISTORE(MR61+6)
      M=ISTORE(MR61+4)+LR62
C--LOOP OVER THE EXCLUDED DIRECTIVES
      DO 3550 L=1,N
      J=LR60+(ISTORE(M)-1)*MDR60
      K=J+MDR601
      WRITE(NCAWU,3500)L,(ISTORE(I+1),I=J,K)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3500)L,(ISTORE(I+1),I=J,K)
      ENDIF
3500  FORMAT(23X,I4,1X,1X,12A1)
C--UPDATE FOR THE NEXT DIRECTIVE
      M=M+ISTORE(MR61+5)
3550  CONTINUE
C--CHECK IF THERE ARE ANY ENABLING DIRECTIVES FOR THIS DIRECTIVE
3600  CONTINUE
      IF(ISTORE(MR61+31))4000,4000,3650
C--ENABLING DIRECTIVES TO BE PRINTED  -  SET UP THE ADDRESS POINTERS
3650  CONTINUE
      WRITE(NCAWU,3700)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3700)
      ENDIF
3700  FORMAT(/10X,12HEnabled by :)
      N=ISTORE(MR61+31)
      M=ISTORE(MR61+29)+LR62
C--LOOP OVER THE ENABLING DIRECTIVES
      DO 3950 L=1,N
      J=LR60+(ISTORE(M)-1)*MDR60
      K=J+MDR601
C--CHECK IF THE JUST THE DIRECTIVE IS REQUIRED
      IF(ISTORE(M+1))3750,3750,3800
C--JUST THE DIRECTIVE
3750  CONTINUE
      WRITE(NCAWU,3500)L,(ISTORE(I+1),I=J,K)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3500)L,(ISTORE(I+1),I=J,K)
      ENDIF
      GOTO 3900
C--DIRECTIVE AND KEYWORD VALUE ARE REQUIRED
3800  CONTINUE
      WRITE(NCAWU,3850)L,(ISTORE(I+1),I=J,K),ISTORE(M+1),ISTORE(M+2)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3850)L,(ISTORE(I+1),I=J,K),ISTORE(M+1),ISTORE(M+2)
      ENDIF
3850  FORMAT(23X,I4,1X,12A1,17H  with parameter ,I4,12H  stored as ,I4)
C--UPDATE FOR THE NEXT DIRECTIVE
3900  CONTINUE
      M=M+ISTORE(MR61+30)
3950  CONTINUE
C--CHECK IF THIS DIRECTIVE ALSO DEFINES A DATA RECORD
4000  CONTINUE
      IF(ISTORE(MR61+11))4050,4550,4050
C--DATA RECORD DEFINED  -  PRINT ITS DETAILS
4050  CONTINUE
      K=IABS(ISTORE(MR61+9))
      L=1
      IF(ISTORE(MR61+9))4100,4150,4150
C--LOCATION NOT VALUE STORED
4100  CONTINUE
      L=3
C--CHECK THE NUMBER OF GROUPS
4150  CONTINUE
      M=IABS(ISTORE(MR61+10))
      N=1
      IF(ISTORE(MR61+10))4200,4250,4250
C--LOCATION STORED
4200  CONTINUE
      N=3
C--NOW PRINT THE DETAILS
4250  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4300)ISTORE(MR61+11),ISTORE(MR61+13),CCONT(L),K,
     2 CCONT(L+1),CCONT(N),M,CCONT(N+1),ISTORE(MR61+12)
      ENDIF
4300  FORMAT(/10X,20HDefines record type ,I6,16H  for list type ,I5,5X,
     2 9HLENGRP = ,A1,I5,A1,5X,9HNGROUP = ,A1,I5,A1,5X,9HOffset = ,I5/)
C--LOOP OVER THE TITLE AND FORMATS
      JQ=MR61+14
      JS=3
      JR=JQ+4*JS
      I=1
      DO 4500 J=JQ,JR,JS
C--CHECK IF THIS TITLE OR FORMAT IS GIVEN
      IF(ISTORE(J))4450,4450,4350
C--PRINT THIS INFORMATION
4350  CONTINUE
      K=ISTORE(J+2)+LR62
      L=K+ISTORE(J)-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4400) CFM(I) , (STORE(M),M=K,L)
      ENDIF
4400  FORMAT ( 10X , A , 'format : ' , 20A4/10(10X,20A4/))
C--UPDATE FOR THE NEXT
4450  CONTINUE
      I=I+1
4500  CONTINUE
C--UPDATE FOR THE NEXT DIRECTIVE
4550  CONTINUE
      MR60=MR60+MDR60
      MR61=MR61+MDR61
4600  CONTINUE
C
C--UPDATE FOR THE NEXT INSTRUCTION
4650  CONTINUE
      MR50=MR50+MDR50
4700  CONTINUE
      RETURN
      END
CODE FOR KGVAL
	FUNCTION KGVAL(CINSTR, CDIR, CPARAM, CVALUE, CDEF,
     1                INSTR, IDIR, IPARAM, IVAL, JVAL, VAL, JTYPE)
C
C----- GET  TEXT OR VALUE CORRESPONDING TO PARAMETER CPARAM OR IPARAM
C	FOR THE DIRECTIVE CDIR IN THE INSTRUCTION CINSTR
C
C
C      IF INSTR +VE, USE AS INDEX AND FIND CPARAM
C      IF        -VE, USE CPARAM AND RETURN INDEX
C      IF IVAL .EQ. NOWT, RETURN DEFAULT VALUES IN JVAL,VAL OR JTYPE
C	RETURN -1 IF FAIL
C
C
      CHARACTER *(*) CINSTR, CDIR, CPARAM, CVALUE, CDEF
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      LINSTR = MIN0 (15, LEN (CINSTR))
      LDIR   = MIN0 (15, LEN (CDIR))
      LPARAM = MIN0 (15, LEN (CPARAM))
      LVALUE = MIN0 (15, LEN (CVALUE))
C
      KGVAL = 1
C----- SAVE WORKSPACE ADDRESS
      NFLSAV = NFL
      LFLSAV = LFL
C
C----- FIND THE INSTRUCTION DETAILS
      IF ( KIVAL ( INSTR, CINSTR, LINSTR) .LE. 0) GOTO 6000
C
C----- FIND THE DIRECTIVE DETAILS
      IF ( KDVAL ( IDIR, CDIR, LDIR) .LE. 0) GOTO 6000
C
C----- FIND THE PARAMETER DETAILS
      IF (KPVAL (IPARAM, CPARAM, LPARAM, IVAL, JTYPE, IDEF, DEF,
     1 CDEF, CVALUE ) .LE. 0) GOTO 6000
C
C----- RESTORE WORK SPACE
      NFL = NFLSAV
      LFL = LFLSAV
      RETURN
6000  CONTINUE
C      WRITE(NCAWU,*) ' some sort of failure in KGVAL'
      KGVAL = -1
      RETURN
      END
C
CODE FOR KIVAL
      FUNCTION KIVAL ( INSTR, CINSTR, LINSTR)
C
C----- GIVEN AN INSTRUCTION NAME OR NUMBER, CHECKS ITS
C      VALIDITY AND RETURNS DIRECTIVE INFO
      CHARACTER *(*) CINSTR
      DIMENSION ITEXT(15)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      KIVAL = 0
C----- LOAD LIST 50 IF REQUIRED, SINCE WE NEED TO FIND
      IF (KHUNTR (50,0, IADDL,IADDR,IADDD, -1) .NE. 0) CALL XFAL50
C
      IF (INSTR .LE. 0) THEN
C----- LOOK FOR INSTRUCTION
        READ (CINSTR, '(15A1)') (ITEXT(I), I=1,LINSTR)
        LINSTR = MIN0( LINSTR, MDR50-1)
        INSTR = KCHKDS (ITEXT, 15, LINSTR, ISTORE(LR50), NR50, MDR50)
        IF (INSTR .LE. 0) GOTO 6000
      ELSE
C----- STORE INSTRUCTION NAME
        IF (INSTR .GT. NR50) GOTO 6000
        LINSTR = MIN0( LINSTR, MDR50-1)
        ISTART = LR50 + (INSTR-1) * MDR50 +1
        IEND = ISTART + LINSTR-1
        WRITE(CINSTR, '(15A1)') (ISTORE(I), I=ISTART,IEND)
      ENDIF
C----- LOAD RELAVENT BIT OF LIST 50
      CALL XLL50R(INSTR)
      KIVAL = 1
6000  CONTINUE
      RETURN
      END
C
CODE FOR KDVAL
      FUNCTION KDVAL ( IDIR, CDIR, LDIR )
C
C----- GIVEN AN DIRECTIVE NAME OR NUMBER, CHECKS ITS
C      VALIDITY AND RETURNS PARAMETER INFO
      CHARACTER *(*) CDIR
      DIMENSION ITEXT(15)
      DIMENSION ICOMN(100)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      DATA IDIMN /100/
C
      KDVAL = 0
      IF (IDIR .LE. 0) THEN
C----- LOOK FOR THE DIRECTIVE
        READ (CDIR, '(15A1)') (ITEXT(I), I=1,LDIR)
        LDIR = MIN0( LDIR, MDR60-1)
        IDIR = KCHKDS (ITEXT, 15, LDIR, ISTORE(LR60), NR60, MDR60)
        IF (IDIR .LE. 0) GOTO 6000
      ELSE
C----- STORE DIRECTIVE NAME
        IF (IDIR .GT. NR60) GOTO 6000
        LDIR = MIN0( LDIR, MDR60-1)
        ISTART = LR60 + (IDIR-1) * MDR60 +1
        IEND = ISTART + LDIR-1
        WRITE(CDIR, '(15A1)' ) (ISTORE(I), I=ISTART,IEND)
      ENDIF
      CALL XDIRFL (IDIR, ICOMN, IDIMN)
      IF (NR62D .LE. 0) GOTO 6000
      KDVAL = 1
6000  CONTINUE
      RETURN
      END
C
CODE FOR KPVAL
      FUNCTION KPVAL (IPARAM, CPARAM, LPARAM, IVAL,
     1                JTYPE, IDEF, DEF, CDEF, CVALUE)
C
C----- GIVEN A PARAMETER NAME OR NUMBER, CHECKS ITS
C      VALIDITY AND RETURNS VALUE INFO
C
      CHARACTER *(*) CPARAM, CVALUE, CDEF
      DIMENSION ITEXT(15)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      IF (IPARAM .LE. 0) THEN
C----- LOOK FOR THE PARAMETER
        READ (CPARAM, '(15A1)') (ITEXT(I), I=1,LPARAM)
        LPARAM = MIN0( LPARAM, MDR62N-1)
        IPARAM =
     1  KCHKDS (ITEXT, 15, LPARAM, ISTORE(LR62N), NR62N, MDR62N)
        IF (IPARAM .LE. 0) GOTO 6000
      ELSE
C----- STORE PARAMETER NAME
        IF (IPARAM .GT. NR62N) GOTO 6000
        LPARAM = MIN0( LPARAM, MDR62N-1)
        ISTART = LR62N + (IPARAM-1) * MDR62D +1
        IEND = ISTART + LPARAM-1
        WRITE(CPARAM, '(15A1)' ) (ISTORE(I), I=ISTART,IEND)
      ENDIF
C
C----- SET THE START OF THE DEFAULT VALUES PLUS OTHER GOODIES
      MR62D = LR62D + MDR62D*(IPARAM-1)
      JTYPE = ISTORE( MR62D)
      NVAL = ISTORE(MR62D+3)
      LVAL = LR62 + ISTORE(MR62D+1)
      MDVAL = ISTORE(MR62D+2)
      MVAL = LVAL + ( NVAL - 1 ) * MDVAL
      IFVAL = ISTORE(MR62D+6)
C
C----- FIND THE DEFAULT ADDRESS
C
      IDEFLT = ISTORE(MR62D+7)
      IF (IDEFLT .GE. 0) THEN
        IF (NVAL .GE. 0) THEN
          IDEFAD = LVAL + ( ISTORE(MR62D+8)-ISTORE(MR62D+6) )*MDVAL
        ELSE
          IDEFAD = MR62D+8
        ENDIF
      ENDIF
      IADD = IDEFAD
      IDEF = 0
      DEF = 0.0
      CDEF = ' '
      CVALUE = ' '
      IF (JTYPE .EQ. 1) THEN
            IDEF = ISTORE(LVAL)
      ELSE IF (JTYPE .EQ. 2) THEN
            DEF = STORE(LVAL)
      ELSE
        WRITE (CDEF, '(12A1)') ( ISTORE(J), J = IADD+1,IADD+MDVAL-2 )
C
        IF (IVAL .GE. NOWT) THEN
C----- SET THE ACTUAL VALUE FOR TEXT ARGUMENTS
          IPARAD = LVAL + ( IVAL -ISTORE(MR62D+6) ) * MDVAL
          IADD = IPARAD
          WRITE (CVALUE, '(12A1)') (ISTORE(J), J = IADD+1,IADD+MDVAL-2)
        ENDIF
      ENDIF
C
      KPVAL = 1
6000  CONTINUE
      RETURN
      END
C
CODE FOR KDLIS
      FUNCTION KDLIS ( A)
C
C----- RETURNS LIST OF POSSIBLE DIRECTIVES, AND DEFAULT
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      KDLIS = 0
      RETURN
      END
C
CODE FOR KPLIS
      FUNCTION KPLIS ( A)
C
C----- RETURNS LIST OF POSSIBLE PARAMETERS AND DEFAULT
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      KPLIS = 0
      RETURN
      END
C
CODE FOR KVLIS
      FUNCTION KVLIS ( A)
C
C----- RETURNS LIST OF POSSIBLE VALUES AND DEFAULT
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      DO 999 I = 1,  NVAL
      IADD = LVAL + (I - ISTORE(MR62D+6)) * MDVAL
      WRITE ( NCAWU , 1050 ) I, ( ISTORE(J) ,
     2 J = IADD+1,IADD+MDVAL-2 )
1050              FORMAT ( / , 1X , 'value', I6, ' is : ' , 12A1 )
C
999   CONTINUE
      KVLIS = 0
      RETURN
      END
C
CRYSTALS CODE FOR LIST6
CODE FOR XPRT6C
      SUBROUTINE XPRT6C(M1)
C--PRINT LIST 6 IN COMPRESSED FORMAT
C
C  M1  IF ZERO OR LESS THAN ZERO STRUCTURE FACTORS ARE PRINTED ON
C      ON THE SCALE OF /FO/, ELSE ON THE SCALE OF /FC/
C
C--
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      CALL XPRT6Q(6,M1,IPAGE(4)-9,3)
      RETURN
      END
C
CODE FOR XPRT6Q
      SUBROUTINE XPRT6Q(IULN,M1,NL,ICOL3)
C--PRINT LIST 6 IN COMPRESSED FORMAT
C
C  IULN    THE LIST TYPE TO BE PRINTED.
C  M1      IF ZERO OR LESS THAN ZERO STRUCTURE FACTORS ARE PRINTED ON
C          ON THE SCALE OF /FO/, ELSE ON THE SCALE OF /FC/
C  NL      THE NUMBER OF LINES PER PAGE
C  ICOL3   THE NUMBER OF COLUMNS PER PAGE (THIS IS CONSTRAINED
C          IN THE RANGE 1 TO 3).
C
C--
      DIMENSION ICOM06(28)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM06(1),L6)
C
C--ENSURE THAT THE NUMBER OF COLUMNS/PAGE DOES NOT EXCEED 3
      ICOL=MIN0(ICOL3,3)
C--CHECK THAT THERE ARE SOME COLUMNS ON THE PAGE
      IF(ICOL)1000,1000,1050
C--INSERT THE DEFAULT NUMBER OF COLUMNS  -  3
1000  CONTINUE
      ICOL=3
C--CHECK IF LIST 6 IS AVAILABLE FOR PRINTING
1050  CONTINUE
      IF(KPRTLN(IULN,I))3400,1100,1100
C--ALL OKAY  -  LOAD LIST 50 AND THE RECORD FOR THE REQUIRED LIST TYPE
1100  CONTINUE
      CALL XFAL50
      CALL XLL50R(IULN+LSTOFF)
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 6
      IDIM06=28
C--SET THE POINTERS TO THE SECOND RECORD  -  CONTAINS THE KEYWORDS
      LN=IULN
      IREC=0
      CALL XDIRFL(4,ICOM06,IDIM06)
C--CLEAR THE CORE AGAIN
      CALL XRSL
      CALL XCSAE
C--FIND THE NUMBER AND ADDRESS OF THE KEYWORDS
      KC=ISTORE(LR62D+1)+LR62
      KD=ISTORE(LR62D+3)
C--ALLOCATE SPACE TO HOLD THE KEYWORDS
      KA=NFL
      KB=3
      I=KCHNFL(KB*KD)
C--FORM A4 CHARACTER STRINGS FROM THE KEYWORDS
      J=KA
      DO 1150 I=1,KD
      CALL XFA4CS(STORE(KC+1),STORE(J),KB*NWCHAR)
      KC=KC+ISTORE(LR62D+2)
      J=J+KB
1150  CONTINUE
C--SET UP THE SCALING POINTERS INITIALLY
      I=0
      A=1.
      C=1.
C--CHECK IF THIS IS A LIST 6
      IF(IULN-6)1400,1250,1400
C--CHECK IF THERE IS A LIST 5 STORED
1250  CONTINUE
      CALL XRLIND(5,I,J,K,L,M,STORE(NFL))
C--CHECK THE DISC ADDRESS
      IF(J)1400,1400,1300
C--THERE IS A LIST 5 STORED  -  LOAD IT INTO CORE
1300  CONTINUE
      CALL XFAL05
      IF ( IERFLG .LT. 0 ) GO TO 9900
      A=1.
      C=STORE(L5O)
C--CHECK THE OUTPUT SCALE REQUIRED
      IF(M1)1400,1400,1350
C--OUTPUT IS ON THE SCALE OF /FO/, NOT THE SCALE OF /FC/
1350  CONTINUE
      C=1.
      A=1./STORE(L5O)
C--SET UP THE PROCESSING OF LIST 6
1400  CONTINUE
      CALL XFLT06(IULN,0)
      CALL XFAL28
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CHECK IF THERE IS A LIST ONE STORED
      IF(KEXIST(1))1500,1500,1450
C--LOAD LIST 1
1450  CONTINUE
      CALL XFAL01
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--PRINT THE DETAILS RECORD
1500  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1550)
      ENDIF
1550  FORMAT(9H Quantity,12X,7HMinimum,8X,7HMaximum,7X,10HMean value,
     2 4X,12HR.M.S. value/)
C--LOOP OVER EACH DETAIL STORED
      M6DTL=L6DTL
      DO 1850 I=2,N6DTL
      KC=KA+KB-1
C--CHECK IF THIS DETAIL IS SET
      IF(STORE(M6DTL+3)-ZERO)1600,1700,1700
C--NOT SET  -  PRINT THE CAPTION AND IGNORE IT
1600  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1650)(ISTORE(J),J=KA,KC)
      ENDIF
1650  FORMAT(2H  ,3A4,4X,20HNo details available)
      GOTO 1800
C--PRINT THE DETAILS
1700  CONTINUE
      K=M6DTL+MD6DTL-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1750)(ISTORE(J),J=KA,KC),(STORE(J),J=M6DTL,K)
      ENDIF
1750  FORMAT(2H  ,3A4,2X,6E15.6)
C--UPDATE FOR THE NEXT PARAMETER
1800  CONTINUE
      M6DTL=M6DTL+MD6DTL
      KA=KA+KB
1850  CONTINUE
C--CHECK IF THIS LIST TYPE 6
      IF(IULN-6)2000,1900,2000
C--PRINT THE R VALUE ETC.
1900  CONTINUE
      J=NINT(STORE(L6P))
      M6P=L6P+2
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1950)J,(STORE(I+1),I=L6P,M6P)
      ENDIF
1950  FORMAT(/7H After ,I5,
     2 44H  Structure factor/refinement calculation(s)//5H R = ,F6.2,
     3 5X,13HWeighted R = ,F6.2,5X,24HMinimisation function = ,E15.6)
C--ASSIGN THE NUMBER OF COEFFICIENTS TO BE PRINTED PER REFLECTION
2000  CONTINUE
      NW=6
      N=NW+NW+NW
      ASSIGN 2050 TO NRET
C--SET UP A PRINT BUFFER IN CORE
      JA=NFL
      LN=IULN
      IREC=1001
      M=KCHNFL(NW*NL*ICOL)
C--RESET THE CONSTANTS FOR THE BEGINNING OF A PAGE
2050  CONTINUE
      K=NL
      J=K+NL
      I=J+NL
      L=JA
      M=JA
C--FETCH THE NEXT REFLECTION
2100  CONTINUE
      IF(KFNR(0))2600,2150,2150
C--MOVE THE REFLECTION FROM THE INPUT BUFFER
2150  CONTINUE
      ISTORE(L)=NINT(STORE(M6))
      ISTORE(L+1)=NINT(STORE(M6+1))
      ISTORE(L+2)=NINT(STORE(M6+2))
      STORE(L+3)=STORE(M6+3)*A
      STORE(L+4)=STORE(M6+5)*C
      STORE(L+5)=STORE(M6+6)*RTD
      L=L+N
      I=I-1
      J=J-1
      K=K-1
C--CHECK IF THE COLUMN IS FULL
      IF(K)2300,2200,2100
C--END OF THE FIRST COLUMN  -  CHECK IF WE SHOULD ONLY PRINT ONE COLUMN
2200  CONTINUE
      IF(ICOL-1)2250,3150,2250
C--MORE THAN ONE COLUMN  -  RETURN FOR MORE REFLECTIONS
2250  CONTINUE
      M=M+NW
      L=M
      GOTO 2100
C--END OF THE SECOND OR THIRD COLUMNS  -  FIND WHICH
2300  CONTINUE
      IF(J)2400,2350,2100
C--END OF THE SECOND COLUMN  -  CHECK IF WE ARE ONLY PRINTING 2
2350  CONTINUE
      IF(ICOL-2)2250,2950,2250
C--MORE THAN TWO COLUMNS  -  CHECK FOR THE END OF A PAGE
2400  CONTINUE
      IF(I)2450,2450,2100
C--END OF A PAGE WITH THREE COLUMNS ON IT  -  PRINT THEM
2450  CONTINUE
      L=L-N
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2500)
      ENDIF
2500  FORMAT(1H1/3(7X,1HH,3X,1HK,3X,1HL,4X,4H/FO/,4X,4H/FC/,3X,5HPhase)
     2 /)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2550)(ISTORE(NX),ISTORE(NX+1),ISTORE(NX+2),
     2 STORE(NX+3),STORE(NX+4),STORE(NX+5),NX=JA,L,NW)
      ENDIF
2550  FORMAT((3(4X,3I4,3F8.1)))
      GOTONRET,(2050,2700,3400,3050)
C
C--LAST REFLECTION MARKER FOUND
2600  CONTINUE
      M=NL-I
C--CHECK IF THERE ANY ROWS WITH THREE COLUMNS TO PRINT
      IF(M)2900,2900,2650
C--PRINT ROWS WITH THREE COLUMNS
2650  CONTINUE
      ASSIGN 2700 TO NRET
      GOTO 2450
C--RETURN AFTER PRINTING 3 COLUMNS  -  RESET TO PRINT 2
2700  CONTINUE
      ASSIGN 3400 TO NRET
      L=L+NW
C--CHECK IF THERE ARE ANY ROWS WITH TWO COLUMNS TO PRINT
2750  CONTINUE
      IF(I)2800,2800,2850
C--END OF 2 COLUMN PRINT - EXIT FOR 2 AND 3 COLUMNS, PRINT 1 FOR 1 AND 2
2800  CONTINUE
      GOTONRET,(2050,2700,3400,3050)
C--PRINT THE NEXT LINE OF TWO COLUMNS
2850  CONTINUE
      M=L+NW
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2550)(ISTORE(NX),ISTORE(NX+1),ISTORE(NX+2),
     2 STORE(NX+3),STORE(NX+4),STORE(NX+5),NX=L,M,NW)
      ENDIF
      I=I-1
      L=L+N
      GOTO 2750
C
C--NO ROWS WITH THREE COLUMNS
2900  CONTINUE
      ASSIGN 3050 TO NRET
C--COMPUTE THE NUMBER OF ROWS WITH TWO COLUMNS TO PRINT
2950  CONTINUE
      I=NL-J
C--CHECK IF THERE ANY ROWS WITH ONLY TWO COLUMNS
      IF(I)3100,3100,3000
C--NEW PAGE CAPTION REQUIRED BEFORE WE START
3000  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2500)
      ENDIF
      L=JA
      GOTO 2750
C--ASSIGN THE EXIT VARIABLE AFTER PRINTING THE 2 COLUMN ROWS
3050  CONTINUE
      ASSIGN 3400 TO NRET
      GOTO 3250
C
C--ONLY ROWS WITH ONE COLUMN TO PRINT
3100  CONTINUE
      ASSIGN 3400 TO NRET
C--COMPUTE THE NUMBER OF 1 COLUMN ROWS TO BE PRINTED
3150  CONTINUE
      J=NL-K
      IF(J)3400,3400,3200
C--CAPTION FOR THE NEW PAGE WITH ONLY ONE COLUMN ON IT
3200  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2500)
      ENDIF
      L=JA
C--CHECK FOR THE END OF THE PAGE
3250  CONTINUE
      IF(J)3300,3300,3350
C--END OF THE PAGE  -  EXIT NOW
3300  CONTINUE
      GOTONRET,(2050,2700,3400,3050)
C--PRINT THE NEXT LINE WITH ONE COLUMN ON IT
3350  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2550)ISTORE(L),ISTORE(L+1),ISTORE(L+2),STORE(L+3),
     2 STORE(L+4),STORE(L+5)
      ENDIF
      L=L+N
      J=J-1
      GOTO 3250
C--A FEW SPARE LINES AT THE END
3400  CONTINUE
      CALL XLINES
      RETURN
C
9900  CONTINUE
C -- ERRORS
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9905 )
      ENDIF
      WRITE ( NCAWU , 9905 )
9905  FORMAT ( 1X , 'Printing of list 6 abandoned' )
      RETURN
      END
C
C----- L6W = -1 FOR M/T; +1 FOR DISK
CODE FOR XSWP06
      SUBROUTINE XSWP06(IULN,MEDIUM)
C--CHECK IF THE CURRENT OUTPUT MEDIUM IS WHAT IS REQUIRED FOR LIST 6
C
C  IULN    THE LIST TYPE BEING PROCESSED.
C  MEDIUM  THE NEW MEDIUM FLAG :
C
C          -1  M/T
C           0  AS BEFORE.
C          +1  DISC.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK WHAT IS REQUIRED NOW
      IF(MEDIUM)1000,1300,1050
C--M/T REQUIRED  -  CHECK WHERE WE ARE
1000  CONTINUE
      IF(L6W)1300,1100,1100
C--DISC REQUIRED  -  CHECK WHERE WE ARE NOW
1050  CONTINUE
      IF(L6W)1100,1300,1300
C--OUTPUT THE DATA TO THE NEW MEDIUM
1100  CONTINUE
      CALL XRSL
      CALL XCSAE
C--LOAD THE OLD LIST FOR READING
      CALL XFLT06(IULN,0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET UP THE NEW LIST FOR OUTPUT
      CALL XSTR06(IULN,MEDIUM,0,1,0)
C--LOAD THE NEXT REFLECTION
1150  CONTINUE
      IF(KLDRNR(I))1250,1200,1200
C--STORE THE NEXT REFLECTION
1200  CONTINUE
      CALL XSLR(1)
      GOTO 1150
C--TERMINATE THE TRANSFER
1250  CONTINUE
      CALL XERT(IULN)
C--AND NOW RETURN
1300  CONTINUE
C -- NORMAL AND ERROR RETURN
9900  CONTINUE
      RETURN
      END
C
CODE FOR XFAL06
      SUBROUTINE XFAL06(IOWF)
C--SET UP LIST 6 FOR READING FROM THE DISC, AND POSSIBLY FOR REWRITING
C
C  IOWF  THE WRITE/OVERWRITE FLAG :
C
C        -1  ATTEMPT AN OVERWRITE.
C         0  READ ONLY.
C        +1  CAREFUL UPDATE ONLY.
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C--
C
C--CALL THE MAIN LOADING ROUTINE
      CALL XFLT06(6,IOWF)
      IF ( IERFLG .LT. 0 ) RETURN
C
C--INITIALISE LIST 28 IF POSSIBLE
      CALL XFAL28
      RETURN
      END
C
CODE FOR XLDR06
      SUBROUTINE XLDR06(IOWF)
C--SET UP LIST 6 FOR READING FROM THE DISC, AND POSSIBLY FOR REWRITING.
C  THIS ROUTINE DOES NOT INITIALISE LIST 28, AND SO SUCH CHECKING
C  WILL BE PERFORMED.
C
C  IOWF  THE WRITE/OVERWRITE FLAG :
C
C        -1  ATTEMPT AN OVERWRITE.
C         0  READ ONLY.
C        +1  CAREFUL UPDATE ONLY.
C
C--
C
C--CALL THE MAIN LOADING ROUTINE
      CALL XFLT06(6,IOWF)
      RETURN
      END
C
CODE FOR XFLT06
      SUBROUTINE XFLT06(IULN,IOWF)
C--SET UP A LIST FOR PROCESSING AS A LIST 6.
C
C  IULN  THE LIST TYPE TO BE SET UP FOR PROCESSING.
C  IOWF  THE WRITE/OVERWRITE FLAG :
C
C        -1  ATTEMPT AN OVERWRITE.
C         0  READ ONLY.
C        +1  CAREFUL UPDATE ONLY.
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM06(28)
      DIMENSION ICOM28(40)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST28/L28MN,M28MN,MD28MN,N28MN,L28CN,M28CN,MD28CN,N28CN,
     2 L28MX,M28MX,MD28MX,N28MX,L28CX,M28CX,MD28CX,N28CX,
     3 L28RC,M28RC,MD28RC,N28RC,I28SPC(8),L28OM,M28OM,MD28OM,N28OM,
     4 L28CD,M28CD,MD28CD,N28CD, L28SK,M28SK,MD28SK,N28SK
      COMMON/XPCK06/I14(1),IPACKR,IPACKW,I15(1),IPHSER,IPHSEW,
     2 I31(1),JCDRAR,JCDRAW
      COMMON/XUSLST/LN5,LN6
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON/XTAPED/LMTW,MMTW,MDMTW,NMTW,LMTR,MMTR,MDMTR,NMTR
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM06(1),L6)
      EQUIVALENCE (ICOM28(1),L28MN)
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 28
      IDIM28 = 40
C--ZERO THE COMMON BLOCK FOR LIST 28
      CALL XZEROF(ICOM28(1),IDIM28)
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 6
      IDIM06=28
      LN6=IULN
C--LOAD THE DATA FROM THE DISC
      CALL XLDLST(IULN,ICOM06,IDIM06,IOWF)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET UP THE PACK COEFFICIENTS FOR THE INDICES
      IPACKR=KCOMP(1,I14,STORE(L6DMP),MD6DMP,N6DMP)
      IPACKW=IPACKR
C--SET UP THE PHASE/BATCH PACK COEFFICIENTS
      IPHSER=KCOMP(1,I15,STORE(L6DMP),MD6DMP,N6DMP)
      IPHSEW=IPHSER
C -- FIND IF THE RATIO AND JCODE HAVE BEEN PACKED
      JCDRAR = KCOMP ( 1 , I31 , STORE(L6DMP) , MD6DMP , N6DMP )
      JCDRAW = JCDRAR
C--SET THE POINTER TO THE CORE BUFFER
      M6=L6
C--CHECK IF THE INPUT IS FROM M/T
      IF(L6D)1000,1000,1050
C--INPUT IS FROM M/T  -  SET UP A BUFFER
1000  CONTINUE
      CALL XIMTR(MD6D)
C--REWIND THE INPUT TAPE
      REWINDMTA
C--SET THE POINTERS TO THE DISC INPUT BUFFER
1050  CONTINUE
      M6R=L6R
      L6R=L6D
      N6R=N6D
C--CONVERT THE DISC POINTERS TO ABSOLUTE VALUES
      CALL XABP06(1)
C--CHECK IF THIS OPERATION ALSO INVOLVES A WRITE TO THE DISC
      IF(IOWF)1100,1150,1100
C--OUTPUT IS TO BE GENERATED
1100  CONTINUE
      CALL XSTR06(IULN,0,IOWF,-1,0)
C--AND NOW RETURN
1150  CONTINUE
      CALL XZEROF(STORE(M6),MD6)
C -- NORMAL AND ERROR EXIT
9900  CONTINUE
      RETURN
      END
C
CODE FOR XEND06
      SUBROUTINE XEND06
C--TERMINATE THE TRANSFER OF LIST 6 REFLECTION DATA TO DISC
C
C--
C
C--CALL THE TERMINATION ROUTINE
      CALL XERT(6)
      RETURN
      END
C
CODE FOR XERT
      SUBROUTINE XERT(IULN)
C--TERMINATE THE OUTPUT OF LIST TYPE 6 TO THE DISC
C
C  IULN    THE TYPE OF LIST BEING OUTPUT AS A LIST 6.
C
C--
C
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON/XTAPED/LMTW,MMTW,MDMTW,NMTW,LMTR,MMTR,MDMTR,NMTR
C
C
C
C
C--SET THE LIST TYPE
      LN=IULN
      IREC=0
C--SET THE OUTPUT FLAG
      JTYPE=1
C--CHECK FOR OUTPUT TO M/T
      IF(L6W)1000,1000,1050
C--OUTPUT TO M/T  -  FINISH IT OFF
1000  CONTINUE
      CALL XTMTW(MTB)
      CALL XTMTR(MTA)
C--SWITCH UNITS
      I=MTA
      MTA=MTB
      MTB=I
      JTYPE=2
C--REWRITE THE LIST DETAILS TO DISC
1050  CONTINUE
      KA=L6W
      KB=N6W
      L6W=M6W
      N6W=1
C--MARK THE CURRENT LIST AS BEING UPDATED NOW
      CALL XMKOWF(IULN,1)
C--REWRITE THE DETAILS TO DISC
      CALL XSTR06(IULN,0,-1,-1,-1)
C--RESET THE POINTERS
      L6W=KA
      N6W=KB
C--ALTER THE WRITE/OVERWRITE FLAG
      CALL XMKOWF(IULN,0)
C--ALTER THE ERROR STATUS
      CALL XALTES(IULN,1)
C--CHECK FOR M/T OUTPUT
      IF(L6W .LE. 0 ) THEN
C--PRINT THE FILE NAME NOW CURRENT
1100  CONTINUE
      WRITE(NCAWU,1200)MTA
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)MTA
      ENDIF
1200  FORMAT (' The updated reflections are now on UNIT ', I2 )
C--AND NOW RETURN
      ELSE
            WRITE(NCAWU,
     1 '( '' Reflections on DISK updated '')')
      ENDIF
1250  CONTINUE
      RETURN
      END
C
CODE FOR XSTR06
      SUBROUTINE XSTR06(IULN,MTFLAG,IOWF,INEW,IMTBUF)
C--INITIATE OUTPUT FOR A LIST 6
C
C  IULN    THE TYPE OF LIST TO OUTPUT.
C  MTFLAG  M/T OUTPUT FLAG :
C
C          -1  OUTPUT IS TO M/T
C           0  OUTPUT IS AS DEFINED BY 'L6D'  -  I.E. SAME AS BEFORE.
C          +1  OUTPUT IS TO DISC.
C
C  IOWF    THE WRITE/OVERWRITE FLAG :
C
C          -1  OVERWRITE IF POSSIBLE.
C           0  OUTPUT A COMPLETELY NEW LIST.
C          +1  CAREFUL UPDATE.
C
C  INEW    THE NEW LIST FLAG :
C
C          -1  THIS IS NOT A NEW VERSION OF THIS LIST.
C           0  THIS IS A NEW LIST, WITH LINKS TO OTHER EXISTING LISTS.
C          +1  THIS IS A NEW LIST, WITH NO LINKS TO OTHER EXISTING
C              LISTS. THIS IS NORMALLY THE CASE WHEN THE LIST HAS JUST B
C              INPUT.
C
C  IMTBUF  THIS POINTER DETERMINES WHETHER AN M/T BUFFER IS SET IF REQUI
C
C          -1  DO NOT SET UP A BUFFER.
C           0  SET UP A BUFFER IF REQUIRED.
C
C
C--TO ALTER THE OUTPUT MEDIUM FROM THAT USED FOR INPUT, 'XFAL06' OR
C  'XFLT06' SHOULD BE CALLED WITH NO OUTPUT REQUESTED ('IOWF' SET TO 0),
C  AND THEN 'XSTR06' SHOULD BE CALLED TO NOMINATE THE OUTPUT MEDIUM.
C
C--
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ISTORE(131072)
      DIMENSION ICOM06(28)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUSLST/LN5,LN6
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON/XTAPED/LMTW,MMTW,MDMTW,NMTW,LMTR,MMTR,MDMTR,NMTR
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM06(1),L6)
C
      LN6=IULN
C--ADJUST THE READ POINTERS DURING THIS OPERATION
      KA=L6R
      KB=M6R
      KC=N6R
C--INDICATE ONLY ONE READ RECORD
      L6R=M6R
      N6R=1
C--CHECK THE OUTPUT TYPE REQUIRED
      MTFLG=MTFLAG
      IF(MTFLG)1000,1050,1100
C--OUTPUT TO M/T
1000  CONTINUE
      KD=N6D
      N6D=0
      MTFLG=-1
      GOTO 1100
C--SAME AS BEFORE  -  CHECK THE PREVIOUS TYPE
1050  CONTINUE
      IF(L6D)1000,1000,1100
C--CONVERT ALL ADDRESSES IN THE MOVE BLOCK TO RELATIVE
1100  CONTINUE
      CALL XABP06(-1)
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 6
      IDIM06=28
C--INITIATE OUTPUT OF THE LIST
      CALL XWLSTD(IULN,ICOM06,IDIM06,IOWF,INEW)
C--RESET THE READ POINTERS
      L6R=KA
      M6R=KB
      N6R=KC
C--CHECK FOR OUTPUT TO M/T
      IF(MTFLG)1150,1250,1250
C--M/T OUTPUT  -  UPDATE THE CONTROL RECORD
1150  CONTINUE
      N6D=KD
      L6D=-1
C--FIND THE BLOCK ON DISC
      I=KFNDRI(IULN,-104,IADDR,IBUFF)
C--UPDATE THE NUMBER, LENGTH AND ADDRESS
      IBUFF(6)=N6D
      IBUFF(3)=MD0+IBUFF(5)*IBUFF(6)
      IBUFF(4)=-1
C--REWITE THE BLOCK
      CALL XUPF(IADDR,IBUFF(1),MD0)
C--UPDATE THE CORE POINTERS
      CALL XUDRH(IULN,-104,0,N6D)
C--CHECK IF THE OUTPUT AREA SHOULD BE CREATED
      IF(IMTBUF)1250,1200,1200
C--CREATE AN OUTPUT AREA
1200  CONTINUE
      CALL XIMTW(MD6D)
      REWINDMTB
C--SET THE POINTERS
1250  CONTINUE
      M6W=L6W
      L6W=L6D
      N6W=0
C--CONVERT THE POINTERS BACK TO ABSOLUTE
      CALL XABP06(1)
C--SET THE BUFFER TO ZERO INITIALLY
      CALL XZEROF(STORE(M6),MD6)
      RETURN
      END
C
CODE FOR KFNR
      FUNCTION KFNR(IN)
C--FETCH THE NEXT REFLECTION, CHECKING WITH LIST 28 THAT IT IS ALLOWED.
C
C----- IN   0 FOR READ-ONLY
C           1 FOR READ-WRITE
C
C--RETURN VALUES OF 'KFNR' ARE :
C
C  -1  END OF THE REFLCTIONS.
C   0  REFLCTION READ TO BE USED, STORED AT 'M6'.
C
C--
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
C
C--FETCH THE NEXT REFLECTION
1000  CONTINUE
      IF(KLDRNR(IN))1100,1050,1050
C--CHECK IF THE REFLECTION IS ALLOWED
1050  CONTINUE
      KFNR=0
      IF(KALLOW(IN)) 1060,1150,1150
1060  CONTINUE
      IF(IN) 1000,1000,1070
1070   CONTINUE
      CALL XSLR(IN)
      GO TO 1000
C--END OF THE REFLECTIONS FOUND
1100  CONTINUE
      KFNR=-1
C--AND NOW RETURN
1150  CONTINUE
      RETURN
      END
C
CODE FOR XSLR
      SUBROUTINE XSLR(IN)
C--STORE THE LAST REFLECTION
C
C  IN  A DUMMY ARGUMENT, IN PLACE FOR COMPATIBILITY.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XPCK06/I14(1),IPACKR,IPACKW,I15(1),IPHSER,IPHSEW,
     2 I31(1),JCDRAR,JCDRAW
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON/XTAPED/LMTW,MMTW,MDMTW,NMTW,LMTR,MMTR,MDMTR,NMTR
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF THE INDICES SHOULD BE PACKED UP
      IF(IPACKW)1050,1000,1000
C--PACK THE INDICES
1000  CONTINUE
      STORE(M6+14)=STORE(M6)+STORE(M6+1)*256.+STORE(M6+2)*65536.
C--CHECK IF THE PHASE AND BATCH NUMBER NEED PACKING UP
1050  CONTINUE
      IF(IPHSEW)1150,1100,1100
C--PACK THE PHASE AND BATCH NUMBER
1100  CONTINUE
      STORE(M6+15)=STORE(M6+13)*20.+AMOD(STORE(M6+6),TWOPI)+10.
C -- CHECK IF WE MUST PACK UP THE RATIO AND JCODE
1150  CONTINUE
      IF ( JCDRAW .GE. 0 ) THEN
        STORE(M6+31) = STORE(M6+18) + 10.* ANINT ( 10. * STORE(M6+20) )
      ENDIF
C--MOVE THE DATA TO THE OUTPUT BUFFER
      J=M6W
C--CHECK FOR OUTPUT TO M/T
      IF(L6W)1300,1300,1350
C--OUTPUT TO M/T
1300  CONTINUE
      J=MMTW
C--TRANSFER THE DATA TO THE OUTPUT BUFFER
1350  CONTINUE
      DO 1400 I=L6DMP,M6DMP
      K=ISTORE(I)
      STORE(J)=STORE(K)
      J=J+1
1400  CONTINUE
C--CHECK FOR M/T OUTPUT
      IF(L6W)1450,1450,1500
C--M/T OUTPUT  -  UPDATE THE POINTERS
1450  CONTINUE
      CALL XIMTWA(MTB)
      GOTO 1550
C--OUTPUT THE DATA TO THE DISC
1500  CONTINUE
      CALL XUPF(L6W,STORE(M6W),MD6W)
C--UPDATE THE POINTERS
      L6W=L6W+KINCRF(MD6W)
C--UPDATE THE NUMBER OF REFLECTIONS OUTPUT
1550  CONTINUE
      N6W=N6W+1
      RETURN
      END
C
CODE FOR XABP06
      SUBROUTINE XABP06(IN)
C--ALTER THE DISC BUFFER POINTERS BY 'IN'*M6.
C
C  IN  INDICATES WHETHER TO SUBTRACT OR ADD 'M6' FROM THE STORED VALUES
C
C      -1  SUBTRACT 'M6'.
C      +1  ADD 'M6'.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET THE INCREMENT/DECREMENT
      J=IN*M6
C--LOOP OVER THE AVAILABLE VALUES
      M6DMP=L6DMP+MD6DMP-1
      DO 1000 I=L6DMP,M6DMP
      ISTORE(I)=ISTORE(I)+J
1000  CONTINUE
      RETURN
      END
C
CODE FOR XFAL28
      SUBROUTINE XFAL28
C--SUBROUTINE TO LOAD LIST 28 FROM DISC, IF IT EXISTS
C
C--
      DIMENSION ICOM28(40)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST28/L28MN,M28MN,MD28MN,N28MN,L28CN,M28CN,MD28CN,N28CN,
     2 L28MX,M28MX,MD28MX,N28MX,L28CX,M28CX,MD28CX,N28CX,
     3 L28RC,M28RC,MD28RC,N28RC,I28SPC(8),L28OM,M28OM,MD28OM,N28OM,
     4 L28CD,M28CD,MD28CD,N28CD, L28SK,M28SK,MD28SK,N28SK
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM28(1),L28MN)
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 28
      IDIM28 = 40
C--ZERO THE LIST 28 COMMON BLOCK
      CALL XZEROF(ICOM28(1),IDIM28)
C--READ THE DETAILS FOR LIST 28
      CALL XRLIND(28,I,J,K,L,M,STORE(NFL))
C--CHECK IF SUCH A LIST EXISTS
      IF(J)1250,1250,1000
C--THERE IS A LIST 28  -  LOAD IT FROM DISC
1000  CONTINUE
      CALL XLDLST(28,ICOM28,IDIM28,0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--FIND THE NUMBER OF ENTRIES IN LIST 28
      N=IDIM28/4
C--SET THE 'M' VARIABLES TO THE LAST ENTRY FOR EACH RECORD
      DO 1050 I=1,N
      J=(I-1)*4
      ICOM28(J+2)=ICOM28(J+1)+(ICOM28(J+4)-1)*ICOM28(J+3)
1050  CONTINUE
C--SET THE 'USE' POINTERS INTO LIST 6
      DO 1200 I=1,3,2
      K=(I-1)*4
C--CHECK IF THERE IS AN ENTRY FOR THIS RECORD
      IF(ICOM28(K+4))1200,1200,1100
C--COMPUTE THE ADDRESS POINTERS
1100  CONTINUE
      L=ICOM28(K+2)
      M=ICOM28(K+3)
      KK=ICOM28(K+1)
C--LOOP OVER EACH ENTRY
      DO 1150 J=KK,L,M
      ISTORE(J)=ISTORE(J)+M6
1150  CONTINUE
1200  CONTINUE
C----- FIX STEP AND STORE IT IN MD28SK
      MD28SK = MAX(1, NINT(STORE(L28SK)) )
C--CHECK IF LIST 1 IS IN CORE
1250  CONTINUE
      IF(KHUNTR(1,0,I,J,K,-1))1300,1350,1350
C--LIST 1 IS NOT IN CORE  -  FLAG ITS CONTROL VARIABLE
1300  CONTINUE
      L1S=NOWT
C--AND NOW RETURN
1350  CONTINUE
C -- NORMAL AND ERROR EXIT
9900  CONTINUE
      RETURN
      END
C
CODE FOR KALLOW
      FUNCTION KALLOW(IN)
C--THIS FUNCTION DETERMINES WHETHER A REFLECTION IS ACCEPTABLE TO LIST 2
C
C  IN  A DUMMY ARGUMENT.
C
C--THE RETURN VALUES OF 'KALLOW' ARE :
C
C  -1  NOT ACCEPTABLE.
C   0  THE REFLECTION IS OKAY.
C
C--THE REFLECTION IS TAKEN FROM THE CORE BUFFER AT 'M6', AND
C  SIN(THETA)/LAMBDA SQUARED AND FO/FC ARE COMPUTED BY THIS ROUTINE.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST28/L28MN,M28MN,MD28MN,N28MN,L28CN,M28CN,MD28CN,N28CN,
     2 L28MX,M28MX,MD28MX,N28MX,L28CX,M28CX,MD28CX,N28CX,
     3 L28RC,M28RC,MD28RC,N28RC,I28SPC(8),L28OM,M28OM,MD28OM,N28OM,
     4 L28CD,M28CD,MD28CD,N28CD, L28SK,M28SK,MD28SK,N28SK
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C----- DISALLOW THIS REFLECTION INITIALLY
      KALLOW = -1
C----- SHOULD WE SKIP IT (STEP STORED IN MD28SK IN XFAL28)
      IF (MOD (N6R, MAX(1, MD28SK) ) .NE. 0) GOTO 1650
C--COMPUTE THE SIN(THETA)/LAMBDA SQUARED
      STORE(M6+16)=SNTHL2(IN)
C--CHECK IF /FC/ IS ZERO
      IF(ABS(STORE(M6+5))-ZERO)1000,1050,1050
C--/FC/ IS ZERO  -  FO/FC DEFAULTS TO ZERO AS WELL
1000  CONTINUE
      STORE(M6+17)=ZERO
      GOTO 1100
C--COMPUTE FO/FC
1050  CONTINUE
      STORE(M6+17)=STORE(M6+3)/STORE(M6+5)
1100  CONTINUE
C--CHECK IF THERE ARE ANY MINIMA CONDITIONS
      IF(N28MN)1250,1250,1150
C--RUN THROUGH THE MINIMA CONDITIONS
1150  CONTINUE
      DO 1200 I=L28MN,M28MN,MD28MN
      J=ISTORE(I)
      IF(STORE(J)-STORE(I+1))1650,1200,1200
1200  CONTINUE
C--CHECK IF THERE ARE ANY MAXIMA CONDITIONS
1250  CONTINUE
      IF(N28MX)1400,1400,1300
C--RUN THROUGH THE MAXIMA CONDITIONS
1300  CONTINUE
      DO 1350 I=L28MX,M28MX,MD28MX
      J=ISTORE(I)
      IF(STORE(J)-STORE(I+1))1350,1350,1650
1350  CONTINUE
C--CHECK IF THERE ARE ANY SLICE CONDITIONS
1400  CONTINUE
      IF(N28RC)1600,1600,1450
C--PASS THROUGH THE SLICE CONDITIONS
1450  CONTINUE
      DO 1550 I=L28RC,M28RC,MD28RC
      A=STORE(M6)*STORE(I  )+STORE(M6+1)*STORE(I+1)+STORE(M6+2)
     2 *STORE(I+2)
C--CHECK THE MINIMUM
      IF(A-STORE(I+3))1650,1500,1500
C--CHECK THE MAXIMUM
1500  CONTINUE
      IF(A-STORE(I+4))1550,1550,1650
1550  CONTINUE
1600  CONTINUE
      IF(N28CD)1800, 1800, 1700
C--PASS THROUGH THE REFLECTION CONDITIONS
1700  CONTINUE
      DO 1750 I = L28CD, M28CD, MD28CD
      A = STORE(M6)*STORE(I  )+STORE(M6+1)*STORE(I+1)+STORE(M6+2)
     2 *STORE(I+2) + STORE(I+3)
C--CHECK THE CONDITION
      IF (MOD (ABS(A), STORE(I+4) ) .GT. ZERO) GOTO 1650
1750  CONTINUE
1800  CONTINUE
C
C -- CHECK FOR SPECIFIC OMISSIONS
      IF ( N28OM .LE. 0 ) GO TO 1640
      DO 1620 I = L28OM , M28OM , MD28OM
      A = 0.
      DO 1610 J = 1 , 3
      IND6 = M6 + J - 1
      IND28 = I + J - 1
      A = A + ABS ( STORE(IND6) - STORE(IND28) )
1610  CONTINUE
      IF ( A .LE.  ( 3 * ZERO )  ) GO TO 1650
1620  CONTINUE
C
1640  CONTINUE
C -- REFLECTION HAS PASSED ALL TESTS
      KALLOW=0
C--AND NOW RETURN
1650  CONTINUE
      RETURN
      END
C
CODE FOR SNTHL2
      FUNCTION SNTHL2(IN)
C--CALCULATE (SIN(THETA)/LAMBDA)**2
C
C  M6   LOCATION OF THE REFLECTION.
C  L1S  LOCATION OF THE R(IJ) TERMS.
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
C
C--CHECK IF LIST 1 IS AVAILABLE
      SNTHL2=0.
      IF(L1S)1050,1050,1000
C--CALCULATE (SIN(THETA)/LAMBDA)**2
1000  CONTINUE
      SNTHL2=STORE(M6)*STORE(M6)*STORE(L1S)+STORE(M6+1)*STORE(M6+1)
     2 *STORE(L1S+1)+STORE(M6+2)*STORE(M6+2)*STORE(L1S+2)+STORE(M6+1)
     3 *STORE(M6+2)*STORE(L1S+3)+STORE(M6)*STORE(M6+2)*STORE(L1S+4)
     4 +STORE(M6)*STORE(M6+1)*STORE(L1S+5)
C--AND NOW RETURN
1050  CONTINUE
      RETURN
      END
C
CODE FOR KTYP06
      FUNCTION KTYP06(IULN)
C--SET THE TYPE OF LIST 6 TO BE USED.
C
C  IULN    THE NUMBER OF THE LIST 6, IN THE RANGE 1 TO N. THE FOLLOWING
C          TYPES ARE KNOWN AT PRESENT :
C
C          1  TYPE IS 6.
C
C--NO OTHER TYPES ARE SUPPORTED AND AN ERROR IS REPORTED FOR ANY OTHERS.
C
C--RETURN VALUES OF 'KTYP06' ARE :
C
C  >0  THE LIST TYPE TO BE USED.
C
C--
C
      DIMENSION ITYPE(2)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C
      DATA ITYPE(1)/6/
C
C--CHECK THE INPUT VALUE
      IF(IULN)1000,1000,1100
C--TYPE IS ILLEGAL
1000  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)IULN
      ENDIF
      WRITE(NCAWU,1050)IULN
1050  FORMAT(30H Illegal list 6 type selector ,I5)
      CALL XERHND ( IERPRG )
C--CHECK THE MAXIMUM
1100  CONTINUE
      IF(IULN-2)1150,1000,1000
C--FIND THE TYPE
1150  CONTINUE
      KTYP06=ITYPE(IULN)
      RETURN
      END
CODE FOR XIRTAC
      SUBROUTINE XIRTAC(IPOSN)
C--INITIATE THE ACCUMULATION OF DETAILS FOR THE REFLECTIONS. THIS
C  ROUTINE SETS UP ONE SLOT IN THE RECORD STARTING AT 'STORE(L6DTL)'.
C
C  IPOSN   THE NUMBER OF THE SLOT TO INITIATE, IN THE RANGE 1 TO MD6.
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
C
C--COMPUTE THE ADDRESS IN THE DETAILS RECORD.
      I=L6DTL+(IPOSN-1)*MD6DTL
C--SET THE MAXIMUM AND MINIMUM FLAGS
      STORE(I)=1E20
      STORE(I+1)=-1E20
C--SET THE SLOTS FOR THE MEAN AND R.M.S.
      STORE(I+2)=0.
      STORE(I+3)=0.
      RETURN
      END
C
CODE FOR XACRT
      SUBROUTINE XACRT(IPOSN)
C--ADD IN THE TOTAL FOR A REFLECTION TO A GIVEN SLOT IN THE DETAILS
C  RECORD.
C
C  IPOSN   THE POSITION IN THE DETAILS RECORD TO BE UPDATED, IN THE RANG
C          1 TO MD6.
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
C
C--FIND THE POSITION IN THE DETAILS AND CORE BUFFER
      I=IPOSN-1
      J=L6DTL+I*MD6DTL
      I=M6+I
C--FIND THE NEW MAXIMUM AND MINIMUM
      STORE(J)=AMIN1(STORE(J),STORE(I))
      STORE(J+1)=AMAX1(STORE(J+1),STORE(I))
C--ADD IN FOR THE MEAN AND R.M.S.
      STORE(J+2)=STORE(J+2)+STORE(I)
      STORE(J+3)=STORE(J+3)+STORE(I)*STORE(I)
      RETURN
      END
C
CODE FOR XCRD
      SUBROUTINE XCRD(IPOSN)
C--COMPUTE THE REFLECTIONS DETAILS AT THE POSITION INDICATED.
C
C  IPOSN   THE POSITION IN THE DETAILS RECORD TO BE COMPUTED, IN THE
C          RANGE 1 TO MD6.
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
C
C--CHECK IF ANY REFLECTIONS HAVE BEEN OUTPUT
      A=0.
      IF(N6W)1050,1050,1000
C--COMPUTE THE RECIPROCAL OF THE NUMBER OF REFLECTIONS OUTPUT
1000  CONTINUE
      A=1./FLOAT(N6W)
C--COMPUTE THE POSITION IN THE DETAILS RECORD
1050  CONTINUE
      I=L6DTL+(IPOSN-1)*MD6DTL
C--COMPUTE THE MEAN
      STORE(I+2)=STORE(I+2)*A
C--COMPUTE THE R.M.S. VALUE
      STORE(I+3)=SQRT(STORE(I+3)*A)
      RETURN
      END
C
CODE FOR XWRDTD
      SUBROUTINE XWRDTD(IULN)
C--WRITE THE REFLECTION DETAILS RECORD TO DISC
C
C  IULN    THE LIST THAT IS BEING OUTPUT AS A LIST TYPE 6.
C
C--
      DIMENSION IBUFF(8) , JBUFF(8)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
C
C--SET THE LIST TYPE
      LN=IULN
C--FIND THE RECORD ON DISC
      I=KFNDRI(IULN,107,J,IBUFF)
C--WRITE THE NEW DETAILS TO DISC
      CALL XUPF(IBUFF(4),STORE(L6DTL),IBUFF(3)-MD0)
C--FIND THE RECORD ON DISC
      I=KFNDRI(IULN,106,J,IBUFF)
C--WRITE THE NEW DETAILS TO DISC
      CALL XUPF(IBUFF(4),STORE(L6P),IBUFF(3)-MD0)
      RETURN
      END



CRYSTALS CODE FOR LISTS1
CODE FOR XALTES
      SUBROUTINE XALTES(LN,IV)
C--ALTER THE ERROR STATUS OF LIST TYPE 'LN'
C
C  LN  THE LIST TYPE NUMBER.
C  IV  THE SIGN OF THE NEW ERROR STATUS :
C
C      -1  ERROR LIST.
C      +1  NOT AN ERROR LIST.
C
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
      ISTAT = KLSCHK ( LN , 0 , 0 , ILSEXI , ILSNMS , I , IERNOP )
      IF ( ISTAT .GT. 0 ) CALL XLSALT ( LN , 0 , 0 , ILSERF , IV )
      RETURN
      END
C
CODE FOR KEXIST
      FUNCTION KEXIST(LN)
C--CHECK IF LIST 'LN' EXISTS.
C
C--RETURN VALUES ARE :
C
C  -1  LIST EXISTS, BUT IS MARKED AS AN ERROR LIST.
C   0  NO SUCH LIST EXISTS.
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C
C -- FIRST CHECK SERIAL NUMBER
      ISTAT = KLSCHK ( LN , 0 , 0 , ILSCLN , ILSMSG , I , IERPRG )
C -- THEN CHECK IF AVAILABLE. NO MESSAGE IF NOT AVAILABLE
      KEXIST = KLSCHK ( LN , 0 , 0 , ILSAVI , ILSNMS , I , IERNOP )
      RETURN
      END
C
CODE FOR XMKOWF
      SUBROUTINE XMKOWF(LN,IOWF)
C--ALTER THE OVERWRITE FLAG FOR A LIST.
C
C  LN      THE LIST TYPE.
C  IOWF    THE NEW OVERWRITE FLAG.
C
C          -1  THIS LIST IS BEING OVERWRITTEN.
C           0  THIS LIST IS READY TO BE USED.
C          +1  THIS LIST IS BEING CAREFULLY UPDATED.
C
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C -- CHECK THAT LIST EXISTS
      ISTAT = KLSCHK ( LN , 0 , 0 , ILSEXI , ILSNMS , I , IERNOP )
C -- IF IT DOES THEN ALTER FLAG
      IF ( ISTAT .GT. 0 ) CALL XLSALT ( LN , 0 , 0 , ILSOWF , IOWF )
      RETURN
      END
C
CODE FOR XWLIND
      SUBROUTINE XWLIND(LN,NFW,LL,IOWF,NEW)
C--WRITE THE ENTRY FOR A NEWLY CREATED LIST INTO THE FILE INDEX
C  AND THE CURRENT LIST INDEX.
C
C  LN   THE LIST TYPE NUMBER
C  NFW  FIRST WORD OCCUPIED BY THE LIST
C  LL   LIST LENGTH
C  IOWF  THE WRITE/OVERWRITE FLAG :
C
C        -1  THIS LIST IS STILL BEING OVERWRITTEN.
C         0  THIS LIST IS READY TO USE.
C        +1  THIS LIST IS STILL BEING CAREFULLY UPDATED.
C
C  NEW  THE NEW VERSION CONTROL FLAG :
C
C       -1  THIS IS NOT A NEW VERSION.
C        0  THIS IS A NEW VERSION.
C
C--
C
C
      DIMENSION ID(4)
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C
      EQUIVALENCE (INDEXF(5),IL)
      EQUIVALENCE (LIST(5),MLN)
C
C
      EQUIVALENCE (ID(1),XID(1))
C
C
C
      DATA I/0/,J/0/,K/0/,L/0/,M/0/,N/0/
C
      ISTAT = KLSCHK ( LN , 0 , 0 , ILSCLN , ILSMSG , I , IERPRG )
C--READ THE INFORMATION FOR THE CURRENT LIST OF THIS TYPE
      CALL XRLIND(LN,K,L,M,N,NOS,ID(1))
C--CHECK IF THIS IS AN OVERWRITE
      IF(NFW-L)1050,1000,1050
C--THIS IS AN OVERWRITE  -  CHECK THE LIST LENGTH
1000  CONTINUE
      LL=MAX0(LL,M)
C--UPDATE THE NEXT FREE DISC ADDRESS AS NECESSARY
1050  CONTINUE
      NLW=NFW+KINCRF(LL)
      N=MAX0(KNEXTF(I),NLW)
      CALL XNEXTF(N)
C--SET 'NLW' TO THE LAST WORD USED.
      NLW=NLW-1
C--BEGIN THE SEARCH FOR ALL LISTS OF THIS TYPE
      J=0
      CALL XFINDE(LN,0,I,-1)
C--CHECK FOR THE END OF THE FILE INDEX
1100  CONTINUE
      IF(I)1200,1200,1150
C--UPDATE THE CURRENT MAXIMUM SERIAL NUMBER
1150  CONTINUE
      J=MAX0(IABS(INDEXF(I+1)),J)
C--RESUME THE SEARCH
      CALL XFINDE(LN,0,I,0)
      GOTO 1100
C--COMPUTE THE NEW SERIAL NUMBER
1200  CONTINUE
      LSN=J+1
C--CHECK IF THIS IS A NEW VERSION
      IF(NEW)1300,1250,1250
C--THISI IS A NEW VERSION  -  MARK IT AS SUCH
1250  CONTINUE
      NOS=LSN
C--CHECK FOR AN OVERWRITE
1300  CONTINUE
      NOS=IABS(NOS)
      IF(NFW-L)1400,1350,1400
C--UPDATE  -  SEARCH FOR THE FILE INDEX BLOCK
1350  CONTINUE
      ISTAT = KLSCHK ( LN , K , 0 , ILSRFI , ILSMSG , I , IERPRG )
C--ENTER THE LIST INFORMATION IN THE FILE INDEX
1400  CONTINUE
      I=IABS(I)
      CALL XWLIE(INDEXF(I),LN,LSN,NFW,NLW,IOWF,NOS)
C--WRITE THE INDEX BACK TO DISC
      CALL XRWIBL(INDEXF(1))
C--UPDATE THE CURRENT LIST INDEX
      CALL XTTLI ( I, LN)
      CALL XRWIBL(LIST(1))
      IF ( ( ISSLSM .EQ. 3 ) .OR. ( ISSLSM .EQ. 4 ) ) THEN
C -- PRINT THE MESSAGE TO THE USER, IF REQUIRED
        IF ( ( ISSLNM .EQ. 0 ) .OR. ( ISSLNM .EQ. LN ) ) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE ( NCWU , 1450 ) LN , LSN , NFW , NLW , LL , NOS
      ENDIF
1450  FORMAT(/6H List ,I6,8H Serial ,I6,9H Address ,I8,4H To ,
     1 I8,8H Length ,I7,17H Original serial ,I6,/)
        WRITE ( NCAWU , 1460 ) LN , LSN , NOS
1460  FORMAT(15X,6H List ,I4,8H Serial ,I4,17H Original serial ,I4,
     1 2X,17H written to disc.)
        ENDIF
      ENDIF
      RETURN
      END
C
CODE FOR XRLIND
      SUBROUTINE XRLIND(LN,LSN,NFW,LL,IOW,NOS,DATE)
C--READ THE ENTRY FOR A LIST IN THE CURRENT INDEX TABLE
C
C  LN      THE LIST TYPE NUMBER
C  LSN     THE LIST SERIAL NUMBER
C  NFW     FIRST WORD OCCUPIED BY THE LIST
C          'NFW' IS SET NEGATIVE IF NO SUCH LIST EXISTS
C  LL      LIST LENGTH
C  IOW     THE UPDATE FLAG, TAKEN FROM THE LAST WRITE/OVERWRITE OPERATIO
C  NOS     THE SERIAL NUMBER OF THE ORIGINAL VERSION OF THIS LIST.
C  DATE    DATE THAT THE LIST WAS CREATED ON
C
C--
C
C
      DIMENSION DATE(2)
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C
      EQUIVALENCE (INDEXF(5),IL)
      EQUIVALENCE (LIST(5),MLN)
C
C
C
      DATA I / 0 /
C
C--CHECK IF THIS LIST NUMBER IS ALLOWED
      ISTAT = KLSCHK ( LN , 0 , 0 , ILSCLN , ILSMSG , I , IERPRG )
C--COMPUTE THE ADDRESS IN THE CURRENTLIST INDEX
      I=LN*IL+IL+1
      IF(LIST(I))1000,1000,1100
C--NO LIST STORED  -  SET THE FIRST WORD ADDRESS NEGATIVE
1000  CONTINUE
      NFW=-1
1050  CONTINUE
      RETURN
C--TRANSFER THE INFORMATION WE HAVE FOUND IN THE CURRENT LIST INDEX
1100  CONTINUE
      LSN=LIST(I+1)
      NFW=LIST(I+2)
      LL=(LIST(I+3)-LIST(I+2))/KINCRF(1)+1
      IOW=LIST(I+4)
      NOS=LIST(I+5)
      CALL XMOVE(LIST(I+6),DATE(1),1)
      CALL XMOVE(LIST(I+7),DATE(2),1)
      GOTO 1050
      END
C
CODE FOR KRCLI
      FUNCTION KRCLI(LN,LSN,NFW,NLW,IOWF,NOS,ID)
C--READ THE DETAILS OF A LIST FROM THE CURRENT LIST INDEX
C
C  LN      THE LIST TYPE.
C  LSN     THE LIST SERIAL NUMBER.
C  NFW     THE FIRST WORD USED.
C  NLW     THE LAST WORD USED.
C  IOWF    THE WRITE/OVERWRITE STATUS.
C  NOS     THE ORIGINAL SERIAL NUMBER.
C  ID      THE DATE CREATED.
C
C--RETURN VALUES OF 'KRCI' ARE :
C  -1  NO SUCH LIST.
C   0  LIST IS PRESENT.
C
C--
C
      DIMENSION ID(2)
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
C
      EQUIVALENCE (INDEXF(5),IL)
      EQUIVALENCE (LIST(5),MLN)
C
C--COMPUTE THE ADDRESS
      I=IABS(LN)*IL+IL+1
C--CHECK IF THE LIST EXISTS
      IF(LIST(I))1100,1000,1100
C--NO SUCH LIST
1000  CONTINUE
      KRCLI=-1
1050  CONTINUE
      RETURN
C--FETCH THE DETAILS
1100  CONTINUE
      LN=LIST(I)
      LSN=LIST(I+1)
      NFW=LIST(I+2)
      NLW=LIST(I+3)
      IOWF=LIST(I+4)
      NOS=LIST(I+5)
      ID(1)=LIST(I+6)
      ID(2)=LIST(I+7)
      KRCLI=0
      GOTO 1050
      END
C
CODE FOR XWCLI
      SUBROUTINE XWCLI(LN,LSN,NFW,NLW,IOWF,NOS,ID)
C--WRITE AN ENTRY INTO THE CURRENT LIST INDEX
C
C  LN      THE LIST TYPE.
C  LSN     THE LIST SERIAL NUMBER.
C  NFW     THE FIRST WORD USED.
C  NLW     THE LAST WORD USED.
C  IOWF    THE WRITE/OVERWRITE STATUS.
C  NOS     THE ORIGINAL SERIAL NUMBER.
C  ID      THE DATE CREATED.
C
C--
C
      DIMENSION ID(2)
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
C
      EQUIVALENCE (INDEXF(5),IL)
      EQUIVALENCE (LIST(5),MLN)
C
C--WRITE THE ENTRY INTO THE TABLE
      I=IABS(LN)*IL+IL+1
      LIST(I)=LN
      LIST(I+1)=LSN
      LIST(I+2)=NFW
      LIST(I+3)=NLW
      LIST(I+4)=IOWF
      LIST(I+5)=NOS
      LIST(I+6)=ID(1)
      LIST(I+7)=ID(2)
      CALL XRWIBL(LIST(1))
      RETURN
      END
C
CODE FOR KRFI
      FUNCTION KRFI(LN,LSN,NFW,NLW,IOWF,NOS,ID)
C--READ THE DATA FOR A LIST FROM THE FILE INDEX.
C
C  LN      THE LIST TYPE  -  NOT CHECKED BY THIS ROUTINE.
C  LSN     THE LIST SERIAL NUMBER. IF THIS IS ZERO, THE SEARCH BEGINS AT
C          START OF THE FILE INDEX. OTHERWISE, A PREVIOUS SEARCH IS RESU
C          THIS VARIABLE IS UPDATED UPON RETURN.
C  NFW     SET TO THE FIRST WORD USED ON RETURN.
C  NLW     SET TO THE LAST WORD USED ON RETURN.
C  IOWF    SET TO THE WRITE/OVERWRITE FLAG ON RETURN.
C  NOS     SET TO THE ORIGINAL SERIAL NUMBER ON RETURN.
C  ID      SET TO THE DATE OF CREATION ON RETURN.
C
C--RETURN VALUES OF 'KRFI' ARE :
C
C  -1  NO MORE LISTS OF THE TYPE INDICATED.
C   0  NEW LIST FOUND, AND ALL THE DATA ARE SET.
C
C--
C
      DIMENSION ID(2)
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
C
      EQUIVALENCE (INDEXF(5),IL)
      EQUIVALENCE (LIST(5),MLN)
C
C--SET THE LIST TYPE
      IULN=IABS(LN)
C--SET THE SERIAL NUMBER FOR THE CALL TO ZERO
      I=0
C--CHECK FOR A NEW SEARCH
      IF(LSN)1150,1000,1150
C--NEW SEARCH  -  INITIATE IT
1000  CONTINUE
      CALL XFINDE(IULN,I,J,-1)
C--CHECK FOR THE END
      IF(J)1050,1200,1200
C--NO MORE  -  SET THE RETURN VALUE
1050  CONTINUE
      KRFI=-1
1100  CONTINUE
      RETURN
C--RESUME THE SEARCH
1150  CONTINUE
      CALL XFINDE(IULN,I,J,0)
      IF(J)1050,1200,1200
C--SET THE RETURN VALUES
1200  CONTINUE
      LN=INDEXF(J)
      LSN=INDEXF(J+1)
      NFW=INDEXF(J+2)
      NLW=INDEXF(J+3)
      IOWF=INDEXF(J+4)
      NOS=INDEXF(J+5)
      ID(1)=INDEXF(J+6)
      ID(2)=INDEXF(J+7)
      KRFI=0
      GOTO 1100
      END
C
CODE FOR XWFI
      SUBROUTINE XWFI(LN,LSN,NFW,NLW,IOWF,NOS,ID,NEW)
C--WRITE AN ENTRY INTO THE FILE INDEX.
C
C  LN      THE LIST TYPE.
C  LSN     THE LIST SERIAL NUMBER
C  NFW     THE FIRST WORD USED.
C  NLW     THE LAST WORD USED.
C  IOWF    THE WRITE/OVERWRITE FLAG.
C  NOS     THE ORIGINAL SERIAL NUMBER.
C  ID      THE DATE CREATED.
C  NEW     THE NEW ENTRY FLAG :
C
C          -1  THIS IS NOT A NEW ENTRY  -  OVERWRITE THE INFORMATION
C              FOR THE LIST GIVEN BY 'LN' AND 'LSN'.
C           0  CREATE A NEW ENTRY.
C
C--
C
      DIMENSION ID(2)
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
C
      EQUIVALENCE (INDEXF(5),IL)
      EQUIVALENCE (LIST(5),MLN)
C
C--FIND THE TRUE VALUE OF 'LN'
      IULN=IABS(LN)
C--CHECK FOR A NEW ENTRY
      IF(NEW)1150,1000,1000
C--SET THE POINTERS TO HUNT TO THE END OF THE FILE INDEX TABLE
1000  CONTINUE
      IULN=0
      I=0
C--FIND THE NEXT ENTRY FOR THIS LIST
      CALL XFINDE(IULN,I,J,-1)
C--SET THE ENTRIES
1100  CONTINUE
      J=IABS(J)
      INDEXF(J)=LN
      INDEXF(J+1)=LSN
      INDEXF(J+2)=NFW
      INDEXF(J+3)=NLW
      INDEXF(J+4)=IOWF
      INDEXF(J+5)=NOS
      INDEXF(J+6)=ID(1)
      INDEXF(J+7)=ID(2)
C--REWRITE THE TABLE
      CALL XRWIBL(INDEXF(1))
      RETURN
C
C--SEARCH FOR A SPECIFIC ENTRY TO UPDATE
1150  CONTINUE
      IULSN=IABS(LSN)
      CALL XFINDL(IULN,IULSN,J,-1)
      GOTO 1100
      END
C
CODE FOR XSETFI
      SUBROUTINE XSETFI
C--START A FILE FROM SCRATCH BY CREATING THE FIRST FILE INDEX LINKS
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
      COMMON/XCOMPD/TITLE(20)
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (INDEXF(5),IL)
      EQUIVALENCE (LIST(5),MLN)
C
C
      DATA I/0/,J/0/,K/0/,L/0/,M/0/
C
C--FIND THE LENGTH OF A BLOCK IN THE FILE INDEX
      J=LNFLE
C--SET UP THE FIRST BLOCK ON THE DISC
      DO 1000 I=1,J
      INDEXF(I)=NOWT
1000  CONTINUE
C--COMPUTE THE NEXT FREE DISC ADDRESS
      L=KINCRS(J)
C--SET UP THE CONSTANTS FOR THE CONTROL BLOCK
      INDEXF(1)=L
      INDEXF(9)=J
C--WRITE THE INITIAL CONTROL BLOCK TO THE DISC
      CALL XUP(0,INDEXF(1),J)
      CALL XDUMP
C--FIND THE LENGTH OF A BLOCK ON THE DISC
      I=KNWR(J)
C--COMPUTE THE ADDRESS OF THE LAST WORD OF THE FIRST FILE INDEX BLOCK
      K=L+I-1
C--FIND THE LENGTH OF AN ENTRY IN AN INDEX
      IL=8
C--SET UP THE ENTRY IN THE INDEX BLOCK
      CALL XWLIE(INDEXF(1),IFILE,1,I,K,IL,J)
C--SET UP THE ENTRY IN THE PART TO BE WRITTEN OUT TO DISC
      CALL XMOVE(INDEXF(1),INDEXF(IL+1),IL)
C--ZERO THE REST OF THE BLOCK
      L=IL+IL+1
      DO 1050 M=L,J
      INDEXF(M)=0
1050  CONTINUE
C--MARK THE END OF THE CURRENT BLOCK OF THE FILE INDEX
      INDEXF(J+1)=IEND
C--WRITE THIS NEW BLOCK TO THE DISC
      CALL XRWIBL(INDEXF(1))
C--UPDATE THE CONTROL BLOCK  -  FETCH IT BACK
      CALL XDOWN(0,INDEXF(IL+1),J)
      INDEXF(IL+1)=K+1
      INDEXF(IL+3)=I
C--SET UP THE DEFAULT TITLE
      INDEXF(IL+7)=10
      M=IL+INDEXF(IL+7)
      CALL XMOVE(TITLE(1),INDEXF(M+1),20)
      CALL OVERFL(M)
C--OUTPUT THE CONTROL BLOCK TO THE DISC
      CALL XUP(0,INDEXF(IL+1),J)
      CALL XDUMP
C--SET UP THREE FILE INDEX TABLES
      MAXMLN=2*(J/IL)
      K=-1
      L=MLN+1
      M=0
      DO 1100 I=1,MAXMLN
      CALL XFINDE(L,M,N,K)
      K=0
1100  CONTINUE
      RETURN
      END
C
CODE FOR XSETLI
      SUBROUTINE XSETLI
C--SET UP THE CURRENT LIST INDEX TABLE ON A NEW FILE
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
C
      EQUIVALENCE (INDEXF(5),IL)
      EQUIVALENCE (LIST(5),MLN)
C
C
C
      DATA I/0/,J/0/,K/0/,L/0/
C
C--BRING DOWN THE CONTROL BLOCK
      CALL XLDCBL(INDEXF(IL+1),5)
C--FIND THE DISC ADDRESS FOR THE CURRENT LIST INDEX BLOCK
      J=KNWR(I)
      J=(INDEXF(IL+1)+J-1)/J*J
C--FIND THE LENGTH OF EACH ENTRY AND THE NUMBER OF ENTRIES ALLOWED
      K=LNLST
      MLN=K/IL-2
      L=J+KINCRS(K)
C--CHECK THAT THERE IS ENOUGH ROOM
      CALL XUP(L,LIST(1),1)
C--ALTER THE FLAGS IN THE CONTROL BLOCK
      INDEXF(IL+1)=L+KINCRF(1)
      INDEXF(IL+5)=J
C--SET UP THE CONTROL INFORMATION IN THE CURRENT LIST INDEX ARRAY
      L=L-1
      CALL XWLIE(LIST(1),ILIST,1,J,L,MLN,K)
      CALL XMOVE(LIST(1),LIST(IL+1),IL)
C--CLEAR THE TABLE BEFORE WRITING IT TO THE DISC
      L=IL+IL+1
      DO 1050 I=1,MLN
      DO 1000 K=1,IL
      LIST(L)=0
      L=L+1
1000  CONTINUE
1050  CONTINUE
C--TERMINATE THE TABLE AND WRITE IT TO THE DISC
      LIST(L)=IEND
      CALL XRWIBL(LIST(1))
C--REWRITE THE CONTROL BLOCK
      CALL XUP(0,INDEXF(IL+1),INDEXF(IL+9))
      CALL XDUMP
C--SET THE CURRENT VERSION OF EACH LIST AS THE LAST CREATED
      CALL XSETCL
      RETURN
      END
C
CODE FOR XSETCL
      SUBROUTINE XSETCL
C--ENTRY FOR RESETTING THE LIST INDEX SO THAT IT CONTAINS ALL THE LATEST
C  LISTS THAT HAVE BEEN WRITTEN
C
C--
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
C
      EQUIVALENCE (INDEXF(5),IL)
      EQUIVALENCE (LIST(5),MLN)
C
C
C
      DATA I/0/,J/0/
C
      CALL XLC
      J=1
C--FETCH THE NEXT BLOCK OF THE FILE INDEX FROM THE DISC
1000  CONTINUE
      I=IL+1
      CALL XFCFI(J,I)
      J=I+IL
C--CHECK FOR THE END OF THE CURRENT BLOCK
1050  CONTINUE
      IF(INDEXF(J)-IFILE)1100,1000,1250
C--CHECK IF THIS POSITION CONTAINS AN ENTRY
1100  CONTINUE
      IF(INDEXF(J))1200,1200,1150
1150  CONTINUE
      CALL XTTLI ( J, LN)
C--MOVE ONTO THE NEXT ENTRY
1200  CONTINUE
      J=J+IL
      GOTO 1050
C--REWRITE THE CURRENT LIST INDEX TO THE DISC
1250  CONTINUE
      CALL XRWIBL(LIST(1))
      RETURN
      END
C
CODE FOR XFINDL
      SUBROUTINE XFINDL(LN,LSN,L,ITYPE)
C--FIND THE GIVEN LIST ANS CHECK THAT IT DOES EXIST IN THE FILE INDEX.
C
C  LN    THE LIST NUMBER.
C  LSN   THE LIST SERIAL NUMBER.
C  L     THE ADDRESS OF THE ENTRY IN THE FILE INDEX  -  SET ON RETURN.
C  ITYPE   THE TYPE OF CALL :
C
C          -1  SYSTEM CALL.
C           0  USER CALL.
C          +1  PROBABLY USER CALL, BUT COULD BE SYSTEM.
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C
C--SEARCH FOR THE LIST
      CALL XFINDE(LN,LSN,L,-1)
C--CHECK IF THIS INDICATES A NEW ENTRY
      IF(L)1000,1000,1100
C--NEW ENTRY  -  LIST DOES NOT EXIST
1000  CONTINUE
      ISTAT = IERERR
      IF ( ITYPE .LT. 0 ) ISTAT = IERPRG
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)LN,LSN
      ENDIF
      WRITE(NCAWU,1050)LN,LSN
1050  FORMAT(11H List type ,I5,21H  with serial number ,I8,
     2 24H  is not present on disc)
      CALL XERHND ( ISTAT )
      RETURN
1100  CONTINUE
      RETURN
      END
C
CODE FOR XFINDE
      SUBROUTINE XFINDE(LN,LSN,IADD,IT)
C--SEARCH THE FILE INDEX TO FIND THE LIST OF TYPE LN
C
C  LN    LIST TYPE (IF EQUAL TO 0, THE NEXT FREE LOCATION IS FOUND)
C  LSN   LIST SERIAL NUMBER  (IF EQUAL TO 0, THE FIRST LIST OF TYPE 'LN'
C        IS RETURNED, OTHERWISE BOTH 'LN' AND 'LSN' MUST MATCH)
C  IADD  ADDRESS OF THE ENTRY IN THE INDEX AFTER A SUCCESSFUL FIND
C        IADD IS SET NEGATIVE WHEN A NEW INDEX TABLE IS CREATED
C  IT    THE TYPE OF ENTRY :
C        -1  START A NEW SEARCH
C         0  RESUME AN OLD SEARCH
C
C--THIS SUBROUTINE ASSUMES THAT 'LSN' IS GREATER THAN ZERO, ALTHOUGH
C  'LN' MAY TAKE ANY VALUE.
C
C--
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
C
C
      COMMON /XFINDC/I,J,K,L,M,N,LASTA,LASTL,NSER,NNN
C
      EQUIVALENCE (INDEXF(5),IL)
      EQUIVALENCE (LIST(5),MLN)
C
C--CHECK IF THIS IS AN INITIAL ENTRY OR A RESUME
      IF(IT)1000,1100,1100
C--INITIAL ENTRY
1000  CONTINUE
      I=1
1050  CONTINUE
      J=IL+1
      CALL XFCFI(I,J)
      I=J
C--RESUME THE SEARCH
1100  CONTINUE
      I=I+IL
      IADD=-I
C--CHECK IF THERE ARE ANY MORE ENTRIES IN THE FILE INDEX
      IF(INDEXF(I))1150,1350,1150
C--CHECK FOR THE END OF THIS BLOCK OF THE FILE INDEX
1150  CONTINUE
      IF(INDEXF(I)-IFILE)1200,1050,1450
C--CHECK IF THIS IS THE LIST TYPE WE WANT
1200  CONTINUE
      IF(IABS(INDEXF(I))-LN)1100,1250,1100
C--CHECK IF WE ARE SEARCHING FOR A SPECIFIC SERIAL NUMBER
1250  CONTINUE
      IF(LSN)1400,1300,1400
C--WE WANT THE NEXT LIST OF THIS TYPE IN THE FILE INDEX
1300  CONTINUE
      IADD=I
1350  CONTINUE
      RETURN
C--WE ARE SEARCHING FOR A SPECIFIC SERIAL NUMBER
1400  CONTINUE
      IF(IABS(INDEXF(I+1))-IABS(LSN))1100,1300,1100
C--END OF INDEX  -  CREATE ANOTHER TABLE AND LINK IT IN
1450  CONTINUE
      IF(INDEXF(I)-IEND)1650,1500,1650
C--RECORD THE ADDRESS AND LENGTH OF THE LAST BLOCK OF THE INDEX
1500  CONTINUE
      LASTA=INDEXF(IL+3)
      LASTL=INDEXF(IL+6)
C--INCREMENT THE SERIAL NUMBER OF THE BLOCK
      NSER=INDEXF(IL+2)+1
C--FIND THE NUMBER OF WORDS IN A DISC BLOCK
      M=KNWR(I)
C--COMPUTE THE DISC ADDRESS OF THE NEXT BLOCK
      L=(KNEXTF(I)+M-1)/M*M
C--FIND THE NUMBER OF WORDS IN AN INDEX BLOCK
      N=LNFLE
C--COMPUTE THE LAST WORD OF THE NEW BLOCK
      M=L+KINCRS(N)-1
C--SET UP THE NEW ENTRY
      CALL XWLIE(INDEXF(IL+1),IFILE,NSER,L,M,IL,N)
      K=IL+IL+1
      IADD=-K
C--SET ALL THE ENTRIES IN THIS NEW BLOCK TO ZERO
1550  CONTINUE
      INDEXF(K)=0
      K=K+1
      IF(K-I)1550,1600,1600
C--MARK THE END OF THE INDEX
1600  CONTINUE
      INDEXF(I)=IEND
      J=INDEXF(IL+3)
      K=INDEXF(IL+6)
C--OUTPUT THE NEW BLOCK TO THE DISC
      CALL XRWIBL(INDEXF(1))
C--UPDATE THE NEXT FREE ADDRESS POINTER
      CALL XNEXTF(M+1)
C--BRING DOWN THE OLD LIST INDEX BLOCK
      CALL XDOWN(LASTA,INDEXF(IL+1),LASTL)
C--ALTER THE INDEX ENTRY OF THE TERMINATOR
      CALL XWLIE(INDEXF(I),INDEXF(IL+1),NSER,L,M,INDEXF(IL+6),N)
C--REWITE THIS BLOCK TO THE DISC
      CALL XRWIBL(INDEXF(1))
C--LOAD THE NEWLY CREATED BLOCK FROM THE DISC AGAIN
      CALL XDOWN(J,INDEXF(IL+1),K)
      I=IABS(IADD)
      GOTO 1350
C
C--ERROR BECAUSE THE FILE INDEX HAS BEEN CORRUPTED
1650  CONTINUE
      CALL XDSMSG ( 2 )
      STOP
      END
C
CODE FOR XPRTLI
      SUBROUTINE XPRTLI
C--PRINT THE CURRENT LIST INDEX
C
      COMMON/XLISTS/LIST(424)
C
      CALL XLC
      CALL XPRT(1,LIST)
      CALL XLOADL
      RETURN
      END
C
CODE FOR XPRTFI
      SUBROUTINE XPRTFI
C--PRINT THE COMPLETE FILE INDEX
C
      COMMON/XFILE/INDEXF(424)
C
      EQUIVALENCE (INDEXF(5),IL)
C
      CALL XLC
      CALL XFCFI(1,(IL+1))
      CALL XPRT(2,INDEXF)
      RETURN
      END
C
CODE FOR XPRT
      SUBROUTINE XPRT(IN,ID)
C--COMMON PRINT ROUTINES FOR THE CURRENT LIST INDEX AND THE FILE INDEX
C
C  IN=1  PRINT THE CURRENT LIST INDEX
C  IN=2  PRINT THE FILE INDEX
C  ID    THE INDEX ENTRY THAT IS TO BE PRINTED
C
C--
C
      DIMENSION ID(424)
C
C
      CHARACTER*20 CINDEX(2)
      CHARACTER*20 CDELET(3)
      CHARACTER*10 CERROR(2)
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
C
      EQUIVALENCE (INDEXF(5),IL)
C
C
      EQUIVALENCE (IB,IC)
C
C
C
      DATA CINDEX / ' current list index ' , ' index of file lists' /
      DATA CERROR / '          ' , 'Error list' /
      DATA CDELET / '                    ' , '  not to be deleted ' ,
     2              '            deleted ' /
C
      DATA I / 0 / , J / 0 / , L / 0 /
C
C
C--PRINT THE HEADER FOR THE TOP OF THE NEXT PAGE
1000  CONTINUE
      CALL XPRTCN
C**MACHINE SPECIFIC IN ALL PROBABILITY
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1050 ) CINDEX(IN) , ID(IL+2) , ID(IL+3) ,
     2 ID(IL+6) , ID(IL+7) , ID(IL+8)
      ENDIF
1050  FORMAT ( 1X , 'Print' , A , '  part' , I3 , 5X , 'Address' , I8 ,
     2 5X , 'Length' , I7 , 5X , 'Created on ' , 2A4 / )
      WRITE ( NCAWU , 1060 ) CINDEX(IN) ,  ID(IL+2)
1060  FORMAT ( 1X , 'Print' , A , ' part ' , I3 )
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1100 )
      ENDIF
1100  FORMAT ( 17X , 'List type    Serial no.       Address        ' ,
     2 'Use flag    Orig. serial    Date created' / )
      WRITE ( NCAWU , 1110 )
1110  FORMAT ( 18X , 'Type Serial Use Origin' / )
C
      I = IL + IL + 1
C--CHECK FOR THE END OF THE CURRENT INDEX BLOCK
1150  CONTINUE
      IF(ID(I)-IFILE)1200,1700,1900
1200  CONTINUE
C -- CHECK IF THERE IS AN ENTRY TO PRINT AT THIS POSITION IN THE BLOCK
      IF ( ID(I) .EQ. 0 ) GO TO 1650
C
      J = I + 7
C
C -- CHECK IF THIS LIST IS MARKED AS AN ERROR LIST
C
      IERROR = 1
      IF ( ID(I+5) .LT. 0 ) IERROR = 2
C
C -- CHECK IF THE LIST HAS BEEN DELETED
C
      IDELET = 1
      IF ( ID(I) .LT. 0 ) THEN
        IDELET = 3
      ELSE IF ( ID(I+1) .LT. 0 ) THEN
        IDELET = 2
      ENDIF
C
C -- WRITE DETAILS FOR THIS LIST
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1450 ) CDELET(IDELET),(ID(L),L=I,J),CERROR(IERROR)
      ENDIF
1450  FORMAT ( A , I6 , I11 , I13, ' to' , I8, I9, I14, 9X, 2A4, 6X, A )
C
      WRITE ( NCAWU , 1451 ) CDELET(IDELET) , ID(I) , ID(I+1) ,
     2 ID(I+4) , ID(I+5) , ID(I+6) , ID(I+7) , CERROR(IERROR)
1451  FORMAT ( A , I4 , 1X , I6 , 1X , I3 , 1X , I4 , 3X , 2A4 , 6X, A )
C
C
1650  CONTINUE
C
C -- GET NEXT LIST
      I = I + IL
      GOTO 1150
C
C
C--FETCH THE NEXT BLOCK OF INFORMATION
1700  CONTINUE
      CALL XFCFI(I,(IL+1))
C--CHECK IF THIS INDEX IS EMPTY
      I=IL+IL+1
C--CHECK FOR THE END OF THE CURRENT TABLE
1750  CONTINUE
      IF(ID(I)-IFILE)1800,1700,1900
C--THIS NOT THE END OF THE BLOCK  -  CHECK FOR AN ENTRY
1800  CONTINUE
      IF(ID(I))1000,1850,1000
C--EMPTY  -  CHECK THE NEXT
1850  CONTINUE
      I=I+IL
      GOTO 1750
C--END OF THE COMPLETE INDEX  -  PRINT THE NEXT FREE WORD
1900  CONTINUE
      CALL XDASUM
C
      CALL XLINES
      RETURN
      END
C
CODE FOR XWTTLE
      SUBROUTINE XWTTLE
C--WRITE THE COMPOUND OR TILE TO DISC
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XCOMPD/TITLE(20)
C
      EQUIVALENCE (INDEXF(5),IL)
C
      CALL XLC
C--LOAD THE CONTROL BLOCK
      CALL XLDCBL(INDEXF(IL+1),0)
C--COMPUTE THE ADDRESS OF THE TITLE AND THEN READ IT
      J=INDEXF(IL+7)+IL+1
C--STORE THE TITLE IN THE CONTROL BLOCK
      CALL XMOVE(TITLE(1),INDEXF(J),20)
      CALL OVERFL(J)
C--REWRITE THE CONTROL TO THE DISC
      CALL XUP(0,INDEXF(IL+1),INDEXF(IL+9))
      CALL XDUMP
      RETURN
      END
C
CODE FOR XPRTCN
      SUBROUTINE XPRTCN
C--PRINT THE NAME  TOGETHER WITH THE PAGE FLIPS ETC.
C
C
C
      DIMENSION ID(4)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
      COMMON/XCOMPD/TITLE(20)
C
      COMMON/XNWPGE/NWPAGE
C
C
      EQUIVALENCE (XID(1),ID(1))
C
      CALL XLC
C**MACHINE SPECIFIC
      CALL XDATE(ID(1),ID(2))
      CALL XTIME(ID(3),ID(4))
C--CHECK IF A NEW PAGE IS REQUIRED
      IF(NWPAGE)1100,900,900
C--NEW PAGE IS REQUIRED
900   CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)TITLE,ID
      ENDIF
1000  FORMAT(1H1,20A4,5X,6HDate  ,2A4,4X,6HTime  ,2A4//)
      GOTO 1300
C--A NEW PAGE IS NOT REQUIRED
1100  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)TITLE,ID
      ENDIF
1200  FORMAT(//1H ,20A4,5X,6HDate  ,
     2 2A4 , 4X , 'Time  ' , 2A4 , // )
C--AND NOW RETURN
1300  CONTINUE
      RETURN
      END
C
CODE FOR XLC
      SUBROUTINE XLC
C--INITIAL SUBROUTINE TO LOAD ALL THE FILE INDEX INFORMATION
C
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
C
C
C--CHECK IF THE SYSTEM HAS ALREADY BEEN INITIALISED
      IF(IACCL)1000,1050,1050
1000  CONTINUE
      CALL XLOADF
      CALL XLOADL
      IACCL=1
1050  CONTINUE
      RETURN
      END
C
CODE FOR XLOADL
      SUBROUTINE XLOADL
C--LOAD THE DETAILS OF THE LIST INDICES AT THE START OF A RUN
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
C
      EQUIVALENCE (INDEXF(5),IL)
C
C--LOAD THE CONTROL BLOCK
      CALL XLDCBL(LIST(1),0)
C--LOAD THE FIRST 32 WORDS OF THE CURRENT LIST INDEX
      CALL XDOWN(LIST(5),LIST,32)
C--CHECK THAT THE BLOCK WE HAVE LOADED IS A CURRENT LIST INDEX
      IF(LIST(1)-ILIST)1000,1050,1000
1000  CONTINUE
      CALL XDSMSG ( 3 )
C--CHECK THAT THE LENGTH OF THE INDEX IS REASONABLE
1050  CONTINUE
      IF(LIST(6)-LNLST)1150,1150,1100
1100  CONTINUE
      CALL XDSMSG ( 1 )
C--LOAD THE WHOLE OF THE CURRENT LIST INDEX
1150  CONTINUE
      CALL XDOWN(LIST(3),LIST(IL+1),LIST(6))
      RETURN
      END
C
CODE FOR XLOADF
      SUBROUTINE XLOADF
C--LOAD THE DETAILS OF THE FILE INDEX WHEN BEGINNING TO USE A FILE
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XCOMPD/TITLE(20)
C
C
C
      DATA J / 0 /
C
C--READ DOWN THE CONTROL BLOCK
      CALL XLDCBL(INDEXF(1),0)
C--STORE THE TITLE OF THE COMPOUND IN ITS ARRAY
      J=INDEXF(7)
      CALL XMOVE(INDEXF(J+1),TITLE(1),20)
      CALL OVERFL(J)
C--LOAD THE FIRST BLOCK OF THE FILE INDEX
      INDEXF(6)=INDEXF(9)
      CALL XFCFI(1,1)
      RETURN
      END
C
CODE FOR XLDCBL
      SUBROUTINE XLDCBL(IA,IFLAG)
C--LOAD THE FIRST BLOCK ON THE DISC  -  THE CONTROL BLOCK
C
C  IA      THE ARRAY INTO WHICH THE BLOCK SHOULD BE LOADED
C  IFLAG   THE NUMBER OF A LOCATION THAT MAY BE UNSET  -  GENERALLY
C          THE ADDRESS OF THE CURRENT LIST INDEX, WITH A VALUE OF 5.
C
C--
      DIMENSION IA(*)
C
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
C
C
C
C
      DATA I/0/
C
C--READ DOWN THE FIRST NINE WORDS
      CALL XDOWN(0,IA(1),9)
C--CHECK THAT ALL THE VALUES HAVE BEEN SET POSITIVE
      DO 1050 I=1,9,2
      IF(IA(I))1000,1000,1050
C--VALUE IS NOT POSITIVE  -  CHECK IF IT MUST BE SET
1000  CONTINUE
      IF(I-IFLAG)1150,1050,1150
1050  CONTINUE
C--CHECK THAT THE BLOCK TO BE LOADED IS NOT TOO LONG
      IF(IA(9)-LNFLE)1100,1100,1150
C--ALL OKAY  -  LOAD THE BLOCK AND RETURN
1100  CONTINUE
      LENGTH = MIN0 ( LNFLE - 8 , IA(9) )
      CALL XDOWN ( 0 , IA(1) , LENGTH )
      RETURN
C
C--DISC IS NOT A SYSTEM DISC OR IS CORRUPT
1150  CONTINUE
      CALL XDSMSG ( 1 )
      STOP
      END
C
CODE FOR XWLIE
      SUBROUTINE XWLIE(LOC,LN,LSN,NFW,NLW,IOW,NOS)
C--WRITE LIST INDEX ENTRY
C
C  LOC  IS THE ADDRESS WHERE THE ENTRY IS TO BE MADE
C  LN   THE LIST TYPE NUMBER
C  LSN  THE LIST SERIAL NUMBER
C  NFW  FIRST WORD OCCUPIED BY THE LIST
C  NLW  LAST  WORD OCCUPIED BY THE LIST
C  IOW  THE UPDATE FLAG, TAKEN FROM THE LAST WRITE/OVERWRITE OPERATION.
C  NOS  THE SERIAL NUMBER OF THE ORIGINAL VERSION OF THIS LIST.
C
C--THIS SUBROUTINE SETS THE DATE
C
C--
C
C
      DIMENSION LOC(8)
C
      LOC(1)=LN
      LOC(2)=LSN
      LOC(3)=NFW
      LOC(4)=NLW
      LOC(5)=IOW
      LOC(6)=IABS(NOS)
C**MACHINE SPECIFIC
      CALL XDATE(LOC(7),LOC(8))
      RETURN
      END
C
CODE FOR XTTLI
      SUBROUTINE XTTLI ( IN, LN)
C--TRANSFER AN ENTRY FROM 'INDEXF(IN)' TO THE CURRENT LIST INDEX
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
C
      EQUIVALENCE (INDEXF(5),IL)
      EQUIVALENCE (LIST(5),MLN)
C
C
C
      DATA I/0/,J/0/,K/0/
C
C--COMPUTE ITS ADDRESS
      I=INDEXF(IN)*IL+IL+1
      J=IN
C--PRESERVE THE ORIGINAL SERIAL NUMBER OF THE ORIGINAL VERSION OF THIS L
      K=LIST(I+5)
C--MOVE THE ENTRY ACROSS
      CALL XMOVE(INDEXF(J),LIST(I),IL)
C--MARK THIS LIST AS NOT AN ERROR LIST
      LIST(I+5)=IABS(LIST(I+5))
C----- ONLY CHECK THE LIST 6 ERROR STATUS SINCE THIS CONSISTS OF A
C      SEPARAT HEADER AND BODY
      IF (LN .NE. 6 ) GOTO 1050
C--CHECK IF THE LIST WAS ORIGINALLY MARKED AS AN ERROR LIST
      IF(K)1000,1050,1050
C--THIS LIST SHOULD BE MARKED AS AN ERROR LIST
1000  CONTINUE
      LIST(I+5)=-LIST(I+5)
1050  CONTINUE
      RETURN
      END
C
CODE FOR XFCFI
      SUBROUTINE XFCFI(I,J)
C--FETCH THE CURRENT FILE INDEX
C
C  I  ADDRESS OF THE INFORMATION OF THE NEXT FILE INDEX
C     IN 'INDEX'
C  J  ADDRESS AT WHICH THE INFORMATION IS TO BE BROUGHT DOWN
C     IN 'INDEX'.
C
C--
      COMMON/XFILE/INDEXF(424)
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
C
C
C
C
      DATA K/0/,L/0/
C
C--FIND THE ADDRESS ANF LENGTH OF THE BLOCK DEFINED BY 'I'
      K=INDEXF(I+2)
      L=INDEXF(I+5)
C--BRING DOWN THE REQUIRED BLOCK
      CALL XDOWN(K,INDEXF(J),L)
C--CHECK THAT THE FILE INDEX IS CORRECTLY SET UP AND HAS NOT BEEN
C  CORRUPTED
      IF(INDEXF(J)-IFILE)1050,1000,1050
1000  CONTINUE
      RETURN
1050  CONTINUE
      CALL XDSMSG ( 2 )
      STOP
      END
C
CODE FOR XRWIBL
      SUBROUTINE XRWIBL(IND)
C--REWRITE AN INDEX BLOCK TO THE DISC
C
C--
      DIMENSION IND(424)
      COMMON/XFILE/INDEXF(424)
C
      EQUIVALENCE (INDEXF(5),IL)
C
C--REWRITE THE BLOCK
      CALL XUP(IND(IL+3),IND(IL+1),IND(IL+6))
C--ENSURE THAT THE TRANSFER IS COMPLETE
      CALL XDUMP
      RETURN
      END
C
CODE FOR KNEXTF
      FUNCTION KNEXTF(IN)
C--ASSIGN THE NEXT FREE FLOATING POINT LOCATION
C
C  IN  DUMMY ARGUMENT WHICH IS NOT USED
C
C--
C
C
C
      DIMENSION ID(4)
C
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
C
C
C
      EQUIVALENCE (XID(1),ID(1))
C
      CALL XDOWN(0,ID(1),1)
      KNEXTF=ID(1)
      RETURN
      END
C
CODE FOR XNEXTF
      SUBROUTINE XNEXTF(IN)
C--WRITE THE VALUE OF 'IN' AS THE NEW NEXT FREE LOCATION
C
C  IN  NEW NEXT FREE DISC ADDRESS (IN 24 BIT WORDS)
C
C--
C
C
      DIMENSION ID(4)
C
      COMMON/XFILEC/IFILE,ILIST,IEND,LNFLE,LNLST,IACCL,XID(4)
C
C
C
      EQUIVALENCE (XID(1),ID(1))
C
      ID(1)=IN
      CALL XUP(0,ID(1),1)
      CALL XDUMP
      RETURN
      END
C
CODE FOR XLINES
      SUBROUTINE XLINES
C--OUTPUT A FEW BLANK LINES TO SEPARATE PARTS OF AJOB
C
C--
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C--PRINT THE BLANK LINES
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)
      ENDIF
1000  FORMAT(//1H )
      RETURN
      END
C
C
CODE FOR XDSMSG
      SUBROUTINE XDSMSG ( ICODE )
C -- COMMON OUTPUT ROUTINE FOR FATAL DISC ERRORS
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
C
      GO TO ( 2100 , 2200 , 2300 , 9910 ) , ICODE
      GO TO 9910
C
2100  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2105 )
      ENDIF
      WRITE ( NCAWU , 2105 )
2105  FORMAT ( 1X , 'The disc file has been corrupted or is ' ,
     2 'not a system file' )
      GO TO 8000
C
2200  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2205 )
      ENDIF
      WRITE ( NCAWU , 2205 )
2205  FORMAT ( 1X , 'The file index has been corrupted' )
      GO TO 8000
C
2300  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2305 )
      ENDIF
      WRITE ( NCAWU , 2305 )
2305  FORMAT ( 1X , 'The current list index has been corrupted' )
      GO TO 8000
C
8000  CONTINUE
      CALL XERHND ( IERCAT )
      STOP
C
9910  CONTINUE
      CALL XOPMSG ( IOPCRY , IOPINT , 0 )
      STOP
      END
C
C
C
CODE FOR KLSCHK
      FUNCTION KLSCHK ( LN , LSN , LRSN , IREQ , IMSG , IADDR , IERR )
C
C -- GENERAL LIST CHECKING ROUTINE
C
C    LN      LIST TYPE
C   LSN      SERIAL NUMBER
C  LRSN      RELATIVE SERIAL NUMBER. ONLY USED IF LSN = 0
C  IREQ      REQUEST TYPE. VALUES ARE:-
C
C      ILSCLN     1       CHECK FOR VALID LIST TYPE. LSN/LRSN NOT USED
C      ILSCLS     2       CHECK FOR VALID LIST TYPE/SERIAL. LRSN NOT
C                          USED.
C      ILSCLV     3       CHECK FOR VALID LIST SERIAL NUMBER. LN/LRSN
C                          NOT USED.
C      ILSEXI     4       CHECK IF A LIST OF THIS TYPE/SERIAL EXISTS.
C      ILSAVI     5       CHECK IF A LIST OF THIS TYPE/SERIAL CAN BE
C                          USED.
C      ILSRFI     6       CHECK LIST EXISTS AND LOCATE IT IN FILE INDEX
C            THESE VALUES ARE SET IN COMMON BLOCK /XLSVAL/
C
C  IMSG      MESSAGE FLAG.
C
C      ILSNMS    -1      NO MESSAGE
C      ILSMSG    +1      ERROR MESSAGES PRINTED
C            THESE VALUES ARE SET IN COMMON BLOCK /XLSVAL/
C
C IADDR      ADDRESS OF FILE INDEX ENTRY FOR THE REQUESTED LIST. SET
C            FOR REQUEST TYPE 'ILSRFI' , AND
C            REQUEST TYPES 'ILSEXI' AND 'ILSAVI' IF INDEX IS READ
C  IERR      ERROR FLAG. TYPE OF ERROR TO SIGNAL, IF ANY. FOR REQUESTS
C            OF TYPE 'ILSAVI' , INVALID LN OR LSN OR LRSN
C            CAUSE PROGRAMMING ERROR TO BE SIGNALLED.
C
C            RETURN VALUES :-
C                 -1      ERROR DURING PROCESSING.
C                  1      LIST CHECK SUCCESSFUL
C
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C
      EQUIVALENCE (INDEXF(5),IL)
      EQUIVALENCE (LIST(5),MLN)
C
      IFAIL = -1
C
C -- ENSURE THAT THE SYSTEM IS INITIALISED
      CALL XLC
C
C -- SET READ FILE INDEX FLAG
      IRDFIL = -1
      IF ( LSN .NE. 0 ) IRDFIL = 1
      IF ( LRSN .NE. 0 ) IRDFIL = 1
      IF ( IREQ .EQ. ILSRFI ) IRDFIL = 1
C
C -- FIRST SECTION. CHECK IS 'LIST TYPE'
      IF ( IREQ .EQ. ILSCLV ) GO TO 2100
      IF ( LN .LE. 0 ) GO TO 9910
      IF ( LN .GT. MLN ) GO TO 9910
C
2100  CONTINUE
C -- SERIAL O.K. OR SKIPPED. NEXT CHECK IS 'SERIAL NUMBER'
      IF ( IREQ .EQ. ILSCLN ) GO TO 8000
      LSER = LSN
      IF ( LSN .NE. 0 ) GO TO 2200
C -- PROCESSING OF RELATIVE SERIAL NUMBER. NOT ALLOWED FOR 'ILSCLS'
      IF ( IREQ .EQ. ILSCLS ) GO TO 9920
C -- LOOK UP CURRENT LIST IN INDEX.
      I = IL + IL * LN + 1
      IF ( LIST(I) .EQ. 0 ) GO TO 9930
      LSER = IABS ( LIST(I+1) ) + LRSN
2200  CONTINUE
C -- CHECK CALCULATED SERIAL NUMBER VALID
      IF ( LSER .LE. 0 ) GO TO 9920
C
C -- LIST TYPE/SERIAL O.K.  NEXT CHECK IS 'EXISTS'
      IF ( IREQ .LT. ILSEXI ) GO TO 8000
C -- FIND THE ACTUAL LIST REQUESTED.
      IF ( IRDFIL .GE. 1 ) GO TO 3100
      GO TO 3200
3100  CONTINUE
      CALL XFINDE ( LN , LSER , IADDR , -1 )
C -- CHECK THAT THERE IS A LIST OF THE REQUESTED TYPE/SERIAL .
      IF ( IADDR .LE. 0 ) GO TO 9940
      ITYPE = INDEXF(IADDR)
      IUSAGE = INDEXF(IADDR+4)
      IERROR = INDEXF(IADDR+5)
      GO TO 4000
C
3200  CONTINUE
      LOCLST = IL + ( IL * LN ) + 1
      IF ( LIST(LOCLST) .EQ. 0 ) GO TO 9940
      ITYPE = LIST(LOCLST)
      IUSAGE = LIST(LOCLST+4)
      IERROR = LIST(LOCLST+5)
      GO TO 4000
C
4000  CONTINUE
C -- LIST REQUESTED HAS NOW BE LOCATED. NEXT CHECK IS 'AVAILABLE'
      IF ( IREQ .LT. ILSAVI ) GO TO 8000
      IF ( IREQ .EQ. ILSRFI ) GO TO 8000
C -- FAILURES NOW INDICATE LIST NOT AVAILABLE
      IFAIL = 0
C -- CHECK THAT LIST IS AVAILABLE FOR USE
      IF ( ITYPE .LE. 0 ) GO TO 9950
      IF ( IUSAGE .LT. 0 ) GO TO 9960
      IF ( IERROR .LE. 0 ) GO TO 9970
C
C
8000  CONTINUE
      KLSCHK = 1
      RETURN
C
C
9910  CONTINUE
      IF ( IMSG .LT. 0 ) GO TO 9990
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 ) LN
      ENDIF
      WRITE ( NCAWU , 9915 ) LN
9915  FORMAT ( 1X , I8 , ' is not a valid list type number' )
      GO TO 9990
9920  CONTINUE
      IF ( IMSG .LT. 0 ) GO TO 9990
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 ) LSER
      ENDIF
      WRITE ( NCAWU , 9925 ) LSER
9925  FORMAT ( 1X , I8 , ' is not a valid list serial number' )
      GO TO 9990
9930  CONTINUE
      IF ( IMSG .LT. 0 ) GO TO 9992
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9935 ) LN
      ENDIF
      WRITE ( NCAWU , 9935 ) LN
9935  FORMAT ( 1X , 'No list of type ' , I8 , ' stored' )
      GO TO 9992
9940  CONTINUE
      IF ( IMSG .LT. 0 ) GO TO 9992
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9945 ) LN , LSER
      ENDIF
      WRITE ( NCAWU , 9945 ) LN , LSER
9945  FORMAT ( 1X , 'No list of type ' , I8 , ' and serial ' , I8 ,
     2 ' stored' )
      GO TO 9992
9950  CONTINUE
      IF ( IMSG .LT. 0 ) GO TO 9992
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9955 ) LN , LSER
      ENDIF
      WRITE ( NCAWU , 9955 ) LN , LSER
9955  FORMAT ( 1X , 'List type ' , I8 , ' with serial ' , I8 ,
     2 ' has been deleted' )
      GO TO 9992
9960  CONTINUE
      IF ( IMSG .LT. 0 ) GO TO 9992
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9965 ) LN , LSER
      ENDIF
      WRITE ( NCAWU , 9965 ) LN , LSER
9965  FORMAT ( 1X , 'List type ' , I8 , ' with serial ' , I8 ,
     2 ' is marked as being written to' )
      GO TO 9992
9970  CONTINUE
      IF ( IMSG .LT. 0 ) GO TO 9992
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9975 ) LN , LSER
      ENDIF
      WRITE ( NCAWU , 9975 ) LN , LSER
9975  FORMAT ( 1X , 'List type ' , I8 , ' with serial ' , I8 ,
     2 ' is marked as an error list' )
      GO TO 9992
C
9990  CONTINUE
      ISTAT = IERR
      IF ( IREQ .EQ. ILSAVI ) ISTAT = IERPRG
      GO TO 9995
9992  CONTINUE
      ISTAT = IERR
9995  CONTINUE
      CALL XERHND ( ISTAT )
      KLSCHK = IFAIL
      RETURN
C
      END
C
C
C
CODE FOR XLSALT
      SUBROUTINE XLSALT ( LN , LSN , LRSN , IFLAG , IVALUE )
C
C -- GENERAL LIST FLAG ALTERING ROUTINE
C
C    LN      LIST TYPE.
C   LSN      LIST SERIAL NUMBER.
C  LRSN      LIST RELATIVE SERIAL NUMBER. ( ONLY USED IF LSN = 0 )
C IFLAG      LIST FLAG TO ALTER. VALUES ARE :-
C
C      SYMBOL      VALUE  USE
C      ------      -----  ---
C      ILSERF      1      ERROR
C      ILSRTF      2      RETAIN FLAG
C      ILSPUF      2      PURGE
C      ILSDLF      3      DELETE
C      ILSOWF      4      OVERWRITE
C      ILSCUR      5      CURRENT LIST
C
C            VALUES ARE SET IN COMMON BLOCK /XLSVAL/
C
C IVALUE     NEW VALUE ( IGNORED FOR IFLAG = 5 )
C
C      SYMBOL     VALUE   USE                     USED WITH
C      ------     -----   ---                     ---- ----
C      ILSSET     -1      SET FLAG                ERROR/RETAIN DELETE
C      ILSCLR     +1      CLEAR FLAG              ERROR/RETAIN/DELETE
C
C      ILSOVR     -1      LIST BEING OVERWRITTEN  OVERWRITE
C      ILSRDY      0      LIST READY              OVERWRITE
C      ILSUPD     +1      LIST BEING UPDATED      OVERWRITE
C
C
      LOGICAL WRFILE , WRCURR , REQCUR
C
      COMMON/XFILE/INDEXF(424)
      COMMON/XLISTS/LIST(424)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (INDEXF(5),IL)
      EQUIVALENCE (LIST(5),MLN)
C
C
C -- CHECK THAT REQUESTED LIST EXISTS
      ISTAT = KLSCHK ( LN , LSN , LRSN , ILSRFI , ILSMSG ,
     2 INDFIL , IERERR )
      IF ( ISTAT .LE. 0 ) GO TO 9900
C
C -- SET UP DATA REQUIRED
      INDCUR = IL + ( IL * LN ) + 1
      LSNCUR = IABS ( LIST(INDCUR+1) )
      LSNREQ = IABS ( INDEXF(INDFIL+1) )
C -- WRFILE/WRCURR INDICATE THAT FILE/CURRENT INDEX IS TO BE REWRITTEN
      WRFILE = .TRUE.
      WRCURR = .TRUE.
      REQCUR = ( LSNCUR .EQ. LSNREQ )
C
C -- BRANCH ON REQUESTED FUNCTION.
      GO TO ( 1000 , 2000 , 3000 , 4000 , 5000 , 9910 ) , IFLAG
      GO TO 9910
C
1000  CONTINUE
C -- ALTER 'ERROR' FLAG
      IOFF = 5
      INEWVL = IVALUE * MAX0 ( IABS ( LIST(INDCUR+5) ) , 1 )
      GO TO 4500
C
2000  CONTINUE
C -- ALTER 'PURGE' FLAG
      IOFF = 1
      INEWVL = IVALUE * IABS ( INDEXF(INDFIL+1) )
      GO TO 4500
C
3000  CONTINUE
C -- ALTER 'DELETE' FLAG
      IF ( .NOT. REQCUR ) GO TO 3100
C -- CURRENT VERSION TO BE ALTERED. WARN USER, IF DELETE FLAG SET
      IF ( IVALUE .NE. ILSSET ) GO TO 3100
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 3005 ) LN , LSNCUR
      ENDIF
      WRITE ( NCAWU , 3005 ) LN , LSNCUR
3005  FORMAT ( 1X , 'List type ' , I3 , ' with serial number ' , I5 ,
     2 ' is the current version. ' ,
     3 / ,' This should not be deleted. You may still save this list' )
      CALL XERHND ( IERWRN )
3100  CONTINUE
      IOFF = 0
      INEWVL = IVALUE * IABS ( INDEXF(INDFIL) )
      GO TO 4500
C
4000  CONTINUE
C -- ALTER 'OVERWRITE' FLAG
      IOFF = 4
      INEWVL = IVALUE
      GO TO 4500
C
4500  CONTINUE
C -- COMMON ROUTINE TO ALTER REQUIRED FLAGS
      WRCURR = REQCUR
      ICURFL = INDCUR + IOFF
      IFILFL = INDFIL + IOFF
      IF ( WRCURR ) LIST(ICURFL) = INEWVL
      IF ( WRFILE ) INDEXF(IFILFL) = INEWVL
      GO TO 8000
C
5000  CONTINUE
C -- ALTER CURRENT LIST
      CALL XTTLI (INDFIL, LN)
      GO TO 8000
C
8000  CONTINUE
C -- FINISH PROCESSING
      IF ( WRCURR ) CALL XRWIBL ( LIST(1) )
      IF ( WRFILE ) CALL XRWIBL ( INDEXF(1) )
      RETURN
C
9900  CONTINUE
C -- ERRORS
      RETURN
9910  CONTINUE
C -- INTERNAL ERROR
      CALL XOPMSG ( IOPCRY , IOPINT , 0 )
      GO TO 9900
      END



CRYSTALS CODE FOR LISTS2
CODE FOR XLDLST
      SUBROUTINE XLDLST(IULN,ICOMMN,IDIMN,IOWF)
C--LOAD A LIST INTO CORE FROM THE DISC
C
C  IULN    THE LIST TYPE. THIS MAY BE SET NEGATIVE,
C          IN WHICH CASE THE LIST IS PREPARED FOR LOADING
C          AND THE ADDRESS OF THE FIRST RECORD IS RETURNED IN
C          'ICOMMN(1)'. NO DATA IS ACTUALLY LOADED INTO CORE
C          IF 'IULN' IS NEGATIVE.
C  ICOMMN  THE COMMON BLOCK TO BE SET UP.
C  IDIMN    THE DIMENSION OF THE COMMON BLOCK.
C  IOWF    THE WRITE/OVERWRITE STATUS, WHICH WILL BE USED ON THIS LIST :
C
C          -1  READ THE LIST, THEN REWRITE IT.
C           0  READ THE LIST ONLY.
C          +1  READ THE LIST, THEN CAREFULLY UPDATE IT.
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION IBUFF(8) , JBUFF(8)
C
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK THAT THE LIST TYPE IS VALID
      LN=IABS(IULN)
      IREC=0
      ISTAT = KLSCHK ( LN , 0 , 0 , ILSAVI , ILSMSG , I , IERERR )
      IF ( ISTAT  .LE. 0 ) GO TO 9900
C  -- ZERO THE COMMON BLOCK
      CALL XZEROF ( ICOMMN(1) , IDIMN )
C--READ THE DETAILS OF THE LIST
      CALL XRLIND(LN,LSN,IADDI,I,J,K,IBUFF(1))
C
C -- MONITOR OPERATION IF REQUIRED
      IF ( ( ISSLSM .EQ. 2 ) .OR. ( ISSLSM .EQ. 4 ) ) THEN
        IF ( ( ISSLNM .EQ. 0 ) .OR. ( ISSLNM .EQ. LN ) ) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,900)LN,LSN,IADDI,I,J,K,IBUFF(1),IBUFF(2)
      ENDIF
900     FORMAT(5H List,I4,7H Serial,I4,5H From,I8,7H Length,I8,
     1 13H Write status,I4,16H Original serial,I4,7H Date  ,2A4,
     2 14H being loaded. )
        WRITE(NCAWU,910)LN,LSN,IBUFF(1),IBUFF(2)
910     FORMAT(15X,6H List ,I4,8H Serial ,I4,6H Date ,2A4,
     1 9X,17H is being loaded.)
        ENDIF
      ENDIF
C
      LSN=IABS(LSN)
C--CHECK IF THIS LIST WAS BEING WRITTEN TO DURING JOB TERMINATION
      IF ( J ) 9910 , 1150 , 1100
1100  CONTINUE
      IF ( IOWF .LE. 0 ) GO TO 9910
C--CHECK THAT THE LIST IS NOT MARKED AS AN ERROR LIST
1150  CONTINUE
      IF ( K .LT. 0 ) GO TO 9920
C--SEARCH FOR THE INTER-DEPENDENCIES RECORD
      K=0
      IF(KFNDRI(LN,1,IADDR,IBUFF))1850,1350,1350
C--RECORD FOUND  -  SET UP SOME POINTERS
1350  CONTINUE
      L=IBUFF(4)
      N=IBUFF(5)
C--FIND THE INCREMENTS
      N1=KINCRF(N)
      M1=KINCRF(1)
C--CHECK IF THERE ARE MORE INTER-DEPENDENCIES TO CHECK
1400  CONTINUE
      IF(N)1750,1750,1450
C--BRING DOWN THE NEXT GROUP
1450  CONTINUE
      CALL XDOWNF(L,IBUFF(1),1)
      L1=L+N1
      L=L+M1
      N=N-1
C--READ THE DATA FROM THE INDICATED LIST TYPE
      CALL XRLIND(IBUFF(1),I,IBUFF(3),IBUFF(4),IBUFF(5),J,IBUFF(6))
C--CHECK IF SUCH A LIST EXISTS
      IF(IBUFF(3))1500,1500,1600
C--LIST DOES NOT EXIST  -  PRINT THE ERROR MESSAGE
1500  CONTINUE
      K=K+1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1550)LN,IBUFF(1)
      ENDIF
      WRITE(NCAWU,1550) LN,IBUFF(1)
1550  FORMAT(11H List type ,I5,25H  depends upon list type ,I5,
     2 33H  which does not exist at present)
      GOTO 1400
C--CHECK THE VALUE
1600  CONTINUE
      CALL XDOWNF(L1,IBUFF(2),1)
      IF(IABS(J)-IBUFF(2))1650,1400,1650
C--NOT THE CORRECT SERIAL NUMBER
1650  CONTINUE
      K=K+1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1700)LN,IBUFF(1),IBUFF(2)
      ENDIF
1700  FORMAT(11H List type ,I5,25H  depends upon list type ,I5,
     2 26H  with original serial no.,I8,
     3 38H  not the current version of this list)
      GOTO 1400
C--ALL INTERDEPENDENCIES PROCESSED
1750  CONTINUE
      IF ( K .GT. 0 ) GO TO 9930
C--SET UP THE POINTERS TO PROCESS EACH RECORD IN TURN
1850  CONTINUE
      I=0
C--CHECK IF THE DATA SHOULD BE LOADED
      IF(IULN)1900,1900,1950
C--NO DATA IS TO BE LOADED  -  SET THE DISC ADDRESS
1900  CONTINUE
      ICOMMN(1)=IADDI
      GOTO 2050
C--READ DOWN THE NEXT HEADER BLOCK
1950  CONTINUE
      IF(KLDDRH(I,IADDI,IBUFF(1)))2050,2000,2000
C--LOAD THE RELEVANT INFORMATION FROM THE NEXT RECORD
2000  CONTINUE
      CALL XLDREC(LN,LSN,IBUFF,ICOMMN,IDIMN,-1)
      GOTO 1950
2050  CONTINUE
      RETURN
9900  CONTINUE
      RETURN
9910  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 ) LN
      ENDIF
      WRITE ( NCAWU , 9915 ) LN
9915  FORMAT ( 1X , 'A previous job failed when writing list ' , I5 ,
     2 ' which cannot now be accessed' )
      CALL XERHND ( IERERR )
      GO TO 9900
9920  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 ) LN
      ENDIF
      WRITE ( NCAWU , 9925 ) LN
9925  FORMAT ( 1X , 'List type ' , I5 , ' is marked as an error list' ,
     2 / , 1X , 'A new version needs to be created or input ' )
      CALL XERHND ( IERERR )
      GO TO 9900
9930  CONTINUE
C -- LIST CANNOT BE LOADED BECAUSE OF INTERDEPENDCIES
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9935 ) LN
      ENDIF
      WRITE ( NCAWU , 9935 ) LN
9935  FORMAT ( 1X , 'List type ' , I5 , ' cannot be loaded' )
      CALL XERHND ( IERERR )
      GO TO 9900
      END
C
CODE FOR XLDREC
      SUBROUTINE XLDREC(IULN,IULSN,IBUFF,ICOMMN,IDIMN,ITYPE)
C--LOAD THE RELEVANT DATA FOR THE RECORD WHOSE HEADER IS IN 'IBUFF'.
C
C  IULN    THE CURRENT LIST TYPE.
C  IULSN   THE CURRENT LIST SERIAL NUMBER.
C  IBUFF   THE HEADER BLOCK OF THE RECORD TO BE LOADED, WHICH MUST BE
C          SET ON ENTRY.
C  ICOMMN  THE COMMON BLOCK FOR THIS LIST.
C  IDIMN    THE DIMENSION OF 'ICOMMN'.
C  ITYPE   THE TYPE OF DATA AREA TO SET UP IN CORE :
C
C          -1  A NORMAL DATA RECORD.
C           0  A DATA AREA AT THE TOP OF CORE, STARTING AT 'LFL'.
C
C--
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ISTORE(131072)
C
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      LN=IULN
      LSN=IULSN
C--COMPUTE THE DATA AREA LENGTH
      M=MAX0(IBUFF(5)*IBUFF(6),0)
C--CHECK IF THERE IS DATA TO BE LOADED FROM THIS RECORD.
      IF(IBUFF(7))1000,1100,1100
C--NO DATA TO BE LOADED  -  CREATE ONLY A RECORD HEADER
1000  CONTINUE
      K=IBUFF(4)
      M=0
C--CHECK THE TYPE OF LOAD INDICATED
      L=NOWT
      IF(ITYPE)1050,1300,1300
C--NORMAL LOAD  -  CREATE THE RECORD HEADER
1050  CONTINUE
      L=KCEDR(LN,LSN,IBUFF(7),IBUFF(5),0,IBUFF(8))
      GOTO 1300
C--CHECK ON THE TYPE OF LOAD REQUIRED
1100  CONTINUE
      IF(ITYPE)1200,1150,1150
C--AREA AT THE TOP OF CORE
1150  CONTINUE
      IREC=IBUFF(7)
      K=KCHLFL(M)
      GOTO 1250
C--DATA TO BE LOADED  -  ALLOCATE SPACE
1200  CONTINUE
      K=KCEDR(LN,LSN,IBUFF(7),IBUFF(5),IBUFF(6),IBUFF(8))
C--SET UP THE LAST ADDRESS
1250  CONTINUE
      L=K+MAX0(0,M-1)
C--CHECK IF THERE IS A COMMON BLOCK OFFSET GIVEN
1300  CONTINUE
      J=IBUFF(8)
      IF(J)1400,1400,1350
C--SET UP THE COMMON BLOCK
1350  CONTINUE
      ICOMMN(J)=K
      ICOMMN(J+1)=L
      ICOMMN(J+2)=IBUFF(5)
      ICOMMN(J+3)=IBUFF(6)
C--CHECK IF THERE IS DATA TO LOAD
1400  CONTINUE
      IF(M)1500,1500,1450
C--BRING DOWN THE DATA
1450  CONTINUE
      CALL XDOWNF(IBUFF(4),STORE(K),M)
C--CHECK IF WE SHOULD UPDATE THE LIST HEADER BLOCK
1500  CONTINUE
      IF(ITYPE)1550,1600,1600
C--UPDATE THE TOTAL LENGTH OF THE DATA AREA
1550  CONTINUE
      CALL XUDRH(LN,IBUFF(7),IBUFF(5),IBUFF(6))
C--AND NOW RETURN
1600  CONTINUE
      RETURN
      END
C
CODE FOR XWLSTD
      SUBROUTINE XWLSTD(IULN,ICOMMN,IDIMN,IOWFLG,NEW)
C--WRITE A NEW LIST AND ITS DATA TO THE DISC.
C
C  IULN    THE LIST TYPE.
C          THIS VALUE MAY BE NEGATIVE, IN WHICH CASE 'IOWFLG' IS
C          ASSUMED TO BE 0 AND NO DATA RECORDS ARE OUTPUT TO THE DISC.
C          THE CORRECT FLAGS OTHERWISE ARE SET UP.
C          THE DISC POINTERS ARE SET IN THE COMMON BLOCK AS FOLLOWS :
C
C          ICOMMN(1)  THE ADDRESS OF THE LAST RECORD OUTPUT (=0).
C          ICOMMN(2)  THE ADDRESS OF THE NEXT RECORD TO BE OUTPUT.
C          ICOMMN(4)  THE LENGTH OUTPUT SO FAR (=0).
C
C  ICOMMN  THE COMMON BLOCK ASSOCIATED WITH THIS LIST.
C  IDIMN    THE DIMENSION OF THE COMMON BLOCK.
C  IOWFLG  THE WRITE/OVERWRITE STATUS FOR THIS LIST :
C
C          -1  ATTEMPT AN OVERWRITE.
C           0  WRITE A COMPLETELY NEW LIST.
C          +1  ATTEMPT A CAREFUL OVERWRITE.
C
C  NEW     THE NEW LIST FLAG :
C
C          -1  THIS IS NOT A NEW VERSION OF THIS LIST.
C           0  THIS IS A NEW LIST, WITH LINKS TO OTHER EXISTING LISTS.
C          +1  THIS IS A NEW LIST, WITH NO LINKS TO OTHER EXISTING
C              LISTS. THIS IS NORMALLY THE CASE WHEN THE LIST HAS JUST B
C              INPUT.
C
C--DATA RECORDS WHICH ARE IN CORE ARE WRITTEN TO THE DISC BY
C  THIS ROUTINE. IF ALL THE DATA RECORDS HAVE BEEN OUTPUT, THE
C  WRITE/OVERWRITE FLAG IS LEFT CLEAR AT THE END AND THE LIST IS
C  MARKED AS NOT IN ERROR. IF ALL THE DATA HAS NOT BEEN OUTPUT,
C  THIS CLEARING IS NOT DONE, AND IS LEFT TO THE CALLING ROUTINE.
C
C--IF THE COMMON BLOCK OFFSET IS GIVEN, 'XUDRH' IS CALLED TO TAKE THE
C  LATEST VALUES FROM THE COMMON BLOCK AND INSERT THEM IN THE DATA RECOR
C
C--
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ISTORE(131072)
C
C
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--ASSIGN THE WRITE/OVERWRITE FLAG
      IOWF=IOWFLG
C -- ASSIGN LIST TYPE
      LN = IABS ( IULN )
C -- CHECK FOR VAID LIST NUMBER
      ISTAT = KLSCHK ( LN , 0 , 0 , ILSCLN , ILSMSG , INDLST , IERPRG )
C
C ** FIRST SECTION. CHECK IF AN EXISTING LIST CAN BE OVERWRITTEN BY
C    THE NEW LIST. IOWF IS SET TO 0 IF A NEW LIST IS BEING CREATED
C -- CHECK IF THIS IS A NEW LIST
      IF ( IULN .LT. 0 ) IOWF = 0
C -- THE NEXT PART COMBINES PROCESSING OF THE LIST IN CORE WITH A
C    CHECK THAT THE LIST, IF TO BE OVERWRITTEN, MATCHES THE DISC COPY
      IREC = 0
      CALL XRLIND ( LN,I,IADDI,N,K,L,IBUFF(1) )
C -- CHECK IF LIST EXISTS. IF NOT CREATE NEW LIST
      IF ( IADDI .LE. 0 ) IOWF = 0
C -- CHECK IF LIST CAN BE PURGED. IF NOT CREATE NEW LIST
      IF ( I .LT. 0 ) IOWF = 0
C -- CHECK IF LIST CAN BE OVERWRITTEN. IF NOT CREATE NEW LIST
      IF ( K .LT. 0 ) IOWF = 0
C -- FIND LIST IN CORE
      I = KHUNTR ( LN , 0 , M0TEMP , J , K , 0 )
1300  CONTINUE
C -- FIND NEXT RECORD, OR JUMP TO NEXT PART IF NO MORE
      IF (  KCHNCB ( J )  .GT.  0  ) GO TO 1800
C -- GET COMMON BLOCK OFFSET
      K = ISTORE(J+7)
C -- CHECK IF THE PARAMETER IS SET
      IF ( K .LE. 0 ) GO TO 1450
C -- UPDATE THE HEADER BLOCK
      ICOMMN(K+2) = MAX0 ( ICOMMN(K+2) , 0 )
      ICOMMN(K+3) = MAX0 ( ICOMMN(K+3) , 0 )
      ISTORE(J+4) = ICOMMN(K+2)
      ISTORE(J+5) = ICOMMN(K+3)
      ISTORE(J+2) = MD0 + ( ISTORE(J+4) * ISTORE(J+5) )
1450  CONTINUE
C -- IF THIS IS A NEW LIST, PROCEED TO NEXT RECORD
      IF ( IOWF .EQ. 0 ) GO TO 1300
C -- NOW CHECK MATCH BETWEEN CORE AND DISC LISTS
C -- SEARCH FOR THE RECORD ON THE DISC
      IF ( KFNDRI ( LN,ISTORE(J+6),IADDR,IBUFF) .LT. 0 ) GO TO 1750
C -- CHECK DATA FOR THIS RECORD IS ON DISC
      IF ( IBUFF(4) .LE. 0 ) GO TO 1750
C -- CHECK LENGRP
      IF ( IBUFF(5) .NE. ISTORE(J+4) ) GO TO 1750
C -- CHECK NGRP
      IF ( IBUFF(6) .NE. ISTORE(J+5) ) GO TO 1750
C -- CHECK HEADER LENGTH
      IF ( IBUFF(3) .NE. ( MD0 + ISTORE(J+4)*ISTORE(J+5) ) ) GO TO 1750
      GO TO 1300
1750  CONTINUE
C -- MISMATCH. NO OVERWRITE
      IOWF = 0
      GO TO 1300
C
1800  CONTINUE
      IOWFM = IOWF
C -- IF PREVIOUS VERSION OF LIST EXISTS, MARK ITS OVERWRITE FLAG
      IF ( IADDI .GT. 0 ) CALL XLSALT ( LN , 0 , 0 , ILSOWF , IOWFM )
C--SET UP THE POINTERS TO THE RECORD CHAIN
      J=M0TEMP+3
C--FIND THE NEXT FREE DISC ADDRESS AND LAST ADDRESS USED
      IADDR=KNEXTF(J)
      IADDL=0
C--CHECK IF THIS IS AN OVERWRITE
      IF(IOWF)1950,1850,1950
C--NOT AN OVERWRITE  -  SET THE INITIAL ADDRESS AND LENGTH COUNTER
1850  CONTINUE
      IADDI=IADDR
      N=0
C--CHECK IF THE COMON BLOCK REQUIRES SETTING
      IF(IULN)1900,1900,1950
C--SET THE FIRST ENTRIES OF THE COMMON BLOCK
1900  CONTINUE
      ICOMMN(1)=IADDL
      ICOMMN(2)=IADDR
      ICOMMN(4)=0
C--COUNTER FOR THE NUMBER OF RECORDS NOT OUTPUT
1950  CONTINUE
      I=0
C--MOVE TO THE NEXT DATA RECORD
2000  CONTINUE
      IF(KCHNCB(J))2050,2050,2550
C--ANOTHER RECORD FOUND  -  CHECK IF THIS IS AN INTERDEPENDENCIES RECORD
2050  CONTINUE
      IF(ISTORE(J+6)-1)2400,2100,2400
C--INTERDEPENDENCIES RECORD  -  UPDATE IT
2100  CONTINUE
      N1=ISTORE(J+4)
      L1=ISTORE(J+3)
C--CHECK IF THERE ARE MORE RELATIONSHIPS TO CHECK FOR
2150  CONTINUE
      IF(N1)2400,2400,2200
C--ASSIGN THE DEPENDENCY AS NOT EXISTING INITIALLY
2200  CONTINUE
      K1=L1+ISTORE(J+4)
      ISTORE(K1)=0
C--CHECK IF THIS LIST HAS ANY LINKS TO OTHER LISTS
      IF(NEW)2250,2250,2350
C--READ THE DATA FOR THE CURRENT LIST
2250  CONTINUE
      CALL XRLIND(ISTORE(L1),IBUFF(1),IBUFF(2),IBUFF(3),IBUFF(4),
     2 IBUFF(5),IBUFF(6))
C--CHECK IF A LIST OF THE CORRECT TYPE EXISTS
      IF(IBUFF(2))2350,2350,2300
C--SUCH A LIST DOES EXIST  -  ALTER THE ENTRY
2300  CONTINUE
      ISTORE(K1)=IABS(IBUFF(5))
C--UPDATE FOR THE NEXT LIST TYPE
2350  CONTINUE
      L1=L1+1
      N1=N1-1
      GOTO 2150
C--OUTPUT THE RECORD TO THE DISC
2400  CONTINUE
      IF(IULN)2000,2000,2450
C--OUTPUT THE DATA RECORD
2450  CONTINUE
      CALL XWDRTD(LN,ISTORE(J+6),IADDL,IADDR,N,ICOMMN,IDIMN,IOWF,IBUFF)
C--CHECK IF THIS RECORD WAS WRITTEN, OR JUST ITS HEADER BLOCK
      IF(ISTORE(J+6))2500,2000,2000
C--RECORD NOT WRITTEN  -  COUNT IT
2500  CONTINUE
      I=I+1
      GOTO 2000
C
C--ALL RECORDS THAT CAN BE PROCESSED HAVE BEEN OUTPUT
2550  CONTINUE
      IF(IULN)2800,2800,2600
C--CHECK FOR AN NEW LIST
2600  CONTINUE
      IF(IOWFM)2700,2650,2700
C--NEW LIST  -  MARK FOR WRITING
2650  CONTINUE
      IOWFM=-1
C--WRITE THE DETAILS OF THE LIST TO THE DISC
2700  CONTINUE
      CALL XWLIND(LN,IADDI,N,IOWFM,NEW)
C--CHECK IF WE HAVE OUTPUT THE COMPLETE LIST
      IF(I)2750,2750,2800
C--CLEAR THE FLAGS
2750  CONTINUE
      CALL XLSALT ( LN , 0 , 0 , ILSOWF , ILSRDY )
      CALL XLSALT ( LN , 0 , 0 , ILSERF , ILSCLR )
2800  CONTINUE
      RETURN
      END
C
C
C
CODE FOR KLSSPC
      FUNCTION KLSSPC ( IULN , ICOMMN , IDIMN , IFLAG )
C
C -- THIS ROUTINE ESTIMATES THE SPACE REQUIRED FOR LIST TYPE 'LN',
C    AND EXTENDS THE DISC FILE TO FIT THE NEW LIST.
C    THE COMMON BLOCK OFFSETS FOR EACH RECORD ARE OBTAINED FROM THE
C    CORE CHAIN. THE LENGTHS OF EACH RECORD ARE CALCULATED FROM THE
C    COMMON BLOCK RATHER THAN THE RECORD HEADERS
C
C      VALUES FOR IFLAG :-
C            1            DISPLAY ESTIMATED SIZE FOR EACH RECORD AND
C                         TOTAL FOR LIST
C            2            DISPLAY ESTIMATED SIZE FOR LIST
C            3            NO DISPLAY OF ESTIMATED SIZES
C
C      RETURN VALUE IS NUMBER OF RECORDS REQUIRED FOR LIST
C
      DIMENSION ICOMMN(IDIMN)
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XDISC/NU
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      ISPACE = 0
C
      I = KHUNTR ( IULN , 0 , J , IADDR , K , 0 )
C
2000  CONTINUE
      I = KCHNCB ( IADDR )
      IF ( I .GT. 0 ) GO TO 3000
      IREC = ISTORE(IADDR+6)
      IOFF = ISTORE(IADDR+7)
      IREQ = ICOMMN(IOFF+2) * ICOMMN(IOFF+3) + MD0
      ISPACE = ISPACE + IREQ
      IF ( IFLAG .GT. 1 ) GO TO 2000
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2005 ) IREC , IULN , IREQ
      ENDIF
      WRITE ( NCAWU , 2005 ) IREC , IULN , IREQ
2005  FORMAT ( 1X , 'Space required for record type ' , I6 ,
     2 ' in list ' , I4 , ' is ' , I6 , ' word(s)' )
      GO TO 2000
C
3000  CONTINUE
      CALL XDACVI ( NWDR , NWDB , NBYWD )
      IBLCK = ( ISPACE / NWDB ) + 1
      IREC = ( ISPACE / NWDR ) + 1
C
      IF ( IFLAG .GT. 2 ) GO TO 3010
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 3005 ) IULN , ISPACE , IBLCK , IREC
      ENDIF
      WRITE ( NCAWU , 3005 ) IULN , ISPACE , IBLCK , IREC
3005  FORMAT ( 1X , 'Total space required for new list ' , I3 ,
     2 ' is ' , I7 , ' word(s)' )
C
3010  CONTINUE
      IADD = KDAFRE ( NU , -1 , IREC )
      IF ( IADD .LE. 0 ) GO TO 3100
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 3015 ) IADD , IULN
      ENDIF
      WRITE ( NCAWU , 3015 ) IADD , IULN
3015  FORMAT ( 1X , 'Disc file extended by ' , I5 , ' record(s) ' ,
     2 'for new list ' , I4 )
3100  CONTINUE
      KLSSPC = IREC
      RETURN
      END
C
CODE FOR XWDRTD
      SUBROUTINE XWDRTD(IULN,IUREC,IADDL,IADDR,N,ICOMMN,IDIMN,IOWF,
     2   IBUFF)
C--THIS ROUTINE WRITES A DATA RECORD TO THE DISC.
C
C  IULN    THE LIST TYPE.
C  IUREC   THE RECORD TYPE.
C  IADDL   THE DISC ADDRESS OF THE LAST HEADER BLOCK, OR ZERO
C          FOR THE START OF THE CHAIN.
C  IADDR   THE ADDRESS OF THE CURRENT HEADER BLOCK. ON RETURN, 'IADDL'
C          POINTS TO THE RECORD JUST OUTPUT, AND 'IADDR' IS UPDATED TO
C          POINT AT THE LOCATION FOR THE NEXT RECORD.
C  N       THE LIST LENGTH, UPDATED BY THE CURRENT RECORD LENGTH ON
C          RETURN.
C  ICOMMN  THE COMMON BLOCK FOR THIS LIST.
C  IDIMN    THE LENGTH OF THE COMMON BLOCK.
C  IOWF    THE WRITE/OVERWRITE FLAG.
C  IBUFF   AN AREA TO ASSEMBLE THE RECORD HEADER FOR THE DISC.
C
C--IF THIS IS AN OVERWRITE, 'IADDL' IS NOT USED AND 'IADDR' IS FOUND
C  FROM THE RECORD ALREADY ON THE DISC.
C
C--
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ISTORE(131072)
C
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--FIND THE RECORD IN CORE
      K=KHUNTR(IULN,IUREC,I,J,IADDD,0)
C--CHECK IF THIS IS AN OVERWRITE
      IF(IOWF)1000,1050,1000
C--THIS IS AN OVERWRITE  -  FIND THE RECORD ON DISC
1000  CONTINUE
      M=KFNDRI(LN,ISTORE(J+6),IADDR,IBUFF)
      IADDD=IBUFF(4)
C--ALTER THE RECORD LENGTH
      CALL XUPF(IADDR+KINCRF(2),ISTORE(J+2),1)
C--ALTER THE NUMBER OF GROUPS IF NECESSARY
      CALL XUPF(IADDR+KINCRF(5),ISTORE(J+5),1)
      GOTO 1200
C--THIS IS A NEW LIST  -  CHECK IF THIS IS THE FIRST RECORD
1050  CONTINUE
      IF(IADDL)1100,1150,1100
C--NOT THE FIRST  -  ADJUST THE POINTER IN THE LAST
1100  CONTINUE
      IBUFF(1)=IADDR
      CALL XUPF(IADDL,IBUFF(1),1)
C--CREATE THE HEADER BLOCK FOR THIS RECORD
1150  CONTINUE
      CALL XMOVE(ISTORE(J),IBUFF(1),MD0)
C--ALTER THE ADDRESS PPINTERS
      IBUFF(1)=0
      IBUFF(2)=IADDL
C--UPDATE THE ADDRESS POINTERS
      IADDL=IADDR
      IADDD=IADDR+KINCRF(MD0)
      IADDR=IADDR+KINCRF(IBUFF(3))
C--SET THE DATA ADDRESS
      IBUFF(4)=IADDD
C--WRITE THE BLOCK TO THE DISC
      CALL XUPF(IADDL,IBUFF(1),MD0)
C--UPDATE THE WORD COUNT
      N=N+IBUFF(3)
C--CHECK IF THE RECORD SHOULD BE OUTPUT TO THE DISC
1200  CONTINUE
      IF(ISTORE(J+6))1250,1350,1350
C--DATA NOT AVAILABLE TO BE OUTPUT  -  FETCH THE COMMON BLOCK POINTER
1250  CONTINUE
      M=ISTORE(J+7)
C--CHECK IF IT IS SET
      IF(M)1450,1450,1300
C--ALTER THE POINTER IN THE COMMON BLOCK
1300  CONTINUE
      ICOMMN(M)=IADDD
      GOTO 1450
C--DATA SHOULD BE OUTPUT  -  CHECK IF THERE IS ANY TO OUTPUT
1350  CONTINUE
      K=ISTORE(J+4)*ISTORE(J+5)
      IF(K)1450,1450,1400
C--DATA TO BE OUTPUT  -  FIND ITS ADDRESS AND OUTPUT IT TO DISC
1400  CONTINUE
      M=ISTORE(J+3)
      CALL XUPF(IADDD,ISTORE(M),K)
C--AND NOW RETURN
1450  CONTINUE
      RETURN
      END
C
CODE FOR KFNDRI
      FUNCTION KFNDRI(IULN,IUREC,IADDR,IBUFF)
C--FIND THE DATA ABOUT A GIVEN DATA RECORD ON DISC.
C
C  IULN    THE LIST TYPE.
C  IUREC   THE USER REQUIRED RECORD.
C  IADDR   THE DISC ADDRESS OF THE RECORD.
C  IBUFF   THE ARRAY TO CONTAIN THE RECORD HEADER BLOCK ON RETURN.
C
C--RETURN VALUES ARE :
C
C  -1  NO SUCH RECORD.
C   0  OKAY.
C
C--
      DIMENSION IBUFF(8) , JBUFF(8)
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C
C--CHECK THAT THE LIST NUMBER IS VALID
      LN=IULN
      IREC=IUREC
      ISTAT = KLSCHK ( LN , 0 , 0 , ILSCLN , ILSMSG , I , IERPRG )
C--READ THE DATA FOR THIS LIST
      CALL XRLIND(LN,IBUFF(1),IBUFF(2),IBUFF(3),IBUFF(4),IBUFF(5),
     2 IBUFF(6))
C--CHECK IF THE LIST IS PRESENT
      IADDI=IBUFF(2)
      IF(IADDI)1000,1000,1100
C--NO SUCH LIST
1000  CONTINUE
      KFNDRI=-1
1050  CONTINUE
      RETURN
C--SET UP THE RECORD READING POINTERS
1100  CONTINUE
      IADDR=0
C--READ THE NEXT RECORD
1150  CONTINUE
      IF(KLDDRH(IADDR,IADDI,IBUFF(1)))1000,1200,1200
C--CHECK IF THIS IS THE RECORD WE REQUIRE
1200  CONTINUE
      IF(IREC-IBUFF(7))1150,1250,1150
C--SUCCESS  -  TRANSFER THE DATA
1250  CONTINUE
      KFNDRI=0
      GOTO 1050
      END
C
CODE FOR KLDDRH
      FUNCTION KLDDRH(LASTAD,IADDR,IBUFF)
C--LOAD A DATA RECORD HEADER INTO A CORE BUFFER
C
C  LASTAD  THE ADDRESS OF THE LAST DATA RECORD.
C          THIS VARIABLE SHOULD BE SET ON ENTRY, AND IS UPDATED
C          TO POINT AT THE CURRENT RECORD HEADER ON EXIT. IF THIS IS
C          THE START OF A CHAIN, THIS VARIABLE SHOULD BE SET TO ZERO.
C  IADDR   THE ADDRESS OF THE RECORD HEADER TO BE LOADED.
C          THIS VARIABLE IS UPDATED TO POINT AT THE NEXT RECORD
C          HEADER ON EXIT.
C  IBUFF   THE BUFFER TO RECEIVE THE DATA RECORD HEADER.
C
C--RETURN VALUES OF 'KLDDRH' ARE :
C
C  -1  END OF THE CHAIN REACHED.
C   0  NEW HEADER LOADED SUCCESSFULLY
C
C--
      DIMENSION IBUFF(8) , JBUFF(8)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C--CHECK FOR THE END OF THE CHAIN
      KLDDRH=0
      IF(IADDR)1150,1000,1100
C--END OF THE CHAIN
1000  CONTINUE
      KLDDRH=-1
1050  CONTINUE
      RETURN
C--BRING DOWN THE NEXT RECORD
1100  CONTINUE
      CALL XDOWNF(IADDR,IBUFF(1),MD0)
C--CHECK THE BACKWARD LINK
      IF(LASTAD-IBUFF(2))1150,1250,1150
C--LINKAGE ERROR
1150  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)LN,LASTAD,IADDR,(IBUFF(I),I=1,MD0)
      ENDIF
      WRITE(NCAWU,1200) LN,LASTAD,IADDR,(IBUFF(I),I=1,MD0)
1200  FORMAT(35H Chain break on disc for list type ,I5//1H ,2I10//(1H ,
     2 12I10))
      CALL XERHND ( IERPRG )
C--UPDATE THE POINTERS
1250  CONTINUE
      LASTAD=IADDR
      IADDR=IBUFF(1)
      GOTO 1050
      END
C
CODE FOR KCEDR
      FUNCTION KCEDR(IULN,IULSN,IUREC,LENGRP,NGRP,IOFF)
C--CREATE A DATA RECORD IN CORE.
C
C  IULN    THE LIST TYPE.
C  IULSN   THE SERIAL NUMBER OF THE LIST.
C  IUREC   THE RECORD TYPE.
C  LENGRP  THE LENGTH OF EACH REPEAT GROUP IN THE RECORD.
C  NGRP    THE NUMBER OF REPEAT GROUPS IN THE RECORD.
C  IOFF    THE COMMON BLOCK OFFSET.
C
C--RETURN VALUES ARE :
C
C  >0  THE ADDRESS OF THE DATA AREA FOR THIS RECORD.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLIMIT/NFLMIN,LFLMAX,NULMAX,IENDC
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK THAT THE LIST SERIAL NUMBER IS VALID
      ISTAT = KLSCHK ( 0 , IULSN , 0 , ILSCLV , ILSMSG , I , IERPRG )
C--SET UP THE POINTERS
      LN=IULN
      LSN=IULSN
      IREC=IUREC
C--CHECK IF THERE IS A CORE CHAIN
      M0=L0
      IF(KVALID(NFLMIN,M0,LFLMAX))1000,1050,1050
C--NO CORE CHAIN ESTABLISHED
1000  CONTINUE
      L0=NFL
      M0=KCHNFL(1)
      ISTORE(L0)=IENDC
      M0=L0
      N0=0
C--CHECK THE NEXT HEADER FOR THIS LIST
1050  CONTINUE
      IF(KCHNCB(M0))1100,1100,1150
C--CHECK THE LIST TYPE
1100  CONTINUE
      IF(ISTORE(M0+6)-LN)1050,1200,1050
C--NO SUCH LIST AT PRESENT ON THE CORE CHAIN
1150  CONTINUE
      CALL XCEDRH(M0,LN,LSN,0,NOWT)
      N0=N0+1
      ISTORE(M0+3)=IENDC
C--SEARCH DOWN TO THE END OF THE CHAIN FOR THIS LIST
1200  CONTINUE
      I=M0+3
C--CHECK THE NEXT BLOCK
1250  CONTINUE
      IF(KCHNCB(I))1250,1250,1300
C--END OF THE CHAIN
1300  CONTINUE
      CALL XCEDRH(I,IREC,LENGRP,NGRP,IOFF)
      ISTORE(M0+2)=ISTORE(M0+2)+ISTORE(I+2)
      KCEDR=ISTORE(I+3)
      RETURN
      END
C
CODE FOR XUDRH
      SUBROUTINE XUDRH(IULN,IUREC,LENGRP,NGRP)
C--UPDATE DATA RECORD HEADER.
C
C  IULN    THE LIST TYPE.
C  IUREC   THE RECORD TYPE.
C  LENGRP  THE LENGTH OF THE REPEAT GROUP FOR THIS RECORD.
C  NGRP    THE NUMBER OF REPEAT GROUPS.
C
C--THIS ROUTINE SEARCHES FOR THE RELEVANT RECORD, AND THEN UPDATES
C  THE ENTRIES FOR 'LENGRP' AND 'NGRP'. IF ONE OF THESE QUANTITIES
C  WAS SPECIFIED TO 'XCEDRH', IT MUST BE GIVEN AS ZERO TO THIS ROUTINE,
C  WHICH SETS THE NEW VALUE FOR BOTH VARIABLES TO THE MAXIMUM PROVIDED
C  TO THIS ROUTINE, TO XCEDRH AND ZERO. THIS ROUTINE DOES NOT UPDATE
C  OR CHECK 'NFL' OR 'LFL'.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET THE RECORD TYPE INFORMATION
      LN=IULN
      IREC=IUREC
C--FIND THE RECORD IN CORE
      K=KHUNTR(IULN,IUREC,M0,I,J,0)
C--SUCCESS  -  UPDATE THE QUANTITIES
      L=MAX0(0,ISTORE(I+4))*MAX0(0,ISTORE(I+5))
C--COMPUTE THE NEW GROUP LENGTH
      M=MAX0(0,LENGRP)
C--CHECK IF THIS IS A CHANGE
      IF(M)1100,1100,1050
C--ALTER THE HEADER BLOCK ENTRY
1050  CONTINUE
      ISTORE(I+4)=M
C--COMPUTE THE NEW NUMBER OF GROUPS
1100  CONTINUE
      M=MAX0(0,NGRP)
C--CHECK IF THIS IS A CHANGE
      IF(M)1200,1200,1150
C--ALTER THE HEADER BLOCK ENTRY
1150  CONTINUE
      ISTORE(I+5)=M
C--COMPUTE THE NEW LENGTH
1200  CONTINUE
      M=ISTORE(I+4)*ISTORE(I+5)
C--ALTER THE RECORD LENGTH
      ISTORE(I+2)=MD0+M
C--CHECK IF THIS RECORD IS CORE RESIDENT
      IF(ISTORE(I+6))1300,1300,1250
C--CORE RESIDENT  -  ALTER THE LENGTH STORED
1250  CONTINUE
      ISTORE(M0+2)=ISTORE(M0+2)-L+M
C--CHECK IF THE CORE MAPS SHOULD BE PRINTED
1300  CONTINUE
      IF(MAPS)1350,1500,1350
C--PRINT THE CORE MAP
1350  CONTINUE
      CALL XPCM(1)
C--CHECK IF THE CONTENTS SHOULD BE DUMPED
      IF ( MAPS .LE. 0 ) GO TO 1500
C--PRINT THE CONTENTS
      IF(ISTORE(I+6))1500,1500,1450
C--DATA RECORD IN CORE  -  PRINT IT
1450  CONTINUE
      NFW=ISTORE(I+3)-MD0
      NLW=NFW+ISTORE(I+2)-1
      CALL XPRINT(NFW,NLW)
C--AND NOW RETURN
1500  CONTINUE
      RETURN
      END
C
CODE FOR XCEDRH
      SUBROUTINE XCEDRH(LAST,IUREC,LENGRP,NGRP,IOFF)
C--CREATE A DATA RECORD HEADER BLOCK IN CORE.
C
C  LAST    THE ADDRESS OF THE LAST DATA RECORD HEADER BLOCK, TO WHICH
C          THIS PARAMETER IS UPDATED TO POINT TO THE NEW HEADER BLOCK.
C          THE NEW ONE IS TO BE LINKED.
C  IUREC    THE RECORD TYPE.
C  LENGRP  THE LENGTH OF THE REPEAT GROUP FOR THIS RECORD TYPE.
C  NGRP    THE NUMBER OF GROUPS FOR THIS TYPE OF RECORD.
C  IOFF    THE COMMON BLOCK OFFSET FOR THIS TYPE OF RECORD.
C
C--THIS ROUTINE ALLOCATES SPACE FOR THE DATA FOR THE RECORD. IF
C  'LENGRP' OR 'NGRP' ARE NOT KNOWN WHEN THIS ROUTINE IS CALLED,
C  THEY MUST BE PROVIDED AS ZERO.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLIMIT/NFLMIN,LFLMAX,NULMAX,IENDC
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--COMPUTE THE LENGTH OF THE DATA RECORD
      L=MAX0(LENGRP,0)
      M=MAX0(NGRP,0)
      I=L*M+MD0
C--SET UP THE CORE AREA FOR THIS LIST
      J=NFL
      K=KCHNFL(I)
C--SET UP THE LINKAGE INFORMATION
      ISTORE(LAST)=J
      ISTORE(J)=IENDC
      ISTORE(J+1)=LAST
      LAST=J
C--SET UP THE HEADER BLOCK
      ISTORE(J+2)=I
      ISTORE(J+3)=J+MD0
      ISTORE(J+4)=L
      ISTORE(J+5)=M
      ISTORE(J+6)=IUREC
      ISTORE(J+7)=IOFF
      RETURN
      END
C
CODE FOR KHUNTR
      FUNCTION KHUNTR(IULN,IUREC,IADDL,IADDR,IADDD,IFLAG)
C--HUNT FOR A GIVEN LIST OR LIST/RECORD ON THE CORE CHAIN.
C
C  IULN    THE LIST TYPE.
C  IUREC   THE RECORD TYPE FOR THE GIVEN LIST. IF THIS IS SET TO ZERO,
C          THE HUNT IS TERMINATED WHEN THE LIST IS FOUND.
C  IADDL   THE ADDRESS OF THE HEADER CONTROL BLOCK FOR THE LIST.
C  IADDR   THE ADDRESS OF THE HEADER CONTROL FOR THE RECORD FOUND.
C          IF THE RECORD IS GIVEN AS ZERO, THIS WORD IS SET TO THE
C          POINTER IN THE LIST HEADER BLOCK FOR THE FIRST RECORD.
C  IADDD   THE ADDRESS OF THE DATA BLOCK. THIS IS LEFT UNSET IF THE
C          RECORD IS GIVEN AS ZERO.
C  IFLAG   CONTROLS ERROR PRINTING :
C
C          -1  SUPPRESS ERROR PRINTING  -  RESULTS RETURNED THROUGH 'KHU
C           0  TAKE ERROR TERMINATIONS WHERE APPROPIATE.
C
C--RETURN VALUES OF 'KHUNTR' FOR 'IFLAG' EQUAL TO -1 ARE :
C
C  -1  NO SUCH LIST IN CORE.
C   0  ALL OKAY  -  NORMAL RETURN VALUE IF 'IFLAG' EQUALS ZERO.
C  +1  NO SUCH RECORD FOR THE GIVEN LIST.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLIMIT/NFLMIN,LFLMAX,NULMAX,IENDC
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--ASSIGN THE LIST AND RECORD TYPES
      LN=IULN
      IREC=IUREC
C----- CHECK FOR A CORE CHAIN OF ANY SORT
      IF (L0 .LE. 0) GOTO 1050
C--SET THE LIST ADDRESS TO THE FIRST POINTER
      IADDL=L0
C--MOVE TO THE NEXT LIST
1000  CONTINUE
      IF(KCHNCB(IADDL))1250,1250,1050
C--END OF THE CHAIN  -  CHECK THE ERROR PROCESSING
1050  CONTINUE
      KHUNTR=-1
      IF(IFLAG)1100,1150,1150
C--AND NOW RETURN
1100  CONTINUE
      RETURN
C--ERROR PRINT FOR NO SUCH LIST
1150  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)IULN
      ENDIF
      WRITE(NCAWU,1200)IULN
1200  FORMAT(11H List type ,I5,24H  is not present in core)
      CALL XERHND ( IERPRG )
C--CHECK THE TYPE OF THE NEXT LIST
1250  CONTINUE
      IF(ISTORE(IADDL+6)-IULN)1000,1300,1000
C--CORRECT LIST TYPE  -  SET POINTERS FOR THE RECORDS
1300  CONTINUE
      IADDR=IADDL+3
      IADDD=NOWT
      KHUNTR=0
C--CHECK IF WE SHOULD SEARCH FOR A RECORD
      IF(IUREC)1350,1100,1350
C--MOVE TO THE NEXT RECORD FOR HIS LIST
1350  CONTINUE
      IF(KCHNCB(IADDR))1600,1600,1400
C--END OF THE CHAIN  -  CHECK FOR ERROR PROCESSING
1400  CONTINUE
      KHUNTR=1
      IF(IFLAG)1100,1450,1450
C--ERROR TERMINATION  -  OMITTED RECORD.
1450  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1500)IULN,IUREC
      ENDIF
      WRITE(NCAWU,1500) IULN,IUREC
1500  FORMAT(11H List type ,I5,18H  and record type ,I8,
     2 24H  is not present in core)
C--TERMINATION
      CALL XPCM(1)
      CALL XERHND ( IERPRG )
C--CHECK THE TYPE OF THE NEXT RECORD
1600  CONTINUE
      IF(ISTORE(IADDR+6)-IUREC)1350,1650,1350
C--SUCCESS  -  SET THE DAT ADDRESS AND RETURN
1650  CONTINUE
      IADDD=ISTORE(IADDR+3)
      GOTO 1100
      END
C
CODE FOR KCHNCB
      FUNCTION KCHNCB(IADD)
C--MOVE ON TO THE NEXT CORE BLOCK ON THE CHAIN, STARTING FROM THE
C  CONTROL BLOCK AT 'ISTORE(IADD)'. THIS ROUTINE APPLIES ALL THE CHECKS
C  VIA 'KCHKCC', BUT TERMINATES THE JOB IF AN ERROR MESSAGE IS FOUND.
C
C  IADD    THE ADDRESS OF THE CURRENT RECORD HEADER BLOCK. THIS
C          PARAMETER IS UPDATED ON RETURN, AND POINTS AT THE NEW
C          HEADER BLOCK.
C
C--RETURN VALUES ARE :
C
C   0  OKAY.
C  +1  END OF CHAIN DETECTED.
C
C--
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C--CALL THE CHAIN INCREMENTING ROUTINE
      KCHNCB=0
      IF(KCHKCC(IADD))1100,1050,1000
C--END OF THE CHAIN
1000  CONTINUE
      KCHNCB=1
1050  CONTINUE
      RETURN
C--SOME SORT OF ERROR
1100  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1150)LN,IREC
      ENDIF
      WRITE(NCAWU,1150) LN,IREC
1150  FORMAT(35H Corrupt data record chain in core ,
     2 25H  -  indicated list type ,I5,18H  and record type ,I8)
      CALL XPCM(1)
      CALL XERHND ( IERPRG )
      STOP
      END
C
CODE FOR KCHKCC
      FUNCTION KCHKCC(IADD)
C--CHECK THAT THE LINKAGE AT 'ISTORE(IADD)' IS VALID, AND MOVE ON TO THE
C  NEXT ITEM IN THE CHAIN.
C
C  IADD    THE CURRENT LINK ADDRESS IN 'ISTORE'. APART FROM THE VERY FIR
C          EACH SET OF LINKAGE POINTERS HAS THE FOLLOWING FORMAT :
C
C          0  ADDRESS OF THE NEXT ITEM IN THE CHAIN, OR THE END MARKER.
C          1  ADDRESS OF THE LAST ITEM IN THE CHAIN.
C
C--RETURN VALUES OF 'KCHKCC' ARE :
C
C  -1  INVALID CHAIN LINKAGE. (ADDRESS INVALID, OR NO BACKWARD LINKAGE).
C   0  OKAY, AND ON RETURN 'IADD' POINTS TO THE FIRST WORD OF THE NEW IT
C  +1  END OF THE CHAIN.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLIMIT/NFLMIN,LFLMAX,NULMAX,IENDC
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF THE ADDRESS GIVEN IS VALID
      KCHKCC=0
      IF(KVALID(NFLMIN,IADD,LFLMAX))1200,1000,1000
C--CHECK FOR THE END OF THE CHAIN
1000  CONTINUE
      IF(ISTORE(IADD)-IENDC)1050,1250,1050
C--CHECK IF THE CONTENTS OF 'ISTORE(IADD)' ARE A VALID ADDRESS
1050  CONTINUE
      IF(KVALID(NFLMIN,ISTORE(IADD),LFLMAX))1200,1100,1100
C--UPDATE 'IADD'
1100  CONTINUE
      I=IADD
      IADD=ISTORE(IADD)
C--CHECK THAT THE BACKWARD POINTER AT THE NEW ADDRESS IS VALID
      IF(KVALID(NFLMIN,ISTORE(IADD+1),LFLMAX))1200,1150,1150
C--VALID ADDRESS  -  CHECK THAT IT IS CORRECT
1150  CONTINUE
      IF(ISTORE(IADD+1)-I)1200,1300,1200
C--INVALID CHAIN LINKAGE INFORMATION
1200  CONTINUE
      KCHKCC=-1
      GOTO 1300
C--END OF THE CHAIN
1250  CONTINUE
      KCHKCC=1
1300  CONTINUE
      RETURN
      END
C
CODE FOR KVALID
      FUNCTION KVALID(IMIN,IADD,IMAX)
C--CHECK IF THE ADDRESS 'IADD' IS VALID.
C
C  IMIN     THE MINIMUM VALUE THAT 'IADD' MAY HAVE.
C  IADD    THE ADDRESS TO BE CHECKED.
C  IMAX     THE MAXIMUM VALUE THAT 'IADD' MAY HAVE.
C          (IF 'IMAX' IS LESS THAN 'IMIN', THE SECOND CHECK ON 'IMAX' IS
C          OMITTED).
C
C--RETURN VALUES OF 'KVALID' ARE :
C
C  -1  INVALID ADDRESS.
C   0  VALID ADDRESS.
C
C--
      KVALID=0
C--CHECK THE MINIMUM VALUE
      IF(IMIN-IADD)1000,1000,1100
C--CHECK IF THE MAXIMUM CHECK SHOULD BE MADE
1000  CONTINUE
      IF(IMIN-IMAX)1050,1050,1150
C--CHECK THE MAXIMUM VALUE
1050  CONTINUE
      IF(IMAX-IADD)1100,1150,1150
C--INVALID ADDRESS
1100  CONTINUE
      KVALID=-1
1150  CONTINUE
      RETURN
      END
C
CODE FOR KCHNFL
      FUNCTION KCHNFL(INCREM)
C--INCREASE THE CURRENT VALUE OF 'NFL' BY 'INCREM'
C
C  INCREM  THE REQUIRED INCREMENT TO 'NFL'  -  MUST BE GREATER
C          THAN ZERO.
C
C--THIS ROUTINE MUST BE USED INSTEAD OF A CALL SUCH
C  AS 'KINCOR(NFL,INCREM)'.
C
C--THE RETURN VALUE IS THE NEW VALUE OF 'NFL' AFTER THE INCREMENT.
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
C
C
      DATA I/0/
C
      I=NFL
      KCHNFL=KINCOR(I,INCREM)
      RETURN
      END
C
CODE FOR KCHLFL
      FUNCTION KCHLFL(INCREM)
C--DECREMENT THE CURRENT VALUE OF 'LFL' BY 'INCREM'
C
C  INCREM  THE REQUIRED CHANGE TO 'LFL'  -  MUST BE POSITIVE.
C
C--THE RETURN VALUE OF 'KCHLFL' IS THE NEW VALUE OF 'LFL' PLUS ONE.
C  FOR THIS REASON, THE MINIMUM ALLOWED CHANGE IN 'INCREM' IS 2.
C
C--THIS FUNCTION SHOULD BE USED IN PREFERENCE TO A CALL
C  OF THE TYPE 'KDECOR(LFL,INCREM)'.
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
C
C
      DATA I/0/,J/0/
C
C--SET UP THE VALUES FOR KINCOR
      I=LFL
      J=MIN0(-1,-INCREM+1)
      KCHLFL=KINCOR(I,J)
      RETURN
      END
C
CODE FOR KDECOR
      FUNCTION KDECOR(IADD,INCREM)
C--ALTER THE ADDRESS 'IADD' NEGATIVELY BY THE AMOUNT 'INCREM-1'
C
C  IADD    ADDRESS TO BE ALTERED
C  INCREM  NUMBER PLUS ONE TO BE SUBTRACTED FROM 'IADD'.
C
C--'LFL' IS UPDATE BY THIS PROCESS SO THAT IT IS EQUAL TO 'IADD-INCREM'.
C
C--RETURN VALUE IS THE NEW ADDRESS 'IADD-INCREM+1'.
C
C--'INCREM' ASSUMES A MINIMUM VALUE OF 2.
C
C--
C
C
      DATA I/0/
C
      I=MIN0(-1,-INCREM+1)
      KDECOR=KINCOR(IADD,I)
      RETURN
      END
C
CODE FOR KINCOR
      FUNCTION KINCOR(IADD,INCREM)
C--INCREMENT THE STORE ADDRESS AND CHECK THAT THE LIMITS HAVE NOT BEEN E
C
C  IADD    ADDRESS TO INCREMENT
C  INCREM  THE INCREMENT  -  THIS MAY BE + OR -.
C
C--THIS ROUTINE ADDS 'INCREM' TO 'IADD', AND UPDATES 'NFL' IF
C  'INCREM' IS POSITIVE OR 'LFL' IF 'INCREM' IS NEGATIVE.
C  NO UPDATE IS DONE IF 'INCREM' IS ZERO.
C
C--'LFL' IS CHANGED SO THAT IT IS EQUAL TO 'IADD-1' ON EXIT, WHILE
C  'NFL' IS CHANGED SO THAT IT IS EQUAL TO 'IADD'.
C
C--THE RETURN VALUE IS 'IADD+INCREM'.
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
C
C
      DATA I/0/
C
      I=IADD+INCREM
C--CHECK THE SIGN OF THE INCREMENT
      IF(INCREM)1000,1100,1050
C--UPDATE 'LFL'
1000  CONTINUE
      LFL=MIN0(LFL,I-1)
      CALL XCHCOR(I,IADD)
      GOTO 1150
C--UPDATE 'NFL'
1050  CONTINUE
      NFL=MAX0(NFL,I)
C--CHECK THAT THE CORE AREA CAN BE USED
1100  CONTINUE
      CALL XCHCOR(IADD,I)
1150  CONTINUE
      KINCOR=I
      RETURN
      END
C
CODE FOR XCHCOR
      SUBROUTINE XCHCOR(NFW,NLW)
C--CHECK THAT THE CORE LIMITS HAVE NOT BEEN EXCEEDED
C
C  NFW  FIRST WORD TO BE USED
C  NLW  LAST WORD TO BE USED
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLIMIT/NFLMIN,LFLMAX,NULMAX,IENDC
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C--COMPUTE THE NUMBER OF FREE WORDS AVAILABLE
      NUL=LFL-NFL+1
C--CHECK THAT TOO MUCH STORE HAS NOT BEEN ALLOCATED
      IF(NFL-LFL+5)1150,1000,1000
C--TOO MUCH CORE HAS BEEN ALLOCATED
1000  CONTINUE
      CALL XERHDR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)LN,IREC
      ENDIF
      WRITE(NCAWU,1050) LN,IREC
1050  FORMAT(49H Insufficient core store available for list type ,I5,
     2 5X,12Hrecord type ,I8)
C--ERROR TERMINATION
1100  CONTINUE
      CALL XPCM(0)
      CALL XERHND ( IERCAT )
C--CHECK THAT THE ALLOCATED STORE CAN BE USED
1150  CONTINUE
      IF(NFW-NFLMIN)1200,1300,1300
C--ATTEMPT TO USE CORE STORE THAT CANNOT BE USED
1200  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1250)LN,IREC,NFLMIN,NFL,NFW,NLW,LFL,LFLMAX
      ENDIF
      WRITE(NCAWU,1250)LN,IREC,NFLMIN,NFL,NFW,NLW,LFL,LFLMAX
1250  FORMAT(39H Illegal store reference for list type ,I5,5X,
     2 12HRecord type ,I8//1X,3I10,5X,5H. . .,3I10)
      GOTO 1100
1300  CONTINUE
      IF(NFL-NFLMIN)1200,1350,1350
C--CHECK THE UPPER LIMITS
1350  CONTINUE
      IF(NLW-LFLMAX)1400,1400,1200
1400  CONTINUE
      IF(LFL-LFLMAX)1450,1450,1200
C--AND NOW RETURN
1450  CONTINUE
      RETURN
      END
C
CODE FOR XPCM
      SUBROUTINE XPCM(ITYPE)
C--PRINT THE DETAILS OF THE CORE CHAIN
C
C  ITYPE   THE TYPE OF CORE MAP REQUIRED :
C
C          -1  LIST TYPE DETAILS ONLY.
C           0  LIST DETAILS, PLUS RECORDS FROM THE CURRENT LIST.
C          +1  LIST AND RECORD DETAILS FOR ALL LISTS.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLIMIT/NFLMIN,LFLMAX,NULMAX,IENDC
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK ON THE TYPE OF PRINT TO BE DONE
      J=1
      IF(ITYPE)1050,1000,1000
C--FULL HEADING REQUIRED
1000  CONTINUE
      J=2
C--PRINT THE INITIAL HEADING
1050  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)NFLMIN,NFL,LFL,LFLMAX,(IB,I=1,J)
      ENDIF
1100  FORMAT(//20H Core allocation map//15H Absolute min. ,I8,8X,
     2 13HCurrent min. ,I8,13X,13HCurrent max. ,I8,8X,
     3 14HAbsolute max. ,I8//1H ,7X,4HList,4X,6HSerial,4X,6HLength,2A1,
     4 2X,6HRecord,3X,7HMinimum,3X,7HMaximum,3X,9HCore used,3X,
     5 6HGRPLEN,3X,6HNGROUP,3X,6HLength/)
      M0=L0
C--CHECK THAT THERE IS A CORE CHAIN TO PRINT
      IF(KVALID(NFLMIN,M0,LFLMAX))1150,1250,1250
C--NO CORE CHAIN  -  PRINT A MESSAGE
1150  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)
      ENDIF
      WRITE(NCAWU,1200)
1200  FORMAT(26H No core chain established)
      GOTO 2050
C--MOVE ON TO THE NEXT LIST ON THE CHAIN
1250  CONTINUE
      IF(KCHKCC(M0))1300,1400,2050
C--INVALID CHAIN OF SOME TYPE
1300  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1350)
      ENDIF
      WRITE(NCAWU,1350)
1350  FORMAT(12H Chain break)
      GOTO 2050
C--PRINT THE DETAILS ABOUT THIS LIST
1400  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)ISTORE(M0+6),ISTORE(M0+4),ISTORE(M0+2)
      ENDIF
1450  FORMAT(1H ,3I10)
C--CHECK ON THE TYPE OF PRINT REQUIRED
      IF(ITYPE)1250,1500,1550
C--CHECK IF THIS IS THE CURRENT LIST
1500  CONTINUE
      IF(LN-ISTORE(M0+6))1250,1550,1250
C--SET OFF DOWN THE RECORD CHAIN FOR THIS LIST
1550  CONTINUE
      L=M0+3
C--MOVE ON TO THE NEXT RECORD FOR THIS LIST
1600  CONTINUE
      IF(KCHKCC(L))1650,1750,1250
C--CHAIN BREAK FOR THE RECORDS
1650  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1700)
      ENDIF
      WRITE(NCAWU,1700)
1700  FORMAT(1H ,32X,11HChain break)
      GOTO 1250
C--CHECK THAT THE LENGTH INDICATED IS CORRECT
1750  CONTINUE
      J=1
      IF(ISTORE(L+2)-MD0-ISTORE(L+4)*ISTORE(L+5))1800,1850,1800
C--INCORRECT LENGTH
1800  CONTINUE
      J=2
C--CHECK IF THE DATA FROM THIS RECORD IS IN CORE
1850  CONTINUE
      M=ISTORE(L+2)
      IF(ISTORE(L+6))1900,1950,1950
C--NOT IN CORE
1900  CONTINUE
      M=MD0
1950  CONTINUE
      K=L+M-1
C--PRINT THE DETAILS FOR THIS RECORD
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2000)ISTORE(L+6),L,K,M,ISTORE(L+4),ISTORE(L+5),
     2 ISTORE(L+2),(IB,I=1,J)
      ENDIF
2000  FORMAT(1H ,30X,3I10,I11,I10,2I9,2A1,3X,12HInconsistent)
      GOTO 1600
C--AND NOW EXIT
2050  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2100)NULMAX,NUL
      ENDIF
      WRITE(NCAWU,2100)NULMAX,NUL
2100  FORMAT(/19H Max. free word(s) ,I8,5X,21HCurrent free word(s) ,I8)
      CALL XLINES
      RETURN
      END
C
CODE FOR XCSAE
      SUBROUTINE XCSAE
C--DETELE DETAILS OF THE CORE CHAIN HOLDING LIST INFORMATION
C
C--USUALLY USED IN CONJUNCTION WITH 'XRSL'.
C
C--
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      L0=NOWT
      M0=NOWT
      N0=0
      RETURN
      END
C
CODE FOR XSSL
      SUBROUTINE XSSL(NFL,LFL,NUL)
C--SET THE STORE LIMITS - THIS SUBROUTINE STACKS THE LIMITS AWAY
C
      COMMON/XLIMIT/NFLMIN,LFLMAX,NULMAX,IENDC
C
      NFLMIN=NFL
      LFLMAX=LFL
      NULMAX=NUL
      CALL XRSL
      RETURN
      END
C
CODE FOR XRSL
      SUBROUTINE XRSL
C--RESET THE STORE LIMITS
C
      COMMON/XLIMIT/NFLMIN,LFLMAX,NULMAX,IENDC
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      NFL=NFLMIN
      LFL=LFLMAX
      NUL=NULMAX
      RETURN
      END
C
C --
C
CODE FOR KSTALL
      FUNCTION KSTALL(ISIZE)
C -- ALLOCATES AN AREA OF LENGTH ISIZE IN STORE
C    RETURN VALUE IS START OF ALLOCATED AREA.
C    IF SPACE IS INSUFFICIENT THEN AN ERROR MESSAGE IS PRINTED
C --
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C --
      IFREE=LFL-NFL
      IF (ISIZE.GT.IFREE) CALL XSTICA (ISIZE,IFREE)
      KSTALL=NFL
      NFL=NFL+ISIZE
      RETURN
      END
C
C --
C
CODE FOR XSTRLL
      SUBROUTINE XSTRLL(IADDR)
C -- MAKES NFL EQUAL TO LOWER OF NFL AND IADDR
C --
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C --
C -- IF ADDRESS IS LESS THAN OR EQUAL TO ZERO THEN RETURN
      IF (IADDR.LE.0) RETURN
      NFL=MIN0(NFL,IADDR)
      RETURN
      END
C
C --
C
CODE FOR KSTALH
      FUNCTION KSTALH ( ISIZE )
C -- ALLOCATES AN AREA OF LENGTH ISIZE IN STORE
C    RETURN VALUE IS START OF ALLOCATED AREA.
C    IF SPACE IS INSUFFICIENT THEN AN ERROR MESSAGE IS PRINTED
C --
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C --
      IFREE = LFL - NFL
      IF (ISIZE.GT.IFREE) CALL XSTICA (ISIZE,IFREE)
      LFL = LFL - ISIZE
      KSTALH = LFL + 1
      RETURN
      END
C
C --
C
CODE FOR XSTRLH
      SUBROUTINE XSTRLH(IADDR)
C -- MAKES LFL EQUAL TO HIGHER OF LFL AND IADDR
C --
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C --
C -- IF ADDRESS IS LESS THAN OR EQUAL TO ZERO THEN RETURN
      IF (IADDR.LE.0) RETURN
      IF (IADDR.GT.65536) RETURN
      LFL=MAX0(NFL,IADDR)
      RETURN
      END
C
C --
C
CODE FOR XSTICA
      SUBROUTINE XSTICA(ISIZE,IFREE)
C -- PRINTS MESSAGE TO INDICATE INSUFFICIENT CORE
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C --
      CALL XOPMSG ( IOPCRY , IOPSPC , ISIZE )
C -- DUMMY RETURN
      RETURN
      END
CODE FOR XPRINT
      SUBROUTINE XPRINT(NFW,NLW)
C--CORE PRINT ROUTINES
C
C  NFW  FIRST WORD IN 'STORE' TO BE PRINTED
C  NLW  LAST WORD IN 'STORE' TO BE PRINTED
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
C
      DATA I/0/,J/0/,K/0/
C
      CALL XLINES
      J=NFW
      IF(NFW-NLW)1000,1000,1200
1000  CONTINUE
      K=J+2
      IF(K-NLW)1050,1150,1150
1050  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)J,(STORE(I),ISTORE(I),STORE(I),I=J,K)
      ENDIF
1100  FORMAT(I7,1H*,3(3X,A4,I10,E20.10))
      J=J+3
      GOTO 1000
1150  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)J,(STORE(I),ISTORE(I),STORE(I),I=J,NLW)
      ENDIF
1200  CONTINUE
      RETURN
      END
C
CODE FOR XMVSPD
      SUBROUTINE XMVSPD(IVALUE,IA,N)
C--DUPLICATE THE VALUE 'IVALUE' OVER THE ARRAY 'IA', STORING IN TOTAL
C  'N' VALUES.
C
C  IVALUE  THE VALUE TO STORE.
C  IA      THE FIRST ARRAY ELEMENT TO BE SET TO 'IVALUE'.
C  N       THE NUMBER OF ARRAY ELEMENTS TO BE SET.
C
C--
C
C
      DIMENSION IA(N)
C
      CALL XFILL(IVALUE,IA(1),N)
      RETURN
C
      END
C
CODE FOR XMVSPF
      SUBROUTINE XMVSPF(VALUE,A,N)
C--DUPLICATE THE VALUE 'VALUE' OVER THE ARRAY 'A', STORING IN TOTAL
C  'N' VALUES.
C
C  VALUE   THE VALUE TO STORE.
C  A       THE FIRST ARRAY ELEMENT TO BE SET TO 'VALUE'.
C  N       THE NUMBER OF ARRAY ELEMENTS TO BE SET.
C
C--
C
C
      DIMENSION A(N)
C
      CALL XFILL(VALUE,A(1),N)
      RETURN
100   CONTINUE
      END



CRYSTALS CODE FOR LISTS3
CODE FOR XRDLN
      SUBROUTINE XRDLN(IULN,IOWFLG)
C--GENERAL LIST READING ROUTINE
C
C  IULN    THE LIST NUMBER TO BE INPUT.
C  IOWFLG  THE WRITE/OVERWRITE FLAG :
C
C          -1  ATTEMPT AN OVERWRITE.
C           0  WRITE A COMPLETELY NEW LIST.
C          +1  ATTEMPT A CAREFUL OVERWRITE.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET THE LIST AND RECORD TYPE
      LN=IULN
      IREC=0
C--SET UP THE INPUT COMMON BLOCK
      JA=NFL
      JB=512
      JC=KCHNFL(JB)
C--READ THE DATA FROM THE INPUT STREAM
      IF (   KRDDPV ( ISTORE(JA) , JB )   .LT.  0  ) GO TO 9910
C
C--LIST READ OKAY  -  CHECK IF THE INPUT WAS FOR LIST 4
      IF(IULN-4)1100,1050,1100
C--LIST TYPE 4  -  STORE THE WEIGHTING SCHEME TYPE
1050  CONTINUE
      I=ISTORE(JA+8)
      ISTORE(I)=ISTORE(JA)
      ISTORE(I+1)=ISTORE(JA+1)
C----- NOW STORE THE REAL VARIABLES
      I = ISTORE(JA+12)
      STORE(I) = FLOAT (ISTORE(JA+2))
      STORE(I+1) = FLOAT (ISTORE(JA+3))
      GOTO 2300
C
C--CHECK FOR LIST TYPE 5
1100  CONTINUE
      IF(IULN-5)1300,1150,1300
C--LIST TYPE 5  -  FLOAT THE ABSOLUTE INDEX FLAG FOR STORAGE
1150  CONTINUE
      I=ISTORE(JA+8)
C--CHECK IF THE ABSOLUTE FLAG IS SET
      IF(ISTORE(I+4))1200,1250,1250
C--DO NOT TAKE THE ABSOLUTE VALUE
1200  CONTINUE
      STORE(I+4)=-1.
      GOTO 2300
C--TAKE THE ABSOLUTE VALUE
1250  CONTINUE
      STORE(I+4)=1.
      GOTO 2300
C
C--CHECK IF THIS IS LIST 13
1300  CONTINUE
      IF(IULN-13)1500,1350,1500
C--THIS IS LIST 13  -  CHECK WHICH ORIENTATION TYPE HAS BEEN GIVEN
1350  CONTINUE
      CALL WSTUP ( ISTORE(JA) , JB )
      GOTO 2300
C
C--CHECK FOR LIST TYPE 14
1500  CONTINUE
      IF(IULN-14)1650,1550,1650
C--LIST 14  -  MOVE THE AXIS DATA FROM LIST 114 TO LIST 14
1550  CONTINUE
      L14 = ISTORE(JA)
      LP = ISTORE(JA+12)
      J = JA
C--LOOP OVER EACH AXIS
      DO 1600 K=1,3
C----- FOURIER LIMITS
      LX = ISTORE(J +16)
C----- PATTERSON LIMITS
      LXP = ISTORE(J +28)
      CALL XMOVE(STORE(LX), STORE(L14), ISTORE(J+18))
      CALL XMOVE(STORE(LXP), STORE(LP), ISTORE(J+18))
C--UPDATE THE POINTERS
      L14 = L14 + ISTORE(JA + 2)
      LP = LP + ISTORE(JA + 2 + 12)
      J=J+4
1600  CONTINUE
      GOTO 2300
C
C--CHECK FOR LIST 25
1650  CONTINUE
      IF(IULN-25)2000,1700,2000
C--LIST 25  -  FORM THE INVERSE OPERATORS
1700  CONTINUE
      IF(ISTORE(JA+3))2300,2300,1750
C--LOOP OVER EACH IN TURN
1750  CONTINUE
      I=ISTORE(JA)
      N=ISTORE(JA+3)
      J=ISTORE(JA+4)
      DO 1950 K=1,N
C--INVERT THE CURRENT MATRIX
      IF (   KINV2 ( 3 , STORE(I) , STORE(J) , 9 , 0 , STORE(NFL) ,
     1 STORE(NFL) , 3 )   .GT.   0   ) GO TO 9920
C--UPDATE THE POINTERS
      I=I+ISTORE(JA+2)
      J=J+ISTORE(JA+6)
1950  CONTINUE
      GOTO 2300
C
C--CHECK IF THIS IS LIST 28
2000  CONTINUE
      IF(IULN-28)2300,2050,2300
C--LIST 28  -  SET UP THE 'USE' AND 'NAME' RECORDS
2050  CONTINUE
      DO 2250 I=2,3
C--SET UP THE POINTERS FOR THIS DATA RECORD  -  THE INPUT ONE
      CALL XDIRFL(I,ISTORE(JA),JB)
C--COMPUTE THE COMMON BLOCK OFFSETS
      J=(I-2)*8+JA
      K=I*4+JA
C--FIND THE ADDRESS OF THE OUTPUT 'NAME' DATA RECORD
      M=ISTORE(J+4)
C--FIND THE INCREMENT FOR THE 'NAME' RECORD
      MM=ISTORE(J+6)
C--FIND THE INCREMENT FOR THE OUTPUT 'USE' RECORD
      JJ=ISTORE(J+2)
C--FIND THE ADDRESS OF THE OUTPUT 'USE' DATA RECORD
      KK=ISTORE(J)
C--FIND THE ADDRESS OF THE INPUT DATA RECORD
      K=ISTORE(K+12)
C--SET THE NUMBER OF PARAMETERS TO BE STORED TO ZERO
      N=0
C--LOOP OVER EACH INPUT KEYWORD
      DO 2200 L=1,NR62D
      IF(ISTORE(MR62D+10))2150,2150,2100
C--THIS KEYWORD WAS INPUT  -  SET UP THE 'USE' RECORD
2100  CONTINUE
      ISTORE(KK)=L-1
      STORE(KK+1)=STORE(K)
C--SET UP THE NAME RECORD
      CALL XFA4CS(STORE(MR62N+1),STORE(M),MIN0(3*NWCHAR,MDR62N-1))
      STORE(M+3)=STORE(K)
C--UPDATE THE POINTERS
      KK=KK+JJ
      M=M+MM
      N=N+1
C--UPDATE THE KEYWORD POINTERS
2150  CONTINUE
      K=K+1
      MR62N=MR62N+MDR62D
      MR62D=MR62D+MDR62D
2200  CONTINUE
C--UPDATE THE RECORD PROPERTIES
      ISTORE(J+3)=N
      ISTORE(J+7)=N
2250  CONTINUE
C
C--NOW OUTPUT THE LIST TO THE DISC
2300  CONTINUE
      CALL XWLSTD(IULN,ISTORE(JA),JB,IOWFLG,1)
9000  CONTINUE
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPLSI , IOPLSP , IULN )
      CALL XLSALT ( IULN , 0 , 0 , ILSERF , ILSSET )
      GO TO 9000
9910  CONTINUE
C -- COMMAND INPUT ERRORS
      CALL XOPMSG ( IOPCRY , IOPCMI , 0 )
      GO TO 9900
9920  CONTINUE
C -- SINGULAR MATRIX
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 ) I , IULN
      ENDIF
      WRITE ( NCAWU , 9925 ) I , IULN
9925  FORMAT ( 1X, 'Matrix ' , I2 , ' in list ' , I3 , ' is singular' )
      CALL XERHND ( IERERR )
      GO TO 9900
      END
C
CODE FOR XPRTLN
      SUBROUTINE XPRTLN(IULN)
C--GENERAL LIST PRINT ROUTINE
C
C  IULN    THE LIST TO BE PRINTED
C
C--
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ISTORE(131072)
C
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF THE LIST IS AVAILABLE FOR PRINTING
      IF(KPRTLN(IULN,IADDI))1000,1050,1050
C--TERMINATING LINES AND RETURN
1000  CONTINUE
      CALL XLINES
      RETURN
C--PRESERVE THE CORE LIMITS
1050  CONTINUE
      JA=NFL
      JB=LFL
C--LOAD LIST TYPE 50
      CALL XFAL50
C--LOAD THE DETAILS OF THE LIST TO BE PRINTED
      CALL XLL50R(IULN+LSTOFF)
C--RESET THE LIST POINTERS
      LN=IULN
      IREC=0
C--SET UP A COMMON BLOCK
      JC=512
      JD=NFL
      JE=KCHNFL(JC)
C--PRESERVE THE CURRENT TOP OF CORE
      JF=LFL
C--SET THE LAST DISC ADDRESS
      LAST=0
C--RESTORE THE CORE LIMITS TO THOSE BEFORE WE ENTERED
1100  CONTINUE
      NFL=JA
      LFL=JB
C--READ THE NEXT DATA RECORD HEADER BLOCK
      IF(KLDDRH(LAST,IADDI,IBUFF(1)))1000,1150,1150
C--SET THE CORE LIMITS TO PROTECT LIST 50
1150  CONTINUE
      NFL=JE
      LFL=JF
C--CHECK IF THIS LIST HAS ANY DIRECTIVES STORED FOR IT
      IF(NR60)1100,1100,1200
C--DIRECTIVES STORED  -  LOOK FOR THE DATA RECORD WE HAVE FOUND ON DISC
1200  CONTINUE
      MR61=LR61
      DO 1400 I=1,NR61
C--CHECK IF THIS IS THE CORRECT LIST TYPE
      IF(IULN-ISTORE(MR61+13))1350,1250,1350
C--COMPARE THE RECORD TYPES
1250  CONTINUE
      IF(ISTORE(MR61+11)-IBUFF(7))1350,1300,1350
C--SUCCESS  -  LOAD THE DETAILS FOR THIS DIRECTIVE
1300  CONTINUE
      CALL XDIRFL(I,ISTORE(JD),JC)
      GOTO 1500
C--UPDATE FOR THE NEXT DIRECTIVE
1350  CONTINUE
      MR61=MR61+MDR61
1400  CONTINUE
C--NO MATCH  -  PRINT THE RECORD NAME ONLY
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)IBUFF(7),IBUFF(5),IBUFF(6)
      ENDIF
      WRITE(NCAWU,1450) IBUFF(7),IBUFF(5),IBUFF(6)
1450  FORMAT(//33H No details available for record ,I5,7H  LGRP ,I4,
     2 7H  NGRP ,I6)
      GOTO 1100
C--LOAD THE RECORD FROM THE DISC
1500  CONTINUE
      CALL XLDREC(LN,LSN,IBUFF,ISTORE(JD),JC,0)
C--CHECK IF A TITLE HAS BEEN GIVEN FOR THIS DATA RECORD
      IF(ISTORE(MR61+15))1650,1650,1550
C--TITLE GIVEN  -  FIND ITS ADDRESS AND LENGTH
1550  CONTINUE
      K=LR62+ISTORE(MR61+16)
      L=K+ISTORE(MR61+14)-1
C--FIND THE NUMBER OF TIMES WE SHOULD PRINT THE TITLE
      M=ISTORE(MR61+15)
C--PRINT THE TITLE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1600)IBUFF(7),IBUFF(5),IBUFF(6),((ISTORE(I),I=K,L),
     2 J=1,M)
      ENDIF
1600  FORMAT(//8H Record ,I4,9H    LGRP ,I4,7H  NGRP ,I6,3X,20A4/(26X,
     2 20A4))
      GOTO 1700
C--NO TITLE AVAILABLE  -  PRINT THE RECORD NUMBER ONLY
1650  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1600)IBUFF(7),IBUFF(5),IBUFF(6)
      ENDIF
C--OUTPUT A SPACE AFTER THE TITLE
1700  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1750)
      ENDIF
1750  FORMAT(1H )
C--CHECK IF A REPEAT COUNT FOR THE KEYWORDS HAS BEEN GIVEN
      IF(ISTORE(MR61+18))1900,1900,1800
C--CHECK IF THERE ARE ANY KEYWORDS TO PRINT
1800  CONTINUE
      IF(NR62N)1900,1900,1850
C--KEYWORDS TO PRINT  -  COMPRESS THE GIVEN TITLE FOR OUTPUT
1850  CONTINUE
      JG=NFL
      JH=KCHNFL(ISTORE(MR61+17))
      I=LR62+ISTORE(MR61+19)
      CALL XFCCS(STORE(I),STORE(JG),ISTORE(MR61+17))
C--PRINT THE KEYWORDS
      CALL XPRTIK(ISTORE(LR62N+1),MDR62N-1,NR62N,MDR62D,ISTORE(MR61+18)
     2 ,STORE(JG),ISTORE(MR61+17))
C--OUTPUT A BLANK LINE AFTER THE KEYWORDS
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1750)
      ENDIF
C--CHECK IF A REPEAT COUNT HAS BEEN GIVEN FOR THE PARAMETER VALUES
1900  CONTINUE
      IF(ISTORE(MR61+21))1100,1100,1950
C--COMPRESS THE OUTPUT FORMAT FOR THE VALUES
1950  CONTINUE
      JG=NFL
      JH=KCHNFL(ISTORE(MR61+20))
      I=LR62+ISTORE(MR61+22)
      CALL XFCCS(STORE(I),STORE(JG),ISTORE(MR61+20))
C--FIND THE ADDRESS OF THE DATA
      LLN=KVALCM(IBUFF(8),ISTORE(JD),JC)
C--FIND THE NUMBER OF WORDS PER GROUP
      MDLN=KVALCM(IBUFF(8)+2,ISTORE(JD),JC)
C--FIND THE NUMBER OF GROUPS
      NLN=KVALCM(IBUFF(8)+3,ISTORE(JD),JC)
C--CHECK THAT THE GROUP LENGTH IS NOT ZERO
      IF(MDLN)1100,1100,2000
C--CHECK THAT THE NUMBER OF GROUPS IS NOT ZERO
2000  CONTINUE
      IF(NLN)1100,1100,2050
C--FIND THE TYPE OF PRINT REQUIRED FOR THIS RECORD
2050  CONTINUE
      ITYPE=1
C--CHECK IF THERE ARE ANY PARAMETERS TO INVESTIGATE
      IF(NR62D)2300,2300,2100
C--LOOP OVER EACH PARAMETER
2100  CONTINUE
      MR62D=LR62D
      DO 2250 I=1,NR62D
      IF(ISTORE(MR62D+5)-2)2150,2300,2200
C--INTEGER NUMBER
2150  CONTINUE
      ITYPE=0
      GOTO 2300
C--UPDATE FOR THE NEXT PARAMETER
2200  CONTINUE
      MR62D=MR62D+MDR62D
2250  CONTINUE
C--CHECK IF THE DATA IS IN CORE OR ON DISC
2300  CONTINUE
      IF(IBUFF(7))2600,2400,2400
C--UPDATE FOR THE NEXT ITEM(S) IN CORE
2350  CONTINUE
      NLN=NLN-N
      LLN=LLN+N*MDLN
C--FIND THE NUMBER OF ITEMS TO PRINT THIS TIME
2400  CONTINUE
      N=MIN0(NLN,ISTORE(MR61+21))
C--CHECK IF THERE IS ANYTHING TO PRINT THIS TIME
      IF(N)1100,1100,2450
C--DATA IN CORE  -  CHECK THE TYPE OF PRINT REQUIRED
2450  CONTINUE
      IF(ITYPE)2500,2500,2550
C--INTEGER PRINT REQUIRED
2500  CONTINUE
      CALL XPRTIK(ISTORE(LLN),MDLN,N,MDLN,1,STORE(JG),ISTORE(MR61+20))
      GOTO 2350
C--FLOATING POINT PRINT REQUIRED
2550  CONTINUE
      CALL XPRTFK(STORE(LLN),MDLN,N,MDLN,1,STORE(JG),ISTORE(MR61+20))
      GOTO 2350
C--DATA NOT IN CORE  -  CHECK THAT THE DISC ADDRESS IS VALID
2600  CONTINUE
      IF(LLN)2650,2650,2750
C--DATA NOT ON DISC
2650  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2700)
      ENDIF
       WRITE(NCAWU,2700)
2700  FORMAT(20H Data is not on disc)
      GOTO 1100
C--DATA ON DISC  -  SET UP A BUFFER
2750  CONTINUE
      MLN=NFL
      I=KCHNFL(ISTORE(MR61+21)*MDLN)
C--CHECK IF THERE IS MORE DATA TO PRINT
2800  CONTINUE
      IF(NLN)1100,1100,2850
C--COMPUTE THE NUMBER TO PRINT THIS TIME
2850  CONTINUE
      N=MIN0(ISTORE(MR61+21),NLN)
C--COMPUTE THE NUMBER OF WORDS
      M=N*MDLN
C--BRING DOWN THE DATA
      CALL XDOWNF(LLN,STORE(MLN),M)
C--UPDATE THE POINTERS
      LLN=LLN+KINCRF(M)
      NLN=NLN-N
C--CHECK ON THE TYPE OF PRINT REQUIRED
      IF(ITYPE)2900,2900,2950
C--INTEGER PRINT REQUIRED
2900  CONTINUE
      CALL XPRTIK(ISTORE(MLN),MDLN,N,MDLN,1,STORE(JG),ISTORE(MR61+20))
      GOTO 2800
C--FLOATING POINT PRINT REQUIRED
2950  CONTINUE
      CALL XPRTFK(STORE(MLN),MDLN,N,MDLN,1,STORE(JG),ISTORE(MR61+20))
      GOTO 2800
      END
C
CODE FOR XPRTIK
      SUBROUTINE XPRTIK(IKEYS,LENGTH,NUMBER,ISTEP,IREP,FORM,IDIMN)
C--GENERAL PRINT FOR INTEGER INFORMATION
C
C  IKEYS   THE ARRAY HOLDING THE INTEGERS TO BE PRINTED.
C  LENGTH  THE LENGTH OF EACH COLUMN TO BE PRINTED.
C  NUMBER  THE NUMBER OF COLUMNS TO BE PRINTED.
C  ISTEP   THE LENGTH OF EACH COLUMN AS STORED.
C  IREP    THE NUMBER OF TIMES TO REPEAT THE DATA.
C  FORM    AN ARRAY HOLDING THE FORMAT TO BE USED.
C  IDIMN    THE DIMENSION OF THE ARRAY HOLDING THE FORMAT.
C
C--
C
      CHARACTER *132 CFORM
      DIMENSION IKEYS(ISTEP,NUMBER)
      DIMENSION FORM(IDIMN)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      WRITE(CFORM, '(33A4)') (FORM(L), L=1,IDIMN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,CFORM)
     1 (((IKEYS(I,J),I=1,LENGTH),J=1,NUMBER),K=1,IREP)
      ENDIF
      RETURN
      END
C
CODE FOR XPRTFK
      SUBROUTINE XPRTFK(AKEYS,LENGTH,NUMBER,ISTEP,IREP,FORM,IDIMN)
C--GENERAL PRINT FOR FLOATING POINT INFORMATION
C
C  AKEYS   THE ARRAY HOLDING THE FLOATING POINT NUMBERS TO BE PRINTED.
C  LENGTH  THE LENGTH OF EACH COLUMN TO BE PRINTED.
C  NUMBER  THE NUMBER OF COLUMNS TO BE PRINTED.
C  ISTEP   THE LENGTH OF EACH COLUMN AS STORED.
C  IREP    THE NUMBER OF TIMES TO REPEAT THE DATA.
C  FORM    AN ARRAY HOLDING THE FORMAT TO BE USED.
C  IDIMN    THE DIMENSION OF THE ARRAY HOLDING THE FORMAT.
C
C--
C
      CHARACTER *132 CFORM
      DIMENSION AKEYS(ISTEP,NUMBER)
      DIMENSION FORM(IDIMN)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      WRITE(CFORM, '(33A4)') (FORM(L), L=1,IDIMN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,CFORM)(((AKEYS(I,J),I=1,LENGTH),J=1,NUMBER),K=1,IREP)
      ENDIF
      RETURN
      END
C
CODE FOR XRDLEX
      SUBROUTINE XRDLEX(IULN)
C--THIS ROUTINE READS A LIST THAT IS TO BE INPUT VIA THE LEXICAL SCANNER
C
C  IULN    THE LIST NUMBER BEING INPUT.
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
C--USE THE LEXICAL SCANNER TO READ THE CARDS
      IF(KLEXAN(IULN,IFIRST,LENGTH))1200,1000,1000
C--SUCCESSFUL INPUT  -  CHECK FOR ANOTHER LIST OF THIS TYPE
1000  CONTINUE
      CALL XRLIND(IULN,LSN,IADDL,IOLEN,IOW,NOS,STORE(NFL))
C--CHECK FOR SUCH A LIST
      IF(IADDL)1150,1150,1050
C--THERE IS SUCH A LIST  -  CHECK THE LENGTH
1050  CONTINUE
      IF(LENGTH-IOLEN)1070,1070,1150
1070  CONTINUE
C----- CHECK THE WRITE  STATUS
      IF(LSN) 1150,1100,1100
C--OVERWRITE CAN BE DONE  -  MARK THE LIST AS BEING OVERWRITTEN
1100  CONTINUE
      CALL XMKOWF(IULN,-1)
C--CREATE THE LIST DATA, GENERATING A NEW VERSION FOR LINKAGE PURPOSES
      CALL XWLIND(IULN,IADDL,IOLEN,0,0)
C--COPY THE LIST
      CALL XCPYLN(IFIRST,IADDL)
C--CLEAR THE LIST FLAG
      CALL XMKOWF(IULN,0)
      CALL XALTES(IULN,1)
      GOTO 1250
C--NOT ENOUGH ROOM FOR AN OVERWRITE  -  NEW LIST
1150  CONTINUE
      CALL XWLIND(IULN,IFIRST,LENGTH,0,0)
      CALL XALTES(IULN,1)
      GOTO 1250
C--INPUT ERROR(S)
1200  CONTINUE
      CALL XOPMSG ( IOPLSI , IOPLSP , IULN )
      CALL XLSALT ( IULN , 0 , 0 , ILSERF , ILSSET )
C--AND NOW RETURN
1250  CONTINUE
      RETURN
      END
C
CODE FOR KLEXAN
      FUNCTION KLEXAN(IULN,IFIRST,LENGTH)
C--THIS IS THE LEXICAL SCANNER LINK, WHICH CONVERTS EACH CARD
C  INTO A STANDARD INTERNAL FORMAT, REMOVING SPACES, CHECKING
C  FOR OPERATORS AND CONTROL STATEMENTS AND COMBINING MULTI-CARD
C  IMAGES TOGETHER.
C
C--THE ARGUMENTS ARE :
C
C  IULN    THE LIST NUMBER THAT HAS BEEN GENERATED
C  IFIRST  THE DISC ADDRESS OF THE FIRST WORD OUTPUT.
C  LENGTH  THE LENGTH OF THE DATA OUTPUT.
C
C--RETURN VALUES ARE :
C
C  -1  ERROR(S) IN DATA
C  >0  NEXT DISC ADDRESS THAT CAN BE USED  (ALL OKAY)
C
C--THE OUTPUT IS ALWAYS TO THE NEXT FREE DISC ADDRESS. THE ARGUMENTS
C  ARE TAKEN FROM LIST 50, WHICH IS ASSUMED TO HAVE BEEN LOADED. THE SCA
C  USES THE WHOLE OF CORE TO FORM THE OUTPUT IMAGES, STORING THE ARGUMEN
C  LIST AT THE BOTTOM AND THE CARD IMAGES AT THE TOP OF CORE.
C
C--THE ARGUMENTS ARE STORED IN A DATA RECORD ON THE DISC, AND EACH ARGUM
C  HAS THE FOLLOWING FORMAT :
C
C  0  TYPE OF INFORMATION
C     LESS THAN ZERO  -  VARIABLE
C     ZERO  -  NUMBER
C     GREATER THAN ZERO  -  OPERATOR, WITH ITS VALUE
C  1  POSITION ON THE MULTICARD IMAGE WHERE THIS INFORMATION ENDED
C  2  FIRST WORD OF THE QUANTITY  -  HOLERITH STRING, UNLESS
C     THE QUANTITY IS A NUMBER
C
C--THE LENGTH OF THE ARGUMENT IS TAKEN FROM THE DATA RECORD, AND
C  USED TO SET UP THE FOLLOWING VARIABLES :
C
C  LK   THE NUMBER OF WORDS IN THE VALUE PART OF THE ARGUMENT.
C  LK1  THE TOTAL LENGTH OF AN ARGUMENT MINUS 1.
C  LK2  THE TOTAL LENGTH OF AN ARGUMENT.
C
C--VARIABLES ARE USED AS :
C
C  MA  TYPE OF THE LAST ARGUMENT, FOR CHECKING PURPOSES.
C  MB  NUMBER OF ARGUMENTS FOUND SO FAR.
C  MC  ADDRESS OF THE CURRENT DATA LOCATION.
C  MD  THE NUMBER OF CARDS PROCESSED.
C  ME  CHARACTER NUMBER OF THE CURRENT ARGUMENT.
C  MF  NUMBER OF PARENTHESES FOUND SO FAR ON THE CURRENT CARD.
C  MG  THE ADDRESS AT WHICH TO INSERT NEW CARD IMAGES.
C  MH  DISC ADDRESS OF THE LAST RECORD OUTPUT TO DISC.
C  MI  DISC ADDRESS OF THE NEXT RECORD OUTPUT TO DISC.
C  MJ  NUMBER OF REAL CARDS READ FOR THIS LOGICAL CARD.
C  MK  ADDRESS OF THE CARDS IN CORE.
C  ML  LIST TYPE NUMBER.
C  MM  LAST RECORD TYPE FOR ARGUMENTS.
C  MN  LAST RECORD TYPE FOR CARDS.
C  MO  CURRENT LIST LENGTH, UPDATED AS EACH RECORD IS OUTPUT.
C  MP  PRESERVES 'NFL'.
C  MQ  PRESERVES 'LFL'.
C  MR  THE NUMBER OF ERRORS FOUND UPTO THE CURRENT CARD.
C
C--THE CARD IMAGES ARE STORED IN ANOTHER DATA RECORD, WHICH IS GIVEN
C  BY THE ORIGINAL DATA RECORD PLUS ONE NEGATED.
C
C--
      DIMENSION ILEXCM(38)
      DIMENSION ISTORE(131072)
      DIMENSION IBUFF(8) , JBUFF(8)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XLEXCH/KS,KE,KN,KV,KB(13),KC(13)
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ILEXCM(1),LK)
C
C
C--SET THE DIMENSION OF THE LEXICAL SCANNER COMMON BLOCK
      IDIMLX=38
C
C -- INITIALISE DIRECTIVES FOR LEXICAL INPUT
      CALL XLXINI ( ILAST , 1 )
C -- INDICATE THAT THE WHOLE REGION UP TO 'LFL' CAN BE USED. THIS
C    ROUTINE DOES NOT USE THE BUFFER SET UP AT 'MD' BY XLXINI.
      MG = 0
      CALL XSTRLL ( MD )
C
      LSTTYP = ISTORE(LR61+13)
      LSTSER = 1
C
      IULN = LSTTYP
      LN = LSTTYP
C
      IOWF = 0
C
C
      IFIRST = KNEXTF ( IN )
      LSTLEN = 0
C
      IADDL = 0
      IADDR = IFIRST
C
C
C
1350  CONTINUE
C
C -- CLEAR PREVIOUS DATA FROM CORE. INDICATE
C    THAT THE NEW DATA IS TO BE WRITTEN AT NFL + 24 , TO ALLOW
C    SPACE FOR LIST /RECORD HEADERS CREATED LATER BY 'KCEDR'
C
      CALL XCSAE
      MD = NFL + 32
C
C -- READ THE NEXT SET OF DIRECTIVES FROM THE INPUT STREAM
C
      IDIRNM = KLXRDD ( ILEXCM , IDIMLX , IADARG , IADCRD , NARGCD ,
     2 NCARD , ILAST )
C
      IF ( IDIRNM .LT. 0 ) GO TO 1350
      IF ( IDIRNM .EQ. 0 ) GO TO 3000
C
      CALL XDIRFL ( IDIRNM , ILEXCM , IDIMLX )
C
C -- IF THE DIRECTIVE JUST READ IS NOT A 'DATA RECORD' THEN GO ON TO
C    THE NEXT DIRECTIVE IMMEDIATELY
C
      IF ( ISTORE(MR61+11) .EQ. 0 ) GO TO 1350
C
C
C -- **** FORMERLY SUBROUTINE XOLLCD ****
C
C
      LENCRD = NWCARD
      IOFCRD = 9
C
      IDATRC = ISTORE(MR61+11)
      ICRDRC = - IDATRC
C
      LENDAT = LK2
      MDARG = LK2
      IOFDAT = ISTORE(MR61+12)
C
C -- OUTPUT THE LOGICAL CARD TO DISK
C
C -- CREATE RECORD HEADER. UPDATE HEADER. WRITE HEADER TO DISC.
C    WRITE DATA TO DISC ( NOTE NEGATIVE RECORD NUMBER )
C
      ICARD = KCEDR ( LSTTYP, LSTSER , ICRDRC , LENCRD, 0 , IOFCRD)
C
      CALL XUDRH ( LSTTYP , ICRDRC , LENCRD , NCARD )
C
      CALL XWDRTD ( LSTTYP, ICRDRC, IADDL, IADDR, LSTLEN, ILEXCM,
     2 IDIMLX , IOWF , IBUFF )
C
      LENGTH = NWCARD * NCARD
      CALL XUPF ( LCRD ,STORE(IADCRD) , LENGTH )
C
C
C -- OUTPUT THE DATA TO DISC
C
C -- CREATE DATA RECORD. COPY DATA TO NEW RECORD. WRITE RECORD TO DISC
C
      IDATA = KCEDR ( LSTTYP, LSTSER, IDATRC, LK2 , NARGCD , IOFDAT )
C
      LARG = IDATA
      MARG = IDATA
      MDARG = LK2
      NARG = NARGCD
C
      LENGTH = LENDAT * NARGCD
      IF ( LENGTH .GT. 0 ) CALL XMOVE ( STORE(IADARG) ,
     2 STORE(IDATA) , LENGTH )
C
      CALL XWDRTD ( LSTTYP , IDATRC , IADDL , IADDR , LSTLEN , ILEXCM ,
     2 IDIMLX , IOWF , IBUFF )
C
C
      GO TO 1350
C
C
3000  CONTINUE
C
C
C
C -- IF THE LIST LENGTH 'LSTLEN' IS ZERO, THEN SET THE ADDRESS
C    OF THE FIRST RECORD TO ZERO. THIS SHOULD STOP PROCESSING
C    ERRORS WHEN THE ONLY DIRECTIVE READ IN IS 'END'
C --
      KLEXAN = IFIRST + LSTLEN
C
      LENGTH = LSTLEN
      IF ( LSTLEN .EQ. 0 ) IFIRST = 0
C
      IF ( LEF .NE. 0 ) GO TO 9900
C
      RETURN
C
C
9900  CONTINUE
C -- ERRORS
      KLEXAN = -1
      RETURN
C
C
      END
C
CODE FOR XPRTLX
      SUBROUTINE XPRTLX(IULN,ITYPE)
C--PRINT OR PUNCH THE OUTPUT FROM THE LEXICAL SCANNER
C
C  IULN    THE LIST NUMBER TO BE PRINTED.
C  ITYPE   THE TYPE OF PRINT REQUIRED :
C
C          -1  PRINT ONLY THE CARD IMAGES STORED ON DISC.
C           0  PRINT THE CARD IMAGES AND CRACKED CODE.
C           1  PUNCH A REUSABLE LIST
C
C--
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF THE LIST IS AVAILABLE FOR PRINTING
      IF(KPRTLN(IULN,NEXT))1000,1050,1050
C--AND NOW RETURN
1000  CONTINUE
      IF ( ITYPE .EQ. 1) THEN
        CALL XPCHND
        CALL XPCHUS
      ENDIF
      CALL XLINES
      RETURN
C--SET THE POINTERS FOR THE PRINT
1050  CONTINUE
      IF ( ITYPE .EQ. 1) CALL XPCHLH ( IULN)
      LAST=0
      N=-1
C--LOAD THE NEXT HEADER BLOCK FROM THE DISC
1100  CONTINUE
      IF(KLDDRH(LAST,NEXT,IBUFF))1000,1150,1150
C--CHECK THE TYPE OF RECORD WE HAVE FOUND
1150  CONTINUE
      IF(IBUFF(7))1200,1250,1250
C--CARD IMAGE  -  PRINT IT
1200  CONTINUE
      N=N+1
      IF ( ITYPE .EQ. 1) CALL XPCHLX (N,IBUFF(4),IBUFF(5),IBUFF(6))
      CALL XPRTLC(N,IBUFF(4),IBUFF(5),IBUFF(6))
      GOTO 1100
C--CRACKED CODE  -  CHECK IF WE SHOULD PRINT IT
1250  CONTINUE
      IF(ITYPE)1100,1300,1300
C--PRINT THE CODE  -  SET UP THE REQUIRED POINTERS
1300  CONTINUE
      L=IBUFF(4)
      M=IBUFF(5)
      K=0
C--CHECK IF THERE IS ENOUGH CORE
      IF(LFL-NFL-M)1350,1400,1400
C--NOT ENOUGH CORE
1350  CONTINUE
      CALL XICA
      GOTO 1000
C--CHECK IF THERE ARE MORE ARGUMENTS TO PROCESS
1400  CONTINUE
      IF(IBUFF(6))1100,1100,1450
C--BRING DOWN THE NEXT ARGUMENT
1450  CONTINUE
      CALL XDOWNF(L,STORE(NFL),M)
C--CHECK THE KIND OF PRINT REQUIRED
      IF(ISTORE(NFL))1500,1600,1500
C--PRINT VARIABLES AND OPERATORS
1500  CONTINUE
      J=NFL+M-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1550)K,(ISTORE(I),I=NFL,J)
      ENDIF
1550  FORMAT(10X,3I6,5X,20A4)
      GOTO 1700
C--PRINT NUMBERS
1600  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1650)K,ISTORE(NFL),ISTORE(NFL+1),STORE(NFL+2)
      ENDIF
1650  FORMAT(10X,3I6,E20.10)
C--UPDATE FOR THE NEXT ARGUMENT
1700  CONTINUE
      K=K+1
      L=L+KINCRF(M)
      IBUFF(6)=IBUFF(6)-1
      GOTO 1400
      END
C
CODE FOR XPRTLC
      SUBROUTINE XPRTLC(NUMB,IADDD,LENGRP,NGRP)
C--PRINT A CARD IMAGE PRODUCED BY THE LEXICAL SCANNER.
C
C  NUMB    THE CARD NUMBER.
C  IADDD   THE DISC ADDRESS OF THE LOGICAL CARD.
C  LENGRP  THE LENGTH OF EACH REAL CARD.
C  NGRP    THE NUMBER OF REAL CARDS IN THIS LOGICAL CARD.
C
C--
C
      CHARACTER *88 CLINE
      DIMENSION CARD(20)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C--MARK THIS AS THE FIRST REAL CARD
      J=0
C--FIND THE ADDRESS AND LENGTH POINTERS
      N=NGRP
      M=LENGRP
      L=IADDD
C--FIND THE LENGTH TO PRINT
      K=MIN0(M,20)
C--CHECK IF THERE ARE MORE CARDS TO PRINT
1000  CONTINUE
      IF(N)1050,1050,1100
C--NO MORE CARDS  -  RETURN
1050  CONTINUE
      RETURN
C--READ THIS IMAGE DOWN
1100  CONTINUE
      CALL XDOWNF(L,CARD(1),K)
C--UPDATE THE POINTERS
      L=L+KINCRF(M)
      N=N-1
C--CHECK IF THIS IS THE FIRST CARD
      IF(J)1150,1150,1250
C--FIRST CARD
1150  CONTINUE
      WRITE(CLINE, 1200) NUMB, CARD
1200  FORMAT(1H ,I5,2H* ,20A4)
      J=1
      GOTO 1400
C--NOT THE FIRST CARD
1250  CONTINUE
      WRITE(CLINE, 1300) CARD
1300  FORMAT(8X,20A4)
1400  CONTINUE
      CALL XCTRIM (CLINE, NCHARS)
      KK = MIN0 ( 78, NCHARS)
      IF (ISSPRT .EQ. 0) WRITE(NCWU,'(1X,A)')  CLINE(1:KK)
      IF(IQUN .EQ. JQUN)  WRITE(NCAWU,'(1X,A)') CLINE(1:KK)
      IF (NCHARS .GE. 79) THEN
       KK = KK + 1
       IF (ISSPRT .EQ. 0) WRITE(NCWU,'(9X,A)')  CLINE(KK:NCHARS)
       IF(IQUN .EQ. JQUN)  WRITE(NCAWU,'(9X,A)') CLINE(KK:NCHARS)
      ENDIF
      GOTO 1000
      END
C
CODE FOR XCELST
      SUBROUTINE XCELST(IULN,ICOMMN,IDIMN)
C--CREATE A LIST IN CORE FROM THE DATA STORED IN LIST 50
C
C  IULN    THE LIST TYPE TO SET UP.
C  ICOMMN  THE COMMON BLOCK TO BE USED WITH THIS LIST.
C  IDIMN    THE DIMENSION OF THE COMMON BLOCK.
C
C--
C
      DIMENSION ICOMMN(IDIMN)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK THE LIST TYPE GIVEN
      ISTAT = KLSCHK ( IULN , 0 , 0 , ILSCLN , ILSMSG , I , IERPRG )
C--RECORD THE CURRENT CORE LIMITS
      JA=NFL
      JB=LFL
C--LOAD THE DETAILS OF LIST 50
      CALL XFAL50
      LFL=LR52-1
C--LOAD THE DETAILS FOR THE LIST IN QUESTION
      CALL XLL50R(IULN+LSTOFF)
C--CHECK IF THERE ARE ANY DIRECTIVES FOR THE LIST
      IF(NR60)1800,1800,1000
C--DIRECTIVES STORED  -  LOOP OVER THEM
1000  CONTINUE
      MR60=LR60
      MR61=LR61
      DO 1750 I=1,NR60
C--CHECK IF THE CURRENT DIRECTIVE DEFINES A DATA RECORD
      IF(ISTORE(MR61+11))1050,1700,1050
C--DATA RECORD DEFINED HERE  -  FIND THE ADDRESS OF 'LENGRP' AND 'NGRP'
1050  CONTINUE
      K=MR61+9
      L=K+1
C--LOOP OVER EACH ITEM, SETTING THEM FROM THE COMMON BLOCK IF NEC.
      DO 1150 J=K,L
C--CHECK IF THE VALUE OR ITS ADDRESS IS GIVEN
      IF(ISTORE(J))1100,1150,1150
C--ITS ADDRESS IS GIVEN  -  FIND THE VALUE
1100  CONTINUE
      ISTORE(J)=KVALCM(IABS(ISTORE(J)),ICOMMN,IDIMN)
C--ENSURE THE VALUE IS OKAY
      ISTORE(J)=MAX0(ISTORE(J),0)
1150  CONTINUE
C--SET UP THE POINTERS FOR THIS DIRECTIVE
      CALL XDIRFL(I,ICOMMN,IDIMN)
C--CREATE THE NECESSARY DATA RECORD AND SET THE COMMON BLOCK POINTERS
      IF(KCDRFI(ICOMMN,IDIMN,1))1200,1300,1300
C--ERROR WHILE PERFORMING THE RECORD CREATION
1200  CONTINUE
      GO TO 9900
C--CHECK IF THE RECORD IS IN CORE
1300  CONTINUE
      IF(ISTORE(MR61+11))1700,1700,1350
C--RECORD IS IN CORE  -  FIND THE LENGTH OF THE DATA
1350  CONTINUE
      K=ISTORE(MR61+12)
      J=ICOMMN(K+2)*ICOMMN(K+3)
C--CHECK FOR SOME DATA
      IF(J)1700,1700,1400
C--DATA STORED  -  ZERO IT INITIALLY
1400  CONTINUE
      L=ICOMMN(K)
      CALL XZEROF(STORE(L),J)
C--CHECK FOR SOME PARAMETER KEYWORDS FOR THIS DIRECTIVE
      IF(NR62D)1700,1700,1450
C--KEYWORDS  -  FIND THE NUMBER OF GROUPS FOR THIS DIRECTIVE
1450  CONTINUE
      N=ICOMMN(K+3)
      MR62D=LR62D
C--PASS OVER EACH PARAMETER KEYWORD, LOOKING FOR DEFAULT VALUES TO USE
      DO 1650 J=1,NR62D
C--CHECK FOR A DEFAULT VALUE
      IF(ISTORE(MR62D+7))1600,1500,1500
C--DEFAULT VALUE  -  ASSIGN IT TO EACH REPEAT GROUP
1500  CONTINUE
      M=L
      DO 1550 K=1,N
      CALL XMOVE(STORE(MR62D+8),STORE(M),1)
      M=M+ISTORE(MR61+9)
1550  CONTINUE
C--UPDATE FOR THE NEXT KEYWORD
1600  CONTINUE
      MR62D=MR62D+MDR62D
      L=L+1
1650  CONTINUE
C--UPDATE FOR THE NEXT DIRECTIVE
1700  CONTINUE
      MR60=MR60+MDR60
      MR61=MR61+MDR61
1750  CONTINUE
C--RESET THE UPPER CORE LIMIT
1800  CONTINUE
      LFL=JB
      RETURN
C
9900  CONTINUE
C -- ERRORS
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9905 ) IULN , ISTORE(MR61+11)
      ENDIF
      WRITE ( NCAWU , 9905 ) IULN , ISTORE(MR61+11)
9905  FORMAT ( 1X , 'Error while creating list type ' , I3 ,
     1 ' record ' , I8 )
      CALL XERHND ( IERPRG )
      RETURN
      END
C
CODE FOR XFAOLS
      SUBROUTINE XFAOLS(IULN,JREC,ICOMMN,IDIMN)
C--FORM AN ABSOLUTE ORDERED LIST IN CORE.
C
C  IULN    THE LIST TYPE.
C  JREC    THE RECORD TYPE NUMBER THAT MUST BE PLACED LAST IN CORE.
C  ICOMMN  THE CONTROLLING COMMON BLOCK.
C  IDIMN    THE DIMENSION OF 'ICOMMN'.
C
C--
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ISTORE(131072)
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--ZERO THE COMMON BLOCK INITIALLY
      CALL XZEROF(ICOMMN(1),IDIMN)
C--SET THE LENGTH OF THE SPECIAL RECORD TO 'NOWT' INITIALLY
      JBUFF(3)=NOWT
C--LOAD THE DETAILS FOR THE REQUIRED LIST
      CALL XLDLST(-IULN,ISTORE(NFL),1,0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE DISC POINTERS INITIALLY
      IADD1=0
      IADD2=ISTORE(NFL)
C--FIND THE NEXT RECORD ON DISC
1000  CONTINUE
      IF(KLDDRH(IADD1,IADD2,IBUFF))1200,1050,1050
C--CHECK IF THIS IS THE SPECIAL RECORD
1050  CONTINUE
      IF(IBUFF(7)-JREC)1150,1100,1150
C--THIS IS THE SPECIAL RECORD  -  PRESERVE ITS RECORD HEADER
1100  CONTINUE
      CALL XMOVE(IBUFF(1),JBUFF(1),8)
      GOTO 1000
C--LOAD THE RECORD WE HAVE FOUND
1150  CONTINUE
      CALL XLDREC(IULN,1,IBUFF,ICOMMN,IDIMN,-1)
      GOTO 1000
C--CHECK IF WE HAVE FOUND AN SPECIAL RECORD
1200  CONTINUE
      IF(JBUFF(3))1300,1300,1250
C--LOAD THE 'ATOM' RECORD
1250  CONTINUE
      CALL XLDREC(IULN,1,JBUFF,ICOMMN,IDIMN,-1)
C--AND NOW RETURN
1300  CONTINUE
C -- NORMAL AND ERROR RETURN
9900  CONTINUE
      RETURN
      END
C
CODE FOR XRCN
      SUBROUTINE XRCN
C--READ THE NEW COMPOUND OR JOB TITLE
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCOMPD/TITLE(20)
C
C--READ THE NEXT DIRECTIVE CARD
1000  CONTINUE
      IF(KRDNDC(STORE(NFL),1))1250,1050,1100
C--'CONTINUATION' CARD  -  IGNORE IT
1050  CONTINUE
      CALL XMONTR(0)
      GOTO 1000
C--SEARCH FOR THE PARAMETER KEYWORD
1100  CONTINUE
      IF(KFNDNP(I))1150,1150,1300
C--ERROR DURING PROCESSING OF THE NEW TITLE
1150  CONTINUE
      CALL XMONTR(0)
      CALL XERHDR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)
      ENDIF
      WRITE ( NCAWU , 1200 )
1200  FORMAT ( 1X, 'Illegal TITLE card. A new title must be specified')
      IDIRFL=-1
C--AND NOW RETURN
1250  CONTINUE
      RETURN
C--COMPUTE THE LENGTH OF THE NEW TITLE
1300  CONTINUE
      NC=KNEQUL(NC,IB)
      IF(NC)1150,1150,1350
C--SOME CHARACTERS TO USE  -  NOW COMPUTE THE LENGTH
1350  CONTINUE
      N=LASTCH-NC+1
C--CHECK THAT THERE IS A NEW TITLE
      IF(N)1150,1150,1400
C--SET THE TITLE ARRAY TO BLANKS
1400  CONTINUE
      CALL XMVSPD(IB,TITLE(1),20)
C--FORM THE TITLE INTO A4 CHARACTERS
      CALL XFA4CS ( LCMAGE(NC) , TITLE(1) , N )
C--WRITE THE TITLE TO THE DISC
      CALL XWTTLE
C--ALTER THE CHARACTER POINTER
      NC=LASTCH+1
      GOTO 1000
      END
C
CODE FOR XDISCF
      SUBROUTINE XDISCF
C--THIS ROUTINE PERFORMS VARIOUS HOUSE-KEEPING FUNCTIONS ON THE DISC
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XDISCS/NCDFU,NCIFU,NCLDU , NCNDU
      COMMON /XDAVAL/ IDAINI,IDATOT,IDAMAX,IDAMIN,IDAAUT,IDAQUA,IDATRY
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET THE MAXIMUM LENGTH OF THE COMMON BLOCK TO BE USED HERE
C -- SET UP AREA FOR COMMAND PROCESSING
      ICOMSZ = 5
      ICOMBL = KSTALL ( ICOMSZ )
C -- LOAD DIRECT ACCESS CONTROL DATA
      CALL XDAEXC
C--ENSURE THAT THE ALL THE DIRECTIVES APPEAR TO HAVE BEEN READ ONCE
      MR61=LR61
      DO 1000 I=1,NR60
      ISTORE(MR61+8)=1
      MR61=MR61+MDR61
1000  CONTINUE
C--MARK THE DIRECTIVE POINTER AS CONTAINING NO DIRECTIVE
      IDIR=-1
C
1050  CONTINUE
C -- READ NEXT DIRECTIVE
      IDIR = KRDNDC ( ISTORE(ICOMBL) , ICOMSZ )
C -- CHECK IF THE DIRECTIVE JUST READ IN IS 'END' OR 'CONTINUE'
      IF ( IDIR .LT. 0 ) GO TO 8800
      IF ( IDIR .EQ. 0 ) GO TO 9930
C
1100  CONTINUE
C -- PROCESS THE KEYWORDS AND PARAMETERS
      IF (  KFNDNP ( I )  .LE.  0  ) GO TO 1200
      IF (  KRDPV ( ISTORE(ICOMBL) , ICOMSZ )  .LT.  0 ) GO TO 1200
      GO TO 1100
C
1200  CONTINUE
      ISTAT = KCHKPV ( IDIR , ISTORE(ICOMBL) , ICOMSZ , -1 )
      IF ( ISTAT .LT. 0 ) GO TO 2150
      IF ( LEF .GT. 0 ) GO TO 2150
C -- DISPLAY CARD JUST READ IN
      CALL XMONTR ( -1 )
C
C -- SET DATA FROM COMMAND READ IN
      LN = ISTORE(ICOMBL)
      LSN = ISTORE(ICOMBL+1)
      LRSN = ISTORE(ICOMBL+2)
      IVAL = ISTORE(ICOMBL+3)
      KB = ILSSET
C -- BRANCH ON THE FUNCTION
      GO TO ( 1250 , 1400 , 1550 , 1700 , 1850 ,
     1 1510 , 1875 , 9910 ) , IDIR
      GO TO 9910
C
C
1250  CONTINUE
      IF ( ISTORE(ICOMBL) ) 1310 , 1320 , 1330
1310  CONTINUE
      CALL XPRTLI
      GO TO 4000
C
1320  CONTINUE
      CALL XPRTFI
      GO TO 4000
C
1330  CONTINUE
      CALL XDASUM
      GO TO 4000
C
1400  CONTINUE
C -- 'MARK' DIRECTIVE
      IF ( IVAL .LT. 0 ) KB = ILSCLR
      IFUNC = 1
      GO TO 1870
1510  CONTINUE
C -- 'USAGE' DIRECTIVE
      IF ( IVAL .LT. 0 ) KB = ILSOVR
      IF ( IVAL .EQ. 0 ) KB = ILSRDY
      IF ( IVAL .GT. 0 ) KB = ILSUPD
      IFUNC = 4
      GO TO 1870
1550  CONTINUE
C -- 'RETAIN' DIRECTIVE
      IF ( IVAL .LT. 0 ) KB = ILSCLR
      IFUNC = 2
      GO TO 1870
1700  CONTINUE
C -- 'DELETE' DIRECTIVE
      IF ( IVAL .LT. 0 ) KB = ILSCLR
      IFUNC = 3
      GO TO 1870
1850  CONTINUE
C -- 'RESET' DIRECTIVE
      IFUNC = 5
      GO TO 1870
1870  CONTINUE
C -- PERFORM OPERATION
      CALL XLSALT ( LN , LSN , LRSN , IFUNC , KB )
      GO TO 4000
C
1875  CONTINUE
C -- 'EXTEND' DIRECTIVE
      IRECS = ISTORE(ICOMBL)
      IFREE = ISTORE(ICOMBL+1)
      IDATRY = ISTORE(ICOMBL+2)
      IDAQUA = ISTORE(ICOMBL+3)
      CALL XDACVI ( NWDRCI , NWDBLI , NBYWDI )
C -- CHECK FOR INVALID VALUES SUPPLIED
      IF ( IRECS .LT. 0 ) GO TO 9900
      IF ( IFREE .LT. 0 ) GO TO 9900
C -- IF AN AMOUNT OF FREE SPACE HAS BEEN REQUESTED, FIND OUT HOW MUCH
C    SPACE MUST BE ADDED.
      CALL XDAEND ( NCDFU , IEND )
      ILASTU = ( KNEXTF ( IN ) / NWDRCI ) + 1
      IUNUSE = IEND - ILASTU - 1
      IADD = MAX0 ( ( IFREE - IUNUSE ) , 0 ) + IRECS
C -- ADD REQUIRED EXTRA RECORDS TO FILE
      CALL XDAXTN ( NCDFU , IEND , IADD )
C -- CALCULATE THE NUMBER OF WORDS THAT HAVE BEEN ADDED TO THE FILE
      IWORDS = IADD * NWDRCI
C -- WRITE A MESSAGE TO INFORM THE USER
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1877 ) IADD , IWORDS
      ENDIF
      WRITE ( NCAWU , 1877 ) IADD , IWORDS
1877  FORMAT ( 1X,'Disc file extended by ',I3, ' record(s)' ,
     1 ' ( ' , I6 , ' integer words ) ' , / )
      GO TO 4000
C
C
4000  CONTINUE
C -- FINISHED THIS DIRECTIVE
      IF ( IERFLG .LT. 0 ) GO TO 2150
      GO TO 1050
C
C
8800  CONTINUE
      IF ( IERFLG .LT. 0 ) GO TO 2150
      IF ( LEF .NE. 0 ) GO TO 2150
      RETURN
C
C
2150  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2200 )
      ENDIF
      WRITE ( NCAWU , 2200 )
2200  FORMAT ( 1X , 'Disc control error(s). Processing abandoned' )
      RETURN
C
9900  CONTINUE
C
C -- ERROR - NEGATIVE NUMBER OF RECORDS
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9905 ) IRECS
      ENDIF
      WRITE ( NCAWU , 9905 ) IRECS
9905  FORMAT ( 1X,I5 , ' is an invalid number of records for EXTEND' )
      CALL XERHND ( IERERR )
      GO TO 2150
9910  CONTINUE
      CALL XOPMSG ( IOPCRY , IOPINT , 0 )
      GO TO 2150
9930  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9935 )
      ENDIF
      WRITE ( NCAWU , 9935 )
9935  FORMAT ( 1X , 'Continuation cards are not allowed for this' ,
     2 ' instruction ' )
      GO TO 2150
C
      END
C
CODE FOR XPURGE
      SUBROUTINE XPURGE
C--SUBROUTINE TO ELIMINATE UNWANTED LISTS FROM THE DISC
C
C
C      NEWFIL      0      PURGE CURRENT FILE
C                  1      CREATE NEW FILE FOR DATA ( 'PURGE NEW' )
C
C
C
C
C--
C
      CHARACTER*16 CSSMAC , CSSOPS , CSSDAT , CSSPRG
      CHARACTER*64 CSSCMD, CSSNDA, CSSCST, CSSDST, CSSSCT, CSSELE
      CHARACTER*64 CSSVDU, CSSLPT
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XDISC/NU
      COMMON/XDISCS/NCDFU,NCIFU,NCLDU , NCNDU
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
      COMMON /XSSCHR/ CSSMAC, CSSOPS, CSSDAT, CSSPRG, CSSCMD, CSSNDA,
     2 CSSCST , CSSDST, CSSSCT, CSSELE, CSSVDU, CSSLPT
      COMMON /XSSLSN/ LSSMAC, LSSOPS, LSSDAT, LSSPRG, LSSCMD, LSSNDA,
     2 LSSCST , LSSDST, LSSSCT, LSSELE, LSSVDU, LSSLPT
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      DATA ICOMSZ / 3 /
      DATA MINSIZ / 5 /
C
C
C--SET THE TIMING AND READ THE CONSTANTS
      CALL XTIME1(2)
      IEXTND = 0
C
C -- ALLOCATE SPACE TO HOLD RETURN VALUES FROM INPUT
      ICOMBF = KSTALL ( ICOMSZ )
      I = KRDDPV ( ISTORE(ICOMBF) , ICOMSZ )
      IF ( I .LT. 0 ) GO TO 9920
C
C
C -- CREATE NEW FILE FLAG -- NEWFIL = 0  >>> NO NEW FILE
      NEWFIL = ISTORE(ICOMBF)
C -- INITIAL SIZE REQUESTED
      IRQSIZ = ISTORE(ICOMBF+1)
C -- SET LOG FLAG
      LOGREQ = ISTORE(ICOMBF+2)
C -- SET TOTAL LENGTH OF FILE REQUIRED FOR NEW LISTS
      LENTOT = 0
C
C -- OLD AND NEW FILE UNITS = 'NCDFU'
      NUOLD = NCDFU
      NUNEW = NCDFU
C -- UNLESS A NEW FILE IS REQUIRED, IN WHICH CASE NEW FILE UNIT = NCNDU
      IF ( NEWFIL .GT. 0 ) NUNEW = NCNDU
C
C -- CHECK INITIAL SIZE VALUE
      IF ( IRQSIZ .LT. 0 ) GO TO 9910
      IF ( IRQSIZ .EQ. 0 ) GO TO 910
      IF ( NEWFIL .GT. 0 ) GO TO 910
C -- AN INITIAL SIZE HAS BEEN REQUESTED WITH NO NEW FILE -- IGNORE AND
C    WARN USER
C --
      CALL XPUMSG ( 1 , 0 )
910   CONTINUE
C--RESET THE CORE
      CALL XRSL
      CALL XCSAE
C--SET SOME INITIAL CONSTANTS
      MLN=49
      KA=NFL
      KB=8
      LN=51
      IREC=0
      KC=KCHNFL(KB)
C--SELECT ENTRIES FROM THE CURRENT LIST INDEX
      DO 1200 I=1,MLN
      KD=KC-KB
C--SET THE LIST TYPE
      ISTORE(KD)=I
C--READ THE ENTRY
      IF(KRCLI(ISTORE(KD),ISTORE(KD+1),ISTORE(KD+2),ISTORE(KD+3),
     2 ISTORE(KD+4),ISTORE(KD+5),ISTORE(KD+6)))1200,1000,1000
C--CHECK THAT THIS LIST IS NOT OPEN FOR WRITING
1000  CONTINUE
C----- CHECKIF ITS A DELETED LIST
      IF(ISTORE(KD))1010,1010,1040
1010  CONTINUE
      CALL XPUMSG ( 5 , KD )
      GOTO 1200
1040  CONTINUE
      IF(ISTORE(KD+4))1050,1150,1150
C--ERROR BECAUSE THE LIST IS OPEN FOR WRITING
1050  CONTINUE
      CALL XPUMSG ( 6 , KD )
      GOTO 1200
C--ALLOCATE SPACE FOR THIS LIST
1150  CONTINUE
      KC=KCHNFL(KB)
C -- INCREASE TOTAL SPACE REQUIRED FOR SAVED LISTS
      LENTOT = LENTOT + ( ISTORE(KD+3) - ISTORE(KD+2) + 1 )
1200  CONTINUE
C--CHECK IF THERE ARE ANY LISTS ON THIS DISC
      IF(KC-KB+KA)2700,2700,1250
C--PRESERVE THE ADDRESS OF THE LAST LIST IN THE CURRENT LIST INDEX
1250  CONTINUE
      KE=KC-KB-KB
C--FIND ANY LISTS IN THE FILE INDEX WHICH CANNOT BE PURGED
      DO 1700 I=1,MLN
      ISRCH=0
C--SET THE POINTERS
1300  CONTINUE
      KD=KC-KB
      ISTORE(KD)=I
C--SEARCH FOR THE NEXT LIST OF THE CORRECT TYPE
      IF(KRFI(ISTORE(KD),ISRCH,ISTORE(KD+2),ISTORE(KD+3),ISTORE(KD+4),
     2 ISTORE(KD+5),ISTORE(KD+6)))1700,1350,1350
C--CHECK IF THIS LIST IS IN THE CURRENT LIST INDEX
1350  CONTINUE
      ISTORE(KD+1)=ISRCH
      DO 1450 J=KA,KE,KB
      IF(ISTORE(J)-ISTORE(KD))1450,1400,1450
C--CHECK THE SERIAL NUMBERS
1400  CONTINUE
      IF(IABS(ISTORE(J+1))-IABS(ISTORE(KD+1)))1500,1300,1500
1450  CONTINUE
C--CHECK IF THIS LIST SHOULD BE SAVED
1500  CONTINUE
      IF ( ISTORE(KD+1) .LT. 0 ) GO TO 1550
C -- CHECK IF THIS SHOULD BE LOGGED
      IF ( LOGREQ .GT. 0 ) CALL XPUMSG ( 8 , KD )
      GO TO 1300
1550  CONTINUE
C -- LIST IS MARKED FOR RETENTION
C----- CHECK IF THIS IS A DELETED LIST
      IF(ISTORE(KD)) 1560,1560,1590
1560  CONTINUE
      CALL XPUMSG ( 5 , KD )
      GOTO 1300
1590  CONTINUE
      IF(ISTORE(KD+4))1600,1650,1650
C--LIST IS OPEN FOR WRITING
1600  CONTINUE
      CALL XPUMSG ( 6 , KD )
      GOTO 1300
C--CREATE SPACE FOR THE ENTRY
1650  CONTINUE
      KC=KCHNFL(KB)
C -- INCREASE TOTAL SPACE REQUIRED FOR SAVED LISTS
      LENTOT = LENTOT + ( ISTORE(KD+3) - ISTORE(KD+2) + 1 )
      GOTO 1300
1700  CONTINUE
C--FIND THE ADDRESS OF THE LAST ENTRY
      KD=KC-KB-KB
C
C -- CREATE NEW FILE IF REQUIRED
C
      IF ( NEWFIL .LE. 0 ) GO TO 1740
C -- CREATE NEW FILE
      ISTAT = KDAOPN ( NUNEW , CSSNDA(1:LSSNDA) , ISSNEW , ISSWRI )
C -- CALCULATE THE SPACE REQUIRED FOR THE NEW FILE. THIS IS THE MAXIMUM
C    OF 0 , ( 'IRQSIZ'- 'MINSIZ' ) , AND 'LSTLEN'
C
      CALL XDACVI ( NWDRCI , NWDBLI , NBYWDI )
C
      LSTLEN = ( LENTOT / NWDRCI ) + 1
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1732 ) LSTLEN
      ENDIF
      WRITE ( NCAWU , 1732 ) LSTLEN
1732  FORMAT ( 1X , 'The space required for the lists to be saved is ',
     2 I5 , ' record(s)' )
C
      IEXTND = MAX0 ( ( IRQSIZ - MINSIZ ) , 0 )
      IEXTND = MAX0 ( IEXTND , LSTLEN )
      CALL XDAXTN ( NUNEW , -1 , IEXTND )
C --
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1735 ) IEXTND
      ENDIF
      WRITE ( NCAWU , 1735 ) IEXTND
1735  FORMAT ( 1X , 'The new file has been extended by ' , I5 ,
     1 ' record(s)' )
C --
1740  CONTINUE
C
C -- INFORM THE USER THAT THE INDEXES ARE ABOUT TO BE RESET
      CALL XPUMSG ( 12 , NUNEW )
C -- CHANGE TO THE OUTPUT DISC
      NSAVEU = KSWPDU ( NUNEW )
C
      CALL XLOADF
      CALL XLOADL
C
      CALL XSETFI
      CALL XSETLI
C
C -- RESTORE THE STORED LIST INDEX ENTRIES TO THE DISC INDEX
C
      DO 2000 I = KA , KD , KB
C
C -- CHECK THAT THE LIST HAS NOT BEEN LOST, BY BEING OVERWRITTEN BY THE
C    INDEX ENTRIES ( THIS IS NOT POSSIBLE IF A NEW FILE IS CREATED )
      IF ( NEWFIL .GT. 0 ) GO TO 1900
      IF ( ISTORE(I+2) .GE. KNEXTF(I) ) GO TO 1900
C -- LIST HAS BEEN LOST
      CALL XPUMSG ( 7 , I )
      ISTORE(I+2)=0
      GOTO 2000
C--WRITE THE LIST INTO THE FILE INDEX
1900  CONTINUE
      CALL XWFI(ISTORE(I),ISTORE(I+1),ISTORE(I+2),ISTORE(I+3),
     2 ISTORE(I+4),ISTORE(I+5),ISTORE(I+6),0)
C--CHECK IF THIS SHOULD BE ENTERED IN THE CURRENT LIST INDEX
      IF(I-KE)1950,1950,2000
C--WRITE THE ENTRY INTO THE CURRENT LIST INDEX
1950  CONTINUE
      CALL XWCLI(ISTORE(I),ISTORE(I+1),ISTORE(I+2),ISTORE(I+3),
     2 ISTORE(I+4),ISTORE(I+5),ISTORE(I+6))
2000  CONTINUE
C -- INFORM USER INDEX ( PARTIALLY RESTORED )
      CALL XPUMSG ( 13 , 0 )
C
C -- A FILE INDEX HAS NOW BEEN WRITTEN TO OUTPUT DISC.
C -- REWRITE LISTS TO THE OUTPUT DISC
C
C--FIND THE NEXT LIST TO BE OUTPUT
2100  CONTINUE
      N=KNEXTF(I)
      M=1000000
      L=0
C--LOOP OVER ALL THE LISTS, SEARCHING FOR THE SMALLEST INITIAL ADDRESS
      DO 2350 I=KA,KD,KB
C--CHECK IF THE LIST HAS ALREADY BEEN PROCESSED
      IF(ISTORE(I+2))2350,2350,2150
C--CHECK THE ADDRESS
2150  CONTINUE
      IF(ISTORE(I+2)-M)2200,2350,2350
C--THIS IS THE SMALLEST  -  CHECK THE VALUE IS NOT TOO SMALL
2200  CONTINUE
      IF ( NEWFIL .GT. 0 ) GO TO 2300
      IF(ISTORE(I+2)-N)2250,2300,2300
C--THIS LIST HAS BEEN OVERWRITTEN BEFORE WE CAN USE IT
2250  CONTINUE
      CALL XPUMSG ( 7 , I )
C--ALTER THE WRITE FLAG TO INDICATE WE CANNOT USE THIS LIST
      ISTORE(I+4)=1
C--ALTER THE ERROR STATUS OF THIS LIST
      ISTORE(I+5)=-MAX0(IABS(ISTORE(I+5)),1)
      L=I
      IFLAG=-1
      GOTO 2550
C--THIS LIST IS BETTER  -  RECORD THE DETAILS
2300  CONTINUE
      L=I
      M=ISTORE(I+2)
2350  CONTINUE
C--CHECK IF WE HAVE PROCESSED ALL THE LISTS
      IF(L)2700,2700,2400
C--CHECK IF WE SHOULD REWRITE THIS LIST
2400  CONTINUE
      IULN=IABS(ISTORE(L))
      IF (  ( M .EQ. N ) .AND. ( NUOLD .EQ. NUNEW ) ) GO TO 2500
C -- DISC UNITS AND/OR ADDRESSES ARE DIFFERENT -- LIST SHOULD BE
C    REWRITTEN
C -- SET LIST NUMBER
      LN = IABS ( ISTORE(I) )
      CALL XPUCPY ( M , N , NUOLD , NUNEW )
2500  CONTINUE
      IFLAG=0
C--COMPUTE THE NEXT LIST LENGTH
      K=ISTORE(L+3)-ISTORE(L+2)+1
C--COMPUTE THE NEW ADDRESSES
      ISTORE(L+2)=N
      ISTORE(L+3)=N+K-1
C--COMPUTE THE NEXT FREE ADDRESS
      N=N+K
      CALL XNEXTF(N)
C--ALTER THE LIST INDEX ENTRIES
2550  CONTINUE
      CALL XWFI(ISTORE(L),ISTORE(L+1),ISTORE(L+2),ISTORE(L+3),
     2 ISTORE(L+4),ISTORE(L+5),ISTORE(L+6),-1)
C--CHECK IF THIS SHOULD BE ENTERED IN THE CURRENT LIST INDEX
      IF(L-KE)2600,2600,2650
C--WRITE THE ENTRY INTO THE CURRENT LIST INDEX
2600  CONTINUE
      CALL XWCLI(ISTORE(L),ISTORE(L+1),ISTORE(L+2),ISTORE(L+3),
     2 ISTORE(L+4),ISTORE(L+5),ISTORE(L+6))
2650  CONTINUE
      ISTORE(L+2)=0
      GOTO 2100
C--END OF THE PROCESS  -  TERMINATION MESSAGES
2700  CONTINUE
C
C
      CALL XPUMSG ( 11 , NUNEW )
      CALL XPRTFI
C
2720  CONTINUE
C -- PROCESSING COMPLETED. RESTORE LIST 50 INDEX ENTRY
      KA = KSWPDU ( NCIFU )
C--LOAD THE INDICES
      CALL XLOADF
      CALL XLOADL
C--READ THE DETAILS OF LIST 50
      LN50=50
      I=KRCLI(LN50,LSN50,NFW50,NLW50,IOWF50,NOS50,ISTORE(NFL))
C--SWOP BACK TO THE DATA DISC
      N = KSWPDU ( NSAVEU )
C--RELOAD ITS INDICES
      CALL XLOADF
      CALL XLOADL
C--WRITE THE INDEX DATA FOR LIST 50 INTO THIS INDEX
      CALL XWCLI(LN50,LSN50,NFW50,NLW50,IOWF50,NOS50,ISTORE(NFL))
C -- FINAL MESSAGE
      CALL XOPMSG ( IOPPUR , IOPEND , 610 )
      CALL XTIME2(2)
      CALL XRSL
      CALL XCSAE
      RETURN
C
C
9900  CONTINUE
      CALL XOPMSG ( IOPPUR , IOPABN , 0 )
      GO TO 2720
9910  CONTINUE
C -- NEGATIVE INITIAL SIZE
      CALL XPUMSG ( 2 , IRQSIZ )
      GO TO 9900
9920  CONTINUE
C -- INPUT ERRORS
      CALL XOPMSG ( IOPPUR , IOPCMI , 0 )
      GO TO 9900
C
      END
C
C --
C
CODE FOR XPUCPY
      SUBROUTINE XPUCPY ( IFROM , ITO , NUOLD , NUNEW )
C
C -- COPY LIST FROM IFROM TO ITO. NUOLD AND NUNEW ARE THE DISC UNITS
C    FOR IFROM AND ITO RESPECTIVELY.
C
C--THIS ROUTINE USES ALL THE AVAILABLE STORE
C
C--
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET UP THE OLD DISC ADDRESSES
      IOLD1 = 0
      IOLD2 = IFROM
C--SET UP THE OUTPUT ADDRESSES
      INEW1 = 0
      INEW2 = ITO
C--FIND THE MAXIMUM AMOUNT OF CORE WE CAN USE
      JA = LFL - NFL
C--LOAD THE NEXT RECORD HEADER
1000  CONTINUE
      NUNIT = KSWPDU ( NUOLD )
C -- CHECK IF THERE IS A NEW RECORD. IF NOT, GOTO END
      IF ( KLDDRH ( IOLD1,IOLD2,IBUFF ) .LT. 0 ) GO TO 1500
C--NEW RECORD TO COPY  -  CHECK IF THIS IS THE FIRST
      IF ( INEW1 .LE. 0 ) GO TO 1150
C--NOT THE FIRST  -  UPDATE THE LAST FORWARD POINTER
      IBUFF(1) = INEW2
      NUNIT = KSWPDU ( NUNEW )
      CALL XUPF(INEW1,IBUFF(1),1)
C--ALTER THE ADDRESS POINTERS IN 'IBUFF'
1150  CONTINUE
      IBUFF(1) = 0
      IBUFF(2) = INEW1
C--FIND THE ADDRESS OF THE DATA FOR THIS RECORD
      M = IBUFF(4)
C--CHECK IF THE DATA IS ON DISC. ( M POSITIVE IF ON DISC )
      IF ( M .LE. 0 ) GO TO 1250
C--COMPUTE THE NEW ADDRESS
      IBUFF(4) = INEW2 + KINCRF ( MD0 )
C--OUTPUT THE HEADER
1250  CONTINUE
      NUNIT = KSWPDU ( NUNEW )
      CALL XUPF ( INEW2 , IBUFF(1) , MD0 )
C--SWITCH ADDRESSES
      INEW1 = INEW2
C--CHECK IF THE DATA IS ON DISC
      IF ( M .GT. 0 ) GO TO 1350
C--THE DATA IS NOT ON DISC
      INEW2 = INEW2 + KINCRF ( MD0 )
      GOTO 1000
C--DATA IS ON DISC  -  COMPUTE THE NEW ADDRESS
1350  CONTINUE
      INEW2 = INEW2 + KINCRF ( IBUFF(3) )
C--FIND THE NEW OUTPUT ADDRESS FOR THE DATA
      L = IBUFF(4)
C--FIND THE LENGTH OF THE RECORD
      N = IBUFF(3) - MD0
C--CHECK IF THERE IS MORE DATA TO OUTPUT
1400  CONTINUE
      IF ( N .LE. 0 ) GO TO 1000
C--OUTPUT THE NEXT BLOCK OF DATA
      K = MIN0 ( JA , N )
C--READ THE NEXT BLOCK DOWN
      NUNIT = KSWPDU ( NUOLD )
      CALL XDOWNF ( M , STORE(NFL) , K )
C--WRITE IT BACK
      NUNIT = KSWPDU ( NUNEW )
      CALL XUPF ( L , STORE(NFL) , K )
C--UPDATE THE ADDRESSES
      L = L + KINCRF ( K )
      M = M + KINCRF ( K )
C--UPDATE THE COUNT
      N = N - K
      GOTO 1400
C--DUMP THE DISC BUFFERS
1500  CONTINUE
      CALL XDUMP
      NUNIT = KSWPDU ( NUNEW )
      RETURN
      END
C
C --
C
CODE FOR XPUMSG
      SUBROUTINE XPUMSG ( IMSG , IPARAM )
C
C -- THIS ROUTINE PRODUCES MESSAGES FOR 'XPURGE'
C
C
C
C -- MESSAGE NUMBERS :-
C
C    1    INITIAL SIZE FOR OLD FILE IGNORED
C    2    ILLEGAL INITIAL SIZE REQUEST
C    3    ( NOT USED )
C    4    ( NOT USED )
C    5    LIST MARKED FOR DELETION
C    6    LIST BEING WRITTEN TO
C    7    LIST LOST
C    8      OLD VERSION
C    9    ( NOT USED )
C   10    ( NOT USED )
C   11    INDEX RESTORED COMPLETELY
C   12    INDEX UNUSABLE
C   13    INDEX PARTIALLY RESTORED
C
C
      CHARACTER*10 FILNAM
      CHARACTER*20 REASON(4)
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      DATA REASON(1) / '( deleted )     ' /
      DATA REASON(2) / '( being updated )' /
      DATA REASON(3) / '( lost )        ' /
      DATA REASON(4) / '( old version ) ' /
C
C
      MSGNUM = IMSG
      LIMIT = 13
C
C
      IF ( MSGNUM .GT. LIMIT ) GO TO 9910
      GO TO ( 2010 , 2020 , 9910 , 9910 , 2050 ,
     1 2050 , 2050 , 2050 , 9910 , 9910 ,
     2 2110 , 2120 , 2130 , 9910 ) , MSGNUM
C
      GO TO 9910
C
C
2010  CONTINUE
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2015 )
      ENDIF
      WRITE ( NCAWU , 2015 )
2015  FORMAT ( 1X , 'An initial size has been requested even though ',
     1 'an old file is being used' , / ,
     2 1X , 'Value ignored' )
      CALL XERHND ( IERWRN )
      GO TO 8000
C
2020  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2025 ) IPARAM
      ENDIF
      WRITE ( NCAWU , 2025 ) IPARAM
2025  FORMAT ( 1X , 'An illegal initial size of ' , I8 ,
     1 ' has been requested' )
      GO TO 8000
C
C -- MESSAGE 3 REMOVED
C -- MESSAGE 4 REMOVED
C
2050  CONTINUE
C
      IREASN = MSGNUM - 4
C
      IULN = IABS ( ISTORE(IPARAM) )
      IULSN = IABS ( ISTORE(IPARAM+1) )
C
      ISTART = IABS ( ISTORE(IPARAM+2) )
      IEND   = IABS ( ISTORE(IPARAM+3) )
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2053 ) IULN, IULSN, ISTART, IEND , REASON(IREASN)
      ENDIF
2053  FORMAT ( 1X , 'List type  ' , I3 , '  serial number ' , I4 ,
     2 ' from ' , I8 , ' to ' , I8 ,
     3 ' will not be copied ' , A )
      WRITE ( NCAWU , 2055 ) IULN , IULSN , REASON(IREASN)
2055  FORMAT ( 1X , 'List type  ' , I3 , '  serial number ' , I4 ,
     2 ' will not be copied ' , A )
C
      GO TO 8000
C
C -- MESSAGE 6 SEE ABOVE
C -- MESSAGE 8 SEE ABOVE
C
C -- MESSAGE 9 REMOVED
C -- MESSAGE 10 REMOVED
C
C
2110  CONTINUE
      CALL XDANAM ( IPARAM , FILNAM )
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2115 ) FILNAM
      ENDIF
      WRITE ( NCAWU , 2115 ) FILNAM
2115  FORMAT ( 1X , 'Disc index completely restored' , // ,
     1 1X , 'Listing of file index of ' , A10 , ' file ' )
      GO TO 8000
C
2120  CONTINUE
      CALL XDANAM ( IPARAM , FILNAM )
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1750 ) FILNAM
      ENDIF
      WRITE ( NCAWU , 1750 ) FILNAM
1750  FORMAT ( / , ' The ' , A10 , ' file is now unusable' )
      GO TO 8000
C
2130  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2135 )
      ENDIF
      WRITE ( NCAWU , 2135 )
2135  FORMAT ( 1X , 'A new disc index has been written, ' ,
     1 'which could be used, with care. ' )
      GO TO 8000
C
C
C
8000  CONTINUE
C
      RETURN
C
C
9910  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 ) MSGNUM
      ENDIF
      WRITE ( NCAWU , 9915 ) MSGNUM
9915  FORMAT ( 1X , 'Illegal or unexpected message code ' , I8 )
      CALL XERHND ( IERPRG )
C -- DUMMY RETURN
      RETURN
C
      END
C
C
C
CODE FOR XSIMUL
      SUBROUTINE XSIMUL
C -- A ROUTINE TO SIMULATE VARIOUS EVENTS, ETC.
C
C -- THIS ROUTINE IS INTENDED TO BE USED FOR SYSTEM TESTING ONLY,
C    USING THE 'SIMULATE' INSTRUCTION.
C
C      WRITTEN BY PAUL BETTERIDGE
C
C    VERSION 1        JUNE 1983       FIRST VERSION
C            1.1      AUGUST 1983     COMMANDS EXECUTED IMMEDIATELY
C            1.11                     ADD 'CHECKDISC' COMMAND
C            1.12                     ADD 'EXAMINE' COMMAND
C            1.13     NOVEMBER 1983   ADD 'IDENTIFY' COMMAND
C            1.14     DECEMBER 1983   ADD 'ENTER' COMMAND
C            1.15                     ADD 'DEPOSIT' COMMAND
C            1.16     JANUARY 1985    EXTEND 'EXAMINE' COMMAND
C            1.17     DECEMBER 1985   MAKE 'ENVIRONMENT' REFLECT CURRENT
C                                     BEHAVIOUR OF PROGRAM
C
C
C    DIRECTIVES AVAILABLE WITH SIMULATE
C
C    1  ENVIRONMENT
C         SET MODE FLAG
C    2  LIMIT
C         SET MAXIMUM NUMBER OF OCCURENCES OF SPECIFIED ERROR TYPE
C    3  ACTION
C         SET ACTION FOR SPECIFIED ERROR TYPE
C    4  RESET
C         CLEAR COUNTER FOR SPECIFED ERROR TYPE
C    5  CAUSE
C         CAUSE SPECIFIED ERROR TYPE
C    6  INITIALISE
C         REINITIALISE ERROR OR ENVIRONMENT VARIABLES
C    7  MESSAGE
C         GENERATE SPECIFIED MESSAGE
C    8  CHECKDISC
C         CHECK INTEGRITY OF DISC STRUCTURE (DISPLAY PARAMETER IGNORED)
C    9  IDENTIFY
C         IDENTIFY PROGRAM VERSION AND DATA FILES
C   10  EXAMINE
C         EXAMINE SPECIFIED DATA FROM DIRECT ACCESS DATA FILE
C   11  DEPOSIT
C         DEPOSIT SPECIFIED DATA IN DIRECT ACCESS DATA FILE
C   12  ENTER
C         WRITE ENTRY IN FILE LIST INDEX
C
C
C
      DIMENSION ID(2)
      DOUBLE PRECISION DSTORE(32678)
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCOMPD/TITLE(20)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
      COMMON /XERCNT/ IERDMP(9) , IERCNT(9) , IERMSG(9) ,
     2 IERLIM(9) , IERSTF(9) , IERCOU(9) , IERMAX
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      EQUIVALENCE ( DSTORE(1) , STORE(1) )
C
      DATA IVERSN / 117 /
      DATA ICOMSZ / 6 /
C
C -- SET THE SIZE OF SPACE REQUIRED FOR COMMAND PROCESSING AND ACQUIRE
      ICOMBL = KSTALL ( ICOMSZ )
C -- ENSURE THAT THE ALL THE DIRECTIVES APPEAR TO HAVE BEEN READ ONCE
      MR61 = LR61
      DO 1000 I = 1 , NR60
      ISTORE(MR61+8) = 1
      MR61 = MR61 + MDR61
1000  CONTINUE
C
1050  CONTINUE
C -- READ NEXT DIRECTIVE
      IDIR = KRDNDC ( ISTORE(ICOMBL) , ICOMSZ )
C -- CHECK IF THE DIRECTIVE JUST READ IN IS 'END' OR 'CONTINUE'
      IF ( IDIR .LT. 0 ) GO TO 8800
      IF ( IDIR .EQ. 0 ) GO TO 9930
C
1100  CONTINUE
C -- PROCESS THE KEYWORDS AND PARAMETERS
      IF (  KFNDNP ( I )  .LE.  0  ) GO TO 1200
      IF (  KRDPV ( ISTORE(ICOMBL) , ICOMSZ )  .LT.  0 ) GO TO 1200
      GO TO 1100
C
1200  CONTINUE
C -- CHECK INPUT OF DIRECTIVE COMPLETE AND BRANCH ON THE FUNCTION
      ISTAT = KCHKPV ( IDIR , ISTORE(ICOMBL) , ICOMSZ , -1 )
      IF ( ISTAT .LT. 0 ) GO TO 9900
      IF ( LEF .GT. 0 ) GO TO 9900
C -- DISPLAY DIRECTIVE
      CALL XMONTR ( -1 )
C
      GO TO ( 2100 , 2200 , 2300 , 2400 , 2500 , 2600 , 2700 , 2800 ,
     2 2900 , 3000 , 3100 , 3200 ,
     3  9910 ) , IDIR
      GO TO 9910
C
2100  CONTINUE
C -- 'ENVIRONMENT' DIRECTIVE
      NEWMOD = ISTORE(ICOMBL)
      IF ( NEWMOD .EQ. 1 ) THEN
        IQUN = 1
        JQUN = 1
      ELSE IF ( NEWMOD .EQ. 2 ) THEN
        IQUN = 2
        JQUN = 2
      ELSE IF ( NEWMOD .EQ. 3 ) THEN
        IQUN = 3
        JQUN = 0
      ENDIF
      GO TO 8000
2200  CONTINUE
C -- 'LIMIT' DIRECTIVE
      ICODE = ISTORE(ICOMBL)
      INUM = ISTORE(ICOMBL+1)
      IERLIM(ICODE) = INUM
      GO TO 8000
2300  CONTINUE
C -- 'ACTION' DIRECTIVE
      ICODE = ISTORE(ICOMBL)
      IACTN = ISTORE(ICOMBL+1)
      IERCNT(ICODE) = IACTN
      GO TO 8000
2400  CONTINUE
C -- 'RESET' DIRECTIVE
      ICODE = ISTORE(ICOMBL)
      IERCOU(ICODE) = 0
      GO TO 8000
2500  CONTINUE
C -- 'CAUSE' DIRECTIVE
      ICODE = ISTORE(ICOMBL)
      CALL XERHND ( ICODE )
      GO TO 8000
2600  CONTINUE
C -- 'INITIALISE' DIRECTIVE
      IF ( ISTORE(ICOMBL) .GT. 0 ) CALL XQUEN
      IF ( ISTORE(ICOMBL+1) .GT. 0 ) CALL XERINI
      GO TO 8000
C
C
2700  CONTINUE
C -- 'MESSAGE' DIRECTIVE
      IFAC = ISTORE(ICOMBL)
      IMSG = ISTORE(ICOMBL+1)
      IPAR = ISTORE(ICOMBL+2)
      CALL XOPMSG ( IFAC , IMSG , IPAR )
      GO TO 8000
C
C
2800  CONTINUE
C -- 'CHECKDISC' DIRECTIVE
C    CHECK THE INTEGRITY OF THE DISC STRUCTURE
      LSTBUF = KSTALL ( 8 )
      IADBUF = KSTALL ( 8 )
C
C -- MINDSC/MAXDSC SHOULD DEFINE LIMITS OF FILE
C -- MINUSE/MAXUSE SHOULD DEFINE AREA OF FILE IN USE
C -- MINLST/MAXLST SHOULD DEFINE AREA ALLOCATED TO LIST
      MINDSC = 1
      MAXDSC = 999999999
      MINUSE = 1
      MAXUSE = KNEXTF ( IN )
C
      IDSPLV = ISTORE(ICOMBL)
C
      NLISTS = 0
      NRCRDS = 0
      NLSTER = 0
C
      DO 2880 I = 1 , 49
      ISRCH = 0
C
2810  CONTINUE
      ISTORE(LSTBUF) = I
      ISTAT = KRFI ( ISTORE(LSTBUF) , ISRCH , ISTORE(LSTBUF+2) ,
     2 ISTORE(LSTBUF+3) , ISTORE(LSTBUF+4) , ISTORE(LSTBUF+5) ,
     3 ISTORE(LSTBUF+6) )
      IF ( ISTAT .LT. 0 ) GO TO 2880
C
      ISTORE(LSTBUF+1) = ISRCH
C
      ITYPE = ISTORE(LSTBUF)
      ISER = ISTORE(LSTBUF+1)
      MINLST = ISTORE(LSTBUF+2)
      MAXLST = ISTORE(LSTBUF+3)
C
      NLISTS = NLISTS + 1
C
      IF ( IDSPLV .GT. 1 ) GO TO 2817
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2815 ) ITYPE , ISER , MINLST , MAXLST
      ENDIF
      WRITE ( NCAWU , 2815 ) ITYPE , ISER , MINLST , MAXLST
2815  FORMAT ( 1X , 'List type ' , I3 , ' serial ' , I3 ,
     2 ' uses from ' , I10 , ' to ' , I10 )
2817  CONTINUE
C
      IF ( MINLST .LT. MINDSC ) GO TO 2890
      IF ( MINLST .LT. MINUSE ) GO TO 2892
      IF ( MAXLST .GT. MAXDSC ) GO TO 2890
      IF ( MAXLST .GT. MAXUSE ) GO TO 2892
C
      IADDL = 0
      IADDR = ISTORE(LSTBUF+2)
2820  CONTINUE
C -- SCAN EACH DISC DATA RECORD
      ISTAT = KLDDRH ( IADDL , IADDR , ISTORE(IADBUF) )
      IF ( ISTAT .LT. 0 ) GO TO 2810
C
      NRCRDS  = NRCRDS  + 1
C
      ISTART = ISTORE(IADBUF+3)
      LENGTH = ISTORE(IADBUF+4) * ISTORE(IADBUF+5)
      IEND = ISTART + LENGTH - 1
      IRECNM = ISTORE(IADBUF+6)
C
      IF ( IDSPLV .GT. 1 ) GO TO 2827
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2825 ) IRECNM , ISTART , IEND
      ENDIF
      WRITE ( NCAWU , 2825 ) IRECNM , ISTART , IEND
2825  FORMAT ( 1X , 'Record type ' , I5 , '  Data from ' , I10 ,
     2 ' to ' , I10 )
2827  CONTINUE
C
      IF ( ISTART .LT. MINLST ) GO TO 2894
      IF ( IEND .GT. MAXLST ) GO TO 2894
C
      GO TO 2820
C
2890  CONTINUE
      NLSTER = NLSTER + 1
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2891 )
      ENDIF
      WRITE ( NCAWU , 2891 )
2891  FORMAT ( 1X , '**** List address points outside file' )
      GO TO 2810
2892  CONTINUE
      NLSTER = NLSTER + 1
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2893 )
      ENDIF
      WRITE ( NCAWU , 2893 )
2893  FORMAT ( 1X, '**** List address points to unused space ' )
      GO TO 2810
2894  CONTINUE
      NLSTER = NLSTER + 1
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2895 )
      ENDIF
      WRITE ( NCAWU , 2895 )
2895  FORMAT ( 1X, '**** Record address points to space outside list' )
      GO TO 2820
C
2880  CONTINUE
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2885 )
      ENDIF
      WRITE ( NCAWU , 2885 )
2885  FORMAT ( 1X , 'List scan complete' )
      CALL XSTRLL ( LSTBUF )
      CALL XSTRLL ( IADBUF )
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2887 ) NLISTS , NRCRDS  , NLSTER
      ENDIF
      WRITE ( NCAWU , 2887 ) NLISTS , NRCRDS  , NLSTER
2887  FORMAT ( / , 1X , I5 , ' list(s) containing ' , I5 ,
     2 ' record(s) . ' , I3 , ' error(s) detected ' , // )
      GO TO 8000
2900  CONTINUE
C -- 'IDENTIFY' COMMAND
C
      CALL XOPMSG ( IOPCRY , IOPVER , ISSVER )
      CALL XOPMSG ( IOPSIM , IOPVER , IVERSN )
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2915 ) TITLE
      ENDIF
      WRITE ( NCAWU , 2915 ) TITLE
2915  FORMAT ( / , 1X , 'Data file is :- ' , / , 1X , 20A4 , // )
C
      GO TO 8000
C
3000  CONTINUE
C -- 'EXAMINE' COMMAND
      ISTART = ISTORE(ICOMBL)
      LENGTH = ISTORE(ICOMBL+1)
      IMODE = ISTORE(ICOMBL+2)
C
C
      IF ( IMODE .EQ. 4 ) LENGTH = LENGTH + MOD ( LENGTH , 2 )
C
      IBUFFR = KSTALL ( LENGTH + 1 )
      ITMPBF = IBUFFR + MOD ( IBUFFR , 2 )
      IENDBF = ITMPBF + LENGTH - 1
      CALL XDOWNF ( ISTART , ISTORE(ITMPBF) , LENGTH )
C
      GO TO ( 3010 , 3020 , 3030 , 3040 , 3050 , 9910 ) , IMODE
      GO TO 9910
C
3010  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 3015 ) ( ISTORE(I) , I = ITMPBF , IENDBF )
      ENDIF
      WRITE ( NCAWU , 3015 ) ( ISTORE(I) , I = ITMPBF , IENDBF )
3015  FORMAT ( 1X , 8I10 )
      GO TO 3090
3020  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 3025 ) ( STORE(I) , I = ITMPBF , IENDBF )
      ENDIF
      WRITE ( NCAWU , 3025 ) ( STORE(I) , I = ITMPBF , IENDBF )
3025  FORMAT ( 1X , 8F10.4 )
      GO TO 3090
3030  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 3035 ) ( STORE(I) , I = ITMPBF , IENDBF )
      ENDIF
      WRITE ( NCAWU , 3035 ) ( STORE(I) , I = ITMPBF , IENDBF )
3035  FORMAT ( 1X , 16A4 )
      GO TO 3090
3040  CONTINUE
      IDBLBF = ITMPBF / 2
      IDBEND = IENDBF / 2
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 3045 ) ( DSTORE(I) , I = IDBLBF , IDBEND )
      ENDIF
      WRITE ( NCAWU , 3045 ) ( DSTORE(I) , I = IDBLBF , IDBEND )
3045  FORMAT ( 1X , 8F10.4 )
      GO TO 3090
3050  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 3055 ) ( STORE(I) , I = ITMPBF , IENDBF )
      ENDIF
      WRITE ( NCAWU , 3055 ) ( STORE(I) , I = ITMPBF , IENDBF )
3055  FORMAT ( 1X , 1P , 5E16.5 )
      GO TO 3090
3090  CONTINUE
      CALL XSTRLL ( IBUFFR )
      GO TO 8000
C
C
3100  CONTINUE
C -- 'DEPOSIT' DIRECTIVE
      IADDRS = ISTORE(ICOMBL)
      IOFFST = ISTORE(ICOMBL+1)
C
      CALL XUPF ( IADDRS , STORE(ICOMBL+IOFFST) , 1 )
C
      GO TO 8000
C
3200  CONTINUE
C -- 'ENTER' DIRECTIVE
      LN = ISTORE(ICOMBL)
      LSN = ISTORE(ICOMBL+1)
      NFW = ISTORE(ICOMBL+2)
      LFW = ISTORE(ICOMBL+3)
      IOWF = ISTORE(ICOMBL+4)
      NOS = ISTORE(ICOMBL+5)
      NEW = 0
C
      ISTAT = KLSCHK ( LN , LSN , 0 , ILSCLS , ILSMSG , IADDR , IERWRN)
      IF ( ISTAT .LT. 0 ) GO TO 8000
C
      CALL XDATE ( ID(1) , ID(2) )
      CALL XWFI ( LN , LSN , NFW , LFW , IOWF , NOS , ID , NEW )
      GO TO 8000
C
C
C
8000  CONTINUE
      GO TO 1050
C
8800  CONTINUE
C -- 'END' FOUND  -  CHECK FOR INPUT ERRORS
      IF ( LEF .NE. 0 ) GO TO 9920
8900  CONTINUE
C -- RELEASE RESOURCES
      CALL XSTRLL ( ICOMBL )
      RETURN
C
9900  CONTINUE
      CALL XOPMSG ( IOPSIM , IOPABN , 0 )
      GO TO 8900
9910  CONTINUE
      CALL XOPMSG ( IOPSIM , IOPINT , 0 )
      GO TO 9900
9920  CONTINUE
      CALL XOPMSG ( IOPSIM , IOPCMI , 0 )
      GO TO 9900
9930  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9935 )
      ENDIF
      WRITE ( NCAWU , 9935 )
9935  FORMAT ( 1X , 'CONTINUE is not allowed in SIMULATE' )
      GO TO 9900
C
C
      END
C
C
C
C
CODE FOR XCPYLN
      SUBROUTINE XCPYLN(IOLD,INEW)
C--THIS ROUTINE COPIES A LIST FROM ONE PART OF THE DISC TO ANOTHER
C
C  IOLD    THE OLD DISC ADDRESS.
C  INEW    THE NEW DISC ADDRESS.
C
C--THIS ROUTINE USES ALL THE AVAILABLE STORE
C
C--
      DIMENSION IBUFF(8) , JBUFF(8)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET UP THE OLD DISC ADDRESSES
      IOLD1=0
      IOLD2=IOLD
C--SET UP THE OUTPUT ADDRESSES
      INEW1=0
      INEW2=INEW
C--FIND THE MAXIMUM AMOUNT OF CORE WE CAN USE
      JA=LFL-NFL
C--LOAD THE NEXT RECORD HEADER
1000  CONTINUE
      IF(KLDDRH(IOLD1,IOLD2,IBUFF))1500,1050,1050
C--NEW RECORD TO COPY  -  CHECK IF THIS IS THE FIRST
1050  CONTINUE
      IF(INEW1)1150,1150,1100
C--NOT THE FIRST  -  UPDATE THE LAST FORWARD POINTER
1100  CONTINUE
      IBUFF(1)=INEW2
      CALL XUPF(INEW1,IBUFF(1),1)
C--ALTER THE ADDRESS POINTERS IN 'IBUFF'
1150  CONTINUE
      IBUFF(1)=0
      IBUFF(2)=INEW1
C--FIND THE ADDRESS OF THE DATA FOR THIS RECORD
      M=IBUFF(4)
C--CHECK IF THE DATA IS ON DISC
      IF(M)1250,1250,1200
C--COMPUTE THE NEW ADDRESS
1200  CONTINUE
      IBUFF(4)=INEW2+KINCRF(MD0)
C--OUTPUT THE HEADER
1250  CONTINUE
      CALL XUPF(INEW2,IBUFF(1),MD0)
C--SWITCH ADDRESSES
      INEW1=INEW2
C--CHECK IF THE DATA IS ON DISC
      IF(M)1300,1300,1350
C--THE DATA IS NOT ON DISC
1300  CONTINUE
      INEW2=INEW2+KINCRF(MD0)
      GOTO 1000
C--DATA IS ON DISC  -  COMPUTE THE NEW ADDRESS
1350  CONTINUE
      INEW2=INEW2+KINCRF(IBUFF(3))
C--FIND THE NEW OUTPUT ADDRESS FOR THE DATA
      L=IBUFF(4)
C--FIND THE LENGTH OF THE RECORD
      N=IBUFF(3)-MD0
C--CHECK IF THERE IS MORE DATA TO OUTPUT
1400  CONTINUE
      IF(N)1000,1000,1450
C--OUTPUT THE NEXT BLOCK OF DATA
1450  CONTINUE
      K=MIN0(JA,N)
C--READ THE NEXT BLOCK DOWN
      CALL XDOWNF(M,STORE(NFL),K)
C--WRITE IT BACK
      CALL XUPF(L,STORE(NFL),K)
C--UPDATE THE ADDRESSES
      L=L+KINCRF(K)
      M=M+KINCRF(K)
C--UPDATE THE COUNT
      N=N-K
      GOTO 1400
C--DUMP THE DISC BUFFERS
1500  CONTINUE
      CALL XDUMP
      RETURN
      END
C
CODE FOR KPRTLN
      FUNCTION KPRTLN(IULN,IADDI)
C--CHECK I A LIST IS AVAILABLE FOR PRINTING AND OUTPUT THE NECESSARY CAP
C
C  IULN    THE LIST TYPE TO BE PRINTED.
C  IADDI   THE DISC ADDRESS OF THE FIRST HEADER BLOCK.
C
C--RETURN VALUES OF 'KPRTLN' ARE :
C
C          -1  ERROR  -  NO PROCESSING IS POSSIBLE
C           0  ALL OKAY FOR PRINTING.
C
C--
      DIMENSION ISTORE(131072)
C
      DIMENSION ID(2)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      KPRTLN=-1
C--SET THE LIST AND RECORD TYPES
      LN=IULN
      IREC=0
      ISTAT = KLSCHK ( LN , 0 , 0 , ILSAVI , ILSMSG , IADDR , IERERR )
      IF ( ISTAT .LE. 0 ) GO TO 9900
C -- READ INDEX
      CALL XRLIND ( LN , LSN , IADDI , LL , IOW , NOS , ID )
C -- START NEW PAGE
      CALL XPRTCN
C--PRINT THE LIST TYPE AND DETAILS
      LSN=IABS(LSN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1300)LN,LSN,IADDI,LL,ID
      ENDIF
1300  FORMAT(17H Print list type ,I5,5X,14Hserial number ,I8,5X,
     2 8HAddress ,I8,5X,7HLength ,I7,5X,12HCreated on  ,2A4/)
      KPRTLN=0
      RETURN
C
9900  CONTINUE
C -- ERRORS
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9905 ) LN
      ENDIF
      WRITE ( NCAWU , 9905 ) LN
9905  FORMAT ( 1X, 'List type ' ,I5, ' is not available for printing' )
      KPRTLN = -1
      RETURN
      END
C
CODE FOR XDUMDR
      SUBROUTINE XDUMDR(ICOMMN,IDIMN)
C--DUMP DATA RECORDS THAT ARE HELD IN CORE
C
C  ICOMMN  THE CONTROLLING COMMON BLOCK.
C  IDIMN    THE DIMENSION OF THE COMMON BLOCK.
C
C--
C
      DIMENSION ICOMMN(IDIMN)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C--WRITE THE COMMON BLOCK
      CALL XLINES
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)ICOMMN
      ENDIF
1000  FORMAT(12I10)
C--COMPUTE THE NUMBER OF DATA RECORDS
      N=IDIMN/4
      DO 1050 I=1,N
      J=(I-1)*4+1
      K=ICOMMN(J)
      L=K+ICOMMN(J+2)*ICOMMN(J+3)-1
      CALL XPRINT(K,L)
1050  CONTINUE
      CALL XLINES
      RETURN
      END
C
CODE FOR KBITS
      FUNCTION KBITS(IF,IV)
C--RETURNS SET TO THE VALUE OF THE BIT MONITORED
C
C  IF  VARIABLE HOLDING THE WORD TO BE CHECKED
C  IV  VALUE OF THE BIT TO BE MONITORED
C      IF BIT N IS TO BE CHECKED, IV=2**N  (BITS RUN FROM 23-0)
C      FOR EXAMPLE, IV=1 FOR BIT 0, IV=4 FOR BIT 2, ETC.
C
C--
C
C
      DATA I/0/
C
C
      I=IF/IV
      KBITS=I-I/2*2
      RETURN
      END
C
CODE FOR XICA
      SUBROUTINE XICA
C--INSUFFICIENT CORE AVAILABLE
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)
      ENDIF
      WRITE(NCAWU,1000)
1000  FORMAT(/28H Insufficient core available)
      LEF=LEF+1
      RETURN
      END

CRYSTALS CODE FOR LISTS4
CODE FOR XRD01
      SUBROUTINE XRD01
C--READ LIST TYPE 1, THE CELL PARAMETERS
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM01(36)
      DIMENSION ICOM20(12)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST20/L20M,M20M,MD20M,N20M,
     2 L20I,M20I,MD20I,N20I, L20V,M20V,MD20V,N20V
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (ICOM01(1),L1P1)
      EQUIVALENCE (ICOM20(1),L20M)
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 20
      IDIM20 = 12
C
C--SET UP THE LENGTH OF THE COMMON BLOCK FOR LIST 1
      IDIM01=36
C--READ THE CELL PARAMETERS FROM THE DATA STREAM
      IF(KRDDPV(ICOM01,IDIM01))1100,1000,1000
C--CALL THE FUNCTION THAT PRODUCES THE OUTPUT LIST 1
1000  CONTINUE
      IF(KFRM01(IDIM01))1100,1050,1050
C--LIST SUCESSFULLY INPUT  -  OUTPUT IT TO DISC
1050  CONTINUE
      CALL XWLSTD(1,ICOM01,IDIM01,-1,1)
C----- LOAD LIST 20
      CALL XLDLST(20,ICOM20,IDIM20,-1)
C----- PREPARE LIST 20 ELEMENTS
      CALL XTRANS(STORE(L1O1),STORE(L20M),3,3)
      CALL XTRANS(STORE(L1O2),STORE(L20I),3,3)
C--STORE THE LIST ON DISC
      CALL XSTR20( 20, 0, 1)
      GOTO 1150
C--ERRORS DURING THE INPUT
1100  CONTINUE
      CALL XOPMSG ( IOPLSI , IOPLSP , 1 )
      CALL XALTES(1,-1)
1150  CONTINUE
      RETURN
      END
C
CODE FOR KFRM01
      FUNCTION KFRM01(ICELL)
C--FORM THE UNIT CELL PARAMETER LIST, LIST 1
C
C  ICELL   A DUMMY ARGUMENT.
C
C--THE RETURN VALUES ARE :
C
C  -1  ERRORS FOUND
C   0  ALL OKAY
C
C--THIS ROUTINE WILL PROCESS EITHER RECIPROCAL OR REAL CELL
C  PARAMETERS. THE PARAMETERS PROVIDED SHOULD BE INDICATED BY
C  SETTING THE REPEAT COUNT FOR THE FIRST PARAMETER OF THE
C  CORRESPONDING DIRECTIVE TO 1 BEFORE THIS ROUTINE IS CALLED. THIS
C  VARIABLE IS LOCATED AT 'ISTORE(LR62D+10)' FOR THE APPROPIATE
C  DIRECTIVE, AND IS AUTOMATICALLY SET DURING INPUT. THE ANGLES
C  CAN PROVIDED IN DEGREES OR AS THEIR COSINES, SO THAT FOUR POSSIBLE
C  INPUT FORMATS ARE ALLOWED :
C
C  1  REAL CELL AND ANGLES
C  2  REAL CELL AND COSINES
C  3  RECIPROCAL CELL AND ANGLES
C  4  RECIPROCAL CELL AND COSINES
C
C--
      DIMENSION ICOM01(36)
      DIMENSION ISTORE(131072)
C
      DIMENSION AA(26),IADD1(4),IADD2(3)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XWORK/A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,
     2 U,V,W,X,Y,Z
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      EQUIVALENCE (ICOM01(1),L1P1)
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      EQUIVALENCE (AA(1),A)
      EQUIVALENCE (U,NU),(V,NV),(W,NW),(X,NX),(Y,NY),(Z,NZ)
C
C
      DATA IADD1(1)/2/,IADD1(2)/3/,IADD1(3)/1/,IADD1(4)/2/
      DATA IADD2(1)/5/,IADD2(2)/-2/,IADD2(3)/-5/
C
C--SET UP THE LENGTH OF THE COMMON BLOCK FOR LIST 1
      IDIM01=36
C--LOAD THE POINTERS FOR THE REAL CELL PARAMETERS INPUT DIRECTIVE
      CALL XDIRFL(1,ICOM01,IDIM01)
C--ASSUME THAT THE REAL CELL PARAMETERS HAVE BEEN INPUT
      M=L1P1
      N=L1P2
C--CHECK IF THE REAL CELL PARAMETERS ARE INDICATED
      IF(ISTORE(LR62D+10))1000,1000,1050
C--A REAL CELL PARAMETER HAS NOT BEEN INPUT
1000  CONTINUE
      M=L1P2
      N=L1P1
C--CHECK IF THE ANGLES OR THEIR COSINES HAVE BEEN INPUT
1050  CONTINUE
      K=M+3
      IF(ABS(STORE(K))-1.1)1100,1200,1200
1100  CONTINUE
C--CONVERT THE COSINES TO THE ANGLES
      DO 1150 I=1,3
      STORE(K)=ACOS(STORE(K))
      K=K+1
1150  CONTINUE
      GOTO 1300
C--CONVERT THE INPUT ANGLES FROM DEGREES TO RADIANS
1200  CONTINUE
      DO 1250 I=1,3
      STORE(K)=STORE(K)*DTR
      K=K+1
1250  CONTINUE
C--START TO CALCULATE THE MISSING CELL PARAMETERS AND VOLUMES
1300  CONTINUE
      NW=1
      NX=M+2
C--CALCULATE THE SINE AND COSINES OF THE INPUT ANGLES
      DO 1350 NY=M,NX
      AA(NW)=COS(STORE(NY+3))
      AA(NW+3)=SIN(STORE(NY+3))
      NW=NW+1
1350  CONTINUE
C--CALCULATE THE VOLUMES
      O=STORE(M)*STORE(M+1)*STORE(M+2)
      STORE(M+6)=O*SQRT(1.-A*A-B*B-C*C+2.*A*B*C)
      STORE(N+6)=1./STORE(M+6)
      O=O*STORE(N+6)
C--CALCULATE THE MISSING PARAMETERS
      H=1./(D*E*F)
      NU=1
      NZ=N
      DO 1400 NY=M,NX
      NV=IADD1(NU)
      NW=IADD1(NU+1)
      STORE(NZ)=O*AA(NU+3)/STORE(NY)
      STORE(NZ+3)=ACOS((AA(NV)*AA(NW)-AA(NU))*AA(NU+3)*H)
      NU=NU+1
      NZ=NZ+1
1400  CONTINUE
C--CALCULATE THE ORTHOGONALIZATION MATRICES
      STORE(L1O1)=STORE(L1P1)*SIN(STORE(L1P1+4))*SIN(STORE(L1P2+5))
      STORE(L1O1+1)=0.
      STORE(L1O1+2)=0.
      STORE(L1O1+3)=-STORE(L1P1)*SIN(STORE(L1P1+4))*COS(STORE(L1P2+5))
      STORE(L1O1+4)=STORE(L1P1+1)*SIN(STORE(L1P1+3))
      STORE(L1O1+5)=0.
      STORE(L1O1+6)=STORE(L1P1)*COS(STORE(L1P1+4))
      STORE(L1O1+7)=STORE(L1P1+1)*COS(STORE(L1P1+3))
      STORE(L1O1+8)=STORE(L1P1+2)
C--CALCULATE THE INVERSE ORTHOGONALISATION MATRIX
      IF(KINV2(3,STORE(L1O1),STORE(L1M2),9,0,STORE(L1M1),STORE(L1M1+9),
     2 9))1450,1550,1450
C--THE REAL ORTHOGONALISATION MATRIX IS SINGULAR
1450  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1500)
      ENDIF
1500  FORMAT(/34H Singular orthogonalisation matrix/)
      GOTO 1750
C--NOW TRANSPOSE THIS MATRIX SO THAT IT IS STORED BY ROWS
1550  CONTINUE
      CALL XTRANS(STORE(L1M2),STORE(L1O2),3,3)
C--CALCULATE THE ORTHOGONALISATION MATRICES WITHOUT CELL PARAMS.
      DO 1650 I=1,3
      NU=L1O1+I
      NV=L1P1+I
      NW=L1O1+MD1O1+I
      NX=L1O2+I
      NY=L1P2+I
      NZ=L1O2+MD1O2+I
C--LOOP OVER A GIVEN PARAMETER
      DO 1600 J=1,3
      STORE(NW-1)=STORE(NU-1)/STORE(NV-1)
      STORE(NZ-1)=STORE(NX-1)/STORE(NY-1)
      NU=NU+3
      NW=NW+3
      NX=NX+3
      NZ=NZ+3
1600  CONTINUE
1650  CONTINUE
C--CALCULATE THE METRIC TENSORS
      CALL XMLTMT(STORE(L1O1),STORE(L1O1),STORE(L1M1),3,3,3)
      CALL XMLTMT(STORE(L1O2),STORE(L1O2),STORE(L1M2),3,3,3)
C--AND NOW THE METRIC TENSORS WITHOUT CELL PARAMETERS
      NU=L1O1+MD1O1
      NV=L1M1+MD1M1
      CALL XMLTMT(STORE(NU),STORE(NU),STORE(NV),3,3,3)
      NU=L1O2+MD1O2
      NV=L1M2+MD1M2
      CALL XMLTMT(STORE(NU),STORE(NU),STORE(NV),3,3,3)
C--CALCULATE THE ANISO TEMPERATURE FACTOR AND RIJ TERMS
      I=L1P2+3
      J=L1M2
      DO 1700 NX=1,3
C--TERMS FOR CONVERSION FROM ISO TO ANISO ATOMS
      NU=L1C+NX
      STORE(NU-1)=COS(STORE(I))
C--RIJ TERMS NOW
      NU=L1S+NX
      STORE(NU-1)=0.25*STORE(J)
      NY=J+IADD2(NX)
      STORE(NU+2)=0.5*STORE(NY)
C--T.F. TERMS NOW
      NU=L1A+NX
      STORE(NU-1)=-TWOPIS*STORE(J)
      NY=L1P2+IADD1(NX)
      NZ=L1P2+IADD1(NX+1)
      STORE(NU+2)=-2.0*TWOPIS*STORE(NY-1)*STORE(NZ-1)
      I=I+1
      J=J+4
1700  CONTINUE
C--SET THE RETURN VALUE AND EXIT
      KFRM01=0
      GOTO 1800
C--ERRORS FOUND
1750  CONTINUE
      KFRM01=-1
1800  CONTINUE
      RETURN
      END
C
CODE FOR XFAL01
      SUBROUTINE XFAL01
C--ROUTINE TO LOAD LIST 1 FROM THE DISC
C
C--
      DIMENSION ICOM01(36)
C
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
C
      EQUIVALENCE (ICOM01(1),L1P1)
C
C--SET UP THE LENGTH OF THE COMMON BLOCK FOR LIST 1
      IDIM01=36
C--LOAD THE LIST
      CALL XLDLST(1,ICOM01,IDIM01,-1)
      RETURN
      END
C
CODE FOR XSPCFM
      SUBROUTINE XSPCFM ( CSYMIN , IUNIQU , ISPECI , CSYMOU )
C
C -- REFORMAT A SPACE GROUP SYMBOL, POSSIBLY APPLYING THE UNIQUE AXIS
C    CONSTRAINT SPECIFIED
C
C -- INPUT :-
C      CSYMIN      INPUT SYMBOL
C      IUNIQU      UNIQUE AXIS SPECIFIED ( IGNORED EXCEPT FOR MONOCLINIC
C                  SPACE GROUPS IN WHICH ONLY ONE AXIS IS SPECIFIED )
C                    1  A UNIQUE
C                    2  B UNIQUE
C                    3  C UNIQUE
C      ISPECI      METHOD BY WHICH IUNIQU WAS DETERMINED
C                    1  USER SPECIFIED
C                    2  WORKED OUT FROM LIST 1
C                    3  ARBITRARY ASSIGNMENT BY THE PROGRAM
C
C -- OUTPUT :-
C      CSYMOU      OUTPUT SYMBOL
C
C
C
C
      CHARACTER*(*) CSYMIN , CSYMOU
C
      PARAMETER ( NAXIS = 3 )
      DIMENSION IAXIS1(NAXIS), IAXIS2(NAXIS), IAXIST(NAXIS)
C
      CHARACTER*1 CAXIS(3)
      CHARACTER*32 CREASN(3)
C
      PARAMETER ( NALLOW = 16 )
      CHARACTER*1 CALLOW(NALLOW)
      DIMENSION IATYPE(NALLOW)
C
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      DATA CALLOW / '-' , '6' , '5' , '4' , '3' , '2' , '1' ,
     2              '/' , 'M' , 'A' , 'B' , 'C' , 'D' , 'N' ,
     3              '(' , ')' /
C
      DATA IATYPE /  0 ,   6 ,   0  ,   4 ,   3 ,   2 ,   1 ,
     2               0 ,   2 ,   2  ,   2 ,   2 ,   2 ,   2 ,
     3               0 ,   0 /
C
      DATA CAXIS / 'a' , 'b' , 'c' /
      DATA CREASN / 'explicitly requested by the user' ,
     2              'consistent with the unit cell' ,
     3              'assumed by the program' /
C
C
C
C
C -- SET LIMITS ON SYMBOL SCAN
C
      IPOS = 1
      MAXLEN = LEN ( CSYMIN )
C
C -- GIVE INITIAL VALUES TO AXIS INTERPRETATIONS
C
      DO 1100 I = 1  , NAXIS
        IAXIST(I) = 0
        IAXIS1(I) = -1
        IAXIS2(I) = -1
1100  CONTINUE
C
C
C -- FIND THE LATTICE TYPE SYMBOL
C
      IPOS = KCCNEQ ( CSYMIN , IPOS , ' ' )
      IF ( IPOS .LE. 0 ) GO TO 9910
C
      ILATTP = IPOS
      ILATEN = IPOS
      IF (CSYMIN(IPOS+1:IPOS+1) .NE. ' ') GOTO 9940
C
C -- SCAN THE REST OF THE SYMBOL
C
C
      INONSP = KCCNEQ ( CSYMIN , IPOS + 1 , ' ' )
      IF ( INONSP .LE. 0 ) GO TO 9930
C
      IWASSP = 1
      NFOUND = 0
C
      DO 2000 I = INONSP , MAXLEN
        IF ( CSYMIN(I:I) .EQ. ' ' ) THEN
          IWASSP = 1
          GO TO 2000
        ENDIF
C
        IF ( IWASSP .EQ. 1 ) THEN
          NFOUND = NFOUND + 1
          IAXIS1(NFOUND) = I
        ENDIF
C
        IWASSP = 0
C
        ITYPE = KCCOMP ( CSYMIN(I:I) , CALLOW , NALLOW , 1 )
        IF ( ITYPE .LE. 0 ) GO TO 9920
        IF ( IAXIST(NFOUND) .LE. 0 ) THEN
          IAXIST(NFOUND) = MAX (IATYPE(ITYPE), IAXIST(NFOUND) )
        ENDIF
C
        IAXIS2(NFOUND) = I
2000  CONTINUE
C
      DO 2001 I = 1,3
        IF (IAXIS2(I)-IAXIS1(I) .GT. 3 ) GOTO 9950
2001  CONTINUE
C
C -- FIX UP MONOCLINIC SYMBOLS
C
      IF ( NFOUND .EQ. 1 ) THEN
        IF ( IAXIST(1) .EQ. 2 ) THEN
      IF (ISSPRT .EQ. 0) THEN
          WRITE ( NCWU , 6005 ) CAXIS(IUNIQU) , CREASN(ISPECI)
      ENDIF
          WRITE ( NCAWU , 6005 ) CAXIS(IUNIQU) , CREASN(ISPECI)
6005      FORMAT ( / , 1X , 'The unique axis has been set to "' , A ,
     2 '" - ' , A )
C
          IAXIS1(IUNIQU) = IAXIS1(1)
          IAXIS2(IUNIQU) = IAXIS2(1)
          IAXIST(IUNIQU) = IAXIST(1)
          DO 6100 I = 1 , 3
            IF ( I .EQ. IUNIQU ) GO TO 6100
            IAXIST(I) = -1
6100      CONTINUE
          NFOUND = 3
        ENDIF
      ENDIF
C
      IF (NFOUND .EQ. 1) THEN
        IOFSET = 2
      ELSE
        IOFSET = 1
      ENDIF
C
8000  CONTINUE
C
C
C -- GENERATE THE RESULTANT SYMBOL
C
      CSYMOU = ' '
      IPOS = 1
C
C -- INSERT THE LATTICE TYPE
C
      CSYMOU(IPOS:) = CSYMIN(ILATTP:ILATEN)
      IPOS = IPOS + ( ILATEN - ILATTP ) + IOFSET
C
C -- INSERT EACH AXIS SYMBOL - EITHER A GENERATED '1', NO SYMBOL, OR
C    THE ACTUAL INPUT
C
      DO 8200 I = 1 , 3
        IF ( IAXIST(I) .EQ. -1 ) THEN
          CSYMOU(IPOS:) = '1'
          IPOS = IPOS + 2
        ELSE IF ( IAXIST(I) .EQ. 0 ) THEN
        ELSE
          DO 8100 J = IAXIS1(I) , IAXIS2(I)
            IF ( CSYMIN(J:J) .EQ. ' ' ) GO TO 8100
            CSYMOU(IPOS:IPOS) = CSYMIN(J:J)
            IPOS = IPOS + 1
8100      CONTINUE
          IPOS = IPOS + 1
        ENDIF
8200  CONTINUE
C
C
9000  CONTINUE
      RETURN
C
C
9900  CONTINUE
      CALL XERHND ( IERERR )
      GO TO 9000
9910  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 )
      ENDIF
      WRITE ( NCAWU , 9915 )
9915  FORMAT ( 1X , 'The space group symbol is missing' )
      GO TO 9900
9920  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 ) CSYMIN(1:MAXLEN)
      ENDIF
      WRITE ( NCAWU , 9925 ) CSYMIN(1:MAXLEN)
9925  FORMAT ( 1X, 'The symbol "', A, '" contains an illegal character')
      GO TO 9900
9930  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9935 )
      ENDIF
      WRITE ( NCAWU , 9935 )
9935  FORMAT ( 1X , 'The symbol given is too short' )
      GO TO 9900
C
9940  CONTINUE
      WRITE(NCAWU,9945)
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9945 )
      ENDIF
9945  FORMAT(' The parts of the symbol MUST be separated by spaces')
      GOTO 9900
9950  CONTINUE
      WRITE(NCAWU,9955) I
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9955 ) I
      ENDIF
9955  FORMAT(' Part',I5,' of the symbol contains too many characters')
      GOTO 9900
      END
CODE FOR XSAVSG
      SUBROUTINE XSAVSG(LBUFF2, NBUFF2)
C
C----- STORE THE SPACE GROUP SYMBOL IN LIST 2
C      LBUFF2  START OF SYMBOL IN ISTORE
C      NBUFF2  NO OF TERMS ITEMS IN REPRESENTATION
C
C      FIRST ITEM IS LATTICE TYPE, FOLLOWED DIRECTLY BY FIRST SYMBOL.
C      OTHER SYMBOLS SEPARATED BY SPACES.
C
      DIMENSION ISTORE(131072)
      DIMENSION ICOM02(28)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (IC,ICOM02(1))
C
      IERFLG = -1
      CALL XFILL (IB, ISTORE(L2SG), MD2SG)
      M2SG = L2SG
C----- WE USE A 4 WORD WORKAREA AT NFL
      L = NFL
      CALL XFILL (IB, ISTORE(L), 4)
C----- LATTICE TYPE
      ISTORE(L) = ISTORE(LBUFF2)
      CALL XSRA (ISTORE(L), ISTORE(M2SG))
      CALL XFILL (IB, ISTORE(L), 4)
      M2SG = M2SG + 1
      J = LBUFF2 + 1
      M = L2SG + MD2SG
      DO 1000 I = 2,NBUFF2
C----- LOOK FOR A BLANK
      IF (ISTORE(J) .NE. IB) THEN
        ISTORE(L) = ISTORE(J)
        L = L + 1
      ELSE
C-----  CHECK THERE IS SOMETHING TO SAVE
        IF(L .NE. NFL) THEN
            IF (M2SG .GE. M) GOTO 1100
            L = NFL
            CALL XSRA (ISTORE(L), ISTORE(M2SG))
            CALL XFILL (IB, ISTORE(L), 4)
            M2SG = M2SG + 1
            ENDIF
      ENDIF
      J = J + 1
1000  CONTINUE
      IERFLG = 1
1100  CONTINUE
      RETURN
      END
C
C
CODE FOR XRD02
      SUBROUTINE XRD02
C--READ LIST TYPE 2, THE SYMMETRY RELATIONSHIPS
C
C--DURING THE SYMMETRY OPERATOR READING, THE FOLLOWING VARIABLES ARE USE
C
C  N3  THE NUMBER OF OPERATORS READ.
C  N4  NUMBER CONTROL FLAG :
C
C      0  NO NUMBER READ YET
C      1  NUMBER READ FOR THIS OPERATOR.
C
C  N5  NEXT ARGUMENT TYPE CONTROL :
C
C      0  NEXT ARGUMENT MUST BE AN OPERATOR.
C      1  NEXT ARGUMENT MUST BE X, Y, Z OR A NUMBER.
C
C--
      DIMENSION ICOM02(28)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XWORK/A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,
     2 U,V,W,X,Y,Z
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
C
      EQUIVALENCE (M1,H),(N1,D),(N5,E),(N3,F),(N4,G)
      EQUIVALENCE (IC,ICOM02(1))
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 2
      IDIM02=28
C--INDCIATE NO INITIAL DIRECTIVE
      IDIR=-1
C--READ THE NEXT DIRECTIVE FROM THE INPUT STREAM
1000  CONTINUE
      LAST=IDIR
      IDIR=KRDNDC(ICOM02,IDIM02)
C--CHECK THE REPLY
      IF(IDIR)2750,1050,1200
C--CONTINUATION CARD  -  CHECK THE LAST DIRECTIVE
1050  CONTINUE
      IF(LAST-1)1100,1100,1750
C--READ THE NEXT PARAMETER OFF THE CURRENT CARD
1100  CONTINUE
      IF(KFNDNP(I))1000,1000,1150
C--READ THE VALUE
1150  CONTINUE
      IF(KRDPV(ICOM02,IDIM02))1000,1100,1100
C--NEW DIRECTIVE  -  CHECK ITS TYPE
1200  CONTINUE
      IF (IDIR .LE. 1) GOTO 1100
      IF (IDIR .EQ. 7) GOTO 1100
C
C--READ THE NEXT SYMMETRY OPERATOR
      CALL XZEROF(STORE(IPARAD),MD2)
C--READ THE PARAMETER KEYWORD
1300  CONTINUE
      IF(KFNDNP(I))1000,1000,1350
C--SET THE FLAGS FORM THE NEXT PART OF THIS OPERATOR
1350  CONTINUE
      K=IPARAD+(IPARAM-1)*3
      M=IPARAD+IPARAM+8
      N3=0
      N4=0
C--CHECK FOR AN INITIAL '+' OR '-' SIGN
      C=1.
      N5=0
      IF(IMAGE(NC).EQ.IPLUS)GOTO 1650
      IF(IMAGE(NC).EQ.MINUS)GOTO 1550
C--INITIAL ARGUMENT MUST A COORDINATE OR NUMBER
      N5=1
      GOTO 2000
C
C--CHECK THE NEXT ARGUMENT FOR A '+' OR '-' SIGN
1400  CONTINUE
      IF(IMAGE(NC).EQ.IPLUS)GOTO 1600
      IF(IMAGE(NC).EQ.MINUS)GOTO 1550
C--NOT A '+' OR '-' SIGN  -  CHECK THE TYPE OF ARGUMENT REQUIRED
      IF(N5)1750,1450,2000
C--OPERATOR EXPECTED  -  CHECK FOR ','
1450  CONTINUE
      IF(IMAGE(NC).NE.ICOMMA)GOTO 1500
C--WE HAVE FOUND ','  -  UPDATE THE POINTERS
      NC=NC+1
C--CHECK IF THE LAST OPERATOR ENDED CORRECTLY
      IF(N3)1750,1750,1300
C--NOT A ','  -  CHECK FOR ';' AND FAIL IF NOT
1500  CONTINUE
      IF(IMAGE(NC).NE.ISEMIC)GOTO 1750
C--WE HAVE FOUND ';'  -  UPDATE AND CHECK IF THIS IS VALID
      NC=NC+1
      IF(N3)1750,1750,1000
C
C--'-' FOUND  -  ALTER 'C'
1550  CONTINUE
      C=-1.
      GOTO 1650
C--'+' FOUND  -  ALTER 'C'
1600  CONTINUE
      C=1.
C--CHECK IF '+' OR '-' SHOULD BE HERE
1650  CONTINUE
      IF(N5)1750,1700,1750
C--UPDATE THE CHARACTER POSITION
1700  CONTINUE
      N5=1
      NC=NC+1
      NC=KNEQUL(NC,IB)
C--CHECK FOR END OF CARD
      IF(NC)1750,1750,1400
C
C--ERROR IN THIS SYMMETRY OPERATOR
1750  CONTINUE
      JCAT=ICAT
      ICAT=1
      CALL XMONTR(0)
      ICAT=JCAT
C--CHECK FOR END OF CARD
      IF(NC)1800,1800,1850
C--END OF CARD  -  ADJUST THE VALUE
1800  CONTINUE
      NC=LASTCH
C--WRITE THE POSITION OUT
1850  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1900)(IB,I=1,NC),IA
      ENDIF
      WRITE(NCAWU,1900) (IB,I=1,NC),IA
1900  FORMAT(11X,82A1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1950)
      ENDIF
      WRITE(NCAWU,1950)
1950  FORMAT(/31H Symmetry operator format error,5X,
     2 18H(Marked by an '*'))
      LEF=LEF+1
      IDIRFL=-1
      GOTO 1000
C
C--NOW CHECK FOR X, Y OR Z.
2000  CONTINUE
      N5=0
      J=KCOMP(1,IMAGE(NC),IX(1),3,1)
      IF(J)2300,2300,2050
C--COORDINATE FOUND  -  CHECK THAT THIS IS THE FIRST TIME
2050  CONTINUE
      J=K+J
      IF(NINT(STORE(J-1)))1750,2100,1750
C--UPDATE THE COUNTER AND STORE THE OPERATOR
2100  CONTINUE
      N3=N3+1
      STORE(J-1)=C
C--UPDATE THE CARD POSITION
      NC=NC+1
C--FIND THE NEXT NON-BLANK CHARACTER
2200  CONTINUE
      NC=KNEQUL(NC,IB)
      IF(NC)2250,2250,1400
C--END OF CARD  -  CHECK THAT THE LAST OPERATOR ENDED CORRECTLY
2250  CONTINUE
      IF(N3)1750,1750,1000
C
C--NOW CHECK FOR A NUMBER  -  THE ONLY THING LEFT
2300  CONTINUE
      IF(N4)2350,2350,1750
C--WE HAVE NOT FOUND A NUMBER BEFORE  -  ATTEMPT TO READ ONE
2350  CONTINUE
      N4=1
      IF(KINPUT(A))2500,2400,1750
C--NUMBER READ OKAY  -  SEARCH FOR THE NEXT NON-BLANK CHARACTER
2400  CONTINUE
      IF(IMAGE(NC-1).EQ.ICOMMA)NC=NC-1
      NC=KNEQUL(NC,IB)
      IF(NC)2450,2450,2500
C--END OF CARD  -  CHECK ITS VALIDITY
2450  CONTINUE
      STORE(M)=A*C
      GOTO 2250
C--NUMBER FOLLOWED BY MORE CHARACTERS
2500  CONTINUE
      IF(IMAGE(NC).EQ.ISLASH)GOTO 2550
C--NOT FOLLOWED BY '/'  -  END OF NUMBER
      STORE(M)=A*C
      GOTO 1400
C--NUMBER OF FOLLOWED BY '/'  -  READ THE REST OF THE FRACTION
2550  CONTINUE
      NC=NC+1
      NC=KNEQUL(NC,IB)
      IF(NC)1750,1750,2600
C--READ THE REST OF THE NUMBER
2600  CONTINUE
      IF(KINPUT(B))2650,2650,1750
C--CHECK THAT IT IS NOT ZERO
2650  CONTINUE
      IF(IMAGE(NC-1).EQ.ICOMMA)NC=NC-1
      IF(B-0.001)1750,1750,2700
C--COMPUTE THE NUMBER
2700  CONTINUE
      STORE(M)=C*A/B
      GOTO 2200
C
C--CHECK THAT THE INPUT WENT OKAY
2750  CONTINUE
      IF(LEF)3050,2800,3050
C--INPUT OKAY  -  CALCULATE THE INVERSE MATRICES
2800  CONTINUE
      M2=L2
      M2I=L2I
      DO 3000 I=1,N2
      IF(KINV2(3,STORE(M2),STORE(M2I),9,0,STORE(L2T),STORE(L2T+3),3))
     2 2850,2950,2850
C--SINGULAR MATRIX
2850  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2900)I
      ENDIF
      WRITE(NCAWU,2900) I
2900  FORMAT(/7H Matrix,I5,13H  is singular)
      GOTO 3050
C--UPDATE FOR THE NEXT MATRIX
2950  CONTINUE
      STORE(M2I+9)=-STORE(M2+9)
      STORE(M2I+10)=-STORE(M2+10)
      STORE(M2I+11)=-STORE(M2+11)
      M2=M2+MD2
      M2I=M2I+MD2I
3000  CONTINUE
C--CALCULATE THE NON-PRIMITIVE LATTICE TRANSLATIONS
      CALL XLAT(STORE(L2P))
      CALL XUDRH(2,105,0,N2P)
C--CALCULATE THE FIRST MULTIPLIER
      G2=FLOAT(IC+1)*FLOAT(N2P)
C--COMPUTE THE SECOND MULTIPLIER
      T2=G2*FLOAT(N2)
C--SET UP THE CONSTANTS BLOCK
      STORE(L2C)=FLOAT(IC)
      STORE(L2C+1)=FLOAT(IL)
      STORE(L2C+2)=G2
      STORE(L2C+3)=T2
C--FORM THE LIST ON THE DISC
      CALL XWLSTD(2,ICOM02,IDIM02,-1,1)
      GOTO 3100
3050  CONTINUE
      CALL XOPMSG ( IOPLSI , IOPLSP , 2 )
      CALL XALTES (2,-1)
      CALL XERHND ( IERERR )
3100  CONTINUE
      RETURN
      END
C
CODE FOR XLAT
      SUBROUTINE XLAT(HL)
C--SET UP IN HL THE UNIT CELL SHIFTS FOR THE NON-PRIMITIVE LATTICE
C
C  HL  THE ARRAY IN WHICH THE OPERATORS ARE SET UP
C
C--THIS SUBROUTINE ALSO SETS SOME VARIABLES AS WELL AS 'HL'
C
C  N2P  THE NUMBER OF SPEARATE SHIFT VECTORS NEEDED TO DESCRIBE
C       THIS LATTICE.
C
C--
C
      DIMENSION HL(12)
C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
C
C--SET UP 'N2P'
      N2P=IL
C--CHECK IF THIS LATTICE IS 'A', 'B' OR 'C' CENTRED
      IF(IL-4)1050,1050,1000
C--ADJUST 'N2P' ACCORDINGLY
1000  CONTINUE
      N2P=2
C--SET UP THE NULL OPERATOR
1050  CONTINUE
      DO 1100 I=1,3
      HL(I)=0.
1100  CONTINUE
      GOTO(1550,1150,1300,1400,1150,1150,1150),IL
C--'I' , 'A' , 'B' OR 'C' CENTRED LATTICE
1150  CONTINUE
      DO 1200 I=4,6
      HL(I)=0.5
1200  CONTINUE
      IF(IL-4)1550,1550,1250
1250  CONTINUE
      HL(IL-1)=0.
      GOTO 1550
C--'R' CENTRED LATTICE
1300  CONTINUE
      DO 1350 I=5,6
      HL(I)=2./3.
      HL(I+3)=1./3.
1350  CONTINUE
      HL(4)=HL(8)
      HL(7)=HL(5)
      GOTO 1550
C--'F' CENTRED LATTICE
1400  CONTINUE
      K=4
      DO 1500 I=4,12,4
      DO 1450 J=1,3
      HL(K)=0.5
      K=K+1
1450  CONTINUE
      HL(I)=0.
1500  CONTINUE
1550  CONTINUE
      RETURN
      END
C
CODE FOR XFAL02
      SUBROUTINE XFAL02
C--ROUTINE TO LOAD LIST 2 FROM THE DISC
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM02(28)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (IC,ICOM02(1))
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 2
      IDIM02=28
C--LOAD THE LIST
      CALL XLDLST(2,ICOM02,IDIM02,-1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--FIND THE CONSTANTS FROM THE CONSTANTS RECORD
      IC=NINT(STORE(L2C))
      IL=NINT(STORE(L2C+1))
      G2=STORE(L2C+2)
      T2=STORE(L2C+3)
C -- NORMAL AND ERROR EXIT
9900  CONTINUE
      RETURN
      END
C
CODE FOR XFAL03
      SUBROUTINE XFAL03
C--ROUTINE TO LOAD LIST 3 FROM THE DISC
C
C--
      DIMENSION ICOM03(12)
C
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
C
      EQUIVALENCE (ICOM03(1),L3)
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 3
      IDIM03=12
C--LOAD THE LIST
      CALL XLDLST(3,ICOM03,IDIM03,-1)
      RETURN
      END
C
CODE FOR XSCATT
      SUBROUTINE XSCATT(ST)
C--CALCULATE AND STORE THE SCATTERING FACTORS FOR THE ATOMS IN LIST 3
C
C  ST  THE VALUE OF SIN(THETA)/LAMBDA FOR THE CALCULATION
C
C--LIST 3 IS ASSUMED TO HAVE BEEN LOADED, AND THE RESULTS APPEAR AT
C  'L3TR' AND 'L3TI' FOR THE REAL AND IMAGINARY COMPONENTS
C  RESPECTIVELY.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF THERE ARE ANY FORM FACTORS STORED
      IF(N3)1100,1100,1000
C--CALCULATE SIN(THETA)/LAMBDA SQUARED
1000  CONTINUE
      SST=ST*ST
C--ASSIGN VARIOUS POINTERS
      M3=L3
      M3TR=L3TR
      M3TI=L3TI
C--LOOP OVER ACH FORM FACTOR TYPE IN TURN
      DO 1050 JZ=1,N3
      JU=M3+3
C--COMPUTE THE REAL PART
      STORE(M3TR)=STORE(JU)*EXP(-STORE(JU+1)*SST)+STORE(JU+2)
     2 *EXP(-STORE(JU+3)*SST)+STORE(JU+4)*EXP(-STORE(JU+5)*SST)
     3 +STORE(JU+6)*EXP(-STORE(JU+7)*SST)+STORE(JU+8)+STORE(M3+1)
C--COMPUTE THE IMAGINARY PART
      STORE(M3TI)=STORE(M3+2)
C--UPDATE FOR THE NEXT FORM FACTOR
      M3=M3+MD3
      M3TR=M3TR+MD3TR
      M3TI=M3TI+MD3TI
1050  CONTINUE
C--AND NOW RETURN
1100  CONTINUE
      RETURN
      END
C
CODE FOR XFAL05
      SUBROUTINE XFAL05
C--ROUTINE TO LOAD LIST 5 FROM THE DISC
C
C--
      CALL XLDR05(5)
      RETURN
      END
C
CODE FOR XLDR05
      SUBROUTINE XLDR05(IULN)
C--LOAD A LIST OF TYPE INTO CORE FROM DISC.
C
C  IULN    THE LIST TYPE TO LOAD. THIS LIST WILL USE THE LIST 5
C          COMMON BLOCK.
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM05(40)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XUSLST/LN5,LN6
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (L5,ICOM05(1))
C
C--SET THE LENGTH OF THE COMMON BLOCK FOR LIST 5
      IDIM05=40
C--SET THE LIST TYPE
      LN5=IULN
C--LOAD THE LIST
      CALL XLDLST(LN5,ICOM05,IDIM05,-1)
      MD5A=MD5
      RETURN
      END
C
CODE FOR XLDRO5
      SUBROUTINE XLDRO5(IULN)
C--LOAD AN ORDERED LIST 5 FROM THE DISC. THIS ROUTINE LEAVES THE ATOM
C  DATA RECORD (101) AS THE LAST RECORD LOADED.
C
C  IULN    THE LIST TYPE TO LOAD. THIS LIST USES THE LIST 5 COMMON
C          BLOCK.
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM05(40)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XUSLST/LN5,LN6
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (L5,ICOM05(1))
C
C--SET THE LENGTH OF THE COMMON BLOCK FOR LIST 5
      IDIM05=40
C--SET THE LIST TYPE
      LN5=IULN
C--LOAD THE LIST
      CALL XFAOLS(LN5,101,ICOM05,IDIM05)
      MD5A=MD5
      RETURN
      END
C
CODE FOR XCPYL5
      SUBROUTINE XCPYL5(LNIN,LNOUT,N10A,NEW)
C--COPY A LIST USING 'XLST05' IN CORE TO ANOTHER LIST USING
C  'XLST05' IN CORE.
C
C  LNIN    THE CURRENT LIST TYPE
C  LNOUT   THE NEW LIST TYPE.
C  N10A    THE NUMBER OF ATOMS TO BE TAKEN FROM THE OLD LIST 5.
C  NEW     THE NEW LIST FLAG. THIS ROUTINE SETS THIS FLAG TO
C          1 IF 'LNIN' AND 'LNOUT' DIFFER. THIS INDICATES A COMPLETELY
C          NEW LIST.
C
C--'N5' IS ASSUMED TO REFLECT THE LENGTH OF THE NEW LIST 5.
C
C--
      DIMENSION ICOM05(40)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUSLST/LN5,LN6
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (L5,ICOM05(1))
C
C--SET THE LENGTH OF THE COMMON BLOCK FOR LIST 5
      IDIM05=40
C--CHECK IF A CHANGE OF LIT TYPE IS INDICATED
      IF(LNIN-LNOUT)1000,1550,1000
C--PRESERVE THE LIST 5 COMMON BLOCK
1000  CONTINUE
      NEW=1
      LN=LNIN
      IREC=1001
      LFL1=LFL
      KA=KCHLFL(IDIM05)
      CALL XMOVE(ICOM05(1),ISTORE(KA),IDIM05)
C--FORM THE NEW LIST IN CORE
      CALL XCELST(LNOUT,ICOM05,IDIM05)
C--LOOP OVER EACH DATA RECORD, MOVING THE REQUIRED DATA OVER
      KC=IDIM05-3
      DO 1500 I=1,KC,4
C--CHECK IF THIS IS THE SECOND ATOM POINTERS
      IF(I-5)1050,1450,1050
C--NOT THE DUMMY POINTERS  -  CHECK FOR SOME DATA TO MOVE
1050  CONTINUE
      N=ICOM05(I+3)
      IF(N)1450,1450,1100
C--FIND THE ADDRESS OF THE DATA RECORDS
1100  CONTINUE
      JX=ICOM05(I)
      JY=ISTORE(KA)
C--FIND THE NUMBER OF DATA RECORDS PRESENT ALREADY
      M=ISTORE(KA+3)
C--CHECK IF THIS IS THE ATOM RECORD
      IF(I-1)1200,1150,1200
C--CHECK IF WE REQUIRE ANY OF THE ATOMS FORMERLY IN LIST 5
1150  CONTINUE
      M=N10A
C--FIND THE MAXIMUM AMOUNT TO MOVE FOR EACH GROUP
1200  CONTINUE
      L=MIN0(ICOM05(I+2),ISTORE(KA+2))
C--MOVE DATA FOR EACH GROUP IN TURN
      DO 1400 J=1,N
      IF(M)1350,1350,1250
C--GROUPS LEFT TO MOVE  -  CHECK THE NUMBER OF ELEMENTS TO MOVE
1250  CONTINUE
      IF(L)1350,1350,1300
C--MOVE THE ELEMENTS FOR THE CURRENT GROUP
1300  CONTINUE
      CALL XMOVE(STORE(JY),STORE(JX),L)
C--UPDATE FOR THE NEXT GROUP
1350  CONTINUE
      M=M-1
      JX=JX+ICOM05(I+2)
      JY=JY+ISTORE(KA+2)
1400  CONTINUE
C--UPDATE FOR THE NEXT RECORD
1450  CONTINUE
      KA=KA+4
1500  CONTINUE
C--RESET THE CORE LIMIT
      LFL=LFL1
C--SET 'MD5A'
      MD5A=MD5
C--AND NOW RETURN
1550  CONTINUE
      LN5=LNOUT
      RETURN
      END
C
CODE FOR XSTR05
      SUBROUTINE XSTR05(IULN,IOWF,INEW)
C--SUBROUTINE TO STORE A LIST TYPE 5 ON DISC.
C
C  IULN    THE LIST TYPE TO STORE ON DISC.
C  IOWFLG  THE WRITE/OVERWRITE STATUS FOR THIS LIST :
C
C          -1  ATTEMPT AN OVERWRITE.
C           0  WRITE A COMPLETELY NEW LIST.
C          +1  ATTEMPT A CAREFUL OVERWRITE.
C
C  INEW    THE NEW LIST FLAG :
C
C          -1  THIS IS NOT A NEW VERSION OF THIS LIST.
C           0  THIS IS A NEW LIST, WITH LINKS TO OTHER EXISTING LISTS.
C          +1  THIS IS A NEW LIST, WITH NO LINKS TO OTHER EXISTING
C              LISTS. THIS IS NORMALLY THE CASE WHEN THE LIST HAS JUST B
C              INPUT.
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM05(40)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (L5,ICOM05(1))
C
C--SET THE LENGTH OF THE COMMON BLOCK FOR LIST 5
      IDIM05=40
C--STORE THE LIST ON DISC
      CALL XWLSTD(IULN,ICOM05,IDIM05,IOWF,INEW)
      RETURN
      END
C
CODE FOR KTYP05
      FUNCTION KTYP05(IULN)
C--SET THE TYPE OF LIST 5 TO BE USED.
C
C  IULN    THE NUMBER OF THE LIST 5, IN THE RANGE 1 TO N. THE FOLLOWING
C          TYPES ARE KNOWN AT PRESENT :
C
C          1  TYPE IS 5.
C          2  TYPE IS 10.
C
C--NO OTHER TYPES ARE SUPPORTED AND AN ERROR IS REPORTED FOR ANY OTHERS.
C
C--RETURN VALUES OF 'KTYP05' ARE :
C
C  >0  THE LIST TYPE TO BE USED.
C
C--
C
      DIMENSION ITYPE(2)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C
      DATA ITYPE(1)/5/,ITYPE(2)/10/
C
C--CHECK THE INPUT VALUE
      IF(IULN)1000,1000,1100
C--TYPE IS ILLEGAL
1000  CONTINUE
      CALL XERHDR(-1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)IULN
      ENDIF
      WRITE(NCAWU,1050) IULN
1050  FORMAT(30H Illegal list 5 type selector ,I5)
      CALL XERHND ( IERPRG )
C--CHECK THE MAXIMUM
1100  CONTINUE
      IF(IULN-3)1150,1000,1000
C--FIND THE TYPE
1150  CONTINUE
      KTYP05=ITYPE(IULN)
      RETURN
      END
C
CODE FOR KSET53
      FUNCTION KSET53(IN)
C--SET UP THE FORM FACTOR TYPES IN LIST 5
C
C  IN  DUMMY ARGUMENT
C
C--ON RETURN 'KSET53' IS SET TO THE MAXIMUM FORM FACTOR
C  TYPE REFERENCED MINUS ONE.
C
C--LISTS 5 AND 3 ARE ASSUMED TO HAVE BEEN LOADED.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      M=-1
C--CHECK IF THERE ARE ANY FORM FACTORS IN LIST 3
      IF(N3)1300,1300,1000
C--CHECK IF THERE ARE ANY ATOMS IN LIST 5
1000  CONTINUE
      IF(N5)1300,1300,1050
C--LOOP OVER ALL THE ATOMS
1050  CONTINUE
      M5=L5
      DO 1250 L=1,N5
C--SCAN LIST 3
      J=KCOMP(1,ISTORE(M5),ISTORE(L3),N3,MD3)-1
C--CHECK THE REPLY
      IF(J)1100,1200,1200
C--THIS ATOM TYPE IS NOT IN LIST 3
1100  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1150)STORE(M5)
      ENDIF
      WRITE(NCAWU,1150) STORE(M5)
1150  FORMAT(29H Form factor not in list 3 : ,A4)
      CALL XERHND ( IERERR )
C--STORE THE FORM FACTOR NUMBER
1200  CONTINUE
      ISTORE(M5)=J
C--UPDATE THE MAXIMUM FOUND
      M=MAX0(M,J)
C--UPDATE FOR THE NEXT ATOM
      M5=M5+MD5
1250  CONTINUE
C--SET THE RETURN VALUE AND EXIT
1300  CONTINUE
      KSET53=M
      RETURN
      END
C
CODE FOR XFAL13
      SUBROUTINE XFAL13
C--ROUTINE TO LOAD LIST 13 FROM THE DISC
C
C--
      DIMENSION ICOM13(36)
C
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
C
      EQUIVALENCE (ICOM13(1),L13CD)
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 13
      IDIM13=36
C--LOAD THE LIST
      CALL XLDLST(13,ICOM13,IDIM13,-1)
      RETURN
      END
C
C
CODE FOR XFAL20
      SUBROUTINE XFAL20
C--ROUTINE TO LOAD LIST 20 FROM THE DISC
C
C      1 = ORTHOGONALISATION MATRIX
C      2 = CRYSTAL FRACTIONS TO INERTIAL
C      3 = CRYSTAL FRACTIONS TO TLS
C      4 = USER DEFINED
      DIMENSION ICOM20(12)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST20/L20M,M20M,MD20M,N20M,
     2 L20I,M20I,MD20I,N20I, L20V,M20V,MD20V,N20V
C
      EQUIVALENCE (ICOM20(1),L20M)
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 20
      IDIM20 = 12
C--LOAD THE LIST
      CALL XLDLST(20,ICOM20,IDIM20,-1)
C----- CHECK FOR LIST 1, WHICH MUST BE LOADED FIRST
      IF (KHUNTR(1, 0, IADDL, IADDR, IADDD, 0) .EQ. 0) THEN
      CALL XTRANS(STORE(L1O1),STORE(L20M),3,3)
      CALL XTRANS(STORE(L1O2),STORE(L20I),3,3)
      ENDIF
      RETURN
      END
C
CODE FOR XSTR20
      SUBROUTINE XSTR20(IULN,IOWF,INEW)
C--SUBROUTINE TO STORE A LIST TYPE 20 ON DISC.
C
C  IULN    THE LIST TYPE TO STORE ON DISC.
C  IOWFLG  THE WRITE/OVERWRITE STATUS FOR THIS LIST :
C
C          -1  ATTEMPT AN OVERWRITE.
C           0  WRITE A COMPLETELY NEW LIST.
C          +1  ATTEMPT A CAREFUL OVERWRITE.
C
C  INEW    THE NEW LIST FLAG :
C
C          -1  THIS IS NOT A NEW VERSION OF THIS LIST.
C           0  THIS IS A NEW LIST, WITH LINKS TO OTHER EXISTING LISTS.
C          +1  THIS IS A NEW LIST, WITH NO LINKS TO OTHER EXISTING
C              LISTS. THIS IS NORMALLY THE CASE WHEN THE LIST HAS JUST B
C              INPUT.
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM20(12)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST20/L20M,M20M,MD20M,N20M,
     2 L20I,M20I,MD20I,N20I, L20V,M20V,MD20V,N20V
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM20(1),L20M)
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 20
      IDIM20 = 12
C--STORE THE LIST ON DISC
      CALL XWLSTD(IULN,ICOM20,IDIM20,IOWF,INEW)
      RETURN
      END
C
CODE FOR XFAL14
      SUBROUTINE XFAL14
C--ROUTINE TO LOAD LIST 14 FROM THE DISC
C
C--
      DIMENSION ICOM14(16)
C
      COMMON/XLST14/L14,M14,MD14,N14, L14O,M14O,MD14O,N14O,
     2 L14SC,M14SC,MD14SC,N14SC, L14P,M14P,MD14P,N14P
C
      EQUIVALENCE (L14,ICOM14(1))
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 14
      IDIM14=16
C--LOAD THE LIST
      CALL XLDLST(14,ICOM14,IDIM14,-1)
      RETURN
      END
C
CODE FOR XFAL24
      SUBROUTINE XFAL24
C--ROUTINE TO LOAD LIST 24 FROM THE DISC
C
C--
      DIMENSION ICOM24(8)
C
      COMMON/XLST24/L24,M24,MD24,N24,L24IR,M24IR,MD24IR,N24IR
C
      EQUIVALENCE (ICOM24(1),L24)
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 24
      IDIM24=8
C--LOAD THE LIST
      CALL XLDLST(24,ICOM24,IDIM24,-1)
      RETURN
      END
C
CODE FOR XFAL25
      SUBROUTINE XFAL25
C--ROUTINE TO LOAD LIST 25 FROM THE DISC
C
C--
      DIMENSION ICOM25(8)
C
      COMMON/XLST25/L25,M25,MD25,N25,L25I,M25I,MD25I,N25I
C
      EQUIVALENCE (ICOM25(1),L25)
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 25
      IDIM25=8
C--LOAD THE LIST
      CALL XLDLST(25,ICOM25,IDIM25,-1)
      RETURN
      END
C
CODE FOR XFAL29
      SUBROUTINE XFAL29
C--ROUTINE TO LOAD LIST 29 FROM THE DISC
C
C--
      DIMENSION ICOM29(4)
C
      COMMON/XLST29/L29,M29,MD29,N29
C
      EQUIVALENCE (L29,ICOM29(1))
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 29
      IDIM29=4
C--LOAD THE LIST
      CALL XLDLST(29,ICOM29,IDIM29,-1)
      RETURN
      END
C
C
CODE FOR XFAL30
      SUBROUTINE XFAL30
C--ROUTINE TO LOAD LIST 30 FROM THE DISC
C
C--
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 30
      PARAMETER (IDIM30 = 32)
      DIMENSION ICOM30(IDIM30)
C
      COMMON/XLST30/
     1 L30DR,M30DR,MD30DR,N30DR, L30CD,M30CD,MD30CD,N30CD,
     2 L30RF,M30RF,MD30RF,N30RF, L30IX,M30IX,MD30IX,N30IX,
     3 L30AB,M30AB,MD30AB,N30AB, L30GE,M30GE,MD30GE,N30GE,
     4 L30CL,M30CL,MD30CL,N30CL, L30SH,M30SH,MD30SH,N30SH
C
      EQUIVALENCE (L30DR,ICOM30(1))
C
C---- IF NO LIST 30, CREATE ONE
      IF (KEXIST(30) .LE. 0) THEN
            CALL XCELST (30, ICOM30, IDIM30)
      ELSE
C-----LOAD THE LIST
            CALL XLDLST(30, ICOM30, IDIM30, -1)
      ENDIF
      RETURN
      END
C
CODE FOR XRD33
      SUBROUTINE XRD33
C--INPUT ROUTINES FOR THE SFLS CONTROL DATA
C
C--USE OF VARIABLES :
C
C  KA  LIST TYPE
C
C--COMMANDS ARE STORED AND OUTPUT, AS NECCESSARY, IN THE ORDER :
C
C   -1    #SPECIAL
C      0  #CALCULATE, #SCALE, #REFINE
C      1  #CONSTRAIN
C      2  #INVERT
C      3  #SOLVE
C      4  #PUNCH
C      5  #CYCLENDS
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM33(24)
C
      DIMENSION IRQ(3,8),IRCALC(3,3),IEND(2),INO(1), JRQ(3,2)
      DIMENSION INVERT(2)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XLST23/L23M,M23M,MD23M,N23M,L23EX,M23EX,MD23EX,N23EX,
     2 L23MN,M23MN,MD23MN,N23MN,L23AC,M23AC,MD23AC,N23AC,
     3 L23IC,M23IC,MD23IC,N23IC, L23SP,M23SP,MD23SP,N23SP
      COMMON/XLST33/L33CD,M33CD,MD33CD,N33CD,L33SV,M33SV,MD33SV,N33SV,
     2 L33ST,M33ST,MD33ST,N33ST,L33IB,M33IB,MD33IB,N33IB,
     3 L33V,M33V,MD33V,N33V,L33CB,M33CB,MD33CB,N33CB
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM33(1),L33CD)
C
C--SYSTEM REQUEST QUEUE ARGUMENTS
C
      DATA IVERSN /102/
C
      DATA NJRQ /2/, NWJRQ /3/
      DATA JRQ(1,1)/'SPEC'/, JRQ(2,1)/'  NO'/, JRQ(3,1)/'  NO'/
      DATA JRQ(1,2)/'SPEC'/, JRQ(2,2)/' LIS'/, JRQ(3,2)/'  NO'/
C
      DATA NRQ/8/, NWRQ/3/
C
      DATA IRQ(1,1)/'    '/,IRQ(2,1)/'    '/,IRQ(3,1)/'    '/
      DATA IRQ(1,2)/'    '/,IRQ(2,2)/'    '/,IRQ(3,2)/'    '/
      DATA IRQ(1,3)/'    '/,IRQ(2,3)/'    '/,IRQ(3,3)/'    '/
      DATA IRQ(1,4)/'REST'/,IRQ(2,4)/'RAIN'/,IRQ(3,4)/'    '/
      DATA IRQ(1,5)/'INVE'/,IRQ(2,5)/'RT  '/,IRQ(3,5)/'    '/
      DATA IRQ(1,6)/'SOLV'/,IRQ(2,6)/'E   '/,IRQ(3,6)/'    '/
      DATA IRQ(1,7)/'PUNC'/,IRQ(2,7)/'H  5'/,IRQ(3,7)/'    '/
      DATA IRQ(1,8)/'CYCL'/,IRQ(2,8)/'ENDS'/,IRQ(3,8)/'    '/
C
      DATA IRCALC(1,1)/'REFI'/,IRCALC(2,1)/'NE  '/,IRCALC(3,1)/'    '/
      DATA IRCALC(1,2)/'SCAL'/,IRCALC(2,2)/'E   '/,IRCALC(3,2)/'    '/
      DATA IRCALC(1,3)/'CALC'/,IRCALC(2,3)/'ULAT'/,IRCALC(3,3)/'E   '/
C
      DATA INO(1)/'NO  '/
C
C--'END' DIRECTIVE
      DATA NWEND/2/
      DATA IEND(1)/'E   '/,IEND(2)/'ND  '/
      DATA INVERT(1) /'CHOL'/, INVERT(2) /'EIGE'/
C
C--POINTERS TO THE INPUT DIRECTIVES
      DATA NREFNE/1/,NVECTR/5/,NSHIFT/6/,NFORCE/8/,NSHFTP/9/
C
C--ASSIGN THE LENGTH OF THE COMMON BLOCK FOR LIST 33  -  SFLS CONTROL
      IDIM33=24
C--SET THE LIST TYPE TO BE USED
      KA=33
C--SET THE FLAGS FOR THE SHIFT TYPE RECORD DEFINITION DIRECTIVE
      CALL XDIRFL(NSHFTP,ICOM33,IDIM33)
C--CREATE THE DATA RECORD FOR THIS DIRECTIVE
      I=KCDRFI(ICOM33,IDIM33,0)
C--INDICATE THAT THIS DIRECTIVE HAS BEEN READ ONCE
      ISTORE(MR61+8)=ISTORE(MR61+7)
C--SET THE TYPE OF EACH SHIFT TO NORMAL
      N=MD33ST*N33ST
      M=-1
      CALL XMVSPD(M,STORE(L33ST),N)
C--SET THE FLAGS FOR THE SHIFT VALUES RECORD
      CALL XDIRFL(NSHIFT,ICOM33,IDIM33)
C--CREATE A DATA RECORD FOR THIS DIRECTIVE
      I=KCDRFI(ICOM33,IDIM33,0)
C--LOOP OVER ALL THE DIRECTIVES THAT USE THIS ONE, SETTING THEIR CONSTAN
      DO 1000 I=NSHIFT,NFORCE
      J=LR61+(I-1)*MDR61
      ISTORE(J+7)=ISTORE(MR61+7)
      ISTORE(J+8)=1
      ISTORE(J+9)=ISTORE(MR61+9)
      ISTORE(J+10)=ISTORE(MR61+10)
1000  CONTINUE
C--ASSIGN THE DEFAULT SHIFT VALUE OF UNITY
      N=MD33SV*N33SV
      A=1.
      CALL XMVSPF(A,STORE(L33SV),N)
C--SET THE FLAGS FOR THE CYCLE CONTROL RECORD
      CALL XDIRFL(NREFNE,ICOM33,IDIM33)
C--CREATE A DATA RECORD FOR THIS DIRECTIVE
      I=KCDRFI(ICOM33,IDIM33,0)
C--LOOP OVER ALL THE DIRECTIVES THAT USE THIS ONE, SETTING THEIR CONSTAN
      DO 1050 I=NREFNE,NVECTR
      J=LR61+(I-1)*MDR61
      ISTORE(J+7)=ISTORE(MR61+7)
      ISTORE(J+8)=1
      ISTORE(J+9)=ISTORE(MR61+9)
      ISTORE(J+10)=ISTORE(MR61+10)
1050  CONTINUE
C--INDICATE THAT THERE IS NO CURRENT DIRECTIVE AGAIN
      IDIRFL=-1
C--INDICATE THAT NO CYCLES HAVE BEEN FOUND YET
      NCYCLE=0
C--INDICATE NO CURRENT DIRECTIVE
      IDIR=-1
C
C--READ THE NEXT DIRECTIVE CARD
1100  CONTINUE
      LAST=IDIR
      IDIR=KRDNDC(ICOM33,IDIM33)
C--CHECK THE REPLY
      IF(IDIR)2150,2100,1150
C--THIS IS A NEW DIRECTIVE  -  SEE IF IT IS 'REFINE', 'SCALE', ETC.
1150  CONTINUE
      IF(IDIR-NREFNE)1600,1250,1200
C--CHECK THE MAXMIMUM POSSIBLE VALUE
1200  CONTINUE
      IF(IDIR-NVECTR)1250,1250,1700
C--A CYCLE TYPE OF DIRECTIVE  -  UPDATE THE NUMBER OF CYCLES
1250  CONTINUE
      NCYCLE=NCYCLE+1
C--MAKE ALL THE CYCLE DIRECTIVES HAVE THE SAME COUNT
      DO 1300 I=NREFNE,NVECTR
      J=LR61+(I-1)*MDR61
      ISTORE(J+8)=NCYCLE
1300  CONTINUE
C--SET THE POINTERS CORRECTLY FOR THIS DIRECTIVE
      CALL XDIRFL(IDIR,ICOM33,IDIM33)
C--SHIFT INSTRUCTIONS MAY BE ALLOWED  -  ALTER THEIR POINTERS
      K=IDIR-NREFNE+1
      DO 1500 I=NSHIFT,NFORCE
      J=LR61+(I-1)*MDR61
C--BRANCH ON THE TYPE OF CALCULATION
      GOTO(1400,1450,1450,1400,1400,1350),K
1350  STOP137
C--ELIMINATE THE EXCLUDED DIRECTIVE COUNT FOR THE SHIFT
1400  CONTINUE
      ISTORE(J+6)=0
C--ALTER THE REPEAT COUNTERS
1450  CONTINUE
      ISTORE(J+7)=NCYCLE+1
      ISTORE(J+8)=NCYCLE
1500  CONTINUE
C--STORE THE TYPE OF ARGUMENT FOUND
      J=IPARAD+MD33CD
      ISTORE(J-1)=K
C--INCREMENT THE NUMBER OF OPERATIONS ALLOWED
      N33IB=2*(NRQ+1)*NCYCLE
C--FIND THE NEXT PARAMETER KEYWORD
1600  CONTINUE
      IF(KFNDNP(I))1100,1100,1650
C--READ THE VALUE ASSOCIATED WITH THIS PARAMETER KEYWORD
1650  CONTINUE
      IF(KRDPV(ICOM33,IDIM33))1100,1600,1600
C
C--SOME TYPE OF SHIFT INFORMATION  -  CHECK FOR THE FIRST TIME
1700  CONTINUE
      IF(NCYCLE)1750,1750,1850
C--NO CALCULATION OF ANY TYPE SO FAR  -  SHIFTS ARE NOT ALLOWED
1750  CONTINUE
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1800)
      ENDIF
      WRITE(NCAWU,1800)
1800  FORMAT(/34H Shift information may only follow,
     2 22H refinement directives)
      LEF=LEF+1
      IDIRFL=-1
      GOTO 1100
C--SET THE COUNT CORRECTLY FOR THIS DIRECTIVE
1850  CONTINUE
      ISTORE(MR61+8)=NCYCLE
      CALL XDIRFL(IDIR,ICOM33,IDIM33)
C--RESET THE ONE WE HAVE FOUND
      ISTORE(MR61+8)=ISTORE(MR61+7)
C--FIND THE NEXT PARAMETER KEYWORD
1900  CONTINUE
      IPAR=KFNDNP(I)
      IF(IPAR)1100,1100,1950
C--READ THE VALUE
1950  CONTINUE
      M33ST=IPARAM+L33ST+(NCYCLE-1)*MD33ST
      ISTORE(M33ST-1)=IDIR-NSHIFT-1
      IF(KRDPV(ICOM33,IDIM33))1100,2000,2000
C--CHECK IF THIS IS A 'GENERAL' KEYWORD FOR ALL PARAMETERS
2000  CONTINUE
      IF(IPAR-1)1900,2050,1900
C--CHANGE ALL THE ENTRIES TO REFLECT THIS VALUE
2050  CONTINUE
      CALL XFILL(STORE(M33ST-1),STORE(M33ST),MD33ST-1)
C--AND NOW THE SHIFT VALUE
      M33SV=L33SV+IPARAM+(NCYCLE-1)*MD33SV
      CALL XFILL(STORE(M33SV-1),STORE(M33SV),MD33SV-1)
      GOTO 1900
C
C--A 'CONTINUATION' CARD  -  CHECK FOR SHIFT FACTORS
2100  CONTINUE
      IDIR=LAST
      IF(IDIR-NSHIFT)1600,1900,1900
C
C--END OF THE DIRECTIVES  -  CHECK FOR ANY ERRORS
2150  CONTINUE
      IF ( LEF .NE. 0 ) GO TO 9910
C--CHECK FOR SOME CALCULATIONS
      IF ( NCYCLE .LE. 0 ) GO TO 9920
C--UPDATE THE POINTERS FOR THE CYCLE CONTROL RECORD
      N33CD=NCYCLE
C--SET THE COUNT TO ZERO AGAIN
      NCYCLE=0
C--LOAD LIST 23 FOR CONSTRAINTS DETAILS
      CALL XFAL23
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--LOOP OVER EACH CYCLE FORMING THE SYSTEM REQUEST RECORD
      M33CD=L33CD
      M33IB=L33IB
      N33IB=0
C--ASSUME NO CALCULATION OF ANY TYPE SO FAR
      KF=-1
C--LOOP OVER EACH TYPE OF CALCULATION
      DO 3450 I=1,N33CD
      M=M33CD+MD33CD
C--SET THE INITIAL INSTRUCTION GENERATION POINTERS
      LRQ = 2
C----- DONT DO 'CYCLENDS'
      MRQ = NRQ - 1
      CALL XMOVE (JRQ(1,1), IRQ(1,2), NWRQ)
C--FIND THE TYPE OF CALCULATION
      J=ISTORE(M-1)
C--BRANCH ON THE TYPE OF CALCULATION
      GOTO(2550,2700,2800,2850,2900,2500),J
2500  STOP135
C--'REFINE' HAS BEEN INPUT FOR THIS CYCLE
2550  CONTINUE
      CALL XMOVE (JRQ(1,2), IRQ(1,2), NWRQ)
C----- SET INVERSION TO CHOLESKI OR EIGENVECTOR
      IRQ(3,5) = INVERT(2+ ISTORE(M33CD+8))
      KG=1
C--INDICATE THAT ANY TYPE OF CALCULATION IS NOW ALLOWED
2600  CONTINUE
      KF=-1
C--SET THE LENGTH POINTER TO BE STORED
2650  CONTINUE
      ILEN=NWEND+1
      CALL XMOVE(IRCALC(1,KG),IRQ(1,3),NWRQ)
      GOTO 2950
C--'SCALE' DIRECTIVE  -  SET THE POINTERS
2700  CONTINUE
      KG=2
C--ADJUST THE OUTPUT POINTERS AND DISAAALLOW ANY OTHER SIMILAR CALCULATI
2750  CONTINUE
      MRQ = LRQ + 1
      K=KF
      KF=0
C--CHECK FOR TWO SUCCESSIVE SIMILAR CYCLES
      IF(K)2650,3400,3400
C--'CALCULATE' DIRECTIVE  -  SET THE PINTERS AND ENTER THE CHECK LOOP
2800  CONTINUE
      KG=3
      GOTO 2750
C--'SOLVE' DIRECTIVE  -  SUPPRESS '#CALCULATE' AND '#CONSTRAIN'
2850  CONTINUE
      KG=1
      LRQ=5
      GOTO 2550
C--'VECTOR' DIRECTIVE  -  ALTER THE '#SOLVE' DIRECTIVE
2900  CONTINUE
      KG=3
      IRQ(3,6)=INO(1)
      GOTO 2600
C--STORE THE NECESSARY INSTRUCTIONS
2950  CONTINUE
      DO 3300 K=LRQ,MRQ
C--BRANCH ON THE INSTRUCTION TO BE ISSUED
      GOTO(3250,3250,3250,3050,3200,3250,3150,3250,3000),K
3000  GOTO 9930
C----- CHECK IF VECTOR IS ALSO SET - IF SO SKIP RESTRAIN
3050  CONTINUE
      IF(J-5)3100,3300,3100
C----- NOT A VECTOR - ISSUE RESTRAIN, TO BE SKIPPED IN XAPP26 IF
C      LIST 23 DOES NOT NEED IT
3100  CONTINUE
      GOTO 3250
C--'#PUNCH' TO BE ISSUED  -  CHECK IF IT IS NECESSARY
3150  CONTINUE
      IF (ISTORE(M33CD+5)) 3300, 3250, 3250
C--'#INVERT' TO BE ISSUED  -  CHECK IF THIS IS A 'VECTOR' INSTRUCTION
3200  CONTINUE
      IF(ISTORE(M-1)-5)3250,3300,3250
C--INSERT THE CURRENT INSTRUCTION IN THE DATA RECORD
3250  CONTINUE
      CALL XMVSPD(IB,ISTORE(M33IB),2*MD33IB)
      ISTORE(M33IB)=MD33IB
C--INSERT THE '#'
      ISTORE(M33IB+1)=IH
C--INSERT THE COMMAND
      CALL XMOVE(IRQ(1,K),STORE(M33IB+2), NWRQ)
C--UPDATE THE POINTERS
      M33IB=M33IB+MD33IB
C--OUTPUT THE 'END' DIRECTIVE
      ISTORE(M33IB)=ILEN
      CALL XMOVE(IEND(1),STORE(M33IB+1),NWEND)
C--FINAL UPDATE OF THE POINTERS
      M33IB=M33IB+MD33IB
      N33IB=N33IB+2
3300  CONTINUE
C--CHECK IF WE HAVE ISSUED THE '#CYCLENDS' DIRECTIVE
      IF(MRQ-NRQ)3350,3400,3400
C--NOT ISSUED YET  -  SET THE POINTERS
3350  CONTINUE
      LRQ=NRQ
      MRQ=NRQ
      ILEN=-(NWEND+1)
      NCYCLE=NCYCLE+1
      GOTO 2950
C--UPDATE FOR THE NEXT CYLE
3400  CONTINUE
      M33CD=M33CD+MD33CD
3450  CONTINUE
C--UPDATE THE INSTRUCTION RECORD COUNT
      CALL XUDRH(KA,104,0,N33IB)
C--UPDATE THE POINTERS FOR THE CYCLE CONTROL RECORD
      N33CD=NCYCLE
      CALL XUDRH(KA,101,0,N33CD)
C--UPDATE THE POINTERS FOR THE SHIFT VALUES RECORD
      N33SV=NCYCLE
      CALL XUDRH(KA,102,0,N33SV)
C--UPDATE THE POINTERS FOR THE SHIFT TYPES RECORD
      N33ST=NCYCLE
      CALL XUDRH(KA,103,0,N33ST)
C--UPDATE THE POINTERS TO THE VALUES FOR EACH CYCLE
      N33V=NCYCLE
      CALL XUDRH(KA,106,0,N33V)
C--WRITE THE LIST TO THE DISC
      CALL XWLSTD(KA,ICOM33,IDIM33,-1,0)
C--FIRE OUT SOME LINES
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPSFS , IOPABN , IVERSN )
      RETURN
9910  CONTINUE
      CALL XOPMSG ( IOPSFS , IOPCMI , IVERSN )
      GO TO 9900
9920  CONTINUE
C -- NO CALCULATIONS INDICATED
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 )
      ENDIF
      WRITE ( NCAWU , 9925 )
9925  FORMAT ( 1X , 'No SFLS calculations indicated' )
      CALL XERHND ( IERERR )
      GO TO 9900
9930  CONTINUE
      CALL XOPMSG ( IOPSFS, IOPABN, IVERSN)
      CALL XERHND (IERPRG)

      END
C
CODE FOR XCYCLE
      SUBROUTINE XCYCLE
C--SUBROUTINE TO RESUME A STRUCTURE FACTOR LEAST SQUARES CALCULATION
C  AT THE NEXT COMPLETE CYCLE.
C
C--
C
      CHARACTER CFORM*12, CFMRQ*6, CIMAGE*80
      DIMENSION ICOM33(24)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST33/L33CD,M33CD,MD33CD,N33CD,L33SV,M33SV,MD33SV,N33SV,
     2 L33ST,M33ST,MD33ST,N33ST,L33IB,M33IB,MD33IB,N33IB,
     3 L33V,M33V,MD33V,N33V,L33CB,M33CB,MD33CB,N33CB
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM33(1),L33CD)
C
      DATA IDIMFM/3/
      DATA CFMRQ /'(20A4)'/
      DATA CFORM /'(A1,19A4,A3)'/
C
C--ASSIGN THE LENGTH OF THE COMMON BLOCK FOR LIST 33  -  SFLS CONTROL
      IDIM33=24
C--LOAD THE LAST LIST 33
      CALL XCSAE
      CALL XRSL
      CALL XFAL33
C--CHECK IF WE HAVE PROCESSED ALL THE '#INSTRUCTIONS' IN LIST 33
      IF ( IERFLG .LT. 0 ) GO TO 1300
      IF(ISTORE(L33CB)-N33IB)1000,1300,1300
C--LOOP OVER THE REMAINING INSTRUCTIONS ISSUING AS MANY AS REQUIRED
1000  CONTINUE
      J=ISTORE(L33CB)+1
C--UPDATE THE NUMBER OF THIS CYCLE
      ISTORE(L33CB+1)=ISTORE(L33CB+1)+1
C--INDICATE THAT THERE ARE NO SYSTEM REQUEST COMMANDS IN CORE
      KX=0
C--CHECK IF THERE IS ANY INFORMATION IN THE SYSTEM REQUEST QUEUE
      IF(NREC)1020,1020,1010
C--COMMANDS STILL IN THE QUEUE  -  READ THEM DOWN
1010  CONTINUE
      KX=NREC
      KY=20
      KZ=KX*KY
      KS=KCHLFL(KZ)
      KT=KS+KZ-1
      READ (NUSRQ,CFMRQ) (ISTORE(KR),KR=KS,KT)
      NREC=0
      IEOF=NREC
      IPOSRQ=0
      REWIND NUSRQ
C--SET UP A BUFFER TO CONTAIN THE COMMAND
1020  CONTINUE
      KB=21
      KA=NFL
      I=KCHNFL(KB)
      DO 1050 I=J,N33IB
C--COMPUTE THE CURRENT ADDRESS
      M33IB=L33IB+ISTORE(L33CB)*MD33IB
C--FIND THE LENGTH POINTER
      K=ISTORE(M33IB)
C--FIND THE ABSOLUTE VALUE OF THIS POINTER
      L=IABS(K)
C--MOVE THE DATA TO THE OUTPUT AREA
      CALL XMVSPD(IB,STORE(KA),KB)
C--NOW THE DATA
      CALL XMOVE(STORE(M33IB+1),STORE(KA),L-1)
C--ISSUE THE COMMAND
      WRITE(CIMAGE,CFORM) (STORE(IZ), IZ= KA, KA+KB-1)
      CALL XISRC (CIMAGE)
C--UPDATE THE POINTER IN LIST 33
      ISTORE(L33CB)=ISTORE(L33CB)+1
C--CHECK FOR THE LAST OPERATION
      IF(K)1100,1050,1050
1050  CONTINUE
C--REWRITE LIST 33
1100  CONTINUE
      CALL XWLSTD(LN,ICOM33,IDIM33,-1,-1)
C--ISSUE A THE SYSTEM REQUESTS
      IF(IHFLAG)1110,1120,1120
C--NO '#INSTRUCTION' WAITING
1110  CONTINUE
      I=KPSRQ(0)
      GOTO 1150
C--'#INSTRUCTION' WAITING
1120  CONTINUE
      I=KPSRQ(1)
C--CHECK IF THERE IS DATA TO BE ADDED TO THE SYSTEM REQUEST QUEUE
1150  CONTINUE
      IF(KX)1300,1300,1200
C--RECORDS TO BE OUTPUT
1200  CONTINUE
      IZZ = KS
      DO 1250 KR=1,KX
C      WRITE(NCAWU ,CFMRQ) (ISTORE(IZ), IZ = IZZ, IZZ-1+KY)
      WRITE(CIMAGE,CFMRQ) (ISTORE(IZ), IZ = IZZ, IZZ-1+KY)
      CALL XISRC (CIMAGE)
      IZZ = IZZ + KY
1250  CONTINUE
C--AND NOW RETURN
1300  CONTINUE
      RETURN
      END
C
CODE FOR XFAL27
      SUBROUTINE XFAL27
C--ROUTINE TO LOAD LIST 27 FROM THE DISC
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM27(4)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST27/L27,M27,MD27,N27
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM27(1),L27)
C
C--SET THE DIMENSION OF THE LIST 27 COMMON BLOCK
      IDIM27=4
C--LOAD THE LIST
      CALL XLDLST(27,ICOM27,IDIM27,-1)
      RETURN
      END
C
CODE FOR XFAL33
      SUBROUTINE XFAL33
C--ROUTINE TO LOAD LIST 33 FROM THE DISC
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM33(24)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST33/L33CD,M33CD,MD33CD,N33CD,L33SV,M33SV,MD33SV,N33SV,
     2 L33ST,M33ST,MD33ST,N33ST,L33IB,M33IB,MD33IB,N33IB,
     3 L33V,M33V,MD33V,N33V,L33CB,M33CB,MD33CB,N33CB
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM33(1),L33CD)
C
C--ASSIGN THE LENGTH OF THE COMMON BLOCK FOR LIST 33  -  SFLS CONTROL
      IDIM33=24
C--LOAD THE LIST
      CALL XLDLST(33,ICOM33,IDIM33,-1)
      M33CD=L33CD+ISTORE(L33CB+1)*MD33CD
      M33SV=L33SV+ISTORE(L33CB+1)*MD33SV
      M33ST=L33ST+ISTORE(L33CB+1)*MD33ST
      M33V=L33V+ISTORE(L33CB+1)*MD33V
      RETURN
      END
C
C
CODE FOR XFAL38
      SUBROUTINE XFAL38
C--ROUTINE TO LOAD LIST 38 FROM THE DISC
C
C--
      DIMENSION ICOM38(24)
C
      COMMON /XLST38/ L38,M38,MD38,N38 , L38GR,M38GR,MD38GR,N38GR ,
     2 L38AT,M38AT,MD38AT,N38AT , L38LK,M38LK,MD38LK,N38LK ,
     3 L38OR,M38OR,MD38OR,N38OR , L38VC,M38VC,MD38VC,N38VC
C
      EQUIVALENCE ( ICOM38(1) , L38 )
C
      IDIM38 = 24
C--LOAD THE LIST
      CALL XLDLST(38,ICOM38,IDIM38,-1)
      RETURN
      END
C
CODE FOR XFAL23
      SUBROUTINE XFAL23
C--ROUTINE TO LOAD LIST 23 FROM THE DISC
C
C--
      DIMENSION ICOM23(24)
C
      COMMON/XLST23/L23M,M23M,MD23M,N23M,L23EX,M23EX,MD23EX,N23EX,
     2 L23MN,M23MN,MD23MN,N23MN,L23AC,M23AC,MD23AC,N23AC,
     3 L23IC,M23IC,MD23IC,N23IC, L23SP,M23SP,MD23SP,N23SP
C
      EQUIVALENCE (ICOM23(1),L23M)
C
C--ASSIGN THE LENGTH OF THE COMMON BLOCK FOR LIST 23  -  SFLS DETAILS
      IDIM23=24
C--LOAD THE LIST
      CALL XLDLST(23,ICOM23,IDIM23,-1)
      RETURN
      END
C
C
CODE FOR XQSTRT
      SUBROUTINE XQSTRT
C      QUICKSTART -
C----- A MINIMAL I/O STARTUP ROUTINE FOR READING DATA FROM OTHER SYSTEMS
C
C      IT EXPECTS CELL PARAMETERS, LAMBDA, RELECTION DETAILS, COMPOSITIO
C      SOME CHECKING DONE AT THIS STAGE, AND MORE AFTER NORMAL LISTS
C      ARE WRITTEN TO THE SYSTEM REQUEST QUEUE.
C
C      COMMAND INPUT - NOTE SPECIAL PROCESSING REQUIRED FOR
C      STRING TYPE PARAMETERS, TYPE 4.
C
      CHARACTER *80 CBUFF1, CBUFF2, CBUFF3, CBUFF4, CLINE
      CHARACTER CFMRQ*6, CEND*3
C
C----- TO HOLD REAL FORMAT EXPRESSION
      CHARACTER *8 CFMTXP
      CHARACTER *4 CFSQ(3), CTMP, CHKLI
      CHARACTER *1 CH(4)
      CHARACTER*16 CSSMAC , CSSOPS , CSSDAT , CSSPRG
      CHARACTER*64 CSSCMD, CSSNDA, CSSCST, CSSDST, CSSSCT, CSSELE
      CHARACTER*64 CSSVDU, CSSLPT
C
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XSSCHR/ CSSMAC, CSSOPS, CSSDAT, CSSPRG, CSSCMD, CSSNDA,
     2 CSSCST , CSSDST, CSSSCT, CSSELE, CSSVDU, CSSLPT
      COMMON /XSSLSN/ LSSMAC, LSSOPS, LSSDAT, LSSPRG, LSSCMD, LSSNDA,
     2 LSSCST , LSSDST, LSSSCT, LSSELE, LSSVDU, LSSLPT
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      DATA CFMRQ / '(20A4)' /, CEND /'END'/
      DATA CFSQ / 'YES ' , 'NO  ', 'NO  ' /
      DATA IDIMBF /13/
      DATA IVERSN /103/
C
C
      CALL XTIME1 ( 2 )
      WRITE (CH, '(4A1)' ) IH
      ICOMBF = KSTALL ( IDIMBF )
C
C -- COMMAND INPUT SECTION - DONE 'BY HAND'
C
C -- READ DIRECTIVE CARD
1000  CONTINUE
      IDIRNM = KRDNDC ( ISTORE(ICOMBF) , IDIMBF )
      IF ( IDIRNM .LT. 0 ) THEN
        GO TO 2500
      ELSE IF ( IDIRNM .EQ. 0 ) THEN
        CALL XMONTR ( 0 )
        GO TO 1000
      ENDIF
C
      IF ( IDIRNM .EQ. 1 .OR. IDIRNM .EQ. 2 .OR. IDIRNM .EQ. 3
     1 .OR. IDIRNM .EQ. 4) THEN
C----- SPACEGROUP, FORMAT COMPOSITION, OR FILE CARD
C -- SEARCH FOR THE PARAMETER KEYWORD
        IF ( KFNDNP(I) .LE. 0 ) GO TO 9810
C----- FIND NEXT AND LAST NON- BLANK ITEMS
        NC = KNEQUL ( NC , IB )
        IF ( NC .LE. 0 ) GO TO 9810
        IF ( NC .GT. LASTCH ) GO TO 9810
        LC = LASTCH
        DO 1100 I = LASTCH, NC, -1
        IF (IMAGE(LC) .NE. IB) GOTO 1150
        LC = LC - 1
1100    CONTINUE
1150    CONTINUE
C----- CREATE AN EXACT FORMAT EXPRESSION FOR INTERNAL WRITE
        ISIZE = MIN0 ( LC - NC + 1 , LEN ( CBUFF1 ) )
        WRITE (CFMTXP, '(2H( , I2, 3HA1))') ISIZE
      END IF
      IF (IDIRNM .EQ. 1) THEN
C----- SPACEGROUP CARD
        WRITE ( CBUFF1(1:ISIZE) , CFMTXP, ERR = 9830 )
     1      ( LCMAGE(J), J = NC, NC + ISIZE - 1 )
        ISIZE1 = ISIZE
        NC = LASTCH + 1
        GO TO 1000
      ELSE IF (IDIRNM .EQ. 2) THEN
C----- FORMAT CARD - NORMAL FORTRAN FORMATS
        WRITE ( CLINE(1:ISIZE) , CFMTXP, ERR = 9830 )
     1      ( LCMAGE(J), J = NC, NC + ISIZE - 1 )
        ISIZE2 = ISIZE
        NC = LASTCH + 1
C----- LIST 6
C----- CHECK THE FORMAT IS 'F' NOT 'I'
      JJ = 0
      JJJ = 0
      DO 2650 J = 1, ISIZE2
      IF (CLINE(J:J) .EQ. 'I') THEN
        JJ = JJ + 1
        JJJ = 1
        CBUFF2(JJ:JJ) = 'F'
      ELSE IF (CLINE(J:J) .EQ. ',' .OR. CLINE(J:J) .EQ. ')' ) THEN
        IF (JJJ .EQ. 1) THEN
            I = JJ + 1
            JJ = JJ + 2
            CBUFF2(I:JJ) = '.0'
            JJJ = 0
        END IF
        JJ = JJ + 1
        CBUFF2(JJ:JJ) = CLINE(J:J)
      ELSE
        JJ = JJ + 1
        CBUFF2(JJ:JJ) = CLINE(J:J)
      END IF
2650  CONTINUE
      ISIZE2 = JJ
      ELSE IF (IDIRNM .EQ. 3) THEN
C----- COMPOSITION CARD, TYPE THEN NUMBER
        WRITE ( CBUFF3(1:ISIZE) , CFMTXP, ERR = 9830 )
     1      ( LCMAGE(J), J = NC, NC + ISIZE - 1 )
        ISIZE3 = ISIZE
        NC = LASTCH + 1
      ELSE IF (IDIRNM .EQ. 4) THEN
C----- REFLECTION FILENAME CARD
        WRITE ( CBUFF4(1:ISIZE) , CFMTXP, ERR = 9830 )
     1      ( LCMAGE(J), J = NC, NC + ISIZE - 1 )
        ISIZE4 = ISIZE
        NC = LASTCH + 1
      ENDIF
C
C -- NORMAL DIRECTIVE. READ THE PARAMETER VALUE
2000  CONTINUE
      IF ( KFNDNP ( I ) .LE. 0 ) GO TO 1000
      ISTAT = KRDPV ( ISTORE(ICOMBF) , IDIMBF )
      IF ( ISTAT .LT. 0 ) GO TO 1000
      IF ( ISTAT .EQ. 0 ) GO TO 2000
      GO TO 9820
C
C
C
2500  CONTINUE
C -- INPUT COMPLETED
C
C -- CHECK FOR ERRORS DURING INPUT
C
      IF ( LEF .GT. 0 ) GO TO 9930
      IF ( IERFLG .LT. 0 ) GO TO 9900
C
C----- WRITE crystals INSTRUCTIONS TO THE SYSTEM REQUEST QUEUE
C----- FORMAT FOR INTERNAL READS
30    FORMAT( 10( A ) )
31    FORMAT ( A, A )
C----- SAVE THE EXISTING SRQ
      CALL XSSRQ (IADSRQ, NSRQ)
C
C----- LET THE DISK EXPAND WITHOUT LIMIT
      WRITE(CLINE, 31) CH(1), 'DISK'
      CALL XISRC (CLINE)
      WRITE(CLINE, 30) 'EXTEND SIZE = 0'
      CALL XISRC (CLINE)
      WRITE(CLINE, 30) 'END'
      CALL XISRC (CLINE)
C
C----- LIST 1
C
      WRITE (CLINE, 31) CH(1), 'LIST 1'
      CALL XISRC (CLINE)
      JJ = ICOMBF + 6
      JJJ = ICOMBF + 11
      WRITE (CLINE, 4600) 'REAL', (STORE(J), J = JJ, JJJ)
4600  FORMAT (A, 6F9.4)
      CALL XISRC (CLINE)
      CALL XISRC (CEND)
C
C----- LIST 13
      WAVE  = STORE(ICOMBF + 4)
      WRITE (CLINE, 31) CH(1), 'LIST 13'
      CALL XISRC (CLINE)
      WRITE (CLINE, 30) 'DIFFRACTION GEOM = NONE'
      CALL XISRC (CLINE)
      WRITE (CLINE, 4600) 'CONDITION WAVE = ', WAVE
      CALL XISRC (CLINE)
      CALL XISRC (CEND)
C
C----- LIST 28
      RATIO  = STORE(ICOMBF + 12)
      WRITE (CLINE, 30) CH(1), 'LIST 28'
      CALL XISRC (CLINE)
      WRITE (CLINE, 4600) 'MINIMA RATIO = ', RATIO
      CALL XISRC (CLINE)
      CALL XISRC (CEND)
C
C----- SPACEGROUP
      WRITE (CLINE, 31) CH(1), 'SPACEGROUP'
      CALL XISRC (CLINE)
      WRITE (CLINE, 31) 'SYMBOL ',  CBUFF1(1:ISIZE1)
      CALL XISRC (CLINE)
      CALL XISRC (CEND)
C
C----- OPEN REFLECTION FILE
      CHKLI = 'DATA'
      IF (CBUFF4(1:ISIZE4) .NE. 'COMMANDS' ) THEN
        CHKLI = 'HKLI'
        WRITE (CLINE, 30) CH(1), 'OPEN HKLI ',  CBUFF4(1:ISIZE4)
        CALL XISRC (CLINE)
      ENDIF
C
C----- LIST 6
C----- TYPE OF INPUT
      ILIST = ISTORE(ICOMBF + 5)
C
      IF (ILIST .LE. 2) THEN
        WRITE (CLINE, 30) CH(1), 'LIST 6'
      ELSE
        WRITE (CLINE, 30) CH(1), 'HKLI'
      ENDIF
      CALL XISRC (CLINE)
      WRITE (CLINE, 32) CHKLI, CFSQ(ILIST)
32    FORMAT
     1 ( 'READ TYPE =FIXED,  NCOEF =5, UNIT =', A,
     1 ' CHECK =NO F''S =', A)
      CALL XISRC (CLINE)
      WRITE (CLINE, 31)'FORMAT ',  CBUFF2(1:ISIZE2)
      CALL XISRC (CLINE)
      CALL XISRC (CEND)
      IF (ILIST .EQ. 3) THEN
C----- DO DATA REDUCTION
        WRITE (CLINE, 30) CH(1), 'LP'
        CALL XISRC (CLINE)
        CALL XISRC (CEND)
        WRITE (CLINE, 30) CH(1), 'SYST'
        CALL XISRC (CLINE)
        CALL XISRC (CEND)
        WRITE (CLINE, 30) CH(1), 'SORT'
        CALL XISRC (CLINE)
        CALL XISRC (CEND)
        WRITE (CLINE, 30) CH(1), 'MERGE'
        CALL XISRC (CLINE)
        CALL XISRC (CEND)
        WRITE (CLINE, 30) CH(1), 'LIST 6'
        CALL XISRC (CLINE)
        WRITE (CLINE, 30) 'READ TYPE =COPY'
        CALL XISRC (CLINE)
        CALL XISRC (CEND)
      ENDIF
C
C
C----- COMPOSITION
      WRITE (CLINE, 30) CH(1), 'COMPOSITION'
      CALL XISRC (CLINE)
      WRITE (CLINE, 31) 'CONTENT ',  CBUFF3(1:ISIZE3)
      CALL XISRC (CLINE)
      WRITE (CLINE, 31) 'SCATTER ', CSSSCT(1:LSSSCT)
      CALL XISRC (CLINE)
      WRITE (CLINE, 31) 'PROPERTIES ', CSSELE(1:LSSELE)
      CALL XISRC (CLINE)
      CALL XISRC (CEND)
C
C----- RESTORE SRQ
      CALL XRSRQ (IADSRQ, NSRQ)
C
C -- RESET STORE
      CALL XCSAE
      CALL XRSL
C
      CALL XOPMSG( IOPQCK, IOPEND, IVERSN)
      CALL XTIME2 ( 2 )
C
      RETURN
C
C
9800  CONTINUE
      LEF = LEF + 1
      GO TO 1000
9810  CONTINUE
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9815 )
      ENDIF
      WRITE ( NCAWU , 9815 )
9815  FORMAT ( 1X, 'Illegal data card. ' )
      GO TO 9800
9820  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9825 )
      ENDIF
      WRITE ( NCAWU ,9825 )
9825  FORMAT (' ERRORS during input')
      GOTO 9800
9830  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9835 )
      ENDIF
      WRITE ( NCAWU , 9835 )
9835  FORMAT ( ' ERRORS during internal read/writes')
      GOTO 9800
C
9900  CONTINUE
      CALL XOPMSG (IOPQCK, IOPABN, 0)
      IDIRFL = -1
      RETURN
9930  CONTINUE
      CALL XOPMSG (IOPQCK, IOPCMI, 0)
      GO TO 9900
C
      END
C
C
C
CODE FOR XFMULA
      SUBROUTINE XFMULA
C----- GENERATE LISTS 3 AND 29 IN SRQ FROM INSTRUCTION CONTAINING
C      CELL CONTENTS AND SOURCE FILE NAMES.
C
C
C      COMMAND INPUT - NOTE SPECIAL PROCESSING REQUIRED FOR
C      STRING TYPE PARAMETERS, TYPE 4.
C
C
C      FORMULA LIST      I= IADDF, JADDF, NADDF
C      SCATTERING LIST   I= IADDS, JADDS, NADDS (=40 = 2*20)
C
      DIMENSION IDEV(4)
      CHARACTER *80 CBUFF1, CBUFF2, CBUFF3, CLINE, CINPBF, COUTBF
      CHARACTER CFMRQ*6, CEND*3
C
C----- TO HOLD REAL FORMAT EXPRESSION
      CHARACTER *8 CFMTXP
      CHARACTER *4 CTMP, CARG, CARGU
C
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      DATA CFMRQ / '(20A4)' /, CEND /'END'/
C
C----- IDEV  = SCPDATA, (NCEXTR)
      DATA IDEV / 'S', 'C', 'P', 'D' /
      DATA IDIMBF / 3 /, NADDF / 2 /, NADDS /40/
C     NUMBER OF WAVWLENGTHS PRESENT IN PROPERTIES FILE
      DATA NPROPW /2/
      DATA IVERSN / 100 /
C
C
      CALL XTIME1 ( 2 )
      ICOMBF = KSTALL ( IDIMBF )
C
C -- COMMAND INPUT SECTION - DONE 'BY HAND'
C
C -- READ DIRECTIVE CARD
1000  CONTINUE
      IDIRNM = KRDNDC ( ISTORE(ICOMBF) , IDIMBF )
      IF ( IDIRNM .LT. 0 ) THEN
        GO TO 2500
      ELSE IF ( IDIRNM .EQ. 0 ) THEN
        CALL XMONTR ( 0 )
        GO TO 1000
      ENDIF
C
      IF ( IDIRNM .EQ. 1 .OR. IDIRNM .EQ. 2 .OR. IDIRNM .EQ. 3) THEN
C----- FORMULA, SCATTERING OR PROPERTIES CARD
C -- SEARCH FOR THE PARAMETER KEYWORD
        IF ( KFNDNP(I) .LE. 0 ) GO TO 9810
C----- FIND NEXT AND LAST NON- BLANK ITEMS
        NC = KNEQUL ( NC , IB )
        IF ( NC .LE. 0 ) GO TO 9810
        IF ( NC .GT. LASTCH ) GO TO 9810
        LC = LASTCH
        DO 1100 I = LASTCH, NC, -1
        IF (IMAGE(LC) .NE. IB) GOTO 1150
        LC = LC - 1
1100    CONTINUE
1150    CONTINUE
C----- CREATE AN EXACT FORMAT EXPRESSION FOR INMTERNAL WRITE
        ISIZE = MIN0 ( LC - NC + 1 , LEN ( CBUFF1 ) )
        WRITE (CFMTXP, '(2H( , I2, 3HA1))') ISIZE
      END IF
      IF (IDIRNM .EQ. 1) THEN
C----- CONTENTS CARD
        WRITE ( CBUFF1(1:ISIZE) , CFMTXP, ERR = 9830 )
     1      ( LCMAGE(J), J = NC, NC + ISIZE - 1 )
        ISIZE1 = ISIZE
        NC = LASTCH + 1
        GO TO 1000
C
      ELSE IF (IDIRNM .EQ. 2) THEN
C----- SCATTERING FACTOR FILE NAME
        WRITE ( CBUFF2(1:ISIZE) , CFMTXP, ERR = 9830 )
     1      ( LCMAGE(J), J = NC, NC + ISIZE - 1 )
        ISIZE2 = ISIZE
        NC = LASTCH + 1
C
      ELSE IF (IDIRNM .EQ. 3) THEN
C----- PROPERTIES FILE NAME
        WRITE ( CBUFF3(1:ISIZE) , CFMTXP, ERR = 9830 )
     1      ( LCMAGE(J), J = NC, NC + ISIZE - 1 )
        ISIZE3 = ISIZE
        NC = LASTCH + 1
      ENDIF
C
C -- NORMAL DIRECTIVE. READ THE PARAMETER VALUE
2000  CONTINUE
      IF ( KFNDNP ( I ) .LE. 0 ) GO TO 1000
      ISTAT = KRDPV ( ISTORE(ICOMBF) , IDIMBF )
      IF ( ISTAT .LT. 0 ) GO TO 1000
      IF ( ISTAT .EQ. 0 ) GO TO 2000
      GO TO 9820
C
C
C
2500  CONTINUE
C -- INPUT COMPLETED
C
C -- CHECK FOR ERRORS DURING INPUT
C
      IF ( LEF .GT. 0 ) GO TO 9930
      IF ( IERFLG .LT. 0 ) GO TO 9900
C
C----- IF THERE IS NO LIST 2, EXIT IN ERROR
      CALL XFAL02
      IF ( IERFLG .LT. 0 ) GO TO 9870
      T2INV = 1. / T2
C----- IF THERE IS NO LIST 13, EXIT IN ERROR
      CALL XFAL13
      IF ( IERFLG .LT. 0 ) GO TO 9870
      WAVE = STORE(L13DC)
C
C----- GET THE ELEMENTS AND CONTENTS FROM THE FORMULA CARD
C      A STORE THEM IN ISTORE(JADDF), STORE(JADDF+1) FOR EACH ELEMENT
C      IF A NUMBER ISNT GIVEN, 1 ASSUMED.
      NELEM = 0
      JADDF  = NFL
      IADDF = JADDF
C----- RESET TO +1 AT END OF CARD
      IEND = -1
C----- TYPE EXPECTED FOR NEXT ARGUMENT (+1 = NUMBER, -1 = CHARACTER)
      IARG = -1
      ISTART = 1
C----- CHECK IF THERE IS ANY DATA ON CARD
      IF (ISTART .GT. ISIZE1) GOTO 9860
C
C----- LOOP BACK HERE FOR NEXT ARGUMENT
5000  CONTINUE
      IF(KCCARG (CBUFF1(1:ISIZE1), ISTART,1, IPOS1, IPOS2) .LE. 0)THEN
        IEND = +1
        IPOS2 = ISIZE1
      END IF
C----- TRY TO PROCESS AS NUMBER
      IF (KCCNUM(CBUFF1(IPOS1:IPOS2), IRESLT, ITYPE) .LE. 0) THEN
C----- NOT A NUMBER
        JARG = -1
      ELSE
C      A NUMBER
        IF (ITYPE .EQ. 1) THEN
            VALUE = FLOAT(IRESLT)
        ELSE
            CALL XMOVE( IRESLT, VALUE, 1)
        END IF
        JARG = +1
      END IF
C
C
      IF ((IARG .EQ. -1) .AND. (JARG .EQ. -1)) THEN
C      STORE CHARACTER
        WRITE(CTMP, 20) CBUFF1(IPOS1:IPOS2)
        READ(CTMP, 20) ISTORE(JADDF)
        NELEM = NELEM + 1
C       EXPECT A NUMBER NEXT TIME
        IARG = +1
      ELSE IF ((IARG .EQ. +1) .AND. (JARG .EQ. +1)) THEN
C       STORE THE NUMBER
        STORE(JADDF+1) = VALUE
        IARG = -1
        JADDF = JADDF + NADDF
      ELSE IF ((IARG .EQ. +1) .AND. (JARG .EQ. -1)) THEN
C       FOUND CHARACTER, EXPECTED NUMBER
        STORE(JADDF+1) = 1.
        JADDF = JADDF + NADDF
C      STORE CHARACTER
        WRITE(CTMP, 20) CBUFF1(IPOS1:IPOS2)
        READ(CTMP, 20) ISTORE(JADDF)
        NELEM = NELEM + 1
C       EXPECT A NUMBER NEXT TIME
        IARG = +1
      ELSE
C----- ERROR
      GOTO 9850
      END IF
      IF (IEND .NE. 1)  GOTO 5000
C     CARD FINISHED - TIDY UP
      IF (IARG .EQ. +1) THEN
        STORE(JADDF + 1) = 1.
      ELSE
        JADDF = JADDF - NADDF
      END IF
C-----  SAVE THE LIST AND SET START OF SCATTERING FACTOR LIST.
C       THIS IS SAVED IN STORE BEFORE BEING WRITTEN TO THE SRQ INCASE
C       SOME FACTORS CANNOT BE FOUND
      I = KSTALL (JADDF - IADDF + NADDF)
      IADDS = NFL
      JADDS = IADDS
C
C
C----- OPEN THE SCATTERING FACTOR FILE
      ISIZE = ISIZE2
      CLINE(1:ISIZE) = CBUFF2(1:ISIZE)
      CALL XRDOPN (5, IDEV, CLINE(1:ISIZE), ISIZE)
      IF ( IERFLG .LT. 0) GOTO 9840
C----- READ HEADER FROM SCATTERING FACTOR FILE
C     READ WHOLE FILE
      REWIND NCEXTR
C----- SKIP COMMENT LINES
5300  CONTINUE
      IF (KRDLIN(NCEXTR, CINPBF, LENGTH)) 9720, 9710, 5301
5301  CONTINUE
      IF ((CINPBF(1:2).EQ.CHAR(92)//' ').OR.(CINPBF(1:2).EQ.'# '))
     1 GOTO 5300
C----- READ NUMBER OF WAVELENGTH TYPES
5302  CONTINUE
      ISTART = 1
      IF(KCRVAL(CINPBF, LENGTH, ISTART, IPOS1,IPOS2,VALUE) .LE .0)
     1   GOTO 9720
      IVALUE = NINT(VALUE)
C----- NUMBER OF LINES PER ELEMENT
      NLINES = 1 + IVALUE
C----- READ WAVELENGTHS
      IF (KRDLIN(NCEXTR, CINPBF, LENGTH)) 9720, 9710, 5303
5303  CONTINUE
      LAM = 0
      ISTART = 1
      DO 5350 I = 1, IVALUE
      IF(KCRVAL(CINPBF, LENGTH, ISTART, IPOS1, IPOS2, VALUE) .LE .0)
     1   GOTO 9720
C-----  SPOT THE WAVELENGTH
        IF (ABS(VALUE-WAVE) .LE. .01 ) LAM = I
5350  CONTINUE
      IF (LAM .EQ. 0) GOTO 9700
C----- BEGIN PROCESSING FORMULA LIST
      DO 5500 J = IADDF, JADDF, NADDF
C----- CONVERT BACK TO CHARACTER
      WRITE(CTMP, 20) ISTORE(J)
      READ(CTMP, 20) CARG
      LSTART = KCCNEQ( CARG, 1, ' ')
      IF (LSTART .EQ. -1) GOTO 9730
      LSTART = MAX0( 1, LSTART)
C     LEFT ADJUST STRING
      CTMP = CARG(LSTART:4)
      CARG = CTMP
      LENSER = 4
      CALL XCCUPC( CARG, CARGU)
C     READ WHOLE FILE FOR EACH ELEMENT
      REWIND NCEXTR
5400  CONTINUE
      IF (KRDLIN(NCEXTR, CINPBF, LENGTH)) 9720, 9710, 5401
5401  CONTINUE
C----- CHECK FIRST FOUR CHARACERS ONLY - REMEMBER CINPBF IS MIXED CASE
      IF ( (CINPBF(1:LENSER) .NE. CARG(1:LENSER)) .AND.
     1 (CINPBF(1:LENSER) .NE. CARGU(1:LENSER)) ) THEN
C----- NO MATCH SKIP REQUIRED NUMBER OF LINES
        DO 5420 I = 2,NLINES
        IF (KRDLIN(NCEXTR, CINPBF, LENGTH)) 9720, 9710, 5402
5402    CONTINUE
5420    CONTINUE
C----- GO BACK FOR NEXT DATA RECORD
        GOTO 5400
      ENDIF
C----- MATCH
      IF (LAM .NE. 1) THEN
C----- SKIP UNTIL REQUIRED LINE
        DO 5430 I = 2,LAM
        IF (KRDLIN(NCEXTR, CINPBF, LENGTH)) 9720, 9710, 5421
5421    CONTINUE
5430    CONTINUE
      END IF
C----- CONVERT WHOLE LINE TO UPPER CASE
      COUTBF = ' '
      CALL XCCUPC (CINPBF, COUTBF)
C----- SAVE ELEMENT NAME LINE
      READ (COUTBF, 20) (ISTORE(JADDS+II), II=0,19)
      JADDS = JADDS + 20
      IF (LAM .LE. NLINES-2) THEN
C----- SKIP REMAINING LINES
        DO 5440 I = LAM, NLINES-2
        IF (KRDLIN(NCEXTR, CINPBF, LENGTH)) 9720, 9710, 5431
5431    CONTINUE
5440    CONTINUE
      END IF
C----- NOW GET THE COMMON PART OF THE DATA
      IF (KRDLIN(NCEXTR, CINPBF, LENGTH)) 9720, 9710, 5441
5441  CONTINUE
C----- CONVERT WHOLE LINE TO UPPER CASE
      COUTBF = ' '
      CALL XCCUPC (CINPBF, COUTBF)
      READ(COUTBF,20) (ISTORE(JADDS+II), II= 0,19)
      II = KSTALL(NADDS)
      JADDS  = JADDS + 20
C----- GO BACK FOR NEXT ELEMENT
5500  CONTINUE
C
C----- ALL FINISHED - RESET JADDS TO START OF LAST ITEM
      JADDS = JADDS - NADDS
C
C----- WRITE crystals INSTRUCTIONS TO THE SYSTEM REQUEST QUEUE
C----- FORMATS FOR INTERNAL READS
10    FORMAT ( 80A1 )
20    FORMAT ( 20A4 )
30    FORMAT ( A )
31    FORMAT ( A, A )
C----- SAVE THE EXISTING SRQ
      CALL XSSRQ (IADSRQ, NSRQ)
C
C----- LIST 3
C
      WRITE (CLINE, 30) '#LIST 3'
      CALL XISRC (CLINE)
      WRITE(CLINE, 5601) 'READ NSCAT = ', NELEM
5601  FORMAT(A, I8)
      CALL XISRC (CLINE)
      DO 5600 I = IADDS, JADDS, NADDS
      WRITE (CLINE, 20) 'SCAT','    ', (ISTORE(I+J), J = 0, 17)
      CALL XISRC (CLINE)
      WRITE (CLINE, 20)  (ISTORE(I+J), J = 20, 39)
      CALL XISRC (CLINE)
5600  CONTINUE
      CALL XISRC (CEND)
C
C     RESET START OF WORK AREA
      JADDS = IADDS
C----- OPEN THE ELEMENTAL PROPERTIES FILE
      ISIZE = ISIZE3
      CLINE(1:ISIZE) = CBUFF3(1:ISIZE)
      CALL XRDOPN (5, IDEV, CLINE(1:ISIZE), ISIZE)
      IF ( IERFLG .LT. 0) GOTO 9840
C     READ WHOLE FILE
      REWIND NCEXTR
C----- SKIP COMMENT LINES
6000  CONTINUE
      IF (KRDLIN(NCEXTR, CINPBF, LENGTH)) 9720, 9710, 6050
6050  CONTINUE
      IF ((CINPBF(1:2).EQ.CHAR(92)//' ').OR.(CINPBF(1:2).EQ.'# '))
     1 GOTO 6000
C----- NUMBER OF LINES PER ELEMENT
      NLINES = 1 + NPROPW
C----- CURRENTLY ONLY TWO WAVELENGTS ARE KNOWN
      IF (ABS (WAVE-1.5418) .LE. .01) THEN
        LAM = 1
      ELSE
        LAM = 2
      END IF
C----- BEGIN PROCESSING FORMULA LIST
      DO 6500 J = IADDF, JADDF, NADDF
C----- CONVERT BACK TO CHARACTER
      WRITE(CTMP, 20) ISTORE(J)
      READ(CTMP, 20) CARG
      LSTART = KCCNEQ( CARG, 1, ' ')
      IF (LSTART .EQ. -1) GOTO 9730
      LSTART = MAX0( 1, LSTART)
C     LEFT ADJUST STRING
      CTMP = CARG(LSTART:4)
      CARG = CTMP
      LENSER = 4
      CALL XCCUPC( CARG, CARGU)
C     READ WHOLE FILE FOR EACH ELEMENT
      REWIND NCEXTR
6400  CONTINUE
C----- GET THE COMMON PART OF THE DATA - CONTAINS ELEMENT NAME
      IF (KRDLIN(NCEXTR, CINPBF, LENGTH)) 9720, 9710, 6401
6401  CONTINUE
C----- CHECK FIRST FOUR CHARACERS ONLY - REMEMBER CINPBF IS MIXED CASE
      IF ( (CINPBF(1:LENSER) .NE. CARG(1:LENSER)) .AND.
     1 (CINPBF(1:LENSER) .NE. CARGU(1:LENSER)) ) THEN
C----- NO MATCH SKIP REQUIRED NUMBER OF LINES
        DO 6420 I = 2,NLINES
        IF (KRDLIN(NCEXTR, CINPBF, LENGTH)) 9720, 9710, 6402
6402    CONTINUE
6420    CONTINUE
C----- GO BACK FOR NEXT DATA RECORD
        GOTO 6400
      ENDIF
C----- MATCH
C----- CONVERT WHOLE LINE TO UPPER CASE
      COUTBF = ' '
      CALL XCCUPC (CINPBF, COUTBF)
      READ(COUTBF,20) (ISTORE(JADDS+II), II= 0,19)
      JADDS  = JADDS + 20
C----- LOOK FOR SECOND PART
      IF (LAM .NE. 1) THEN
C----- SKIP UNTIL REQUIRED LINE
        DO 6430 I = 1,LAM-1
        IF (KRDLIN(NCEXTR, CINPBF, LENGTH)) 9720, 9710, 6431
6431    CONTINUE
6430    CONTINUE
      END IF
      IF (KRDLIN(NCEXTR, CINPBF, LENGTH)) 9720, 9710, 6435
C----- CONVERT WHOLE LINE TO UPPER CASE
6435  CONTINUE
      COUTBF = ' '
      CALL XCCUPC (CINPBF, COUTBF)
C----- SAVE ELEMENT NAME LINE
      READ (COUTBF, 20) (ISTORE(JADDS+II), II=0,19)
      JADDS = JADDS + 20
      IF (LAM .LE. NLINES-2) THEN
C----- SKIP REMAINING LINES
        DO 6440 I = LAM, NLINES-2
        IF (KRDLIN(NCEXTR, CINPBF, LENGTH)) 9720, 9710, 6439
6439    CONTINUE
6440    CONTINUE
      END IF
      II = KSTALL(NADDS)
C----- GO BACK FOR NEXT ELEMENT
6500  CONTINUE
C
C----- ALL FINISHED - RESET JADDS TO START OF LAST ITEM
      JADDS = JADDS - NADDS
      JADDF = IADDF
C
C----- WRITE CRYSTALS INSTRUCTIONS TO THE SYSTEM REQUEST QUEUE
C
C----- LIST 29
C
      WRITE (CLINE, 30) '#LIST 29'
      CALL XISRC (CLINE)
      WRITE(CLINE, 5601) 'READ NELEM = ', NELEM
      CALL XISRC (CLINE)
      DO 6600 I = IADDS, JADDS, NADDS
      WRITE (CLINE, 20) 'ELEM','    ', (ISTORE(I+J), J = 0, 17)
      CALL XISRC (CLINE)
      WRITE (CLINE, 20)  (ISTORE(I+J), J = 20, 39)
      CALL XISRC (CLINE)
      WRITE(CLINE, 6601) 'CONT NUM = ', (T2INV * STORE(JADDF+1))
6601  FORMAT(A, F15.6)
      JADDF = JADDF + NADDF
      CALL XISRC (CLINE)
6600  CONTINUE
      CALL XISRC (CEND)
C
C----- RESTORE SRQ
      CALL XRSRQ (IADSRQ, NSRQ)
C
C -- RESET STORE
      CALL XCSAE
      CALL XRSL
C
      CALL XOPMSG( IOPCMP, IOPEND, IVERSN)
      CALL XTIME2 ( 2 )
C
      RETURN
C
C
9700  CONTINUE
      WRITE(NCAWU,9701)
9701  FORMAT(' System files contain no entries for reqiured wavelength')
      GOTO 9900
9710  CONTINUE
      CALL XERIOM (NCEXTR, IABS(I))
      WRITE(NCAWU,9711) CLINE(1:ISIZE)
9711  FORMAT (' End of file ', A, ' - item not found')
      GOTO 9900
9720  CONTINUE
      CALL XERIOM (NCEXTR, IABS(I))
      WRITE(NCAWU,9721) CLINE(1:ISIZE)
9721  FORMAT (' Error in file ', A, ' - item not found')
      GOTO 9900
9730  CONTINUE
      WRITE(NCAWU,9731)
9731  FORMAT( ' Zero length element name')
9800  CONTINUE
      LEF = LEF + 1
      GO TO 1000
9810  CONTINUE
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9815 )
      ENDIF
      WRITE ( NCAWU , 9815 )
9815  FORMAT ( 1X, 'Illegal data card. ' )
      GO TO 9800
9820  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9825 )
      ENDIF
      WRITE ( NCAWU ,9825 )
9825  FORMAT (' ERRORS during input')
      GOTO 9800
9830  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9835 )
      ENDIF
      WRITE ( NCAWU , 9835 )
9835  FORMAT ( ' ERRORS during internal read/writes')
      GOTO 9800
9840  CONTINUE
      CALL XERIOM (NCEXTR, IABS(I))
      WRITE(NCAWU,9841)  NCEXTR, CLINE(1:ISIZE)
9841  FORMAT( ' FILE open error, UNIT ', I6, ' ', A)
      GOTO 9900
9850  CONTINUE
      WRITE(NCAWU,9851)
9851  FORMAT ( ' ERROR in formula card')
      GOTO 9900
9860  CONTINUE
      WRITE(NCAWU,9861)
9861  FORMAT ( ' No data on formula card')
9870  CONTINUE
      WRITE (NCAWU,9871)
9871  FORMAT ( ' List 2 or 13 not available')
      GOTO 9900
C
9900  CONTINUE
      CALL XOPMSG (IOPCMP, IOPABN, 0)
      IDIRFL = -1
      RETURN
9930  CONTINUE
      CALL XOPMSG (IOPCMP, IOPCMI, 0)
      GO TO 9900
      END

CRYSTALS CODE FOR MATRIX
CODE FOR XMLTMM
      SUBROUTINE XMLTMM(A,B,C,L,M,N)
C--MATRIX MULTIPLICATION OF 'A' BY 'B' TO GIVE 'C'.
C
C--THE PARAMETERS CAN BEST BE DESCRIBED BY THE MATRIX OPERATION :
C
C  A(L,M).B(M,N)=C(L,N)
C
C--
C
      DIMENSION A(L,M),B(M,N),C(L,N)
C
C--LOOP OVER ROWS OF THE OUTPUT MATRIX
      DO 1000 K=1,N
C--LOOP OVER COLUMNS OF THE OUTPUT MATRIX
      DO 1000 I=1,L
      C(I,K)=0.
C--LOOP OVER THE CONTRIBUTIONS OF THIS ELEMENT
      DO 1000 J=1,M
1000  C(I,K)=C(I,K)+A(I,J)*B(J,K)
      RETURN
      END
C
CODE FOR XMLTMT
      SUBROUTINE XMLTMT(A,B,C,L,M,N)
C--MATRIX MULTIPLICATION OF 'A' BY 'B' TRANSPOSED TO GIVE 'C'.
C
C--THE PARAMETERS CAN BEST BE DESCRIBED BY THE MATRIX OPERATION :
C
C  A(L,M).B(N,M)'=C(L,N)
C
C
C--
C
      DIMENSION A(L,M),B(N,M),C(L,N)
C
C--LOOP OVER ROWS OF THE OUTPUT MATRIX
      DO 1000 K=1,N
C--LOOP OVER COLUMNS OF THE OUTPUT MATRIX
      DO 1000 I=1,L
      C(I,K)=0.
C--LOOP OVER THE CONTRIBUTIONS OF THIS ELEMENT
      DO 1000 J=1,M
1000  C(I,K)=C(I,K)+A(I,J)*B(K,J)
      RETURN
      END
C
CODE FOR XMLTTM
      SUBROUTINE XMLTTM(A,B,C,L,M,N)
C--MATRIX MULTIPLICATION OF 'A' TRANSPOSED BY 'B' TO GIVE 'C'.
C
C--THE PARAMETERS CAN BEST BE DESCRIBED BY THE MATRIX OPERATION :
C
C  A(M,L)'.B(M,N)=C(L,N)
C
C--
C
      DIMENSION A(M,L),B(M,N),C(L,N)
C
C--LOOP OVER ROWS OF THE OUTPUT MATRIX
      DO 1000 K=1,N
C--LOOP OVER COLUMNS OF THE OUTPUT MATRIX
      DO 1000 I=1,L
      C(I,K)=0.
C--LOOP OVER THE CONTRIBUTIONS OF THIS ELEMENT
      DO 1000 J=1,M
1000  C(I,K)=C(I,K)+A(J,I)*B(J,K)
      RETURN
      END
C
CODE FOR XMLTTT
      SUBROUTINE XMLTTT(A,B,C,L,M,N)
C--MATRIX MULTIPLICATION OF 'A' TRANSPOSED BY 'B' TRANSPOSED TO GIVE 'C'
C
C--THE PARAMETERS CAN BEST BE DESCRIBED BY THE MATRIX OPERATION :
C
C  A(M,L)'.B(N,M)'=C(L,N)
C
C--
C
      DIMENSION A(M,L),B(N,M),C(L,N)
C
C--LOOP OVER ROWS OF THE OUTPUT MATRIX
      DO 1000 K=1,N
C--LOOP OVER COLUMNS OF THE OUTPUT MATRIX
      DO 1000 I=1,L
      C(I,K)=0.
C--LOOP OVER THE CONTRIBUTIONS OF THIS ELEMENT
      DO 1000 J=1,M
1000  C(I,K)=C(I,K)+A(J,I)*B(K,J)
      RETURN
      END
C
CODE FOR XTRANS
      SUBROUTINE XTRANS(A,C,L,N)
C--MATRIC TRANSPOSITION ROUTINE
C
C--IN MATRIX NOTATION, THIS MAY BE REPRESENTED AS :
C
C  C(N,L)=A(L,N)'
C
C--
C
      DIMENSION A(L,N),C(N,L)
C
      DO 1000 I=1,L
      DO 1000 J=1,N
1000  C(J,I)=A(I,J)
      RETURN
      END
C
CODE FOR MTRANS
      SUBROUTINE MTRANS(A)
C IN-PLACE TRANSPOSITION OF 3X3 MATRIX
C
      DIMENSION A(3,3)
      T = A(2,1)
      A(2,1) = A(1,2)
      A(1,2) = T
C
      T = A(2,3)
      A(2,3) = A(3,2)
      A(3,2) = T
C
      T = A(3,1)
      A(3,1) = A(1,3)
      A(1,3) = T
      END
CODE FOR XNEGTR
      SUBROUTINE XNEGTR(A,B,N)
C--NEGATE THE 'N' ELEMENTS OF 'A' TO 'B'.
C
C  A  INPUT VECTOR.
C  B  OUTPUT VECTOR.
C  N  THE NUMBER OF ELEMENTS IN 'A' AND 'B'.
C
C--
C
      DIMENSION A(N),B(N)
C
C
      DATA I/0/
C
C--CHECK FOR SOME ELEMENTS
      IF(N)1100,1100,1000
1000  CONTINUE
      DO 1050 I=1,N
      B(I)=-A(I)
1050  CONTINUE
C--AND NOW RETURN
1100  CONTINUE
      RETURN
      END
C
CODE FOR XADDR
      SUBROUTINE XADDR(A,B,C,N)
C--ADD THE 'N' ELEMENTS OF 'A' TO 'B' AND STORE THE RESULTS IN 'C'
C
C  A  FIRST INPUT VECTOR.
C  B  SECOND INPUT VECTOR.
C  C  THE RESULTS VECTOR.
C  N  THE ORDER OF 'A', 'B' AND 'C'.
C
C--
C
      DIMENSION A(N),B(N),C(N)
C
C
      DATA I/0/
C
C--CHECK FOR SOME ELEMNTS
      IF(N)1100,1100,1000
1000  CONTINUE
      DO 1050 I=1,N
      C(I)=A(I)+B(I)
1050  CONTINUE
C--AND NOW RETURN
1100  CONTINUE
      RETURN
      END
C
CODE FOR XSUBTR
      SUBROUTINE XSUBTR(A,B,C,N)
C--SUBTRACT THE 'N' ELEMENTS OF 'B' FROM 'A' AND STORE THE RESULTS IN 'C
C
C  A  FIRST INPUT VECTOR.
C  B  SECOND INPUT VECTOR.
C  C  THE RESULTS VECTOR.
C  N  THE ORDER OF 'A', 'B' AND 'C'.
C
C--
C
      DIMENSION A(N),B(N),C(N)
C
C
      DATA I/0/
C
C--CHECK FOR SOME ELEMNTS
      IF(N)1100,1100,1000
1000  CONTINUE
      DO 1050 I=1,N
      C(I)=A(I)-B(I)
1050  CONTINUE
C--AND NOW RETURN
1100  CONTINUE
      RETURN
      END
C
CODE FOR XMULTR
      SUBROUTINE XMULTR(A,B,C,N)
C--MULTIPLY THE 'N' ELEMENTS OF 'A' BY THE SCALAR 'B'
C  AND STORE THE RESULTS IN 'C'.
C
C  A  THE INPUT VECTOR.
C  B  THE SCALAR MULTIPLIER.
C  C  THE OUTPUT VECTOR.
C  N  THE NUMBER OF ELEMENTS IN 'A' AND 'C'.
C
C--
C
      DIMENSION A(N),C(N)
C
C
      DATA I/0/
C
C--CHECK FOR SOME ELEMENTS
      IF(N)1100,1100,1000
1000  CONTINUE
      DO 1050 I=1,N
      C(I)=A(I)*B
1050  CONTINUE
1100  CONTINUE
      RETURN
      END
C
CODE FOR XDVDR
      SUBROUTINE XDVDR(A,B,C,N)
C--DIVIDE THE 'N' ELEMENTS OF 'A' BY THE SCALAR 'B'
C  AND STORE THE RESULTS IN 'C'.
C
C  A  THE INPUT VECTOR.
C  B  THE SCALAR MULTIPLIER.
C  C  THE OUTPUT VECTOR.
C  N  THE NUMBER OF ELEMENTS IN 'A' AND 'C'.
C
C--
C
      DIMENSION A(N),C(N)
C
C
      DATA I/0/
C
C--CHECK FOR SOME ELEMENTS
      IF(N)1100,1100,1000
1000  CONTINUE
      DO 1050 I=1,N
      C(I)=A(I)/B
1050  CONTINUE
1100  CONTINUE
      RETURN
      END
C
CODE FOR XDETR3
      FUNCTION XDETR3(AMAT)
C--COMPUTE THE DETERMINANT OF THE 3 BY 3 MATRIX 'AMAT'.
C
C  AMAT  THE MATRIX.
C
C--THE RETURN VALUE IS THE VALUE OF THE DETERMINANT.
C
C--
C
      DIMENSION AMAT(9)
C
      XDETR3=(AMAT(5)*AMAT(9)-AMAT(8)*AMAT(6))*AMAT(1)-(AMAT(2)*AMAT(9)
     2 -AMAT(8)*AMAT(3))*AMAT(4)+(AMAT(2)*AMAT(6)-AMAT(5)*AMAT(3))
     3 *AMAT(7)
      RETURN
      END
C
C
CODE FOR XMTCEX
      SUBROUTINE XMTCEX (A,B,K,L)
C----- EXCHANGE ORDER OF COLUMNS OF MATRIX A(K,L)
      DIMENSION  A(K,L), B(K,L)
      N = L + 1
      DO 200 J = 1, L
      DO 100 I = 1, K
      B(I,J) = A(I,N-J)
100   CONTINUE
200   CONTINUE
      RETURN
      END
C
CODE FOR XMTREX
      SUBROUTINE XMTREX (A,B,K,L)
C----- EXCHANGE ORDER OF ROWS OF MATRIX A(K,L)
      DIMENSION  A(K,L), B(K,L)
      N = K + 1
      DO 200 I = 1, L
      DO 100 J = 1, K
      B(J,I) = A(N-J,I)
100   CONTINUE
200   CONTINUE
      RETURN
      END
C
CODE FOR MATINV
      SUBROUTINE MATINV(A,B,D)
C
C
      DIMENSION A(3,3),B(3,3)
      CALL VMULT(A(1,2),A(1,3),B(1,1))
      CALL VMULT(A(1,3),A(1,1),B(1,2))
      CALL VMULT(A(1,1),A(1,2),B(1,3))
      D=A(1,1)*B(1,1)+A(2,1)*B(2,1)+A(3,1)*B(3,1)
      IF(D.EQ.0.0)RETURN
      N=1
1000  K=1
1100  B(K,N)=B(K,N)/D
      K=K+1
      IF(K.LE.3)GOTO 1100
      N=N+1
      IF(N.LE.3)GOTO 1000
      CALL MTRANS(B)
      RETURN
      END
CODE FOR XUNTM3
      SUBROUTINE XUNTM3(AMAT)
C--SET UP A UNIT MATRIX IN 'AMAT'
C
C  AMAT  THE MATRIX TO BE SET UP AS A UNIT MATRIX.
C
C--
C
      DIMENSION AMAT(9)
C
C--ZERO THE MATRIX
      CALL XZEROF(AMAT(1),9)
      AMAT(1)=1.
      AMAT(5)=1.
      AMAT(9)=1.
      RETURN
      END
C
CODE FOR NROT
      FUNCTION NROT(AL,T,AMAT)
C--COMPUTE THE ROTATION MATRIX RESULTING FROM A ROTATION OF 'T' DEGREES
C  ABOUT THE AXIS WITH DIRECTION COSINES GIVEN BY 'AL'.
C
C  AL    THE DIRECTION COSINES OF THE LINE ABOUT WHICH THE ROTATION IS
C        TO BE PERFORMED. THIS SET OF COSINES MUST BE WITH RESPECT TO AN
C        ORTHOGONAL SYSTEM OF AXES.
C  T     THE ANGLE OF ROTATION IN DEGREES.
C  AMAT  THE RESULTANT ROTATION MATRIX. THE MATRIX IS STORED BY COLUMNS.
C
C--RETURN VALUES OF 'NROT' ARE :
C
C  -1  THE VECTOR IN 'AL' HAS ZERO LENGTH.
C  >0  MATRIX COMPUTED CORRECTLY.
C
C--
C
      DIMENSION AL(3),AMAT(9)
C
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
C
      DATA E/0.0/,S/0.0/,C/0.0/,D/0.0/
C
C--NORMALISE THE INPUT VECTOR
      CALL XZEROF(AMAT(1),9)
      NROT=-1
      IF(NORM3(AL))1050,1050,1000
C--CONVERT THE ANGLE TO DEGREES
1000  CONTINUE
      NROT=1
      E=T*PI/180.0
      S=SIN(E)
      C=COS(E)
      D=1.-C
C--COMPUTE THE REQUIRED ELEMENTS
      AMAT(1)=C+AL(1)*AL(1)*D
      AMAT(2)=AL(1)*AL(2)*D+AL(3)*S
      AMAT(3)=AL(3)*AL(1)*D-AL(2)*S
      AMAT(4)=AL(1)*AL(2)*D-AL(3)*S
      AMAT(5)=C+AL(2)*AL(2)*D
      AMAT(6)=AL(2)*AL(3)*D+AL(1)*S
      AMAT(7)=AL(3)*AL(1)*D+AL(2)*S
      AMAT(8)=AL(2)*AL(3)*D-AL(1)*S
      AMAT(9)=C+AL(3)*AL(3)*D
1050  CONTINUE
      RETURN
      END
C
CODE FOR NCROP3
      FUNCTION NCROP3(A,B,C)
C--COMPUTES THE CROSS PRODUCT OF THE VECTORS A AND B AND STORES THE
C  RESULT IN C.
C
C  A  THE FIRST VECTOR.
C  B  THE SECOND VECTOR.
C  C  THE CROSS PRODUCT OF A WITH B. (C = A CROSS B).
C
C--THE RETURN VALUES OF 'NCROP' ARE :
C
C  -1  THE INPUT VECTORS ARE PARALLEL  RESULTANT VECTOR HAS ZERO LENGTH.
C  >0  THE RESULTANT VECTOR IS NOT ZERO.
C
C--THE OUTPUT VECTOR IN 'C' IS NORMALISED BEFORE RETURN.
C
C--
C
      DIMENSION A(3),B(3),C(3)
C
      NCROP3=1
      CALL VMULT(A,B,C)
      IF(NORM3(C))1000,1000,1050
C--ZERO LENGTH VECTOR
1000  CONTINUE
      NCROP3=-1
1050  CONTINUE
      RETURN
      END
C
CODE FOR VMULT
      SUBROUTINE VMULT(A,B,C)
C----- FORM THE UN-NORMALISED VECTOR PRODUCT
      DIMENSION A(3),B(3),C(3)
      C(1)=A(2)*B(3)-A(3)*B(2)
      C(2)=A(3)*B(1)-A(1)*B(3)
      C(3)=A(1)*B(2)-A(2)*B(1)
      RETURN
      END
CODE FOR VPROD
      SUBROUTINE VPROD(A,B,C)
C----- FORM THE SCALAR PRODUCT.
      DIMENSION A(3),B(3)
      C=A(1)*B(1)+A(2)*B(2)+A(3)*B(3)
      RETURN
      END
CODE FOR NORM3
      FUNCTION NORM3(X)
C--NORMALISE THE VECTOR 'X' SO THAT THE SUM OF THE SQUARES
C  OF ITS THREE ELEMENTS IS UNITY.
C
C  X  THE VECTOR, CONTAINING THREE ELEMENTS.
C
C--THE RETURN VALUES OF 'NORM' ARE :
C
C  -1  THE VECTOR HAS ZERO LENGTH  (<0.0001).
C  >0  ALL OKAY.
C
C--
C
      DIMENSION X(3)
C
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
C
      DATA D/0.0/
C
C--SUM THE SQUARES
      D=X(1)*X(1)+X(2)*X(2)+X(3)*X(3)
C--CHECK THAT THE VECTOR IS NOT OF ZERO LENGTH
      NORM3=-1
      IF(D-ZEROSQ)1050,1050,1000
C--NORMALISE THE COMPONENTS
1000  CONTINUE
      D=1./SQRT(D)
      X(1)=X(1)*D
      X(2)=X(2)*D
      X(3)=X(3)*D
      NORM3=1
C--AND NOW RETURN
1050  CONTINUE
      RETURN
      END
C
CODE FOR KINV2
      FUNCTION KINV2(N,A,B,NA,NM,C,D,NC)
C--MATRIX INVERSION AND SOLUTION OF SIMULTANEOUS LINEAR EQUATIONS
C
C  N       ORDER OF THE MATICES TO BE INVERTED.
C  A       MATRIX TO BE INVERTED  I.E. A(N,N)
C  B       INVERSE MATRIX  -  CALCULATED BY THIS SUBROUTINE  -  B(N,N)
C  NA      THE ORDER OF 'A' AND 'B'  -  GREATER THAN OR EQUAL
C          TO 'N*N'.
C  NM      NUMBER OF COLUMN VECTORS TO BE MULTIPLIED ONTO THE INVERSE
C          MATRIX
C  C       COLUMN VECTORS TO BE MULTIPLIED ONTO THE INVERSE MATRIX C(N,M
C  D       RESULTS OF MULTIPLICATION ON TO THE INVERSE MATRIX  -  D(N,M)
C  NC      THE ORDER OF 'C' AND 'D'  -  GREATER THAN OR EQUAL
C          TO THE MAXIMUM OF 'N' AND 'N*NM'. THIS MEANS THAT A COLUMN
C          VECTOR AT LEAST MUST BE PROVIDED FOR BOTH.
C
C--IN MATRIX NOTATION
C
C  D=B.C
C  C=A.D
C
C--RETURN VALUES OF 'KINV2' ARE :
C
C   0  INVERSION ETC. WENT OKAY.
C  >0  SINGULAR  -  RETURN VALUE INDICATES FIRST SIGNULAR ELEMENT FOUND.
C
C--
      DOUBLE PRECISION  X02ABF,DUMMY
C
      DIMENSION A(NA),B(NA),C(NC),D(NC)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      DATA ASING/0.0/,BSING/0.0/,CSING/0.0/,E/0.0/,F/0.0/
      DATA M1/0/,M2/0/,M3/0/,M4/0/,M5/0/,M6/0/,M7/0/,M8/0/
      DATA I/0/,J/0/,K/0/,L/0/,M/0/
C
      KINV2=0
C--SET 'EPS', SUCH THAT 'EPS' IS THE SMALLEST NUMBER FOR 1.0+EPS>1.0
      BSING=16.0**(-5)
C--SET THE SMALLEST NUMBER THAT CAN BE EXACTLY REPRESENTED ON THE MACHIN
      CSING=SNGL(X02ABF(DUMMY))
C--SET THE SINGULARITY CHECK LIMITS
      CSING=CSING/BSING
      BSING=BSING*16.
C--SET ROW INTERCHANGE FLAGS
      DO 1000 I=1,N
      D(I)=FLOAT(I)
1000  CONTINUE
C--COMMENCE DECOMPOSITION A=L.U  -  BY ROWS WITH INTERCHANGES
      M5=1
      M6=1
      M1=M5
      M2=M6
      DO 1100 I=1,N
      DO 1050 J=1,N
      B(M2)=A(M1)
      M1=M1+1
      M2=M2+1
1050  CONTINUE
1100  CONTINUE
      M8=1
      DO 1900 J=1,N
      M2=M6
      M7=M8
      F=-1.
      L=J-1
C--CALCULATE THE L PART , EXCEPT FOR THE DIVISION BY U(I,I)
      DO 1450 I=J,N
      E=B(M2)
      ASING=BSING*ABS(E)
      IF(L)1250,1250,1150
1150  CONTINUE
      M3=I
      M4=M7
      DO 1200 K=1,L
      E=E-B(M3)*B(M4)
      M3=M3+N
      M4=M4+1
1200  CONTINUE
C--TRANSFER TO THE B ARRAY AND CHECK FOR THE MAXIMUM VALUE
1250  CONTINUE
      B(M2)=E
      M2=M2+1
      IF(F-ABS(E))1300,1450,1450
C--THIS IS THE CURRENT MAXIMUM
1300  CONTINUE
      F=ABS(E)
      M=I
      D(M)=ABS(D(M))
C--CHECK SINGULARITY FOR THIS ELEMENT
      IF(ASING-F)1350,1400,1400
1350  CONTINUE
      IF(CSING-F)1450,1400,1400
1400  CONTINUE
      D(M)=-D(M)
1450  CONTINUE
C--CHECK IF THE MAXIMUM VALUE IS INDICATED AS SINGULAR
      IF(D(M))1500,1500,1550
1500  CONTINUE
      KINV2=J
      GOTO 3100
C--INTERCHANGE ROWS
1550  CONTINUE
      CALL XINT2(N,B,NA,D,NC,J,M,N)
      E=1./B(M6)
      B(M6)=E
      IF(J-N)1600,1900,1600
1600  CONTINUE
      M=J+1
      M3=M6+1
      DO 1650 I=M,N
      B(M3)=B(M3)*E
      M3=M3+1
1650  CONTINUE
      IF(L)1850,1850,1700
C--COMPLETE CALCULATION OF U
1700  CONTINUE
      M2=M6+N
      M7=M7+N
      DO 1800 I=M,N
      M3=J
      M4=M7
      DO 1750 K=1,L
      B(M2)=B(M2)-B(M3)*B(M4)
      M3=M3+N
      M4=M4+1
1750  CONTINUE
      M2=M2+N
      M7=M7+N
1800  CONTINUE
C--UPDATE VARIOUS FLAGS
1850  CONTINUE
      M6=M6+N+1
      M8=M8+N
1900  CONTINUE
C--DECOMPOSITION ENDS.
C
C--INVERT THE LOWER TRIANGULAR MATRIX L
      M5=2
C--PROCESS BY ROWS
      DO 2150 I=2,N
      M4=M5
C--PROCESS BY COLUMNS
      DO 2100 J=I,N
      B(M5)=-B(M5)
      K=J-I
      IF(K)2050,2050,1950
1950  CONTINUE
      M1=M5+N
      M2=M4
      DO 2000 L=1,K
      B(M5)=B(M5)-B(M1)*B(M2)
      M1=M1+N
      M2=M2+1
2000  CONTINUE
2050  CONTINUE
      M5=M5+1
2100  CONTINUE
      M5=M5+I
2150  CONTINUE
C
C--INVERT THE UPPER TRIANGULAR MATRIX U
      M5=N*N-1
      DO 2300 I=2,N
      M4=M5+1
      DO 2250 J=I,N
      K=J-I+1
      M1=M5
      M2=M4
      E=0.
      DO 2200 L=1,K
      E=E-B(M1)*B(M2)
      M1=M1-N
      M2=M2-1
2200  CONTINUE
      B(M5)=E*B(M1)
      M5=M5-1
2250  CONTINUE
      M5=M5-I
2300  CONTINUE
C
C--ASSEMBLY OF THE FINAL MATRIX  -  STILL WITH ROWS INTERCHANGED
      M5=1
      DO 2700 J=1,N
      M3=M5+N
      M4=M5+J
      DO 2650 I=1,N
      M1=M3
      M2=M4
      IF(I-J)2350,2350,2400
2350  CONTINUE
      E=B(M5)
      M3=M3+1
      K=N-J
      GOTO 2450
2400  CONTINUE
      E=0.
      M3=M3+N+1
      M4=M4+1
      K=N-I+1
2450  CONTINUE
      IF(K)2600,2600,2500
2500  CONTINUE
      DO 2550 L=1,K
      E=E+B(M1)*B(M2)
      M1=M1+N
      M2=M2+1
2550  CONTINUE
2600  CONTINUE
      B(M5)=E
      M5=M5+1
2650  CONTINUE
2700  CONTINUE
C--ASSEMBLY ENDS.
C
C--SORT OUT THE INTERCHANGES AND STORE FINAL INVERSE MATRIX
      DO 2850 I=1,N
      DO 2800 J=1,N
      K=NINT(D(J))
      IF(K-I)2800,2750,2800
2750  CONTINUE
      CALL XINT2(N,B,NA,D,NC,I,J,1)
      GOTO 2850
2800  CONTINUE
      WRITE(NCAWU,2830)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2830)
      ENDIF
2830  FORMAT(15H Inverter fails  )
      CALL XERHND ( IERSEV )
2850  CONTINUE
C--FINAL ASSEMBLY ENDS.
C
C--SOLVE THE GIVEN EQUATIONS IF ANY
      IF(NM)3100,3100,2900
2900  M3=1
      M4=1
      DO 3050 I=1,NM
      DO 3000 J=1,N
      M1=J
      M2=M3
      D(M4)=0.
      DO 2950 K=1,N
      D(M4)=D(M4)+B(M1)*C(M2)
      M1=M1+N
2950  M2=M2+1
3000  M4=M4+1
3050  M3=M3+N
C
3100  RETURN
      END
C
CODE FOR XINT2
      SUBROUTINE XINT2(N,B,NB,D,ND,J,K,ITYPE)
C--INTERCHANGES EITHER ROWS OR COLUMNS J AND K
C
C--THE TYPE OF INTERCHANGE IS DETERMINATED BY 'ITYPE' :
C
C  1  COLUMNS.
C  2  ROWS.
C
C--
C
      DIMENSION B(NB),D(ND)
C
C
      DATA I/0/,L/0/,M/0/
      DATA F/0.0/
C
      IF(J-K)1000,1100,1000
1000  CONTINUE
      L=(J-1)*(N/ITYPE)+1
      M=(K-1)*(N/ITYPE)+1
      F=D(J)
      D(J)=D(K)
      D(K)=F
      DO 1050 I=1,N
      F=B(L)
      B(L)=B(M)
      B(M)=F
      L=L+ITYPE
      M=M+ITYPE
1050  CONTINUE
1100  CONTINUE
      RETURN
      END
C
CODE FOR XCHOLS
      SUBROUTINE XCHOLS(N,IBASE,IRES)
C--INVERSION OF A SYMMETRIC UPPER TRIANGULAR MATRIX BY THE CHOLESKI
C  METHOD
C
C--THE MATRIX IS HELD IN THE ARRAY 'STORE' IN THE COMMON BLOCK 'XDATA'.
C  THE MATRIX IS STORED AS ITS UPPER TRIANGLE BY ROWS.
C
C  N      ORDER OF THE MATRIX
C  IBASE  ADDRESS OF THE FIRST ELEMENT
C  IRES   ADDRESS OF WORK SPACE OF LENGTH N
C
C--
C
C----- IF THE MATRIX HAS BEEN ACCUMULATED DOUBLE PRECISION,
C      THE FOLLOWING VARIABLES WOULD BEST BE IN QUADRUPLE PRECISION.
C      SINCE QUAD PRECISION IS NOT PART OF FORTRAN77, WE USE DOUBLE
C      LENGTH VARIABLES FOR BOTH SINGLE AND DOUBLE LENGTH MATRICES.
C
C----- DOUBLE PRECISION VARIABLES USED IN MATRIX INVERSION
      DOUBLE PRECISION DA
C----- THE FOLLOWING MIGHT BE BEST IN QUADRUPLE PRECISION
      DOUBLE PRECISION DPV,ASING,BSING,CSING,DSING,EPV,ONE, ADD
C      REAL *16  DPV,ASING,BSING,CSING,DSING,EPV,ONE
C
C----- NOTE THAT IF STR11 IS USED DOUBLE PRECISION, LENGRP IN
C      LIST11 IN COMMAND FILE MUST BE CHANGED FROM 1 TO 2
C      FOR LHS AND RHS
C      AND I11LEN IN XPRC12
C      DOUBLE PRECISION STR11(1048576)
      DIMENSION STR11(1048576)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDATF/NFLD,LFLD,NULD
C      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDATD/XSTR11(1048576)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      EQUIVALENCE (STR11(1),XSTR11(1))
C
C
      DATA ONE/0.1D1/
C      DATA ONE/0.1Q1/
C
C--ASSIGN THE SINGULARITY CHECK LIMITS
      CSING=0.2D1**(-32)
C      CSING=0.2Q1**(-32)
      BSING = SQRT(CSING)
C      BSING = QSQRT(CSING)
C--DECOMPOSE THE MATRIX INTO L.L'
      LU=IRES
      N1=N-1
      K=IBASE
      DPV=STR11(K)
      ASING=BSING
      IF ((N1 .GT. 100) .AND. (IQUN .EQ. JQUN) .AND. (ISSSPD .EQ. 2))
     1THEN
        MDISP = 1
      ELSE
        MDISP = 0
      ENDIF
C--CHECK THE FIRST ELEMENT OF THE FIRST ROW
      IF(N1)2000,2050,1000
1000  CONTINUE
      IF(DPV-BSING)1050,1050,1100
1050  CONTINUE
      CALL XSING(0,N,IBASE,K)
      STR11(LU)=0.
      GOTO 1200
1100  CONTINUE
      DPV = SQRT(DPV)
C      DPV = QSQRT(DPV)
      STR11(K)=DPV
      STR11(LU) = 1.D0/DPV
      K=K+1
      DO 1150 I=1,N1
      STR11(K)=STR11(K)*STR11(LU)
      K=K+1
1150  CONTINUE
C--CONTINUE WITH THE REST OF THE MATRIX
      IF (MDISP .EQ. 1)
     1 CALL XWHIZZ ( '          Decomposing the matrix ', 2 )
1200  CONTINUE
      LU=LU+1
      DO 1650 I=1,N1
      IF (MDISP .EQ. 1)
     1      CALL XWHIZZ('  ', I)
      DPV=STR11(K)
      ASING=DPV*CSING
      L=IBASE+I
      DO 1250 J=1,I
#DOS      DPV = DPV - DPROD( STR11(L), STR11(L) )
&DOSC----- FIX FOR COMPILER ERROR
&DOS      DPV = DPV - DBLE(STR11(L)) * DBLE(STR11(L))
C      DPV = DPV- QLEN(STR11(L)*STR11(L))
      L=L+N-J
1250  CONTINUE
      IF(DPV-BSING)1350,1350,1300
1300  CONTINUE
      IF(DPV-ASING)1350,1350,1400
1350  CONTINUE
      CALL XSING(I,N,IBASE,K)
      STR11(LU)=0.
      GOTO 1600
1400  CONTINUE
      DPV = SQRT(DPV)
C      DPV = QSQRT(DPV)
      EPV=ONE/DPV
      STR11(K)=DPV
      STR11(LU) = EPV
      K=K+1
      IF(I-N1)1450,1600,1450
1450  CONTINUE
      LW=I+1
      DO 1550 J=LW,N1
      DPV=STR11(K)
      LS=IBASE+I
      LT=IBASE+J
      DO 1500 M=1,I
#DOS      DPV = DPV - DPROD( STR11(LS), STR11(LT) )
&DOSC----- FIX FOR COMPILER ERROR
&DOS      DPV = DPV - DBLE(STR11(LS)) * DBLE(STR11(LT))
C      DPV= DPV- QLEN(STR11(LS)*STR11(LT))
      LS=LS+N-M
      LT=LT+N-M
1500  CONTINUE
      STR11(K)=DPV*EPV
      K=K+1
1550  CONTINUE
1600  CONTINUE
      LU=LU+1
1650  CONTINUE
C
C--INVERSION OF THE TRIANGULAR MATRIX L
      LV=K
      K=K-1
      LU=LU-1
      STR11(K)=STR11(LU)
      K=K-1
      LU=LU-1
      IF (MDISP .EQ. 1)
     1 CALL XWHIZZ ( '          Inverting the triangular matrix ', 2)
      DO 1800 I=1,N1
      IF (MDISP .EQ. 1)
     1      CALL XWHIZZ('  ', I)
      LW=LV
      DO 1750 J=1,I
      ADD=0.0
      LW=LW-J
      LT=K
      LS=LW
      DO 1700 L=J,I
#DOS      ADD = ADD - DPROD( STR11(LS), STR11(LT) )
&DOSC----- FIX FOR COMPILER ERROR
&DOS      ADD = ADD - DBLE(STR11(LS)) * DBLE(STR11(LT))
      LT=LT-1
      LS=LS-L
1700  CONTINUE
      STR11(K)=ADD*STR11(LU)
      K=K-1
1750  CONTINUE
      STR11(K)=STR11(LU)
      K=K-1
      LU=LU-1
1800  CONTINUE
C
C--FORM THE INVERSE MATRIX FROM THE TWO INVERTED TRIANGLES
      K=IBASE
      LS=IBASE-1
      IF (MDISP .EQ. 1)
     1 CALL XWHIZZ ( '          Forming the full inverse matrix ', 2)
      DO 1950 I=1,N
      IF (MDISP .EQ. 1)
     1      CALL XWHIZZ('  ', I)
      LT=LS
      DO 1900 J=I,N
      ADD=0.0
      DO 1850 M=J,N
      LV=M+LT
      LW=M+LS
#DOS      ADD = ADD + DPROD( STR11(LV), STR11(LW) )
&DOSC----- FIX FOR COMPILER ERROR
&DOS      ADD = ADD + DBLE(STR11(LV)) * DBLE(STR11(LW))
1850  CONTINUE
      STR11(K)=ADD
      K=K+1
      LT=LT+N-J
1900  CONTINUE
      LS=LS+N-I
1950  CONTINUE
C
2000  CONTINUE
      RETURN
C
C--ONLY ONE ELEMENT
2050  CONTINUE
      IF(DPV-ASING)2100,2100,2150
2100  CONTINUE
      CALL XSING(0,N,IBASE,K)
      STR11(LU)=0.
      GOTO 2000
2150  CONTINUE
      STR11(K)=1.0/STR11(K)
      GOTO 2000
      END
C
CODE FOR XSOLVE
      SUBROUTINE XSOLVE(N,IBASE,IVECT,IRES)
C--SOLVE THE NORMAL EQUATIONS
C
C  N     ORDER OF THE MATRIX
C  IBASE FIRST LOCATION OF THE MATRIX
C  IVECT FIRST LOCATION OF THE VECTOR
C  IRES  FIRST LOCATION OF THE RESULTS
C
C--
C
C
C----- NOTE THAT IF STR11 IS USED DOUBLE PRECISION, LENGRP IN
C      LIST11 IN COMMAND FILE MUST BE CHANGED FROM 1 TO 2
C      FOR LHS AND RHS
C      AND I11LEN IN XPRC12
C      DOUBLE PRECISION STR11(1048576)
      DIMENSION STR11(1048576)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDATF/NFLD,LFLD,NULD
C      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDATD/XSTR11(1048576)
C
      EQUIVALENCE (STR11(1),XSTR11(1))
C
C--WORK OUT THE ANSWERS
      K=IRES
      DO 1250 I=1,N
      LS=IBASE+I-1
      STR11(K)=0.0
      LT=IVECT
      DO 1200 J=1,N
      STR11(K)=STR11(K)+STR11(LT)*STR11(LS)
      IF(J-I)1050,1100,1100
1050  CONTINUE
      LS=LS+N-J
      GOTO 1150
1100  CONTINUE
      LS=LS+1
1150  CONTINUE
      LT=LT+1
1200  CONTINUE
      K=K+1
1250  CONTINUE
      RETURN
      END
C
CODE FOR XSING
      SUBROUTINE XSING(NOC,N,IBASE,K)
C--SINGULARITY ERROR
C
C  NOC     THE SINGULAR PARAMETER MINUS ONE.
C  N       THE ORDER OF THE MATRIX.
C  IBASE   THE ADDRESS OF THE FIRST WORD.
C
C--
C----- NOTE THAT IF STR11 IS USED DOUBLE PRECISION, LENGRP IN
C      LIST11 IN COMMAND FILE MUST BE CHANGED FROM 1 TO 2
C      FOR LHS AND RHS
C      AND I11LEN IN XPRC12
C      DOUBLE PRECISION STR11(1048576)
      DIMENSION STR11(1048576)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDATF/NFLD,LFLD,NULD
C      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDATD/XSTR11(1048576)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      EQUIVALENCE (STR11(1),XSTR11(1))
C
      LS=NOC+1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)LS
      ENDIF
      WRITE(NCAWU,1000) LS
1000  FORMAT(33H Singularity - relative parameter,I5/)
      LS=IBASE+NOC
      DO 1150 LT=1,N
      STR11(LS)=0.0
      IF(NOC-LT)1100,1050,1050
1050  CONTINUE
      LS=LS+N-LT
      GOTO 1150
1100  CONTINUE
      LS=LS+1
      K=K+1
1150  CONTINUE
      RETURN
      END
C
CODE FOR XMXMPI
      SUBROUTINE XMXMPI(A,B,N)
C -- B = INVERSE (A)
C----- MOORE-PENROSE INVERTOR
C----- ACTA (1977),A33 212-215. A. L. MACKAY
      DIMENSION A(N,N)
      DIMENSION B(N,N)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C --
      EQUIVALENCE (STORE(1),ISTORE(1))
C --
C -- SET UP NUMBERS REQUIRED LATER
      NSQ=N*N
C -- ILIMIT IS THE MAXIMUM NUMBER OF ITERATIONS FOR ANY MATRIX
      ILIMIT=20
C -- ITRLIM IS THE MAXIMUM NUMBER OF INITIAL TRIALS MADE
      ITRLIM=5
C --
      CALL XZEROF(B(1,1),NSQ)
C -- ALLOCATE WORKING SPACE FOR CALCULATIONS
      IPMAT=KSTALL(NSQ)
      IQMAT=KSTALL(NSQ)
      IRMAT=KSTALL(NSQ)
      IINIT=KSTALL(NSQ)
      ISCALE=KSTALL(N)
C -- SAVE INITIAL MATRIX
      CALL XMOVE(A(1,1),STORE(IINIT),NSQ)
C -- CALCULATE SCALE FACTORS FOR MATRIX
      DO 1050 I=1,N
      NSCALE=ISCALE+I-1
      STORE(NSCALE)=10.
      IF (ABS(A(I,I)) .LT. 0.01) GO TO 1050
      STORE(NSCALE)=1/SQRT(ABS(A(I,I)))
1050  CONTINUE
C -- SCALE INITIAL MATRIX
      CALL XMXSCL(A(1,1),A(1,1),STORE(ISCALE),N)
C -- SUM ELEMENTS - NECCESSARY FOR DETERMINING FIRST TRIAL INVERSE
      CALL XMXSEL(A(1,1),N,N,ALP)
C -- IF ALP=0. THEN WE HAVE A ZERO MATRIX
      IF (ALP .LE. 0.000001) GOTO 9500
      ALP=1./ALP
C -- SET P = 2I
      CALL XZEROF(STORE(IPMAT),NSQ)
      NDIAG=IPMAT
      DO 1200 I=1,N
      STORE(NDIAG)=2.
      NDIAG=NDIAG+N+1
1200  CONTINUE
C -- SET ATTEMPTS COUNTER
      ITRIES=1
1300  CONTINUE
C -- INITIAL TRY IS ALP*TRANSPOSE(A)
      CALL XTRANS (A(1,1),STORE(IQMAT),N,N)
      CALL XMULTR (STORE(IQMAT),ALP,STORE(IQMAT),NSQ)
C --
      ITIMES=1
C -- INITIAL VALUE OF OLD TRACE = 0
      TR=0.
1500  CONTINUE
C -- ITERATION LOOP
C -- R = AQ
      CALL XMLTMM(A(1,1),STORE(IQMAT),STORE(IRMAT),N,N,N)
C -- CALCULATE TRACE OF R
      X=XMXTRC(STORE(IRMAT),N)
C -- R = P - R
      CALL XSUBTR(STORE(IPMAT),STORE(IRMAT),STORE(IRMAT),NSQ)
C -- B = Q R
      CALL XMLTMM(STORE(IQMAT),STORE(IRMAT),B(1,1),N,N,N)
C -- CHECK FOR CONVERGENCE
      IF (ABS(X-TR).LT.0.01) GOTO 4000
C -- NOT CONVERGED
C -- IF TRACE IS NEGATIVE OR GREATER THAN ORDER THEN TRY
C    ANOTHER INITIAL MATRIX
      IF ( (X .LE. 0.) .OR. (X .GT. N) ) GOTO 3000
      ITIMES=ITIMES+1
C -- IF WE HAVE HAD ENOUGH ATTEMPTS WITH THIS MATRIX TRY ANOTHER
      IF (ITIMES.GE.(ILIMIT+1)) GOTO 3000
C -- REMEMBER TRACE FOR COMPARISON
      TR=X
C -- SET NEXT TRIAL MATRIX
      CALL XMOVE(B(1,1),STORE(IQMAT),NSQ)
C -- REPEAT
      GO TO 1500
3000  CONTINUE
C -- THIS ATTEMPT HAS NOT WORKED
C -- INCREMENT TRIES COUNT
        ITRIES=ITRIES+1
C -- IF WE HAVE DONE THE MAXIMUM NUMBER OF LOOPS THEN GIVE UP HOPE
      IF (ITRIES.GT.(ITRLIM+1)) GOTO 9800
C -- TRY AGAIN WITH A DIFFERENT INITIAL MATRIX
      ALP=.3*ALP
      GOTO 1300
4000  CONTINUE
C -- PROCESS HAS APPARENTLY CONVERGED
C    IF THE CURRENT TRACE IS NEARLY ZERO THEN ABANDON ATTEMPT
      IF (X.LT.0.01) GOTO 9810
C -- PROCESS HAS SUCCESSFULLY CONVERGED
C -- SCALE MATRIX AGAIN TO RELATE IT TO THE INITIAL VALUES
      CALL XMXSCL(B(1,1),B(1,1),STORE(ISCALE),N)
9500  CONTINUE
C -- RESTORE INITIAL MATRIX
      CALL XMOVE(STORE(IINIT),A(1,1),NSQ)
C -- RELEASE WORK SPACE
      CALL XSTRLL(IINIT)
      CALL XSTRLL(IPMAT)
      CALL XSTRLL(IQMAT)
      CALL XSTRLL(IRMAT)
      CALL XSTRLL(ISCALE)
      RETURN
9800  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,9801)
      ENDIF
      WRITE (NCAWU,9801)
9801  FORMAT (41H Inversion process has failed to converge  )
      GO TO 9900
9810  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,9811)
      ENDIF
      WRITE (NCAWU,9811)
9811  FORMAT (33H Trace of inverse has become zero   )
9900  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,9901)
      ENDIF
      WRITE (NCAWU,9901)
9901  FORMAT (32H Error in Moore-Penrose inverter   )
C -- CALL ERROR ROUTINE
      CALL XERHND ( IERERR )
      RETURN
      END
C
C --
C
CODE FOR XMXSCL
      SUBROUTINE XMXSCL(A,B,SCALE,N)
C -- B(I,J)=A(I,J)*SCALE(I)*SCALE(J)
      DIMENSION A(N,N)
      DIMENSION B(N,N)
      DIMENSION SCALE(N)
C --
      DO 1200 I=1,N
      DO 1100 J=1,N
      B(I,J)=A(I,J)*SCALE(I)*SCALE(J)
1100  CONTINUE
1200  CONTINUE
      RETURN
      END
C
C --
C
CODE FOR XMXSEL
      SUBROUTINE XMXSEL(A,N,M,SUM)
C -- SUM=A(1,1)+A(1,2)+... A(N,M)
      DIMENSION A(N,M)
      SUM=0.
      DO 1200 J=1,N
      DO 1100 I=1,M
      SUM=SUM+A(I,J)
1100  CONTINUE
1200  CONTINUE
      RETURN
      END
C
C --
C
CODE FOR XMXTRC
      FUNCTION XMXTRC(A,N)
C -- XMXTRC = TRACE ( A )
      DIMENSION A(N,N)
C --
      SUM=0.
      DO 2000 I=1,N
      SUM=SUM+A(I,I)
2000  CONTINUE
      XMXTRC=SUM
      RETURN
      END
C
C --
C
CODE FOR XMXPRM
      SUBROUTINE XMXPRM(RMAT)
C -- PRINTS ROTATION MATRIX
      DIMENSION RMAT(3,3)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C --
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,2010)
      ENDIF
2010  FORMAT (1X)
      DO 3000 J=1,3
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,2020) (RMAT(I,J),I=1,3)
      ENDIF
2020  FORMAT (1X,3F10.5)
3000  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,3010)
      ENDIF
3010  FORMAT (/)
      RETURN
      END
C
C --
C
CODE FOR XMXEGV
      SUBROUTINE XMXEGV(XM1,XM2,XM3)
      DOUBLE PRECISION DM1,DM2,DM3,DWORK
      DIMENSION XM1(3,3),XM2(3,3),XM3(3)
      DIMENSION DM1(3,3),DM2(3,3),DM3(3),DWORK(10)
C --
      DO 2000 J=1,3
      DO 1500 I=1,3
      DM1(I,J)=DBLE(XM1(I,J))
1500  CONTINUE
2000  CONTINUE
      I=0
      CALL F02ABF (DM1(1,1),3,3,DM3(1),DM2(1,1),3,DWORK(1),I)
      DO 3000 J=1,3
      DO 2500 I=1,3
      XM2(I,J)=SNGL(DM2(I,J))
      XM3(I)=SNGL(DM3(I))
2500  CONTINUE
3000  CONTINUE
      RETURN
      END
C
C --
C
CODE FOR XMXMFV
      SUBROUTINE XMXMFV(VECTOR,XMATR,NDIM)
C -- CONVERTS VECTOR TO MATRIX
      DIMENSION VECTOR(NDIM)
      DIMENSION XMATR(NDIM,NDIM)
C --
      DO 2000 J=1,NDIM
      DO 1500 I=1,NDIM
      IF (I-J) 1200,1300,1200
1200  CONTINUE
      XMATR(I,J)=0.
      GOTO 1500
1300  CONTINUE
      XMATR(I,J)=VECTOR(J)
1500  CONTINUE
2000  CONTINUE
      RETURN
      END
C
C --
C
CODE FOR XMXRTI
      SUBROUTINE XMXRTI (ATOMS,XMATR,MDATM,NATM)
C -- APPLIES XMATR TO ATOMS
      DIMENSION ATOMS(MDATM,NATM)
      DIMENSION XMATR(3,3)
      DIMENSION RESULT(3)
C --
      DO 2000 J=1,NATM
      CALL XMLTMT(XMATR(1,1),ATOMS(1,J),RESULT(1),3,3,1)
      CALL XMOVE (RESULT(1),ATOMS(1,J),3)
2000  CONTINUE
      RETURN
      END
C
C --
C
CODE FOR XMXTRL
      SUBROUTINE XMXTRL (ATOMS,VECTOR,MDATM,NATM)
C -- TRANSLATES ATOMS BY VECTOR
C    FINAL ATOM COORDINATES ARE MULTIPLIED BY WEIGHT
C    (SETTING THOSE WITH ZERO WEIGHT TO 0. 0. 0.)
C --
      DIMENSION ATOMS(MDATM,NATM)
      DIMENSION VECTOR(3)
C --
      DO 2000 I=1,3
      DO 1000 J=1,NATM
      ATOMS(I,J)=ATOMS(I,J)-VECTOR(I)
      ATOMS(I,J)=ATOMS(I,J)*ATOMS(4,J)
1000  CONTINUE
2000  CONTINUE
      RETURN
      END
C
C --
C
CODE FOR XMXCLO
      SUBROUTINE XMXCLO(DATA,XMATR)
      DIMENSION DATA(6)
      DIMENSION XMATR(9)
C --
      XMATR(1)=DATA(1)*SIN(DATA(5))*SIN(DATA(6))
      XMATR(2)=0.
      XMATR(3)=0.
      XMATR(4)=-DATA(1)*SIN(DATA(5))*COS(DATA(6))
      XMATR(5)=DATA(2)*SIN(DATA(4))
      XMATR(6)=0.
      XMATR(7)=DATA(1)*COS(DATA(5))
      XMATR(8)=DATA(2)*COS(DATA(4))
      XMATR(9)=DATA(3)
C --
      RETURN
      END
C
C --
C
CODE FOR XMXCRM
      SUBROUTINE XMXCRM(ROTN,XMATR)
      DIMENSION ROTN(3)
      DIMENSION XMATR(3,3)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C --
      ITMP1=KSTALL(9)
      ITMP2=KSTALL(27)
C -- GET UNIT MATRIX
      CALL XUNTM3(STORE(ITMP1))
C -- CALCULATE ROTATION MATRIX ABOUT X,Y,Z, AXES
      DO 2000 I=1,3
      IPL1=3*(I-1)
      IPL2=9*(I-1)
      J=NROT(STORE(IPL1+ITMP1),ROTN(I),STORE(ITMP2+IPL2))
2000  CONTINUE
      CALL XMLTMM(STORE(ITMP2+9),STORE(ITMP2),STORE(ITMP1),3,3,3)
      CALL XMLTMM(STORE(ITMP2+18),STORE(ITMP1),XMATR(1,1),3,3,3)
C -- RELEASE WORK SPACE
      CALL XSTRLL(ITMP1)
      CALL XSTRLL(ITMP2)
      RETURN
      END
CRYSTALS CODE FOR MTAPES
CODE FOR XIMTW
      SUBROUTINE XIMTW(IN)
C--INITIATE MAGNETIC TAPE WRITE
C
C  IN  LENGTH OF EACH INDIVIDUAL ITEM
C
C--
C
      CALL XIMTT(IN,1)
      RETURN
      END
C
CODE FOR XIMTR
      SUBROUTINE XIMTR(IN)
C--INITIATE MAGNETIC TAPE READ
C
C  IN  LENGTH OF EACH ITEM
C
C--
      COMMON/XTAPED/LMTW,MMTW,MDMTW,NMTW,LMTR,MMTR,MDMTR,NMTR
C
C--CALL THE INITIALISING ROUTINE
      CALL XIMTT(IN,2)
C--SET THE BUFFER POINTER SO THAT NO DATA IS IN THE BUFFER
      MMTR=NMTR
      RETURN
      END
C
CODE FOR XIMTT
      SUBROUTINE XIMTT(IN,IM)
C--INITIATE MAGNETIC TAPE TRANSFER
C
C  IN  LENGTH OF EACH INDIVIDUAL ITEM
C  IM  1 FOR WRITE AND 2 FOR READ
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
C
      COMMON /XTAPED/L(4,2)
C
C
      DATA NWMTBF/254/
C
C--ASSIGN THE ITEM LENGTH
      LENGTH=IN
C--CHECK IF THE ITEM LENGTH IS ZERO
      IF(LENGTH)1000,1000,1050
C--ITEM LENGTH IS ZERO  -  TRANSFER IS ONE BUFFER AT A TIME
1000  CONTINUE
      LENGTH=NWMTBF
C--SET THE LAST WORD IN THE BUFFER
1050  CONTINUE
      L(4,IM)=LFL
C--SET THE LIST AND RECORD TYPES
      LN=200
      IREC=100+IM
      L(1,IM)=KCHLFL(NWMTBF/LENGTH*LENGTH)
C--SET THE CURRENT ADDRESS TO THE START OF THE BUFFER
      L(2,IM)=L(1,IM)
C--SET THE INCREMENT FOR EACH ITEM
      L(3,IM)=LENGTH
      RETURN
      END
C
CODE FOR XIMTWA
      SUBROUTINE XIMTWA(N)
C--INCREMENT THE MAGNETIC TAPE WRITE ADDRESS FOR UNIT 'N'
C
C  N  THE UNIT NUMBER ON WHICH THE TRANSFER IS TO BE MADE.
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XTAPED/LMTW,MMTW,MDMTW,NMTW,LMTR,MMTR,MDMTR,NMTR
C
C--INCREMENT THE CURRENT BUFFER POSITION
      MMTW=MMTW+MDMTW
C--CHECK FOR A FULL BUFFER
      IF(MMTW-NMTW)1050,1050,1000
C--BUFFER IS FULL  -  OUTPUT IT AND RESET THE POINTERS
1000  CONTINUE
      WRITE(N)(STORE(M),M=LMTW,NMTW)
      MMTW=LMTW
1050  CONTINUE
      RETURN
      END
C
CODE FOR XIMTRA
      SUBROUTINE XIMTRA(N)
C--INCREMENT THE MAGNETIC TAPE READ ADDRESS FOR UNIT 'N'
C
C  N  THE UNIT NUMBER ON WHICH TO DO THE TRANSFER
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XTAPED/LMTW,MMTW,MDMTW,NMTW,LMTR,MMTR,MDMTR,NMTR
C
C--INCREMENT THE BUFFER ADDRESS
      MMTR=MMTR+MDMTR
C--CHECK IF THE BUFFER IS FULL
      IF(MMTR-NMTR)1050,1050,1000
C--BUFFER IS FULL  -  READ ANOTHER AND RESET THE POINTERS
1000  CONTINUE
      READ(N)(STORE(M),M=LMTR,NMTR)
      MMTR=LMTR
1050  CONTINUE
      RETURN
      END
C
CODE FOR XTMTW
      SUBROUTINE XTMTW(N)
C--TERMINATE THE MAGNETIC TAPE WRITE FOR UNIT 'N'
C
C  N  THE UNIT NUMBER BEING USED FOR OUTPUT.
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XTAPED/LMTW,MMTW,MDMTW,NMTW,LMTR,MMTR,MDMTR,NMTR
C
C--WRITE THE LAST BUFFER OUT
      WRITE(N)(STORE(M),M=LMTW,NMTW)
      MMTW=LMTW
      ENDFILEN
      REWINDN
      RETURN
      END
C
CODE FOR XTMTR
      SUBROUTINE XTMTR(N)
C--TERMINATE THE TRANFERS ON THE INPUT M/T 'N'
C
C  N  THE NUMBER OF THE M/T BEING USED FOR INPUT
C
C--
      COMMON/XTAPED/LMTW,MMTW,MDMTW,NMTW,LMTR,MMTR,MDMTR,NMTR
C
      REWINDN
      MMTR=NMTR
      RETURN
      END
C
C
CRYSTALS CODE FOR NAG

C THE FOLLOWING ROUTINES ARE IN THIS SUBLIBRARY
* F01FTEXT
* F02FTEXT
* P01FTEXT
*UPTODATE P01AAFTEXT
* S18FTEXT
*UPTODATE S18AEFTEXT
*UPTODATE S18AFFTEXT
* X02FTEXT
*UPTODATE X02AAFTEXT
*UPTODATE X02ABFTEXT
*UPTODATE X02ACFTEXT
*UPTODATE X02ADFTEXT
*UPTODATE X02AEFTEXT
*UPTODATE X02AGFTEXT
*UPTODATE X02BAFTEXT
*UPTODATE X02BBFTEXT
*UPTODATE X02BCFTEXT
*UPTODATE X02BDFTEXT
*UPTODATE X02BEFTEXT
*UPTODATE X02CAFTEXT
*UPTODATE X02DAFTEXT
* X04FTEXT
*UPTODATE X04AAFTEXT
* F01FTEXT
      SUBROUTINE F01AJF(N, ATOL, A, IA, D, E, Z, IZ)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 4 REVISED.
C     MARK 4.5 REVISED
C     MARK 5C REVISED
C
C     TRED2
C     THIS SUBROUTINE REDUCES THE GIVEN LOWER TRIANGLE OF A
C     SYMMETRIC MATRIX, A, STORED IN THE ARRAY A(N,N), TO
C     TRIDIAGONAL FORM USING HOUSEHOLDERS REDUCTION. THE DIAGONAL
C     OF THE RESULT IS STORED IN THE ARRAY D(N) AND THE
C     SUB-DIAGONAL IN THE LAST N - 1 STORES OF THE ARRAY E(N)
C     (WITH THE ADDITIONAL ELEMENT E(1) = 0). THE TRANSFORMATION
C     MATRICES ARE ACCUMULATED IN THE ARRAY Z(N,N). THE ARRAY
C     A IS LEFT UNALTERED UNLESS THE ACTUAL PARAMETERS
C     CORRESPONDING TO A AND Z ARE IDENTICAL.
C     1ST AUGUST 1971
C
      INTEGER I, IA, II, IZ, J1, J, K, L, N
      DOUBLE PRECISION ATOL, F, G, H, HH, A(IA,N), D(N), E(N), Z(IZ,N)
      DO 40 I=1,N
         DO 20 J=1,I
            Z(I,J) = A(I,J)
   20    CONTINUE
   40 CONTINUE
      IF (N.EQ.1) GO TO 280
      DO 260 II=2,N
         I = N - II + 2
         L = I - 2
         F = Z(I,I-1)
         G = 0.0D0
         IF (L.EQ.0) GO TO 80
         DO 60 K=1,L
            G = G + Z(I,K)*Z(I,K)
   60    CONTINUE
   80    H = G + F*F
C     IF G IS TOO SMALL FOR ORTHOGONALITY TO BE
C     GUARANTEED THE TRANSFORMATION IS SKIPPED
         IF (G.GT.ATOL) GO TO 100
         E(I) = F
         H = 0.0D0
         GO TO 240
  100    L = L + 1
         G = DSQRT(H)
         IF (F.GE.0.0D0) G = -G
         E(I) = G
         H = H - F*G
         Z(I,I-1) = F - G
         F = 0.0D0
         DO 180 J=1,L
            Z(J,I) = Z(I,J)/H
            G = 0.0D0
C     FORM ELEMENT OF A*U
            DO 120 K=1,J
               G = G + Z(J,K)*Z(I,K)
  120       CONTINUE
            J1 = J + 1
            IF (J1.GT.L) GO TO 160
            DO 140 K=J1,L
               G = G + Z(K,J)*Z(I,K)
  140       CONTINUE
C     FORM ELEMENT OF P
  160       E(J) = G/H
            F = F + G*Z(J,I)
  180    CONTINUE
C     FORM K
         HH = F/(H+H)
C     FORM REDUCED A
         DO 220 J=1,L
            F = Z(I,J)
            G = E(J) - HH*F
            E(J) = G
            DO 200 K=1,J
               Z(J,K) = Z(J,K) - F*E(K) - G*Z(I,K)
  200       CONTINUE
  220    CONTINUE
  240    D(I) = H
  260 CONTINUE
  280 E(1) = 0.0D0
      D(1) = 0.0D0
C     ACCUMULATION OF TRANSFORMATION MATRICES
      DO 400 I=1,N
         L = I - 1
         IF (D(I).EQ.0.0D0) GO TO 360
         DO 340 J=1,L
            G = 0.0D0
            DO 300 K=1,L
               G = G + Z(I,K)*Z(K,J)
  300       CONTINUE
            DO 320 K=1,L
               Z(K,J) = Z(K,J) - G*Z(K,I)
  320       CONTINUE
  340    CONTINUE
  360    D(I) = Z(I,I)
         Z(I,I) = 1.0D0
         IF (L.EQ.0) GO TO 400
         DO 380 J=1,L
            Z(I,J) = 0.0D0
            Z(J,I) = 0.0D0
  380    CONTINUE
  400 CONTINUE
      RETURN
      END
** END OF F01AJFTEXT
* F02FTEXT
      SUBROUTINE F02ABF(A, IA, N, R, V, IV, E, IFAIL)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 3 REVISED.
C     MARK 4.5 REVISED
C
C     EIGENVALUES AND EIGENVECTORS OF A REAL SYMMETRIX MATRIX
C     1ST AUGUST 1971
C
      INTEGER P01AAF, ISAVE, IFAIL, N, IA, IV
C$P 1
      DOUBLE PRECISION SRNAME
      DOUBLE PRECISION TOL, XXXX, A(IA,N), R(N), V(IV,N), E(N), X02ADF,
     * X02AAF
      DATA SRNAME /8H F02ABF /
      ISAVE = IFAIL
      IFAIL = 1
      TOL = X02ADF(1.0D0)
      CALL F01AJF(N, TOL, A, IA, R, E, V, IV)
      TOL = X02AAF(1.0D0)
      CALL F02AMF(N, TOL, R, E, V, IV, IFAIL)
      IF (IFAIL.NE.0) IFAIL = P01AAF(ISAVE,IFAIL,SRNAME)
      RETURN
      END
** END OF F02ABFTEXT
      SUBROUTINE F02AMF(N, ACHEPS, D, E, Z, IZ, IFAIL)
C     MARK 2 RELEASE. NAG COPYRIGHT 1972
C     MARK 3 REVISED.
C     MARK 4 REVISED.
C     MARK 4.5 REVISED
C
C     TQL2
C     THIS SUBROUTINE FINDS THE EIGENVALUES AND EIGENVECTORS OF A
C     TRIDIAGONAL MATRIX, T, GIVEN WITH ITS DIAGONAL ELEMENTS IN
C     THE ARRAY D(N) AND ITS SUB-DIAGONAL ELEMENTS IN THE LAST N
C     - 1 STORES OF THE ARRAY E(N), USING QL TRANSFORMATIONS. THE
C     EIGENVALUES ARE OVERWRITTEN ON THE DIAGONAL ELEMENTS IN THE
C     ARRAY D IN ASCENDING ORDER. THE EIGENVECTORS ARE FORMED IN
C     THE ARRAY Z(N,N), OVERWRITING THE ACCUMULATED
C     TRANSFORMATIONS AS SUPPLIED BY THE SUBROUTINE F01AJF. THE
C     SUBROUTINE WILL FAIL IF ANY ONE EIGENVALUE TAKES MORE THAN 30
C     ITERATIONS.
C     1ST APRIL 1972
C
      INTEGER P01AAF, ISAVE, IFAIL, N, I, L, J, M, I1, M1, II, K, IZ
C$P 1
      DOUBLE PRECISION SRNAME
      DOUBLE PRECISION B, F, H, ACHEPS, G, P, R, C, S, D(N), E(N), Z(IZ,
     *N)
      DATA SRNAME /8H F02AMF /
      ISAVE = IFAIL
      IF (N.EQ.1) GO TO 40
      DO 20 I=2,N
         E(I-1) = E(I)
   20 CONTINUE
   40 E(N) = 0.0D0
      B = 0.0D0
      F = 0.0D0
      DO 300 L=1,N
         J = 0
         H = ACHEPS*(DABS(D(L))+DABS(E(L)))
         IF (B.LT.H) B = H
C     LOOK FOR SMALL SUB-DIAG ELEMENT
         DO 60 M=L,N
            IF (DABS(E(M)).LE.B) GO TO 80
   60    CONTINUE
   80    IF (M.EQ.L) GO TO 280
  100    IF (J.EQ.30) GO TO 400
         J = J + 1
C     FORM SHIFT
         G = D(L)
         H = D(L+1) - G
         IF (DABS(H).GE.DABS(E(L))) GO TO 120
         P = H*0.5D0/E(L)
         R = DSQRT(P*P+1.0D0)
         H = P + R
         IF (P.LT.0.0D0) H = P - R
         D(L) = E(L)/H
         GO TO 140
  120    P = 2.0D0*E(L)/H
         R = DSQRT(P*P+1.0D0)
         D(L) = E(L)*P/(1.0D0+R)
  140    H = G - D(L)
         I1 = L + 1
         IF (I1.GT.N) GO TO 180
         DO 160 I=I1,N
            D(I) = D(I) - H
  160    CONTINUE
  180    F = F + H
C     QL TRANSFORMATION
         P = D(M)
         C = 1.0D0
         S = 0.0D0
         M1 = M - 1
         DO 260 II=L,M1
            I = M1 - II + L
            G = C*E(I)
            H = C*P
            IF (DABS(P).LT.DABS(E(I))) GO TO 200
            C = E(I)/P
            R = DSQRT(C*C+1.0D0)
            E(I+1) = S*P*R
            S = C/R
            C = 1.0D0/R
            GO TO 220
  200       C = P/E(I)
            R = DSQRT(C*C+1.0D0)
            E(I+1) = S*E(I)*R
            S = 1.0D0/R
            C = C/R
  220       P = C*D(I) - S*G
            D(I+1) = H + S*(C*G+S*D(I))
C     FORM VECTOR
            DO 240 K=1,N
               H = Z(K,I+1)
               Z(K,I+1) = S*Z(K,I) + C*H
               Z(K,I) = C*Z(K,I) - S*H
  240       CONTINUE
  260    CONTINUE
         E(L) = S*P
         D(L) = C*P
         IF (DABS(E(L)).GT.B) GO TO 100
  280    D(L) = D(L) + F
  300 CONTINUE
C     ORDER EIGENVALUES AND EIGENVECTORS
      DO 380 I=1,N
         K = I
         P = D(I)
         I1 = I + 1
         IF (I1.GT.N) GO TO 340
         DO 320 J=I1,N
            IF (D(J).GE.P) GO TO 320
            K = J
            P = D(J)
  320    CONTINUE
  340    IF (K.EQ.I) GO TO 380
         D(K) = D(I)
         D(I) = P
         DO 360 J=1,N
            P = Z(J,I)
            Z(J,I) = Z(J,K)
            Z(J,K) = P
  360    CONTINUE
  380 CONTINUE
      IFAIL = 0
      RETURN
  400 IFAIL = P01AAF(ISAVE,1,SRNAME)
      RETURN
      END
** END OF F02AMFTEXT
* P01FTEXT
*UPTODATE P01AAFTEXT
      INTEGER FUNCTION P01AAF(IFAIL, ERROR, SRNAME)
C     MARK 1 RELEASE.  NAG COPYRIGHT 1971
C     MARK 3 REVISED
C     MARK 4A REVISED, IER-45
C     MARK 4.5 REVISED
C     MARK 7 REVISED (DEC 1978)
C     RETURNS THE VALUE OF ERROR OR TERMINATES THE PROGRAM.
      INTEGER ERROR, IFAIL, NOUT
C$P 1
      DOUBLE PRECISION SRNAME
C     TEST IF NO ERROR DETECTED
      IF (ERROR.EQ.0) GO TO 20
C     DETERMINE OUTPUT UNIT FOR MESSAGE
      CALL X04AAF (0,NOUT)
C     TEST FOR SOFT FAILURE
      IF (MOD(IFAIL,10).EQ.1) GO TO 10
C     HARD FAILURE
      WRITE (NOUT,99999) SRNAME, ERROR
C     STOPPING MECHANISM MAY ALSO DIFFER
C     CALL P01AAZ
      STOP
C     SOFT FAIL
C     TEST IF ERROR MESSAGES SUPPRESSED
   10 IF (MOD(IFAIL/10,10).EQ.0) GO TO 20
      WRITE (NOUT,99999) SRNAME, ERROR
   20 P01AAF = ERROR
      RETURN
99999 FORMAT (1H0, 38HERROR DETECTED BY NAG LIBRARY ROUTINE , A8,
     * 11H - IFAIL = , I5//)
      END
** END OF P01AAFTEXT
* S18FTEXT
*UPTODATE S18AEFTEXT
      DOUBLE PRECISION FUNCTION S18AEF(X, IFAIL)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
C     BESSEL FUNCTION I0(X)
C
C     **************************************************************
C
C     TO EXTRACT THE CORRECT CODE FOR A PARTICULAR MACHINE-RANGE,
C     ACTIVATE THE STATEMENTS CONTAINED IN COMMENTS BEGINNING  CDD ,
C     WHERE  DD  IS THE APPROXIMATE NUMBER OF SIGNIFICANT DECIMAL
C     DIGITS REPRESENTED BY THE MACHINE
C     DELETE THE ILLEGAL DUMMY STATEMENTS OF THE FORM
C     * EXPANSION  (DDDD) *
C
C     ALSO INSERT APPROPRIATE DATA STATEMENTS TO DEFINE CONSTANTS
C     WHICH DEPEND ON THE RANGE OF NUMBERS REPRESENTED BY THE
C     MACHINE, RATHER THAN THE PRECISION (SUITABLE STATEMENTS FOR
C     SOME MACHINES ARE CONTAINED IN COMMENTS BEGINNING CRD WHERE
C     D IS A DIGIT WHICH SIMPLY DISTINGUISHES A GROUP OF MACHINES).
C     DELETE THE ILLEGAL DUMMY DATA STATEMENTS WITH VALUES WRITTEN
C     *VALUE* .
C
C     **************************************************************
C
C     .. SCALAR ARGUMENTS ..
      DOUBLE PRECISION X
      INTEGER IFAIL
C     ..
C     .. LOCAL SCALARS ..
C$P 1
      DOUBLE PRECISION SRNAME
      DOUBLE PRECISION G, T, XBIG, XVSMAL, Y, YBIG
C     .. FUNCTION REFERENCES ..
      DOUBLE PRECISION DLOG, DEXP
      INTEGER P01AAF
C     ..
      DATA SRNAME /8H S18AEF /
C08   DATA XVSMAL /1.0D-4/
C09   DATA XVSMAL /3.2D-5/
C12   DATA XVSMAL /1.0D-6/
C15   DATA XVSMAL /3.2D-8/
      DATA XVSMAL /3.2D-9/
C19   DATA XVSMAL /3.2D-10/
C     XBIG = LARGEST X SUCH THAT  EXP(X)/SQRT(X) .LT. MAXREAL
C             (ROUNDED DOWN)
C     YBIG = EXP(XBIG)/SQRT(XBIG)
C     FOR IBM 360/370 AND SIMILAR MACHINES
CR1   DATA XBIG,YBIG /177.2D0,2.7D+75/
C     FOR DEC-10, HONEYWELL, UNIVAC 1100(S.P.)
CR2   DATA XBIG,YBIG /90.2D0,6.3D+37/
C     FOR ICL 1900
CR3   DATA XBIG,YBIG /179.3D0,2.2D+76/
C     FOR CDC 7600/CYBER
CR4   DATA XBIG,YBIG /744.9D0,4.7D+321/
C     FOR UNIVAC 1100(D.P.)
CR5   DATA XBIG,YBIG /712.3D0,3.3D+307/
C     FOR DEC VAX 11/780
      DATA XBIG,YBIG /88.0D0,1.7D+37/
C
      T = DABS(X)
C     ERROR 1 TEST
      IF (T.GT.XBIG) GO TO 80
      IFAIL = 0
C     X RANGE TEST
      IF (T.GT.12.0D0) GO TO 60
C     TEST FOR MIDDLE RANGE
      IF (T.GT.4.0D0) GO TO 40
C     SMALL X
C     TEST FOR VERY SMALL X
      IF (T.GT.XVSMAL) GO TO 20
      S18AEF = 1.0D0
      GO TO 100
   20 G = DEXP(T)
      T = 0.5D0*T - 1.0D0
C
C
C     EXPANSION (0035) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y=  +3.08508323D-1+T*(  -1.86478069D-1+T*(  +1.57686847D-1+
C08  AT*(  -1.28895516D-1+T*(  +9.41615739D-2+T*(  -6.04328134D-2+
C08  BT*(  +3.41510170D-2+T*(  -1.71264378D-2+T*(  +7.69874623D-3+
C08  CT*(  -3.14217301D-3+T*(  +1.16281590D-3+T*(  -3.77327453D-4+
C08  DT*(  +1.19121179D-4+T*(  -4.67023479D-5+
C08  ET*(  +1.25170153D-5))))))))))))))
C
C     EXPANSION (0035) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y=  +3.085083225D-1+T*(  -1.864780666D-1+T*(  +1.576868468D-1+
C09  AT*(  -1.288956234D-1+T*(  +9.416157393D-2+T*(  -6.043165089D-2+
C09  BT*(  +3.415101696D-2+T*(  -1.713197375D-2+T*(  +7.698746228D-3+
C09  CT*(  -3.128640567D-3+T*(  +1.162815900D-3+T*(  -3.950426472D-4+
C09  DT*(  +1.191211786D-4+T*(  -3.489221823D-5+T*(  +1.251701532D-5+
C09  ET*(  -3.149367911D-6)))))))))))))))
C
C     EXPANSION (0035) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y=  +3.085083225537D-1+T*(  -1.864780666100D-1+
C12  AT*(  +1.576868439705D-1+T*(  -1.288956212997D-1+
C12  BT*(  +9.416163400294D-2+T*(  -6.043168004160D-2+
C12  CT*(  +3.415053905809D-2+T*(  -1.713179048190D-2+
C12  DT*(  +7.700609104316D-3+T*(  -3.129251464727D-3+
C12  ET*(  +1.158888468912D-3+T*(  -3.938874947045D-4+
C12  FT*(  +1.236706911308D-4+T*(  -3.613622861718D-5+
C12  GT*(  +9.830542086049D-6+T*(  -2.438504834571D-6+
C12  HT*(  +5.866981988794D-7+T*(  -1.672619002648D-7+
C12  IT*(  +3.552213748272D-8))))))))))))))))))
C
C     EXPANSION (0035) EVALUATED AS Y(T)  --PRECISION 15E.16
C15   Y=  +3.085083225536711D-1+T*(  -1.864780666094668D-1+
C15  AT*(  +1.576868439699908D-1+T*(  -1.288956213305214D-1+
C15  BT*(  +9.416163402029200D-2+T*(  -6.043167950086759D-2+
C15  CT*(  +3.415053883594465D-2+T*(  -1.713179479244525D-2+
C15  DT*(  +7.700610548238343D-3+T*(  -3.129232874073100D-3+
C15  ET*(  +1.158883078270167D-3+T*(  -3.939345014889662D-4+
C15  FT*(  +1.236829425904201D-4+T*(  -3.606463713226221D-5+
C15  GT*(  +9.813309263701611D-6+T*(  -2.502852637768319D-6+
C15  HT*(  +6.013460978748421D-7+T*(  -1.361952673926676D-7+
C15  IT*(  +2.862900854369717D-8+T*(  -5.841016145715136D-9+
C15  JT*(  +1.378625787804520D-9+
C15  KT*( -2.530899946655355D-10)))))))))))))))))))))
C
C     EXPANSION (0035) EVALUATED AS Y(T)  --PRECISION 17E.18
      Y=  +3.08508322553671039D-1+T*(  -1.86478066609466760D-1+
     AT*(  +1.57686843969995904D-1+T*(  -1.28895621330524993D-1+
     BT*(  +9.41616340200868389D-2+T*(  -6.04316795007737183D-2+
     CT*(  +3.41505388391452157D-2+T*(  -1.71317947935716536D-2+
     DT*(  +7.70061052263382555D-3+T*(  -3.12923286656374358D-3+
     ET*(  +1.15888319775791686D-3+T*(  -3.93934532072526720D-4+
     FT*(  +1.23682594989692688D-4+T*(  -3.60645571444886286D-5+
     GT*(  +9.81395862769787105D-6+T*(  -2.50298975966588680D-6+
     HT*(  +6.00566861079330132D-7+T*(  -1.36042013507151017D-7+
     IT*(  +2.92096163521178835D-8+T*(  -5.94856273204259507D-9+
     JT*(  +1.13415934215369209D-9+T*( -2.10071360134551962D-10+
     KT*( +4.44484446637868974D-11+
     LT*( -7.48150165756234957D-12)))))))))))))))))))))))
C
C     EXPANSION (0035) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y=  +3.0850832255367103953D-1+T*(  -1.8647806660946676075D-1+
C19  AT*(  +1.5768684396999586206D-1+T*(  -1.2889562133052496374D-1+
C19  BT*(  +9.4161634020088817344D-2+T*(  -6.0431679500774614881D-2+
C19  CT*(  +3.4150538839108284692D-2+T*(  -1.7131794793558845134D-2+
C19  DT*(  +7.7006105229899461374D-3+T*(  -3.1292328666662116016D-3+
C19  ET*(  +1.1588831957319864270D-3+T*(  -3.9393453156577578087D-4+
C19  FT*(  +1.2368260229532060075D-4+T*(  -3.6064558781683970924D-5+
C19  GT*(  +9.8139412868667807577D-6+T*(  -2.5029862046131434148D-6+
C19  HT*(  +6.0059431739522308981D-7+T*(  -1.3604724152589129050D-7+
C19  IT*(  +2.9180903864909561201D-8+T*(  -5.9434264329293442580D-9+
C19  JT*(  +1.1532002547234216346D-9+T*( -2.1329989100573818880D-10+
C19  KT*( +3.7194763684842307584D-11+T*( -6.3074904316764487680D-12+
C19  LT*( +1.2089468298240983040D-12+
C19  MT*( -1.8784179614174412800D-13)))))))))))))))))))))))))
C
      S18AEF = G*Y
      GO TO 100
C
C     MIDDLE X
   40 G = DEXP(T)
      T = 0.25D0*T - 2.0D0
C
C
C     EXPANSION (0036) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y=  +1.43431782D-1+T*(  -3.71571541D-2+T*(  +1.44861278D-2+
C08  AT*(  -6.30122230D-3+T*(  +2.89353541D-3+T*(  -1.37631504D-3+
C08  BT*(  +6.73177142D-4+T*(  -3.36290944D-4+T*(  +1.67961894D-4+
C08  CT*(  -8.59465309D-5+T*(  +5.01438907D-5+T*(  -2.55448774D-5+
C08  DT*(  +5.54416320D-6+T*(  -2.79124210D-6+T*(  +5.79902384D-6+
C08  ET*(  -2.58491708D-6)))))))))))))))
C
C     EXPANSION (0036) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y=  +1.434317819D-1+T*(  -3.715715414D-2+T*(  +1.448612352D-2+
C09  AT*(  -6.301222301D-3+T*(  +2.893626033D-3+T*(  -1.376315041D-3+
C09  BT*(  +6.724521352D-4+T*(  -3.362909444D-4+T*(  +1.708101331D-4+
C09  CT*(  -8.594653090D-5+T*(  +4.406764708D-5+T*(  -2.554487744D-5+
C09  DT*(  +1.272517843D-5+T*(  -2.791242095D-6+T*(  +1.379937549D-6+
C09  ET*(  -2.584917075D-6+T*(  +1.104771573D-6))))))))))))))))
C
C     EXPANSION (0036) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y=  +1.434317818569D-1+T*(  -3.715715425644D-2+
C12  AT*(  +1.448612373342D-2+T*(  -6.301216956565D-3+
C12  BT*(  +2.893620477892D-3+T*(  -1.376388812767D-3+
C12  CT*(  +6.725083973161D-4+T*(  -3.358360330658D-4+
C12  DT*(  +1.705260897922D-4+T*(  -8.742186248288D-5+
C12  ET*(  +4.486676250931D-5+T*(  -2.287156222189D-5+
C12  FT*(  +1.142371408329D-5+T*(  -5.461269051676D-6+
C12  GT*(  +2.577083077721D-6+T*(  -1.297962120106D-6+
C12  HT*(  +5.623121016284D-7+T*(  -1.342660594828D-7+
C12  IT*(  +5.653445311965D-8+T*(  -6.702448677965D-8+
C12  JT*(  +2.425721534790D-8))))))))))))))))))))
C
C     EXPANSION (0036) EVALUATED AS Y(T)  --PRECISION 15E.16
C15   Y=  +1.434317818568503D-1+T*(  -3.715715425660841D-2+
C15  AT*(  +1.448612373373570D-2+T*(  -6.301216944612088D-3+
C15  BT*(  +2.893620465323518D-3+T*(  -1.376389069008084D-3+
C15  CT*(  +6.725085919694947D-4+T*(  -3.358335189754990D-4+
C15  DT*(  +1.705245467454439D-4+T*(  -8.743538291189024D-5+
C15  ET*(  +4.487387831119869D-5+T*(  -2.282804400092824D-5+
C15  FT*(  +1.140334358829206D-5+T*(  -5.548439478014173D-6+
C15  GT*(  +2.614274720462510D-6+T*(  -1.189131231894508D-6+
C15  HT*(  +5.192357609897779D-7+T*(  -2.152964532328402D-7+
C15  IT*(  +8.670120481253008D-8+T*(  -3.580576522294057D-8+
C15  JT*(  +1.318013695388947D-8+T*(  -3.206544995575089D-9+
C15  KT*(  +1.127807821205358D-9+T*( -9.096828667154934D-10+
C15  LT*( +2.825585726019810D-10))))))))))))))))))))))))
C
C     EXPANSION (0036) EVALUATED AS Y(T)  --PRECISION 17E.18
      Y =
     GT*(  +2.61457634142262604D-6+T*(  -1.18752840689765504D-6+
     HT*(  +5.18632519069546106D-7+T*(  -2.17653548816447667D-7+
     IT*(  +8.75291839187305722D-8+T*(  -3.34900221934314738D-8+
     JT*(  +1.24131668344616429D-8+T*(  -4.66215489983794905D-9+
     KT*(  +1.58599776268172290D-9+T*( -3.80370174256271589D-10+
     LT*( +1.23188158175419302D-10+T*( -8.46900307934754898D-11+
     MT*( +2.45185252963941089D-11)))))))))))))
      Y=  +1.43431781856850311D-1+T*(  -3.71571542566085323D-2+
     AT*(  +1.44861237337359455D-2+T*(  -6.30121694459896307D-3+
     BT*(  +2.89362046530968701D-3+T*(  -1.37638906941232170D-3+
     CT*(  +6.72508592273773611D-4+T*(  -3.35833513200679384D-4+
     DT*(  +1.70524543267970595D-4+T*(  -8.74354291104467762D-5+
     ET*(  +4.48739019580173804D-5+T*(  -2.28278155280668483D-5+
     FT*(  +1.14032404021741277D-5+T*(  -5.54917762110482949D-6+
     GY)))))))))))))
C
C     EXPANSION (0036) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y=  +1.4343178185685031071D-1+T*(  -3.7157154256608529617D-2+
C19  AT*(  +1.4486123733735940056D-2+T*(  -6.3012169445992907185D-3+
C19  BT*(  +2.8936204653100399418D-3+T*(  -1.3763890694005676517D-3+
C19  CT*(  +6.7250859226473849510D-4+T*(  -3.3583351339688115207D-4+
C19  DT*(  +1.7052454338865393184D-4+T*(  -8.7435427266706018722D-5+
C19  ET*(  +4.4873900992550687052D-5+T*(  -2.2827826322589233732D-5+
C19  FT*(  +1.1403245405046993212D-5+T*(  -5.5491358755173967651D-6+
C19  GT*(  +2.6145587489026594806D-6+T*(  -1.1876386129043432359D-6+
C19  HT*(  +5.1867562074346417550D-7+T*(  -2.1745209965767604588D-7+
C19  IT*(  +8.7454812402950374687D-8+T*(  -3.3744232366202447987D-8+
C19  JT*(  +1.2503195511458724053D-8+T*(  -4.4459427230194587402D-9+
C19  KT*(  +1.5111687324503826760D-9+T*( -4.9724253843991245619D-10+
C19  LT*( +1.6385610938810420429D-10+T*( -4.9858650699064147968D-11+
C19  MT*( +1.1504780908334940160D-11+T*( -3.3263935102228889600D-12+
C19  NT*( +1.8591063411513098240D-12+
C19  OT*( -4.8781177932637798400D-13)))))))))))))))))))))))))))))
C
      S18AEF = G*Y
      GO TO 100
C
C     LARGE X
   60 G = DEXP(T-0.5D0*DLOG(T))
      T = 24.0D0/T - 1.0D0
C
C
C     EXPANSION (0037) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y=  +4.01071065D-1+T*(  +2.18216826D-3+T*(  +5.59827269D-5+
C08  AT*(  +2.79704810D-6+T*(  +2.22642925D-7+T*(  +2.49574115D-8)))))
C
C     EXPANSION (0037) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y=  +4.010710651D-1+T*(  +2.182168256D-3+T*(  +5.598487707D-5+
C09  AT*(  +2.797048103D-6+T*(  +2.169090557D-7+T*(  +2.495741155D-8+
C09  BT*(  +3.822579830D-9))))))
C
C     EXPANSION (0037) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y=  +4.010710650668D-1+T*(  +2.182168172172D-3+
C12  AT*(  +5.598482525317D-5+T*(  +2.797705824730D-6+
C12  BT*(  +2.171613059408D-7+T*(  +2.369586371205D-8+
C12  CT*(  +3.440923995653D-9+T*( +6.284907334603D-10+
C12  DT*( +1.579111213677D-10+T*( +7.186180190509D-11+
C12  ET*( +2.340749923654D-11))))))))))
C
C     EXPANSION (0037) EVALUATED AS Y(T)  --PRECISION 15E.16
C15   Y=  +4.010710650668474D-1+T*(  +2.182168172116796D-3+
C15  AT*(  +5.598482533619400D-5+T*(  +2.797707025776663D-6+
C15  BT*(  +2.171604498120274D-7+T*(  +2.368833843881964D-8+
C15  CT*(  +3.443856712516276D-9+T*( +6.486795836711866D-10+
C15  DT*( +1.545697718533012D-10+T*( +4.586796117551065D-11+
C15  ET*( +2.226273536199183D-11+T*( +1.547327566378010D-11+
C15  FT*( +4.496440289935385D-12+T*( -3.044730035928687D-12+
C15  GT*( -2.170471559606428D-12+
C15  HT*( -2.411756899398287D-13)))))))))))))))
C
C     EXPANSION (0037) EVALUATED AS Y(T)  --PRECISION 17E.18
      Y=  +4.01071065066847416D-1+T*(  +2.18216817211694382D-3+
     AT*(  +5.59848253337377763D-5+T*(  +2.79770701849785597D-6+
     BT*(  +2.17160501061222148D-7+T*(  +2.36884434055843528D-8+
     CT*(  +3.44345025431425567D-9+T*( +6.47994117793472057D-10+
     DT*( +1.56147127476528831D-10+T*( +4.82726630988879388D-11+
     ET*( +1.89599322920800794D-11+T*( +1.05863621425699789D-11+
     FT*( +8.27719401266046976D-12+T*( +2.82807056475555021D-12+
     GT*( -4.34624739357691085D-12+T*( -4.29417106720584499D-12+
     HT*( +4.30812577328136192D-13+T*( +1.44572313799118029D-12+
     IT*( +4.73229306831831040D-14+
     JT*( -1.95679809047625728D-13)))))))))))))))))))
C
C     EXPANSION (0037) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y=  +4.0107106506684741582D-1+T*(  +2.1821681721169444223D-3+
C19  AT*(  +5.5984825333793869167D-5+T*(  +2.7977070184547602578D-6+
C19  BT*(  +2.1716049913450601437D-7+T*(  +2.3688444310954546095D-8+
C19  CT*(  +3.4434761778711018340D-9+T*( +6.4798546599576738163D-10+
C19  DT*( +1.5596755827968609280D-10+T*( +4.8317557581369720320D-11+
C19  ET*( +1.9688661329266574848D-11+T*( +1.0449077288480794624D-11+
C19  FT*( +6.4220654560433725440D-12+T*( +3.0819891159672381440D-12+
C19  GT*( -1.2796874612755333120D-12+T*( -4.5692556020853309440D-12+
C19  HT*( -2.8976380738342092800D-12+T*( +1.5929661492722401280D-12+
C19  IT*( +2.3978847028834467840D-12+T*( -1.9782650535057817600D-13+
C19  JT*( -1.0454721503030149120D-12+T*( -3.5759472348495872000D-14+
C19  KT*( +2.7186179143945420800D-13+T*( +1.2008469636841472000D-14+
C19  LT*( -3.3144842200547328000D-14))))))))))))))))))))))))
C
      S18AEF = G*Y
      GO TO 100
C
C     ERROR 1 EXIT
   80 IFAIL = P01AAF(IFAIL,1,SRNAME)
      S18AEF = YBIG
C
  100 RETURN
      END
** END OF S18AEFTEXT
*UPTODATE S18AFFTEXT
      DOUBLE PRECISION FUNCTION S18AFF(X, IFAIL)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
C     MARK 8C REVISED. IER-269 (OCT 1980).
C     BESSEL FUNCTION I1(X)
C
C     **************************************************************
C
C     TO EXTRACT THE CORRECT CODE FOR A PARTICULAR MACHINE-RANGE,
C     ACTIVATE THE STATEMENTS CONTAINED IN COMMENTS BEGINNING  CDD ,
C     WHERE  DD  IS THE APPROXIMATE NUMBER OF SIGNIFICANT DECIMAL
C     DIGITS REPRESENTED BY THE MACHINE
C     DELETE THE ILLEGAL DUMMY STATEMENTS OF THE FORM
C     * EXPANSION  (DDDD) *
C
C     ALSO INSERT APPROPRIATE DATA STATEMENTS TO DEFINE CONSTANTS
C     WHICH DEPEND ON THE RANGE OF NUMBERS REPRESENTED BY THE
C     MACHINE, RATHER THAN THE PRECISION (SUITABLE STATEMENTS FOR
C     SOME MACHINES ARE CONTAINED IN COMMENTS BEGINNING CRD WHERE
C     D IS A DIGIT WHICH SIMPLY DISTINGUISHES A GROUP OF MACHINES).
C     DELETE THE ILLEGAL DUMMY DATA STATEMENTS WITH VALUES WRITTEN
C     *VALUE* .
C
C     **************************************************************
C
C     .. SCALAR ARGUMENTS ..
      DOUBLE PRECISION X
      INTEGER IFAIL
C     ..
C     .. LOCAL SCALARS ..
C$P 1
      DOUBLE PRECISION SRNAME
      DOUBLE PRECISION G, T, XBIG, XVSMAL, Y, YBIG
C     .. FUNCTION REFERENCES ..
      DOUBLE PRECISION DLOG, DEXP
      INTEGER P01AAF
C     ..
      DATA SRNAME /8H S18AFF /
C08   DATA XVSMAL /1.0D-4/
C09   DATA XVSMAL /3.2D-5/
C12   DATA XVSMAL /1.0D-6/
C15   DATA XVSMAL /3.2D-8/
      DATA XVSMAL /3.2D-9/
C19   DATA XVSMAL /3.2D-10/
C     XBIG = LARGEST X SUCH THAT  EXP(X)/SQRT(X) .LT. MAXREAL
C             (ROUNDED DOWN)
C     YBIG = EXP(XBIG)/SQRT(XBIG)
C     FOR IBM 360/370 AND SIMILAR MACHINES
CR1   DATA XBIG,YBIG /177.2D0,2.7D+75/
C     FOR DEC-10, HONEYWELL, UNIVAC 1100(S.P.)
CR2   DATA XBIG,YBIG /90.2D0,6.3D+37/
C     FOR ICL 1900
CR3   DATA XBIG,YBIG /179.3D0,2.2D+76/
C     FOR CDC 7600/CYBER
CR4   DATA XBIG,YBIG /744.9D0,4.7D+321/
C     FOR UNIVAC 1100(D.P.)
CR5   DATA XBIG,YBIG /712.3D0,3.3D+307/
C      FOR DEC VAX 11/780
      DATA XBIG,YBIG /88.0D0,1.7D+37/
C
      T = DABS(X)
C     ERROR 1 TEST
      IF (T.GT.XBIG) GO TO 80
      IFAIL = 0
C     X RANGE TEST
      IF (T.GT.12.0D0) GO TO 60
C     TEST FOR MIDDLE RANGE
      IF (T.GT.4.0D0) GO TO 40
C     SMALL X
C     TEST FOR VERY SMALL X
      IF (T.GT.XVSMAL) GO TO 20
      S18AFF = 0.5D0*X
      GO TO 100
   20 T = 0.125D0*T*T - 1.0D0
C
C
C     EXPANSION (0043) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y=  +1.19741655D+0+T*(  +9.28758890D-1+T*(  +2.68657662D-1+
C08  AT*(  +4.09286373D-2+T*(  +3.84762606D-3+T*(  +2.45223921D-4+
C08  BT*(  +1.13063239D-5+T*(  +3.92892854D-7)))))))
C
C     EXPANSION (0043) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y=  +1.197416550D+0+T*(  +9.287588901D-1+T*(  +2.686576622D-1+
C09  AT*(  +4.092863729D-2+T*(  +3.847626062D-3+T*(  +2.452239209D-4+
C09  BT*(  +1.130632386D-5+T*(  +3.928928537D-7)))))))
C
C     EXPANSION (0043) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y=  +1.197416549637D+0+T*(  +9.287588901146D-1+
C12  AT*(  +2.686576595217D-1+T*(  +4.092863718276D-2+
C12  BT*(  +3.847639407499D-3+T*(  +2.452243141144D-4+
C12  CT*(  +1.128497044797D-5+T*(  +3.923685392897D-7+
C12  DT*(  +1.067670554920D-8+T*( +2.330286285600D-10)))))))))
C
C     EXPANSION (0043) EVALUATED AS Y(T)  --PRECISION 15E.16
C15   Y=  +1.197416549636702D+0+T*(  +9.287588901146102D-1+
C15  AT*(  +2.686576595220928D-1+T*(  +4.092863718276363D-2+
C15  BT*(  +3.847639404238095D-3+T*(  +2.452243141144006D-4+
C15  CT*(  +1.128497957799518D-5+T*(  +3.923685392897174D-7+
C15  DT*(  +1.066627123145040D-8+T*( +2.330286285600112D-10+
C15  ET*( +4.173727097882224D-12))))))))))
C
C     EXPANSION (0043) EVALUATED AS Y(T)  --PRECISION 17E.18
      Y=  +1.19741654963670236D+0+T*(  +9.28758890114609554D-1+
     AT*(  +2.68657659522092832D-1+T*(  +4.09286371827770484D-2+
     BT*(  +3.84763940423809498D-3+T*(  +2.45224314039278904D-4+
     CT*(  +1.12849795779951847D-5+T*(  +3.92368710996392755D-7+
     DT*(  +1.06662712314503955D-8+T*( +2.32856921884663846D-10+
     ET*( +4.17372709788222413D-12+
     FT*( +6.24387910353848320D-14)))))))))))
C
C     EXPANSION (0043) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y=  +1.1974165496367023583D+0+T*(  +9.2875889011460955436D-1+
C19  AT*(  +2.6865765952209280388D-1+T*(  +4.0928637182777048352D-2+
C19  BT*(  +3.8476394042384197425D-3+T*(  +2.4522431403927890421D-4+
C19  CT*(  +1.1284979576609523316D-5+T*(  +3.9236871099639275503D-7+
C19  DT*(  +1.0666273903797298255D-8+T*( +2.3285692188466384563D-10+
C19  ET*( +4.1713516784131046400D-12+T*( +6.2438791035384832000D-14+
C19  FT*( +7.9180648970649600000D-16))))))))))))
C
      S18AFF = X*Y
      GO TO 100
C
C     MIDDLE X
   40 G = DEXP(T)
      T = 0.25D0*T - 2.0D0
C
C
C     EXPANSION (0044) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y=  +1.34142493D-1+T*(  -2.99140925D-2+T*(  +9.76020768D-3+
C08  AT*(  -3.40759200D-3+T*(  +1.17320332D-3+T*(  -3.67687996D-4+
C08  BT*(  +8.42565753D-5+T*(  +5.59728936D-6+T*(  -2.41247862D-5+
C08  CT*(  +2.35080066D-5+T*(  -2.21733453D-5+T*(  +1.36440625D-5+
C08  DT*(  -1.89739179D-6+T*(  +1.31096677D-6+T*(  -4.39594806D-6+
C08  ET*(  +2.04204709D-6)))))))))))))))
C
C     EXPANSION (0044) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y=  +1.341424933D-1+T*(  -2.991409248D-2+T*(  +9.760211205D-3+
C09  AT*(  -3.407592004D-3+T*(  +1.173129378D-3+T*(  -3.676879960D-4+
C09  BT*(  +8.484809269D-5+T*(  +5.597289356D-6+T*(  -2.644860471D-5+
C09  CT*(  +2.350800662D-5+T*(  -1.721586589D-5+T*(  +1.364406247D-5+
C09  DT*(  -7.756231083D-6+T*(  +1.310966772D-6+T*(  -7.905084934D-7+
C09  ET*(  +2.042047089D-6+T*(  -9.013598912D-7))))))))))))))))
C
C     EXPANSION (0044) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y=  +1.341424932927D-1+T*(  -2.991409238989D-2+
C12  AT*(  +9.760211025571D-3+T*(  -3.407596468626D-3+
C12  BT*(  +1.173134117233D-3+T*(  -3.676264096858D-4+
C12  CT*(  +8.480011929240D-5+T*(  +5.217818255143D-6+
C12  DT*(  -2.620655968490D-5+T*(  +2.473724235346D-5+
C12  ET*(  -1.789619803823D-5+T*(  +1.142085667417D-5+
C12  FT*(  -6.649860183496D-6+T*(  +3.523606198412D-6+
C12  GT*(  -1.805382790889D-6+T*(  +9.852042220010D-7+
C12  HT*(  -4.447215247821D-7+T*(  +1.021824254180D-7+
C12  IT*(  -4.505657546108D-8+T*(  +5.825193532379D-8+
C12  JT*(  -2.137968646738D-8))))))))))))))))))))
C
C     EXPANSION (0044) EVALUATED AS Y(T)  --PRECISION 15E.16
C15   Y=  +1.341424932926982D-1+T*(  -2.991409238974067D-2+
C15  AT*(  +9.760211025286696D-3+T*(  -3.407596479277477D-3+
C15  BT*(  +1.173134128546845D-3+T*(  -3.676261813644457D-4+
C15  CT*(  +8.479994409371570D-5+T*(  +5.215578508861103D-6+
C15  DT*(  -2.620517107156340D-5+T*(  +2.474928446808203D-5+
C15  ET*(  -1.790260037692807D-5+T*(  +1.138210964994464D-5+
C15  FT*(  -6.631537188516544D-6+T*(  +3.601181743921443D-6+
C15  GT*(  -1.838822740857724D-6+T*(  +8.884275924436715D-7+
C15  HT*(  -4.060152623900778D-7+T*(  +1.741345209187592D-7+
C15  IT*(  -7.213105372475229D-8+T*(  +3.062872297108590D-8+
C15  JT*(  -1.146662778794534D-8+T*(  +2.772708966945032D-9+
C15  KT*( -9.914352278371534D-10+T*( +8.263393060071838D-10+
C15  LT*( -2.585602855843796D-10))))))))))))))))))))))))
C
C     EXPANSION (0044) EVALUATED AS Y(T)  --PRECISION 17E.18
      Y =
     GT*(  -1.83910206626348772D-6+T*(  +8.86951515545183908D-7+
     HT*(  -4.05456611578551130D-7+T*(  +1.76305222240064495D-7+
     IT*(  -7.28978293484163628D-8+T*(  +2.84961041291017650D-8+
     JT*(  -1.07563514207617768D-8+T*(  +4.11321223904934809D-9+
     KT*(  -1.41575617446629553D-9+T*( +3.38883570696523350D-10+
     LT*( -1.10970391104678003D-10+T*( +7.79929176497056645D-11+
     MT*( -2.27061376122617856D-11)))))))))))))
      Y=  +1.34142493292698178D-1+T*(  -2.99140923897405570D-2+
     AT*(  +9.76021102528646704D-3+T*(  -3.40759647928956354D-3+
     BT*(  +1.17313412855965374D-3+T*(  -3.67626180992174570D-4+
     CT*(  +8.47999438119288094D-5+T*(  +5.21557319070236939D-6+
     DT*(  -2.62051678511418163D-5+T*(  +2.47493270133518925D-5+
     ET*(  -1.79026222757948636D-5+T*(  +1.13818992442463952D-5+
     FT*(  -6.63144162982509821D-6+T*(  +3.60186151617732531D-6+
     GY)))))))))))))
C
C     EXPANSION (0044) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y=  +1.3414249329269817831D-1+T*(  -2.9914092389740559536D-2+
C19  AT*(  +9.7602110252864721110D-3+T*(  -3.4075964792892586671D-3+
C19  BT*(  +1.1731341285593238429D-3+T*(  -3.6762618100311115229D-4+
C19  CT*(  +8.4799943820374214419D-5+T*(  +5.2155733732522876693D-6+
C19  DT*(  -2.6205167963948297248D-5+T*(  +2.4749325297973732372D-5+
C19  ET*(  -1.7902621373343015831D-5+T*(  +1.1381909286711502521D-5+
C19  FT*(  -6.6314463061664910712D-6+T*(  +3.6018226816369370946D-6+
C19  GT*(  -1.8390856219860622587D-6+T*(  +8.8705402749571279009D-7+
C19  HT*(  -4.0549690005824350650D-7+T*(  +1.7611785989651199931D-7+
C19  IT*(  -7.2828311971692262588D-8+T*(  +2.8732496785343932531D-8+
C19  JT*(  -1.0840504034690950758D-8+T*(  +3.9122095980161710162D-9+
C19  KT*(  -1.3458111447069821501D-9+T*( +4.4748047024971893965D-10+
C19  LT*( -1.4898399423473962189D-10+T*( +4.5665794931233390592D-11+
C19  MT*( -1.0541784610642067456D-11+T*( +3.0683838993620008960D-12+
C19  NT*( -1.7377647145171025920D-12+
C19  OT*( +4.5775493193216819200D-13)))))))))))))))))))))))))))))
C
      S18AFF = DSIGN(G*Y,X)
      GO TO 100
C
C     LARGE X
   60 G = DEXP(T-0.5D0*DLOG(T))
      T = 24.0D0/T - 1.0D0
C
C
C     EXPANSION (0045) EVALUATED AS Y(T)  --PRECISION 08E.09
C08   Y=  +3.92624494D-1+T*(  -6.40545370D-3+T*(  -9.12451446D-5+
C08  AT*(  -3.82721490D-6+T*(  -2.78984102D-7+T*(  -2.96738127D-8)))))
C
C     EXPANSION (0045) EVALUATED AS Y(T)  --PRECISION 09E.10
C09   Y=  +3.926244942D-1+T*(  -6.405453697D-3+T*(  -9.124761019D-5+
C09  AT*(  -3.827214904D-6+T*(  -2.724091627D-7+T*(  -2.967381267D-8+
C09  BT*(  -4.383292624D-9))))))
C
C     EXPANSION (0045) EVALUATED AS Y(T)  --PRECISION 12E.13
C12   Y=  +3.926244942041D-1+T*(  -6.405453603544D-3+
C12  AT*(  -9.124755347160D-5+T*(  -3.827950034494D-6+
C12  BT*(  -2.726853285086D-7+T*(  -2.826186206848D-8+
C12  CT*(  -3.965182881278D-9+T*( -7.068696867564D-10+
C12  DT*( -1.734215243288D-10+T*( -7.774606791952D-11+
C12  ET*( -2.533926898209D-11))))))))))
C
C     EXPANSION (0045) EVALUATED AS Y(T)  --PRECISION 15E.16
C15   Y=  +3.926244942041166D-1+T*(  -6.405453603482220D-3+
C15  AT*(  -9.124755355333729D-5+T*(  -3.827951362129912D-6+
C15  BT*(  -2.726844939064504D-7+T*(  -2.825360264463809D-8+
C15  CT*(  -3.967981996319198D-9+T*( -7.288220600471799D-10+
C15  DT*( -1.704720475191773D-10+T*( -4.984995964878307D-11+
C15  ET*( -2.360757461732030D-11+T*( -1.625784942705443D-11+
C15  FT*( -4.930682983830821D-12+T*( +3.031081657644896D-12+
C15  GT*( +2.296326081181966D-12+
C15  HT*( +2.864463574710190D-13)))))))))))))))
C
C     EXPANSION (0045) EVALUATED AS Y(T)  --PRECISION 17E.18
      Y=  +3.92624494204116555D-1+T*(  -6.40545360348237412D-3+
     AT*(  -9.12475535508497109D-5+T*(  -3.82795135453556215D-6+
     BT*(  -2.72684545741400871D-7+T*(  -2.82537120880041703D-8+
     CT*(  -3.96757162863209348D-9+T*( -7.28107961041827952D-10+
     DT*( -1.72060490748583241D-10+T*( -5.23524129533553498D-11+
     ET*( -2.02947854602758139D-11+T*( -1.11795516742222899D-11+
     FT*( -8.69631766630563635D-12+T*( -3.05957293450420224D-12+
     GT*( +4.42966462319664333D-12+T*( +4.47735589657057690D-12+
     HT*( -3.95353303949377536D-13+T*( -1.48765082315961139D-12+
     IT*( -5.77176811730370560D-14+
     JT*( +1.99448557598015488D-13)))))))))))))))))))
C
C     EXPANSION (0045) EVALUATED AS Y(T)  --PRECISION 19E.20
C19   Y=  +3.9262449420411655531D-1+T*(  -6.4054536034823746802D-3+
C19  AT*(  -9.1247553550908501103D-5+T*(  -3.8279513544952731211D-6+
C19  BT*(  -2.7268454372357710872D-7+T*(  -2.8253712929434771752D-8+
C19  CT*(  -3.9675987527407277127D-9+T*( -7.2809998359709274272D-10+
C19  DT*( -1.7187282226057648858D-10+T*( -5.2393348632806530560D-11+
C19  ET*( -2.1055276286591258112D-11+T*( -1.1056476687880072192D-11+
C19  FT*( -6.7639380417875619840D-12+T*( -3.2807424254310154240D-12+
C19  GT*( +1.2431528563850690560D-12+T*( +4.7030271230869504000D-12+
C19  HT*( +3.0522499336199864320D-12+T*( -1.5863951335214284800D-12+
C19  IT*( -2.4822246330641940480D-12+T*( +1.7181030171593932800D-13+
C19  JT*( +1.0726764420299489280D-12+T*( +4.6135638859186176000D-14+
C19  KT*( -2.7733286267020902400D-13+T*( -1.3569887628689408000D-14+
C19  LT*( +3.3679618863005696000D-14))))))))))))))))))))))))
C
      S18AFF = DSIGN(G*Y,X)
      GO TO 100
C
C     ERROR 1 EXIT
   80 IFAIL = P01AAF(IFAIL,1,SRNAME)
      S18AFF = YBIG
C
  100 RETURN
      END
** END OF S18AFFTEXT
* X02FTEXT
*UPTODATE X02AAFTEXT
      DOUBLE PRECISION FUNCTION X02AAF(X)
C     NAG COPYRIGHT 1975
C     MARK 4.5 RELEASE
      DOUBLE PRECISION X
C     * EPS *
C     RETURNS THE VALUE EPS WHERE EPS IS THE SMALLEST
C     POSITIVE
C     NUMBER SUCH THAT 1.0 + EPS > 1.0
C     THE X PARAMETER IS NOT USED
C     FOR DEC VAX 11/780
C     X02AAF = 2.0**(-56.0)
      X02AAF = 2.0D0**(-55)
      RETURN
      END
** END OF X02AAFTEXT
*UPTODATE X02ABFTEXT
      DOUBLE PRECISION FUNCTION X02ABF(X)
C     NAG COPYRIGHT 1975
C     MARK 4.5 RELEASE
      DOUBLE PRECISION X
C     * RMIN *
C     RETURNS THE VALUE OF THE SMALLEST POSITIVE REAL FLOATING-
C     POINT NUMBER EXACTLY REPRESENTABLE ON THE COMPUTER
C     THE X PARAMETER IS NOT USED
C     FOR DEC VAX 11/780
C     X02ABF = 2.0**(-128.0)
      X02ABF = 0.25 * 2.0D0**(-126)
      RETURN
      END
** END OF X02ABFTEXT
*UPTODATE X02ACFTEXT
      DOUBLE PRECISION FUNCTION X02ACF(X)
C     NAG COPYRIGHT 1975
C     MARK 4.5 RELEASE
      DOUBLE PRECISION X
C     * RMAX *
C     RETURNS THE VALUE OF THE LARGEST POSITIVE REAL  FLOATING-
C     POINT NUMBER REPRESENTABLE ON THE COMPUTER
C     FOR DEC VAX 11/780
C     X02ACF = 2.0**127*(1-2**(-56))
      X02ACF = (2.0D0**126 - 2.0D0**70) * 2.0D0
      RETURN
      END
** END OF X02ACFTEXT
*UPTODATE X02ADFTEXT
      DOUBLE PRECISION FUNCTION X02ADF(X)
C     NAG COPYRIGHT 1975
C     MARK 4.5 RELEASE
      DOUBLE PRECISION X
C     * TOL *
C     RETURNS THE RATIO OF THE SMALLEST POSITIVE REAL FLOATING-
C     POINT NUMBER REPRESENTABLE ON THE COMPUTER TO EPS
C     FOR DEC VAX 11/780
C     X02ADF = 2.0D0**(-72)
      X02ADF = 2.0D0**(-72)
      RETURN
      END
** END OF X02ADFTEXT
*UPTODATE X02AEFTEXT
      DOUBLE PRECISION FUNCTION X02AEF(X)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
      DOUBLE PRECISION X
C     * MINIMUM (LARGEST NEGATIVE) ARGUMENT FOR EXP *
C     RETURNS THE LARGEST NEGATIVE REAL NUMBER ENEG SUCH THAT
C     EXP(ENEG) CAN BE SUCCESSFULLY COMPUTED WITHOUT UNDERFLOW BY
C     THE COMPILER-SUPPLIED EXP ROUTINE.
C     THE VALUE CANNOT BE LESS THAN (I.E. MORE NEGATIVE THAN)
C     ALOG(X02ABF(X)), BUT MAY BE GREATER BECAUSE OF SPECIFIC
C     RESTRICTIONS OR LIMITATIONS IN THE EXP ROUTINE.
      X02AEF = -88.7
      RETURN
      END
** END OF X02AEFTEXT
*UPTODATE X02AGFTEXT
      DOUBLE PRECISION FUNCTION X02AGF(X)
C     MARK 8 RELEASE. NAG COPYRIGHT 1980.
C
C     RETURNS THE SMALLEST POSITIVE FLOATING-POINT NUMBER  R
C     EXACTLY REPRESENTABLE ON THE COMPUTER SUCH THAT  -R, 1.0/R,
C     AND -1.0/R CAN ALL BE COMPUTED WITHOUT OVERFLOW OR UNDERFLOW.
C     ON MANY MACHINES THE CORRECT VALUE CAN BE DERIVED FROM THOSE
C     OF X02AAF, X02ABF AND X02ACF AS FOLLOWS
C
C     IF (X02ABF(X)*X02ACF(X).GE.1.0) X02AGF = X02ABF(X)
C     IF (X02ABF(X)*X02ACF(X).LT.1.0)
C    *                            X02AGF = (1.0+X02AAF(X))/X02ACF(X)
C
C     THE CORRECT VALUE SHOULD BE DEFINED AS A CONSTANT,
C     POSSIBLY IN SOME BINARY, OCTAL OR HEXADECIMAL REPRESENTATION,
C     AND INSERTED INTO THE ASSIGNMENT STATEMENT BELOW.
C
C     X IS A DUMMY ARGUMENT
C
C     .. SCALAR ARGUMENTS ..
      DOUBLE PRECISION X
C     ..
      X02AGF = (1.0D0 + 2.0D0**(-55))/((2.0D0**126 - 2.0D0**70) * 2.0D0)
      RETURN
      END
** END OF X02AGFTEXT
*UPTODATE X02BAFTEXT
      INTEGER FUNCTION X02BAF(X)
C     NAG COPYRIGHT 1975
C     MARK 4.5 RELEASE
      DOUBLE PRECISION X
C     * BASE *
C     RETURNS THE BASE OF THE ARITHMETIC USED ON THE COMPUTER
C     THE X PARAMETER IS NOT USED
C     FOR DEC VAX 11/780
C     X02BAF = 2
      X02BAF = 2
      RETURN
      END
** END OF X02BAFTEXT
*UPTODATE X02BBFTEXT
      INTEGER FUNCTION X02BBF(X)
C     NAG COPYRIGHT 1975
C     MARK 4.5 RELEASE
      DOUBLE PRECISION X
C     * MAXINT *
C     RETURNS THE LARGEST INTEGER REPRESENTABLE ON THE COMPUTER
C     THE X PARAMETER IS NOT USED
C     FOR DEC VAX 11/780
C     X02BBF = 2147483647
      X02BBF = 2147483647
      RETURN
      END
** END OF X02BBFTEXT
*UPTODATE X02BCFTEXT
      INTEGER FUNCTION X02BCF(X)
C     NAG COPYRIGHT 1975
C     MARK 4.5 RELEASE
      DOUBLE PRECISION X
C     * MAXPW2 *
C     RETURNS THE LARGEST INTEGER TO WHICH POWER 2.0 MAY BE RAISED
C     THE X PARAMETER IS NOT USED
C     FOR DEC VAX 11/780
C     X02BCF = 126
      X02BCF = 126
      RETURN
      END
** END OF X02BCFTEXT
*UPTODATE X02BDFTEXT
      INTEGER FUNCTION X02BDF(X)
C     NAG COPYRIGHT 1975
C     MARK 4.5 RELEASE
      DOUBLE PRECISION X
C     * MINPW2 *
C     RETURNS THE LARGEST NEGATIVE INTEGER TO WHICH POWER 2.0 MAY
C     BE
C     RAISED
C     THE X PARAMETER IS NOT USED
C     FOR DEC VAX 11/780
C     X02BDF = -126
      X02BDF = -126
      RETURN
      END
** END OF X02BDFTEXT
*UPTODATE X02BEFTEXT
      INTEGER FUNCTION X02BEF(X)
C     NAG COPYRIGHT 1975
C     MARK 4.5 RELEASE
      DOUBLE PRECISION X
C     * MAXDEC *
C     RETURNS THE MAXIMUM NUMBER OF DECIMAL DIGITS THAT CAN BE
C     ACCURATELY REPRESENTED IN THE COMPUTER OVER THE WHOLE RANGE
C     OF
C     FLOATING-POINT NUMBERS.
C     THE X PARAMETER IS NOT USED.
C     FOR DEC VAX 11/780
C     X02BEF = 16
      X02BEF = 16
      RETURN
      END
** END OF X02BEFTEXT
*UPTODATE X02CAFTEXT
      INTEGER FUNCTION X02CAF(X)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
      DOUBLE PRECISION X
C     * ACTIVE SET SIZE *
C     IN A NON-PAGED ENVIRONMENT, RETURNS ZERO.
C     IN A PAGED ENVIRONMENT, RETURNS A SAFE UNDERESTIMATE OF THE
C     AMOUNT OF ACTUAL (AS OPPOSED TO VIRTUAL) STORAGE THAT IS
C     EXPECTED TO BE AVAILABLE TO A PROGRAM RUNNING UNDER TYPICAL
C     CONDITIONS (THE EXPECTED ACTIVE SET SIZE OR WORKING SET SIZE).
C     THE AMOUNT OF STORAGE IS GIVEN AS THE NUMBER OF REAL
C     VARIABLES THAT CAN BE STORED IN IT. IT IS IMPORTANT THAT
C     THE VALUE SHOULD BE AN UNDERESTIMATE RATHER THAN AN
C     OVERESTIMATE. THE VALUE IS USED BY LINEAR ALGEBRA ROUTINES TO
C     DETERMINE HOW MANY COLUMNS OF A MATRIX CAN BE HANDLED TOGETHER
C     AS A BLOCK IN THE EXPECTATION THAT THE WHOLE BLOCK CAN FIT
C     INTO ACTUAL STORAGE.
C     THE PRECISE VALUE IS NOT CRITICAL. IT DOES NOT AFFECT THE
C     NUMERICAL RESULTS, BUT MERELY THE AMOUNT OF PAGING PERFORMED
C     BY SOME ROUTINES WHEN SOLVING LARGE PROBLEMS IN A PAGED
C     ENVIRONMENT. IF IN DOUBT, SET THE VALUE TO ZERO.
C     ***** THE VALUE MAY VARY BETWEEN INSTALLATIONS *****
      X02CAF = 7680
      RETURN
      END
** END OF X02CAFTEXT
*UPTODATE X02DAFTEXT
      LOGICAL FUNCTION X02DAF(X)
C     MARK 8 RELEASE. NAG COPYRIGHT 1980.
C
C     RETURNS .FALSE. IF THE SYSTEM SETS UNDERFLOWING QUANTITIES
C     TO ZERO, WITHOUT ANY ERROR INDICATION OR UNDESIRABLE WARNING
C     OR SYSTEM OVERHEAD.
C     RETURNS .TRUE. OTHERWISE, IN WHICH CASE CERTAIN LIBRARY
C     ROUTINES WILL TAKE SPECIAL PRECAUTIONS TO AVOID UNDERFLOW
C     (USUALLY AT SOME COST IN EFFICIENCY).
C
C     X IS A DUMMY ARGUMENT
C
C     .. SCALAR ARGUMENTS ..
      DOUBLE PRECISION X
C     ..
      X02DAF = .FALSE.
      RETURN
      END
** END OF X02DAFTEXT
* X04FTEXT
*UPTODATE X04AAFTEXT
      SUBROUTINE X04AAF(I,NERR)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978
C     MARK 7C REVISED IER-190 (MAY 1979)
C     IF I = 0, SETS NERR TO CURRENT ERROR MESSAGE UNIT NUMBER
C     (STORED IN NERR1).
C     IF I = 1, CHANGES CURRENT ERROR MESSAGE UNIT NUMBER TO
C     VALUE SPECIFIED BY NERR.
C
C     *** NOTE ***
C     THIS ROUTINE ASSUMES THAT THE VALUE OF NERR1 IS SAVED
C     BETWEEN CALLS. IN SOME IMPLEMENTATIONS IT MAY BE
C     NECESSARY TO STORE NERR1 IN A LABELLED COMMON
C     BLOCK /AX04AA/ TO ACHIEVE THIS.
C
C     .. SCALAR ARGUMENTS ..
      INTEGER I, NERR
C     ..
C     .. LOCAL SCALARS ..
      INTEGER NERR1
C     ..
      DATA NERR1 /6/
      IF (I.EQ.0) NERR = NERR1
      IF (I.EQ.1) NERR1 = NERR
      RETURN
      END
** END OF X04AAFTEXT
CRYSTALS CODE FOR PUNCH
CODE FOR XPCH5S
      SUBROUTINE XPCH5S
C--PUNCH LIST 5 IN CRYSTALS FORMAT
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XUSLST/LN5,LN6
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--LOAD LIST 5 FROM THE DISC
      IF (KHUNTR (5,0, IADDL,IADDR,IADDD, -1) .LT. 0) CALL XFAL05
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--PUNCH OUT THE LIST HEADING
      CALL XPCHLH(LN5)
C--OUTPUT THE CONTENTS RECORD
      WRITE(NCPU,1000)N5,MD5LS,MD5ES,MD5BS
1000  FORMAT(13HREAD NATOM = ,I6,11H, NLAYER = ,I4,13H, NELEMENT = ,I4,
     2 11H, NBATCH = ,I4)
C--OUTPUT THE OVERALL PARAMETERS
      WRITE(NCPU,1050) STORE(L5O),STORE(L5O+1),STORE(L5O+2),
     1 STORE(L5O+3),STORE(L5O+4),STORE(L5O+5)
1050  FORMAT(8HOVERALL ,F11.6,4(1X,F9.6),1X,F17.7)
C--CHECK FOR SOME ATOMS
      IF(N5)1200,1200,1100
C--OUTPUT THE ATOMS
1100  CONTINUE
      M5 = L5
      DO 1170 K = 1, N5
C----- DONT PUNCH 'SPARE' FOR THE MOMENT - IT CAUSES PROBLEMS
C      WITH ALIEN PROGRAMS
      MD5TMP = MIN (13, MD5)
      J = M5 + MD5TMP - 1
      WRITE(NCPU,1150) (STORE(I), I = M5, J)
1150  FORMAT(5HATOM ,A4,1X,6F11.6/10HCONTINUE  ,6F11.6)
      M5 = M5 + MD5
1170  CONTINUE
C--CHECK IF THERE ARE ANY LAYER SCALES TO OUTPUT
1200  CONTINUE
      IF(MD5LS)1350,1350,1250
C--PUNCH THE LAYER SCALES
1250  CONTINUE
      M5LS=L5LS+MD5LS-1
      WRITE(NCPU,1300)(STORE(I),I=L5LS,M5LS)
1300  FORMAT(10HLAYERS    ,6F11.6/(10HCONTINUE  ,6F11.6))
C--CHECK IF THERE ARE ANY ELEMENT SCALES TO OUTPUT
1350  CONTINUE
      IF(MD5ES)1500,1500,1400
C--OUTPUT THE ELEMENT SCALES
1400  CONTINUE
      M5ES=L5ES+MD5ES-1
      WRITE(NCPU,1450)(STORE(I),I=L5ES,M5ES)
1450  FORMAT(10HELEMENTS  ,6F11.6/(10HCONTINUE  ,6F11.6))
C--CHECK IF THERE ARE ANY BATCH SCALS TO BE OUTPUT
1500  CONTINUE
      IF(MD5BS)1650,1650,1550
C--OUTPUT THE BATCH SCALE FACTORS
1550  CONTINUE
      M5BS=L5BS+MD5BS-1
      WRITE(NCPU,1600)(STORE(I),I=L5BS,M5BS)
1600  FORMAT(10HBATCH     ,6F11.6/(10HCONTINUE  ,6F11.6))
C--AND NOW THE 'END'
1650  CONTINUE
      CALL XPCHND
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPPCH , IOPLSP , 5 )
      RETURN
      END
C
C
CODE FOR XPCH5X
      SUBROUTINE XPCH5X
C--PUNCH LIST 5 IN X-RAY FORMAT
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--LOAD LIST 5
      CALL XFAL05
      IF ( IERFLG .LT. 0 ) GO TO 9900
      F=1./STORE(L5O)
      WRITE(NCPU,1000)F
1000  FORMAT(//7HSCALE  ,F10.6,4H   1)
      M5=L5
      F=4.*TWOPIS
      N=999
      DO 1400 I=1,N5
      ISTORE(M5+1)=NINT(STORE(M5+1))
      ISTORE(M5+1)=IABS(ISTORE(M5+1))
      IF(ISTORE(M5+1)-1000)1150,1050,1050
1050  CONTINUE
      ISTORE(M5+1)=N
      N=N-1
      IF(N)1100,1100,1150
1100  CONTINUE
      N=999
1150  CONTINUE
      STORE(M5+3)=STORE(M5+3)*F
      WRITE(NCPU,1200)STORE(M5),ISTORE(M5+1),STORE(M5+4),STORE(M5+5),
     2 STORE(M5+6),STORE(M5+3),STORE(M5+2)
1200  FORMAT(7HATOM   ,A3,I3,3F8.5,F6.3,F5.2)
      IF(ABS(STORE(M5+3))-UISO)1250,1350,1350
1250  CONTINUE
      J=M5+7
      K=M5+12
      WRITE(NCPU,1300)STORE(M5),ISTORE(M5+1),(STORE(L),L=J,K)
1300  FORMAT(7HUIJ    ,A3,I3,6F8.5)
1350  CONTINUE
      M5=M5+MD5
1400  CONTINUE
      RETURN
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPPCH , IOPLSP , 5 )
      END
C
C
CODE FOR XPCH5C
      SUBROUTINE XPCH5C
C---- PUNCH LIST 5 IN SHELDRICK FORMAT
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--LOAD LIST 3, TO FIND THE FORM FACTORS TO BE USED
      IF (KHUNTR (3,0, IADDL,IADDR,IADDD, -1) .LT. 0) CALL XFAL03
      IF (KHUNTR (5,0, IADDL,IADDR,IADDD, -1) .LT. 0) CALL XFAL05
      IF ( IERFLG .LT. 0 ) GO TO 9900
      M5=L5
      L5A=NFL
      M5A=L5A
      DO 1000 I=1,N5
      ISTORE(M5A)=ISTORE(M5)
      M5=M5+MD5
      M5A=M5A+1
1000  CONTINUE
C--LINK LISTS 5 AND 3
      I=KSET53(0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
      M5=L5
      M5A=L5A
      N=99
      WRITE(NCPU,1050)
1050  FORMAT(/1H )
C--PUNCH EACH ATOM  -  ONE AT A TIME
      DO 1450 I=1,N5
      ISTORE(M5)=ISTORE(M5)+1
      L=M5+4
      M=M5+6
      J=NINT(STORE(M5+1))
      J=IABS(J)
      IF(J-100)1200,1100,1100
1100  CONTINUE
      J=N
      N=N-1
      IF(N)1150,1150,1200
1150  CONTINUE
      N=99
1200  CONTINUE
C--CHECK WHETHER ISO OR ANISO
      IF(ABS(STORE(M5+3))-UISO)1250,1350,1350
1250  CONTINUE
      M5O=M5+7
      L5O=M5+12
      WRITE(NCPU,1300)ISTORE(M5A),J,ISTORE(M5),(STORE(K),K=L,M),
     2 STORE(M5+2),(STORE(K),K=M5O,L5O)
1300  FORMAT(A2,I2,I5,6F10.5,2H =/5X,4F10.5)
      GOTO 1400
1350  CONTINUE
      WRITE(NCPU,1300)ISTORE(M5A),J,ISTORE(M5),(STORE(K),K=L,M),
     2 STORE(M5+2),STORE(M5+3)
1400  CONTINUE
      M5=M5+MD5
      M5A=M5A+1
1450  CONTINUE
      RETURN
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPPCH , IOPLSP , 5 )
      RETURN
      END
C
CODE FOR XPCH38
      SUBROUTINE XPCH38
C--PUNCH LIST 38 IN CRYSTALS FORMAT
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XUSLST/LN5,LN6
      COMMON /XLST38/ L38,M38,MD38,N38 , L38GR,M38GR,MD38GR,N38GR ,
     2 L38AT,M38AT,MD38AT,N38AT , L38LK,M38LK,MD38LK,N38LK ,
     3 L38OR,M38OR,MD38OR,N38OR , L38VC,M38VC,MD38VC,N38VC
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--LOAD LIST 38 FROM THE DISC
      CALL XFAL38
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--PUNCH OUT THE LIST HEADING
      LN38 = 38
      CALL XPCHLH (LN38)
C--OUTPUT THE CONTENTS RECORD
      WRITE(NCPU,1000) N38GR, N38AT, N38LK, N38OR, N38VC
1000  FORMAT('READ NGROUP= ',I5, ' NATOM= ',I5, ' NLINK= ',I5,
     2 ' NORIGIN= ',I5, ' NVECTOR= ',I5)
C
C----- CHECK FOR SOME GROUPS
      IF(N38GR)8200,8200,1100
1100  CONTINUE
      M38GR = L38GR
      M38LK = L38LK
      M38OR = L38OR
      M38VC = L38VC
      M38AT = L38AT
C----- LOOP OVER ALL GROUPS - REMEMBER THERE IS A LINK FOR EACH GROUP.
C
      DO 2000 M38 = 1,N38GR
      I = M38GR + MD38GR -1
      WRITE(NCPU,1200) (STORE(J),J=M38GR,I)
1200  FORMAT('GROUP ',A4,1X,F5.0,1X,F4.0,4(1X,F10.5),/
     2 ('CONT      ',6(1X,F10.5)) )
      I = M38LK + MD38LK -1
      WRITE(NCPU,1250) (ISTORE(J),J=M38LK,I)
1250  FORMAT('LINK',6X,6(1X,2I5))
C
C----- ANY ATOM CARDS ?
      IF (ISTORE(M38LK +1)) 1300,1300,1400
1300  CONTINUE
      WRITE(NCAWU,1350)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1350)
      ENDIF
1350  FORMAT(1X,' LIST 38 error. A group contains no atoms ')
      GOTO 9900
1400  CONTINUE
      I = M38AT + MD38AT*ISTORE(M38LK +1) -1
      WRITE(NCPU,1450) (STORE(J),J=M38AT,I)
1450  FORMAT('ATOM      ', A4,1X,F5.0)
      M38AT = M38AT + MD38AT*ISTORE(M38LK +1)
C
C----- ANY ORIGIN CARDS ?
      IF (ISTORE(M38LK+3)) 1600,1600,1500
1500  CONTINUE
      I = M38OR + MD38OR*ISTORE(M38LK +3) -1
      WRITE(NCPU,1550) (STORE(J),J=M38OR,I)
1550  FORMAT(('ORIGIN    ', A4,6(1X,F5.0)))
      M38OR = M38OR + MD38OR*ISTORE(M38LK+3)
1600  CONTINUE
C
C----- ANY VECTOR CARDS ?
      IF (ISTORE(M38LK+5)) 1750,1750,1650
1650  CONTINUE
      I = M38VC + MD38VC*ISTORE(M38LK +5) -1
      WRITE(NCPU,1700) (STORE(J),J=M38VC,I)
1700  FORMAT(('VECTOR    ', A4,6(1X,F5.0)))
      M38VC = M38VC + MD38VC*ISTORE(M38LK+3)
1750  CONTINUE
C
      M38GR = M38GR + MD38GR
      M38LK = M38LK + MD38LK
2000  CONTINUE

C--AND NOW THE 'END'
      CALL XPCHND
      CALL XPCHUS
      RETURN
C
8200  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,8300)
      ENDIF
      WRITE(NCAWU,8300)
8300  FORMAT(' There are no GROUP definitions stored')
      GOTO 9900
C
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPPCH , IOPLSP , 38 )
      RETURN
      END
C
CODE FOR XPCH6S
      SUBROUTINE XPCH6S
C--PUNCH LIST 6 IN S.F.L.S. FORMAT
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XUSLST/LN5,LN6
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET UP LIST 6 FOR READING ONLY
      IN = 0
      CALL XFAL06(IN)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--PUNCH THE INITIAL HEADING
      CALL XPCHLH(LN6)
C--PUNCH THE 'READ', 'INPUT' AND 'FORMAT' CARDS
      WRITE(NCPU,1000)
1000  FORMAT('READ NCOEFFICIENT = 11, TYPE = FIXED, UNIT = DATAFILE' ,
     1 ', CHECK=NO' /
     2 'INPUT H K L /FO/ SIGMA(/FO/) /FC/ PHASE RATIO  /FOT/ ELEMENTS'
     4 ,' WEIGHT' /
     3 'FORMAT (3F4.0,F10.2,F8.2,F10.2,F8.4,F 6.2,F10.2,F3.0,G12.5)'/
     4 3HEND)
C--FETCH THE NEXT REFLECTION
1050  CONTINUE
      IF (KFNR(IN)) 1250, 1100, 1100
C--FIX THE INDICES
1100  CONTINUE
      J=M6+2
      DO 1150 I=M6,J
      ISTORE(I)=NINT(STORE(I))
1150  CONTINUE
C--FIX THE ELEMENTS
      ISTORE(M6+11)=NINT(STORE(M6+11))
C--PUNCH THE REFLECTION
      WRITE(NCPU,1200)(ISTORE(I),I=M6,J),STORE(M6+3),STORE(M6+12),
     2 STORE(M6+5),STORE(M6+6),STORE(M6+20),STORE(M6+10),ISTORE(M6+11),
     3 STORE(M6+4)
1200  FORMAT(3I4,F10.2,F8.2,F10.2,F8.4,F6.2,F10.2,I3,G12.5)
      GOTO 1050
C--TERMINATE THE LIST
1250  CONTINUE
      I = -512
      WRITE(NCPU,1200)I
      CALL XPCHUS
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPPCH , IOPLSP , 6 )
      RETURN
      END
C
CODE FOR XPCH6O
      SUBROUTINE XPCH6O
C--PUNCH THE OBSERVED QUANTITIES FOR EACH REFLECTION
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XUSLST/LN5,LN6
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET UP LIST 6 FOR READING ONLY
      IN = 0
      CALL XFAL06(IN)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--PUNCH THE INITIAL HEADING
      CALL XPCHLH(LN6)
C--PUNCH THE 'READ', 'INPUT' AND 'FORMAT' CARDS
      WRITE(NCPU,1000)
1000  FORMAT(53HREAD NCOEFFICIENT = 12, TYPE = FIXED, UNIT = DATAFILE ,
     1  10H, CHECK=NO/
     2 41HINPUT H K L /FO/ SIGMA(/FO/) JCODE RATIO ,
     3 38H BATCH TBAR CORRECTIONS /FOT/ ELEMENTS/14HFORMAT (3F4.0,,
     4 44HF10.2,F8.2,F3.0,F7.1,F3.0,2E12.5,F10.2,F3.0)/3HEND)
C--FETCH THE NEXT REFLECTION
1050  CONTINUE
      IF (KFNR(IN)) 1250, 1100, 1100
C--FIX THE INDICES
1100  CONTINUE
      J=M6+2
      DO 1150 I=M6,J
      ISTORE(I)=NINT(STORE(I))
1150  CONTINUE
C--FIX THE ELEMENTS
      ISTORE(M6+11)=NINT(STORE(M6+11))
C--FIX THE 'JCODE', 'SERIAL' AND 'BATCH'
      ISTORE(M6+18)=NINT(STORE(M6+18))
      ISTORE(M6+13)=NINT(STORE(M6+13))
      ISTORE(M6+19)=NINT(STORE(M6+19))
C--PUNCH THE REFLECTION
      WRITE(NCPU,1200)(ISTORE(I),I=M6,J),STORE(M6+3),STORE(M6+12),
     2 ISTORE(M6+18),STORE(M6+20),ISTORE(M6+13),STORE(M6+9),
     3 STORE(M6+27),STORE(M6+10),ISTORE(M6+11)
1200  FORMAT(3I4,F10.2,F8.2,I3,F7.1,I3,2E12.5,F10.2,I3)
      GOTO 1050
C--TERMINATE THE LIST
1250  CONTINUE
      I = -512
      WRITE(NCPU,1200)I
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPPCH , IOPLSP , 6 )
      RETURN
      END
C
CODE FOR XPCH6G
      SUBROUTINE XPCH6G(IN)
C--GENERAL COMPRESSED PUNCHING ROUTINES FOR LIST 6
C
C  IN  THE TYPE OF PUNCHING REQUIRED :
C
C      -1  '/FO/', OR '/FOT/' AND 'ELEMENTS', DEPENDING UPON LIST 13.
C       0  AS FOR -1, EXCEPT THAT 'RATIO' IS ALSO PUNCHED.
C
C--THE INITIAL INDICES FOR EACH KL GROUP APPEAR ON A SEPARATE CARD.
C  THE END OF EACH KL GROUP IS INDICATED BY A NEGATIVE CARD SEQUENCE
C  NUMBER FOR THE LAST CARD.
C
C--THE FORMAT OF EACH CARD IS   (HSTEP  KEY1  KEY2  .  .)  REPEATED
C  THE 'HSTEP' GIVES THE INCREMENT FROM THE LAST REFLECTION, SO THAT THE
C  DATA MUST BE SORTED.
C
C--INDEX STEPS WHICH ARE NEGATIVE LEAD TO THE REFLECTION BEING REJECTED
C  ON INPUT.
C
C--
      DIMENSION ISTORE(131072)
C
      DIMENSION AA(5),IPOS(5)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XUSLST/LN5,LN6
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C----- INTERCHANGE THE ROLES OF 'IN'
      IN = -1 -IN
C--INCREMENT THE VALUE OF 'IN'
      IN=IN+2
C--SET THE NUMBER OF COEFFICIENTS, APART FROM THE INDICES
      NW=IN
C--LOAD LIST 13
      CALL XFAL13
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CHECK IF THIS STRUCTURE IS TWINNED
      IF(ISTORE(L13CD+1))1050,1000,1000
C--TWINNED  -  ADJUST 'IN' AND 'NW'
1000  CONTINUE
      IN=IN+2
      NW=IN-1
C--CLEAR THE CORE
1050  CONTINUE
      CALL XRSL
      CALL XCSAE
C--SET UP LIST 6 FOR INPUT
      IN1 = 0
      CALL XFAL06(IN1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--BRANCH ON THE INPUT TYPE
      GOTO(1200,1150,1300,1250,1100),IN
1100  STOP 230
C--/FO/ AND RATIO
1150  CONTINUE
      IPOS(2)=M6+20
C--/FO/
1200  CONTINUE
      IPOS(1)=M6+3
      GOTO 1350
C--/FOT/, ELEMENTS AND RATIO
1250  CONTINUE
      IPOS(3)=M6+20
C--/FOT/ AND ELEMENTS
1300  CONTINUE
      IPOS(1)=M6+10
      IPOS(2)=M6+11
C--FIND THE MULTIPLIERS
1350  CONTINUE
      DO 1450 I=1,NW
      M6DTL=L6DTL+MD6DTL*(IPOS(I)-M6)
C--CHECK IF THERE ARE ANY DETAILS STORED
      AA(I)=1.
      IF(STORE(M6DTL+3)-ZERO)1450,1400,1400
C--COMPUTE THE MULTIPLIER
1400  CONTINUE
      AA(I)=999./STORE(M6DTL+1)
1450  CONTINUE
C--CHECK IF THIS IS FOR A TWINNED CRYSTAL
      IF(IN-2)1550,1550,1500
C--TWINNED  -  MULTIPLIER FOR ELEMENTS IS 1.0
1500  CONTINUE
      AA(2)=1.
C--PUNCH THE LIST TYPE
1550  CONTINUE
      CALL XPCHLH(LN6)
C--PUNCH THE 'READ' CARD
      I=NW+3
      WRITE(NCPU,1600)I
1600  FORMAT(20HREAD NCOEFFICIENT = ,I5,
     2 36H, TYPE = COMPRESSED, UNIT = DATAFILE)
C--CHECK FOR A TWINNED STRUCTURE
      IF(IN-2)1650,1650,1750
C--NOT TWINNED
1650  CONTINUE
      WRITE(NCPU,1700)(IB,I=1,IN)
1700  FORMAT(20HINPUT  H  K  L  /FO/,2A1,5HRATIO)
      GOTO 1850
C--TWINNED STRUCTURE
1750  CONTINUE
      WRITE(NCPU,1800)(IB,I=3,IN)
1800  FORMAT(31HINPUT  H  K  L  /FOT/  ELEMENTS,2A1,5HRATIO)
C--OUTPUT THE MULTIPLIERS
1850  CONTINUE
      WRITE(NCPU,1900)(AA(I),I=1,NW)
1900  FORMAT(28HMULTIPLIERS  1.0  1.0  1.0  ,3F17.9)
      CALL XPCHND
C--SET UP A FEW INITIAL CONSTANTS
      CALL XPCHIN(80)
      IK1=-1000000
C--FETCH THE NEXT REFLECTION
1950  CONTINUE
      IF (KFNR(IN1)) 2400, 2000, 2000
C--COMPUTE THE INDICES
2000  CONTINUE
      JH=NINT(STORE(M6))
      IK=NINT(STORE(M6+1))
      IL=NINT(STORE(M6+2))
C--CHECK IF 'K' HAS CHANGED SINCE THE LAST REFLECTION
      IF(IK-IK1)2200,2050,2200
C--'K' HAS NOT CHANGED  -  CHECK IF 'L' HAS CHANGED
2050  CONTINUE
      IF(IL-IL1)2200,2100,2200
C--THIS IS THE SAME 'KL' PAIR  -  OUTPUT 'H' AND THE COEFFICIENTS
2100  CONTINUE
      CALL XPCHAR(JH)
      DO 2150 M=1,NW
      L=IPOS(M)
      I=NINT(STORE(L)*AA(M))
      CALL XPCHAR(I)
2150  CONTINUE
      GOTO 1950
C--CHANGE 'KL' PAIRS  -  OUTPUT THE TERMINATOR
2200  CONTINUE
      IF(IK1+1000000)2250,2350,2250
C--THIS IS NOT THE FIRST REFLECTION
2250  CONTINUE
      CALL XPCHAR(512)
C--CHECK IF 'L' HAS CHANGED
      IF(IL-IL1)2300,2350,2300
C--NEW LINE FOR NEXT 'L' VALUE
2300  CONTINUE
      CALL XPCHLL
2350  CONTINUE
      CALL XPCHAR(IK)
      CALL XPCHAR(IL)
      IK1=IK
      IL1=IL
      GOTO 2100
C--END OF THE REFLECTIONS  -  OUTPUT THE TERMINATOR
2400  CONTINUE
      CALL XPCHAR(-512)
      CALL XPCHLL
      CALL XPCHUS
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPPCH , IOPLSP , 6 )
      END
C
CODE FOR XPCHIN
      SUBROUTINE XPCHIN(IN)
C--INITIATE PUNCHING CONSTANTS
C
C  IN  NUMBER OF CHARACTERS ON A LINE
C
C--THIS SET OF ROUTINES USES THE VARIABLES IN 'XWORKA' :
C
C  JO  BOTTOM LOCATION MINUS ONE FOR THE OUTPUT ARRAY
C  JP  BOTTOM LOCATION FOR THE OUTPUT ARRAY
C  JQ  TOP LOCATION FOR THE OUTPUT ARRAY PLUS TWO
C  JR  TOP LOCATION FOR THE OUTPUT ARRAY
C  JS  CURRENT POSITION IN THE OUTPUT ARRAY
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
C
      IREC=7501
C--SET UP THE CONSTANTS
      JO=NFL-1
      JP=NFL
      JQ=KCHNFL(IN+1)
      JR=JQ-2
      JS=JO
      RETURN
      END
C
CODE FOR XPCHAR
      SUBROUTINE XPCHAR(N)
C--OUTPUT A NUMBER TO THE BUFFER
C
C  N  THE NUMBER TO BE OUTPUT
C
C--
C
C
      DIMENSION IT(20)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--INSERT THE FINAL BLANK
      M=1
      IT(M)=IB
      I=IABS(N)
C--CHECK IF THE VALUE IS ZERO
      IF(I)1050,1000,1050
C--THE VALUE IS ZERO
1000  CONTINUE
      M=2
      IT(M)=NUMB(1)
      GOTO 1200
C--PROCESS THE NEXT NUMBER
1050  CONTINUE
      J=I
      I=I/10
      J=J-I*10
      M=M+1
      IT(M)=NUMB(J+1)
      IF(I)1100,1100,1050
C--CHECK THE SIGN OF THE INPUT NUMBER
1100  CONTINUE
      IF(N)1150,1200,1200
C--INSERT THE NEGATIVE SIGN
1150  CONTINUE
      M=M+1
      IT(M)=MINUS
C--CHECK IF THERE IS ROOM FOR THIS NUMBER IN THE CORE BUFFER
1200  CONTINUE
      IF(JS+M-JQ)1300,1250,1250
C--PRINT THE LAST CARD
1250  CONTINUE
      CALL XPCHLL
C--OUTPUT THE LAST NUMBER
1300  CONTINUE
      JS=JS+M
      J=JS
      DO 1350 I=1,M
      ISTORE(J)=IT(I)
      J=J-1
1350  CONTINUE
      RETURN
      END
C
CODE FOR XPCHLL
      SUBROUTINE XPCHLL
C--OUTPUT THE LAST CARD THAT HAS BEEN ASSEMBLED
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--PUNCH THE LAST CARD
      JS=MIN0(JS,JR)
      WRITE(NCPU,1000)(ISTORE(I),I=JP,JS)
1000  FORMAT(80A1)
      JS=JO
      RETURN
      END
C
CODE FOR XPCHLH
      SUBROUTINE XPCHLH(IN)
C--PUNCH OUT THE LIST HEADING
C
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      CALL XDATE(A,B)
      CALL XTIME(C,D)
      WRITE(NCPU,1000)IH,IH,A,B,C,D,IH,IH,IN
1000  FORMAT(A1,79X/A1,12H Punched on ,2A4,4H at ,2A4,47X
     1 /A1,79X/A1,4HLIST,I7,68(' '))
      RETURN
      END
C
CODE FOR XPCHND
      SUBROUTINE XPCHND
C--PUNCH OUT AN 'END'
C
C--
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      WRITE(NCPU,1000)
1000  FORMAT(3HEND,77(' '))
      RETURN
      END
C
C
CODE FOR XPCHUS
      SUBROUTINE XPCHUS
C
C----- WRITE A 'USE' CARD
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
C
      WRITE ( NCPU , 1000 ) IH
1000  FORMAT( A1, 'USE LAST', 71(' '))
      RETURN
      END

C
C
C
CODE FOR XPCHLX
      SUBROUTINE XPCHLX(NUMB,IADDD,LENGRP,NGRP)
C--PUNCH A CARD IMAGE PRODUCED BY THE LEXICAL SCANNER.
C      (SEE ALSO XPRTLC)
C
C  NUMB    THE CARD NUMBER.
C  IADDD   THE DISC ADDRESS OF THE LOGICAL CARD.
C  LENGRP  THE LENGTH OF EACH REAL CARD.
C  NGRP    THE NUMBER OF REAL CARDS IN THIS LOGICAL CARD.
C
C--
      CHARACTER *88 CLINE
C
      DIMENSION CARD(20)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C--MARK THIS AS THE FIRST REAL CARD
      J=0
C--FIND THE ADDRESS AND LENGTH POINTERS
      N=NGRP
      M=LENGRP
      L=IADDD
C--FIND THE LENGTH TO PRINT
      K=MIN0(M,20)
C--CHECK IF THERE ARE MORE CARDS TO PRINT
1000  CONTINUE
      IF(N)1050,1050,1100
C--NO MORE CARDS  -  RETURN
1050  CONTINUE
      RETURN
C--READ THIS IMAGE DOWN
1100  CONTINUE
      CALL XDOWNF(L,CARD(1),K)
C--UPDATE THE POINTERS
      L=L+KINCRF(M)
      N=N-1
C--CHECK IF THIS IS THE FIRST CARD
      WRITE(CLINE,1200)  CARD
      CALL XCTRIM (CLINE, NCHAR)
      KK = MIN0 ( 80, NCHAR)
      WRITE(NCPU,'(A)')  CLINE(1:KK)
      IF (NCHAR .GE. 81) THEN
       KK = KK + 1
       WRITE(NCPU,'(A)')  CLINE(KK:NCHAR)
      ENDIF
1200  FORMAT(20A4)
      J=1 + J
      GOTO 1000
      END

CRYSTALS CODE FOR SCRIPT
CODE FOR KSCPRC
      FUNCTION KSCPRC ( CINPUT , IUSLEN )
C
C -- MAIN SCRIPT PROCESSING ROUTINE FOR CRYSTALS
C
C -- THIS ROUTINE TAKES THE INPUT LINES, READ FROM A SCRIPT FILE
C    AND GENERATES COMMANDS THAT CAN BE USED IN THE NORMAL WAY BY
C    CRYSTALS.
C
C -- INPUT ARGUMENTS :-
C
C      CINPUT      INPUT TEXT READ FROM SCRIPT FILE
C      IUSLEN      USEABLE LENGTH OF 'CINPUT'
C
C -- RETURN VALUE ( KSCPRC ) :-
C
C      -VE,0       GET NEW LINE FROM INPUT DEVICE IMMEDIATELY
C      +1          PRINT LINE IN BUFFER AS PLAIN TEXT
C      +2          TREAT DATA IN BUFFER AS A COMMAND
C      +3          SEND DATA IN BUFFER BACK TO SCRIPT PROCESSOR
C
C
C
C
      CHARACTER*(*) CINPUT
C
C
C
C      HISTORY
C            ( THIS HISTORY BEGINS WITH THE FIRST RELEASE VERSION OF
C            'SCRIPT'. THERE WERE A NUMBER OF IMPLEMENTATIONS, WHICH
C             HAVE LEFT OBVIOUS TRACES, BEFORE VERSION 1 )
C
C      VERSION           DATE        DESCRIPTION
C
C      1.00              MARCH 1985  INITIAL VERSION OF 'SCRIPT'
C
C      2.00              MAY 1985    INITIAL RELEASE OF VERSION 2.
C                                    THE ONLY MAJOR CHANGES WITH RESPECT
C                                    TO VERSION 1 ARE IN THE COMMENTS.
C
C      2.01                          ADD 'IDENTIFY' COMMAND. CORRECT
C                                    INPUT SYNTAX FOR 'CASE'.
C      2.02                          MOVE CONVERSION TO UPPERCASE, AND
C                                    REDUCE VOLUME CONVERTED.
C
C      2.10                          ADD NEW STACK ITEM 'JSTLVL'.
C      2.11                          DELETE REDUNDANT MESSAGE IN KSCADR.
C                                    IMPROVE INITIALISATION OF FIRST
C                                    STACK FRAME.
C                                    MAKE KSCSTK RETURN INFORMATION FROM
C                                    OUTER STACK FRAMES.
C
C      2.20                          INTRODUCE AN 'OUTWARD' SEARCH FOR
C                                    IDENTIFIERS
C
C      2.30                          ADD CHARACTER DATA TYPE, WITH
C                                    NECESSARY CHANGES TO EXPRESSION
C                                    EVALUATION ETC.
C                                    ADD 'TRANSFER' INSTRUCTION.
C                                    REMEMBER ENDS OF STRUCTURES.
C      2.31                          CONVERT ALL CALLS TO 'KSCEXP' TO
C                                    INCLUDE LOWERCASE COPY OF SOURCE
C                                    DATA FOR CHARACTER CONSTANTS.
C                                    ADD 'UPPERCASE' OPERATOR FOR
C                                    EXPRESSIONS
C      2.32                          CHECK ARGUMENTS IN XSCMSG. FIX
C                                    DIAGNOSTIC MESSAGE IN KSCEXE.
C                                    RENAME 'DIRECT' INTERRUPT TO
C                                     'QUIT'
C                                    MOVE SCRIPT UNIT NUMBERS TO XUNITS
C      2.33                          RENAME 'XSCPSH' AND 'XSCPOP' TO
C                                    'XSCFRM' AND 'XSCRST'. MINOR
C                                    CORRECTIONS TO EXPRESSIONS. ADD AN
C                                    AMBIGUITY CHECK IN 'KSCVAL'. REMOVE
C                                    REQUIREMENT FOR EACH CLASS OF
C                                    MESSAGE TO HAVE CONTIGUOUS NUMBERS
C
C      2.34                          RESTORE 'DIRECT' INTERRUPT
C
C      2.35                          ADD FACILITY FOR PROVIDING A
C                                    VALIDATION EXPRESSION IN 'GET'. ADD
C                                    NEW USER MESSAGE TYPE. USE
C                                    EXPRESSIONS FOR PROMPT AND DEFAULT
C                                    VALUE IN 'GET'. MAKE '>=' WORK.
C                                    CORRECTION TO AMBIGUITY CHECK IN
C                                    'KSCVAL'. HANDLE 'END ...' AFTER
C                                    ERROR FLAG SET.
C
C      2.50                          REMOVE ALL 'LABEL' INSTRUCTIONS.
C                                    REPLACE LARGE IF...ENDIF CONSTRUCTS
C                                    WITH COMPUTED GOTOS. CHECK LENGTH
C                                    OF DATA STORED IN BUFFER BY 'GET'
C                                    FIX UNARY '-' OF REAL VALUES; FIX
C                                    CASE OF 'NO DEFAULT' IN FIRST 'GET'
C
C       2.51       AUG 89            STORE SCRIPT NAME IN KSCSCT, AND
C                                    ENABLE SMG MENU SELECTION IN KSCVAL
C
C
C      *****************************************************************
C      *****                KNOWN PROBLEMS / ERRORS                *****
C      *****************************************************************
C
C      COMPONENT   PROBLEM/ERROR
C      ---------   -------------
C
C      TYPE        ISSUE OF A #TYPE COMMAND FROM AN SMG MENU IN A TASK
C                  WHICH HAS NOT BEEN INTO DIRECT MODE CAUSES THE FILE
C                  TO BE DISPLAYED WITHOUT WAITING FOR 'RETURNS' AFTER
C                  EACH PAGE.
C      FILE OPEN   FILE OPEN ERRORS FROM A TASK WHICH HAS BEEN IN DIRECT
C                  MODE CAUSE THE SCTIOT TO EXIT EVEN IF AN ERROR HANDLE
C                  IS SET.
C
C      SCRIPT      VERIFICATION OF LONG SCRIPT COMMAND LINES CAUSES
C                  OUTPUT OVERFLOW. LINES SHOULD BE BROKEN DOWN TO ONE
C                  SCREEN WIDTH.
C
C                  INSTRUCTIONS WHICH APPEND DATA TO INTERNAL COMMAND
C                  BUFFER SHOULD CHECK THAT THIS BUFFER HAS NOT BEEN
C                  OVERFILLED. ( 'INSERT', 'STORE' ETC. ) - DONE FOR
C                  'GET'
C
C                  WHEN AN ERROR IS DETECTED IN A BLOCK WITH NO ERROR
C                  CONTINGENCY, THE 'JWASEX' FLAG SHOULD BE SET, AS
C                  WELL AS CLEARING 'JEXECU', TO AVOID PROBLEMS WITH
C                  'ELSE'.
C
C                  WHEN EXECUTION OF A BLOCK IS ABANDONED BECAUSE OF AN
C                  ERROR, THERE SHOULD BE A CHECK TO SEE IF THE END OF
C                  THE CURRENT BLOCK IS KNOWN.
C
C      USER INPUT  THERE IS NO WAY OF CHANGING THE INTERRUPT STRINGS.
C
C                  THE INPUT ',1' AS A RESPONSE TO A 'GET REAL' DOES NOT
C                  GENERATE AN ERROR, BUT LEADS TO FAILURE LATER WHEN
C                  THE INPUT STRING IS ACTUALLY USED BY 'CRYSTALS'
C
C      'STORE'     USING 'STORE KEYWORD' WITH AN OUT OF RANGE EXPRESSION
C                  DOES NOT GENERATE AN ERROR.
C
C      IDENTIFIERS THERE IS NO CHECK THAT IDENTIFIERS ARE VALID. FOR
C                  INSTANCE, IDENTIFIERS LONGER THAN 12 CHARACTERS
C                  WILL NOT WORK, BUT THERE IS NO CHECK. THE FIRST
C                  CHARACTER OF ANY IDENTIFIER SHOULD BE ALPHABETIC
C
C      *****************************************************************
C
C
C
C
C      *****************************************************************
C      *****                BRIEF TABLE OF CONTENTS                *****
C      *****************************************************************
C
C      NAME        GROUP             DESCRIPTION
C      ----        -----             -----------
C      KSCPRC      MAIN              MAIN SCRIPT PROCESSOR ROUTINE
C
C      KSCACT      MISC              ACTIVATE CONTINGENCY
C      KSCADR      MISC              INPUT VARIABLE NAME
C      KSCCNT      COMMAND           'ON'
C      KSCELS      COMMAND           'ELSE'
C      KSCEST      EXPRESSIONS       PROCESS STANDARD VALUES
C      KSCETR      COMMAND           'EXTRACT'
C      KSCEVL      COMMAND           'EVALUATE'
C      KSCEXE      EXPRESSIONS       EXECUTE INTERPRETED EXPRESSION
C      KSCEXP      EXPRESSIONS       INTERPRET EXPRESSION
C      KSCEXT      COMMAND           'EXTERNAL'
C      KSCIDN      IDENTIFIERS       STORE/FIND IDENTIFIERS
C      KSCINT      INPUT PROCESSING  HANDLE INTERRUPTS
C      KSCINX      COMMAND           'INDEX'
C      KSCQUE      COMMAND           'QUEUE'
C      KSCREL      EXPRESSIONS       RELATIONAL FUNCTIONS
C      KSCSAD      STRINGS           ALLOCATE DESCRIPTOR
C      KSCSCD      STRINGS           MOVE CHARACTERS TO DESCRIPTOR
C      KSCSCT      COMMAND           'STRUCTURE' TYPE COMMANDS AND 'END'
C      KSCSDC      STRINGS           MOVE DESCRIPTOR TO CHARACTERS
C      KSCSDD      STRINGS           MOVE DESCRIPTOR TO DESCRIPTOR
C      KSCSET      COMMAND           'SET'
C      KSCSHW      COMMAND           'SHOW'
C      KSCSRE      STRINGS           RELATIONAL FUNCTIONS
C      KSCSTK      STACK             GET INFORMATION FROM STACK
C      KSCSTR      COMMAND           'STORE'
C      KSCTRA      COMMAND           'TRANSFER'
C      KSCTRN      MISC              TRANSFER DATA TO/FROM VARIABLE
C      KSCUMS      COMMAND           'MESSAGE'
C      KSCVAL      COMMAND           'GET'
C      KSCVAR      COMMAND           'VARIABLE'
C      XSCFRM      STACK             CREATE NEW STACK FRAME
C      XSCJMP      MISC              PERFORM JUMP TO LABEL
C      XSCMSG      MISC              OUTPUT DIAGNOSTIC MESSAGES
C      XSCRST      STACK             REMOVE CURRENT STACK FRAME
C      XSCSNM      MISC              GENERATE UNIQUE STRUCTURE NAME
C      XSCSTU      STACK             UPDATE CURRENT STACK FRAME
C
C      *****************************************************************
C
C
C
C
C      *****************************************************************
C      *****     ROUTINES INVOLVED IN EXECUTION OF EACH COMMAND    *****
C      *****************************************************************
C
C      ( EXECUTION ROUTINE IS SHOWN ONLY IF DIFFERENT FROM 'INPUT' )
C
C      COMMAND           INPUT       EXECUTION
C      -------           -----       ---------
C      BLOCK             KSCSCT
C      CASE              KSCSCT
C      IF                KSCSCT
C      LOOP              KSCSCT
C      SCRIPT            KSCSCT
C
C      ACTIVATE          KSCPRC      KSCACT
C      BRANCH            KSCPRC                        (OBSOLETE)
C      CLEAR             KSCPRC
C      COPY              KSCPRC
C      DECREMENT         KSCPRC                        (OBSOLETE)
C      ELSE              KSCELS
C      END               KSCPRC      KSCSCT
C      ERROR             KSCPRC                        (OBSOLETE)
C      EVALUATE          KSCEVL
C      EXECUTE           KSCPRC
C      EXTERNAL          KSCEXT
C      EXTRACT           KSCETR
C      FINISH            KSCPRC
C      GET               KSCVAL
C      IDENTIFY          KSCPRC
C      INDEX             KSCINX
C      INSERT            KSCPRC
C      JUMP              KSCPRC                        (OBSOLETE)
C      LABEL             KSCPRC                        (OBSOLETE)
C      MESSAGE           KSCUMS
C      ON                KSCCNT
C      QUEUE             KSCQUE
C      SELECT            KSCPRC                        (OBSOLETE)
C      SEND              KSCPRC
C      SET               KSCSET
C      SHOW              KSCSHW
C      STORE             KSCSTR
C      TRANSFER          KSCTRA
C      VARIABLE          KSCVAR
C      VERIFY            KSCPRC
C
C      *****************************************************************
C
C
C
C
C      *****************************************************************
C      *****      ROUTINES INVOLVED IN EACH UTILITY FUNCTION       *****
C      *****************************************************************
C
C      FUNCTION          ROUTINE     ACTION
C      --------          -------     ------
C      EXPRESSIONS       KSCEXP      INTERPRET EXPRESSION. CONVERT INPUT
C                                    TEXT INTO A REVERSE POLISH ORDERED
C                                    LIST OF VALUES AND OPERATORS. CALL
C                                    'KSCEXE' TO CALCULATE VALUE. RETURN
C                                    CALCULATED VALUE.
C                        KSCEXE      EXECUTE INTERPRETED EXPRESSION. USE
C                                    THE OUTPUT OF 'KSCEXP' TO CALCULATE
C                                    EXPRESSION VALUE.
C                        KSCREL      RELATIONAL FUNCTIONS. EVALUATE
C                                    RELATIONS ( EQUALS, LESS THAN )
C                                    BETWEEN DATA ITEMS.
C                        KSCEST      PROCESS STANDARD VALUES. CONVERT
C                                    TEXT REPRESENTATIONS OF STANDARD
C                                    VALUES TO NUMERIC FORM.
C
C      IDENTIFIERS       KSCIDN      STORE IDENTIFIERS IN TABLE. LOCATE
C                                    IDENTIFIERS IN TABLE.
C
C      INPUT PROCESSING  KSCINT      HANDLE INTERRUPTS.
C
C      STACK             XSCFRM      CREATE NEW STACK FRAME. THE FRAME
C                                    IS GENERATED ACCORDING TO A SERIES
C                                    OF INSTRUCTIONS ENCODED IN DATA IN
C                                    THIS ROUTINE.
C      STACK             XSCRST      REMOVE CURRENT STACK FRAME. OUTER
C                                    FRAME IS USED TO CONTINUE EXECUTION
C      STACK             KSCSTK      GET INFORMATION FROM STACK. READ
C                                    ONE ITEM FROM CURRENT OR OUTER
C                                    STACK FRAME.
C      STACK             XSCSTU      UPDATE ONE ITEM IN CURRENT STACK
C                                    FRAME.
C
C      STRINGS           KSCSAD      ALLOCATE DESCRIPTOR.
C      STRINGS           KSCSCD      MOVE CHARACTERS TO DESCRIPTOR.
C      STRINGS           KSCSDC      MOVE DESCRIPTOR TO CHARACTERS
C      STRINGS           KSCSDD      MOVE DESCRIPTOR TO DESCRIPTOR
C      STRINGS           KSCSRE      RELATIONAL FUNCTIONS ON DATA HELD
C                                    IN DESCRIPTORS
C
C      MISC              KSCACT      ACTIVATE CONTINGENCY.
C      MISC              KSCADR      INPUT VARIABLE NAME. ( OBSOLETE
C                                    ROUTINE USED BY BRANCH, DECREMENT
C                                    ETC. )
C      MISC              KSCTRN      TRANSFER DATA TO/FROM VARIABLE.
C                                    INTERFACE TO REST OF 'CRYSTALS'
C      MISC              XSCJMP      PERFORM JUMP TO LABEL. ( OBSOLETE
C                                    ROUTINE USED BY 'JUMP' ETC. )
C      MISC              XSCMSG      OUTPUT DIAGNOSTIC MESSAGES FOR
C                                    SCRIPT INSTRUCTION SYNTAX ERRORS.
C      MISC              XSCSNM      GENERATE UNIQUE STRUCTURE NAME.
C
C      *****************************************************************
C
C
C
C
C      *****************************************************************
C      *****           USEFUL CHANGES THAT COULD BE MADE           *****
C      *****************************************************************
C
C      GENERAL     PRODUCE A SINGLE INPUT PROCESSING ROUTINE, TO HANDLE
C                  ALL SCRIPT COMMAND INPUT. THIS WOULD REMOVE LARGE
C                  AMOUNTS OF COMMON CODE.
C
C                  REMOVE LABEL PROCESSING CODE; THE COMMAND NAMES HAVE
C                  BEEN REMOVED, SO THE CODE IS INACCESSIBLE
C
C                  REMOVE OLD INSTRUCTIONS FOR MOVING TEXT, SUCH AS
C                  'COPY', 'INSERT' ETC., AND REPLACE BY 'TRANSFER'
C
C                  MAINTAIN AN ARRAY FOR GENERAL DATA STORAGE, SIMILAR
C                  TO 'STORE'/'ISTORE' IN THE MAIN PROGRAM.
C
C      EXPRESSIONS HOLD INTERMEDIATE CODE AND WORKING STACKS IN GENERAL
C                  STORAGE.
C
C                  DO NOT DESTROY INTERPRETED CODE DURING EXECUTION
C                  PHASE
C
C      STACK       BREAK STACK FRAME INTO FOUR COMPONENTS; GLOBAL FRAME
C                  FOR VERIFICATION CONSTANTS ETC., FILE FRAME FOR EACH
C                  FILE, STRUCTURE FRAME FOR EACH STRUCTURE, AND
C                  EXECUTION FOR EXPRESSION EVALUATION ETC.
C
C                  USE GENERAL STORAGE FOR STACK FRAMES.
C
C      *****************************************************************
C
C
C
C      *****************************************************************
C      *****              MORE SUBSTANTIAL EXTENSIONS              *****
C      *****************************************************************
C
C      VARIABLES   CREATE A MORE GENERAL FORM OF VARIABLE. THIS WOULD
C                  HAVE MORE PROPERTIES THAN THE EXISTING SORT, SUCH AS
C                  INTERNAL FORM :- INTEGER, REAL ETC.
C                  EXTERNAL FORM :- INTEGER, REAL, KEYWORD,
C                  VALIDATION :- VALID IF ( VALUE .GT. 0 )
C                  USAGE :- SOURCE , STORAGE , SINK
C                  USER INPUT :- MISSING IF ( VALUE .EQ. 0 );
C                        PROMPT = 'A PROMPT';
C                        DEFAULT = 'DEFAULT VALUE';
C                        READ_FROM = USER, FILE.
C                  DISPLAY :- TITLE = 'A TITLE';
C                        WRITE_TO = USER, FILE, CRYSTALS, SCRIPT;
C                        FORMAT = '(F10.5)'.
C                  E.G.  GENERALISE 'TRANSFER' INSTRUCTION :-
C                          DECLARE VARIABLE A WITH TYPE=CHARACTER,
C                            USAGE=SOURCE, PROMPT="A", READ_FROM=USER,
C                            DEFAULT="FINISH"
C                          DECLARE VARIABLE COMMAND WITH TYPE=CHARACTER,
C                            USAGE=SINK, WRITE_TO=CRYSTALS
C                          TRANSFER A TO COMMAND
C                        GENERATES THE PROMPT
C                          A (TEXT) [ FINISH ] :
C                        AND AUTOMATICALLY TRANSFERS THE RESULT TO
C                        CRYSTALS.
C
C                  IN ADDITION, THOSE VARIABLES WHICH ONLY NEED TO BE
C                  INITIALISED ONCE COULD BE HANDLED IN A CONSISTENT
C                  FASHION THROUGHOUT A SERIES OF SCRIPTS. ( SEE THE
C                  CURRENT USAGE OF 'RADIATION' ) THIS WOULD BE FURTHER
C                  IMPROVED IF THE DEFINITIONS OF THE VARIABLES COULD
C                  BE EXTERNAL TO THE SCRIPT, AND STORED IN A CENTRAL
C                  AREA.
C
C
C      CONTROL     CREATE A NEW TYPE OF OBJECT, 'STATE'. THIS IS
C                  MODIFIED BY PROCEDURES, WHICH HAVE CERTAIN SPECIFIED
C                  INITIAL 'STATE' REQUIREMENTS, AND GENERATE SPECIFIED
C                  FINAL 'STATES'. CERTAIN STATES COUL OBVIOUSLY BE
C                  LINKED TO THE PRESENCE/ABSENCE OF DATA. E.G. IF THERE
C                  IS A VALID LIST 1, THE STATE 'CELLPRESENT' IS TRUE.
C                  THE PROCEDURE 'READCELL' WOULD CREATE THIS STATE.
C                  IF ANOTHER PROCEDURE, OR ANY OTHER PART OF A SCRIPT,
C                  REQUIRED THIS STATE TO EXIST, 'READCELL' COULD BE
C                  CELLED TO ACHIEVE THIS. 'CELLPRESENT' SHOULD
C                  CERTAINLY BE PRESENT BEFORE DATA REDUCTION IS
C                  ATTEMPTED. THIS WOULD AUTOMATE THE CHECKING AND
C                  ACQUISITION OF DATA REQUIRED FOR THE EXECUTION OF
C                  EACH PHASE; A STATEMENT OF WHAT STATES WERE REQUIRED
C                  SHOULD BOTH CHECK THAT THOSE STATES WERE ENABLED, AND
C                  EXECUTE WHATEVER PROCEDURES WERE NECESSARY TO GET THE
C                  MISSING DATA.
C
C      *****************************************************************
C
C
C
C
C
C -- GENERAL NOTES ON VARIABLE DESCRIPTIONS
C
C      FLAGS ARE 'SET' WHEN THEIR VALUE IS 1, AND 'CLEAR' WHEN
C      IT IS ZERO.
C
C -- VARIABLES USED IN 'SCRIPT' GENERALLY
C
C      IDENTIFIERS
C            MAXLAB      MAXIMUM SIZE OF AN IDENTIFIER
C
C      STACK OFFSETS. THESE QUANTITIES INDENTIFY ITEMS TO BE READ FROM
C      THE STACK.
C            JVARIB      HIGHEST IDENTIFIER NUMBER CURRENTLY IN USE
C            JNVARI      NUMBER OF IDENTIFIERS USED IN THE CURRENT
C                        BLOCK
C            JNFDAT      NEXT FREE DATA LOCATION ( NOT USED )
C            JNFCHR      NEXT FREE CHARACTER LOCATION ( NOT USED )
C            JEXECU      EXECUTION FLAG. IF SET, STATEMENTS IN THE
C                        CURRENT BLOCK ARE BEING EXECUTED
C            JBTYPE      TYPE OF CURRENT STATEMENT BLOCK
C            JBSTRT      STARTING RECORD NUMBER OF CURRENT BLOCK
C            JBLEND      ENDING ADDRESS OF CURRENT BLOCK
C            JNSTAT      RELATIVE STATEMENT NUMBER IN CURRENT BLOCK
C            JREQST      REQUIRED STATEMENT NUMBER IN CURRENT BLOCK
C                        ( JNSTAT AND JREQST ARE USED BY 'CASE'. IF
C                        JREQST = 0, ALL STATEMENTS ARE TO BE EXECUTED )
C            JWASEX      PAST EXECUTION FLAG. IF SET, SOME PART OF THE
C                        CURRENT STATEMENT BLOCK HAS BEEN EXECUTED. THIS
C                        IS USED BY 'IF' ... 'ELSE IF' ETC.
C            JSTLVL      CURRENT STACK LEVEL. THIS ALLOWS ROUTINES TO
C                        FIND OUT HOW MANY STACK LEVELS EXIST
C
C      SCRIPT MESSAGE CODES. THESE CODES ARE PASSED TO 'XSCNSG' WHICH
C      CAN CONVERT THEM INTO READABLE TEXT. THESE MESSAGES ARE DESIGNED
C      FOR SYNTAX ERRORS IN THE SCRIPT, RATHER THAN FOR 'ERRORS' FOUND
C      IN THE INPUT OF THE EVENTUAL USER. THE CODES ARE NOT LISTED
C      INDIVIDUALLY HERE. THEY ARE DEFINED BY PARAMETER STATEMENTS, AND
C      THE TEXT CORRESPONDING TO EACH CAN BE FOUND IN THE ROUTINE XSCMSG
C
C      TEXT BUFFERS. THERE ARE THREE MAIN BUFFERS, OF WHICH TWO ARE KEPT
C      IN TWO FORMS ( ALL UPPERCASE, AND AS ENTERED ).
C            LENLIN      MAXIMUM LENGTH OF A SCRIPT SOURCE FILE LINE,
C                        AND THE MAXIMUM LENGTH OF A COMMAND THAT CAN BE
C                        PASSED BACK TO 'CRYSTALS'
C            LENDIR      MAXIMUM LENGTH OF A SCRIPT DIRECTIVE
C
C            CUPPER      ALL UPPERCASE COPY OF CURRENT SCRIPT DIRECTIVE
C            CLOWER      AS ENTERED COPY OF CURRENT SCRIPT DIRECTIVE
C            IDIRPS      CURRENT PROCESSING POSITION IN CURRENT
C                        DIRECTIVE
C            IDIRLN      LAST USEFUL POSITION IN CURRENT DIRECTIVE
C
C            CCOMBF      'COMMAND' BUFFER. IN THE BUFFER THE SCRIPT
C                        PROCESSOR BUILDS UP DATA TO BE SENT TO
C                        CRYSTALS.
C            ICOMPS      ( NOT USED )
C            ICOMLN      LENGTH OF COMMAND BUFFER. THIS VARIABLE POINTS
C                        TO THE CURRENT END OF THE COMMAND BUFFER
C
C            CUINPB      ALL UPPERCASE COPY OF THE 'USER INPUT' BUFFER.
C                        ANY INPUT FROM THE END USER IS PLACED IN THIS
C                        BUFFER BEFORE PROCESSING
C            CLINPB      AS ENTERED COPY OF USER INPUT BUFFER
C            IINPPS      CURRENT POSITION IN USER INPUT BUFFER
C            IINPLN      LAST USEFUL POSITION IN INPUT BUFFER
C
C      'ALLOWED VALUE' LIST. THIS IS SET BY THE SCRIPT COMMAND 'VERIFY',
C      AND USED PRINCIPALLY BY THE COMMAND 'GET' TO CHECK USER INPUT.
C            CCHECK      CHARACTER ARRAY CONTAINING ALLOWED VALUES
C            NCHKUS      NUMBER OF ELEMENTS OF CCHECK THAT ARE CURRENTLY
C                        DEFINED.
C            NCHK        PARAMETER DEFINING NUMBER OF ELEMENTS IN CCHECK
C            LCHK        PARAMETER DEFINING LENGTH OF EACH ELEMENT OF
C                        CCHECK
C
C      'GLOBAL FLAGS'. THESE FLAGS ARE USED THROUGHOUT 'SCRIPT', MAINLY
C      AS FLAGS FOR VERIFICATION AND OTHER GLOBAL CONTROL FUNCTIONS.
C
C            ISCMSG      IF SET, ENABLE OUTPUT OF MESSAGES BY 'XSCMSG'
C            ISCFST      IF SET, ENABLE 'FAST LABEL SEARCH' MODE. THIS
C                        MODE ATTEMPTS TO FIND THE LABEL IN A LIST OF
C                        KNOWN LABELS.
C            ISCCOM      CURRENT SCRIPT DIRECTIVE
C            ISCSER      IF SET, LABEL SEARCH IS IN PROGRESS. STATEMENTS
C                        ENCOUNTERED WILL NOT BE EXECUTED.
C            ISCVAL      VALUE OF LAST USER INPUT FROM 'GET'
C            ISCVTP      TYPE ( INTEGER/REAL ETC. ) OF LAST USER INPUT
C            ISCVLS      STARTING ADDRESS IN INPUT BUFFER OF LAST USER
C                        INPUT
C            ISCVLN      LENGTH OF STRING REPRESENTATION OF LAST USER
C                        INPUT
C            ISCINI      IF SET, CURRENT SCRIPT HAS BEEN INITIALISED.
C                        THIS FLAG IS CLEARED WHEN EACH SCRIPT FILE
C                        IS STARTED, AND SET WHEN THE 'SCRIPT' STRUCTURE
C                        IS ENCOUNTERED
C            ISCEVE      IF SET, EXPRESSION EVALUATION VERIFICATION IS
C                        ENABLED
C            ISCVER      IF SET, INPUT COMMAND VERIFICATION IS ENABLED
C            ISCSVE      IF SET, STACK OPERATION VERIFICATION IS ENABLED
C            ISCIVE      IF SET, IDENTIFIER TABLE OPERATION VERIFICATION
C                        IS ENABLED
C            ISCDSB      IF SET, STACK OPERATIONS SHOULD NOT BE
C                        ATTEMPTED. THIS FLAG IS USED AFTER 'END
C                        SCRIPT', 'FINISH', AND 'QUEUE PROCESS' TO STOP
C                        OPERATIONS ON INVALID STACK FRAMES.
C
C      'USER MESSAGES'. THESE ARE THE MESSAGES THAT ARE DISPLAYED TO
C      THE 'END USER' IN CERTAIN CIRCUMSTANCES, SUCH AS INPUT ERROR,
C      OR ( OPTIONALLY ) CONTINGENCY ACTIVATION. THE INITIAL TEXTS
C      OF THESE MESSAGES CAN BE CHANGED USING THE 'MESSAGE' COMMAND
C
C            CSCMSG      CHARACTER ARRAY CONTAINING MESSAGE TEXTS. THE
C                        ELEMENTS ARE 80 CHARACTERS LONG
C            LSCMSG      INTEGER ARRAY CONTAINING THE USEFUL LENGTH
C                        OF EACH MESSAGE IN CSCMSG
C            NSCUMS      PARAMETER DEFINING NUMBER OF ELEMENTS IN CSCMSG
C                        WHICH ARE OUTPUT BY 'GET'
C            NSCMSG      PARAMETER DEFINING TOTAL NUMBER OF ELEMENTS IN
C                        CSCMSG
C
C
C
C
C -- VARIABLES USED IN THIS ROUTINE
C
C      CVARIB      USED AS SCRATCH STORAGE FOR VARIABLE NAMES
C      CLABEL      USED AS SCRATCH STORAGE FOR LABELS
C      CSERCH      THE CURRENT SEARCH LABEL. WHEN A LABEL SEARCH IS
C                  BEGUN, THE LABEL REQUIRED IS PLACED IN 'CSERCH'
C                  AND THE SEARCH FLAG 'ISCSER' IS SET
C
C      CCONTU      THIS DEFINES THE CONTINUATION CHARACTER '-'
C      CSPACE      THIS CONTAINS A SPACE ' '
C      CSCRPT      THIS DEFINES THE SCRIPT INSTRUCTION INDICATOR '%'
C
C      CMMNDS      THIS CHARACTER ARRAY CONTAINS THE NAMES OF THE
C                  SCRIPT COMMANDS
C      CSTRUC      THIS CHARACTER ARRAY CONTAINS THE NAMES OF THE
C                  STATEMENT BLOCK TYPES
C
C      IVERSN      SCRIPT PROCESSOR VERSION NUMBER
C
C
C      FOR EACH COMMAND THERE IS AN INTEGER VARIABLE WITH A NAME OF
C      THE FORM 'ICXXXX' WHERE XXXX IS AN ABBREVIATION OF THE COMMAND
C      NAME, WHICH IS AN INDEX OF THE COMMAND NAME IN 'CMMNDS'.
C      E.G. FOR 'LABEL', ( = CMMNDS(1) ) , ICLABE = 1
C
C
C
C
C -- RELATIONSHIPS BETWEEN 'SCRIPTS' AND THE REST OF 'CRYSTALS',
C    AND 'SCRIPTS' AND THE 'FINAL USER'
C
C      AS FAR AS THE REST OF 'CRYSTALS' IS CONCERNED, THE SCRIPT
C      PROCESSOR SHOULD APPEAR :-
C
C            1)    TO ABSORB ALL COMMAND LINES WHICH 'KRDREC' PASSES
C                  TO IT
C            2)    TO GENERATE A SERIES OF 'CRYSTALS' COMMAND INPUT
C                  WHICH CAN BE EXECUTED.
C
C
C      TO THE 'FINAL USER' ( I.E. THE PERSON TO WHOM 'KSCVAL' ADDRESSES
C      ITS QUESTIONS ) THE SCRIPT PROCESSOR SHOULD APPEAR :-
C
C            1)    TO BE GENERATING A SERIES OF QUESTIONS
C            2)    TO BE GENERATING OUTPUT DEPENDING ON THE ANSWERS
C
C      THERE SHOULD BE NO DIFFERENCE AS FAR AS THE REST OF 'CRYSTALS'
C      IS CONCERNED, BETWEEN THE BEHAVIOUR OF A NORMAL USER TYPING IN
C      COMMANDS IN AN INTERACTIVE JOB AND THE SCRIPT PROCESSOR
C      GENERATING COMMANDS. THIS SIMILARITY SHOULD BE EVEN GREATER THAN
C      NORMALLY EXISTS BETWEEN INPUT FROM AN INTERACTIVE TERMINAL AND
C      FROM A 'USE' FILE, BECAUSE THE SCRIPT PROCESSOR CAN RESPOND TO
C      ERROR CONDITIONS. FOR THIS REASON, THE ONLY PART OF 'CRYSTALS'
C      WHICH NEEDS TO KNOW THAT A SCRIPT IS BEING PROCESSED IS 'KRDREC'.
C
C
C
C
      PARAMETER ( MAXLAB = 12 )
      PARAMETER ( JVARIB =  1 , JNVARI =  2 , JNFDAT =  3 )
      PARAMETER ( JNFCHR =  4 , JEXECU =  5 , JBTYPE =  6 )
      PARAMETER ( JBSTRT =  7 , JBLEND =  8 , JNSTAT =  9 )
      PARAMETER ( JREQST = 10 , JWASEX = 11 , JSTLVL = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      CHARACTER*(MAXLAB) CVARIB
      CHARACTER*(MAXLAB) CLABEL
      CHARACTER*(MAXLAB) CSERCH
C
      CHARACTER*1 CCONTU , CSPACE , CSCRPT
C
C
      PARAMETER ( LCOM = 10 , NCOM = 30 )
      CHARACTER*(LCOM) CMMNDS(NCOM)
C
      PARAMETER ( LSTRUC = 12 , NSTRUC = 5 )
      CHARACTER*(LSTRUC) CSTRUC(0:NSTRUC)
C
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
      PARAMETER ( NCHK = 20 , LCHK = 12 )
      CHARACTER*(LCHK) CCHECK(NCHK)
      COMMON /XSCCHK/ CCHECK
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
C
      COMMON /UFILE/ NCUFU(10),IFLCHR(10),IFLMAX,IFLIND,NCLU,
     2 IRDLOG(10), IRDCPY(10), IRDCAT(10), IRDPAG, IRDLIN,
     3 IRDCMS(10), IRDINC(10), IRDSCR(10), IRDSRQ(10),
     4 IRDREC(10), IRDFND(10), IRDHGH(10)
      COMMON /XFLDAT/ KEYFIL(8,35), IFLUNI(35), IFLACC(35), IFLSTA(35),
     2 IFLFRM(35), IFLREA(35), IFLOPN(35), IFLLCK(35) , NFLUSD , NFLMAX
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      COMMON /XSCCNT/ ISCXN1 , NCHKUS , ISCXN3 , MAXSYS
      PARAMETER ( NSCMSG = 20 )
      CHARACTER*80 CSCMSG(NSCMSG)
      COMMON /XSCMS1/ CSCMSG
      COMMON /XSCMS2/ LSCMSG(NSCMSG)
C
C
      SAVE CSERCH
C
C
      DATA CCONTU / '-' / , CSPACE / ' ' / , CSCRPT / '%' /
C
C
      DATA CMMNDS /   '          ' , 'ACTIVATE  ' , 'COPY      ' ,
     2 'CLEAR     ' , 'INSERT    ' , 'SEND      ' , 'GET       ' ,
     3 'VERIFY    ' , '          ' , '          ' , '          ' ,
     4 '          ' , 'FINISH    ' , 'END       ' , 'QUEUE     ' ,
     5 'ON        ' , 'STORE     ' , 'VARIABLE  ' , 'SET       ' ,
     6 'EXTERNAL  ' , 'ELSE      ' , '          ' , 'EXECUTE   ' ,
     7 'SHOW      ' , 'EVALUATE  ' , 'MESSAGE   ' , 'INDEX     ' ,
     8 'EXTRACT   ' , 'IDENTIFY  ' , 'TRANSFER  ' /
C
      DATA                ICLABE /  1 /, ICACTI /  2 /, ICCOPY /  3 /
      DATA ICCLEA /  4 /, ICINSE /  5 /, ICSEND /  6 /, ICGET  /  7 /
      DATA ICVERI /  8 /, ICERRO /  9 /, ICJUMP / 10 /, ICBRAN / 11 /
      DATA ICDECR / 12 /, ICFINI / 13 /, ICEND  / 14 /, ICQUEU / 15 /
      DATA ICON   / 16 /, ICSTOR / 17 /, ICVARI / 18 /, ICSET  / 19 /
      DATA ICEXTE / 20 /, ICELSE / 21 /, ICSELE / 22 /, ICEXEC / 23 /
      DATA ICSHOW / 24 /, ICEVAL / 25 /, ICMESS / 26 /, ICINDE / 27 /
      DATA ICEXTR / 28 / , ICIDEN / 29 / , ICTRAN / 30 /
C
      DATA CSTRUC / '<Special>' , 'SCRIPT' , 'BLOCK' , 'LOOP' ,
     2 'IF' , 'CASE' /
C
      DATA IVERSN / 251 /
C
      DATA CSERCH / ' ' /
C
C
C
C
C -- CLEAR STACK OPERATION DISABLE FLAG
      ISCDSB = 0
C
C
C -- SET DEFAULT ACTION WITH INPUT LINE. THIS IS TO TYPE IT, UNLESS WE
C    ARE SEARCHING FOR A LABEL. ALSO SET NUMBER OF COMMAND VERBS FOR
C    WHICH WE WILL CHECK
C
      IF ( ISCINI .GT. 0 ) THEN
        IEXECU = KSCSTK ( JEXECU , 0 )
      ELSE
        IEXECU = 0
      ENDIF
C
      IF ( ISCSER .GT. 0 ) THEN
C
C -- THE FOLLOWING METHOD CAN SPEED UP THE LOCATION OF LABELS
C    CONSIDERABLY.
C
        KSCPRC = 0
        IF ( CINPUT(1:6) .NE. '%LABEL' ) RETURN
      ELSE IF ( IEXECU .LE. 0 ) THEN
        KSCPRC = 0
      ELSE
        KSCPRC = 1
      ENDIF
C
C -- CHECK FOR ERRORS.
      IF ( IERFLG .LT. 0 ) THEN
C
C -- CHECK IF AN ERROR CONTINGENCY HAS BEEN DECLARED AT THIS LEVEL
        ISTAT = KSCACT ( 'ERROR' )
        IF ( ISTAT .GT. 0 ) THEN
C
C -- CONTINGENCY FOUND AND PROCESSED
C -- CLEAR SYSTEM ERROR FLAG
          IERFLG = 1
C
          KSCPRC = 0
C
C -- IF THE POSITION IN THE FILE IS BEING ADJUSTED, IMMEDIATE RETURN
C    BEFORE TOO MUCH DAMAGE IS CAUSED
          IF ( IRDFND(IFLIND) .NE. 0 ) THEN
            RETURN
          ENDIF
C
C -- IF THIS IS A SCRIPT TYPE BLOCK, AN ERROR HANDLING LABEL MAY HAVE
C    BEEN DECLARED. EITHER JUMP TO SPECIFIED LABEL, OR CLOSE SCRIPT
C    FILE AT THIS POINT.
C
C -- IF THERE IS NO ERROR LABEL, THE CURRENT SCRIPT FILE IS CLOSED.
C    IN THIS CASE, THE SYSTEM ERROR FLAG IS STILL SET, SO OUTER SCRIPTS
C    MAY STILL HAVE CONTINGENCIES/ERROR LABELS TO HANDLE THE ERROR.
C
C -- IF THERE IS AN ERROR LABEL, THE SYSTEM ERROR FLAG IS CLEARED, AND
C    THE SPECIFIED ERROR LABEL IS SEARCHED FOR.
C
        ELSE IF ( KSCSTK ( JBTYPE , 0 ) .EQ. 1 ) THEN
          ISTAT = KSCIDN ( 2, 1, 'ERROR', 3, I, IDENT, IERROR, -1 )
          IF ( ISTAT .LE. 0 ) THEN
            IDIRLN = 0
            CALL XFLUNW ( 2 , 2 )
            KSCPRC = 0
            RETURN
          ELSE
            IERFLG = 1
            ISTAT = KSCIDN ( 3, 1, CSERCH, 2, I, IERROR , IRECRD , 1 )
            CALL XSCJMP ( CSERCH )
            KSCPRC = 0
          ENDIF
        ELSE
C
C -- A BLOCK TYPE OTHER THAN 'SCRIPT', WITH NO CONTINGENCY DECLARED.
C    DEACTIVATED EXECUTION, AND CONTINUE READING THROUGH FILE.
          CALL XSCSTU ( JEXECU , 0 )
          KSCPRC = 0
        ENDIF
C
      ENDIF
C
C
C
C                      ******************
C                      * INPUT CHECKING *
C                      ******************
C
C
C
C -- BLANK LINES >> IMMEDIATE RETURN
C
      IF ( IUSLEN .LE. 0 ) RETURN
C
C -- MOVE INPUT TEXT INTO SCRIPT DIRECTIVE BUFFER.
      CLOWER(IDIRLN+1:) = CINPUT(1:IUSLEN)
      IDIRLN = IDIRLN + IUSLEN
C
C -- TEXT IS PROCESSED IMMEDIATELY
      IF ( CLOWER(1:1) .NE. CSCRPT ) THEN
        IDIRLN = 0
        RETURN
      ENDIF
C
C
C -- CHECK FOR A CONTINUATION MARK AT THE END OF THE LINE. IF THERE IS
C    ONE, ADJUST LINE LENGTH ( SO CONTINUATION MARK DOES NOT FORM PART
C    OF DIRECTIVE TO BE EXECUTED ) AND RETURN CONTROL SO THE NEXT PART
C    OF THE DIRECTIVE CAN BE FETCHED.
C
      IF ( CLOWER(IDIRLN:IDIRLN) .EQ. CCONTU ) THEN
        IDIRLN = IDIRLN - 1
        KSCPRC = 0
        RETURN
      ENDIF
C
C -- SET POINTERS ( CHARACTER 1 HAS ALREADY BEEN PROCESSED )
      IDIRPS = 2
C
C -- ECHO LINE IF VERIFY ENABLED
C -- ECHO LINE, IF VERIFY IS ENABLED AND THE LINE IS GOING TO BE
C    EXECUTED.
C
      IF ( ( ISCVER .GT. 0 ) .AND. ( ISCSER .LE. 0 ) .AND.
     2     ( IEXECU .GT. 0 ) ) THEN
        WRITE ( NCAWU , 1005 ) CLOWER(1:IDIRLN)
1005    FORMAT ( 1X , A )
      ENDIF
C
C
C -- WE HAVE A DIRECTIVE TO BE PROCESSED HERE. CHECK FIRST FOR COMMENTS
C    AND LABELS. IF WE ARE NOT SEARCHING FOR A LABEL, WE THEN GO ON TO
C    CHECK OTHER POSSIBLE DIRECTIVES.
C
      IRDLIN = 0
C
C -- DETECT COMMENT LINES. THESE ARE IGNORED, AND CONTROL RETURNS TO
C    'CRYSTALS'. EMPTY LINES, CONTAINING ONLY '%', ARE TREATED
C    IN THE SAME WAY.
C
      IF ( CLOWER(IDIRPS:IDIRPS) .EQ. CSCRPT ) THEN
        IDIRLN = 0
        KSCPRC = 0
        RETURN
      ENDIF
C
C -- EXTRACT DIRECTIVE NAME FROM INPUT.
      LENGTH = KCCARG ( CLOWER , IDIRPS , 1 , NDIREC , NEND )
      IF ( LENGTH .LE. 0 ) THEN
        IDIRLN = 0
        KSCPRC = 0
        RETURN
      ENDIF
C
C -- CONVERT THE DIRECTIVE TO UPPERCASE
C
      CALL XCCUPC ( CLOWER(1:IDIRLN) , CUPPER(1:IDIRLN) )
      IF ( IDIRLN .LT. LEN ( CLOWER ) ) THEN
        CUPPER(IDIRLN+1:) = ' '
      ENDIF
C
C -- COUNT THIS DIRECTIVE
      IF ( ISCINI .GT. 0 ) THEN
        ICOUNT = KSCSTK ( JNSTAT , 0 ) + 1
        CALL XSCSTU ( JNSTAT , ICOUNT )
C
C -- HANDLE STRUCTURE BLOCKS WHERE A SINGLE INSTRUCTION IS ENABLED
C    E.G. 'CASE'
C
        IREQST = KSCSTK ( JREQST , 0 )
        IF ( IREQST .GT. 0 ) THEN
          IF ( IREQST .EQ. ICOUNT ) THEN
            CALL XSCSTU ( JEXECU , 1 )
            IEXECU = 1
          ELSE
            CALL XSCSTU ( JEXECU , 0 )
            IEXECU = 0
          ENDIF
        ENDIF
      ENDIF
C
C -- CHECK DIRECTIVE AGAINST ALLOWED LIST
C    THE DIRECTIVE NAME IS CHECKED FIRST AGAINST THE LIST OF COMMANDS,
C    AND THEN AGAINST THE LIST OF STRUCTURE NAMES. IF IT IS A STRUCTURE
C    NAME, THE 'BEGIN NEW STRUCTURE' ROUTINE IS CALLED, AND CONTROL
C    RETURNS TO 'CRYSTALS'.
C
      ISCCOM = KCCOMP ( CUPPER(NDIREC:NEND) , CMMNDS , NCOM , 1 )
      IF ( ISCCOM .LE. 0 ) THEN
        ISCSTR = KCCOMP ( CUPPER(NDIREC:NEND), CSTRUC(1), NSTRUC, 1 )
        IF ( ISCSTR .GT. 0 ) THEN
          ISTAT = KSCSCT ( ISCSTR , 1 )
          IDIRLN = 0
          KSCPRC = 0
          RETURN
        ELSE
          IF ( ISCSER .LE. 0 ) GO TO 9910
        ENDIF
      ENDIF
C
C
C            **** COMMAND PROCESSING ****
C
C -- CHECK FOR INITIALISATION. FIRST EXECUTABLE COMMAND IN EACH SCRIPT
C    MUST BE 'SCRIPT'
C
      IF ( ISCINI .LE. 0 ) GO TO 9994
C
C -- 'END'
C
      IF ( ISCCOM .EQ. ICEND ) THEN
C
C -- 'END' SHOULD BE FOLLOWED BY A STRUCTURE NAME, AND THAT NAME SHOULD
C    CORRESPOND TO THE ONE THAT STARTED THE CURRENT BLOCK.
C
        LENSTR = KCCARG ( CUPPER , IDIRPS , 1 , NARG , NEND )
        IF ( LENSTR .LE. 0 ) GO TO 9980
C
        ISTRUC = KCCOMP ( CUPPER(NARG:NEND), CSTRUC(1), NSTRUC, 1 )
        IF ( ISTRUC .LE. 0 ) GO TO 9990
C
C -- CHECK STRUCTURE TYPE TO BE ENDED IS SAME AS CURRENT TYPE
        ICTYPE = KSCSTK ( JBTYPE , 0 )
        IF ( ICTYPE .GT. NSTRUC ) ICTYPE = 0
        IF ( ISTRUC .NE. ICTYPE ) GO TO 9992
C
        ISTAT = KSCSCT ( ISTRUC , 2 )
C
        IF ( ISCSER .GT. 0 ) GO TO 9930
C
        KSCPRC = 0
C
C -- 'LABEL'
C
      ELSE IF ( ISCCOM .EQ.  ICLABE ) THEN
        LENLAB = KCCARG ( CUPPER , IDIRPS , 1 , NLABEL , NEND )
        IF ( LENLAB .LE. 0 ) GO TO 9940
C
        CLABEL = CUPPER(NLABEL:NEND)
C
        IF ( ISCVER .GT. 0 ) THEN
          WRITE ( NCAWU , 1015 ) CLABEL , IRDREC(IFLIND)
1015      FORMAT ( 1X , 'Label ' , A , ' found in record ' , I5 )
        ENDIF
C
        ISTAT = KSCIDN ( 1, 1, CLABEL, 2, 0, IDENT, IRDREC(IFLIND), 0 )
C
C -- CHECK LABEL FOUND IF SEARCH IS IN PROGRESS
        IF ( ( ISCSER .GT. 0 ) .AND. ( CLABEL .EQ. CSERCH )  ) THEN
          ISCSER = 0
        ENDIF
C
        KSCPRC = 0
C
C -- 'ELSE'
C
      ELSE IF ( ISCCOM .EQ. ICELSE ) THEN
C
        KSCPRC = KSCELS ( IN )
C
      ENDIF
C
C
C -- IF WE ARE IN THE MIDDLE OF A SEARCH, END PROCESSING NOW
C -- IF THIS IS PART OF A LABEL SEARCH, OR THE INSTRUCTIONS IN THE
C    CURRENT BLOCK ARE NOT BEING EXECUTED, WE CAN STOP PROCESSING THE
C    CURRENT DIRECTIVE NOW. NOTE THAT 'END' AND 'LABEL' MUST ALWAYS
C    BE PROCESSED. THE END OF THE CURRENT BLOCK MAY ( IMPLICITLY )
C    RE-ENABLE COMMAND PROCESSING, AND A 'LABEL' INSTRUCTION MAY
C    RESOLVE A LABEL SEARCH.
C
C
C -- CHECK IF EXECUTION IS DISABLED FOR THIS CONTROL STRUCTURE
C
      IF ( ( ISCSER .GT. 0 ) .OR. ( IEXECU .LE. 0 ) ) THEN
        KSCPRC = 0
        GO TO 8000
      ENDIF
C
C
C
C            END OF SPECIAL COMMAND PROCESSING. REMAINING COMMANDS
C            ARE EXECUTED ONLY IF NOT IN LABEL SEARCH MODE
C
C       (LABEL)     ,  ACTIVATE    ,  COPY        ,
C       CLEAR       ,  INSERT      ,  SEND        ,  GET         ,
C       VERIFY      ,  (ERROR)     ,  (JUMP)      ,  (BRANCH)    ,
C       (DECREMENT) ,  FINISH      ,  END         ,  QUEUE       ,
C       ON          ,  STORE       ,  VARIABLE    ,  SET         ,
C       EXTERNAL    ,  ELSE        ,  (SELECT)    ,  EXECUTE     ,
C       SHOW        ,  EVALUATE    ,  MESSAGE     ,  INDEX       ,
C       EXTRACT     ,  IDENTIFY    ,  TRANSFER    /
C
      GO TO ( 8000 , 4030 , 4040 ,
     2 4120 , 4050 , 4090 , 4070 ,
     3 4170 , 4010 , 4130 , 4140 ,
     4 4160 , 4260 , 8000 , 4100 ,
     5 4020 , 4060 , 4190 , 4210 ,
     6 4110 , 8000 , 4150 , 4090 ,
     7 4200 , 4230 , 4220 , 4080 ,
     8 4180 , 4240 , 4250 ,
     9 9988 ) , ISCCOM
      GO TO 9988
C
C
C
C
C
C -- 'ERROR'
C
4010  CONTINUE
C
        LENLAB = KCCARG ( CUPPER , IDIRPS , 1 , NLABEL , NEND )
        IF ( LENLAB .LE. 0 ) GO TO 9940
C
        CLABEL = CUPPER(NLABEL:NEND)
C
C -- CHECK IF LABEL IS CURRENTLY KNOWN. IF NOT CREATE IT
        IADDR = KSCIDN ( 2 , 1 , CLABEL , 2 , I, IIDENT , IVALUE , -1 )
        IF ( IADDR .LE. 0 ) THEN
          IADDR = KSCIDN ( 1 , 1 , CLABEL , 2, 0, IIDENT , 0 , -1 )
        ENDIF
C
C -- STORE AWAY ADDRESS OF LABEL IDENTIFIER
        ISTAT = KSCIDN ( 1 , 1 , 'ERROR' , 3, 0, IERROR , IIDENT , -1 )
C
        IF ( ISCVER .GT. 0 ) WRITE ( NCAWU , 1017 ) CLABEL
1017    FORMAT ( 1X , 'Error label set to ' , A , / )
C
        KSCPRC = 0
      GO TO 8000
C
C
4020  CONTINUE
C
C
C -- 'ON'
C
C
        KSCPRC = KSCCNT ( IN )
      GO TO 8000
C
C
4030  CONTINUE
C
C
C -- 'ACTIVATE'
C
C
        LENARG = KCCARG ( CUPPER , IDIRPS , 1 , NARG , NEND )
        IF ( LENARG .LE. 0 ) GO TO 9996
C
        ISTAT = KSCACT  ( CUPPER(NARG:NEND) )
        IF ( ISTAT .LE. 0 ) GO TO 9998
C
        KSCPRC = 0
      GO TO 8000
C
C
4040  CONTINUE
C
C -- 'COPY'
C
        LENCPY = KCCARG ( CUPPER , IDIRPS , 2 , NCOPY , NEND )
        IF ( LENCPY .LE. 0 ) GO TO 9950
C
        CINPUT = CLOWER(NCOPY:NEND)
        IUSLEN = NEND - NCOPY + 1
        KSCPRC = 2
      GO TO 8000
C
C
4050  CONTINUE
C
C -- 'INSERT'
C
        LENINS = KCCARG ( CUPPER , IDIRPS , 2 , NINS , NEND )
        IF ( LENINS .LE. 0 ) GO TO 9950
        IF ( ICOMLN .LE. 0 ) THEN
          IBSTRT = 1
        ELSE
          IBSTRT = ICOMLN + 2
        ENDIF
        ICOMLN = IBSTRT + LENINS - 1
        CCOMBF(IBSTRT:ICOMLN) = CLOWER(NINS:NEND)
C
        KSCPRC = 0
      GO TO 8000
C
C
4060  CONTINUE
C
C -- 'STORE'
C
C
        KSCPRC = KSCSTR ( IN )
      GO TO 8000
C
C
4070  CONTINUE
C
C
C -- 'GET'
C
C
        KSCPRC = KSCVAL ( IN )
      GO TO 8000
C
C
4080  CONTINUE
C
C -- 'INDEX'
C
C
        KSCPRC = KSCINX ( IN )
      GO TO 8000
C
C
4090  CONTINUE
C
C
C -- 'SEND' AND 'EXECUTE'
C
        IF ( ICOMLN.GT. 0 ) THEN
          CINPUT = CCOMBF(1:ICOMLN)
          IUSLEN = ICOMLN
          KSCPRC = 2
          IF ( ISCCOM .EQ. ICEXEC ) KSCPRC = 3
        ELSE
          KSCPRC = 0
        ENDIF
      GO TO 8000
C
C
4100  CONTINUE
C
C -- 'QUEUE'
C
C
        KSCPRC = KSCQUE ( IN )
      GO TO 8000
C
C
4110  CONTINUE
C
C -- 'EXTERNAL'
C
C
        KSCPRC = KSCEXT ( IUSLEN )
      GO TO 8000
C
C
4120  CONTINUE
C
C -- 'CLEAR'
C
        CCOMBF = ' '
        ICOMLN = 0
        KSCPRC = 0
      GO TO 8000
C
C
4130  CONTINUE
C
C -- 'JUMP'
C
        LENLAB = KCCARG ( CUPPER , IDIRPS , 1 , NLABEL , NEND )
        IF ( LENLAB .LE. 0 ) GO TO 9940
C
        CSERCH = CUPPER(NLABEL:NEND)
        CALL XSCJMP ( CSERCH )
C
        KSCPRC = 0
      GO TO 8000
C
C
4140  CONTINUE
C
C -- 'BRANCH'
C
C
        ISTAT = KSCADR ( IADDR , CVARIB , ITYPE , IVALUE )
        IF ( ISTAT .LE. 0 ) GO TO 9900
        IF ( ITYPE .NE. 1 ) GO TO 9970
C
        LENNUM = KCCARG ( CUPPER , IDIRPS , 1 , NNUM , NEND )
        IF ( LENNUM .LE. 0 ) GO TO 9960
C
        READ ( CUPPER(NNUM:NEND) , '(I32)' , ERR = 9960 ) ICHECK
C
        IF ( IVALUE .EQ. ICHECK ) THEN
          LENLAB = KCCARG ( CUPPER , IDIRPS , 1 , NLABEL , NEND )
          IF ( LENLAB .LE. 0 ) GO TO 9940
C
          CSERCH = CUPPER(NLABEL:NEND)
          CALL XSCJMP ( CSERCH )
C
        ENDIF
        KSCPRC = 0
      GO TO 8000
C
C
4150  CONTINUE
C
C -- 'SELECT'
C
C
        ISTAT = KSCADR ( IADDR , CVARIB , ITYPE , IINDEX )
        IF ( ISTAT .LE. 0 ) GO TO 9900
        IF ( ITYPE .NE. 1 ) GO TO 9970
C
        ILABEL = 0
        IF ( IINDEX .GT. 0 ) THEN
2000      CONTINUE
          ILABEL = ILABEL + 1
          LENLAB = KCCARG ( CUPPER , IDIRPS , 1 , NLABEL , NEND )
          IF ( LENLAB .GT. 0 ) THEN
            IF ( ILABEL .LT. IINDEX ) GO TO 2000
            CSERCH = CUPPER(NLABEL:NEND)
            CALL XSCJMP ( CSERCH )
          ENDIF
        ENDIF
        KSCPRC = 0
      GO TO 8000
C
C
4160  CONTINUE
C
C -- 'DECREMENT AND BRANCH'
C
C
        ISTAT = KSCADR ( IADDR , CVARIB , ITYPE , IVALUE )
        IF ( ISTAT .LE. 0 ) GO TO 9900
        IF ( ITYPE .NE. 1 ) GO TO 9970
C
        IVALUE = IVALUE - 1
      ISTAT = KSCIDN ( 1, 3, CVARIB, 1, ITYPE , IDENT , IVALUE , 0 )
C
C -- IF VALUE IS POSITIVE THEN JUMP TO LABEL SPECIFIED
        IF ( IVALUE .GT. 0 ) THEN
          LENLAB = KCCARG ( CUPPER , IDIRPS , 1 , NLABEL , NEND )
          IF ( LENLAB .LE. 0 ) GO TO 9940
C
          CSERCH = CUPPER(NLABEL:NEND)
          CALL XSCJMP ( CSERCH )
        ENDIF
        KSCPRC = 0
      GO TO 8000
C
C
4170  CONTINUE
C
C -- 'VERIFY'
C
        NCHKUS = 0
2100    CONTINUE
        LENGTH = KCCARG ( CLOWER , IDIRPS , 1 , NCHECK , NEND )
        IF ( LENGTH .GT. 0 ) THEN
          IF ( NCHKUS .GE. NCHK ) GO TO 9920
          NCHKUS = NCHKUS + 1
C
          CCHECK(NCHKUS) = CLOWER(NCHECK:NEND)
          GO TO 2100
        ENDIF
        KSCPRC = 0
      GO TO 8000
C
C
4180  CONTINUE
C
C -- 'EXTRACT'
C
C
        KSCPRC = KSCETR ( IN )
      GO TO 8000
C
C
4190  CONTINUE
C
C -- 'VARIABLE'
C
C
        KSCPRC = KSCVAR ( IN )
      GO TO 8000
C
C
4200  CONTINUE
C
C -- 'SHOW'
C
C
        KSCPRC = KSCSHW ( IN )
      GO TO 8000
C
C
4210  CONTINUE
C
C -- 'SET'
C
C
        KSCPRC = KSCSET ( IN )
      GO TO 8000
C
C
4220  CONTINUE
C
C -- 'MESSAGE'
C
C
        KSCPRC = KSCUMS ( IUSLEN )
      GO TO 8000
C
C
4230  CONTINUE
C
C
C -- 'EVALUATE'
C
C
        KSCPRC = KSCEVL ( IN )
      GO TO 8000
C
C
4240  CONTINUE
C
C -- 'IDENTIFY'
C
C
      CALL XOPMSG ( IOPSCP , IOPVER , IVERSN )
      KSCPRC = 0
      GO TO 8000
C
C
4250  CONTINUE
C
C -- 'TRANSFER'
C
C
      KSCPRC = KSCTRA ( CINPUT , IUSLEN )
      GO TO 8000
C
C
4260  CONTINUE
C
C -- 'FINISH'
C
C
C -- DISABLE STACK OPERATIONS
      ISCDSB = 1
C
        CALL XFLUNW ( 2 , 3 )
        KSCPRC = 0
      GO TO 8000
C
C
C
C
8000  CONTINUE
C
C -- EXECUTION OF INSTRUCTION HAS BEEN COMPLETED
C
C -- FINAL PROCESSING FOR 'CASE'
C
      IF ( ( ISCINI .GT. 0 ) .AND. ( ISCDSB .LE. 0 ) ) THEN
        IREQST = KSCSTK ( JREQST , 0 )
        ICOUNT = KSCSTK ( JNSTAT , 0 )
C
C -- CHECK IF THIS IS THE TARGET STATEMENT OF A 'CASE'
C
        IF ( IREQST .EQ. ICOUNT ) THEN
C
C -- CHECK IF THE END OF THE CURRENT STRUCTURE BLOCK IS KNOWN. IF IT
C    IS, THAT IS THE NEXT STATEMENT TO BE EXECUTED.
C
          IBLEND = KSCSTK ( JBLEND , 0 )
          IF ( IBLEND .GT. 0 ) IRDFND(IFLIND) = IBLEND
        ENDIF
      ENDIF
C
C
C
C
      IDIRLN = 0
      RETURN
C
C
9900  CONTINUE
      IDIRLN = 0
      KSCPRC = 0
      RETURN
C
9910  CONTINUE
      ISCCOM = 0
      CALL XSCMSG ( MILLEG , MCOMND , CLOWER(NDIREC:NEND) , 0 )
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MTOOMY , MAVKEY , 'The maximum is' , NCHK )
      GO TO 9900
9930  CONTINUE
      CALL XSCMSG ( MNOTFD , MLABEL , CSERCH , 0 )
      GO TO 9900
9940  CONTINUE
      CALL XSCMSG ( MMISSG , MLABEL , ' ' , 0 )
      GO TO 9900
9950  CONTINUE
      CALL XSCMSG ( MMISSG , MDATA , ' ' , 0 )
      GO TO 9900
9960  CONTINUE
      CALL XSCMSG ( MILLMS , MCONST , ' ' , 0 )
      GO TO 9900
9970  CONTINUE
      CALL XSCMSG ( MWRONG , MVARIA , CVARIB , 0 )
      GO TO 9900
9980  CONTINUE
      CALL XSCMSG ( MMISSG , MSTRUC , ' '  , 0 )
      GO TO 9900
9988  CONTINUE
      CALL XSCMSG ( MINTRN , MCMMND , 'Internal error in KSCPRC' , 0 )
      CALL XOPMSG ( IOPSCP , IOPINT , 0 )
      GO TO 9900
9990  CONTINUE
      CALL XSCMSG ( MILLEG , MSTRUC , CUPPER(NARG:NEND) , 0 )
      GO TO 9900
9992  CONTINUE
      CALL XSCMSG ( MUNEXP , MSTRUC ,
     2 'Expected: '//CSTRUC(ICTYPE)//' Found: '//CSTRUC(ISTRUC) , 0 )
      GO TO 9900
9994  CONTINUE
      CALL XSCMSG ( MINCLY , MINITD ,
     2              'Scripts should begin with SCRIPT' , 0 )
      GO TO 9900
9996  CONTINUE
      CALL XSCMSG ( MMISSG , MCONTT , ' ' , 0 )
      GO TO 9900
9998  CONTINUE
      CALL XSCMSG ( MILLEG , MCONTT , CUPPER(NARG:NEND) , 0 )
      GO TO 9900
C
C
C
      END
CODE FOR KSCACT
      FUNCTION KSCACT ( CTYPE )
C
C -- ACTIVATE CONTINGENCY
C
C -- THIS ROUTINE IMPLEMENTS THE 'ACTIVATE' INSTRUCTION IN SCRIPTS.
C    IT IS ALSO CALLED BY CERTAIN OTHER PARTS OF SCRIPTS IN ORDER TO
C    ACTIVATE CONTINGENCIES, AND CAN BE CALLED BY OTHER PARTS OF
C    'CRYSTALS' FOR THE SAME PURPOSE.
C
C      INPUT PARAMETER :-
C
C      CTYPE       NAME OF CONTINGENCY ( AS A CHARACTER STRING. )
C
C      RETURN VALUES :-
C
C      KSCACT      -1      NO SUCH CONTINGENCY
C                  +1      SUCCESS
C
      CHARACTER*(*) CTYPE
C
      PARAMETER ( JVARIB =  1 , JNVARI =  2 , JNFDAT =  3 )
      PARAMETER ( JNFCHR =  4 , JEXECU =  5 , JBTYPE =  6 )
      PARAMETER ( JBSTRT =  7 , JBLEND =  8 , JNSTAT =  9 )
      PARAMETER ( JREQST = 10 , JWASEX = 11 , JSTLVL = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      PARAMETER ( NSCMSG = 20 )
      CHARACTER*80 CSCMSG(NSCMSG)
      COMMON /XSCMS1/ CSCMSG
      COMMON /XSCMS2/ LSCMSG(NSCMSG)
C
C
      COMMON /UFILE/ NCUFU(10),IFLCHR(10),IFLMAX,IFLIND,NCLU,
     2 IRDLOG(10), IRDCPY(10), IRDCAT(10), IRDPAG, IRDLIN,
     3 IRDCMS(10), IRDINC(10), IRDSCR(10), IRDSRQ(10),
     4 IRDREC(10), IRDFND(10), IRDHGH(10)
      COMMON /XFLDAT/ KEYFIL(8,35), IFLUNI(35), IFLACC(35), IFLSTA(35),
     2 IFLFRM(35), IFLREA(35), IFLOPN(35), IFLLCK(35) , NFLUSD , NFLMAX
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C -- SEARCH FOR CONTIGENCY. IF NOT DECLARED, RETURN IMMEDIATELY
C
      ISTAT = KSCIDN ( 2 , 1 , CTYPE , 4 , ISUB , ID , IMSG , -1 )
      IF ( ISTAT .LE. 0 ) GO TO 9900
C
      GO TO ( 2100 , 2200 , 2300 , 2400 , 9910 ) , ISUB
      GO TO 9910
C
C
2100  CONTINUE
C
C -- 'RESTART'
C
C -- FIND STARTING ADDRESS OF CURRENT BLOCK
      IPOS = KSCSTK ( JBSTRT , 0 )
C
C -- RESTORE PREVIOUS STACK LEVEL
      CALL XSCRST
C
C -- REPOSITION INPUT FILE
      IRDFND(IFLIND) = IPOS
      GO TO 9000
C
2200  CONTINUE
C
C -- 'REPEAT'
C
C -- FIND STARTING ADDRESS OF CURRENT BLOCK, AND REPOSITION FILE
C    TO THE LINE AFTER THIS
      IPOS = KSCSTK ( JBSTRT , 0 )
      IRDFND(IFLIND) = IPOS + 1
      GO TO 9000
C
2300  CONTINUE
C
C -- 'TERMINATE'
C
C -- DISABLE PROCESSING OF THIS BLOCK. THIS INVOLVES CLEARING THE
C    EXECUTION FLAG, AND SETTING 'WASEX' SO THAT 'ELSE' DOES NOT
C    REENABLE EXECUTION.
C
      CALL XSCSTU ( JEXECU , 0 )
      CALL XSCSTU ( JWASEX , 1 )
      GO TO 9000
C
2400  CONTINUE
C
C -- 'CONTINUE'
C
C -- NO OPERATION
C
      GO TO 9000
C
9000  CONTINUE
C
C -- OUTPUT ANY MESSAGE ASSOCIATED WITH THIS CONTINGENCY
C
      IF ( IMSG .GT. 0 ) THEN
        WRITE ( NCAWU , 9905 ) CSCMSG(IMSG)(1:LSCMSG(IMSG))
9905    FORMAT ( / , 1X , A , / )
      ENDIF
      KSCACT = 1
      RETURN
C
C
9900  CONTINUE
      KSCACT = -1
      RETURN
C
9910  CONTINUE
      CALL XSCMSG ( MILLEG , MCONTI , ' ' , 0 )
      GO TO 9900
      END
CODE FOR KSCADR
      FUNCTION KSCADR ( IADDR , CVARIB , ITYPE , IVALUE )
C
C -- SEARCH INPUT FOR A VARIABLE NAME. IDENTIFY VARIABLE AND
C    RETURN NAME AND VALUE
C
C -- THIS ROUTINE PERFORMS A COMMON 'SCRIPT' SYNTAX CHECKING/ANALYSIS
C    FUNCTION.
C
C      INPUT PARAMETERS :-
C
C            <NONE>
C
C      OUTPUT PARAMETERS :-
C
C            IADDR       INDEX NUMBER OF IDENTIFIER FOUND
C            CVARIB      CHARACTER VARIABLE CONTAINING IDENTIFIER FOUND
C            ITYPE       TYPE OF VARIABLE ( INTEGER / REAL ETC. ). THIS
C                        CORRESPONDS TO THE 'SUBTYPE' FIELD USED BY
C                        'KSCIDN'
C            IVALUE      CURRENT VALUE OF THE VARIABLE
C
C      RETURN VALUE :-
C
C            0      VARIABLE NOT KNOWN
C            +VE    INDEX NUMBER OF VARIABLE ( A COPY OF 'IADDR' )
C
C
      CHARACTER*(*) CVARIB
C
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
C
C
C
C
C -- GET NAME FROM INPUT
C
      LENVAR = KCCARG ( CUPPER , IDIRPS , 1 , NVAR , NEND )
      IF ( LENVAR .LE. 0 ) GO TO 9910
C
      CVARIB = CUPPER(NVAR:NEND)
C
C -- LOOKUP IN TABLE
C
      IADDR = KSCIDN ( 2, 3, CVARIB, 1, ITYPE, IDENT, IVALUE, 1 )
      IF ( IADDR .LE. 0 ) GO TO 9900
C
      KSCADR = IADDR
      RETURN
C
C
9900  CONTINUE
C
      IADDR = 0
      CVARIB = ' '
      IVALUE = 0
C
      KSCADR = 0
      RETURN
C
9910  CONTINUE
C -- NO VARIABLE NAME
      CALL XSCMSG ( MMISSG , MVARIA , ' ' , 0 )
      GO TO 9900
      END
CODE FOR KSCCNT
      FUNCTION KSCCNT ( IN )
C
C -- DECLARE CONTIGENCIES
C
C -- THIS ROUTINE IMPLEMENTS THE 'ON' INSTRUCTION IN SCRIPTS.
C
C      INPUT PARAMETERS :-
C            IN          DUMMY
C
C      RETURN VALUE :-
C            <ANY>       VALUE TO BE ASSIGNED TO 'KSCPRC'
C
C
C      LOCAL VARIABLES :-
C
C            CACT        CHARACTER ARRAY DEFINING POSSIBLE ACTIONS
C                        FOR EACH CONTINGENCY. EACH ACTION HERE HAS
C                        A CORRESPONDING SECTION IN 'KSCACT' WHICH
C                        CARRIES IT OUT.
C            CMSG        CHARACTER ARRAY DEFINING POSSIBLE MESSAGES
C                        FOR EACH CONTINGENCY. THESE ARE OUTPUT BY
C                        'KSCACT' WHEN THE CONTINGENCY IS ACTIVATED
C
C
      PARAMETER ( LACT = 12 , NACT = 4 )
      CHARACTER*(LACT) CACT(NACT)
C
      PARAMETER ( LMSG = 12 , NMSG = 5 )
      CHARACTER*(LMSG) CMSG(NMSG)
      DIMENSION ITMSG(NMSG)
C
C
      PARAMETER ( MAXLAB = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      CHARACTER*(MAXLAB) CCONT
C
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C

      DATA CACT / 'RESTART' , 'REPEAT'  , 'TERMINATE' , 'CONTINUE' /
      DATA CMSG / 'ABANDONED' , 'USER1' , 'USER2' , 'USER3' , 'USER4' /
      DATA ITMSG / 6 , 7 , 8 , 9 , 10 /
C
C
C -- READ CONTINGENCY TYPE
C
      LENARG = KCCARG ( CUPPER , IDIRPS , 1 , NARG , NEND )
      IF ( LENARG .LE. 0 ) GO TO 9910
C
      CCONT = CUPPER(NARG:NEND)
C
C -- READ ACTION
C
      LENARG = KCCARG ( CUPPER , IDIRPS , 1 , NARG , NEND )
      IF ( LENARG .LE. 0 ) GO TO 9920
C
      IACT = KCCOMP ( CUPPER(NARG:NEND) , CACT , NACT , 1 )
      IF ( IACT .LE. 0 ) GO TO 9920
C
C -- CHECK TO SEE IF THERE IS A MESSAGE SPECIFIER
      IMSG = 0
      IF ( KCCARG ( CUPPER , IDIRPS , 1 , NARG , NEND ) .GT. 0 ) THEN
        IMSG = KCCOMP ( CUPPER(NARG:NEND) , CMSG , NMSG , 1 )
        IF ( IMSG .LE. 0 ) GO TO 9930
        IMSG = ITMSG(IMSG)
      ENDIF
C
      ISTAT = KSCIDN ( 1 , 1 , CCONT , 4 , IACT , ID , IMSG , -1 )
C
      KSCCNT = 0
      RETURN
C
C
9900  CONTINUE
      KSCCNT = 0
      RETURN
C
9910  CONTINUE
      CALL XSCMSG ( MMISSG , MCONTT , ' ' , 0 )
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MILLMS , MCONTI , ' ' , 0 )
      GO TO 9900
9930  CONTINUE
      CALL XSCMSG ( MILLEG , MMESSG , CUPPER(NARG:NEND) , 0 )
      GO TO 9900
      END
CODE FOR KSCELS
      FUNCTION KSCELS ( IN )
C
C -- THIS ROUTINE IMPLEMENTS THE SCRIPT 'ELSE' INSTRUCTION
C
C      INPUT PARAMETER :-
C
C            IN          DUMMY
C
C      RETURN VALUE :-
C            <ANY>       VALUE TO BE ASSIGNED TO 'KSCPRC'
C
C
C      LOCAL VARIABLES :-
C
C            CKEY1       CHARACTER ARRAY DEFINING KEYWORDS THAT CAN
C                        FOLLOW 'ELSE'. ( I.E. 'IF' )
C            CKEY2       CHARACTER ARRAY DEFINING KEYWORDS THAT CAN
C                        FOLLOW THE LOGICAL EXPRESSION. ( I.E. 'THEN' )
C
      PARAMETER ( JLOGIC = 3 )
      PARAMETER ( JIF = 4 )
C
      PARAMETER ( LKEY1 = 4 , NKEY1 = 1 )
      CHARACTER*(LKEY1) CKEY1(NKEY1)
C
      PARAMETER ( LKEY2 = 4 , NKEY2 = 1 )
      CHARACTER*(LKEY2) CKEY2(NKEY2)
C
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
      PARAMETER ( JVARIB =  1 , JNVARI =  2 , JNFDAT =  3 )
      PARAMETER ( JNFCHR =  4 , JEXECU =  5 , JBTYPE =  6 )
      PARAMETER ( JBSTRT =  7 , JBLEND =  8 , JNSTAT =  9 )
      PARAMETER ( JREQST = 10 , JWASEX = 11 , JSTLVL = 12 )
C
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
C
C
      DATA CKEY1 / 'IF' /
      DATA CKEY2 / 'THEN' /
C
C
C -- CHECK THAT THE CURRENT BLOCK IS AN 'IF' BLOCK. 'ELSE' STATEMENTS
C    ONLY MAKE SENSE IN 'IF' BLOCKS.
C
      ITYPE = KSCSTK ( JBTYPE , 0 )
      IF ( ITYPE .NE. JIF ) GO TO 9910
C
C -- CHECK FOR A FOLLOWING 'IF', IMPLYING AN OVERALL 'ELSE IF' EFFECT.
C
      LENARG = KCCARG ( CUPPER , IDIRPS , 1 , NARG , NEND )
      IF ( LENARG .LE. 0 ) THEN
        IVALUE = 1
      ELSE
        ISTAT = KCCOMP ( CUPPER(NARG:NEND) , CKEY1 , NKEY1 , 1 )
        IF ( ISTAT .LE. 0 ) GO TO 9920
C
C -- IF THE COMMAND IS 'ELSE IF', A LOGICAL EXPRESSION AND 'THEN' SHOULD
C    FOLLOW IT.
C
        ISTAT = KSCEXP ( IVALUE , IEXTYP , CUPPER, CLOWER , IDIRPS , 1 )
        IF ( ISTAT .LT. 0 ) GO TO 9900
        IF ( ISTAT .EQ. 0 ) GO TO 9930
        IF ( IEXTYP .NE. JLOGIC ) GO TO 9940
C
C -- READ 'THEN'
        LENARG = KCCARG ( CUPPER , IDIRPS , 1 , NARG , NEND )
        IF ( LENARG .LE. 0 ) GO TO 9950
C
        ISTAT = KCCOMP ( CUPPER(NARG:NEND) , CKEY2 , NKEY2 , 1 )
        IF ( ISTAT .LE. 0 ) GO TO 9920
      ENDIF
C
C -- ENABLE EXECUTION IF LOGICAL EXPRESSION TRUE, AND NO PART OF IF
C    BLOCK HAS EXECUTED
      IWASEX = KSCSTK ( JWASEX , 0 )
C
      IF ( ( IWASEX .LE. 0 ) .AND. ( IVALUE .GT. 0 ) ) THEN
        CALL XSCSTU ( JEXECU , 1 )
        CALL XSCSTU ( JWASEX , 1 )
      ELSE
        CALL XSCSTU ( JEXECU , 0 )
      ENDIF
C
9900  CONTINUE
      KSCELS = 0
      RETURN
C
9910  CONTINUE
      CALL XSCMSG ( MILLEG, MCOMND, 'ELSE should appear in IF block',0)
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MILLEG , MKEYWD , CUPPER(NARG:NEND) , 0 )
      GO TO 9900
9930  CONTINUE
      CALL XSCMSG ( MMISSG , MEXPRE , ' ' , 0 )
      GO TO 9900
9940  CONTINUE
      CALL XSCMSG ( MWRONG , MEXPRE , ' ' , 0 )
      GO TO 9900
9950  CONTINUE
      CALL XSCMSG ( MMISSG , MKEYWD , ' ' , 0 )
      GO TO 9900
      END
CODE FOR KSCEST
      FUNCTION KSCEST ( CTEXT , ITYPE , IRESLT )
C
C -- GET STANDARD VALUES IN EXPRESSIONS
C
C -- THIS ROUTINE IS CALLED BY THE EXPRESSION ANALYSIS ROUTINE 'KSCEXP'
C    TO IDENTIFY CERTAIN TOKENS AS 'STANDARD VALUES' AND TO RETURN
C    THE CORRESPONDING VALUE.
C
C
C
C      CTEXT       TEXT TO BE CHECKED FOR AN STANDARD VALUE
C                  SPECIFIER
C      ITYPE       DATA TYPE OF SPECIFIER FOUND
C                    1      INTEGER
C                    2      REAL
C                    3      LOGICAL
C      IRESLT      VALUE FOUND
C
C      KSCEST      INDICATES SUCCESS OR FAILURE
C                    -1      FAILURE
C                    +1      SUCCESS
C
C -- THE FOLLOWING VALUES ARE DETECTED BY THIS ROUTINE :-
C
C      NAME        TYPE        VALUE
C      ----        ----        -----
C      TRUE        LOGICAL     TRUE
C      FALSE       LOGICAL     FALSE
C      VALUE       <VARIABLE>  <VARIABLE>  THE VALUE AND TYPE DEPENDS
C                              ON THE TYPE OF THE LAST USER INPUT
C
C -- NAMES ARE STORED IN 'CSTAND'
C    TYPES ARE STORED IN 'ISTYPE'
C    VALUES ARE STORED IN 'ISVALU'
C    IF VALUE IS DETERMINED AT EXECUTION TIME, A FLAG IN LOGICAL ARRAY
C    'LSCALC' IS SET TO TRUE, AND 'ISTYPE' AND 'ISVALU' MAY ( IF
C    APPROPRIATE ) BE ZERO.
C
C
      CHARACTER*(*) CTEXT
C
C
      PARAMETER ( LSTAND = 12 , NSTAND = 6 )
      PARAMETER ( JINTEG = 1 , JREAL = 2 , JLOGIC = 3 )
      PARAMETER ( JCHAR = 4 )
      PARAMETER ( JTRUE = 1  , JFALSE = 0 )
C
      CHARACTER*(LSTAND) CSTAND(NSTAND)
      DIMENSION ISTYPE(NSTAND)
      DIMENSION ISVALU(NSTAND)
      LOGICAL LSCALC(NSTAND)
C
C
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
C
C
      DATA CSTAND / 'TRUE' , 'FALSE' , 'VALUE' , 'USERLENGTH' ,
     2 'NULLSTRING' , 'CVALUE' /
      DATA ISTYPE / JLOGIC , JLOGIC  , 0       , JINTEG       ,
     2 JCHAR        , JCHAR    /
      DATA ISVALU / JTRUE  , JFALSE  , 0       , 0            ,
     2 0            , 0        /
      DATA LSCALC / .FALSE. , .FALSE. , .TRUE. , .TRUE.       ,
     2 .FALSE.      , .TRUE.   /
C
C
C
C
C -- CHECK SPECIFIER AGAINST ALLOWED LIST. RETURN IF NOT FOUND
C
      ISTAND = KCCOMP ( CTEXT , CSTAND , NSTAND  , 1 )
      IF ( ISTAND .LE. 0 ) THEN
        KSCEST = -1
        RETURN
      ENDIF
C
C
C
C -- DETERMINE VALUE
C
      IF ( LSCALC(ISTAND) ) THEN
C
C      **** VALUES WHICH MUST BE CALCULATED AT EXECUTION TIME ****
C
C -- 'VALUE'
C
        IF ( ISTAND .EQ. 3 ) THEN
C
          ITYPE = ISCVTP
          CALL XMOVE ( ISCVAL , IRESLT , 1 )
C
C -- 'USERLENGTH'
C
        ELSE IF ( ISTAND .EQ. 4 ) THEN
          ITYPE = JINTEG
          IRESLT = MAX0 ( 0 , ( IINPLN - IINPPS + 1 ) )
C
C -- 'CVALUE'
C
        ELSE IF ( ISTAND .EQ. 6 ) THEN
          ITYPE = JCHAR
          ISTAT = KSCSCD ( CLINPB(ISCVLS:ISCVLS+ISCVLN-1) , IRESLT )
C
        ENDIF
C
      ELSE
C
C                   **** FIXED, PRECODED VALUES ****
C
        ITYPE = ISTYPE(ISTAND)
        CALL XMOVE ( ISVALU(ISTAND) , IRESLT , 1 )
      ENDIF
C
C
C
C -- RETURN SUCCESS
C
      KSCEST = 1
C
      RETURN
      END
CODE FOR KSCETR
      FUNCTION KSCETR ( IN )
C
C -- THIS ROUTINE IMPLEMENTS THE 'EXTRACT' INSTRUCTION IN SCRIPTS
C
C      INPUT PARAMETER :-
C
C            IN          DUMMY
C
C      RETURN VALUE :-
C            <ANY>       RETURN VALUE TO BE ASSIGNED TO 'KSCPRC'
C
C
C -- DEFINE SUBCOMMANDS FOR 'EXTRACT'
      PARAMETER ( LOPR = 8 , NOPR = 5 )
      CHARACTER*(LOPR) COPER(NOPR)
C
C -- DEFINE KEYWORDS FOR 'EXTRACT FIND'
      PARAMETER ( LFIND = 8 , NFIND = 2 )
      CHARACTER*(LFIND) CFIND(NFIND)
C
C -- DEFINE KEYWORDS FOR 'EXTRACT TRANSFER'
      PARAMETER ( LTRANS = 8 , NTRANS = 2 )
      CHARACTER*(LTRANS) CTRANS(NTRANS)
C
C -- SET UP INPUT BUFFER, AND AREA TO STORE SEARCH STRING
      PARAMETER ( NINPBF = 120 )
      CHARACTER*(NINPBF) CINPBF
      PARAMETER ( NSERCH = 80 )
      CHARACTER*(NSERCH) CSERCH
C
      PARAMETER ( MAXLAB = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      COMMON /XSCCNT/ ISCXN1 , NCHKUS , ISCXN3 , MAXSYS
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      SAVE CINPBF
      SAVE LENGTH
C
      DATA COPER / 'TRANSFER' , 'REWIND' , 'CLOSE' , 'NEXT' , 'FIND' /
      DATA CFIND / 'STRING' , 'BUFFER' /
      DATA CTRANS / 'COMMAND' , 'INPUT' /
C
C
C
C -- READ KEYWORD
C
      LENTYP = KCCARG ( CUPPER , IDIRPS , 1 , NTYPE , NEND )
      IF ( LENTYP .LE. 0 ) GO TO 9940
C
      ITYPE = KCCOMP ( CUPPER(NTYPE:NEND) , COPER , NOPR , 2 )
      IF ( ITYPE .LE. 0 ) GO TO 9910
C
C
C -- 'TRANSFER'
C
      IF ( ITYPE .EQ. 1 ) THEN
C
C -- READ SUBKEYWORD
        LENARG = KCCARG ( CUPPER , IDIRPS , 1 , NTYPE , NEND )
        IF ( LENARG .LE. 0 ) GO TO 9940
C
        ITRANS = KCCOMP ( CUPPER(NTYPE:NEND) , CTRANS , NTRANS , 2 )
        IF ( ITRANS .LE. 0 ) GO TO 9910
C
C -- MOVE DATA TO USER INPUT BUFFER OR COMMAND BUFFER
        IF ( ITRANS .EQ. 1 ) THEN
          IF ( ICOMLN .LE. 0 ) THEN
            IBSTRT = 1
          ELSE
            IBSTRT = ICOMLN + 2
          ENDIF
          ICOMLN = IBSTRT + LENGTH - 1
          CCOMBF(IBSTRT:ICOMLN) = CINPBF(1:LENGTH)
        ELSE IF ( ITRANS .EQ. 2 ) THEN
          CLINPB = CINPBF(1:LENGTH)
          CUINPB = CINPBF(1:LENGTH)
          IINPPS = 1
          IINPLN = LENGTH
        ENDIF
C
C -- 'REWIND'
C
      ELSE IF ( ITYPE .EQ. 2 ) THEN
C
C -- REWIND FILE
        REWIND NCEXTR
C
C -- 'CLOSE'
C
      ELSE IF ( ITYPE .EQ. 3 ) THEN
C
C -- CLOSE FILE
        ISTAT = KFLCLS ( NCEXTR )
C
      ELSE IF ( ITYPE .EQ. 4 ) THEN
C
C -- 'NEXT'
C
C -- READ NEXT RECORD
C
        ISTAT = KRDLIN ( NCEXTR , CINPBF , LENGTH )
        IF ( ISTAT .LT. 0 ) GO TO 8910
        IF ( ISTAT .EQ. 0 ) GO TO 8920
C
      ELSE IF ( ITYPE .EQ. 5 ) THEN
C
C -- 'FIND'
C
C -- FIND A PARTICULAR RECORD
C
C -- READ SUBKEYWORD
C
        LENARG = KCCARG ( CUPPER , IDIRPS , 1 , NTYPE , NEND )
        IF ( LENARG .LE. 0 ) GO TO 9940
C
        IFIND = KCCOMP ( CUPPER(NTYPE:NEND) , CFIND , NFIND , 2 )
        IF ( IFIND .LE. 0 ) GO TO 9910
C
        IF ( IFIND .EQ. 1 ) THEN
C -- EITHER READ SEARCH STRING FROM INPUT LINE
          LENSER = KCCARG ( CUPPER , IDIRPS , 2 , NSER , NEND )
          IF ( LENSER .LE. 0 ) GO TO 9950
          CSERCH = CLOWER(NSER:NEND)
        ELSE IF ( IFIND .EQ. 2 ) THEN
C -- OR GET IT FROM THE COMMAND BUFFER
          LENSER = ICOMPS
          CSERCH = CCOMBF(1:LENSER)
        ENDIF
C
C -- SEARCH ENTIRE FILE FOR THE STRING
        REWIND NCEXTR
2500    CONTINUE
          ISTAT = KRDLIN ( NCEXTR , CINPBF , LENGTH )
          IF ( ISTAT .LT. 0 ) GO TO 8910
          IF ( ISTAT .EQ. 0 ) GO TO 8920
C -- SEARCH ONLY ALLOWS STRING TO BE AT BEGINNING OF LINE
          IF ( CINPBF(1:LENSER) .NE. CSERCH(1:LENSER) ) GO TO 2500
C
      ENDIF
C
      GO TO 9000
C
8900  CONTINUE
C -- SET ERROR FLAG, SO SCRIPT CAN TAKE APPROPRIATE ACTION
      CALL XERHND ( IERSFL )
      GO TO 9000
8910  CONTINUE
C -- READ ERROR ON EXTRACT FILE
      GO TO 8900
8920  CONTINUE
C -- END OF FILE ERROR ON EXTRACT FILE
      GO TO 8900
C
C
9000  CONTINUE
C
      KSCETR = 0
C
      RETURN
C
9900  CONTINUE
      GO TO 9000
9910  CONTINUE
      CALL XSCMSG ( MILLEG , MKEYWD , CUPPER(NTYPE:NEND) , 0 )
      GO TO 9900
9940  CONTINUE
      CALL XSCMSG ( MMISSG , MKEYWD , ' ' , 0 )
      GO TO 9900
9950  CONTINUE
      CALL XSCMSG ( MMISSG , MDATA , ' ' , 0 )
      GO TO 9900
C
C
      END
CODE FOR KSCEVL
      FUNCTION KSCEVL ( IN )
C
C -- EVALUATE EXPRESSION.
C
C -- THIS ROUTINE IMPLEMENTS THE SCRIPT 'EVALUATE' INSTRUCTION
C
C  'IN' IS A DUMMY ARGUMENT
C
C      RETURN VALUE OF KSCEVL IS THE VALUE TO BE USED FOR 'KSCPRC'
C
C
C
      PARAMETER ( MAXLAB = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      CHARACTER*(MAXLAB) CVARIB
C
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
C -- FIND NAME OF RESULT VARIABLE
C
      ISTAT = KSCADR ( IADDR , CVARIB , ITYPE , IVALUE )
      IF ( ISTAT .LE. 0 ) GO TO 9900
C
C -- FIND '=' SIGN
      LENEQU = KCCARG ( CUPPER , IDIRPS , 1 , NEQU , NEND )
      IF ( LENEQU .LE. 0 ) GO TO 9910
      IF ( CUPPER(NEQU:NEND) .NE. '=' ) GO TO 9910
C
C -- FIND EXPRESSION, AND CHECK TYPE AGAINST THE TYPE OF THE VARIABLE.
C
      ISTAT = KSCEXP ( IRESLT , IRTYPE , CUPPER , CLOWER , IDIRPS , 1 )
      IF ( ISTAT .LT. 0 ) GO TO 9900
      IF ( ISTAT .EQ. 0 ) GO TO 9930
      IF ( ITYPE .NE. IRTYPE ) GO TO 9920
C
C -- STORE RESULT
C
C -- MAKE SPECIAL PROVISION FOR KEEPING CHARACTER RESULT. VARIABLE
C    ALREADY HAS DESCRIPTOR WHICH CAN HOLD RESULT, SO USE THAT.
C
      IF ( IRTYPE .EQ. 4 ) THEN
        NEWVAL = IRESLT
        IRESLT = IVALUE
        ISTAT = KSCSDD ( 2 , NEWVAL , IRESLT )
      ENDIF
C
C
      ISTAT = KSCIDN ( 1 , 3 , CVARIB , 1 , ITYPE , IID , IRESLT , 1 )
      IF ( ISTAT .LE. 0 ) GO TO 9900
C
9900  CONTINUE
      KSCEVL = 0
C
      RETURN
C
C
9910  CONTINUE
C -- INCORRECT '='
      CALL XSCMSG ( MILLMS , MEQUAL , ' ' , 0 )
      GO TO 9900
9920  CONTINUE
C -- INCORRECT EXPRESSION TYPE
      CALL XSCMSG ( MINCOR , MEXPRE , ' ' , 0 )
      GO TO 9900
9930  CONTINUE
C -- NO EXPRESSION
      CALL XSCMSG ( MMISSG , MEXPRE , ' ' , 0 )
      GO TO 9900
C
C
      END
CODE FOR KSCEXE
      FUNCTION KSCEXE ( ICODE , XCODE , LENITM , NITEM , CTEXT )
C
C -- EXECUTE CODE GENERATED BY 'KSCEXP'
C
C -- THIS IS THE SECOND PART OF EXPRESSION EVALUATION. THIS ROUTINE
C    TAKES THE INTERPRETATION OF THE INPUT EXPRESSION PRODUCED BY
C    'KSCEXP', AND ACTUALLY DOES THE CALCULATION.
C
C
C      INPUT PARAMETERS :-
C
C            ICODE       THIS IS AN INTEGER ARRAY CONTAINING THE CODE TO
C                        BE EXECUTED.
C            XCODE       THIS IS A REAL ARRAY, EQUIVALENCED TO 'ICODE',
C                        USED TO ACCES REAL NUMBERS
C            LENITM      THE LENGTH OF EACH ITEM IN ICODE/XCODE
C            NITEM       THE NUMBER OF INDIVIDUAL EXPRESSION ITEMS
C            CTEXT       A CHARACTER REPRESENTATION OF THE ORIGINAL
C                        EXPRESSION. THIS IS USED, WITH THE ADDRESSES
C                        STORED IN EACH ITEM IN ICODE/XCODE, TO PRODUCE
C                        DIAGNOSTICS, WHEN THE EVALUATION FAILS
C
C      OUTPUT PARAMETERS :-
C        THERE ARE NO EXPLICIT OUTPUT PARAMETERS, BUT THE CALCULATION
C        DESTROYS THE CONTENTS OF ICODE/XCODE AS IT PROCEEDS, AND THE
C        RESULT WILL BE CONTAINED IN THE FIRST ELEMENT OF ICODE/XCODE
C        AT THE END OF THE EVALUATION.
C
C      RETURN VALUES :-
C            -1          EVALUATION FAILED
C            +1          EVALUATION SUCCESSFUL
C
C
C      LOCAL VARIABLES :-
C            CDATAT      CHARACTER ARRAY CONTAINING THE NAMES OF THE
C                        VARIOUS DATA TYPES ( INTEGER/REAL ETC. ) ,
C                        USED DURING DIAGNOSTIC OUTPUT.
C            IDEFOP      INTEGER ARRAY CONTROLLING OPERATOR DEFINITIONS.
C                        THERE IS AN ENTRY IN 'IDEFOP' FOR EACH OPERATOR
C                        WHICH CAN BE HANDLED BY 'KSCEXP'. THE VALUE OF
C                        THIS ENTRY POINTS TO A DEFINTION OF A 'CLASS'
C                        OF OPERATORS, CONTAINED IN 'NARGS', 'NRESLT',
C                        AND 'ITYPES'. THUS A NUMBER OF OPERATORS WILL
C                        SHARE THE SAME DEFINITION, IF THEY BELONG TO
C                        THE SAME 'CLASS'.
C
C                        FOR EXAMPLE '.EQ.' AND '.NE.'
C                        BELONG TO THE SAME CLASS, BECAUSE THEY BOTH
C                        TAKE TWO ARGUMENTS OF ANY DATA AND GIVE ONE
C                        RESULT
C
C            NARGS       NUMBER OF ARGUMENTS REQUIRED BY THIS OPERATOR.
C                        THERE MUST BE AT LEAST THIS NUMBER OF DATA
C                        ITEMS AVALAILBLE, WHEN THE OPERATOR IS FOUND
C            NRESLT      NUMBER OF RESULT VALUES GENERATED AFTER
C                        APPLICATION OF THE OPERATOR TO ITS ARGUMENTS.
C                        THIS WILL OFTEN, BUT NOT INVARIABLY, BE 1
C            ITYPES      THIS ARRAY DEFINES THE TYPES OF DATA REQUIRED
C                        FOR EACH ARGUMENT OF THE OPERATOR. THE TYPES
C                        MAY BE :-
C                              JNONE       NO DATA
C                              JINTEG      INTEGER VALUE
C                              JREAL       REAL NUMBER
C                              JLOGIC      LOGICAL VALUE
C                              JCHAR       CHARACTER VALUE
C                              JANY        ANY DATA
C                              JSAME       SAME AS TYPE OF PREVIOUS ITEM
C                              JNUMER      NUMERIC DATA ( I.E. INTEGER
C                                          OR REAL )
C
C            JVALUE      ADDRESS IN EACH ITEM IN ICODE/XCODE OF DATA
C                        VALUE, IF ANY
C            JVTYPE      ADDRESS OF TYPE OF VALUE ( INTEGER/REAL ETC. )
C            JCTYPE      ADDRESS OF TYPE OF THIS ITEM (DATA OR OPERATOR)
C            JPOSTK      ADDRESS OF POSITION OF ITEM IN INPUT EXPRESSION
C
C            NOPER       NUMBER OF OPERATORS KNOWN
C            NUBASE      NUMBER OF UNARY OPERATORS KNOWN
C            NARGMX      MAXIMUM NUMBER OF ARGUMENTS FOR AN OPERATOR
C            NOTYPE      NUMBER OF OPERATOR CLASSES
C
C
      CHARACTER*(*) CTEXT
C
      PARAMETER ( JVALUE = 1 , JVTYPE = 2 , JCTYPE = 3 )
      PARAMETER ( JPOSTK = 4 )
      PARAMETER ( NOPER = 35 , NUBASE = 24 )
      PARAMETER ( NARGMX = 3 , NOTYPE = 13 )
C
      PARAMETER ( JNONE = 0 )
      PARAMETER ( JINTEG = 1 , JREAL = 2 , JLOGIC = 3 )
      PARAMETER ( JCHAR = 4 )
      PARAMETER ( JANY = 5 , JSAME = 6 , JNUMER = 7 )
C
      CHARACTER*12 CDATAT(JNONE:JNUMER)
C
      DIMENSION ICODE(LENITM,NITEM)
      DIMENSION XCODE(LENITM,NITEM)
C
      DIMENSION IDEFOP(NOPER)
C
      DIMENSION NARGS(NOTYPE) , NRESLT(NOTYPE)
      DIMENSION ITYPES(NARGMX,NOTYPE)
C
      DIMENSION IARG(NARGMX) , ITYPE(NARGMX) , IPOSIT(NARGMX)
C
      PARAMETER ( LENWRK = 80 )
      CHARACTER*(LENWRK) CWORK1 , CWORK2
C
      CHARACTER*6 CLOGIC(0:1)
C
      LOGICAL LRESLT , LEQUAL , LLESST
C
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      PARAMETER ( NCHK = 20 , LCHK = 12 )
      CHARACTER*(LCHK) CCHECK(NCHK)
      COMMON /XSCCHK/ CCHECK
      COMMON /XSCCNT/ ISCXN1 , NCHKUS , ISCXN3 , MAXSYS
C
C
      DATA IDEFOP / 1 , 1 , 2 , 2 , 2 , 2 , 3 , 3 , 3 , 3 ,
     2              2 , 2 , 2 , 2 , 2 , 2 , 2 , 2 , 5 , 5 ,
     3           6 , 7 , 11 , 11 ,
     4           8 , 9 ,  9 , 10 ,  8 , 10 ,  4 , 12 , 13 , 10 , 12 /
C
      DATA NARGS  / 0 , 2 , 2 , 1 , 2 , 2 , 3 , 1 , 1 , 1 , 2 , 1 , 1 /
      DATA NRESLT / 0 , 1 , 1 , 1 , 1 , 2 , 1 , 1 , 1 , 1 , 1 , 1 , 1 /
C
      DATA ITYPES /                 JNONE  , JNONE  , JNONE  ,
     2 JNUMER , JSAME  , JNONE  ,   JANY   , JSAME  , JNONE  ,
     3 JREAL  , JNONE  , JNONE  ,   JLOGIC , JLOGIC , JNONE  ,
     4 JANY   , JLOGIC , JNONE  ,   JANY   , JSAME  , JLOGIC ,
     5 JLOGIC , JNONE  , JNONE  ,   JNUMER , JNONE  , JNONE  ,
     6 JINTEG , JNONE  , JNONE  ,     JCHAR  , JCHAR  , JNONE   ,
     7 JCHAR  , JNONE  , JNONE  ,     JANY   , JNONE  , JNONE   /
C
      DATA CDATAT / 'none' , 'integer' , 'real' , 'logical' ,
     2              'character' , 'any' , 'same' , 'numeric' /
C
      DATA CLOGIC / 'FALSE' , 'TRUE' /
C
C
      NLAST = 0
C
C -- SCAN THROUGH DATA
C
      DO 2000 I = 1 , NITEM
C
C -- NUMERIC DATA IS PUSHED TOWRDS THE FRONT OF THE LIST
C
        IF ( ICODE(JCTYPE,I) .EQ. 1 ) THEN
          NLAST = NLAST + 1
          IF ( NLAST .EQ. I ) GO TO 2000
          CALL XMOVE ( ICODE(JVALUE,I) , ICODE(JVALUE,NLAST) , LENITM )
          GO TO 2000
        ENDIF
C
C -- OPERATORS ARE EXECUTED
C
        IOPER = ICODE(JVALUE,I)
        IOPPOS = ICODE(JPOSTK,I)
C
        IDEFIN = IDEFOP(IOPER)
        NARGUM = NARGS(IDEFIN)
        NRES   = NRESLT(IDEFIN)
C
C -- CHECK DATA REQUIRED BY OPERATOR IS AVAILABLE. SCAN BACKWARDS
C
        IF ( NARGUM .GT. NLAST ) GO TO 9910
C
        IADDR = NLAST
        DO 1200 J = 1 , NARGUM
          IF ( ICODE(JCTYPE,IADDR) .NE. 1 ) GO TO 9910
C
          IARG(J) = IADDR
          ITYPE(J) = ICODE(JVTYPE,IADDR)
          IPOSIT(J) = ICODE(JPOSTK,IADDR)
          IADDR = IADDR - 1
1200    CONTINUE
C
C -- CHECK TYPES OF DATA
C
        ILAST = 0
        DO 1300 J = 1 , NARGUM
          IREQ = ITYPES(J,IDEFIN)
C
          IF ( IREQ .EQ. JANY ) THEN
          ELSE IF ( IREQ .EQ. JNONE ) THEN
            GO TO 9920
          ELSE IF ( IREQ .EQ. JSAME ) THEN
            IF ( ILAST .NE. ITYPE(J) ) GO TO 9920
          ELSE IF ( IREQ .EQ. JNUMER ) THEN
            IF ( ( ITYPE(J) .NE. JINTEG ) .AND.
     2           ( ITYPE(J) .NE. JREAL ) ) GO TO 9920
          ELSE
            IF ( ITYPE(J) .NE. IREQ ) GO TO 9920
          ENDIF
C
          ILAST = ITYPE(J)
1300    CONTINUE
C
        NLAST = NLAST - NARGUM + NRES
C
C -- DATA CHECK WAS O.K.
C
C -- OPERATORS 1 AND 2 ARE '(' AND ')' AND DO NOT CAUSE ANY EXECUTION
C
C
      IF ( IOPER .GT. NUBASE ) GO TO 5000
C
      GO TO ( 8000 , 8000 , 4010 , 4020 , 4030 ,
     2        4040 , 4050 , 4050 , 4050 , 4050 ,
     3        4050 , 4050 , 4050 , 4050 , 4050 ,
     4        4050 , 4050 , 4050 , 4100 , 4110 ,
     5        8000 , 4120 , 4130 , 4140 ,
     6        9940 ) , IOPER
      GO TO 9940
C
C
C
4010  CONTINUE
C
C -- 'ADD'
C
          IF ( ITYPE(1) .EQ. 1 ) THEN
            ICODE(JVALUE,IARG(2)) = ICODE(JVALUE,IARG(2)) +
     2                              ICODE(JVALUE,IARG(1))
          ELSE IF ( ITYPE(1) .EQ. 2 ) THEN
            XCODE(JVALUE,IARG(2)) = XCODE(JVALUE,IARG(2)) +
     2                              XCODE(JVALUE,IARG(1))
          ENDIF
C
      GO TO 8000
C
C
4020  CONTINUE
C
C -- 'SUBTRACT'
C
          IF ( ITYPE(1) .EQ. 1 ) THEN
            ICODE(JVALUE,IARG(2)) = ICODE(JVALUE,IARG(2)) -
     2                              ICODE(JVALUE,IARG(1))
          ELSE IF ( ITYPE(1) .EQ. 2 ) THEN
            XCODE(JVALUE,IARG(2)) = XCODE(JVALUE,IARG(2)) -
     2                              XCODE(JVALUE,IARG(1))
          ENDIF
C
      GO TO 8000
C
C
4030  CONTINUE
C
C -- 'MULTIPLY'
C
          IF ( ITYPE(1) .EQ. 1 ) THEN
            ICODE(JVALUE,IARG(2)) = ICODE(JVALUE,IARG(2)) *
     2                              ICODE(JVALUE,IARG(1))
          ELSE IF ( ITYPE(1) .EQ. 2 ) THEN
            XCODE(JVALUE,IARG(2)) = XCODE(JVALUE,IARG(2)) *
     2                              XCODE(JVALUE,IARG(1))
          ENDIF
C
      GO TO 8000
C
C
4040  CONTINUE
C
C
C -- 'DIVIDE'
C
          IF ( ITYPE(1) .EQ. 1 ) THEN
            ICODE(JVALUE,IARG(2)) = ICODE(JVALUE,IARG(2)) /
     2                              ICODE(JVALUE,IARG(1))
          ELSE IF ( ITYPE(1) .EQ. 2 ) THEN
            XCODE(JVALUE,IARG(2)) = XCODE(JVALUE,IARG(2)) /
     2                              XCODE(JVALUE,IARG(1))
          ENDIF
      GO TO 8000
C
C
4050  CONTINUE
C
C -- 'LOGICAL OPERATIONS'
          IF ( ITYPE(1) .NE. 2 ) THEN
            ISTAT = KSCREL ( ICODE(JVALUE,IARG(2)) , ITYPE(1) ,
     2                       ICODE(JVALUE,IARG(1)) , ITYPE(1) ,
     3                       LEQUAL , LLESST )
          ELSE
            ISTAT = KSCREL ( XCODE(JVALUE,IARG(2)) , ITYPE(1) ,
     2                       XCODE(JVALUE,IARG(1)) , ITYPE(1) ,
     3                       LEQUAL , LLESST )
          ENDIF
          IF ( ( IOPER .EQ. 7 ) .OR. ( IOPER .EQ. 8 ) ) THEN
            LRESLT = LEQUAL
          ELSE IF ( ( IOPER .EQ. 9 ) .OR. ( IOPER .EQ. 10 ) ) THEN
            LRESLT = .NOT. LEQUAL
          ELSE IF ( ( IOPER .EQ. 11 ) .OR. ( IOPER .EQ. 12 ) ) THEN
            LRESLT = LLESST .OR. LEQUAL
          ELSE IF ( ( IOPER .EQ. 13 ) .OR. ( IOPER .EQ. 14 ) ) THEN
            LRESLT = .NOT. LLESST
          ELSE IF ( ( IOPER .EQ. 15 ) .OR. ( IOPER .EQ. 16 ) ) THEN
            LRESLT = LLESST
          ELSE IF ( ( IOPER .EQ. 17 ) .OR. ( IOPER .EQ. 18 ) ) THEN
            LRESLT = .NOT. ( LLESST .OR. LEQUAL )
          ENDIF
C
          IF ( LRESLT ) THEN
            ICODE(JVALUE,IARG(2)) = 1
          ELSE
            ICODE(JVALUE,IARG(2)) = 0
          ENDIF
          ICODE(JVTYPE,IARG(2)) = 3
C
      GO TO 8000
C
C
4100  CONTINUE
C
C -- 'OR'
C
          ICODE(JVALUE,IARG(2)) =
     2       MAX0 ( ICODE(JVALUE,IARG(2)) , ICODE(JVALUE,IARG(1)) )
C
C
      GO TO 8000
C
C
4110  CONTINUE
C
C -- 'AND'
C
          ICODE(JVALUE,IARG(2)) =
     2       MIN0 ( ICODE(JVALUE,IARG(2)) , ICODE(JVALUE,IARG(1)) )
C
C
      GO TO 8000
C
C
4120  CONTINUE
C
C -- '.ELSE.'
C
          IF ( ICODE(JVALUE,IARG(3)) .GT. 0 ) THEN
            IFROM = 2
          ELSE
            IFROM = 1
          ENDIF
          CALL XMOVE ( ICODE(JVALUE,IARG(IFROM)) ,
     2                 ICODE(JVALUE,IARG(3)) , LENITM )
C
      GO TO 8000
C
C
4130  CONTINUE
C
C -- 'CONCATENATE'
C
      ISTAT = KSCSDC ( ICODE(JVALUE,IARG(2)) , CWORK1 , LEN1 )
      IF ( LEN1 .LT. LENWRK ) THEN
        ISTAT = KSCSDC ( ICODE(JVALUE,IARG(1)),CWORK1(LEN1+1:), LEN2 )
      ELSE
        LEN2 = 0
      ENDIF
      ISTAT = KSCSCD ( CWORK1(1:LEN1+LEN2) , ICODE(JVALUE,IARG(2)) )
C
      GO TO 8000
C
C
4140  CONTINUE
C
C -- 'STARTSWITH'
C
      ISTAT = KSCSDC ( ICODE(JVALUE,IARG(2)) , CWORK1 , LEN1 )
      ISTAT = KSCSDC ( ICODE(JVALUE,IARG(1)) , CWORK2 , LEN2 )
C
      IF ( LEN1 .LE. 0 ) THEN
        LRESLT = .FALSE.
      ELSE IF ( LEN2 .LE. 0 ) THEN
        LRESLT = .TRUE.
      ELSE IF ( LEN2 .GT. LEN1 ) THEN
        LRESLT = .FALSE.
      ELSE
        LRESLT = ( CWORK1(1:LEN2) .EQ. CWORK2(1:LEN2) )
      ENDIF
C
      IF ( LRESLT ) THEN
        ICODE(JVALUE,IARG(2)) = 1
      ELSE
        ICODE(JVALUE,IARG(2)) = 0
      ENDIF
      ICODE(JVTYPE,IARG(2)) = 3
C
      GO TO 8000
C
C
C
C
5000  CONTINUE
C
C
C
C                        **** UNARY OPERATORS ****
C
C
C
      IUOPER = IOPER - NUBASE
C
      GO TO ( 5010 , 8000 , 5020 , 5030 , 8000 ,
     2        5040 , 5050 , 5060 , 5070 , 5080 ,
     3        5090 ,
     4        9940 ) , IUOPER
      GO TO 9940
C
C
C
C
5010  CONTINUE
C
C -- 'NOT'
C
          ICODE(JVALUE,IARG(1)) = 1 - ICODE(JVALUE,IARG(1))
C
C
      GO TO 8000
C
C
5020  CONTINUE
C
C -- 'UNARY -'
C
      IF ( ICODE(JVTYPE,IARG(1)) .EQ. 1 ) THEN
        ICODE(JVALUE,IARG(1)) = - ICODE(JVALUE,IARG(1))
      ELSE
        XCODE(JVALUE,IARG(1)) = - XCODE(JVALUE,IARG(1))
      ENDIF
C
      GO TO 8000
C
C
5030  CONTINUE
C
C -- 'EXISTS'
C
        ILIST = ICODE(JVALUE,IARG(1))
        IF ( ILIST .LE. 0 ) GO TO 9930
        IF ( ILIST .GT. 50 ) GO TO 9930
        ICODE(JVALUE,IARG(1)) = KEXIST ( ILIST )
C
      GO TO 8000
C
C
5040  CONTINUE
C
C -- 'REAL'
C
          XCODE(JVALUE,IARG(1)) = REAL ( ICODE(JVALUE,IARG(1)) )
        ICODE(JVTYPE,IARG(1)) = 2
C
C
      GO TO 8000
C
C
5050  CONTINUE
C
C -- 'INTEGER'
C
          ICODE(JVALUE,IARG(1)) = INT ( XCODE(JVALUE,IARG(1)) )
        ICODE(JVTYPE,IARG(1)) = 1
C
      GO TO 8000
C
C
5060  CONTINUE
C
C -- '.VALUE.'
C
      ISTAT = KSCSDC ( ICODE(JVALUE,IARG(1)) , CWORK1 , LEN1 )
      ISTAT = KSCIDN ( 2, 3, CWORK1(1:LEN1), 1, IVTYPE, IID, IVAL, 1 )
      IF ( ISTAT .LE. 0 ) GO TO 9900
C
      IF ( IVTYPE .EQ. 4 ) THEN
        IVARVL = IVAL
        ISTAT = KSCSDD ( 1 , IVARVL , IVAL )
      ENDIF
C
      ICODE(JVALUE,IARG(1)) = IVAL
      ICODE(JVTYPE,IARG(1)) = IVTYPE
C
      GO TO 8000
C
C
5070  CONTINUE
C
C -- 'CHARACTER'
C
      IDTYPE = ICODE(JVTYPE,IARG(1))
      IF ( IDTYPE .EQ. 4 ) THEN
      ELSE
        IF ( IDTYPE .EQ. 1 ) THEN
          WRITE ( CWORK1 , '(I12)' ) ICODE(JVALUE,IARG(1))
        ELSE IF ( IDTYPE .EQ. 2 ) THEN
          WRITE ( CWORK1 , '(F12.5)' ) XCODE(JVALUE,IARG(1))
        ELSE IF ( IDTYPE .EQ. 3 ) THEN
          CWORK1 = CLOGIC(ICODE(JVALUE,IARG(1)))
        ENDIF
        ISTAT = KCCTRM ( 1 , CWORK1 , ISTART , IEND )
        ISTAT = KSCSCD ( CWORK1(ISTART:IEND) , ICODE(JVALUE,IARG(1)) )
        ICODE(JVTYPE,IARG(1)) = 4
      ENDIF
C
      GO TO 8000
C
C
5080  CONTINUE
C
C -- 'KEYWORD'
C
      ICURR = ICODE(JVALUE,IARG(1))
      IF ( ICURR .LE. 0 ) GO TO 9930
      IF ( ICURR .GT. NCHKUS ) GO TO 9930
      ISTAT = KSCSCD ( CCHECK(ICURR) , ICODE(JVALUE,IARG(1)) )
      ICODE(JVTYPE,IARG(1)) = 4
C
      GO TO 8000
C
C
5090  CONTINUE
C
C -- 'UPPERCASE'
C
      ISTAT = KSCSDC ( ICODE(JVALUE,IARG(1)) , CWORK1 , LEN1 )
      CALL XCCUPC ( CWORK1(1:LEN1) , CWORK2(1:LEN1) )
C
      ISTAT = KSCSCD ( CWORK2(1:LEN1) , ICODE(JVALUE,IARG(1)) )
      ICODE(JVTYPE,IARG(1)) = 4
      GO TO 8000
C
C
C
C
C
8000  CONTINUE
C
C
C
C
2000  CONTINUE
C
      KSCEXE = 1
      RETURN
C
C
9900  CONTINUE
C
      KSCEXE = -1
      RETURN
C
9910  CONTINUE
C -- NOT ENOUGH DATA FOR THIS OPERATOR
      CALL XSCMSG ( MINSUF, MOPERA, '* This is a programming error', 0 )
      GO TO 9900
9920  CONTINUE
C -- MIXED OR INAPPROPRIATE ARGUMENT TYPES
      CALL XSCMSG ( MMIXED , MARGTP , ' ' , 0 )
      GO TO 9990
9930  CONTINUE
C -- VALUE OUT OF RANGE
      CALL XSCMSG ( MOUTRG , MARGUM , ' ' , 0 )
      GO TO 9990
9940  CONTINUE
      CALL XSCMSG ( MINTRN , MEXPRE , 'Internal error in KSCEXE' , 0 )
      GO TO 9900
9990  CONTINUE
C
C -- DESCRIBE FAILING OPERATION
C
      WRITE ( NCAWU , 9991 )
9991  FORMAT ( / , 1X, 'Failing components of input string are :' , // ,
     2 1X , 'Component' , 5X , 'Location >>' , 15X , 'Reqd. type' ,
     3  10X , 'Actual type'  , / )
      DO 9998 I = 1 , NARGUM
        IF ( I .EQ. NARGUM ) THEN
          WRITE ( NCAWU , 9992 ) CTEXT(IOPPOS-6:IOPPOS-1) ,
     2 CTEXT(IOPPOS:IOPPOS+6)
9992      FORMAT ( 1X , 'Operator' , 8X , A , ' >>' , A )
        ENDIF
C
        WRITE ( NCAWU , 9995 ) I , CTEXT(IPOSIT(I)-6:IPOSIT(I)-1) ,
     2 CTEXT(IPOSIT(I):IPOSIT(I)+6) , CDATAT(ITYPES(I,IDEFIN)) ,
     3 CDATAT(ITYPE(I))
9995    FORMAT ( 1X, 'Operand', I3, 6X, A, ' >>', A, 8X, A, 8X, A )
C
9998  CONTINUE
      WRITE ( NCAWU , 9999 )
9999  FORMAT ( 1X )
C
      GO TO 9900
      END
CODE FOR KSCEXP
      FUNCTION KSCEXP ( IRESLT, ITYPE, CTEXT, CLTEXT, ISTART, IEVAL )
C
C -- EVALUATE EXPRESSION
C
C -- THIS ROUTINE PERFORMS THE FIRST PART OF EXPRESSION EVALUATION.
C    THIS CONSISTS OF SYNTAX CHECKING AND CONVERTING THE EXPRESSION INTO
C    A 'REVERSE POLISH' FORM WHICH IS ACTUALLY EVALUATED BY 'KSCEXE'
C
C      INPUT PARAMETERS :-
C            <NONE>
C
C      OUTPUT PARAMETERS :-
C
C      IRESLT      VALUE OF EXPRESSION
C      ITYPE       TYPE OF EXPRESSION
C                    1      INTEGER EXPRESSION
C                    2      REAL EXPRESSION
C                    3      LOGICAL EXPRESSION
C      CTEXT       TEXT FROM WHICH EXPRESSION IS TO BE EXTRACTED
C      CLTEXT      LOWERCASE COPY OF TEXT. USED AS SOURCE OF CHARACTER
C                  CONSTANTS
C      ISTART      STARTING POSITION OF EXPRESSION IN 'CTEXT'.
C                  ( UPDATED BY THIS ROUTINE )
C      IEVAL       EVALUATION FLAG
C                    0,-VE  DO NOT EVALUATE EXPRESSION
C                    1      EVALUATE EXPRESSION
C
C -- RETURN VALUES OF 'KSCEXP' :-
C      -1      ERROR IN EXPRESSION
C       0      NO EXPRESSION FOUND
C      +1      SUCCESS
C
C
C -- THE EXPRESSION IS ANALYSED IN TERMS OF THE FOLLOWING GENERAL SCHEME
C
C     <EXPRESSION> =     '(' <EXPRESSION> ')'                        OR
C                        <UNARY OPERATOR> <EXPRESSION>               OR
C                        <EXPRESSION> <BINARY OPERATOR> <EXPRESSION> OR
C                        <NUMERIC CONSTANT>                          OR
C                        <LOCAL VARIABLE>                            OR
C                        <GLOBAL VARIABLE>                           OR
C                        <STANDARD VALUE>
C
C      <UNARY OPERATOR> IS ONE OF :-
C            .NOT.       LOGICAL COMPLEMENT
C            +           UNARY PLUS
C            -           UNARY MINUS
C            EXISTS      ( CRYSTALS LIST EXISTENCE CHECK )
C            .IF.        INTRODUCES CONDITIONAL
C            REAL        INTEGER TO REAL CONVERSION
C            INTEGER     REAL TO INTEGER CONVERSION
C
C      <BINARY OPERATOR> IS ONE OF :-
C            +           ADDITION
C            -           SUBTRACTION
C            *           MULTIPLICATION
C            /           DIVISION
C            .EQ. , =    EQUALITY
C            .NE. , <>   INEQUALITY
C            .LE. , =<   LESS THAN OR EQUAL
C            .GE. , >=   GREATER THAN OR EQUAL
C            .LT. , <    LESS THAN
C            .GT. , >    GREATER THAN
C            .OR.        LOGICAL OR
C            .AND.       LOGICAL AND
C            .THEN.      COMPONENT OF CONDITIONAL EXPRESSION
C            .ELSE.      COMPONENT OF CONDITIONAL EXPRESSION
C      <NUMERIC CONSTANT> IS
C            AN INTEGER OR REAL NUMBER THAT CAN BE IDENTIFIED BY
C            'KCCNUM'
C      <LOCAL VARIABLE> IS
C            THE NAME OF A VARIABLE DEFINED IN THE CURRENT BLOCK
C      <GLOBAL VARIABLE> IS
C            THE NAME OF A VARIABLE DEFINED IN ANY BLOCK. NOTE THAT THE
C            FIRST VARIABLE OF THIS NAME TO BE DEFINED, IF THERE IS MORE
C            THAN ONE, WILL BE THE ONE USED.
C      <STANDARD VALUE> IS
C            ANY VALUE THAT CAN BE IDENTIFIED BY 'KSCEST'
C
C
C      LOCAL VARIABLES :-
C            DUMPCD      LOGICAL VARIABLE SET TRUE IF 'ISCEVE' IS SET.
C            ENDEXP      LOGICAL VARIABLE INDICATING THE END OF THE
C                        EXPRESSION HAS BEEN FOUND
C            RGTPAR      LOGICAL VARIABLE INDICATING THAT A RIGHT
C                        PARENTHESIS HAS BEEN FOUND.
C
C            JVALUE      DEFINES POSITION IN EACH OUTPUT ITEM OF DATA
C                        VALUE
C            JVTYPE      DEFINES POSITION IN EACH OUTPUT ITEM OF DATA
C                        TYPE ( INTEGER/REAL ETC. )
C            JCTYPE      DEFINES POSITION IN EACH OUTPUT ITEM OF ITEM
C                        TYPE ( DATA OR OPERATOR )
C            JPOSTK      DEFINES POSITION IN EACH OUTPUT ITEM OF
C                        POSITION OF THIS ITEM IN THE INPUT STRING
C
C            JOUTLN      DEFINES LENGTH OF AN OUTPUT ITEM
C            NOUTVL      DEFINES MAXIMUM NUMBER OF OUTPUT ITEMS
C            NOPERS      DEFINES SIZE OF 'PENDING OPERATOR STACK'
C
C            COPER       CHARACTER ARRAY CONTAINING OPERATORS
C            NOPER       NUMBER OF OPERATORS
C            LOPER       SIZE OF EACH ENTRY IN COPER
C            NBROPR      NUMBER OF BRACKET TYPE OPERATORS ( I.E. '('
C                        AND ')' )
C            IBASBR      BASE ADDRESS IN 'COPER' OF BRACKET TYPE
C            NBOPER      NUMBER OF BINARY OPERATORS
C            IBASBI      BASE ADDRESS IN 'COPER' OF BINARY OPERATORS
C            NUOPER      NUMBER OF UNARY OPERATORS
C            IBASUN      BASE ADDRESS IN 'COPER' OF UNARY OPERATORS
C
C            IPRECD      PRECEDENCE TABLE. ONE ENTRY FOR EACH OPERATOR
C                        PRECEDENCE VALUES RANGE FROM 0 TO 20
C
C            IVARIB      CURRENT DATA VALUE
C            IOUTLS      ARRAY OF OUTPUT ITEMS. THIS ARRAY IS FILLED IS
C                        FILLED BY THIS ROUTINE AND PROCESSED BY
C                        'KSCEXE'
C            XOUTLS      EQUIVALENCED TO 'IOUTLS'. THIS IS USED AS AN
C                        ARGUMENT FOR 'KSCEXE'
C            IOPRST      PENDING OPERATOR STACK. OPERATORS ARE STACKED
C                        HERE UNTIL THEY CAN BE PLACED IN THE OUTPUT
C                        LIST
C
C            NOUTLS      NUMBER OF ITEMS IN OUTPUT LIST ( SO FAR )
C            NOPRST      NUMBER OF ITEMS CURRENTLY ON PENDING OPERATOR
C                        STACK
C            NBRACK      NET NUMBER OF PARENTHESES FOUND ( + 1 FOR EACH
C                        '(', -1 FOR EACH ')'
C
C            CSTRNG      CHARACTER VARIABLE HOLDING LIST OF CHARACTERS
C                        THAT CAN BEGIN CHARACTER CONSTANTS.
C
C            NDATAT      NUMBER OF DATA TYPES RECOGNISED
C            CDATAT      CHARACTER ARRAY HOLDING DATA TYPES, USED IN
C                        VERIFICATION. ELEMENT 0 CORRESPONDS TO THE
C                        INVALID DATA TYPE RETURNED BY 'KSCEST' FOR
C                        'VALUE' AFTER 'GET TEXT' ETC.
C
C
C
C      THE FORM OF THE OUTPUT LIST IS AS FOLLOWS :-
C
C      VALUE       TYPE        COMPONENT TYPE      POSITION
C
C                  INTEGER = 1
C                  REAL = 2
C                  LOGICAL = 3
C
C                              VALUE = 1
C                              OPERATOR = 2
C
C
C -- FOR EXAMPLE, THE EXPRESSION
C
C                        1  +  2
C
C    BECOMES :-
C
C   1 ( ACTUAL VALUE )    1 ( INTEGER )    1 ( VALUE )    1 ( POSITION )
C
C   2 ( ACTUAL VALUE )    1 ( INTEGER )    1 ( VALUE )    5 ( POSITION )
C
C   3 ( '+' )             0 ( NOT USED )   2 ( OPERATOR ) 3 ( POSITION )
C
C
C
      CHARACTER*(*) CTEXT , CLTEXT
C
      LOGICAL DUMPCD
C
C
      PARAMETER ( JVALUE = 1 , JVTYPE = 2 , JCTYPE = 3 )
      PARAMETER ( JPOSTK = 4 , JOUTLN = 4 )
      PARAMETER ( NOUTVL = 100 , NOPERS = 10 )
C
      PARAMETER ( IBASBR = 1               , NBROPR =  2 )
      PARAMETER ( IBASBI = IBASBR + NBROPR , NBOPER = 22 )
      PARAMETER ( IBASUN = IBASBI + NBOPER , NUOPER = 11 )
      PARAMETER ( NOPER = IBASUN + NUOPER - 1 )
      PARAMETER ( LOPER = 10 )
C
      DIMENSION IVARIB(JOUTLN)
      DIMENSION IOUTLS(JOUTLN,NOUTVL) , XOUTLS(JOUTLN,NOUTVL)
      DIMENSION IOPRST(2,0:NOPERS)
C
      LOGICAL ENDEXP , RGTPAR
C
      CHARACTER*(LOPER) COPER(NOPER)
      DIMENSION IPRECD(0:NOPER)
C
      PARAMETER ( LDATAT = 10 , NDATAT = 4 )
      CHARACTER*(LDATAT) CDATAT(0:NDATAT)
C
      CHARACTER*2 CSTRNG
C
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      EQUIVALENCE ( IOUTLS(1,1) , XOUTLS(1,1) )
C
      DATA IVARIB(JCTYPE) / 1 /
C
      DATA COPER /                '('   ,   ')'   ,
     2                  '+'   ,   '-'   ,   '*'   ,   '/'   ,
     3                '.EQ.'  ,   '='   ,  '.NE.' ,  '<>'   ,
     4                '.LE.'  ,  '=<'   ,  '.GE.' ,  '>='   ,
     5                '.LT.'  ,   '<'   ,  '.GT.' ,   '>'   ,
     6                '.OR.'  , '.AND.' , '.THEN.' , '.ELSE.' ,
     7                '//'    , 'STARTSWITH' ,
     8                '.NOT.' ,   '+'   ,   '-'   , 'EXISTS' ,
     9                '.IF.'  , 'REAL'  ,'INTEGER', '.VALUE.',
     *                'CHARACTER','KEYWORD','UPPERCASE' /
C
      DATA IPRECD /      0    ,   200   ,    0    ,
     2                  100   ,   100   ,   120   ,   120   ,
     4                   80   ,    80   ,    80   ,    80   ,
     4                   80   ,    80   ,    80   ,    80   ,
     5                   80   ,    80   ,    80   ,    80   ,
     6                   50   ,    60   ,    30   ,    20   ,
     7                  100   ,    80   ,
     8                   90   ,   180   ,   180   ,   180   ,
     9                   40   ,   180   ,   180   ,   180   ,
     *                  180   ,   180   ,   180   /
C
      DATA CDATAT / '<invalid>', 'integer', 'real', 'logical',
     2             'character' /
C
      DATA CSTRNG / '''"' /
C
C
C -- INITIALISE PROCESSING
C
      NOUTLS = 0
      NOPRST = 0
      IOPRST(1,0) = 0
      IOPRST(2,0) = 0
      NBRACK = 0
      DUMPCD = ( ISCEVE .GT. 0 )
C
C -- CHECK FOR CASE OF NO EXPRESSION
      ISTAT = KCCNEQ ( CTEXT , ISTART , ' ' )
      IF ( ISTAT .LE. 0 ) THEN
        KSCEXP = 0
        RETURN
      ENDIF
C
C -- CREATE A NEW FRAME FOR EXPRESSION PROCESSING
C
      CALL XSCFRM ( 100 )
C
C
1000  CONTINUE
C
C -- WE EXPECT THE NEXT ITEM TO BE '(' , NUMBER , VARIABLE , STRING ETC.
C
C -- CHECK FOR STRINGS FIRST. ( USE LOWERCASE COPY FOR ACTUAL DATA )
C
      IF ( INDEX ( CSTRNG , CTEXT(ISTART:ISTART)  ) .GT. 0 ) THEN
        LENARG = KCCARG ( CTEXT , ISTART , 2 , NARG , NEND )
        IF ( LENARG .LE. 0 ) GO TO 9910
        ISTAT = KSCSCD ( CLTEXT(NARG:NEND) , IVALUE )
        IF ( ISTAT .LE. 0 ) GO TO 9900
C
        ITYPE = 4
        GO TO 1040
      ENDIF
C
C -- NOW DEAL WITH THE ORDINARY TYPES OF DATA
C
      LENARG = KCCARG ( CTEXT , ISTART , 1 , NARG , NEND )
      IF ( LENARG .LE. 0 ) GO TO 9910
C
C
C -- IF '(' IS FOUND :-
C      1)  PUSH '(' ONTO OPERATOR STACK
C      2)  LOOK FOR THE BEGINNING OF AN EXPRESSION (I.E. BACK TO START)
C
      IF ( CTEXT(NARG:NEND) .EQ. '(' ) THEN
        NBRACK = NBRACK + 1
        NOPRST = NOPRST + 1
        IF ( NOPRST .GT. NOPERS ) GO TO 9930
        IOPRST(1,NOPRST) = 1
        IOPRST(2,NOPRST) = NARG
        GO TO 1000
      ENDIF
C
C -- CHECK FOR UNARY OPERATOR/NUMBER/VARIABLE NAME/STANDARD DATA NAME
C
      IUOPER = KCCOMP ( CTEXT(NARG:NEND) , COPER(IBASUN) , NUOPER , 1)
      IF ( IUOPER .GT. 0 ) THEN
        IUOPER = IUOPER + IBASUN - 1
C
C -- IF UNARY OPERATOR FOUND :-
C      1)  REMOVE OPERATORS WITH HIGHER PRECEDENCE FROM STACK
C      2)  PUSH NEW OPERATOR ONTO STACK
C      3)  LOOK FOR THE BEGINNING OF AN EXPRESSION
C
C -- COMPARE OPERATOR FOUND WITH THOSE ON STACK. MOVE ANY WITH HIGHER
C    PRECEDENCE TO OUTPUT, THEN PUSH CURRENT OPERATOR TO STACK
C
          IPLACE = NOPRST + 1
          IF ( IPLACE .GT. NOPERS ) GO TO 9930
          DO 1020 I = NOPRST , 1 , -1
            IF ( ( IPRECD(IOPRST(1,I)) .GT. IPRECD(IUOPER) ) .AND.
     2         ( IOPRST(1,I) .NE. 1 ) ) THEN
            IOPRST(1,I+1) = IOPRST(1,I)
            IOPRST(2,I+1) = IOPRST(2,I)
          ELSE
            IPLACE = I + 1
            GO TO 1030
          ENDIF
1020    CONTINUE
1030    CONTINUE
        IOPRST(1,IPLACE) = IUOPER
        IOPRST(2,IPLACE) = NARG
        NOPRST = IPLACE
        GO TO 1000
      ELSE
C -- TRY TO IDENTIFY VALUE, AS NUMBER, LOCAL VARIABLE, GLOBAL VARIABLE
C    OR STANDARD VALUE
C
        ISTAT = KCCNUM ( CTEXT(NARG:NEND) , IVALUE , ITYPE )
        IF ( ISTAT .LE. 0 ) THEN
          ISTAT = KSCIDN ( 2 , 3 , CTEXT(NARG:NEND) , 1 ,
     2                     ITYPE , IID , IVALUE , -1 )
          IF ( ISTAT .GT. 0 ) THEN
C -- MAKE LOCAL COPY OF VALUE OF VARIABLE
            IF ( ITYPE .EQ. 4 ) THEN
              IVARVL = IVALUE
              ISTAT = KSCSDD ( 1 , IVARVL , IVALUE )
            ENDIF
          ELSE
              ISTAT = KSCEST ( CTEXT(NARG:NEND) , ITYPE , IVALUE )
              IF ( ISTAT .LE. 0 ) GO TO 9950
            ENDIF
        ENDIF
      ENDIF
C
C
1040  CONTINUE
C
C -- MOVE VALUE FOUND TO OUTPUT
C
      CALL XMOVE ( IVALUE , IVARIB(JVALUE) , 1 )
      IVARIB(JVTYPE) = ITYPE
      IVARIB(JPOSTK) = NARG
C
      NOUTLS = NOUTLS + 1
      IF ( NOUTLS .GT. NOUTVL ) GO TO 9920
      CALL XMOVE ( IVARIB , IOUTLS(JVALUE,NOUTLS) , JOUTLN )
C
1050  CONTINUE
C
C
C -- THE VALUE CAN BE FOLLOWED BY ')' OR A BINARY OPERATOR OR
C    THE END OF THE EXPRESSION.
C
      ISAVEP = ISTART
      LENOPR = KCCARG ( CTEXT , ISTART , 1 , NARG , NEND )
      ENDEXP = ( LENOPR .LE. 0 )
C
      IF ( .NOT. ENDEXP ) THEN
        RGTPAR = ( CTEXT(NARG:NEND) .EQ. ')' )
      ELSE
        RGTPAR = .FALSE.
      ENDIF
C
      IF ( RGTPAR ) THEN
        NBRACK = NBRACK - 1
        IF ( NBRACK .LT. 0 ) GO TO 9940
      ENDIF
C
C
C -- PROCESS OPERATOR FOUND
C
      IF ( .NOT. ( ENDEXP .OR. RGTPAR ) ) THEN
        IBOPER = KCCOMP ( CTEXT(NARG:NEND), COPER(IBASBI) , NBOPER , 1 )
        ENDEXP = ( IBOPER .LE. 0 )
C -- RESTORE 'IBOPER' TO SCALE 1 - N
        IBOPER = IBOPER + 2
C -- RESTORE POINTER
        IF ( ENDEXP ) ISTART = ISAVEP
      ENDIF
C
C -- IF END OF EXPRESSION, OR ')' :-
C      1)  REMOVE ALL OPERATORS BACK TO '(' OR BEGINNING OF EXPRESSION
C      2)  FOR 'END' THEN INTERPRETATION  IS FINISHED
C          FOR ')' LOOK FOR ANOTHER ')', BINARY OPERATOR OR END OF EXPR.
C
      IF ( ENDEXP .OR. RGTPAR ) THEN
        INEXT = 0
        DO 1060 I = NOPRST , 1 , -1
          IF ( RGTPAR .AND. ( IOPRST(1,I) .EQ. 1 ) ) THEN
            INEXT = I - 1
            GO TO 1070
          ENDIF
C
          NOUTLS = NOUTLS + 1
          IF ( NOUTLS .GT. NOUTVL ) GO TO 9920
          IOUTLS(JVALUE,NOUTLS) = IOPRST(1,I)
          IOUTLS(JVTYPE,NOUTLS) = 0
          IOUTLS(JCTYPE,NOUTLS) = 2
          IOUTLS(JPOSTK,NOUTLS) = IOPRST(2,I)
1060    CONTINUE
1070    CONTINUE
        NOPRST = INEXT
C
        IF ( ENDEXP ) GO TO 6000
        IF ( RGTPAR ) GO TO 1050
      ENDIF
C
C -- COMPARE OPERATOR FOUND WITH EACH ON STACK AND PUSH ONTO STACK
C    OR MOVE TO OUTPUT
C
C -- IF BINARY OPERATOR :-
C      1)  REMOVE OPERATORS WITH HIGHER PRECEDENCE FROM STACK
C      2)  PUSH NEW OPERATOR ONTO STACK
C      3)  LOOK FOR THE BEGINNING OF AN EXPRESSION
C
      DO 1200 I = NOPRST , 1 , -1
        IF ( ( IPRECD(IOPRST(1,I)) .GT. IPRECD(IBOPER) ) .AND.
     2      ( IOPRST(1,I) .NE. 1 ) ) THEN
          NOUTLS = NOUTLS + 1
          IF ( NOUTLS .GT. NOUTVL ) GO TO 9920
          IOUTLS(JVALUE,NOUTLS) = IOPRST(1,I)
          IOUTLS(JVTYPE,NOUTLS) = 0
          IOUTLS(JCTYPE,NOUTLS) = 2
          IOUTLS(JPOSTK,NOUTLS) = IOPRST(2,I)
        ELSE
          INEXT = I + 1
          GO TO 1300
        ENDIF
1200  CONTINUE
C
      INEXT = 1
C
1300  CONTINUE
C
C -- PUSH CURRENT OPERATOR
C
      IF ( INEXT .GT. NOPERS ) GO TO 9930
      IOPRST(1,INEXT) = IBOPER
      IOPRST(2,INEXT) = NARG
      NOPRST = INEXT
C
      IF ( IBOPER .EQ. 2 ) GO TO 1050
      GO TO 1000
C
C
C
6000  CONTINUE
C
C -- END OF EXPRESSION. CHECK NUMBER OF PARENTHESES
C
      IF ( NBRACK .NE. 0 ) GO TO 9940
C
C
C -- DISPLAY CODE IF VERIFY ENABLED
C
      IF ( DUMPCD ) THEN
C
        WRITE ( NCAWU , 7005 ) NOUTLS
7005    FORMAT ( 1X, 'Display of generated code - ' ,  I3 , ' item(s)' )
C
        DO 7100 I = 1 , NOUTLS
          IF ( IOUTLS(JCTYPE,I) .EQ. 1 ) THEN
            IDATAT = IOUTLS(JVTYPE,I)
            IF ( IDATAT .EQ. 2 ) THEN
              WRITE ( NCAWU , 7012 ) I, CDATAT(IDATAT), XOUTLS(JVALUE,I)
7012          FORMAT ( 1X , 4X , I4 , ' : ' , 10X , A12 , 10X , F16.5 )
            ELSE
              WRITE ( NCAWU , 7015 ) I, CDATAT(IDATAT), IOUTLS(JVALUE,I)
7015          FORMAT ( 1X , 4X , I4 , ' : ' , 10X , A12 , 10X , I16 )
            ENDIF
          ELSE IF ( IOUTLS(JCTYPE,I) .EQ. 2 ) THEN
            WRITE ( NCAWU , 7025 ) I , COPER(IOUTLS(JVALUE,I))
7025        FORMAT ( 1X , 4X , I4 , ' : ' , 32X , A16 )
          ENDIF
7100    CONTINUE
      ENDIF
C
C
C -- PROCESS OUTPUT LIST TO FORM VALUE, AND STORE CALCULATED VALUE.
C    IF AN ERROR OCCURS DURING EVALUATION, STORE A DUMMY VALUE
C
      IF ( IEVAL .GT. 0 ) THEN
        ISTAT = KSCEXE ( IOUTLS , XOUTLS , JOUTLN , NOUTLS , CTEXT )
        IF ( ISTAT .LE. 0 ) GO TO 9900
        ITYPE = IOUTLS(JVTYPE,1)
        CALL XMOVE ( IOUTLS(JVALUE,1) , IRESLT , 1 )
      ELSE
        ITYPE = 0
        IRESLT = 0
      ENDIF
C
C -- DELETE TEMPORARY STACK FRAME
C
      CALL XSCRST
C
C
      KSCEXP = 1
      RETURN
C
C
9900  CONTINUE
      ITYPE = 0
      IRESLT = 0
C
C -- DELETE TEMPORARY STACK FRAME
C
      CALL XSCRST
C
      KSCEXP = -1
      RETURN
C
9910  CONTINUE
C -- MISSING ARGUMENT
      CALL XSCMSG ( MMISSG , MARGUM , ' ' , 0 )
      GO TO 9900
9920  CONTINUE
C -- OUTPUT LIST OVERFLOW
      CALL XSCMSG ( MOVERF , MOUTLS , ' ' , 0 )
      GO TO 9900
9930  CONTINUE
C -- OPERATOR STACK OVERFLOW
      CALL XSCMSG ( MOVERF , MOPRST , ' '  , 0 )
      GO TO 9900
9940  CONTINUE
C -- ILLEGAL NUMBER OF BRACKETS
      CALL XSCMSG ( MILLEG , MBRACK , ' ' , 0 )
      GO TO 9900
9950  CONTINUE
C -- ILLEGAL TOKEN IN EXPRESSION
      CALL XSCMSG ( MILLEG , MTOKEN , CTEXT(NARG:NEND) , 0 )
      GO TO 9900
C
C
      END
CODE FOR KSCEXT
      FUNCTION KSCEXT ( IN )
C
C -- THIS ROUTINE IMPLEMENTS THE SCRIPT 'EXTERNAL' INSTRUCTION
C
C -- THIS ROUTINE CAN, IF A SUITABLE LINKING ROUTINE IS AVAILABLE,
C    CAUSE EXTERNAL COMMANDS TO BE EXECUTED. THIS REQUIRES THAT THE
C    ROUTINE 'XDETCH' HAS BEEN IMPLEMENTED.
C
C      INPUT PARAMETER :-
C            IN          DUMMY
C
C      RETURN VALUE :-
C            <ANY>       VALUE TO BE ASSIGNED TO 'KSCPRC'
C
C      LOCAL VARIABLES :-
C
C            COMMND      CHARACTER ARRAY CONTAINING NAMES OF SUBCOMMANDS
C
C
      PARAMETER ( LCOM = 4 , NCOM = 2 )
      CHARACTER*(LCOM) COMMND(NCOM)
C
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
      DATA COMMND / 'COPY' , 'SEND' /
C
C
C -- READ INSTRUCTION KEYWORD
C
      LENCOM = KCCARG ( CUPPER , IDIRPS , 1 , NTYPE , NEND )
      IF ( LENCOM .LE. 0 ) GO TO 9910
C
      ICOM = KCCOMP ( CUPPER(NTYPE:NEND) , COMMND , NCOM , 2 )
      IF ( ICOM .LE. 0 ) GO TO 9910
C
C -- FOR 'COPY' READ REST OF INPUT LINE. FOR 'SEND' USE COMMAND BUFFER
C
      IF ( ICOM .EQ. 1 ) THEN
        CALL XDETCH ( CLOWER(IDIRPS:IDIRLN) )
      ELSE IF ( ICOM .EQ. 2  ) THEN
        CALL XDETCH ( CCOMBF(1:ICOMLN) )
      ENDIF
C
      KSCEXT = 0
      RETURN
C
C
9900  CONTINUE
      KSCEXT = 0
      RETURN
C
9910  CONTINUE
      CALL XSCMSG ( MILLMS , MKEYWD , ' ' , 0 )
      GO TO 9900
      END
CODE FOR KSCIDN
      FUNCTION KSCIDN ( IFUNC , ISCOPE , CNAME , ITYPE , ISUBTP ,
     2 IIDENT , IVALUE , NOTFND )
C
C -- IDENTIFIER HANDLING
C -- THIS ROUTINE CONTROLS THE IDENTIFIER LIST. INFORMATION CAN ONLY
C    BE PUT INTO THIS LIST, AND RECOVERED FROM IT, USING THIS ROUTINE.
C
C      PARAMETERS :-
C            ( IFUNC, ISCOPE, ITYPE, AND NOTFND ARE ALWAYS INPUT
C            PARAMETERS. CNAME, ISUBTP, AND IVALUE ARE INPUT
C            PARAMETERS FOR 'STORE' OPERATIONS. CNAME IS AN INPUT
C            FOR 'FIND BY NAME', IIDENT AN INPUT FOR 'FIND BY NUMBER' )
C
C
C      IFUNC       FUNCTION REQUIRED
C                        1      STORE IDENTIFIER
C                        2      FIND IDENTIFIER BY NAME
C                        3      FIND IDENTIFIER BY NUMBER
C
C      ISCOPE      SCOPE OF SEARCH FOR IDENTIFIER
C                        1      SEARCH CURRENT LEVEL ONLY FOR NAME
C                        2      SEARCH ALL LEVELS FOR NAME
C                        3     SEARCH ALL LEVELS FOR NAME, STARTING
C                              WITH THE CURRENT LEVEL AND WORKING
C                              TOWARDS THE OUTERMOST LEVEL
C      CNAME       IDENTIFIER
C      ITYPE       IDENTIFIER TYPE
C                        1      VARIABLE
C                        2      LABEL
C                        3      ERROR IDENTIFIER
C                        4      CONTINGENCY
C      ISUBTP      SUBTYPE ( NOT USED BY THIS ROUTINE. MAY TAKE ANY
C                  INTEGER VALUE )
C      IIDENT      IDENTIFIER NUMBER
C      IVALUE      IDENTIFIER VALUE
C      NOTFND      MESSAGE FLAG IF IDENTIFIER NOT FOUND
C                    -1      MESSAGE
C                    +1      NO MESSAGE
C
C      RETURN VALUES :-
C            -1          FAILURE. IDENTIFIER NOT KNOWN
C            +VE         SUCCESS. RETURN VALUE IS THE INDEX OF THE
C                        IDENTIFIER ( A COPY OF IIDENT )
C
C      LOCAL VARIABLES :-
C
C            CHARACTER REPRESENTATIONS OF INPUT ARGUMENTS USED DURING
C            VERIFICATION
C                  CSCOPE      USED TO CONVERT 'ISCOPE'
C                  CTYPE       USED TO CONVERT 'ITYPE'
C                  COPER       USED TO CONVERT 'IFUNC'
C
C            VARIABLES FORMING THE MAIN 'DATABASE' FOR IDENTIFIERS
C                  MAXIDN      PARAMETER DEFINING MAXIMUM NUMBER OF
C                              IDENTIFIERS THAT CAN BE KNOWN.
C                  CIDENT      CHARACTER ARRAY HOLDING IDENTIFIER NAMES
C                  ITYPEI      ARRAY HOLDING TYPES OF IDENTIFIERS
C                  ISBTPI      ARRAY HOLDING SUBTYPES OF IDENTIFIERS
C                  IVALUI      ARRAY HOLDING VALUES OF IDENTIFIERS
C
C            VARIABLES CONTROLLING SEARCH
C                  LMULTI      LOGICAL VARIABLE, DISTINGUISHING BETWEEN
C                              SINGLE STRUCTURE SEARCHES ( 'LOCAL' AND
C                              'GLOBAL' ), AND MULTI-STRUCTURE SEARCHES
C                              SUCH AS 'OUTWARD'
C                  LVERIF      LOGICAL VARIABLE CONTROLLING VERIFICATION
C
C
C -- THE 'SCOPE' OF A SEARCH FOR AN IDENTIFIER CAN BE EITHER 'LOCAL'
C    OR 'GLOBAL'. 'LOCAL' MEANS THAT ONLY THOSE IDENTIFIERS DEFINED IN
C    THE CURRENT BLOCK ARE CONSIDERED. 'GLOBAL' MEANS THAT ALL
C    IDENTIFIERS THAT HAVE BEEN DEFINED, AND ARE STILL DEFINED, ARE
C    CONSIDERED, IN THE ORDER THAT THEY WERE DEFINED.
C
C
C
      CHARACTER*(*) CNAME
C
      PARAMETER ( LSCP = 8 , NSCP = 3 )
      PARAMETER ( LTYP = 14 , NTYP = 5 )
      PARAMETER ( LOPR = 14 , NOPR = 3 )
      CHARACTER*(LSCP) CSCOPE(NSCP)
      CHARACTER*(LTYP) CTYPE(NTYP)
      CHARACTER*(LOPR) COPER(NOPR)
C
      LOGICAL LMULTI
      LOGICAL LVERIF
C
C
      PARAMETER ( MAXLAB = 12 )
      PARAMETER ( JVARIB =  1 , JNVARI =  2 , JNFDAT =  3 )
      PARAMETER ( JNFCHR =  4 , JEXECU =  5 , JBTYPE =  6 )
      PARAMETER ( JBSTRT =  7 , JBLEND =  8 , JNSTAT =  9 )
      PARAMETER ( JREQST = 10 , JWASEX = 11 , JSTLVL = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      PARAMETER ( MAXIDN = 100 )
C
      CHARACTER*(MAXLAB) CIDENT(MAXIDN)
      DIMENSION ITYPEI(MAXIDN) , IVALUI(MAXIDN) , ISBTPI(MAXIDN)
C
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      SAVE CIDENT , ITYPEI , IVALUI , ISBTPI
C
      DATA CSCOPE / 'local   ' , 'global  ' , 'outward ' /
      DATA CTYPE / 'variable' , 'label' , 'error label' ,
     2             'contingency' , 'structure end' /
      DATA COPER / 'store by name ' , 'find by name  ' ,
     2 '  find by id  ' /
C
C
C
      LMULTI = ( ISCOPE .EQ. 3 )
      LVERIF = ( ISCIVE .GT. 0 )
C
C
C -- DEFINE NUMBER OF STRUCTURES TO BE SEARCHED OVER. THIS IS 1 FOR MOST
C    TYPES OF SEARCH. FOR THE MULTI-LEVEL SEARCH, IT IS EQUAL TO THE
C    NUMBER OF LEVELS.
C
      IF ( LMULTI ) THEN
        NLEVEL = KSCSTK ( JSTLVL , 0 )
      ELSE
        NLEVEL = 1
      ENDIF
C
C -- SET OUTER LIMITS ON VARIABLE NAME/TYPE LIST PRODUCED DURING ERRORS
C
      IF ( LVERIF ) THEN
        ILSBEG = MAXIDN
        ILSEND = 1
      ENDIF
C
C -- CLEAR IDENTIFIER NUMER FOR 'STORE/FIND BY NAM'
C
      IF ( ( IFUNC .EQ. 1 ) .OR. ( IFUNC .EQ. 2 ) ) THEN
        IIDENT = 0
      ENDIF
C
C -- SEARCH OVER ALL STRUCTURES. NOTE THAT A STRUCTURE IN THIS SENSE
C    MAY BE MORE THAN ONE STACK FRAME.
C
      DO 2000 ILEVEL = 0 , NLEVEL - 1
C
C -- SET PARAMETERS DEFINING SEARCH FOR THIS STRUCTURE
C
        IVARIB = KSCSTK ( JVARIB , ILEVEL )
C
        IF ( ISCOPE .EQ. 2 ) THEN
          NIDENT = IVARIB
        ELSE
          NIDENT = KSCSTK ( JNVARI , ILEVEL )
        ENDIF
C
        IF ( NIDENT .LE. 0 ) GO TO 2000
C
        IDNEND = IVARIB
        IDNBEG = IDNEND - NIDENT + 1
C
        IF ( LVERIF ) THEN
          ILSEND = MAX0 ( ILSEND , IDNEND )
          ILSBEG = MIN0 ( ILSBEG , IDNBEG )
        ENDIF
C
C -- BEGIN SEARCH
C
C -- FOR 'FIND BY NAME', LOOP OVER ALL NAMES
C
        IF ( ( IFUNC .EQ. 1 ) .OR. ( IFUNC .EQ. 2 ) ) THEN
          IF ( NIDENT .GT. 0 ) THEN
            DO 1100 I = IDNBEG , IDNEND
              IF ( ( CNAME .EQ. CIDENT(I) ) .AND.
     2             ( ITYPE .EQ. ITYPEI(I) ) ) THEN
                IIDENT = I
                GO TO 2100
              ENDIF
1100        CONTINUE
          ENDIF
C
C -- FOR 'FIND BY NUMBER' CHECK WHETHER NUMBER IS IN CURRENT RANGE
C
        ELSE IF ( IFUNC .EQ. 3 ) THEN
          IF ( ( IIDENT .GE. IDNBEG ) .AND.
     2         ( IIDENT .LE. IDNEND ) ) THEN
            CNAME = CIDENT(IIDENT)
            GO TO 2100
          ENDIF
        ENDIF
C
C
2000  CONTINUE
C
C -- IF A 'SEARCH BY NUMBER' HAS FALLEN OUT OF THE LOOP, IT IS AN ERROR
C
      IF ( IFUNC .EQ. 3 ) GO TO 9940
C
2100  CONTINUE
C
C -- CONTROL CAN BE PASSED TO THIS POINT EITHER BY PASSING THROUGH THE
C    LOOP WITHOUT FINDING A MATCH, OR DIRECTLY AFTER A MATCH.
C
C
C -- PERFORM REQUESTED OPERATION
C
      IF ( IFUNC .EQ. 1 ) THEN
C
C -- 'STORE'
C    IF THE IDENTIFIER IS UNKNOWN, THEN CREATE A NEW IDENTIFIER.
C
        IF ( IIDENT .LE. 0 ) THEN
C
        IVARIB = KSCSTK ( JVARIB , 0 ) + 1
        NVARIB = KSCSTK ( JNVARI , 0 ) + 1
          IF ( IVARIB .GT. MAXIDN ) GO TO 9920
C
          CALL XSCSTU ( JVARIB , IVARIB )
          CALL XSCSTU ( JNVARI , NVARIB )
C
          IIDENT = IVARIB
          ITYPEI(IIDENT) = ITYPE
          ISBTPI(IIDENT) = ISUBTP
          CIDENT(IIDENT) = CNAME
        ENDIF
C
C -- STORE OR UPDATE VALUE
C
        CALL XMOVE ( IVALUE , IVALUI(IIDENT) , 1 )
C
      ELSE IF ( ( IFUNC .EQ. 2 ) .OR. ( IFUNC .EQ. 3 ) ) THEN
C
C -- FIND IDENTIFIER
C    FOR 'FIND' OPERATIONS IT IS AN ERROR IF THE IDENTIFIER IS UNKNOWN
C    THE 'TYPE' MUST BE CHECKED TO COPE WITH 'FIND BY ID' OPERATIONS.
C
        IF ( IIDENT .LE. 0 ) GO TO 9930
C
        IF ( ITYPEI(IIDENT) .NE. ITYPE ) GO TO 9910
C
C -- SET VALUE AND SUBTYPE
C
        CALL XMOVE ( IVALUI(IIDENT) , IVALUE , 1 )
        ISUBTP = ISBTPI(IIDENT)
C
      ENDIF
C
C -- VERIFY OPERATION IF REQUIRED
C
      IF ( LVERIF ) THEN
        WRITE ( NCAWU , 8005 ) CSCOPE(ISCOPE) , COPER(IFUNC) ,
     2 CTYPE(ITYPE) , CNAME , IIDENT
8005    FORMAT ( 1X , A , ' ' , A , ' on ' , A , ' ' , A12 ,
     2 '  ( index: ' , I4 , ' )' )
      ENDIF
C
C
      KSCIDN = IIDENT
C
C
      RETURN
C
C
9900  CONTINUE
      IF ( ( NOTFND .GT. 0 ) .AND.
C -- PRODUCE LIST OF IDENTIFIERS KNOWN WHEN AN ERROR OCCURS
C
     2        ( LVERIF ) .AND.
     3        ( ILSEND .GE. ILSBEG ) ) THEN
        WRITE ( NCAWU , 9905 ) CTYPE(ITYPE) , CSCOPE(ISCOPE)
9905    FORMAT ( 6X , 'The following identifiers of type "' , A ,
     2 '" are known,' , / ,
     3 6X , 'using "' , A , '" search' , // ,
     4 6X , 'Index' , 8X , 'Name' )
C
        DO 9908 J = ILSBEG , ILSEND
          IF ( ITYPEI(J) .EQ. ITYPE ) THEN
            WRITE ( NCAWU , 9907 ) J , CIDENT(J)
9907        FORMAT ( 6X , I5 , 8X , A )
          ENDIF
9908    CONTINUE
C
        WRITE ( NCAWU , 9909 )
9909    FORMAT ( // )
      ENDIF
C
      KSCIDN = -1
      RETURN
C
9910  CONTINUE
      CALL XSCMSG ( MINCON , MIDENT , CNAME , 0 )
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MOVERF , MIDNLS , ' ' , 0 )
      GO TO 9900
9930  CONTINUE
      IF ( NOTFND .LE. 0 ) GO TO 9900
      CALL XSCMSG ( MUNKNW , MIDENT , CNAME , 0 )
      GO TO 9900
9940  CONTINUE
      CALL XSCMSG ( MOUTRG , MIDNNM , ' ' , IIDENT )
      GO TO 9900
      END
CODE FOR KSCINT
      FUNCTION KSCINT ( CTEXT )
C
C -- INTERRUPT PROCESSING FOR SCRIPTS
C
C -- THIS ROUTINE IS CALLED BY 'KSCVAL' EACH TIME THE USER HAS ENTERED
C    TEXT TO CHECK FOR 'INTERRUPTS'. THESE ARE STRINGS, WHICH MUST BE
C    EXTERED EXACTLY, WHICH CAUSE THE NORMAL FLOW OF THE SCRIPT TO BE
C    CHANGED.
C
C      INPUT PARAMETER :-
C
C            CTEXT       TEXT TO BE CHECKED
C
C      RETURN VALUES :-
C            -1          TEXT DOES NOT REPRESENT AN INTERRUPT
C            0           TEXT REPRESENTS AN INTERRUPT
C
C      LOCAL VARIABLES :-
C            KEYCOM      CHARACTER ARRAY HOLDING THE POSSIBLE INTERRUPT
C                        TEXTS
C
C
      CHARACTER*(*) CTEXT
C
C
      PARAMETER ( LCOM = 8 , NCOM = 3 )
      CHARACTER*(LCOM) KEYCOM(NCOM)
C
C
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C
      DATA KEYCOM / 'ERROR' , 'DIRECT' , 'END' /
C
C
      KSCINT = -1
C
C -- CHECK SUPPLIED TEXT AGAINST INTERRUPT KEYWORDS. NOTE THAT MATCH
C    MUST BE EXACT.
C
      ICOM = KCCOMP ( CTEXT , KEYCOM , NCOM , 1 )
C
      IF ( ICOM .EQ. 1 ) THEN
C
C -- 'ERROR' INTERRUPT. SET ERROR FLAG
C
        CALL XERHND ( IERSFL )
        KSCINT = 0
      ELSE IF ( ICOM .EQ. 2 ) THEN
C
C -- 'DIRECT' INTERRUPT. CLOSE ALL SCRIPT FILES.
C
        CALL XFLUNW ( 1 , 2 )
        ISCINI = 0
        KSCINT = 0
      ELSE IF ( ICOM .EQ. 3 ) THEN
C
C -- 'END' INTERRUPT. ONLY AVAILABLE IF AN 'END' CONTINGENCY HAS BEEN
C    DECLARED.
C
        ISTAT = KSCACT ( 'END' )
        IF ( ISTAT .GT. 0 ) KSCINT = 0
      ENDIF
C
      RETURN
      END
CODE FOR KSCINX
      FUNCTION KSCINX ( IN )
C
C -- THIS ROUTINE IMPLEMENTS THE 'INDEX' INSTRUCTION IN SCRIPTS
C
C
C -- THIS ROUTINE ASSIGNS A VALUE TO A NAMED VARIABLE SELECTED FROM A
C    LIST OF EXPRESSIONS ON THE BASIS OF AN INDEXING EXPRESSION.
C
C      INPUT PARAMETER :-
C            IN          DUMMY
C
C
C -- RETURN VALUES ( OF KSCINX ) :-
C
C      ( ANY )           VALUE TO BE USED AS RETURN VALUE OF KSCPRC
C
C
C
C
C
C
      PARAMETER ( MAXLAB = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      COMMON /XSCCNT/ ISCXN1 , NCHKUS , ISCXN3 , MAXSYS
C
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
C
      CHARACTER*(MAXLAB) CVAR1
C
C
C
C
C -- READ VARIABLE
C
      ISTAT = KSCADR ( IADDR1 , CVAR1 , ITYPE1 , IVALUE )
      IF ( ISTAT .LE. 0 ) GO TO 9920
C
C -- READ INDEXING EXPRESSION ( THIS MUST BE AN INTEGER EXPRESSION )
C
      ISTAT = KSCEXP ( IINDEX , ITYPEE , CUPPER , CLOWER , IDIRPS , 1 )
      IF ( ISTAT .LT. 0 ) GO TO 9920
      IF ( ISTAT .EQ. 0 ) GO TO 9940
C
      IF ( ITYPEE .NE. 1 ) GO TO 9950
C
C -- READ N EXPRESSIONS. THESE NUST ALL BE OF THE SAME TYPE AS THE
C    VARIABLE. NOTE IF N IS LE 0, THE LOOP WILL BE EXECUTED ZERO TIMES
C    AND THE VALUE OF THE VARIABLE WILL NOT BE CHANGED.
C
      DO 1500 I = 1 , IINDEX
        ISTAT = KSCEXP ( IVALUE, ITYPEE, CUPPER, CLOWER, IDIRPS, 1 )
        IF ( ISTAT .LT. 0 ) GO TO 9900
        IF ( ISTAT .EQ. 0 ) GO TO 9000
C
        IF ( ITYPEE .NE. ITYPE1 ) GO TO 9960
1500  CONTINUE
C
C -- STORE NEW VALUE
C
      ISTAT = KSCIDN ( 1, 3, CVAR1, 1 , ITYPE1 , ID , IVALUE , 1 )
C
C
9000  CONTINUE
      KSCINX = 0
      RETURN
C
C
C
C
9900  CONTINUE
      GO TO 9000
C
9920  CONTINUE
      CALL XSCMSG ( MILLMS , MVARIA , ' ' , 0 )
      GO TO 9900
9940  CONTINUE
      CALL XSCMSG ( MMISSG , MINDEX , ' ' , 0 )
      GO TO 9900
9950  CONTINUE
      CALL XSCMSG ( MWRONG , MINDEX , ' ' , 0 )
      GO TO 9900
9960  CONTINUE
      CALL XSCMSG ( MWRONG , MEXPRE , ' ' , 0 )
      GO TO 9900
C
      END
CODE FOR KSCQUE
      FUNCTION KSCQUE ( IN )
C
C -- THIS ROUTINE IMPLEMENTS THE SCRIPT 'QUEUE' INSTRUCTION
C
C      INPUT PARAMETER :-
C            IN          DUMMY
C
C      RETURN VALUE :-
C            <ANY>       VALUE TO BE ASSIGNED TO 'KSCPRC'
C
C
C      LOCAL VARIABLES :-
C            COPER       CHARACTER ARRAY DEFINING SUBCOMMANDS
C
C            NCQUE       INTEGER VARIABLE DEFINING QUEUE UNIT NUMBER
C
      PARAMETER ( MAXLAB = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      DIMENSION JDEV(4)
      COMMON /XSCCNT/ ISCXN1 , NCHKUS , ISCXN3 , MAXSYS
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
C
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
C
C
      PARAMETER ( NOPR = 4 , LOPR = 8 )
      CHARACTER*(LOPR) COPER(NOPR)
C
C
C
      COMMON /UFILE/ NCUFU(10),IFLCHR(10),IFLMAX,IFLIND,NCLU,
     2 IRDLOG(10), IRDCPY(10), IRDCAT(10), IRDPAG, IRDLIN,
     3 IRDCMS(10), IRDINC(10), IRDSCR(10), IRDSRQ(10),
     4 IRDREC(10), IRDFND(10), IRDHGH(10)
      COMMON /XFLDAT/ KEYFIL(8,35), IFLUNI(35), IFLACC(35), IFLSTA(35),
     2 IFLFRM(35), IFLREA(35), IFLOPN(35), IFLLCK(35) , NFLUSD , NFLMAX
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
      DATA JDEV / 'S', 'C', 'P', 'Q' /
      DATA COPER / 'SEND' , 'REWIND' , 'PROCESS' , 'COPY' /
C
C
C
C -- READ SUBCOMMAND KEYWORD, AND CHECK AGAINST ALLOWED LIST
C
      LENTYP = KCCARG ( CUPPER , IDIRPS , 1 , NTYPE , NEND )
      IF ( LENTYP .LE. 0 ) GO TO 9940
C
      ITYPE = KCCOMP ( CUPPER(NTYPE:NEND) , COPER , NOPR , 2 )
      IF ( ITYPE .LE. 0 ) GO TO 9910
C
C
C -- 'SEND'
C
      IF ( ITYPE .EQ. 1 ) THEN
C
C -- OUTPUT COMMAND BUFFER
C
        IF ( ICOMLN .GT. 0 ) THEN
          WRITE ( NCQUE , 1005 ) CCOMBF(1:ICOMLN)
1005      FORMAT ( A )
        ENDIF
C
C -- 'REWIND'
C
      ELSE IF ( ITYPE .EQ. 2 ) THEN
C -- REWIND QUEUE FILE
C
        ENDFILE (UNIT = NCQUE, IOSTAT = IOS, ERR = 1009)
1009    CONTINUE
        REWIND  (UNIT = NCQUE, IOSTAT = IOS, ERR = 1010)
1010    CONTINUE
C
C -- 'PROCESS'
C
      ELSE IF ( ITYPE .EQ. 3 ) THEN
C
C -- REWIND QUEUE FILE, AND MAKE THIS FILE BE THE NEW SOURCE OF CRYSTALS
C    COMMANDS
C
        REWIND  (UNIT = NCQUE, IOSTAT = IOS, ERR = 1020)
1020    CONTINUE
C
        IF ( IFLIND .GE. IFLMAX ) GO TO 9920
C
            LFILE = 1
            CALL XRDOPN( 5, JDEV, ' ', LFILE)
            IF (IERFLG .LT. 0) GOTO 9930
C
        IFLIND = IFLIND + 1
C
        IRDCPY(IFLIND) = 0
        IRDLOG(IFLIND) = 1
        IRDCAT(IFLIND) = ICAT
        NCRU = NCQUE
        IFLCHR(IFLIND) = KFLCHR ( NCRU )
        IRDCMS(IFLIND) = 0
        IRDINC(IFLIND) = 10000
        IRDSCR(IFLIND) = 0
        IRDSRQ(IFLIND) = 0
C
        ICAT = IRDCAT(IFLIND)
        IUSFLG = IFLCHR(IFLIND)
C
C -- COMMAND FILE LEVEL CHANGED, SO STACK OPERATIONS ARE INVALID
C
      ISCDSB = 1
C
C
C -- 'COPY'
C
      ELSE IF ( ITYPE .EQ. 4 ) THEN
C
C -- COPY REMAINDER OF COMMAND LINE TO QUEUE FILE
C
        NSTART = KCCNEQ ( CLOWER , IDIRPS , ' ' )
        IF ( NSTART .LE. 0 ) GO TO 9950
        WRITE ( NCQUE , 1005 ) CLOWER(NSTART:IDIRLN)
C
      ENDIF
C
C
C
9000  CONTINUE
C
      KSCQUE = 0
C
      RETURN
C
9900  CONTINUE
      GO TO 9000
9910  CONTINUE
      CALL XSCMSG ( MILLEG , MKEYWD , CUPPER(NTYPE:NEND) , 0 )
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MINSUF , MCHANL , ' ' , 0 )
      GO TO 9900
9930  CONTINUE
      CALL XSCMSG ( MERROR , MOPENF , ' ' , 0 )
      CALL XERIOM ( NCQUE , ISTAT )
      GO TO 9900
9940  CONTINUE
      CALL XSCMSG ( MMISSG , MKEYWD , ' ' , 0 )
      GO TO 9900
9950  CONTINUE
      CALL XSCMSG ( MMISSG , MDATA , ' ' , 0 )
      GO TO 9900
C
C
      END
CODE FOR KSCREL
      FUNCTION KSCREL ( IVAL1 , ITYPE1 , IVAL2 , ITYPE2 , LEQ , LLST )
C
C -- DETERMINES EQUALITY/ORDERING OF TWO QUANTITIES
C
C
C -- INPUT PARAMETERS :-
C
C      IVAL1       VALUE 1
C      ITYPE1      TYPE OF VALUE 1
C                    1      INTEGER
C                    2      REAL
C                    3      LOGICAL
C      IVAL2,ITYPE2 ( SAME AS ABOVE, FOR SECOND QUANTITY )
C
C
C -- OUTPUT PARAMETERS :-
C
C      LEQ          .TRUE.   IF IVAL1 EQUALS IVAL2
C                   .FALSE.  OTHERWISE
C      LLST          .TRUE.   IF IVAL1 IS LESS THEN IVAL2
C                   .FALSE.  OTHERWISE
C
C
C -- RETURN VALUES :-
C
C      KSCREL      -1      INVALID COMPARISON. DATA TYPES ARE DIFFERENT
C                  +1      SUCCESS
C
C
      PARAMETER ( JINTEG = 1 , JREAL = 2 , JLOGIC = 3 )
      PARAMETER ( JCHAR = 4 )
C
      LOGICAL LEQ , LLST
C
      EQUIVALENCE ( IVALU1 , VALUE1 )
      EQUIVALENCE ( IVALU2 , VALUE2 )
C
C
      IF ( ITYPE1 .NE. ITYPE2 ) THEN
        KSCREL = -1
        RETURN
      ENDIF
C
C
      KSCREL = 1
C
      IF ( ITYPE1 .EQ. JINTEG ) THEN
C
C -- COMPARE INTEGERS
C
        LEQ = ( IVAL1 .EQ. IVAL2 )
        LLST = ( IVAL1 .LT. IVAL2 )
      ELSE IF ( ITYPE1 .EQ. JREAL ) THEN
C
C -- COMPARE REALS
C
        CALL XMOVE ( IVAL1 , IVALU1 , 1 )
        CALL XMOVE ( IVAL2 , IVALU2 , 1 )
        LEQ = ( VALUE1 .EQ. VALUE2 )
        LLST = ( VALUE1 .LT. VALUE2 )
      ELSE IF ( ITYPE1 .EQ. JLOGIC ) THEN
C
C -- COMPARE LOGICAL VALUES
C
        IVALU1 = MIN0 ( 1 , MAX0 ( 0 , IVAL1 ) )
        IVALU2 = MIN0 ( 1 , MAX0 ( 0 , IVAL2 ) )
        LEQ = ( IVALU1 .EQ. IVALU2 )
        LLST = .FALSE.
      ELSE IF ( ITYPE1 .EQ. JCHAR ) THEN
C
C -- COMPARE CHARACTER VALUES
C
        ISTAT = KSCSRE ( IVAL1 , IVAL2 , LEQ , LLST )
      ELSE
        KSCREL = -1
      ENDIF
C
C
      RETURN
      END
CODE FOR KSCSAD
      FUNCTION KSCSAD ( LENGTH , IDESC )
C
C -- ALLOCATE NEW DESCRIPTOR
C
C -- THIS ROUTINE ALLOCATES A NEW 'CHARACTER STRING DESCRIPTOR'
C
C      INPUT PARAMETER :-
C            LENGTH      SIZE TO BE ALLOCATED FOR NEW DESCRIPTOR. THIS
C                        SIZE IS WRITTEN INTO THE DESCRIPTOR.
C
C      OUTPUT PARAMETER :-
C            IDESC       NUMBER OF NEW DESCRIPTOR
C
C      RETURN VALUES :-
C            -1          ERROR - NO MORE DESCRIPTORS. A MESSAGE IS
C                        OUTPUT
C            +1          SUCCESS
C
      PARAMETER ( JVARIB =  1 , JNVARI =  2 , JNFDAT =  3 )
      PARAMETER ( JNFCHR =  4 , JEXECU =  5 , JBTYPE =  6 )
      PARAMETER ( JBSTRT =  7 , JBLEND =  8 , JNSTAT =  9 )
      PARAMETER ( JREQST = 10 , JWASEX = 11 , JSTLVL = 12 )
C
      PARAMETER ( LDESCR = 2 , NDESCR = 100 )
      PARAMETER ( LCHAR = 80 )
      CHARACTER*(LCHAR) CDESC(NDESCR)
      COMMON /XSCSCH/ CDESC
      COMMON /XSCDSC/ IDESCR(LDESCR,NDESCR)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C -- FIND NEXT FREE DESCRIPTOR
C
      IDESC = KSCSTK ( JNFCHR , 0 )
      IF ( IDESC .GT. NDESCR ) GO TO 9910
C
C -- CREATE NEW DESCRIPTOR.
C
      IDESCR(1,IDESC) = IDESC
      IDESCR(2,IDESC) = LENGTH
C
C -- UPDATE NEXT FREE DESCRIPTOR DETAILS
C
      CALL XSCSTU ( JNFCHR , IDESC + 1 )
C
      KSCSAD = 1
      RETURN
C
C
9900  CONTINUE
      KSCSAD = -1
      RETURN
9910  CONTINUE
C -- OUTPUT ERROR MESSAGE
      WRITE ( NCAWU , 9915 )
9915  FORMAT ( 1X , 'No more descriptors' )
      GO TO 9900
      END
CODE FOR KSCSCD
      FUNCTION KSCSCD ( CTEXT , IDESC )
C
C -- CONVERT TEXT FROM FORTRAN CHARACTER FORM TO DESCRIPTOR
C
C      INPUT PARAMETER :-
C            CTEXT       TEXT TO BE MOVED TO DESCRIPTOR AREA
C
C      OUTPUT PARAMETER :-
C            IDESC       VARIABLE INTO WHICH DESCRIPTOR NUMBER IS
C                        WRITTEN
C
      CHARACTER*(*) CTEXT
C
C
      PARAMETER ( LDESCR = 2 , NDESCR = 100 )
      PARAMETER ( LCHAR = 80 )
      CHARACTER*(LCHAR) CDESC(NDESCR)
      COMMON /XSCSCH/ CDESC
      COMMON /XSCDSC/ IDESCR(LDESCR,NDESCR)
C
C
      ISTAT = KSCSAD ( LEN ( CTEXT ) , IDESC )
      IF ( ISTAT .LT. 0 ) GO TO 9900
C
      CDESC(IDESCR(1,IDESC)) = CTEXT
C
      KSCSCD = 1
      RETURN
C
9900  CONTINUE
      KSCSCD = -1
      RETURN
      END
C
C
C
C
C
CODE FOR KSCSCT
      FUNCTION KSCSCT ( ISTRUC , IFUNC )
C
C -- HANDLE STRUCTURE DEFINING INSTRUCTIONS
C
C -- INPUT PARAMETERS :-
C
C      ISTRUC      STRUCTURE TYPE
C      IFUNC       FUNCTION
C                    1      BEGIN STRUCTURE
C                    2      END STRUCTURE
C -- RETURN VALUES :-
C      -1          ERROR DURING STRUCTURE OPERATION
C      +1          SUCCESS
C
C
C      LOCAL VARIABLES :-
C
C      ( DEFINITION OF INPUT SYNTAX FOR 'BEGIN STRUCTURE' )
C
C            NSTRUC      PARAMETER DEFINING NUMBER OF STRUCTURE TYPES
C                        KNOWN
C            IDEFPT      POINTER TO DEFINITION OF REQUIREMENTS OF EACH
C                        STRUCTURE TYPE WHEN IT IS BEGUN.
C            NDEFS       NUMBER OF ELEMENTS IN DEFINITION OF EACH
C                        STRUCTURE TYPE
C            IDEFKY      POINTER TO KEYWORDS USED IN DEFINTION OF EACH
C                        STRUCTURE TYPE
C            NKEYS       NUMBER OF KEYWORDS REQUIRED FOR EACH STRUCTURE
C                        TYPE.
C
C
C            NDEFIN      PARAMETER DEFINING NUMBER OF DEFINITION
C                        ELEMENTS
C            IDEFIN      ARRAY ( 2,NDEFIN ) CONTAINING THE INDIVIDUAL
C                        DEFINITION ELEMENTS. FOR EACH STRUCTURE TYPE
C                        THERE ARE POINTERS ( IDEFPT AND NDEFS )
C                        WHICH CONTROL WHICH ELEMENTS OF IDEFIN DESCRIBE
C                        THE SYNTAX OF THE PARTICULAR STRUCTURE UNDER
C                        CONSIDERATION. THE FORMAT OF EACH ELEMENT IS,
C                        FOR ELEMENT 'I' :-
C
C                        IDEFIN(1,I)      TYPE OF DATA REQUIRED :-
C                                    JINTEG      INTEGER EXPRESSION
C                                    JREAL       REAL EXPRESSION
C                                    JLOGIC      LOGICAL EXPRESSION
C                                    JEXPRE      ANY EXPRESSION
C                                    JNAME       A STRUCTURE NAME
C                                    JKEY        A KEYWORD
C                        IDEFIN(2,I)      THE NUMBER OF OCCURENCES
C                                         OF THE ITEM REQUIRED. ( 0
C                                         MEANS ITEM IS OPTIONAL )
C
C            CKEY        CHARACTER ARRAY DEFINING KEYWORDS. THE
C                        PARTICULAR KEYWORDS AVAILABLE WITH EACH
C                        STRUCTURE TYPE ARE DEFINED BY IDEFKY AND NKEYS
C
C            FOR EXAMPLE CONSIDER 'IF'. THIS IS STRUCTURE NUMBER 4
C            IDEFPT(4) IS 4,  AND NDEFS(4) IS 2. THEREFORE THE
C            SYNTAX FOR 'IF' IS DEFINED BY IDEFIN(,4) AND IDEFIN(,5)
C
C            IDEFIN(1,4) IS 'JLOGIC', IDEFIN(2,4) IS '1', WHICH MEANS
C            THAT 'IF' MUST BE FOLLOWED BY 1 LOGICAL EXPRESSION
C
C            IDEFIN(1,5) IS 'JKEY', IDEFIN(2,5) IS '1', WHICH MEANS THAT
C            THE EXPRESSION MUST BE FOLLOWED BY A KEYWORD. THE ACTUAL
C            KEYWORDS AVAILABLE ARE FOUND AS FOLLOWS :-
C
C            IDEFKY(4) IS 2, ANDS NKEYS(4) IS 1, SO THERE IS 1 KEYWORD
C            WHOSE VALUE IS GIVEN BY CKEY(2) ( I.E. 'THEN' )
C
C      ( INTERPRETATION OF INPUT FOR 'BEGIN STRUCTURE' )
C
C            IREAD       INTEGER ARRAY. EACH ELEMENT IS ZERO INITIALLY.
C                        IT IS SET TO 1 IF EXPRESSIONS ARE PROCESSED
C                        SUCCESSFULLY, AND TO THE INDEX OF THE KEYWORD
C                        IF A KEYWORD IS FOUND
C            LERROR      ( NOT USED )
C            IERROR      POSITIVE IF AN INPUT ERROR WAS FOUND
C            IEXPEV      IF SET, EXPRESSIONS ARE EVALUATED
C            LEXECU      LOGICAL VALUE. TRUE IF INSTRUCTION SHOULD BE
C                        EXECUTED. THIS IS IMPORTANT WHEN CONSIDERING
C                        WHETHER EXPRESSIONS SHOULD BE EVALUATED DURING
C                        INPUT PHASE. IF NOT SET, TYPES OF EXPRESSIONS
C                        ARE NOT CHECKED AGAINST THE DEFINITION
C
C      ( VARIABLES USED DURING EXECUTION OF STRUCTURE INSTRUCTIONS )
C
C            LSKIPL      IF TRUE, LOOP IS EXECUTED ZERO TIMES
C            LEQUAL      USED IN 'CASE AMONG' FOR COMPARISONS
C            LLESS       USED IN 'CASE AMONG' FOR COMPARISONS
C            LTERMI      IF TRUE, LOOP TERMINATION CONDITION MET
C
C
C
      PARAMETER ( JINTEG = 1 , JREAL = 2 , JLOGIC = 3 )
      PARAMETER ( JEXPRE = 4 )
      PARAMETER ( JNAME = 5 , JKEY = 6 )
C
C
      PARAMETER ( NSTRUC = 5 )
      DIMENSION IDEFPT(NSTRUC) , NDEFS(NSTRUC)
      DIMENSION IDEFKY(NSTRUC) , NKEYS(NSTRUC)
C
      PARAMETER ( LDEFIN = 2 , NDEFIN = 7 )
      DIMENSION IDEFIN(LDEFIN,NDEFIN)
C
      PARAMETER ( LKEY = 8 , NKEY = 4 )
      CHARACTER*(LKEY) CKEY(NKEY)
C
      DIMENSION IREAD(5)
      LOGICAL LSKIPL
      LOGICAL LEQUAL , LLESS
      LOGICAL LTERMI
      LOGICAL LEXECU
C
      PARAMETER ( MAXLAB = 12 )
C
      CHARACTER*(MAXLAB) CSTNAM
      PARAMETER ( JVARIB =  1 , JNVARI =  2 , JNFDAT =  3 )
      PARAMETER ( JNFCHR =  4 , JEXECU =  5 , JBTYPE =  6 )
      PARAMETER ( JBSTRT =  7 , JBLEND =  8 , JNSTAT =  9 )
      PARAMETER ( JREQST = 10 , JWASEX = 11 , JSTLVL = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      CHARACTER*(MAXLAB) CNAME
      LOGICAL LERROR
C
C
C
      COMMON /UFILE/ NCUFU(10),IFLCHR(10),IFLMAX,IFLIND,NCLU,
     2 IRDLOG(10), IRDCPY(10), IRDCAT(10), IRDPAG, IRDLIN,
     3 IRDCMS(10), IRDINC(10), IRDSCR(10), IRDSRQ(10),
     4 IRDREC(10), IRDFND(10), IRDHGH(10)
      COMMON /XFLDAT/ KEYFIL(8,35), IFLUNI(35), IFLACC(35), IFLSTA(35),
     2 IFLFRM(35), IFLREA(35), IFLOPN(35), IFLLCK(35) , NFLUSD , NFLMAX
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
C
      DATA IDEFPT / 1 , 0 , 2 , 4 , 6 /
      DATA NDEFS  / 1 , 0 , 2 , 2 , 2 /
C
      DATA IDEFIN / JNAME  , 1 ,   JINTEG , 0 ,   JKEY   , 0 ,
     2              JLOGIC , 1 ,   JKEY   , 1 ,   JEXPRE , 1 ,
     3              JKEY   , 0 /
C
      DATA IDEFKY / 0 , 0 , 1 , 2 , 3 /
      DATA NKEYS  / 0 , 0 , 1 , 1 , 2 /
C
      DATA CKEY / 'TIMES' , 'THEN' , 'RANGE' , 'AMONG' /
C
C
      IERROR = -1
C
C -- CHECK IF INSTRUCTIONS SHOULD BE EXECUTED ( ONLY IF OUTER BLOCK
C    IS BEING EXECUTED )
C
      IF ( ISCINI .GT. 0 ) THEN
        LEXECU = ( KSCSTK ( JEXECU , 0 ) .GT. 0 )
      ELSE
        LEXECU = .FALSE.
      ENDIF
C
C
C -- FOR 'BEGIN' TYPE OPERATIONS, COMPLETE INPUT PROCESSING
C
      IF ( IFUNC .EQ. 1 ) THEN
        IDEF1 = IDEFPT(ISTRUC)
        IDEFEN = IDEF1 + NDEFS(ISTRUC) - 1
C
        IEXPEV = 0
        IF ( LEXECU ) IEXPEV = 1
C
        ICOMP = 0
        DO 1200 I = IDEF1 , IDEFEN
          ICOMP = ICOMP + 1
          ITYPE = IDEFIN(1,I)
          IREAD(ICOMP) = 0
C
          IF ( ITYPE .LE. JEXPRE ) THEN
C -- READ EXPRESSION, AND CHECK TYPE IF NECESSARY
            ISTAT = KSCEXP ( IVALUE, IEXTYP, CUPPER, CLOWER, IDIRPS,
     2                                                          IEXPEV )
            IF ( ISTAT .LT. 0 ) IERROR = 1
            IF ( ISTAT .EQ. 0 ) GO TO 1200
C
            IF ( LEXECU .AND. ( ITYPE .NE. JEXPRE ) ) THEN
              IF ( IEXTYP .NE. ITYPE ) GO TO 1200
            ENDIF
            IREAD(ICOMP) = 1
          ELSE IF ( ITYPE .EQ. JNAME ) THEN
C -- READ NAME
            LENNAM = KCCARG ( CUPPER , IDIRPS , 1 , NNAME , NEND )
            IF ( LENNAM .LE. 0 ) GO TO 1200
            CNAME = CUPPER(NNAME:NEND)
            IREAD(ICOMP) = 1
          ELSE IF ( ITYPE .EQ. JKEY ) THEN
C -- READ AND CHECK KEYWORD
            LENKEY = KCCARG ( CUPPER , IDIRPS , 1 , NARG , NEND )
            IF ( LENKEY .LE. 0 ) GO TO 1200
            IKEY = KCCOMP ( CUPPER(NARG:NEND) ,
     2                      CKEY(IDEFKY(ISTRUC)) , NKEYS(ISTRUC) , 1 )
            IF ( IKEY .LE. 0 ) GO TO 1200
            IREAD(ICOMP) = IKEY
          ENDIF
1200    CONTINUE
C
C -- CHECK IF INPUT WENT OK
C
        ICOMP = 1
        DO 1300 I = IDEF1 , IDEFEN
          IF ( IREAD(ICOMP) .LT. IDEFIN(2,I) ) GO TO 9920
          ICOMP = ICOMP + 1
1300    CONTINUE
C
C -- CHECK IF THE END OF THE CURRENT STRUCTURE IS KNOWN
C
        IBLEND = 0
        IF ( ISCINI .GT. 0 ) THEN
          ICURR = IRDREC(IFLIND)
          CALL XSCSNM ( ISTRUC , ICURR , CSTNAM )
          ISTAT = KSCIDN ( 2, 1, CSTNAM, 5, ISUBTP, IDENT, IBLEND, 0 )
          IF ( ISTAT .LE. 0 ) IBLEND = 0
        ENDIF
      ELSE
C
C -- FOR 'END' TYPE OPERATIONS, REMEMBER TYPE AND STARTING ADDRESS OF
C    CURRENT STRUCTURE
        IOLDTP = KSCSTK ( JBTYPE , 0 )
        IOLDST = KSCSTK ( JBSTRT , 0 )
      ENDIF
C
      IF ( IERROR .GT. 0 ) GO TO 9920
C
C
C                      ***********************
C                      * EXECUTE INSTRUCTION *
C                      ***********************
C
      IF ( IFUNC .EQ. 1 ) THEN
        GO TO ( 2100 , 2200 , 2300 , 2400 , 2500 , 9910 ) , ISTRUC
        GO TO 9910
      ELSE IF ( IFUNC .EQ. 2 ) THEN
        GO TO ( 5100 , 5200 , 5300 , 5400 , 5500 , 9910 ) , ISTRUC
        GO TO 9910
      ENDIF
C
C
C
C
2100  CONTINUE
C
C -- 'SCRIPT'
C
C -- CREATE NEW STACK FRAME
C
      CALL XSCFRM ( ISTRUC )
C
C----- STORE SCRIPT NAME
      ISTAT = KSCSCD ( CNAME, ISRPNM)
      ISTAT = KSCIDN (1, 1, 'SCRIPTNAME', 1, 1, IDSCP, ISRPNM, -1)
C -- ENABLE EXECUTION
C
      CALL XSCSTU ( JEXECU , 1 )
      GO TO 4000
C
C
2200  CONTINUE
C -- 'BLOCK'
C
C -- CREATE NEW STACK FRAME
C
      CALL XSCFRM ( ISTRUC )
      GO TO 4000
C
C
2300  CONTINUE
C -- 'LOOP'
C
C -- CHECK INPUT SYNTAX IS 'LOOP' OR 'LOOP NN TIMES'
C
      IF ( IREAD(1) .NE. IREAD(2) ) GO TO 9920
C
      IF ( IREAD(1) .GT. 0 ) THEN
C
C -- 'LOOP NN TIMES'
C
        IEND = IVALUE
        LSKIPL = ( IEND .LE. 0 )
      ELSE
C
C -- 'LOOP'
C
        IEND = 0
        LSKIPL = .FALSE.
      ENDIF
C
C -- CREATE NEW STACK LEVEL
C
      CALL XSCFRM ( ISTRUC )
C
C -- IF LOOP WILL BE EXECUTED ZERO TIMES, CLEAR EXECUTION FLAG.
C    OTHERWISE CREATE LOOP CONTROL VARIABLES IN CONTEXT OF NEW
C    BLOCK
C
      IF ( LEXECU ) THEN
        IF ( LSKIPL ) THEN
          CALL XSCSTU ( JEXECU , 0 )
        ELSE
          ISTAT = KSCIDN ( 1, 1, 'LOOPCOUNTER', 1, 1, IDC, 1, -1 )
          ISTAT = KSCIDN ( 1 , 1 , 'LOOPEND' , 1 , 1 , IDE , IEND , -1)
        ENDIF
      ENDIF
C
      GO TO 4000
C
C
2400  CONTINUE
C -- 'IF'
C
C -- CREATE NEW STACK FRAME
C
      CALL XSCFRM ( ISTRUC )
C
C -- IF LOGICAL EXPRESSION WAS FALSE, DISABLE EXECUTION. IF TRUE, THEN
C    SET FLAG TO SIGNAL TO ANY 'ELSE' INSTRCUTIONS THAT A PART OF THIS
C    'IF' BLOCK HAS BEEN EXECUTED.
C
      IF ( ( IVALUE .LE. 0 ) .AND. LEXECU ) THEN
        CALL XSCSTU ( JEXECU , 0 )
        CALL XSCSTU ( JWASEX , 0 )
      ELSE
        CALL XSCSTU ( JWASEX , 1 )
      ENDIF
      GO TO 4000
C
C
2500  CONTINUE
C -- 'CASE'
C
C -- CHECK WHETHER 'RANGE' OR 'AMONG' WAS SPECIFIED
C
      IF ( IREAD(2) .EQ. 1 ) THEN
C
C -- 'CASE II RANGE JJ KK'
C
C -- CHECK EXPRESSION 'II' WAS AN INTEGER EXPRESSION. THEN READ UP TO
C    TWO MORE INTEGER EXPRESSSIONS 'JJ' AND 'KK', AND SET REQUIRED
C    STATEMENT ON THE BASIS OF THE VALUES OF THESE THREE EXPRESSIONS.
C
        IF ( LEXECU .AND. ( IEXTYP .NE. JINTEG ) ) GO TO 9930
        ISTAT = KSCEXP ( ILOWER, ITYPE, CUPPER, CLOWER, IDIRPS, IEXPEV )
        IF ( ISTAT .LT. 0 ) THEN
          GO TO 9940
        ELSE IF ( ISTAT .EQ. 0 ) THEN
          ILOWER = 1
          IUPPER = 1000
        ELSE
          IF ( LEXECU .AND. ( ITYPE .NE. JINTEG ) ) GO TO 9930
          ISTAT = KSCEXP ( IUPPER, ITYPE, CUPPER, CLOWER, IDIRPS,
     2                                                          IEXPEV )
          IF ( ISTAT .LT. 0 ) THEN
            GO TO 9940
          ELSE IF ( ISTAT .EQ. 0 ) THEN
            IUPPER = ILOWER + 1000
          ELSE
            IF ( LEXECU .AND. ( ITYPE .NE. JINTEG ) ) GO TO 9930
          ENDIF
        ENDIF
C
        IPOS = IVALUE - ILOWER + 1
        IMAX = IUPPER - ILOWER + 1
        IPOS = MIN0 ( IMAX , IPOS )
      ELSE IF ( IREAD(2) .EQ. 2 ) THEN
C
C -- 'CASE EXP AMONG EXP1 EXP2 ... EXPN'
C
C -- START READING EXPRESSIONS. CHECK THEY ARE EACH OF THE SAME TYPE AS
C    'EXP'. WHEN ONE IS FOUND THAT IS EQUAL TO 'EXP' THEN WE HAVE THE
C    NUMBER OF THE REQUIRED STATEMENT
C
        IPOS = 0
2510    CONTINUE
          IPOS = IPOS + 1
          ISTAT = KSCEXP ( ITEST, ITYPE, CUPPER, CLOWER, IDIRPS, IEXPEV)
          IF ( ISTAT .LT. 0 ) THEN
            GO TO 9940
          ELSE IF ( LEXECU .AND. ( ISTAT .GT. 0 ) ) THEN
            ISTAT = KSCREL ( IVALUE , IEXTYP , ITEST , ITYPE ,
     2                       LEQUAL , LLESS )
            IF ( ISTAT .LE. 0 ) GO TO 9930
            IF ( .NOT. LEQUAL ) GO TO 2510
         ENDIF
      ELSE
C
C -- 'CASE II'
C
C -- CHECK EXPRESSION WAS AN INTEGER EXPRESSION. ITS VALUES GIVES THE
C    REQUIRED STATEMENT DIRECTLY.
C
        IF ( LEXECU .AND. ( IEXTYP .NE. JINTEG ) ) GO TO 9930
        IPOS = IVALUE
      ENDIF
C
C -- CREATE NEW STACK FRAME
C
C -- DISABLE EXECUTION INITIALLY. SET REQUIRED STATEMENT NUMBER.
C
      CALL XSCFRM ( ISTRUC )
      CALL XSCSTU ( JEXECU , 0 )
      IF ( LEXECU ) CALL XSCSTU ( JREQST , IPOS )
C
      GO TO 4000
C
C
4000  CONTINUE
C
C -- GENERAL BEGINNING OF STRUCTURE PROCESSING
C
C -- STORE AWAY ADDRESS OF END OF THIS STRUCTURE IF KNOWN
      CALL XSCSTU ( JBLEND , IBLEND )
C
      GO TO 9000
C
C
C
C
C                        *** END STRUCTURE ***
C
C
C
C
C
5100  CONTINUE
C -- 'END SCRIPT'
C
C -- DISABLE STACK OPERATIONS
      ISCDSB = 1
C
      CALL XSCRST
      CALL XFLUNW ( 2 , 3 )
      GO TO 7000
C
C
5200  CONTINUE
C -- 'END BLOCK'
      CALL XSCRST
      GO TO 7000
C
C
5300  CONTINUE
C -- 'END LOOP'
C
C -- CHECK LOOP CONTROL VARAIBLES, AND EITHER REPEAT LOOP OR TERMINATE
C    AS APPROPRIATE
C
      IF ( KSCSTK ( JEXECU , 0 ) .GT. 0 ) THEN
        ISTAT = KSCIDN ( 2, 1, 'LOOPCOUNTER' , 1 , IS , IDC, ICOUNT, 1)
        ISTAT = KSCIDN ( 2 , 1 , 'LOOPEND' , 1 , IS , IDE, IEND , 1)
        LTERMI = ( ICOUNT .EQ. IEND )
      ELSE
        LTERMI = .TRUE.
      ENDIF
C
C -- CHECK END CONDITION, AND EITHER END LOOP, OR INCREMENT COUNTER,
C    AND REWIND TO START AGAIN
C
      IF ( LTERMI ) THEN
      CALL XSCRST
      ELSE
        IF ( KSCSTK ( JBLEND , 0 ) .LE. 0 ) THEN
          CALL XSCSTU ( JBLEND , IRDREC(IFLIND) )
        ENDIF
        ICOUNT = ICOUNT + 1
        ISTAT = KSCIDN ( 1, 1, 'LOOPCOUNTER', 1, 1, IDC, ICOUNT, 0 )
        IRDFND(IFLIND) = KSCSTK ( JBSTRT , 0 ) + 1
      ENDIF
      GO TO 7000
C
C
5400  CONTINUE
C -- 'END IF'
      CALL XSCRST
      GO TO 7000
C
C
5500  CONTINUE
C -- 'END CASE'
      CALL XSCRST
      GO TO 7000
C
C
7000  CONTINUE
C
C -- GENERAL END OF STRUCTURE PROCESSING
C
C -- IF CURRENT STRUCTURE IS A 'LOOP', REMEMBER WHERE THE END OF THE
C    INNER STRUCTURE WAS.
C
      IF ( IOLDTP .GT. 1 ) THEN
        IF ( KSCSTK ( JBTYPE , 0 ) .EQ. 3 ) THEN
          CALL XSCSNM ( IOLDTP , IOLDST , CSTNAM )
C
          ICURR = IRDREC(IFLIND)
          ISTAT = KSCIDN ( 1, 1, CSTNAM, 5, 1, IDENT, ICURR, 0 )
        ENDIF
      ENDIF
C
      GO TO 9000
C
C
9000  CONTINUE
C
C
      KSCSCT = 1
C
C
      RETURN
C
C
9900  CONTINUE
      KSCSCT = -1
      RETURN
C
9910  CONTINUE
      CALL XSCMSG ( MILLEG , MSTRUC , 'Internal error' , 0 )
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MILLMS , MPARAM , ' ' , 0 )
      GO TO 9900
9930  CONTINUE
      CALL XSCMSG ( MWRONG , MEXPRE , ' ' , 0 )
      GO TO 9900
9940  CONTINUE
      CALL XSCMSG ( MILLEG , MEXPRE , ' ' , 0 )
      GO TO 9900
C
C
      END
CODE FOR KSCSDC
      FUNCTION KSCSDC ( IDESC , CTEXT , LENGTH )
C
C -- CONVERT TEXT FROM DESCRIPTOR TO FORTRAN CHARACTER FORM
C
      CHARACTER*(*) CTEXT
C
      PARAMETER ( LDESCR = 2 , NDESCR = 100 )
      PARAMETER ( LCHAR = 80 )
      CHARACTER*(LCHAR) CDESC(NDESCR)
      COMMON /XSCSCH/ CDESC
      COMMON /XSCDSC/ IDESCR(LDESCR,NDESCR)
C
      IF ( IDESC .LE. 0 ) THEN
        CTEXT = ' '
        LENGTH = 0
      ELSE
        CTEXT = CDESC(IDESCR(1,IDESC))
        LENGTH = IDESCR(2,IDESC)
      ENDIF
C
      KSCSDC = 1
      RETURN
C
      END
CODE FOR KSCSDD
      FUNCTION KSCSDD ( IFUNC , IDESC1 , IDESC2 )
C
C -- COPY TEXT FROM DESCRIPTOR TO DESCRIPTOR
C
C
C      INPUT PARAMETERS :-
C
C            IFUNC       FUNCTION CONTROL
C                        1     ALWAYS ALLOCATE A NEW DESCRIPTOR AS
C                              OUTPUT, UNLESS COPYING EMPTY STRING
C                        2     ONLY USE A NEW DESCRIPTOR IF STRING
C                              CANNOT BE COPIED TO EXISTING ONE
C
C            IDESC1      INPUT DESCRIPTOR
C
C      OUTPUT PARAMETER :-
C            IDESC2      OUTPUT DESCRIPTOR. THIS WILL ALSO BE READ IF
C                        IFUNC = 2
C
C      RETURN VALUE :-
C            -1          ERROR ALLOCATING COPYING TEXT
C            +1          SUCCESS
C
      LOGICAL LEMPTY , LALLOC , LOUTDS
C
      PARAMETER ( LDESCR = 2 , NDESCR = 100 )
      PARAMETER ( LCHAR = 80 )
      CHARACTER*(LCHAR) CDESC(NDESCR)
      COMMON /XSCSCH/ CDESC
      COMMON /XSCDSC/ IDESCR(LDESCR,NDESCR)
C
C -- CHECK IF INPUT STRING IS EMPTY
C
      IF ( IDESC1 .GT. 0 ) THEN
        LENGTH = IDESCR(2,IDESC1)
        LEMPTY = ( LENGTH .LE. 0 )
      ELSE
        LENGTH = 0
        LEMPTY = .TRUE.
      ENDIF
C
C -- CHECK IF NEW DESCRIPTOR WILL BE REQUIRED
C
      IF ( IFUNC .EQ. 1 ) THEN
        LALLOC = .NOT. LEMPTY
        LOUTDS = LALLOC
      ELSE IF ( IFUNC .EQ. 2 ) THEN
        IF ( IDESC2 .LE. 0 ) THEN
          LALLOC = .NOT. LEMPTY
          LOUTDS = LALLOC
        ELSE
          LALLOC = .FALSE.
          LOUTDS = .TRUE.
        ENDIF
      ENDIF
C
      IF ( LALLOC ) THEN
        ISTAT = KSCSAD ( LENGTH , IDESC2 )
        IF ( ISTAT .LE. 0 ) GO TO 9900
      ENDIF
C
      IF ( LOUTDS ) THEN
        IDESCR(2,IDESC2) = LENGTH
        IF ( .NOT. LEMPTY ) THEN
          CDESC(IDESCR(1,IDESC2)) = CDESC(IDESCR(1,IDESC1))
        ENDIF
      ELSE
        IDESC2 = 0
      ENDIF
C
      KSCSDD = 1
      RETURN
C
9900  CONTINUE
      KSCSDD = -1
      RETURN
      END
CODE FOR KSCSET
      FUNCTION KSCSET ( IN )
C
C
C -- THIS ROUTINE IMPLEMENTS THE 'SET' INSTRUCTION IN SCRIPTS
C
C
C      INPUT PARAMETER :-
C            IN          DUMMY
C
C -- RETURN VALUES ( OF KSCSET ) :-
C
C      ( ANY )           VALUE TO BE USED AS RETURN VALUE OF KSCPRC
C
C
C      LOCAL VARIABLES :-
C
C            CVALUE      CHARACTER ARRAY DEFINING NAMES OF TYPES OF
C                        OPERATION PERFORMED.
C            IRQTYP      INTEGER ARRAY DEFINING TYPE OF VALUE REQUIRED
C                        FOR EACH TYPE OF SET OPERATION
C
C                              JINTEG      INTEGER EXPRESSION
C                              JREAL       REAL EXPRESSION
C                              JLOGIC      LOGICAL EXPRESSION
C
C -- THIS ROUTINE IS USED TO SET NEW VALUES OF CERTAIN GLOBAL VARIABLES
C    IN THE COMMON BLOCK 'XSCGBL'. THE FUNCTIONS OF THESE VARIABLES ARE
C    DESCRIBED IN THE ROUTINE 'KSCPRC'.
C
C
C
C
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
C
      PARAMETER ( JINTEG = 1 , JREAL = 2 , JLOGIC = 3 )
C
      PARAMETER ( LVAL = 8 , NVAL = 6 )
      CHARACTER*(LVAL) CVALUE(NVAL)
C
      DIMENSION IRQTYP(NVAL)
C
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
      DATA CVALUE / 'MESSAGE' , 'VERIFY' , 'FAST' , 'EVALUATE' ,
     2 'STACK' , 'IDENT' /
C
      DATA IRQTYP / JLOGIC ,    JLOGIC ,    JLOGIC , JLOGIC ,
     2 JLOGIC , JLOGIC /
C
C
C -- FIND OUT WHAT TYPE OF VALUE IS REQUIRED
C
      LENTYP = KCCARG ( CUPPER , IDIRPS , 1 , NTYPE , NEND )
      IF ( LENTYP .LE. 0 ) GO TO 9910
C
      IVALTP = KCCOMP ( CUPPER(NTYPE:NEND) , CVALUE , NVAL , 2 )
      IF ( IVALTP .LE. 0 ) GO TO 9910
C
C -- READ VALUE
C
      ISTAT = KSCEXP ( IVALUE , ITYPE , CUPPER , CLOWER , IDIRPS , 1 )
      IF ( ISTAT .LT. 0 ) GO TO 9900
      IF ( ISTAT .EQ. 0 ) GO TO 9920
C
      IF ( ITYPE .NE. IRQTYP(IVALTP) ) GO TO 9930
C
      IF ( IVALTP .EQ. 1 ) THEN
        ISCMSG = IVALUE
      ELSE IF ( IVALTP .EQ. 2 ) THEN
        ISCVER = IVALUE
      ELSE IF ( IVALTP .EQ. 3 ) THEN
        ISCFST = IVALUE
      ELSE IF ( IVALTP .EQ. 4 ) THEN
        ISCEVE = IVALUE
      ELSE IF ( IVALTP .EQ. 5 ) THEN
        ISCSVE = IVALUE
      ELSE IF ( IVALTP .EQ. 6 ) THEN
        ISCIVE = IVALUE
      ENDIF
C
C
9000  CONTINUE
      KSCSET = 0
      RETURN
C
C
9900  CONTINUE
      GO TO 9000
C
9910  CONTINUE
      CALL XSCMSG ( MILLMS , MKEYWD , ' ' , 0 )
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MILLMS , MEXPRE , ' ' , 0 )
      GO TO 9900
9930  CONTINUE
      CALL XSCMSG ( MWRONG , MEXPRE , ' ' , 0 )
      GO TO 9900
C

      END
CODE FOR KSCSHW
      FUNCTION KSCSHW ( IN )
C
C -- THIS ROUTINE IMPLEMENTS THE SCRIPT 'SHOW' INSTRUCTION
C
C -- DISPLAY VALUE OF VARIABLE
C
C      INPUT PARAMETER :-
C            IN          DUMMY
C
C      RETURN VALUE :-
C            <ANY>       VALUE TO BE ASSIGNED TO 'KSCPRC'
C
C
C      LOCAL VARIABLES :-
C            CLOG        TEXT REPRESENTATIONS OF THE TWO POSSIBLE
C                        LOGICAL VALUES ( TRUE AND FALSE )
C
C
      PARAMETER ( MAXLAB = 12 )
C
      CHARACTER*(MAXLAB) CVARIB
C
      PARAMETER ( LVALUE = 64 )
      CHARACTER*(LVALUE) CVALUE
      CHARACTER*5 CLOG(0:1)
C
C
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
C
      EQUIVALENCE ( IVALUE , XVALUE )
C
      DATA CLOG / 'false' , 'true' /
C
C
C
C
      IVAR = 0
C
1000  CONTINUE
C
C -- GET VARIABLE NAME
C
      LENVAR = KCCARG ( CUPPER , IDIRPS , 1 , NVAR , NEND )
      IF ( LENVAR .LE. 0 ) GO TO 9000
C
      CVARIB = CUPPER(NVAR:NEND)
C
      IVAR = IVAR + 1
C
      ISTAT = KSCIDN ( 2,3, CVARIB , 1, ITYPE, IID, IVALUE,1 )
      IF ( ISTAT .LE. 0 ) GO TO 9900
C
C -- CONVERT VARIABLE VALUE TO TEXT REPRESENTATION
C
        IF ( ITYPE .EQ. 1 ) THEN
          WRITE ( CVALUE , '(I12)' ) IVALUE
        LENVAL = 12
        ELSE IF ( ITYPE .EQ. 2 ) THEN
          WRITE ( CVALUE , '(F12.5)' ) XVALUE
        LENVAL = 12
        ELSE IF ( ITYPE .EQ. 3 ) THEN
          CVALUE = CLOG(IVALUE)
        LENVAL = 5
      ELSE IF ( ITYPE .EQ. 4 ) THEN
        CVALUE(1:1) = '"'
        ISTAT = KSCSDC ( IVALUE , CVALUE(2:) , LENTXT )
        IF ( LENTXT .LE. LVALUE - 1 ) THEN
          CVALUE(LENTXT+2:) = '"'
        ENDIF
        LENVAL = MIN0 ( LVALUE , LENTXT + 2 )
        ENDIF
C
C -- DISPLAY VARIABLE NAME AND VALUE
C
      WRITE ( NCAWU , 2105 ) CVARIB(1:LENVAR) , CVALUE(1:LENVAL)
2105    FORMAT ( 1X , A , ' = ' , A )
C
C
      GO TO 1000
C
C
9000  CONTINUE
      IF ( IVAR .LE. 0 ) GO TO 9910
      KSCSHW = 0
      RETURN
C
C
C
9900  CONTINUE
      KSCSHW = 0
      RETURN
9910  CONTINUE
      CALL XSCMSG ( MMISSG , MVARIA , ' ' , 0 )
      GO TO 9900
C
C
      END
CODE FOR KSCSRE
      FUNCTION KSCSRE ( IDESC1 , IDESC2 , LEQUAL , LLESST )
C
C -- COMPARE DESCRIPTOR WITH DESCRIPTOR
C
C -- THIS ROUTINE CALCULATIONS RELATIONAL FUNCTIONS BETWEEN TWO
C    STRINGS REPRESENTED BY SCRIPT CHARACTER STRING DESCRIPTORS
C
C      INPUT PARAMETERS :-
C            IDESC1,IDESC2     ADDRESSES OF DESCRIPTORS FOR CHARACTER
C                              STRINGS TO BE COMPARED
C
C      OUTPUT PARAMETERS :-
C            LEQUAL      LOGICAL VARIABLE. SET TRUE IF STRING1 = STRING2
C            LLESST      LOGICAL VARIABLE. SET TRUE IF STRING1 LESS THAN
C                        STRING2
C
C      RETURN VALUE :-
C            +1          SUCCESS
C
C
C      STRING1 IS EQUAL TO STRING2 IF
C            1)          BOTH ARE EMPTY
C                                  OR
C            2)          BOTH ARE NON-EMPTY, THE SAME LENGTH, AND
C                        CONTAIN THE SAME CHARACTERS
C
C      STRING1 LESS THAN STRING2 IF
C            1)          STRING1 EMPTY AND STRING2 NON-EMPTY
C                                OR
C            2)          BOTH ARE NON-EMPTY, AND 'LLT' MAKES STRING1
C                        LESS THAN STRING2
C
C
      LOGICAL LEQUAL , LLESST
C
      PARAMETER ( LDESCR = 2 , NDESCR = 100 )
      PARAMETER ( LCHAR = 80 )
      CHARACTER*(LCHAR) CDESC(NDESCR)
      COMMON /XSCSCH/ CDESC
      COMMON /XSCDSC/ IDESCR(LDESCR,NDESCR)
C
C
      IF ( IDESC1 .LE. 0 ) THEN
        LEN1 = 0
      ELSE
        LEN1 = IDESCR(2,IDESC1)
      ENDIF
C
      IF ( IDESC2 .LE. 0 ) THEN
        LEN2 = 0
      ELSE
        LEN2 = IDESCR(2,IDESC2)
      ENDIF
C
C
      IF ( LEN1 .EQ. 0 ) THEN
        IF ( LEN2 .EQ. 0 ) THEN
          LEQUAL = .TRUE.
          LLESST = .FALSE.
        ELSE
          LEQUAL = .FALSE.
          LLESST = .TRUE.
        ENDIF
      ELSE IF ( LEN2 .EQ. 0 ) THEN
        LEQUAL = .FALSE.
        LLESST = .FALSE.
      ELSE
        LEQUAL= ( CDESC(IDESCR(1,IDESC1)) .EQ. CDESC(IDESCR(1,IDESC2)) )
        LLESST= LLT ( CDESC(IDESCR(1,IDESC1)), CDESC(IDESCR(1,IDESC2)) )
      ENDIF
C
      KSCSRE = 1
C
      RETURN
      END
CODE FOR KSCSTK
      FUNCTION KSCSTK ( ITEM , IRELLV )
C
C -- RETURN INFORMATION FROM STACK
C
C -- THIS ROUTINE USED TO GET INFORMATION FROM THE STACK. NO ROUTINE
C    SHOULD ATTEMPT DIRECT ACCESS TO THE STACK, AS THIS MAKES FUTURE
C    CHANGES TO THE ORGANISATION OF THE STACK MORE DIFFICULT.
C
C      INPUT PARAMETERS :-
C
C            ITEM        CODE DESCRIBING ITEM REQUIRED. THESE CODES ARE
C                        ALL DEFINED IN PARAMETER STATEMENTS
C            IRELLV      RELATIVE LEVEL OF STACK FOR WHICH INFORMATION
C                        IS REQUIRED. A VALUE OF 0 REPRESENTS THE
C                        CURRENT FRAME. THIS WILL USUALLY BE THE ONE
C                        WANTED. 1 MEANS THE OUTER FRAME, 2 THE NEXT
C                        OUTER, AND SO ON.
C
C      RETURN VALUES :-
C            -VE         ERROR GETTING REQUESTED ITEM (INVALID REQUEST)
C            0,+VE       THE REQUESTED VALUE
C
C
C
      PARAMETER ( NSTACK = 30 , LSTACK = 12 )
      PARAMETER ( NFILVL = 10 )
      PARAMETER ( JVARIB =  1 , JNVARI =  2 , JNFDAT =  3 )
      PARAMETER ( JNFCHR =  4 , JEXECU =  5 , JBTYPE =  6 )
      PARAMETER ( JBSTRT =  7 , JBLEND =  8 , JNSTAT =  9 )
      PARAMETER ( JREQST = 10 , JWASEX = 11 , JSTLVL = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
C
      COMMON /UFILE/ NCUFU(10),IFLCHR(10),IFLMAX,IFLIND,NCLU,
     2 IRDLOG(10), IRDCPY(10), IRDCAT(10), IRDPAG, IRDLIN,
     3 IRDCMS(10), IRDINC(10), IRDSCR(10), IRDSRQ(10),
     4 IRDREC(10), IRDFND(10), IRDHGH(10)
      COMMON /XFLDAT/ KEYFIL(8,35), IFLUNI(35), IFLACC(35), IFLSTA(35),
     2 IFLFRM(35), IFLREA(35), IFLOPN(35), IFLLCK(35) , NFLUSD , NFLMAX
C
      COMMON /XSCSTK/ ILEVEL(NFILVL) , ISTACK(LSTACK,NSTACK)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C -- CHECK REQUEST IS LEGAL
C
      IF ( ITEM .LE. 0 ) GO TO 9910
      IF ( ITEM .GT. LSTACK ) GO TO 9910
C
C -- CHECK LEVEL REQUIRED IS LEGAL
C
      LEVEL = ILEVEL(IFLIND)
      IF ( LEVEL .LE. 0 ) GO TO 9920
C
      IF ( IRELLV .LT. 0 ) GO TO 9920
      IREQLV = LEVEL - IRELLV
      IF ( IREQLV .LE. 0 ) GO TO 9920
C
C -- GET THE ITEM REQUIRED
C
      KSCSTK = ISTACK(ITEM,IREQLV)
      RETURN
C
C
9900  CONTINUE
      KSCSTK = -1
      RETURN
9910  CONTINUE
      CALL XSCMSG ( MILLEG , MSTKIT , ' ' , ITEM )
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MILLEG , MSTKLV , ' ' , ILEVEL )
      GO TO 9900
C
C
      END
CODE FOR KSCSTR
      FUNCTION KSCSTR ( IN )
C
C -- THIS ROUTINE IMPLEMENTS THE 'STORE' INSTRUCTION IN SCRIPTS
C
C      INPUT PARAMETER :-
C            IN          DUMMY
C
C
C -- RETURN VALUES ( OF KSCSTR ) :-
C
C      ( ANY )           VALUE TO BE USED AS RETURN VALUE OF KSCPRC
C
C
C
C      LOCAL VARIABLES :-
C
C            CVALUE      CHARACTER ARRAY DEFINING TYPES OF DATA THAT CAN
C                        BE OUTPUT, AND DEFINING KEYWORDS USED TO
C                        INTRODUCE USER FORMAT AND LENGTH SPECIFICATIONS
C            IRQTYP      EXPRESSION TYPE REQUIRED FOR EACH ITEM IN
C                        CVALUE.
C                              JINTEG      INTEGER EXPRESSION
C                              JREAL       REAL EXPRESSION
C                              JLOGIC      LOGICAL EXPRESSION
C                              JCHAR       CHARACTER EXPRESSION
C            LENGTH      LENGTH OF DATA TO BE OUTPUT. THIS IS INITIALLY
C                        SET TO 12
C
C            CFORM       CHARACTER VARIABLE HOLDING A USER SUPPLIED
C                        FORMAT EXPRESSION
C            LENFRM      LENGTH OF USER SUPPLIED FORMAT EXPRESSION
C            LSPCFM      LOGICAL VALUE. TRUE IF A USER FORMAT EXPRESSION
C                        HAS BEEN SUPPLIED
C
C
C            CLOGIC      CHARACTER REPRESENTATIONS OF LOGICAL VALUES
C
C
C
C
C
      PARAMETER ( MAXLAB = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
      PARAMETER ( NCHK = 20 , LCHK = 12 )
      CHARACTER*(LCHK) CCHECK(NCHK)
      COMMON /XSCCHK/ CCHECK
C
      PARAMETER ( JINTEG = 1 , JREAL = 2 , JLOGIC = 3 , JCHAR = 4)
C
      CHARACTER*(MAXLAB) CVARIB
      CHARACTER*80 CFORM, CTXT
      LOGICAL LSPCFM
C
      CHARACTER*6 CLOGIC(0:1)
C
      PARAMETER ( NVAL = 7 , LVAL = 9 )
      CHARACTER*(LVAL) CVALUE(NVAL)
      DIMENSION IRQTYP(NVAL)
C
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      EQUIVALENCE ( IVALUE , VALUE )
C
      DATA CVALUE / 'INTEGER' , 'REAL' , 'KEYWORD' , 'FORMAT' ,
     2              'LOGICAL' , 'LENGTH' , 'CHARACTER' /
C
      DATA IRQTYP / JINTEG , JREAL , JINTEG , 0 , JLOGIC , 0 , JCHAR/
C
      DATA ITPINT / 1 / , ITPREA / 2 /
      DATA ITPKEY / 3 / , ITPFRM / 4 /
      DATA ITPLOG / 5 / , ITPLEN / 6 /
      DATA ITPCHR / 7 /
C
      DATA CLOGIC / ' FALSE' , ' TRUE ' /
C
C
      LSPCFM = .FALSE.
      LENGTH = 12
C
C -- FIND OUT WHAT TYPE OF VALUE IS REQUIRED
C
1100  CONTINUE
C
C
C -- READ A KEYWORD, AND CHECK ITS VALUE
C
      LENTYP = KCCARG ( CUPPER , IDIRPS , 1 , NTYPE , NEND )
      IF ( LENTYP .LE. 0 ) GO TO 9910
C
      IVALTP = KCCOMP ( CUPPER(NTYPE:NEND) , CVALUE , NVAL , 2 )
      IF ( IVALTP .LE. 0 ) GO TO 9910
C
      IF ( IVALTP .EQ. ITPFRM ) THEN
C
C -- 'FORMAT'. THIS IS FOLLOWED BY
C            1)  A FORMAT EXPRESSION
C            2)  ANOTHER KEYWORD
C
        LENFRM = KCCARG ( CUPPER , IDIRPS , 2 , NFORM , NEND )
        CFORM = CUPPER(NFORM:NEND)
        LSPCFM = .TRUE.
        GO TO 1100
      ELSE IF ( IVALTP .EQ. ITPLEN ) THEN
C -- 'LENGTH'. THIS IS FOLLOWED BY
C            1)  A LENGTH ( INTEGER EXPRESSION )
C            2)  ANOTHER KEYWORD
C
        ISTAT = KSCEXP ( LENGTH, ITYPE, CUPPER, CLOWER, IDIRPS, 1 )
        IF ( ISTAT .LT. 0 ) GO TO 9900
        IF ( ISTAT .EQ. 0 ) GO TO 9940
        IF ( ITYPE .NE. JINTEG ) GO TO 9940
        GO TO 1100
      ENDIF
C
C -- ANOTHER KEYWORD HAS BEEN READ. THIS MEANS THAT ACTION IS ABOUT
C    TO BEGIN. 'INTEGER' , 'REAL' ETC. ARE FOLLOWED BY EXPRESSIONS.
C
      IVAR = 0
      IREQ = IRQTYP(IVALTP)
C
2000  CONTINUE
C
      ISTAT = KSCEXP ( IVALUE , ITYPE , CUPPER , CLOWER , IDIRPS , 1 )
      IF ( ISTAT .LT. 0 ) GO TO 9900
      IF ( ISTAT .EQ. 0 ) GO TO 9000
C
C -- CHECK TYPE OF EXPRESSION
      IF ( IREQ .NE. ITYPE ) GO TO 9930
C
C -- CONVERT EXPRESSION TO TEXT, USING EITHER DEFAULT FORMAT OR THE USER
C    SUPPLIED EXPRESSION. APPEND THE TEXT GENERATED TO THE COMMAND
C    BUFFER. ( NOTE 'LOGICAL' AND 'KEYWORD' ARE NOT CONVERTED VIA
C    'INTERNAL WRITES', SINCE THE INFORMATION IS ALREADY IN CHARACTER
C    FORM )
C
      IF ( IVALTP .EQ. ITPINT ) THEN
        IF ( LSPCFM ) THEN
          WRITE ( CCOMBF(ICOMLN+1:) , CFORM ) IVALUE
        ELSE
          WRITE ( CCOMBF(ICOMLN+1:) , '(I12)' ) IVALUE
        ENDIF
      ELSE IF ( IVALTP .EQ. ITPREA ) THEN
        IF ( LSPCFM ) THEN
          WRITE ( CCOMBF(ICOMLN+1:) , CFORM ) VALUE
        ELSE
          WRITE ( CCOMBF(ICOMLN+1:) , '(F12.6)' ) VALUE
        ENDIF
      ELSE IF ( IVALTP .EQ. ITPKEY ) THEN
        CCOMBF(ICOMLN+1:) = CCHECK(IVALUE)
        LENGTH = INDEX(CCHECK(IVALUE)//' ' , ' ' ) - 1
      ELSE IF ( IVALTP .EQ. ITPLOG ) THEN
        CCOMBF(ICOMLN+1:) = CLOGIC(IVALUE)
        LENGTH = 6
      ELSE IF (IVALTP .EQ. ITPCHR ) THEN
C----- CHARACTER EXPRESSION EXPECTED
        IF ( ITYPE .NE. JCHAR ) GO TO 9940
        CTXT = ' '
        ISTAT = KSCSDC ( IVALUE , CTXT , LENTXT )
        IF ( LENTXT .GT. 0 ) THEN
          CCOMBF(ICOMLN+1:ICOMLN+1+LENTXT) = CTXT(1:LENTXT)
          LENGTH =  LENTXT
        ENDIF
      ENDIF
C
C
      ICOMLN = ICOMLN + LENGTH
C
C -- READ ANOTHER EXPRESSION
C
      IVAR = IVAR + 1
      GO TO 2000
C
9000  CONTINUE
C
C -- CHECK THAT AT LEAST ONE EXPRESSION WAS GIVEN.
C
      IF ( IVAR .LE. 0 ) GO TO 9920
      KSCSTR = 0
      RETURN
C
C
C
C
9900  CONTINUE
      KSCSTR = 0
      RETURN
C
9910  CONTINUE
      CALL XSCMSG ( MILLMS , MKEYWD , ' ' , 0 )
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MMISSG , MEXPRE , ' ' , 0 )
      GO TO 9900
9930  CONTINUE
      CALL XSCMSG ( MWRONG , MEXPRE , ' ' , 0 )
      GO TO 9900
9940  CONTINUE
      CALL  XSCMSG ( MILLMS , MLENGT , ' ' , 0 )
      GO TO 9900
C
      END
CODE FOR KSCTRA
      FUNCTION KSCTRA ( CTEXT , IUSLEN )
C
C -- PERFORM 'TRANSFER' INSTRUCTION
C
C      INPUT PARAMETERS :-
C            <NONE>
C
C      OUTPUT PARAMETERS :-
C            CTEXT       TEXT TO BE RETURNED TO 'CRYSTALS'
C            IUSLEN      USABLE LENGTH OF 'CTEXT'
C
C      RETURN VALUE :-
C            <ANY>       VALUE TO BE ASSIGNED TO 'KSCPRC'
C
C
C
C      LOCAL VARIABLES :-
C            LTO         LENGTH OF LINK KEYWORDS
C            NTO         NUMBER OF LINKING KEYWORDS
C            CTO         CHARACTER ARRAY HOLDING LINKING KEYWORDS
C                        ( THE ONLY LINKING KEYWORD IS 'TO' )
C            LDEST       LENGTH OF DESTINATION KEYWORDS
C            NDEST       NUMBER OF DESTINATION KEYWORDS
C            CDEST       CHARACTER ARRAY HOLDING DESTINATION KEYWORDS
C                              DISPLAY     DISPLAY DATA ON TERMINAL
C                              CRYSTALS    DATA IS A CRYSTALS COMMAND
C                              SCRIPT      DATA IS A SCRIPT COMMAND
C            CWORK       WORK AREA IN WHICH TEXT TO BE DISPLAYED IS
C                        STORED
C
C
C
      CHARACTER*(*) CTEXT
C
C
C
      PARAMETER ( LTO = 2 , NTO = 1 )
      CHARACTER*(LTO) CTO(NTO)
C
      PARAMETER ( LDEST = 12 , NDEST = 3 )
      CHARACTER*(LDEST) CDEST(NDEST)
C
      PARAMETER ( LENDSP = 80 )
      CHARACTER*(LENDSP) CWORK
C
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
C
      DATA CTO / 'TO' /
      DATA CDEST / 'DISPLAY' , 'CRYSTALS' , 'SCRIPT' /
C
C
C
      ISTAT = KSCEXP ( IVALUE , ITYPE , CUPPER , CLOWER , IDIRPS , 1 )
      IF ( ISTAT .LT. 0 ) GO TO 9900
      IF ( ISTAT .EQ. 0 ) GO TO 9910
C
C
      IF ( ITYPE .NE. 4 ) GO TO 9920
C
      LENARG = KCCARG ( CUPPER , IDIRPS , 1 , NARG , NEND )
      IF ( LENARG .LE. 0 ) GO TO 9930
C
      ICOMP = KCCOMP ( CUPPER(NARG:NEND) , CTO , NTO , 1 )
      IF ( ICOMP .LE. 0 ) GO TO 9940
C
      LENARG = KCCARG ( CUPPER , IDIRPS , 1 , NARG , NEND )
      IF ( LENARG .LE. 0 ) GO TO 9930
C
      IDEST = KCCOMP ( CUPPER(NARG:NEND) , CDEST , NDEST , 1 )
      IF ( IDEST .LE. 0 ) GO TO 9940
C
      KSCTRA = 0
C
      IF ( IDEST .EQ. 1 ) THEN
C
C -- 'DISPLAY'
C
        ISTAT = KSCSDC ( IVALUE , CWORK , LENWRK )
        IF ( LENWRK .GT. 0 ) THEN
          WRITE ( NCAWU , 1105 ) CWORK(1:LENWRK)
1105      FORMAT ( 1X , A )
        ELSE
          WRITE ( NCAWU , 1115 )
1115      FORMAT ( 1X )
        ENDIF
      ELSE IF ( IDEST .EQ. 2 ) THEN
C
C -- 'CRYSTALS'
C
        ISTAT = KSCSDC ( IVALUE , CTEXT , IUSLEN )
        IF ( IUSLEN .GT. 0 ) KSCTRA = 2
      ELSE IF ( IDEST .EQ. 3 ) THEN
C
C -- 'SCRIPT'
C
        ISTAT = KSCSDC ( IVALUE , CTEXT , IUSLEN )
        IF ( IUSLEN .GT. 0 ) KSCTRA = 3
      ENDIF
C
C
      RETURN
C
C
9900  CONTINUE
      KSCTRA = 0
      RETURN
C
9910  CONTINUE
      CALL XSCMSG ( MMISSG , MEXPRE , ' ' , 0 )
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MWRONG , MEXPRE , ' ' , 0 )
      GO TO 9900
9930  CONTINUE
      CALL XSCMSG ( MMISSG , MKEYWD , ' ' , 0 )
      GO TO 9900
9940  CONTINUE
      CALL XSCMSG ( MILLEG , MKEYWD , CUPPER(NARG:NEND) , 0 )
      GO TO 9900
      END
CODE FOR KSCTRN
      FUNCTION KSCTRN ( IDIREC , CVARIB , IVALUE )
C
C -- MOVE VALUE TO OR FROM SCRIPT VARIABLE
C
C -- THIS ROUTINE PROVIDES AN INTERFACE BETWEEN THE MAIN CRYSTALS
C    PROGRAMS AND THE SCRIPT FACILITIES, BY ALLOWING DATA TO BE MOVED
C    QUITE SIMPLY BETWEEN THEM.
C
C      IDIREC      DIRECTION OF MOVEMENT
C                    1      MOVE DATA FROM 'IVALUE' TO VARIABLE
C                    2      MOVE DATA TO 'IVALUE' FROM VARIABLE
C      CVARIB      NAME OF VARIABLE. IF THIS IS ALL BLANK, NO ACTION
C                  IS TAKEN, AND THE ROUTINE IMMEDIATELY RETURNS.
C      IVALUE      VALUE
C
C      RETURN VALUES OF KSCTRN
C
C      -1          ERROR. VARIABLE NAME IS NOT KNOWN
C      +1          SUCCESS
C
C
      CHARACTER*(*) CVARIB
      CHARACTER *64 CBUFF
C
C
C
C
C -- CHECK WHETHER A VARIABLE NAME HAS BEEN GIVEN
C
      KSCTRN = 1
      IF ( CVARIB .EQ. ' ' ) RETURN
C
C -- FIND IDENTIFIER
C
C
      ISTAT = KSCIDN ( 2 , 3 , CVARIB , 1 , ITYPE , IDENT , ICVAL , -1 )
      IF ( ISTAT .LE. 0 ) GO TO 9900
C
C -- TRANSFER DATA
C
      IF ( IDIREC .EQ. 1 ) THEN
        IF (ITYPE .EQ. 4) THEN
C         A CHARACTER VARIABLE - CONVERT TO HOLLERITH
          WRITE (CBUFF, '(A4)') IVALUE
          ISTAT = KSCSCD (CBUFF(1:4), JVALUE )
          ISTAT = KSCIDN ( 1, 3, CVARIB, 1, ITYPE, IDENT, JVALUE , -1)
        ELSE
          ISTAT = KSCIDN ( 1, 3, CVARIB, 1, ITYPE, IDENT, IVALUE , -1)
        END IF
      ELSE
        IF (ITYPE .EQ. 4) THEN
C            A CHARACTER VARIABLE - RECOVER FROM HOLLERITH
             ISTAT = KSCSDC (ICVAL, CBUFF, I )
             READ (CBUFF, '(A4)') IVALUE
        ELSE
             CALL XMOVE ( ICVAL , IVALUE , 1 )
        ENDIF
      ENDIF
C
      RETURN
C
C
9900  CONTINUE
      KSCTRN = -1
C
      RETURN
      END
CODE FOR KSCUMS
      FUNCTION KSCUMS ( IN )
C
C -- CHANGE USER MESSAGE
C
C -- THIS ROUTINE IMPLEMENTS THE SCRIPT 'MESSAGE' INSTRUCTION
C
C      INPUT PARAMETER :-
C            IN          DUMMY
C
C
C      RETURN VALUE OF KSCUMS IS THE VALUE TO BE USED FOR 'KSCPRC'
C
C
C      LOCAL VARIABLES :-
C
C            CTYPE       CHARACTER ARRAY DEFINING NAMES OF MESSAGES
C                        THAT CAN BE CHANGED USING THIS ROUTINE
C
C -- THE MESSAGES ARE STORED IN THE ARRAY 'CSCMSG' WITH LENGTHS IN
C    'LSCMSG'. THESE ARRAYS ARE DESCRIBED IN 'KSCPRC'
C
C
      PARAMETER ( LTYP = 12 , NTYP = 20 )
      CHARACTER*(LTYP) CTYPE(NTYP)
C
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      PARAMETER ( NSCMSG = 20 )
      CHARACTER*80 CSCMSG(NSCMSG)
      COMMON /XSCMS1/ CSCMSG
      COMMON /XSCMS2/ LSCMSG(NSCMSG)
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
C
C
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
C
      DATA CTYPE / 'EXTRA' , 'DEFAULT' , 'REAL' , 'INTEGER' ,
     2 'VALUE' , 'ABANDONED' , 'USER1' , 'USER2' , 'USER3' , 'USER4' ,
     3 'PRINTEGER' , 'PRREAL' , 'PRTEXT' , 'PRKEYWORD' , 'PRVERIFIED' ,
     4 'PRFILENAME' , 'PRABBREV' , 'PRYESNO' , 'AMBIG' , 'INAPPROP' /
C
C
C
C
C -- READ/CHECK KEYWORD ( MESSAGE NAME )
C
      LENTYP = KCCARG ( CUPPER , IDIRPS , 1 , NTYPE , NEND )
      IF ( LENTYP .LE. 0 ) GO TO 9910
C
      ITYPE = KCCOMP ( CUPPER(NTYPE:NEND) , CTYPE , NTYP , 2 )
      IF ( ITYPE .LE. 0 ) GO TO 9910
C
C -- READ NEW MESSAGE TEXT
C
      LENMSG = KCCARG ( CUPPER , IDIRPS  , 2 , NMSG , NEND )
      IF ( LENMSG .LE. 0 ) GO TO 9920
C
C -- STORE NEW MESSAGE TEXT, AND ITS LENGTH
C
      LSCMSG(ITYPE) = LENMSG
      CSCMSG(ITYPE) = CLOWER(NMSG:NEND)
C
C
9900  CONTINUE
      KSCUMS = 0
      RETURN
C
9910  CONTINUE
      CALL XSCMSG ( MILLMS , MKEYWD , ' ' , 0 )
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MILLMS , MMESSG , ' ' , 0 )
      GO TO 9900
      END
CODE FOR KSCVAL
      FUNCTION KSCVAL ( IN )
C
C -- READ USER INPUT FOR SCRIPT PROCESSING ROUTINE
C
C -- THIS ROUTINE IMPLEMENTS THE 'GET' INSTRUCTION IN SCRIPTS
C
C  'IN' IS A DUMMY ARGUMENT
C
C -- RETURN VALUES ( OF KSCVAL ) :-
C
C      ( ANY )           VALUE TO BE USED AS RETURN VALUE OF KSCPRC
C
C
C      LOCAL VARIABLES :-
C
C            CBUFFR      BUFFER FOR PROMPT STRING ( 80 CHARACTERS )
C            CVAL        BUFFER FOR ALLOWED VALUE LIST ( 160 CHARS )
C            LINLEN      THIS GIVES THE BREAK POINT FOR THE ALLOWED
C                        VALUE LIST. IF THE LIST WOULD BE LONGER THAN
C                        LINLEN, IT IS BROKEN AT A POINT LE LINLEN.
C
C            LDEFBF      PARAMETER DEFINING MAXIMUM LENGTH OF DEFAULT
C                        VALUE
C            CDEFLT      BUFFER FOR DEFAULT VALUE ( IF ANY )
C
C            CVALTP      CHARACTER ARRAY DEFINING NAMES OF THE POSSIBLE
C                        TYPES OF VALUE ( 'INTEGER', 'KEYWORD', ETC )
C            IRESTP      INTEGER ARRAY DEFINING THE TYPE ( INTEGER/REAL/
C                        LOGICAL/NONE ) OF THE RESULTING VALUE STORED
C                        IN 'ISCVAL'. THE VALUE OF IRESTP() IS MOVED TO
C                        ISCVTP, AND ISCVTP IS USED BY 'KSCEST' FOR
C                        EXAMPLE.
C            CMODIF      CHARACTER ARRAY DEFINING 'MODIFIERS'. THESE
C                        SELECT VARIOUS MODIFICATIONS TO NORMAL ACTION
C                        OF THIS ROUTINE
C
C            IVALUE      VALUE FOUND ( MOVED TO ISCVAL AT THE END )
C            INTERR      ERROR FLAG. IF SET, 'USER ERROR' CAN BE
C                        HANDLED BY THIS ROUTINE ALONE. THIS IS TRUE
C                        IF THE 'USER ERROR' ( I.E. AN ERROR IN THE
C                        FINAL USER'S INPUT ) WAS FOUND IN TEXT WHICH
C                        WAS ENTERED IN THIS CALL OF KSCVAL, RATHER THAN
C                        IN TEXT WHICH WAS ALREADY IN THE INPUT BUFFER
C            ICHECK      IF SET, VALUE READ WILL BE CHECKED AGAINST
C                        ALLOWED VALUE LIST
C
C      ( MODIFIERS, WHICH ARE SET IF 1, CLEAR IF 0 )
C            IFINAL      IF SET, INPUT ITEM MUST BE LAST ON THE INPUT
C                        LINE
C            IAPPND      IF SET, INPUT TEXT IS APPENDED TO COMMAND
C                        BUFFER WITH NO INTERVENING SPACE
C            IFILL       IF SET, FULL FORM OF ABBREVIATED KEYWORDS IS
C                        STORED IN THE COMMAND BUFFER
C            INOSTR      IF SET, INPUT TEXT IS NOT STORED IN COMMAND
C                        BUFFER
C            INOPMT      IF SET, USER IS NOT PROMPTED FOR MORE INPUT
C                        IF THE INPUT BUFFER IS EMPTY
C            INOREM      IF SET, INPUT TEXT IS NOT REMOVED FROM INPUT
C                        BUFFER
C            INOMSG      IF SET, NO MESSAGE IS PRODUCED FOR A 'USER
C                        ERROR'
C
C
C
C
      PARAMETER ( LDEFBF = 80 )
      CHARACTER*(LDEFBF) CDEFLT
C
C -- CHARACTER BUFFERS FOR GENERATING PROMPT STRINGS
C
      CHARACTER *80 CTOP, CBTM, CBOX, CMENU
      CHARACTER *80 CBUFFR, CPRMPT
      CHARACTER*160 CVAL
C----- TO HOLD REAL FORMAT EXPRESSION
      CHARACTER *8 CFMTXP
C
C
C
      PARAMETER ( NVAL = 8 , LVAL = 12 )
      CHARACTER*(LVAL) CVALTP(NVAL)
      DIMENSION IRESTP(NVAL)
      DIMENSION IPRMSG(NVAL)
C
      PARAMETER ( NMOD = 7 , LMOD = 12 )
      CHARACTER*(LMOD) CMODIF(NMOD)
C
C
      PARAMETER ( MAXLAB = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
      COMMON /XSCCNT/ ISCXN1 , NCHKUS , ISCXN3 , MAXSYS
      PARAMETER ( NSCMSG = 20 )
      CHARACTER*80 CSCMSG(NSCMSG)
      COMMON /XSCMS1/ CSCMSG
      COMMON /XSCMS2/ LSCMSG(NSCMSG)
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
      PARAMETER ( NCHK = 20 , LCHK = 12 )
      CHARACTER*(LCHK) CCHECK(NCHK)
      COMMON /XSCCHK/ CCHECK
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
C
C
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
      COMMON /UFILE/ NCUFU(10),IFLCHR(10),IFLMAX,IFLIND,NCLU,
     2 IRDLOG(10), IRDCPY(10), IRDCAT(10), IRDPAG, IRDLIN,
     3 IRDCMS(10), IRDINC(10), IRDSCR(10), IRDSRQ(10),
     4 IRDREC(10), IRDFND(10), IRDHGH(10)
      COMMON /XFLDAT/ KEYFIL(8,35), IFLUNI(35), IFLACC(35), IFLSTA(35),
     2 IFLFRM(35), IFLREA(35), IFLOPN(35), IFLLCK(35) , NFLUSD , NFLMAX
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C
      EQUIVALENCE ( IVALUE , VALUE )
C
      DATA CVALTP / 'INTEGER'      , 'REAL'         , 'TEXT'         ,
     2              'KEYWORD'      , 'VERIFIED'     , 'FILENAME'     ,
     3              'ABBREVIATED'  , 'YESNO'        /
C
      DATA ITPINT / 1 / , ITPREA / 2 /
      DATA ITPTXT / 3 / , ITPKEY / 4 /
      DATA ITPVKY / 5 / , ITPFIL / 6 /
      DATA ITPABB / 7 / , ITPYSN / 8 /
C
      DATA IRESTP / 1 , 2 , 0 , 0 , 1 , 1 , 1 , 1 /
      DATA IPRMSG / 11 , 12 , 13 , 14 , 15 , 16 , 17 , 18 /
C
      DATA CMODIF / 'FINAL'        , 'APPEND'       , 'FILL'         ,
     2              'NOSTORE'      , 'NOPROMPT'     , 'NOREMOVE'     ,
     3              'NOMESSAGE'    /
     3
C
      DATA LINLEN / 76 /
C
      IF (ISSTML .EQ. 3 ) THEN
C----- INITIALISE MENU BOX FOR DOS
            DO 1 I = 2,77
            CTOP(I:I) = CHAR(196)
            CBOX(I:I) = ' '
            CBTM(I:I) = CHAR(196)
1           CONTINUE
            CTOP(1:1) = CHAR(218)
            CTOP(78:78) = CHAR(191)
            CBOX(1:1) = CHAR(179)
            CBOX(78:78) = CHAR(179)
            CBTM(1:1) = CHAR(192)
            CBTM(78:78) = CHAR(217)
      ENDIF
C
C
C
C
      IVALUE = 0
      INTERR = 0
C
C -- SET INITIAL VALUE FOR VALUE FOUND
C
      CALL XMOVE ( 0 , ISCVAL , 1 )
C
C
C -- READ MODIFIERS IF ANY
C
C -- SET INITIAL VALUES
C
      IFINAL = 0
      IAPPND = 0
      IFILL = 0
      INOSTR = 0
      INOPMT = 0
      INOREM = 0
      INOMSG = 0
C
1000  CONTINUE
C
C -- READ KEYWORD. CHECK AGAINST MODIFIER NAMES ( IF NO MATCH, IT
C    WILL BE CHECKED AGAINST DATA TYPES BELOW )
C
        LMODIF = KCCARG ( CUPPER , IDIRPS , 1 , NMODIF , NEND )
        IF ( LMODIF .LE. 0 ) GO TO 9810
C
        IMODIF = KCCOMP ( CUPPER(NMODIF:NEND) , CMODIF , NMOD , 2 )
        IF ( IMODIF .LE. 0 ) THEN
          GO TO 1020
        ELSE IF ( IMODIF .EQ. 1 ) THEN
          IFINAL = 1
        ELSE IF ( IMODIF .EQ. 2 ) THEN
          IAPPND = 1
        ELSE IF ( IMODIF .EQ. 3 ) THEN
          IFILL = 1
        ELSE IF ( IMODIF .EQ. 4 ) THEN
          INOSTR = 1
        ELSE IF ( IMODIF .EQ. 5 ) THEN
          INOPMT = 1
        ELSE IF ( IMODIF .EQ. 6 ) THEN
          INOREM = 1
        ELSE IF ( IMODIF .EQ. 7 ) THEN
          INOMSG = 1
        ENDIF
C
      GO TO 1000
C
C
1020  CONTINUE
C
C -- CHECK KEYWORD FOUND AGAINST VALUE TYPE NAMES
C
      IVALTP = KCCOMP ( CUPPER(NMODIF:NEND) , CVALTP , NVAL , 2 )
      IF ( IVALTP .LE. 0 ) GO TO 9820
C
C -- CREATE 'ALLOWED VALUES' LIST IF REQUIRED
C
      IF (      ( ( IVALTP .EQ. ITPVKY ) .OR.
     2            ( IVALTP .EQ. ITPABB ) .OR.
     3            ( IVALTP .EQ. ITPYSN ) ) .AND.
     4                        ( NCHKUS .GT. 0 ) ) THEN
        CVAL = '( '
        ICP = 3
        IPMBRK = 0
        DO 1050 I = 1 , NCHKUS
C -- TRIM SPACES
          CVAL(ICP:) = CCHECK(I)
          ICP = ICP + INDEX ( CCHECK(I)//' ' , ' ' )
C -- SET BREAK POINT
          IF ( ICP .LT. LINLEN ) IPMBRK = ICP - 1
1050      CONTINUE
        CVAL(ICP:) = ')'
        ICHECK = 1
      ELSE
C -- NO ALLOWED VALUE LIST
        ICP = 0
        ICHECK = 0
      ENDIF
C
C -- DETERMINE PROMPT STRING
C
      ISTAT = KSCEXP ( IPMTST, IPMTTP, CUPPER, CLOWER, IDIRPS, 1 )
      IF ( ISTAT .LE. 0 ) GO TO 9830
      IF ( IPMTTP .NE. 4 ) GO TO 9830
C
      ISTAT = KSCSDC ( IPMTST , CBUFFR , LENPMT )
C
C----- SAVE THE PROMPT STRING
      MENPMT = LENPMT
      CPRMPT(1:LENPMT) = CBUFFR(1:LENPMT)
C
      IMSG = IPRMSG(IVALTP)
      CBUFFR(LENPMT+1:) = CSCMSG(IMSG)
      LENPMT = LENPMT + LSCMSG(IMSG) + 1
      CBUFFR(LENPMT+1:LENPMT+2) = '[ '
      LENPMT = LENPMT + 2
C
C -- DETERMINE DEFAULT VALUE STRING IF ANY
C
      ISTAT = KSCEXP ( IDEFST, IDEFTP, CUPPER, CLOWER, IDIRPS, 1 )
      IF ( ISTAT .LT. 0 ) THEN
        GO TO 9840
      ELSE IF ( ISTAT .EQ. 0 ) THEN
        LENDEF = 0
      ELSE
C -- STORE DEFAULT VALUE, AND INSERT TEXT IN PROMPT
        IF ( IDEFTP .NE. 4 ) GO TO 9840
        ISTAT = KSCSDC ( IDEFST, CDEFLT , LENDEF )
      ENDIF
      IF ( LENDEF .LE. 0 ) THEN
C -- NO DEFAULT VALUE. INDICATE THIS BY PUTTING '-' IN PROMPT
        CBUFFR(LENPMT+1:LENPMT+1) = '-'
        LENDEF = 1
        IDEFLT = 0
        CDEFLT = ' '
      ELSE
        CBUFFR(LENPMT+1:) = CDEFLT
        IDEFLT = 1
      ENDIF
C
C -- COMPLETE PROMPT STRING
C
      LENTOT = LENPMT + LENDEF
      CBUFFR(LENTOT+1:LENTOT+5) = ' ] : '
      LENTOT = LENTOT + 5
C
C -- SET UP POINT AT WHICH DATA WILL BE STORED
C
      IF ( ( IAPPND .LE. 0 ) .AND. ( INOSTR .LE. 0 ) ) THEN
        ICOMLN = ICOMLN + 1
      ENDIF
C
C
1100  CONTINUE
C
C
C -- IF INPUT IS EXHAUSTED, PROMPT THE USER FOR INPUT WITH THE
C    APPROPRIATE PROMPT STRING. CONVERT INPUT TO UPPERCASE FOR
C    PROCESSING.
C
      IF ( ( IINPPS .GT. IINPLN ) .AND.
     2     ( INOPMT .LE. 0 ) )       THEN
C
C -- OUTPUT ALLOWED VALUE LIST IF ANY
C
        IF ( ICHECK .GT. 0 ) THEN
C---- CHECK FOR VT TERMINAL, AND INSTRUCTION VERIFIED OR ABBREVIATED
          IF( ((ISSTML .NE. 1) .AND. (ISSTML .NE. 2))  .OR.
     1      ((IVALTP .NE. 5) .AND.(IVALTP .NE. 7)) ) THEN
            IF (ISSTML .EQ. 3) THEN
C----       SPECIAL  DOS PROMPT - YELLOW ON CYAN
              CALL VGACOL ('BOL', 'YEL', 'CYA' )
              WRITE(NCAWU,1102) CTOP(1:78)
              IF ( ICP .GT. LINLEN ) THEN
                CMENU = CBOX
                CMENU(2:IPMBRK+1) = CVAL(1:IPMBRK)
                WRITE ( NCAWU , 1102 ) CMENU(1:78)
                CMENU = CBOX
                JCP = MIN (LINLEN+IPMBRK, ICP)
                CMENU(2:JCP-IPMBRK+1) = CVAL(IPMBRK+1:JCP)
                WRITE ( NCAWU , 1102 ) CMENU(1:78)
1102            FORMAT ( 1X , A )
              ELSE
                CMENU = CBOX
                CMENU(2:ICP+1) = CVAL(1:ICP)
                WRITE ( NCAWU , 1102 ) CMENU(1:78)
              ENDIF
              WRITE(NCAWU,1102) CBTM(1:78)
C----       NORMAL DOS PROMPT - RED ON WHITE
              CALL VGACOL ('OFF', 'RED', 'WHI' )
            ELSE
              IF ( ICP .GT. LINLEN ) THEN
                WRITE ( NCAWU , 1102 ) CVAL(1:IPMBRK)
                WRITE ( NCAWU , 1102 ) CVAL(IPMBRK+1:ICP)
              ELSE
                WRITE ( NCAWU , 1102 ) CVAL(1:ICP)
              ENDIF
            ENDIF
          ELSE
C----       MENU MODE
            CALL XMENUR (CPRMPT, MENPMT, CLINPB, LENLIN, CDEFLT,
     1                  LDEFBF, IINPLN)
            GOTO 1200
          ENDIF
        ENDIF
C
C -- PROMPT THE USER
C
        CALL XPRMPT ( NCAWU , CBUFFR(1:LENTOT) )
C
C -- READ THE USER'S RESPONSE FROM THE TERMINAL
C
        ISTAT = KRDLIN ( NCUFU(1) , CLINPB , IINPLN )
        IF ( ISTAT .LE. 0 ) GO TO 1100
C
1200    CONTINUE
        INTERR = 1
C -- MAKE UPPERCASE COPY
        CALL XCCUPC ( CLINPB , CUINPB )
        IINPPS = 1
C
C -- CHECK FOR USER INTERRUPT ( E.G. 'ERROR' , 'QUIT' )
        IF ( IINPLN .GT. 0 ) THEN
          ISTAT = KSCINT ( CUINPB(1:IINPLN) )
          IF ( ISTAT .GE. 0 ) THEN
            KSCVAL = ISTAT
            IINPLN = 0
            RETURN
          ENDIF
        ENDIF
      ENDIF
C
C
C -- CHECK IF NO INPUT WAS GIVEN AND A DEFAULT VALUE IS AVAILABLE
C
      IF ( IINPLN .LE. 0 ) THEN
        IF ( IDEFLT .LE. 0 ) GO TO 9920
        CLINPB = CDEFLT
        CUINPB = CDEFLT
        IINPLN = LENDEF
      ENDIF
C
C                   **** CHECK VALUE ****
C
C -- IDENTIFY TEXT REQUIRED FOR THIS INPUT VALUE, AND CHECK FOR
C    EXTRA DATA
C
C -- MOST DATA ITEMS ARE TERMINATED BY A SPACE
C
      NSTART = KCCNEQ ( CLINPB , IINPPS , ' ' )
      NENDIN = IINPLN
      NDATA = NSTART
C
C -- 'TEXT' HOWEVER CONSISTS OF THE REMAINDER OF THE INPUT LINE
C
      IF ( IVALTP .NE. ITPTXT ) THEN
        LENARG = KCCARG ( CLINPB , NDATA , 3 , NSTART , NEND )
        IF ( IFINAL .GT. 0 ) THEN
          IF ( KCCNEQ ( CLINPB , NDATA , ' ' ) .GT. 0 ) GO TO 9910
        ENDIF
        NENDIN = NEND
      ENDIF
C
C -- REMOVE PROCESSED TEXT FROM THAT REMAINING IN BUFFER
C
      IF ( INOREM .LE. 0 ) THEN
        IINPPS = NENDIN + 2
      ENDIF
C
C
C -- CHECKING OF NUMERIC DATA
C
      LFMTXP = NENDIN-NSTART+1
      IF ( IVALTP .EQ. ITPREA ) THEN
        WRITE (CFMTXP, '(3H( F, I2, 3H.0))') LFMTXP
        READ ( CLINPB(NSTART:NENDIN) , CFMTXP , ERR = 9930 ) VALUE
      ELSE IF ( IVALTP .EQ. ITPINT ) THEN
        WRITE (CFMTXP, '(3H( I,I2,3H  ))') LFMTXP
        READ ( CLINPB(NSTART:NENDIN) , CFMTXP, ERR = 9940 ) IVALUE
      ENDIF
C
C -- CHECKING OF KEYWORD DATA AGAINST AN ALLOWED LIST
C
      IF ( ICHECK .GT. 0 ) THEN
C -- DETERMINE WHETHER CHECK IS FOR EXACT OR ABBREVIATED MATCH
        IEXACT = 2
        IF ( ( IVALTP .EQ. ITPVKY ) .OR. ( IVALTP .EQ. ITPYSN ) ) THEN
          IEXACT = 1
        ENDIF
        IVALUE = KCCOMP ( CUINPB(NSTART:NENDIN), CCHECK,NCHKUS, IEXACT)
        IF ( IVALUE .LE. 0 ) GO TO 9950
C -- IF WE HAVE FOUND AN ABBREVIATED MATCH, CHECK THAT THERE IS NO
C    AMBIGUITY
C
        IF ( IEXACT .EQ. 2 ) THEN
          IF ( IVALUE .LT. NCHKUS ) THEN
            NCHECK = NCHKUS - IVALUE
            ICHECK = KCCOMP ( CUINPB(NSTART:NENDIN),
     2                          CCHECK(IVALUE+1), NCHECK , 2 )
            IF ( ICHECK .GT. 0 ) GOTO 9960
          ENDIF
        ENDIF
      ENDIF
C
C -- STORE AWAY VALUE OF USER'S INPUT FOR POSSIBLE LATER USE. THE TYPE,
C    STARTING POSITION IN THE INPUT STRING, AND LENGTH ARE ALSO STORED.
      CALL XMOVE ( IVALUE , ISCVAL , 1 )
      ISCVLS = NSTART
      ISCVLN = NENDIN
C
      ISCVTP = IRESTP(IVALTP)
C
C -- CHECK FOR A VALIDATING EXPRESSION
C
      IDIRSV = IDIRPS
      ISTAT = KSCEXP ( IVALID, IVLDTP, CUPPER, CLOWER, IDIRPS, 1 )
      IF ( ISTAT .LT. 0 ) THEN
        GO TO 9850
      ELSE IF ( ISTAT .EQ. 0 ) THEN
      ELSE
        IF ( IVLDTP .NE. 3 ) GO TO 9850
        IF ( IVALID .NE. 1 ) THEN
          IDIRPS = IDIRSV
          GO TO 9970
        ENDIF
      ENDIF
C
C
C -- STORE USER'S INPUT IN BUFFER
C
      IF ( INOSTR .LE. 0 ) THEN
        IF ( IFILL .GT. 0 ) THEN
          ISTAT = KCCAPP ( CCOMBF , ICOMLN , CCHECK(IVALUE) )
        ELSE
          ISTAT = KCCAPP ( CCOMBF , ICOMLN , CLINPB(NSTART:NENDIN) )
        ENDIF
        IF ( ISTAT .LE. 0 ) GO TO 9860
      ENDIF
C
C -- STORE AWAY VALUE OF USER'S INPUT FOR POSSIBLE LATER USE. THE TYPE,
C    STARTING POSITION IN THE INPUT STRING, AND LENGTH ARE ALSO STORED.
      CALL XMOVE ( IVALUE , ISCVAL , 1 )
      ISCVLS = NSTART
      ISCVLN = NENDIN
C
9000  CONTINUE
C
C -- A VALUE TYPE WILL BE SET BEFORE EACH RETURN
      ISCVTP = IRESTP(IVALTP)
      KSCVAL = 0
      RETURN
C
C
9800  CONTINUE
C
C -- ERROR IN THE SCRIPT COMMAND.
      GO TO 9000
C
9810  CONTINUE
      CALL XSCMSG ( MMISSG , MKEYWD , ' ' , 0 )
      GO TO 9800
9820  CONTINUE
      CALL XSCMSG ( MILLEG , MKEYWD , CLOWER(NMODIF:NEND) , 0 )
      GO TO 9800
9830  CONTINUE
      CALL XSCMSG ( MILLMS , MPRMPT , ' ' , 0 )
      GO TO 9800
9840  CONTINUE
      CALL XSCMSG ( MILLEG , MDEFLT , ' ' , 0 )
      GO TO 9800
9850  CONTINUE
      CALL XSCMSG ( MILLEG , MVLDEX , ' ' , 0 )
      GO TO 9800
9860  CONTINUE
      CALL XSCMSG ( MOVERF , 37 , ' ' , 0 )
      GO TO 9800
C
C
9900  CONTINUE
C
C -- ERROR IN USER'S INPUT
C    GET USER TO TRY AGAIN, IF ERROR CAN BE HANDLED HERE
      IINPLN = 0
      IF ( INTERR .GT. 0 ) GO TO 1100
C -- IF USER MESSAGES ARE BEING PRODUCED, START ERROR SEARCH
      IF ( INOMSG .LE. 0 ) CALL XERHND ( IERSFL )
      GO TO 9000
C
9910  CONTINUE
      IF ( INOMSG .GT. 0 ) GO TO 9900
      IERROR = 1
      GO TO 9990
C
9920  CONTINUE
      IF ( INOMSG .GT. 0 ) GO TO 9900
      IERROR = 2
C -- FIX POINTERS SO THERE IS NO ATTEMPT TO DISPLAY THE 'INCORRECT USER
C    INPUT'
      NSTART = 1
      NENDIN = 0
      GO TO 9990
C
9930  CONTINUE
      IF ( INOMSG .GT. 0 ) GO TO 9900
      IERROR = 3
      GO TO 9990
C
9940  CONTINUE
      IF ( INOMSG .GT. 0 ) GO TO 9900
      IERROR = 4
      GO TO 9990
C
9950  CONTINUE
      IF ( INOMSG .GT. 0 ) GO TO 9900
      IERROR = 5
      GO TO 9990
9960  CONTINUE
      IF ( INOMSG .GT. 0 ) GO TO 9900
      IERROR = 19
      GO TO 9990
9970  CONTINUE
      IF ( INOMSG .GT. 0 ) GO TO 9900
      IERROR = 20
      GO TO 9990
C
C
9990  CONTINUE
C
C
C -- THIS SECTION OUTPUTS MESSAGES FOLLOWING A 'USER ERROR'. THE MESSAGE
C    TEXT CAN BE CHANGED BY THE 'MESSAGE' COMMAND. THE USER IS ALSO
C    SHOWN THE PART OF THE INPUT THAT WAS INCORRECT
C
      WRITE ( NCAWU , 9995 ) CSCMSG(IERROR)(1:LSCMSG(IERROR))
9995  FORMAT ( / , 1X , A )
C
      IF ( NENDIN .GE. NSTART ) THEN
        WRITE ( NCAWU , 9997 ) '"'//CUINPB(NSTART:NENDIN)//'"'
9997    FORMAT ( 11X , A , / )
      ELSE
        WRITE ( NCAWU , 9998 )
9998    FORMAT ( 1X )
      ENDIF
      GO TO 9900
C
C
      END
CODE FOR KSCVAR
      FUNCTION KSCVAR ( IN )
C
C -- DEFINE NEW VARIABLE
C
C -- THIS ROUTINE IMPLEMENTS THE SCRIPT 'VARIABLE' INSTRUCTION
C
C  'IN' IS A DUMMY ARGUMENT
C
C      RETURN VALUE OF KSCVAR IS THE VALUE TO BE USED FOR 'KSCPRC'
C
C
C
      PARAMETER ( MAXLAB = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
C
      CHARACTER*(MAXLAB) CVARIB
C
      PARAMETER ( LTYP = 12 , NTYP = 4 )
      CHARACTER*(LTYP) CTYPE(NTYP)
C
C
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
      EQUIVALENCE ( IVALUE , VALUE )
C
C
      DATA CTYPE / 'INTEGER' , 'REAL' , 'LOGICAL' , 'CHARACTER' /
C
C -- READ/CHECK KEYWORD
C
C
      LENARG = KCCARG ( CUPPER , IDIRPS , 1 , NTYPE , NEND )
      IF ( LENARG .LE. 0 ) GO TO 9930
C
      ITYPE = KCCOMP ( CUPPER(NTYPE:NEND) , CTYPE , NTYP , 1 )
      IF ( ITYPE .LE. 0 ) GO TO 9930
C
      IVAR = 0
C
1000  CONTINUE
C
C -- READ VARIABLE NAME
C
      LENVAR = KCCARG ( CUPPER , IDIRPS , 1 , NVAR , NEND )
      IF ( LENVAR .LE. 0 ) GO TO 8000
C
      CVARIB = CUPPER(NVAR:NEND)
C
C -- CHECK IF VARIABLE IS ALREADY KNOWN. IT NOT, CREATE IT. IF IT IS,
C    CHECK THAT ITS EXISTING TYPE IS CONSISTENT WITH THE NEW DEFINITION
C
      IADDR = KSCIDN ( 2, 3, CVARIB, 1, IVTYPE, IDENT, IVALUE, -1 )
C
C -- IF VARIABLE IS NOT ALREADY KNOWN, INITIALISE IT
C
      IF ( IADDR .LE. 0 ) THEN
C
        IF ( ITYPE .EQ. 1 ) THEN
C -- 'INTEGER' - ZERO
          IVALUE = 0
        ELSE IF ( ITYPE .EQ. 2 ) THEN
C -- 'REAL' - ZERO
          VALUE = 0.0
        ELSE IF ( ITYPE .EQ. 3 ) THEN
C -- 'LOGICAL' - SET TO 'FALSE'
          IVALUE = 0
        ELSE IF ( ITYPE .EQ. 4 ) THEN
C -- CHARACTER - ALLOCATE AN EMPTY DESCRIPTOR
          ISTAT = KSCSAD ( 0 , IVALUE )
        ENDIF
C
        IADDR = KSCIDN ( 1, 3, CVARIB, 1, ITYPE, IDENT, IVALUE, -1 )
      ELSE
        IF ( IVTYPE .NE. ITYPE ) GO TO 9920
      ENDIF
C
C -- VERIFY OPERATION
C
      IF ( ISCVER .GT. 0 ) THEN
        WRITE ( NCAWU , 1505 ) CTYPE(ITYPE) , IADDR , CVARIB
1505  FORMAT ( 1X, A, ' variable ( number', I3, ' ) assigned :-', A )
      ENDIF
C
      IVAR = IVAR + 1
      GO TO 1000
C
8000  CONTINUE
C
C -- AT LEAST ONE VARIABLE NAME SHOULD HAVE BEEN GIVEN
C
      IF ( IVAR .EQ. 0 ) GO TO 9910
      KSCVAR = 0
      RETURN
C
C
9900  CONTINUE
      KSCVAR = 0
C
      RETURN
9910  CONTINUE
      CALL XSCMSG ( MMISSG , MVARIA , ' ' , 0 )
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MINCON , MVARIA , CVARIB , 0 )
      GO TO 9900
9930  CONTINUE
      CALL XSCMSG ( MILLMS , MKEYWD , ' ' , 0 )
      GO TO 9900
C
      END
CODE FOR XSCFRM
      SUBROUTINE XSCFRM ( ITYPE )
C
C -- CREATE NEW STACK LEVEL
C
C      ITYPE       TYPE OF STACK LEVEL TO CREATE
C
C -- THE 'TYPES' CORRESPOND TO THE VARIOUS STRUCTURE MAKING INSTRUCTIONS
C    'SCRIPT', 'BLOCK', ETC
C
C    IN ADDITION A TYPE OF 0 IS USED WHEN A SCRIPT FILE IS FIRST OPENED
C    SO INDICATE THAT A NEW FILE IS BEING USED.
C
C    THE STACK IS HELD IN AN ARRAY 'ISTACK'. THE STACK LEVEL AT ANY
C    MOMENT IS DETERMINED BY REFERENCE TO THE ARRAY ELEMENT
C    'ILEVEL(IFLIND)'. THIS POINTS TO A SET OF VALUES IN 'ISTACK'. THIS
C    METHOD MEANS THAT A SCRIPT FILE CAN BE CLOSED WITHOUT WORRYING
C    ABOUT STACK POINTERS, AS THE POINTER FOR THE PREVIOUS FILE WILL
C    AUTOMATICALLY COME INTO USE. UP TO 'NSTACK' STACK LEVELS MAY EXIST.
C
C    FOR LEVEL N, ITEM J IN THE STACK IS 'ISTACK(J,N)'. THE ITEMS
C    STORED IN THE STACK ARE REFERRED TO BY NUMERIC CODES. THESE CODES
C    ARE LISTED IN 'KSCPRC'.
C
C
C
C -- THIS ROUTINE BUILDS A NEW STACK FRAME. THE VALUES OF EACH ITEM
C    IN THIS NEW FRAME ARE DERIVED ACCORDING TO THE DESCRIPTION
C    IN 'INOPER'. FOR EACH ITEM, A CODE IN 'INOPER' INDICATES HOW IT
C    IS TO BE GENERATED FOR THE NEW STACK FRAME. THE POSSIBLE CODES
C    ARE :-
C            JCOPY       COPY VALUE IN OUTER STACK FRAME
C            JZERO       SET VALUE TO ZERO
C            JCALC       INVOKE SPECIAL CODE TO CALCULATE THIS
C                        ITEM. ( USED FOR :-
C                              JBTYPE - VALUE = 'ITYPE'
C                              JBSTRT - VALUE = 'IRDREC(IFLIND)'
C                              JSTLVL - VALUE = 'INEWLV'
C
C      THE ARRAY 'ICOPY0' GIVES THE INITIAL VALUES FOR THOSE ELEMENTS
C      WHICH ARE COPIED WHEN THERE IS NO OUTER STACK FRAME.
C
C
C
C
      PARAMETER ( NSTACK = 30 , LSTACK = 12 )
      PARAMETER ( NFILVL = 10 )
      PARAMETER ( JVARIB =  1 , JNVARI =  2 , JNFDAT =  3 )
      PARAMETER ( JNFCHR =  4 , JEXECU =  5 , JBTYPE =  6 )
      PARAMETER ( JBSTRT =  7 , JBLEND =  8 , JNSTAT =  9 )
      PARAMETER ( JREQST = 10 , JWASEX = 11 , JSTLVL = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
C
      PARAMETER ( JCOPY = 1 , JZERO = 2 , JCALC = 3 )
      DIMENSION INOPER(LSTACK)
      DIMENSION ICOPY0(LSTACK)
C
      COMMON /UFILE/ NCUFU(10),IFLCHR(10),IFLMAX,IFLIND,NCLU,
     2 IRDLOG(10), IRDCPY(10), IRDCAT(10), IRDPAG, IRDLIN,
     3 IRDCMS(10), IRDINC(10), IRDSCR(10), IRDSRQ(10),
     4 IRDREC(10), IRDFND(10), IRDHGH(10)
      COMMON /XFLDAT/ KEYFIL(8,35), IFLUNI(35), IFLACC(35), IFLSTA(35),
     2 IFLFRM(35), IFLREA(35), IFLOPN(35), IFLLCK(35) , NFLUSD , NFLMAX
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XSCSTK/ ILEVEL(NFILVL) , ISTACK(LSTACK,NSTACK)
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
C
C                   JVARIB JNVARI JNFDAT JNFCHR JEXECU
C                   JBTYPE JBSTRT JBLEND JNSTAT JREQST
C                   JWASEX JSTLVL
C
      DATA INOPER / JCOPY , JZERO , JCOPY , JCOPY , JCOPY ,
     2              JCALC , JCALC , JZERO , JZERO , JZERO ,
     3              JZERO , JCALC /
C
      DATA ICOPY0 /     0 ,     0 ,     1 ,     1 ,     1 ,
     2                  0 ,     0 ,     0 ,     0 ,     0 ,
     3                  0 ,     0 /
C
C
C
C -- VERIFY OPERATION
C
      IF ( ISCSVE .GT. 0 ) THEN
        WRITE ( NCAWU , 1005 ) ITYPE
1005    FORMAT ( 1X , 'Create stack frame of type : ' , I6 )
      ENDIF
C
C -- INITIALISE STACK POINTERS FOR NEW FILE LEVEL IF REQUIRED
C
      IF ( ITYPE .LE. 0 ) THEN
C
        INEW = MAX0 ( ILEVEL(IFLIND) + 1 , 1 )
        ILEVEL(IFLIND+1) = - INEW
        ISCINI = 0
        RETURN
      ENDIF
C
C -- CHECK CURRENT STACK LEVEL
C -- ENSURE THAT 'SCRIPT' IS THE FIRST BLOCK TYPE IN EACH FILE.
C
      ICURLV = ILEVEL(IFLIND)
C
      IF ( ITYPE .EQ. 1 ) THEN
        IF ( ICURLV .GT. 0 ) GO TO 9910
        ICURLV = -1 - ICURLV
        INEWLV = ICURLV + 1
      ELSE
        IF ( ICURLV .LE. 0 ) GO TO 9910
        INEWLV = ICURLV + 1
      ENDIF
C
C -- CHECK STACK LIMIT
C
      IF ( INEWLV .GT. NSTACK ) GO TO 9920
C
C -- VERIFY OPERATION
C
      IF ( ISCSVE .GT. 0 ) THEN
        WRITE ( NCAWU , 1015 ) ICURLV , INEWLV
1015    FORMAT ( 1X , 'Current level :  ' , I5 , ' New level : ' , I5 )
      ENDIF
C
C -- CREATE NEW STACK BLOCK
C
      DO 2000 I = 1 , LSTACK
C
C -- WORK OUT THE NEW VALUE FOR EACH ITEM IN THE STACK FRAME
C
        IF ( INOPER(I) .EQ. JCOPY ) THEN
          IF ( ICURLV .GT. 0 ) THEN
            NEWVAL = ISTACK(I,ICURLV)
          ELSE
            NEWVAL = ICOPY0(I)
          ENDIF
        ELSE IF ( INOPER(I) .EQ. JZERO ) THEN
          NEWVAL = 0
        ELSE IF ( INOPER(I) .EQ. JCALC ) THEN
          IF ( I .EQ. JBTYPE ) THEN
            NEWVAL = ITYPE
          ELSE IF ( I .EQ. JBSTRT ) THEN
            NEWVAL = IRDREC(IFLIND)
          ELSE IF ( I .EQ. JSTLVL ) THEN
            NEWVAL = INEWLV
          ENDIF
        ELSE
          NEWVAL = 0
        ENDIF
C
        ISTACK(I,INEWLV) = NEWVAL
C
2000  CONTINUE
C
C -- VERIFY OPERATION
C
      IF ( ISCSVE .GT. 0 ) THEN
        WRITE ( NCAWU , 2005 ) ( ISTACK(J,INEWLV) , J = 1 , LSTACK )
2005    FORMAT ( 1X , 'Contents of new stack level' , / ,
     2 2 ( 1X , 10I8 , / ) )
      ENDIF
C
C -- UPDATE CURRENT STACK LEVEL
      ILEVEL(IFLIND) = INEWLV
C
      ISCINI = 1
C
      RETURN
C
C
9900  CONTINUE
      RETURN
C
9910  CONTINUE
      CALL XSCMSG ( MINCOR, MORDER, 'SCRIPT should be first in file',0)
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MOVERF , MSTACK , ' ' , 0 )
      GO TO 9900
C
C
      END
CODE FOR XSCJMP
      SUBROUTINE XSCJMP ( CLABEL )
C
C -- JUMP TO SPECIFIED LABEL
C
C      CLABEL            LABEL TO BE USED FOR SEARCH
C
C
C
      CHARACTER*(*) CLABEL
C
C
      COMMON /UFILE/ NCUFU(10),IFLCHR(10),IFLMAX,IFLIND,NCLU,
     2 IRDLOG(10), IRDCPY(10), IRDCAT(10), IRDPAG, IRDLIN,
     3 IRDCMS(10), IRDINC(10), IRDSCR(10), IRDSRQ(10),
     4 IRDREC(10), IRDFND(10), IRDHGH(10)
      COMMON /XFLDAT/ KEYFIL(8,35), IFLUNI(35), IFLACC(35), IFLSTA(35),
     2 IFLFRM(35), IFLREA(35), IFLOPN(35), IFLLCK(35) , NFLUSD , NFLMAX
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XSCCNT/ ISCXN1 , NCHKUS , ISCXN3 , MAXSYS
C
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
C
C
C -- SET DEFAULT SEARCH START POINT
C    THE SEARCH WILL START FROM THE FURTHEST POINT REACHED IN THE FILE,
C    IF THE LOCATION OF THE LABEL IS NOT KNOWN
C
      ILOCAT = MAX0 ( IRDREC(IFLIND) , IRDHGH(IFLIND) )
C
C -- SEE IF THE VALUE OF THIS LABEL IS KNOWN, IF FAST SEARCH IS ENABLED
C
      IF ( ISCFST .GT. 0 ) THEN
C -- CHECK IF THIS LABEL IS KNOWN
        ISTAT = KSCIDN ( 2 , 1 , CLABEL , 2 ,I , IDENT , IRECRD , -1 )
        IF ( ISTAT .GT. 0 ) THEN
          IF ( IRECRD .GT. 0 ) THEN
            ILOCAT = IRECRD
C -- VERIFY OPERATION
            IF ( ISCVER .GT. 0 ) THEN
              WRITE ( NCAWU , 1005 ) CLABEL , IRECRD
1005          FORMAT ( 1X, 'Fast search for label ' , A , ' at ' , I5 )
            ENDIF
C
          ENDIF
        ENDIF
      ELSE
       ILOCAT = 0
      ENDIF
C
C -- INDICATE LABEL SEARCH IN PROGRESS
C
      ISCSER = 1
      IRDFND(IFLIND) = ILOCAT
      IF ( IRDFND(IFLIND) .LT. IRDREC(IFLIND) ) THEN
C -- SET NEW FILE POSITION
        REWIND NCRU
        IRDHGH(IFLIND) = IRDREC(IFLIND)
        IRDREC(IFLIND) = 0
      ENDIF
C
      RETURN
      END
CODE FOR XSCMSG
      SUBROUTINE XSCMSG ( IERROR , ITYPE , CPARAM , IPARAM )
C
C -- OUTPUT STANDARD MESSAGES
C
C      IERROR      ERROR TYPE
C      ITYPE       DATA TYPE
C      CPARAM      OPTIONAL CHARACTER TEXT
C      IPARAM      OPTIONAL NUMERIC PARAMETER ( IGNORED )
C
C -- THESE MESSAGES ARE USED TO INDICATE SYNTAX ERRORS IN THE SCRIPT
C    SOURCE TEXT, RATHER THAN THE ERRORS OF THE FINAL USER.
C
C
      CHARACTER*(*) CPARAM
C
C
      PARAMETER ( LCOMP = 12, NCOMP = 30 )
      PARAMETER ( LERROR = 22 , NERROR = 17 )
      PARAMETER ( LTYPE = 21 , NTYPE = 36 )
C
      PARAMETER ( MAXQUO = 50 )
C
      CHARACTER*(LCOMP) CCOMP(0:NCOMP)
      CHARACTER*(LTYPE) CTYPE(NTYPE)
      CHARACTER*(LERROR) CERROR(NERROR)
C
      DIMENSION LNTYPE(NTYPE) , LNERR(NERROR)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
      PARAMETER ( LENLIN = 80 )
      PARAMETER ( LENDIR = 240 )
      CHARACTER*(LENDIR) CLOWER , CUPPER
      CHARACTER*(LENLIN) CCOMBF , CLINPB , CUINPB
      COMMON /XSCCHR/ CLOWER , CUPPER , CCOMBF , CLINPB , CUINPB
      COMMON /XSCCH2/ IDIRPS , IDIRLN , ICOMPS , ICOMLN , IINPPS ,
     2 IINPLN
C
      DATA CCOMP / 'SCRIPT      ' ,
     2 '(LABEL)     ', 'ACTIVATE    ', 'COPY        ',
     2 'CLEAR       ', 'INSERT      ', 'SEND        ', 'GET         ',
     3 'VERIFY      ', '(ERROR)     ', '(JUMP)      ', '(BRANCH)    ',
     4 '(DECREMENT) ', 'FINISH      ', 'END         ', 'QUEUE       ',
     5 'ON          ', 'STORE       ', 'VARIABLE    ', 'SET         ',
     6 'EXTERNAL    ', 'ELSE        ', '(SELECT)    ', 'EXECUTE     ',
     7 'SHOW        ', 'EVALUATE    ', 'MESSAGE     ', 'INDEX       ',
     8 'EXTRACT     ', 'IDENTIFY    ', 'TRANSFER    ' /
C
      DATA CTYPE / 'command' , 'constant' , 'variable' , 'data' ,
     2 'expression' , '"="' , 'allowed value' , 'label' , 'structure' ,
     3 'initialised' , 'operator' , 'argument type(s)' ,
     4 'contingency action' , 'contingency type' , 'argument' ,
     5 'output list' , 'operator stack' , 'number of brackets' ,
     6 'token in expression' , 'keyword' , 'identifier' ,
     7 'identifier list' , 'identifier number' , 'indexing expression',
     8 'parameter' , 'opening file' , 'file channels' , 'stack' ,
     9 'prompt string' , 'message' , 'length' , 'stack level' ,
     * 'stack item code' , 'operation order' , 'default value' ,
     1 'validating expression' /
C
      DATA LNTYPE / 7 , 8 , 8 , 4 ,
     2 10 , 3 , 13 , 5 , 9 ,
     3 11 , 8 , 16 ,
     4 18 , 16 , 8 ,
     5 11 , 14 , 18 ,
     6 19 , 7 , 10 ,
     7 15 , 17 , 19 ,
     8 9 , 12 , 13 , 5 ,
     9 13 , 7 , 6 , 11 ,
     * 15 , 15 , 13 ,
     1 21 /
C
      DATA CERROR / 'Illegal' , 'Illegal or missing' , 'Wrong type of',
     2 'Missing' , 'Incorrect type of' , 'Too many' , 'Not found' ,
     3 'Unexpected' , 'Incorrectly' , 'Insufficent data for' ,
     4 'Mixed or inappropriate', 'Overflow of', 'Inconsistent use of',
     5 'Unknown' , 'Out of range' , 'Error in' ,'** INTERNAL ERROR in' /
C
      DATA LNERR / 7 , 18 , 13 ,
     2 7 , 17 , 8 , 9 ,
     3 10 , 11 , 20 ,
     4 22 , 11 , 19 ,
     5 7 , 12 , 8 , 20 /
C
      IF ( ISCMSG .LE. 0 ) RETURN
C
C
C
C -- CHECK SUPPLIED ARGUMENTS
C
      IF ( IERROR .LE. 0 ) GO TO 9910
      IF ( IERROR .GT. NERROR ) GO TO 9910
      IF ( ITYPE .LE. 0 ) GO TO 9910
      IF ( ITYPE .GT. NTYPE ) GO TO 9910
C
C
      IF ( ISCCOM .LE. 0 ) ISCCOM = 0
C
C -- OUTPUT BASIC MESSAGE
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1005 ) CCOMP(ISCCOM),
     2                      CERROR(IERROR)(1:LNERR(IERROR)) ,
     3                      CTYPE(ITYPE)(1:LNTYPE(ITYPE))
      ENDIF
      WRITE ( NCAWU , 1005 ) CCOMP(ISCCOM),
     2                      CERROR(IERROR)(1:LNERR(IERROR)) ,
     3                      CTYPE(ITYPE)(1:LNTYPE(ITYPE))
1005  FORMAT ( / 1X , 'CRYSTALS SCRIPT error - Failing component is ' ,
     2 A , / ,
     3 1X , A , 2X , A )
C
C -- OUTPUT A STRING VALUE, IF ONE WAS SUPPLIED
C
      IF ( ( LEN ( CPARAM ) .LE. MAXQUO ) .AND.
     2     ( CPARAM .NE. ' ' ) ) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE ( NCWU , 1035 ) CPARAM
      ENDIF
        WRITE ( NCAWU , 1035 ) CPARAM
1035    FORMAT ( 11X , '"' , A , '"' , / )
      ELSE
      IF (ISSPRT .EQ. 0) THEN
        WRITE ( NCWU , 1045 ) CPARAM
      ENDIF
        WRITE ( NCAWU , 1045 ) CPARAM
1045    FORMAT ( 1X , A , / )
      ENDIF
C
C -- OUTPUT THE CURRENT DIRECTIVE, WITH A POINTER TO THE CURRENT
C    CURSOR POSITION WHICH SHOULD INDICATE THE POSITION OF THE ERROR
C
      IPOS = IDIRPS - 1
      IF ( IPOS .LE. 0 ) IPOS = IDIRLN
      IF ( ( IPOS .GT. 0 ) .AND. ( IDIRLN .GT. 0 ) ) THEN
        IMIN = MAX0 ( 1 , IPOS - 35 )
        IMAX = MIN0 ( IPOS + 35 , LENDIR )
      IF (ISSPRT .EQ. 0) THEN
        WRITE ( NCWU , 1055 ) CLOWER(IMIN:IPOS),
     2 CLOWER(IPOS+1:IMAX)
      ENDIF
        WRITE ( NCAWU , 1055 ) CLOWER(IMIN:IPOS),
     2 CLOWER(IPOS+1:IMAX)
1055  FORMAT ( 1X , A , '<', A,  / )
      ENDIF
C
      RETURN
C
C
9900  CONTINUE
      RETURN
9910  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 ) IERROR , ITYPE
      ENDIF
      WRITE ( NCAWU , 9915 ) IERROR , ITYPE
9915  FORMAT ( // , 1X , '*****' , / ,
     2 1X , 'An illegal call to XSCMSG has been made' , / ,
     3 1X , 'The supplied code values were : ' , 2I16 , // )
      GO TO 9900
      END
CODE FOR XSCRST
      SUBROUTINE XSCRST
C
C -- REDUCE STACK LEVEL BY ONE
C
C
      PARAMETER ( NSTACK = 30 , LSTACK = 12 )
      PARAMETER ( NFILVL = 10 )
      PARAMETER ( JVARIB =  1 , JNVARI =  2 , JNFDAT =  3 )
      PARAMETER ( JNFCHR =  4 , JEXECU =  5 , JBTYPE =  6 )
      PARAMETER ( JBSTRT =  7 , JBLEND =  8 , JNSTAT =  9 )
      PARAMETER ( JREQST = 10 , JWASEX = 11 , JSTLVL = 12 )
C
C
C
      COMMON /XSCGBL/ ISCMSG , ISCFST , ISCCOM , ISCSER , ISCVAL ,
     2 ISCVTP , ISCVLS , ISCVLN , ISCINI , ISCEVE , ISCVER , ISCSVE ,
     3 ISCIVE , ISCDSB
      COMMON /XSCSTK/ ILEVEL(NFILVL) , ISTACK(LSTACK,NSTACK)
      COMMON /UFILE/ NCUFU(10),IFLCHR(10),IFLMAX,IFLIND,NCLU,
     2 IRDLOG(10), IRDCPY(10), IRDCAT(10), IRDPAG, IRDLIN,
     3 IRDCMS(10), IRDINC(10), IRDSCR(10), IRDSRQ(10),
     4 IRDREC(10), IRDFND(10), IRDHGH(10)
      COMMON /XFLDAT/ KEYFIL(8,35), IFLUNI(35), IFLACC(35), IFLSTA(35),
     2 IFLFRM(35), IFLREA(35), IFLOPN(35), IFLLCK(35) , NFLUSD , NFLMAX
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
C
C
C -- VERIFY OPERATION
C
      IF ( ISCSVE .GT. 0 ) THEN
        LEVEL = ILEVEL(IFLIND)
        WRITE ( NCAWU , 1005 ) LEVEL , ISTACK(JBTYPE,LEVEL)
1005    FORMAT ( 1X , 'Delete current stack level ' , I5 ,
     2 ' of type : ' , I5 )
      ENDIF
C
C -- UPDATE CURRENT STACK LEVEL
C
      ILEVEL(IFLIND) = ILEVEL(IFLIND) - 1
C
      RETURN
C
C
      END
CODE FOR XSCSNM
      SUBROUTINE XSCSNM ( ITYPE , IADDR , CNAME )
C
C -- FORM STANDARD STRUCTURE NAME.
C
C -- THIS ROUTINE FORMS A UNIQUE STRUCTURE NAME BY WHICH THE STRUCTURE
C    BE IDENTIFIED LATER. THIS IS BASED ON THE TYPE AND THE ADDRESS OF
C    THE STRUCTURE
C
C -- THE NAME HAS THE FORM 'TYPENNN' WHERE 'TYPE' REPRESENTS THE TYPE,
C    E.G. 'SCRIPT' OR 'CASE', AND 'NNN' IS A CHARACTER REPRESENTATION
C    OF THE ADDRESS.
C
C
C      INPUT PARAMETERS :-
C            ITYPE       TYPE OF STRUCTURE ( IN RANGE 1 - 5 )
C            IADDR       ADDRESS
C
C      OUTPUT PARAMETER :-
C            CNAME       PASSED LENGTH CHARACTER VARIABLE IN WHICH THE
C                        GENERATED NAME IS STORED
C
C
C      LOCAL VARIABLES
C            CADDR       CHARACTER VARIABLE USED TO STORE CHARACTER FORM
C                        OF IADDR
C            CSTRUC      CHARACTER ARRAY HOLDING STRUCTURE NAMES
C
C
      CHARACTER*(*) CNAME
C
C
      PARAMETER ( MAXLAB = 12 )
C
      PARAMETER ( NSTRUC = 5 )
      CHARACTER*(MAXLAB) CADDR
C
      CHARACTER*(MAXLAB) CSTRUC(NSTRUC)
C
C
      DATA CSTRUC / 'SCRIPT' , 'BLOCK' , 'LOOP' , 'IF' , 'CASE' /
C
C
C
C
C -- GET TYPE PART OF NAME AND TRIM SPACES
C
      CNAME = CSTRUC(ITYPE)
      ISTAT = KCCTRM ( 1 , CNAME , ISTART , IEND )
C
C -- GET ADDRESS PART OF NAME AND TRIM SPACES
C
      WRITE ( CADDR , '(I12)' ) IADDR
      ISTAT = KCCTRM ( 1 , CADDR , ISTBEG , ISTEND )
C
C -- ADD SECOND PART OF NAME TO FIRST
C
      CNAME(IEND+1:) = CADDR(ISTBEG:ISTEND)
C
      RETURN
      END
CODE FOR XSCSTU
      SUBROUTINE XSCSTU ( ITEM , IVALUE )
C
C -- UPDATE INFORMATION IN CURRENT STACK FRAME
C
C      INPUT PARAMETERS :-
C
C            ITEM        CODE INDICATING STACK ITEM TO BE UPDATED
C            IVALUE      NEW VALUE
C
C
      PARAMETER ( NSTACK = 30 , LSTACK = 12 )
      PARAMETER ( NFILVL = 10 )
      PARAMETER ( JVARIB =  1 , JNVARI =  2 , JNFDAT =  3 )
      PARAMETER ( JNFCHR =  4 , JEXECU =  5 , JBTYPE =  6 )
      PARAMETER ( JBSTRT =  7 , JBLEND =  8 , JNSTAT =  9 )
      PARAMETER ( JREQST = 10 , JWASEX = 11 , JSTLVL = 12 )
      PARAMETER ( MILLEG =  1, MILLMS =  2, MWRONG =  3, MMISSG =  4 )
      PARAMETER ( MINCOR =  5, MTOOMY =  6, MNOTFD =  7, MUNEXP =  8 )
      PARAMETER ( MINCLY =  9, NINSUF = 10, MMIXED = 11, MOVERF = 12 )
      PARAMETER ( MINCON = 13, MUNKNW = 14, MOUTRG = 15, MERROR = 16 )
      PARAMETER ( MINTRN = 17 )
C
      PARAMETER ( MCOMND =  1, MCONST =  2, MVARIA =  3, MDATA  =  4 )
      PARAMETER ( MEXPRE =  5, MEQUAL =  6, MAVKEY =  7, MLABEL =  8 )
      PARAMETER ( MSTRUC =  9, MINITD = 10, MOPERA = 11, MARGTP = 12 )
      PARAMETER ( MCONTI = 13, MCONTT = 14, MARGUM = 15, MOUTLS = 16 )
      PARAMETER ( MOPRST = 17, MBRACK = 18, MTOKEN = 19, MKEYWD = 20 )
      PARAMETER ( MIDENT = 21, MIDNLS = 22, MIDNNM = 23, MINDEX = 24 )
      PARAMETER ( MPARAM = 25, MOPENF = 26, MCHANL = 27, MSTACK = 28 )
      PARAMETER ( MPRMPT = 29, MMESSG = 30, MLENGT = 31, MSTKLV = 32 )
      PARAMETER ( MSTKIT = 33, MORDER = 34, MDEFLT = 35, MVLDEX = 36 )
C
C
      COMMON /UFILE/ NCUFU(10),IFLCHR(10),IFLMAX,IFLIND,NCLU,
     2 IRDLOG(10), IRDCPY(10), IRDCAT(10), IRDPAG, IRDLIN,
     3 IRDCMS(10), IRDINC(10), IRDSCR(10), IRDSRQ(10),
     4 IRDREC(10), IRDFND(10), IRDHGH(10)
      COMMON /XFLDAT/ KEYFIL(8,35), IFLUNI(35), IFLACC(35), IFLSTA(35),
     2 IFLFRM(35), IFLREA(35), IFLOPN(35), IFLLCK(35) , NFLUSD , NFLMAX
C
      COMMON /XSCSTK/ ILEVEL(NFILVL) , ISTACK(LSTACK,NSTACK)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
C
C -- CHECK REQUEST
C
      IF ( ITEM .LE. 0 ) GO TO 9910
      IF ( ITEM .GT. LSTACK ) GO TO 9910
C
C -- CHECK STACK LEVEL
C
      LEVEL = ILEVEL(IFLIND)
      IF ( LEVEL .LE. 0 ) GO TO 9920
C
C -- SET NEW VALUE
C
      ISTACK(ITEM,LEVEL) = IVALUE
      RETURN
C
C
9900  CONTINUE
      RETURN
9910  CONTINUE
      CALL XSCMSG ( MILLEG , MSTKIT , ' ' , 0 )
      GO TO 9900
9920  CONTINUE
      CALL XSCMSG ( MILLEG , MSTKLV , ' ' , 0 )
      GO TO 9900
C
C
      END
CRYSTALS CODE FOR SETTING
CODE FOR WSTUP
      SUBROUTINE WSTUP ( IBLOCK , IDIM0 )
C
C----- SET UP THE ORIENTATION MATRIX APPROPRIATE FOR THE DIFFRACTOMETER
C      IN USE
C
      DIMENSION IBLOCK(IDIM0),DIRCOS(3)
C
      DIMENSION ISTORE(131072)
      DIMENSION ICOM13(36)
C
      COMMON /XABSW/A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,VV,W,X,Y,
     2 Z,DD(4)
      COMMON /CAD/FCV(3),PD(3,3),QD(3,3),RD(3,3),SD(3,3),SI,CO,FKAP(3),
     2 FBIS(3),FPSI,FEUL(3),FHKL(3),CD(3,3),FLAM(3),DET,CON1,CON2,CON3
      COMMON /XABSWK/IMODE,WAV,WAVSQ,IDIF,IDAT,IFF,IG,ALPHA,IR1,IR2,
     2 IR3,IR4,ISET,NPI,NPV,VK(3),UM(3,3),UB(3,3),V(3,2),FACT(10),
     3 BFACT(10),CFACT(10),THL,ISPC
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM13(1),L13CD)
C
      EQUIVALENCE (FCV(1),FC1),(FCV(2),FC2),(FCV(3),FC3),(FBIS(1),
     2 FTHETA),(FBIS(2),FPHIB),(FBIS(3),FCHIB),(FEUL(1),FPHIE),(FEUL(2)
     3 ,FOME),(FEUL(3),FCHIE),(FKAP(1),FPHIK),(FKAP(2),FOMK),(FKAP(3),
     4 FKAPPA),(FHKL(1),FH),(FHKL(2),FK),(FHKL(3),FL)
C
C
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 13
      IDIM13=36
C ---- COPY THE LOAD DETAILS TO THE CORRECT COMMON BLOCK
      CALL XMOVE ( IBLOCK , ICOM13 , IDIM13 )
C----- LOAD LIST 1
      CALL XFAL01
      HLFPI=0.5*PI
C-- ORIETATION MATRIX IS STORED BY ROWS, SO MUST TRANSPOSE
      CALL MTRANS(STORE(L1O2))
      WAV=STORE(L13DC)
      WAVSQ=WAV*WAV
C--CONSTANTS FOR Y290
      THL=DTR*STORE(L13DC+6)
C--- CONSTANTS FOR CAD4
      CON1=STORE(L13DC+3)
      CON2=STORE(L13DC+4)
      CON3=STORE(L13DC+5)
      FLAM(1)=WAV
C----- DETERMINE DIFFRACTOMETER TYPE
      IDIF=ISTORE(L13DT)-5
C--DETERMINE SETTING TYPE
C----- SET DEFAULT TO 'MATRIX'
      IDAT=5
      DO 1450 I=4,8
        CALL XDIRFL(I,ICOM13,IDIM13)
C--CHECK IF THE FIRST PARAMETER FOR THIS DIRECTIVE HAS BEEN INPUT
        IF ( ISTORE(LR62D+10) .GT. 0 ) IDAT = I - 3
1450  CONTINUE
      ISTORE(L13DT+2) = IDAT
C
      IF(IDIF .LE. 0) RETURN
      GOTO(1100,3300,3300,1100,1000),IDIF
1000  CONTINUE
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
C
C
C----- CAD 4
1100  CONTINUE
C-----   MOST OF THE CODE DEALING WITH CAD4 IS TAKEN FROM
C-----   THE NONIUS DIFFRACTOMETER PROGRAMME.
C
C
      IDOT=0
      IHKLFL=0
C----- ORTHOGONALISATION MATRIX
      CALL XMOVE(STORE(L1O2),CD(1,1),9)
      K=1
      GOTO(1400,3200,2700,2900,1300,1200),IDAT
1200  CONTINUE
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
1300  CONTINUE
C----- MATRIX READ IN BY ROWS
      GO TO 3900
1400  CONTINUE
C----- 2 REFLECTIONS
      KK=L132R
1500  CONTINUE
      FH=STORE(KK)
      FK=STORE(KK+1)
      FL=STORE(KK+2)
      JK=KK+3
C---- CONVERT TO EULERIAN
      CALL WAIN(IDIF,JK,JK)
      KK=KK+9
1600  CONTINUE
      M=3
1700  CONTINUE
C-----   LOOPS 2 TIMES TO GET:
C-----   E TO B
C-----   B TO C
      CALL HFROM(M)
      M=M-1
      IF(M.GE.2)GOTO 1700
      CALL XMLTMM (CD, FHKL, PD(1,K), 3 , 3, 1)
1900  CALL VPROD(PD(1,K),PD(1,K),SI)
      CALL VPROD(FCV,FCV,CO)
      SI=SQRT(SI)
      CO=SQRT(CO)
      M=1
2000  PD(M,K)=PD(M,K)/SI
      QD(M,K)=FCV(M)/CO
      M=M+1
      IF(M.LE.3)GOTO 2000
      K=K+1
      IF(K.LE.2)GOTO 1500
      GOTO 2200
2100  QD(1,1)=-QD(1,1)
      QD(2,1)=-QD(2,1)
      QD(3,1)=-QD(3,1)
2200  CONTINUE
      CALL ANGV2(PD(1,1),PD(1,2),ANGP)
      CALL ANGV2(QD(1,1),QD(1,2),ANGQ)
      CO=ANGQ-ANGP
      IF(((HLFPI-ANGP)*(HLFPI-ANGQ)) .LT. 0.0) GOTO 2100
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3100)CO
      ENDIF
      SI=1.0/SIN(ANGQ)
      CO=SIN(CO)*SI
      SI=SI*SIN(ANGP)
      M=1
2300  QD(M,2)=SI*QD(M,2)+CO*QD(M,1)
      M=M+1
      IF(M.LE.3)GOTO 2300
      CALL VMULT(PD(1,1),PD(1,2),PD(1,3))
      CALL VMULT(QD(1,1),QD(1,2),QD(1,3))
      CALL MATINV(PD,SD,SI)
      M=1
2400  CALL XMLTMM(QD,SD(1,M),PD(1,M),3,3,1)
      M=M+1
      IF(M.LE.3)GOTO 2400
      M=1
2500  CALL XMLTMM(PD,CD(1,M),RD(1,M),3,3,1)
      M=M+1
      IF(M.LE.3)GOTO 2500
      CALL MATINV(RD,CD,DET)
      CALL WRMAT
      CALL XMOVE(RD(1,1),UB(1,1),9)
      GOTO 4000
2700  CONTINUE
C----0 REAL AXIS
      FCV(1) = CD(1,3)
      FCV(2)=CD(2,3)
      FCV(3)=CD(3,3)
      KK=L13RL
      PD(1,1)=STORE(KK)
      PD(2,1)=STORE(KK+1)
      PD(3,1)=STORE(KK+2)
      KK=KK+3
      GOTO 1900
2900  CONTINUE
C----- RECIPROCAL AXIS
      KK=L13RC
      FH=STORE(KK)
      FK=STORE(KK+1)
      FL=STORE(KK+2)
      KK=KK+3
      FCV(1) = 0.
      FCV(2)=0.0
      FCV(3)=1.0
      GOTO 1600
3100  FORMAT(/' Initial azimuth =',F7.2)
3200  CONTINUE
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
3300  CONTINUE
C
C
C
C
C----- Y290 H&W
C----- ALL ANGLES IN BASE SYSTEM
      GOTO(3500,3800,3400,3400,3900,3400),IDAT
3400  CONTINUE
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
3500  CONTINUE
C----- 2 REFLECTIONS
      K=L132R
      ISET=K
C----- CONVERT TO RADIANS
      CALL WAIN(2,K+3,K+3)
      CALL WAIN(2,K+12,K+12)
      DO 3600 J=1,2
      STH=STHETA(STORE(K))
      CTH=SQRT(1.-STH*STH)
C----- COMPONENTS OF SCATTERING VECTOR IN EQUATORIAL PLANE
      VK(1)=CTH
      VK(2)=STH
      VK(3)=0
C----- OMEGA ROTATION
      A=-STORE(K+4)*RTD
      CALL XZEROF(DIRCOS(1),3)
      DIRCOS(3) = 1.
      IF (NROT(DIRCOS,A,STORE(IR1)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
C----- CHI
      A=-STORE(K+5)*RTD
      CALL XZEROF(DIRCOS(1),3)
      DIRCOS(2) = 1.
      IF (NROT(DIRCOS,A,STORE(IR2)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
C----- PHI
      A=-STORE(K+6)*RTD
      CALL XZEROF(DIRCOS(1),3)
      DIRCOS(3) = 1.
      IF (NROT(DIRCOS,A,STORE(IR3)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
C----- TOTAL ROTATION
C     [R] = [P].[X].[W]
      CALL XMLTMM(STORE(IR2),STORE(IR1),STORE(IR4),3,3,3)
      CALL XMLTMM(STORE(IR3),STORE(IR4),STORE(IR1),3,3,3)
C----- FIND SCATTERING VECTOR WHEN CIRCLES RETURNED TO ZERO
      CALL XMLTMM(STORE(IR1),VK(1),V(1,J),3,3,1)
      K=K+9
3600  CONTINUE
C----- SET UP COORDINATE SYSTEM SUCH THAT X IS PARALLEL TO V[I,1]
C                        Y IS PERPENDICULAR TO V[I,1] & V[I,2]
      CALL WMET(STORE(IR1),V)
C----- ORTHOGONALISE INDICES & SET UT COORDINATE SYSTEM [H]
      CALL XMLTMM(STORE(L1O2),STORE(ISET),V(1,1),3,3,1)
      CALL XMLTMM(STORE(L1O2),STORE(ISET+9),V(1,2),3,3,1)
      CALL WMET(STORE(IR2),V)
      IF (NORM3(STORE(IR2)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
      IF (NORM3(STORE(IR2+3)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
      IF (NORM3(STORE(IR2+6)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
      IF (NORM3(STORE(IR1)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
      IF (NORM3(STORE(IR1+3)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
      IF (NORM3(STORE(IR1+6)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
C----- [H] IS AN ORTHOGONAL ROTATION METRIX SO [H]T=[H]-1
      CALL XTRANS(STORE(IR2),STORE(IR3),3,3)
      CALL XMLTMM(STORE(IR1),STORE(IR3),UM,3,3,3)
      CALL XMLTMM(UM,STORE(L1O2),UB,3,3,3)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3710)UM(1,1),UM(1,2),UM(1,3),UM(2,1),
     1 UM(2,2),UM(2,3),UM(3,1),UM(3,2),UM(3,3)
      ENDIF
3710  FORMAT(16H Rotation matrix   ,
     1 /(/,20X,3F10.4))
      GOTO 4000
3800  CONTINUE
C----- 3 REFLECTIONS
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
3900  CONTINUE
C----- ORIENTATION MATRIX
C----- MATRIX READ IN BY ROWS,BUT STORED,BY COLUMNS
      CALL XTRANS(STORE(L13OM),UB(1,1),3,3)
4000  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4100)UB(1,1),UB(1,2),UB(1,3),UB(2,1),UB(2,2),
     1 UB(2,3),UB(3,1),UB(3,2),UB(3,3)
      ENDIF
4100  FORMAT(//19H Orientation matrix   ,
     1 /(/,20X,3F10.4))
      CALL XMOVE(UB(1,1),STORE(L13OM),9)
C----- AND NOW COPY THE LIST 13 DETAILS BACK FOR LOADING TO DISC
      CALL XMOVE ( ICOM13, IBLOCK, IDIM13 )
      RETURN
      END
CODE FOR WRMAT
      SUBROUTINE WRMAT
C
C
      COMMON /CAD/FCV(3),PD(3,3),QD(3,3),RD(3,3),SD(3,3),SI,CO,FKAP(3),
     2 FBIS(3),FPSI,FEUL(3),FHKL(3),CD(3,3),FLAM(3),DET,CON1,CON2,CON3
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C----- TAKEN FROM NONIUS
C----- CD IS ORIENTATION MATRIX = L1O2
C
C
      CALL MTRANS(CD)
      N=1
1100  K=N
1200  CALL VPROD(CD(1,N),CD(1,K),SD(N,K))
      K=K+1
      IF(K.LE.3)GOTO 1200
      N=N+1
      IF(N.LE.3)GOTO 1100
      N=1
1300  CONTINUE
      N=N+1
      IF(N.LE.3)GOTO 1300
      IF(DET.EQ.0.0)GOTO 1400
      SD(1,1)=SQRT(SD(1,1))
      SD(2,2)=SQRT(SD(2,2))
      SD(3,3)=SQRT(SD(3,3))
      CALL ANGV2(CD(1,2),CD(1,3),SD(2,1))
      CALL ANGV2(CD(1,1),CD(1,3),SD(3,1))
      CALL ANGV2(CD(1,1),CD(1,2),SD(3,2))
      SI=1.0/DET
      CALL MTRANS(CD)
      RETURN
1400  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,1500)
      ENDIF
1500  FORMAT(' Singular')
      RETURN
      END
CODE FOR HFROM
      SUBROUTINE HFROM(NR)
C     1=CTOH,2=BTOC,3=ETOB,4=KTOE,5=MTOK
C
C
      COMMON /CAD/FCV(3),PD(3,3),QD(3,3),RD(3,3),SD(3,3),SI,CO,FKAP(3),
     2 FBIS(3),FPSI,FEUL(3),FHKL(3),CD(3,3),FLAM(3),DET,CON1,CON2,CON3
C
C
C
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (FCV(1),FC1),(FCV(2),FC2),(FCV(3),FC3),(FBIS(1),
     2 FTHETA),(FBIS(2),FPHIB),(FBIS(3),FCHIB),(FEUL(1),FPHIE),(FEUL(2)
     3 ,FOME),(FEUL(3),FCHIE),(FKAP(1),FPHIK),(FKAP(2),FOMK),(FKAP(3),
     4 FKAPPA),(FHKL(1),FH),(FHKL(2),FK),(FHKL(3),FL)
C
C
      DATA PI/3.14159263694/
      MIXUP=0
      GOTO(1000,1300,1400,1800,1900),NR
1000  IF(DET.EQ.0.0)GOTO 1100
      CALL XMLTMM(CD,FCV,FHKL,3,3,1)
      RETURN
1100  N=1
1200  FHKL(N)=0.0
      N=N+1
      IF(N.LE.3)GOTO 1200
      MIXUP=1
      RETURN
1300  FC1=-(SIN(FPHIB)*COS(FCHIB)*2.0*SIN(FTHETA))/FLAM(1)
      FC2=(COS(FPHIB)*COS(FCHIB)*2.0*SIN(FTHETA))/FLAM(1)
      FC3=(SIN(FCHIB)*2.0*SIN(FTHETA))/FLAM(1)
      RETURN
1400  IF(FTHETA.GT.0.0)GOTO 1500
      FTHETA=-FTHETA
      FOME=FOME+PI+2.0*FTHETA
      FOME=BETW(FOME,PI)
1500  T1=COS(FOME-FTHETA)
      T2=SIN(FOME-FTHETA)
      SI=T1*(SIN(FCHIE))
      CO=SQRT((COS(FCHIE))**2+((SIN(FCHIE))*T2)**2)
      FCHIB=ATAN2(SI,CO)
      IF(CO.NE.0.0)GOTO 1600
      FPHIB=0.0
      SI=-SIN(FCHIE)*SIN(FPHIE)
      CO=COS(FPHIE)*T1
      GOTO 1700
1600  SI=-T2
      CO=T1*COS(FCHIE)
      FPHIB=FPHIE-ATAN2(SI,CO)
      FPHIB=BETW(FPHIB,PI)
      SI=T2*SIN(FCHIE)
      CO=COS(FCHIE)
1700  FPSI=ATAN2(SI,CO)
      RETURN
1800  FKAPPA=BETW(FKAPPA,PI)
      SI=CON2*SIN(0.5*FKAPPA)
      CO=COS(0.5*FKAPPA)
      SI=ATAN2(SI,CO)
      FOME=FOMK+SI
      FPHIE=FPHIK+SI
      FOME=BETW(FOME,PI)
      FPHIE=BETW(FPHIE,PI)
      SI=SQRT(CON1)*SIN(0.5*FKAPPA)
      CO=SQRT(ABS(1.0-SI*SI))
      FCHIE=2.0*ATAN2(SI,CO)
      RETURN
1900  CONTINUE
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      END
CODE FOR ORTH
      SUBROUTINE ORTH(A,B,MIXUP)
C
C
      DIMENSION A(3),B(3)
      MIXUP=1
      CALL VPROD(A,A,TEMP1)
1000  CALL VPROD(B,B,TEMP2)
      IF(TEMP1.GT.TEMP2)GOTO 1200
      IF(TEMP2.GT.(TEMP1*625.0))GOTO 1400
      CALL VPROD(A,B,TEMP2)
      TEMP2=-TEMP2/TEMP1
      TEMP2=FLOAT(INT(TEMP2+SIGN(0.5,TEMP2)))
      IF(TEMP2.EQ.0.0)RETURN
      N=1
1100  B(N)=B(N)+A(N)*TEMP2
      N=N+1
      IF(N.LE.3)GOTO 1100
      MIXUP=0
      GOTO 1000
1200  TEMP1=TEMP2
      N=1
1300  TEMP2=A(N)
      A(N)=B(N)
      B(N)=TEMP2
      N=N+1
      IF(N.LE.3)GOTO 1300
      MIXUP=0
      GOTO 1000
1400  MIXUP=-1
      A(1)=0.0
      A(2)=0.0
      A(3)=0.0
      RETURN
      END
CODE FOR ANGV2
      SUBROUTINE ANGV2(A,B,C)
C
C
      DIMENSION A(3),B(3),T(3)
C
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      CO=A(1)*B(1)+A(2)*B(2)+A(3)*B(3)
      CALL VMULT(A,B,T)
      T(1)=T(1)*T(1)+T(2)*T(2)+T(3)*T(3)
      SI=SQRT(T(1))
      C=ATAN2(SI,CO)
      RETURN
      END
CODE FOR BETW
      FUNCTION BETW(A,R)
      BETW=A-2.0*R*FLOAT(INT((SIGN(R,A)+A)/(2.0*R)))
      RETURN
      END
CODE FOR HTOW
      SUBROUTINE HTOW(NR)
C     1=HTOC,2=CTOB,3=BTOE,4=ETOK,5=KTOW
C
C
      COMMON /CAD/FCV(3),PD(3,3),QD(3,3),RD(3,3),SD(3,3),SI,CO,FKAP(3),
     2 FBIS(3),FPSI,FEUL(3),FHKL(3),CD(3,3),FLAM(3),DET,CON1,CON2,CON3
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
C
C
C
      EQUIVALENCE (FCV(1),FC1),(FCV(2),FC2),(FCV(3),FC3),(FBIS(1),
     2 FTHETA),(FBIS(2),FPHIB),(FBIS(3),FCHIB),(FEUL(1),FPHIE),(FEUL(2)
     3 ,FOME),(FEUL(3),FCHIE),(FKAP(1),FPHIK),(FKAP(2),FOMK),(FKAP(3),
     4 FKAPPA),(FHKL(1),FH),(FHKL(2),FK),(FHKL(3),FL)
C
C
      MIXUP=0
      GOTO(1000,1100,1300,1800,2100),NR
1000  CALL XMLTMM(RD,FHKL,FCV,3,3,1)
      RETURN
1100  FPHIB=ATAN2(-FC1,FC2)
      CO=SQRT(FC1*FC1+FC2*FC2)
      FCHIB=ATAN2(FC3,CO)
      SI=SQRT(CO*CO+FC3*FC3)*FLAM(1)/2.0
      IF(SI.GE.1.0)GOTO 1200
      CO=SQRT(1.0-SI*SI)
      FTHETA=ATAN2(SI,CO)
      RETURN
1200  FTHETA=PI/2.0
      MIXUP=1
      RETURN
1300  SI=SIN(FPSI)*COS(FCHIB)
      CO=SIN(FCHIB)
      FOME=ATAN2(SI,CO)+FTHETA
      SI=-SIN(FPSI)
      CO=SIN(FCHIB)*COS(FPSI)
      FPHIE=ATAN2(SI,CO)+FPHIB
      SI=SQRT(SIN(FCHIB)**2+(SIN(FPSI)*COS(FCHIB))**2)
      CO=COS(FCHIB)*COS(FPSI)
      FCHIE=ATAN2(SI,CO)
      IF(FCHIB)1400,1600,1500
1400  FCHIE=-FCHIE
      FOME=FOME+PI
      FPHIE=FPHIE+PI
1500  FPHIE=BETW(FPHIE,PI)
      FOME=BETW(FOME,PI)
      RETURN
1600  IF(SIN(FPSI))1400,1700,1500
1700  FCHIE=0.0
      FPHIE=FPHIB
      FOME=FTHETA
      RETURN
1800  FCHIE=BETW(FCHIE,PI)
      SI=SIN(0.5*FCHIE)
      CO=CON1-SI*SI
      IF((CON3-CO).GT.0.0)GOTO 2000
      CO=SQRT(CO)
      FKAPPA=2.0*ATAN2(SI,CO)
      SI=SI*CON2
      FOMK=ATAN2(SI,CO)
1900  FPHIK=FPHIE-FOMK
      FOMK=FOME-FOMK
      FPHIK=BETW(FPHIK,PI)
      FOMK=BETW(FOMK,PI)
      RETURN
2000  FKAPPA=PI
      FOMK=PI/2.0
      MIXUP=1
      GOTO 1900
2100  CONTINUE
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      END
CODE FOR WAIN
      SUBROUTINE WAIN(IDI,J,K)
      DIMENSION ISTORE(131072)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON /CAD/FCV(3),PD(3,3),QD(3,3),RD(3,3),SD(3,3),SI,CO,FKAP(3),
     2 FBIS(3),FPSI,FEUL(3),FHKL(3),CD(3,3),FLAM(3),DET,CON1,CON2,CON3
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
      COMMON /XABSWK/IMODE,WAV,WAVSQ,IDIF,IDAT,IFF,IG,ALPHA,IR1,IR2,
     2 IR3,IR4,ISET,NPI,NPV,VK(3),UM(3,3),UB(3,3),V(3,2),FACT(10),
     3 BFACT(10),CFACT(10),THL,ISPC
      EQUIVALENCE (STORE(1),ISTORE(1))
C----- CONVERTS DIFFRACTOMETER ANGLES INPUT AT STORE(K) TO STANDARD
C      ANGLES AT (J) .  STANDARD ANLES IN ORDER T W X P (K PSI)
      M=J
      L=K+5
      DO 1000 I=K,L
      STORE(M)=STORE(I)*DTR
      M=M+1
1000  CONTINUE
      GOTO(1400,1300,1300,1200,1100),IDI
1100  CONTINUE
C----- THIS SYSTEM NOT AVAILABLE
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
1200  CONTINUE
C----- CAD-4 - KAPPA
C----- CONVERT T P W K TO T W X P
      FBIS(1)=STORE(J)
      FKAP(2)=STORE(J+1)
      FKAP(3)=STORE(J+4)
      FKAP(1)=STORE(J+3)
      CALL HFROM(4)
      STORE(J+1)=FEUL(2)
      STORE(J+2)=FEUL(3)
      STORE(J+3)=FEUL(1)
      STORE(J+5)=STORE(J+5)
      RETURN
1300  CONTINUE
C----- Y290 H&W
      RETURN
1400  CONTINUE
C----- CAD 4 EULERIAN
C----- SET ABSWK VARIABLES
      FEUL(2)=STORE(J+1)
      FEUL(3)=STORE(J+2)
      FEUL(1)=STORE(J+3)
      FBIS(1)= STORE(J  )
      RETURN
      END
C
CODE FOR WMET
      SUBROUTINE WMET(A,B)
C
C
      DIMENSION A(3,3),B(3,3)
C----- FORM A COORDINATE SYSTEM WITH U PARALLEL TO X, V PERP TO U & Y
      A(1,1)=B(1,1)
      A(2,1)=B(2,1)
      A(3,1)=B(3,1)
C
      A(1,2)=A(2,1)*B(3,2)-A(3,1)*B(2,2)
      A(2,2)=A(3,1)*B(1,2)-A(1,1)*B(3,2)
      A(3,2)=A(1,1)*B(2,2)-A(2,1)*B(1,2)
C
      A(1,3)=A(2,1)*A(3,2)-A(3,1)*A(2,2)
      A(2,3)=A(3,1)*A(1,2)-A(1,1)*A(3,2)
      A(3,3)=A(1,1)*A(2,2)-A(2,1)*A(1,2)
C----- NOTE THAT THE RESULT IS NOT NRMALISED, AND THAT
C      B(I,3) IS NOT USED.
      RETURN
      END
CODE FOR STHETA
      FUNCTION STHETA(A)
C
C
      DIMENSION A(3),B(3)
C
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      DIMENSION ISTORE(131072)
C
      COMMON /XABSWK/IMODE,WAV,WAVSQ,IDIF,IDAT,IFF,IG,ALPHA,IR1,IR2,
     2 IR3,IR4,ISET,NPI,NPV,VK(3),UM(3,3),UB(3,3),V(3,2),FACT(10),
     3 BFACT(10),CFACT(10),THL,ISPC
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
      EQUIVALENCE (STORE(1),ISTORE(1))
      CALL XMLTMM(STORE(L1O2),A,B,3,3,1)
      S=0.5*WAV*SQRT(B(1)*B(1)+B(2)*B(2)+B(3)*B(3))
      IF(S-1.)1200,1200,1000
1000  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)A,S
      ENDIF
1100  FORMAT(/20H Sin theta gt than 1,3F6.1,F8.4)
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
1200  CONTINUE
      STHETA=S
      RETURN
      END
CODE FOR WINPL
      FUNCTION WINPL(KX,KY,XIN,NPTS)
C
C
      DIMENSION DELTA(10),A(10)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      DIMENSION ISTORE(131072)
      EQUIVALENCE (STORE(1),ISTORE(1))
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      NTERMS=3
C----- BASED ON DATA REDUCTION AND ERROR ANALYSIS FOR THE
C      PHYSICAL SCIENCES. BEVINGTON. MCGRAW-HILL. P 266.
C
C----- WE WILL DO 3 POINT INTERPOLATION ONLY.
      JX=KX-1
      JY=KY-1
C----- FIND APPROPRIATE VALUE OF X(1)
      DO 1500 I = 1, NPTS
      IF(XIN-STORE(I+JX))1100,1300,1500
1100  I1=I-NTERMS/2
      IF(I1)1200,1200,1600
1200  I1=1
      GOTO 1600
1300  YOUT=STORE(I+JY)
      GOTO 3100
1500  CONTINUE
      I1=NPTS-NTERMS+1
1600  I2=I1+NTERMS-1
      IF(NPTS-I2)1700,2100,2100
1700  I2=NPTS
      I1=I2-NTERMS+1
      IF (I1) 1900, 1900, 2100
1900  I1=1
      NTERMS = I2 - I1 + 1
C----- EVALUATE DEVIATIONS DELTA
2100  CONTINUE
      DENOM=STORE(JX+I1+1)-STORE(JX+I1)
      DELTAX=(XIN-STORE(I1+JX))/DENOM
      DO 2200 I=1,NTERMS
      IX=I1+I-1
2200  DELTA(I)=(STORE(IX+JX)-STORE(I1+JX))/DENOM
C----- COEFFICIENTS A
      A(1) = STORE(I1+JY)
      DO 2600 K = 2, NTERMS
      PROD=1.
      SUM=0.
      IMAX=K-1
      IXMAX=I1+IMAX
      DO 2500 I=1,IMAX
      J=K-I
      PROD=PROD*(DELTA(K)-DELTA(J))
2500  SUM=SUM-A(J)/PROD
2600  A(K)=SUM+STORE(IXMAX+JY)/PROD
C----- ACCUMULATE EXPANSION
      SUM = A(1)
      DO 2900 J=2,NTERMS
      PROD=1.
      IMAX=J-1
      DO 2800 I=1,IMAX
2800  PROD=PROD*(DELTAX-DELTA(I))
2900  SUM=SUM+A(J)*PROD
      YOUT = SUM
3100  WINPL=YOUT
      RETURN
      END
CODE FOR WCVT
      SUBROUTINE WCVT(IDI,J,K)
C----- CONVERT ANGLES SPECIFIED IN TERMS OF A PARTICULAR MACHINE TO
C     THOSE IN TERMS OF A ROLLETT MACHINE.
C     ANGLES MUST BE GIVEN IN ORDER TWXP.
C     THE RULES FOR CONVERSION CAN  BE FOUND AS FOLLOWS
C
C     1. IMAGINE A CRYSTAL WITH ITS UPPER FACE CLEARLY MARKED ON
C        A DIFFRACTOMETER WITH ALL ANGLES SET AT ZERO.
C
C     2. ROTATE THE MACHINE ABOUT THE INCIDENT BEAM UNTIL + THETA
C        IS ANTI CLOCKWISE WHEN VIEWED FROM ABOVE.THE IMAGINARY THETA
C        AXIS NOW POINTS VERTICALLY UPWARDS. IF OMEGA ROTATES IN THE
C        SAME SENSE AS THETA ITS SIGN IS POSITIVE.
C
C     3. IF PHI ROTATES IN THE SAME SENSE AS THETA THEN ITS SIGN IS
C        POSITIVE.
C
C     4. ROTATE CHI UNTIL THE MARKED END OF THE CRYSTAL
C        IS AGAIN UPPERMOST. THIS GIVES X(0).
C     5. FIND THE SENSE (+ OR -) OF ROTATION NEEDED TO CAUSE CHI TO
C        ROTATE ANTI-CLOCKWISE AS VIEWED FROM THE X-RAY SOURCE.
C        THEN X(R) = X(0) +/- X(P)
C     6. IN THE ROLLETT MACHINE OMEGA IS THE ANGLE THE SCATTERING VECTO
C        MUST BE ROTATED IN THE HORIZONTAL PLANE FROM BEING PERPENDICUL
C        TO THE INCIDENT BEAM IN ORDER TO SATISFY THE BRAGG CONDITION.
C     7. IN THE ROLLETT MACHINE THETA IS HALF THE ANGLE MADE BETWEEN TH
C        DIFFRACTED BEAM AND THE CONTINUATION OF THE INCIDENT BEAM PAST
C        THE CRYSTAL.
C
      DIMENSION ISTORE(131072)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
      EQUIVALENCE (STORE(1),ISTORE(1))
      GOTO (1200,1300,1400,1200,1000),IDI
1000  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1010)
      ENDIF
1010  FORMAT(28H This geometry not available )
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
1200  CONTINUE
C----- CAD 4
C     T,W,P OK
      STORE(J+2)=PI-STORE(K+2)
      RETURN
1300  CONTINUE
C----- ROLLETT
1400  CONTINUE
C----- H&W Y290
      RETURN
      END
CRYSTALS CODE FOR SORT
CODE FOR XSORT
      SUBROUTINE XSORT
C--TREE SORT WITH PRUNING OF TOP BRANCHES
C
C--CONTROL VARIABLES IN THIS ROUTINE ARE :
C
C  IULN    THE LIST TYPE TO BE SORTED.
C  MEDIUM  THE OUTPUT MEDIUM REQUIRED.
C
C          -1  M/T
C           0  SAME AS BEFORE.
C          +1  DISC.
C
C--THIS ROUTINE ALWAYS OUTPUTS TO M/T INITIALLY, AND THEN REWRITES IF
C  NECESSARY.
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ISORT(131072),SORT(131072)
C
      CHARACTER*2 CPASS(2)
      DIMENSION PROCS(2)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XSORTX/IH,IK,IL,MH,IBASE,LA,NRL,NWR,LRM,MIH
      COMMON/XWORK/A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,
     2 U,V,W,X,Y,Z
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON/XTAPED/LMTW,MMTW,MDMTW,NMTW,LMTR,MMTR,MDMTR,NMTR
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (ISORT(1),ISTORE(1)),(SORT(1),STORE(1))
      EQUIVALENCE (N1,NFL),(N2,LFL)
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      EQUIVALENCE (PROCS(1),IULN),(PROCS(2),MEDIUM)
C
C
      DATA CPASS / '  ' , 'es' /
C
C--INITIALISE THE TIMING
      CALL XTIME1(2)
C--READ THE CONTROL DATA
      IF (  KRDDPV ( PROCS(1) , 2 )  .LT.  0  ) GO TO 9910
      IULN=KTYP06(IULN)
C--CLEAR THE STORE
      CALL XRSL
      CALL XCSAE
C--SET UP THE LIST 6 TRANSFER
      CALL XFLT06(IULN,0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CHECK THE TYPE OF OUTPUT MEDIUM
      IF(MEDIUM)1150,1100,1150
C--SAME AS BEFORE  -  SET THE 'MEDIUM' FLAG
1100  CONTINUE
      MEDIUM=ISIGN(1,L6D)
C--SET UP THE OUTPUT PROCESSING
1150  CONTINUE
      CALL XSTR06(IULN,-1,0,1,0)
C--SET THE CONSTANTS
      NW=MD6R
      NN=N6R
C--PRESERVE THE READ FLAGS
      L6TEMP=L6R
      N6TEMP=N6R
C--SET A FEW SEARCH CONSTANTS
      MHD=0
      LRM=1000000
      MH=-1000000
      NR=0
C--SET THE CORE LIMITS
      IBASE=N1
      LA=N2
      NWR=NW+2
      IPASS=0
C--START PASSAGE THROUGH THE REFLECTIONS
1200  CONTINUE
      L6R=L6TEMP
      N6R=N6TEMP
C--CHECK FOR INPUT ON M/T
      IF(L6R)1250,1300,1300
C--RESET THE M/T DETAILS
1250  CONTINUE
      REWIND MTA
      MMTR=NMTR
C--SET UP THE LINKED SORT AREA
1300  CONTINUE
      IF ( MH .EQ. MHD ) GO TO 9920
      IPASS=IPASS+1
      MHD=MH
      MIH=1000000
      I=IBASE
      ISORT(I)=LRM
      ISORT(I+1)=I
      NRL=I+NWR
      I=NRL
1500  CONTINUE
      ISORT(I)=0
      J=I
      I=I+NWR
      IF(I-LA+NWR)1550,1550,1600
1550  CONTINUE
      ISORT(J+1)=I
      GOTO 1500
1600  CONTINUE
      ISORT(J+1)=IBASE
C--PICK UP THE NEXT REFLECTION
1650  CONTINUE
      IF(KLDRNR(I))2650,1700,1700
C--FIX THE INDICES
1700  CONTINUE
      IL=NINT(STORE(M6))
      IK=NINT(STORE(M6+1))
      IH=NINT(STORE(M6+2))
C--CHECK THIS INDEX AGAINST THE HIGHEST PROCESSED SO FAR
      IF(IH-MH)1650,1650,1800
C--BEGIN SHUFFLE THROUGH THE TREE, STARTING WITH H
1800  CONTINUE
      IF(IH-MIH)1850,1650,1650
C--START THE PASS THROUGH THE H STACK
1850  CONTINUE
      J=IBASE
      GOTO 1950
C--RECORD THE LAST H ADDRESS AND CHECK THIS VALUE
1900  CONTINUE
      J=I
1950  CONTINUE
      I=ISORT(J+1)
      IF(ISORT(I)-IH)1900,2000,2200
C--WE HAVE AN ENTRY FOR THIS H VALUE
2000  CONTINUE
      I=I+1
C--CHECK THE VALUE OF K
2050  CONTINUE
      J=I
      I=ISORT(I+1)
      IF(ISORT(I)-IK)2050,2100,2350
2100  CONTINUE
      I=I+1
C--CHECK THE VALUE OF L
2150  CONTINUE
      J=I
      I=ISORT(I+1)
      IF(ISORT(I)-IL)2150,2500,2500
C
C--INSERT A NEW VALUE OF H  -  CHECK IF THERE IS A FREE BLOCK
2200  CONTINUE
      IF(ISORT(NRL)-LRM)2300,2250,2300
C--FIND THE NEXT FREE BLOCK BY DELETING AN H BRANCH
2250  CONTINUE
      IF(KPRUNE(I))1650,2300,1650
C--TAKE THE NEXT FREE BLOCK AND INSERT THIS VALUE OF H
2300  CONTINUE
      I=ISORT(J+1)
      ISORT(J+1)=NRL
      J=NRL
      NRL=ISORT(J+1)
      ISORT(J)=IH
      ISORT(J+1)=I
      ISORT(J+2)=IBASE
      J=J+1
      I=IBASE
C--INSERT A NEW VALUE OF K  -  CHECK IF THERE IS FREE BLOCK
2350  CONTINUE
      IF(ISORT(NRL)-LRM)2450,2400,2450
C--FIND A FREE BLOCK BY DELETING AN H BRANCH
2400  CONTINUE
      IF(KPRUNE(I))1650,2450,1650
C--LINK IN THIS VALUE OF K
2450  CONTINUE
      ISORT(J+1)=NRL
      J=NRL
      NRL=ISORT(J+1)
      ISORT(J)=IK
      ISORT(J+1)=I
      ISORT(J+2)=IBASE
      J=J+1
      I=IBASE
C--INSERT A NEW VALUE OF L  -  CHECK IF THERE IS FREE BLOCK FOR THIS L
2500  CONTINUE
      IF(ISORT(NRL)-LRM)2600,2550,2600
C--FIND A BLOCK BY DELETING AN H BRANCH
2550  CONTINUE
      IF(KPRUNE(I))1650,2600,1650
C--INSERT THIS VALUE OF L
2600  CONTINUE
      ISORT(J+1)=NRL
      J=NRL
      NRL=ISORT(J+1)
      ISORT(J)=IL
      ISORT(J+1)=I
C--STORE THE INPUT INFORMATION FOR THIS REFLECTION
      CALL XMOVE(STORE(M6R),STORE(J+2),MD6R)
      GOTO 1650
C
C--SORT OUT THE TREE
C  I  CURRENT H ADDRESS
C  J  CURRENT K ADDRESS
C  K  CURRENT L ADDRESS
C--
2650  CONTINUE
      I=IBASE
      GOTO 3100
C--FETCH FIRST L FOR THIS K BRANCH
2700  CONTINUE
      K=ISORT(J+2)
      GOTO 2800
C--FETCH NEXT L FOR THIS BRANCH
2750  CONTINUE
      K=ISORT(K+1)
C--CHECK FOR THE END OF THIS L CHAIN
2800  CONTINUE
      IF(ISORT(K)-LRM)2850,2950,2850
2850  CONTINUE
      NR=NR+1
C--MOVE THE DATA TO THE OUTPUT M/T BUFFER
      CALL XMOVE(STORE(K+2),STORE(MMTW),MD6W)
      CALL XIMTWA(MTB)
      N6W=N6W+1
      GOTO 2750
C--FETCH FIRST K FOR THIS H BRANCH
2900  CONTINUE
      J=ISORT(I+2)
      GOTO 3000
C--FETCH THE NEXT K FOR THIS BRANCH
2950  CONTINUE
      J=ISORT(J+1)
3000  CONTINUE
      IF(ISORT(J)-LRM)2700,3050,2700
C--FIND THE NEXT H BRANCH
3050  CONTINUE
      MH=MAX0(MH,ISORT(I))
3100  CONTINUE
      I=ISORT(I+1)
      IF(ISORT(I)-LRM)2900,3150,2900
3150  CONTINUE
      I=MIN0(IPASS,2)
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 3200 ) IPASS , CPASS(I) , NR
      ENDIF
      WRITE ( NCAWU , 3200 ) IPASS , CPASS(I) , NR
3200  FORMAT ( 1X , 'After ' , I3 , ' pass' , A , I6 ,
     2 ' reflection(s) have been sorted' )
      IF(NR-NN)1200,3250,3250
C--END OF THE REFLECTION PROCESSING
3250  CONTINUE
      CALL XERT(IULN)
C--CHECK IF WE SHOULD WRITE THE DATA TO DISC
      CALL XSWP06(IULN,MEDIUM)
3270  CONTINUE
      CALL XOPMSG ( IOPSOR , IOPEND , 500 )
      CALL XTIME2(2)
      CALL XRSL
      CALL XCSAE
      RETURN
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPSOR , IOPABN , 0 )
      GO TO 3270
9910  CONTINUE
C -- INPUT ERRORS
      CALL XOPMSG ( IOPSOR , IOPCMI , 0 )
      GO TO 9900
9920  CONTINUE
C -- NOT ENOUGH SPACE
      I = NN - NR
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 ) I
      ENDIF
      WRITE ( NCAWU , 9925 ) I
9925  FORMAT ( 1X , I5 , ' reflections have been lost' )
      CALL XOPMSG ( IOPSOR , IOPSPC , 0 )
      GO TO 9900
      END
C
CODE FOR KPRUNE
      FUNCTION KPRUNE(IN)
C--THESE ROUTINES REMOVE 'H' BRANCHES FROM THE TREE WHEN MORE CORE
C  IS NEEDED
C
C--RETURNS EQUAL TO ZERO UNLESS THE PRESENT REFLECTION CANNOT BE
C  INCLUDED
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ISORT(131072),SORT(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XSORTX/IH,IK,IL,MH,IBASE,LA,NRL,NWR,LRM,MIH
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ISORT(1),ISTORE(1)),(SORT(1),STORE(1))
      EQUIVALENCE (N1,NFL),(N2,LFL)
C
      KPRUNE=0
      L=IBASE
      GOTO 1050
C--RECORD THE ADDRESS OF THE LAST TWO ELEMENTS IN THE STACK
1000  CONTINUE
      M=L
      L=K
C--CHECK FOR THE END OF THE H CHAIN
1050  CONTINUE
      K=ISORT(L+1)
      IF(ISORT(K)-LRM)1000,1100,1000
C--CHECK IF THE H VALUE WE WANT TO DELETE IS THE ONE WE WANT TO USE
1100  CONTINUE
      IF(IH-ISORT(L))1200,1150,1150
1150  CONTINUE
      KPRUNE=-1
C--REMOVE THE LAST H VALUE
1200  CONTINUE
      MIH=ISORT(L)
      NRL=L
      ISORT(M+1)=K
      M=ISORT(L+2)
      GOTO 1350
C--FORM THE L BRANCHES INTO A LINEAR ROW IN THE FREE BLOCK CHAIN
1250  CONTINUE
      L=K
1300  CONTINUE
      K=ISORT(L+1)
      IF(ISORT(K)-LRM)1250,1350,1250
C--CHECK IF THIS IS THE END OF THE K CHAIN
1350  CONTINUE
      IF(ISORT(M)-LRM)1400,1450,1400
C--PICK UP THE L CHAIN FOR THIS K VALUE
1400  CONTINUE
      ISORT(L+1)=M
      L=M
      M=ISORT(L+1)
      ISORT(L+1)=ISORT(L+2)
      GOTO 1300
1450  CONTINUE
      RETURN
      END
C
CODE FOR XREORD
      SUBROUTINE XREORD
C--REORDER THE REFLECTIONS IN LIST 6 FOR THE S.F.L.S ROUTINES
C
C--IF THE DATA ARE NOT TWINNED, REFLECTIONS WHICH COME FROM THE SAME
C  GROUP OF EQUIVALENT INDICES ARE BROUGHT TOGETHER IN LIST 6.
C
C--FOR TWINNED DATA LIST 25 IS USED, AND IN THIS CASE
C  OVERLAPPED REFLECTIONS WITH COMMON GROUPS OF INDICES ARE BROUGHT
C  TOGETHER TO SAVE TIME DURING S.F.L.S.
C
C--
      DIMENSION ISTORE(131072)
C
C
      DIMENSION PROCS(2)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON/XLST25/L25,M25,MD25,N25,L25I,M25I,MD25I,N25I
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
      EQUIVALENCE (PROCS(1),IULN),(PROCS(2),MEDIUM)
C
C--INITIALISE THE TIMING
      CALL XTIME1(2)
C--READ ANY NECESSARY DATA
      IF (  KRDDPV ( PROCS(1) , 2 )  .LT.  0  ) GO TO 9910
      IULN=KTYP06(IULN)
      CALL XRSL
      CALL XCSAE
C--LOAD LISTS ONE AND TWO
      CALL XFAL01
      CALL XFAL02
C--SET THE FRIEDEL LAW FLAG
      IFRIED=2
C--FIND THE TWIN FLAG
      CALL XFAL13
      ITWIN=ISTORE(L13CD+1)
C--SET UP DEFAULT VALUES FOR LIST 25
      L25=NOWT
      M25=NOWT
      MD25=0
      N25=0
C--CHECK IF WE SHOULD USE LIST 25  (TWINNED STRUCTURE)
      IF(ITWIN)1150,1100,1100
C--WE SHOULD USE LIST 25
1100  CONTINUE
      CALL XFAL25
C--SET UP LIST 6 FOR INPUT AND SUBSEQUENT OUTPUT
1150  CONTINUE
      CALL XFLT06(IULN,0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C----- CHECK IF THE DATA IS REALLY ON DISK
      IF (L6R .LE. 0) GOTO 9930
C--CHECK THE TYPE OF OUTPUT MEDIUM
      IF(MEDIUM)1250,1200,1250
C--SAME AS BEFORE  -  SET THE 'MEDIUM' FLAG
1200  CONTINUE
      MEDIUM=ISIGN(1,L6R)
C--SET UP THE OUTPUT PROCESSING
1250  CONTINUE
      CALL XSTR06(IULN,-1,0,1,0)
C--PRESERVE THE LIST 6 MARKERS
      KZ=L6R
      KY=N6R
C--SET UP THE CORE AREA FOR THE POINTERS TO 'KL' PAIRS
      M6DTLK=L6DTL+MD6DTL
      KA=NINT(STORE(M6DTLK))
      KB=(NINT(STORE(M6DTLK+1))-KA+1)*2
      M6DTLL=M6DTLK+MD6DTL
      KC=NINT(STORE(M6DTLL))
      KD=NINT(STORE(M6DTLL+1))-KC+1
      KE=NFL
      LN=6
      IREC=2001
      KF=KCHNFL(KB*KD)-2
C--INITIALISE THE 'KL' TABLE
      DO 1300 I=KE,KF,2
      ISTORE(I)=-1
      ISTORE(I+1)=0
1300  CONTINUE
      A=-550000.
      B=-550000.
C--SET THE FINISHED VALUE FLAG
      Y=2.*ZEROSQ
C
C--START OF THE LOOP TO FIND ALL THE 'KL' PAIRS
C
C--FETCH THE NEXT REFLECTION
1350  CONTINUE
      IF (N6R .LE. 0) GOTO 1900
      KH=L6R
C--CHECK IF THIS VALUE IS EQUAL TO 'Y'
      CALL XDOWNF(KH,STORE(NFL),1)
      IF(ABS(STORE(NFL)-Y)-ZEROSQ)1400,1500,1500
C--THIS VALUE IS NOT OKAY
1400  CONTINUE
      CALL XERHDR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)Y
      ENDIF
1450  FORMAT(31H First word of a reflection is ,E15.10)
      CALL XERHND ( IERCAT )
C--LOAD THE COMPLETE REFLECTION
1500  CONTINUE
      IF(KLDRNR(1))1900,1550,1550
C--CHECK IF 'K' HAS CHANGED
1550  CONTINUE
      IF(ABS(STORE(M6+1)-A)-0.5)1600,1700,1700
C--CHECK IF 'L' HAS CHANGED
1600  CONTINUE
      IF(ABS(STORE(M6+2)-B)-0.5)1650,1700,1700
C--STILL THE SAME 'KL' PAIR  -  INCREMENT THE TOTAL
1650  CONTINUE
      ISTORE(KG+1)=ISTORE(KG+1)+1
      GOTO 1350
C--NEW 'KL' PAIR
1700  CONTINUE
      KG=(NINT(STORE(M6+2))-KC)*KB+(NINT(STORE(M6+1))-KA)*2+KE
C--CHECK IF WE HAVE MET THIS 'KL' PAIR BEFORE
      IF ( ISTORE(KG + 1) .NE. 0 ) GO TO 9920
      ISTORE(KG)=KH
      A=STORE(M6+1)
      B=STORE(M6+2)
      GOTO 1650
C--END OF THE SEARCH FOR 'KL' PAIRS
1900  CONTINUE
      L6R=KZ
      N6R=KY
C
C--START OF THE SORT LOOP
C
C--CHECK IF THIS REFLECTION HAS ALREADY BEEN USED
1950  CONTINUE
      IF (N6R .LE. 0) GOTO 3000
      CALL XDOWNF(L6R,STORE(NFL),1)
      IF(ABS(STORE(NFL)-Y)-ZEROSQ)2000,2050,2050
C--THIS REFLECTION HAS ALREADY BEEN USED  -  SKIP IT
2000  CONTINUE
      IF(KLDRNR(1))3000,1950,1950
C--FETCH THE NEXT REFLECTION
2050  CONTINUE
      KH=L6R
      IF(KLDRNR(1))3000,2100,2100
C--MARK THE REFLECTION AS USED
2100  CONTINUE
      STORE(NFL)=Y
      CALL XUPF(KH,STORE(NFL),1)
C--TRANSFER THE REFLECTION TO THE M/T BUFFER AND OUTPUT IT TO TAPE
      CALL XSLR(1)
C--PREPARE TO PASS THROUGH LIST 2 AND 25
      KS=N25
      A=STORE(M6)
      B=STORE(M6+1)
      C=STORE(M6+2)
C--CHECK IF THIS IS A TWINNED STRUCTURE
      IF(ITWIN)2350,2150,2150
C--FETCH THE ELEMENTS FOR THIS REFLECTION
2150  CONTINUE
      I=NINT(STORE(M6+11))
      J=I/10
C--CHECK IF THIS REFLECTION HAS ONLY ONE ELEMENT
      IF(J)1950,1950,2200
C--THIS REFLECTION HAS MORE THAN ONE ELEMENT
2200  CONTINUE
      I=J
      J=I/10
      IF(J)2250,2250,2200
C--'I' NOW HOLDS THE ELEMENT IN WHICH THE INDICES ARE GIVEN
2250  CONTINUE
      M25I=(I-1)*MD25I+L25I
C--CALCULATE THE INDICES IN THE STANDARD SETTING
      D=STORE(M25I)*STORE(M6)+STORE(M25I+1)*STORE(M6+1)+STORE(M25I+2)
     2 *STORE(M6+2)
      E=STORE(M25I+3)*STORE(M6)+STORE(M25I+4)*STORE(M6+1)+STORE(M25I+5)
     2 *STORE(M6+2)
      F=STORE(M25I+6)*STORE(M6)+STORE(M25I+7)*STORE(M6+1)+STORE(M25I+8)
     2 *STORE(M6+2)
C--PASS THROUGH THE VARIOUS TWIN TRANSFORMATION MATRICES
      M25=L25
C--COMPUTE THE TRANSFORMED INDICES
2300  CONTINUE
      A=STORE(M25)*D+STORE(M25+1)*E+STORE(M25+2)*F
      B=STORE(M25+3)*D+STORE(M25+4)*E+STORE(M25+5)*F
      C=STORE(M25+6)*D+STORE(M25+7)*E+STORE(M25+8)*F
C--PASS THROUGH THE SYMMETRY POSITIONS, GENERATING ALL THE EQUIVALENTS
2350  CONTINUE
      M2=L2
      DO 2950 KT=1,N2
      O=STORE(M2)*A+STORE(M2+3)*B+STORE(M2+6)*C
      P=STORE(M2+1)*A+STORE(M2+4)*B+STORE(M2+7)*C
      Q=STORE(M2+2)*A+STORE(M2+5)*B+STORE(M2+8)*C
C--LOOP OVER THE FRIEDEL PAIRS
      DO 2900 KU=1,IFRIED
C--CHECK THE COMPUTED INDICES AGAINST THE LIMITS IN LIST 28
      IF(P-STORE(M6DTLK)+0.5)2850,2850,2400
2400  CONTINUE
      IF(P-STORE(M6DTLK+1)-0.5)2450,2850,2850
C--CHECK THE COMPUTED VALUE OF 'L'
2450  CONTINUE
      IF(Q-STORE(M6DTLL)+0.5)2850,2850,2500
2500  CONTINUE
      IF(Q-STORE(M6DTLL+1)-0.5)2550,2850,2850
C--COMPUTE THE LOOK UP ADDRESS
2550  CONTINUE
      KG=(NINT(Q)-KC)*KB+(NINT(P)-KA)*2+KE
      N=ISTORE(KG+1)
C--CHECK IF THERE ARE ANY REFLECTIONS TO COMPARE
      IF(N)2850,2850,2600
C--BEGIN COMPARING THE TRANSFORMED 'H' VALUES
2600  CONTINUE
      M=L6R
      L6R=ISTORE(KG)
      MM=N6R
      N6R=N+1
      DO 2800 KV=1,N
      IF (L6R .LE. 0) GOTO 2800
      K=L6R
C--FETCH THE NEXT REFLECTION WITH THIS VALUE OF 'K' AND 'L'
      IF(KLDRNR(1))2800,2650,2650
C--CHECK IF THIS REFLECTION HAS BEEN USED BEFORE
2650  CONTINUE
      CALL XDOWNF(K,STORE(NFL),1)
      IF(ABS(STORE(NFL)-Y)-ZEROSQ)2800,2700,2700
C--CHECK THE VALUE OF H
2700  CONTINUE
      IF(ABS(STORE(M6)-O)-0.5)2750,2800,2800
C--THE REQUIRED VALUE OF 'H' HAS BEEN FOUND
2750  CONTINUE
      CALL XSLR(1)
C--MARK THE REFLECTION AS USED
      STORE(NFL)=Y
      CALL XUPF(K,STORE(NFL),1)
2800  CONTINUE
C--RESET THE POINTER TO LIST 6 TO FETCH THE NEXT REFLECTION
      L6R=M
      N6R=MM
C--INVERT THE COMPUTED INDICES FOR FRIEDEL'S LAW
2850  CONTINUE
      O=-O
      P=-P
      Q=-Q
2900  CONTINUE
C--CHANGE SYMMETRY POSITIONS
      M2=M2+MD2
2950  CONTINUE
C--INCREMENT TO THE NEXT TRANSFORMATION MATRIX
      M25=M25+MD25
      KS=KS-1
C--CHECK IF WE SHOULD CHECK ANY MORE FOR THIS REFLECTION
      IF(KS)1950,1950,2300
C
C--END OF THE REFLECTION FETCHING LOOP
3000  CONTINUE
      CALL XERT(IULN)
C--COPY THE DATA TO THE OUTPUT MEDIUM IF NEC.
      CALL XSWP06(IULN,MEDIUM)
C--TERMINATION MESSGES
3020  CONTINUE
      CALL XOPMSG ( IOPREO , IOPEND , 200 )
      CALL XTIME2(2)
      CALL XRSL
      CALL XCSAE
      RETURN
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPREO , IOPABN , 0 )
      GO TO 3020
9910  CONTINUE
C -- INPUT ERRORS
      CALL XOPMSG ( IOPREO , IOPCMI , 0 )
      GO TO 9900
9920  CONTINUE
      WRITE(NCAWU,9925)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU ,9925)
      ENDIF
9925  FORMAT ( 1X , 'The data need sorting' )
      CALL XERHND ( IERERR )
      GO TO 9900
9930  CONTINUE
      WRITE(NCAWU,9935)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU ,9935)
      ENDIF
9935  FORMAT ( 1X, 'The previous instruction should have left the data',
     1 / ' on the disc. Include a line STORE MEDIUM=DISK  or ', /
     2 ' a call to #LIST 6 with READ TYPE= COPY '  )
      CALL XERHND ( IERERR )
      GO TO 9900
      END
C
CODE FOR XSHELQ
      SUBROUTINE XSHELQ(STORE,NW,IPOS,NITEM,IDIMN,ABUFF)
C--IN CORE SHELL SORT ROUTINE, SORTING INTO ASCENDING ORDER.
C
C  STORE   THE ARRAY HOLDING THE DATA TO BE SORTED.
C  NW      THE NUMBER OF WORDS PER ITEM.
C  IPOS    THE POSITION OF THE ITEM TO BE SORTED (1 TO 'NW').
C  IDIMN    THE DIMENSION OF 'STORE'.
C  NITEM   THE NUMBER OF ITEMS TO BE SORTED.
C  ABUFF   A BUFFER OF LENGTH 'NW'.
C
C--
C
      DIMENSION STORE(IDIMN),ABUFF(NW)
C
C--COMPUTE THE INITIAL STEP LENGTH
      NSTEP=1
      DO 1050 I=1,NITEM
      J=3*NSTEP+1
      IF(J-NITEM)1050,1100,1100
1050  CONTINUE
C--ENSURE THAT THE STEP LENGTH IS NOT TOO LARGE
1100  CONTINUE
      NSTEP=MAX0(NSTEP,13)
C--COMPUTE THE LAST USED ADDRESS
      LAST=(NITEM-1)*NW+IPOS
C--LOOP OVER EACH SEARCH VALUE
1150  CONTINUE
      NSTEPC=MAX0(1,NSTEP-1)
      NCW=NSTEPC*NW
      L=IPOS
      DO 1450 M=1,NSTEPC
      K=L
      GOTO 1250
1200  CONTINUE
      K=K+NCW
1250  CONTINUE
      I=K
      J=I+NCW
      IF(J-LAST)1300,1300,1400
1300  CONTINUE
      IF(STORE(J)-STORE(I))1350,1200,1200
C--INTER-CHANGE ENTRIES
1350  CONTINUE
      I0=I-IPOS
      J0=J-IPOS
      CALL XMOVE(STORE(I0+1),ABUFF(1),NW)
      CALL XMOVE(STORE(J0+1),STORE(I0+1),NW)
      CALL XMOVE(ABUFF(1),STORE(J0+1),NW)
      J=I
      I=I-NCW
      IF(I)1200,1200,1300
1400  CONTINUE
      L=L+NW
1450  CONTINUE
      NSTEP=(NSTEP-1)/3
      IF(NSTEP)1500,1500,1150
1500  CONTINUE
      RETURN
      END
C
CODE FOR XSHELR
      SUBROUTINE XSHELR(STORE,NW,IPOS,NITEM,IDIMN,ABUFF)
C--IN CORE SHELL SORT ROUTINE, SORTING INTO DESCENDING ORDER.
C
C  STORE   THE ARRAY HOLDING THE DATA TO BE SORTED.
C  NW      THE NUMBER OF WORDS PER ITEM.
C  IPOS    THE POSITION OF THE ITEM TO BE SORTED (1 TO 'NW').
C  IDIMN    THE DIMENSION OF 'STORE'.
C  NITEM   THE NUMBER OF ITEMS TO BE SORTED.
C  ABUFF   A BUFFER OF LENGTH 'NW'.
C
C--
C
      DIMENSION STORE(IDIMN),ABUFF(NW)
C
C--COMPUTE THE INITIAL STEP LENGTH
      NSTEP=1
      DO 1050 I=1,NITEM
      J=3*NSTEP+1
      IF(J-NITEM)1050,1100,1100
1050  CONTINUE
C--ENSURE THAT THE STEP LENGTH IS NOT TOO LARGE
1100  CONTINUE
      NSTEP=MAX0(NSTEP,13)
C--COMPUTE THE LAST USED ADDRESS
      LAST=(NITEM-1)*NW+IPOS
C--LOOP OVER EACH SEARCH VALUE
1150  CONTINUE
      NSTEPC=MAX0(1,NSTEP-1)
      NCW=NSTEPC*NW
      L=IPOS
      DO 1450 M=1,NSTEPC
      K=L
      GOTO 1250
1200  CONTINUE
      K=K+NCW
1250  CONTINUE
      I=K
      J=I+NCW
      IF(J-LAST)1300,1300,1400
1300  CONTINUE
      IF(STORE(I)-STORE(J))1350,1200,1200
C--INTER-CHANGE ENTRIES
1350  CONTINUE
      I0=I-IPOS
      J0=J-IPOS
      CALL XMOVE(STORE(I0+1),ABUFF(1),NW)
      CALL XMOVE(STORE(J0+1),STORE(I0+1),NW)
      CALL XMOVE(ABUFF(1),STORE(J0+1),NW)
      J=I
      I=I-NCW
      IF(I)1200,1200,1300
1400  CONTINUE
      L=L+NW
1450  CONTINUE
      NSTEP=(NSTEP-1)/3
      IF(NSTEP)1500,1500,1150
1500  CONTINUE
      RETURN
      END
C
CODE FOR XSHELI
      SUBROUTINE XSHELI(ISTORE,NW,IPOS,NITEM,IDIMN,IBUFF)
C--IN CORE SHELL SORT ROUTINE, SORTING INTO ASCENDING ORDER.
C
C  ISTORE  THE ARRAY HOLDING THE DATA TO BE SORTED.
C  NW      THE NUMBER OF WORDS PER ITEM.
C  IPOS    THE POSITION OF THE ITEM TO BE SORTED (1 TO 'NW').
C  IDIMN    THE DIMENSION OF 'ISTORE'.
C  NITEM   THE NUMBER OF ITEMS TO BE SORTED.
C  IBUFF   A BUFFER OF LENGTH 'NW'.
C
C--
C
      DIMENSION ISTORE(IDIMN),IBUFF(NW)
C
C--COMPUTE THE INITIAL STEP LENGTH
      NSTEP=1
      DO 1050 I=1,NITEM
      J=3*NSTEP+1
      IF(J-NITEM)1050,1100,1100
1050  CONTINUE
C--ENSURE THAT THE STEP LENGTH IS NOT TOO LARGE
1100  CONTINUE
      NSTEP=MAX0(NSTEP,13)
C--COMPUTE THE LAST USED ADDRESS
      LAST=(NITEM-1)*NW+IPOS
C--LOOP OVER EACH SEARCH VALUE
1150  CONTINUE
      NSTEPC=MAX0(1,NSTEP-1)
      NCW=NSTEPC*NW
      L=IPOS
      DO 1450 M=1,NSTEPC
      K=L
      GOTO 1250
1200  CONTINUE
      K=K+NCW
1250  CONTINUE
      I=K
      J=I+NCW
      IF(J-LAST)1300,1300,1400
1300  CONTINUE
      IF(ISTORE(J)-ISTORE(I))1350,1200,1200
C--INTER-CHANGE ENTRIES
1350  CONTINUE
      I0=I-IPOS
      J0=J-IPOS
      CALL XMOVE(ISTORE(I0+1),IBUFF(1),NW)
      CALL XMOVE(ISTORE(J0+1),ISTORE(I0+1),NW)
      CALL XMOVE(IBUFF(1),ISTORE(J0+1),NW)
      J=I
      I=I-NCW
      IF(I)1200,1200,1300
1400  CONTINUE
      L=L+NW
1450  CONTINUE
      NSTEP=(NSTEP-1)/3
      IF(NSTEP)1500,1500,1150
1500  CONTINUE
      RETURN
      END
C
CODE FOR XSHELJ
      SUBROUTINE XSHELJ(ISTORE,NW,IPOS,NITEM,IDIMN,IBUFF)
C--IN CORE SHELL SORT ROUTINE, SORTING INTO DESCENDING ORDER.
C
C  ISTORE  THE ARRAY HOLDING THE DATA TO BE SORTED.
C  NW      THE NUMBER OF WORDS PER ITEM.
C  IPOS    THE POSITION OF THE ITEM TO BE SORTED (1 TO 'NW').
C  IDIMN    THE DIMENSION OF 'ISTORE'.
C  NITEM   THE NUMBER OF ITEMS TO BE SORTED.
C  IBUFF   A BUFFER OF LENGTH 'NW'.
C
C--
C
      DIMENSION ISTORE(IDIMN),IBUFF(NW)
C
C--COMPUTE THE INITIAL STEP LENGTH
      NSTEP=1
      DO 1050 I=1,NITEM
      J=3*NSTEP+1
      IF(J-NITEM)1050,1100,1100
1050  CONTINUE
C--ENSURE THAT THE STEP LENGTH IS NOT TOO LARGE
1100  CONTINUE
      NSTEP=MAX0(NSTEP,13)
C--COMPUTE THE LAST USED ADDRESS
      LAST=(NITEM-1)*NW+IPOS
C--LOOP OVER EACH SEARCH VALUE
1150  CONTINUE
      NSTEPC=MAX0(1,NSTEP-1)
      NCW=NSTEPC*NW
      L=IPOS
      DO 1450 M=1,NSTEPC
      K=L
      GOTO 1250
1200  CONTINUE
      K=K+NCW
1250  CONTINUE
      I=K
      J=I+NCW
      IF(J-LAST)1300,1300,1400
1300  CONTINUE
      IF(ISTORE(I)-ISTORE(J))1350,1200,1200
C--INTER-CHANGE ENTRIES
1350  CONTINUE
      I0=I-IPOS
      J0=J-IPOS
      CALL XMOVE(ISTORE(I0+1),IBUFF(1),NW)
      CALL XMOVE(ISTORE(J0+1),ISTORE(I0+1),NW)
      CALL XMOVE(IBUFF(1),ISTORE(J0+1),NW)
      J=I
      I=I-NCW
      IF(I)1200,1200,1300
1400  CONTINUE
      L=L+NW
1450  CONTINUE
      NSTEP=(NSTEP-1)/3
      IF(NSTEP)1500,1500,1150
1500  CONTINUE
      RETURN
      END


CRYSTALS CODE FOR SPACEGRP
CODE FOR XSPCGR
      SUBROUTINE XSPCGR
C
C -- THIS IS THE MAIN SUBROUTINE FOR THE 'SPACEGROUP' INSTRUCTION
C    PROVIDED BY ERIC GABE, NRCC, WITH PERMISSION TO DISTRIBUTE.
C
C -- THIS ROUTINE PROVIDES AN INTERFACE BETWEEN 'CRYSTALS' AND THE
C    ALLEN LARSON SPACEGROUP SYMBOL INTERPRETATION ROUTINE.
C
C      VERSION     DATE              BY          CHANGE
C      -------     ----              --          ------
C      1.00        JANUARY 1986      PWB         INITIAL VERSIONC
C      1.01        JUNE 1986         PWB         CORRECT HANDLING OF
C                                                NON-PRIMITIVE LATTICE
C                                                TRANSLATIONS
C      2.00        AUGUST 1990       DJW         UPDATE TO USE VOL 'A'
C                                                SG SYMBOLS, AND ADD
C                                                FOURIER LIMITS
C
C -- THE MAIN FUNCTIONS OF THIS ROUTINE ARE :-
C      COMMAND INPUT - NOTE SPECIAL PROCESSING REQUIRED FOR PARAMETER
C      TYPE 4.
C
C      SELECTING A UNIQUE AXIS BASED ON THE UNIT CELL, IF POSSIBLE
C
C      REFORMATTING THE SYMBOL TO USE THE UNIQUE AXIS ( ROUTINE XSPCFM )
C
C      DETERMINING THE MATRICES ( ROUTINE SGROUP AND OTHERS )
C
C      CONVERTING THE OUTPUT OF 'SGROUP' TO THE FORM REQUIRED FOR A
C      CRYSTALS LIST 2, AND WRITING THE RESULTS TO DISC.
C
C
C -- (SOME) LOCAL VARIABLES/PARAMETERS
C
C P    COSMIN      A CELL ANGLE WHOSE COSINE IS LESS THAN 'COSMIN' IS
C                  ASSUMED TO BE 90.0 DEGREES WHEN PERFORMING AUTOMATIC
C                  UNIQUE AXIS DETERMINATION
C
C P    MAXN2       MAXIMUM NUMBER OF MATRICES THAT CAN BE CALCULATED
C                  ( I.E. 24 )
C P    NWORK       SIZE OF WORK SPACE REQUIRED BY 'SGROUP'
C
C
C -- SGROUP PROVIDES SOME INFORMATION IN EITHER INTEGER FORM OR AS
C    AN ENCODED VALUE. APPROPRIATE TRANSLATIONS ARE MADE BY THIS ROUTINE
C
C
C
      PARAMETER ( NNPLAT = 7 )
C
      DIMENSION XNPLAT(NNPLAT)
C
      PARAMETER ( MAXN2 = 24 )
      PARAMETER ( NWORK = 1000 )
C
      CHARACTER *1 XYZ(3)
      CHARACTER*20 CBUFF1 , CBUFF2
      PARAMETER ( NBUFF2 = 10 )
C
C
      PARAMETER ( COSMIN = 0.003 )
C
      DIMENSION  RMI(3), RMA(3), ABC(3), JAXIS(3)
C
      DIMENSION TRANS(0:10)
      PARAMETER ( SIXTH =  1. / 6. , THIRD  = 1. / 3. )
      PARAMETER ( TWOTHD = 2. / 3. , FIVSXT = 5. / 6. )
C
      DIMENSION ISTORE(131072)
      DIMENSION ICOM02(28)
      DIMENSION ICOM14(16)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST14/L14,M14,MD14,N14, L14O,M14O,MD14O,N14O,
     2 L14SC,M14SC,MD14SC,N14SC, L14P,M14P,MD14P,N14P
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (IC,ICOM02(1))
      EQUIVALENCE (L14,ICOM14(1))
C
C
C
C
      DATA XYZ /'X', 'Y', 'Z' /
      DATA XNPLAT / 1. , 5. , 6. , 7. , 2. , 4. , 3. /
C
      DATA IDIMBF / 2 /
      DATA IVERSN / 200 /
C
C
      DATA TRANS / 0.00          , 0.00 ,
     2             SIXTH         , 0.25 ,
     3             THIRD         , 0.00 ,
     4             0.50          , 0.00 ,
     5             TWOTHD        , 0.75 ,
     6             FIVSXT        /
C
C
C
      CALL XTIME1 ( 2 )
C
      ICOMBF = KSTALL ( IDIMBF )
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 2
      IDIM02=28
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 14
      IDIM14=16
C
      IULN = 2
C
C
C
C -- COMMAND INPUT SECTION - DONE 'BY HAND'
C
C -- READ DIRECTIVE CARD
1000  CONTINUE
      ISTAT = KRDNDC ( ISTORE(ICOMBF) , IDIMBF )
      IF ( ISTAT .LT. 0 ) THEN
        GO TO 2000
      ELSE IF ( ISTAT .EQ. 0 ) THEN
        CALL XMONTR ( 0 )
        GO TO 1000
      ENDIF
C
      IF ( ISTAT .EQ. 1 ) THEN
C
C -- SEARCH FOR THE PARAMETER KEYWORD
C
        IF ( KFNDNP(I) .LE. 0 ) GO TO 9810
C
C -- STORE AWAY SYMBOL
C
        NC = KNEQUL ( NC , IB )
        IF ( NC .LE. 0 ) GO TO 9810
        IF ( NC .GT. LASTCH ) GO TO 9810
      ISIZE = MIN0 ( LASTCH - NC + 1 , LEN ( CBUFF1 ) )
        WRITE ( CBUFF1 , '(20A1)' ) ( IMAGE(J), J = NC, NC + ISIZE - 1 )
        NC = LASTCH + 1
        GO TO 1000
      ENDIF
C
C -- NORMAL DIRECTIVE. READ THE PARAMETER VALUE
1050  CONTINUE
      IF ( KFNDNP ( I ) .LE. 0 ) GO TO 1000
      ISTAT = KRDPV ( ISTORE(ICOMBF) , IDIMBF )
      IF ( ISTAT .LT. 0 ) GO TO 1000
      IF ( ISTAT .EQ. 0 ) GO TO 1050
      GO TO 9820
C
C
C
2000  CONTINUE
C
C
C
C -- INPUT COMPLETED
C
C -- CHECK FOR ERRORS DURING INPUT
C
      IF ( LEF .GT. 0 ) GO TO 9930
      IF ( IERFLG .LT. 0 ) GO TO 9900
C
      IUNIQU = ISTORE(ICOMBF+1)
      ISPECI = 1
C
C -- RESET STORE AFTER INPUT PHASE
C
      CALL XCSAE
      CALL XRSL
C
C----- TRY TO LOAD LIST 1
        IF ( KEXIST ( 1 ) .GT. 0 ) THEN
          CALL XFAL01
          IF ( IERFLG .LT. 0 ) GO TO 9900
            ABC(1) = STORE(L1P1  )
            ABC(2) = STORE(L1P1+1)
            ABC(3) = STORE(L1P1+2)
        ELSE
C-----      SET DUMMY CELL PARAMETERS
            ABC(1) = 10.
            ABC(2) = 10.
            ABC(3) = 10.
        ENDIF
C
C --  CHECK UP ON UNIQUE AXIS SPECIFIED. IF 'AUTOMATIC' WAS SELECTED,
C     TRY DETERMINING UNIQUE AXIS FROM LIST 1.
C
      IF ( IUNIQU .EQ. 0 ) THEN
        IUNIQU = 2
        ISPECI = 3
          DO 2100 I = L1P1 + 3 , L1P1 + 5
            IF ( ABS ( COS ( STORE(I) ) ) .GT. COSMIN ) THEN
              IUNIQU = I - L1P1 - 2
            ISPECI = 2
            ENDIF
2100      CONTINUE
      ENDIF
C
C -- REFORMAT INPUT SYMBOL ( DOES NOTHING AT THE MOMENT ). CONVERT
C    CHARACTER DATA BACK INTO INTEGERS, FOR USE WITH INTERPRETATION
C    ROUTINE
C
C
      CALL XSPCFM ( CBUFF1 , IUNIQU , ISPECI , CBUFF2 )
      IF ( IERFLG .LT. 0 ) GO TO 9900
C
C -- ALLOCATE BUFFER AND FILL WITH SPACES. LOAD SYMBOL INTO BUFFER
C
      LBUFF2 = KSTALL ( NBUFF2 )
      CALL XFILL ( IB , ISTORE(LBUFF2) , NBUFF2 )
C
      READ ( CBUFF2, '(10A1)' ) (ISTORE(J), J = LBUFF2, LBUFF2+NBUFF2-1)
C
C -- SET VARIABLES TO ASSUMED MAXIMUM VALUES.
C
      N2 = MAXN2
      N2I = MAXN2
      N2T = MAXN2
C
C -- ALLOCATE SPACE FOR THE NEW LIST 2
      CALL XCELST ( IULN , ICOM02 , IDIM02 )
C----- PACK THE SYMBOL INTO LIST 2
      CALL XSAVSG( LBUFF2, NBUFF2)
      IF (IERFLG .LT. 0) GOTO 9900
C
C -- ALLOCATE WORK SPACE REQUIRED BY INTERPRETATION ROUTINE
C
      IWORK = KSTALL ( NWORK )
C
C -- CALL THE SYMBOL INTERPRETATION ROUTINE
C
      CALL SGROUP ( ISTORE(LBUFF2) ,
     2 LAUENO , NAXIS , NCENT , LCENT ,
     3 N2 , NPOL , ISTORE(L2) ,
     4 STORE(L2P) , N2P ,
     5 NCAWU , NCAWU , ISTORE(IWORK))
C
      IF ( IERFLG .LT. 0 ) GO TO 9900
C
C----  FIND THE FOURIER LIMITS
      CALL XZEROF (RMI, 9)
      CALL XZEROF (RMA, 9)
      CALL   CDFOUN (LAUENO, NCENT, N2, N2P, ABC, ISTORE(L2),
     1 ISTORE(L2P), SPG, RMI, RMA, JAXIS )
C
C
C----- LOAD LIST 14 FOR UPDATING
      CALL XFAL14
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU, 2400)
      ENDIF
      WRITE(NCAWU, 2400)
2400  FORMAT(/,1X, '   Fourier limits are :-')
C----- STORE REAL CELL LIMITS
      M14 = L14
      DO 2600 J = 1, 3
        DO 2550 L = 1, 3
            IF (JAXIS(L) .EQ. J) THEN
              STORE(M14  ) = RMI(JAXIS(L))
              STORE(M14+2) = RMA(JAXIS(L))
      IF (ISSPRT .EQ. 0) THEN
              WRITE(NCWU,2410) XYZ(J), STORE(M14), STORE(M14+2)
      ENDIF
              WRITE(NCAWU,2410) XYZ(J), STORE(M14), STORE(M14+2)
2410  FORMAT(30X, A1, ' axis from ', F6.3, ' to ', F6.3)
            ENDIF
2550    CONTINUE
        M14 = M14 + MD14
2600  CONTINUE
C
C----- THE SORT DIRECTIONS
      DO 2650 J = 1,3
        ISTORE(L14O +J-1) = JAXIS(J)
2650  CONTINUE
C
C
C----  FIND THE PATTERSON LIMITS
      CALL XZEROF (RMI, 9)
      CALL XZEROF (RMA, 9)
C----- COPY THE SYMMETRY MATRICES, REMOVING THE TRANSLATIONAL PARTS
      CALL XMOVE(ISTORE(L2), ISTORE(IWORK), 288)
      J = IWORK + 9
      DO 2500 I = 1,24
            CALL XZEROF(ISTORE(J), 3)
            J = J + 12
2500  CONTINUE
      CALL   CDFOUN (LAUENO, 1, N2, N2P, ABC, ISTORE(IWORK),
     1 ISTORE(L2P), SPG, RMI, RMA, JAXIS )
C
C----- THE PATTERSON LIMITS - IN SAME ORDER AS REAL CELL
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU, 2420)
      ENDIF
      WRITE(NCAWU, 2420)
2420  FORMAT(/,1X, '  Patterson limits are :-')
C
      M14P = L14P
      DO 2750 J = 1, 3
        DO 2700 L = 0, 2
            IF (ISTORE(L14O+L) .EQ. J) THEN
                  STORE(M14P  ) = RMI(J)
                  STORE(M14P+2) = RMA(J)
      IF (ISSPRT .EQ. 0) THEN
              WRITE(NCWU,2410) XYZ(J), STORE(M14P), STORE(M14P+2)
      ENDIF
              WRITE(NCAWU,2410) XYZ(J), STORE(M14P), STORE(M14P+2)
            ENDIF
2700    CONTINUE
        M14P = M14P + MD14P
2750  CONTINUE
C
C -- ADJUST N2I AND N2T TO REFLECT ( POSSIBLY ) CHANGED VALUE OF N2
C
      N2I = N2
      N2T = N2
C
C -- CONVERT OPERATORS TO REAL FORM, TRANSLATE CODES FOR TRANSLATIONAL
C    PART, TRANSPOSE MATRIX
C
      M2 = L2 + ( N2 - 1 ) * MD2
      DO 5100 I = L2 , M2 , MD2
        DO 5050 J = I , I + 8
          STORE(J) = REAL ( ISTORE(J) )
5050    CONTINUE
C
        DO 5070 J = I + 9 , I + 11
          STORE(J) = TRANS ( ISTORE(J) )
5070    CONTINUE
C
        SAVE = STORE(I+3)
        STORE(I+3) = STORE(I+1)
        STORE(I+1) = SAVE
C
        SAVE = STORE(I+6)
        STORE(I+6) = STORE(I+2)
        STORE(I+2) = SAVE
C
        SAVE = STORE(I+7)
        STORE(I+7) = STORE(I+5)
        STORE(I+5) = SAVE
C
5100  CONTINUE
C
C
C -- CALCULATE INVERSE MATRICES
C
      M2 = L2
      M2I = L2I
      DO 5300 I = 1 , N2
        ISTAT = KINV2 ( 3 , STORE(M2) , STORE(M2I) , 9 , 0 ,
     2                  STORE(L2T) , STORE(L2T+3) , 3 )
        IF ( ISTAT .NE. 0 ) GO TO 9940
        STORE(M2I+9)=-STORE(M2+9)
        STORE(M2I+10)=-STORE(M2+10)
        STORE(M2I+11)=-STORE(M2+11)
        M2 = M2 + MD2
        M2I = M2I + MD2I
5300  CONTINUE
C
C -- CALCULATE AND STORE 'CONSTANTS'
C
      IC = NCENT
      G2 = REAL ( IC + 1 ) * REAL ( N2P )
      T2 = G2 * REAL ( N2 )
C
      STORE(L2C) = REAL ( IC )
      STORE(L2C+1) = XNPLAT ( LCENT )
      STORE(L2C+2) = G2
      STORE(L2C+3) = T2
C
C -- SAVE NEW LIST 2
      CALL XWLSTD ( IULN , ICOM02 , IDIM02 , -1 , 1 )
C -- SAVE NEW LIST 14
      CALL XWLSTD ( 14 , ICOM14 , IDIM14 , 0 , 1 )
C
      CALL XOPMSG( IOPSGP, IOPEND, IVERSN)
      CALL XTIME2 ( 2 )
C
      RETURN
C
C
9800  CONTINUE
      LEF = LEF + 1
      GO TO 1000
9810  CONTINUE
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9815 )
      ENDIF
      WRITE ( NCAWU , 9815 )
9815  FORMAT ( 1X, 'Illegal space group card. ' ,
     2 'The symbol should appear on the SPACE card.' )
      GO TO 9800
9820  CONTINUE
      CALL XMONTR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9825 )
      ENDIF
      WRITE ( NCAWU , 9825 )
9825  FORMAT ( 1X , 'Parameter type is illegal for XSPCGR' )
      CALL XERHND ( IERPRG )
      GO TO 9800
C
C
9900  CONTINUE
      CALL XOPMSG (IOPSGP, IOPABN, 0)
      IDIRFL = -1
      RETURN
9930  CONTINUE
      CALL XOPMSG (IOPSGP, IOPCMI, 0)
      GO TO 9900
9940  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9945 )
      ENDIF
      WRITE ( NCAWU , 9945 )
9945  FORMAT ( 1X , 'One of the calculated matrices failed to invert' )
      CALL XERHND ( IERPRG )
      GO TO 9900
      END
C
C
CODE FOR SGROUP
      SUBROUTINE SGROUP(SPG,LAUENO,NAXIS,NCENT,LCENT,NSYM,NPOL,JRT,
     $  CEN,NCV,LPT,LPTX,RT)
C
C
C
C----------------------------------------------------------------------
C       THIS PROGRAM WAS DEVELOPED FOR
C                  THE DIVISION OF CHEMISTRY
C                      OF
C             THE NATIONAL RESEARCH COUNCIL OF CANADA
C                      BY
C       ALLEN C. LARSON, P.O.BOX 5898, SANTA FE, NM 87502,USA
C----------------------------------------------------------------------
C-----------------------------------------------------------------------
C
C   THIS SR INTERPRETS THE SPACE GROUP SYMBOL
C   **NOTE**   Vol. A of Int Tab uses different symbols for cubic
C   2-July-87  space groups with -3 axes,
C              i.e. P n -3 n instead of P n 3 n.
C              The routine changes the symbol to the old form for
C              interpretation, but prints the new form.
C             DATA IN THE CALLING SEQUENCE ARE
C
C       SGP    INPUT  TEN WORDS CONTAINING THE SPACE GROUP SYMBOL 10A1
C       LAUENO OUTPUT THE LAUE GROUP NO.
C              1=1BAR, 2=2/M, 3=MMM, 4=4/M, 5=4/MM, 6=R3R, 7=R3MR,
C              8=3, 9=31M, 10=3M1, 11=6/M, 12=6/MMM, 13=M3 AND 14=M3M
C       NAXIS  OUTPUT UNIQUE AXIS IN MONOCLINIC SPACE GROUPS
C             = 4 ON ERROR EXITS
C       NCENT  OUTPUT 1BAR FLAG  (0/1) FOR (ACENTRIC/CENTRIC)
C       LCENT  OUTPUT LATTICE CENTERING NO.
C              1=P, 2=A, 3=B, 4=C, 5=I, 6=F AND 7=R
C       NSYM   OUTPUT THE NO. OF MATRICES GENERATED
C       JRT    OUTPUT THE NSYM (3,4,NSYM) MATRICES
C       CEN    OUTPUT THE LATTICE CENTERING VECTORS
C       NCV    OUTPUT THE NO. OF LATTICE CENTERING VECTORS
C       LPT    OUTPUT LISTING DEVICE FOR NORMAL OUTPUT.
C              IF .EQ.0 NO LISTING WILL BE PRODUCED
C       LPTX   OUTPUT LISTING DEVICE FOR ERROR LISTINGS
C       RT     SCRATCH ARRAY OF 500 WORDS NEEDED BY SGROUP
C-----------------------------------------------------------------------
C
C
C***********************************************************************
C
C                  CHANGES FOR 'CRYSTALS' VERSION
C
C      ARGUMENTS 'LPT' AND 'LPTX' TO THIS ROUTINE ARE IGNORED. OUTPUT
C      IS TO 'NCWU' AND 'NCAWU' AS APPROPRIATE
C
C      ROUTINES CALL 'XERHND' TO SIGNAL ERRORS.
C
C      ADD ',' TO FORMAT STATEMENTS WHERE NECESSARY. FORMAT STATEMENTS
C      MOVED NEXT TO APPROPRIATE 'WRITE' STATEMENT
C
C      IN SGERRS, ERROR MESSAGES ARE STORED IN CHARACTER VARIABLES
C
C      IN SGPRNT, OPERATORS ARE WRITTEN TO 'NCWU' ONLY
C
C      IN SGTRCF, DECLARE ARRAY AS (5,4,25) RATHER THAN (5,4,24)
C      IN SGMTML, DECLARE ARRAY AS (5,4,25) RATHER THAN (5,4,24)
C
C***********************************************************************
C
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
      DIMENSION RMI(3), RMA(3), ABC(3)
      DIMENSION SPG(10),JRT(3,4,24),CEN(3,4)
      DIMENSION RT(5,4,25),D(3,3),L(4,4),LCEN(7)
      CHARACTER *1 CHR(25), CHAR
      CHARACTER *10 CSPG
C

C-----------------------------------------------------------------------
C               C B A P F I R
C-----------------------------------------------------------------------
      DATA LCEN/4,3,2,1,6,5,7/
C-----------------------------------------------------------------------
C                1   2   3   4   5   6   7   8   9  10  11  12  13  14
C-----------------------------------------------------------------------
      DATA CHR/' ','C','B','A','P','F','I','R','M','N','D','1','2','3',
     $         '4','5','6','-','/','H','.','0','0','0','0'/
C-----------------------------------------------------------------------
C               15  16  17  18  19  20  21
C-----------------------------------------------------------------------
      DO 101 I = 1,4
       DO 100 J = 1,4
        L(J,I) = 0
100    CONTINUE
101   CONTINUE
      WRITE (CSPG,10000) SPG
10000 FORMAT (10A1)
C-----------------------------------------------------------------------
C  CHECK THAT THERE ARE BLANKS IN THE SYMBOL, SO THAT IT HAS AT LEAST A
C  SPORTING CHANCE OF BEING INTERPRETED CORRECTLY
      DO 1012 I = 1,10
        J = 11 - I
        IF (CSPG(J:J) .NE. ' ') THEN
          DO 1010 K = 2,J
            IF (CSPG(K:K) .EQ. ' ') GO TO 1014
 1010     CONTINUE
        ENDIF
 1012 CONTINUE
      IER = 24
      GO TO 710
1014  CONTINUE
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C  Change the symbol for the cubic cases.  EJG   2-July-87
C  If the -3 symbol is preceded by a second kind symmetry element,
C  m, n, a, b, c or d then change -3 to 3
C-----------------------------------------------------------------------
      DO 104 J = 1,9
        IF (CSPG(J:J + 1) .EQ. '-3') THEN
          DO 102 JJ = 1,J - 1
            K = J - JJ
            CHAR = CSPG(K:K)
            IF (CHAR .EQ. ' ') GO TO 102
            IF (CHAR .EQ. 'M' .OR. CHAR .EQ. 'N' .OR.
     $          CHAR .EQ. 'D' .OR. CHAR .EQ. 'A' .OR.
     $          CHAR .EQ. 'B' .OR. CHAR .EQ. 'C') THEN
              CSPG(J:9) = CSPG(J + 1:10)
              CSPG(10:10) = ' '
              GO TO 106
            ENDIF
  102     CONTINUE
        ENDIF
  104 CONTINUE
  106 CONTINUE
      K = 0
      M = 0
      IER = 0
      NCENT = 0
      LAUENO = 0
      NAXIS = 0
      IERX = 0
      N = 0
C-----------------------------------------------------------------------
C  BREAK THE SPACE GROUP SYMBOL INTO THE 4 FIELDS AND CODE
C    AS NUMERICAL VALUES FOR MANIPULATION
C-----------------------------------------------------------------------
        DO 140 J = 1,10
          DO 110 I = 1,21
          IF (CSPG(J:J) .EQ. CHR(I)) GO TO 120
  110     CONTINUE
        GO TO 140
  120   IF (K + M + I .EQ. 1) GO TO 140
        IF (I .EQ. 1) GO TO 130
        IF (M .EQ. 0) K = K + 1
        M = M + 1
        L(M,K) = I
        IF (I .LT. 12) GO TO 130
        IF (M - 4) 140,130,130
  130   CONTINUE
        M = 0
        IF (K .GT. 3) GO TO 150
  140   CONTINUE
C-----------------------------------------------------------------------
C  IF ONLY 1 FIELD WAS FOUND.  THERE IS AN ERROR. GO TO 710
C-----------------------------------------------------------------------
  150 IF ( K .LE. 1 ) IER = 1
      IF ( IER .GT. 0 ) GO TO 710
C-----------------------------------------------------------------------
C  IF THE FIRST CHARACTER WAS NOT A P, A, B, C, F, I OR R  ERROR.
C-----------------------------------------------------------------------
      IF ( L(1,1) .GT. 8 ) IER = 2
      IF ( IER .GT. 0 ) GO TO 710
C-----------------------------------------------------------------------
C  CONVERT THE -N NOTATION TO THE NB(AR) NOTATION
C-----------------------------------------------------------------------
      IF ( L(1,2) .EQ. 18 ) CALL SGLPAK(L(1,2),IER)
      IF ( IER .GT. 0 ) GO TO 710
      IF ( L(1,3) .EQ. 18 ) CALL SGLPAK(L(1,3),IER)
      IF ( IER .GT. 0 ) GO TO 710
      IF ( L(1,4) .EQ. 18 ) CALL SGLPAK(L(1,4),IER)
      IF ( IER .GT. 0 ) GO TO 710
C-----------------------------------------------------------------------
C  SET THE MATRIX COUNT N TO 2
C-----------------------------------------------------------------------
      N = 2
C-----------------------------------------------------------------------
C  SET THE TRANSLATION FLAGS
C-----------------------------------------------------------------------
      D(1,1) = 0.0
      D(1,2) = 0.0
      D(1,3) = 0.0
      D(2,1) = 0.0
      D(2,2) = 0.0
      D(2,3) = 0.0
      D(3,1) = 0.0
      D(3,2) = 0.0
      D(3,3) = 0.0
C-----------------------------------------------------------------------
C  SET THE LATTICE CENTERING FLAG. 1=P, 2=A, 3=B, 4=C, 5=I, 6=F, 7=R
C-----------------------------------------------------------------------
      LCENT = L(1,1)-1
      LCENT = LCEN(LCENT)
      IF ( LCENT .NE. 7 ) GO TO 170
C-----------------------------------------------------------------------
C  RHOMBOHEDRAL LATTICE.
C  MAKE SURE THAT THERE IS A 3-AXIS.
C-----------------------------------------------------------------------
      IF ( L(1,2) .NE. 14 ) IER = 3
      IF ( IER .GT. 0 ) GO TO 710
      IF ( L(1,K) .EQ. 8 ) GO TO 160
C-----------------------------------------------------------------------
C  HEXAGONAL AXES. RETAIN R CENTERING AND SET LAUENO TO 8 OR 9
C-----------------------------------------------------------------------
      IF ( L(1,K) .EQ. 20 ) K = K-1
      LAUENO = K+6
      GO TO 190
  160 CONTINUE
C-----------------------------------------------------------------------
C RHOMBOHEDRAL AXES. DELETE R CENTERING AND SET LAUENO TO 6 OR 7
C-----------------------------------------------------------------------
      LCENT = 1
      K = K-1
      LAUENO = K+4
      GO TO 180
  170 CONTINUE
C-----------------------------------------------------------------------
C  CALL A S.R. TO DETERMINE LAUENO AND SOME PRELIMINARY DATA
C-----------------------------------------------------------------------
      IER = 0
      I209 = 0
      CALL SGLATC(K,L,D,LCENT,NCENT,LAUENO,NAXIS,LPT,IER,I209,ID)
      IF ( IER .GT. 0 ) GO TO 710
      IF ( I209 .EQ. 0 ) GO TO 190
  180 CONTINUE
C-----------------------------------------------------------------------
C   CUBIC OR RHOMBOHEDRAL CELL. INSERT THE 3-FOLD AXIS
C-----------------------------------------------------------------------
      CALL SGRMAT(RT(1,1,2),0,1,0,0,0,1,1,0,0)
      CALL SGRMAT(RT(1,1,3),0,0,1,1,0,0,0,1,0)
      N = 4
  190 CONTINUE
      CALL SGRMAT(RT,1,0,0,0,1,0,0,0,1)
C-----------------------------------------------------------------------
C  DECODE THE LAST 3 FIELDS OF THE SYMBOL
C-----------------------------------------------------------------------
        DO 680 M = 2,K
        IF ( L(1,M) .EQ. 0 ) IER = 6
        IF ( IER .GT. 0 ) GO TO 710
        I = IABS(L(1,M)-5)
  200   IF ( I .LE. 0 .OR. I .GT. 15 ) IER = 7
        IF ( IER .GT. 0 ) GO TO 710
        NXI = N
C-----------------------------------------------------------------------
C                A   B   C   M   N   D   1   2   3   4   5   6   -   /
C-----------------------------------------------------------------------
        GO TO (210,210,210,210,210,330,390,400,500,520,710,540,560,560,
     $   560),I
C-----------------------------------------------------------------------
C        H
C-----------------------------------------------------------------------
  210   CONTINUE
C-----------------------------------------------------------------------
C  A MIRROR IS NEEDED
C-----------------------------------------------------------------------
        GO TO (710,220,240,260),M
C-----------------------------------------------------------------------
C                    A   B   C  AXIS
C-----------------------------------------------------------------------
  220   CONTINUE
        IF ( LAUENO .GT. 3 ) GO TO 270
        IF ( K .EQ. 2 ) GO TO 250
  230   CONTINUE
        IF ( I .EQ. 1 ) IER = 8
        IF ( IER .GT. 0 ) GO TO 710
C-----------------------------------------------------------------------
C  AN A-AXIS MIRROR
C-----------------------------------------------------------------------
        CALL SGRMAT(RT(1,1,N),-1,0,0,0,1,0,0,0,1)
        RT(1,4,N) = D(1,1)
        IF ( I .EQ. 2 .OR. I .EQ. 5 ) RT(2,4,N) = 0.5
        IF ( I .EQ. 3 .OR. I .EQ. 5 ) RT(3,4,N) = 0.5
        GO TO 560
  240   IF ( L(1,2) .EQ. 14 .OR. L(1,2) .EQ. 17 ) GO TO 310
C-----------------------------------------------------------------------
C  IT IS NOT TRIGONAL OR HEXAGONAL
C-----------------------------------------------------------------------
        IF ( L(1,2) .EQ. 15 ) GO TO 230
C-----------------------------------------------------------------------
C  IT IS NOT TETRAGONAL
C-----------------------------------------------------------------------
  250   CONTINUE
        IF ( I .EQ. 2 ) IER = 9
        IF ( IER .GT. 0 ) GO TO 710
C-----------------------------------------------------------------------
C  A B-AXIS MIRROR
C-----------------------------------------------------------------------
        CALL SGRMAT(RT(1,1,N),1,0,0,0,-1,0,0,0,1)
        RT(2,4,N) = D(2,2)
        IF ( I .EQ. 1 .OR. I .EQ. 5 ) RT(1,4,N) = 0.5
        IF ( I .EQ. 3 .OR. I .EQ. 5 ) RT(3,4,N) = 0.5
        GO TO 560
  260   IF ( L(1,3) .EQ. 14 .OR. L(1,2) .EQ. 15 ) GO TO 280
C-----------------------------------------------------------------------
C  IT IS NOT CUBIC OR TETRAGONAL
C-----------------------------------------------------------------------
        IF ( L(1,2) .EQ. 14 .OR. L(1,2) .EQ. 17 ) GO TO 280
C-----------------------------------------------------------------------
C  IT IS NOT TRIGONAL OR HEXAGONAL
C-----------------------------------------------------------------------
  270   CONTINUE
        IF ( I .EQ. 3 ) IER = 10
        IF ( IER .GT. 0 ) GO TO 710
C-----------------------------------------------------------------------
C  A C-AXIS MIRROR
C-----------------------------------------------------------------------
        CALL SGRMAT(RT(1,1,N),1,0,0,0,1,0,0,0,-1)
        RT(3,4,N) = D(3,3)
        IF ( I .EQ. 1 .OR. I .EQ. 5 ) RT(1,4,N) = 0.5
        IF ( I .EQ. 2 .OR. I .EQ. 5 ) RT(2,4,N) = 0.5
        IF ( M .NE. 2 .OR. L(1,2) .NE. 17) GO TO 560
C-----------------------------------------------------------------------
C  IF THIS A 63-AXIS THE MIRROR IS AT 1/4
C-----------------------------------------------------------------------
        IF ( L(2,2) .EQ. 14 ) RT(3,4,N) = 0.5
        GO TO 560
  280   CONTINUE
C-----------------------------------------------------------------------
C  A DIAGONAL MIRRROR PERPENDICULAR TO -110
C-----------------------------------------------------------------------
        CALL SGRMAT(RT(1,1,N),0,1,0,1,0,0,0,0,1)
        RT(1,4,N) = D(2,2)
        RT(2,4,N) = -D(2,2)
        IF ( I .EQ. 3 .OR. I .EQ. 5 ) RT(3,4,N) = 0.5
        IF ( LAUENO .EQ. 7 .AND. I .EQ. 3 ) GO TO 290
        IF ( I .EQ. 3 .OR. I .EQ. 4 ) GO TO 560
  290   CONTINUE
        IF ( LCENT .EQ. 6 .OR. LCENT .EQ. 4 ) GO TO 300
        RT(1,4,N) = 0.5+RT(1,4,N)
        RT(2,4,N) = 0.5+RT(2,4,N)
        GO TO 560
  300   CONTINUE
C-----------------------------------------------------------------------
C  EITHER F OR C-CENTERED TETRAGONAL. GLIDES ARE 1/4,1/4
C-----------------------------------------------------------------------
        RT(1,4,N) = 0.25+RT(1,4,N)
        RT(2,4,N) = 0.25+RT(2,4,N)
        GO TO 560
  310   CONTINUE
        IF ( LAUENO .EQ. 7 ) GO TO 280
C-----------------------------------------------------------------------
C  MIRROR NORMAL TO (1000) IN HEX CELL
C-----------------------------------------------------------------------
        CALL SGRMAT(RT(1,1,N),-1,1,0,0,1,0,0,0,1)
        IF ( I .EQ. 3 ) RT(3,4,N) = 0.5
  320   CONTINUE
        GO TO 560
C-----------------------------------------------------------------------
C    D TYPE MIRROR
C-----------------------------------------------------------------------
  330   CONTINUE
        IF ( LCENT .LE. 1 ) IER = 11
        IF ( IER .GT. 0 ) GO TO 710
        GO TO (710,340,350,360),M
  340   IF ( LAUENO .GT. 3 ) GO TO 370
        IF ( K .EQ. 2 ) GO TO 350
        CALL SGRMAT(RT(1,1,N),-1,0,0,0,1,0,0,0,1)
        IF ( ID .EQ. 2 ) RT(1,4,N) = 0.25
        RT(2,4,N) = 0.25
        RT(3,4,N) = 0.25
        GO TO 560
  350   CONTINUE
        CALL SGRMAT(RT(1,1,N),1,0,0,0,-1,0,0,0,1)
        RT(1,4,N) = 0.25
        IF ( ID .EQ. 2 ) RT(2,4,N) = 0.25
        IF ( LAUENO .EQ. 5 ) RT(2,4,N) = D(2,1)
        RT(3,4,N) = 0.25
        GO TO 560
  360   IF ( L(1,2) .EQ. 15 .OR. L(1,3) .EQ. 14 ) GO TO 380
C-----------------------------------------------------------------------
C  IT IS NOT TETRAGONAL OR CUBIC
C-----------------------------------------------------------------------
  370   CONTINUE
        CALL SGRMAT(RT(1,1,N),1,0,0,0,1,0,0,0,-1)
        RT(1,4,N) = 0.25
        RT(2,4,N) = 0.25
        IF ( ID .EQ. 2 ) RT(3,4,N) = 0.25
        GO TO 560
  380   CONTINUE
C-----------------------------------------------------------------------
C  CUBIC OR TETRAGONAL. D-GLIDE ALONG DIAGONAL
C-----------------------------------------------------------------------
        CALL SGRMAT(RT(1,1,N),0,1,0,1,0,0,0,0,1)
        RT(1,4,N) = 0.25
        RT(2,4,N) = 0.25
        RT(3,4,N) = 0.25
        IF (L(1,3) .NE. 13) GO TO 320
        RT(1,4,N) = 0.0
        RT(2,4,N) = 0.5
        GO TO 560
C-----------------------------------------------------------------------
C    1 FOLD ROTATION
C-----------------------------------------------------------------------
  390   IF ( L(2,M) .NE. 3 ) GO TO 680
C-----------------------------------------------------------------------
C  WE HAVE A CENTER OF SYMMETRY
C-----------------------------------------------------------------------
        NCENT = 1
        GO TO 680
C-----------------------------------------------------------------------
C    2 FOLD ROTATION AXIS
C-----------------------------------------------------------------------
  400   CONTINUE
C-----------------------------------------------------------------------
C  WE WILL NOT ALLOW A -2 AXIS.
C-----------------------------------------------------------------------
        IF ( L(2,M) .EQ. 3 ) IER = 19
        IF ( IER .GT. 0 ) GO TO 710
        GO TO (710,410,420,440),M
  410   IF ( K .EQ. 2 ) GO TO 430
        CONTINUE
C-----------------------------------------------------------------------
C  ROTATION ABOUT THE A-AXIS. (ORTHOGONAL CELL)
C-----------------------------------------------------------------------
        CALL SGRMAT(RT(1,1,N),1,0,0,0,-1,0,0,0,-1)
        RT(2,4,N) = D(2,1)
        RT(3,4,N) = D(3,1)
        IF ( IABS(L(2,M)-13) .EQ. 1 ) RT(1,4,N) = 0.5
        GO TO 560
  420   CONTINUE
        IF ( L(1,2) .EQ. 14 ) GO TO 460
        IF ( L(1,2) .EQ. 17 ) GO TO 450
C-----------------------------------------------------------------------
C  IT IS NOT A HEXAGONAL OR TRIGONAL SPACE GROUP
C-----------------------------------------------------------------------
  430   CONTINUE
C-----------------------------------------------------------------------
C  ROTATION ABOUT THE B-AXIS
C-----------------------------------------------------------------------
        CALL SGRMAT(RT(1,1,N),-1,0,0,0,1,0,0,0,-1)
        RT(1,4,N) = D(1,2)
        RT(3,4,N) = D(3,2)
        IF ( L(2,M) .EQ. 12 ) RT(2,4,N) = 0.5
        GO TO 560
  440   IF ( L(1,2) .GE. 14   ) GO TO 490
        IF ( L(1,3) .EQ. 14 ) GO TO 490
        CONTINUE
        CALL SGRMAT(RT(1,1,N),-1,0,0,0,-1,0,0,0,1)
        RT(1,4,N) = D(1,3)
        RT(2,4,N) = D(2,3)
        IF ( IABS(L(2,M)-13) .EQ. 1 ) RT(3,4,N) = 0.5
        IF (   L(2,M) .EQ. 16    ) RT(3,4,N) = 0.5
        GO TO 560
  450   CONTINUE
        IF ( L(1,4) .EQ. 12 ) GO TO 460
C-----------------------------------------------------------------------
C  2-AXIS NORMAL TO (-2110)
C     USED FOR THE P 6N22 GROUPS
C-----------------------------------------------------------------------
        CALL SGRMAT(RT(1,1,N),1,-1,0,0,-1,0,0,0,-1)
        GO TO 560
  460   CONTINUE
        IF ( LAUENO .EQ. 7 ) GO TO 480
  470   CONTINUE
C-----------------------------------------------------------------------
C  2-AXIS ALONG TO (11-20) TRIG  AND (110) TETRAG
C     USED FOR THE P 3N21 GROUPS
C-----------------------------------------------------------------------
        CALL SGRMAT(RT(1,1,N),0,1,0,1,0,0,0,0,-1)
        RT(1,4,N) = D(2,1)
        IF ( L(2,M) .EQ. 12 ) RT(1,4,N) = RT(1,4,N)+0.5
        RT(2,4,N) = -D(2,1)
        RT(3,4,N) = D(3,1)
        GO TO 560
  480   CONTINUE
C-----------------------------------------------------------------------
C  2-AXIS NORMAL TO (110)
C-----------------------------------------------------------------------
        CALL SGRMAT(RT(1,1,N),0,-1,0,-1,0,0,0,0,-1)
        GO TO 560
  490   CONTINUE
        IF ( L(1,2) .EQ. 15 ) GO TO 470
C-----------------------------------------------------------------------
C  2-AXIS NORMAL TO (10-10)
C-----------------------------------------------------------------------
        CALL SGRMAT(RT(1,1,N),1,0,0,1,-1,0,0,0,-1)
        GO TO 560
C-----------------------------------------------------------------------
C    3 FOLD ROTATION
C-----------------------------------------------------------------------
  500   GO TO (710,510,390,710),M
  510   CONTINUE
        IF ( LAUENO .LE. 7 ) GO TO 390
        CALL SGRMAT(RT(1,1,N),0,-1,0,1,-1,0,0,0,1)
        IF ( L(2,M) .EQ. 12 ) RT(3,4,N) = 0.33333333
        IF ( L(2,M) .EQ. 13 ) RT(3,4,N) = 0.66666667
        IF ( L(2,2) .EQ. 3 ) NCENT = 1
        GO TO 560
  520   CONTINUE
C-----------------------------------------------------------------------
C  FOUR FOLD AXIS
C-----------------------------------------------------------------------
        IF ( M .NE. 2 ) IER = 12
        IF ( IER .GT. 0 ) GO TO 710
        IF ( L(2,2) .EQ. 3 ) GO TO 530
        CALL SGRMAT(RT(1,1,N),0,-1,0,1,0,0,0,0,1)
        RT(1,4,N) = D(1,3)
        RT(2,4,N) = D(2,3)
        IF ( L(2,2) .EQ. 12 ) RT(3,4,N) = 0.25
        IF ( L(2,2) .EQ. 13 ) RT(3,4,N) = 0.5
        IF ( L(2,2) .EQ. 14 ) RT(3,4,N) = 0.75
        GO TO 560
  530   CONTINUE
        CALL SGRMAT(RT(1,1,N),0,1,0,-1,0,0,0,0,-1)
        RT(1,4,N) = D(1,3)
        RT(2,4,N) = D(2,3)
        RT(3,4,N) = D(3,3)
        GO TO 560
  540   CONTINUE
C-----------------------------------------------------------------------
C  6-AXIS
C-----------------------------------------------------------------------
        IF ( M .NE. 2 ) IER = 13
        IF ( IER .GT. 0 ) GO TO 710
        IF ( L(2,2) .EQ. 3 ) GO TO 550
        CALL SGRMAT(RT(1,1,N),1,-1,0,1,0,0,0,0,1)
        IF ( L(2,2) .GT. 11 .AND. L(2,2) .LT. 18 ) RT(3,4,N) = (L(2,2)-
     $   11)/6.0
        GO TO 560
  550   CONTINUE
        CALL SGRMAT(RT(1,1,N),-1,1,0,-1,0,0,0,0,-1)
        IF ( L(1,3) .EQ. 2 .OR. L(1,4) .EQ. 2 ) RT(3,4,N) = 0.5
  560   CONTINUE
        RT(1,4,N) = AMOD(RT(1,4,N)+5.0,1.0)
        RT(2,4,N) = AMOD(RT(2,4,N)+5.0,1.0)
        RT(3,4,N) = AMOD(RT(3,4,N)+5.0,1.0)
        RT(5,2,N) = 1728*RT(1,4,N)+144*RT(2,4,N)+12*RT(3,4,N)
          DO 580 M2 = 1,N-1
          IF ( RT(5,1,M2) .EQ. RT(5,1,N) ) GO TO 570
          IF ( RT(5,1,M2) .NE. -RT(5,1,N) ) GO TO 580
          NCENT = 1
  570     CONTINUE
          IF ( RT(5,2,N) .NE. RT(5,2,M2) ) GO TO 670
          GO TO 680
  580     CONTINUE
        N = N+1
        IF ( N .GT. 25 ) IER = 14
        IF ( IER .GT. 0 ) GO TO 710
  590   CONTINUE
        IDENT = 0
        NXL = N-1
        IF ( NXL .LT. NXI ) GO TO 640
          DO 630 NX = NXI,NXL
            DO 620 M1 = 2,NX
            CALL SGMTML(RT,M1,RT,NX,RT,N)
              DO 610 M2 = 1,N-1
              IF ( RT(5,1,N) .EQ. RT(5,1,M2) ) GO TO 600
              IF ( -RT(5,1,N) .NE. RT(5,1,M2) ) GO TO 610
              NCENT = 1
  600         CONTINUE
              GO TO 620
  610         CONTINUE
            N = N+1
            IF ( N .GT. 25 ) IER = 15
            IF ( IER .GT. 0 ) GO TO 710
  620       CONTINUE
          IF ( N-1 .EQ. NXL ) GO TO 640
  630     CONTINUE
        NXI = NXL+1
        GO TO 590
  640   CONTINUE
        IF ( L(1,M) .LT. 12 ) GO TO 680
C-----------------------------------------------------------------------
C  SEARCH FOR A / TO INDICATE A MIRROR PERPENDICULAR TO THIS AXIS
C-----------------------------------------------------------------------
        IF ( L(2,M) .EQ. 3 ) GO TO 680
          DO 650 I = 2,3
          IF ( L(I,M) .EQ. 0 ) GO TO 680
          IF ( L(I,M) .EQ. 19 ) GO TO 660
          IF ( L(I,M) .LT. 12 ) IER = 16
          IF ( IER .GT. 0 ) GO TO 710
  650     CONTINUE
        GO TO 680
  660   IF ( L(I+1,M) .LE. 1 ) IER = 17
        IF ( IER .GT. 0 ) GO TO 710
        I = IABS(L(I+1,M)-5)
        GO TO 200
  670   CONTINUE
        CALL SGTRCF(M,RT,N,M2,LCENT,LAUENO,IER,LPTX)
        IF ( IER .GT. 0 ) IERX = IER
        IER = 0
  680   CONTINUE
      NSYM = N-1
        DO 700 I = 1,3
          DO 700 K = 1,NSYM
            DO 690 J = 1,3
            JRT(I,J,K) = RT(I,J,K)
  690       CONTINUE
          JRT(I,4,K) = 12*RT(I,4,K)+144.1
          JRT(I,4,K) = JRT(I,4,K)-12*(JRT(I,4,K)/12)
  700     CONTINUE
      CALL SGPRNT(SPG,JRT,LAUENO,NAXIS,NCENT,LCENT,NSYM,NPOL,CEN,NCV,
     $ LPT)
C
C
C
C
      IF ( IERX .EQ. 0 ) RETURN
      IER = IERX
  710 CONTINUE
      IF ( LPTX .GT. 0 ) CALL SGERRS(SPG,IER,LPTX)
      NAXIS = 4
      RETURN
      END
C
C
CODE FOR SGLATC
      SUBROUTINE SGLATC(K,L,D,LCENT,NCENT,LAUENO,NAXIS
     $  ,LPT,IER,I209,ID)
C-----------------------------------------------------------------------
C  SPACE GROUP LATTICE AND OPERATOR INTERPRETATION
C-----------------------------------------------------------------------
C
      DIMENSION D(3,3),L(4,4)
C-----------------------------------------------------------------------
C  NOW LET US DETERMINE THE LAUE GROUP AND UNIQUE AXIS IF MONOCLINIC
C-----------------------------------------------------------------------
      IF ( K-3 ) 100,180,190
  100 CONTINUE
C-----------------------------------------------------------------------
C  ONLY 2 FIELDS WERE READ
C-----------------------------------------------------------------------
      IF ( L(1,2) .EQ. 17 ) GO TO 120
      IF ( L(1,2) .EQ. 14 ) GO TO 130
      IF ( L(1,2) .EQ. 15 ) GO TO 140
      IF ( L(1,2) .EQ. 12 ) GO TO 170
C-----------------------------------------------------------------------
C  2/M, B-AXIS UNIQUE
C-----------------------------------------------------------------------
      IM = 2
      GO TO 350
  110 CONTINUE
C-----------------------------------------------------------------------
C  WE HAVE SOMETHING LIKE P 6N 1 *
C-----------------------------------------------------------------------
      IF ( L(1,4) .NE. 12 ) GO TO 460
  120 CONTINUE
C-----------------------------------------------------------------------
C  6/M
C-----------------------------------------------------------------------
      LAUENO = 11
      GO TO 620
  130 CONTINUE
C-----------------------------------------------------------------------
C  3BAR
C-----------------------------------------------------------------------
      LAUENO = 8
      GO TO 620
  140 CONTINUE
C-----------------------------------------------------------------------
C  4/M
C-----------------------------------------------------------------------
      LAUENO = 4
C-----------------------------------------------------------------------
C  IS IT I-CENTERED OR F-CENTERED?
C-----------------------------------------------------------------------
      IF ( LCENT .GE. 5 ) GO TO 150
C-----------------------------------------------------------------------
C  IS IT C-CENTERED?
C-----------------------------------------------------------------------
      IF ( LCENT .EQ. 4 ) GO TO 160
C-----------------------------------------------------------------------
C  NO.  IS THERE A N-GLIDE NORMAL TO C?
C-----------------------------------------------------------------------
      IF ( L(3,2) .EQ. 10 ) GO TO 520
      IF ( L(4,2) .EQ. 10 ) D(2,3) = 0.5
C-----------------------------------------------------------------------
C  NO. OK LET'S GET ON WITH THIS.
C-----------------------------------------------------------------------
      GO TO 620
  150 CONTINUE
C-----------------------------------------------------------------------
C  IS THERE EITHER AN A-GLIDE OR A D-GLIDE NORMAL TO C?
C-----------------------------------------------------------------------
      IF ( L(4,2) .NE. 4 .AND. L(4,2) .NE. 11 ) GO TO 530
C-----------------------------------------------------------------------
C  YES.
C-----------------------------------------------------------------------
      D(1,3) = 0.75
      IF ( LCENT .EQ. 5 ) D(2,3) = 0.25
      GO TO 620
  160 CONTINUE
C-----------------------------------------------------------------------
C  C-CENTERED 4/M TETRAGONAL
C  IF THERE IS NO A-GLIDE NORMAL TO C WE ARE THROUGH
C-----------------------------------------------------------------------
      IF ( L(3,2) .NE. 4 .AND. L(4,2) .NE. 4 ) GO TO 620
      D(1,3) = 0.25
      D(2,3) = 0.25
      IF ( L(4,2) .EQ. 4 ) D(2,3) = 0.75
      GO TO 620
  170 CONTINUE
C-----------------------------------------------------------------------
C  1BAR
C-----------------------------------------------------------------------
      LAUENO = 1
      GO TO 620
  180 CONTINUE
C-----------------------------------------------------------------------
C  3 FIELDS WERE READ.  MUST BE M3 CUBIC. (R3R HAS BEEN TAKEN CARE OF)
C-----------------------------------------------------------------------
      IF ( L(1,3) .NE. 14 ) IER = 20
      IF ( IER .GT. 0 ) GO TO 630
      LAUENO = 13
C-----------------------------------------------------------------------
C  SET THE B-AXIS TRANSLATION FLAG IF A 21 ALONG A
C-----------------------------------------------------------------------
      IF ( L(2,2) .EQ. 12 ) D(2,1) = 0.5
C-----------------------------------------------------------------------
C  SET THE C-AXIS TRANSLATION FLAG IF AN A-GLIDE NORMAL TO C
C-----------------------------------------------------------------------
      IF ( L(1,2) .EQ. 3 .OR. L(1,2) .EQ. 4 ) D(3,3) = 0.5
      GO TO 610
C-----------------------------------------------------------------------
C  FOUR FIELDS WERE READ
C-----------------------------------------------------------------------
  190 IF ( L(1,3) .EQ. 14 ) GO TO 390
C-----------------------------------------------------------------------
C  IT IS NOT CUBIC
C-----------------------------------------------------------------------
      IF ( L(1,2) .EQ. 17 ) GO TO 450
C-----------------------------------------------------------------------
C  IT IS NOT HEXAGONAL
C-----------------------------------------------------------------------
      IF ( L(1,2) .EQ. 14 ) GO TO 470
C-----------------------------------------------------------------------
C  IT IS NOT TRIGONAL
C-----------------------------------------------------------------------
      IF ( L(1,2) .EQ. 15 ) GO TO 480
C-----------------------------------------------------------------------
C  IT IS NOT TETRAGONAL
C-----------------------------------------------------------------------
      IF ( L(1,2) .EQ. 12 ) GO TO 340
      IF ( L(1,3) .EQ. 12 ) GO TO 360
C-----------------------------------------------------------------------
C  IT MAY BE ORTHORHOMBIC
C-----------------------------------------------------------------------
  200 CONTINUE
C-----------------------------------------------------------------------
C  IT IS ORTHORHOMBIC
C-----------------------------------------------------------------------
      LAUENO = 3
C-----------------------------------------------------------------------
C  SET UP COUNTS OF THE VARIOUS TYPES OF MIRRORS.
C-----------------------------------------------------------------------
      IM = 0
      IR = 0
      IA = 0
      IB = 0
      IC = 0
      ID = 0
      I21 = 0
C-----------------------------------------------------------------------
C  DO WE HAVE A 2-AXIS ALONG A
C-----------------------------------------------------------------------
      IF ( L(1,2) .NE. 13 ) GO TO 210
C-----------------------------------------------------------------------
C  YES, IS IT A 21?
C-----------------------------------------------------------------------
      IF ( L(2,2) .NE. 12 ) GO TO 220
      D(1,2) = 0.5
      D(1,3) = 0.5
      I21 = 4
      GO TO 220
  210 CONTINUE
      IR = 1
      IF ( L(1,2) .EQ. 9 ) IM = 4
      IF ( L(1,2) .EQ. 3 ) IB = 1
      IF ( L(1,2) .EQ. 2 ) IC = 1
      IF ( L(1,2) .EQ. 11 ) ID = 1
      IF ( L(1,3) .EQ. 4 .OR. L(1,3) .EQ. 10 ) D(1,1) = 0.5
      IF ( L(1,4) .EQ. 4 .OR. L(1,4) .EQ. 10 ) D(1,1) = D(1,1)+0.5
  220 CONTINUE
C-----------------------------------------------------------------------
C  DO WE HAVE A 2-AXIS ALONG B
C-----------------------------------------------------------------------
      IF ( L(1,3) .NE. 13 ) GO TO 230
C-----------------------------------------------------------------------
C  YES, IS IT A 21?
C-----------------------------------------------------------------------
      IF ( L(2,3) .NE. 12 ) GO TO 240
      D(2,1) = 0.5
      D(2,3) = 0.5
      I21 = I21+2
      GO TO 240
  230 CONTINUE
      IR = IR+1
      IF ( L(1,3) .EQ. 9 ) IM = IM+2
      IF ( L(1,3) .EQ. 4 ) IA = 1
      IF ( L(1,3) .EQ. 2 ) IC = IC+1
      IF ( L(1,3) .EQ. 11 ) ID = ID+1
      IF ( L(1,2) .EQ. 3 .OR. L(1,2) .EQ. 10 ) D(2,2) = 0.5
      IF ( L(1,4) .EQ. 3 .OR. L(1,4) .EQ. 10 ) D(2,2) = D(2,2)+0.5
  240 CONTINUE
C-----------------------------------------------------------------------
C  DO WE HAVE A 2-AXIS ALONG C
C-----------------------------------------------------------------------
      IF ( L(1,4) .NE. 13 ) GO TO 250
C-----------------------------------------------------------------------
C  YES, IS IT A 21?
C-----------------------------------------------------------------------
      IF ( L(2,4) .NE. 12 ) GO TO 260
      D(3,1) = 0.5
      D(3,2) = 0.5
      I21 = I21+1
      GO TO 260
  250 CONTINUE
      IR = IR+1
      IF ( L(1,4) .EQ. 9 ) IM = IM+1
      IF ( L(1,4) .EQ. 4 ) IA = IA+1
      IF ( L(1,4) .EQ. 3 ) IB = IB+1
      IF ( L(1,4) .EQ. 11 ) ID = ID+1
      IF ( L(1,2) .EQ. 2 .OR. L(1,2) .EQ. 10 ) D(3,3) = 0.5
      IF ( L(1,3) .EQ. 2 .OR. L(1,3) .EQ. 10 ) D(3,3) = D(3,3)+0.5
  260 CONTINUE
C-----------------------------------------------------------------------
C  IF THERE ARE 3 MIRRORS CHECK FOR CENTERING
C     WHICH MAY ALTER THE ORIGIN LOCATION
C-----------------------------------------------------------------------
      IF ( IR .EQ. 3 ) GO TO 300
C-----------------------------------------------------------------------
C  LESS THAN 3 MIRRORS. SET UP THE 2-AXES LOCATIONS
C-----------------------------------------------------------------------
      IF ( I21 .EQ. 4 .OR. I21 .EQ. 5 .OR. I21 .EQ. 7 ) D(1,2) = 0.0
      IF ( I21 .EQ. 6 .OR. I21 .EQ. 7 ) D(1,3) = 0.0
      IF ( I21 .EQ. 3 ) D(2,1) = 0.0
      IF ( I21 .EQ. 2 .OR. I21 .EQ. 6 .OR. I21 .EQ. 7 ) D(2,3) = 0.0
      IF ( I21 .EQ. 1 .OR. I21 .EQ. 3 .OR. I21 .EQ. 7 ) D(3,1) = 0.0
      IF ( I21 .EQ. 5 ) D(3,2) = 0.0
      IF ( IM .LE. 0 ) GO TO 620
      IF ( IM .EQ. 1 .AND. (I21 .EQ. 4 .OR. I21 .EQ. 2)) GO TO 270
      IF ( IM .EQ. 2 .AND. (I21 .EQ. 4 .OR. I21 .EQ. 1)) GO TO 280
      IF ( IM .EQ. 4 .AND. (I21 .EQ. 2 .OR. I21 .EQ. 1)) GO TO 290
      GO TO 620
  270 CONTINUE
      IF ( D(3,3) .EQ. 0.0 ) GO TO 620
      D(3,3) = 0.0
      D(3,2) = D(3,2)+0.5
      GO TO 620
  280 CONTINUE
      IF ( D(2,2) .EQ. 0.0 ) GO TO 620
      D(2,2) = 0.0
      D(2,1) = D(2,1)+0.5
      GO TO 620
  290 CONTINUE
      IF ( D(1,1) .EQ. 0.0 ) GO TO 620
      D(1,1) = 0.0
      D(1,3) = D(1,3)+0.5
      GO TO 620
  300 CONTINUE
C-----------------------------------------------------------------------
C  3 MIRRORS PRESENT.  IS THE LATTICE CENTERED?
C-----------------------------------------------------------------------
      IF ( LCENT .EQ. 1 ) GO TO 620
C-----------------------------------------------------------------------
C  YES.  IS IT A-CENTERED?
C-----------------------------------------------------------------------
      IF ( LCENT .EQ. 2 ) GO TO 310
C-----------------------------------------------------------------------
C  NO.   IS IT B=CENTERED?
C-----------------------------------------------------------------------
      IF ( LCENT .EQ. 3 ) GO TO 320
C-----------------------------------------------------------------------
C  NO.  IS IT C-CENTERED?
C-----------------------------------------------------------------------
      IF ( LCENT .EQ. 4 ) GO TO 330
C-----------------------------------------------------------------------
C  NO.   IS IT I-CENTERED?
C-----------------------------------------------------------------------
      IF ( LCENT .NE. 5 ) GO TO 620
C-----------------------------------------------------------------------
C  YES.  IF ONLY 1 GLIDE PLANE SHIFT THE MIRRORS BY I
C-----------------------------------------------------------------------
      IF ( IA+IB+IC .NE. 1 ) GO TO 620
      D(1,1) = D(1,1)+0.5
      D(2,2) = D(2,2)+0.5
      D(3,3) = D(3,3)+0.5
      GO TO 620
  310 CONTINUE
C-----------------------------------------------------------------------
C  AN A-CENTERED LATTICE.
C   IF ONLY ONE B OR C GLIDE PRESENT RELOCATE THE MIRRORS BY A
C-----------------------------------------------------------------------
      IF ( IB+IC .NE. 1 ) GO TO 620
      IF ( IA .EQ. 2 ) GO TO 620
      D(2,2) = D(2,2)+0.5
      D(3,3) = D(3,3)+0.5
      GO TO 620
  320 CONTINUE
C-----------------------------------------------------------------------
C  A B-CENTERED LATTICE
C-----------------------------------------------------------------------
      IF ( IA+IC .NE. 1 ) GO TO 620
      IF ( IB .EQ. 2 ) GO TO 620
      D(1,1) = D(1,1)+0.5
      D(3,3) = D(3,3)+0.5
      GO TO 620
  330 CONTINUE
C-----------------------------------------------------------------------
C  A C-CENTERED LATTICE
C-----------------------------------------------------------------------
      IF ( IA+IB .NE. 1 ) GO TO 620
      IF ( IC .EQ. 2 ) GO TO 620
      D(1,1) = D(1,1)+0.5
      D(2,2) = D(2,2)+0.5
      GO TO 620
  340 IF ( L(1,3) .EQ. 12 ) GO TO 370
C-----------------------------------------------------------------------
C  IT IS NOT C-AXIS UNIQUE MONOCLINIC
C-----------------------------------------------------------------------
      IF ( L(1,4) .NE. 12 ) GO TO 200
      IM = 3
  350 CONTINUE
C-----------------------------------------------------------------------
C  IT IS B-AXIS UNIQUE MONOCLINIC. (FULL SYMBOL USED)
C-----------------------------------------------------------------------
      LAUENO = 2
      NAXIS = 2
      IA = 4
      IC = 2
      NA = 1
      NB = 2
      NC = 3
      GO TO 380
  360 IF ( L(1,4) .NE. 12 ) GO TO 200
C-----------------------------------------------------------------------
C  IT IS A-AXIS UNIQUE MONOCLINIC
C-----------------------------------------------------------------------
      LAUENO = 2
      NAXIS = 1
      IA = 3
      IC = 2
      NA = 2
      NB = 1
      NC = 3
      IM = 2
      GO TO 380
  370 IF ( L(1,4) .EQ. 12 ) GO TO 170
C-----------------------------------------------------------------------
C  IT IS C-AXIS UNIQUE MONOCLINIC
C-----------------------------------------------------------------------
      LAUENO = 2
      NAXIS = 3
      IA = 4
      IC = 3
      NA = 1
      NB = 3
      NC = 2
      IM = 4
  380 CONTINUE
      IF ( L(2,IM) .EQ. 12 ) D(NB,NAXIS) = 0.5
      IF ( L(3,IM) .EQ. IA .OR. L(3,IM) .EQ. 10 ) D(NA,NAXIS) = 0.5
      IF ( L(3,IM) .EQ. IC .OR. L(3,IM) .EQ. 10 ) D(NC,NAXIS) = 0.5
      IF ( L(4,IM) .EQ. IA .OR. L(4,IM) .EQ. 10 ) D(NA,NAXIS) = 0.5
      IF ( L(4,IM) .EQ. IC .OR. L(4,IM) .EQ. 10 ) D(NC,NAXIS) = 0.5
      GO TO 620
  390 CONTINUE
C-----------------------------------------------------------------------
C  IT IS M3M CUBIC
C-----------------------------------------------------------------------
      LAUENO = 14
C-----------------------------------------------------------------------
C  SET THE C-AXIS TRANSLATION FLAG IF AN A-GLIDE NORMAL TO C
C-----------------------------------------------------------------------
      IF ( L(1,2) .EQ. 3 .OR. L(1,2) .EQ. 4 ) D(3,3) = 0.5
C-----------------------------------------------------------------------
C  IS A 4N-AXIS SPECIFIED
C-----------------------------------------------------------------------
      IF ( L(1,2) .NE. 15 ) GO TO 610
C-----------------------------------------------------------------------
C  YES.  IS IT 4BAR?
C-----------------------------------------------------------------------
      IF ( L(2,2) .EQ. 3 ) GO TO 400
C-----------------------------------------------------------------------
C  NO.  IS IT A 4?
C-----------------------------------------------------------------------
      IF ( L(2,2) .LT. 12 ) GO TO 610
      IF ( L(2,2) .GT. 14 ) GO TO 610
C-----------------------------------------------------------------------
C  NO. IS IT A 41?
C-----------------------------------------------------------------------
      IF ( L(2,2) .EQ. 12 ) GO TO 410
C-----------------------------------------------------------------------
C  NO. IS IT A 42?
C-----------------------------------------------------------------------
      IF ( L(2,2) .EQ. 13 ) GO TO 420
C-----------------------------------------------------------------------
C  NO.  IT MUST BE A 43
C  P 43 3 2
C-----------------------------------------------------------------------
      IF ( LCENT .EQ. 6 ) GO TO 430
      D(1,3) = 0.75
      D(2,3) = 0.25
      GO TO 610
  400 CONTINUE
C-----------------------------------------------------------------------
C  4B.  IS IT 4B 3 M
C-----------------------------------------------------------------------
      IF ( L(1,4) .EQ. 9 ) GO TO 610
C-----------------------------------------------------------------------
C  NO.  IS IT 4B 3 D?
C-----------------------------------------------------------------------
      IF ( L(1,4) .EQ. 11 ) GO TO 440
C-----------------------------------------------------------------------
C  NO.
C-----------------------------------------------------------------------
      D(1,3) = 0.5
      D(2,3) = 0.5
      D(3,3) = 0.5
      GO TO 610
  410 CONTINUE
C-----------------------------------------------------------------------
C  41-AXIS. IS IT F 41 3 2?
C-----------------------------------------------------------------------
      IF ( LCENT .EQ. 6 ) GO TO 430
C-----------------------------------------------------------------------
C  NO. IT IS EITHER P 41 3 2 OR I 41 3 2
C-----------------------------------------------------------------------
      D(1,3) = 0.25
      D(2,3) = -0.25
      GO TO 610
  420 CONTINUE
C-----------------------------------------------------------------------
C  P 42 3 2
C-----------------------------------------------------------------------
      D(1,3) = 0.5
      D(2,3) = 0.5
      GO TO 610
  430 CONTINUE
C-----------------------------------------------------------------------
C  F 41 3 2
C-----------------------------------------------------------------------
      D(1,3) = 0.25
      D(2,3) = 0.25
      GO TO 610
  440 CONTINUE
C-----------------------------------------------------------------------
C  I 4B 3 D WE HOPE
C-----------------------------------------------------------------------
      IF ( LCENT .NE. 5 ) IER = 21
      IF ( IER .GT. 0 ) GO TO 630
      D(1,3) = 0.75
      D(2,3) = 0.25
      D(3,3) = 0.75
      GO TO 610
  450 CONTINUE
      IF ( L(1,3) .EQ. 12 ) GO TO 110
  460 CONTINUE
C-----------------------------------------------------------------------
C  IT IS HEXAGONAL 6/MMM
C-----------------------------------------------------------------------
      LAUENO = 12
      GO TO 620
  470 CONTINUE
C-----------------------------------------------------------------------
C  IT IS TRIGONAL P3**
C-----------------------------------------------------------------------
      IF ( L(1,3) .EQ. 12 ) GO TO 600
      IF ( L(1,4) .NE. 12 ) GO TO 460
C-----------------------------------------------------------------------
C  IT IS TRIGONAL 3M1
C-----------------------------------------------------------------------
      LAUENO = 9
      GO TO 620
  480 CONTINUE
C-----------------------------------------------------------------------
C  IT IS TETRAGONAL 4/MMM
C-----------------------------------------------------------------------
      LAUENO = 5
C-----------------------------------------------------------------------
C  IF THERE IS AN N-GLIDE NORMAL TO C PLACE ANY
C         MIRROR NORMAL TO A AT 1/4
C-----------------------------------------------------------------------
      IF ( L(3,2) .EQ. 10 .OR. L(4,2) .EQ. 10 ) D(1,1) = 0.5
C-----------------------------------------------------------------------
C  IF THERE IS AN A-GLIDE NORMAL TO C PLACE ANY
C         MIRROR NORMAL TO (110) AT 1/4
C-----------------------------------------------------------------------
      IF ( L(3,2) .EQ. 4 .OR. L(4,2) .EQ. 4 ) D(2,2) = 0.25
C-----------------------------------------------------------------------
C  IF THERE IS A 21 ALONG B MOVE PLACE IT AT X=1/4
C-----------------------------------------------------------------------
      IF ( L(1,3) .EQ. 13 .AND. L(2,3) .EQ. 12 ) D(1,2) = 0.5
C-----------------------------------------------------------------------
C  IF THERE IS A 21 ALONG (110) MOVE PLACE IT AT X=1/4
C       IF ( L(1,4).EQ.13.AND.L(2,4).EQ.12 ) D(2,1)=0.5
C  IF THERE IS EITHER A B- OR N-GLIDE NORMAL TO THE A-AXIS
C         SHIFT THE MIRROR BY 1/4 ALONG THE A-AXIS
C-----------------------------------------------------------------------
      IF ( L(1,3) .EQ. 3 .OR. L(1,3) .EQ. 10 ) D(1,1) = D(1,1)+0.5
C-----------------------------------------------------------------------
C  IF THERE IS EITHER A B- OR N-GLIDE NORMAL TO (110)
C         SHIFT THE MIRROR BY 1/4 ALONG THE A-AXIS
C-----------------------------------------------------------------------
      IF ( L(1,4) .EQ. 3 .OR. L(1,4) .EQ. 10 ) D(2,2) = D(2,2)+0.25
C-----------------------------------------------------------------------
C  SET THE Z LOCATION FOR 2-AXES ALONG (110)
C-----------------------------------------------------------------------
      IF ( L(2,2) .GT. 11 .AND. L(2,2) .LT. 15 .AND. L(2,3) .NE. 12 ) D
     $ (3,1) = -(L(2,2)-11)/4.0
C-----------------------------------------------------------------------
C  SET THE Z-TRANSLATION FOR 21-AXES ALONG (110)
C-----------------------------------------------------------------------
      IF ( L(1,4) .EQ. 13 .AND. L(2,4) .NE. 12 ) GO TO 490
      IF ( L(2,2) .GT. 11 .AND. L(2,2) .LT. 15 ) D(3,1) = (L(2,2)-11)/
     $ 4.0
  490 CONTINUE
C-----------------------------------------------------------------------
C  SET THE Z-TRANSLATION FOR 21-AXES ALONG B
C-----------------------------------------------------------------------
      IF ( L(1,3) .EQ. 13 .AND. L(2,3) .NE. 12 ) GO TO 500
      IF ( L(2,2) .GT. 11 .AND. L(2,2) .LT. 15 ) D(3,2) = (L(2,2)-11)/
     $ 4.0
  500 CONTINUE
C-----------------------------------------------------------------------
C  PLACE THE D IN F 4* D * AT Y=7/8
C-----------------------------------------------------------------------
      IF ( L(1,3)+L(3,2) .EQ. 11 .AND. LCENT .EQ. 6 ) D(2,1) = 0.75
C-----------------------------------------------------------------------
C  SET POSITION OF M IN F 4** * * AT X=1/8 IF THERE IS A C ALONG (110)
C-----------------------------------------------------------------------
      IF ( L(1,4) .EQ. 2 .AND. LCENT .EQ. 6 ) D(1,1) = 0.5
C-----------------------------------------------------------------------
C IS THIS A 4BAR?
C-----------------------------------------------------------------------
      IF ( L(2,2) .EQ. 3 ) GO TO 560
C-----------------------------------------------------------------------
C IS THE LATTICE PRIMATIVE?
C-----------------------------------------------------------------------
      IF ( LCENT .GT. 1 ) GO TO 530
C-----------------------------------------------------------------------
C  YES.  DO WE HAVE A N-GLIDE NORMAL TO C?
C-----------------------------------------------------------------------
      IF ( L(3,2) .EQ. 10 .OR. L(4,2) .EQ. 10 ) GO TO 520
C-----------------------------------------------------------------------
C  NO.  DO WE HAVE A 21 ALONG B?
C-----------------------------------------------------------------------
      IF ( L(1,3) .EQ. 13 .AND. L(2,3) .EQ. 12 ) GO TO 510
C-----------------------------------------------------------------------
C  NO. DO WE HAVE A N-GLIDE NORMAL TO A?
C-----------------------------------------------------------------------
      IF ( L(1,3) .NE. 10 ) GO TO 620
      IF ( L(2,2) .LE. 0 ) GO TO 620
      IF ( L(2,2) .GT. 15 ) GO TO 620
  510 CONTINUE
      D(1,3) = 0.5
      D(2,3) = 0.5
      GO TO 620
  520 CONTINUE
C-----------------------------------------------------------------------
C  P 4N/N * *
C-----------------------------------------------------------------------
      D(1,3) = 0.5
      GO TO 620
  530 CONTINUE
C-----------------------------------------------------------------------
C  IS THE LATTICE I OR F-CENTERED?
C-----------------------------------------------------------------------
      IF ( LCENT .LT. 5 ) GO TO 550
C-----------------------------------------------------------------------
C  YES.
C  IF THERE IS A C ALONG (110) PLACE THE D AT Y=1/4
C-----------------------------------------------------------------------
      IF ( L(1,4) .EQ. 2 ) D(2,1) = D(2,1)+0.5
C-----------------------------------------------------------------------
C  IS THIS I 41/A * * OR F 41/D * * ?
C-----------------------------------------------------------------------
      IF ( L(4,2) .NE. 4 .AND. L(4,2) .NE. 11 ) GO TO 540
C-----------------------------------------------------------------------
C  YES.
C-----------------------------------------------------------------------
      D(1,3) = 0.25
      IF ( LCENT .EQ. 5 ) D(2,3) = 0.75
      GO TO 620
  540 CONTINUE
C-----------------------------------------------------------------------
C  IS THERE A 41 PRESENT?
C-----------------------------------------------------------------------
      IF ( L(2,2) .NE. 12 ) GO TO 620
C-----------------------------------------------------------------------
C  YES.
C  IF F-CENTERED GO TO 1558
C-----------------------------------------------------------------------
      IF ( LCENT .EQ. 6 ) GO TO 580
      D(2,3) = 0.5
C-----------------------------------------------------------------------
C  SET THE B-AXIS TRANSLATION FLAGS FOR I 41 2 2
C-----------------------------------------------------------------------
      GO TO 570
  550 CONTINUE
C-----------------------------------------------------------------------
C  IS THE LATTICE C-CENTERED?
C-----------------------------------------------------------------------
      IF ( LCENT .NE. 4 ) IER = 23
      IF ( IER .GT. 0 ) GO TO 630
C-----------------------------------------------------------------------
C  C-CENTERED.  AN A NORMAL TO C
C-----------------------------------------------------------------------
      IF ( L(3,2) .EQ. 4 .OR. L(4,2) .EQ. 4 ) GO TO 590
C-----------------------------------------------------------------------
C       IF ( L(3,2).EQ.0 ) D(1,1)=2.0*D(2,2)+D(1,1)
C-----------------------------------------------------------------------
      IF ( D(1,1) .EQ. 0.0 ) D(1,1) = 2.0*D(2,2)
C-----------------------------------------------------------------------
C    IS THERE A 21 ON THE DIAGONAL?
C-----------------------------------------------------------------------
      IF ( L(1,4) .EQ. 13 .AND. L(2,4) .EQ. 12 ) GO TO 520
      IF ( L(2,2) .LE. 0 ) GO TO 620
C-----------------------------------------------------------------------
C  IS THERE A N-GLIDE NORMAL TO (110)?
C-----------------------------------------------------------------------
      IF ( L(1,4) .NE. 10 ) GO TO 620
      IF ( L(2,2) .GT. 15 ) GO TO 620
      D(1,1) = D(1,1)-2.0*D(2,2)
      GO TO 520
  560 CONTINUE
C-----------------------------------------------------------------------
C  ACCOUNT FOR TRANSLATIONS DUE TO DIAGONAL SYMMETRY OPERATION
C  IF F 4B D 2 WE WANT THE 2 AT Z=1/8
C-----------------------------------------------------------------------
      IF ( L(1,3) .EQ. 11 .AND. LCENT .EQ. 6 ) D(3,1) = 0.25
C-----------------------------------------------------------------------
C  IF * 4B * 21 WE WANT THE MIRROR AT X=1/4
C-----------------------------------------------------------------------
      IF ( L(1,4) .EQ. 13 .AND. L(2,4) .EQ. 12 ) D(1,1) = 0.5
C-----------------------------------------------------------------------
C  IF THERE IS A C- OR A N-GLIDE ALONG (110) SET THE 2-AXIS AT Z=1/4
C-----------------------------------------------------------------------
      IF ( L(1,4) .EQ. 2 .OR. L(1,4) .EQ. 10 ) D(3,2) = 0.5
C-----------------------------------------------------------------------
C  IF THERE IS A B- OR A N-GLIDE ALONG (110) SET THE 2 AT X=1/4
C-----------------------------------------------------------------------
      IF ( L(1,4) .EQ. 3 .OR. L(1,4) .EQ. 10 ) D(1,2) = 0.5
      IF ( L(1,4) .NE. 11 ) GO TO 620
  570 CONTINUE
      IF ( LCENT .EQ. 5 ) D(1,2) = 0.5
      D(3,2) = 0.75
      GO TO 620
  580 CONTINUE
C-----------------------------------------------------------------------
C  F 41 * *
C-----------------------------------------------------------------------
      D(1,3) = 0.25
      D(2,3) = 0.75
      GO TO 620
  590 CONTINUE
C-----------------------------------------------------------------------
C  C 4* /A * *
C-----------------------------------------------------------------------
      D(1,3) = 0.25
      D(2,3) = 0.25
      IF ( L(1,4) .EQ. 3 .OR. L(1,4) .EQ. 10 ) D(1,1) = 0.5
      GO TO 620
  600 CONTINUE
C-----------------------------------------------------------------------
C  IT IS TRIGONAL 31*
C-----------------------------------------------------------------------
      IF ( L(1,4) .EQ. 12 ) GO TO 130
C-----------------------------------------------------------------------
C  IT IS TRIGONAL 31M
C-----------------------------------------------------------------------
      LAUENO = 10
      GO TO 620
  610 CONTINUE
      I209 = 1
  620 CONTINUE
      RETURN
  630 CONTINUE
      IF ( IER .EQ. 0 ) IER = 5
      RETURN
      END
C
C
CODE FOR SGTRCF
      SUBROUTINE SGTRCF(M,RT,N,M2,LCENT,LAUENO,IER,LPT)
      DIMENSION RT(5,4,25)
      DIMENSION ICENV(3,5),NCVT(7),JCVT(7)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      DATA ICENV/0,0,0,0,6,6,6,0,6,6,6,0,6,6,6/
      DATA NCVT/1,2,3,4,5,4,1/
      DATA JCVT/1,1,2,3,4,1,1/
      IER = 0
      IRN = RT(5,2,N)
      IRM = RT(5,2,M2)
      IRX = MOD((IRN/144+IRM/144),12)
      IRY = MOD((IRN/12 +IRM/12 ),12)
      IRZ = MOD(IRN+IRM,12)
      NCV = NCVT(LCENT)
      JCV = JCVT(LCENT)
        DO 120 ICV = 1,NCV,JCV
        IRX1 = MOD(IRX+ICENV(1,ICV),12)
        IRY1 = MOD(IRY+ICENV(2,ICV),12)
        IRZ1 = MOD(IRZ+ICENV(3,ICV),12)
C-----------------------------------------------------------------------
C  DOES THIS PAIR MAKE A 1BAR?
C-----------------------------------------------------------------------
        M2Z = M2
        IF ( RT(5,1,N)+RT(5,1,M2) .EQ. 0 ) M2Z = 1
C-----------------------------------------------------------------------
C  NO.
C-----------------------------------------------------------------------
        IF ( RT(3,3,N)+RT(3,3,M2Z) .LE. 0 ) IRZ1 = 0
C-----------------------------------------------------------------------
C  IS THIS AN OPERATOR OPERATING ALONG THE FACE DIAGONAL?
C-----------------------------------------------------------------------
        IF ( LAUENO .LE. 3 .OR. M .NE. 4 ) GO TO 100
C-----------------------------------------------------------------------
C  YES.
C-----------------------------------------------------------------------
        IRX1 = MOD(IRX1+IRY1,12)
        IRY1 = 0
        GO TO 110
  100   CONTINUE
C-----------------------------------------------------------------------
C  NO.
C-----------------------------------------------------------------------
        IF ( RT(1,1,N)+RT(1,1,M2Z) .LE. 0 ) IRX1 = 0
        IF ( RT(2,2,N)+RT(2,2,M2Z) .LE. 0 ) IRY1 = 0
  110   CONTINUE
        TOTTR = 144*IRX1+12*IRY1+IRZ1
        IF ( TOTTR .EQ. 0 ) RETURN
  120   CONTINUE
      CONTINUE
C
C -- ERROR
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,10000) RT(5,2,N),RT(5,2,M2),TOTTR,IRX,
     2 IRY,IRZ,RT(5,1,N),RT(5,1,M2)
      ENDIF
      WRITE (NCAWU,10000) RT(5,2,N),RT(5,2,M2),TOTTR,IRX,
     2 IRY,IRZ,RT(5,1,N),RT(5,1,M2)
10000 FORMAT (3F10.1,3I5,2F10.1)
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,11000) M,N,M2
      ENDIF
      WRITE (NCAWU,11000) M,N,M2
11000 FORMAT (1X,'Operator',I2,' generates matrix',I3,
     2 ' which has a translation conflict',2I3)
C
      IER = 18
C
C
      RETURN
      END
C
C
C
CODE FOR SGLPAK
      SUBROUTINE SGLPAK(L,IER)
      DIMENSION L(4)
      IF ( L(2) .LT. 12 ) IER = 4
      IF ( L(2) .GT. 17 ) IER = 4
      L(1) = L(2)
      L(2) = 3
      RETURN
      END
C
C
C
CODE FOR SGERRS
      SUBROUTINE SGERRS(SGP,IER,LPT)
      DIMENSION SGP(10)
C
      CHARACTER *52 CMESSG(25)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      DATA CMESSG(1)  /
     2 'Either a 5-axis anywhere or a 3-axis in field 4' /
      DATA CMESSG(2)  / 'Less than 2 operator fields were found' /
      DATA CMESSG(3)  /
     2 'Lattice operator was not a P, A, B, C, I, F or R' /
      DATA CMESSG(4)  / 'Rhombohedral lattice without a 3-axis' /
      DATA CMESSG(5)  / 'Minus sign does not precede 1, 2, 3, 4 or 6 ' /
      DATA CMESSG(6)  / 'Lattice S. R. found an error'/
      DATA CMESSG(7)  /
     2 '1st operator in a field was a space. Impossible' /
      DATA CMESSG(8)  / 'I for computed GO TO out of range' /
      DATA CMESSG(9) / 'An a-glide mirror normal to a' /
      DATA CMESSG(10) / 'A b-glide mirror normal  to b' /
      DATA CMESSG(11) / 'A c-glide mirror normal  to c' /
      DATA CMESSG(12) / 'A d-glide in a primitive lattice' /
      DATA CMESSG(13) / 'A 4-axis not in the 2nd operator field' /
      DATA CMESSG(14) / 'A 6-axis not in the 2nd operator field' /
      DATA CMESSG(15) /
     2 'More than 24 matrices needed to define the group' /
      DATA CMESSG(16) /
     2 'More than 24 matrices needed to define the group' /
      DATA CMESSG(17) / 'Improper construction of a rotation operator' /
      DATA CMESSG(18) / 'No mirror following a /' /
      DATA CMESSG(19) / 'A translation conflict between operators' /
      DATA CMESSG(20) / 'The 2bar operator is not allowed' /
      DATA CMESSG(21) /
     2 '3 fields are legal only in R lattices and m3 cubic' /
      DATA CMESSG(22) / 'Syntax error. Expected I-43d at this point' /
      DATA CMESSG(23) / '**** THERE IS NO ERROR MESSAGE 23 ****' /
      DATA CMESSG(24) / 'A or B centered tetragonal?  Impossible!!!!' /
      DATA CMESSG(25) / 'No delimiter blanks in symbol. Try again. '/
C
C
C
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,10000) SGP, CMESSG(IER+1)
      ENDIF
      WRITE (NCAWU,10000) SGP, CMESSG(IER+1)
10000 FORMAT (1X,'Error while processing space group symbol ',10A1,/,
     2 1X,A)
C
C
      CALL XERHND ( IERERR )
C
C
      RETURN
      END
C
C
C
CODE FOR SGPRNT
      SUBROUTINE SGPRNT (SPG,JRT,LAUENO,NAXIS,NCENT,LCENT,NSYM,NPOL,CEN,
     $                   NCV,LPT)
C-----------------------------------------------------------------------
C  SPACE GROUP ROUTINE PRINTING
C-----------------------------------------------------------------------
      DIMENSION SPG(10),JRT(3,4,25),CEN(3,4),NCVT(7),CENV(3,6),NSYS(14)
      CHARACTER*3 XYZ(12),TRA(11),OUTL(3,2,3),POLAR(8)
      CHARACTER*4 LTYP(3,7),SYST(3,8),LAUE(2,14)
      CHARACTER*1 NAX(3),NC(2)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      DATA XYZ/'-z','-y','-x','x-y','Err','y-x',' x',' y',' z','+x',
     $         '+y','+z'/
      DATA TRA/'   ','Err','1/6','1/4','1/3','Err','1/2','Err','2/3',
     $         '3/4','5/6'/
      DATA LTYP/'  Pr','imit','ive ',
     $          ' A-C','ente','red ',' B-C','ente','red ',
     $          ' C-C','ente','red ',' I-C','ente','red ',
     $          ' F-C','ente','red ',' R-C','ente','red '/
      DATA SYST/'Tric','lini','c   ','Mono','clin','ic  ',
     $          'Orth','orho','mbic','Tetr','agon','al  ',
     $          'Rhom','bohe','dral','Trig','onal','    ',
     $          'Hexa','gona','l   ','Cubi','c   ','    '/
      DATA LAUE/'1bar','    ','2/m ','    ','mmm ','    ','4/m ','    ',
     $          '4/mm','m   ','3bar','    ','3bar',' M  ','3bar','    ',
     $          '3bar','m 1 ','3bar','1 m ','6/m ','    ','6/mm','m   ',
     $          'M 3 ','    ','M 3 ','M   '/
      DATA POLAR/'x','y','x y','z','x z','y z','xyz','111'/
      DATA NAX/'a','b','c'/
      DATA NSYS/1,2,3,4,4,5,5,6,6,6,7,7,8,8/
      DATA NC/'A',' '/
      DATA NCVT/1,2,2,2,2,4,3/
      DATA CENV/  0,0.5,0.5,  0.5,0,0.5,  0.5,0.5,0,  0.5,0.5,0.5,
     $      0.3333333,0.6666667,0.6666667,0.6666667,0.3333333,0.3333333/
      NCV = NCVT(LCENT)
      MULT = NCV*NSYM*(NCENT + 1)
      LSYS = NSYS(LAUENO)
      CEN(1,1) = 0.0
      CEN(2,1) = 0.0
      CEN(3,1) = 0.0
      IF (NCV .LE. 1) GO TO 110
      J = LCENT - 1
      IF (LCENT .EQ. 6) J = 1
      IF (LCENT .EQ. 7) J = 5
        DO 100 I = 2,NCV
        CEN(1,I) = CENV(1,J)
        CEN(2,I) = CENV(2,J)
        CEN(3,I) = CENV(3,J)
        J = J + 1
  100   CONTINUE
  110 CONTINUE
      NPX = 1
      NPY = 2
      NPZ = 4
      NPXYZ = 0
      NPYXZ = 1
        DO 120 I = 1,NSYM
        IF (JRT(1,1,I) .LE. 0) NPX = 0
        IF (JRT(2,2,I) .LE. 0) NPY = 0
        IF (JRT(3,3,I) .LE. 0) NPZ = 0
        IF (JRT(1,3,I) .GT. 0) NPXYZ = 8
        IF (JRT(1,3,I) .LT. 0) NPYXZ = 0
  120   CONTINUE
      NPOL = (NPX + NPY + NPZ + NPXYZ*NPYXZ)*(1 - NCENT)
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,10000) SPG,NC(NCENT + 1),
     $                  LTYP(1,LCENT),LTYP(2,LCENT),LTYP(3,LCENT),
     $                  SYST(1,LSYS),SYST(2,LSYS),SYST(3,LSYS),
     $                  LAUE(1,LAUENO),LAUE(2,LAUENO),MULT
      ENDIF
      WRITE (NCAWU,10000) SPG,NC(NCENT + 1),
     $                  LTYP(1,LCENT),LTYP(2,LCENT),LTYP(3,LCENT),
     $                  SYST(1,LSYS),SYST(2,LSYS),SYST(3,LSYS),
     $                  LAUE(1,LAUENO),LAUE(2,LAUENO),MULT
      IF (NAXIS .GT. 0) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE (NCWU,11000) NAX(NAXIS)
      ENDIF
        WRITE (NCAWU,11000) NAX(NAXIS)
      ENDIF
      IF (NPOL  .GT. 0) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE (NCWU,12000) POLAR(NPOL)
      ENDIF
        WRITE (NCAWU,12000) POLAR(NPOL)
      ENDIF
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,13000)
      ENDIF
      WRITE (NCAWU,13000)
10000 FORMAT (1X,' Space Group ',10A1/
     $        '  The Space Group is ',A1,'Centric',6A4,
     $        '  Laue Symmetry ',2A4/
     $        '  Multiplicity of a General Site is',I4)
11000 FORMAT ('  The Unique Axis is ',A1)
12000 FORMAT ('  The location of the origin is arbitrary in ',A3)
13000 FORMAT (1X,' The Equivalent Positions are:'/)
      KI = 1
      KL = 2
      IF (LAUENO .GT. 5) KL = 3
        DO 140 I = 1,NSYM
          DO 130 J = 1,3
          IJ = 2*JRT(J,1,I) + 3*JRT(J,2,I) + 4*JRT(J,3,I) + 5
          IK = JRT(J,4,I) + 1
          IF (IK .GT. 1 .AND. IJ .GT. 5) IJ = IJ + 3
          OUTL(J,2,KI) = XYZ(IJ)
          OUTL(J,1,KI) = TRA(IK)
  130     CONTINUE
        KI = KI + 1
        IF (KI .LE. KL) GO TO 140
      IF (ISSPRT .EQ. 0) THEN
        WRITE (NCWU,15000)
     $        ((OUTL(I1,1,K),OUTL(I1,2,K),I1 = 1,3),K = 1,KL)
      ENDIF
        WRITE (NCAWU,15000)
     $        ((OUTL(I1,1,K),OUTL(I1,2,K),I1 = 1,3),K = 1,KL)
        KI = 1
  140   CONTINUE
      IF (LAUENO .EQ. 1) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE (NCWU,15000)
     $  (OUTL(I,1,1),OUTL(I,2,1),I = 1,3)
      ENDIF
        WRITE (NCAWU,15000)
     $  (OUTL(I,1,1),OUTL(I,2,1),I = 1,3)
      ENDIF
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,14000)
      ENDIF
      WRITE (NCAWU,14000)
      RETURN
14000 FORMAT (' ')
15000 FORMAT (3(2X,3(1X,2A3)))
      END
C
C
C
CODE FOR SGMTML
      SUBROUTINE SGMTML(X,I,Y,J,Z,K)
      DIMENSION X(5,4,25),Y(5,4,25),Z(5,4,25)
        DO 100 L = 1,4
          DO 100 M = 1,4
          Z(L,M,K) = 0.0
            DO 100 N = 1,4
            Z(L,M,K) = Z(L,M,K)+Y(L,N,J)*X(N,M,I)
  100       CONTINUE
      Z(1,4,K) = AMOD(5.0+Z(1,4,K),1.0)
      Z(2,4,K) = AMOD(5.0+Z(2,4,K),1.0)
      Z(3,4,K) = AMOD(5.0+Z(3,4,K),1.0)
      Z(5,1,K) = 81*(2*Z(1,1,K)+3*Z(1,2,K)+4*Z(1,3,K))+9*(2*Z(2,1,K)+3*
     $ Z(2,2,K)+4*Z(2,3,K))+2*Z(3,1,K)+3*Z(3,2,K)+4*Z(3,3,K)
      Z(5,2,K) = 1728*Z(1,4,K)+144*Z(2,4,K)+12*Z(3,4,K)
      Z(5,3,K) = 0.0
      Z(5,4,K) = 0.0
      CONTINUE
      RETURN
      END
C
C
C
CODE FOR SGRMAT
      SUBROUTINE SGRMAT(RT,A,B,C,D,E,F,G,H,O)
      INTEGER A,B,C,D,E,F,G,H,O
      DIMENSION RT(5,4)
      RT(1,1) = A
      RT(1,2) = B
      RT(1,3) = C
      RT(1,4) = 0.0
      RT(2,1) = D
      RT(2,2) = E
      RT(2,3) = F
      RT(2,4) = 0.0
      RT(3,1) = G
      RT(3,2) = H
      RT(3,3) = O
      RT(3,4) = 0.0
      RT(4,1) = 0.0
      RT(4,2) = 0.0
      RT(4,3) = 0.0
      RT(4,4) = 1.0
      RT(5,1) = 81*(2*RT(1,1)+3*RT(1,2)+4*RT(1,3))+9*(2*RT(2,1)+3*RT(2,
     $ 2)+4*RT(2,3))+2*RT(3,1)+3*RT(3,2)+4*RT(3,3)
      RT(5,2) = 1728*RT(1,4)+144*RT(2,4)+12*RT(3,4)
      RT(5,3) = 10.0
      RT(5,4) = 20.
      RETURN
      END
C
C
CODE FOR XCONOP
      SUBROUTINE XCONOP( TXTIN, LIN, TXTOUT, LOUT)
C
C-----CONVERT FRACTIONAL SYMMETRY OPERATOR TO DECIMAL
C
C      TXTIN      TEXT OF FRACTIONAL OPERATOR (FROM XSUMOP)
C      LIN        LENGTH OF TEXT
C      TXTOUT     TEXT OF DECIMAL OPERATOR
C      LOUT       LENGTH OF TEXT
C
      CHARACTER *(*) TXTIN
      CHARACTER *(*) TXTOUT
      CHARACTER *8 CVALUE
      CHARACTER *3 CSIGN
      CHARACTER *1 CTERM
      CHARACTER *10 CNUM
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      DATA CSIGN / '--+' /
      DATA CNUM / '1234567890' /
C
C----- CLEAR BUFFER
      TXTOUT = ' '
      JIN = 1
      LOUT = 0
C
1000  CONTINUE
      JSIGN = (INDEX (CSIGN, TXTIN(JIN:JIN)))
      IF (JSIGN .LE. 0) THEN
            LOUT = LOUT + 1
            TXTOUT(LOUT:LOUT) = TXTIN(JIN:JIN)
            JIN = JIN + 1
      ELSE
            JIN = JIN + 1
            IF (INDEX( CNUM, TXTIN(JIN:JIN)) .GT. 0) THEN
                  JSIGN = JSIGN - 2
                  I = KGTNUM (TXTIN(JIN:LIN), CTERM, NCHAR)
                  JIN = JIN + NCHAR + 1
                  IF (I .LE. 0) GOTO 9000
                  IF (CTERM .NE. '/') GOTO 9000
                  J = KGTNUM (TXTIN(JIN:LIN), CTERM, NCHAR)
                  JIN = JIN + NCHAR + 1
                  IF (J .LE. 0) GOTO 9000
                  IF (CTERM .EQ. '/') GOTO 9000
                  VALUE = FLOAT( I * JSIGN) / FLOAT(J)
                  WRITE( CVALUE,'(SP,F7.4)') VALUE
                  I = LOUT + 1
                  LOUT = LOUT + 6
                  TXTOUT( I:LOUT) = CVALUE(1:7)
                  LOUT = LOUT + 1
                  TXTOUT( LOUT:LOUT ) = CTERM
            ELSE
                  LOUT = LOUT + 1
                  J = JIN - 1
                  TXTOUT(LOUT:LOUT) = TXTIN(J:J)
            ENDIF
      ENDIF
C
      IF (JIN .LE. LIN) GOTO 1000
      RETURN
9000  CONTINUE
      STOP 'XCONOP ERROR'
      END
C
C
CODE FOR CDFOUN
      SUBROUTINE CDFOUN (LAUE,ICEN,NEQV,NCV,ABC,JRT,CEN,SPG,
     1 RMI, RMA, JAXIS )
C-----------------------------------------------------------------------
C
C           NRCVAX Structure Package Fourier Unit Generator
C
C                            E. J. Gabe
C           Chemistry Division,  N. R. C.   Ottawa   Canada
C
C *********************************************************************
C * THIS ROUTINE MAY NOT BE REPRODUCED WITHOUT PERMISSION FROM N.R.C. *
C *********************************************************************
C
C  The routine generates the x, y and z limits of the portion of the
C  unit cell to be computed by a Fourier routine, in order to ensure
C  that at least one assymetric unit is computed.  The unit is computed
C  as a parallelepiped, with bounding surfaces parallel to cell faces.
C  this means that in higher symmetry space-groups there will be some
C  redundancy. This is unavoidable.
C
C  The routine functions by setting up a grid of test points within the
C  unit cell, spaced at fractions of a cell which depend on the Laue
C  group and which are chosen to be adequately small for that group.
C  The axes can be in any order and are represented symbolically by I1,
C  I2 and I3.  There are NX1, NX2 and NX3 points in each of the 3
C  directions.  NEQV is the number of equivalent positions (24 max),
C  ICENT is the centrosymmetric indicator (1 or 2) and NCV is the
C  number of lattice centring points (4 max).
C
C  The limits are found by generating all equivalents for each test
C     point, i.e. NEQV*ICENT*NCV equivs for each of NX1*NX2*NX3 points
C     and then finding the min (or max) value of the I3 coordinate.
C     The max Fourier limit is then the maximum of the minimum values.
C     The minimum value is found with the same procedure, but only using
C     those values less than the previously found maximum in the search
C     for the maximum remaining I3 coordinate for each test point.
C     The min Fourier limit is then the minimum of these maximum values.
C     I1, I2 and I3 are then rotated and the new I3 limits found, subect
C     to the constraints of the limit found for the previous I3
C     direction(s).
C
C  Because of the large number of points and equivs involved the
C  procedure can be quite lengthy for higher symmetry space-groups, but
C  for all commonly occurring groups it takes only a second or so.
C
C-----------------------------------------------------------------------
C----- CHANGES BY DJW, AFTER IUCR XV
C
C      USE REAL SPG IN CALL, AND COPY TO CHARACTER SGDUM
C      REPLACE INTEGER RT BY JRT
C      COMMON BLOCK FUNIT ADDED TO CALL ARGUMENT LIST
C
      DIMENSION ABC(3),JRT(3,4,24),CEN(3,4),NXYZ(3),MXYZ(3),IDXYZ(3),
     $  IDMXYZ(3),MA(3),MI(3),IAX(3,6),LET(3),RMIS(3),RMAS(3),
     $  JCEN(3,4),IRT(3,24),SPG(10),
     1  RMI(3),RMA(3), JAXIS(3)
      CHARACTER C1*2,C2*2,C3*2,LET*1,SGDUM*10
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      EQUIVALENCE (NXYZ(1),  NX),  (NXYZ(2),  NY),  (NXYZ(3),  NZ),
     $  (MXYZ(1),  MX),  (MXYZ(2),  MY),  (MXYZ(3),  MZ),
     $  (IDXYZ(1), IDX), (IDXYZ(2), IDY), (IDXYZ(3), IDZ),
     $  (IDMXYZ(1),IDMX),(IDMXYZ(2),IDMY),(IDMXYZ(3),IDMZ)
      DATA IAX/1,2,3, 3,1,2, 2,3,1, 3,2,1, 1,3,2, 2,1,3/
      DATA LET/'X','Y','Z'/
C----- CONVERT SYMBOL TO CHARACTER FORM
      WRITE(SGDUM,10000) SPG
10000 FORMAT(10A1)
C-----------------------------------------------------------------------
C  Initialize for the limit search
C-----------------------------------------------------------------------
      ICENT = ICEN + 1
      ICELL = 48
      ICELL2 = ICELL + ICELL
      ITRANS = ICELL/12
      DO 130 I = 1,NCV
        DO 120 J = 1,3
  120     JCEN(J,I) = ICELL*CEN(J,I) + 0.01
  130 CONTINUE
      DO 140 I = 1,NEQV
        DO 140 J = 1,3
  140   IRT(J,I) = ITRANS*JRT(J,4,I)
C-----------------------------------------------------------------------
C  Get the cell-search fractions depending on the Laue group as follows
C
C  Laue Group     Number      Nx  Ny  Nz         Comment
C      1             1         4   4   4     Triclinic
C     2/m            2         8   8   8     Monoclinic
C     mmm            3         8   8   8     Orthorhombic  (Fddd 16)
C     4/m            4         8   8  16     Tetragonal
C     4/mmm          5         8   8  16     Tetragonal
C     -3R            6         8   8   8     Rhombohedral
C     -3mR           7         8   8   8     Rhombohedral
C     -3             8        12  12  24     Hexagonal
C     -3m1           9        12  12  24     Hexagonal
C     -31m          10        12  12  24     Hexagonal
C     6/m           11        12  12  24     Hexagonal
C     6/mmm         12        12  12  24     Hexagonal
C     m3            13        16  16  16     Cubic
C     m3m           14        16  16  16     Cubic
C  The values for groups 8 and 9 are OK for the order X,Y,Z, if the 2
C  other orders are searched NX and NY should be 24
C-----------------------------------------------------------------------
      IF (LAUE .EQ.  1) NX = 4
      IF (LAUE .GE.  2 .AND. LAUE .LE.  7) NX =  8
      IF (SGDUM .EQ. 'F D D D') NX = 16
      IF (LAUE .GE.  8 .AND. LAUE .LE. 12) NX = 12
      IF (LAUE .EQ. 13 .OR.  LAUE .EQ. 14) NX = 16
      NY = NX
      NZ = NY
      IF (LAUE .GE.  4 .AND. LAUE .LE.  5) NZ = 16
      IF (LAUE .GE.  8 .AND. LAUE .LE. 12) NZ = 24
C-----------------------------------------------------------------------
C  Set up the test point and min/max steps
C-----------------------------------------------------------------------
      MX = NX/2
      MY = NY/2
      MZ = NZ/2
      IDX = ICELL/NX
      IDY = ICELL/NY
      IDZ = ICELL/NZ
      IDMX = ICELL/MX
      IDMY = ICELL/MY
      IDMZ = ICELL/MZ
C-----------------------------------------------------------------------
C  Section to generate the minimum values of a selected coordinate
C  I3 is the direction for which min/max values are being sought.
C  I1 and I2 are the directions for which min and max Fourier limits
C     may have already been found.  These are 0 and 1 at the start.
C
C  The IORD loop allows the axes to be searched in the 3 orders
C  X,Y,Z    Z,X,Y    Y,Z,X.   This will give all possible distinct
C  Fourier limits and in higher symmetry groups allows the routine to
C  find the minimum volume which contains the assymetric unit.
C
C  In the interests of speed only the order X,Y,Z is used.
C-----------------------------------------------------------------------
      RATMIN = 100.0
C     DO 300 IORD = 1,3
      DO 300 IORD = 1,1
        I1 = IAX(1,IORD)
        I2 = IAX(2,IORD)
        I3 = IAX(3,IORD)
        C1 = ' X'
        C2 = ' Y'
        C3 = ' Z'
        IF (I1 .EQ. 2) C1 = ' Y'
        IF (I1 .EQ. 3) C1 = ' Z'
        IF (I2 .EQ. 1) C2 = ' X'
        IF (I2 .EQ. 3) C2 = ' Z'
        IF (I3 .EQ. 1) C3 = ' X'
        IF (I3 .EQ. 2) C3 = ' Y'
        DO 150 I = 1,3
          MI(I) = 0
          MA(I) = ICELL
  150     CONTINUE
C-----------------------------------------------------------------------
C  First the loop for the 3 coordinates (ILIM)
C-----------------------------------------------------------------------
        DO 290 ILIM = 1,3
          NX1 = NXYZ(I1) - 1
          NX2 = NXYZ(I2) - 1
          NX3 = NXYZ(I3) - 1
          MAXLIM = NX3*IDXYZ(I3)
          MINLIM = IDXYZ(I3)
          MAI1 = MA(I1)
          MAI2 = MA(I2)
          MAI3 = MA(I3)
          MII1 = MI(I1)
          MII2 = MI(I2)
          MII3 = MI(I3)
C-----------------------------------------------------------------------
C  Now the loop for the min and max values of the I3 direction (IMM),
C  then the loops for the J1, J2 and J3 search directions
C-----------------------------------------------------------------------
          DO 280 IMM = 1,2
            MAX3 = 0
            MIN3 = ICELL
            DO 260 J1 = 1,NX1
              K1 = J1*IDXYZ(I1)
              DO 250 J2 = 1,NX2
                K2 = J2*IDXYZ(I2)
                DO 230 J3 = 1,NX3
                  K3 = J3*IDXYZ(I3)
C-----------------------------------------------------------------------
C  Generate all equivs of each test point K1,K2,K3 and from them find
C  the minimum and maximum I3 values, under the constraint that only I3
C  values for which the I1 and I2 values are within the present limits
C  on the I1 and I2 directions and that the I3 value is less than the
C  present I3 maximum limit.
C-----------------------------------------------------------------------
                  MINEQ = ICELL
                  MAXEQ = 0
                  DO 226 NE = 1,NEQV
                    NE1 = K1*JRT(I1,I1,NE) + K2*JRT(I1,I2,NE) +
     $                    K3*JRT(I1,I3,NE) +   IRT(I1,NE)
                    NE2 = K1*JRT(I2,I1,NE) + K2*JRT(I2,I2,NE) +
     $                    K3*JRT(I2,I3,NE) +   IRT(I2,NE)
                    NE3 = K1*JRT(I3,I1,NE) + K2*JRT(I3,I2,NE) +
     $                    K3*JRT(I3,I3,NE) +   IRT(I3,NE)
                    DO 224 NC = 1,NCV
                      KE1 = NE1 + JCEN(I1,NC)
                      KE2 = NE2 + JCEN(I2,NC)
                      KE3 = NE3 + JCEN(I3,NC)
                      DO 220 NIC = 1,ICENT
                        IF (NIC  .EQ.    2) KE1 = ICELL2 - KE1
                        IF (KE1 .LT.     0) KE1 = KE1 + ICELL
                        IF (KE1 .GT. ICELL) KE1 = KE1 - ICELL
                        IF (KE1 .GE. ICELL) KE1 = KE1 - ICELL
                        IF (KE1 .LT. MII1 .OR. KE1 .GT. MAI1) GO TO 220
                        IF (NIC  .EQ.    2) KE2 = ICELL2 - KE2
                        IF (KE2 .LT.     0) KE2 = KE2 + ICELL
                        IF (KE2 .GT. ICELL) KE2 = KE2 - ICELL
                        IF (KE2 .GE. ICELL) KE2 = KE2 - ICELL
                        IF (KE2 .LT. MII2 .OR. KE2 .GT. MAI2) GO TO 220
                        IF (NIC  .EQ.    2) KE3 = ICELL2 - KE3
                        IF (KE3 .LT.     0) KE3 = KE3 + ICELL
                        IF (KE3 .GT. ICELL) KE3 = KE3 - ICELL
                        IF (KE3 .GE. ICELL) KE3 = KE3 - ICELL
                        IF (KE3 .GT. MAI3) GO TO 220
                        IF (KE3 .LT. MINEQ) MINEQ = KE3
                        IF (KE3 .GT. MAXEQ) MAXEQ = KE3
  220                   CONTINUE
  224                 CONTINUE
  226               CONTINUE
                  IF (IMM .EQ. 1) THEN
                    IF (MINEQ .GT. MAX3) MAX3 = MINEQ
                    IF (MAX3 .GE. MAXLIM) GO TO 270
                  ELSE
                    IF (MAXEQ. LT. MIN3) MIN3 = MAXEQ
                    IF (MIN3 .LE. MINLIM) GO TO 270
                  ENDIF
  230             CONTINUE
  250           CONTINUE
  260         CONTINUE
  270       IF (IMM .EQ. 1) THEN
              MAX3 = IDMXYZ(I3)*((MAX3 + IDXYZ(I3))/IDMXYZ(I3))
              MA(I3) = MAX3
              MAI3 = MAX3
            ELSE
              MIN3 = IDMXYZ(I3)*(MIN3/IDMXYZ(I3))
              MI(I3) = MIN3
              MII3 = MIN3
            ENDIF
  280       CONTINUE
          R = MA(I3)
          RMA(I3) = R/ICELL
          R = MI(I3)
          RMI(I3) = R/ICELL
          I  = I3
          I3 = I2
          I2 = I1
          I1 = I
          MINEQ = MII3
          MAXEQ = MAI3
          MII3 = MII2
          MAI3 = MAI2
          MII2 = MII1
          MAI2 = MAI1
          MII1 = MINEQ
          MAI1 = MAXEQ
  290     CONTINUE
        ASSYM = NEQV*ICENT*NCV
        D1 = MA(I1) - MI(I1)
        D2 = MA(I2) - MI(I2)
        D3 = MA(I3) - MI(I3)
        FOUND = ICELL*ICELL*ICELL/(D1*D2*D3)
        RATIO = ASSYM/FOUND
C-----------------------------------------------------------------------
C  Triclinic, Monoclinic, Orthorhombic and Cubic are finished.
C  Tetragonal and Hexagonal are finished if Ratio = 1.0.
C  Otherwise find the minimum ratio.
C-----------------------------------------------------------------------
        IF (LAUE .LE. 3 .OR. LAUE .GE. 13) GO TO 310
        IF (RATIO .LT. 1.001) GO TO 310
        IF (RATIO .LT. RATMIN) THEN
          RATMIN = RATIO
          I1S = I1
          I2S = I2
          I3S = I3
          RMIS(I1) = RMI(I1)
          RMAS(I1) = RMA(I1)
          RMIS(I2) = RMI(I2)
          RMAS(I2) = RMA(I2)
          RMIS(I3) = RMI(I3)
          RMAS(I3) = RMA(I3)
          ENDIF
  300   CONTINUE
        I1 = I1S
        I2 = I2S
        I3 = I3S
        RMI(I1) = RMIS(I1)
        RMA(I1) = RMAS(I1)
        RMI(I2) = RMIS(I2)
        RMA(I2) = RMAS(I2)
        RMI(I3) = RMIS(I3)
        RMA(I3) = RMAS(I3)
C-----------------------------------------------------------------------
C  Work out the Fourier order from the limits
C-----------------------------------------------------------------------
  310 D1 = (RMA(I1) - RMI(I1))*ABC(I1)
      D2 = (RMA(I2) - RMI(I2))*ABC(I2)
      D3 = (RMA(I3) - RMI(I3))*ABC(I3)
C-----------------------------------------------------------------------
C  The shortest length is assigned to sections and the longest across
C-----------------------------------------------------------------------
      IF (D1 .LE. D2 .AND. D1 .LE. D3) THEN
        J3 = I1
        J2 = I2
        J1 = I3
        IF (D3 .GE. D2) THEN
          J2 = I3
          J1 = I2
        ENDIF
      ENDIF
      IF (D2 .LE. D1 .AND. D2 .LE. D3) THEN
        J3 = I2
        J2 = I1
        J1 = I3
        IF (D3 .GE. D1) THEN
          J2 = I3
          J1 = I1
        ENDIF
      ENDIF
      IF (D3 .LE. D2 .AND. D3 .LE. D1) THEN
        J3 = I3
        J2 = I1
        J1 = I2
        IF (D2 .GE. D1) THEN
          J2 = I2
          J1 = I1
        ENDIF
      ENDIF
C----- SAVE JAXIS
      JAXIS(1) = J1
      JAXIS(2) = J2
      JAXIS(3) = J3
      RETURN
      END
