CRYSTALS CODE FOR ABSORB
CODE FOR MABS
      FUNCTION MABS(IPOINT)
C--CALCULATE ABSORPTION CORRECTIONS
C
C     IPOINT = -1 FOR INITIATION
C            =  0 FOR PROCESSING
C            =  1 FOR TERMINATION
C
C----- ALL CORRRECTION CALCULATIONS ARE PERFORMED FOR A ROLLETT MACHINE
C      SEE COMPUTING METHODS IN CRYSTALLOGRAPHY, PAGE 28.
C      IN THIS MACHINE THE HORIZONTALINCIDENT BEAM IS Y, WITH THE +VE
C      SENSE BEING FROM THE CRYSTAL TOWARDS THE SOURCE. Z IS VERTICAL
C      WITH THE POSITIVE SENSE UPWARDS AND X COMPLETES A RIGHT HANDED
C      SYSTEM. ALL ROTATIONS ARE REGARDED AS BEING DERIVED FROM RIGHT
C      HANDED SCREWS, I.E. A +VE ROTATION ABOUT Z TAKES X INTO Y AND
C      ABOUT Y TAKES Z INTO X.
C
C       ALL DIFFRACTOMETER ANGLE CALCULATIONS ARE PERFORMED IN THE
C      COORDINATE SYSTEM DEFINED BY THE MANUFACTURERS, THUS FACILITATIN
C      THE CHECKING OF CODE. CONVERSIONS TO A ROLLETT MACHINE ARE DONE
C      IN THE SUBROUTINE WCVT , WHERE RULES ARE GIVEN FOR PERFORMING TH
C      COMVERSION.
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 30
      PARAMETER (IDIM30 = 32)
      DIMENSION ICOM30(IDIM30)
      DIMENSION ISTORE(131072)
      DIMENSION DIRCOS(3)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      COMMON /XABSW/A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,VV,W,X,Y,
     2 Z,DD(4)
      COMMON /XABSWK/IMODE,WAV,WAVSQ,IDIF,IDAT,IFF,IG,ALPHA,IR1,IR2,
     2 IR3,IR4,ISET,NPI,NPV,VK(3),UM(3,3),UB(3,3),V(3,2),FACT(10),
     3 BFACT(10),CFACT(10),THL,ISPC
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST6A/L6IMP,M6IMP,MD6IMP,N6IMP,L6MLT,M6MLT,MD6MLT,N6MLT,
     2 L6BMP,M6BMP,MD6BMP,N6BMP,L6IB,M6IB,MD6IB,N6IB,
     3 ITYPE6,IAPPND,DENSTY,IUNIT,MEDIUM,NCARDS,NGROUP,INCREM,
     4 LIDFK,MIDFK,MDIDFK,NIDFK,LODFK,MODFK,MDODFK,NODFK,
     5 LFACT,MFACT,MDFACT,NFACT,NSCALE,N6DEAD,IFO,JFO,
     6 IPRINT,ISQ,IPHI,ITHETA,ITUBE,IPLATE,IGAUSS,IHUBER,
     7 LPHI,MPHI,MDPHI,NPHI,LPHIC,MPHIC,MDPHIC,NPHIC,
     8 LPHID,MPHID,MDPHID,NPHID,IT,IT01,NTI,IT02,ITC,IT01C,NTIC,IT02C,
     9 ITU,MITU,MDITU,NITU,IPL,MPL,MDPL,NPL,WI,RANGE,ICHECK
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON/XLST27/L27,M27,MD27,N27
      COMMON/XLST30/
     1 L30DR,M30DR,MD30DR,N30DR, L30CD,M30CD,MD30CD,N30CD,
     2 L30RF,M30RF,MD30RF,N30RF, L30IX,M30IX,MD30IX,N30IX,
     3 L30AB,M30AB,MD30AB,N30AB, L30GE,M30GE,MD30GE,N30GE,
     4 L30CL,M30CL,MD30CL,N30CL, L30SH,M30SH,MD30SH,N30SH
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      COMMON /CAD/FCV(3),PD(3,3),QD(3,3),RD(3,3),SD(3,3),SI,CO,FKAP(3),
     2 FBIS(3),FPSI,FEUL(3),FHKL(3),CD(3,3),FLAM(3),DET,CON1,CON2,CON3
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (L30DR,ICOM30(1))
C
C
      EQUIVALENCE (FCV(1),FC1),(FCV(2),FC2),(FCV(3),FC3),(FBIS(1),
     2 FTHETA),(FBIS(2),FPHIB),(FBIS(3),FCHIB),(FEUL(1),FPHIE),(FEUL(2)
     3 ,FOME),(FEUL(3),FCHIE),(FKAP(1),FPHIK),(FKAP(2),FOMK),(FKAP(3),
     4 FKAPPA),(FHKL(1),FH),(FHKL(2),FK),(FHKL(3),FL)
C
      SAVE
C
      DATA IVERSN/202/
C
      MABS = -1
C--CHECK IF THIS AN INITIALISATION, CALCULATION OR TERMINATION CALL
      IF(IPOINT)1000,2000,6500
C----- CHECK THAT THE REQUIRED LISTS ATE LOADED
1000  CONTINUE
      IF (KHUNTR( 1 ,0,IDUM,JDUM,KDUM,-1) .NE. 0) GOTO 9900
      IF (KHUNTR( 13 ,0,IDUM,JDUM,KDUM,-1) .NE. 0) GOTO 9900
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--STORED BY ROWS SO MUST TRANSPOSE
      CALL MTRANS(STORE(L1O2))
      TLM=1.
      RT=90.*DTR
      WAV=STORE(L13DC)
      WAVSQ=WAV*WAV
      FLAM(1)=WAV
C--CONSTANTS FOR Y290
      THL=DTR*STORE(L13DC+6)
C--- CONSTANTS FOR CAD4
      CON1=STORE(L13DC+3)
      CON2=STORE(L13DC+4)
      CON3=STORE(L13DC+5)
C--- CLEAR MAXIMUM CORRECTIONS
      CALL XZEROF(FACT(1),10)
      CALL XZEROF(BFACT(1),10)
      DO 1200 I=1,10
C--- SET MINIMUM CORRECTIONS
      CFACT(I)=100000.
1200  CONTINUE
C--DETERMINE SETTING TYPE
      IDAT=ISTORE(L13DT+2)
C----- DETERMINE DIFFRACTOMETER TYPE
      IDIF=ISTORE(L13DT)-5
      IF(IDIF .LE. 0) GOTO 1250
C
C------ CHECK IF ANY CORRECTIONS ARE GIVEN
C----- CHECK IF ROD OR PLATE
      ISPEC = MAX0( ITUBE,IPLATE)
      IF (ISPEC) 1206,1206,1203
1203  CONTINUE
C----- SET DEFAULT ADDRESS FOR TUBE
      ISPC = ITU
      IF (ITUBE) 1204,1204,1252
C----- MOVE PLATE DETAILS INTO ROD SLOTS
1204  CONTINUE
C----- REGARD PLATE AS BEING 2 HALF PLATES
      STORE(IPL+5) = 0.5 * STORE(IPL+5)
      ISPC = IPL
      GOTO 1252
1206  CONTINUE
      IF(IPHI) 1201,1201,1252
1201  CONTINUE
      IF(ITHETA) 1202,1202,1252
1202  CONTINUE
C----- NOTHING GIVEN  - SET TYPE TO ZERO
      GOTO 1250
1250  CONTINUE
      IDIF=0
      GO TO 1900
1252  CONTINUE
C----- APPARATUS IS NOT PHOTOGRAPHIC ?
      IF(IDIF)1250,1250,1253
1253  CONTINUE
C----- IS SETTING DATA GIVEN ?
      IF(IDAT)1250,1250,1210
1210  CONTINUE
      IF(IDAT-8)1300,1300,1250
C--PHI CURVES
1300  CONTINUE
      WRITE(NCAWU,1301)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1301)
      ENDIF
1301  FORMAT (///,2X,' An absorption correction may be computed'/)
C--- CHECK IF PHI CORRECTION REQUESTED
      IFF=NFL
      IF(IPHI)1490,1490,1310
1310  CONTINUE
      LN=106
      IREC=4001
      NPI=MDPHI
      IQQ=KCHNFL(NPI+4)
      CALL XMOVE(STORE(LPHI),STORE(IFF  ),NPI)
      K=IFF+NPI
C--- EXTEND PHI VALUE CURVE BEYOND 180
      STORE(K  )=180.+STORE(IFF  )
      STORE(K+1)=180.+STORE(IFF+1)
      STORE(K+2)=180.+STORE(IFF+2)
      STORE(K+3)=180.+STORE(IFF+3)
      NPV=NPHIC
C--FORMAT H K L I E I(I)
C--NO. OF CURVES
C
      IREC=4002
C
      MPHID=LPHID
      MPHIC=LPHIC
      DO 1400 I=1,NPV
      J=NFL
      IQQ=KCHNFL(MDPHID+MDPHIC+5)
      CALL XMOVE(STORE(MPHIC),STORE(J),MDPHIC)
      J=J+MDPHIC+1
      CALL XMOVE(STORE(MPHID),STORE(J),MDPHID)
      J=J+MDPHID
C--- EXTEND INTENSITY VALUES CURVE
      CALL XMOVE(STORE(MPHID),STORE(J),4)
      MPHID=MPHID+MDPHID
      MPHIC=MPHIC+MDPHIC
1400  CONTINUE
      NPI=NPI+4
C
C
1490  CONTINUE
C--THETA CURVE
      IF(ITHETA)1800,1800,1600
1600  CONTINUE
C--CONVERT TO RADIANS
      CALL XMULTR(STORE(IT),DTR,STORE(IT),NTI)
1800  CONTINUE
C--- WORK MATRIX ADDRESSES
      IR1=NFL
      IR2=NFL+9
      IR3=NFL+18
      IR4=IR3+9
      IQQ=KCHNFL(36)
      IBUF=NFL
      LN=106
      IREC=5001
      IQQ=KCHNFL(MD6)
C--- PROCESS CORRECTION DATA
      CALL WPRCS
      IF ( IERFLG .LT. 0 ) GO TO 9900
1900  CONTINUE
C--END OF INITIALISATION
C---  INITIALISE OVERALL CORRECTION
      AFACT =1.
      MABS=0
      RETURN
C
C--COMPUTE THE CORRECTION FOR THE CURRENT REFLECTION
2000  CONTINUE
      MABS=-1
      AFACT=1.
      IF(IDIF)6300,6300,2050
2050  CONTINUE
      IMODE=0
      IF(STORE(M6+21)-.0001)2100,2100,2200
C--- THETA NOT SET - ANGLES TO BE CALCULATED
2100  CONTINUE
      IMODE=1
C----- CALCULATE THETA
2200  CONTINUE
      STH=STHETA(STORE(M6))
      CTH=SQRT(1.-STH*STH)
      TH=ATAN2(STH,CTH)
      GO TO (2400,2650,2700,2400,2300),IDIF
2300  CONTINUE
      STOP 2000
C--CAD4
2400  CONTINUE
      IF(IMODE)2500,2500,2600
C--COPY AND CONVERT ANGLES
2500  CONTINUE
      J=IBUF+21
      K=M6+21
      CALL WAIN(IDIF,J,K)
2550  CONTINUE
      CALL WCVT(IDIF,J,J)
2560  CONTINUE
      OM=STORE(J+1)
      CHI=STORE(J+2)
      PHI=STORE(J+3)
      GO TO 3200
C- CALCULATE ANGLES
2600  CONTINUE
      CALL XMOVE(STORE(M6),FHKL(1),3)
      CALL HTOW(1)
      CALL HTOW(2)
      J=IBUF +21
      STORE(J+1)=FBIS(1)
      STORE(J+2)=FBIS(3)
      STORE(J+3)=FBIS(2)
      GOTO 2550
C----- ROLLETT MACHINE
2650  CONTINUE
C--Y290
2700  CONTINUE
      IF(IMODE)2750,2750,2770
C----- COPY AND CONVERT ANGLES
2750  CONTINUE
      J=IBUF+21
      M=M6+21
      CALL WAIN(IDIF,J,K)
      GO TO 2560
2770  CONTINUE
C----- CALCULATE ANGLES
      OM=TH
      CALL XMLTMM(UB,STORE(M6),VK,3,3,1)
      CHI=ATAN2(VK(3),SQRT(VK(1)*VK(1)+VK(2)*VK(2)))
      PHI=ATAN2(-VK(2),VK(1))
       IF(TH-THL)3200,3200,2800
C--FIXED CHI
2800  CONTINUE
      IF(VK(3))3000,2900,2900
2900  CONTINUE
      OM=TH+CHI-RT
      CHI=RT
      PHI=PHI+RT
      GOTO 3100
3000  CONTINUE
      OM=TH-CHI-RT
      CHI=-RT
      PHI=PHI+RT
3100  CONTINUE
      GOTO 3200
C
C
C----- COMPUTE THE CORRECTIONS --------
C
C
3200  CONTINUE
      STORE(M6+22)=OM
      STORE(M6+23)=CHI
      STORE(M6+24)=PHI
C----- NOTE THAT ANGLES ARE NOW FOR A ROLLETT MACHINE.
C----- COMPUTING METHODS IN CRYSTALLOGRAPHY,PAGE 28
      SC=SIN(CHI)
      IF(IPHI)4600,4600,3400
C
C
C--PHI CORRECTIONS
3400  CONTINUE
C---  PROJECTION OF SCATTERING VECTOR ONTO PLANE
C---  PERPENDICULAR TO PHI AXIS
      AL=((1.+STH*STH*(SC*SC-2.))/(1.-STH*STH*SC*SC))
      IF(AL-1.)3600,3600,3500
3500  CONTINUE
      AL=1.
3600  CONTINUE
      AL=0.5*ACOS(AL)
      FACT(8)=AL
      EP=ABS(2.*STH*SC)
      K=IFF+NPI+3
      J=K
      A=1000000
      DO 3900 I=1,NPV
      B=ABS(EP-STORE(K+1))
      IF(B-A)3700,3800,3800
3700  CONTINUE
      A=B
      J=K
3800  CONTINUE
      K=K+NPI+5
3900  CONTINUE
      C=PHI+AL-2.*PI
4000  CONTINUE
      IF(C-STORE(IFF+1))4100,4100,4200
4100  CONTINUE
      C=C+PI
      GOTO 4000
4200  CONTINUE
      A=WINPL(IFF  ,J+2,C,NPI)
      FACT(9)=A
      A=STORE(J)/A
      C=PHI-AL-2.*PI
4300  CONTINUE
      IF(C-STORE(IFF+1))4400,4400,4500
4400  CONTINUE
      C=C+PI
      GOTO 4300
4500  CONTINUE
      B=WINPL(IFF  ,J+2,C,NPI)
      FACT(1)=0.5*(A+STORE(J)/B)
      AFACT=AFACT*FACT(1)
      FACT(10)=B
      BFACT(1)=AMAX1(BFACT(1),FACT(1))
      CFACT(1)=AMIN1(CFACT(1),FACT(1))
4600  CONTINUE
      IF(ITHETA)4800,4800,4700
C
C
C--THETA CORRECTION
4700  CONTINUE
      A=WINPL(IT,ITC,TH,NTI)
      FACT(2)=A
      BFACT(2)=AMAX1(BFACT(2),FACT(2))
      CFACT(2)=AMIN1(CFACT(2),FACT(2))
      AFACT=AFACT*A
4800  CONTINUE
C----- CHECK FOR ROD OR PLATE CORRECTION
      IF (ISPEC) 5900,5900,4900
C
C
C
C------ SPECIMEN IS ROD OR PLATE SHAPED.
C       COMPUTATION IS SUBSTANTIALLY THE SAME.
4900  CONTINUE
      I=0
C----- SET MAXIMUM CORRECTION
      D=STORE(ISPC +5)
C----- ROTATE ABOUT Z
      A=PHI*RTD
      CALL XZEROF(DIRCOS(1),3)
      DIRCOS(3) = 1.
      IF (NROT(DIRCOS,A,STORE(IR1)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
C----- ROTATE ABOUT Y
      A=CHI*RTD
      CALL XZEROF(DIRCOS(1),3)
      DIRCOS(2) = 1.
      IF (NROT(DIRCOS,A,STORE(IR2)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
C----- ROTATE ABOUT Z
      A=OM*RTD
      CALL XZEROF(DIRCOS(1),3)
      DIRCOS(3) = 1.
      IF (NROT(DIRCOS,A,STORE(IR3)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
      CALL XMLTMM(STORE(IR2),STORE(IR3),STORE(IR4),3,3,3)
      CALL XMLTMM(STORE(IR3),STORE(IR4),STORE(IR1),3,3,3)
C----- COMPONENETS OF SPECIMEN IN STANDARD SETTING
      CALL XMLTMM(STORE(IR1),STORE(ISPC),STORE(IR4),3,3,1)
      IF (NORM3(STORE(IR4)) .LE. 0.0 ) STOP 'ZERO LENGTH VECTOR'
C----- DIFFRACTED BEAM
      VK(1)=SIN(2.*TH)
      VK(2)=-COS(2.*TH)
      VK(3)=0.
C----- COSINE OF ANGLE BETWEEN BEAM AND AXIS
      A=STORE(IR4)*VK(1)+STORE(IR4+1)*VK(2)+STORE(IR4+2)*VK(3)
      A = ABS(A)
      IF(ITUBE) 4920,4920,4910
4910  CONTINUE
C     ROD
      A=SQRT(1.-A*A)
4920  CONTINUE
C----- PLATE
      IF(STORE(ISPC+3)-A)5100,5000,5000
5000  CONTINUE
      I=1
C--COMPONENTS OF INCIDNT BEAM ARE 0 1 0
5100  CONTINUE
      B = ABS(STORE(IR4+1))
      IF(ITUBE) 4940,4940,4930
4930  CONTINUE
C----- ROD
      B=SQRT(1.-B*B)
4940  CONTINUE
C----- PLATE
      IF(STORE(ISPC+3)-B)5300,5200,5200
5200  CONTINUE
      I=1
5300  CONTINUE
      C=A*B/(A+B)
      IF(STORE(ISPC+3)-C)5500,5400,5400
5400  CONTINUE
      I=1
5500  CONTINUE
      D=EXP(STORE(ISPC+4)/C)
      IF(I)5800,5800,5600
5600  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,5700)STORE(M6),STORE(M6+1),STORE(M6+2),A,B,C,D
      ENDIF
      WRITE(NCAWU,5700) STORE(M6), STORE(M6+1), STORE(M6+2),A,B,C,D
5700  FORMAT(1X,3F4.0,' Excessive shape correction',/,
     1 ' Inclinations ',3F7.3,'  Correction ',F12.3)
C----- SET MAXIMUM CORRECTION
      D = STORE(ISPC +5)
5800  CONTINUE
      FACT(3)=D
      BFACT(3)=AMAX1(BFACT(3),FACT(3))
      CFACT(3)=AMIN1(CFACT(3),FACT(3))
      AFACT=AFACT*D
C
5900  CONTINUE
      IF(IPRINT)5950,6200,5950
5950  CONTINUE
C---  FULL LISTING
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,6100) STORE(M6),STORE(M6+1),STORE(M6+2),STORE(M6+3),
     1 STORE(M6+12),TH,OM,CHI,PHI,AFACT
      ENDIF
      IF(IPRINT)6000,6200,6200
6000  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,6100)FACT
      ENDIF
6100  FORMAT(1X,10F10.3)
6200  CONTINUE
C
6300  CONTINUE
      BFACT(10)=AMAX1(BFACT(10),AFACT)
      CFACT(10)=AMIN1(CFACT(10),AFACT)
C----- COMPUTE PATH LENGTH RELATIVE TO BASE OF TBAR=1
      TBAR=1.+ALOG(AFACT)
      STORE(M6+9)=TBAR
      AFACT=SQRT(AFACT)
      STORE(M6+27)=STORE(M6+27)*AFACT
      MABS=0
      RETURN
C
C--TERMINATION MESSAGES
6500  CONTINUE
C
C -- IF NO ABSORPTION CORRECTION WAS PERFORMED, THEN RETURN NOW
C
      IF ( IDIF .EQ. 0 ) RETURN
C
C----- LOAD DATA IF LIST 30 NOT ALREADY IN CORE
      IF (KHUNTR (30,0, IADDL,IADDR,IADDD, -1) .LT. 0) CALL XFAL30
      IF (IERFLG .LT. 0) GOTO 6520
      LIX = L6DTL
      STORE(L30IX) = STORE(LIX)
      STORE(L30IX+1) = STORE(LIX+1)
      LIX = LIX + MD6DTL
      STORE(L30IX+2) = STORE(LIX)
      STORE(L30IX+3) = STORE(LIX+1)
      LIX = LIX + MD6DTL
      STORE(L30IX+4) = STORE(LIX)
      STORE(L30IX+5) = STORE(LIX+1)
      IF (CFACT(10) .EQ. 100000.) THEN
        STORE(L30AB+4) = 1.
      ELSE
        STORE(L30AB+4) = CFACT(10)
      ENDIF
      IF (BFACT(10) .EQ. 0.) THEN
        STORE(L30AB+5) = 1.
      ELSE
        STORE(L30AB+5) = BFACT(10)
      ENDIF
      ISTORE(L30AB+8) = 2
      CALL XWLSTD ( 30, ICOM30, IDIM30, -1, -1)
 6520  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,6600)BFACT(10),CFACT(10)
      ENDIF
      WRITE(NCAWU,6600) BFACT(10),CFACT(10)
C----- SET DIFFRACTOMETER TYPE TO ROLLETT
      ISTORE(L13DT)=7
6600  FORMAT(/,5X
     2 ,23H Maximum correction is ,F7.2,/,5X,
     3  23H Minimum correction is ,F7.2,/,5X,
     4  51H The setting angles stored in list 6 are now for a  ,
     5  19H 'Rollett' machine.  )
      MABS=0
      CALL XOPMSG (IOPABS, IOPEND, IVERSN)
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPABS , IOPABN , 0 )
      MABS = -1
      RETURN
C
      END
C
C
CODE FOR WPRCS
      SUBROUTINE WPRCS
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      DIMENSION DIRCOS(3)
C
C
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      DIMENSION ISTORE(131072)
C
      COMMON /XABSW/A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,VV,W,X,Y,
     2 Z,DD(4)
      COMMON /CAD/FCV(3),PD(3,3),QD(3,3),RD(3,3),SD(3,3),SI,CO,FKAP(3),
     2 FBIS(3),FPSI,FEUL(3),FHKL(3),CD(3,3),FLAM(3),DET,CON1,CON2,CON3
C
C
      COMMON /XABSWK/IMODE,WAV,WAVSQ,IDIF,IDAT,IFF,IG,ALPHA,IR1,IR2,
     2 IR3,IR4,ISET,NPI,NPV,VK(3),UM(3,3),UB(3,3),V(3,2),FACT(10),
     3 BFACT(10),CFACT(10),THL,ISPC
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST6A/L6IMP,M6IMP,MD6IMP,N6IMP,L6MLT,M6MLT,MD6MLT,N6MLT,
     2 L6BMP,M6BMP,MD6BMP,N6BMP,L6IB,M6IB,MD6IB,N6IB,
     3 ITYPE6,IAPPND,DENSTY,IUNIT,MEDIUM,NCARDS,NGROUP,INCREM,
     4 LIDFK,MIDFK,MDIDFK,NIDFK,LODFK,MODFK,MDODFK,NODFK,
     5 LFACT,MFACT,MDFACT,NFACT,NSCALE,N6DEAD,IFO,JFO,
     6 IPRINT,ISQ,IPHI,ITHETA,ITUBE,IPLATE,IGAUSS,IHUBER,
     7 LPHI,MPHI,MDPHI,NPHI,LPHIC,MPHIC,MDPHIC,NPHIC,
     8 LPHID,MPHID,MDPHID,NPHID,IT,IT01,NTI,IT02,ITC,IT01C,NTIC,IT02C,
     9 ITU,MITU,MDITU,NITU,IPL,MPL,MDPL,NPL,WI,RANGE,ICHECK
      COMMON/XLST27/L27,M27,MD27,N27
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
C
C
      EQUIVALENCE (XCRU,NCRU),(XCWU,NCWU),(XCRRU,NCRRU)
C
      EQUIVALENCE (FCV(1),FC1),(FCV(2),FC2),(FCV(3),FC3),(FBIS(1),
     2 FTHETA),(FBIS(2),FPHIB),(FBIS(3),FCHIB),(FEUL(1),FPHIE),(FEUL(2)
     3 ,FOME),(FEUL(3),FCHIE),(FKAP(1),FPHIK),(FKAP(2),FOMK),(FKAP(3),
     4 FKAPPA),(FHKL(1),FH),(FHKL(2),FK),(FHKL(3),FL)
C
C
C----- INDICATE TO NONIUS CODE THAT THERE IS A MATRIX
      DET = 1.
C
C
C
C----- PROCESS CORRRRRECTION DATA
      IF(IPHI)1600,1600,1100
1100  CONTINUE
      K=IFF-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1300)NPI,(STORE(K+I),I=1,NPI)
      ENDIF
      DO 1200 I=1,NPI
      STORE(K+I)=DTR*STORE(K+I)
1200  CONTINUE
1300  FORMAT(/I4,11H Phi values,/(1X,10F10.2))
      K=IFF+NPI
      KK=NPI+4+K
      DO 1500 L=1,NPV
      STORE(K+4)=2.*STHETA(STORE(K))
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1400)(STORE(I),I=K,KK)
      ENDIF
1400  FORMAT(/3F4.0,6X,6H Imax ,F12.3,3X,13H 2Sin(Theta) ,F6.4,/(1X,
     2 10F10.0))
      K=KK+1
      KK=K+NPI+4
1500  CONTINUE
1600  CONTINUE
C
C
      IF(ITUBE)1650,1650,1700
1650  CONTINUE
      IF(IPLATE)1900,1900,1700
1700  CONTINUE
      CALL WAIN(IDIF,IR4,ISPC)
      CALL WCVT(IDIF,IR4,IR4)
C----- ROTATE ABOUT Z
      A=-STORE(IR4+1)*RTD
      CALL XZEROF(DIRCOS(1),3)
      DIRCOS(3) = 1.
      IF (NROT(DIRCOS,A,STORE(IR1)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
C----- ROTATE ABOUT Y
      A=-STORE(IR4+2)*RTD
      CALL XZEROF(DIRCOS(1),3)
      DIRCOS(2) = 1.
      IF (NROT(DIRCOS,A,STORE(IR2)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
C----- ROTATE ABOUT Z
      A=-STORE(IR4+3)*RTD
      CALL XZEROF(DIRCOS(1),3)
      DIRCOS(3) = 1.
      IF (NROT(DIRCOS,A,STORE(IR3)) .LE. 0.0) THEN
      CALL XOPMSG (IOPABS,IOPINT,0)
      CALL XERHND(IERPRG)
      ENDIF
C----- FORM [P].[X].[W]
      CALL XMLTMM(STORE(IR2),STORE(IR1),STORE(IR4),3,3,3)
      CALL XMLTMM(STORE(IR3),STORE(IR4),STORE(IR1),3,3,3)
C----- TUBE LIES ALONNG X
      VK(1)=1.
      VK(2)=0.
      VK(3)=0.
C----- CALC INDICES OF TUBE
      CALL XMLTMM(STORE(IR1),VK(1),STORE(ISPC),3,3,1)
      IF(NORM3(STORE(ISPC)) .LE. 0.0)STOP 'ZERO LENGTH VECTOR'
C
C----- FIND MINIMUM INCLINATION ANGLE
      B = STORE(ISPC +5) / (STORE(ISPC +5) + ALOG(STORE(ISPC +6)) )
      IF(ITUBE .GT. 0) THEN
      A=ASIN(B)
      ELSE
      A = ACOS(B)
      ENDIF
      STORE(ISPC+3)=RTD*A
C---- SHUFFLE EVERYTHING DOWN
      STORE(ISPC+4)=STORE(ISPC+5)
      STORE(ISPC+5)=STORE(ISPC+6)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1800)(STORE(J),J=ISPC,ISPC+5)
      ENDIF
      WRITE(NCAWU,1800)(STORE(J),J=ISPC,ISPC+5)
      STORE(ISPC+3)=B
1800  FORMAT(//,' Specimen shape correction',/,
     1 ' Components of specimen axis ',3F7.2,/,
     2 ' Limiting inclination ',F7.3,',    MU*T ',F7.3,/,
     3 ' Maximum permitted correction ',F7.3,//)
C
1900  CONTINUE
      RETURN
      END

CRYSTALS CODE FOR ACCUMULAT
CODE FOR XSETMT
      SUBROUTINE XSETMT(II,IJ,IK,IL,IM,IN)
C--SET UP THE CONSTANTS REQUIRED FOR THE MATRIX ACCUMULATION
C
C--ALL THE ARGUMENTS ARE DUMMY ARGUMENTS, AND ARE USED TO MAINTAIN
C  COMPATIBILITY WITH THE MACHINE CODE VERSION OF THIS ROUTINE.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST11/L11,M11,MD11,N11,L11R,M11R,MD11R,N11R,
     2 L11P,M11P,MD11P,N11P,L11IR,M11IR,MD11IR,N11IR
      COMMON/XACC11/LW11,MW11,MDW11,NW11,LW11T
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET THE NUMBER OF ELEMENTS TO BE ACCUMULATED AT ONE GO
      NW11 = 8
C--SET THE POINTER TO THE LAST BLOCK DETAIL
      M12B=L12B+(N12B-1)*MD12B
C--SET THE STACK TO HOLD THE FIRST MATRIX AND LAST DERIV ELEMENTS
      LW11=NFL
      LN=11
      IREC=1001
      MDW11=2
      MW11=KCHNFL(N12*MDW11)
C--SET UP THE AREA FOR TEMPORARY DERIV STORAGE
      IREC=1002
      LW11T=KADD11(IREC,MD11,N12+NW11)
      IF ( IERFLG .LT. 0 ) GO TO 9900
      MW11=LW11
C--SET UP THE 'DO' LOOP END VARIABLES
      M11=L11
      DO 1700 I=L12B,M12B,MD12B
      L=LW11T+ISTORE(I+1)-1
C--FIND THE ORDER OF THE CURRENT MATRIX BLOCK
      N=ISTORE(I+1)
C--LOOP OVER EACH LINE OF THE MATRIX
      DO 1600 J=LW11T,L
      ISTORE(MW11)=J+((L-J+NW11)/NW11-1)*NW11
C--SET THE FIRST ELEMENT OF THE MATRIX
      ISTORE(MW11+1)=M11
      M11=M11+N
      N=N-1
      MW11=MW11+MDW11
1600  CONTINUE
1700  CONTINUE
C -- GENERAL AND ERROR RETURN
9900  CONTINUE
      RETURN
      END
C
CODE FOR XADLHS
      SUBROUTINE XADLHS
C--ADD THE DERIVATIVES INTO THE L.H.S. OF THE NORMAL MATRIX
C
C--THE COMMON BLOCK 'XACC11' IS USED FOR THE FORTRAN MATRIX
C  ACCUMULATION ROUTINES :
C
C  LW11   ADDRESS OF THE FIRST WORD OF STACK OF 'DO' LOOP TERMINATORS
C  MDW11  NUMBER OF WORDS PER ENTRY IN THE STACK (=2)
C
C         THE ENTRIES IN THE STACK ARE :
C
C         0  THE 'DO' LOOP TERMINATOR FOR THE CURRENT PARAMETER.
C         1  THE FIRST ELEMENT IN THE MATRIX FOR THE CURRENT PARAMETER.
C
C  NW11   NUMBER OF ELEMENTS ACCUMULATED PER PASS (=4)
C  LW11T  ADDRESS OF TEMPORARY STORAGE TO BE USED FOR P.D.'S .
C
C--
C----- NOTE THAT IF STR11 IS USED DOUBLE PRECISION, LENGRP IN
C      LIST11 IN COMMAND FILE MUST BE CHANGED FROM 1 TO 2
C      FOR LHS AND RHS
C      AND I11LEN IN XPRC12
C      DOUBLE PRECISION STR11(1048576)
      DIMENSION STR11(1048576)
      DIMENSION ISTORE(131072)
      DIMENSION I11COM(5)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDATF/NFLD,LFLD,NULD
C      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDATD/XSTR11(1048576)
      COMMON /XACC11/ J11COM(5)
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
C
      EQUIVALENCE (I11COM(1),LW11), (I11COM(2),MW11), (I11COM(3),MDW11)
      EQUIVALENCE (I11COM(4),NW11), (I11COM(5),LW11T)
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (STR11(1),XSTR11(1))
C----- MOVE THE COMMON BLOCK VARIABLES INTO LOCAL
      CALL XMOVE(J11COM(1),I11COM(1),5)
C
C--LOOP OVER THE BLOCKS OF THE MATRIX
      KA=JO
      MW11=LW11
      DO 2500 I=L12B,M12B,MD12B
C--TRANSFER THE DERIVATIVES FOR THIS BLOCK TO 'LW11T' AND ADD ENOUGH BLA
      L=LW11T+ISTORE(I+1)-1
&CYBC----- VECTORISABLE CODE FOR CYBER
&CYB      N = ISTORE(I+1)
&CYBCVD$L NODEPCHK
&CYB      DO 2000 J = 0, N-1
&CYB      STR11(LW11T+J) = STORE(KA+J)
&CYB2000  CONTINUE
&CYB      KA = KA + N
&CYBC--BLANK OUT THE LAST (NW11-1) SLOTS
&CYB      DO 2010 J = L+1, L+NW11-1
&CYB      STR11(J)=0.0
&CYB2010  CONTINUE
#CYB      DO 2000 J=LW11T,L
#CYB      STR11(J)=STORE(KA)
#CYB      KA=KA+1
#CYB2000  CONTINUE
#CYBC--BLANK OUT THE LAST (NW11-1) SLOTS
#CYB      STR11(L+1)=0.
#CYB      STR11(L+2)=0.
#CYB      STR11(L+3)=0.
#CYB      STR11( L+4) = 0.
#CYB      STR11( L+5) = 0.
#CYB      STR11( L+6) = 0.
#CYB      STR11( L+7) = 0.
C--LOOP OVER THE DIFFERENT ROWS OF THE MATRIX
      DO 2300 J=LW11T,L
C--FIND THE 'DO' LOOP END VARIABLE
      M=ISTORE(MW11)
C--FIND THE MATRIX START ADDRESS
      KB=ISTORE(MW11+1)
      MW11=MW11+MDW11
C----- SET THE CONSTANT TERM
      STR11J = STR11(J)
C--LOOP OVER THE COLUMNS OF THE CURRENT ROW
&CYBC----- VECTORISABLE CODE FOR CYBER
&CYB      N = (M-J+NW11)/NW11*NW11
&CYBCVD$L NODEPCHK
&CYB      DO 2100 K = 0, N-1
&CYB      STR11(KB+K) = STR11(KB+K) + STR11J *STR11(J+K)
&CYB2100  CONTINUE
#CYBC----- DO-LOOP UNROLLING. THIS TECHNIQUE MAY DRAMATICALY SPEED UP
#CYBC----- THE ACCUMULATION ON SOME COMPILERS. THE VAX COMPILER RECOGNIS
#CYBC----- WHAT IS HAPPENING, AND PRODUCES CODE OF EQUAL SPEED FOR EITHE
#CYBC----- TECHNIQUE.
#CYB      DO 2100 K=J,M,NW11
#CYB      STR11(KB  ) = STR11(KB  ) +STR11J *STR11(K  )
#CYB      STR11(KB+1) = STR11(KB+1) +STR11J *STR11(K+1)
#CYB      STR11(KB+2) = STR11(KB+2) +STR11J *STR11(K+2)
#CYB      STR11(KB+3) = STR11(KB+3) +STR11J *STR11(K+3)
#CYB      STR11(KB+4) = STR11(KB+4) +STR11J *STR11(K+4)
#CYB      STR11(KB+5) = STR11(KB+5) +STR11J *STR11(K+5)
#CYB      STR11(KB+6) = STR11(KB+6) +STR11J *STR11(K+6)
#CYB      STR11(KB+7) = STR11(KB+7) +STR11J *STR11(K+7)
#CYB      KB=KB+NW11
#CYB2100  CONTINUE
2300  CONTINUE
2500  CONTINUE
C----- RESTORE THE COMMON BLOCK VARIABLES
      CALL XMOVE(I11COM(1),J11COM(1),5)
      RETURN
      END
C
CODE FOR XADRHS
      SUBROUTINE XADRHS(WDF)
C--ADD INTO THE R.H.S. OF THE NORMAL EQUATIONS
C
C  WDF  SQRT(W)*(/FO/ - /FC/)
C
C--
C
C----- NOTE THAT IF STR11 IS USED DOUBLE PRECISION, LENGRP IN
C      LIST11 IN COMMAND FILE MUST BE CHANGED FROM 1 TO 2
C      FOR LHS AND RHS
C      AND I11LEN IN XPRC12
C      DOUBLE PRECISION STR11(1048576)
      DIMENSION STR11(1048576)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDATF/NFLD,LFLD,NULD
C      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDATD/XSTR11(1048576)
      COMMON/XLST11/L11,M11,MD11,N11,L11R,M11R,MD11R,N11R,
     2 L11P,M11P,MD11P,N11P,L11IR,M11IR,MD11IR,N11IR
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (STR11(1),XSTR11(1))
C
      CALL XMOVE(WDF,DA,1)
      J=L11R
&CYBC----- VECTORISABLE CODE FOR CYBER
&CYB      N = JP - JO
&CYBCVD$L NODEPCHK
&CYB      DO 1000, I = 0, N
&CYB      STR11(J+I) = STR11(J+I) + STORE(JO+I)*DA
&CYB1000  CONTINUE
#CYB      DO 1000 I=JO,JP
#CYB      STR11(J) = STR11(J) + STORE(I)*DA
#CYB      J=J+1
#CYB1000  CONTINUE
      RETURN
      END
CRYSTALS CODE FOR DIFABS
CODE FOR XDFABS
      SUBROUTINE XDFABS
C     **************
C
C   EMPIRICAL ABSORPTION CORRECTION PROGRAM
C
C   A low order term Fourier series is used to model an absorption surfa
C   for differences between the observed structure factors and those
C   obtained from a structure factor calculation (after isotropic least
C   squares refinement).   Spherical polar angles are used to define the
C   incident and diffracted beam path directions.   This reduces the num
C   of angles required to four - viz. PHI(p), MU(p), PHI(s) and MU(s).
C   A theta-dependent correction is evaluated to allow for diffracted
C   beams with different path lengths occurring at the same polar angles
C   Again, a low order term Fourier series is used; in Bragg angle, THET
C   This version is general for any 4-circle diffractometer data collect
C   geometry: however, routine ANGLES may require extra code for the
C   calculation of the Eulerian angles from the Miller indices using the
C   orientation matrix.
C
C   Author - Nigel Walker, Chemistry Dept., Queen Mary College, London E
C   Reference - WALKER & STUART (1983) Acta Cryst. A39, 158-166.
C               WALKER & STUART (1984) Acta Cryst. (in preparation).
C
C   DIMENSIONING OF ARRAYS IN COMMON /NORMAL/ AND  SUBROUTINE SOLVEN
C   ----------------------------------------------------------------
C   If NCO=NACOEF+NBCOEF, then arrays ANORM & VEC should have minimum
C   dimensions (NCO,NCO); ATB & TERMS (NCO); ROWJ (2*NCO); and WORK (5*N
C
C   VERSION 8.08
C   THIS VERSION USES NON-LINEAR LEAST-SQUARES WITH UNIT WEIGHTS
C   INPUTS SHELX 'LIST 5' DATA AND OUTPUTS 'HKLF 3' TYPE DATA
C   GENERAL ROUTINE FOR CALCULATION OF SPHERICAL POLAR ANGLES
C
C   SET UP DIFFRACTOMETER CHARACTERISTICS
C     IDIFRT=0   Enraf-Nonius CAD4
C     IDIFRT=1   Syntex P-1
C     IDIFRT=2   Syntex P21
C     IDIFRT=3   Picker FACS-I
C     IDIFRT=4   Philips PW1100
C
C   SET UP GEOMETRY CHARACTERISTICS
C     IPOS=0   bisecting geometry
C     IPOS=1   data collected in parallel position
C     IPOS=2     "      "      " a general   "
C
C
      LOGICAL TCOR
      REAL X(3) , MU , MUMIN , MUMAX
      INTEGER NP(16)
      COMMON /NORMAL/ ANORM(44,44),ATB(44),ROWJ(88),TERMS(44)
      COMMON /SOLVE/ NSIZE,FILTER,FILSTA,FILDEC,FILEND
      COMMON /REFL/ FC,FO,FM,PHI(2),MU(2),SINTH,COSTH
      COMMON /DRVR/ LI,LD,LO,lf,lp,ncy,NSHAPE,NACOEF,NBCOEF,SFMU,TCOR
      COMMON /SRES/ NUMREF,SUMRES,SUMFS,SUMRSQ,SUMFSQ
      COMMON/ORIENT/TWOTHZ,OMZ,PHIZ,PLUS(3),IPOS,IDIFRT,ORIENT(3,3),DST
      COMMON /CELLP/ TA,TB,TC,ZA,ZB,ZC
C
C
      DIMENSION IPROCS(4)
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
C
      DATA  STHMAX / 0.0 / , MUMIN / 100.0 / , MUMAX / -100.0 /
C
      DATA IVERSN / 809 /
      DATA IDIMN / 4 /
C
C
      CALL XTIME1 ( 2 )
C
      CALL XCSAE
      CALL XRSL
C
      I=KRDDPV ( IPROCS , IDIMN )
      IF (I.LT.0) GO TO 9910
C
      IS     = IPROCS(1)
      IDIFRT = IPROCS(2)
      IPOS   = IPROCS(3)
      IACTN = IPROCS(4)
C
C     LOAD A FEW LISTS
C
      CALL XFAL01
      CALL XFAL05
      CALL XFAL13
C
C---------------------------------------------------------------------
C
C   SET UP I/O UNIT NUMBERS
      LF=MT1
      REWIND MT1
      LP = NCWU
C
C   OUTPUT HEADER.
      IF (ISSPRT .EQ. 0)  WRITE(NCWU,1200)
1200  FORMAT(' DIFABS (V08.8) VERSION USING NON-LINEAR LEAST-SQUARES' )
C
C     *********
      NACOEF=34
      NBCOEF=10
C     *********
C
C
C     **************
      NSIZE=44
      FILTER=0.00005
      FILSTA=0.0001
      FILDEC=0.00005
      FILEND=0.0
      NCYCLE=5
C     **************
C
C
C   READ INPUT PARAMETERS
      WAVE=STORE(L13DC)
      SFACT=STORE(L5O)
C----- COPY OVER THE ORIENTATION MATRIX
      CALL XMOVE (STORE(L13OM),ORIENT(1,1),9)
      IF ( (ABS(ABS(XDETR3(ORIENT)) -1) .LE. ZERO) .OR.
     1     (ABS(XDETR3(ORIENT)) .LE. ZERO)  ) THEN
        CALL XMOVE (STORE(L1O2), ORIENT(1,1), 9)
        CALL MTRANS(ORIENT)
      ENDIF
      IF(SFACT.LE.0.0)SFACT=1.0
      TCOR=.FALSE.
      IF(IS.EQ.1)TCOR=.TRUE.
C       READ(LI,*)NCYCLE,FILTER,FILSTA,FILDEC,FILEND
      IF(.NOT.TCOR)NCYCLE=NCYCLE-1
C
C   GET CELL PARAMETERS
      CALL CELL
C
C   SET UP DIFFRACTOMETER CHARACTERISTICS
C   SET ANGLE ZEROES AND DIRECTION SENSES.
C
      TWOTHZ=0.0
      OMZ=0.0
      PHIZ=0.0
      IF(IDIFRT.EQ.4) GO TO 110
      PLUS(1)=1.0
      PLUS(2)=-1.0
      PLUS(3)=-1.0
      GO TO 120
110   PLUS(1)=1.0
      PLUS(2)=1.0
      PLUS(3)=1.0
120   CONTINUE
C
C   INITIALIZE RESIDUES
      NF=-1
      CALL RES(NF)
C
C   SET COUNTERS
      NREF=0
      NTOT=0
      NCUTO=0
      NCUTC=0
      NLOW=0
      DO 15 J=1,16
15    NP(J)=0
C
C   SET UP COEFFICIENT STARTING VALUES (ZERO)
C   AND INITIALIZE NORM EQUATIONS
      NCO=NACOEF+NBCOEF
      DO 20 I=1,NCO
      ATB(I)=0.0
      TERMS(I)=0.0
      DO 25 J=1,I
      ANORM(I,J)=0.0
25    CONTINUE
20    CONTINUE
C
C
C     ************
      SFMU=WAVE*7.
C     ************
C
C   NOW GET TO WORK...
C
      NCY=1
      NSHAPE=NACOEF
C
C     SET UP LIST 6 FOR PROCESSING
      CALL XFAL06(0)
C
      GO TO 260
C
C
C
1000  CONTINUE
C
      IH=NINT(STORE(M6))
      IK=NINT(STORE(M6+1))
      IL=NINT(STORE(M6+2))
      FOBS=STORE(M6+3)
      FCALC=STORE(M6+5)
      SIGF=STORE(M6+12)
      IF (SIGF.LE.0) SIGF=SQRT(FOBS)
C
      IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.EQ.0)GOTO 290
      NREF=NREF+1
      IUSE=0
C----- CHECK IF THIS REFLECTION IS ALLOWED
      IF (KALLOW(0) .LE. -1) GOTO 250
C   IF UNOBSERVED, WRITE DUMMY RECORD
      IF(FOBS.LE.0.0) GO TO 250
      NTOT=NTOT+1
C
C
C   CALCULATE SETTING ANGLES FROM ORIENTATION MATRIX.
      STHLSQ=0.25*(IH*IH*TA+IK*IK*TB+IL*IL*TC+IL*IH*ZB
     ++IK*IL*ZA+IH*IK*ZC)
      SINL=SQRT(STHLSQ)
      DST=2.0*SINL
      X(1)=IH
      X(2)=IK
      X(3)=IL
      CALL ANGLES (OMEGA,PHIE,CHIE,X,IERR)
      IF(IERR.NE.1) GOTO 147
      IF (ISSPRT .EQ. 0)  WRITE (NCWU,1220) IH,IK,IL
1220  FORMAT(' *** ERROR IN SETTING ANGLES FOR REFLECTION',3I4,' ***')
      GOTO 250
C
147   SINTH=WAVE*SINL
      COSTH=SQRT(1. - SINTH*SINTH)
C   MAX THETA
      IF(SINTH.LE.STHMAX) GOTO 148
      STHMAX=SINTH
      CTHMAX=COSTH
148   CONTINUE
C
C   CALCULATE SPHERICAL POLAR COORDS FROM 4-CIRCLE DIFFRACT. EULERIAN AN
C   calculate primary & secondary beam angles
C   for bisecting geometry (not Picker)
      IF(IPOS.EQ.0.AND.IDIFRT.NE.3) CALL BISECT (CHIE,PHIE)
C   or for the general case
      IF(IPOS.NE.0.OR.IDIFRT.EQ.3) CALL GEN4C (OMEGA,CHIE,PHIE)
C
C   MIN AND MAX MU
      IF(MU(1).LT.MUMIN) MUMIN=MU(1)
      IF(MU(1).GT.MUMAX) MUMAX=MU(1)
      IF(IPOS.EQ.0)GOTO 149
      IF(MU(2).LT.MUMIN) MUMIN=MU(2)
      IF(MU(2).GT.MUMAX) MUMAX=MU(2)
C
C   TAKE THE SQUARE ROOT OF MU * SFMU
149   IF(MU(1).GT.0.) MU(1)=SQRT(MU(1))*SFMU
      IF(MU(1).LT.0.) MU(1)=-SQRT(ABS(MU(1)))*SFMU
      IF(IPOS.EQ.0)GOTO 150
      IF(MU(2).GT.0.) MU(2)=SQRT(MU(2))*SFMU
      IF(MU(2).LT.0.) MU(2)=-SQRT(ABS(MU(2)))*SFMU
      GOTO 155
C   FOR BISECTING GEOMETRY
150   MU(2)=MU(1)
C
C   COUNT REFLS. IN EACH OCTANT
155   DO 160 J=1,2
      JJ=(J-1)*4
      M=0
      IF(MU(J).LT.0.)M=8
      N=PHI(J)/90. + 1.
      IOCT=N+JJ+M
      NP(IOCT)=NP(IOCT) + 1
160   CONTINUE
C
C
      FO=FOBS
      FC=FCALC*SFACT
C
C   TEST FOR INCLUSION IN COEFFICIENT DETERMINATION
C
C   DON'T ALLOW REFLS .LT. 3*SIGF
      FCUT=FO/SIGF
      IF(FCUT.GE.3.) GOTO 200
      NCUTO=NCUTO + 1
      GOTO 250
C
C   DON'T ALLOW REFLS WITH FCALC .LT. 3*SIGF(OBS)
200   FCUT=FC/SIGF
      IF(FCUT.GE.3.) GOTO 202
      NCUTC=NCUTC + 1
      GOTO 250
C
C   DON'T ALLOW REFLS IF SCALED FOBS .LT. 0.5*FCALC (POSSIBLE EXTINCTION
202   TWOBS=FO*2.
      IF(FC.LT.TWOBS) GOTO 205
      NLOW=NLOW + 1
      GOTO 250
C
C   STORE PHI,MU AND THETA FOR LATER USE
205   IUSE=1
250   WRITE(LF)IUSE,FC,FO,PHI,MU,SINTH,COSTH
C
C
C   SET UP OBSERVATIONAL AND NORMAL EQUATIONS
      IF(IUSE.EQ.1) CALL ABNORM
C     FETCH NEXT REFLECTION
260   CONTINUE
      IF (KLDRNR(0)) 290, 1000, 1000
C
C
290   CONTINUE
C
C     CHECK THAT WE HAVE USED SOME REFLECTIONS
      IF(NREF)9900,9900,291
291   CONTINUE
C
      CALL XCSAE
C
C     START PROCESSING THE ACCUMULATED DATA
C
C   REPORT REFLECTION SUMMARY
      NZERO=NREF-NTOT
      IF (ISSPRT .EQ. 0)WRITE(NCWU,1600)NREF,NZERO,NCUTO,NCUTC,NLOW
      WRITE(NCAWU,1600)NREF,NZERO,NCUTO,NCUTC,NLOW
1600  FORMAT(/I6,' Reflections input',
     +       /I6,' Rejected with Fobs=0',
     +       /I6,' Rejected with Fobs/SigFobs .LT. 3',
     +       /I6,' Rejected with Fcalc/SigFobs .LT. 3',
     +       /I6,' Rejected with Fcalc .GT. 2*Fobs')
C
      CALL ARCTAN (THMAX,CTHMAX,STHMAX)
C
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,1700)THMAX,MUMIN,MUMAX,NP
1700  FORMAT(/' Maximum THETA =',F6.2,' degrees',
     +       /' Minimum MU =',F6.2,' degrees',
     +       /' Maximum MU =',F6.2,' degrees',
     + //' NUMBER OF REFLECTION PATHS IN EACH OCTANT',
     + /12X,'Primary',20X,'Secondary'/2(5X,'0-90 -180 -270 -360',4X)
     + /' +MU',4I5,8X,4I5 / ' -MU',4I5,8X,4I5)
      ENDIF
C
C   REPORT RESIDUALS BEFORE CORRECTION
      IF (ISSPRT .EQ. 0) WRITE(NCWU,1800)
1800  FORMAT(//' RESIDUALS BEFORE CORRECTION')
      NF=1
      CALL RES(NF)
C
C   SOLVE EQUATIONS
      CALL SOLVEN
C
C
C   LOOP ROUND DOING CYCLES
C
      IF(TCOR)NSHAPE=NACOEF+NBCOEF
C
      DO 300 NCY=2,NCYCLE
C
C   INITIALIZE RESIDUALS AND NORMAL EQUATIONS
      NF=-1
      CALL RES(NF)
      DO 310 I=1,NSHAPE
      ATB(I)=0.0
      DO 320 J=1,I
      ANORM(I,J)=0.0
320   CONTINUE
310   CONTINUE
C
      REWIND LF
      DO 400 NRECRD=1,NREF
      READ(LF)IUSE,FC,FO,PHI,MU,SINTH,COSTH
      IF(IUSE.EQ.1)CALL ABNORM
400   CONTINUE
C
      IF (ISSPRT .EQ. 0)  WRITE(NCWU,1900)NCY-1
1900  FORMAT(//' RESIDUALS AFTER CYCLE',I2)
      NF=1
      CALL RES(NF)
C
      CALL SOLVEN
C
300   CONTINUE
C
C
C   APPLY CORRECTION TO ALL DATA
      CALL ABSPLY ( NREF, IACTN)
      IF(NREF)9900,9900,209
209   CONTINUE
C
      IF (ISSPRT .EQ. 0)  WRITE(NCWU,210) (TERMS(J),J=1,NSHAPE)
210   FORMAT(/' ***VALUES FOR COEFFICIENTS***'//,
     +  2(6F10.4/)/ , 2(4F10.4/)/ , 2(7F10.4/)/  , 2(5F10.4/)/ )
C
C   PRINT EXAMPLE OF ABSORPTION SURFACE
      CALL ABSPRI(MUMIN,MUMAX,THMAX)
C
C
C
C
C
9000  CONTINUE
C
      CALL XOPMSG ( IOPDAB , IOPEND , IVERSN )
      CALL XTIME2 ( 2 )
C
      RETURN
C
C
C
C
9900  CONTINUE
      CALL XOPMSG ( IOPDAB , IOPABN , 0 )
      GO TO 9000
9910  CONTINUE
      CALL XOPMSG ( IOPDAB , IOPCMI , 0 )
      GO TO 9900
      END
C
C
C
CSUBROUTINESSUBROUTINESSUBROUTINESSUBROUTINESSUBROUTINESSUBROUTINESSUBRO
CSUBROUTINESSUBROUTINESSUBROUTINESSUBROUTINESSUBROUTINESSUBROUTINESSUBRO
CSUBROUTINESSUBROUTINESSUBROUTINESSUBROUTINESSUBROUTINESSUBROUTINESSUBRO
CSUBROUTINESSUBROUTINESSUBROUTINESSUBROUTINESSUBROUTINESSUBROUTINESSUBRO
C
C
C
C
CODE FOR ABNORM
      SUBROUTINE ABNORM
C     *****************
C
C
C  ROUTINE TO DERIVE ABSORPTION COEFFICIENTS.
C
C   To be modelled:-    Fc = k Fo . A(p,s)
C   where:
C         A(p,s) = A(p).A(s).A(p-s)
C   using model:
C         A(p,s) = SUM {Pn,m [sin(nop+mup) + Qn,m cos(nop+mup)]}
C                 *SUM {Pn,m [sin(nos+mus) + Qn,m cos(nos+mus)]}
C                 *SUM {Rn sin(nO) + Sn cos(nO)}
C   where:
C     o=phi, u=mu and O=theta
C     p=primary and s=secondary, p-s=2O, and n and m are integers.
C     k = scale factor from least squares refinement.
C
C   Coefficients for zero order terms are set to unity and taken out
C   of summation, hence:
C                   Fc = k Fo . {1 + A'(p)}.{1 + A'(s)}.{1 + A'(O)}
C
C   Terms Pn,m and Qn,m used are:-
C    a) n=1,2,3,4,5,6 and m=0  b) n=0 and m=1,2,3,4
C    c) n=1,2,3,4 and m=1, and n=m=2,3,4    ie. a total of 34
C   and terms Rn and Sn used are:-
C      n=1,2,3,4,5    ie. a total of 10
C
C   All coefficients have starting values of zero.
C
C
      LOGICAL TCOR
      REAL MU
      COMMON /NORMAL/ ANORM(44,44),ATB(44),ROWJ(88),TERMS(44)
      COMMON /REFL/ FC,FO,FM,PHI(2),MU(2),SINTH,COSTH
      COMMON /DRVR/ LI,LD,LO,lf,lp,ncy,NSHAPE,NACOEF,NBCOEF,SFMU,TCOR
C
C
C   GET TRIG TERMS
      CALL ABSTOR
C
C   APPLY CORRECTION FACTOR FROM PREVIOUS CYCLE TO FOBS
      IF(NCY.EQ.1) GOTO 5
      CALL AFACT(PS1,PS2,PS3,ABSFAC)
      FM=FO*ABSFAC
      GOTO 6
C
5     FM=FO
      PS1=1.0
      PS2=1.0
      PS3=1.0
C
6     NF=0
      CALL RES(NF)
C
      DEL=FC-FM
C
C   CALCULATE DERIVATIVES
C
      DCONST=FO*PS3
      DO 10 J=1,NACOEF
      JJ=J+NACOEF
      ROWJ(J)=DCONST *(ROWJ(J)*PS2 + PS1*ROWJ(JJ))
10    CONTINUE
C
      IF(.NOT.TCOR.OR.NCY.EQ.1) GOTO 30
C
      NSTART=NACOEF+1
      DCONST=FO*PS1*PS2
      DO 20 J=NSTART,NSHAPE
      JJ=J+NACOEF
      ROWJ(J)=DCONST*ROWJ(JJ)
20    CONTINUE
C
C
C   NOTE... SHAPE DERIVS. ARE IN ROWJ (1 thro' NSHAPE)
C
C   ADD INTO NORMAL EQUATIONS
C
C
30    DO 40 K=1,NSHAPE
      DO 50 L=1,K
      ANORM(K,L)=ANORM(K,L) + ROWJ(K)*ROWJ(L)
50    CONTINUE
C
C   R.H.S.
      ATB(K)=ATB(K) + ROWJ(K)*DEL
40    CONTINUE
C
C
      RETURN
      END
C
C
C
C
CODE FOR BISECT
      SUBROUTINE BISECT (CHIE,PHIE)
C     *****************************
C
C   CALCULATE SPHERICAL POLAR COORDINATES PHI AND MU
C   FROM EULERIAN DIFFRACTOMETER ANGLES PHIE, CHIE AND THETA
C   FOR A CRYSTAL IN THE BISECTING POSITION.
C   ALL ANGLES IN DEGREES.
C
      REAL MU
      COMMON /REFL/ FC,FO,FM,PHI(2),MU(2),SINTH,COSTH
C
      DATA DTOR/0.0174533/
      DATA RAD/57.2957795/
C
      RCHIE=CHIE*DTOR
      SCHI= SIN(RCHIE)
      CCHI= COS(RCHIE)
C
C...CALCULATE MU
      SMU= SINTH * SCHI
      CMU= SQRT(1. - SMU*SMU)
      CALL ARCTAN(XMU,CMU,SMU)
C
C
C...CALCULATE DELTA PHI
      TANTH= SINTH/COSTH
      DPHI= ATAN(TANTH * CCHI)*RAD
C
C
C   CALCULATE PHI AND MU FOR PRIMARY AND SECONDARY BEAM PATHS
C   ONLY ASSUMPTION IS A(p)=A(-s)
C   Huber & Kopfmann (1969) Acta Cryst. A25, 143-152
C
C
C
      PHI(1)= PHIE + DPHI
      PHI(2)= PHIE + 180. - DPHI
      CALL NORM(PHI(1))
      CALL NORM(PHI(2))
C
      MU(1)= XMU
      MU(2)= XMU
C
      RETURN
      END
C
C
C
C
CODE FOR GEN4C
      SUBROUTINE GEN4C (OMEGA,CHIE,PHIE)
C     **********************************
C
C   GENERAL ROUTINE TO CALCULATE SPHERICAL POLAR COORDINATES
C   PHI AND MU FROM EULERIAN DIFFRACTOMETER ANGLES -
C   ALL ANGLES IN DEGREES.
C   NOTE: OMEGA is defined such that the CHI axis makes an angle
C         of THETA + OMEGA with the primary beam direction,
C         ie. OMEGA=0 in the bisecting position.
C
      REAL MU,MUP,MUS
      COMMON /REFL/ FC,FO,FM,PHI(2),MU(2),SINTH,COSTH
C
      DATA DTOR/0.0174533/
      DATA RAD/57.2957795/
C
      THETA= ATAN(SINTH/COSTH)
      ROMEGA= OMEGA*DTOR
      OMP= THETA + ROMEGA
      OMS= THETA - ROMEGA
      RCHIE=CHIE*DTOR
      SCHI= SIN(RCHIE)
      CCHI= COS(RCHIE)
C
C...CALCULATE MU
      SMU= SIN(OMP) * SCHI
      CMU= SQRT(1. - SMU*SMU)
      CALL ARCTAN(MUP,CMU,SMU)
      SMU= SIN(OMS) * SCHI
      CMU= SQRT(1. - SMU*SMU)
      CALL ARCTAN(MUS,CMU,SMU)
C
C
C...CALCULATE DELTA PHI
      DPHIP= ATAN(CCHI * TAN(OMP))*RAD
      DPHIS= ATAN(CCHI * TAN(OMS))*RAD
C
C
C   CALCULATE PHI AND MU FOR PRIMARY AND SECONDARY BEAM PATHS
C   ONLY ASSUMPTION IS A(p)=A(-s)
C   Huber & Kopfmann (1969) Acta Cryst. A25, 143-152
C
C
C
      PHI(1)= PHIE + DPHIP
      PHI(2)= PHIE + 180. - DPHIS
      CALL NORM(PHI(1))
      CALL NORM(PHI(2))
C
      MU(1)= MUP
      MU(2)= MUS
C
      RETURN
      END
C
C
C
C
C
CODE FOR ABSTOR
      SUBROUTINE ABSTOR
C     *****************
C
C   CALCULATES SIN & COS OF POLAR ANGLES
C
C   WORK OUT TERMS USING EXPANSIONS FOR TRIG FUNCTIONS.
C
C   NOTE: if bisecting geometry, MU expansions only performed once
C         since MU(s)=MU(p).
C
      LOGICAL TCOR
      REAL MU
      COMMON /NORMAL/ ANORM(44,44),ATB(44),ROWJ(88),TERMS(44)
      COMMON /REFL/ FC,FO,FM,PHI(2),MU(2),ST,CT
      COMMON/ORIENT/TWOTHZ,OMZ,PHIZ,PLUS(3),IPOS,IDIFRT,ORIENT(3,3),DST
      COMMON /DRVR/ LI,LD,LO,lf,lp,ncy,NSHAPE,NACOEF,NBCOEF,SFMU,TCOR
C
      DATA DTOR/0.0174533/
C
C
      SPP=SIN(PHI(1)*DTOR)
      CPP=COS(PHI(1)*DTOR)
C
      SPS=SIN(PHI(2)*DTOR)
      CPS=COS(PHI(2)*DTOR)
C
      SMP=SIN(MU(1)*DTOR)
      CMP=COS(MU(1)*DTOR)
C
      IF(IPOS.EQ.0.AND.IDIFRT.NE.3)GOTO 5
      SMS=SIN(MU(2)*DTOR)
      CMS=COS(MU(2)*DTOR)
C
C
5     SPP2=CPP*SPP
      SPP2=SPP2+SPP2
      CPP2=CPP*CPP-SPP*SPP
C
      SPP3=CPP*SPP2+CPP2*SPP
      CPP3=CPP*CPP2-SPP*SPP2
C
      SPP4=CPP2*SPP2
      SPP4=SPP4+SPP4
      CPP4=CPP2*CPP2-SPP2*SPP2
C
      SPP5=CPP2*SPP3+CPP3*SPP2
      CPP5=CPP2*CPP3-SPP2*SPP3
C
      SPP6=CPP3*SPP3
      SPP6=SPP6+SPP6
      CPP6=CPP3*CPP3-SPP3*SPP3
C
      SPS2=CPS*SPS
      SPS2=SPS2+SPS2
      CPS2=CPS*CPS-SPS*SPS
C
      SPS3=CPS*SPS2+CPS2*SPS
      CPS3=CPS*CPS2-SPS*SPS2
C
      SPS4=CPS2*SPS2
      SPS4=SPS4+SPS4
      CPS4=CPS2*CPS2-SPS2*SPS2
C
      SPS5=CPS2*SPS3+CPS3*SPS2
      CPS5=CPS2*CPS3-SPS2*SPS3
C
      SPS6=CPS3*SPS3
      SPS6=SPS6+SPS6
      CPS6=CPS3*CPS3-SPS3*SPS3
C
      SMP2=CMP*SMP
      SMP2=SMP2+SMP2
      CMP2=CMP*CMP-SMP*SMP
C
      SMP3=CMP2*SMP+CMP*SMP2
      CMP3=CMP2*CMP-SMP2*SMP
C
      SMP4=CMP2*SMP2
      SMP4=SMP4+SMP4
      CMP4=CMP2*CMP2-SMP2*SMP2
C
      IF(IPOS.EQ.0.AND.IDIFRT.NE.3)GOTO 10
      SMS2=CMS*SMS
      SMS2=SMS2+SMS2
      CMS2=CMS*CMS-SMS*SMS
C
      SMS3=CMS2*SMS+CMS*SMS2
      CMS3=CMS2*CMS-SMS2*SMS
C
      SMS4=CMS2*SMS2
      SMS4=SMS4+SMS4
      CMS4=CMS2*CMS2-SMS2*SMS2
      GOTO 15
C
C   FOR BISECTING GEOMETRY
10    SMS=SMP
      CMS=CMP
      SMS2=SMP2
      CMS2=CMP2
      SMS3=SMP3
      CMS3=CMP3
      SMS4=SMP4
      CMS4=CMP4
C
15    SXP11=CPP*SMP+SPP*CMP
      CXP11=CPP*CMP-SPP*SMP
      SXS11=CPS*SMS+SPS*CMS
      CXS11=CPS*CMS-SPS*SMS
C
      SXP22=CPP2*SMP2+SPP2*CMP2
      CXP22=CPP2*CMP2-SPP2*SMP2
      SXS22=CPS2*SMS2+SPS2*CMS2
      CXS22=CPS2*CMS2-SPS2*SMS2
C
      SXP33=CPP3*SMP3+SPP3*CMP3
      CXP33=CPP3*CMP3-SPP3*SMP3
      SXS33=CPS3*SMS3+SPS3*CMS3
      CXS33=CPS3*CMS3-SPS3*SMS3
C
      SXP44=CPP4*SMP4+SPP4*CMP4
      CXP44=CPP4*CMP4-SPP4*SMP4
      SXS44=CPS4*SMS4+SPS4*CMS4
      CXS44=CPS4*CMS4-SPS4*SMS4
C
      SXP21=CPP2*SMP+SPP2*CMP
      CXP21=CPP2*CMP-SPP2*SMP
      SXS21=CPS2*SMS+SPS2*CMS
      CXS21=CPS2*CMS-SPS2*SMS
C
      SXP31=CPP3*SMP+SPP3*CMP
      CXP31=CPP3*CMP-SPP3*SMP
      SXS31=CPS3*SMS+SPS3*CMS
      CXS31=CPS3*CMS-SPS3*SMS
C
      SXP41=CPP4*SMP+SPP4*CMP
      CXP41=CPP4*CMP-SPP4*SMP
      SXS41=CPS4*SMS+SPS4*CMS
      CXS41=CPS4*CMS-SPS4*SMS
C
C
      ROWJ(1)=SPP
      ROWJ(2)=SPP2
      ROWJ(3)=SPP3
      ROWJ(4)=SPP4
      ROWJ(5)=SPP5
      ROWJ(6)=SPP6
C
      ROWJ(7)=CPP
      ROWJ(8)=CPP2
      ROWJ(9)=CPP3
      ROWJ(10)=CPP4
      ROWJ(11)=CPP5
      ROWJ(12)=CPP6
C
      ROWJ(13)=SMP
      ROWJ(14)=SMP2
      ROWJ(15)=SMP3
      ROWJ(16)=SMP4
C
      ROWJ(17)=CMP
      ROWJ(18)=CMP2
      ROWJ(19)=CMP3
      ROWJ(20)=CMP4
C
      ROWJ(21)=SXP11
      ROWJ(22)=SXP21
      ROWJ(23)=SXP31
      ROWJ(24)=SXP41
      ROWJ(25)=SXP22
      ROWJ(26)=SXP33
      ROWJ(27)=SXP44
C
      ROWJ(28)=CXP11
      ROWJ(29)=CXP21
      ROWJ(30)=CXP31
      ROWJ(31)=CXP41
      ROWJ(32)=CXP22
      ROWJ(33)=CXP33
      ROWJ(34)=CXP44
C
      ROWJ(35)=SPS
      ROWJ(36)=SPS2
      ROWJ(37)=SPS3
      ROWJ(38)=SPS4
      ROWJ(39)=SPS5
      ROWJ(40)=SPS6
C
      ROWJ(41)=CPS
      ROWJ(42)=CPS2
      ROWJ(43)=CPS3
      ROWJ(44)=CPS4
      ROWJ(45)=CPS5
      ROWJ(46)=CPS6
C
      ROWJ(47)=SMS
      ROWJ(48)=SMS2
      ROWJ(49)=SMS3
      ROWJ(50)=SMS4
C
      ROWJ(51)=CMS
      ROWJ(52)=CMS2
      ROWJ(53)=CMS3
      ROWJ(54)=CMS4
C
      ROWJ(55)=SXS11
      ROWJ(56)=SXS21
      ROWJ(57)=SXS31
      ROWJ(58)=SXS41
      ROWJ(59)=SXS22
      ROWJ(60)=SXS33
      ROWJ(61)=SXS44
C
      ROWJ(62)=CXS11
      ROWJ(63)=CXS21
      ROWJ(64)=CXS31
      ROWJ(65)=CXS41
      ROWJ(66)=CXS22
      ROWJ(67)=CXS33
      ROWJ(68)=CXS44
C
      IF(.NOT.TCOR.OR.NCY.EQ.1) GOTO 20
C
      ST2=CT*ST
      ST2=ST2+ST2
      CT2=CT*CT-ST*ST
C
      ST3=CT*ST2+CT2*ST
      CT3=CT*CT2-ST*ST2
C
      ST4=CT2*ST2
      ST4=ST4+ST4
      CT4=CT2*CT2-ST2*ST2
C
      ST5=CT2*ST3+CT3*ST2
      CT5=CT2*CT3-ST2*ST3
C
C
      ROWJ(69)=ST
      ROWJ(70)=ST2
      ROWJ(71)=ST3
      ROWJ(72)=ST4
      ROWJ(73)=ST5
C
      ROWJ(74)=CT
      ROWJ(75)=CT2
      ROWJ(76)=CT3
      ROWJ(77)=CT4
      ROWJ(78)=CT5
C
20    RETURN
      END
C
C
C
C
CODE FOR AFACT
      SUBROUTINE AFACT (PS1,PS2,PS3,ABSFAC)
C     *************************************
C
C   ROUTINE TO CALCULATE ABSORPTION FACTOR
C
      LOGICAL TCOR
      COMMON /NORMAL/ ANORM(44,44),ATB(44),ROWJ(88),TERMS(44)
      COMMON /DRVR/ LI,LD,LO,lf,lp,ncy,NSHAPE,NACOEF,NBCOEF,SFMU,TCOR
C
C
      PS1=1.0
      PS2=1.0
      PS3=1.0
C
      DO 10 J=1,NACOEF
      JJ=J+NACOEF
      PS1=PS1 + TERMS(J)*ROWJ(J)
      PS2=PS2 + TERMS(J)*ROWJ(JJ)
10    CONTINUE
C
      IF(.NOT.TCOR.OR.NCY.LE.2) GOTO 30
C
      NSTART=NACOEF+1
      DO 20 J=NSTART,NSHAPE
      JJ=J+NACOEF
      PS3=PS3 + TERMS(J)*ROWJ(JJ)
20    CONTINUE
C
30    ABSFAC = PS1*PS2*PS3
C
C
      RETURN
      END
C
C
C
C
C
C
C
C
CODE FOR RES
      SUBROUTINE RES (NF)
C     *******************
C
C  ROUTINE TO ACCUMULATE RESIDUAL INFORMATION
C
C
      LOGICAL TCOR
      REAL MU
      COMMON /REFL/ FC,FO,FM,PHI(2),MU(2),SINTH,COSTH
      COMMON /DRVR/ LI,LD,LO,lf,lp,ncy,NSHAPE,NACOEF,NBCOEF,SFMU,TCOR
      COMMON /SRES/ NUMREF,SUMRES,SUMFS,SUMRSQ,SUMFSQ
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      IF(NF.NE.-1) GOTO 100
C
C  NF=-1      INITIALIZE
      NUMREF=0
      SUMRES=0.0
      SUMFS=0.0
      SUMRSQ=0.0
      SUMFSQ=0.0
      RETURN
C
100   IF(NF.NE.0) GOTO 200
C
C  NF=0       ADD IN THIS REFLECTION
      NUMREF=NUMREF+1
      SUMFS=SUMFS + FC
      SUMFSQ=SUMFSQ + FC*FC
      RESID=ABS( FC-FM )
      SUMRES=SUMRES + RESID
      SUMRSQ=SUMRSQ + RESID*RESID
      RETURN
C
C  NF=1       END      REPORT RESULTS
200   CONTINUE
      RM=SUMRES/SUMFS
      RMS=SQRT(SUMRSQ/SUMFSQ)
      IF (ISSPRT .EQ. 0) WRITE(NCWU,210) NUMREF, RM , RMS
210   FORMAT(/' **ANALYSIS OF RESIDUALS**'/' For the',I6,
     +' reflections'/' the relative residual was ',F6.4,
     +'   and the relative rms residual was ',F6.4/)
      RETURN
      END
C
C
C
C
CODE FOR ABSPRI
      SUBROUTINE ABSPRI (MUMIN,MUMAX,THMAX)
C     *************************************
C
C
C   PRINT ABSORPTION SURFACE AND THETA CURVE
C
C
      LOGICAL TCOR
      REAL MU,MUMIN,MUMAX,A(18)
      COMMON /NORMAL/ ANORM(44,44),ATB(44),ROWJ(88),TERMS(44)
      COMMON /REFL/ FC,FO,FM,PHI(2),MU(2),SINTH,COSTH
      COMMON /DRVR/ LI,LD,LO,lf,lp,ncy,NSHAPE,NACOEF,NBCOEF,SFMU,TCOR
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
C
      DATA DTOR/0.0174533/
C
C   PRINT PHI AT INTERVALS OF 10 DEGREES
C   AND MU AT INTERVALS OF 5 DEGREES
      IMAX=MUMAX/5. + 0.8
      IMIN=MUMIN/5. - 0.8
      MRANGE=IMAX-IMIN + 1
      MUS=IMAX*5
      MUF=IMIN*5
C
C
      DO 100 J=1,2
      NPS=(J-1)*180
      NPF=NPS+170
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,50)NPS,NPF,MUF,MUS,(JJ,JJ=NPS,NPF,10)
50    FORMAT(//' ABSORPTION SURFACE FOR PHI =',I4,' --->',I4,
     +' WITH MU RANGE =',I3,' --->',I3, / 6X,18(I3,2X) )
      ENDIF
C
      DO 90 I=1,MRANGE
      II=(IMAX - (I-1))*5
      RMU=II
      IF(II.GT.0) RMU=SQRT(RMU)*SFMU
      IF(II.LT.0) RMU=-SQRT(ABS(RMU))*SFMU
      MU(1)=RMU
      MU(2)=RMU
C
      DO 80 K=1,18
      KK=(K-1)*10 + NPS
      PHI(1)=KK
      PHI(2)=KK
C
      CALL ABSTOR
      CALL AFACT (PS1,PS2,PS3,ABSFAC)
      A(K)=PS1*PS2
80    CONTINUE
C
      IF (ISSPRT .EQ. 0)  WRITE(NCWU,200)II,A
200   FORMAT(I4,1X,18F5.2)
90    CONTINUE
C
100   CONTINUE
C
      IF(.NOT.TCOR) GOTO 500
C
C   PRINT THETA DEPENDENT CURVE AT 5 DEGREE INTERVALS
      IMAX=THMAX/5. + 0.8
      MRANGE=IMAX+1
      MEND=IMAX*5
C
      DO 350 I=1,MRANGE
      THET=(I-1)*5.
      SINTH=SIN(THET*DTOR)
      COSTH=COS(THET*DTOR)
      CALL ABSTOR
      CALL AFACT(PS1,PS2,PS3,ABSFAC)
      A(I)=PS3
C
350   CONTINUE
C
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,400) MEND,(I,I=0,MEND,5)
400   FORMAT(/' Curve for THETA = 0 --->',I3,/3X,18(I7))
        WRITE(NCWU,410) (A(I),I=1,MRANGE)
410   FORMAT(5X,18F7.3)
      ENDIF
C
C
500   RETURN
      END
C
C
C
C
CODE FOR ABSPLY
      SUBROUTINE ABSPLY (NREF, IACTN)
C     ************************
C
C
C------ IACTN -1 DONT WRITE THE CORRECTED DATA TO DISK
C              0 TRY TO UPDATE THE EXISTING LIST 6
C              1 CREATE A NEW LIST 6
C
C
      LOGICAL TCOR
      REAL MU
C
      DIMENSION IBUF(7)
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 30
      PARAMETER (IDIM30 = 32)
      DIMENSION ICOM30(IDIM30)
      DIMENSION ISTORE(131072)
C
      COMMON /NORMAL/ ANORM(44,44),ATB(44),ROWJ(88),TERMS(44)
      COMMON /REFL/ FC,FO,FM,PHI(2),MU(2),SINTH,COSTH
      COMMON /DRVR/ LI,LD,LO,lf,lp,ncy,NSHAPE,NACOEF,NBCOEF,SFMU,TCOR
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XDISCS/NCDFU,NCIFU,NCLDU , NCNDU
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST30/
     1 L30DR,M30DR,MD30DR,N30DR, L30CD,M30CD,MD30CD,N30CD,
     2 L30RF,M30RF,MD30RF,N30RF, L30IX,M30IX,MD30IX,N30IX,
     3 L30AB,M30AB,MD30AB,N30AB, L30GE,M30GE,MD30GE,N30GE,
     4 L30CL,M30CL,MD30CL,N30CL, L30SH,M30SH,MD30SH,N30SH
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (L30DR,ICOM30(1))
C
      DATA AMIN / 100.0 / , AMAX / -100.0 /
C
C
C      READ LIST 6 AGAIN
      CALL XFAL06(0)
C     START WRITING NEW LIST 6
      IF (IACTN .EQ. 1) THEN
C----- FIND OUT HOW MUCH ROOM WE NEED
        LN = 6
        I =  KRCLI (LN,IBUF(1),IBUF(2),IBUF(3),IBUF(4),IBUF(5),
     1                 IBUF(6),IBUF(7))
        LENTOT = (IBUF(3) - IBUF(2)) + 1
        CALL XDACVI (IBUF(1),IBUF(2),IBUF(3),IBUF(4),IBUF(5),
     1                 IBUF(6),IBUF(7))
        LSTLEN = (LENTOT / IBUF(1)) + 1
        IEXTN =  KDAFRE (NCDFU, -1, LSTLEN)
      IF (ISSPRT .EQ. 0) WRITE(NCWU, 150) IEXTN
        WRITE(NCAWU, 150) IEXTN
150     FORMAT (/,' Disc file extended by ', I6, ' records')
        CALL XSTR06( 6, 0, 0, 0, 0)
      ELSE IF (IACTN .EQ. 0) THEN
        CALL XSTR06 (6, 0, 1, -1, 0)
      END IF
C
      NTOT=0
      ATOT=0.
      NSET=1
      SFMUSQ=SFMU*SFMU
C     SET REFLECTION PROCESSED TO ZERO

C
C   INITIALIZE RESIDUALS
      NF=-1
      CALL RES(NF)
C
C
      NF=0
      REWIND LF
C     START FETCHING THE REFLECTIONS
20    CONTINUE
      IF ( KLDRNR(0) .LE. -1) GOTO 100
C
      FOBS = STORE(M6+3)
      SIGF = STORE(M6+12)
C
      READ(LF) IUSED,FC,FO,PHI,MU,SINTH,COSTH
      IF(FOBS.LE.0.0) GOTO 30
      NTOT=NTOT + 1
C
      CALL ABSTOR
      CALL AFACT(PS1,PS2,PS3,A)
      IF(A.GT.AMIN) GOTO 2
      AMIN=A
      APHINP=PHI(1)
      APHINS=PHI(2)
      AMUNP=MU(1)*ABS(MU(1))/SFMUSQ
      AMUNS=MU(2)*ABS(MU(2))/SFMUSQ
2     IF(A.LT.AMAX) GOTO 4
      AMAX=A
      APHIXP=PHI(1)
      APHIXS=PHI(2)
      AMUXP=MU(1)*ABS(MU(1))/SFMUSQ
      AMUXS=MU(2)*ABS(MU(2))/SFMUSQ
4     ATOT=ATOT + A
C
C
      IF(IUSED.NE.1) GOTO 10
      FM=FO*A
      CALL RES(NF)
C
10    FOBS=FOBS*A
      SIGF=SIGF*A
30    CONTINUE
C
C     UPDATE VALUES INSTORE
      STORE(M6+3)=FOBS
C     UPDATE SIGMA IF STORED
      STORE(M6+12)=SIGF
      NREF=NREF+1
C
C
C     STORE THIS REFLECTION
      IF (IACTN .GE. 0) CALL XSLR(1)
C     LOOP FOR NEXT REFLECTION
      GO TO 20
100   CONTINUE
C
C     CLOSE NEW LIST 6
      IF (IACTN .GE. 0) CALL XEND06
C
C
C   REPORT RESIDUALS AFTER CORRECTION
      IF (ISSPRT .EQ. 0) WRITE(NCWU,300)
300   FORMAT(//' RESIDUALS AFTER CORRECTION')
      NF=1
      CALL RES(NF)
C
C
C   REPORT CORRECTION SUMMARY
      AVER=ATOT/NTOT
      WRITE(NCAWU,200)NTOT,AMIN,APHINP,AMUNP,APHINS,AMUNS,AMAX,
     +APHIXP,AMUXP,APHIXS,AMUXS,AVER
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,200)NTOT,AMIN,APHINP,AMUNP,APHINS,AMUNS,AMAX,
     +APHIXP,AMUXP,APHIXS,AMUXS,AVER
200   FORMAT(//I6,' Reflections corrected'
     +       /' Minimum absorption correction =',F6.3,
     +  5X,'at  PHI(P)=',F5.1,' MU(P)=',F5.1, /47X,
     +  'PHI(S)=',F5.1,' MU(S)=',F5.1,
     +       /' Maximum absorption correction =',F6.3,
     +  5X,'at  PHI(P)=',F5.1,' MU(P)=',F5.1, /47X,
     +  'PHI(S)=',F5.1,' MU(S)=',F5.1,
     +       /' Average absorption correction =',F6.3)
      ENDIF
C
C----- UPDATE AND STORE LIST 30
      CALL XFAL30
      STORE(L30AB + 6) = AMIN
      STORE(L30AB + 7) = AMAX
      ISTORE(L30AB + 8) = 1
      CALL XWLSTD ( 30, ICOM30, IDIM30, -1, -1)
C
      RETURN
      END
C
C
C
C
C
C
CODE FOR CELL
      SUBROUTINE CELL
C     ***************
C
C   GENERAL SUBROUTINE TO CALCULATE CELL PARAMETERS FROM THE
C   ORIENTATION MATRIX
C
      LOGICAL TCOR
      COMMON /DRVR/ LI,LD,LO,lf,lp,ncy,NSHAPE,NACOEF,NBCOEF,SFMU,TCOR
      COMMON/ORIENT/TWOTHZ,OMZ,PHIZ,PLUS(3),IPOS,IDIFRT,ORIENT(3,3),DST
      COMMON /CELLP/ TA,TB,TC,ZA,ZB,ZC
      REAL DIRECT(3,3),W(3),X(3),Y(3),Z(3)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
C
C
      DATA RAD / 57.2957795 /
C
      CALL AMI3(ORIENT,DIRECT,DET)
C
      DO 11 I=1,3
      W(I)=0.
      Y(I)=0.
      DO 12 J=1,3
      W(I)=W(I)+ORIENT(J,I)**2
      Y(I)=Y(I)+DIRECT(I,J)**2
12    CONTINUE
      Y(I)=SQRT(Y(I))
11    CONTINUE
C
      DO 13 I=1,3
      J=I+1
      K=J+1
      IF(J.GT.3)J=J-3
      IF(K.GT.3)K=K-3
      X(I)=0.
      Z(I)=0.
      DO 14 L=1,3
      X(I)=X(I) + ORIENT(L,J)*ORIENT(L,K)
      Z(I)=Z(I) + DIRECT(J,L)*DIRECT(K,L)
14    CONTINUE
      X(I)=2*X(I)
      COSZ=Z(I)/Y(J)/Y(K)
      SINZ=SQRT(1. - COSZ*COSZ)
      Z(I)=ATAN(SINZ/COSZ)*RAD
      IF(Z(I).LT.0.)Z(I)=Z(I)+180.
13    CONTINUE
C
      TA=W(1)
      TB=W(2)
      TC=W(3)
      ZA=X(1)
      ZB=X(2)
      ZC=X(3)
C
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,100)((ORIENT(I,J),J=1,3),I=1,3),Y,Z
100   FORMAT(/' Orientation Matrix:'/,3(5X,3F10.6/),/
     +' Unit Cell Parameters:'/,'  a=',F7.3,'  b=',F7.3,'  c=',F7.3,
     +'   alpha=',F7.2,'  beta=',F7.2,'  gamma=',F7.2/)
      ENDIF
C
      RETURN
      END
C
C
C
C
C
CODE FOR ANGLES
      SUBROUTINE ANGLES (OMEGA,PHI,CHI,X,IERR)
C     ****************************************
C
C.... CALCULATES DIFFRACTOMETER SETTING ANGLES GIVEN OMEGA
C
      COMMON/ORIENT/TWOTHZ,OMZ,PHIZ,PLUS(3),IPOS,IDIFRT,ORIENT(3,3),DST
      DIMENSION X(3),E(3)
      DATA RAD/57.2957795/
      DATA PI/3.1415926563/
C
      DO 14 I=1,3
      E(I)=0.
      DO 12 J=1,3
   12 E(I)=E(I)+ORIENT(I,J)*X(J)
   14 E(I)=E(I)/DST
      IERR=0
C
      IF(IPOS.NE.1) GO TO 36
C
C     CHI=90, DATA COLLECTED IN PARALLEL POSITION.
C
      CHI=90.
      IF(ABS(E(3)).GT.1.) GO TO 64
      OMEGA = ACOS ( ABS( E(3) ) )
      IF(-E(3).GE.0.) GO TO 20
      OMEGA = PI - OMEGA
   20 CPHI=E(1)/SIN(OMEGA)
      SPHI=-E(2)/SIN(OMEGA)
      IF (CPHI.GT.1..OR.SPHI.GT.1.) GO TO 64
      CALL ARCTAN (PHI,CPHI,SPHI)
      IF ( E(1) .LE. 0.0 ) GO TO 26
      IF ( E(2) ) 30 , 30 , 28
   26 IF (E(2))34,34,32
   28 PHI=360. - ACOS(CPHI)*RAD
      GO TO 35
   30 PHI=ACOS(CPHI)*RAD
      GO TO 35
C*****THIS MAY BE IN ERROR BECAUSE OF THE WAY ARCTAN WORKS:
   32 PHI= 180. + PHI
      GO TO 35
   34 PHI=180. - PHI
   35 OMEGA=OMEGA*RAD
      GO TO 62
C
   36 IF(IDIFRT.NE.3) GO TO 80
C
C    DATA COLLECTED IN BISECTING POSITION.  (PICKER GEOMETRY).
C
      C=ABS(COS(OMEGA/RAD))
      IF (C-0.000001) 38,38,42
   38 IF(ABS(E(3))-0.000001) 40,40,64
   40 CHI=0.0
      CPHI=E(1)
      SPHI=-E(2)
      GO TO 58
   42 SCHI=-E(3)/C
      IF(ABS(SCHI).GT.1.0) SCHI=SIGN(1.0,SCHI)
      A=SIN(OMEGA/RAD)
      CCHI=SQRT(1.0-SCHI**2)
      CALL ARCTAN (CHI,CCHI,SCHI)
      B=C*CCHI
      DENO=A**2+B**2
      IF (DENO-0.000001) 46,46,48
   46 PHI=0.0
      GO TO 62
   48 CPHI=(A*E(1)+B*E(2))/DENO
      IF(ABS(CPHI).GT.1.0) CPHI=SIGN(1.0,CPHI)
      IF (B-0.0000001) 52,52,54
   52 SPHI=-E(2)/A
      GO TO 56
   54 SPHI=(E(1)-A*CPHI)/B
   56 IF(ABS(SPHI).GT.1.0) SPHI=SIGN(1.0,SPHI)
   58 CALL ARCTAN (PHI,CPHI,SPHI)
   62 OMEGA=OMZ+OMEGA/PLUS(1)
      GO TO 90
   64 IERR=1
      RETURN
C
C     DATA COLLECTED IN BISECTING POSITION.  (NONIUS & SYNTEX GEOMETRY)
C
   80 OMEGA=0.0
      C=1.0
      A=0.0
      SCHI=-E(3)
      IF(ABS(SCHI).GT.1.0) SCHI=SIGN(1.0,SCHI)
C
C     COS(CHI) ALWAYS POSITIVE IF COLLECTING IN LOWER
C     HEMISPHERE  (-90<CHI<+90).
C
      CCHI=SQRT(1.0-SCHI**2)
      CALL ARCTAN (CHI,CCHI,SCHI)
      IF(CCHI-0.0001) 46,46,84
   84 CPHI=E(2)/CCHI
      IF(ABS(CPHI).GT.1.0) CPHI=SIGN(1.0,CPHI)
      SPHI=E(1)/CCHI
      IF(ABS(SPHI).GT.1.0) SPHI=SIGN(1.0,SPHI)
      CALL ARCTAN (PHI,CPHI,SPHI)
   90 PHI=PHIZ+PHI/PLUS(2)
      CHI=CHI/PLUS(3)
      RETURN
      END
C
C
C
C
CODE FOR ARCTAN
      SUBROUTINE ARCTAN (A,COSA,SINA)
C     *******************************
C
      DATA RAD/57.2957795/
C
C   CALCULATES ARC TAN IN DEGREES.
C
      IF(COSA) 10,20,10
10    A=ATAN(SINA/COSA)*RAD
      IF(COSA) 30,30,40
20    A=90.0
      IF(SINA) 30,30,40
30    A=A+180.0
40    RETURN
      END
C
C
C
CODE FOR NORM
      SUBROUTINE NORM (A)
C     *******************
C
      DO 14 I=1,10
      IF (A) 12,16,16
12    A=A+360.
14    CONTINUE
16    A=AMOD(A,360.0)
      RETURN
      END
CRYSTALS CODE FOR DISTANGLE
CODE FOR XDIST
      SUBROUTINE XDIST
C--CALCULATE AND PRINT DISTANCES AND ANGLES
C
C  AT      MINIMUM CONTACT FOR DISTANCES.
C  AC      MAXIMUM CONTACT FOR DISTANCES.
C  BT      MINIMUM CONTACT FOR ANGLES.
C  BC      MAXIMUM CONTACT FOR ANGLES.
C  BP      MINIMUM OVERALL CONTACT SQUARED.
C  AP      MAXIMUM OVERALL CONTACT SQUARED.
C  AO      MAXIMUM OVERALL CONTACT.
C  IDIST   DISTANCE OR BOX FLAG :
C          -1  D/A CALCULATION.
C
C----- CONTROL VARIABLES IN XPROCD
C
C  IALL    DISTANCE CONTROL FLAG :
C          -1  PRINT CONTACTS TO THOSE ATOMS BELOW THE CURRENT ONE IN LI
C           0  PRINT ALL CONTACTS TO THE CURRENT ATOM.
C  IP      PRINT CONTROL FLAG FOR COORDINATES :
C          -1  DO NOT PRINT GENERATED COORDINATE FOR A DISTANCE.
C           0  PRINT GENERATED COORDINATES FOR A DISTANCE.
C  IESD    E.S.D. CALCULATION CONTROL FLAG :
C          -1  DO NOT CALCULATE E.S.D.'S.
C           0  CALCULATE E.S.D.'S.
C  ICELL   CELL E.S.D. CONTROL FLAG :
C          -1  DO NOT THE CELL E.S.D.'S IN THE E.S.D. CALCULATIONS.
C           0  INCLUDE THE UNIT CELL E.S.D.'S IN THE E.S.D. CALCULATIONS
C  ISORT   DETERMINES WHETHER THE DISTANCES ARE SORTED :
C          -1  DO NOT SORT THE DISTANCES AT EACH ATOM
C           0  SORT THE DISTANCES.
C  INTRA   CONTROLS WHETHER ONLY INTRA-MOLECULAR DISTANCES AND ANGLES
C          ARE PRODUCED :
C          -1  ALL D/A OUTPUT IS PRODUCED.
C           0  ONLY INTRA-MOLECULAR D/A OUTPUT IS LISTED.
C           1  ONLY INTER-MOLECULAR OUTPUT IS PRODUCED.
C
C  LEVEL   CONTROLS LISTING LEVEL
C            -1 OFF
C             0 LOW
C             1 HIGH
C             2 HIGH
C
C  IULN    THE INPUT LIST TYPE.
C  IRDUS     TYPE OF RADIUS TO USE
C            0 OVERALL LIMITS
C            N N'TH RADIUS FROM LIST 29
C
C  IDSPDA   MONITOR LEVEL
C            0 OFF
C            1 DISTANCES
C            2 ANGLES
C            3 ALL
C  IPUNCH    PUNCHED OUTPUT
C            -1 NOTHING
C            -1 NOTHING
C             0 RESTRAINTS
C             1 PUBLICATION
C             2 CIF
C
C  ISYMOD   SYMMETRY MODIFIER
C           -1  PATTERSON
C            0  NORMAL
C            1  NOSYMMETRY
C
C  ITRANS   TRANSLATION MODIFIER
C           -1 DO NOT APPLY UNIT CELL TRANSLATIONS
C            0 DO APPLY UNIT CELL TRANSLATIONS
C
C
C
C----- A FUNCTION VECTOR IS DEFINED TO INDICATE THE TREATMENT OF ATOMS
C
C----- JFNVC - 0 DONOT USE THE FUNCTION VECTOR
C              1 DO    USE THE FUNCTION VECTOR
C      LFNVC,MFNVC ECT, THE FUNCTION VECTOR POINTERS
C
C      (MFNVC +0)      USE FLAG
C                        -1      DO NOT USE ATOM
C                         0      CAN BE USED DURING INPUT TO INDICATE
C                                  ACTION NOT YET SPECIFIED
C                         1      DO USE ATOM
C      (MFNVC +1)      RADIUS FOR CONTACT
C
C      IDEFFN      THE VALUE TO BE USED FOR ATOMS WHOSE INCLUDE/EXCLUDE
C                  STATUS IS NOT EXPLICITLY STATED.
C                    -1      EXCLUDE UNSPECIFIED ATOMS
C                     0      INITIAL VALUE. IF STILL 0 WHEN INPUT IS
C                            COMPLETE, THIS IS CHANGED TO 1.
C                     1      INCLUDE SPECIFIED ATOMS
C
C -- THE POSSIBLE INCLUSION / EXCLUSION SPECIFICATIONS ARE:-
C
C            DIRECTIVES USED   IDEFFN      ACTION
C            ---------- ----   ------      ------
C            NONE              0           ALL ATOMS INCLUDED
C            INCLUDE ONLY      -1          UNSPECIFIED ATOMS EXCLUDED
C            EXCLUDE ONLY      +1          UNSPECIFIED ATOMS INCLUDED
C            INCLUDE + EXCLUDE -1          UNSPECIFIED ATOMS EXCLUDED
C
C
C
C--THE COMMON BLOCK XWORKA IS USED AS :
C
C  JA  ADDRESS OF FIRST ATOM IN ATOM COORDINATE STACK
C  JB  ADDRESS OF THE SECOND ATOM IN THE COORDINATE STACK
C  JC  ADDRESS OF ANY ATOM IN THE STACK
C  JD  WORK SPACE
C  JE  WORK SPACE
C  JF  WORK SPACE
C
C--ALL THE ABOVE WORK SPACE WILL HOLD THE LARGEST USED MATRIX
C
C  JG  ADDRESS OF THE SYMMETRY MATRIX FOR THE FIRST ATOM IN DISTANCES
C  JH  ADDRESS OF THE SYMMETRY MATRIX FOR THE SECOND ATOM IN DISTANCES
C  JI  ADDRESS OF THE SYMMETRY MATRIX FOR ANY ATOM IN DISTANCES
C
C  JJ  ADDRESS OF THE SYMMETRY MATRIX FOR THE FIRST ATOM IN ANGLES
C  JK  ADDRESS OF THE SYMMETRY MATRIX OF THE SECOND ATOM IN ANGLES
C  JL  ADDRESS OF THE SYMMETRY MATRIX OF THE THIRD ATOM IN ANGLES
C
C  JM  ADDRESS OF THE FIRST ELEMENT OF THE V/CV MATRIX FOR DISTANCES
C  JN  ADDRESS OF THE FIRST ELEMENT OF THE FIRST ATOM IN THE V/VC
C      MATRIX FOR DISTANCES
C
C  JP  ADDRESS OF THE FIRST ELEMENT OF THE V/VC MATRIX FOR ANGLES
C  JQ  ADDRESS OF THE FIRST ELEMENT OF THE FIRST ATOM IN THE V/VC
C      MATRIX FOR ANGLES
C
C  JS  THE NEXT ADDRESS THAT CAN BE USED IN THE STACK ON RETURN
C      FROM 'XDIST1'.
C      (THE STACK STARTS AT 'NFL' AND GOES UP).
C  JT  THE NUMBER OF WORDS PER ENTRY IN THE STACK.
C
C  JU  FIRST ANGLE TO CALCULATE
C  JV  LAST ANGLE TO CALCULATE
C  IJW  START OF PRINT BUFFER
C  IJX  CURRENT ITEM IN BUFFER
C  IJY  LAST POSITION IN BUFFER
C
C--FOR ANGLES THE ATOMS ARE GIVEN BY :
C
C  B - A - C
C
C  ANGLE(1) IS AT C
C  ANGLE(2) IS AT A
C  ANGLE(3) IS AT B
C
C  L(1)  A TO B
C  L(2)  B TO C
C  L(3)  C TO A
C
C--
C
      CHARACTER *4 RESTR, RESTR1, RESTR2
      CHARACTER *12 CBUFF
      CHARACTER *32 CATOM1, CATOM2, CATOM3, CBLANK
C
C----- NOTE THAT IF STR11 IS USED DOUBLE PRECISION, LENGRP IN
C      LIST11 IN COMMAND FILE MUST BE CHANGED FROM 1 TO 2
C      FOR LHS AND RHS
C      AND I11LEN IN XPRC12
C      DOUBLE PRECISION STR11(1048576)
      DIMENSION STR11(1048576)
      DIMENSION ISTORE(131072)
C
      DIMENSION B(3), PROCS(17)
      DIMENSION CC(4),TT(2)
      DIMENSION IS(9),ANGLE(3),DIST(3),DISTSQ(3)
      DIMENSION IAPD(13)
      DIMENSION INTRAD(5)
C----- TO HOLD HE NUMBER OF 'PARTS' PER ATOM
      DIMENSION IPART(3)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDATF/NFLD,LFLD,NULD
C      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDSTNC/AT,AC,BT,BC,BP,AP,AO,IDIST,LBOX,MBOX,MDBOX,NBOX,
     2 LFNVC,MFNVC,MDFNVC,NFNVC,MFNVCA
C
      COMMON /XPROCD/DISTS(4),IALL,IP,IESD,ICELL,ISORT,INTRA,LEVEL,IULN
     1 ,IRDUS,IDSPDA,IPUNCH,ISYMOD,ITRANS
      COMMON /XDISTW/A,BB,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST11/L11,M11,MD11,N11,L11R,M11R,MD11R,N11R,
     2 L11P,M11P,MD11P,N11P,L11IR,M11IR,MD11IR,N11IR
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XLST29/L29,M29,MD29,N29
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (STR11(1),XSTR11(1))
C
      EQUIVALENCE (DISTS(1),PROCS(1))
      EQUIVALENCE (B(1),C)
      EQUIVALENCE (CC(1),AC),(TT(1),AT)
      EQUIVALENCE (APD(1),IAPD(1))
C
C
      DATA RESTR1 /'DIST'/, RESTR2 /'ENER'/
      DATA TOLER1 / .2 /, TOLER2 / .5 /
C
      DATA IDIMN /17/
C
      DATA IS(1)/0/,IS(2)/3/,IS(3)/6/
      DATA IS(4)/3/,IS(5)/3/,IS(6)/3/
      DATA IS(7)/6/,IS(8)/-6/,IS(9)/9/
C
      DATA IVERSN /620/
      DATA ANGLE(1)/0.0/,DIST(1)/0.0/,DISTSQ(1)/0.0/
C
      DATA CBLANK /' '/
#HOL      DATA AKEY /' KEY'/
&HOL      DATA AKEY /4H KEY/
C
      DATA INTRAD(1)/1/,INTRAD(2)/1/,INTRAD(3)/0/
      DATA INTRAD(4)/0/,INTRAD(5)/0/
C----- MAXIMUM PARTS PER PARAMETER
      DATA MXPPP /10/
C
C--SET THE TIMING FUNCTION
      CALL XTIME1(2)
      CALL XCSAE
C -- ALLOCATE A BUFFER FOR COMMAND PROCESSING
      MQ = KSTALL ( 100 )
C----- INITIALISE LEXICAL INPUT
      ICHNG=0
      CALL XLXINI (INEXTD, ICHNG)
C---- RESERVE A COMMAND LINE BUFFER OF 8 ELEMENTS
      JDIMBF = 8
      IDIMBF=JDIMBF+IDIMN
      ICOMBF=KSTALL(IDIMBF)
      JCOMBF = ICOMBF+JDIMBF
C----- ZERO THE BUFFER
      CALL XZEROF( ISTORE(ICOMBF), IDIMBF)
C--READ THE INITIAL CONSTANTS
C----- INSTRUCTION READING LOOP
100   CONTINUE
C----- READ A DIRECTIVE
      IDIRNM = KLXSNG(ISTORE(ICOMBF),IDIMBF,INEXTD)
      IF (IDIRNM .LT. 0) GOTO 100
      IF (IDIRNM .EQ. 0) GOTO 1000
      GOTO( 100, 100, 100, 100, 220, 230, 200, 9910), IDIRNM
      GOTO 9910
C
C
200   CONTINUE
C------ LOAD LIST 5/10
      IULN= ISTORE(JCOMBF+11)
      IULN = KTYP05 (IULN)
      CALL XLDR05 (IULN)
      IF (IERFLG .LT. 0) GOTO 9900
C----- ALLOCATE A FUNCTION VECTOR
      MDFNVC = 2
      NFNVC = N5
      I=N5*MDFNVC
      LFNVC = KSTALL (I)
      CALL XZEROF ( ISTORE(LFNVC) , I )
      IDEFFN = 0
      GOTO 100
220   CONTINUE
C -- 'INCLUDE' DIRECTIVE
      CALL XDSSEL ( ISTORE(LFNVC) , MDFNVC , NFNVC , 1 , IDEFFN )
      GO TO 100
230   CONTINUE
C -- 'EXCLUDE' DIRECTIVE
      CALL XDSSEL ( ISTORE(LFNVC) , MDFNVC , NFNVC , -1 , IDEFFN )
      GO TO 100
C--SET A FEW INITIAL CONSTANTS AND PRINT THE CAPTION
1000  CONTINUE
C
C -- COMMAND INPUT COMPLETE. CHECK FOR ERRORS
      IF ( LEF .GT. 0 ) GO TO 9910
C
C----- RELOCATE THE COMMON BLOCK DATA
      CALL XMOVE( STORE(JCOMBF), PROCS(1),IDIMN)
C----- EXTRACT THE FUNCTION FLAG
      JFNVC = MIN0(1,IRDUS)
      IRDUS = MAX0(1,IRDUS)
      CHECK = VALUE + ZERO
C----- SET RESTRAINT DIRECTIVE NAME AND DISTANCE TOLERANCE
      IF (IRDUS .EQ. 2) THEN
            RESTR = RESTR2
            TOLER = TOLER2
      ELSE
            RESTR = RESTR1
            TOLER = TOLER1
      ENDIF
C
C -- SET DEFAULT VALUE FOR 'IDEFFN'
      IF ( IDEFFN .EQ. 0 ) IDEFFN = 1
C----- LOAD LIST 29
      CALL XFAL29
C----- SCAN LIST 5 SETTING FUNCTION VECTOR TO APPROPRIATE RADIUS
      IFNVC=LFNVC
      I29=L29 + (N29-1)*MD29
      I5 = L5 + (N5-1)*MD5
      BMAX = 0.
      BMIN = 0.
      DO 7450 M5=L5,I5,MD5
      DO 7250 M29= L29,I29,MD29
      JZ=M29+IRDUS
      IF (ISTORE(M5) - ISTORE(M29)) 7250,7350,7250
7250  CONTINUE
C----- NO MATCH - POINT TO DEFAULT ATOM
      JZ = L29 + IRDUS
7350  CONTINUE
C----- MATCH
      STORE(IFNVC+1) = STORE(JZ)
      BMAX = AMAX1( BMAX, STORE(JZ))
C -- SET USE FLAG FOR THIS ATOM TO THE DEFAULT, IF THE FLAG IS NOT
C    ALREADY SET.
      IF ( ISTORE(IFNVC) .EQ. 0 ) ISTORE(IFNVC) = IDEFFN
C
      IFNVC = IFNVC + MDFNVC
7450  CONTINUE
C
      AT = DISTS(1)
      AC = DISTS(2)
      BT = DISTS(3)
      BC = DISTS(4)
C----- RESET FUNCTION VECTOR AND LIMITS IF NECESSARY
      IF(JFNVC) 7670,7670,7660
7660  CONTINUE
      BMAX = 2.*BMAX + TOLER
      AT = CHECK
      AC = BMAX
      BT = AT
C----- DONT COMPUTE ANGLES IF USING VDW RADII
      IF (IRDUS .NE. 2) BC = BMAX
7670  CONTINUE
C----- LOAD LISTS 1 AND 2, AND SET UP SOME CONSTANTS
      CALL XDIST2
      IF( IERFLG .LT. 0 ) GOTO 9900
C
C----- REDUCE SYMMETRY IF NECESSARY
      CALL KSYMOD (ISYMOD, IC, IL, N2P, L2C, L2, N2, MD2)
C
C----- WRITE OUT THE CELL CONTENT PROPERTIES
C----- SKIP THE MOLECULAR PROPERTIES CALCULATION - FOR NOW
      JZ=IESD+2
      JZ=MAX0(1,JZ)
      JZ=MIN0(2,JZ)
      CALL XPRTCN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)(IB,I=1,JZ)
      ENDIF
1050  FORMAT(21H Distances and angles,2A1,1H-,2X,
     2 39Hwith standard deviations estimated from,
     3 36H the full variance-covariance matrix)
C
      IF (JFNVC .LE. 0) THEN
      WRITE(NCAWU,1100) AT,AC,BT,BC
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)AT,AC,BT,BC
      ENDIF
1100  FORMAT(//16H Distance limits,F7.3,4H  to,F7.3//
     2 16H Angles   limits,F7.3,4H  to,F7.3)
      ELSE
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,1130) TOLER, AT
      ENDIF
        WRITE(NCAWU,1130) TOLER, AT
1130    FORMAT(1X,' Tolerance in determining contacts = ',G10.5,
     1         / ,'        Minimum resolved distance  = ',G10.5//)
      ENDIF
C
C
C
      REWIND (MTE)
C
C----- SET LEVEL TO HIGH IF COORDINATES REQUESTED
      IF ((IP .GE. 0) .AND. (LEVEL . GE. 0)) LEVEL = 1
C----- WRITE HEADER IF RESTRAINTS TO BE GENERATED
      IF (IPUNCH .EQ. 0) CALL XPCHLH (16)
C
C----- ALLOCATE ONE SLOT FOR THE MOMENT
      JF = KSTALL(1)
C--CHECK IF E.S.D.'S ARE TO CALCULATED
      IF(IESD)1150,1200,1200
C--E.S.D.'S ARE NOT TO BE CALCULATED
1150  CONTINUE
      NW=12
C----- SAVE SOME SPACE FOR THE TARGET RADIUS IN RESTRAINTS
      IF (IPUNCH .EQ. 0) NW = 14
      NCOL=9
C----- RESET COLUMNS FOR BRIEF O/P
      IF (LEVEL .LE. 0) NCOL = 11
      L12=-1
      JU=2
      JV=2
      GOTO 1800
C--SET UP THE SYSTEM FOR E.S.D.'S
1200  CONTINUE
      JQ=0
      JS=1
C--LOAD LIST 12
      CALL XFAL12(JS,JQ,JU,JV)
C--CHECK IF THE E.S.D.'S OF THE CELL PARAMETERS ARE TO INCLUDED
      IF(ICELL)1250,1300,1300
C--DO NOT INCLUDE THE CELL ERRORS
1250  CONTINUE
      NWDT=6
      NWAT=9
      GOTO 1350
C--INCLUDE THE CELL ERRORS
1300  CONTINUE
      NWDT=12
      NWAT=15
C--SET VARIOUS CONSTANTS FOR E.S.D. CALCULATIONS
1350  CONTINUE
      NWD=6
      NWA=9
      NWS=4
      NW=13
C----- SAVE SOME SPACE FOR THE TARGET RADIUS IN RESTRAINTS
      IF (IPUNCH .EQ. 0) NW = 14
      JU=1
      JV=3
      NCOL=5
C----- RESET COLUMN FOR BRIEF O/P
      IF (LEVEL .LE. 0) NCOL = 6
C--SET A FEW AREAS OF CORE FOR E.S.D. CALCLATION
      JA=NFL
      JD = JA + NWA * NWS * MXPPP
      NO=JD+NWAT*3-1
      NZ=NWAT*NWAT
      JE=JD+NZ
      JF=JE+NZ
      JG=JF+NZ
      JH=JG
      JJ=JG+NWD*NWD
      JK=JJ
      JM=JJ+NWA*NWA
      JN=JM
      JP=JM+NWDT*NWDT
      JQ=JP
C--COMPUTE THE LENGTH OF THE DATA AREA
      JS=JP+NWAT*NWAT-NFL
C--ALLOCATE THE SPACE
      LN=9
      IREC=1001
      I=KCHNFL(JS)
C--ZERO THE AREA INITIALLY
      CALL XZEROF(STORE(JA),JS)
C--SET UP THE UNIT MATRIX SYMMETRY OPERATOR FOR THE FIRST ATOM
C  IN THE AREA FOR DISTANCES AND ANGLES
      DO 1400 I=1,3
      STORE(JH)=1.
      STORE(JK)=1.
      JH=JH+NWD+1
      JK=JK+NWA+1
      JN=JN+2*(NWDT+1)
      JQ=JQ+2*(NWAT+1)
1400  CONTINUE
      JL=JK+3*(NWA+1)
C--LOAD LIST 11
      CALL XFAL11(1,1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
      IF(ISTORE(L11P+15))1600,1450,1450
1450  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1500)
      ENDIF
1500  FORMAT(//34H Matrix is wrong type for E.S.D.'s)
      CALL XERHND ( IERWRN )
      IESD=-1
      GOTO 1000
C--APPLY THE CORRECT MULTIPLICATION FACTOR TO THE MATRIX
1600  CONTINUE
      C=STORE(L11P+17)/STORE(L11P+16)
      M11=L11+N11-1
      DO 1650 I=L11,M11
      STR11(I)=STR11(I)*C
1650  CONTINUE
C--PREPARE TO INITIATE THE CELL ERROR AREA IF NECESSARY
      IF(ICELL)1750,1700,1700
1700  CONTINUE
      CALL XFAL31(JM,JP)
      IF ( IERFLG .LT. 0 ) GO TO 9900
      GOTO 1800
C--RESET THE FIRST ATOM ADDRESSES FOR NO CELL ERRORS
1750  CONTINUE
      JN=JM
      JQ=JP
C--SET THE NUMBER OF WORDS PER ATOM IN THE DISTANCES STACK
1800  CONTINUE
      JT=NW
C----- GET A LINE BUFFER
      IJW=NFL
      IJY=IJW+12
      I=KCHNFL(16)
C--SET THE ANGLE DETAILS
      G=360./PI
      GS=0.5*G
      SIN45=SIN(0.25*PI)
C--PREPARE A SORT BUFFER AT THE TOP OF CORE
      LN=9
      IREC=1002
      ITEMP1=KCHLFL(JT)
C--PREPARE ONE EMPTY SLOT AT THE TOP AS WELL
      IREC=1003
      I=KCHLFL(JT)
C
C
C
C --             **** MAIN DISTANCE / ANGLES LOOP ****
C
C
C
      M5A=L5
      M12A=L12
      MFNVCA = LFNVC
C
C
C----- SAVE THE NEXT FREE ADDRESS
      NFLBAS = NFL
      DO 6000 I=1,N5
C----- RESTORE THE NEXT FREE ADDRESS
      NFL = NFLBAS
C
C -- CAN WE USE THIS ATOM ?
      IF ( ISTORE(MFNVCA) .LE. 0 ) GO TO 5900
      M12=L12
      M5=L5
      MFNVC = LFNVC
C--CALCULATE ALL THE DISTANCES AND ANGLES ABOUT THIS ATOM
1850  FORMAT(/23H Distances about atom  ,A4,F5.0,10X,3HX =,F9.5,5X,
     2 3HY =,F9.5,5X,3HZ =,F9.5)
C--CHECK IF ANY DISTANCES OR ANGLES HAVE BEEN FOUND AT THIS ATOM
C
      K = KDIST1( N5, JS, JT, JFNVC, TOLER, ITRANS)
C
C----- DISTANCE STACK STARTS AT NFL AND RUNS TO JS
C----- RESET NFL (ITS BEEN CHECKED) TO UPPER  LIMIT
      NFL = JS
C--CHECK THE REPLY
      IF ( K ) 9920 , 5900 , 1950
1950  CONTINUE
      IF (IALL .LT. 0) THEN
C----- ELIMINATE DUPLICATE ATOMS
      IF (K .GE. 2) THEN
        L = NFLBAS
1960    CONTINUE
        J = L + NW
        LV = J
        LU = JS - NW
        NREJ = 0
          DO 1970 M =  J, LU, NW
C-----    ARE ATOM ADDRESSES SAME?
          IF   (ISTORE(L) .EQ. ISTORE(M))  THEN
C-----      ARE DISTANCES SAME?
            IF (ABS(STORE(L+10) - STORE(M+10)) .LE. CHECK) THEN
C-----      ARE ATOMS COINCIDENT?
              IF ( XDSTN2 (STORE(L+7), STORE(M+7)) .LE. CHECK) THEN
                NREJ = NREJ + 1
                GOTO 1970
              ENDIF
            ENDIF
          ENDIF
          IF (LV .NE. M) THEN
C-----      SHUFFLE ITEMS UP IF ADDRESSES DIFFERENT
            CALL XMOVE (STORE(M), STORE(LV), NW)
          ENDIF
          LV = LV + NW
1970      CONTINUE
        L = L + NW
        JS = JS - NREJ*NW
        K = K - NREJ
        IF (L .LT. JS-NW) GOTO 1960
      ENDIF
      ENDIF
C----- SAVE THE PIVOT ADDRESS
      M5P = M5A
C----- INDICATE NO CAPTION YET FOR THIS PIVOT
      LEVEL2 = 0
C--CHECK IF WE SHOULD SORT THE DISTANCES
      IF(ISORT)2050,2000,2000
C--THAT OUTPUT DISTANCES MUST BE SORTED
2000  CONTINUE
      ITEMP2=JT*K
       CALL XSHELQ( STORE(NFLBAS), JT, 11, K, ITEMP2, STORE(ITEMP1) )
C--SET UP THE PROCESSING FLAGS
2050  CONTINUE
      JS=JS-NW
      K = NFLBAS
      N=0
C--CHECK IF ERRORS ARE TO BE CALCULATED
      IF(IESD)2150,2100,2100
C--SET UP THE ATOM STACK FOR THE PIVOT ATOM
2100  CONTINUE
      JB=JA
      CALL XFPCES( M12A, JB, NWS, IPART(1) )
2150  CONTINUE
C----- INITIALIZE BUFFER
      IJX=IJW
C--PRINT THE CALCULATED DISTANCES
      DO 3750 J = NFLBAS, JS, NW
      M=J+1
C--CHECK IF WE WANT ALL DISTANCES
      IF(INTRA)2400,2200,2300
C--INTRA-MOLECULAR DISTANCES ONLY
2200  CONTINUE
      DO 2250 L=1,5
      M=M+1
      IF(ISTORE(M)-INTRAD(L))3750,2250,3750
2250  CONTINUE
      GOTO 2400
C--ONLY INTER-MOLECULAR DISTANCES REQUIRED
2300  CONTINUE
      DO 2350 L=1,5
      M=M+1
      IF(ISTORE(M)-INTRAD(L))2400,2350,2400
2350  CONTINUE
      GOTO 3750
C--PROCESS THIS DISTANCE
2400  CONTINUE
      L=ISTORE(J+1)
      M=J+4
C--BRANCH ON THE TYPE OF DISTANCE FOUND
      GOTO(3750,2450,3600,2450),L
C--DISTANCE ACCEPTABLE
2450  CONTINUE
      L=ISTORE(J)
C--CHECK IF ALL THE DISTANCES ARE  REQUIRED
      IF(IALL)2500,2550,2550
2500  CONTINUE
      IF(M5A-L)2550,2550,3550
C--CHECK IF THE ERRORS ARE TO BE CALCULATED
2550  CONTINUE
C----- SET ESD TO ZERO
      STORE(IJX+3)=.00000001
      STORE(JF)=0.0
      IF(IESD)2800,2600,2600
C--CALCULATE THE E.S.D.
2600  CONTINUE
      JC=JB
C--ADD THE SECOND ATOM INTO THE STACK
      CALL XFPCES( ISTORE(J+12), JC, NWS, IPART(2) )
C--SET UP THE V/CV MATRIX AT 'JD'
      CALL XCOVAR( JA, NWD, NWS, JD, JE, IPART, 2)
C--SET UP THE RELEVANT SYMMETRY MATRIX  AT JH
      CALL XMVCSP(J,JH,NWD)
C--APPLY THE SYMMETRY MATRIX AND STORE THE TRANSFORMATION MATRIX AT 'JF'
      CALL XMD3B(JE,JG,JF,2,NWD)
C--MOVE THE V/CV MATRIX TO DISTANCE V/CV AREA  (THIS WILL INCLUDE CELL)
      CALL XMVCD(JD,NWD,JN,NWDT)
C--CALCULATE 'DX','DY' AND 'DZ'
      CALL XSUBTR(STORE(M5A+4),STORE(J+7),B(1),3)
C--CALCULATE THE RECIPROCAL OF THE DISTANCE
      F=1./STORE(J+10)
      NY=JD
C--CHECK IF THE CELL ERRORS ARE TO BE USED
      IF(ICELL)2700,2650,2650
C--CALCULATE THE CELL ERRORS
2650  CONTINUE
      CALL XAPP31(NY)
      NY=NY+6
C--CALCULATE THE ERROR CONTRIBUTIONS FOR ATOM ONE
2700  CONTINUE
      CALL XMULTR(B(1),F,B(1),3)
      CALL XMLTMM(STORE(L1M1),B(1),BPD(4),3,3,1)
C--APPLY THE DERIVATIVE VECTOR TO THE TRANSFORMATION MATRIX
      J1=JF
      DO 2750 I1=1,3
      STORE(NY)=STORE(J1)*BPD(4)+STORE(J1+6)*BPD(5)+STORE(J1+12)*BPD(6)
      STORE(NY+3)=-STORE(J1+21)*BPD(4)-STORE(J1+27)*BPD(5)-STORE(J1+33)
     2 *BPD(6)
      NY=NY+1
      J1=J1+1
2750  CONTINUE
C--CALCULATE THE VARIANCE
      CALL XMLTMM(STORE(JM),STORE(JD),STORE(JE),NWDT,NWDT,1)
      CALL XMLTTM(STORE(JD),STORE(JE),STORE(JF),1,NWDT,1)
C--CALCULATE THE E.S.D.
C -- CALCULATE E.S.D. FROM THE VARIANCE, PRODUCING NEGATIVE E.S.D.'S
C    FROM 'NEGATIVE VARIANCES'
      STORE(JF) = XDSESD ( STORE(JF) , STORE(JN) , NWDT )
      STORE(IJX+3)=STORE(JF)
2800  CONTINUE
C----- COMPRESS ATOMS INTO CHARACTER FORM
      CALL CATSTR (STORE(M5P), STORE(M5P+1),1,1,0,0,0, CATOM1, LATOM1)
      CALL CATSTR (STORE(L), STORE(L+1),
     1 ISTORE(J+2), ISTORE(J+3), ISTORE(J+4), ISTORE(J+5),
     2 ISTORE(J+6), CATOM2, LATOM2)
C
      IF (IDSPDA .EQ. 1  .OR. IDSPDA .EQ. 3 ) THEN
      IF (STORE(JF) .GT. ZERO) THEN
        WRITE(NCAWU,2806)
     1 CBLANK(1: 23-LATOM1), CATOM1(1:LATOM1), CATOM2(1:21),
     2 STORE(J+10), STORE(JF)
      ELSE
        WRITE(NCAWU,2806)
     1 CBLANK(1: 23-LATOM1), CATOM1(1:LATOM1), CATOM2(1:21),
     2 STORE(J+10)
      ENDIF
2806    FORMAT (1X,A, A, ' to ', A, F9.3, F6.3)
      ENDIF
C
      IF (IPUNCH .GE. 1) THEN

C----- DUMMY WRITES AT END FOR COMPATIBILITY WITH TORSION
      WRITE( MTE) 'D',STORE(J+10),STORE(JF),
     1  STORE(M5A), STORE(M5A+1), 1,1,0,0,0,
C--- ATOM 2
     2  STORE(L), STORE(L+1), ISTORE(J+2),
     3  ISTORE(J+3), ISTORE(J+4), ISTORE(J+5), ISTORE(J+6),
C--- DUMMY
     4  IB, ZERO, 1,1,0,0,0,
C--- DUMMY
     5  IB, ZERO, 1,1,0,0,0
C
      ELSE IF (IPUNCH .EQ. 0) THEN
C----- WRITE RESTRAINT
      WRITE (NCPU,'(A,'' '', F7.3, '',.01= '', A,'' to '',A)' )
     1 RESTR, STORE(J+13), CATOM1(1:LATOM1),
     2 CATOM2(1:LATOM2)
      ENDIF
      IF ((LEVEL2 .EQ. 0) .AND. (LEVEL .GE. 0)) THEN
C----- WRITE A CAPTION
        IF (LEVEL .EQ. 0) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,2825) STORE(M5P),STORE(M5P+1)
      ENDIF
2825  FORMAT(/,1X,12HPivot atom   ,A4,F5.0)
        ELSE IF (LEVEL .GE. 1) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,1850) STORE(M5P),STORE(M5P+1),
     1  (STORE(MMN),MMN=M5P+4,M5P+6)
      ENDIF
        ENDIF
        LEVEL2 = 1
      ENDIF
      IF (LEVEL) 3500, 2830, 2860
2830  CONTINUE
C----- STORE CURRENT DISTANCE IN BUFFER
      STORE(IJX)=STORE(L)
      STORE(IJX+1)= STORE(L+1)
      STORE(IJX+2)=STORE(J+10)
      IJX=IJX+4
      IF(IJX-IJY) 3500,3500,2840
2840  CONTINUE
C----- PRINT BUFFER
      IJX=IJX-4
C -- CHECK FOR E.S.D.
      IF (IESD .LT. 0) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,2850) ((STORE(IJZ),IJZ=I1,I1+2),I1=IJW,IJX,4)
      ENDIF
2850    FORMAT(11X,4(5X,A4,F5.0,F7.3,6X))
      ELSE
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,2851) ((STORE(IJZ),IJZ=I1,I1+3),I1=IJW,IJX,4)
      ENDIF
2851    FORMAT(11X,4(5X,A4,F5.0,F7.3,F6.3))
      ENDIF
      IJX=IJW
      GOTO 3500
2860  CONTINUE
C----- FULL PRINT
C----- CHECK IF THE TRANSFORMED COORDINATES ARE TO BE PRINTED
      IF(IP) 2870,3200,3200
C----- CHECK IF THIS IS FIRST DISTANCE
2870  CONTINUE
      IF(N)2900,2900,3000
C--PRINT THE CAPTION HEADING
2900  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2950)IB
      ENDIF
2950  FORMAT(/1H ,A4,2X,4HAtom,3X,6HSerial,3X,4HS(I),2X,1HL,2X,4HT(X),
     2 1X,4HT(Y),1X,4HT(Z),A4,25X,2HX',8X,2HY',8X,2HZ')
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3100)
      ENDIF
C--CHECK IF THE ERRORS ARE TO BE PRINTED
3000  CONTINUE
      IF(IESD)3050,3150,3150
C--NO ERRORS TO BE PRINTED
3050  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3100)STORE(L),STORE(L+1),(ISTORE(NX+2),NX=J,M),
     2 STORE(J+10)
      ENDIF
3100  FORMAT(7X,A4,F8.0,4X,I3,I4,3I5,F11.3,14X,3F10.5)
      GOTO 3500
C--ERRORS TO BE PRINTED
3150  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3450)STORE(L),STORE(L+1),(ISTORE(NY+2),NY=J,M),
     2 STORE(J+10),STORE(JF)
      ENDIF
      GOTO 3500
C--PRINT THE GENERATED COORDINATES  -  CHECK IF THIS IS THE FIRST ATOM
3200  CONTINUE
      IF(N)3250,3250,3300
3250  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2950)IB,IB
      ENDIF
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3100)
      ENDIF
C--CHECK IF THE ERRORS ARE TO BE PRINTED
3300  CONTINUE
      NX=J+2
      IF(IESD)3350,3400,3400
C--NO ERRORS
3350  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3100)STORE(L),STORE(L+1),(ISTORE(NY+2),NY=J,M),
     2 STORE(J+10),(STORE(NY+7),NY=J,NX)
      ENDIF
      GOTO 3500
C--PRINT THE ERRORS
3400  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3450)STORE(L),STORE(L+1),(ISTORE(NY+2),NY=J,M),
     2 STORE(J+10),STORE(JF),(STORE(NY+7),NY=J,NX)
      ENDIF
3450  FORMAT(7X,A4,F8.0,4X,I3,I4,3I5,F11.3,F7.3,7X,3F10.5)
3500  CONTINUE
      N=N+1
C--CHECK WHETHER THIS DISTANCE IS ACCEPTABLE FOR ANGLES.
C  IF THIS IS GOOD FOR ANGLES MOVE IT UP SO THAT ALL NON-ANGLES
C  DISTANCE ENTRIES ARE EXCLUDED BY THE END OF THE DISTANCE PRINT
3550  CONTINUE
      IF(ISTORE(J+1)-3)3750,3600,3600
C--CHECK IF IT IS NECESSARY TO MOVE THE DISTANCE BLOCK
3600  CONTINUE
      IF(K-J)3650,3700,3650
C--MOVE THE DATA
3650  CONTINUE
      CALL XMOVE(STORE(J),STORE(K),NW)
C--UPDATE THE CURRENT LAST POINTER
3700  CONTINUE
      K=K+NW
3750  CONTINUE
C----- EMPTY PRINT BUFFER
      IF(IJX-IJW) 3790,3790,3760
3760  CONTINUE
      IJX=IJX-4
C -- CHECK FOR E.S.D.
      IF (IESD .LT. 0) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,2850) ((STORE(IJZ),IJZ=I1,I1+2),I1=IJW,IJX,4)
      ENDIF
      ELSE
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,2851) ((STORE(IJZ),IJZ=I1,I1+3),I1=IJW,IJX,4)
      ENDIF
      ENDIF
3790  CONTINUE
      IJX=IJW
C
C--START OF THE ANGLES PRINT LOOP
      M=1
      L = NFLBAS
      K=K-NW
C--CHECK IF ANY ANGLES REMAIN TO BE CALCULATED AND PRINTED
3800  CONTINUE
      IF(K-L)5900,5900,3850
3850  CONTINUE
C--CHECK IF THIS IS THE FIRST TIME OR A CONTINUATION
      IF (NFLBAS - L) 3890, 3990, 3990
C
C----- CONTINUATION
3890  CONTINUE
      IF (LEVEL) 4110, 3900, 3900
3900  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3950)
      ENDIF
3950  FORMAT(//13H Continuation)
      IF (LEVEL) 4110, 4110, 4100
C
C----- FIRST TIME
3990  CONTINUE
      IF ((LEVEL2 .EQ. 0) .AND. (LEVEL .GE. 0)) THEN
C----- WRITE A CAPTION
        IF (LEVEL .EQ. 0) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,2825) STORE(M5P),STORE(M5P+1)
      ENDIF
        ELSE IF (LEVEL .GE. 1) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,1850) STORE(M5P),STORE(M5P+1),
     1  (STORE(MMN),MMN=M5P+4,M5P+6)
      ENDIF
        ENDIF
        LEVEL2 = 1
      ENDIF
      IF (LEVEL) 4110, 4110, 4000
4000  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4050)STORE(M5A),STORE(M5A+1)
      ENDIF
4050  FORMAT(//20H Angles about atom  ,A4,F5.0)
4100  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2950)AKEY
      ENDIF
4110  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3100)
      ENDIF
      N=M
      NX=L+4
      NY=ISTORE(L)
      IF (LEVEL) 4165, 4160, 4140
4140  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4150)N,STORE(NY),STORE(NY+1),(ISTORE(NZ+2),NZ=L,NX)
      ENDIF
4150  FORMAT(I4,3X,A4,F8.0,4X,I3,I4,3I5,3X,9F8.2)
      GOTO 4180
4160  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4170) N,STORE(NY),STORE(NY+1)
      ENDIF
      GOTO 4180
4165  CONTINUE
4170  FORMAT(I4,2X,A4,F5.0,3X,13F8.2)
4180  CONTINUE
      NX=L+(NCOL-1)*NW
      NY=L+NW
C--MAIN PRINT AND CALCULATION LOOP
      DO 5550 NZ=NY,K,NW
      N=N+1
      NB=NZ-NW
      NB=MIN0(NB,NX)
      NC=0
C--CHECK IF E.S.D.'S ARE REQUIRED
      IF(IESD)4250,4200,4200
C--INSERT THE SECOND ATOM  -  ATOM (B)
4200  CONTINUE
      JC=JB
      CALL XFPCES( ISTORE(NZ+12), JC, NWS, IPART(2) )
      CALL XMVCSP(NZ,JK,NWA)
C--STARTING FROM THE FIRST ATOM OF THE CURRENT LIST ,
C  CALCULATE ALL THE ANGLES TO THE PRESENT ATOM
C
C  ATOM A IS AT M5A
C  ATOM B IS AT ISTORE(NZ)
C  ATOM C IS AT ISTORE(NA)
C
4250  CONTINUE
      DO 5350 NA=L,NB,NW
C--CHECK THAT A AND B ARE NOT THE SAME ATOM
      IF(STORE(NZ+10)-CHECK)4300,4300,4350
C--EITHER B OR C DUPLICATES A  -  ANGLE IS SET TO 0.0
4300  CONTINUE
      APD(NC+1)=0.
      APD(NC+2)=0.
      NC=NC+3-JU
      GOTO 5350
C--CHECK THAT A AND C ARE NOT THE SAME ATOM
4350  CONTINUE
      IF(STORE(NA+10)-CHECK)4300,4300,4400
C--COMPUTE THE COORDINATES OF 'E'  -  AE BISECTS THE ANGLE AT A.
4400  CONTINUE
      F=STORE(NZ+10)/STORE(NA+10)
      B(1)=0.5*(STORE(M5A+4)+STORE(NZ+7)+F*(STORE(NA+7)-STORE(M5A+4)))
      B(2)=0.5*(STORE(M5A+5)+STORE(NZ+8)+F*(STORE(NA+8)-STORE(M5A+5)))
      B(3)=0.5*(STORE(M5A+6)+STORE(NZ+9)+F*(STORE(NA+9)-STORE(M5A+6)))
C--SET L1 AS THE DISTANCES FROM A TO B
      DIST(1)=STORE(NZ+10)
      DISTSQ(1)=STORE(NZ+11)
C--COMPUTE 'DX', 'DY' AND 'DZ' FOR THE BOND B TO E.
      CALL XSUBTR(STORE(NZ+7),B(1),BPD(7),3)
C--CALCULATE THE DISTANCE BETWEEN THE TWO NON-PIVOT ATOMS
      DISTSQ(2)=XDSTN2(STORE(NZ+7),B(1))
C--CALCULATE THE DISTANCE FROM 'A' TO 'E'
      DISTSQ(3)=XDSTN2(STORE(M5A+4),B(1))
C--COMPUTE THE DISTANCES
      DO 4450 NF=2,3
      DIST(NF)=SQRT(DISTSQ(NF))
4450  CONTINUE
C--CHECK IF THE POINTS 'B' AND 'E' ARE COINCIDENT
      IF(DIST(2)-CHECK)4300,4300,4500
C--CALCULATE THE OUTPUT ANGLE
4500  CONTINUE
      F=DIST(2)/DIST(1)
C--CHECK IF THE SIN OR COS SHOULD BE USED
      IF(F-SIN45)4550,4550,4600
4550  CONTINUE
      ANGLE(2)=ASIN(F)
      GOTO 4650
C--USE THE COS
4600  CONTINUE
      ANGLE(2)=ACOS(DIST(3)/DIST(1))
4650  CONTINUE
      NC=NC+1
      APD(NC)=ANGLE(2)*G
C--CHECK IF THE E.S.D. IS TO BE CALCULATED
      IF(IESD) 5345,4700,4700
C--CALCULATE THE E.S.D.
4700  CONTINUE
      NF=JC
C--ADD THE THIRD ATOM (C) INTO THE STACK
      CALL XFPCES( ISTORE(NA+12), NF, NWS, IPART(3) )
C--CALCULATE THE V/CV MATRIX FOR THE POSITIONAL ERRORS
      CALL XCOVAR( JA, NWA, NWS, JD, JE, IPART, 3)
C--MOVE THE V/CV MATRIX TO THE FINAL AREA, WHICH CONTAIN THE CELL ERRORS
      CALL XMVCD(JD,NWA,JQ,NWAT)
C--ADD THE SYMMETRY MATRIX OF THE LAST ATOM
      CALL XMVCSP(NA,JL,NWA)
C--APPLY THE SYMMETRY INFORMATION
      CALL XMD3B(JE,JJ,JD,3,NWA)
C--CALCULATE 'DX' ETC. FOR BOND 1 (A - B)
      CALL XSUBTR(STORE(M5A+4),STORE(NZ+7),BPD(4),3)
C--CALCULATE 'DX' ETC. FOR BOND 3 (C - A)
      CALL XSUBTR(STORE(NA+7),STORE(M5A+4),BPD(10),3)
C--SET UP THE MATRIX TO TRANFORM FROM V/CV MATRIX OF 'ABC' TO 'ABE'
      CALL XZEROF(STORE(JE),54)
C--ADD THE TRANSFORMATIONS FOR A AND B.
      STORE(JE)=1.
      STORE(JE+10)=1.
      STORE(JE+20)=1.
      STORE(JE+30)=1.
      STORE(JE+40)=1.
      STORE(JE+50)=1.
C--CALCULATE THE DERIVATIVES WITH RESPECT TO 'AB' AND 'CA'
      CALL XMLTMM(STORE(L1M1),BPD(4),STORE(JF),3,3,1)
      CALL XMLTMM(STORE(L1M1),BPD(10),STORE(JF+3),3,3,1)
C--FINISH OFF THE DERIVATIVES BY DIVIDING BY THE BOND LENGTHS
      NF=JF+2
      DO 4750 NE=JF,NF
      STORE(NE)=STORE(NE)/STORE(NZ+10)
      STORE(NE+3)=STORE(NE+3)/STORE(NA+10)
4750  CONTINUE
      NL=JE+54
C--COMPUTE AB/AC
      F=0.5*STORE(NZ+10)/STORE(NA+10)
C--LOOP OVER THE COORDINATES OF E  -  'X' FIRST ETC..
      DO 4850 NF=1,3
      B(1)=0.5*BPD(NF+9)/STORE(NA+11)
      B(2)=0.5*BPD(NF+9)/STORE(NA+10)
      B(3)=0.5*BPD(NF+9)*STORE(NZ+10)/STORE(NA+11)
      NG=JF
C--LOOP OVER THE COORDINATES OF A, B AND C
      DO 4800 NE=1,3
C--DERIVATIVES FOR A
      STORE(NL)=B(1)*(STORE(NG)*STORE(NA+10)+STORE(NZ+10)*STORE(NG+3))
C--DERIVATIVES FOR B
      STORE(NL+3)=-B(2)*STORE(NG)
C--DERIVATIVES FOR C
      STORE(NL+6)=-B(3)*STORE(NG+3)
      NG=NG+1
      NL=NL+1
4800  CONTINUE
C--ADD IN THE ODD TERMS FOR X W.R.T. X, ETC..
      NL=NL-4+NF
      STORE(NL)=STORE(NL)+0.5-F
      STORE(NL+3)=STORE(NL+3)+0.5
      STORE(NL+6)=STORE(NL+6)+F
      NL=NL+10-NF
4850  CONTINUE
C--APPLY THE TRANSFORMATION AT 'JE' TO THE TRANSFORMATION MATRIX AT 'JD'
      L1=JE
      M1=JF
      DO 4950 I1=1,NWA
      K1=JD
      DO 4900 J1=1,3
      STORE(M1)=STORE(L1)*STORE(K1)+STORE(L1+1)*STORE(K1+9)+STORE(L1+2)
     2 *STORE(K1+18)
      STORE(M1+3)=STORE(L1+3)*STORE(K1+30)+STORE(L1+4)*STORE(K1+39)
     2 +STORE(L1+5)*STORE(K1+48)
      STORE(M1+6)=STORE(L1+6)*STORE(K1+60)+STORE(L1+7)*STORE(K1+69)
     2 +STORE(L1+8)*STORE(K1+78)
      M1=M1+1
      K1=K1+1
4900  CONTINUE
      L1=L1+NWA
      M1=M1+6
4950  CONTINUE
C--COMPUTE 'DX', ETC., FOR THE BOND E - A.
      BPD(10)=-BPD(4)-BPD(7)
      BPD(11)=-BPD(5)-BPD(8)
      BPD(12)=-BPD(6)-BPD(9)
C
C--BEGIN TO COMPUTE THE V/CV MATRIX FOR THREE BONDS  -  AB, BE AND EA.
      I1=JE
      NF=JD
C--CLEAR THE AREA TO ZERO
      DO 5000 NE=JD,NO
      STORE(NE)=0.
5000  CONTINUE
C--ADD IN THE TERMS FOR EACH OF THE THREE BONDS IN TURN
      DO 5150 NE=1,3
      ND=NE*3
C--MOVE 'DX' ETC.
      CALL XMOVE(BPD(ND+1),B(1),3)
      F=1./DIST(NE)
C--APPLY THE CELL ERRORS IF NEC.
      IF(ICELL)5100,5050,5050
5050  CONTINUE
      CALL XAPP31(I1)
      I1=I1+6
5100  CONTINUE
      J1=NF
      NF=NF+IS(ND-2)
      CALL XMULTR(B(1),F,B(1),3)
C--CALCULATE THE CONTRIBUTIONS FOR THE FIRST ATOM
      CALL XMLTMM(STORE(L1M1),B(1),STORE(NF),3,3,1)
C--CALCULATE THE CONTRIBUTIONS FOR THE SECOND ATOM
      NG=NF
      NF=NF+IS(ND-1)
      CALL XNEGTR(STORE(NG),STORE(NF),3)
      NF=NF+IS(ND)
C--CALCULATE THE FINAL TRANSFORMATION MATRIX AND STORE IT AT JE
      CALL XMLTTT(STORE(J1),STORE(JF),STORE(I1),1,NWA,NWA)
      I1=I1+NWA
5150  CONTINUE
C--MULTIPLY THE DERIVATIVES ONTO THE V/CV MATRIX
      CALL XMLTMM(STORE(JP),STORE(JE),STORE(JD),NWAT,NWAT,3)
      CALL XMLTTM(STORE(JE),STORE(JD),STORE(JF),3,NWAT,3)
C--CHECK IF THE SIN OR COS HAS BEEN USED
      IF(APD(NC)-90.)5200,5200,5250
C--THE SIN WAS USED  -  ANGLE IS LESS THAN 90
5200  CONTINUE
      BPD(6)=COS(ANGLE(2))
C--CALCULATE THE DERIVATIVES FOR AB AND BE.
      BPD(4)=-2.*DIST(2)/(DISTSQ(1)*BPD(6))
      BPD(5)=2./(DIST(1)*BPD(6))
      BPD(6)=0.
      GOTO 5300
C--THE COS WAS USED  -  ANGLE IS GREATER THAN 90
5250  CONTINUE
      BPD(5)=SIN(ANGLE(2))
C--CALCULATE THE DERIVATIVES FOR AB AND AE
      BPD(4)=2.*DIST(3)/(DISTSQ(1)*BPD(5))
      BPD(6)=-2./(DIST(1)*BPD(5))
      BPD(5)=0.
C--CALCULATE THE VARIANCE OF THE ANGLE
5300  CONTINUE
      NC=NC+1
      CALL XMLTMM(STORE(JF),BPD(4),STORE(JD),3,3,1)
      CALL XMLTTM(BPD(4),STORE(JD),APD(NC),1,3,1)
C -- CALCULATE E.S.D. FROM THE VARIANCE, PRODUCING NEGATIVE E.S.D.'S
C    FROM 'NEGATIVE VARIANCES'
      APD(NC) = GS * XDSESD ( APD(NC) , STORE(JP) , NWAT )
5345  CONTINUE
      IZZ = ISTORE(NZ)
      IXX = ISTORE(NA)
      TERM = APD(NC-1-IESD)
      IF (IESD .LT. 0) THEN
        ESD = 0.0
      ELSE
        ESD = APD(NC)
      ENDIF
C----- STRIP AND PACK ATOM NAMES
      CALL CATSTR (STORE(IXX), STORE(IXX+1), ISTORE(NA+2),
     1 ISTORE(NA+3), ISTORE(NA+4), ISTORE(NA+5), ISTORE(NA+6),
     2 CATOM1, LATOM1)
      CALL CATSTR (STORE(M5A), STORE(M5A+1),
     1 1,1,0,0,0, CATOM2, LATOM2)
      CALL CATSTR (STORE(IZZ), STORE(IZZ+1), ISTORE(NZ+2),
     1 ISTORE(NZ+3), ISTORE(NZ+4), ISTORE(NZ+5), ISTORE(NZ+6),
     2 CATOM3, LATOM3)
      IF (IPUNCH .GE. 1) THEN
C--- NOTE THAT TWO ITEMS ARE OUTPUT EVEN WHEN ESDS ARE NOT COMPUTED
        WRITE(MTE) 'A',TERM,ESD,
     *  STORE(IXX), STORE(IXX+1), ISTORE(NA+2),
     1  ISTORE(NA+3), ISTORE(NA+4), ISTORE(NA+5), ISTORE(NA+6),
C--- PIVOT
     2  STORE(M5A), STORE(M5A+1), 1,1,0,0,0,
C--- ATOM 3
     3  STORE(IZZ), STORE(IZZ+1), ISTORE(NZ+2),
     4  ISTORE(NZ+3), ISTORE(NZ+4), ISTORE(NZ+5), ISTORE(NZ+6),
C--- DUMMY
     5  IB, ZERO, 1,1,0,0,0
C
      ELSE IF (IPUNCH .EQ. 0) THEN
        NANG = NINT (TERM)
      WRITE(NCPU, '(''ANGL '',I3,'',1= '',A,'' to '',A,'' to '',A)')
     1  NANG, CATOM1(1:LATOM1), CATOM2(1:LATOM2), CATOM3(1:LATOM3)
      ENDIF
      IF (IDSPDA .GE. 2 ) THEN
        CBUFF = ' '
        NANG = MAX((12 - LATOM2) /2, 1)
        CBUFF(NANG:NANG+LATOM2-1) = CATOM2(1:LATOM2)
        IF( ESD .GE. ZERO) THEN
          WRITE(NCAWU,5348)
     1 CBLANK(1: 23-LATOM1), CATOM1(1:LATOM1), CBUFF(1:12),
     2 CATOM3(1:21), TERM, ESD
        ELSE
          WRITE(NCAWU,5348)
     1 CBLANK(1: 23-LATOM1), CATOM1(1:LATOM1), CBUFF(1:12),
     2 CATOM3(1:21), TERM
        ENDIF
      ENDIF
5348    FORMAT (1X,A, A, ' to ', A, ' to ', A,  F7.2, F5.2)
C
C
5350  CONTINUE
C--START OF THE PRINT LOOP
      ND=ISTORE(NZ)
      NE=NZ+4
C--CHECK IF THE E.S.D.'S ARE TO BE PRINTED
      IF(IESD)5400,5450,5450
C--NO ERRORS TO BE PRINTED
5400  CONTINUE
      IF (LEVEL) 5550, 5410, 5440
5410  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4170)N,STORE(ND),STORE(ND+1),
     1 (APD(NF),NF=1,NC)
      ENDIF
      GOTO 5550
5440  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4150)N,STORE(ND),STORE(ND+1),(ISTORE(NF+2),NF=NZ,NE),
     2 (APD(NF),NF=1,NC)
      ENDIF
      GOTO 5550
C--PRINT WITH ERRORS
5450  CONTINUE
      IF (LEVEL) 5550, 5510, 5540
5510  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,5520)N,STORE(ND),STORE(ND+1),
     1 (APD(NF),NF=1,NC)
      ENDIF
5520  FORMAT(I4,2X,A4,F5.0,3X,7(F8.2,F6.2))
      GOTO 5550
5540  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,5500)N,STORE(ND),STORE(ND+1),(ISTORE(NF+2),NF=NZ,NE),
     2 (APD(NF),NF=1,NC)
      ENDIF
5500  FORMAT(I4,3X,A4,F8.0,4X,I3,I4,3I5,3X,5(F8.2,F6.2))
5550  CONTINUE
      DO 5600 NA=1,NC
      IAPD(NA)=NA+M-1
5600  CONTINUE
C--CHECK FOR E.S.D.'S
      IF(IESD)5650,5750,5750
C--NO E.S.D.'S
5650  CONTINUE
      IF (LEVEL) 5850, 5840, 5660
5660  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,5700)AKEY,(IAPD(NA),NA=1,NC)
      ENDIF
5700  FORMAT(/1H ,A4,41X,9I8)
      GOTO 5850
C--E.S.D.'S HAVE BEEN PRINTED
5750  CONTINUE
      NC=NC/2
      IF (LEVEL) 5850, 5840, 5760
5760  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,5800)AKEY,(IAPD(NA),NA=1,NC)
      ENDIF
5800  FORMAT(/1H ,A4,41X,I9,4I14)
      GOTO 5850
5840  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,5500)
      ENDIF
5850  CONTINUE
      M=M+NCOL
      L=L+NCOL*NW
      GOTO 3800
5900  CONTINUE
      M5A=M5A+MD5A
      MFNVCA = MFNVCA + MDFNVC
      IF(M12A)6000,6000,5950
5950  CONTINUE
      M12A=ISTORE(M12A)
6000  CONTINUE
C
C
C
C --                   **** MAIN LOOP COMPLETED ****
C
C
C
C -- WRITE PUBLICATION LISTING
      IF (IPUNCH .EQ. 0) THEN
C----- FINISH RESTRAINT LIST
        CALL XPCHUS
      ELSE IF (IPUNCH .EQ. 1) THEN
        CALL XPRTDA(3,IESD,NCPU)
      ELSE IF (IPUNCH .EQ. 2) THEN
C----- CIF
        CALL XPRTDA(13,IESD,NCPU)
      ENDIF
C
C--TERMINATION MESSAGES
6050  CONTINUE
      CALL XOPMSG ( IOPDIS, IOPEND, IVERSN )
      CALL XTIME2(2)
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPDIS , IOPABN , 0 )
      GO TO 6050
9910  CONTINUE
C -- INPUT ERRORS
      CALL XOPMSG ( IOPDIS , IOPCMI , 0 )
      GO TO 9900
9920  CONTINUE
C -- INSUFF. CORE
      CALL XOPMSG ( IOPDIS , IOPSPC , 0 )
      WRITE(NCAWU,9921) K
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,9921)  K
      ENDIF
9921  FORMAT(' ', I10, ' Contacts to current atom.' )
      GO TO 9900
C
      END
C
C
C
C
C
C
CODE FOR XDSSEL
      SUBROUTINE XDSSEL ( IFUNC , MDFUNC , NFUNC , IMARK , IDEFLT )
C
C
C      IFUNC(MDFUNC,NFUNC)  FUNCTION VECTOR. IFUNC(1,*) IS MARKED WITH
C                           THE FLAG TO INDICATE WHETHER ATOM IS TO BE
C                           INCLUDED
C      IMARK       MARK TO PLACE IN FUNCTION VECTOR FOR ATOMS INDICATED
C                  BY INPUT
C      IDEFLT      MARK TO PLACE ON UNSPECIFIED ATOMS. SET BY THIS
C                  ROUTINE IF APPROPRIATE. ( IN GENERAL, IN SOME ATOMS
C                  ARE INCLUDED BY THIS ROUTINE, THE REMAINDER WILL BE
C                  ASSUMED TO BE EXCLUDED, AND VICE VERSA )
C                    INITIAL VALUE     IMARK       FINAL VALUE
C                    0                 <ANY>       - 'IMARK'
C                   -1                 <ANY>       -1
C                    1                 <ANY>       - 'IMARK'
C
C
      DIMENSION IFUNC(MDFUNC,NFUNC)
C
      LOGICAL SETTHS
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLEXIC/LK,LK1,LK2,NWCARD,LARG,MARG,MDARG,NARG,
     2 LCRD,MCRD,MDCRD,NCRD,MA,MB,MC,MD,ME,MF,MG,MH,
     3 MI,MJ,MK,ML,MM,MN,MO,MP,MQ,MR,MS,MT,MU,MV,MW,MX,MY,Z
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
C -- SEARCH INPUT FOR TYPE/ATOM SPECIFIERS
C
1000  CONTINUE
C
      ISAVME = ME
      ISAVMF = MF
C
      IF ( ME .LE. 0 ) GO TO 9000
C
      IF ( ISTORE(MF) .GE. 0 ) GO TO 9910
C
C -- CHECK FOR A ATOM HEADER
C
      ITYPE = ISTORE(MF+2)
      ME = ME - 1
      MF = MF + LK2
C
      IOPER = 1
      LSCAN = L5
      MSCAN = L5 + ( N5 - 1 ) * MD5
C
C -- TRY FOR '(', INDICATING AN ATOM SPECIFICATION
      IF ( KOP(6) .EQ. 0 ) THEN
        ME = ISAVME
        MF = ISAVMF
C
        ISTAT = KATOMU ( IN )
        IF ( ISTAT .LE. 0 ) GO TO 9900
        IOPER = 2
        LSCAN = M5A
        MSCAN = LSCAN + ( N5A - 1 ) * MD5A
      ENDIF
C
      MFUNC = 1 + ( LSCAN - L5 ) / MD5
      DO 1100 J = LSCAN , MSCAN , MD5
        SETTHS = .FALSE.
C
        IF ( IOPER .EQ. 1 ) THEN
          SETTHS = ( ISTORE(J) .EQ. ITYPE )
        ELSE
          SETTHS = .TRUE.
        ENDIF
C
        IF ( SETTHS ) THEN
          IFUNC(1,MFUNC) = IMARK
        ENDIF
C
        MFUNC = MFUNC + 1
1100  CONTINUE
C
C -- CHECK FOR ',' BETWEEN ARGUMENTS
      ISTAT = KOP ( 8 )
C
      GO TO 1000
C
C
9000  CONTINUE
C
C -- SET ASSUMED MARK FOR REMAINING ATOMS
      IF ( IDEFLT .GE. 0 ) IDEFLT = - IMARK
C
      RETURN
C
C
9900  CONTINUE
      RETURN
9910  CONTINUE
      CALL XILOPD ( ISTORE(MF+1) )
      CALL XERHND ( IERWRN )
      GO TO 9900
C
      END
C
C
C
C
C
CODE FOR XDSESD
      FUNCTION XDSESD ( VARIAN , VCVMAT , NVCV )
C
C -- CALCULATE AN E.S.D. FROM A VARIANCE.
C
C    E.S.D.                  ACTION
C    ------                  ------
C    LESS THEN 'TOLER'       A WARNING MESSAGE AND THE VARIANCE-
C                            COVARIENCE MATRIX ARE PRINTED
C    'TOLER' TO 'ZERO'       THE E.S.D. IS SET TO 0.0. NO MESSAGE IS
C                            PRODUCED
C    GREATER THAN 'ZERO'     E.S.D. OK
C
C      'TOLER' IS A SMALL NEGATIVE REAL NUMBER WHICH GIVES A LIMIT TO
C      THE RANGE OF VALUES ASSUMED TO BE ROUNDING ERRORS ON '0.0'
C
      DIMENSION VCVMAT(NVCV,NVCV)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      DATA TOLER / -1.0E-5 /
C
      XDSESD = SIGN (  SQRT ( ABS ( VARIAN ) )  ,  VARIAN )
C
      IF ( XDSESD .LT. TOLER ) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE ( NCWU , 1005 ) XDSESD , IB
      ENDIF
        WRITE ( NCAWU , 1005 ) XDSESD
1005    FORMAT ( /, 1X , 'Negative e.s.d. output ' , F14.10 , A1 , / ,
     2 1X , 'Variance-covariance matrix follows' , // )
C
        DO 1100 I = 1 , NVCV
      IF (ISSPRT .EQ. 0) THEN
          WRITE ( NCWU , 1015 ) ( VCVMAT(J,I) , J = 1 , NVCV )
      ENDIF
1015      FORMAT ( 1X , 1P , 3 ( 3E13.4 , 5X ) )
1100    CONTINUE
C
        CALL  XERHND ( IERWRN )
C
      ELSE IF ( XDSESD .LT. ZERO ) THEN
        XDSESD = 0.0
      ENDIF
C
      RETURN
      END
C
C
C
C
C
C
CODE FOR XCOND
      SUBROUTINE XCOND
C--CONDENSE A LIST 5 OR LIST 10 AND ASSEMBLE MOLECULAR FRAGMENTS
C
C
C  IACT    OPERATION - SET IN COMMAND FILE
C          -1 FOR #PEAKS
C           0 FOR #PEAKS
C           1 FOR #REGROUP
C
C  ITYPE   TYPE OF ATOMS TO BE MODIFIED
C           -1 FOR ALL
C            0 FOR PEAKS ONLY
C
C  LN1    INPUT LIST TYPE
C  LN2    OUTPUT LIST TYPE
C  D1     ELIMINATE ATOMS OR PEAKS CLOSER THAN 'D1' TO THE CURRENT ATOM
C  D2     CONTACT DISTANCE FOR ATOM MOVING AND FRAGMENT ASSEMBLY
C  NATOM  THE MAXIMUM NUMBER OF ATOMS THAT THE FINAL LIST CAN CONTAIN
C  ILIST   THE LIST CONTROL FLAG :
C
C          -1  DO NOT LIST THE MOVED OR DELETED ATOMS.
C           0  LIST THE MOVED OR DELETED ATOMS.
C
C  D3      THE MAXIMUM DISTANCE THAT IS ALLOWED WHEN FOURIER TYPE
C          COORDINATE CORRECTIONS ARE TO BE MADE.
C  AMULT   THE FOURIER TYPE CORRECTION MULTIPLIER.
C  IREF    THE FOURIER TYPE CORRECTION CONTROL FLAG :
C
C          -1  MAKE NO CORRECTIONS.
C           0  MAKE ANY SUITABLE CORRECTIONS.
C
C--THE COMMON BLOCK /XWORKA/ IS USED :
C
C  JB  ADDRESS OF THE TEMP. STORAGE FOR ATOMS
C  JC  ADDRESS OF THE ATOM HEADER FOR MOVING ATOMS FROM 'JB'
C  JD  WORK SPACE FOR 'KATOMS'
C  JE  START OF DISTANCE STACK.
C  JF  NUMBER OF ATOMS LEFT TO SCAN
C  JG  CURRENT LAST ENTRY IN LIST 5 OR 10
C  JH  MD5-1
C  JI  MD5+MD5
C  JK  ZERO FOR THE FIRST OPERATION FOR THE CURRENT PIVOT ATOM,
C      ELSE NON-ZERO.
C  JL  ZERO FOR THE FIRST OPERATION FOR THE CURRENT CALL,
C      ELSE NON-ZERO.
C
C--
      DIMENSION ISTORE(131072)
C
      DIMENSION IAPD(13), PROCS(15)
      DIMENSION PEAK(1)
C
      CHARACTER*8 CDELET , CMOVED , CCORRE
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDSTNC/AT,AC,BT,BC,BP,AP,AO,IDIST,LBOX,MBOX,MDBOX,NBOX,
     2 LFNVC,MFNVC,MDFNVC,NFNVC,MFNVCA
C
      COMMON /XPROCC/DISTS(4),LN1,LN2,ITYPE,NATOM,ILIST,ISEQ,D3,AMULT,
     2 IACT, ISYMOD, ITRANS
      COMMON /XDISTW/A,BB,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      EQUIVALENCE (DISTS(1),PROCS(1))
      EQUIVALENCE (D1,DISTS(2)),(D2,DISTS(4))
      EQUIVALENCE (APD(1),IAPD(1))
C
C
      DATA IDIMN /15/
C
      DATA IVERSN / 303 /
C
      DATA CDELET / 'Deleted ' / , CMOVED / ' Moved  ' /
      DATA CCORRE / 'Corrects' /
      DATA TOLER / .2 /
C
#HOL      DATA PEAK(1) /'Q   '/
&HOL      DATA PEAK(1) /4HQ   /
C
C--CALLL THE TIMING FUNCTION
      CALL XTIME1(2)
C -- READ THE REST OF THE INSTRUCTIONS AND CHECK FOR ERRORS
      IF (   KRDDPV ( PROCS(1) , IDIMN )    .LT.   0   ) GO TO 9910
C--LOAD A FEW PIECES OF DATA
      AT=DISTS(1)
      AC=AMAX1(DISTS(2),D3)
      BT=DISTS(3)
      BC=DISTS(4)
      CALL XDIST2
C
C----- REDUCE SYMMETRY IF NECESSARY
      CALL KSYMOD (ISYMOD, IC, IL, N2P, L2C, L2, N2, MD2)
C--LOAD THE INPUT LIST
      LN1=KTYP05(LN1)
      CALL XLDR05(LN1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--FIND THE OUTPUT LIST TYPE
      LN2=KTYP05(LN2)
C--CHECK IF FOURIER TYPE REFINEMENT IS REQUIRED
      IREF=-1
C--CHECK THE CONTACT DISTANCE GIVEN
      IF(D3-ZERO)1200,1200,1100
C--FOURIER REFINEMENT IS REQUIRED
1100  CONTINUE
      IREF=0
C--CHECK IF A MULTIPLIER HAS BEEN GIVEN
      IF (AMULT + 99.) 1150, 1150, 1200
C--ASSIGN THE DEFAULT MULTIPLIER
1150  CONTINUE
      AMULT=FLOAT(2-IC)
C--SET A FEW CONSTANTS
1200  CONTINUE
      JT=12
      L12=-1
      M12=-1
C--SET UP A FEW STACK CONSTANTS
      JB=NFL
      JC=JB+MD5
      JD=JC+20
      JE=JD+30
C--CHECK THE STORE AREA
      IF ( JE - LFL ) 1350 , 9920 , 9920
C--SET UP A FEW CONSTANTS FOR THE PASSAGE THROUGH THE ATOMS
1350  CONTINUE
      M5A=L5
      JF=N5
      JG=L5+(N5-1)*MD5
      JL=0
      SEQ=1.0
C
C--SET UP THE CONTROL VARIABLES FOR THIS PASS AND CHECK IF ANY ATOMS ARE
1400  CONTINUE
      M5=M5A+MD5
      JF=JF-1
      IF(JF)3400,3400,1450
C--CHECK THE REMAINING ATOMS WITH THE CURRENT PIVOT
1450  CONTINUE
      NFL=JE
      JJ=M5
C -- CHECK SPACE AVAILABLE
      IF (KDIST1(JF, J, JT, 0, TOLER, ITRANS)) 9920, 3350, 1550
C--REMOVE DUPLICATE ENTRIES FOR EACH ATOM, LEAVING THE MIN. CONTACT DIST
1550  CONTINUE
      NFL=J
      I=JE
      JS=JE
C--CHECK IF THERE ARE ANY MORE ATOMS IN THE STACK
1600  CONTINUE
      IF(I-J)1650,2000,2000
C--BEGIN THE SEARCH FOR ALL CONTACTS TO THIS CURRENT ATOM
1650  CONTINUE
      E=STORE(I+10)
      K=I
C--CHECK IF THERE ARE ANY MORE ATOMS IN THE STACK
1700  CONTINUE
      IF(I-J)1750,1950,1950
C--CHECK IF THIS IS THE SAME ATOM
1750  CONTINUE
      IF(ISTORE(I)-ISTORE(K))1950,1800,1950
C--CHECK THE DISTANCE
1800  CONTINUE
      IF(STORE(I+10)-E)1850,1900,1900
1850  CONTINUE
      E=STORE(I+10)
      K=I
C--MOVE TO THE NEXT ATOM
1900  CONTINUE
      I=I+JT
      GOTO 1700
C--MOVE THE STACK INFORMATION
1950  CONTINUE
      CALL XMOVE(STORE(K),STORE(JS),JT)
      K=K+JT
      JS=JS+JT
      GOTO 1600
C--CHECK IF ANY ATOMS HAVE BEEN FOUND
2000  CONTINUE
      IF(JS-JE)3350,3350,2050
C--ATOMS FOUND  -  CHECK FOR ATOMS TO BE DELETED
2050  CONTINUE
      JK=0
      JS=JS-JT
      IPOINT=NOWT
      IF (IACT) 2100, 2100, 3000
C-----  CONDENSING A PEAKS LIST -
C--CHECK IF FOURIER TYPE REFINEMENT IS BEING DONE
2100  CONTINUE
      IF(IREF)2450,2150,2150
C--CHECK THAT THE PIVOT IS AN ATOM AND NOT A PEAK
2150  CONTINUE
      IF(KCOMP(1,PEAK(1),STORE(M5A),1,MD5A))2200,2200,2450
C--NOT A PEAK  -  SEARCH FOR AN ACCEPTABLE CONTACT
2200  CONTINUE
      E=D3
C--LOOP OVER ALL THE ATOMS
      DO 2400 I=JE,JS,JT
C--CHECK THE TYPE  -  MUST BE A PEAK
      K=ISTORE(I)
      IF(KCOMP(1,PEAK(1),STORE(K),1,MD5A))2400,2400,2250
C--CHECK THAT THE TWO HAVE THE SAME OCCUPANCY
2250  CONTINUE
      IF(ABS(XOCC(K)-XOCC(M5A))-ZERO)2300,2300,2400
C--COMPARE THE CURRENT MINIMUM DISTANCE
2300  CONTINUE
      IF(STORE(I+10)-E)2350,2400,2400
C--DISTANCE IS OKAY TOO  -  ALTER THE POINTERS
2350  CONTINUE
      E=STORE(I+10)
      IPOINT=I
2400  CONTINUE
C--ELIMINATE UNWANTED ATOMS
2450  CONTINUE
C----- SAVE THE POINTERS IN CASE WE NEED TO REGROUP ATOMS
      JSS = JE
      JJS = J
      DO 2950 I=JE,JS,JT
C----- GET THE ADDRESS IN LIST 10
      KKKI = ISTORE(I)
C--UPDATE THE ATOM ADDRESS
      ISTORE(I)=ISTORE(I)+JK
C--CHECK IF THIS PEAK SHOULD BE USED TO CORRECT THE COORDS.
      IF(IPOINT-I)2600,2500,2600
C--CORRECTING PEAK  -  MOVE ALONG THE COORDINATES
2500  CONTINUE
      K=I
      L=M5A
      DO 2550 M=1,3
      STORE(L+4)=STORE(L+4)+AMULT*(STORE(K+7)-STORE(L+4))
      K=K+1
      L=L+1
2550  CONTINUE
C---- REPLACE ATOM HEIGHT BY CORRESPONDING PEAK HEIGHT
      IF( (KCOMP(1,PEAK(1),STORE(KKKI),1,MD5A) .GE. 1) .AND.
     1 (MD5A .GE. 14) ) STORE(M5A+13) = STORE(KKKI+13)
C--PRINT THE DETAILS IF NECESSARY
      CALL XPRTCD ( I , J , CCORRE )
      GOTO 2700
C--CHECK IF THIS ATOM SHOULD BE DELETED
2600  CONTINUE
      IF( STORE(I+10) - D1) 2650,2650, 2900
C--CHECK FOR LISTING WITH THIS CALL
2650  CONTINUE
      IF ( ITYPE .EQ. 0) THEN
C----- ONLY DELETE PEAKS.
        K = ISTORE(I)
        IF ( KCOMP(1, PEAK(1), STORE(K), 1, MD5A) .LE. 0) GOTO 2900
      ENDIF
      CALL XPRTCD ( I , J , CDELET )
C--CHECK IF THIS ATOM IS AT THE BOTTOM
2700  CONTINUE
      IF(J-JG)2750,2850,2850
C--MOVE THE STACK UP INTO THE SLOT FOR THIS ATOM
2750  CONTINUE
      K=J+MD5
      DO 2800 L=K,JG,MD5
      CALL XMOVE(STORE(L),STORE(J),MD5)
      J=J+MD5
2800  CONTINUE
      JK=JK-MD5
C--UPDATE THE VARIOUS POINTERS
2850  CONTINUE
      JF=JF-1
      JG=JG-MD5
      N5=N5-1
C--MARK THE ATOM AS DELETED IN THE STACK
      STORE(I+10)=-1.
2900  CONTINUE
      JSS = JSS + JT
2950  CONTINUE
C----- RESTORE POINTERS
      JS = JSS - JT
      J  = JJS
      IF (IACT) 3350, 3000, 3000
C
C--BEGIN MOVING NON-DELETED ATOMS
3000  CONTINUE
      NFL=JD
C--MAIN ATOM MOVING LOOP
      DO 3300 I=JE,JS,JT
      IF (STORE(I+10) .LE. -1.) GOTO 3300
      IF(STORE(I+10)-D2)3050,3050,3300
C--CHECK IF WE ARE PRINTING THE MOVED ATOMS
3050  CONTINUE
      CALL XPRTCD ( I , J , CMOVED )
      JK=-1
C--SHIFT THE SYMMETRY OPERATORS TO THE HEADER PLACE
      CALL XMOVE(ISTORE(I+2),ISTORE(JC+7),5)
C--SHIFT THE ATOM TO TEMP. STORAGE
      CALL XMOVE(STORE(J),STORE(JB),MD5)
C--MOVE THE REST OF THE ATOMS DOWN TO MAKE ROOM FOR THIS ATOM AT THE TOP
      K=J
      L=J-MD5
C--CHECK IF WE HAVE REACHED THE TOP
3150  CONTINUE
      IF(L-JJ)3250,3200,3200
C--MOVE THE NEXT ATOM DOWN
3200  CONTINUE
      CALL XMOVE(STORE(L),STORE(K),MD5)
      K=K-MD5
      L=L-MD5
      GOTO 3150
C--MOVE THE NEW ATOM FROM TEMP. STORAGE TO THE TOP OF THE STACK
3250  CONTINUE
      JJ=KATOMS(JC,JB,JJ)
3300  CONTINUE
C--UPDATE FOR THE NEXT PIVOT ATOM
3350  CONTINUE
      IF(ISEQ)3370,3360,3360
C--CHANGE THE SERIAL NUMBER
3360  CONTINUE
      STORE(M5A+1)=SEQ
      SEQ=SEQ+1.0
C--UPDATE THE POINTER
3370  CONTINUE
      M5A=M5A+MD5
      GOTO 1400
C
C--END OF THE CONDENSING LOOP  -  OUTPUT THE NEW LIST
3400  CONTINUE
C----- WE MUST ASLO CHECH THE LAST ATOM
      IF(ISEQ) 3430,3420,3420
3420  CONTINUE
C----- UPDATE SERIAL NUMBER OF LAST ATOM
      STORE(M5A+1)=SEQ
3430  CONTINUE
      IF(N5-NATOM)3600,3600,3450
C--THE LIST MUST BE SHORTENED
3450  CONTINUE
      N=N5-NATOM
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3500)N,NATOM
      ENDIF
3500  FORMAT(//14H The following,I5,
     2 37H  atom(s) have been omitted to reduce,
     3 23H the number of atoms to,I5/)
      CALL XERHND ( IERWRN )
      J=L5+NATOM*MD5
      K=L5+(N5-1)*MD5
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3550)(ISTORE(I),STORE(I+1),I=J,K,MD5)
      ENDIF
3550  FORMAT((5(3X,A4,F8.0,7X)))
      N5=NATOM
C--PRINT THE NEW ATOM TOTAL
3600  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3650)N5
      ENDIF
3650  FORMAT(//19H List now contains ,I5,9H  atom(s))
C--CREATE THE OUTPUT LIST TYPE WHERE NECESSARY
      N=N5
      NEW=1
      CALL XCPYL5(LN1,LN2,N,NEW)
C--OUTPUT THE LIST TO THE DISC
      CALL XSTR05(LN2,0,NEW)
C
C
3720  CONTINUE
C
C -- FINAL MESSAGES
C
      CALL XOPMSG ( IOPREF, IOPEND, IVERSN )
C
      CALL XTIME2(2)
      CALL XCSAE
      CALL XRSL
      RETURN
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPREF , IOPABN , 0 )
      GO TO 3720
9910  CONTINUE
C -- INPUT ERRORS
      CALL XOPMSG ( IOPREF , IOPCMI , 0 )
      GO TO 9900
9920  CONTINUE
C -- INSUFFICIENT SPACE
      CALL XOPMSG ( IOPREF , IOPSPC , 0 )
      GO TO 9900
      END
C
CODE FOR XCOLL
      SUBROUTINE XCOLL
C----- COLLECT
C--CONDENSE A LIST 5 OR LIST 10 AND ASSEMBLE MOLECULAR FRAGMENTS
C
C  LN1    INPUT LIST TYPE
C  LN2    OUTPUT LIST TYPE
C  ILIST   THE LIST CONTROL FLAG :
C          -1  DO NOT LIST THE MOVED OR DELETED ATOMS.
C           0  LIST THE MOVED OR DELETED ATOMS.
C  TOLER   THE TOLLERANCE ADDED TO SUM OF RADII FOR BOND LIMIT
C  ITYPE    ALL(-1) OR PEAKS ONLY(0)
C
C--THE COMMON BLOCK /XWORKA/ IS USED :
C
C  JB  ADDRESS OF THE TEMP. STORAGE FOR ATOMS
C  JC  ADDRESS OF THE ATOM HEADER FOR MOVING ATOMS FROM 'JB'
C  JD  WORK SPACE FOR 'KATOMS'
C  JE  START OF DISTANCE STACK.
C  JF  NUMBER OF ATOMS LEFT TO SCAN
C  JG  CURRENT LAST ENTRY IN LIST 5 OR 10
C  JH  MD5-1
C  JI  MD5+MD5
C  JK  ZERO FOR THE FIRST OPERATION FOR THE CURRENT PIVOT ATOM,
C      ELSE NON-ZERO.
C  JL  ZERO FOR THE FIRST OPERATION FOR THE CURRENT CALL,
C      ELSE NON-ZERO.
C
C--
      DIMENSION ISTORE(131072)
C
      DIMENSION IAPD(13), PROCS(15)
      DIMENSION PEAK(1)
C
      CHARACTER*8 CMOVED
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDSTNC/AT,AC,BT,BC,BP,AP,AO,IDIST,LBOX,MBOX,MDBOX,NBOX,
     2 LFNVC,MFNVC,MDFNVC,NFNVC,MFNVCA
C
      COMMON /XPROCC/DISTS(4),LN1,LN2,ITYPE,NATOM,ILIST,ISEQ,D3,AMULT,
     2 IACT, ISYMOD, ITRANS
      COMMON /XDISTW/A,BB,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XLST29/L29,M29,MD29,N29
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      EQUIVALENCE (DISTS(1),PROCS(1))
      EQUIVALENCE (TOLER,DISTS(4))
      EQUIVALENCE (APD(1),IAPD(1))
C
C
      DATA IDIMN /15/
C
      DATA CMOVED / ' Moved  ' /
C
#HOL      DATA PEAK(1)/'Q   '/, IPEAK/'Q   '/
&HOL      DATA PEAK(1)/4HQ   /, IPEAK/'Q   '/
C
C--CALLL THE TIMING FUNCTION
      CALL XTIME1(2)
C -- READ THE REST OF THE INSTRUCTIONS AND CHECK FOR ERRORS
      IF (   KRDDPV ( PROCS(1) , IDIMN )    .LT.   0   ) GO TO 9910
C
C--LOAD THE INPUT LIST
      LN1=KTYP05(LN1)
      CALL XLDR05(LN1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--FIND THE OUTPUT LIST TYPE
      LN2=KTYP05(LN2)
C
C----- ALLOCATE A FUNCTION VECTOR TO HOLD RADII OF EACH ATOM AND STATUS
      MDFNVC = 2
      NFNVC = N5
      I=N5*MDFNVC
      LFNVC = KSTALL (I)
      CALL XZEROF ( ISTORE(LFNVC) , I )
C
C----- LOAD THE FUNCTION VECTOR WITH RADIUS 1 (VDW)
      JFNVC = 1
      IRDUS = 1
C----- LOAD LIST 29
      CALL XFAL29
C----- SCAN LIST 5 SETTING FUNCTION VECTOR TO APPROPRIATE RADIUS
      MFNVC=LFNVC
      I29=L29 + (N29-1)*MD29
      I5 = L5 + (N5-1)*MD5
      BMAX = 0.
      BMIN = 0.
      DO 7450 M5=L5,I5,MD5
      DO 7250 M29= L29,I29,MD29
      JZ=M29+IRDUS
      IF (ISTORE(M5) - ISTORE(M29)) 7250,7350,7250
7250  CONTINUE
C----- NO MATCH - POINT TO DEFAULT ATOM
      JZ = L29 + IRDUS
7350  CONTINUE
C----- MATCH
      STORE(MFNVC+1) = STORE(JZ)
      BMAX = AMAX1( BMAX, STORE(JZ))
C----- SET THE FUNCTION TO 'USE'  I.E.  +1
      ISTORE(MFNVC ) = 1
      MFNVC = MFNVC + MDFNVC
7450  CONTINUE
      IF (ILIST .GE. 0) THEN
        WRITE(NCAWU,7460) TOLER
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU ,7460) TOLER
      ENDIF
7460    FORMAT(/' Tolerance used in determining bonds is ',F4.2,/)
      ENDIF
C
C----- RESET FUNCTION VECTOR AND LIMITS USED BY D/A IF NECESSARY
      IF(JFNVC) 7670,7670,7660
7660  CONTINUE
      BMAX=2.*BMAX + TOLER
      AT = 0.
      AC = BMAX
      BT = 0.
      BC = BMAX
7670  CONTINUE
C----- LOAD LISTS 1 AND 2, AND SET UP SOME CONSTANTS
      CALL XDIST2
C
C
C----- REDUCE SYMMETRY IF NECESSARY
      CALL KSYMOD (ISYMOD, IC, IL, N2P, L2C, L2, N2, MD2)
      JT=12
      L12=-1
      M12=-1
C--SET UP A FEW STACK CONSTANTS
      JB=NFL
      JC=JB+MD5
      JD=JC+20
      JE=JD+30
C--CHECK THE STORE AREA
      IF ( JE - LFL ) 1350 , 9920 , 9920
1350  CONTINUE
C----- THE 'USE' FLAG IS DECREMENTED WHEN AN ATOM IN THE FOUND LIST MAKE
C      A CONTACT TO AN UNFOUND ATOM
C----- SET CUTTENT LEVEL OF ACTIVITY (NEGATIVE)
      ICURR = -1
C----- MARK FIRST ATOM AS FOUND
      ISTORE(LFNVC) = ICURR
      IF (ITYPE .EQ. 0) THEN
C----- ONLY MOVE PEAKS - MARK ALL NON-PEAKS AS FOUND
            I5 = L5 + (N5-1)*MD5
            MFNVC = LFNVC
            DO 1360 M5 = L5, I5, MD5
            IF(ISTORE(M5) .NE. IPEAK) ISTORE(MFNVC) = ICURR
            MFNVC = MFNVC + MDFNVC
1360        CONTINUE
      ENDIF
C----- FRAGMENT PRINT FLAG
      IFRGPT = -1
1370  CONTINUE
C----- LOOP BACK HERE IF ICHNG NOT ZERO
C--SET UP THE CONTROL VARIABLES FOR THIS PASS
C----- SET NO NEW CHANGES YET
      ICHNG = 0
      MATOM = 0
C----- OUTER PIVOT LOOP ALWAYS RE-START FROM BEGINNING
      M5A = L5
      MFNVCA = LFNVC
1400  CONTINUE
C----- INNER CONTACT LOOP, STARTING FROM M5, ALWAYS GOES OVER ALL ATOMS
      M5=L5
      MFNVC = LFNVC
      IF (MATOM  .GE. N5) GOTO 3400
C----- DONT REUSE PREVIOUS FOUND OR UNFOUND ATOMS AS PIVOT.
      IF (ISTORE(MFNVCA) .NE. ICURR) GOTO 3350
      NFL=JE
C -- COMPUTE DISTANCE STACK
      NDIST = KDIST1( N5, J, JT, 1, TOLER, ITRANS)
      IF(NDIST .LE. -1 ) THEN
C----- ERROR
            GOTO 9920
      ELSE IF (NDIST .EQ. 0) THEN
        IF (ITYPE .LT. 0) THEN
            IF (ISTORE(MFNVCA) .EQ. 1) THEN
C----- AN ISOLATED ATOM
                  WRITE(NCAWU,1451) ISTORE(M5A), STORE(M5A+1)
      IF (ISSPRT .EQ. 0) THEN
                  WRITE(NCWU,1451) ISTORE(M5A), STORE(M5A+1)
      ENDIF
1451              FORMAT(' Isolated atom : ', A4,F6.0)
            ELSE IF ( (ICHNG .EQ. 0) .AND. ( IFRGPT .LT. 0) ) THEN
C----- START OF A NEW FRAGMENT - SET FLAG TO 'PRINT'
                  IFRGPT = +1
            END IF
        END IF
            GOTO 3350
      ENDIF
C--REMOVE DUPLICATE ENTRIES FOR EACH ATOM, LEAVING THE MIN. CONTACT DIST
      NFL=J
      I=JE
      JS=JE
C--CHECK IF THERE ARE ANY MORE ATOMS IN THE STACK
1600  CONTINUE
      IF(I-J)1650,2000,2000
C--BEGIN THE SEARCH FOR ALL CONTACTS TO THIS CURRENT ATOM
1650  CONTINUE
      E=STORE(I+10)
      K=I
C--CHECK IF THERE ARE ANY MORE ATOMS IN THE STACK
1700  CONTINUE
      IF(I-J)1750,1950,1950
C--CHECK IF THIS IS THE SAME ATOM
1750  CONTINUE
      IF(ISTORE(I)-ISTORE(K))1950,1800,1950
C--CHECK THE DISTANCE
1800  CONTINUE
      IF(STORE(I+10)-E)1850,1900,1900
1850  CONTINUE
      E=STORE(I+10)
      K=I
C--MOVE TO THE NEXT ATOM
1900  CONTINUE
      I=I+JT
      GOTO 1700
C--MOVE THE STACK INFORMATION
1950  CONTINUE
      CALL XMOVE(STORE(K),STORE(JS),JT)
      K=K+JT
      JS=JS+JT
      GOTO 1600
C--CHECK IF ANY ATOMS HAVE BEEN FOUND
2000  CONTINUE
      IF(JS-JE)3350,3350,2050
C--ATOMS FOUND  -  CHECK FOR ATOMS TO BE DELETED
2050  CONTINUE
      JK=0
      JS=JS-JT
      IPOINT=NOWT
C
C--BEGIN MOVING NON-DELETED ATOMS
      NFL=JD
C--MAIN ATOM MOVING LOOP
      DO 3300 I=JE,JS,JT
C----- CHECK IF ACCEPTABLE
      IF(ISTORE(I+1) .LE. 1) GOTO 3300
C--CHECK IF WE ARE PRINTING THE MOVED ATOMS
      IF (IFRGPT .GT. 0) THEN
      IF (ISSPRT .EQ. 0) THEN
            WRITE(NCWU,'(A)' ) ' Start of a new fragment '
      ENDIF
            WRITE(NCAWU,'(A)' ) ' Start of a new fragment '
C            NOW INHIBIT PRINTING
            IFRGPT = -1
      ENDIF
      CALL XPRTCD(I,J,CMOVED)
      JK=-1
C--SHIFT THE SYMMETRY OPERATORS TO THE HEADER PLACE
      CALL XMOVE(ISTORE(I+2),ISTORE(JC+7),5)
C--SHIFT THE ATOM TO TEMP. STORAGE
      CALL XMOVE(STORE(J),STORE(JB),MD5)
C
C----- LIST 5 ADDRESS
      IADDR = ISTORE(I)
C----- WHICH ATOM
      IATOM = (IADDR-L5)/MD5 + 1
C----- FUNCTION VECTOR ADDRESS
      IADDF = LFNVC + (IATOM-1)*MDFNVC
C--MOVE THE NEW ATOM FROM TEMP. STORAGE TO CORRECT POSITION
3250  CONTINUE
      JJ=KATOMS(JC,JB,IADDR)
      ISTORE(IADDF) = ICURR -1
      ICHNG = ICHNG + 1
3300  CONTINUE
C--UPDATE FOR THE NEXT PIVOT ATOM
3350  CONTINUE
      M5A = M5A + MD5
      MFNVCA = MFNVCA + MDFNVC
      MATOM = MATOM + 1
      GOTO 1400
C
C
3400  CONTINUE
C----- SEE IF THERE ARE ANY UNMOVED ATOMS LEFT
      ICURR = ICURR - 1
      IF (ICHNG .EQ. 0) THEN
            K = LFNVC + MDFNVC*(NFNVC-1)
            DO 3370 I = LFNVC, K, MDFNVC
            IF (ISTORE(I) .EQ. 1) THEN
                  ISTORE(I) = ICURR
                  ICHNG = ICHNG + 1
                  GOTO 3380
            END IF
3370        CONTINUE
3380  CONTINUE
      END IF
      IF (ICHNG .NE. 0) GOTO 1370
C
C
C--END OF THE CONDENSING LOOP  -  OUTPUT THE NEW LIST
C--CREATE THE OUTPUT LIST TYPE WHERE NECESSARY
      N=N5
      NEW=1
      CALL XCPYL5(LN1,LN2,N,NEW)
C--OUTPUT THE LIST TO THE DISC
      CALL XSTR05(LN2,0,NEW)
C
C
3720  CONTINUE
C
C -- FINAL MESSAGES
C
      CALL XOPMSG ( IOPREF , IOPEND , 301 )
C
      CALL XTIME2(2)
      CALL XCSAE
      CALL XRSL
      RETURN
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPREF , IOPABN , 0 )
      GO TO 3720
9910  CONTINUE
C -- INPUT ERRORS
      CALL XOPMSG ( IOPREF , IOPCMI , 0 )
      GO TO 9900
9920  CONTINUE
C -- INSUFFICIENT SPACE
      CALL XOPMSG ( IOPREF , IOPSPC , 0 )
      GO TO 9900
      END
C
C
CODE FOR XPRTCD
      SUBROUTINE XPRTCD(I,J,MESS)
C--PRINT AN ATOM THAT IS TO BE DELETED OR MOVED BY 'XCOND'
C
C  I       ADDRESS OF THE DISTANCE CONTROL BLOCK FOR THIS CONTACT.
C  J       SET TO THE ADDRESS OF THE ATOM TO BE ALTERED ON RETURN.
C  MESS    MESSAGE THAT IS TO BE PRINTED.
C
C--THIS ROUTINE CHECKS 'ILIST' TO SEE IF THE PRINT IS REQUIRED,
C  AND ASSUMES THAT THE CURRENT PIVOT ATOM IS AT 'M5A'.
C
C--TWO VARIABLES IN 'XWORKA' ARE USED TO CONTROL THE PRINTING :
C
C  JK  ZERO IF THIS IS THE FIRST PRINT FOR THIS PIVOT ATOM,
C      ELSE NON-ZERO.
C  JL  ZERO IF THIS IS THE FIRST PRINT OF ANY KIND FOR THIS CALL
C      OF 'XCOND', ELSE NON-ZERO.
C
C--
      DIMENSION ISTORE(131072)
C
      DIMENSION IAPD(13), PROCS(15)
      CHARACTER*(*) MESS
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDSTNC/AT,AC,BT,BC,BP,AP,AO,IDIST,LBOX,MBOX,MDBOX,NBOX,
     2 LFNVC,MFNVC,MDFNVC,NFNVC,MFNVCA
C
      COMMON /XPROCC/DISTS(4),LN1,LN2,ITYPE,NATOM,ILIST,ISEQ,D3,AMULT,
     2 IACT, ISYMOD, ITRANS
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (PROCS(1), DISTS(1))
      DATA IDIMN /15/
C
C--FIND THE ADDRESS OF THE ATOM TO BE ALTERED
      J=ISTORE(I)
      K=I+4
C--CHECK FOR LISTING WITH THIS CALL
      IF(ILIST)1400,1000,1000
C--PRINT REQUIRED  -  CHECK IF THIS THE FIRST DELETION FOR THIS ATOM
1000  CONTINUE
      IF(JK)1300,1050,1300
C--CHECK IF THIS IS THE FIRST ACTION IN THIS CALL
1050  CONTINUE
      IF(JL)1100,1100,1200
C--THIS IS THE FIRST CALL  -  OUTPUT THE HEADING
1100  CONTINUE
      JL=1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1150)
      ENDIF
1150  FORMAT(///' Current pivot atom',7X,'Atom',3X,'Serial',3X,'S(I)',
     2 2X,'L',2X,'T(X)',1X,'T(Y)',1X,'T(Z)',2X,'Distance',5X,'Action',
     3 6X, 'x/a', 5X, 'y/b', 5X, 'z/c', 5X, 'Rho', /)
      WRITE ( NCAWU , 1155 )
1155  FORMAT ( 1X , '  Pivot      Atom   Distance       Action',
     3 5X, 'x/a', 5X, 'y/b', 5X, 'z/c', 5X, 'Rho', /)
C--PRINT THE ATOM TO BE ALTERED WITH THE PIVOT ATOM
1200  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1250)STORE(M5A),STORE(M5A+1),ISTORE(J),STORE(J+1),
     2 (ISTORE(L+2),L=I,K) , STORE(I+10) , MESS,
     3 STORE(J+4), STORE(J+5), STORE(J+6), STORE(J+13)
      ENDIF
1250  FORMAT (/, 1X,4X,A4,F8.0,9X,A4,F8.0,4X,I3,I4,3I5,F9.3,6X,A8,
     1 3F8.3, F9.1 )
      WRITE ( NCAWU , 1255 ) STORE(M5A) , STORE(M5A+1)
1255  FORMAT ( 1X, A4 , F5.0 )
      WRITE ( NCAWU , 1355 ) STORE(J) , STORE(J+1) , STORE(I+10) , MESS,
     3 STORE(J+4), STORE(J+5), STORE(J+6), STORE(J+13)
      GOTO 1400
C--PRINT THE ALTERED ATOM WITHOUT THE CURRENT PIVOT
1300  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1350)ISTORE(J),STORE(J+1),(ISTORE(L+2),L=I,K),
     2 STORE(I+10) , MESS,
     3 STORE(J+4), STORE(J+5), STORE(J+6), STORE(J+13)
      ENDIF
1350  FORMAT ( 26X,A4,F8.0,4X,I3,I4,3I5,F9.3,6X,A8,
     1 3F8.3, F9.1 )
      WRITE ( NCAWU , 1355 ) STORE(J) , STORE(J+1) , STORE(I+10) , MESS,
     3 STORE(J+4), STORE(J+5), STORE(J+6), STORE(J+13)
1355  FORMAT ( 1X , 13X , A4 , F5.0 ,  F8.5 , 4X , A8,
     1 3F8.3, F9.1 )
C--AND NOW RETURN
1400  CONTINUE
      RETURN
      END
C
CODE FOR XOCC
      FUNCTION XOCC(IADD)
C--COMPUTE THE OCCUPANCY OF AN ATOM.
C
C  IADD    THE ADDRESS OF THE ATOM IN 'STORE'.
C
C--RETURN VALUES OF 'XOCC' ARE :
C
C  -1.  INSUFFICIENT CORE.
C  >0.  THE OCCUPANCY.
C
C--THE DETAILS FOR 'KDIST1' SHOULD ALREADY HAVE BEEN SET UP, WITH A
C  MAXIMUM DISTANCE CONTACT OF AT LEAST '2.0*VALUE'.
C  THE RESULTS FROM 'KDIST1' OVERWRITE THE DATA AT 'NFL', SO THAT
C  THIS SHOULD BE PROTECTED IF IT IS IMPORTANT.
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
C
C--PRESERVE THE LIST 5 POINTERS
      KA=M5A
      M5A=IADD
      KB=M5
      M5=IADD
C--PRESERVE THE LIST 12 POINTERS
      KC=M12
      M12=NOWT
C--SET THE ENTRY LENGTH
      KD=12
C--COMPUTE SOME DISTANCES
      IF(KDIST1( 1, I, KD, 0, .2, 0)) 1000, 1050, 1150
C--NOT ENOUGH CORE
1000  CONTINUE
      XOCC=-1.
      GOTO 1100
C--NO OTHER CONTACTS
1050  CONTINUE
      XOCC=1.
1100  CONTINUE
      M5A=KA
      M5=KB
      M12=KC
      RETURN
C--SOME CONACTS  -  CHECK THEM OUT
1150  CONTINUE
      I=I-KD
      A=1.
      B=2.*VALUE
      DO 1250 K=NFL,I,KD
      IF(STORE(K+10)-B)1200,1200,1250
C--UPDATE THE POINTER
1200  CONTINUE
      A=A+1.
1250  CONTINUE
      XOCC=1./A
      GOTO 1100
      END
C
CODE FOR KDIST1
      FUNCTION KDIST1( IN, JS, JT, JFNVC, TOLER, ITRANS)
C--ENTRY THAT CALCULATES DISTANCES AND STORES THE RESULTS AT NFL
C
C  IN  THE NUMBER OF ATOMS TO BE MOVED AROUND.
C  JS  POINTER TO THE DISTANCES STACK  -  ORIGINALLY SET TO 'NFL'
C      AND POINTING TO THE NEXT FREE LOCATION AFTER THE STACK ON EXIT.
C  JT  THE NUMBER OF WORDS PER ENTRY IN THE DISTANCES STACK.
C JFNVC SET TO ZERO IF NO FUNCTION VECTOR SUPPLIED
C TOLER SET TO TOTAL TOLERANCE IF FUNCTION VECTOR SUPPLIED
C ITRANS SET TO -1 TO SUPPRESS UNIT CELL TRANSLATIONS
C
C--THE RETURN VALUES OF 'KDIST1' ARE :
C
C  -1  NOT ENOUGH CORE IS AVAILABLE.
C   0  NO SUITABLE CONTACTS HAVE BEEN FOUND.
C  >0  THE NUMBER OF ENTRIES IN THE DISTANCES STACK.
C
C--THE VARIABLE 'IDIST' DETERMINES THE TYPE OF SEARCH
C  THAT IS PERFORMED :
C
C  -1  NORMAL DISTANCES AND ANGLES.
C   0  PLACEMENT WITHIN THE VOLUME DEFINED BY 'BPD(4-9)'.
C  >0  PLACEMENT WITHIN THE VOLUME GIVEN BY THE FACE
C      EQUATIONS. THE VALUES IN 'BPD(4-9)' ARE USED IN THE
C      INITIAL SEARCH AND MUST BE THE MIN. AND MAX.
C      VALUES TO BE FOUND.
C
C--THE BOX VARIABLES FOLLOW 'IDIST' IN 'XDSTNC' :
C
C  LBOX    LOCATION OF THE BOX CONTROL DATA.
C  MBOX    WORK VARIABLE.
C  MDBOX   NUMBER OF WORDS PER BOX CONTROL BLOCK ENTRY
C  NBOX    NUMBER OF CONTROL BLOCKS MINUS ONE.
C
C--THE FIRST ENTRY IN THIS TABLE IS THE CENTROID OF THE BOX IN CRYSTAL
C  FRACTIONS, AND THE REMAINING ENTRIES CONTAIN THE EQUATION OF ONE
C  OF THE PLANES BOUNDING THE SHAPE TO BE FILLED. THE EQUATIONS USE
C  COORDINATES IN CRYSTAL FRACTIONS AND ARE OF THE FORM A*X+Y*B+Z*C-D=0.
C
C--FOR THE BOX ALGORITHM, THE REPLIES ARE THE SAME, EXCEPT THAT THE
C  DISTANCE ENTRIES ARE NOT SET, ONLY THE COORDINATES.
C
C--THE FOLLOWING VARIABLES MUST BE SET ON ENTRY
C
C  AT     MINIMUM ALLOWED DISTANCE FOR DISTANCES
C  AC     MAXIMUM ALLOWED DISTANCE FOR DISTANCES
C  BT     MINIMUM ALLOWED DISTANCE FOR ANGLES
C  BC     MAXIMUM ALLOWED DISTANCE FOR ANGLES
C  AO    MAXIMUM ALLOWED DISTANCE OVERALL
C  AP     MAXIMUM ALLOWED DISTANCES SQUARED OVERALL
C  BP     MINIMUM ALLOWED DISTANCE SQUARED OVERALL
C  M5A    ADDRESS OF THE CURRENT PIVOT ATOM IN LIST 5
C  M5     ADDRESS OF THE FIRST ATOM TO MOVE AROUND IN LIST 5
C----  MFNVCA  ADDRESS IN FUNVTION VECTOR OF PIVOT ATOM
C      MFNVC   ADDRESS IN FUNCTION VECTOR OF FIRST ATOM
C
C--ATOMS WHICH FORM ACCEPTABLE CONTACTS ARE STORED IN A STACK
C  WHICH HAS THE FOLLOWING FORMAT :
C
C   0  ADDRESS OF THE ATOM IN LIST 5
C   1  ACCEPTANCE FLAG
C
C      1  ACCEPTABLE TO NONE
C      2  DISTANCES ONLY
C      3  ANGLES ONLY
C      4  ACCEPTABLE TO BOTH
C
C   2  S, THE SYMMETRY MATRIX TO BE USED (NEGATIVE FOR CENTRE OF SYM.)
C   3  NON-PRIMITIVE LATTICE INDICATOR
C   4  T(X)
C   5  T(Y)
C   6  T(Z)
C   7  TRANSFORMED X
C   8  TRANSFORMED Y
C   9  TRANSFORMED Z
C  10  DISTANCE
C  11  DISTANCE SQUARED
C  12  ADDRESS IN LIST 12  (IF USED).
C  13  TARGET CONTACT DISTANCE FOR RESTRAINTS (OPTIONAL)
C
C--THE STACK STARTS AT NFL, AND GOES UPWARDS SO THAT THE LAST ENTRY IS
C  AT JS, AND THE STEP IS JT.
C
C--THE COMMON BLOCK /XAPD/ IS USED AS :
C
C  APD(1-3)  SYMMETRY RELATED X, Y AND Z, WITH TRANSLATION PART OMITTED.
C  APD(4-6)  INITIAL SYMMETRY RELATED X, Y AND Z.
C  APD(7-9)  FINAL SYMMETRY RELATED X, Y AND Z AFTER A SUCCESSFUL FIND.
C
C  BPD(1-3)  D(L,M,N) IN ANGSTROM  -  CORRESPONDS TO A UNIT CELL SHIFT.
C  BPD(4-6)  MINIMUM FRACTIONAL COORDINATES OF THE SEARCH VOLUME.
C  BPD(7-9)  MAXIMUM FRACTIONAL COORDINATES OF THE SEARCH VOLUME.
C
C--
      DIMENSION ISTORE(131072)
C
      DIMENSION XX(3)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDSTNC/AT,AC,BT,BC,BP,AP,AO,IDIST,LBOX,MBOX,MDBOX,NBOX,
     2 LFNVC,MFNVC,MDFNVC,NFNVC,MFNVCA
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      EQUIVALENCE (E,XX(1)),(F,XX(2)),(G,XX(3))
C
C--SET UP A FEW INITIAL POINTERS
      NJ=0
      JS=NFL
C--SET DEFAULT DISTANCES
      E=0.
      F=0.
C--CHECK IF WE ARE CALCULATING DISTANCES OR A BOX FUNCTION
      IF(IDIST)1000,1100,1100
C--DISTANCES ARE BEING CALCULATED
1000  CONTINUE
      I=M5A
C--SET UP THE MAXIMUM AND MINIMUM VALUES FOR EACH DIRECTION FOR A DISTAN
      DO 1050 J=1,3
      BPD(J+3)=STORE(I+4)-AO/BPD(J)
      BPD(J+6)=STORE(I+4)+AO/BPD(J)
      I=I+1
1050  CONTINUE
C--SET UP THE OTHER FLAGS
1100  CONTINUE
      NC=2*IC+1
      ND=IN
C--CHECK IF THERE MORE ATOMS TO PROCESS
1150  CONTINUE
      IF(ND)2800,2800,1200
C--LOOP OVER EACH SYMMETRY OPERATOR COMBINATION FOR THIS ATOM
1200  CONTINUE
      M2=L2
      DO 2700 NE=1,N2
C--APPLY THIS SYMMETRY OPERATOR
      CALL XMLTTM(STORE(M2),STORE(M5+4),APD(1),3,3,1)
C--LOOP OVER EACH REQUIRED SIGN FOR THE CENTRE OF SYMMETRY FLAG
      DO 2650 NF=1,NC,2
      M2P=L2P
C--LOOP OVER EACH OF THE NON-PRIMITIVE LATTICE TRANSLATIONS
      DO 2600 NG=1,N2P
      NH=M2
C--ADD IN THE VARIOUS TRANSLATION PARTS
      DO 1250 NI=1,3
      APD(NI+3)=APD(NI)+STORE(M2P)+STORE(NH+9)
      APD(NI+6)=APD(NI+3)
      M2P=M2P+1
      NH=NH+1
1250  CONTINUE
      IF (ITRANS .EQ. -1) GOTO 1550
C--MOVE THE X COORDINATE SO THAT IT IS OUT OF THE REQUIRED VOLUME
      CALL XSHIFT(1)
C--ADVANCE THE X COORDINATE BY ONE OR MORE UNIT CELLS
1300  CONTINUE
      IF(KDIST(1))2600,1350,1350
C--MOVE THE Y COORDINATE SO THAT IT IS OUT OF THE REQUIRED VOLUME
1350  CONTINUE
      CALL XSHIFT(2)
C--ADVANCE THE Y COORDINATE BY ONE OR MORE UNIT CELLS
1400  CONTINUE
      IF(KDIST(2))1300,1450,1450
C--MOVE THE Z COORDINATE SO THAT IT IS OUT OF THE REQUIRED VOLUME
1450  CONTINUE
      CALL XSHIFT(3)
C--ADVANCE THE Z COORDINATE BY ONE OR MORE UNIT CELLS
1500  CONTINUE
      IF(KDIST(3))1400,1550,1550
C--A SUCCESSFUL FIND  -  CHECK THE CORE CONTROL
1550  CONTINUE
      IF(JS+MAX0(JT,13)-LFL)1650,1600,1600
C--NOT ENOUGH CORE FOR THIS ENTRY
1600  CONTINUE
C----- NEGATE NUMBER OF CONTACTS TO SIGNAL STORE OVERFLOW
      NJ = -NJ
      GOTO 2800
C--ASSIGN A DEFAULT ACCEPTANCE FLAG
1650  CONTINUE
      ISTORE(JS+1)=1
C--CHECK ON THE TYPE OF FUNCTION
      IF(IDIST)1800,2500,1700
C--FILLING A MULTI-SIDED BOX  -  MOVE TO THE CENTROID
1700  CONTINUE
      CALL XSUBTR(APD(7),STORE(LBOX),XX(1),3)
C--CHECK THAT THE POINT IS WITHIN THE BOX
      MBOX=LBOX
      DO 1750 NH=1,NBOX
      MBOX=MBOX+MDBOX
      IF(STORE(MBOX)*XX(1)+STORE(MBOX+1)*XX(2)+STORE(MBOX+2)*XX(3)
     2 -STORE(MBOX+3))1750, 1750, 2570
1750  CONTINUE
      GOTO 2500
1800  CONTINUE
C----- SHALL WE USE THE FUNCTION VECTOR?
      IF (JFNVC) 1840,1840,1810
1810  CONTINUE
C----- CHECK IF THE SECOND ATOM IS PERMITTED
      IF (ISTORE(MFNVC)) 2725,2725,1840
1840  CONTINUE
C----- CHECK FOR SELF-SELF CONTACT
      IF(M5-M5A)2100,1850,2100
1850  CONTINUE
C----- CHECK X
      IF (ABS(STORE(M5A+4)-APD(7)) - ZERO)1950,1950,2050
1950  CONTINUE
C----- CHECK Y
      IF (ABS(STORE(M5A+5)-APD(8)) - ZERO)2000,2000,2050
2000  CONTINUE
      IF (ABS(STORE(M5A+6)-APD(9)) - ZERO) 2570, 2570, 2050
2050  CONTINUE
C--THIS IS NOT A SELF-SELF CONTACT WITH NO OPERATORS  -  CALC. DIST.
2100  CONTINUE
      F=XDSTN2(STORE(M5A+4),APD(7))
      IF(F-BP) 2570, 2150, 2150
C--CHECK THE DISTANCE AGAINST THE MAXIMUM ALLOWED VALUE SQUARED
2150  CONTINUE
      IF(AP-F) 2570, 2200, 2200
C--COMPUTE THE DISTANCE
2200  CONTINUE
      E=SQRT(F)
C---- USE THE FUNCTION VECTOR ?
      IF (JFNVC) 2225,2225,3000
2225  CONTINUE
C----- SET TARGET TO CURRENT VALUE
      BOND = E
C----- USE OVERALL LIMITS
C--WRITE IN ACCEPTANCE FLAGS
      IF(E-AT)2350,2250,2250
2250  CONTINUE
      IF(AC-E)2350,2300,2300
C--DISTANCE ACCEPTABLE
2300  CONTINUE
      ISTORE(JS+1)=ISTORE(JS+1)+1
2350  CONTINUE
      IF(E-BT)2500,2400,2400
2400  CONTINUE
      IF(BC-E)2500,2450,2450
C--ANGLE ACCEPTABLE
2450  CONTINUE
      ISTORE(JS+1)=ISTORE(JS+1)+2
      GOTO 2500
C
3000  CONTINUE
C-----  CHECK THE DISTANCE AGAINST THE RADII
C----- DONT PUT INTO STACK IF TOO LONG COMPARED WITH FUNCTION VECTOR
      BOND = STORE(MFNVC+1) + STORE(MFNVCA+1)
      IF ((E .GT. (BOND + TOLER)).OR. ( E .LE. AT)) THEN
      GOTO 2570
      ELSE
            ISTORE(JS+1) = 4
      ENDIF
C--SET THE REMAINING FLAGS
2500  CONTINUE
      ISTORE(JS)=M5
      ISTORE(JS+2)=(2-NF)*NE
      ISTORE(JS+3)=NG
      NJ=NJ+1
      J=JS+4
      DO 2550 I=1,3
      ISTORE(J)=NINT(APD(I+6)-APD(I+3))
      STORE(J+3)=APD(I+6)
      J=J+1
2550  CONTINUE
      STORE(JS+10)=E
      STORE(JS+11)=F
      ISTORE(JS+12)=M12
      IF (JT .EQ. 14) STORE(JS+13) = BOND
      JS=JS+JT
2570  CONTINUE
      IF (ITRANS .EQ. 0) GOTO 1500
2600  CONTINUE
      CALL XNEGTR(APD(1),APD(1),3)
2650  CONTINUE
      M2=M2+MD2
2700  CONTINUE
2725  CONTINUE
      MFNVC = MFNVC+MDFNVC
      ND=ND-1
      M5=M5+MD5
C--CHECK IF LIST 12 NEEDS UPDATING
      IF(M12)1150,1150,2750
C--UPDATE THE LIST 12 POINTER
2750  CONTINUE
      M12=ISTORE(M12)
      GOTO 1150
2800  CONTINUE
      KDIST1=NJ
      RETURN
      END
C
CODE FOR XDSTN2
      FUNCTION XDSTN2(A,B)
C--COMPUTE THE DISTANCE SQUARED BETWEEN TWO POINTS
C
C  A  VECTOR CONTAINING THE COORDINATES OF THE FIRST POINT.
C  B  VECTOR CONTAINING THE COORDINATES OF THE SECOND POINT.
C
C--THE RETURN VALUE OF 'XDSTN2' IS THE DISTANCE SQUARED.
C
C--
C
      DIMENSION A(3),B(3),C(3),D(3)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
C
C--SUBTRACT THE VECTORS
      CALL XSUBTR(A(1),B(1),C(1),3)
C--ORTHOGONALISE THE DIFFERENCE VECTOR
      CALL XMLTTM(STORE(L1O1),C(1),D(1),3,3,1)
C--COMPUTE THE DISTANCE
      C(1)=D(1)*D(1)+D(2)*D(2)+D(3)*D(3)
C--CHECK THE VALUE
      IF(C(1)-ZEROSQ)1000,1050,1050
C--LESS THAN 'ZERO'  -  ASSIGN THE ANSWER TO 'VALUE'
1000  CONTINUE
      C(1)=VALUSQ
1050  CONTINUE
      XDSTN2=C(1)
      RETURN
      END
C
CODE FOR XSHIFT
      SUBROUTINE XSHIFT(NOC)
C--SHIFTS THE ATOM OUT OF RANGE SO THAT IT CAN START COMING BACK
C
C  NOC  THE NUMBER OF THE PARAMETER TO MOVE, IN THE RANGE 1 TO 3.
C
C--THE COMMON BLOCK 'XPDS' IS USED AS :
C
C  APD(7-9)  CURRENT SET OF ATOMIC COORDINATES TO ALTER.
C  BPD(4-6)  MIINIMUM ALONG EACH OF THE AXIAL DIRECTIONS.
C  BPD(7-9)  MAXIMUM ALONG EACH OF THE AXIAL DIRECTIONS.
C
C--
      COMMON/XPDS/APD(14),BPD(14)
C
C--CHECK IF WE GONE FAR ENOUGH BACKWARDS
1000  CONTINUE
      IF(APD(NOC+6)-BPD(NOC+3))1050,1100,1100
C--SUCCESS  -  NOW RETURN
1050  CONTINUE
      RETURN
C--MOVE BACK ONE MORE UNIT CELL
1100  CONTINUE
      APD(NOC+6)=APD(NOC+6)-1.
      GOTO 1000
      END
C
CODE FOR KDIST
      FUNCTION KDIST(NOC)
C--MOVES AN ATOM POSITIVELY FORWARD ONE UNIT CELL, AND CHECKS IF
C  THE ATOM IS STILL WITHIN THE SEARCH VOLUME FOR THE GIVEN AXIAL DIRECT
C
C  NOC  THE AXIAL DIRECTION ALONG WHICH TO MOVE.
C
C--THE RETURN VALUES OF 'KDIST' ARE :
C
C  -1  ATOM CANNOT BE FITTED IN THE REQUIRED VOLUME ANY MORE.
C   0  ATOM IS STILL WITHIN THE REQUIRED VOLUME FOR THIS DIRECTION.
C
C--THE ATOM IS ASSUMED TO HAVE BEEN POSITIONED OUTSIDE THE VOLUME BY
C  'XSHIFT', AND IT IS ALWAYS MOVED AT LEAST ONE UNIT CELL FOR EACH CALL
C  OF THIS ROUTINE.
C
C--THE COMMON BLOCK 'XPDS' IS USED AS :
C
C  APD(7-9)  CURRENT SET OF ATOMIC COORDINATES TO ALTER.
C  BPD(4-6)  MIINIMUM ALONG EACH OF THE AXIAL DIRECTIONS.
C  BPD(7-9)  MAXIMUM ALONG EACH OF THE AXIAL DIRECTIONS.
C
C--
      COMMON/XPDS/APD(14),BPD(14)
C
      KDIST=-1
C--MOVE FORWARD ONE UNIT CELL
1000  CONTINUE
      APD(NOC+6)=APD(NOC+6)+1.
C--CHECK IF WE HAVE ARRIVED IN THE REQUIRED VOLUME
      IF(APD(NOC+6)-BPD(NOC+3))1000,1050,1050
C--CHECK IF WE HAVE GONE TOO FAR ALONG THIS AXIAL DIRECTION
1050  CONTINUE
      IF(APD(NOC+6)-BPD(NOC+6))1100,1100,1150
C--WE ARE IN THE REQUIRED VOLUME
1100  CONTINUE
      KDIST=0
1150  CONTINUE
      RETURN
      END
C
CODE FOR XDIST2
      SUBROUTINE XDIST2
C--SET UP A FEW CONSTANTS
C
      DIMENSION ISTORE(131072)
C
      DIMENSION IAPD(13)
      DIMENSION CC(4)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDSTNC/AT,AC,BT,BC,BP,AP,AO,IDIST,LBOX,MBOX,MDBOX,NBOX,
     2 LFNVC,MFNVC,MDFNVC,NFNVC,MFNVCA
      COMMON/XCNTRL/LC,ISTAT2,ICNTR1,ICNTR2,LCG,MCG,MDCG,NCG,
     2 LCA,MCA,MDCA,NCA,LCS,MCS,MDCS,NCS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      EQUIVALENCE (APD(1),IAPD(1))
      EQUIVALENCE (CC(1),AT)
C
      ISTAT2=0
C--LOAD LIST 1 AND LIST 2
      CALL XFAL01
      CALL XFAL02
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET UP THE SHIFT DATA
      DO 1050 I=1,3
      K=L1O2+I-1
      BPD(I)=0.
      DO 1000 J=1,I
      BPD(I)=BPD(I)+STORE(K)*STORE(K)
      K=K+3
1000  CONTINUE
      BPD(I)=1./SQRT(BPD(I))
1050  CONTINUE
C--CHECK THE INPUT DISTANCES PROVIDED
      DO 1150 I=1,4
      IF(CC(I)-ZERO)1100,1150,1150
C--SET UP THE DEFAULT
1100  CONTINUE
      CC(I)=ZERO
1150  CONTINUE
      AO=AMAX1(AC,BC)
      AP=AO*AO
      BP=AMIN1(AT,BT)
      BP=BP*BP
C--INDICATE THAT LIST 12 IS NOT STORE INITIALLY
      L12=NOWT
      M12=NOWT
C--DEFAULT TO AN INTER-ATOMIC DISTANCES CALCULATION
      IDIST=-1
9900  CONTINUE
C -- NORMAL AND ERROR RETURN
      RETURN
      END
C
CODE FOR KSYMOD
      SUBROUTINE KSYMOD (ISYMOD, IC, IL, N2P, L2C, L2, N2, MD2)
C
C----- MODIFY THE SYMMETRY CONDITIONS FOR PATTERSONS OR NO SYMMETRY CASE
C
      DIMENSION ISTORE(131072)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      IF (ISYMOD .EQ. -1) THEN
C-----  PATTERSON PEAKS - MAKE CENTRIC AND DROP TRANSLATIONS
        WRITE(NCAWU,7710)
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,7710)
      ENDIF
7710    FORMAT(//,' Symmetry of the Patterson space group being used')
        IC = 1
        STORE(L2C) = 1.
        M2 = L2
        DO 7700 I = 1, N2
        CALL XZEROF (STORE(M2+9), 3)
        M2 = M2 + MD2
7700    CONTINUE
      ELSE IF (ISYMOD .EQ. 1) THEN
C----- NO SYMMETRY OPTION. MAKE NONCENTRO WITHOUT OPERATORS
        WRITE(NCAWU,7720)
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,7720)
      ENDIF
7720    FORMAT(//,' No symmetry operators will be used')
        IC = 0
        STORE(L2C) = 0.
C-----  NO CENTRINGS
        STORE(L2C+1) = 1.
        IL = 1
        N2P = IL
C-----  IDENTITY OPERATOR ONLY
        N2 = 1
      ENDIF
C
      RETURN
      END
CODE FOR XFAL31
      SUBROUTINE XFAL31(IADDD,IADDA)
C--LOAD LIST 31 INTO STORE AND SET UP THE CONSTANTS TO ALLOW FOR CELL
C  PARAMETER ERRORS
C
C  IADDD  ADDRESS OF THE AREA ASSIGNED TO THE DISTANCE V/VC MATRIX
C         (AN AREA OF 144 WORDS)
C  IADDA  ADDRESS OF THE AREA ASSIGNED TO THE ANGLES V/CV MATRIX.
C         (225 WORDS LONG)
C
C
C--LIST 1 MUST ALREADY HAVE BEEN LOADED
C
C--THE TERMS ARE STORED AT 'L31T', AND OCCUPY 12 LOCATIONS
C
C--
C
      DIMENSION ICOM31(12)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
C
      COMMON/XLST31/ L31K,M31K,MD31K,N31K, L31,M31,MD31,N31,
     1               L31T,M31T,MD31T,N31T
C
C
      EQUIVALENCE (L31K,ICOM31(1))
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--LOAD LIST 31 FROM DISC
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 31
      IDIM31=12
      CALL XLDLST(31,ICOM31,IDIM31,0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C----- SCALE DOWN THE ELEMENTS OF THE V/CV MATRIX
      A = STORE(L31K)
      M31 = L31
      M31L = M31 + MD31 -1
      DO 900 I = M31, M31L
        STORE(I)  =  STORE(I) * A
900   CONTINUE
C--FORM THE WORK AREA
      M31T=L31T
      L=L1M1
      N=L1P1
C--SET UP THE TERMS FOR THE CELL LENGTHS
      DO 1050 I=1,3
      A=1./STORE(N)
      DO 1000 J=1,3
      STORE(M31T)=STORE(L)*A
      M31T=M31T+1
      L=L+1
1000  CONTINUE
      N=N+1
1050  CONTINUE
C--SET UP THE TERMS FOR THE ANGLES
      STORE(M31T)=-STORE(L1P1+1)*STORE(L1P1+2)*SIN(STORE(L1P1+3))
      STORE(M31T+1)=-STORE(L1P1)*STORE(L1P1+2)*SIN(STORE(L1P1+4))
      STORE(M31T+2)=-STORE(L1P1)*STORE(L1P1+1)*SIN(STORE(L1P1+5))
C--SET UP THE V/VC MATRIX IN THE DISTANCE AND ANGLES AREAS
      M31=L31
      I=IADDD
      M=IADDA
      DO 1150 I1=1,6
      J=I
      N=M
      DO 1100 I2=I1,6
      STORE(I)=STORE(M31)
      STORE(J)=STORE(M31)
      STORE(M)=STORE(M31)
      STORE(N)=STORE(M31)
      I=I+1
      J=J+12
      M31=M31+1
      M=M+1
      N=N+15
1100  CONTINUE
      I=I+6+I1
      M=M+9+I1
1150  CONTINUE
9900  CONTINUE
C -- NORMAL AND ERROR RETURN
      RETURN
      END
C
CODE FOR XAPP31
      SUBROUTINE XAPP31(IADD)
C--CALCULATE THE TERMS NEEDED FOR THE CELL ERRORS FOR THE
C  CURRENT PAIR OF ATOMS
C
C--'IADD' IS THE ADDRESS AT WHICH TO PUT THE RESULTS
C
C--'DX', 'DY' AND 'DZ' ARE STORED IN C, D AND E, WHILE F CONTAINS
C  THE RECIPROCAL OF THE DISTANCE
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON /XDISTW/A,BB,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y
C
      COMMON/XLST31/ L31K,M31K,MD31K,N31K, L31,M31,MD31,N31,
     1               L31T,M31T,MD31T,N31T
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--COMPUTE A FEW INITIAL CONSTANTS
      YZ=D*E
      XZ=C*E
      XY=C*D
C--CALCULATE THE DIFFERENTIALS FOR THE CELL LENGTHS
      STORE(IADD)=F*(C*C*STORE(L31T)+XY*STORE(L31T+1)+XZ*STORE(L31T+2))
      STORE(IADD+1)=F*(XY*STORE(L31T+3)+D*D*STORE(L31T+4)
     2 +YZ*STORE(L31T+5))
      STORE(IADD+2)=F*(XZ*STORE(L31T+6)+YZ*STORE(L31T+7)
     2 +E*E*STORE(L31T+8))
C--CALCULATE THE DIFFERENTIALS FOR THE ANGLES
      STORE(IADD+3)=F*YZ*STORE(L31T+9)
      STORE(IADD+4)=F*XZ*STORE(L31T+10)
      STORE(IADD+5)=F*XY*STORE(L31T+11)
      RETURN
      END
C
CODE FOR XFPCES
      SUBROUTINE XFPCES( IADD12, ISTACK, NW, NPART)
C--FORM THE POSITIONAL COORDINATE ERROR STACK
C
C--ENTRY PARAMETERS ARE :
C
C  IADD12  ADDRESS OF THE PREAMBLE BLOCK FOR THIS ATOM IN LIST 12
C  ISTACK  ADDRESS AT WHICH TO PUT THE RESULTS FOR THIS ATOM
C          (THIS IS UPDATED BY THIS SUBROUTINE)
C  NW      NUMBER OF WORDS PER STACK ENTRY
C  NPART   SET BY THIS ROUTINE TO THE NUMBER OF 'LS PARTS' FOR THE ATOM
C
C--THIS STACK IS USED BY 'XCOVAR' TO FORM THE CORRECT V/VC MATRIX
C
C--THE FORMAT OF THE STACK IS :
C
C  0  PARAMETER NUMBER
C  1  ADDRESS OF THE DATA FOR THE BLOCK CONTAINING THIS PARAMETER
C  2  ADDRESS OF THE DIAGONAL ELEMENT IN LIST 11 FOR THIS PARAMETER
C  3  MULTIPLIER FOR THIS PARAMETER
C
C--IF THE COORDINATE HAS NOT BE REFINED, THE FORMAT IS :
C
C  0  -1
C  1  NOT DEFINED
C  2  DIAGONAL ELEMENT TO BE USED
C  3  MULTIPLIER FOR THIS PARAMETER
C
C----- THE STACK IS REPEATED NPART TIMES
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      NPART = 0
C----- GET THE FIRST PART HEADER
      J = KFPH (IADD12)
C
900   CONTINUE
C----- WE MUST ALWAYS TRY FOR A FIRST PART
C--LOOP OVER COORDINATES
      DO 1200 I=4,6
C----- FIND THE PARAMETER POSITION
      ISTORE(ISTACK) = KFPP (I, J, K)
C--IS THIS PARAMETER REFINED
      IF(ISTORE(ISTACK))1000,1000,1050
C--COORDINATE NOT REFINED
1000  CONTINUE
      STORE(ISTACK+2)=0.
      STORE(ISTACK+3)=0.
      GOTO 1150
C--SET UP THE REMAINING INFORMATION
1050  CONTINUE
      ISTORE(ISTACK+2)=KBLCK(ISTORE(ISTACK))
      ISTORE(ISTACK+1)=M12B
      STORE(ISTACK+3)=1.
C--CHECK IF THE 'WEIGHT' CAN DIFFER FROM UNITY
      IF(ISTORE(J+1)-1)1150,1150,1100
C--'WEIGHT' CAN DIFFER FROM UNITY
1100  CONTINUE
      STORE(ISTACK+3)=STORE(K+1)
1150  CONTINUE
      ISTACK=ISTACK+NW
1200  CONTINUE
      NPART = NPART+1
C----- ANY MORE PARTS TO PROCESS ?
      IF (J) 1350, 1350, 1250
1250  CONTINUE
      IF (ISTORE(J)) 1350, 1350, 1300
1300  CONTINUE
C----- MORE PARTS TO BE SET UP
      J = ISTORE (J)
      GOTO 900
1350  CONTINUE
C
      RETURN
      END
C
CODE FOR XMVCD
      SUBROUTINE XMVCD(IADD1,NW1,IADD2,NW2)
C--MOVE VARIANCE - COVARIANCE DATA
C
C  IADD1  ADDRESS OF THE INFORMATION TO MOVE
C  NW1    LENGTH OF EACH ROW AS STORED AT IADD1
C  IADD2  ADDRESS AT WHICH TO PUT THE INFORMATION
C  NW2    LENGTH OF A ROW AT IADD2
C
C--NW1 IS ASSUMED TO BE LESS THAN OR EQUAL TO NW2
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      I=IADD1
      J=IADD2
      DO 1050 K=1,NW1
      L=I
      M=J
      DO 1000 N=1,NW1
      STORE(M)=STORE(L)
      L=L+1
      M=M+1
1000  CONTINUE
      I=I+NW1
      J=J+NW2
1050  CONTINUE
      RETURN
      END
C
CODE FOR XMVCSP
      SUBROUTINE XMVCSP(IADD1,IADD2,NW2)
C--SET UP THE SYMMETRY INFORMATION IN THE V/VC AREA
C
C  IADD1  ADDRESS OF THE ATOM HEADER FROM WHICH THE SYMMETRY INFORMATION
C         SHOULD BE EXTRACTED.
C  IADD2  ADDRESS AT WHICH TO PUT THE INFORMATION
C  NW2    LENGTH OF A ROW AT IADD2
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      NW1=3
      I=(IABS(ISTORE(IADD1+2))-1)*MD2+L2
      A=1.
      IF(ISTORE(IADD1+2))1000,1050,1050
1000  CONTINUE
      A=-1.
1050  CONTINUE
      J=IADD2
      DO 1150 K=1,NW1
      L=I
      M=J
      DO 1100 N=1,NW1
      STORE(M)=STORE(L)*A
      L=L+1
      M=M+1
1100  CONTINUE
      I=I+NW1
      J=J+NW2
1150  CONTINUE
      RETURN
      END
C
CODE FOR XCOVAR
      SUBROUTINE XCOVAR ( LS, NS, NW, LF, JA, IPART, NATOM)
C
C----- CALCULATE AN ATOMIC PARAMETER VARIANCE COVARIANCE MATRIX
C      FROM THE GIVEN LS PARAMETER V/COV MATRIX
C
C
C  LS  ADDRESS OF THE FIRST WORD OF THE STACK
C  NS  NUMBER OF ENTRIES IN THE STACK
C  NW  NUMBER OF WORDS PER ENTRY IN THE STACK
C  LF  ADDRESS AT WHICH TO SET UP THE V/CV MATRIX
C  JA  ADDRESS AT WHICH TO SET UP THE 'MULTIPLIERS' OR 'WEIGHTS'
C      AS A DIAGONAL MATRIX
C  IPART(NATOM) HOLDS THE NUMBER OF 'PARTS' FOR EACH ATOM
C
C--FORMAT OF THE STACK :
C
C  0  LEAST SQUARES PARAMETER NUMBER
C  1  ADDRESS OF THE BLOCK INFORMATION FOR THIS PARAMETER
C  2  ADDRESS OF THE DIAGONAL ELEMENT FOR THIS PARAMETER
C  3  COEFFICIENT FOR THIS PARAMETER
C
C--IF THE PARAMETER NUMBER IS NEGATIVE, THE FORMAT IS :
C
C  0  -1
C  1  NOT DEFINED
C  2  DIAGONAL ELEMENT TO USE
C  3  COEFFICIENT TO USE
C
C--THIS PATTERN IS REPEATED 'NS' TIMES STARTING FROM 'LS' EVERY 'NW' WOR
C
C--
      DIMENSION IPART(NATOM)
      DIMENSION ISTORE(131072)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      DATA NPAR/3/
C
C----- CHECK IF ALL ATOMS HAVE ONLY ONE PART, GET NO. OF LS PARAMETERS
      NLS = 0
      MPART = 0
      DO 900 I = 1,NATOM
      NLS = NLS + NPAR * IPART(I)
      MPART = MAX( MPART, IPART(I) )
900   CONTINUE
      IF (MPART .EQ. 1) GOTO 950
C
C
C----- CONVERT THE VCV MATRIX FOR THE LS PARAMETERS INTO ONE FOR
C      THE PHYSICAL PARAMETERS.
C
C----- RESERVE SOME SPACE FOR THE LS VCV MATRIX
      NSS = NLS * NLS
      IVCV = KSTALL(NSS)
C----- RESERVE SOME SPACE FOR THE PARTIAL PRODUCT
      NPHYS = 3 * NATOM
      NPP = NLS * NPHYS
      IPP = KSTALL(NPP)
C----- RESERVE A PARTS PER PARAMETER VECTOR
      IPPV = KSTALL(NPHYS)
C----- RESERVE SPACE FOR THE DIAGONAL 'WEIGHTS' MATRIX
      IWTS = KSTALL(NSS)
C----- DID WE HAVE ENOUGH ROOM?
      IF (IERFLG .LE. 0) GOTO 9000
C
C----- FETCH THE LS VCV MATRIX
      CALL XGVCV (LS, NLS, NW, IVCV, IWTS)
C----- COMPRES THE 'WEIGHTS' MATRIX TO A VECTOR IN COLUMN 1
      J = IWTS
      K = IWTS
      DO 1300 I = 1,NLS
      STORE(J) = STORE(K)
      J = J + 1
      K = K + 1 + NLS
1300  CONTINUE
C
C----- SET UP THE PARTS-PER-PARAMETER VECTOR
      K = IPPV
      DO 1400 I = 1, NATOM
      ISTORE(K)   = IPART(I)
      ISTORE(K+1) = IPART(I)
      ISTORE(K+2) = IPART(I)
      K = K + 3
1400  CONTINUE
C
C----- FORM THE FIRST PARTIAL PRODUCT
      CALL XFVCV (NLS, NLS, NPHYS, STORE(IVCV), STORE(IWTS), STORE(IPP),
     1 ISTORE(IPPV), 1, 3 )
C
C----- FORM THE FINAL PRODUCT
      CALL XFVCV (NLS, NPHYS, NPHYS, STORE(IPP), STORE(IWTS), STORE(LF),
     1 ISTORE(IPPV), 2, 3 )
C
C----- GENERATE THE MODIFIED 'WEIGHT' MATRIX
      CALL XFWM ( NLS, NPHYS, STORE(IWTS), STORE(JA), ISTORE(IPPV), 3)
C
C----- RESTORE THE WORK AREA
      CALL XSTRLL (IVCV)
      GOTO 9900
C
950   CONTINUE
C----- ONE TO ONE CORRESPONDANCE BETWEEN PHYSICAL AND LS PARAMETERS
      CALL XGVCV ( LS, NS, NW, LF, JA)
      GOTO 9900
C
9000  CONTINUE
      WRITE(NCAWU,9100)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,9100)
      ENDIF
9100  FORMAT(/,' Error allocating space for e.s.d. calculation'/)
9900  CONTINUE
      RETURN
      END
C
C
CODE FOR XFVCV
      SUBROUTINE XFVCV (IDM1, IDM2, IDM3, V, A, U, NPARTS, IPOINT, NPAR)
C
C----- MATRIX MULTIPLIER FOR GENERATION OF V/CV MATRIX FOR DERIVED PARAM
C
C---- CALLED TWICE.
C      IPOINT =  1 FOR FIRST CALL
C      ON BOTH CALLS,
C      IDM1 = NO OF LS PARAM
C      IDM3 = NO OF PHYSICAL PARAMS
C      NPAR = NUMBER OF PARAMETERS PER ATOM
C------ON FIRST CALL,
C      V IS LS V/CV MATRIX,
C      A IS 'WEIGHT' VECTOR, REPRESENTING TRANSPOSE OF DIAGONAL 'WEIGHT'
C      U IS THE PARTIAL PRODUCT MATRIX
C      NPARTS IS VECTOR OF LS PATRTS PER PHYSICAL PARAMETER
C      IDM2 = NO OF LS PARAMS
C
C------ON SECOND CALL
C      V IS PARTIAL PRODUCT MATRIX
C      A IS 'WEIGHT' VECTOR, REPRESENTING TRANSPOSE OF DIAGONAL 'WEIGHT'
C      U IS PHYSICAL V/CV MATRIX
C      IDM2 = NO OF PHYSICAL PARAMS
C
      DIMENSION V(IDM1,IDM2), A(IDM1), U(IDM2,IDM3), NPARTS(IDM3)
C
C      U(I,J) = SUM [ A(L)*V(L,I)], L = WEIGHT ELEMENTS FOR PARAMETER J
C
      LBASE = 0
      DO 1300 I = 1, IDM2
      IF (IPOINT .EQ. 1)    LBASE = 0
      INDEXF = I
      ISUB  = I
C
            DO 1200 J = 1,IDM3
            IF (IPOINT .EQ. 1) THEN
                  INDEXF = J
            ELSE
                  ISUB = J
            ENDIF
            LOFF = MOD (INDEXF-1, NPAR) + LBASE + 1
            SUM = 0.0
C
                  DO 1100 K = 1, NPARTS(INDEXF)
                  L = NPAR * (K-1)  + LOFF
                  SUM = SUM + V(L,ISUB) * A(L)
1100              CONTINUE
C
            U(I,J) = SUM
            IF (IPOINT .EQ. 1) THEN
             IF (MOD(INDEXF,NPAR).EQ.0) LBASE=LBASE+NPAR*NPARTS(INDEXF)
            ENDIF
1200        CONTINUE
C
      IF (IPOINT .NE. 1)  THEN
            IF (MOD(INDEXF,NPAR).EQ.0) LBASE=LBASE+NPAR*NPARTS(INDEXF)
      ENDIF
1300  CONTINUE
      RETURN
      END
C
CODE FOR XFWM
      SUBROUTINE XFWM (IDM1, IDM2, A, B, NPARTS, NPAR)
C
C----- GENERATE MODIFIED WEIGHT MATRIX FOR V-CV MATRIX
C
C      IDM1 = NO OF LS PARAM
C      IDM2 = NO OF PHYSICAL PARAMS
C      NPAR = NUMBER OF PARAMETERS PER ATOM
C      A IS 'WEIGHT' VECTOR, REPRESENTING DIAGONAL 'WEIGHT' MATRIX
C      B IS THE NEW 'WEIGHT' MATRIX FOR PHYSICAL PARAMS
C      NPARTS IS VECTOR OF LS PATRTS PER PHYSICAL PARAMETER
C
C
      DIMENSION A(IDM1), B(IDM2,IDM2), NPARTS(IDM2)
C
C      B(I,I) = SUM [ A(L)**2], L = WEIGHT ELEMENTS FOR PARAMETER I
C
C----- ZERO THE WEIGHT MATRIX
      NS = IDM2*IDM2
      CALL XZEROF (B(1,1),NS)
C
C
      LBASE = 0
      DO 1200 I = 1, IDM2
      INDEXF = I
C
      LOFF = MOD (INDEXF-1, NPAR) + LBASE + 1
      SUM = 0.0
C
             DO 1100 K = 1, NPARTS(INDEXF)
             L = NPAR * (K-1)  + LOFF
             SUM = SUM + A(L) * A(L)
1100         CONTINUE
C
      B(I,I) = SUM
      IF (MOD(INDEXF,NPAR).EQ.0) LBASE = LBASE + NPAR * NPARTS(INDEXF)

1200  CONTINUE
      RETURN
      END
C
C
CODE FOR XGVCV
      SUBROUTINE XGVCV ( LS, NS, NW, LF, JA)
C
C----- GET THE V/COV MATRIX FOR THE GIVEN LS PARAMETERS
C
C  LS  ADDRESS OF THE FIRST WORD OF THE STACK
C  NS  NUMBER OF ENTRIES IN THE STACK
C  NW  NUMBER OF WORDS PER ENTRY IN THE STACK
C  LF  ADDRESS AT WHICH TO SET UP THE V/CV MATRIX
C  JA  ADDRESS AT WHICH TO SET UP THE 'MULTIPLIERS' OR 'WEIGHTS'
C      AS A DIAGONAL MATRIX
C
C--FORMAT OF THE STACK :
C
C  0  LEAST SQUARES PARAMETER NUMBER
C  1  ADDRESS OF THE BLOCK INFORMATION FOR THIS PARAMETER
C  2  ADDRESS OF THE DIAGONAL ELEMENT FOR THIS PARAMETER
C  3  COEFFICIENT FOR THIS PARAMETER
C
C--IF THE PARAMETER NUMBER IS NEGATIVE, THE FORMAT IS :
C
C  0  -1
C  1  NOT DEFINED
C  2  DIAGONAL ELEMENT TO USE
C  3  COEFFICIENT TO USE
C
C--THIS PATTERN IS REPEATED 'NS' TIMES STARTING FROM 'LS' EVERY 'NW' WOR
C
C--
C----- NOTE THAT IF STR11 IS USED DOUBLE PRECISION, LENGRP IN
C      LIST11 IN COMMAND FILE MUST BE CHANGED FROM 1 TO 2
C      FOR LHS AND RHS
C      AND I11LEN IN XPRC12
C      DOUBLE PRECISION STR11(1048576)
      DIMENSION STR11(1048576)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDATF/NFLD,LFLD,NULD
C      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDATD/XSTR11(1048576)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (STR11(1),XSTR11(1))
C
      N=LS
      IA=LF
      L=NS*NS
      JB=LF+L-1
      IC=JA
      IB=JA
      DO 1000 I=LF,JB
      STORE(I)=0.
      STORE(IC)=0.
      IC=IC+1
1000  CONTINUE
C--FORM THE VARIANCE-COVARIANCE MATRIX
      DO 1600 I=1,NS
C--CHECK THAT THIS PARAMETER HAS BEEN REFINED
      IF(ISTORE(N))1050,1050,1100
C--NOT REFINED
1050  CONTINUE
      STORE(IA)=STORE(N+2)
      STORE(IB)=STORE(N+3)
      IA=IA+NS+1
      GOTO 1550
1100  CONTINUE
      K=ISTORE(N+2)
C--STORE THE DIAGONAL ELEMENTS
      STORE(IA)=STR11(K)
      STORE(IB)=STORE(N+3)
C--CHECK IF THIS IS THE LAST PARAMETER
      IF(I-NS)1150,1650,1650
1150  CONTINUE
      IC=IA+NS
      IA=IA+1
      ID=I+1
      M=N+NW
C--SET UP THE OFF-DIAGONAL TERMS
      DO 1500 J=ID,NS
C--CHECK THAT THE PARAMETER THAT WE HAVE MET IS TO BE REFINED
      IF(ISTORE(M))1450,1450,1200
C--CHECK IF THE TWO PARAMETERS ARE IN THE SAME BLOCK
1200  CONTINUE
      IF(ISTORE(N+1)-ISTORE(M+1))1450,1250,1450
C--COMPUTE THE ADDRESS OF THE OFF-DIAGONAL TERM IN THE L.S. MATRIX
1250  CONTINUE
      K=ISTORE(N)-ISTORE(M)
      IF(K)1300,1300,1350
1300  CONTINUE
      K=ISTORE(N+2)-K
      GOTO 1400
1350  CONTINUE
      K=ISTORE(M+2)+K
1400  CONTINUE
      STORE(IA)=STR11(K)
      STORE(IC)=STR11(K)
1450  CONTINUE
      M=M+NW
      IA=IA+1
      IC=IC+NS
1500  CONTINUE
      IA=IA+I
1550  CONTINUE
      IB=IB+NS+1
      N=N+NW
1600  CONTINUE
1650  CONTINUE
      RETURN
      END
C
CODE FOR XMD3B
      SUBROUTINE XMD3B(IADD1,IADD2,IADD3,N,N3)
C--MULTIPLY A DIAGONAL MATRIX ONTO A 3 BLOCK BAND MATRIX
C
C  IADD1  ADDRESS OF THE DIAGONAL MATRIX
C  IADD2  ADDRESS OF THE BAND MATRIX
C  IADD3  ADDRESS OF THE PRODUCT  -  ZEROS ARE NOT SET.
C  N      ORDER OF THE MATRICES DIVIDED BY 3
C  N3 (I.E. THE ORDER OF THE MATRICES)     =N*3
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      K=IADD3
      L=IADD2
      M=IADD1
      DO 1050 I=1,N
      DO 1000 J=1,3
      A=STORE(M)
      STORE(K)=STORE(L)*A
      STORE(K+1)=STORE(L+1)*A
      STORE(K+2)=STORE(L+2)*A
      K=K+N3
      L=L+N3
      M=M+N3+1
1000  CONTINUE
      K=K+3
      L=L+3
1050  CONTINUE
      RETURN
      END
C
CODE FOR XPRTA
      SUBROUTINE XPRTA(A,L,M)
C
C
      DIMENSION A(L,M)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      CALL XLINES
      DO 1050 I=1,L
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)(A(I,J),J=1,M)
      ENDIF
1000  FORMAT(1H ,9F13.9)
1050  CONTINUE
      RETURN
      END


CRYSTALS CODE FOR FOURIER
CODE FOR XFOURB
      SUBROUTINE XFOURB
C--MAIN FOURIER ROUTINE
C
C  NTYP    TYPE OF FOURIER
C
C          1  /FO/ FOURIER, WITH REJECTION IF /FC/<0.001
C          2  /FC/ FOURIER, WITH REJECTION IF /FC/<0.001
C          3  DF FOURIER, WITH REJECTION IF /FC/<0.001
C           4  2FO-FC FOURIER
C           5  'OPTIMAL' (WEIGHTED) FOURIER
C           6  FO PATTERSON
C           7  FC PATTERSON
C           8  'E' MAP WITH DATA FROM TAPE
C
C  NE      NUMBER OF THE E-MAP TO COMPUTE.
C  NWT     WEIGHTING PARAMETER :
C
C          -1  SIM WEIGHTED.
C           0  NO WEIGHTS.
C           1  WEIGHTS TAKEN FROM LIST 6.
C
C  IPRINT  PRINT CONTROL FLAG :
C
C          -1  NO PRINTING OF THE MAP
C           0  PRINT THE MAP.
C
C  THRES1  VALUES ON THE MAP BELOW THIS ARE PRINTED AS BLANKS.
C  THRES2  VALUES ABOVE THIS ON THE MAP ARE PRINTED AS BLANKS.
C  IALL    REFLECTIONS REJECTION FLAG :
C
C           0  DO NOT USE AN /FC/ REJECTION TEST.
C       1 - 3  USE A REJECTION TEST FOR /FC/'S
C
C  NLINE   NUMBER OF LINES PER GRID POINT ON THE MAP
C  NCHAR   NUMBER OF CHARACTERS PER NUMBER ON THE MAP.
C  NCHARC  NUMBER OF CHARACTERS PER LINE NUMBER ON THE MAP.
C  NSPACE  NUMBER OF SPACES AT THE EDGE OF THE MAP.
C  ISCAN   PEAK SEARCH CONTROL FLAG :
C
C          -1  NO PEAK SCAN.
C           0  PEAK SCAN, USING DEFAULT VALUE FOR 'HEIGHT*SCALE FACTOR'.
C           1  PEAK SCAN, USING THE ACTUAL VALUE OF 'HEIGHT'.
C
C  HEIGHT  THE MINIMUM PEAK HEIGHT FLAG, MULTIPLIED BY THE SCALE
C          FACTOR IF 'SCAN' IS ZERO.
C  NPEAK   THE NUMBER OF PEAKS ALLOWED.
C  INTAPE  A MAP CAN BE READ FROM TAPE IS THIS PARAMETER IS NON-ZERO.
C  IOUTAP  THE MAP SHOULD BE OUTPUT TO TAPE IS THIS PARAMETER IS NON-ZER
C  F000    THE VALUE OF F(000) TO BE USED.
C  ISC     TYPE OF SCALING REQUIRED :
C
C          -1  TAKE SCALE FACTOR FROM LIST 14.
C           0  TAKE SCALE FACTOR FROM LIST 14, EXCEPT FOR E-MAPS AND PAT
C           1  COMPUTE A SCALE FACTOR FOR ALL TYPES.
C
C  SCLCON  VALUE TO WHICH THE ORIGIN IS TO BE SCALED.
C  REJECT  REJECTION DISTANCE FOR PEAKS DURING THE PEAK SEARCH.
C          IF A NEW PEAK HAS A GREATER PEAK HEIGHT THAN ANY OTHERS
C          WITHIN 'REJECT' ANGSTROM OF IT, THE OTHER PEAKS ARE DELETED
C          AND THE NEW ONE RETAINED. ON THE OTHER HAND, IF THE HEIGHT OF
C          THE NEW PEAK IS LESS THAN 'REJECT' ANGSTROM, THE NEW PEAK IS
C          OMITTED.
C  NGMAP   -1 NEGATES 'F' BEFORE COMPUTATION OF MAP, FOR FINDING 'HOLES'
C             PEAK HEIGHTS RESTORED LATER.
C           0 FOR A NORMAL MAP, RESET AT STARTUP TO +1
C
C  IFCALC  -1 DONOT COMPUTE STRUCTURE FACTORS
C           0 DO   COMPUTE STRUCTURE FACTORS
C
C--USE OF THE VARIABLES IN THE COMMON BLOCK 'XWORKA' :
C
C  JA  MINIMUM X
C  JB  MINIMUM Y
C  JC  MINIMUM Z
C
C--THE THREE ABOVE ARE EQUIVALENCED TO 'MINW'
C
C  JD  NUMBER OF DIVISIONS IN THE UNIT CELL ALONG THE X DIRECTION
C  JE  NUMBER OF DIVISIONS IN THE UNIT CELL ALONG THE Y DIRECTION
C  JF  NUMBER OF DIVISIONS IN THE UNIT CELL ALONG THE Z DIRECTION
C
C--THE THREE ABOVE ARE EQUIVALENCED TO 'NUN'
C
C  JG  NUMBER OF DIVISIONS TO COMPUTE ALONG THE X DIRECTION
C  JH  NUMBER OF DIVISIONS TO COMPUTE ALONG THE Y DIRECTION
C  JI  NUMBER OF DIVISIONS TO COMPUTE ALONG THE Z DIRECTION
C
C--THE THREE ABOVE ARE EQUIVALENCED TO 'NUM'
C
C  JJ  ADDRESS OF THE COSINE TABLE FOR X
C  JK  ADDRESS OF THE COSINE TABLE FOR Y
C  JL  ADDRESS OF THE COSINE TABLE FOR Z
C
C--THE THREE ABOVE ARE EQUIVALENCED TO 'IAC'
C
C  JM  ADDRESS OF THE SINE TABLE FOR X RELATIVE TO COSINE TABLE
C  JN  ADDRESS OF THE SINE TABLE FOR Y RELATIVE TO COSINE TABLE
C  JO  ADDRESS OF THE SINE TABLE FOR Z RELATIVE TO COSINE TABLE
C
C--THE THREE ABOVE ARE EQUIVALENCED TO 'IAS'
C
C  JP  MAXIMUM COSINE ADDRESS FOR X
C  JQ  MAXIMUM COSINE ADDRESS FOR Y
C  JR  MAXIMUM COSINE ADDRESS FOR Z
C
C--THE THREE ABOVE ARE EQUIVALENCED TO 'MXC'
C
C  JS  ADDRESS OF THE LOOK UP TABLE FOR 'H'
C  JT  START OF THE 'HK' PAIRS STACK  -  HELD IN 'FSTORE'.
C  JU  ADDRESS OF THE LAST ENTRY IN THE 'HK' STACK
C  JV  NUMBER OF WORDS PER 'HK' ENTRY IN THE STACK
C  JW  NUMBER OF HEADER WORDS PER 'HK' ENTRY, AS FOLLOWS :
C      0  H VALUE FOR THIS PAIR
C      1  K VALUE FOR THIS PAIR
C  JX  NUMBER OF Y POSITIONS TO BE CALCULATED AT A TIME
C  JY  NUMBER OF 'HK' PAIRS FOUND
C  JZ  (NUMBER OF Z LAYERS PER HK ENTRY)*2
C
C  KB  INCREMENT UP Z SIN/COS TABLE FOR THE CURRENT SCAN.
C  KC  NUMBER OF POINTS ALONG Y MINUS JX.
C
C  KF  INCREMENT ALONG THE FOR X DIRECTION.
C  KG  INCREMENT ALONG THE FOR Y DIRECTION.
C  KH  INCREMENT ALONG THE FOR Z DIRECTION.
C
C--THE VARIABLES ABOVE ARE EQUIVALENCED TO 'ISTEP'.
C
C  KI  CURRENT SECTION POINTER IN THE 'KH' PAIR STACKS
C  KJ  NUMBER OF SECTIONS COMPUTED.
C  KK
C  KL
C  KM
C  KN  NUMBER OF WORDS IN PARTIAL TOTAL AREA
C  KO  INCREMENT ALONG THE PARTIAL SUM TABLE FOR Y FOR 'JX' TERMS.
C  KP  NOT USED
C  KQ
C  KR  ADDRESS OF THE EQUIVALENT INDICES TABLE
C  KS  USED IN EQUIVALENT INDICES PROCESSING.
C  KT  USED IN EQUIVALENT INDICES PROCESSING.
C  KU  NUMBER OF WORDS PER EQUIVALENT INDEX ENTRY.
C  KV  ADDRESS OF THE PARTIAL SUM FOR Y.
C  KW  WORK VARIABLE FOR KV.
C
C  KX  MAXIMUM ALONG THE X DIRECTION.
C  KY  MAXIMUM ALONG THE Y DIRECTION
C  KZ  MAXIMUM ALONG THE Z DIRECTION.
C
C--THE ABOVE THREE VARIABLES ARE EQUIVALENCED TO 'MAXW'
C
C--FORMAT OF THE ENTRY FOR EACH H VALUE IN THE INITIAL SEARCH :
C
C   0  LINK TO THE NEXT H VALUE
C  -1  H VALUE
C  -2  ADDRESS OF THE FIRST K FOR THIS H
C  -3  MAXIMUM VALUE OF K FOUND FOR THIS H
C  -4  MINIMUM VALUE OF K FOUND FOR THIS H
C
C--FORMAT OF THE ENTRY FOR EACH K VALUE IN THE INITIAL SEARCH :
C
C   0  LINK TO THE NEXT K VALUE
C  -1  THIS K VALUE
C
C--DURING THE INITIAL SEARCH, THE TWO STACKS ABOVE ARE FORMED FROM
C  THE TOP DOWN.
C
C--AFTER THE INITIAL SEARCH, THE 'HK' PAIRS ARE ORGANIZED AS :
C
C  FOR EACH H VALUE, IN THE H LOOK UP TABLE, THE ADDRESS OF THE
C  ASSOCIATED K LOOK UP TABLE.
C
C  FOR EACH K VALUE, IN THE K LOOK UP TABLE, THE ADDRESS OF THE
C  THE INFORMATION FOR THIS 'HK' PAIR .
C
C--THE VARIABLES IN THE COMMON BLOCK 'XWORK' ARE USED AS FOLLOWS :
C
C  IAXIS   THE ORIENTATION PARAMETERS.
C  IXYZ    SORTED AXIS NAMES  -  I.E. SORTED 'X', 'Y' AND 'Z'.
C  NV      THE NUMBER OF SCANS COMPLETED.
C  SCALE   THE SCALE FACTOR FROM LIST 5.
C  SS      MAP SCALE FACTOR ON THE SCALE OF ELECTRONS
C  SC      THE MAP SCALE FACTOR USED.
C  VOL     THE VOLUME, TAKEN FROM LIST 1.
C  NORFL   THE NUMBER OF REFLECTIONS USED ON THE PRESENT SCAN.
C  L6DUMP  A DUMP OF THE READ POINTER FOR LIST 6  -  'L6R'.
C  N6DUMP  A DUMP OF THE NUMBER OF REFLECTIONS TO BE READ  -  'N6R'.
C  SSV     SUM OF THE FORM FACTORS SQUARED TIMES THE NUMBER OF
C          ATOMS IN THE ASYMMETRIC UNIT FOR EACH ATOM TYPE IN LIST 29.
C          THIS IS USED FOR SIM WEIGHTING, AND LIST 29 IS CORRECTED
C          BY REMOVING ATOMS THAT ARE IN LIST 5 BEFORE THIS TOTAL IS
C          COMPUTED.
C  SSU     RATIO OF SUM(W FO) / SUM(FO)
C  DENMIN  MINIMUM ELECTRON DENSITY
C  IPMAP   INDEX OF FIRST PATTERSON MAP IN NTYP
C  IEMAP   INDEX OF E - MAP IN NTYP. ALSO LAST MAP TYPE
C  HWMIN   THE DETAILS OF THE MAX. AND MIN. SIM WEIGHTS ARE HELD IN
C          THIS ARRAY.
C  AAA     THE MEAN DENSITY AT ORIGINAL ATOMIC SITE.
C  BBB     THE NUMBER OF ORIGINAL ATOMIC SITES FOUND.
C  CCC     SUM THE SQUARED DEVIATIONS AT THE ORIGINAL ATOMIC SITES.
C  DDD     THE ROOT MEAN SQUARE DEVIATION FROM THE MEAN AT THE ORIGINAL
C          ATOMIC SITES.
C  L81     ADDRESS OF THE CURRENT MAP SECTION. THE MAP IS HELD
C          IN 'FSTORE' AND 'L8' POINTS TO THE START OF THIS AREA.
C  L82     ADDRESS OF THE LAST SECTION CALCULATED.
C  L83     ADDRESS OF THE LAST BUT ONE SECTION COMPUTED.
C  N10MAX  THE MAXIMUM OF PEAKS THAT CAN COLLECTED DURING THIS FOURIER.
C          THIS IS A FUNCTION OF 'NPEAK', BUT NOT EQUAL TO IT TO ALLOW
C          FOR DUPLICATED PEAKS.
C  NY      THE NUMBER OF POINTS ACROSS THE PAGE.
C  NZ      THE NUMBER OF POINTS DOWN THE PAGE.
C  NYNZ    THE PRODUCT OF 'NY' AND 'NZ'.
C  NYM2    THE NUMBER OF POINTS ACROSS THE PAGE, MINUS 2.
C  NY2     TWICE THE NUMBER OF POINTSACROSS THE PAGE
C  NYNZM2  THE PRODUCT OF 'NY' AND 'NZ' MINUS 2.
C
C--
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 30
      PARAMETER (IDIM30 = 32)
      DIMENSION ICOM30(IDIM30)
      DIMENSION FSTORE(131072),JSTORE(131072)
      DIMENSION MINW(3),ISTEP(3),MAXW(3),NUM(3),NUN(3),
     2 IAS(3),IAC(3),MXC(3)
      DIMENSION ISTORE(131072)
C
C
      CHARACTER *8 CDENMN(3)
C
      DIMENSION PROCS(24)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XPROCS/NTYP,NE,NWT,IPRINT,THRES1,THRES2,IALL,NLINE,NCHAR,
     2 NCHARC,NSPACE,ISCAN,HEIGHT,NPEAK,INTAPE,IOUTAP,F000,ISC,SCLCON,
     3 REJECT,APEAKH , NGMAP, IFCALC, IPKMON
      COMMON/XWORKC/IAXIS(3),NV,IXYZ(3),SCALE,SS,SC,VOL,
     2 NORFL,L6DUMP,N6DUMP,SSV,SSU,HWMIN(6,2),AAA,BBB,CCC,DDD,
     3 L81,L82,L83,N10MAX,NY,NZ,NYNZ,NY2,NYM2,NYNZM2, DENMIN,
     4 IPMAP, IEMAP, DENMAX
      COMMON/XWORKD/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,
     3 KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,KL,KM,KN,KO,KP,KQ,
     4 KR,KS,KT,KU,KV,KW,KX,KY,KZ,
     5 MA,MB,MC,MD,ME,MF,MG,MH,MI,MJ,MK,ML,MM,MN,MO,MP,MQ,
     6 MR,MS,MT,MU,MV,MW,MX,MY,MZ
      COMMON/XLST08/L8,M8,MD8,N8
      COMMON/XLST10/L10,M10,MD10,N10,L10A,M10A,MD10A,N10A
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XNWPGE/NWPAGE
      COMMON/XLST14/L14,M14,MD14,N14, L14O,M14O,MD14O,N14O,
     2 L14SC,M14SC,MD14SC,N14SC, L14P,M14P,MD14P,N14P
      COMMON/XLST30/
     1 L30DR,M30DR,MD30DR,N30DR, L30CD,M30CD,MD30CD,N30CD,
     2 L30RF,M30RF,MD30RF,N30RF, L30IX,M30IX,MD30IX,N30IX,
     3 L30AB,M30AB,MD30AB,N30AB, L30GE,M30GE,MD30GE,N30GE,
     4 L30CL,M30CL,MD30CL,N30CL, L30SH,M30SH,MD30SH,N30SH
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (L30DR,ICOM30(1))
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (FSTORE(1),STORE(1)),(ISTORE(1),JSTORE(1))
      EQUIVALENCE (JA,MINW(1)),(JD,NUN(1)),(JG,NUM(1)),(JJ,IAC(1))
      EQUIVALENCE (JM,IAS(1)),(JP,MXC(1)),(KF,ISTEP(1)),(KX,MAXW(1))
C
C
      EQUIVALENCE (PROCS(1), NTYP)
C
C
C
      DATA CDENMN / ' maximum' , '        ', ' minimum'/
C
      DATA IVERSN /835/
      DATA IDIMFB /24/
C
C--READ THE REMAINDER OF THE DATA
      CALL XTIME1(2)
      ISTAT = KRDDPV ( PROCS, IDIMFB)
      IF ( ISTAT .LT. 0 ) GO TO 9910
C----- SET THE START OF THE PATTERSON  MAPS
      IPMAP =6
C----- SET THE EMAP, WHICH IS ALSO LAST TYPE
      IEMAP = 10
C--CHECK THE FOURIER TYPE
      IF(NTYP)1100,1100,1150
1100  NTYP=1
C--CHECK THAT THIS IS AN ALLOWED FOURIER TYPE
1150  CONTINUE
C---- SET MULTIPLIER +VE FOR MORMAL MAP
      IF (NGMAP .GT. -1) THEN
            NGMAP = 1
      ENDIF
      IF (NTYP .GT. IEMAP) GOTO 9920
C--CLEAR THE CORE CONTROL FLAGS
      IF( (IFCALC .EQ. 0) .AND. (NTYP .LT. IPMAP) ) THEN
            IF (KEXIST(33) .LE. 0) THEN
      WRITE(NCAWU, '(//'' This option NOT available unless SFLS ''
     1 ,''have been performed in the past''//)' )
            GOTO 9900
            ENDIF
            CALL XSFLSB(IFCALC)
      ENDIF
      IF (IERFLG .LT. 0) GOTO 9900
      CALL XRSL
      CALL XCSAE
C----- INITIALISE THE MINIMUM DENSITY
      DENMIN =  100000.
      DENMAX =  -100000.
C--LOAD LIST 5 AND SET UP LIST 10
      CALL XFOURI
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--LOAD LISTS 1, 2, 6 AND 14, SORT LIST 5, AND SET UP LIST 10
      CALL XFOURJ
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--PRESERVE THE CORE LIMITS AT THIS POINT
      NFL1=NFL
      LFL1=LFL
C--SET UP THE PRINT ROUTINES
      CALL XFPRT1
C--CHECK FOR A MAP SCAN
      IF(ISCAN)1350,1550,1550
C--NO MAP SCAN  -  CHECK FOR A MAP PRINT
1350  CONTINUE
      IF ( IPRINT .GE. 0 ) GO TO 1550
C--NEITHER OF THE FIRST TWO  -  CHECK FOR A SUPERPOSITION
      IF ( IOUTAP )   9930 , 9930 , 1550
C
C--SEARCH THROUGH THE REFLECTIONS FOR THE 'HK' PAIRS AND SET UP THEIR TA
1550  CONTINUE
      CALL XFOURM
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--START OF THE CALCULATION FOR THE NEXT GROUP OF SECTIONS
1600  CONTINUE
      CALL XFOURN
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--PROCESS THE NEXT SECTION
1650  CONTINUE
      K=JT
C--ZERO THE PARTIAL SUM AREA
      CALL XZEROF(FSTORE(KV),KN)
C--ZERO THE MAP AREA
      J=L81+N8-1
      DO 1700 I=L81,J
      FSTORE(I)=F000
1700  CONTINUE
C--LOOP OVER THE 'HK' PAIRS
      DO 2000 I=JT,JU,JV
C--CHECK IF THIS STILL HAS THE SAME 'H' VALUE
      IF(JSTORE(I)-JSTORE(K))1850,1750,1850
C--FETCH THE ADDRESS OF THE FIRST K COSINE
1750  CONTINUE
      KL=JB*JSTORE(I+1)
      KM=KG*JSTORE(I+1)
      N=I+KI
      A=FSTORE(N)*SC
      B=FSTORE(N+1)*SC
      KW=KV
C--PASS OVER THE Y ROWS
      DO 1800 J=1,JH
C--CHECK IF WE OFF THE END OF THE K COSINE TABLE
      L=MOD(KL,JE)+JK
      M=L+JN
      STORE(KW)=STORE(KW)+A*STORE(L)+B*STORE(M)
      STORE(KW+1)=STORE(KW+1)+B*STORE(L)-A*STORE(M)
      KL=KL+KM
      KW=KW+2
1800  CONTINUE
      GOTO 2000
C--FETCH THE ADDRESS OF THE FIRST COSINE FOR X
1850  CONTINUE
      KL=JA*ISTORE(K)
      KM=KF*ISTORE(K)
      M8=L81
C--PASS ALONG EACH OF THE X ROWS IN TURN
      DO 1950 J=1,JG
      KW=KV
C--CHECK IF WE ARE OFF THE END OF X COSINE TABLE
      KD=MOD(KL,JD)+JJ
      KE=KD+JM
      KB=M8+KC
C--PASS ALONG THE Y ROW
      DO 1900 M=M8,KB,JX
      FSTORE(M)=FSTORE(M)+STORE(KW)*STORE(KD)+STORE(KW+1)*STORE(KE)
      KW=KW+KO
1900  CONTINUE
      KL=KL+KM
      M8=M8+MD8
1950  CONTINUE
      CALL XZEROF(STORE(KV),KN)
      K=I
C--CHECK FOR THE END OF TABLE
      IF(JSTORE(I))2000,1750,1750
2000  CONTINUE
C
C----- CHECK IF WE MUST NEGATE THE MAP
      IF (NGMAP .LE. -1) THEN
        M81 = L81 + NYNZ + 1
        DO 2020 I = L81, M81
            FSTORE(I) = -FSTORE(I)
2020    CONTINUE
      END IF
C--CHECK IF WE SHOULD OUTPUT THIS MAP SECTION TO TAPE
      IF(IOUTAP)2100,2100,2050
C--OUTPUT THIS SECTION TO M/T
2050  CONTINUE
      M81=L81+NYNZ-1
      WRITE(MT1)NYNZ,(FSTORE(I),I=L81,M81)
C
C--LOCATE THE MAXIMA IN THE MAP IF NECESSARY
2100  CONTINUE
      CALL XFOURO
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--PRINT THE MAP IF NECESSARY
      CALL XFPRT2
C--CHANGE THE SECTION POINTERS
      I=L83
      L83=L82
      L82=L81
      L81=I
C--INCREMENT THE CURRENT SCAN POINTER
      KI=KI+2
C--INCREMENT THE NUMBER OF SECTIONS COMPUTED POINTER
      KJ=KJ+1
      STORE(L14+12)=STORE(L14+12)+STORE(L14+13)
C--SEE IF THIS WAS THE LAST LAYER TO BE CALCULATED
      IF(NUM(3)-KJ)2200,2200,2150
C--CHECK IF THERE ARE MORE SECTIONS LEFT IN THIS SCAN
2150  IF(JZ+JW-KI)1600,1650,1650
C
C--CHECK IF WE HAVE BEEN DOING OUTPUT
2200  CONTINUE
      IF(IOUTAP)2300,2300,2250
2250  CONTINUE
      ENDFILE MT1
      REWIND MT1
C--CHECK IF THIS WAS A WEIGHTED FOURIER
2300  CONTINUE
      IF (NWT .EQ. 0) GOTO 2450
      IF (ABS(SSU - 1.) .GT. ZERO) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,2310) SSU
      ENDIF
        WRITE(NCAWU,2310) SSU
2310    FORMAT(
     1 ' Peak height multiplier tries to scale weighted map peaklist',
     2 /,' to unweighted map peak heights',
     2 /' Peak height multiplier is ',G15.5//)
      ENDIF
      IF (NWT) 2350, 2450, 2450
C--SIM WEIGHTED FOURIER  -  PRINT SOME STATISTICS
2350  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2400)SSV,((HWMIN(I,J),I=1,6),J=1,2)
      ENDIF
2400  FORMAT(/48H Sum of squares of light atom atomic numbers is ,
     2 G15.3,/,
     3 37H Minimum sim weight for reflection : ,3F4.0,2F9.2,E15.5//
     4 37H Maximum sim weight for reflection : ,3F4.0,2F9.2,E15.5)
C--FORM LIST 5 OR 10, WHICHEVER IS APPROPIATE
2450  CONTINUE
      WRITE(NCAWU, 2451) APEAKH
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU, 2451) APEAKH
      ENDIF
2451  FORMAT(1X, 'Minimum peak height for search is ', F8.2)
      CALL XRSL
      CALL XCSAE
      NFL=NFL1
      LFL=LFL1
      CALL XFOURP(LNOUT)
      IF ( IERFLG .LT. 0 ) GO TO 9900
      CALL XCSAE
      CALL XRSL
C----- RESTORE MIN/MAX HOLE
C      DENMIN = FLOAT(NGMAP) * DENMIN * SSU/SS
      DENMIN = DENMIN * SSU/SS
      DENMAX = DENMAX * SSU/SS
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,2610) DENMIN,DENMAX
      ENDIF
      WRITE (NCAWU,2610) DENMIN,DENMAX
2610  FORMAT(/ ' The minimum and maximum',
     1' map densities are ',2G10.3/10X,' on an absolute scale')
C----- STORE IN LIST30 IF DIFFERENCE MAP
      IF (NTYP .EQ. 3) THEN
        CALL XFAL30
        STORE(L30RF+5) = MIN (DENMIN, DENMAX)
        STORE(L30RF+6) = MAX (DENMIN, DENMAX)
      CALL XWLSTD ( 30, ICOM30, IDIM30, -1, -1)
      ENDIF
C--CHECK IF WE CAN PRINT THE MEAN ELECTION DENSITY
      IF(NTYP-3)2600,2500,2600
C--DIFFERENCE MAP  -  PRINT THE AVERAGE ELECTRON DENSITY AT AN ATOMIC SI
2500  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2550)AAA,DDD
      ENDIF
2550  FORMAT(/51H Mean electron density at original atomic sites is ,
     2 F9.2,30H  with an R.M.S. deviation of ,F9.2)
C--PRINT THE TERMINATION MESSAGE
2600  CONTINUE
      CALL XOPMSG ( IOPFOU , IOPEND , IVERSN )
      CALL XTIME2(2)
      RETURN
9900  CONTINUE
C -- ERRORS DETECTED
      CALL XOPMSG ( IOPFOU , IOPABN , 0 )
      GO TO 2600
9910  CONTINUE
C -- INPUT ERRORS
      CALL XOPMSG ( IOPFOU , IOPCMI , 0 )
      GO TO 9900
9920  CONTINUE
C -- ILLEGAL MAP TYPE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 )
      ENDIF
      WRITE ( NCAWU , 9925 )
9925  FORMAT ( 1X , ' Impossible Fourier type ' )
      CALL XERHND ( IERERR )
      GO TO 9900
9930  CONTINUE
C -- NO OPERATION
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9935 )
      ENDIF
      WRITE ( NCAWU , 9935 )
9935  FORMAT ( 1X , 'Flags set for no map, no scan, ' ,
     1 'and no output tape' )
      CALL XERHND ( IERERR )
      GO TO 9900
      END
C
CODE FOR XFOURI
      SUBROUTINE XFOURI
C--THIS ROUTINE LOADS LIST 5 FROM DISC, IF ONE EXISTS AND IT
C  IS REQUIRED. LIST 5 IS STORED IN COMPRESSED FORM AT THE TOP
C  OF CORE SO THAT PEAK SEARCH DATA CAN INSERTED INTO IT.
C  IF A SIM-WEIGHTED FOURIER IS BEING CALCULATED, THIS ROUTINE ALSO
C  LOADS LISTS 3 AND 29 AND SETS UP THE NECESSARY SIM WEIGHTING CONSTANT
C
C  NWT   THE TYPE OF WEIGHTING TO BE USED :
C
C          -1  SIM WEIGHTED.
C           0  NO WEIGHTS.
C           1  WEIGHTS TAKEN FROM LIST 6.
C
C--THE FORMAT OF LIST 5 SET UP HERE IS :
C
C  0  TYPE.
C  1  SERIAL.
C  2  X
C  3  Y
C  4  Z
C  5  INTERPOLATED HEIGHT FROM THE MAP.
C  6  SECTION IN THE MAP ON WHICH THIS ATOM APPEARS.
C
C--THESE COORDINATES ARE SWOPPED OVER BY 'XFOURI' LATER ON, AND THE
C  ENTRY IN WORD 6 IS CALCULATED AT THE SAME TIME.
C  THESE ORIGINAL ATOMIC SITES ARE CONTROLLED BY THE 'L10A' VARIABLES.
C
C--THE FORMAT OF TH PEAKS LIST ACCUMULATED DURING THE MAP SCAN IS AS FOL
C
C  0  HEIGHT.
C  1  X
C  2  Y
C  3  Z
C  4  THE METHOD OF FINDING THE PEAK HEIGHT :
C
C      1  LEAST SQUARES.
C      2  QUADRATIC INTERPOLATION.
C
C  THESE COORDINATES ARE SORTED WHEN THEY ARE STORED. THIS LIST OF PEAKS
C  CONTROLLED BY THE 'L10' VARIABLES.
C
C--
      DIMENSION FSTORE(131072),JSTORE(131072)
      DIMENSION MINW(3),ISTEP(3),MAXW(3),NUM(3),NUN(3),
     2 IAS(3),IAC(3),MXC(3)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XPROCS/NTYP,NE,NWT,IPRINT,THRES1,THRES2,IALL,NLINE,NCHAR,
     2 NCHARC,NSPACE,ISCAN,HEIGHT,NPEAK,INTAPE,IOUTAP,F000,ISC,SCLCON,
     3 REJECT,APEAKH , NGMAP, IFCALC, IPKMON
      COMMON/XWORKC/IAXIS(3),NV,IXYZ(3),SCALE,SS,SC,VOL,
     2 NORFL,L6DUMP,N6DUMP,SSV,SSU,HWMIN(6,2),AAA,BBB,CCC,DDD,
     3 L81,L82,L83,N10MAX,NY,NZ,NYNZ,NY2,NYM2,NYNZM2, DENMIN,
     4 IPMAP, IEMAP, DENMAX
      COMMON/XWORKD/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,
     3 KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,KL,KM,KN,KO,KP,KQ,
     4 KR,KS,KT,KU,KV,KW,KX,KY,KZ,
     5 MA,MB,MC,MD,ME,MF,MG,MH,MI,MJ,MK,ML,MM,MN,MO,MP,MQ,
     6 MR,MS,MT,MU,MV,MW,MX,MY,MZ
      COMMON/XLST08/L8,M8,MD8,N8
      COMMON/XLST10/L10,M10,MD10,N10,L10A,M10A,MD10A,N10A
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST23/L23M,M23M,MD23M,N23M,L23EX,M23EX,MD23EX,N23EX,
     2 L23MN,M23MN,MD23MN,N23MN,L23AC,M23AC,MD23AC,N23AC,
     3 L23IC,M23IC,MD23IC,N23IC, L23SP,M23SP,MD23SP,N23SP
      COMMON/XLST29/L29,M29,MD29,N29
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (FSTORE(1),STORE(1)),(ISTORE(1),JSTORE(1))
      EQUIVALENCE (JA,MINW(1)),(JD,NUN(1)),(JG,NUM(1)),(JJ,IAC(1))
      EQUIVALENCE (JM,IAS(1)),(JP,MXC(1)),(KF,ISTEP(1)),(KX,MAXW(1))
C
C----- SET DEFAULT SIM WEIGHTS
      SSV=1.0
      SSU = 1.0
C----- SET DEFAULT SCALE FACTOR
      SCALE=1.
C--CHECK IF THIS MAP REQUIRES /FC/'S AND THUS A LIST 5
      L10A=LFL+1
      N10A = 0
      IF (NTYP .LT. IPMAP)  GOTO 1050
C--PATTERSON OR E-MAP  -  SUPPRESS SIM WEIGHTING
      NWT=IABS(NWT)
      GOTO 1950
C--A MAP USING PHASES AND POSSIBLY /FC/'S
1050  CONTINUE
C----- 'OPTIMAL' MAP SET WEIGHTING
      IF (NTYP .EQ. 5) NWT = -1
      IF(NWT)1100,1200,1200
1100  CONTINUE
C----- LOAD 29, FOR SIM WEIGHTING
      CALL XFAL29
      IF (IERFLG .LT. 0) GOTO 9900
C----- SHORTEN AND REORGANISE LIST 29
      M5=L29
      N5=N29
      MD5=MD29
C--ALLOCATE SOME SPACE
      LN=29
      IREC=1001
      MD29=3
      L29=KCHLFL(MD29*N29)
      LFL = L29 - 1
C--MOVE THE DATA AROUND
      M29=L29
      DO 1150 I=1,N29
C--SECOND COPY OF THE ATOM TYPE
      CALL XMOVE(STORE(M5),STORE(M29),1)
      CALL XMOVE(STORE(M5),STORE(M29+1),1)
C----- AND RELOCATE THE CELL CONTENTS
      CALL XMOVE(STORE(M5+4),STORE(M29+2),1)
      M29=M29+MD29
      M5=M5+MD5
1150  CONTINUE
      GOTO 1300
C--THIS OPERATION IS UNWEIGHTED  -  CHECK IF LIST 5 IS OBLIGATORY
1200  CONTINUE
      IF (NTYP .LT. IPMAP) GOTO 1300
C--CHECK IF THERE IS A LIST 5 TO USE
      IF(KEXIST(5))1950,1950,1300
C
C--BRING DOWN LIST 5 TO FIND THE SCALE FACTOR
1300  CONTINUE
      CALL XFAL05
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CHECK IF THERE ARE ANY ATOMS IN LIST 5
      IF(N5)1450,1450,1350
C--SET THE ATOMS UP AT THE TOP OF CORE
C     IN A LIST 10
1350  CONTINUE
      LN=10
      IREC=1002
      N10A=N5
      MD10A=7
      L10A=KCHLFL(MD10A*N10A)
      M10A=L10A
C--SET THE POINTERS TO LOOP OVER ALL THE ATOMS
      M5=L5
      DO 1400 I=1,N5
C--MOVE THE TYPE AND SERIAL
      CALL XMOVE(STORE(M5),STORE(M10A),2)
C--MOVE THE COORDINATES
      CALL XMOVE(STORE(M5+4),STORE(M10A+2),3)
C--SET THE INITIAL PEAK HEIGHT TO ZERO
      STORE(M10A+5)=0.0
C--INITIALISE THE SECTION FLAG
      ISTORE(M10A+6)=-1
      M10A=M10A+MD10A
      M5=M5+MD5
1400  CONTINUE
C----- LOAD DATA IF NOT ALREADY IN CORE
      IF (KHUNTR (1,0, IADDL,IADDR,IADDD, -1) .LT. 0) CALL XFAL01
      IF (KHUNTR (2,0, IADDL,IADDR,IADDD, -1) .LT. 0) CALL XFAL02
      IF (KHUNTR (5,0, IADDL,IADDR,IADDD, -1) .LT. 0) CALL XFAL05
      IF (KHUNTR (23,0, IADDL,IADDR,IADDD, -1) .LT. 0) CALL XFAL23
      IF (IERFLG .LT. 0) GOTO 9900
C----- SAVE THE TOLERANCE AND UPDATE VALUES
      STOLER = STORE(L23SP+5)
      IUPDAT = ISTORE(L23SP+1)
C----- SET THE OCCUPANCIES
      IF (IUPDAT .GE. 0) THEN
        I = KSPINI( -1, STOLER)
C----- SAVE SOME WORK SPACE
        J =NFL
        I = KCHNFL(40)
        M5 = L5
        DO 3350 I = 1, N5
          IF (IUPDAT .GE. 0)
     1      IGSTAT =KSPGET ( STORE(J), STORE(J+10), ISTORE(J+20),
     2      STORE(J+30), MGM, M5, IUPDAT, NUPDAT)
          M5 = M5 + MD5
3350  CONTINUE
C----- RESTORE WORKSPACE
        NFL= J
      ENDIF
C
C--ASSIGN THE SCALE FACTOR FROM LIST 5
1450  CONTINUE
      SCALE=STORE(L5O)
C
C--CHECK IF THIS IS A SIM WEIGHTED FOURIER
      IF(NWT)1500,1950,1950
C
C--FIND THE ATOM TYPES IN LIST 5 AND ADJUST LIST 29 ACCORDINGLY
1500  CONTINUE
C -- CHECK THAT THERE ARE ATOMS IN LIST 5
      IF ( N5 .LE. 0 ) GO TO 9910
C--LOOP OVER EACH ATOM
      L5A=L5
      MD5A=MD5
      M5A=L5A
      DO 1850 I=1,N5
      J=KCOMP(1,STORE(M5A),STORE(L29+1),N29,MD29)
C--CHECK IF THIS ATOM IS IN LIST 29
      IF ( J .LE. 0 ) GO TO 9920
C--ADJUST THE CONTENTS OF LIST 29 TO ELIMINATE THIS ATOM
      J=L29+(J-1)*MD29
      STORE(J+2)=AMAX1(0.0,STORE(J+2)-STORE(M5A+2)* STORE(M5A+13))
      M5A=M5A+MD5A
1850  CONTINUE
C----- CHECK IF ANY ATOMS TO BE FOUND
      M29=L29
      SSV=0.0
      DO 1870 I=1,N29
      SSV=SSV+STORE(M29+2)
      M29=M29+MD29
1870  CONTINUE
      IF (SSV - ZERO) 9930,9930,1880
1880  CONTINUE
      HWMIN(6,1)=10.
      HWMIN(6,2)=0.
      SSU=1./SCALE
C--RESET THE CORE LIMITS TO REASONABLE VALUES
1950  CONTINUE
      CALL XRSL
      CALL XCSAE
      IF (NWT .LT. 0) THEN
C----- LOAD LIST 3 AND LINK IT TO LIST 29 AS A LIST5
        CALL XFAL03
        IF ( IERFLG .LT. 0) GOTO 9900
        N5 = N29
        M5 = L29
        L5 = L29
        MD5 = MD29
        I = KSET53(0)
        IF ( IERFLG .LT. 0) GOTO 9900
C--COMPUTE THE SIM WEIGHT MULTILPIER
      CALL XSCATT(0.0)
      SSV=0.
      M29=L29
C--FORM THE SUM OF THE SQUARES OF THE FORM FACTORS
      DO 1900 I=1,N29
      J=L3TR+ISTORE(M29)*MD3TR
      SSV = SSV + STORE(M29+2) * STORE(J) * STORE(J)
      M29=M29+MD29
1900  CONTINUE
      IF ( SSV .LE. ZERO) SSV = 1.
      ENDIF
C----- SAVE LIST 29 AND L10 AT TOP OF STORE
      LFL=L10A-1
C----- AND NOW RETURN OK
C
9900  CONTINUE
C -- ERRORS
      RETURN
9910  CONTINUE
C -- NO ATOMS IN LIST 5 FOR SIM WEIGHTS
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 )
      ENDIF
      WRITE ( NCAWU , 9915 )
9915  FORMAT(1X, ' LIST 5 contains no atoms for SIM weighting.'/
     1 1X, ' Unit Weights used')
      SSV = 1.0
      GOTO 1950
9920  CONTINUE
C -- ATOM NOT IN LIST 29
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 )
      ENDIF
      WRITE ( NCAWU , 9925 )
9925  FORMAT ( 1X , 'Atom in list 5 but not in list 29' )
      CALL XPRTCO ( 2 , M5A , I )
      CALL XERHND ( IERERR )
      GO TO 9900
C
9930  CONTINUE
C----- NO ATOMS LEFT IN LIST 29
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,9935)
      ENDIF
      WRITE(NCAWU,9935)
9935  FORMAT(1X,// '  Sim weighting inapplicable.',/,
     1 1X, ' LIST 5 and LIST 29 contain the same number of atoms.',
     2 /,1X,' Unit Weights applied')
      SSV = 1.
      GOTO 1950
C
      END
CODE FOR XFOURJ
      SUBROUTINE XFOURJ
C--THIS ROUTINE LOADS LISTS 1, 2, 6 AND 14 FROM DISC, SORTS
C  LIST 5 TO ALLOW FOR VARYING PROJECTIONS AND SETS UP LIST 10
C  FOR PEAKS LIST OUTPUT.
C
C--WHEN THE LISTS ARE LOADED THEY ARE SORTED TO ALLOW FOR THE DIFFERING
C  PROJECTS AND LIST 14 IS CHECKED TO SEE THAT IT IS VALID.
C  ALL THE VARIABLES DESCRIBING THE MAP ARE SET UP IN 'XWORKA', AND THE
C  VALUES IN LIST 14 ARE LEFT IN FRACTIONAL COORDINATES, EXCEPT FOR THE
C  NUMBER OF DIVISIONS ALONG EACH AXIS WHICH IS SIMPLY STORED IN
C  FLOATING POINT.
C
C--
      DIMENSION FSTORE(131072),JSTORE(131072)
      DIMENSION MINW(3),ISTEP(3),MAXW(3),NUM(3),NUN(3),
     2 IAS(3),IAC(3),MXC(3)
      DIMENSION ISTORE(131072)
C
C
      DIMENSION DISTS(4)
C
      CHARACTER*24 CDIREC(3)
C
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XPROCS/NTYP,NE,NWT,IPRINT,THRES1,THRES2,IALL,NLINE,NCHAR,
     2 NCHARC,NSPACE,ISCAN,HEIGHT,NPEAK,INTAPE,IOUTAP,F000,ISC,SCLCON,
     3 REJECT,APEAKH , NGMAP, IFCALC, IPKMON
      COMMON/XWORKC/IAXIS(3),NV,IXYZ(3),SCALE,SS,SC,VOL,
     2 NORFL,L6DUMP,N6DUMP,SSV,SSU,HWMIN(6,2),AAA,BBB,CCC,DDD,
     3 L81,L82,L83,N10MAX,NY,NZ,NYNZ,NY2,NYM2,NYNZM2, DENMIN,
     4 IPMAP, IEMAP, DENMAX
      COMMON/XWORKD/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,
     3 KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,KL,KM,KN,KO,KP,KQ,
     4 KR,KS,KT,KU,KV,KW,KX,KY,KZ,
     5 MA,MB,MC,MD,ME,MF,MG,MH,MI,MJ,MK,ML,MM,MN,MO,MP,MQ,
     6 MR,MS,MT,MU,MV,MW,MX,MY,MZ
      COMMON/XLST08/L8,M8,MD8,N8
      COMMON/XLST10/L10,M10,MD10,N10,L10A,M10A,MD10A,N10A
      COMMON/XDSTNC/AT,AC,BT,BC,BP,AP,AO,IDIST,LBOX,MBOX,MDBOX,NBOX,
     2 LFNVC,MFNVC,MDFNVC,NFNVC,MFNVCA
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST14/L14,M14,MD14,N14, L14O,M14O,MD14O,N14O,
     2 L14SC,M14SC,MD14SC,N14SC, L14P,M14P,MD14P,N14P
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (FSTORE(1),STORE(1)),(ISTORE(1),JSTORE(1))
      EQUIVALENCE (JA,MINW(1)),(JD,NUN(1)),(JG,NUM(1)),(JJ,IAC(1))
      EQUIVALENCE (JM,IAS(1)),(JP,MXC(1)),(KF,ISTEP(1)),(KX,MAXW(1))
C
C
      EQUIVALENCE (DISTS(1),AT)
C
C
C
      DATA CDIREC / ' Axis  down  the page : ' ,
     2  ' Axis across the page : ' , ' Sectioned through    : ' /
C
C--LOAD A FEW LISTS
      CALL XZEROF(DISTS(1),4)
      DISTS(2)=AMAX1(REJECT,2.*VALUE)
C----- LOAD LISTS 1 AND 2
      CALL XDIST2
      IF ( IERFLG .LT. 0 ) GO TO 9900
C----- SET UP SIM WEIGHTING FACTORS
      SSV=SSV*G2*FLOAT(N2)
      SSU=SSU*FLOAT(2-IC)/(SSV)
C--SET UP THE VOLUME OF THE CELL
      VOL=STORE(L1P1+6)
C----- SET THE NUMBER OF PEAKS, ASSUMING AN ATOMIC VOLUME OF AVOL
      AVOL = 15.0
      IF (NPEAK .LE. 0) NPEAK = NINT((VOL )/(AVOL))/ T2
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050) NPEAK
      ENDIF
      WRITE(NCAWU,1050) NPEAK
1050  FORMAT(/,10X,' Number of new peaks to be retained is : ', I6)
C----- ADD IN THE EXISTING ATOMS IF NOT A DIFFERENCE MAP
      IF (NTYP .NE. 3)   NPEAK = NPEAK + N10A
      M2I=L2I+MD2I*(N2I-1)
      CALL XFAL14
      IF ( IERFLG .LT. 0 ) GO TO 9900
C----- SWOP ADDRESSES IF PATTERSON BEING DONE
      IF (NTYP .GE. IPMAP .AND. NTYP .LT. IEMAP) THEN
        L14 = L14P
        N14 = N14P
        ND14 = MD14P
      ENDIF
C--UNPACK THE SORT DIRECTIVES
      IAXIS(1)=ISTORE(L14O)
      IAXIS(2)=ISTORE(L14O+1)
      IAXIS(3)=ISTORE(L14O+2)
C--CHECK THAT THE ORIENTATION PARAMETERS ARE VALID
      DO 1150 I=1,2
      DO 1100 J=I,2
      IF ( IAXIS(I) - IAXIS(J+1) ) 1100 , 9910 , 1100
1100  CONTINUE
1150  CONTINUE
C--INTERCHANGE THE LIST 14 DIRECTIVES
      CALL XFSWOP(STORE(L14),3*MD14,MD14,1,MD14)
C--SORT THE CELL PARAMETERS
      CALL XFSWOP(STORE(L1P1),6,1,3,2)
C--SORT THE D/A CONTROL BLOCK
      CALL XFSWOP(BPD,3,1,3,1)
C--SORT THE COORDINATE DIRECTIONS
      CALL XSWOP(IAXIS,IX,3,1,1,IXYZ,3,1,1,1)
C--SET UP THE NUMBER OF HEADER WORDS PER 'HK' BLOCK
      JW=2
C--SET UP THE NUMBER OF Y POINTS TO BE CALCULATED AT A TIME
      JX=1
C
C--PROCESS THE FOURIER DIRECTIVES AND SET UP THE COSINE TABLES
      I=L1P1
      M14=L14
      LN=14
      IREC=1010
      DO 2200 J=1,3
C--CHECK IF WE ARE GOING POSITIVELY OR NEGATIVELY ALONG THIS AXIS
      K=1
      IF(STORE(M14)-STORE(M14+2)-0.0001)1250,1200,1200
C--NEGATIVE MOVEMENT
1200  CONTINUE
      K=-1
C--FETCH THE NUMBER OF DIVISIONS
1250  CONTINUE
      NUN(J)=NINT(STORE(M14+3))
C--CHECK IF THE NUMBER OF DIVISIONS HAS BEEN GIVEN
      IF(NUN(J))1300,1300,1600
C--THE NUMBER OF DIVISIONS MUST BE SET UP  -  CHECK THE INCREMENT
1300  CONTINUE
      IF(ABS(STORE(M14+1))-0.05)1350,1350,1400
C--NO INCREMENT HAS BEEN GIVEN  -  INSERT THE DEFAULT OF 0.3 ANGSTROM
1350  CONTINUE
      STORE(M14+1)=0.3
C--COMPUTE THE DIVISIONS ALONG THIS AXIS
1400  CONTINUE
      NUN(J)=IABS(NINT(STORE(I)/STORE(M14+1)))
C--MAKE SURE THAT THE NUMBER OF DIVISIONS IS A MULTIPLE OF 4
1450  CONTINUE
      IF(NUN(J)-NUN(J)/4*4)1500,1550,1500
C--NOT A MULTIPLE OF 4  -  DECREMENT
1500  CONTINUE
      NUN(J)=NUN(J)-1
      GOTO 1450
C--COMPUTE THE INTERVALS AND MAX. AND MIN. ALONG THE AXIS
1550  CONTINUE
      ISTEP(J)=K
      MINW(J)=NINT(FLOAT(NUN(J))*STORE(M14))-ISTEP(J)
      MAXW(J)=NINT(FLOAT(NUN(J))*STORE(M14+2))+ISTEP(J)
C--STORE THE INFORMATION IN LIST 14
      STORE(M14  )=FLOAT(MINW(J))
      STORE(M14+1)=FLOAT(ISTEP(J))
      STORE(M14+2)=FLOAT(MAXW(J))
      STORE(M14+3)=FLOAT(NUN(J))
      GOTO 1700
C--THE INTERVALS ALONG THE AXIS HAVE BEEN GIVEN
1600  CONTINUE
      MINW(J)=NINT(STORE(M14))
      ISTEP(J)=NINT(STORE(M14+1))
      MAXW(J)=NINT(STORE(M14+2))
C--CHECK THAT WE WILL MOVE ALONG THIS AXIS
      IF(ISTEP(J))1700,1650,1700
1650  CONTINUE
      ISTEP(J)=K
C--COMPUTE THE NUMBER OF INTERVALS AND CHECK IT
1700  CONTINUE
      NUM(J)=(MAXW(J)-MINW(J)+ISTEP(J)-K)/ISTEP(J)+1
      IF ( NUM(J) )  9920 , 9920 , 1850
C--CHECK IF THIS AXIS CAN SHARE A SIN/COS TABLE
1850  CONTINUE
      CALL XDVDR(STORE(M14),STORE(M14+3),STORE(M14),3)
      IF(J-1)2050,2050,1900
1900  CONTINUE
      DO 2000 K=2,J
      IF(NUN(J)-NUN(K-1))2000,1950,2000
C--THESE TWO CAN SHARE TABLES
1950  CONTINUE
      IAC(J)=IAC(K-1)
      IAS(J)=IAS(K-1)
      MXC(J)=MXC(K-1)
      GOTO 2150
2000  CONTINUE
C--SINE/COSINE TABLE FOR THIS AXIS  -  COMPUTE THE LENGTH OF THE ENTRY
2050  CONTINUE
      IAS(J)=NUN(J)+1
      L=IAS(J)
C--ADDRESS OF THE COSINE TABLE
      IAC(J)=NFL+IAS(J)
      MXC(J)=IAC(J)+NUN(J)
      IAS(J)=IAS(J)+IAS(J)
      KO=KCHNFL(IAS(J)+IAS(J))
C--SET UP THE SINES AND COSINES
      B=TWOPI/FLOAT(NUN(J))
      DO 2100 K=1,L
      M=K-1
      A=B*FLOAT(M)
C--SET UP THE COSINE PART
      N=IAC(J)+M
      STORE(N)=COS(A)
      M=IAC(J)-M
      STORE(M)=STORE(N)
C--SET UP THE SINE PART
      N=N+IAS(J)
      STORE(N)=SIN(A)
      M=M+IAS(J)
      STORE(M)=-STORE(N)
2100  CONTINUE
C--NEXT AXIAL DIRECTION
2150  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,2300)  CDIREC(J), IXYZ(J), MINW(J), ISTEP(J),
     2 MAXW(J),NUN(J)
      ENDIF
2300  FORMAT( / ( /A, A1, 3X, 'Running from ', I4, '  in steps of ', I3,
     2 5H  to ,I4,18H  in divisions of ,I4))
      I=I+1
      M14=M14+MD14
2200  CONTINUE
C--INTERCHANGE THE SYMMETRY OPERATORS FOR THE DIFFERENT AXIAL PROJECTION
      M2=L2
      DO 2250 K=L2I,M2I,MD2I
      CALL XFSWOP(STORE(K),12,1,3,4)
      CALL XFSWOP(STORE(K),9,3,1,3)
C--NOW THE TRUE SYMMETRY OPERATORS, NOT THE INVERSE ONES
      CALL XFSWOP(STORE(M2),12,1,3,4)
      CALL XFSWOP(STORE(M2),9,3,1,3)
      M2=M2+MD2
2250  CONTINUE
C--SORT THE NON-PRIMITIVE LATTICE OPERATORS
      CALL XFSWOP(STORE(L2P),MD2P*N2P,1,MD2P,N2P)
C--SET UP THE EQUIVALENT INDICES FLAGS
      KU=4
      KR=NFL
      I=KCHNFL(2*KU*N2I)
C--SET UP THE INCREMENT ALONG THE PARTIAL SUM FOR Y
      KO=JX+JX
C
C--CHECK IF A SCAN IS POSSIBLE  -  SET UP THE LIMITS FOR A BOX SEARCH
      M14=L14
      N=1000000
      DO 2450 I=1,3
C--CHECK IF WE HAVE ENOUGH POINTS TO INTERPOLATE WITH ALONG THIS AXIS
      IF(NUM(I)-3)2350,2400,2400
C--NOT ENOUGH POINTS ALONG THIS AXIS
2350  CONTINUE
      ISCAN=-1
      N=-1
C--THERE ARE ENOUGH  -  MOVE THE LIMITS ACROSS
2400  CONTINUE
      BPD(I+3)=AMIN1(STORE(M14),STORE(M14+2))
      BPD(I+6)=AMAX1(STORE(M14),STORE(M14+2))
      M14=M14+MD14
2450  CONTINUE
C--SET THE ADDRESS OF THE MISSING ATOMS
      M=NFL
C--CHECK IF THERE ARE ANY ATOM IN LIST 5
      IF(N10A)2850,2850,2500
C--INDICATE A BOX SEARCH
2500  CONTINUE
      IDIST=0
C--SET THE POINTERS TO LIST 5
      L5=L10A
      M5=L5-2
      MD5=MD10A
      N5=N10A
C--LOOP OVER EACH ATOM IN TURN, PLACING IT IN THE REQUIRED VOLUME
      DO 2700 I=1,N5
C--SWOP THE COORDINATES OF THE CURRENT ATOM
      CALL XFSWOP(STORE(M5+4),3,1,1,1)
C--MOVE THE ATOM AROUND
C
      J = KDIST1(1, K, 10, 0, .2, 0)
C
      M5=M5-MD5
      IF(J)2650,2550,2600
C--ATOM IS NOT IN THE CURRENT UNIT CELL VOLUME
2550  CONTINUE
      LN=5
      IREC=1002
      CALL XMOVE(STORE(M5+2),STORE(NFL),2)
      J=KCHNFL(2)
      GOTO 2650
C--MOVE THE TRANSPOSED COORDINATES OVER
2600  CONTINUE
      CALL XMOVE(STORE(NFL+7),STORE(M5+4),3)
C--COMPUTE THE SECTION ON WHICH THIS ATOM OCCURS
      ISTORE(M5+8)=MIN0(N,MIN0(NUM(3)-2,MAX0(1,NINT((STORE(M5+6)
     2 -STORE(L14+12))/STORE(L14+13)))))+1
C--UPDATE FOR THE NEXT ATOM
2650  CONTINUE
      M5=M5+MD5
2700  CONTINUE
C--CHECK IF WE HAVE OMITTED ANY ATOMS
      IF(M-NFL)2750,2850,2850
C--PRINT THE OMITTED ATOMS
2750  CONTINUE
      NFL=NFL-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2800)(STORE(I),I=M,NFL)
      ENDIF
2800  FORMAT(//9(12H *** Warning),4H *** //22H The following atom(s),
     2 18H do not fit in the,
     3 39H volume of the cell to be calculated : //(5(3X,A4,F8.0,7X)))
      WRITE(NCAWU,2801)(STORE(I),I=M,NFL)
2801  FORMAT(// (12H *** Warning),4H *** //22H The following atom(s),
     2 18H do not fit in the,
     3 39H volume of the cell to be calculated : //(2(3X,A4,F8.0,7X)))
      CALL XERHND ( IERWRN )
C
C--SET THE NUMBER OF PEAKS FOUND AS ZERO
2850  CONTINUE
      NFL=M
      MD10=0
      N10=0
C--COMPUTE THE INCREMENT ALONG EACH Y ROW
      MD8=(JH+JX-1)/JX*JX
C--NOW CHECK IF WE ARE DOING A PEAK SCAN
      IF(ISCAN)3100,2900,2900
C--SET UP THE MAP REGION FLAGS FOR THE SCAN
2900  CONTINUE
      NY=MD8
      NZ=NUM(1)
      NYNZ=NY*NZ
      NY2=NY+NY
      NYM2=NY-2
      NYNZM2=NYNZ-NY2
C--SET UP THE FLAGS FOR THE PEAK STORAGE
      MD10=5
C--COMPUTE THE MAXIMUM NUMBER OF PEAKS THAT WE CAN HOLD
      N10MAX=(3*NPEAK+1)/2
C--SET UP THE CORE AREA
      L10=KCHLFL(MD10*(N10MAX+1))
C--CHECK IF THIS IS A PATTERSON
      IF( (NTYP .GE. IPMAP) .AND. (NTYP .LT. IEMAP)) THEN
C--THIS IS A PATTERSON  -  MAKE THE STRUCTURE CENTRO
      IC=1
      M2=L2
      DO 3050 I=1,N2
      CALL XZEROF(STORE(M2+9),3)
      M2=M2+MD2
3050  CONTINUE
      END IF
C
C--ADJUST THE PEAK SCAN CONSTANTS AS NECESSARY
3100  CONTINUE
      IF(ISCAN)3400,3150,3150
C--PEAK SCAN IS INDICATED  -  CHECK IF THE HEIGHT HAS BEEN GIVEN
3150  CONTINUE
      IF(HEIGHT-ZERO)3200,3200,3350
C--NO HEIGHT HAS BEEN GIVEN  -  CHECK THE FOURIER TYPE
3200  CONTINUE
      IF (NTYP .GE. IPMAP) GOTO 3300
C--/FO/, /FC/ OR DIFFERENCE FOURIER  -  DEFAULT TO '1.5*SCALE'
      HEIGHT=1.5
      GOTO 3400
C--PATTERSON OR E-MAP
3300  CONTINUE
      HEIGHT=50.
C--INDICATE THAT THE SCALE FACTOR IS NOT NEEDED
3350  CONTINUE
      ISCAN=1
C--CHECK IF AUTOMATIC SCALING IS REQUIRED
3400  CONTINUE
      IF(ISC)3550,3450,3550
C--AUTOMATIC SCALING  -  CHECK THE TYPE
3450  CONTINUE
      IF (NTYP .NE. IPMAP) GOTO 3550
C--COMPUTE THE SCALE FACTOR
      ISC=1
C
C--SET UP LIST 6  -  CHECK THE FOURIER TYPE
3550  CONTINUE
      IF (NTYP .EQ. IEMAP) GOTO 3650
C--USING NORMAL REFLECTIONS
      CALL XFAL06(0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--RECORD THE REFLECTION DETAILS
      L6DUMP=L6R
      N6DUMP=N6R
      GOTO 3700
C--E-MAP  -  SET THE REFLECTION TRANSFER
3650  CONTINUE
      MD6=6
      CALL XIMTR(MD6)
C--ALLOCATE A SPACE
      LN=6
      IREC=2001
      M6=KCHLFL(MD6)
C--ZERO THE DUMP VARIABLES
      L6DUMP=NOWT
      N6DUMP=0
C--POSITION FOR THE E-MAP REQUIRED
      CALL ESKIP(NE)
C--SET THE NUMBER OF REFLECTIONS READ
3700  CONTINUE
      NORFL=0
C--CHECK IF WE REQUIRE AN OUTPUT TAPE
      IF(IOUTAP)3800,3750,3750
C--AN OUTPUT TAPE IS REQUIRED
3750  CONTINUE
      REWIND MT1
C----- SET UP TRANSFORMATION MATRIX  (BRIEFLY)
      CALL XZEROF (STORE(NFL), 9)
      STORE(NFL-1+IAXIS(1)) = 1.0
      STORE(NFL+2+IAXIS(2)) = 1.0
      STORE(NFL+5+IAXIS(3)) = 1.0
      IF (XDETR3 (STORE(NFL)) .LE. 0) STORE(NFL+5+IAXIS(3)) = -1.0
C----- WRITE THE M/T HEADER  DETAILS
      WRITE (MT1) 'INFO  DOWN, ACROSS AND SECTION '
      WRITE (MT1) 'TRAN', (STORE(I), I=NFL,NFL+8)
      WRITE (MT1) 'CELL', (STORE(I), I = L1P1, L1P1+5)
      WRITE (MT1) 'L14 ', ((STORE(J), J=I,I+3),
     1                        I=L14,2*MD14+L14, MD14)
      WRITE (MT1) 'SIZE', NUM
3800  CONTINUE
      RETURN
C
9900  CONTINUE
C -- ERRORS
      GO TO 3700
9910  CONTINUE
C -- INVALID ORIENTATION PARAMETER
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 ) IAXIS
      ENDIF
      WRITE ( NCAWU , 9915 ) IAXIS
9915  FORMAT ( 1X , 'Illegal orientation parameters ' , 3I4 )
      CALL XERHND ( IERERR )
      GO TO 9900
9920  CONTINUE
C -- ILLEGAL NUMBER OF POINTS
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 ) IXYZ(J) , NUM(J)
      ENDIF
      WRITE ( NCAWU , 9925 ) IXYZ(J) , NUM(J)
9925  FORMAT ( 1X , 'Number of points along ' , A1 , ' is ' , I8 ,
     1 ' which is illegal' )
      CALL XERHND ( IERERR )
      GO TO 9900
      END
C
CODE FOR XFOURM
      SUBROUTINE XFOURM
C--SET THE 'HK' PAIRS TABLE, AND THE MAP AREA
C
C--
      DIMENSION FSTORE(131072),JSTORE(131072)
      DIMENSION MINW(3),ISTEP(3),MAXW(3),NUM(3),NUN(3),
     2 IAS(3),IAC(3),MXC(3)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XPROCS/NTYP,NE,NWT,IPRINT,THRES1,THRES2,IALL,NLINE,NCHAR,
     2 NCHARC,NSPACE,ISCAN,HEIGHT,NPEAK,INTAPE,IOUTAP,F000,ISC,SCLCON,
     3 REJECT,APEAKH , NGMAP, IFCALC, IPKMON
      COMMON/XWORKC/IAXIS(3),NV,IXYZ(3),SCALE,SS,SC,VOL,
     2 NORFL,L6DUMP,N6DUMP,SSV,SSU,HWMIN(6,2),AAA,BBB,CCC,DDD,
     3 L81,L82,L83,N10MAX,NY,NZ,NYNZ,NY2,NYM2,NYNZM2, DENMIN,
     4 IPMAP, IEMAP, DENMAX
      COMMON/XWORKD/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,
     3 KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,KL,KM,KN,KO,KP,KQ,
     4 KR,KS,KT,KU,KV,KW,KX,KY,KZ,
     5 MA,MB,MC,MD,ME,MF,MG,MH,MI,MJ,MK,ML,MM,MN,MO,MP,MQ,
     6 MR,MS,MT,MU,MV,MW,MX,MY,MZ
      COMMON/XLST08/L8,M8,MD8,N8
      COMMON/XLST10/L10,M10,MD10,N10,L10A,M10A,MD10A,N10A
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST14/L14,M14,MD14,N14, L14O,M14O,MD14O,N14O,
     2 L14SC,M14SC,MD14SC,N14SC, L14P,M14P,MD14P,N14P
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (FSTORE(1),STORE(1)),(ISTORE(1),JSTORE(1))
      EQUIVALENCE (JA,MINW(1)),(JD,NUN(1)),(JG,NUM(1)),(JJ,IAC(1))
      EQUIVALENCE (JM,IAS(1)),(JP,MXC(1)),(KF,ISTEP(1)),(KX,MAXW(1))
C
C--START OF THE INITIAL SEARCH TO SET UP THE 'HK' PAIR FLAGS
      KA=LFL
      JY=1
      JZ=0
C--SET THE LIST AND RECORD TYPE
      LN=8
      IREC=1001
C--SCAN COUNTER TO ONE
      NV=1
C--SET THE NUMBER OF REFLECTIONS USED TO ZERO
      NORFL=0
C--SET UP THE POINTER TO THE START OF THE 'K' CHAIN
      I=LFL
      ISTORE(I)=NOWT
      K=KCHLFL(1)
C--FETCH THE NEXT REFLECTION
1000  CONTINUE
      IF(KFOURC(I))1600,1050,1050
C--COMPUTE THE EQUIVALENT SETS OF INDICES
1050  CONTINUE
      DO 1550 N=L2I,M2I,MD2I
C--COMPUTE THE NEW H
      M=NINT(STORE(M6)*STORE(N)+STORE(M6+1)*STORE(N+3)+STORE(M6+2)
     2 *STORE(N+6))
C--COMPUTE THE NEW K
      L=NINT(STORE(M6)*STORE(N+1)+STORE(M6+1)*STORE(N+4)+STORE(M6+2)
     2 *STORE(N+7))
C--CHECK THE SIGN OF H
      IF(M)1100,1150,1150
C--H IS NEGATIVE  -  REVERSE THE SIGNS OF BOTH INDICES
1100  CONTINUE
      M=-M
      L=-L
C--COMPUTE THE MAXIMUM VALUE OF H
1150  CONTINUE
      JZ=MAX0(JZ,M)
C--START THE SEARCH THROUGH THE H CHAIN
      J=I
C--MOVE ONTO THE NEXT H VALUE
1200  CONTINUE
      K=J
      J=ISTORE(K)
C--CHECK FOR THE END OF THE CHAIN
      IF(J)1300,1300,1250
C--CHECK THE CURRENT VALUE OF H AGAINST THE VALUE IN THE CHAIN
1250  CONTINUE
      IF(ISTORE(J-1)-M)1200,1350,1300
C--INSERT THIS VALUE OF H IN THE CHAIN
1300  CONTINUE
      ISTORE(K)=LFL
      ISTORE(LFL)=J
      J=LFL
      K=KCHLFL(5)
C--SET UP THE REMAINDER OF THE HEADER
      ISTORE(J-1)=M
      ISTORE(J-2)=NOWT
      ISTORE(J-3)=NOWT
      ISTORE(J-4)=1000000
C--ALTER THE FLAGS TO CHECK FOR THIS VALUE OF K WITH THE CURRENT H
1350  CONTINUE
      M=J
      J=J-2
C--MOVE TO THE NEXT K VALUE IN THE CHAIN
1400  CONTINUE
      K=J
      J=ISTORE(K)
C--CHECK FOR THE END OF THE K CHAIN
      IF(J)1500,1500,1450
C--CHECK FOR THE VALUE OF INTEREST
1450  CONTINUE
      IF(ISTORE(J-1)-L)1400,1550,1500
C--INSERT THIS VALUE OF K IN THE CHAIN
1500  CONTINUE
      JY=JY+1
      ISTORE(K)=LFL
      ISTORE(LFL)=J
C--SET THE REST OF THE HEADER
      ISTORE(LFL-1)=L
      K=KCHLFL(2)
C--SET UP THE MAXIMUM VALUE OF K FOUND FOR THIS VALUE OF H
      ISTORE(M-3)=MAX0(ISTORE(M-3),L)
C--SET UP THE MINIMUM VALUE OF K FOUND FOR THIS VALUE OF H
      ISTORE(M-4)=MIN0(ISTORE(M-4),L)
1550  CONTINUE
      GOTO 1000
C
C--START OF THE LOOP THAT UNRAVELS THE H STACK AND SETS UP ITS TABLE
1600  CONTINUE
      J=I
      JS=NFL
C--ALLOCATE THE STORAGE AREA FOR THE H LOOK UP TABLE
      IREC=1002
      K=KCHNFL(JZ+1)
      M=-1
      N=JS
      IREC=1003
C--FETCH THE NEXT LINK IN THE H CHAIN
1650  CONTINUE
      J=ISTORE(J)
C--CHECK FOR THE END OF THE CHAIN
      IF(J)1900,1900,1700
C--CHECK IF THIS IS THE NEXT H VALUE WE REQUIRE
1700  CONTINUE
      M=M+1
      IF(ISTORE(J-1)-M)1850,1750,1800
C--THIS IS THE NEXT H VALUE THAT WE REQUIRE
1750  CONTINUE
      ISTORE(N)=NFL-ISTORE(J-4)
      K=KCHNFL(ISTORE(J-3)-ISTORE(J-4)+1)
      N=N+1
      GOTO 1650
C--THIS IS NOT AN H VALUE FOR WHICH THERE IS AN ENTRY IN THE CHAIN
1800  CONTINUE
      ISTORE(N)=NOWT
      N=N+1
      GOTO 1700
C--ERROR BECAUSE THE H CHAIN IS OUT OF STEP
1850  CONTINUE
      STOP 160
C
C--RESET 'LFL' AND ALLOCATE THE MAP STORAGE AREA
1900  CONTINUE
      KB=LFL
      LFL=KA
C--COMPUTE THE SIZE NEEDED FOR EACH FOURIER SECTION
      N8=MD8*JG
      K=0
      J=1
C--CHECK FOR A MAP SCAN
      IF(ISCAN)2000,1950,1950
C--THERE IS TO BE A MAP SCAN
1950  CONTINUE
      K=1
      J=3
C--ALLOCATE MAP SPACE
2000  CONTINUE
      LN=8
      IREC=101
      L8=KCHLFL(N8*J)
C--SET THE FLAGS TO THE VARIOUS MAP SECTIONS
      L81=L8
      L82=L81+N8*K
      L83=L82+N8*K
      KC=MD8-JX
C--NOW SET 'LFL' SO THAT IT IS THE MINIMUM OF ITSELF AND 'KB'
      LFL=MIN0(LFL,KB)
C--SET UP THE Y PARTIAL SUM AREA
      KN=MD8+MD8
      IREC=1004
      KV=KCHLFL(KN)
C--COMPUTE THE NUMBER OF Z LAYERS WE CAN GET IN CORE AT ONE TIME
      JZ=MIN0((LFL-NFL-MD10-JY*JW)/(JY*2),JI)
      MDM=LFL-NFL
C--CHECK THAT WE CAN GET AT LEAST ONE LAYER IN CORE
      IF ( JZ  )  9910 , 9910 , 2200
C--SET UP THE ENTRIES FOR EACH 'HK' PAIR
2200  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2250)JZ
      ENDIF
2250  FORMAT(//34H Number of section(s) per scan is ,I3)
      JZ=JZ+JZ
      JT=NFL
      JV=JW+JZ
      JU=JT+(JY-1)*JV
      IREC=1005
C--FETCH THE NEXT LINK ON THE H CHAIN
2300  CONTINUE
      I=ISTORE(I)
C--CHECK FOR THE END OF THE H CHAIN
      IF(I)2500,2500,2350
C--START PROCESSING THE K CHAIN  -  FIND THE ADDRESS OF THE K TABLE
2350  CONTINUE
      J=ISTORE(I-1)+JS
      J=ISTORE(J)
      K=I-2
C--FETCH THE NEXT LINK IN THE  K CHAIN
2400  CONTINUE
      K=ISTORE(K)
C--CHECK FOR THE END OF THE CHAIN
      IF(K)2300,2300,2450
C--SET THE ENTRY FOR THIS VALUE OF K
2450  CONTINUE
      L=ISTORE(K-1)+J
C--SET THE ADDRESS IN THE K TABLE
      ISTORE(L)=NFL
C--STORE THE 'H' VALUE
      JSTORE(NFL)=ISTORE(I-1)
C--STORE THE 'K' VALUE
      JSTORE(NFL+1)=ISTORE(K-1)
      L=KCHNFL(JV)
      GOTO 2400
C
C--SET UP A DUMMY LAST ENTRY
2500  CONTINUE
      JSTORE(NFL)=NOWT
      JSTORE(NFL+1)=NOWT
C--ALLOCATE SPACE FOR THE FINAL ENTRY
      L=KCHNFL(JV)
      JZ=JZ-1
      KJ=0
      RETURN
9900  CONTINUE
C -- ERRORS
      RETURN
9910  CONTINUE
C -- NOT ENOUGH SPACE
      N = ( JW + 2 ) * JY + NFL - LFL + 1
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 )
      ENDIF
      WRITE ( NCAWU , 9915 )
9915  FORMAT(1X, ' Insufficient memory for 1 layer')
      CALL XOPMSG ( IOPFOU , IOPSPC , N )
      GO TO 9900
C
      END
C
CODE FOR XFOURN
      SUBROUTINE XFOURN
C--SCAN THE REFLECTIONS TO SET UP THE 'KH' TABLE FOR THE NEXT SECTIONS
C
C--
      DOUBLE PRECISION B
      DIMENSION FSTORE(131072),JSTORE(131072)
      DIMENSION MINW(3),ISTEP(3),MAXW(3),NUM(3),NUN(3),
     2 IAS(3),IAC(3),MXC(3)
      DIMENSION ISTORE(131072)
C
C
      DIMENSION RFL(3)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XPROCS/NTYP,NE,NWT,IPRINT,THRES1,THRES2,IALL,NLINE,NCHAR,
     2 NCHARC,NSPACE,ISCAN,HEIGHT,NPEAK,INTAPE,IOUTAP,F000,ISC,SCLCON,
     3 REJECT,APEAKH , NGMAP, IFCALC, IPKMON
      COMMON/XWORKC/IAXIS(3),NV,IXYZ(3),SCALE,SS,SC,VOL,
     2 NORFL,L6DUMP,N6DUMP,SSV,SSU,HWMIN(6,2),AAA,BBB,CCC,DDD,
     3 L81,L82,L83,N10MAX,NY,NZ,NYNZ,NY2,NYM2,NYNZM2, DENMIN,
     4 IPMAP, IEMAP, DENMAX
      COMMON/XWORKD/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,
     3 KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,KL,KM,KN,KO,KP,KQ,
     4 KR,KS,KT,KU,KV,KW,KX,KY,KZ,
     5 MA,MB,MC,MD,ME,MF,MG,MH,MI,MJ,MK,ML,MM,MN,MO,MP,MQ,
     6 MR,MS,MT,MU,MV,MW,MX,MY,MZ
      COMMON/XLST08/L8,M8,MD8,N8
      COMMON/XLST10/L10,M10,MD10,N10,L10A,M10A,MD10A,N10A
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST14/L14,M14,MD14,N14, L14O,M14O,MD14O,N14O,
     2 L14SC,M14SC,MD14SC,N14SC, L14P,M14P,MD14P,N14P
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
      COMMON/XLST29/L29,M29,MD29,N29
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (FSTORE(1),STORE(1)),(ISTORE(1),JSTORE(1))
      EQUIVALENCE (JA,MINW(1)),(JD,NUN(1)),(JG,NUM(1)),(JJ,IAC(1))
      EQUIVALENCE (JM,IAS(1)),(JP,MXC(1)),(KF,ISTEP(1)),(KX,MAXW(1))
C
C
      EQUIVALENCE (IX,IAXIS(1)),(IY,IAXIS(2)),(IZ,IAXIS(3))
C
C     I1/I0 BESSEL FUNCTION RATIO FROM MULTAN
      VEC(U) = U*(U + 0.4807)/((U + 0.8636)*U + 1.3943)
C
C----- INITIALISE SUM WEIGHTED FO AND FO
      SSU = 0.0
      SST = 0.0
C----- SYMMETRY DEPENDANT MULTIPLICITY
      SSC = (G2 * FLOAT(N2) ) / FLOAT(2-IC)
C--ZERO THE ACCUMULATION AREA FOR THE HK PAIRS
      W=0.
      DO 1050 I=JT,JU,JV
      K=I+JW
      L=K+JZ
      DO 1000 M=K,L
      FSTORE(M)=0.
1000  CONTINUE
1050  CONTINUE
      NORFL=0
      KB=KJ*KH+JC
C--SET UP THE ENTRIES IN THE 'HK' STACK FOR THE NEXT FEW LAYERS
1100  CONTINUE
      IF(KFOURC(I))3050,1150,1150
C--GENERATE THE EQUIVALENT REFLECTIONS FOR THESE INDICES
1150  CONTINUE
      KS=KR
      A=0.
      DO 1500 I=L2I,M2I,MD2I
C--CALCULATE THE NEW INDICES
      RFL(1)=STORE(M6)*STORE(I)+STORE(M6+1)*STORE(I+3)+STORE(M6+2)
     2 *STORE(I+6)
      RFL(2)=STORE(M6)*STORE(I+1)+STORE(M6+1)*STORE(I+4)+STORE(M6+2)
     2 *STORE(I+7)
      RFL(3)=STORE(M6)*STORE(I+2)+STORE(M6+1)*STORE(I+5)+STORE(M6+2)
     2 *STORE(I+8)
      J=KS
      K=KS+KU
C--FIX AND STORE THIS SET OF EQUIVALENT INDICES
      DO 1200 L=1,3
      ISTORE(J)=NINT(RFL(L))
      ISTORE(K)=-ISTORE(J)
      J=J+1
      K=K+1
1200  CONTINUE
C--COMPUTE THE PHASE SHIFT FOR THIS SET OF EQUIV. INDICES
      STORE(KS+3)=-TWOPI*(RFL(1)*STORE(I+9)+RFL(2)*STORE(I+10)+RFL(3)
     2 *STORE(I+11))
C--COMPUTE THE LAUE GROUP MULTIPLICITY FOR THIS REFLECTION
      KT=KS+KU
C--LOOP OVER THE NEW INDICES AND THEIR FRIEDEL RELATED SET
      DO 1350 J=KS,KT,KU
      IF(ISTORE(J)-ISTORE(KR))1350,1250,1350
1250  CONTINUE
      IF(ISTORE(J+1)-ISTORE(KR+1))1350,1300,1350
1300  CONTINUE
      IF(ISTORE(J+2)-ISTORE(KR+2))1350,1400,1350
1350  CONTINUE
      GOTO 1450
C--THIS GROUP DUPLICATES THE FIRST SET OF EQUIVALENT INDICES
1400  CONTINUE
      A=A+1.
C--UPDATE FOR THE NEXT SET OF EQUIVALENT INDICES
1450  CONTINUE
      KS=KS+KU+KU
1500  CONTINUE
      A=1./A
C
C--CHECK IF THE NEXT REFLECTION SHOULD BE WEIGHTED
      U=STORE(M6+3)/SCALE
C----- SUM FO
      SST = SST + U
      V=STORE(M6+5)
      IF(NWT)1550,2300,1850
C--SIM WEIGHTED FOURIER  -  CALCULATE THE WEIGHT TERM
1550  CONTINUE
C----- SET DEFAULT TO CENTRO-SYMMETRIC SIM WEIGHTING
      ISMWT = 1
      STORE(M6+4) = 1.
C--COMPUTE THE SIM WEIGHT MULTILPIER
C----- GET SINTH/LAM**2 AND HENCE SIG (F**2)
      SSW = SNTHL2(IN)
C----- GET AN AVERAGE TEMPERATURE FACTOR CORRECTION
      BT = EXP(4.*SSW)
      SSW = SQRT( SSW)
      CALL XSCATT(SSW)
      SSW=0.
      M29=L29
C--FORM THE SUM OF THE SQUARES OF THE FORM FACTORS
      DO 1555 I=1,N29
      J=L3TR+ISTORE(M29)*MD3TR
      SSW= SSW + STORE(M29+2) * STORE(J) * STORE(J)
      M29=M29+MD29
1555  CONTINUE
      SSW = SSW * SSC * BT
      IF (SSW .LE. ZERO)   GOTO 1700
      B = U * V / SSW
C--CHECK IF THE STRUCTURE IS CENTRO OR NOT
      IF(IC)1600,1600,1650
C--NON-CENTRO STRUCTURE
1600  CONTINUE
C----- MODIFY WEIGHTS FOR OPTIMAL MAPS
      IF (NTYP .EQ. 5) THEN
C----   CHECK IF ALMOST CENTRO
        Q = STORE(M6+6)/PI + 2.
        Q = Q - AINT(Q)
C-----  CHECK LE 12 DEGREES ( IN RADIANS)
        IF (Q .LE. .07) GOTO 1650
        ISMWT = -1
      ENDIF
      B = 2.* B
      IF (B .GT. 6.) GOTO 1700
C----- ACCCEPT A SOFT FAILURE
      IFAIL = 1
      STORE(M6+4)=S18AFF(B,IFAIL)/S18AEF(B,IFAIL)
C----- SIMPLER CALC USING FUNCTION STATEMENT FROM MULTAN
C      STORE(M6+4) = VEC(B)
      GOTO 1700
C
C--CENTRO STRUCTURE
1650  CONTINUE
      STORE(M6+4)=TANH(B)
C
C--CHECK FOR MAX. AND MIN. WEIGHTS
1700  CONTINUE
      I=2
      IF(STORE(M6+4)-HWMIN(6,2))1750,1750,1800
C--CHECK FOR A NEW MINIMUM
1750  CONTINUE
      I=1
      IF(STORE(M6+4)-HWMIN(6,1))1800,2250,2250
C--NEW WEIGHT LIMIT
1800  CONTINUE
      HWMIN(IX,I)=STORE(M6)
      HWMIN(IY,I)=STORE(M6+1)
      HWMIN(IZ,I)=STORE(M6+2)
      HWMIN(4,I)=U
      HWMIN(5,I)=V
      HWMIN(6,I)=STORE(M6+4)
      U = U * STORE(M6+4)
C----- IF 'OPTIMAL' DONT WEIGHT FC
      IF (NTYP .NE. 5) V = V * STORE(M6+4)
      GOTO 2300
C--WEIGHTS FROM LIST 6  -  CHECK IF THIS IS AN E-MAP
1850  CONTINUE
      IF (NTYP .NE. IEMAP) GOTO 2250
C--THIS IS AN E-MAP  -  COMPUTE THE WEIGHTS
      B=0.
      KS=KR
      DO 2200 I=L2I,M2I,MD2I
      KT=KS+KU*IC
C--LOOP OVER THE NECESSARY NUMBER OF REFLECTIONS
      DO 2050 J=KS,KT,KU
      IF(ISTORE(J)-ISTORE(KR))2050,1950,2050
1950  CONTINUE
      IF(ISTORE(J+1)-ISTORE(KR+1))2050,2000,2050
2000  CONTINUE
      IF(ISTORE(J+2)-ISTORE(KR+2))2050,2100,2050
2050  CONTINUE
      GOTO 2150
C--THIS REFLECTION DUPLICATES THE FIRST SET OF EQUIVALENT INDICES
2100  CONTINUE
      B=B+1.
2150  CONTINUE
      KS=KS+KU+KU
2200  CONTINUE
      STORE(M6+4)=SQRT(B)
C--COMPUTE THE WEIGHTED MULTIPLICITY TERM
2250  CONTINUE
      U=U*STORE(M6+4)
      V=V*STORE(M6+4)
2300  CONTINUE
C---- SUM THE (NOW POSSIBLY WEIGHTED) FO
      SSU = SSU + U
C--LOOP OVER EACH EQUIVALENT AND ADD IN ITS CONTRIBUTION
      KS=KR
      DO 3000 I=L2I,M2I,MD2I
C--BRANCH ON THE TYPE OF FOURIER
      GOTO (2450, 2500, 2550, 2555, 2557,
     1 2600, 2650, 2657, 2658, 2500, 2400), NTYP
2400  STOP 265
C--'FO' FOURIER
2450  CONTINUE
      F=U
      GOTO 2750
C--'FC' FOURIER
2500  CONTINUE
      F=V
      GOTO 2750
C--'DF' FOURIER
2550  CONTINUE
      F=U-V
      GOTO 2750
C----- 2Fo - FC MAP
2555  CONTINUE
      F = 2.*U - V
      GOTO 2750
C----- OPTIMAL - WTD FO OR WTD 2 FO - FC
2557  CONTINUE
      IF (ISMWT .GT. 0) THEN
            F = U
      ELSE
            F = 2.*U - V
      ENDIF
      GOTO 2750
C--'FO' PATTERSON
2600  CONTINUE
      F=U*U
      GOTO 2700
C--'FC' PATTERSON
2650  CONTINUE
      F=V*V
      GOTO 2700
2657  CONTINUE
C---- (FO-FC)**2 PATTERSON
      F = (U-V)**2
      GOTO 2700
2658  CONTINUE
C----- FO**2 - FC**2 PATTERSON
      F = U*U - V*V
      GOTO 2700
C--ACCUMULATE THE ORIGIN FOR SCALING
2700  CONTINUE
      F=F*A
      P=F
      Q=0.
      GOTO 2800
C--COMPUTE A AND B
2750  CONTINUE
      H=STORE(M6+6)+STORE(KS+3)
      F=F*A
      P=F*COS(H)
      Q=F*SIN(H)
C--SUM THE TERMS USED
2800  CONTINUE
      W=W+F
C--ADD IN THE CONTRIBUTIONS FOR THIS 'HK' PAIR
      S=1.
      L=ISTORE(KS)
      M=ISTORE(KS+1)
C--CHECK THE SIGN OF  'H'
      IF(L)2850,2900,2900
C--'H' IS NEGATIVE
2850  CONTINUE
      L=-L
      M=-M
      S=-1.0
C--FIND THE ADDRESS OF THE 'H' AND 'K' TABLES
2900  CONTINUE
      L=L+JS
      K=ISTORE(L)+M
      K=ISTORE(K)+JW
C--COMPUTING THE STARTING POINT FOR THIS Z LAYER
      KL=KB*ISTORE(KS+2)
      KM=KH*ISTORE(KS+2)
C--LOOP OVER EACH SECTION TO BE COMPUTED IN THIS PASS
      DO 2950 L=1,JZ,2
      N=MOD(KL,JF)+JL
      M=N+JO
      FSTORE(K)=FSTORE(K)+P*STORE(N)+Q*STORE(M)
      FSTORE(K+1)=FSTORE(K+1)+S*(Q*STORE(N)-P*STORE(M))
      K=K+2
      KL=KL+KM
2950  CONTINUE
      KS=KS+KU+KU
3000  CONTINUE
      GOTO 1100
C
C--PROCESS THE NEXT GROUP OF SECTIONS
3050  CONTINUE
      SC=0.
      IF(W-ZERO)3070,3060,3060
3060  CONTINUE
      SC=SCLCON/W
C--CHECK FOR SCALE FACTOR FROM LIST 14
3070  CONTINUE
      IF(ISC)3100,3100,3150
3100  CONTINUE
      SC=STORE(L14SC)*2.0/VOL
C--INCREMENT THE SCAN COUNTER
3150  CONTINUE
      SS=SC*VOL*0.5
      NV=NV+1
C--PRINT THE NUMBER OF REFLECTIONS USED ON THIS SCAN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3250)N6D,NORFL,NV
      ENDIF
      WRITE(NCAWU,3250)N6D,NORFL,NV
3250  FORMAT(/' Total number if reflections is ',I6,/,
     1        '                       of which ',I6,
     2 ' have been used for scan ',I3)
C--CHECK IF THERE ARE ANY REFLECTIONS
      IF ( NORFL .LE. 0 ) GO TO 9910
C---- PEAK HEIGHT NORMALISATION
      IF (NWT .EQ. 0) THEN
            SSU = 1.
      ELSE
            SSU = SST / SSU
      ENDIF
      KI=JW
      RETURN
9900  CONTINUE
C -- ERRORS
      RETURN
9910  CONTINUE
C -- NO REFLECTIONS
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 )
      ENDIF
      WRITE ( NCAWU , 9915 )
9915  FORMAT ( 1X , 'No reflections for Fourier' )
      CALL XERHND ( IERERR )
      GO TO 9900
C
      END
C
CODE FOR XFOURO
      SUBROUTINE XFOURO
C--LOCATE MAXIMA IN THE FOURIER IF NECESSARY
C
C--
      DIMENSION FSTORE(131072),JSTORE(131072)
      DIMENSION MINW(3),ISTEP(3),MAXW(3),NUM(3),NUN(3),
     2 IAS(3),IAC(3),MXC(3)
      DIMENSION ISTORE(131072)
C
      DIMENSION AMULT(3),SOL1(4,4),SOL2(3,3),SOL3(3,3),P(7),QQ(4),XX(3)
     2 ,RHO(3,3,3)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XPROCS/NTYP,NE,NWT,IPRINT,THRES1,THRES2,IALL,NLINE,NCHAR,
     2 NCHARC,NSPACE,ISCAN,HEIGHT,NPEAK,INTAPE,IOUTAP,F000,ISC,SCLCON,
     3 REJECT,APEAKH , NGMAP, IFCALC, IPKMON
      COMMON/XWORKC/IAXIS(3),NV,IXYZ(3),SCALE,SS,SC,VOL,
     2 NORFL,L6DUMP,N6DUMP,SSV,SSU,HWMIN(6,2),AAA,BBB,CCC,DDD,
     3 L81,L82,L83,N10MAX,NY,NZ,NYNZ,NY2,NYM2,NYNZM2, DENMIN,
     4 IPMAP, IEMAP, DENMAX
      COMMON/XWORKD/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,
     3 KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,KL,KM,KN,KO,KP,KQ,
     4 KR,KS,KT,KU,KV,KW,KX,KY,KZ,
     5 MA,MB,MC,MD,ME,MF,MG,MH,MI,MJ,MK,ML,MM,MN,MO,MP,MQ,
     6 MR,MS,MT,MU,MV,MW,MX,MY,MZ
      COMMON/XLST08/L8,M8,MD8,N8
      COMMON/XLST10/L10,M10,MD10,N10,L10A,M10A,MD10A,N10A
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST14/L14,M14,MD14,N14, L14O,M14O,MD14O,N14O,
     2 L14SC,M14SC,MD14SC,N14SC, L14P,M14P,MD14P,N14P
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (FSTORE(1),STORE(1)),(ISTORE(1),JSTORE(1))
      EQUIVALENCE (JA,MINW(1)),(JD,NUN(1)),(JG,NUM(1)),(JJ,IAC(1))
      EQUIVALENCE (JM,IAS(1)),(JP,MXC(1)),(KF,ISTEP(1)),(KX,MAXW(1))
C
      EQUIVALENCE (P(1),AA),(P(2),AE),(P(3),AF),(P(4),AG)
      EQUIVALENCE (P(5),AB),(P(6),AC),(P(7),AD)
C
C
      DATA AMULT(1)/1.0/,AMULT(2)/0.0/,AMULT(3)/1.0/
C
      DATA SOL1(1,1)/18./,SOL1(1,2)/-10./,SOL1(1,3)/-10./,SOL1(1,4)/
     2 -10./
      DATA SOL1(2,1)/-10./,SOL1(2,2)/11./,SOL1(2,3)/4./,SOL1(2,4)/4./
      DATA SOL1(3,1)/-10./,SOL1(3,2)/4./,SOL1(3,3)/11./,SOL1(3,4)/4./
      DATA SOL1(4,1)/-10./,SOL1(4,2)/4./,SOL1(4,3)/4./,SOL1(4,4)/11./
C
C--COMPUTE THE FRACTIONAL 'Z' FOR THIS SECTION
      Z=STORE(L14+12)-STORE(L14+13)
C--CHECK IF WE SHOULD DO THE PEAK SEARCH
      IF(ISCAN)1950,1000,1050
1000  CONTINUE
      APEAKH = HEIGHT  * SS / SSU
      GOTO 1100
1050  CONTINUE
      APEAKH=HEIGHT
C--CHECK IF WE HAVE CALCULATED 3 SECTIONS YET
1100  IF(KJ-2)1950,1150,1150
C--PASS THROUGH EACH POINT OF THE CENTRAL SECTION
1150  CONTINUE
      X=STORE(L14)
      DO 1910 II = NY , NYNZM2 , NY
      X=X+STORE(L14+1)
      Y=STORE(L14+6)
      DO 1900 IK=1,NYM2
      Y=Y+STORE(L14+7)
      NK=II+IK
      M=NK+L82
C----- SAVE THE MINIMUM DENSITY
      DENMIN = MIN (DENMIN, FSTORE(M))
      DENMAX = MAX(DENMAX, FSTORE(M))
C--CHECK IF THE CENTRAL POINT IS GREATER THAN THE MINIMUM REQUIRED
      IF(FSTORE(M)-APEAKH)1900,1200,1200
C--POINTER TO THE LAYER BELOW
1200  CONTINUE
      L=NK+L83
C--POINTER TO THE LAYER ABOVE
      N=NK+L81
      LM=L-NY
      LN=L+NY
      NA=M-NY
      NB=M+NY
      NM=N-NY
      NN=N+NY
C--COMPUTE THE MAXIMUM OF THE NEAREST 19 POINTS
      W=AMAX1(FSTORE(L),FSTORE(M),FSTORE(N),FSTORE(M-1),FSTORE(M+1),
     2 FSTORE(NA),FSTORE(NB))
      Q=AMAX1(W,FSTORE(N+1),FSTORE(N-1),FSTORE(L+1),FSTORE(L-1),
     2 FSTORE(NA+1),FSTORE(NA-1))
      W=AMAX1(Q,FSTORE(NB-1),FSTORE(NB+1),FSTORE(LN),FSTORE(LM),
     2 FSTORE(NN),FSTORE(NM))
C--CHECK IF THE MAXIMUM IS GREATER THAN THE CENTRAL POINT
      IF(FSTORE(M)-W+0.01)1900,1250,1250
C--TRY THE LEAST SQUARES FIT FIRST
1250  CONTINUE
      M10=L10+MD10*N10
      A=1.+VALUSQ
C--SET UP THE DENSITY VALUES
      RHO(1,1,1)=A
      RHO(2,1,1)=FSTORE(L-1)
      RHO(3,1,1)=A
      RHO(1,2,1)=FSTORE(LM)
      RHO(2,2,1)=FSTORE(L)
      RHO(3,2,1)=FSTORE(LN)
      RHO(1,3,1)=A
      RHO(2,3,1)=FSTORE(L+1)
      RHO(3,3,1)=A
C
      RHO(1,1,2)=FSTORE(NA-1)
      RHO(2,1,2)=FSTORE(M-1)
      RHO(3,1,2)=FSTORE(NB-1)
      RHO(1,2,2)=FSTORE(NA)
      RHO(2,2,2)=FSTORE(M)
      RHO(3,2,2)=FSTORE(NB)
      RHO(1,3,2)=FSTORE(NA+1)
      RHO(2,3,2)=FSTORE(M+1)
      RHO(3,3,2)=FSTORE(NB+1)
C
      RHO(1,1,3)=A
      RHO(2,1,3)=FSTORE(N-1)
      RHO(3,1,3)=A
      RHO(1,2,3)=FSTORE(NM)
      RHO(2,2,3)=FSTORE(N)
      RHO(3,2,3)=FSTORE(NN)
      RHO(1,3,3)=A
      RHO(2,3,3)=FSTORE(N+1)
      RHO(3,3,3)=A
C--CONVERT TO LOGS
      DO 1450 I=1,3
      DO 1400 J=1,3
      DO 1350 K=1,3
C--CHECK IF THE RHO VALUE IS LESS THAN 1.
      IF(RHO(K,J,I)-1.)1800,1300,1300
C--TAKE LOGS
1300  CONTINUE
      RHO(K,J,I)=ALOG(RHO(K,J,I))
1350  CONTINUE
1400  CONTINUE
1450  CONTINUE
C--COMPUTE THE 'B', 'C', AND 'D' TERMS
      AB=0.
      AC=0.
      AD=0.
      DO 1550 I=1,3
      DO 1500 J=1,3
      AB=AB+RHO(3,J,I)-RHO(1,J,I)
      AC=AC+RHO(J,3,I)-RHO(J,1,I)
      AD=AD+RHO(J,I,3)-RHO(J,I,1)
1500  CONTINUE
1550  CONTINUE
      AB=0.1*AB
      AC=0.1*AC
      AD=0.1*AD
C--COMPUTE THE 'H', 'K' AND 'L' TERMS
      AH=0.25*(RHO(2,1,1)-RHO(2,1,3)-RHO(2,3,1)+RHO(2,3,3))
      AK=0.25*(RHO(1,2,1)-RHO(1,2,3)-RHO(3,2,1)+RHO(3,2,3))
      AL=0.25*(RHO(1,1,2)-RHO(1,3,2)-RHO(3,1,2)+RHO(3,3,2))
C--COMPUTE THE 'Q' TERMS
      CALL XZEROF(QQ(1),4)
      DO 1700 I=1,3
      DO 1650 J=1,3
      DO 1600 K=1,3
      QQ(1)=QQ(1)+RHO(K,J,I)
      QQ(2)=QQ(2)+RHO(K,J,I)*AMULT(K)
      QQ(3)=QQ(3)+RHO(K,J,I)*AMULT(J)
      QQ(4)=QQ(4)+RHO(K,J,I)*AMULT(I)
1600  CONTINUE
1650  CONTINUE
1700  CONTINUE
C--SOLVE THE EQUATIONS
      CALL XMLTMM(SOL1,QQ,P,4,4,1)
      CALL XDVDR(P,42.,P,4)
C--SOLVE FOR THE ATOMIC COORDINATES
      SOL2(1,1)=-(AE+AE)
      SOL2(1,2)=-AL
      SOL2(2,1)=-AL
      SOL2(1,3)=-AK
      SOL2(3,1)=-AK
      SOL2(2,2)=-(AF+AF)
      SOL2(2,3)=-AH
      SOL2(3,2)=-AH
      SOL2(3,3)=-(AG+AG)
      IF(KINV2(3,SOL2,SOL3,9,1,P(5),XX,3))1800,1750,1800
1750  CONTINUE
C -- L.S. FIT MADE TO PEAK. CALCULATE NEW X,Y,Z
      STORE(M10+1)=X+XX(1)*STORE(L14+1)
      STORE(M10+2)=Y+XX(2)*STORE(L14+7)
      STORE(M10+3)=Z+XX(3)*STORE(L14+13)
C -- IF THE CALCULATED POSITION OF THE PEAK IS UNREASONABLE, GO ON TO
C    INTERPOLATION
      IF ( KFRRSN ( XX, STORE(M10+1), STORE(M10+2), STORE(M10+3), 0 )
     1  .LT. 0 ) GO TO 1800
      STORE(M10)=EXP(AA+XX(1)*(AB+XX(1)*AE)+XX(2)*(AC+XX(2)*AF)+XX(3)
     2 *(AD+XX(3)*AG)+AH*XX(2)*XX(3)+AK*XX(1)*XX(3)+AL*XX(1)*XX(2))
      STORE(M10)= STORE(M10) * SSU
      ISTORE(M10+4)=1
      GOTO 1850
C--COMPUTE THE TERMS OF THE PARABOLIC INTERPOLATION
1800  Q=FSTORE(M)+FSTORE(M)
      U=FSTORE(L)-FSTORE(N)
      V=FSTORE(M-1)-FSTORE(M+1)
      W=FSTORE(NA)-FSTORE(NB)
      R=U/(FSTORE(N)+FSTORE(L)-Q)
      S=V/(FSTORE(M-1)+FSTORE(M+1)-Q)
      T=W/(FSTORE(NA)+FSTORE(NB)-Q)
C--COMPUTE THE AVERAGE INTERPOLATED PEAK HEIGHT
      Q=FSTORE(M)-(U*R+V*S+W*T)*.041667
C--COMPUTE THE NEW 'X', 'Y' AND 'Z' COORDINATES OF THE PEAK
      XX(1) = 0.5 * T
      XX(2) = 0.5 * S
      XX(3) = 0.5 * R
      STORE(M10) = Q * SSU
      STORE(M10+1)=X+0.5*STORE(L14+1)*T
      STORE(M10+2)=Y+0.5*STORE(L14+7)*S
      STORE(M10+3)=Z+0.5*STORE(L14+13)*R
      ISTORE(M10+4)=2
      IF ( KFRRSN ( XX, STORE(M10+1), STORE(M10+2), STORE(M10+3), 0 )
     1  .LT. 0 ) THEN
C----- L-S AND INTERPOLATION FAIL - SET TO MAXIMUM
        STORE(M10)   = FSTORE(M)
        STORE(M10+1) = X
        STORE(M10+2) = Y
        STORE(M10+3) = Z
        ISTORE(M10+4) = 3
      END IF
C--SORT THE PEAKS INTO ORDER
1850  CONTINUE
C
      N10=N10+1
      CALL XSHELR(STORE(L10),MD10,1,N10,MD10*N10,STORE(NFL))
      N10=MIN0(N10,N10MAX)
1900  CONTINUE
1910  CONTINUE
C
C
C--CHECK IF THERE ARE ANY ATOMS IN LIST 5 TO CHECK
1950  CONTINUE
      IF(N10A)2200,2200,2000
C--CHECK FOR ANY ATOMS ON THIS SECTION
2000  CONTINUE
      M10A=L10A
C--PASS THROUGH ALL THE ATOMS
      DO 2150 NC=1,N10A
      IF(KJ-ISTORE(M10A+6))2100,2050,2100
C--WE ARE ON THE RIGHT SECTION FOR THIS ATOM
2050  CONTINUE
      I=MIN0(NUM(1)-2,MAX0(1,NINT((STORE(M10A+2)-STORE(L14))/
     2 STORE(L14+1))))
      K=MIN0(NUM(2)-2,MAX0(1,NINT((STORE(M10A+3)-STORE(L14+6))/
     2 STORE(L14+7))))
      NK=I*NY+K
C--SECTION POINTERS
      L=NK+L83
      M=NK+L82
      N=NK+L81
C--DIFFERENT ROW POINTERS
      NA=M-NY
      NB=M+NY
C--INITIAL CONSTANTS
      T=(STORE(M10A+2)-STORE(L14))/STORE(L14+1)-FLOAT(I)
      S=(STORE(M10A+3)-STORE(L14+6))/STORE(L14+7)-FLOAT(K)
      R=(STORE(M10A+4)-Z)/STORE(L14+13)
C--DOUBLE THE CENTRAL MAP POINT
      Q=FSTORE(M)+FSTORE(M)
C--INTERPOLATE THE HEIGHT OF THE GIVEN ATOM
      STORE(M10A+5)=FSTORE(M)+0.5/3.0*(T*(T*(FSTORE(NA)+FSTORE(NB)-Q)
     2 -FSTORE(NA)+FSTORE(NB))+S*(S*(FSTORE(M+1)+FSTORE(M-1)-Q)
     3 -FSTORE(M-1)+FSTORE(M+1))+R*(R*(FSTORE(N)+FSTORE(L)-Q)-FSTORE(L)
     4 +FSTORE(N)))
      STORE(M10A+5) = SSU * STORE(M10A+5)
2100  CONTINUE
      M10A=M10A+MD10A
2150  CONTINUE
2200  CONTINUE
      RETURN
      END
C
CODE FOR XFOURP
      SUBROUTINE XFOURP(LNOUT)
C--OUTPUT THE RESULTS OF THE PEAK SEARCH TO THE DISC
C
C  LNOUT  THE TYPE OF LIST OUTPUT, USUALLY A LIST TYPE 10.
C
C--
      DIMENSION FSTORE(131072),JSTORE(131072)
      DIMENSION MINW(3),ISTEP(3),MAXW(3),NUM(3),NUN(3),
     2 IAS(3),IAC(3),MXC(3)
      DIMENSION ISTORE(131072)
      DIMENSION ICOM05(40)
C
C
      DIMENSION BLANK(1) , ACCUR(3)
C
      CHARACTER*16 CFOUND
      CHARACTER*12 CFIT(3)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XPROCS/NTYP,NE,NWT,IPRINT,THRES1,THRES2,IALL,NLINE,NCHAR,
     2 NCHARC,NSPACE,ISCAN,HEIGHT,NPEAK,INTAPE,IOUTAP,F000,ISC,SCLCON,
     3 REJECT,APEAKH , NGMAP, IFCALC, IPKMON
      COMMON/XWORKC/IAXIS(3),NV,IXYZ(3),SCALE,SS,SC,VOL,
     2 NORFL,L6DUMP,N6DUMP,SSV,SSU,HWMIN(6,2),AAA,BBB,CCC,DDD,
     3 L81,L82,L83,N10MAX,NY,NZ,NYNZ,NY2,NYM2,NYNZM2, DENMIN,
     4 IPMAP, IEMAP, DENMAX
      COMMON/XWORKD/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,
     3 KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,KL,KM,KN,KO,KP,KQ,
     4 KR,KS,KT,KU,KV,KW,KX,KY,KZ,
     5 MA,MB,MC,MD,ME,MF,MG,MH,MI,MJ,MK,ML,MM,MN,MO,MP,MQ,
     6 MR,MS,MT,MU,MV,MW,MX,MY,MZ
      COMMON/XLST08/L8,M8,MD8,N8
      COMMON/XLST10/L10,M10,MD10,N10,L10A,M10A,MD10A,N10A
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XDSTNC/AT,AC,BT,BC,BP,AP,AO,IDIST,LBOX,MBOX,MDBOX,NBOX,
     2 LFNVC,MFNVC,MDFNVC,NFNVC,MFNVCA
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST14/L14,M14,MD14,N14, L14O,M14O,MD14O,N14O,
     2 L14SC,M14SC,MD14SC,N14SC, L14P,M14P,MD14P,N14P
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (FSTORE(1),STORE(1)),(ISTORE(1),JSTORE(1))
      EQUIVALENCE (JA,MINW(1)),(JD,NUN(1)),(JG,NUM(1)),(JJ,IAC(1))
      EQUIVALENCE (JM,IAS(1)),(JP,MXC(1)),(KF,ISTEP(1)),(KX,MAXW(1))
      EQUIVALENCE (L5,ICOM05(1))
C
C
      EQUIVALENCE (IB,BLANK(1))
C
C
C
      DATA CFIT / 'Good Shape  ' , 'Poor Shape  ' , 'Dubious Peak' /
C
      DATA CFOUND / '  Not in the map' /
      DATA LFOUND / 16 /
C
C--COMPUTE THE ACCURACY TERMS FOR THE COORDS.
      M14=L14
      DO 1000 I=1,3
      ACCUR(I)=0.01*STORE(M14+1)
      M14=M14+MD14
1000  CONTINUE
C--SORT OUT LIST 14 TO CALCULATE THE MAP COORDINATES
      CALL XUSWOP(IAXIS,STORE(L14+3),3*MD14,MD14,1,BPD(10),3,1,1,1)
C--SET UP THE INITIAL GUESS OF A LIST AS 10
      LNOUT=10
C--SET THE LENGTH OF THE COMMON BLOCK FOR LIST 5
      IDIM05=40
C--CHECK IF WE HAVE FOUND ANY PEAKS
      IF(N10)2550,2550,1050
C--BRANCH ON THE FOURIER TYPE
1050  CONTINUE
      IF (NTYP .LT. IPMAP) GOTO 1150
C--OLD ATOMS ARE NOT REQUIRED  -  DELETE THEM IF NECESSARY
      N10A=0
      ORGOCC=1.
C--BRING DOWN THE OLD LIST 5 IF THIS IS POSSIBLE
1150  CONTINUE
C----- GET THE MAP SIGN
      SMAP = FLOAT(NGMAP)
      IF(KEXIST(5))1200,1200,1250
C--NO LIST 5 TO USE  -  SET UP A COMPLETELY NEW LIST
1200  CONTINUE
      CALL XZEROF(ICOM05(1),IDIM05)
      N5=N10A+N10
      CALL XCELST(LNOUT,ICOM05,IDIM05)
      MD5A=MD5
C--OUTPUT THE CAPTIONS FOR THE PEAK SEARCH DATA
      CALL XPRTCN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1300)LNOUT,SS,APEAKH,N10MAX
      ENDIF
      GOTO 1750
C
C--LOAD THE OLD LIST 5
1250  CONTINUE
      CALL XFAL05
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CREATE THE OUTPUT LIST TYPE
      N5=N10+N10A
      NEW=1
      CALL XCPYL5(5,LNOUT,N10A,NEW)
C----- NEED A PRINT?
      IF (IPKMON .GE. 0) THEN
C--CAPTION FOR THE LIST 5 AND PEAK SCAN RESULTS
      CALL XPRTCN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1300)LNOUT,SS,APEAKH,N10MAX
      ENDIF
1300  FORMAT(40H Results of the peak search and contents,
     2 17H of the new list ,I3//20H Map scale factor = ,F10.3,5X,
     3 22HMinimum peak height = ,F10.1,5X,
     4 34HMaximum number of peaks allowed = ,I5//5H Type,3X,6HSerial,
     5 4X,1HX,9X,1HY,9X,1HZ,11X, 6HHeight/)
      WRITE ( NCAWU , 1305 ) LNOUT
1305  FORMAT ( / , 1X , 'Results of the peak search and contents ' ,
     2 'of the new list ' , I3 , // ,
     3 8X , 'Atom' , 10X , 'Height' ,
     4 9X , 'x' , 9X , 'y' , 9X , 'z' , 4X , 'Fit' )
      ENDIF
C--CHECK IF WE SHOULD PRINT DETAILS OF THE ORIGINAL ATOMS
      IF(N10A)1750,1750,1350
C--LOOP OVER EACH ATOM IN TURN
1350  CONTINUE
      M5=L5
      M5A=NOWT
      M10A=L10A
C--SET THE PEAK HEIGHTS OF THE INPUT ATOMS
      AAA=0.
      BBB=0.00001
C--LOOP OVER THE ORIGINAL ATOMS
      DO 1550 I=1,N10A
      STORE(M5+13)=STORE(M10A+5)
      N = LFOUND
C--CHECK IF WE CAN FIND THIS ATOM ON THIS MAP
      IF(ISTORE(M10A+6))1450,1400,1400
C--ADD IN THE PEAK HEIGHT TO COMPUTE THE MEAN
1400  CONTINUE
      AAA=AAA+STORE(M10A+5)
      BBB=BBB+1.
      N=1
C--UNSWOP THE COORDINATES AND COMPUTE THE MAP POSITION
1450  CONTINUE
      CALL XUSWOP(IAXIS,STORE(M10A+2),3,1,1,APD,3,1,1,1)
      CALL XMLTVR(APD(1),BPD(10),APD(4),3)
C--PRINT THE RESULTS
      IF (IPKMON .GE. 0) THEN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1500)STORE(M5),STORE(M5+1),(APD(J),J=1,3),
     2 STORE(M5+13), CFOUND(1:N)
      ENDIF
1500  FORMAT ( 1X,A4,F8.0,1X,3F10.5,1X,F10.1,2X,A )
      WRITE(NCAWU,1501)STORE(M5),STORE(M5+1),STORE(M5+13),
     1 (APD(J),J=1,3), CFOUND(1:N)
1501  FORMAT ( 6X , A4 , F5.0 , 5X , F8.1 , 3F10.4 , 2X , A )
      ENDIF
C--UPDATE THE POINTERS
      M10A=M10A+MD10A
      M5=M5+MD5
1550  CONTINUE
C--COMPUTE THE MEAN ELECTRON DENSITY AT THE ATOMIC SITE CENTRES
      AAA=AAA/BBB
      CCC=0.
      M10A=L10A
C--COMPUTE THE R.M.S. DEVIATION
      DO 1700 I=1,N10A
      IF(ISTORE(M10A+6))1650,1600,1600
C--ADD IN THIS CONTRIBUTION
1600  CONTINUE
      DDD=STORE(M10A+5)-AAA
      CCC=CCC+DDD*DDD
C--UPDATE THE POINTER
1650  CONTINUE
      M10A=M10A+MD10A
1700  CONTINUE
C--COMPUTE THE R.M.S. VALUE
      DDD=SQRT(CCC/BBB)
C
C--ADD THE DATA FROM THE PEAK SEARCH
1750  CONTINUE
      KE=N10A
      N5=N10A
C--CHECK IF THERE ARE ANY ATOMS TO OUTPUT
      IF(N10)2400,2400,1800
C--SET UP THE AREA FOR THE OUTPUT PEAKS
1800  CONTINUE
      K=L5+MD5*N10A
C--PASS THROUGH THE PEAKS, TRUNCATING TO THE CORRECT ACCURACY
      M10=L10
      DO 1900 I=1,N10
      J=M10
      DO 1850 L=1,3
      STORE(J+1)=ACCUR(L)*FLOAT(NINT(STORE(J+1)/ACCUR(L)))
      J=J+1
1850  CONTINUE
      M10=M10+MD10
1900  CONTINUE
C--SET UP THE FLAGS BEFORE WE PASS THROUGH
      M10=L10
      KD=12
      IDIST=-1
      MD5A=MD5
      MD5=MD10
C--LOOP OVER EACH ATOM FOUND DURING THE PEAK SEARCH
      DO 2350 I=1,N10
C--CHECK IF THIS PEAK HEIGHT IS POSITIVE
      IF(STORE(M10))2300,1950,1950
C--PEAK TO OUTPUT  -  COMPUTE THE COORDINATES
1950  CONTINUE
      N5=N5+1
      CALL XUSWOP(IAXIS,STORE(M10+1),3,1,1,STORE(K+4),3,1,1,1)
C--SET THE PEAK SERIAL NUMBER
      STORE(K+1)=FLOAT(N5-KE)
      STORE(K+2)=ABS(XOCC(M10-3))
      CALL XMLTVR(STORE(K+4),BPD(10),APD(1),3)
C--SET THE PEAK HEIGHT
C----- CORRECT SIGN OF MAP ELEMENTS
      STORE(M10) = SMAP * STORE(M10)
      STORE(K+13)=STORE(M10)
      L=K+2
      N=ISTORE(M10+4)
      IF (IPKMON .GE. 0) THEN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1500)STORE(K),STORE(K+1),( STORE(M+4),M=K,L ),
     2 STORE(K+13), CFIT(N)
      ENDIF
      WRITE(NCAWU,1501) STORE(K),STORE(K+1),STORE(K+13),
     1 ( STORE(M+4),M=K,L ) , CFIT(N)
      ENDIF
      K=K+MD5A
C -- IF PEAK IS UNREASONABLE, MARK AS DELETED
      IF ( N .EQ. 3 ) STORE(M5+3) = -1.
C--CHECK FOR ANY CONTACTS TO THIS PEAK
      M5A=M10-3
      M5=M5A+MD10
      N = KDIST1( N10-I, KC, KD, 0, .2, 0)
C--CHECK IF THERE ARE ANY CONTACTS TO THIS ATOM
      IF(N)2300,2300,2000
C--MARK THE OTHER CONTACTS NOT TO BE USED
2000  CONTINUE
      KC=NFL
C--DELETE THE NEXT PEAK
2050  CONTINUE
      IF(STORE(KC+10)-REJECT)2100,2100,2250
C----- DISTANCE TOO SHORT - REJECT
2100  CONTINUE
      M5=ISTORE(KC)
C----- REJECT ALTOGETHER IF COINCIDENT
      IF (STORE(KC+10) - VALUE) 2210,2210,2110
2110  CONTINUE
C--CHECK IF THIS PEAK HAS ALREADY BEEN DELETED
      IF(STORE(M5+3))2250,2150,2150
C--UNSWOP THE COORDINATES OF THE ATOM TO BE DELETED
2150  CONTINUE
      CALL XUSWOP(IAXIS,STORE(M5+4),3,1,1,APD,3,1,1,1)
      CALL XMLTVR(APD(1),BPD(10),APD(4),3)
C--PRINT THE DELETED MESSAGE
      IF (IPKMON .GE. 0) THEN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2200)(APD(M),M=1,3),STORE(M5+3),STORE(KC+10)
      ENDIF
2200  FORMAT(14X,3F10.5,1X,F10.1,2X,10HRejected, ,F8.6,
     2 18H  angstrom contact)
      ENDIF
2210  CONTINUE
C--MARK THE PEAK AS DELETED
      STORE(M5+3)=-1.
C--UPDATE FOR THE NEXT PEAK
2250  CONTINUE
      KC=KC+KD
      N=N-1
      IF(N)2300,2300,2050
C--UPDATE FOR THE NEXT PEAK
2300  CONTINUE
      M10=M10+MD10
2350  CONTINUE
C--UPDATE THE POINTERS
2400  CONTINUE
      N5=MIN0(N5,KE+NPEAK)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2450)LNOUT,N5
      ENDIF
      WRITE(NCAWU,2450)LNOUT,N5
2450  FORMAT(/14H The new list ,I3,11H  contains ,I5,9H  atom(s))
      MD5=MD5A
      CALL XSTR05(LNOUT,0,NEW)
C--AND NOW RETURN
2500  CONTINUE
      RETURN
C
C--NO PEAKS FOUND  -  SEE IF WE SHOULD OUTPUT A LIST 5 INSTEAD
2550  CONTINUE
      IF(N10A)2600,2600,1250
C--NO ATOMS EITHER  -  NO LIST 10 TO OUTPUT
2600  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2650)
      ENDIF
      WRITE(NCAWU,2650)
2650  FORMAT(//37H No peaks found, so no list 10 formed/)
      CALL XALTES(LNOUT,-1)
      GOTO 2500
C
9900  CONTINUE
C -- ERRORS
      RETURN
C
      END
C
CODE FOR XMLTVR
      SUBROUTINE XMLTVR(A,B,C,N)
C--MULTIPLY THE 'N' ELEMENTS OF 'A' BY THE 'N' ELEMENTS OF 'B'
C  AND STORE THE RESULTS IN 'C'.
C
C  A  THE INPUT VECTOR.
C  B  THE SECOND INPUT VECTOR.
C  C  THE OUTPUT VECTOR.
C  N  THE NUMBER OF ELEMENTS IN 'A' AND 'C'.
C
C--
C
C
      DIMENSION A(N),B(N),C(N)
C
C
C
      DATA I/0/
C
C--CHECK FOR SOME ELEMENTS
      IF(N)1100,1100,1000
1000  CONTINUE
      DO 1050 I=1,N
      C(I)=A(I)*B(I)
1050  CONTINUE
1100  CONTINUE
      RETURN
      END
C
CODE FOR KFOURC
      FUNCTION KFOURC(IN)
C--FETCH THE NEXT REFLECTION FOR A FOURIER
C
C--RETURN VALUES ARE:
C
C  -1  END OF THE REFLECTIONS
C   0  REFLECTION FOUND
C
C--
      DIMENSION FSTORE(131072),JSTORE(131072)
      DIMENSION MINW(3),ISTEP(3),MAXW(3),NUM(3),NUN(3),
     2 IAS(3),IAC(3),MXC(3)
      DIMENSION ISTORE(131072)
C
C
      DIMENSION RFL(3)
      DIMENSION FFILTR(3)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XPROCS/NTYP,NE,NWT,IPRINT,THRES1,THRES2,IALL,NLINE,NCHAR,
     2 NCHARC,NSPACE,ISCAN,HEIGHT,NPEAK,INTAPE,IOUTAP,F000,ISC,SCLCON,
     3 REJECT,APEAKH , NGMAP, IFCALC, IPKMON
      COMMON/XWORKC/IAXIS(3),NV,IXYZ(3),SCALE,SS,SC,VOL,
     2 NORFL,L6DUMP,N6DUMP,SSV,SSU,HWMIN(6,2),AAA,BBB,CCC,DDD,
     3 L81,L82,L83,N10MAX,NY,NZ,NYNZ,NY2,NYM2,NYNZM2, DENMIN,
     4 IPMAP, IEMAP, DENMAX
      COMMON/XWORKD/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,
     3 KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,KL,KM,KN,KO,KP,KQ,
     4 KR,KS,KT,KU,KV,KW,KX,KY,KZ,
     5 MA,MB,MC,MD,ME,MF,MG,MH,MI,MJ,MK,ML,MM,MN,MO,MP,MQ,
     6 MR,MS,MT,MU,MV,MW,MX,MY,MZ
      COMMON/XLST08/L8,M8,MD8,N8
      COMMON/XLST10/L10,M10,MD10,N10,L10A,M10A,MD10A,N10A
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON/XTAPED/LMTW,MMTW,MDMTW,NMTW,LMTR,MMTR,MDMTR,NMTR
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (FSTORE(1),STORE(1)),(ISTORE(1),JSTORE(1))
      EQUIVALENCE (JA,MINW(1)),(JD,NUN(1)),(JG,NUM(1)),(JJ,IAC(1))
      EQUIVALENCE (JM,IAS(1)),(JP,MXC(1)),(KF,ISTEP(1)),(KX,MAXW(1))
C
C
      EQUIVALENCE (IAXIS(1),IX),(IAXIS(2),IY),(IAXIS(3),IZ)
      DATA FFILTR(1)/ 0.0/,  FFILTR(2)/ 0.25/,  FFILTR(3)/ 0.5/
C
C--READ THE REFLECTIONS  -  CHECK FOR AN E-MAP
1000  CONTINUE
      IF (NTYP .EQ. IEMAP) GOTO 1350
      IF(KFNR(0)) 1550,1100,1100
C--CHECK IF THIS MAP REQUIRES THAT /FC/ BE SET
1100  CONTINUE
      IF (NTYP .EQ. IPMAP) GOTO 1250
C--CHECK IF WE SHOULD APPLY THE REJECTION TEST
      IF (IALL .GT. 0) THEN
C----- CHECK FC GREATER THAN A FRATION OF FO, PLUS A RESIDUAL
      IF (ABS(STORE(M6+5))*SCALE .LT.
     1  0.001+ FFILTR(IALL)*ABS(STORE(M6+3))) GOTO 1000
      ENDIF
C--SORT THE INDICES FOR THE DIFFERENT PROJECTIONS
1250  CONTINUE
      RFL(1)=STORE(M6)
      RFL(2)=STORE(M6+1)
      RFL(3)=STORE(M6+2)
C--SORT BACK
1300  CONTINUE
      STORE(M6)=RFL(IX)
      STORE(M6+1)=RFL(IY)
      STORE(M6+2)=RFL(IZ)
      KFOURC=0
      NORFL=NORFL+1
      RETURN
C
C--UNPACK THE E-MAP DATA
1350  CONTINUE
      CALL XIMTRA(MTE)
      IF ( STORE(MMTR) - 0.5 )  1600 , 1450 , 1450
1450  RFL(3)=AINT(0.0001*STORE(MMTR)+0.5)
      X=0.01*STORE(MMTR)-100.*RFL(3)
      RFL(2)=AINT(X+SIGN(0.5,X+0.1))
      X=100.*(X-RFL(2))
      RFL(1)=AINT(X+SIGN(0.5,X+0.1))
      N6D=N6D+1
C--CHECK IF THERE IS A SIN AND COSINE
      IF(ABS(STORE(MMTR+4))+ABS(STORE(MMTR+5))-0.000001)1350,1350,1500
1500  CONTINUE
      STORE(M6+3)=0.
      STORE(M6+4)=1.
      STORE(M6+5)=STORE(MMTR+2)*SQRT(STORE(MMTR+4)*STORE(MMTR+4)
     2 +STORE(MMTR+5)*STORE(MMTR+5))
      STORE(M6+6)=ATAN2(STORE(MMTR+5),STORE(MMTR+4))
      GOTO 1300
C
C--RESET POINTERS TO START OF REFLECTION LIST
1550  L6R=L6DUMP
      N6R=N6DUMP
      GOTO 1650
C--END OF THE E-MAP PROCESSING  -  REPOSITION THE TAPE
1600  CALL ESKIP(NE)
1650  CONTINUE
      KFOURC=-1
      RETURN
      END
C
CODE FOR XFPRT1
      SUBROUTINE XFPRT1
C--INITIALISATION PART OF THE FOURIER PRINTING ROUTINE
C
C  NCN  NUMBER OF CHARACTERS PER GRID NUMBER
C  NLINE   NUMBER OF LINES PER LINE OF THE MAP.
C  NCHAR   NUMBER OF CHARACTERS PER GRID NUMBER
C  NCHARC  NUMBER OF CHARACTERS PER NUMBER DOWN THE MARGINS
C  NSPACE  NUMBER OF SPACES AFTER THE NUMBER DOWN THE MARGIN (MIN 2)
C
C--USEAGE OF VARIABLES :
C
C  MA  NUMBER OF CHARACTERS PER GRID NUMBER.
C  MB  SMALLEST NUMBER THAT WILL NOT FIT INTO 'MA' CHARACTERS.
C  MC  LARGEST NUMBER THAT WILL NOT FIT INTO 'MA' CHARACTERS.
C  MD  NUMBER OF LINES PER ROW OF MAP
C  ME  ADDRESS OF THE MAP COORDINATES ACROSS THE TOP OF THE MAP.
C  MF  NUMBER OF CHARACTERS PER NUMBER DOWN THE MARGIN.
C  MG  NUMBER OF CHARACTERS AFTER A NUMBER DOWN THE MARGIN (MIN = 2).
C  MH  ADDRESS OF THE LAST PIECE OF MARGIN INFORMATION IN THE ARRAY AT '
C  MI  ADDRESS OF THE FIRST PIECE OF INFORMATION AFTER THE MARGIN IN THE
C  MJ  ADDRESS OF THE LINE OF STARS FOR THE NUMBERS AT THE TOP.
C  MK  ADDRESS OF THE LAST BLANK BEFORE THE FIRST '*' IN THE 'ME' ARRAY.
C      (I.E. MH-1).
C  ML  NUMBER OF CHARACTERS ACROSS A PAGE.
C  MM  ADDRESS OF THE BUFFER FOR A LINE OF CHARACTERS.
C  MN  SMALLEST NUMBER THAT WILL NOT FIT INTO 'MF' CHARACTERS.
C  MO  LARGEST NUMBER THAT WILL NOT FIT INTO 'MF' CHARACTERS.
C  MP  MAXIMUM NUMBER OF NUMBERS PER LINE THAT CAN BE PRINTED.
C  MQ  LAST WORD OF THE '*' ARRAY TO BE PRINTED ON THE CURRENT PAGE.
C  MR  LAST WORD OF THE NUMBERS ALONG 'Y' TO BE PRINTED FOR THE CURRENT
C  MS  FIRST WORD OF THE NUMBERS ALONG 'Y' FOR THE CURRENT PAGE.
C  MT  1  MARGIN CAN BE FITTED AT THE END OF THE CURRENT SET OF LINES.
C      0  NO MARGIN CAN BE FITTED IN.
C  MU  NUMBER OF CHARACTERS FOR THE CURRENT SET OF GRID POINTS ON A LINE
C  MV  OFFSET OF THE CURRENT FIRST NUMBER ALONG 'Y'.
C  MW  NUMBER OF GRID POINTS TO PRINT ON A LINE ON THIS PAGE.
C  MX  NUMBER OF GRID POINTS ALREADY PRINTED ON A LINE ON THE CURRENT PA
C  MY  NUMBER OF THE PASS THROUGH EACH SECTION.
C  MZ  NUMBER OF GRID POINTS ON EACH LINE LEFT.
C
C--
      DIMENSION FSTORE(131072),JSTORE(131072)
      DIMENSION MINW(3),ISTEP(3),MAXW(3),NUM(3),NUN(3),
     2 IAS(3),IAC(3),MXC(3)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XPROCS/NTYP,NE,NWT,IPRINT,THRES1,THRES2,IALL,NLINE,NCHAR,
     2 NCHARC,NSPACE,ISCAN,HEIGHT,NPEAK,INTAPE,IOUTAP,F000,ISC,SCLCON,
     3 REJECT,APEAKH , NGMAP, IFCALC, IPKMON
      COMMON/XWORKC/IAXIS(3),NV,IXYZ(3),SCALE,SS,SC,VOL,
     2 NORFL,L6DUMP,N6DUMP,SSV,SSU,HWMIN(6,2),AAA,BBB,CCC,DDD,
     3 L81,L82,L83,N10MAX,NY,NZ,NYNZ,NY2,NYM2,NYNZM2, DENMIN,
     4 IPMAP, IEMAP, DENMAX
      COMMON/XWORKD/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,
     3 KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,KL,KM,KN,KO,KP,KQ,
     4 KR,KS,KT,KU,KV,KW,KX,KY,KZ,
     5 MA,MB,MC,MD,ME,MF,MG,MH,MI,MJ,MK,ML,MM,MN,MO,MP,MQ,
     6 MR,MS,MT,MU,MV,MW,MX,MY,MZ
      COMMON/XLST08/L8,M8,MD8,N8
      COMMON/XLST10/L10,M10,MD10,N10,L10A,M10A,MD10A,N10A
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (FSTORE(1),STORE(1)),(ISTORE(1),JSTORE(1))
      EQUIVALENCE (JA,MINW(1)),(JD,NUN(1)),(JG,NUM(1)),(JJ,IAC(1))
      EQUIVALENCE (JM,IAS(1)),(JP,MXC(1)),(KF,ISTEP(1)),(KX,MAXW(1))
C
C
      EQUIVALENCE (IPAGE(1),NCHPIN),(IPAGE(2),NLNPIN)
      EQUIVALENCE (IPAGE(3),NCHPPG),(IPAGE(4),NLNPPG)
C
C--CHECK IF WE SHOULD SET UP THE PRINT VARIABLES
      IF(IPRINT)1150,1000,1000
C--SET UP THE DEFAULT LIST TYPE
1000  CONTINUE
      LN=8
      IREC=1100
C--SET UP THE GRID POINT NUMBERS
      MA=NCHAR
      MB=10**MA
      MC=-10**(MA-1)
      MD=NLINE
C--SET UP THE MARGIN PARAMETERS
      MF=NCHARC
      MN=10**MF
      MO=-10**(MF-1)
      MG=MAX0(2,NSPACE)
C--SET UP THE TOP OF PAGE NUMBERS
      ME=NFL
      MI=KCHNFL(MF+MG)
C--BLANK OUT THIS AREA
      CALL XMVSPD(IB,ISTORE(ME),MF+MG)
C--RECORD THE POSITION OF THE LAST PIECE OF MARGIN DATA
      MH=MI-1
C--RECORD THE POSITION LAST BLANK BEFORE THE '*'
      MK=MH-1
C--SET UP THE NUMBERS
      MJ=KCHNFL(JH*MA)
      L=JB
      I=MI
      DO 1050 M=1,JH
      L=MOD(L,JE)
      CALL XNUMB(L,I,MA,MB,MC)
      L=L+KG
1050  CONTINUE
C--SET UP THE LINE OF '*' TO PRINT UNDER THE NUMBERS
      I=MJ
      MM=KCHNFL(JH*MA+MG)
      DO 1100 M=1,JH
      CALL XMVSPD(IB,ISTORE(I),MA)
      I=I+MA
      CALL XMVSPD(IA,ISTORE(I-1),1)
1100  CONTINUE
C--A FINAL '*'
      CALL XMVSPD(IB,ISTORE(I),MG)
      I=I+MG
      CALL XMVSPD(IA,ISTORE(I-1),1)
C--SET UP THE LINE BUFFER
      ML=NCHPPG
      I=KCHNFL(ML)
C--COMPUTE THE MAXIMUM NUMBER OF GRID POINTS PER PAGE
      MP=MIN0(JH,(ML-MF-MG)/MA)
1150  CONTINUE
      RETURN
      END
C
CODE FOR XFPRT2
      SUBROUTINE XFPRT2
C--PRINT ROUTINE OF THE FOURIER  -  SECTION IS AT 'L81'
C
C--
      DIMENSION FSTORE(131072),JSTORE(131072)
      DIMENSION MINW(3),ISTEP(3),MAXW(3),NUM(3),NUN(3),
     2 IAS(3),IAC(3),MXC(3)
      DIMENSION ISTORE(131072)
C
C
      CHARACTER *16 CTYPE(10)
      CHARACTER*8 CWEIGH(2), CDENMN(2)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XPROCS/NTYP,NE,NWT,IPRINT,THRES1,THRES2,IALL,NLINE,NCHAR,
     2 NCHARC,NSPACE,ISCAN,HEIGHT,NPEAK,INTAPE,IOUTAP,F000,ISC,SCLCON,
     3 REJECT,APEAKH , NGMAP, IFCALC, IPKMON
      COMMON/XWORKC/IAXIS(3),NV,IXYZ(3),SCALE,SS,SC,VOL,
     2 NORFL,L6DUMP,N6DUMP,SSV,SSU,HWMIN(6,2),AAA,BBB,CCC,DDD,
     3 L81,L82,L83,N10MAX,NY,NZ,NYNZ,NY2,NYM2,NYNZM2, DENMIN,
     4 IPMAP, IEMAP, DENMAX
      COMMON/XWORKD/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,
     3 KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,KL,KM,KN,KO,KP,KQ,
     4 KR,KS,KT,KU,KV,KW,KX,KY,KZ,
     5 MA,MB,MC,MD,ME,MF,MG,MH,MI,MJ,MK,ML,MM,MN,MO,MP,MQ,
     6 MR,MS,MT,MU,MV,MW,MX,MY,MZ
      COMMON/XLST08/L8,M8,MD8,N8
      COMMON/XLST10/L10,M10,MD10,N10,L10A,M10A,MD10A,N10A
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST14/L14,M14,MD14,N14, L14O,M14O,MD14O,N14O,
     2 L14SC,M14SC,MD14SC,N14SC, L14P,M14P,MD14P,N14P
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (FSTORE(1),STORE(1)),(ISTORE(1),JSTORE(1))
      EQUIVALENCE (JA,MINW(1)),(JD,NUN(1)),(JG,NUM(1)),(JJ,IAC(1))
      EQUIVALENCE (JM,IAS(1)),(JP,MXC(1)),(KF,ISTEP(1)),(KX,MAXW(1))
C
C
      EQUIVALENCE (IPAGE(1),NCHPIN),(IPAGE(2),NLNPIN)
      EQUIVALENCE (IPAGE(3),NCHPPG),(IPAGE(4),NLNPPG)
C
C
C
      DATA CDENMN / 'Negated ', '        ' /
      DATA CWEIGH / '        ' , 'Weighted' /
      DATA CTYPE / 'Fobs - map' , 'FC - map' , 'Difference map' ,
     2             '2FO - FC map' , 'Optimal Fo map', 'FO Patterson' ,
     3 'Fc Patterson', '(Fo-Fc)**2 Patt', '(FoSQ-FcSQ) Patt',
     4 'E - map' /
C
C
C--SET UP THE INITIAL FLAGS
      IF (KJ) 1000, 1050, 1000
C--FIRST SECTION  -  PRINT THE MAP TYPE
1050  CONTINUE
      L=2*IABS(NWT)+1
      K=L+1
      J=NTYP+1
      WRITE ( NCAWU , 1100 ) CDENMN((NGMAP+3)/2),
     1 CWEIGH(IABS(NWT)+1) , CTYPE(NTYP)
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1100 ) CDENMN((NGMAP+3)/2),
     1 CWEIGH(IABS(NWT)+1) , CTYPE(NTYP)
      ENDIF
1100  FORMAT ( // 1X , 'Fourier computed is: ',/,
     1  12X , A,A, 1X , A //)
1000   CONTINUE
C---- DO WE WANT A PRINT OUT
      IF (IPRINT) 2250, 1150, 1150
1150  CONTINUE
      MZ=JH
      MY=0
C--CHECK IF THERE IS MORE TO PRINT ON THIS SECTION
1200  CONTINUE
      IF(MZ)2200,2200,1250
C--PRINT THE NEXT PART OF THE CURRENT SECTION
1250  CONTINUE
      MY=MY+1
C--PRINT OUT THE PAGE HEADINGS
      M=NINT(STORE(L14+12)*STORE(L14+15))
      CALL XPRTCN
      L=2*IABS(NWT)+1
      K=L+1
      J=NTYP+1
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,1300) IXYZ,M,MY,CDENMN((NGMAP+3)/2),
     1 CWEIGH(IABS(NWT)+1),CTYPE(NTYP),
     2 SS , NV
      ENDIF
1300  FORMAT ( 1X,A1,' Down,  ',A1, ' Across,  ','Section at ',A1,
     2 ' = ' , I4, ', Part ', I2,/,A, A, 1X, A, 4X, 'Multiplied by',
     3 F11.3, 5X, 'Scan', I3, // )
C--COMPUTE THE NUMBER OF GRID POINTS PER LINE PRINTED ALREADY
      MX=JH-MZ
C--COMPUTE THE NUMBER TO PRINT THIS TIME
      MW=MIN0(MP,MZ)
C--COMPUTE THE NUMBER OF CHARACTERS ALREADY PRINTED
      MV=MX*MA
C--OMPUTE THE NUMBER OF CHARACTER TO PRINT ON ALINE THIS TIME
      MU=MW*MA
      MT=0
C--CHECK IF WE CAN FIT A MARGIN DOWN THE RIGHT HAND SIDE
      IF(2*(MF+MG)+MU-ML)1350,1350,1400
C--A MARGIN DOWN THE RIGHT WILL FIT
1350  CONTINUE
      MT=1
C--PRINT OUT THE INITIAL CAPTIONS ACROSS THE TOP OF THE PAGE
1400  CONTINUE
      MS=MI+MV
      MR=MS+MU-1
C--THE LINE OF NUMBERS WE REQUIRE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)(ISTORE(I),I=ME,MH),(ISTORE(I),I=MS,MR)
      ENDIF
1450  FORMAT(1H ,120A1)
C--AND NOW THE '*' UNDERNEATH
      MQ=MJ+MU-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)(ISTORE(I),I=ME,MK),IA,(ISTORE(I),I=MJ,MQ)
      ENDIF
C--NOW PRINT THE SECTION  -  A LINE AT A TIME
      M81=L81+MX
      I=JA
      DO 2000 NN=1,JG
      J=M81
      K=MM
      L=MOD(I,JD)
C--SET UP THE LEFT HAND MARGIN
      CALL XNUMB(L,K,MF,MN,MO)
      CALL XMVSPD(IB,ISTORE(K),MG)
      K=K+MG
      CALL XMVSPD(IA,ISTORE(K-1),1)
C--NOW LOOP OVER EACH GRID POINT TO BE PRINTED
      DO 1700 N=1,MW
C--CHECK IF THIS NUMBER IS BELOW THE ALLOWED MINIMUM
      IF(STORE(J)-THRES1)1550,1550,1500
C--CHECK IF THE NUMBER IS OVER THE MAXIMUM
1500  CONTINUE
      IF(STORE(J)-THRES2)1600,1550,1550
C--NUMBER IS OUT OF RANGE  -  OUTPUT BLANKS
1550  CONTINUE
      CALL XMVSPD(IB,ISTORE(K),MA)
      K=K+MA
      GOTO 1650
C--NUMBER CAN BE PRINTED
1600  CONTINUE
      M=NINT(STORE(J))
      CALL XNUMB(M,K,MA,MB,MC)
C--UPDATE FOR THE NEXT POINT
1650  CONTINUE
      J=J+1
1700  CONTINUE
C--CHECK FOR A RIGHT HAND MARGIN
      IF(MT)1800,1800,1750
C--RIGHT MARGIN REQUIRED
1750  CONTINUE
      CALL XMVSPD(IB,ISTORE(K),MG)
      K=K+MG
      CALL XMVSPD(IA,ISTORE(K-1),1)
      CALL XNUMB(L,K,MF,MN,MO)
C--CHECK IF MORE THAN ONE LINE IS REQUIRED PER ROW
1800  CONTINUE
      IF(MD-1)1950,1950,1850
C--OUTPUT SOME BLANK LINES
1850  CONTINUE
      DO 1900 J=2,MD
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)
      ENDIF
1900  CONTINUE
C--PRINT THE CURRENT LINE
1950  CONTINUE
      K=K-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)(ISTORE(J),J=MM,K)
      ENDIF
      M81=M81+MD8
      I=I+KF
2000  CONTINUE
C--CHECK FOR MORE THAN ONE PER ROW
      IF(MD-1)2150,2150,2050
C--PRINT THE BLANK LINES
2050  CONTINUE
      DO 2100 J=2,MD
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)
      ENDIF
2100  CONTINUE
C--CAPTIONS AT THE BOTTOM OF THE PAGE
2150  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)(ISTORE(J),J=ME,MK),IA,(ISTORE(J),J=MJ,MQ)
      ENDIF
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)(ISTORE(J),J=ME,MH),(ISTORE(J),J=MS,MR)
      ENDIF
      MZ=MZ-MW
      GOTO 1200
C--END OF THIS SECTION
2200  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)
      ENDIF
2250  CONTINUE
      RETURN
      END
C
CODE FOR XNUMB
      SUBROUTINE XNUMB(NUMBER,IADD,N,MAX,MIN)
C--CONVERT A NUMBER TO ALPHA-NUMERIC AND STORE IT
C
C  NUMBER  THE NUMBER TO CONVERT
C  IADD    THE ADDRESS IN STORE AT WHICH TO PLACE IT  (UPDATED ON RETURN
C  N       THE NUMBER OF DIGITS REQUIRED.
C  MAX     THE SMALLEST NUMBER THAT WILL NOT FIT.
C  MIN     THE LARGEST NUMBER THAT WILL NOT FIT.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF THE NUMBER IS IN RANGE
      IF(NUMBER-MAX)1050,1000,1000
C--NUMBER IS TOO LARGE  -  OUTPUT 'N' PLUSES
1000  CONTINUE
      CALL XMVSPD(IPLUS,ISTORE(IADD),N)
      GOTO 1350
C--CHECK IF IT IS TOO SMALL
1050  CONTINUE
      IF(NUMBER-MIN)1100,1100,1150
C--THE NUMBER IS TOO SMALL
1100  CONTINUE
      CALL XMVSPD(MINUS,ISTORE(IADD),N)
      GOTO 1350
C--OUTPUT THE NUMBER
1150  CONTINUE
      L=IADD+N-1
      CALL XMVSPD(IB,ISTORE(IADD),N)
      I=IABS(NUMBER)
C--LOOP OVER EACH DIGIT
      DO 1200 M=1,N
      J=I/10
      K=I-J*10
      I=J
      CALL XMOVE(NUMB(K+1),ISTORE(L),1)
      L=L-1
C--CHECK IF THE NUMBER IS NOW ZERO
      IF(I)1200,1250,1200
1200  CONTINUE
C--CHECK THE SIGN OF THE ORIGINAL NUMBER
1250  CONTINUE
      IF(NUMBER)1300,1350,1350
C--OUTPUT A MINUS
1300  CONTINUE
      CALL XMVSPD(MINUS,ISTORE(L),1)
C--AND NOW RETURN
1350  CONTINUE
      IADD=IADD+N
      RETURN
      END
C
CODE FOR ESKIP
      SUBROUTINE ESKIP(NE)
C--POSITION THE INPUT E-TAPE FOR SOLUTION 'NE'
C
C--
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON/XTAPED/LMTW,MMTW,MDMTW,NMTW,LMTR,MMTR,MDMTR,NMTR
C
C--REWIND THE INPUT TAPE AND READ THE FIRST BLOCK
      CALL XIMTR(MTE)
      J=NE
C--DECREMENT THE NUMBER OF FILES TO BE SKIPPED
1000  CONTINUE
      J=J-1
      MMTR=NMTR
C--CHECK FOR THE END
      IF(J)1100,1100,1050
C--READ THE NEXT REFLECTION
1050  CONTINUE
      CALL XIMTRA(MTE)
      IF(STORE(MMTR)-0.5)1000,1050,1050
C--AND NOW RETURN
1100  CONTINUE
      RETURN
      END
C
CODE FOR XFSWOP
      SUBROUTINE XFSWOP(A,IDIM,ISTEP1,MD1,NBLOCK)
C--INTERCHANGE THE DATA IN THE ARRAY 'A', USING THE LIST 14 INTERCHANGE
C  DIRECTIVES. THE RESULTS ARE WRITTEN BACK TO 'A', AND THE LOCATIONS
C  FROM 'STORE(NFL)' ONWARDS ARE USED AS INTERMEDIATE STORAGE.
C
C  A       ARRAY HOLDING THE DATA TO BE SORTED.
C  IDIM    THE DIMENSION OF THE ARRAY 'A'. THIS IS NOT NECESSARILY
C          'MD1*NBLOCK', AS THE DATA MAY BE ARRANGED DIFFERENTLY, FOR
C          EXAMPLE IN LIST 14, WHERE 'ISTEP1' IS 6 WHILE 'MD1' IS 1.
C  ISTEP1  INCREMENT BETWEEN SUCCESSIVE ELEMENTS IN A BLOCK.
C  MD1     INCREMENT BETWEEN SUCCESSIVE BLOCKS.
C  NBLOCK  NUMBER OF BLOCKS OF DATA TO SORT.
C
C--THE DATA ARE PRESUMED TO FORM A CONTINUOUS BLOCK WHOSE TOTAL LENGTH
C  BEFORE AND AFTER SWOPPING IS '3*NBLOCK'.
C
C--
C
C
      DIMENSION A(IDIM)
C
      COMMON/XPROCS/NTYP,NE,NWT,IPRINT,THRES1,THRES2,IALL,NLINE,NCHAR,
     2 NCHARC,NSPACE,ISCAN,HEIGHT,NPEAK,INTAPE,IOUTAP,F000,ISC,SCLCON,
     3 REJECT,APEAKH , NGMAP, IFCALC, IPKMON
      COMMON/XWORKC/IAXIS(3),NV,IXYZ(3),SCALE,SS,SC,VOL,
     2 NORFL,L6DUMP,N6DUMP,SSV,SSU,HWMIN(6,2),AAA,BBB,CCC,DDD,
     3 L81,L82,L83,N10MAX,NY,NZ,NYNZ,NY2,NYM2,NYNZM2, DENMIN,
     4 IPMAP, IEMAP, DENMAX
      COMMON/XWORKD/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,
     3 KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,KL,KM,KN,KO,KP,KQ,
     4 KR,KS,KT,KU,KV,KW,KX,KY,KZ,
     5 MA,MB,MC,MD,ME,MF,MG,MH,MI,MJ,MK,ML,MM,MN,MO,MP,MQ,
     6 MR,MS,MT,MU,MV,MW,MX,MY,MZ
      COMMON/XLST08/L8,M8,MD8,N8
      COMMON/XLST10/L10,M10,MD10,N10,L10A,M10A,MD10A,N10A
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      I=3*NBLOCK
      CALL XSWOP(IAXIS,A,IDIM,ISTEP1,MD1,STORE(NFL),I,ISTEP1,MD1,
     2 NBLOCK)
      CALL XMOVE(STORE(NFL),A(1),I)
      RETURN
      END
C
CODE FOR XSWOP
      SUBROUTINE XSWOP(IAXIS,A,IDIM1,ISTEP1,MD1,B,IDIM2,ISTEP2,MD2,
     2  NBLOCK)
C--ROUTINE TO APPLY THE SORT DIRECTIVES IN 'IAXIS' TO THE DATA IN 'A',
C  AND OUTPUT THE RESULTS IN 'B'.
C
C  IAXIS(1)  COMPONENT OF 'A' TO BE TAKEN FIRST.
C  IAXIS(2)  COMPONENT OF 'A' TO BE TAKEN SECOND.
C  IAXIS(3)  COMPONENT OF 'A' TO BE TAKEN THIRD.
C  A         ARRAY HOLDING THE INPUT DATA.
C  IDIM1     THE DIMENSION OF 'A'.
C  ISTEP1    INCREMENT BETWEEN SUCCESSIVE INPUT ELEMENTS IN A BLOCK.
C  MD1       INCREMENT BETWEEN SUCCESSIVE BLOCKS OF DATA IN 'A'.
C  B         ARRAY TO HOLD THE RESULTS
C  IDIM2     THE DIMENSION OF 'B'.
C  ISTEP2    INCREMENT BETWEEN SUCCESSIVE OUTPUT ELEMENTS IN A BLOCK.
C  MD2       INCREMENT BETWEEN SUCCESSIVE OUTPUT BLOCKS.
C  NBLOCK    NUMBER OF BLOCKS OF DATA TO PROCESS.
C
C--
C
C
      DIMENSION A(IDIM1),B(IDIM2),IAXIS(3),IXX(3)
C
C--COMPUTE THE CORRECT SORTED INCREMENTS
      DO 1000 K=1,3
      IXX(K)=(IAXIS(K)-1)*ISTEP1
1000  CONTINUE
      I=1
      J=1
C--PROCESS SUCCESSIVE BLOCKS
      DO 1100 K=1,NBLOCK
      M=J
C--LOOP OVER EACH COORDINATE
      DO 1050 L=1,3
      N=I+IXX(L)
      CALL XMOVE(A(N),B(M),1)
      M=M+ISTEP2
1050  CONTINUE
      I=I+MD1
      J=J+MD2
1100  CONTINUE
      RETURN
      END
C
CODE FOR XUSWOP
      SUBROUTINE XUSWOP(IAXIS,B,IDIM2,ISTEP2,MD2,A,IDIM1,ISTEP1,MD1,
     2  NBLOCK)
C--ROUTINE TO UNSWOP DATA FROM A FOURIER
C
C  IAXIS(1)  COMPONENT OF 'A' TO BE TAKEN FIRST.
C  IAXIS(2)  COMPONENT OF 'A' TO BE TAKEN SECOND.
C  IAXIS(3)  COMPONENT OF 'A' TO BE TAKEN THIRD.
C  B         ARRAY TO HOLD THE INPUT DATA TO BE UNSORTED
C  IDIM2     THE DIMENSION OF 'B'.
C  ISTEP2    INCREMENT BETWEEN SUCCESSIVE OUTPUT ELEMENTS IN A BLOCK.
C  MD2       INCREMENT BETWEEN SUCCESSIVE OUTPUT BLOCKS.
C  A         ARRAY HOLDING THE RESULTS.
C  IDIM1     THE DIMENSION OF 'A'.
C  ISTEP1    INCREMENT BETWEEN SUCCESSIVE INPUT ELEMENTS IN A BLOCK.
C  MD1       INCREMENT BETWEEN SUCCESSIVE BLOCKS OF DATA IN 'A'.
C  NBLOCK    NUMBER OF BLOCKS OF DATA TO PROCESS.
C
C--
C
C
      DIMENSION A(IDIM1),B(IDIM2),IAXIS(3),IXX(3)
C
C--COMPUTE THE CORRECT SORTED INCREMENTS
      DO 1000 K=1,3
      IXX(K)=(IAXIS(K)-1)*ISTEP1
1000  CONTINUE
      I=1
      J=1
C--PROCESS SUCCESSIVE BLOCKS
      DO 1100 K=1,NBLOCK
      M=J
C--LOOP OVER EACH COORDINATE
      DO 1050 L=1,3
      N=I+IXX(L)
      CALL XMOVE(B(M),A(N),1)
      M=M+ISTEP2
1050  CONTINUE
      I=I+MD1
      J=J+MD2
1100  CONTINUE
      RETURN
      END
C
C
C
C
C
C
CODE FOR KFRRSN
      FUNCTION KFRRSN ( GRID, COORD, IPRINT)
C -- THIS FUNCTION CHECKS IF IT IS REASONABLE TO HAVE A FOURIER PEAK
C    AT THE POSITION GIVEN BY THE LOCAL COORDINATE 'GRID'
C
C    INPUT:
C      GRID      LOCAL COORDS, IN RANGE +/-1
C      IPRINT    0 = NO PRINT
C      COORD       X,Y,Z COORDINATES OF PEAK TO BE TESTED, IN AN ARRAY
C                    WITH THREE ELEMENTS
C
C    RETURN VALUE:
C      -1          PEAK IS UNREASONABLE
C       1          PEAK IS REASONABLE
C
C
      DIMENSION GRID(3), COORD(3)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C
      DATA AXSMIN / -1.1 /
      DATA AXSMAX /  1.1 /
C
C
      KFRRSN = 1
C
      DO 2000 I = 1 , 3
        IF ( GRID(I) .LT. AXSMIN ) KFRRSN = -1
        IF ( GRID(I) .GT. AXSMAX ) KFRRSN = -1
2000  CONTINUE
C
C
      IF ( KFRRSN .LT. 0 ) THEN
      IF (IPRINT .GT. 0 ) THEN
      WRITE(NCAWU,2005) COORD
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2005) COORD
      ENDIF
      END IF
2005  FORMAT(1X,'Malformed peak at ', 3F10.5)
C
      ENDIF
C
C
      RETURN
      END

CRYSTALS CODE FOR LABEL
CODE FOR AUTOMA
      SUBROUTINE AUTOMA
C
C--   A PROCEDURE TO CONTROL THE AUTOMATIC REFINEMENT
C
C     MODE = INITIAL = -1 THE FIRST TIME THE SUBROTINE IS CALLED
C     MODE = REFINE  =  0 IF THE SUBROUTINE PREPARES REFINEMENT
C     MODE = FOURIER =  1 IF THE SUBROUTINE PREPARES FOURIER + LABEL
C     MODE = FINAL   =  2 THE LAST TIME THE SUBROTINE IS CALLED
C
      DIMENSION ISTORE(131072)
C
      CHARACTER STRING*12,TYPE(2)*7,BUFF*80
C
      DIMENSION XO(11),XN(11),KEY(10),NEWVET(48,3)
      DIMENSION PROCS(4)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XLST29/L29,M29,MD29,N29
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
      COMMON /XSFWK/SCALE,R,RW,FOT,FCT,DFT,WDFT,AMINF,SFO,SFC,AP,BP,AT,
     2 BT,AC,BC,ACI,BCI,ACT,BCT,FO,FC,P,W,DF,WDF,TC,T,FOCC,TFOCC,SST,
     3 ST,A,C,S,COSP,SINP,LAYER,IBATCH,EXT,EXT1,EXT2,EXT3,FCEXT,FCEXS,
     4 PH,PK,PL,SH,SK,SL,WAVE,THETA1,THETA2,POL1,POL2,DEL,DELTA,D,B,
     5 ACONV,SCALEO,SCALEL,SCALEB,SCALES,SCALEK,SCALEG,SCALEW,PSHIFT,
     6 FRIED
C
      COMMON /LABCOM/ LABVET(31),JGOON,MAXCYC,MAXPEA,TRGR1,TRGR2,NONEW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (PROCS(1),MONIT)
      EQUIVALENCE (PROCS(2),MODE )
      EQUIVALENCE (PROCS(3),VALUE)
      EQUIVALENCE (PROCS(4),INTEG)
      DATA IDIM0/4/
C
C--CALL THE TIMING FUNCTION
      CALL XTIME1(2)
C -- READ THE REST OF THE INSTRUCTIONS AND CHECK FOR ERRORS
      IF (   KRDDPV ( PROCS(1) , IDIM0 )    .LT.   0   ) GO TO 9910
C--INPUT WENT OKAY  -  CLEAR THE CORE AGAIN
      CALL XRSL
      CALL XCSAE
C
C-- SET PRINT CODE   ( 1 = ON  ,  0 = OFF )
      IF (MONIT.LE.0) THEN
                        ISTAT2=0
                      ELSE
                        ISTAT2=1
                      ENDIF
C
C-- LOAD LIST 5
C
      LN1=1
      LN1=KTYP05(LN1)
      CALL XLDR05(LN1)
      JANAT = N5 * 2.5
C
C-- LOAD LIST 6 READONLY ( TO GET R-VALUE AND MINIMIZATION FUNCTION )
C
      CALL XFAL06(0)
      NUMLS=STORE(L6P)
      GR=STORE(L6P+1)
      FM=STORE(L6P+3)
      TYPE(1)='INITIAL'
      TYPE(2)='FINAL  '
      ISTOP=0
C---------
      NCYC=LABVET(31)
      IF (MODE.EQ.-1) THEN
C-- THIS IS THE FIRST TIME THIS SUBROUTINE HAS BEEN CALLED
                      LABVET(31)=LABVET(31)+1
                      NCYC=LABVET(31)
                      N5NEW=N5
                      MAXPEA=JANAT
                      NREFIN=3
                      JTYPE=1
                    ENDIF
      IF (MODE.EQ.0) THEN
C-- WE NOW DECIDE IF WE HAVE TO REFINE AND WHAT
                       LABVET(31)=LABVET(31)+1
                       NCYC=LABVET(31)
                       J=LABVET(31)+10
                       N5OLD=LABVET(J-1)
                       NREFIN=2
                       JLDEF=LABVET(20)
                       IF (NCYC.EQ.MAXCYC) THEN
                                            N5OLD=MAXPEA
                                            N5NEW=MAXPEA
                                          ENDIF
                       IF (N5OLD.NE.MAXPEA) THEN
C
C-- COMPUTE THE NUMBER OF ATOMS TO DEAL WITH
C-- AND RESET THE LENGHT OF LIST 5
C
                                              QQ=FLOAT(MAXPEA-N5OLD)
     *                                           *(1.0-2.0*GR/100.0)
                                              IF (QQ.LT.1.0) QQ=1.0
                                              N5NEW=N5OLD+NINT(QQ)
                                            ENDIF
                       IF (N5NEW.NE.N5) THEN
                                          N5=N5NEW
                                          N=N5
                                          NEW=1
                                          CALL XSTR05(LN1,0,NEW)
                                          WRITE(NCAWU,1250) N5
                                          WRITE(NCWU, 1250) N5
                                        ENDIF
 1250 FORMAT(/29H +++ THE NEW LIST 5 CONTAINS ,I5,9H  ATOM(S),/)
                    ENDIF
      IF (MODE.EQ.1)  THEN
C-- COMPUTE FOURIER AND APPLY LABEL ( IF NOT STOP CONDITION )
                        IF (GR.GT.59.9) GO TO 1600
                        NCYC=LABVET(31)
                        IF (GR.LT.TRGR1) JTYPE=2
                        IF (NCYC.GE.(MAXCYC-1).AND.GR.LT.TRGR2) JTYPE=2
                        JANAT=MAXPEA*2
                        IF (NCYC.GE.MAXCYC) THEN
                           IF (NCYC.EQ.(MAXCYC+2)) THEN
                                                     ISTOP=1
                                                   ELSE
                                                     IF (GR.LT.14.0.OR
     *                                                  .GR.GT.27.0)
     *                                               ISTOP=1
                                                   ENDIF
                                            ENDIF
                      ENDIF
C-- IF THIS IS THE LAST TIME STOP WITH ITERATION
      IF (ISTOP.EQ.1) THEN
                        MODE=2
                        NREFIN=2
                      ENDIF
      J=LABVET(31)
      LABVET(J)=INT(GR*100.0)
      J=LABVET(31)+10
      LABVET(J)=N5NEW
      J=LABVET(31)+20
      LABVET(J)=NUMLS
      IF (MODE.LE.2) THEN
                       WRITE(NCAWU,1520) (J,J=1,NCYC)
                       WRITE(NCAWU,1530) (LABVET(J),J=1,NCYC)
                       WRITE(NCAWU,1540) MAXPEA,(LABVET(J),
     *                                                  J=11,11+NCYC-1)
                       DO 1510 J=1,NCYC-1
 1510                  KEY(J) = LABVET(J+21)-LABVET(J+20)
                       WRITE(NCAWU,1550) (KEY(J),J=1,NCYC-1)
                     ENDIF
 1520 FORMAT(' +++++ LABVET ( CICLO ) ',10I6)
 1530 FORMAT(' +++++ LABVET ( R-VAL ) ',10I6)
 1540 FORMAT(' +++++ LABVET ( ',I5,' ) ',10I6)
 1550 FORMAT(' +++++ LABVET ( L.S.  ) ',10I6)
C
      CALL AUTSRQ(MODE,GR,NREFIN,JANAT,TYPE(JTYPE))
C
C-- END OF THE PROCEDURE
C
 1600 CONTINUE
C
C -- FINAL MESSAGES
C
      CALL XOPMSG ( IOPREF , IOPEND , 301 )
C
      CALL XTIME2(2)
      CALL XCSAE
      CALL XRSL
      RETURN
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPREF , IOPABN , 0 )
      GO TO 1600
9910  CONTINUE
C -- INPUT ERRORS
      CALL XOPMSG ( IOPREF , IOPCMI , 0 )
      GO TO 9900
9920  CONTINUE
C -- INSUFFICIENT SPACE
      CALL XOPMSG ( IOPREF , IOPSPC , 0 )
      GO TO 9900
      END
CODE FOR LABEH
C-----------------------------------------------------------------------
      SUBROUTINE LABEH(IZPK,T2,IVET,JALL)
C
C-- SUBROUTINE TO RE-LABEL PEAKS ACCORDING ONLY TO
C-- THE RELATIVE PEAK HEIGHT AND TO THE CELL CONTENT
C-- IF JALL = 0 ONLY HEAVY ATOMS (Z=>11) ARE LABELLED
C-- IF JALL = 1 ALL ATOMS ARE LABELLED
C
      DIMENSION ISTORE(131072)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON /LABCOM/ LABVET(31),JGOON,MAXCYC,MAXPEA,TRGR1,TRGR2,NONEW
      COMMON/SPEC/ SOPER(3,4,24),CENTRT(7,12),AAA(6),NOPER,NCENTR,ICENT,
     *            KPOL,JSYS,LAT,INDV(32),MPV(64),JSPINI,DDMIN,NCAWU,NCWU
      DIMENSION NUMBER(8,2),IVET(12),IZPK(500)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      LABVET(20)=0
      L15  =IVET(1)
      N15  =IVET(2)
      MD15 =IVET(3)
      LSIR =IVET(4)
      NSIR =IVET(5)
      MDSIR=IVET(6)
      LSA=LSIR
      JHYDR=0
      DO 1000 I=1,NSIR
      KZ=NINT(STORE(LSA+13))
      IF (KZ.NE.1) THEN
                     NUMBER(I,1)=NINT(STORE(LSA+12))
                     ELSE
                     NUMBER(I,1)=-99
                     ENDIF
      IF (KZ.GE.11) THEN
                      NUMBER(I,2)=NINT(STORE(LSA+13))
                    ELSE
                      NUMBER(I,2)=0
                    ENDIF
      IF (KZ.EQ.1) JHYDR=I
      LSA=LSA+MDSIR
 1000 CONTINUE
      WRITE(NCAWU,*) ' ++++ LABDEF NUMBER ',NUMBER
      K=1
      M15=L15
      HEIG1=STORE(M15+5)
      Z1  =FLOAT(NUMBER(1,2))
      DO 1100 I=1,N15
      DO 1090 J=1,NSIR
      IF (J.EQ.JHYDR) GO TO 1090
      IF (NUMBER(J,1).EQ.0) GO TO 1090
      K=J
      LASTH=I-1
      NUMB=NINT(STORE(M15+6)*T2)
 1120 NUMBER(K,1)=NUMBER(K,1)-NUMB
      IF (NUMBER(K,1).LE.-99) GO TO 1400
      KZ=NUMBER(K,2)
      WRITE(NCAWU,1130) ISTORE(M15),I,K,NUMBER(K,1),KZ,
     *                      NINT(STORE(M15+6)*T2),STORE(M15+5)
 1130 FORMAT(1H ,A4,I5,' K,NUMBER(K),KZ,OCC*T2,HEIGHT',3I4,I8,F10.3)
      HEIGN=STORE(M15+5)
      ZN  =FLOAT(NUMBER(K,2))
      IF (JALL.EQ.0.AND.KZ.LT.11) GO TO 1400
      IF (NUMBER(K,1).GE.0) THEN
         RAP=HEIG1*ZN/Z1
         RAP1=RAP*0.6
         RAP2=RAP*1.4
         WRITE(NCAWU,1132) HEIG1,Z1,ZN,RAP,RAP1,HEIGN,RAP2
 1132 FORMAT('HEIG1,Z1,ZN,RAP,RAP1,HEIGN,RAP2',7F9.3)
         IF ((HEIGN.GT.RAP1.AND.HEIGN.LT.RAP2).OR.KZ.EQ.0) THEN
            IZPK(I)=K
            IF (NUMBER(K,1).EQ.0) K=K+1
              GO TO 1095
            ELSE
              NUMBER(K,1)=NUMBER(K,1)+NUMB
            ENDIF
          ELSE
              NUMBER(K,1)=NUMBER(K,1)+NUMB
              K=K+1
              IF (K.LE.NSIR) THEN
                GO TO 1120
              ELSE
                GO TO 1400
              ENDIF
         ENDIF
 1090 CONTINUE
 1095 M15=M15+MD15
 1100 CONTINUE
      LABVET(20)=1
      RETURN
 1200 CONTINUE
      WRITE(NCAWU,1300) LAST
      WRITE(NCWU, 1300) LAST
 1300 FORMAT(/' +++ WARNING -- Only ',I5,'  Atoms re-labelled ',/)
      RETURN
 1400 CONTINUE
      WRITE(NCAWU,1500) LASTH
      WRITE(NCWU, 1500) LASTH
 1500 FORMAT(/' +++ WARNING -- Only ',I5,'  Heavy atoms re-labelled ',/)
      RETURN
      END
C-----------------------------------------------------------------------
CODE FOR AUTSRQ
      SUBROUTINE AUTSRQ(MODE,GR,NREFIN,JANAT,CTYPE)
C-- THIS ROUTINE IS USED TO MODIFY THE SYSTEM REQUEST QUEUE
C-- ACCORDING TO THE ACTION DEFINED BY "MODE" AND TO THE R VALUE
C
C     MODE = INITIAL = -1 THE FIRST TIME THE SUBROTINE IS CALLED
C     MODE = REFINE  =  0 IF THE SUBROUTINE PREPARES REFINEMENT
C     MODE = FOURIER =  1 IF THE SUBROUTINE PREPARES FOURIER + LABEL
C     MODE = FINAL   =  2 THE LAST TIME THE SUBROTINE IS CALLED
C
C     MODE    JUMP
C      -1       1
C       0       2
C       1       3
C       2       4
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      CHARACTER CTYPE*7,BUFF*80
C
C----- SAVE THE EXISTING SRQ
      CALL XSSRQ (IADSRQ, NSRQ)
      JUMP=MODE+2
      IF (JUMP.EQ.1) WRITE(NCAWU,11)
      IF (JUMP.EQ.2) WRITE(NCAWU,12)
      IF (JUMP.EQ.3) WRITE(NCAWU,13)
      IF (JUMP.EQ.4) WRITE(NCAWU,14)
   11 FORMAT(' +++        The first time the subrotine is called ')
   12 FORMAT(' +++        If the subroutine prepares refinement ')
   13 FORMAT(' +++        If the subroutine prepares fourier + label ')
   14 FORMAT(' +++        The last time the subrotine is called ')
      GO TO (1000,1000,3000,4000),JUMP
 1000 CONTINUE
C
C-- RECOMPUTE SCALE AND PERFORM NREFIN CYCLES OF L.S.
C
      WRITE(BUFF,'(A)') '#LIST 12   '
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'BLOCK X''S U[ISO]   '
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'END   '
      CALL XISRC (BUFF)
C
      WRITE(BUFF,'(A)') '#SFLS   '
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'SCALE   '
      CALL XISRC (BUFF)
      DO 1100 I=1,NREFIN
         WRITE(BUFF,'(A)') 'REFINE  '
         CALL XISRC (BUFF)
 1100 CONTINUE
      WRITE(BUFF,'(A)') 'END'
      CALL XISRC (BUFF)
C
C-- RESTART AUTOMATIC
C
      WRITE(BUFF,'(A)') '#AUTOMATIC'
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'SELECT MODE = FOURIER'
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'END'
      CALL XISRC (BUFF)
      GO TO 5000
 3000 CONTINUE
C
C-- MODIFY OCCUPANCIES
C
      WRITE(BUFF,'(A)') '#OCCMOD '
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'END'
      CALL XISRC (BUFF)
C
C-- COMPUTE FOURIER AND STRUCTURE FACTORS
C
      WRITE(BUFF,'(A)') '#FOURIER'
      CALL XISRC (BUFF)
      WRITE(BUFF,3100) JANAT
 3100 FORMAT(   26HPEAKS REJECT = .3 NPEAK = ,I5,'   HEIGHT = 1')
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'REFLECTIONS    CALC = YES    '
C     WRITE(BUFF,'(A)') 'REFL WEI = SIM CALC = YES    '
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'END'
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') '#PEAK 10 10 '
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'SELECT REJ = 0.0003   '
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'REFINE DIST = 0.3 MULT=0.0  '
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'END'
      CALL XISRC (BUFF)
C
C-- RUN LABEL
C
      WRITE(BUFF,'(A)') '#LABEL'
      CALL XISRC (BUFF)
      WRITE(BUFF,3200) CTYPE
 3200 FORMAT(   23HSELECT MON = HI MODE = ,A7)
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'END'
      CALL XISRC (BUFF)
C
C-- RESTART AUTOMATIC
C
      WRITE(BUFF,'(A)') '#AUTOMATIC'
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'SELECT MODE = REFINE'
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'END'
      CALL XISRC (BUFF)
      GO TO 5000
 4000 CONTINUE
C
C-- IF R > 15 COMPUTE A FOURIER
C
      IF (GR.GT.15.0) THEN
C
C-- MODIFY OCCUPANCIES
C
                        WRITE(BUFF,'(A)') '#OCCMOD '
                        CALL XISRC (BUFF)
                        WRITE(BUFF,'(A)') 'END'
                        CALL XISRC (BUFF)
C
C-- COMPUTE FOURIER AND STRUCTURE FACTORS
C
                        WRITE(BUFF,'(A)') '#FOURIER'
                        CALL XISRC (BUFF)
                        WRITE(BUFF,3100) JANAT
                        CALL XISRC (BUFF)
                        WRITE(BUFF,'(A)') 'REFLECTIONS    CALC = YES  '
                        CALL XISRC (BUFF)
                        WRITE(BUFF,'(A)') 'END'
                        CALL XISRC (BUFF)
                        WRITE(BUFF,'(A)') '#PEAK 10 10 '
                        CALL XISRC (BUFF)
                        WRITE(BUFF,'(A)') 'SELECT REJ = 0.3   '
                        CALL XISRC (BUFF)
                        WRITE(BUFF,'(A)') 'END'
                        CALL XISRC (BUFF)
C
C-- RUN LABEL
C
                        WRITE(BUFF,'(A)') '#LABEL'
                        CALL XISRC (BUFF)
                        WRITE(BUFF,3200) CTYPE
                        CALL XISRC (BUFF)
                        WRITE(BUFF,'(A)') 'END'
                        CALL XISRC (BUFF)
C
                      ENDIF
C
C-- RECOMPUTE SCALE AND  PERFORM LAST NREFIN CYCLES OF L.S.
C
      WRITE(BUFF,'(A)') '#SFLS   '
      CALL XISRC (BUFF)
      WRITE(BUFF,'(A)') 'SCALE   '
      CALL XISRC (BUFF)
      DO 4100 I=1,NREFIN
         WRITE(BUFF,'(A)') 'REFINE  '
         CALL XISRC (BUFF)
 4100 CONTINUE
      WRITE(BUFF,'(A)') 'END'
      CALL XISRC (BUFF)
 5000 CONTINUE
C
C----- RESTORE SRQ
C
      CALL XRSRQ (IADSRQ, NSRQ)
      RETURN
      END
CODE FOR OCCMOD
      SUBROUTINE OCCMOD
C
C--MODIFY LIST 5 ACCORDING TO E.S.D. & U
C
C--
      DIMENSION ISTORE(131072)
C
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST11/L11,M11,MD11,N11,L11R,M11R,MD11R,N11R,
     2 L11P,M11P,MD11P,N11P,L11IR,M11IR,MD11IR,N11IR
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XLST29/L29,M29,MD29,N29
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XAPK/NWKA,NKA,LKA,COORD(2,14)
      COMMON /XPTCL/IFIR,MINX,MINU,LINEX,LINEU,NSTA,NXF,NXD,NUF,NUD,
     2 NOP,NAP,ICC,IBAR,ISELCO,TYPECO,ISELAN,TYPEAN,IDSPCO,IDSPAN,
     3 LSTAXS , ILSTCO,IPCHCO, ILSTAN,IPCHAN,
     4 AMULT,BPD(11),IBASE,JBASE,IUIJ,LINEA(118),LINEB(118),BUFF(5)
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      DIMENSION PROCS(6)
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (PROCS(1),MONIT)
      EQUIVALENCE (PROCS(2),MODE )
      EQUIVALENCE (PROCS(3),VALUE)
      EQUIVALENCE (PROCS(4),INTEG)
      EQUIVALENCE (PROCS(5),LN1  )
      EQUIVALENCE (PROCS(6),LN2  )
      DATA IDIM0/6/
C
C--CALL THE TIMING FUNCTION
      CALL XTIME1(2)
C -- READ THE REST OF THE INSTRUCTIONS AND CHECK FOR ERRORS
      IF (   KRDDPV ( PROCS(1) , IDIM0 )    .LT.   0   ) GO TO 9910
C--INPUT WENT OKAY  -  CLEAR THE CORE AGAIN
      CALL XRSL
      CALL XCSAE
C
C--LOAD A FEW LISTS
      CALL XFAL01
      CALL XFAL29
      LN1=1
      LN1=KTYP05(LN1)
      CALL XLDR05(LN1)
C--FORM THE ABSOLUTE LIST 12
      JQ=0
C     IF (JQ.EQ.0) GO TO 9999
      JS=1
      CALL XFAL12(JS,JQ,JR,JN)
      IF ( IERFLG .LT. 0 ) GO TO 2350
C--LINK LISTS 5 AND 12
      I=KSET52(0,-1)
      IF ( IERFLG .LT. 0 ) GO TO 2350
C--BRING DOWN THE MATRIX
      CALL XFAL11(1,1)
      IF (IERFLG .LT. 0) GOTO 2350
      AMULT=STORE(L11P+17)/STORE(L11P+16)
      IBASE=NFL
      JBASE = IBASE
      K = KCHNFL ( 4 * N5)
C----- SET AUXILLIARY LIST 5 ADDRESSES
      L5A=L5
      N5A=N5
      MD5A=MD5
      M5A=L5
C
C-- ALLOCATE AND LOAD A DUMMY LIST TO CONTAIN TYPE, Z-VALUE AND A CODE
C                CODE=0  HEAVIEST ATOMIC SPECIE
C                CODE=1  OTHERWISE
C
      MDXX=3
      NXX=N29
      I=NXX*MDXX
      LXX = KSTALL (I)
C-- ZERO THE ARRAY
      CALL XZEROF ( ISTORE(LXX) , I )
      KZMAX=-1
      MXX=LXX
      M29=L29
      DO 1000 I=1,NXX
      KZ=NINT(STORE(M29+6))/2
      IF (KZ.EQ.0) KZ=1
      IF (KZ.GT.KZMAX) J=I
      ISTORE(MXX  )=ISTORE(M29)
      ISTORE(MXX+1)=KZ
      ISTORE(MXX+2)=0
      M29=M29+MD29
      MXX=MXX+MDXX
 1000 CONTINUE
      JJ=LXX+(J-1)*MDXX+2
      ISTORE(JJ)=1
C
      MXX=LXX
      DO 1040 I=1,NXX
      WRITE(NCAWU,1060) I,ISTORE(MXX  ),ISTORE(MXX+1),ISTORE(MXX+2)
 1060 FORMAT(5H YYYY,I3,1H),2X,A4,I4,I4)
      MXX=MXX+MDXX
 1040 CONTINUE
C
C-- CONVERT ANISO TO ISO
C
      CALL XPRAXI( 1, 1, JBASE, L5A, MD5A, N5A, LSTAXS, 0)
      IF ( IERFLG .LT. 0 ) GO TO 2450
C
C -- SET INITIAL VALUES.
C
      M5=L5
      M12=L12
C     M5A=L5+2
C
C-- SET THE ADDRESS OF THE WORK AREA
C
      JS = NFL + 1
C
C--LOOP OVER THE ATOMS
C
      DO 1600 K=1,N5
C--CALCULATE THE E.S.D.'S AND STORE THEM IN BPD
      U=STORE(M5+3)
      CALL SAPPLY (IJDW)
      BPD(3)=BPD(3) * STORE(L1P1  )
      BPD(4)=BPD(4) * STORE(L1P1+1)
      BPD(5)=BPD(5) * STORE(L1P1+2)
C--CHECK IF THIS ATOM IS ANISO OR ISO
      IF(ABS(U)-UISO)1100,1150,1150
1100  CONTINUE
C----- CALCULATE U[EQUIV]
      U=STORE(JBASE)
C----- SET ESD=0.
      BPD(2)=0.
1150  CONTINUE
      JBASE = JBASE + 4
C -- UPDATE THE ATOM INFORMATION FOR THE NEXT ATOM
C     IF (IACTN.EQ.1) THEN
                        VALUE=SQRT(BPD(3)*BPD(3)
     *                            +BPD(4)*BPD(4)
     *                            +BPD(5)*BPD(5) )
     *                            +U
      WRITE(NCAWU,1435) ISTORE(M5),STORE(M5+1),STORE(M5+2),STORE(M5+3),
     *                  BPD(3),BPD(4),BPD(5),VALUE
                        STORE(M5+13)=VALUE
C                     ENDIF
      M12=ISTORE(M12)
      M5=M5+MD5
C     M5A=M5A+MD5
1600  CONTINUE
      M5 = L5
C-- SORT THE LIST 5 WITH RESPECT TO 14-TH VALUE
      JUMP=-14
      CALL SORTZ(L5,N5,MD5,JUMP)
C
C-- COMPUTE THE NUMBER OF ATOMS TO MODIFY (NMOD)
C
           IF (N5.GT.30) THEN
                           NMOD=4
      ELSE IF (N5.GT.15) THEN
                           NMOD=3
      ELSE IF (N5.GT. 8) THEN
                           NMOD=2
                         ELSE
                           NMOD=1
                         ENDIF
      WRITE(NCAWU,*) 'N5 =',N5,'   NMOD=',NMOD
C
C-- MODIFY OCC'S
C
      M5 = L5
      J=M5 + MD5 * (NMOD) + 13
      ANUM=STORE(J)
      WRITE(NCAWU,*) 'ANUM = ',ANUM
      ANUM=EXP(ANUM)
      M5=L5
C     DO 1700 I=1,N5
      DO 1700 I=1,NMOD
      OCC = STORE(M5+2)
      IF (I.LE.NMOD) THEN
                       DENOM = STORE(M5+13)
                       DENOM = EXP(DENOM)
                       FAC=  ANUM / DENOM
                       IF (FAC.LT.0.86) FAC=0.86
                       IF (STORE(M5+3).GT.0.3) FAC=0.0
                       STORE(M5+2) = OCC * FAC
                     ELSE
      UISO=STORE(M5+3)
      IF (UISO.LT.0.0) THEN
                         MXX=LXX
                         DO 1650 J=1,NXX
                         IF (ISTORE(M5).EQ.ISTORE(MXX)) THEN
                                            IF (ISTORE(MXX+2).EQ.0) THEN
                                            STORE(M5+2)=STORE(M5+2)*1.15
C                                           STORE(M5+3)=0.0
                                                                   ENDIF
                                                        ENDIF
                         MXX=MXX+MDXX
 1650                    CONTINUE
                       ENDIF
                     ENDIF
      M5=M5+MD5
 1700 CONTINUE
 1430 FORMAT(1H ,A4,F6.0,F10.4,2F7.4,3X,4F7.4,3X,6F2.0,2F8.1)
 1435 FORMAT(1H ,A4,F6.0,F10.4,F7.4,3X,4F10.4)
                M5=L5
                DO 1451 I=1,N5
                OCC = STORE(M5+2)
                WRITE(NCAWU,1430) ISTORE(M5),STORE(M5+1),OCC,STORE(M5+3)
     *                           ,(STORE(M5+J),J=3,5),
     *                            STORE(M5+13)
                M5=M5+MD5
 1451           CONTINUE
 9999           CONTINUE
C-- SORT THE LIST 5 WITH RESPECT TO SEQUENCE NUMBER
      JUMP=2
      CALL SORTZ(L5,N5,MD5,JUMP)
C----- RESET  LIST 5 AUX. ADDRESSES
      L5A=L5
      N5A=N5
      MD5A=MD5
      M5A=L5
      N=N5
      NEW=1
      CALL XSTR05(LN1,0,NEW)
2300  CONTINUE
      CALL XOPMSG ( IOPPPR , IOPLSE , 5 )
      CALL XTIME2 ( 2 )
      RETURN
 2350 CONTINUE
      WRITE(NCAWU,2360)
      WRITE(NCWU,2360)
 2360 FORMAT(' - WARNING - Standard deviation not available ',
     *  /,   '             No modification of occupancies')
      GO TO 2300
C
2450  CONTINUE
      CALL XOPMSG ( IOPPPR , IOPLSP , 5 )
      GO TO 2300
9910  CONTINUE
      CALL XOPMSG ( IOPPPR , IOPCMI , 0 )
      GO TO 2450
C
      END
CODE FOR XLABEL
      SUBROUTINE XLABEL
C
C--   A PROCEDURE TO TRY TO ASSOCIATE PEAKS WITH ATOM TYPES
C
C
C---- REQUIRES A LIST 5 DEFINITION WITH AT LEAST 14 PARAMETERS PER ATOM
C      MARCH 1989
C
C  LN1    INPUT LIST TYPE
C  LN2    OUTPUT LIST TYPE
C  ILIST   THE LIST CONTROL FLAG :
C          -1  DO NOT LIST THE MOVED OR DELETED ATOMS.
C           0  LIST THE MOVED OR DELETED ATOMS.
C  TOLER   THE TOLLERANCE ADDED TO SUM OF RADII FOR BOND LIMIT
C  ITYPE    ALL(-1) OR PEAKS ONLY(0)
C
C--THE COMMON BLOCK /XWORKA/ IS USED :
C
C  JB  ADDRESS OF THE TEMP. STORAGE FOR ATOMS
C  JC  ADDRESS OF THE ATOM HEADER FOR MOVING ATOMS FROM 'JB'
C  JD  WORK SPACE FOR 'KATOMS'
C  JE  START OF DISTANCE STACK.
C  JF  NUMBER OF ATOMS LEFT TO SCAN
C  JG  CURRENT LAST ENTRY IN LIST 5 OR 10
C  JH  MD5-1
C  JI  MD5+MD5
C  JK  ZERO FOR THE FIRST OPERATION FOR THE CURRENT PIVOT ATOM,
C      ELSE NON-ZERO.
C  JL  ZERO FOR THE FIRST OPERATION FOR THE CURRENT CALL,
C      ELSE NON-ZERO.
C
C--
      DIMENSION ISTORE(131072)
C
      CHARACTER STRING*12,BUFF*80
C
      DIMENSION IZPK(500),ICOPK(9),ICOGR(500),IVET(12)
      DIMENSION ICOEL(9),INP(9)
      DIMENSION DMNMX(10,10,2)
      DIMENSION XO(11),XN(11),KEY(10),NEWVET(48,3)
C
      DIMENSION PROCS(6)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDSTNC/AT,AC,BT,BC,BP,AP,AO,IDIST,LBOX,MBOX,MDBOX,NBOX,
     2 LFNVC,MFNVC,MDFNVC,NFNVC,MFNVCA
      COMMON /XDISTW/A,BB,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y
C
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XLST29/L29,M29,MD29,N29
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      COMMON /LABCOM/ LABVET(31),JGOON,MAXCYC,MAXPEA,TRGR1,TRGR2,NONEW
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (PROCS(1),MONIT)
      EQUIVALENCE (PROCS(2),MODE )
      EQUIVALENCE (PROCS(3),GVAL )
      EQUIVALENCE (PROCS(4),INTEG)
      EQUIVALENCE (PROCS(5),LN1  )
      EQUIVALENCE (PROCS(6),LN2  )
      DATA IDIM0/6/
      DATA  IPEAK/'Q   '/
C
C--CALL THE TIMING FUNCTION
      CALL XTIME1(2)
C -- READ THE REST OF THE INSTRUCTIONS AND CHECK FOR ERRORS
      IF (   KRDDPV ( PROCS(1) , IDIM0 )    .LT.   0   ) GO TO 9910
C--INPUT WENT OKAY  -  CLEAR THE CORE AGAIN
      CALL XRSL
      CALL XCSAE
C
C--LOAD THE INPUT LIST
      LN1=KTYP05(LN1)
      CALL XLDR05(LN1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--FIND THE OUTPUT LIST TYPE
      LN2=KTYP05(LN2)
      IF (MD5 .LT. 14) THEN
        WRITE(NCWU,1000)
        WRITE(NCAWU,1000)
1000    FORMAT (/'Labelling requires a LIST 5 OR 10 with peak heights')
        GOTO 3720
      ENDIF
C-- SAVE PARAMETES RELATIVE TO LIST 10
C
      L5K=L5
      MD5K=MD5
      N5K=N5
C
C-- SET PRINT CODE   ( 1 = ON  ,  0 = OFF )
      IF (MONIT.LE.0) THEN
                        ISTAT2=0
                      ELSE
                        ISTAT2=1
                      ENDIF
      WRITE(NCAWU,*) '++++ LABEL MODE ',MODE
      JALL=1
      IF (MODE.NE.0) THEN
C                      GR=ULTIMR(I)
      J=LABVET(31)
      GR=FLOAT(LABVET(J))/100.0
C                      IF (LABVET(31).GT.1) THEN
                            IF (GR.LT.TRGR1) THEN
                                               MODE=0
                       ELSE IF (GR.LT.30.00) THEN
                                               MODE=0
                                               JALL=0
                                             ENDIF
C                                           ENDIF
                       WRITE(NCAWU,*) 'WWWW GR,LABVET(31),MODE,JALL'
     *                                     ,GR,LABVET(31),MODE,JALL
                     ENDIF
C
C-- INITIALIZE SPECIAL POSITIONS ROUTINE
C
                 CALL XSPINC
                 MAXPEA=N5
      WRITE(NCAWU,*) ' +++ LUNGHEZZA LISTA 10 =',MAXPEA
C
C-- COMPUTE OCCUPANCY FACTOR AND ADD
C-- (SEQUENTIAL CODE)*10 TO OCCUPANCY
C
                 N5OLD=0
                 M5A=L5
                 DO 1435 I=1,N5
                 CALL XMOVE(STORE(M5A+4),XO(1),3)
                 K=KSPECB(NEWVET,XO,XN,KEY,ITYP,ISER,KHEAD,IACTN)
                 OCC=1.0/FLOAT(KEY(10))
                 IF (ISTORE(M5A).NE.IPEAK) N5OLD=N5OLD+1
                 STORE(M5A+2)= OCC + I*10
 1430            FORMAT(1H ,A4,F6.0,F10.4,F7.4,3X,3F7.4,3X,6F2.0,2F8.1)
                 M5A=M5A+MD5
 1435            CONTINUE
C
C--SORT LIST 10 PEAK-HEIGHT DECREASING
                 JUMP=-14
                 CALL SORTZ(L5,N5,MD5,JUMP)
C
C-- COUNT THE NUMBER OF PEAKS AND RECORD THE LARGEST SEQUENTIAL
C-- CODE FOR NON PEAK ATOMS
                 KPEAK=0
                 MPEAK=-99
                 M5A=L5
                 DO 1440 I=1,N5
                 KI=NINT(STORE(M5A+1))
                 IF (ISTORE(M5A).EQ.IPEAK) THEN
                                             KPEAK=KPEAK+1
                                           ELSE
                                              IF (KI.GT.MPEAK) MPEAK=KI
                                           ENDIF
                 M5A=M5A+MD5
 1440            CONTINUE
                 JSTOP=0
C
C-- ASSIGN A NEW SEQUENTIAL CODE TO PEAKS AND
C-- SAVE THE ORIGINAL CODE  IN THE U[ISO] FIELD
C
                KPEAK=MPEAK
                M5A=L5
                DO 1450 I=1,N5
                OCC = STORE(M5A+2) - FLOAT(INT(STORE(M5A+2)/10)) * 10
                IF (ISTORE(M5A).EQ.IPEAK) THEN
                                            KPEAK=KPEAK+1
                                            UISOLD=STORE(M5A+3)
                                            STORE(M5A+3)=STORE(M5A+1)
                                            STORE(M5A+1)=KPEAK
                                  STORE(M5A+13)=STORE(M5A+13)*1.33
                                          ENDIF
                M5A=M5A+MD5
 1450           CONTINUE
C                             ENDIF
      N5NEW=N5OLD+N5OLD
      IF (N5NEW.GT.N5) N5NEW=N5
      WRITE(NCAWU,*)
     * ' +++ LISTA 5 =',N5OLD,'   LISTA 10 (OLD,NEW)=',N5,N5NEW
      N5=N5NEW
      N5K=N5
      IF (ISTAT2.NE.0) THEN
      WRITE(NCAWU, * ) '     -------  INPUT LIST  (SORTED)   -------'
      WRITE(NCWU,  * ) '     -------  INPUT LIST  (SORTED)   -------'
                       ENDIF
C
C--SORT LIST 10 PEAK-HEIGHT DECREASING (WE HAVE MODIFIED INTENSITIES)
      JUMP=-14
      CALL SORTZ(L5,N5,MD5,JUMP)
      IF (ISTAT2.NE.0) THEN
                M5A=L5
                DO 1451 I=1,N5
                OCC = STORE(M5A+2)
C               IF (MODE.NE.0) OCC=OCC-FLOAT(INT(STORE(M5A+2)/10)) * 10
                OCC=OCC-FLOAT(INT(STORE(M5A+2)/10)) * 10
                WRITE(NCAWU,1430) ISTORE(M5A),STORE(M5A+1),OCC,
     *                            (STORE(M5A+J),J=3,13)
                WRITE(NCWU, 1430) ISTORE(M5A),STORE(M5A+1),OCC,
     *                            (STORE(M5A+J),J=3,13)
                M5A=M5A+MD5
 1451           CONTINUE
              ENDIF
      CALL CLUPAR(N5K,L5K,MD5K,IVET,IIC,FOCC,JANAT,
     *                  ISTAT2)
CCC   IF (JGOON.EQ.0) THEN
CCC                     M5A=L5
CCC                     DO 1445 I=1,N5
CCC                     OCC=STORE(M5A+2)-FLOAT(INT(STORE(M5A+2)/10))*10
CCC                     STORE(M5A+2)=OCC
CCC                     IF (ISTORE(M5A).EQ.IPEAK) THEN
CCC                                    STORE(M5A+13)=STORE(M5A+13)/1.33
CCC                                    STORE(M5A+ 3)=UISOLD
CCC                                  ENDIF
CCC                     M5A=M5A+MD5
CCC 1445                   CONTINUE
CCC                     GO TO 1560
CCC                   ENDIF
CCC   WRITE(NCAWU,*) ' +++ GR,NONEW,NCYC,JGOON',GR,NONEW,NCYC,JGOON
C
C
C     IF (MODE.NE.0) THEN
C                      CALL NAMEPK(IVET,NFL,FOCC,N3N,DMNMX,IZPK,ICOPK,
C    *                             ICOGR,NGRAMB,ICOEL,INP,ISTAT2)
C                    ELSE
C                      CALL LABDEF(IZPK,T2,IVET)
C                      MPEAK=100000
C                    ENDIF
      CALL NAMEPK(IVET,NFL,FOCC,N3N,DMNMX,IZPK,ICOPK,
     *            ICOGR,NGRAMB,ICOEL,INP,ISTAT2)
C     IF (MODE.EQ.0) CALL LABDEF(IZPK,T2,IVET,JALL)
      IF (MODE.EQ.0) CALL LABEH (IZPK,T2,IVET,JALL)
      CALL CLUEND(L5K,MD5K,IVET,IZPK,IPEAK,NONEW)
C     IF (MODE.NE.0) THEN
C     WRITE(NCAWU,'(12H +++ MAXPEA=,I5,5X,7H N5OLD=,I5)') MAXPEA,N5OLD
C
C-- CHANGE SIGN TO INTENSITY FOR DELETED ATOMS
C
                       M5A=L5K
                       DO 1465 I=1,N5K
                       IF (I.GT.MAXPEA)STORE(M5A+13)=-ABS(STORE(M5A+13))
                       M5A=M5A+MD5K
 1465                  CONTINUE
C                    ENDIF
C
C--SORT LIST 10 SEQUENCE INCREASING
      JUMP= 2
      CALL SORTZ(L5K,N5K,MD5K,JUMP)
      IF (JSTOP.EQ.1) GO TO 1560
      WRITE(NCWU,1506) LN2 , LN1
      WRITE(NCAWU,1507) LN2 ,LN1
 1506 FORMAT(/,37H Results of the labeling and contents,
     2 17H of the new LIST ,I3,' It was LIST ',I3,//,
     3 5H TYPE,3X,6HSERIAL,3X,3HOCC,4X,6HU[ISO],
     5 6X,1HX,6X,1HY,6X,1HZ,25X,6HU[I,J],18X,6HHEIGHT/)
 1507 FORMAT(/,37H Results of the labeling and contents,
     2 17H of the new LIST ,I3,' It was LIST ',I3,'  +++',//,
     3 5H TYPE,3X,6HSERIAL,3X,3HOCC,4X,6HU[ISO],
     5 6X,1HX,6X,1HY,6X,1HZ,9X,6HHEIGHT/)
      L5=L5K
      MD5=MD5K
      M5A=L5
      DO 1550 I=1,N5K
      OCC = STORE(M5A+2)
C     IF (MODE.NE.0) OCC=OCC-FLOAT(INT(STORE(M5A+2)/10)) * 10
      OCC=OCC-FLOAT(INT(STORE(M5A+2)/10)) * 10
      KI=NINT(STORE(M5A+1))
      STRING='            '
      IF (KI.GT.MPEAK) THEN
                         ISER=NINT(STORE(M5A+3))
                         WRITE(STRING,1433) ISER
                         STORE(M5A+3)=UISOLD
C                        STORE(M5A+13)=STORE(M5A+13)/1.33
                       ENDIF
      HEIGH=STORE(M5A+13)
      IF (HEIGH.LT.0.0) THEN
                          STRING='DELETED '
                          HEIGH=-HEIGH
                        ENDIF
      WRITE(NCAWU,1431) ISTORE(M5A),STORE(M5A+1),OCC,
     *                 (STORE(M5A+J),J=3,6) ,HEIGH,STRING
      WRITE(NCWU, 1432) ISTORE(M5A),STORE(M5A+1),OCC,
     *                 (STORE(M5A+J),J=3,12),HEIGH,STRING
      STORE(M5A+2)=OCC
 1431 FORMAT(1H ,A4,2X,F6.0,2X,2F7.4,3X,3F7.4,5X,F8.1,1X,A12)
 1432 FORMAT(1H ,A4,2X,F6.0,2X,2F7.4,3X,3F7.4,3X,6F7.4,F8.1,1X,A12)
 1433 FORMAT('WAS PEAK',I4)
C
C-- SET SEQUENCE CODE = HUGE VALUE FOR DELETED ATOMS
      IF (STORE(M5A+13).LT.0.0) STORE(M5A+1)=99999999.9
      M5A=M5A+MD5
 1550 CONTINUE
C--SORT LIST 10 SEQUENCE INCREASING
      JUMP= 2
      CALL SORTZ(L5K,N5K,MD5K,JUMP)
 1560 CONTINUE
      N5=MAXPEA
      L5=L5K
      MD5=MD5K
      M5A=L5
C
      KHEAD=0
      ISER=1
      IACTN=1
      ITYP = 0
C
      WRITE(NCAWU,1570) LN2,N5
      WRITE(NCWU ,1570) LN2,N5
 1570 FORMAT(/14H The new LIST ,I3,11H  contains ,I5,9H  atom(s),/)
C-- COPY LIST 10 INTO LIST 5
      N=N5
      NEW=1
      CALL XCPYL5(LN1,LN2,N,NEW)
      CALL XSTR05(LN2,0,NEW)
C
C
3720  CONTINUE
C
C -- FINAL MESSAGES
C
      CALL XOPMSG ( IOPREF , IOPEND , 301 )
C
      CALL XTIME2(2)
      CALL XCSAE
      CALL XRSL
      RETURN
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPREF , IOPABN , 0 )
      GO TO 3720
9910  CONTINUE
C -- INPUT ERRORS
      CALL XOPMSG ( IOPREF , IOPCMI , 0 )
      GO TO 9900
9920  CONTINUE
C -- INSUFFICIENT SPACE
      CALL XOPMSG ( IOPREF , IOPSPC , 0 )
      GO TO 9900
      END
C----------------------------------------------------------------
CODE FOR CLUPAR
      SUBROUTINE CLUPAR(N5K,L5K,MD5K,IVET,IIC,FOCC,JANAT,
     *                  ISTAT2)
C
C--   THIS SUBROUTINE PREPARES PARAMETERS FOR LABELLING CODE
C
C
C
      DIMENSION ISTORE(131072)
C
      DIMENSION XO(11),XN(11),KEY(10),NEWVET(48,3),IVET(12)
      DIMENSION X1(3),X2(3),S12(3),XEQ(3),VET(2)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDSTNC/AT,AC,BT,BC,BP,AP,AO,IDIST,LBOX,MBOX,MDBOX,NBOX,
     2 LFNVC,MFNVC,MDFNVC,NFNVC,MFNVCA
      COMMON /XPROCC/DISTS(4),LN1,LN2,ITYPE,NATOM,ILIST,ISEQ,D3,AMULT,
     2 IACT, ISYMOD, ITRANS
      COMMON /XDISTW/A,BB,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
      COMMON/XLST29/L29,M29,MD29,N29
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      COMMON /LABCOM/ LABVET(31),JGOON,MAXCYC,MAXPEA,TRGR1,TRGR2,NONEW
      COMMON/SPEC/ SOPER(3,4,24),CENTRT(7,12),AAA(6),NOPER,NCENTR,ICENT,
     *            KPOL,JSYS,LAT,INDV(32),MPV(64),DUMMY(4)
C                                                JSPINI,DDMIN,NCAWU,NCWU
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C----- LOAD LIST 3(SCATTERING FACTORS) AND 29 (RADII ETC)
      CALL XFAL03
      CALL XFAL29
      IF ( IERFLG .LT. 0) GOTO 9900
C----- LOAD LISTS 1 AND 2, AND SET UP SOME CONSTANTS
      CALL XDIST2
C
      JT=12
      L12=-1
      M12=-1
C--SET UP A FEW WORK STACK CONSTANTS
      JB=NFL
      JC=JB+MD5K
      JD=JC+20
      JE=JD+30
C--CHECK THE STORE AREA
      IF ( JE - LFL ) 1350 , 9920 , 9920
1350  CONTINUE
C
      FOCC=1.0/T2
C
C-- ALLOCATE A DUMMY LIST TO CONTAIN A PSEUDO LIST 10
C
      MDUM=8
      NDUM=N5K
      I=NDUM*MDUM
      LDUM = KSTALL (I)
C-- ZERO THE ARRAY
      CALL XZEROF ( ISTORE(LDUM) , I )
C
C-- ALLOCATE A DUMMY LIST TO CONTAIN A LIST 3 (SIR-LIKE)
C
      MDSIR=18
      NSIR=N29
      I=NSIR*MDSIR
      LSIR = KSTALL (I)
C-- ZERO THE ARRAY
      CALL XZEROF ( ISTORE(LSIR) , I )
C
C--  LOAD THE SIR-LIKE LIST 3
C
C
      CALL XSCATT(0.0)
C
      RAGMIN=9999
      ANAT=0.0
      LSA=LSIR
      M29=L29
      M3=L3
      M3TR=L3TR
      DO 1360 I=1,NSIR
      WRITE(NCAWU,'(I5,1H),A4,3F10.3)') I,ISTORE(M3),STORE(M3TR)
C     KZ=NINT(STORE(M29+6))/2
      KZ=NINT(STORE(M3TR))
      IF (KZ.EQ.0) KZ=1
      ISTORE(LSA   )=ISTORE(M29  )
       STORE(LSA+12)= NINT(STORE(M29+4)*T2)
       STORE(LSA+13)= KZ
       RAG=STORE(M29+1)
      IF (RAG.LT.RAGMIN.AND.KZ.NE.1) RAGMIN=RAG
       STORE(LSA+15)= RAG
      IF (KZ.GT.1) ANAT=ANAT+STORE(LSA+12)
      M29=M29+MD29
      M3=M3+MD3
      M3TR=M3TR+MD3TR
      LSA=LSA+MDSIR
 1360 CONTINUE
C
C-- SORT (SIR-LIKE) LIST 3 Z DECREASING ( NOW I CONSIDER ATOM WEIGHT )
C
      JUMP=-14
      CALL SORTZ(LSIR,NSIR,MDSIR,JUMP)
      LSA=LSIR
      DO 1370 I=1,NSIR
      WRITE(NCAWU,'(I5,1H),A4,3F10.3)')
     * I,ISTORE(LSA),STORE(LSA+12),STORE(LSA+13),STORE(LSA+15)
      LSA=LSA+MDSIR
1370  CONTINUE
      WRITE(NCAWU,'(16H RAGGIO MINIMO =,F10.3)') RAGMIN
C
C--  LOAD THE PSEUDO-LIST 10
C
      KHEAD=0
      ISER=1
      IACTN=1
      ITYP = 0
C
      LA=LDUM
      L15A=L5K
      DO 2020 I=1,NDUM
      ITYP=ISTORE(L15A)
      ISTORE(LA  )=ITYP
      RAG=RAGMIN
      LSA=LSIR
      DO 2010 J=1,NSIR
      IF (ISTORE(LSA).EQ.ITYP) RAG=STORE(LSA+15)
 2010 LSA=LSA+MDSIR
      OCC = STORE(L15A+2) - FLOAT(INT(STORE(L15A+2)/10)) * 10
      HEIGH=STORE(L15A+13)
      CALL XMOVE(STORE(L15A+4),XO(1),3)
      K=KSPECB(NEWVET,XO,XN,KEY,ITYP,ISER,KHEAD,IACTN)
      OCC=1.0/FLOAT(KEY(10))
      STORE(LA+1)=I
      STORE(LA+2)=XO(1)
      STORE(LA+3)=XO(2)
      STORE(LA+4)=XO(3)
      STORE(LA+5)=HEIGH
      STORE(LA+6)=OCC
      STORE(LA+7)=RAG
      L15A=L15A+MD5K
 2020 LA=LA+MDUM
C
C-- REJECT ATOMS IF TOO CLOSE
C
      VET(1)=1
      VET(2)=-1
      IFIN=ICENT+1
      L15A=L5K
      LA=LDUM
      DO 2040 I=1,NDUM-1
      IF (STORE(LA+1).LT.0.0) GO TO 2038
      RAG1=STORE(LA+7)
      CALL XMOVE(STORE(LA+2),X1(1),3)
      LB=LDUM+I*MDUM
      L15B=L5K+I*MD5K
      DO 2030 J=I+1,NDUM
      IF (STORE(LB+1).LT.0.0) GO TO 2028
      RAG2=STORE(LB+7)
      CALL XMOVE(STORE(LB+2),X2(1),3)
      D12S=RAG1+RAG2-0.75
      DO 50 KT=1,NCENTR
        DO 50 IFI=1,IFIN
          COEF=VET(IFI)
          DO 50 K=1,NOPER
            CALL XEQUI(X2,K,COEF,XEQ,KT)
            CALL XDISTB(X1,XEQ,D12,S12)
      IF (D12.LT.D12S) THEN
                         WRITE(NCAWU,2025)
     *                   ISTORE(L15A),STORE(L15A+1),X1,
     *                   ISTORE(L15B),STORE(L15B+1),XEQ,D12S,D12
                         STORE(LB+1)=-1
                         GO TO 60
                       ENDIF
   50 CONTINUE
   60 CONTINUE
C     WRITE(NCAWU,2026)
C    *ISTORE(L15A),STORE(L15A+1),X1,
C    *ISTORE(L15B),STORE(L15B+1),X2,D12S,D12
CORIG CALL XDISTB(X1,X2,D12,S12)
C     D12S=-9999.99
CORIG IF (D12.LT.D12S) THEN
CORIG                    WRITE(NCAWU,2025)
CORIG*                   ISTORE(L15A),STORE(L15A+1),X1,
CORIG*                   ISTORE(L15B),STORE(L15B+1),X2,D12S,D12
 2025 FORMAT(2(1H ,A4,F5.1,3F8.4),2F8.4,' REJECTED +++')
CORIG                    STORE(LB+1)=-1
CORIG                  ELSE
CORIG                    WRITE(NCAWU,2026)
CORIG*                   ISTORE(L15A),STORE(L15A+1),X1,
CORIG*                   ISTORE(L15B),STORE(L15B+1),X2,D12S,D12
 2026 FORMAT(2(1H ,A4,F5.1,3F8.4),2F8.4,' NOT REJECTED +++')
CORIG                  ENDIF
 2028 L15B=L15B+MD5K
 2030 LB=LB+MDUM
 2038 L15A=L15A+MD5K
 2040 LA=LA+MDUM
C
C-- PACK THE LIST ( PSEUDO 10 & LIST 5 )
C
C     WRITE(NCAWU,*) '------------------------------------'
C     LA=LDUM
C     DO 2051 I=1,NDUM
C     WRITE(NCAWU,2029) ISTORE(LA),(STORE(LA+J),J=1,MDUM-1)
C2029 FORMAT(1H ,A4,10F10.4)
C2051 LA=LA+MDUM
C     WRITE(NCAWU,*) '------------------------------------'
C
      JRE=0
      LA=LDUM
      LB=LDUM-MDUM
      L15A=L5K
      L15B=L5K-MD5K
      DO 2050 I=1,NDUM
      IF (STORE(LA+1).LT.0.0) GO TO 2048
      JRE=JRE+1
      LB=LB+MDUM
      L15B=L15B+MD5K
      IF (LA.NE.LB) THEN
                      CALL XMOVE(STORE(LA),STORE(LB),MDUM)
                      CALL XMOVE(STORE(L15A),STORE(L15B),MD5K)
                    ENDIF
      STORE(LB+1)=JRE
 2048 L15A=L15A+MD5K
 2050 LA=LA+MDUM
C
C     WRITE(NCAWU,*) '------------------------------------'
C     WRITE(NCAWU,*) '-------',JRE,'  ----------------------'
C     LA=LDUM
C     DO 2052 I=1,NDUM
C     WRITE(NCAWU,2029) ISTORE(LA),(STORE(LA+JJ),JJ=1,MDUM-1)
C2052 LA=LA+MDUM
C     WRITE(NCAWU,*) '------------------------------------'
C               M5A=L5K
C               DO 1451 I=1,N5K
C               OCC = STORE(M5A+2)
C               OCC=OCC-FLOAT(INT(STORE(M5A+2)/10)) * 10
C               WRITE(NCAWU,1430) ISTORE(M5A),STORE(M5A+1),OCC,
C    *                            (STORE(M5A+J),J=3,13)
C1430            FORMAT(1H ,A4,F6.0,F10.4,F7.4,3X,3F7.4,3X,6F2.0,2F8.1)
C               M5A=M5A+MD5K
C1451           CONTINUE
      I=NDUM-JRE
      IF (I.GT.0) WRITE(NCAWU,2060) I
 2060 FORMAT(/,' +++ ',I5,' PEAK(S) REJECTED +++',/)
      WRITE(NCAWU,*) ' +++ LUNGH. LISTA PRIMA E DOPO IL PACK',NDUM,JRE
C
      NDUM=JRE
      N5K =JRE
C
C
C-- COMPUTE THE NUMBER OF ATOMS TO DEAL WITH
C
      MAXPEA=0
      SUM=0.0
      LA=LDUM
      DO 2070 I=1,NDUM
      OCCT2=STORE(LA+6)*T2
      SUM=SUM+OCCT2
      IF ((SUM-ANAT).LT.0.083333) MAXPEA=MAXPEA+1
 2070 LA=LA+MDUM
C
C-- MAXPEA IS THE EXACT NUMBER OF PEAKS TO CONSIDER
C
      NDUM=MAXPEA
C
C-- LOAD THE ARRAY OF POINTERS
C
      IVET(1)=LDUM
      IVET(2)=NDUM
      IVET(3)=MDUM
      IVET(4)=LSIR
      IVET(5)=NSIR
      IVET(6)=MDSIR
      IVET(7)=LSIR
      IVET(8)=NSIR
      IVET(9)=MDSIR
      IVET(10)=L2
      IVET(11)=N2
      IVET(12)=MD2
 3720 CONTINUE
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPREF , IOPABN , 0 )
      GO TO 3720
9910  CONTINUE
C -- INPUT ERRORS
      CALL XOPMSG ( IOPREF , IOPCMI , 0 )
      GO TO 9900
9920  CONTINUE
C -- INSUFFICIENT SPACE
      CALL XOPMSG ( IOPREF , IOPSPC , 0 )
      GO TO 9900
      END
C-----------------------------------------------------------------------
CODE FOR CLUEND
      SUBROUTINE CLUEND(L5K,MD5K,IVET,IZPK,IPEAK,NONEW)
C
C--   THIS SUBROUTINE TERMINATES LABELLING
C
      DIMENSION ISTORE(131072)
      DIMENSION IZPK(500),IVET(12)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/SPEC/ SOPER(3,4,24),CENTRT(7,12),AAA(6),NOPER,NCENTR,ICENT,
     *            KPOL,JSYS,LAT,INDV(32),MPV(64),JSPINI,DDMIN,NCAWU,NCWU
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      MAXPEA=IVET(2)
      L3  =IVET(4)
      N3  =IVET(5)
      MD3 =IVET(6)
C
      NONEW=1
      M5A=L5K
      DO 2000 I=1,MAXPEA
      IZPKC=ISTORE(L3+(IZPK(I)-1)*MD3)
      Z2   = STORE(L3+(IZPK(I)-1)*MD3+13)
      U1=STORE(M5A+3)
      N1=STORE(M5A+1)
      ITYP1=ISTORE(M5A)
      ITYP2=IZPKC
      IF (ITYP1.EQ.IPEAK) THEN
                            NONEW=0
                            STORE(M5A+13)=STORE(M5A+13)/1.33
                          ELSE
           IF (U1.LT.0.0) THEN
C-- IF U[ISO] IF NEGATIVE SET IT TO 0.001
                            STORE(M5A+3) = 0.001 + ABS(U1)
                          ELSE
      IF (ITYP1.NE.IZPKC) THEN
                            NONEW=0
C--  OTHERWISE MODIFY U[ISO] ACCORDING TO
C
C              Z1 : U1 = Z2 : U2
                            Z1=1.0
                            M3=L3
                            DO 1200 J=1,N3
                            IF (ITYP1.NE.ISTORE(M3)) GO TO 1100
                            Z1=STORE(M3+13)
 1100                       M3=M3+MD3
 1200                       CONTINUE
C                           ARGL=Z1*EXP(-U1)/Z2
C                           U2=-ALOG(ARGL)
                            U2=Z2*U1/Z1
                            WRITE(NCAWU,1300) ITYP1,N1,U1,Z1,
     *                                        ITYP2,N1,U2,Z2
 1300 FORMAT(' MODIFICA DI U[ISO] -->',2(1H ,A4,I4,F8.4,F6.1))
                            STORE(M5A+3) = U2
                          ENDIF
                        ENDIF
                      ENDIF
      ISTORE(M5A)=IZPKC
      M5A=M5A+MD5K
 2000 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
CODE FOR NAMEPK
      SUBROUTINE NAMEPK(IVET,NFLPK,FOCC,N3N,DMNMX,IZPK,ICOPK,ICOGR,
     1NGRAMB,ICOEL,INP,ISTAT2)
C
C--GIVES  NAME TO THE PEAKS
      DIMENSION ISTORE(131072)
      DIMENSION IZPK(500),ICOPK(9),ICOGR(500),IVET(12)
      DIMENSION PIC(9),NPIC15(9),RAPIC(9),RAP(9),ICOEL(9),INP(9)
      DIMENSION DMNMX(10,10,2)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XBUIL/DMAX,DMIN,G(18),IFT1,IFT2,IFT3,L3DUM,LCLUS,LADDR,LDIS
     1,LCON,LNEGL,MD,MDDIS,MDCON,MNEGL,NNEGL,LADCON,LANG,NCON,MCLUS
     2,NOK,NGH,NGL,NORHI,NORHI2,NPRES1,NPRES2,NPRES3,NPRE12,NGRUP,NFRAG
     3,IVE3I(9),IVE3S(9),IVE15I(9),IVE15S(9),IVE(9),DMN(9),DMX(9)
      COMMON/SPEC/ SOPER(3,4,24),CENTRT(7,12),AAA(6),NOPER,NCENTR,ICENT,
     *            KPOL,JSYS,LAT,INDV(32),MPV(64),JSPINI,DDMIN,NCAWU,NCWU
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      L15=IVET(1)
      N15=IVET(2)
      MD15=IVET(3)
      L3  =IVET(4)
      N3  =IVET(5)
      MD3 =IVET(6)
      L3  =IVET(7)
      N3  =IVET(8)
      MD3 =IVET(9)
      L2  =IVET(10)
      N2  =IVET(11)
      MD2 =IVET(12)
      NGH=0
      NGL=0
      NOK=0
      NGRUP=1
      NGRAMB=0
      DO 40 I=1,9
      INP(I)=0
      DMN(I)=0
      DMX(I)=0
      IVE(I)=0
      PIC(I)=0
      NPIC15(I)=0
      RAPIC(I)=0
      RAP(I)=0
      ICOPK(I)=0
      ICOEL(I)=0
      IVE3I(I)=0
      IVE3S(I)=0
      IVE15I(I)=0
40    IVE15S(I)=0
      DO 41 I=1,500
      ICOGR(I)=0
41    IZPK(I)=0
      DO 42 I=1,10
      DO 42 J=1,10
      DMNMX(I,J,1)=0.
42    DMNMX(I,J,2)=0.
C--
      L3DUM=NFLPK
      MD=8
      M=L3DUM
      M3=L3
      N3N=N3
      DO  50 I= 1,N3
      IF(STORE(M3+13).LT.1.5)N3N=N3-1
      IF(STORE(M3+13).GE.11)NGH=NGH+1
      STORE(M  )=STORE(M3+12)*FOCC
      STORE(M+1)=STORE(M3+15)
      STORE(M+2)=STORE(M3+13)
      STORE(M+3)=0
      STORE(M+4)=0
      STORE(M+5)=0
      STORE(M+6)=I
      STORE(M+7)=1
      M=M+MD
      M3=M3+MD3
50    CONTINUE
      L=L3DUM
      NFLPK=M
      NGL=N3N-NGH
      IF(ISTAT2.GT.2)WRITE(NCWU,1)NGH,NGL
1     FORMAT(1X,'N. GRUPPI HEAVY=',I3,2X,'N. GRUPPI LIGHT =',I3)
C--SORT DECREASING RADIUS  MODE
      JUMP=-2
      CALL SORTZ(L3DUM,N3,MD,JUMP)
      DMI=STORE(L+1+(N3N-1)*MD)
      DMA=STORE(L+1)
      DMIN=2*DMI-.35
      DMAX=2*DMA+.41
      DMIN=DMIN*DMIN
      DMAX=DMAX*DMAX
C--SORT DECREASE-Z MODE
      JUMP=-3
      CALL SORTZ(L3DUM,N3,MD,JUMP)
      LM=NFLPK
      MM=LM
      M=L3DUM
      DO 60 I=1,N3
      STORE(M+3)=0
      IF(I.LE.NGH)THEN
      IF(I.LT.N3N)STORE(M+3)=STORE(M+2)/STORE(M+2+MD)
      IF(I.GE.N3N)STORE(M+3)=1
      IF(STORE(M+2).GT.18)STORE(M+7)=2
      ENDIF
      STORE(M+4)=DMI+STORE(M+1)-.35
      STORE(M+5)=DMA+STORE(M+1)+.41
      STORE(MM)=STORE(M)
      STORE(MM+1)=STORE(M+1)
      STORE(MM+2)=STORE(M+2)
      STORE(MM+3)=STORE(M+3)
      STORE(MM+4)=STORE(M+4)
      DMN(I)=STORE(M+4)
      STORE(MM+5)=STORE(M+5)
      DMX(I)=STORE(M+5)
      STORE(MM+6)=STORE(M+6)
      STORE(MM+7)=STORE(M+7)
      MM=MM+MD
60    M=M+MD
      IVE3I(1)=1
      IVE3S(1)=N3N
      IVE15I(1)=1
      IVE15S(1)=N15
      IVE(1)=2
      IF(NGH.EQ.0)GO TO 560
      A=0.
      MLM=L3DUM
      DO 100  I=1,NGH
      PIC(I)=A+STORE(MLM)
      A=PIC(I)
      IFIN=I
      CALL PIC15(IVET,FOCC,A,NP)
      NPIC15(I)=NP
      IF(STORE(MLM+3).LT.1.35)GO TO 100
      M15=L15+(NPIC15(I)-1)*MD15+5
      MM15=M15+MD15
      RAPIC(I)=STORE(M15)/STORE(MM15)
      RAP(I)=STORE(MLM+3)*.222+1.167
      IF(RAPIC(I).LT.RAP(I))GO TO 100
      IFIN=0
      NOK=1
      IVE3S(NGRUP)=I
      IVE15S(NGRUP)=NPIC15(I)
      IJ=IVE3I(NGRUP)
      DO 110 J=IJ,I
110   ICOEL(J)=ICOEL(J)+10**(NGRUP-1)
      IVE(NGRUP)=1
      NGRUP=NGRUP+1
      IVE3I(NGRUP)=I+1
      IVE15I(NGRUP)=NPIC15(I)+1
100   MLM=MLM+MD
C--
      IF(IFIN.NE.0)GO TO 200
      IF(N3N.EQ.NGH)THEN
      IVE3I(NGRUP)=0
      IVE15I(NGRUP)=0
      NGRUP=NGRUP-1
      GO TO 590
      ELSE
      IVE3S(NGRUP)=N3N
      IVE15S(NGRUP)=N15
      IVE(NGRUP)=2
      GO TO 560
      ENDIF
200   CONTINUE
C-- PROCEDURA NOK=0
      INF=IVE3I(NGRUP)
      MLM=L3DUM+3+(INF-1)*MD
      A=0.
      INFG=INF
      DO 300 I=INF,NGH
      IF(A.GE.STORE(MLM))GO TO 300
      IF(NPIC15(I).LE.1)GO TO 300
      A=STORE(MLM)
      ML=MLM
      INFG=I
300   MLM=MLM+MD
      INF=IVE15I(NGRUP)
      ISUP=NPIC15(INFG)
      IVE(NGRUP)=3
      IVE3S(NGRUP)=NGH
      MM=NPIC15(INFG)
      MM15=L15+MM*MD15+5
      FF=STORE(MM15)*RAP(INFG)
      M15=L15+(IVE15I(NGRUP)-1)*MD15+5
      DO 400 I=INF,ISUP
      IJ=I-1
      IF(STORE(M15).LE.FF)GO TO 450
400   M15=M15+MD15
      GO TO 500
C--PEAKS LIKE HEAVY
450   CONTINUE
      IF(IJ.LT.INF)GO TO 470
      IVE3S(NGRUP)=INFG
      II=IVE3I(NGRUP)
      DO 460 L=II,INFG
460   ICOEL(L)=ICOEL(L)+10**(NGRUP-1)
C460   ICOEL(L)=NGRUP
      IVE15S(NGRUP)=IJ
      IVE(NGRUP)=1
C--PEAK LIKE AMBIGUI
      NGRUP=NGRUP+1
470   IVE(NGRUP)=3
      IVE15I(NGRUP)=IJ+1
      IVE15S(NGRUP)=NPIC15(NGH)
      IVE3I(NGRUP)=1
      IF(NGRUP.GT.1)IVE3I(NGRUP)=IVE3I(NGRUP-1)
      IVE3S(NGRUP)=NGH
      IF(N3N.GT.NGH)IVE3S(NGRUP)=NGH+1
      II=IVE3I(NGRUP)
      DO 480 I=II,NGH
480   ICOEL(I)=ICOEL(I)+10**(NGRUP-1)
500   IF(N3N.EQ.NGH)GO TO 590
C-- CARBONI
      NGRUP=NGRUP+1
      IVE3I(NGRUP)=NGH+1
      IVE3S(NGRUP)=N3N
      IVE15I(NGRUP)=IVE15S(NGRUP-1)+1
      IVE15S(NGRUP)=N15
      IVE(NGRUP)=2
560   II=IVE3I(NGRUP)
      DO 570 I=II,N3N
570   ICOEL(I)=ICOEL(I)+10**(NGRUP-1)
C--SET DISTANCES
590   CONTINUE
      IVE15S(NGRUP)=N15
      DO 600 I=1,NGRUP
      INF=IVE3I(I)
      ISUP=IVE3S(I)
      MLM=L3DUM+(INF-1)*MD+1
      DMN(I)=1000.
      DMX(I)=0.
      DO 650 J=INF,ISUP
      IF(STORE(MLM).LE.DMN(I))DMN(I)=STORE(MLM)
      IF(STORE(MLM).LT.DMX(I))GO TO 650
      DMX(I)=STORE(MLM)
      ICOPK(I)=STORE(MLM+6)
650   MLM=MLM+MD
600   CONTINUE
      DO 700 I=1,NGRUP
      DO 710 J=1,NGRUP
      DMNMX(I,J,1)=DMN(I)+DMN(J)-.35
      DMNMX(I,J,2)=DMX(I)+DMX(J)+.41
710   CONTINUE
700   CONTINUE
C--SET THE LIMITS FROM INPUT
      DO 900 I=1,NGRUP
      INF=IVE15I(I)
      ISUP=IVE15S(I)
      INF2=IVE3I(I)
      ISUP2=IVE3S(I)
      DO 900 J=INF,ISUP
      IZPK(J)=IVE3S(I)
      ICOGR(J)=I
900   CONTINUE
      NPRES2=1
      DO 950 I=1,NGRUP
      IF(IVE(I).EQ.1)NPRES2=IVE15S(I)
950   CONTINUE
      RETURN
      END
C
CODE FOR PIC15
      SUBROUTINE PIC15(IVET,FOCC,A,NB)
      DIMENSION ISTORE(131072)
      DIMENSION IVET(12)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
      L15=IVET(1)
      N15=IVET(2)
      MD15=IVET(3)
      M15=L15
      SOM=A
      ERRO=.5*FOCC
      DO 100 I=1,N15
      SOM=SOM-STORE(M15+6)
      NB=I
      IF(SOM.GT.ERRO.OR.SOM.GT.0)GO TO  99
      IF(ABS(SOM).LE.ERRO)RETURN
      RETURN
99    M15=M15+MD15
100   CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
CODE FOR SORTZ
      SUBROUTINE SORTZ(LIND,NUMB,IBLK,JUMP)
C--SORT THE DATA IN STORE
C
C  LIND  ADDRES IN STORE
C  NUMB  NUMBER OF BLOCK OF DATA TO BE SORTED
C  IBLK  BLOCK LENGHT OF THE DATA (I.E. NUMBER OF ITEMS PER BLOCK)
C  JUMP  < 0 SORT IN DECREASING ORDER
C  JUMP  > 0 SORT IN INCREASING ORDER
C  IABS(JUMP) = RELATIVE ADDRES OF THE KEY OF SORT
C
      DIMENSION ISTORE(131072)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      JSIG=1
      IF (JUMP.LT.0) THEN
                       JUMP=IABS(JUMP)
                       JSIG=-1
                     ENDIF
      IF (NUMB.EQ.1) RETURN
      JUMP=JUMP-1
      JA=2
2010  CONTINUE
      JB=NUMB/JA
      IF(JB) 2020,2020,2030
2020  CONTINUE
      JB=1
2030  CONTINUE
      JC=NUMB-JB
2040  CONTINUE
      JD=0
      M=LIND
      DO 2070 I=1,JC
      MK=M+JB*IBLK
      IF ((STORE(M+JUMP)-STORE(MK+JUMP))*JSIG) 2060,2060,2050
 2050 CONTINUE
      MM=M
      MMK=MK
      DO 2055 JE=1,IBLK
      F=STORE(MM)
      STORE(MM)=STORE(MMK)
      STORE(MMK)=F
      MM=MM+1
      MMK=MMK+1
 2055 CONTINUE
      JD=1
 2060 CONTINUE
      M=M+IBLK
 2070 CONTINUE
      IF (JD) 2080,2080,2040
 2080 CONTINUE
      IF (JB-1) 2100,2100,2090
 2090 CONTINUE
      JA=JA*2
      GO TO 2010
 2100 CONTINUE
      RETURN
      END
C---------------------------------------------------------------------
      FUNCTION ULTIMR(IFLAG)
C
      DIMENSION ISTORE(131072)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C-- LOAD LIST 6 READ ONLY( TO GET R-VALUE AND MINIMIZATION FUNCTION )
C
      CALL XFAL06 (0)
      ULTIMR=STORE(L6P+1)
      RETURN
      END
CRYSTALS CODE FOR LIST4
CODE FOR XAPP04
      SUBROUTINE XAPP04
C--CALCULATE THE WEIGHTS AND STORE THEM
C
C--VARIABLES USED :
C
C  JTYPE   THE TYPE OF /FO/ AND /FC/ TO BE USED :
C
C          0  USE /FO/, /FC/ AND UNIT WEIGHT MODIFIER.
C          1  USE /FO/, /FC/ AND 1/FO AS WEIGHT MODIFIER.
C          2  USE /FO/ **2, /FC/ **2 AS  WEIGHT MODIFIER.
C          3  FIND SUITABLE VALUE OF JTYPE FROM LIST 23
C
C  NW      CONTROL FLAG FOR THE CHEBYSHEV WEIGHTING
C
C          0  APPLY THE PARAMETERS IN LIST 4, WEIGHTING SCHEME TYPE 11.
C          1  CALCULATE THE PARAMETERS, WEIGHTING SCHEME TYPE 10.
C
C  NGW     THE NUMBER OF REFLECTIONS WITH NEGATIVE WEIGHTS.
C  WMX      MAXIMUM WEIHT TO BE APPLIED
C  NMX      NUMBER OF REFLECTIONS WITH MAXIMUM WEIGHT
C  IFTYPE   0 FOR FITTING CHEBYCHEV TO FO
C                 IN THIS CASE, THE FIT IS TO FO AND (DELTA)SQ
C           1 FOR FITTING TO FC (SCHEMES 14 & 15)
C                 IN THIS CASE, THE FIT IS TO LOG(FC) AND SQRT(DELTA)SQ
C
C  A       THE SCALE FACTOR FOR /FC/.
C  H       THE MINIMISATION FUNCTION FOR CHEBYSHEV WEIGHTS.
C  ADW     THE MAXIMUM CHEBYSHEV WEIGHT FOUND.
C  CS      CHEBYSHEV WEIGHTING SCHEME PARAMETER (POWER OF /FO/)
C  AM      MULTILPIER FOR EACH WEIGHT THAT IS PRODUCED :
C
C          1     FOR NORMAL WEIGHTS
C          1/FO  FOR ADDITIVE MODE 1000
C
C  FO      /FO/, OR /FO/ **2 FOR ADDITIVE MODE 2000
C  RFO     THE RECIPROCAL OF 'FO', UNLESS 'FO' IS ZERO, WHEN ZERO IS ASS
C  FC      /FC/, OR /FC/ **2 FOR ADDITIVE MODE 2000
C  AW      THE FINAL WEIGHT
C  WWT      WEIGHT MODIFIER FOR TUKEY ALGORITHM
C  RAW     THE RECIPROCAL OF THE E.S.D. IN LIST 6,  OR ZERO.
C  E       1/F!MAX, OR 1/(F!MAX*F!MAX) FOR ADDITIVE MODE 2000
C          WHERE ! IS O OR C
C  ITL     TYPE LABEL :
C
C                FOR /FO/
C          **2   FOR /FO/ **2, UNDER ADDITIVE MODE 2000.
C
C  NR      ADDRESS OF THE L.H.S. FOR THE CHEBYSHEV ACCUMULATION
C  NS      ADDRESS OF THE R.H.S. FOR THE CHEBYSHEV ACCUMULATION
C  NT      THE ADDRESS OF THE ANSWERS.
C  NU      ADDRESS OF THE DERIVATIVES BEFORE THEY ARE ADDED IN
C  NV      ADDRESS OF THE LAST DERIVATIVE
C
C--
C----- NOTE THAT IF STR11 IS USED DOUBLE PRECISION, LENGRP IN
C      LIST11 IN COMMAND FILE MUST BE CHANGED FROM 1 TO 2
C      FOR LHS AND RHS
C      AND I11LEN IN XPRC12
C      DOUBLE PRECISION STR11(1048576)
      DIMENSION STR11(1048576)
      DIMENSION ISTORE(131072)
      DIMENSION ICOM04(16)
C
      DIMENSION NPARAM(16)
      CHARACTER*16 IFMT1
      CHARACTER*12 IFMT2
      CHARACTER*4 ITL,  CSQUAR, IBL
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDATF/NFLD,LFLD,NULD
C      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDATD/XSTR11(1048576)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST04/ITYPE4,ICON41,ICON42,ICON43,L4,M4,MD4,N4,
     2 L4C,M4C,MD4C,N4C,L4F,M4F,MD4F,N4F
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST11/L11,M11,MD11,N11,L11R,M11R,MD11R,N11R,
     2 L11P,M11P,MD11P,N11P,L11IR,M11IR,MD11IR,N11IR
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XLST23/L23M,M23M,MD23M,N23M,L23EX,M23EX,MD23EX,N23EX,
     2 L23MN,M23MN,MD23MN,N23MN,L23AC,M23AC,MD23AC,N23AC,
     3 L23IC,M23IC,MD23IC,N23IC, L23SP,M23SP,MD23SP,N23SP
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM04(1),ITYPE4)
      EQUIVALENCE (STR11(1),XSTR11(1))
C
C
      DATA CSQUAR / '**2 ' /, IBL / '    ' /
      DATA SMALL / .01 /
C
C----- NO OF PARAMETERS EXPECTED FOR EACH SCHEME. 0 = UNDEFINED
      DATA NPARAM / 1, 1, 2, 1, 0, 0, 0, 0, 0, 0,
     1              0, 1, 3, 0, 0, 3 /
C
      DATA IFMT1 / '(I6,2X,20F7.3)  '/
      DATA IFMT2 / '(/7X,20I7)  '/
      DATA MINSCM /1/, MAXSCM /16/
C
      DATA IVERSN / 520 /
C
C
C----- ENABLE PRINTING OF OUTLIERS
      JPRINT = 0
C--CLEAR THE TIME AND CORE AREAS
      CALL XTIME1(2)
C--READ ANY DIRECTIVES THAT OFFER THEMSELVES
      I=KRDDPV(ISTORE(NFL),1)
      IF ( I .LT. 0 ) GO TO 9970
C--CLEAR THE CORE
      CALL XCSAE
      CALL XRSL
C--LOAD LIST TYPE 1
      CALL XFAL01
      CALL XFAL23
      IF (IERFLG .LT. 0) GOTO 9990
      IF (ISTORE(L23MN+3) .LT. 0) GOTO 5560
C--BRING DOWN LIST 4
      CALL XFAL04
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE LIST 4 TYPE
      IULN=4
C--FIND THE TYPE OF THIS WEIGHTING SCHEME
      JTYPE=ICON41
      IF (JTYPE .EQ. 3) THEN
C----- RESET JTYPE DEPENDING ON SCHEME NUMBER AND REFINEMENT TYPE
         IF (ISTORE(L23MN+1) .GE. 0) THEN
C----- FSQ REFINEMENT CHECK IF WE MUST USE 1/2FO, OR /FO/SQ
            IF (  (ITYPE4 .EQ. 10) .OR.
     1            (ITYPE4 .EQ. 11) .OR.
     1            (ITYPE4 .EQ. 14) .OR.
     1            (ITYPE4 .EQ. 15) )    THEN
      IF (ISSPRT .EQ. 0) THEN
                  WRITE(NCWU,100) '/FO/ **2'
      ENDIF
100    FORMAT( 20X, ' LIST 4 weighting type is ', A)
               JTYPE = 2
            ELSE
      IF (ISSPRT .EQ. 0) THEN
                  WRITE(NCWU,100) '1/FO'
      ENDIF
               JTYPE = 1
            ENDIF
         ELSE
C----- NORMAL REFINEMENT
      IF (ISSPRT .EQ. 0) THEN
                  WRITE(NCWU,100) 'NORMAL'
      ENDIF
            JTYPE = 0
         ENDIF
      ENDIF
C----- SET THE MAXIMUM WEIGHT
      WMX = STORE(L4F+1)
C----- SET THE RECIPROCAL MAXIMUM WEIGHT
      WMXINV = 1./ AMAX1( WMX, ZERO)
C----- NO. WITH MAXIMUM WEIGHT
      NMX = 0
C----- SET A UNIT WEIGHT MODIFIER
      WWT = 1.0
C--CHECK IF THIS IS VALID WEIGHTING SCHEME
      IF ( ITYPE4 .LT. MINSCM ) GO TO 9930
      IF ( ITYPE4 .GT. MAXSCM ) GO TO 9930
      IF ((ITYPE4 .EQ. 14) .OR. (ITYPE4 .EQ. 15)) THEN
C----- WEIGHT ACAINST FC
            IFTYPE = 1
      ELSE
C----- WEIGHT ACAINST FO
            IFTYPE = 0
      ENDIF
C--SET UP THE DEFAULT SCALE FACTOR
      A=1.
C--SET THE NUMBER OF NEGATIVE WEIGHTS FOUND TO ZERO
      NGW=0
C----- CHECK IF LIST 6 EXISTS
      IF (KEXIST(6) .LE. 0) GOTO 9990
C--JUMP ON THE SORT OF WEIGHTING SCHEME
      GOTO(1400,1400,1400,1250,1400,1400,1400,1400,1400,1700,1700,2350,
     2 2410, 1700, 1700, 1400,  9980 ) , ITYPE4
      GO TO 9980
C
C--CHECK FOR WEIGHTING SCHEME TYPE 4
1250  CONTINUE
C -- CHECK ENOUGH PARAMETERS GIVEN
      IF ( MD4 .LT. NPARAM(ITYPE4) ) GO TO 9940
      GO TO 1450
C--CHECK FOR MOST OTHER WEIGHTING SCHEMES
1400  CONTINUE
      IF ( MD4 .NE. NPARAM(ITYPE4) ) GO TO 9940
C--CHECK IF THIS IS THE FIRST THREE WEIGHTING SCHEMES
1450  CONTINUE
      IF(ITYPE4-3)1500,1500,1650
C--CHECK THE VALUE FOR PARAMETER ONE  -  A DIVISOR LATER ON
1500  CONTINUE
C -- CHECK FOR ZERO OR NEARLY ZERO DIVISOR
      IF ( ABS(STORE(L4)) - ZERO ) 9950 , 9950 , 1650
C--SET UP THE REFLECTIONS FOR PROCESSING
1650  CONTINUE
      CALL XFAL06(1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CLEAR THE ACCUMULATION AREA FOR THE WEIGHT
      CALL XIRTAC(5)
      GOTO 5100
C
C--CHEBYSHEV TYPE WEIGHTING  -
1700  CONTINUE
C--SET THE NUMBER OF REFLECTIONS USED TO ZERO
      NX=0
C--SET THE MAXIMUM CHEBYSHEV WEIGHT AS ZERO INITIALLY
      ADW=0.
C--SET THE CHEBYSHEV MINIMISATION FUNCTION AS ZERO INITIALLY
      H=0.
C-- CHECK IF THERE IS A LIST 5 TO LOAD
      IF(KEXIST(5))1800,1800,1750
C--THERE IS A LIST 5  -  LOAD IT
1750  CONTINUE
      CALL XFAL05
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE SCALE FACTOR
      A=STORE(L5O)
C--CHECK THAT THERE ARE AT LEAST TWO COEFFICIENTS TO FIND
1800  CONTINUE
      IF ( MD4 .LE. 1 ) GO TO 9910
C--CHECK IF WE CALCULATING OR JUST APPLYING CHEBYSHEV WEIGHTS
      IF ((ITYPE4 .EQ. 11).OR.(ITYPE4 .EQ. 15)) THEN
C--SIMPLY APPLYING THE WEIGHTS  -  SET UP LIST 6
      CALL XFAL06(1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
      CALL XIRTAC(5)
C--INDICATE ONLY AN APPLICATION
      NW=0
      GOTO 2150
      ENDIF
C--SET UP LIST 6 FOR THE INITIAL PASS
      CALL XFAL06(1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE CHEBYSHEV POINTER FOR THE CALCULATION OF THE PARAMETERS
      NW=1
C--SET UP A DUMMY LIST 12
      LN=12
      IREC=8001
      N12=MD4
      MD12B=2
      N12B=1
      L12B=KCHLFL(MD12B)
      ISTORE(L12B)=1
      ISTORE(L12B+1)=MD4
C--SET UP THE MATRIX AREA
      IOLD=-1
      CALL XSET11 (IOLD,1,1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--ASSIGN A FEW POINTERS
      NR=L11
      NS=L11R
C--SET UP THE ANSWERS AREA
      LN=IULN
      NT=KADD11(1001,MD11,MD4)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE PARTIAL DERIVATIVE AREA
      IREC=1002
      NU=NFL
      NV=KCHNFL(MD4)-1
2150  CONTINUE
      IF (IFTYPE .EQ. 0) THEN
C--FETCH THE MAXIMUM VALUE OF /FO/
      M6DTL=L6DTL+3*MD6DTL
      E=STORE(M6DTL+1)
      ELSE
C--FETCH THE MAXIMUM VALUE OF /FC/
      M6DTL = L6DTL + 5*MD6DTL
      E = A* STORE(M6DTL+1)
      E = LOG(E)
      ENDIF
      CS=0.
      EW=1.0
C--SET THE DEFAULT /FO/ TYPE AS NOT THE SQUARED VARIETY
      ITL = '    '
C--CHECK ON THE TYPE OF REFINEMENT THAT WE ARE DOING
      IF(JTYPE .EQ. 2 ) THEN
C--     THIS IS REFINEMENT AGAINST /FO/ **2
        ITL = CSQUAR
        E=E*E
      ENDIF
C--SET UP THE CORRECT DIVISOR
      E=1.0/E
C--CHECK IF WE ARE CALCULATING OR ONLY APPLYING THE WEIGHTS
      IF ((ITYPE4 .EQ. 11).OR.(ITYPE4 .EQ. 15))
     1  GOTO 5100
C--SET UP THE WEIGHTING PARAMETER
      CS = STORE(L4F)
      EW=(1.0/E)**CS
      GOTO 3900
C
C--WEIGHTING SCHEME ON SIN(THETA)  -  CHECK IF A PARAMETER HAS BEEN GIVE
2350  CONTINUE
      AP=-1.0
      IF(MD4)1400,1400,2400
C--A PARAMETER HAS BEEN GIVEN
2400  CONTINUE
      AP=STORE(L4)
      GOTO 1650
C
2410  CONTINUE
C----- MODIFY EXISTING WEIGHTS
C----- CHECK PARAMETERS GIVEN
      AP=-1
      IF(MD4)1400,1400,2420
2420  CONTINUE
C----- CHECK SECOND IS NON ZERO
      AP=STORE(L4)
      APP=STORE(L4+1)
      IF ( ABS ( APP ) .LE. ZERO ) GO TO 9940
      GO TO 1650
C
C--PROCESS THE NEXT REFLECTION  -  CHECK THAT THE CURRENT /FO/ IS NOT ZE
2450  CONTINUE
      FO=STORE(M6+3)
C--SET THE WEIGHT TO THE SIGMA VALUED STORED IN LIST 6
      AW=STORE(M6+12)
      FC=STORE(M6+5)*A
      AM=1.0
C--SET UP THE INVERSE VALUES
      RFO=0.
      RAW=0.
C--CHECK THAT /FO/ IS LARGE ENOUGH
      IF(ABS(FO)-ZERO)2550,2550,2500
C--THIS /FO/ IS LARGE ENOUGH  -  COMPUTE ITS INVERSE
2500  CONTINUE
      RFO=1./FO
      GOTO 2600
C--/FO/ IS ZERO  -  ASSIGN A SMALL VALUE TO AVOID 0**0
2550  CONTINUE
      FO=ZEROSQ
C--CHECK THE SIZE OF THE SIGMA TERM
2600  CONTINUE
      IF(ABS(AW)-ZERO)2700,2700,2650
C--THIS WEIGHT IS LARGE ENOUGH  -  COMPUTE ITS INVERSE
2650  CONTINUE
      RAW=1./AW
C--CHECK IF WE ARE REFINING AGAINST /FO/ **2
2700  CONTINUE
      IF(JTYPE-1)2850,2750,2800
C--WEIGHTS FROM /FO/, BUT MODIFIED TO REFINE AGAINST /FO/ **2
2750  CONTINUE
      AM=0.5*RFO
      GOTO 2850
C--WEIGHTS COMPUTED FROM /FO/ **2
2800  CONTINUE
      AW=2.0*AW*FO
      FO=FO*FO
      FC=FC*FC
C--BRANCH ON THE TYPE OF WEIGHTING SCHEME
2850  CONTINUE
      GOTO(2950,3100,3150,3200,3350,3400,3450,3500,3550,3600,4050,4550,
     2 4560, 3600, 4050, 3452, 2900),ITYPE4
2900  STOP 377
C
C--WEIGHTING SCHEME TYPE 1  -  FO/P(1), OR P(1) IF FO>P(1)
2950  CONTINUE
      IF(FO-STORE(L4))3000,3000,3050
3000  CONTINUE
      AW=FO/STORE(L4)
      GOTO 5050
3050  CONTINUE
      AW=STORE(L4)*RFO
      GOTO 5050
C--WEIGHTING SCHEME TYPE 2  -  1, OR P(1)/FO IF FO>P(1)
3100  CONTINUE
      AW=1.
      IF(FO-STORE(L4))5050,5050,3050
C--WEIGHTING SCHEME TYPE 3  -  1/(1+[(FO-P(2))/P(1)]**2)
3150  CONTINUE
      AW=1./(1.+((FO-STORE(L4+1))*(FO-STORE(L4+1)))/(STORE(L4)
     2 *STORE(L4)))
      GOTO 4600
C--WEIGHTING SCHEME TYPE 4  -  1/(P(1)+FO+P(2)*FO**2+. . . )
3200  CONTINUE
      AW=STORE(L4)+FO
      F=FO
      M=L4
C--CHECK IF THE SERIES HAS MORE THAN ONE TERM
      IF(MD4-2) 4600,3250,3250
C--ADD IN THE REMAINING TERMS
3250  CONTINUE
      DO 3300 L=2,MD4
      F=F*FO
      M=M+1
      AW=AW+F*STORE(M)
3300  CONTINUE
      AW = 1. / AW
      GOTO 4600
C--WEIGHTING SCHEME TYPE 5  -  STORE(M6+4)=W
3350  CONTINUE
      AW=STORE(M6+4)
      GOTO 4600
C--WEIGHTING SCHEME TYPE 6  -  STORE(M6+4)=SQRT(W)
3400  CONTINUE
      AW=STORE(M6+4)
      IF(AW)4650,5050,5050
C--WEIGHTING SCHEME TYPE 7  -  1/SIGMA(/FO/)
3450  CONTINUE
      AW=RAW
      GOTO 4600
3452  CONTINUE
C----- SHELXTL WEIGHTS, W = 1/(SIGSQ+G*FSQ)
      AW = 1 / ( FO*FO*STORE(L4) + AW*AW*STORE(L4+1) + STORE(L4+2)  )
      GOTO 4600
C--WEIGHTING SCHEME TYPE 8  -  1/SIGMA(/FO/)**2
3500  CONTINUE
      AW=RAW
      GOTO 5050
C--WEIGHTING SCHEME TYPE 9  -  UNIT WEIGHTS
3550  CONTINUE
      AW=1.
      GOTO 5050
C
C--CALCULATE THE CHEBYSHEV COEFFICIENTS  -  WEIGHTING SCHEME TYPE 10
C----- OR SCHEME 14
3600  CONTINUE
      B = (FO - FC) * (FO - FC)
      IF (IFTYPE .EQ. 0) THEN
      G=2.*FO*E-1.
      ELSE
      G = 2. * (LOG(AMAX1(1.,FC))*E) -1.
      B = SQRT(B)
      ENDIF
      STORE(NU)=1.
      STORE(NU+1)=G
      IF(MD4-2)3750,3750,3650
C--ACCUMULATE TERMS HIGHER THAN 2
3650  CONTINUE
      NQ=NU+2
      DO 3700 L=3,MD4
      STORE(NQ)=2.*G*STORE(NQ-1)-STORE(NQ-2)
      NQ=NQ+1
3700  CONTINUE
C--COMPUTE THE WEIGHTS FOR THIS REFLECTION
3750  CONTINUE
      W=EW/(1.+FO**CS)
      NQ=NR
      NP=NS
C--ACCUMULATE THE LEAST SQUARES MATRIX
      DO 3850 L=NU,NV
C--THE LEFT HAND SIDE
      DO 3800 M=L,NV
      STR11(NQ)=STR11(NQ)+STORE(L)*STORE(M)*W
      NQ=NQ+1
3800  CONTINUE
C--THE RIGHT HAND SIDE
      STR11(NP)=STR11(NP)+STORE(L)*B*W
      NP=NP+1
3850  CONTINUE
C--FETCH THE NEXT REFLECTION
3900  CONTINUE
      IF(KFNR(0))3950,2450,2450
C
C
C
C--SOLVE THE CHEBYSHEV CASE
3950  CONTINUE
      CALL XCHOLS(MD4,NR,NT)
      CALL XSOLVE(MD4,NR,NS,NT)
C--CLEAR THE LIST ENTRIES
      CALL XCSAE
C--RELOAD LIST 4
      CALL XFAL04
C--MOVE THE PARAMETERS TO LIST 4
      IF ((ITYPE4 .EQ. 10) .OR. (ITYPE4 .EQ. 14)) THEN
      NP=NT
      NQ=L4
      DO 4000 L=1,MD4
      STORE(NQ)=STR11(NP)
      NP=NP+1
      NQ=NQ+1
4000  CONTINUE
      IF (ITYPE4 .EQ. 10) THEN
C--ALTER THE SCHEME TYPE TO 11, AND APPLY THE PARAMETERS
      ITYPE4=11
      ELSE IF (ITYPE4 .EQ. 14) THEN
C----- ALTER TYPE TO 15
            ITYPE4 = 15
      ENDIF
      ELSE
C----- PROGRAMMING ERROR
            GOTO 9980
      ENDIF
C--SET THE NUMBER OF REFLECTIONS USED TO ZERO
      NX=0
C--SET THE MAXIMUM CHEBYSHEV WEIGHT AS ZERO INITIALLY
      ADW=0.
C--SET THE CHEBYSHEV MINIMISATION FUNCTION AS ZERO INITIALLY
      H=0.
      GOTO 1650
C
C----- WEIGHTING SCHEMES TYPE 11, 15 - APPLY CHEBYCHEV WEIGHTS
4050  CONTINUE
      F=FO-FC
      F=F*F
      FSQ = F
      IF (IFTYPE .EQ. 0) THEN
      G=2.*FO*E-1.
      ELSE
            F = SQRT(F)
            G = 2. * (LOG(AMAX1(1.,FC))*E) -1.
      ENDIF
      B=1.
      C=G
      AW=B*STORE(L4)
C--CHECK THE NUMBER OF TERMS TO BE USED
      IF(MD4-2)4250,4200,4100
C--ADD IN TERMS OVER THE SECOND
4100  CONTINUE
      M=L4+2
      DO 4150 L=3,MD4
      D=2.*G*C-B
      AW=AW+D*STORE(M)
      M=M+1
      B=C
      C=D
4150  CONTINUE
C--ADD IN THE SECOND TERM
4200  CONTINUE
      AW=AW+G*STORE(L4+1)
C--CHECK IF WE SHOULD ACCUMULATE THE VARIANCE
4250  CONTINUE
      IF (NW) 4400, 4400, 4300
C--ACCUMULATE THE VARIANCE
4300  CONTINUE
      IF(KALLOW(I))4400,4350,4350
C--THIS REFLECTION DID TAKE PART IN FORMING THE COEFFICIENTS
4350  CONTINUE
      NX=NX+1
      F=AW-F
      H=H+F*F*EW/(1.+FO**CS)
C--FIND THE MAXIMUM OF THE INVERSE WEIGHT
4400  CONTINUE
      IF (IFTYPE .EQ. 1)       AW = AW * AW
      ADW=AMAX1(ADW,AW)
C--COMPUTE THE WEIGHT TERM
C----- IF INVERSE VERY SMALL OR NEGATIVE, SET WEIGHT TO MAXIMUM
      IF (AW - WMXINV) 4460, 4500, 4500
4460  CONTINUE
C----- SET GREATER THAN MAXIMUM - WILL BE TRAPPED LATER
      AW = WMX + 1.
      GOTO 5000
C--THE WEIGHT IS NOT NEGATIVE OR ZERO
4500  CONTINUE
      AWI = AW
      AW=1.0/AW
      IF (ITYPE4 .EQ. 15)  THEN
C----- TUKEY-PRINCE SCHEME (SCHEME 15)
            CALL XMODWT (FSQ, AWI, WWT, JPRINT)
C----- APPLY WEIGHT MODIFIERS
            AW = AW* WWT
      ENDIF
C
      GOTO 4600
C
C--WEIGHTING SCHEME TYPE 12  -  A FUNCTION OF SIN(THETA)/LAMBDA
4550  CONTINUE
      AW=SQRT(SNTHL2(L))**AP
      GOTO 5000
C
4560  CONTINUE
C-- WEIGHTING SCHEME TYPE 13 -  MODIFY EXISTING WEIGHTS
      A=SNTHL2(L)
      AW=STORE(M6+4)*STORE(M6+4)*EXP(4.*TWOPIS*A*AP/APP)
      GOTO 4600
C
C--CALCULATE THE SQUARE ROOT OF THE WEIGHT AND STORE IT
4600  CONTINUE
      IF(AW - ZEROSQ) 4650,4650,5000
C--ERROR BECAUSE THE COMPUTED WEIGHT IS NEGATIVE  -  CHECK IF THE FIRST
4650  CONTINUE
C--UPDATE THE COUNTER AND PRINT THE REFLECTION IF NECCESSARY
      NGW=NGW+1
      IF(NGW-1)4700,4700,4750
C--THIS IS THE FIRST NEGATIVE WEIGHT
4700  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,'(55X,'' Small or negative weight reflections'')')
      ENDIF
4750  CONTINUE
      IF (WWT .LE. SMALL) THEN
        IF (JPRINT .EQ. 1) THEN
C----- WE CANNOT WRITE TO THE SCREEN IF THE 'THERMOMETER' IS BEING DRAWN
CTEMP          WRITE(NCAWU, '( 20X, '' Outliers '',
CTEMP     1    3X,''h'',3X, ''k'',3X, ''l'',4X, ''F obs'', 4X,
CTEMP     2    ''F calc'', 3X, ''Delta sq'', 1X, ''Est delta sq'')' )
            IF (ISSPRT .EQ. 0) WRITE(NCWU,  '( '' Outliers '',
     1    3X,''h'',3X, ''k'',3X, ''l'',4X, ''F obs'', 4X,
     2    ''F calc'', 3X, ''Delta sq'', 1X, ''Est delta sq'')' )
        ENDIF
        IF ((JPRINT .GT. 0) .AND. (JPRINT .LT. 60)) THEN
CTEMP            WRITE(NCAWU,'(1X, 3I4,2F10.2,2G10.2)')
CTEMP     1      NINT(STORE(M6)), NINT(STORE(M6+1)), NINT(STORE(M6+2)),
CTEMP     2      FO, FC, FSQ, AWI
          IF (ISSPRT .EQ. 0) WRITE(NCWU,'(10X, 3I4,2F10.2,2G10.2)')
     1      NINT(STORE(M6)), NINT(STORE(M6+1)), NINT(STORE(M6+2)),
     2      FO, FC, FSQ, AWI
        ELSE IF (JPRINT .EQ. 60 ) THEN
          IF (ISSPRT .EQ. 0) THEN
            WRITE(NCWU, '(1X,'' And so on .......'')')
          ENDIF
        ELSE
          CONTINUE
        ENDIF
      ELSE
        IF(NGW .LT. 60) THEN
          IF (ISSPRT .EQ. 0) THEN
          WRITE(NCWU,4850)NINT(STORE(M6)), NINT(STORE(M6+1)),
     1    NINT(STORE(M6+2)), STORE(M6+3),AW
4850      FORMAT(55X,3I4,F10.2,E11.2)
          ENDIF
        ELSE IF (NWG .EQ. 60) THEN
          IF (ISSPRT .EQ. 0) THEN
            WRITE(NCWU, '(55X, '' and so on . . . . .'')')
          ENDIF
        ELSE
          CONTINUE
        ENDIF
        AW=0.
        GOTO 5050
      ENDIF
C--STORE THE SQUARE ROOT OF THE WEIGHT
5000  CONTINUE
C----- CHECK IF TOO LARGE
      IF (AW - WMX) 5020, 5020, 5010
5010  CONTINUE
C----- TOO LARGE
      AW  = WMX
      NMX = NMX + 1
5020  CONTINUE
      AW=SQRT(AW)
C--STORE THE LAST REFLECTION
5050  CONTINUE
      STORE(M6+4)=AM*AW
      CALL XSLR(1)
      CALL XACRT(5)
C--FETCH THE NEXT REFLECTION
5100  CONTINUE
      IF(KLDRNR(1))5150,2450,2450
C
C
C
C----- TIDY UP AND END
C
5150  CONTINUE
C--JUMP ON THE SCHEME TYPE
      GOTO(5550,5550,5550,5550,5550,5550,5550,5550,5550,9975,5700,5550,
     2 5550, 9975, 5700, 5550,  9930), ITYPE4
C
C--TERMINATE THE REFLECTION TRANSFER AND RETURN
5550  CONTINUE
      CALL XCRD(5)
      CALL XEND06
C--FORM LIST 36 AND OUTPUT IT
5560  CONTINUE
      CALL XCELST(36,ICOM04,4)
      CALL XWLSTD(36,ICOM04,4,-1,0)
C--PRINT THE FINAL CAPTION
C----- WARN USER IF ANY WEIGHTS ARE NEGATIVE
      IF (NGW .GT. 0) GOTO 9920
5570  CONTINUE
C--CHECK IF ANY REFLECTIONS HAVE BEEN FOUND WITH NEGATIVE WEIGHTS
      IF(NGW)5450,5450,5200
C--CHECK IF ALL THE REFLECTIONS HAVE NEGATIVE OR ZERO WEIGHTS
5200  CONTINUE
      IF ( NGW .GE. N6D ) GO TO 9960
C--PRINT OUT THE NUMBER OF REFLECTIONS WITH NEGATIVE WEIGHTS
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,5400)NGW,N6D
      ENDIF
      WRITE(NCAWU,5400) NGW,N6D
5400  FORMAT(/,I6,' Reflections with small or negative weights',
     2 ' out of a total of ',I6/)
5450  CONTINUE
C----- WARN OF MAXIMAL WEIGHTS
      IF (NMX .GT. 0) THEN
            WRITE(NCAWU,5580) NMX,WMX
      IF (ISSPRT .EQ. 0) THEN
            WRITE(NCWU,5580) NMX,WMX
      ENDIF
5580  FORMAT(1X,/, I6, ' Reflections have been given the maximum',
     1 ' weight of ', F10.2,/)
      ENDIF
C----- WARN OF OUTLIERS
      IF(JPRINT .GT. 0) THEN
            WRITE(NCAWU,5585) JPRINT
      IF (ISSPRT .EQ. 0) THEN
            WRITE(NCWU ,5585) JPRINT
      ENDIF
5585  FORMAT(1X,/, I6, ' Reflections rejected as Outliers',/)
      ENDIF
5590  CONTINUE
      CALL XOPMSG ( IOPWEI , IOPEND , IVERSN )
      CALL XTIME2(2)
      RETURN
C
C--PRINT THE RESULTS OF THE CHEBYSHEV SOLUTION FOR /FO/
C  CHECK IF HAVE BEEN CALCULATING THE PARAMETERS IN THIS RUN
5700  CONTINUE
      IF(NW)5550,5550,5750
C--THE PARAMETERS HAVE BEEN CALCULATED ON THIS RUN  -  PRINT THE RESULTS
5750  CONTINUE
      B=H/FLOAT(NX-MD4)
      CALL XPRTCN
      F=1./E
C----- RESTORE 'E' (AS F!)
      IF (IFTYPE .EQ. 1)      F =  EXP(F)
      WRITE(NCAWU,5800) MD4, ITL, F, B
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,5800) MD4, ITL, F, B, IBL, CS
      ENDIF
5800  FORMAT(33H Chebyshev weighting scheme for  ,I2,7H  terms//
     2 13H Maximum /FO/,A3,4H =  ,G11.2,10X,21H Estimated variance =,
     3 G14.5, A4, /, 9X, 14H/Fo/ weight = , F6.2)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,5850)
      ENDIF
5850  FORMAT(//6H Terms,7X,12HCoefficients,11X,8HE.S.D.'S,4X,6HRatios//
     2 )
C--SET THE POINTERS TO PRINT THE RESULTS
      NQ=NT
      NP=NR
C--PRINT THE RESULTS
      DO 6050 L=1,MD4
      C=STR11(NP)
      C=SQRT(C*B)
      D=0.
      DD=STR11(NQ)
C--CHECK FOR A SINGULARITY
      IF(C-0.0000001)5950,5950,5900
C--NOT SINGULAR  -  COMPUTE THE RATIO
5900  CONTINUE
      D=DD/C
C--PRINT THE RESULT
5950  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,6000)L,DD,C,D
      ENDIF
6000  FORMAT(I4,2F20.5,F10.2)
      NQ=NQ+1
      NP=NP+MD4-L+1
6050  CONTINUE
C--SET THE DETAILS FOR LIST 11
      STORE(L11P+16)=FLOAT(NX-MD4)
      STORE(L11P+17)=H
      CALL XFCM
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,6100)
      ENDIF
6100  FORMAT(//19H Correlation matrix)
      CALL XPRTNM ( 16 , IFMT1 , IFMT2 )
C--SET THE NEW WEIGHTING SCHEME TYPE
      ISTORE(L4C)=ITYPE4
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 4
      IDIM04=16
C--WRITE THE NEW LIST OUT TO DISC
      CALL XWLSTD(IULN,ICOM04,IDIM04,-1,-1)
C
C
C--PRINT THE PLOT OF PREDICTED W*DELTA**2 AGAINST /FO/
      CALL XPRTCN
      CALL XLINES
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,6150)ITL,ITL
      ENDIF
      WRITE(NCAWU,6160) ITL
6160  FORMAT( 31H Reciprocal weights versus /FO/,A3//)
6150  FORMAT(40H Plot of estimated delta**2 against /FO/,A3///9X,4H/FO/
     2 ,A3,2X,8HDelta**2/)
C--SET INTERVAL IN FSQ
      CDW=0.
      F=SQRT(F)/40.
C----- WATCH OUT FOR FSQ FITTING
      IF (JTYPE .EQ. 2) ADW = SQRT(ADW)
C--SET MAX WT TO 90
      ADW=90./ADW
C--PASS OVER EACH RANGE OF /FO/
      DO 6700 NDW=1,10000
C--COMPUTE WEIGHT
      CDW=CDW+F
      EDW=CDW*CDW
      IF (IFTYPE .EQ. 0) THEN
      BDW=EDW*E
      ELSE
      BDW = LOG(AMAX1(1.,EDW))*E
      ENDIF
C--CHECK FOR THE END OF THE RANGE
      IF(BDW-1.)6200,6200,6750
6200  CONTINUE
      G=2.*BDW-1.
      B=1.
      C=G
      WDW=B*STORE(L4)
C--CHECK THE NUMBER OF TERMS INVOLVED
      IF(MD4-2)6400,6350,6250
6250  CONTINUE
      M=L4+2
      DO 6300 L=3,MD4
      D=2.*G*C-B
      WDW=WDW+D*STORE(M)
      M=M+1
      B=C
      C=D
6300  CONTINUE
6350  CONTINUE
      WDW=WDW+G*STORE(L4+1)
      IF (JTYPE .EQ. 2) THEN
C-----      WE ARE FITTING TO FSQ, SO TAKE ROOT TO GET NICE GRAPH
            EDW = SQRT(EDW)
            WDW = SQRT(WDW)
      ENDIF
C--FIND THE POINT ON THE PAGE
6400  CONTINUE
      IF (IFTYPE .EQ. 1)       WDW = WDW * WDW
      JDW=NINT(ADW*WDW)
C--CHECK THAT THE POINT IS ON THE PAGE
      IF(JDW)6650,6650,6450
6450  CONTINUE
      L=MINUS
C--CHECK THAT THE POINT IS NOT OFF THE PAGE
      IF(JDW-90)6550,6550,6500
6500  CONTINUE
      L=IPLUS
      JDW=90
C--PRINT THE LINE FOR THIS /FO/
6550  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,6600)EDW,WDW,(L,JJ=1,JDW)
      ENDIF
6600  FORMAT(1H ,E12.4,E13.2,2H I,101A1)
      JDW=MIN0(JDW,57)
      WRITE(NCAWU,6630)EDW ,WDW, (L,JJ=1,JDW)
6630  FORMAT(1X,E10.3,E10.3,2X,60A1)
      GOTO 6700
6650  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,6600)EDW,WDW
      ENDIF
      WRITE(NCAWU,6630) EDW,WDW

6700  CONTINUE
6750  CONTINUE
      CALL XLINES
      GOTO 5550
9900  CONTINUE
C -- ERRORS
      CALL XALTES (4,-1)
      CALL XOPMSG ( IOPWEI , IOPABN , IVERSN )
      GO TO 5590
9910  CONTINUE
C -- TOO FEW COEFFICIENTS
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 )
      ENDIF
      WRITE ( NCAWU , 9915 )
9915  FORMAT ( 1X , 'Too few Chebyshev coefficients' )
      CALL XERHND ( IERERR )
      GO TO 9900
9920  CONTINUE
C -- NEGATIVE WEIGHTS
      CALL XERHND (IERWRN)
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 )
      ENDIF
      WRITE ( NCAWU , 9925 )
9925  FORMAT(///, 7X, 'List 4 is generating small or negative weights')
      GOTO 5570
9930  CONTINUE
C -- ILLEGAL WEIGHTING SCHEME
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9935 ) ITYPE4
      ENDIF
      WRITE ( NCAWU , 9935 ) ITYPE4
9935  FORMAT ( 1X , I5 , ' is an unknown weighting scheme' )
      CALL XERHND ( IERERR )
      GO TO 9900
9940  CONTINUE
C -- INSUFFICIENT PARAMETERS
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9945 )
      ENDIF
      WRITE ( NCAWU , 9945 )
9945  FORMAT ( 1X , 'Insufficient parameters given in list 4' )
      CALL XERHND ( IERERR )
      GO TO 9900
9950  CONTINUE
C -- FIRST PARAMETER ZERO
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9955 ) ITYPE4
      ENDIF
      WRITE ( NCAWU , 9955 ) ITYPE4
9955  FORMAT ( 1X , 'The first parameter for weighting scheme ' , I3 ,
     1 ' may not be zero' )
      CALL XERHND ( IERERR )
      GO TO 9900
9960  CONTINUE
C -- ALL HAVE BAD WEIGHTS
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9965 )
      ENDIF
      WRITE ( NCAWU , 9965 )
9965  FORMAT ( 1X , 'All reflections have a negative or zero weight' )
      CALL XERHND ( IERERR )
      GO TO 9900
9970  CONTINUE
      CALL XOPMSG ( IOPWEI , IOPCMI , IVERSN )
      GO TO 9900
9975  CONTINUE
C----- PROGRAMMING ERROR
      CALL XERHND ( IERPRG)
      GOTO 9900
C
9980  CONTINUE
      CALL XOPMSG ( IOPWEI , IOPINT , IVERSN )
      GO TO 9900
9990  CONTINUE
      WRITE(NCAWU,9991)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,9991)
      ENDIF
9991  FORMAT(7X ,'LIST 6 not on disk',/
     1 7X , 'Weighting abandoned' )
      GOTO 5560
C
      END
C
CODE FOR XMODWT
      SUBROUTINE XMODWT (DELF, DELEST, AWT, IPRINT)
C----- COMPUTE THE MODIFICATION TO BE APPLIED TO THE EXISTING WEIGHTS
C
C      DELF - DELTA FSQ
C      DELEST - ESTIMATED DELTASQ, ON SAME SCALE
C      AWT WEIGHT MODIFIER
C      IPRINT IS .GE. 0 INCREMENTED HERE BY OUTLIERS
C
      DIMENSION ISTORE(131072)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      DATA TOLSQ /36./
C
      IF (DELF .GT. TOLSQ * DELEST) THEN
            AWT = 0.
            IF ( IPRINT .GE. 0) IPRINT = IPRINT + 1
      ELSE
            AWT = (1. - DELF / (TOLSQ * DELEST)) **2
      ENDIF
      RETURN
      END
CODE FOR XANAL
      SUBROUTINE XANAL
C--AGREEMENT ANALYSIS AND LAYER SCALING SUBROUTINE
C
C--ALLOCATION OF THE CORE :
C
C  ICLS  LOCATION OF THE REFLECTION CLASS STACK, WITH ENTRIES FOR :
C
C        0  H=2N
C        1  H=2N+1
C        2  K=2N
C        3  K=2N+1
C        4  L=2N
C        5  L=2N+1
C        6  K+L=2N
C        7  K+L=2N+1
C        8  H+L=2N
C        9  H+L=2N+1
C       10  H+K=2N
C       11  H+K=2N+1
C       12  H+K+L=2N
C       13  H+K+L=2N+1
C       14 -H+K+L=3N
C       15 -H+K+L=3N+1
C
C  IPAR  LOCATION OF THE INDEX PARITY GROUP STACK, WITH ENTRIES :
C
C        0  GGG
C        1  UGG
C        2  GUG
C        3  UUG
C        4  GGU
C        5  UGU
C        6  GUU
C        7  UUU
C
C  IGEN  LOCATION OF THE GENERAL STACK, WITH ENTRIES FOR :
C
C        0  /FO/
C        1  SIN(THETA)/LAMBDA
C        2 -H
C        3 /H/
C        4 +H
C        5 -K
C        6 /K/
C        7 +K
C        8 -L
C        9 /L/
C       10 +L
C
C--THE GENERAL STACK CONTAINS ONE ENTRY FOR EACH RANGE FOR EACH VALUE,
C  STARTING AT THE FIRST VALUE. FOR H, K AND L THE FIRST RANGE CONTAINS
C  THE ENTRIES FOR AN INDEX OF ZERO, THE SECOND RANGE  THE ENTRIES FOR
C  AND INDEX OF 1, ETC..
C  FOR /FO/ AND SIN(THETA)/LAMBDA THE FIRST RANGE CONTAINS THE ENTRIES F
C  REFLECTIONS WITH THE VALUES IN THE FIRST INTERVAL, AND SO ON.
C
C--THE FORMAT OF EACH ENTRY IS :
C
C  0  SCALE FOR THIS GROUP (IF NEC.)
C  1  NUMBER OF OBSERVATIONS
C  2  SUM OF /FO/
C  3  SUM OF /FC/
C  4  SUM OF /DF/
C  5  SUM OF W* /FO/ **2
C  6  SUM OF W* /DF/ **2
C  7  SUM OF W* /FO/ * /FC/
C  8  SUM OF /DF/ **2
C
C--THE 'APD' ARRAY HOLDS THE SAME INFORMATION AS AN ENTRY, EXCEPT
C  THAT THE INFORMATION APPLIES TO ALL THE REFLECTIONS AND THERE IS NO
C  SCALE FACTOR STORED. (APD(1) IS EQUIVALENT TO ENTRY 1, ETC.).
C
C--THE 'BPD' ARRAY HOLDS :
C
C  BPD(1)  SUM OF W* /FO/ **2 FOR ALL REFLECTIONS
C  BPD(2)  SUM OF W* DELTA**2 FOR ALL REFLECTIONS
C  BPD(3)  SUM OF W* /FO/ * /FC/ FOR ALL REFLECTIONS
C
C--OTHER USEFUL VARIABLES ARE :
C  DVF     DIVISION SIZE FOR /FO/
C  MM4     IF NOT GREATER THAN 0, /FO/ DIVISIONS ARE BASED ON
C          SQRT(/FO/)
C          IF GREATER THAN 0, /FO/ IS USED
C  MM5     SET TO ZERO IF THE ANALYSIS IS TO BE DONE ON THE SCALE
C          OF /FO/, ELSE TO 1
C  DVS     DIVISION SIZES FOR SIN(THETA)/LAMBDA
C  MM1     AXIS UP WHICH TO LAYER SCALE  -  DEFAULT IS 1
C  MM2     WRITE/OVERWRITE MODE AFTER LAYER SCALING
C  MM3     FLAG FOR A SECOND AGREEMENT ANALYSIS
C
C  JA      THE TYPE OF /FO/ INTERVAL :
C
C          0  BASED ON SQRT(/FO/)
C          1  BASED ON /FO/
C
C  VV      STEP BETWEEN SUCCESSIVE /FO/ RANGES
C  WW      STEP BETWEEN SUCCESSIVE SIN(THETA)/LAMBDA RANGES
C  SCALF   SCALE FACTOR FOR /FO/
C  SCALC   SCALE FACTOR FOR /FC/
C  E       MAX. SIN(THETA)/LAMBDA VALUE
C  F       MAX. /FO/ VALUE
C  HMIN(3) MIN. INDICES OBSERVED
C  HMAX(3) MAX. INDICES OBSERVED
C  NW      NUMBER OF WORDS PER ENTRY  -  THE FORMAT IS GIVEN ABOVE
C  ISTEP   NUMBER OF WORDS PER RANGE IN THE GENERAL STACK (=11*NW)
C  IBASE(3) THE STEP TO GET FROM THE START OF A RANGE TO THE ENTRY FOR
C           THE MODULUS OF AN INDEX.
C  NR      THE LAYER SCALE INDEX  -  DEFAULT IS 1.
C  MAXADD  THE MAXIMUM CORE ADDRESS USED DURING A SCAN.
C
C--DURING EACH SCAN FOR A REFLECTION, THE FOLLOWING VARIABLES ARE USED :
C
C  H(3)    THE INDICES
C  FO      SCALED /FO/
C  FC      SCALED /FC/
C  S       THE CURRENT WEIGHT
C  DF      /FO/-/FC/
C  ACI     W* /FO/ **2
C  ACT     DELTA**2
C  BCI     W*DELTA**2
C  AP      W* /FO/ * /FC/
C
C--DURING THE PRINTING OF A RANGE, THE FOLLOWING VARIABLES ARE SET :
C
C  L       ADDRESS OF THE ENTRY
C  M       PRINT LIMIT FOR THIS ENTRY  -  SET ON RETURN
C  R       R-FACTOR THAT HAS BEEN COMPUTED
C  RW      WEIGHTED R-FACTOR
C
C--ALL THE CALCULATIONS ARE DONE AT ONE PLACE, WHICH IS ENTERED WITH 'L'
C
C--VARIABLES TO CONTROL THE PLOTTING OF THE W*DELTA**2'S ARE :
C
C  NCHAR   LENGTH OF THE PLOT ARRAY
C  ADIV    NUMBER OF DIVISIONS FOR EACH LOG UNIT
C  NDIV     NINT(ADIV)
C  BMAX    MAXIMUM RATIO ALLOWED
C  BMIN    MINIMUM RATIO ALLOWED
C  ICE     CENTRAL LINE CHARACTER
C  ICENT   POSITION OF THE CENTRAL LINE IN 'IOUT'
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION NOPE(4,30),PN(5),PM(5)
      DIMENSION IFY(16),IFYY(16),IFN(16),IFH(6),IFC(6),IFO(6),IFS(6)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      COMMON /XWTWK/SCALF,R,RW,FOT,FCT,DFT,WDFT,E,F,AP,BP,AT,BT,AC,BC,
     2 ACI,BCI,ACT,BCT,FO,FC,VV,WW,DF,WDF,TC,T,NOCC,TFOCC,SS,S,H(3),
     3 INDEXA(3),MAXADD
      COMMON /XWTWKA/SCALC,IBASE(3),NW,ISTEP,NR,HMIN(3),HMAX(3),ITYPE,
     2 IPAR,IGEN,ICLS,JA,I,J,K,L,M,N,NX,NY,NZ,K1,K2,K3,NC,N1
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST04/ITYPE4,ICON41,ICON42,ICON43,L4,M4,MD4,N4,
     2 L4C,M4C,MD4C,N4C,L4F,M4F,MD4F,N4F
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
C
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
      COMMON/EXPLOT/NCHAR,ICE,ICENT,BMIN,BMAX,ADIV,IOUT(13)
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--HEADING FOR THE LAYER SCALING PART
C
#HOL      DATA PN(1)/'  SC'/,PN(2)/'ALE '/,PN(3)/'    '/,PN(4)/'    '/
#HOL      DATA PN(5)/'    '/
#HOLC--HEADING FOR THE NORMAL PLOT TYPE ENTRIES
#HOL      DATA PM(1)/'LOG('/,PM(2)/'<W*D'/,PM(3)/'ELTA'/,PM(4)/'**2>'/
#HOL      DATA PM(5)/')   '/
&HOL      DATA PN(1)/4H  SC/,PN(2)/4HALE /,PN(3)/4H    /,PN(4)/4H    /
&HOL      DATA PN(5)/4H    /
&HOLC--HEADING FOR THE NORMAL PLOT TYPE ENTRIES
&HOL      DATA PM(1)/4HLOG(/,PM(2)/4H<W*D/,PM(3)/4HELTA/,PM(4)/4H**2>/
&HOL      DATA PM(5)/4H)   /
C--DATA FOR THE VAIOUS CLASSES OF REFLECTION GROUPS
      DATA NOPE(1,1)/'    '/,NOPE(2,1)/' /FO'/,NOPE(3,1)/'/ RA'/
      DATA NOPE(4,1)/'NGE '/
      DATA NOPE(1,2)/'  SI'/,NOPE(2,2)/'NTH/'/,NOPE(3,2)/'L RA'/
      DATA NOPE(4,2)/'NGE '/
      DATA NOPE(1,3)/'    '/,NOPE(2,3)/'   L'/,NOPE(3,3)/'AYER'/
      DATA NOPE(4,3)/'    '/
      DATA NOPE(1,4)/'  PA'/,NOPE(2,4)/'RITY'/,NOPE(3,4)/' GRO'/
      DATA NOPE(4,4)/'UP  '/
      DATA NOPE(1,5)/'    '/,NOPE(2,5)/' TOT'/,NOPE(3,5)/'ALS '/
      DATA NOPE(4,5)/'    '/
      DATA NOPE(1,6)/'    '/,NOPE(2,6)/'H   '/,NOPE(3,6)/'= 2N'/
      DATA NOPE(4,6)/'    '/
      DATA NOPE(1,7)/'    '/,NOPE(2,7)/'H   '/,NOPE(3,7)/'= 2N'/
      DATA NOPE(4,7)/'+1  '/
      DATA NOPE(1,8)/'    '/,NOPE(2,8)/'K   '/,NOPE(3,8)/'= 2N'/
      DATA NOPE(4,8)/'    '/
      DATA NOPE(1,9)/'    '/,NOPE(2,9)/'K   '/,NOPE(3,9)/'= 2N'/
      DATA NOPE(4,9)/'+1  '/
      DATA NOPE(1,10)/'    '/,NOPE(2,10)/'L   '/,NOPE(3,10)/'= 2N'/
      DATA NOPE(4,10)/'    '/
      DATA NOPE(1,11)/'    '/,NOPE(2,11)/'L   '/,NOPE(3,11)/'= 2N'/
      DATA NOPE(4,11)/'+1  '/
      DATA NOPE(1,12)/'   K'/,NOPE(2,12)/'+L  '/,NOPE(3,12)/'= 2N'/
      DATA NOPE(4,12)/'    '/
      DATA NOPE(1,13)/'   K'/,NOPE(2,13)/'+L  '/,NOPE(3,13)/'= 2N'/
      DATA NOPE(4,13)/'+1  '/
      DATA NOPE(1,14)/'   H'/,NOPE(2,14)/'+L  '/,NOPE(3,14)/'= 2N'/
      DATA NOPE(4,14)/'    '/
      DATA NOPE(1,15)/'   H'/,NOPE(2,15)/'+L  '/,NOPE(3,15)/'= 2N'/
      DATA NOPE(4,15)/'+1  '/
      DATA NOPE(1,16)/'   H'/,NOPE(2,16)/'+K  '/,NOPE(3,16)/'= 2N'/
      DATA NOPE(4,16)/'    '/
      DATA NOPE(1,17)/'   H'/,NOPE(2,17)/'+K  '/,NOPE(3,17)/'= 2N'/
      DATA NOPE(4,17)/'+1  '/
      DATA NOPE(1,18)/'  H+'/,NOPE(2,18)/'K+L '/,NOPE(3,18)/'= 2N'/
      DATA NOPE(4,18)/'    '/
      DATA NOPE(1,19)/'  H+'/,NOPE(2,19)/'K+L '/,NOPE(3,19)/'= 2N'/
      DATA NOPE(4,19)/'+1  '/
      DATA NOPE(1,20)/' -H+'/,NOPE(2,20)/'K+L '/,NOPE(3,20)/'= 3N'/
      DATA NOPE(4,20)/'    '/
      DATA NOPE(1,21)/' -H+'/,NOPE(2,21)/'K+L '/,NOPE(3,21)/'# 3N'/
      DATA NOPE(4,21)/'    '/
      DATA NOPE(1,22)/'    '/,NOPE(2,22)/'   G'/,NOPE(3,22)/'GG  '/
      DATA NOPE(4,22)/'    '/
      DATA NOPE(1,23)/'    '/,NOPE(2,23)/'   U'/,NOPE(3,23)/'GG  '/
      DATA NOPE(4,23)/'    '/
      DATA NOPE(1,24)/'    '/,NOPE(2,24)/'   G'/,NOPE(3,24)/'UG  '/
      DATA NOPE(4,24)/'    '/
      DATA NOPE(1,25)/'    '/,NOPE(2,25)/'   U'/,NOPE(3,25)/'UG  '/
      DATA NOPE(4,25)/'    '/
      DATA NOPE(1,26)/'    '/,NOPE(2,26)/'   G'/,NOPE(3,26)/'GU  '/
      DATA NOPE(4,26)/'    '/
      DATA NOPE(1,27)/'    '/,NOPE(2,27)/'   U'/,NOPE(3,27)/'GU  '/
      DATA NOPE(4,27)/'    '/
      DATA NOPE(1,28)/'    '/,NOPE(2,28)/'   G'/,NOPE(3,28)/'UU  '/
      DATA NOPE(4,28)/'    '/
      DATA NOPE(1,29)/'    '/,NOPE(2,29)/'   U'/,NOPE(3,29)/'UU  '/
      DATA NOPE(4,29)/'    '/
      DATA NOPE(1,30)/'    '/,NOPE(2,30)/'  CL'/,NOPE(3,30)/'ASS '/
      DATA NOPE(4,30)/'    '/
C--FORMAT WHEN THERE ARE SOME REFLECTIONS
      DATA IFY(1)/'    '/,IFY(2)/'    '/,IFY(3)/'    '/
      DATA IFY(4)/'    '/
      DATA IFY(5)/'    '/,IFY(6)/'    '/,IFY(7)/'I9,F'/
      DATA IFY(8)/'13.1'/
      DATA IFY(9)/',F12'/,IFY(10)/'.1,2'/,IFY(11)/'E16.'/
      DATA IFY(12)/'4,F9'/
      DATA IFY(13)/'.2,F'/,IFY(14)/'8.2,'/,IFY(15)/'5X,1'/
      DATA IFY(16)/'3A1)'/
C--FORMAT WHEN THERE ARE NO REFLECTIONS
      DATA IFN(1)/'    '/,IFN(2)/'    '/,IFN(3)/'    '/
      DATA IFN(4)/'    '/
      DATA IFN(5)/'    '/,IFN(6)/'    '/,IFN(7)/'I9, '/
      DATA IFN(8)/'85X,'/
      DATA IFN(9)/'A1) '/
      DATA IFN(10)/'    '/,IFN(11)/'    '/,IFN(12)/'    '/
      DATA IFN(13)/'    '/,IFN(14)/'    '/,IFN(15)/'    '/
      DATA IFN(16)/'    '/
C--FORMAT FOR THE LAYER SCALING ENTRIES
      DATA IFYY(1)/'    '/,IFYY(2)/'    '/,IFYY(3)/'    '/
      DATA IFYY(4)/'    '/
      DATA IFYY(5)/'    '/,IFYY(6)/'    '/,IFYY(7)/'    '/
      DATA IFYY(8)/'    '/
      DATA IFYY(9)/'    '/,IFYY(10)/'    '/,IFYY(11)/'    '/
      DATA IFYY(12)/'    '/
      DATA IFYY(13)/'    '/,IFYY(14)/'    '/,IFYY(15)/'F10.'/
      DATA IFYY(16)/'5)  '/
C--INITIAL FORMAT FOR INDEX GROUPS
      DATA IFH(1)/'(1H '/,IFH(2)/',I9,'/,IFH(3)/'6X, '/
      DATA IFH(4)/'    '/,IFH(5)/'    '/,IFH(6)/'    '/
C--INITIAL FORMAT FOR THE REFLECTION CLASSES
      DATA IFC(1)/'(4A4'/,IFC(2)/',   '/,IFC(3)/'    '/
      DATA IFC(4)/'    '/,IFC(5)/'    '/,IFC(6)/'    '/
C--INITIAL FORMAT FOR THE /FO/ RANGES
      DATA IFO(1)/'(1H '/,IFO(2)/',F13'/,IFO(3)/'.2, '/
      DATA IFO(4)/'96X,'/,IFO(5)/'2A1/'/,IFO(6)/'16X,'/
C--INITIAL FORMAT FOR THE SIN(THETA)/LAMBDA RANGES
      DATA IFS(1)/'(1H '/,IFS(2)/',F12'/,IFS(3)/'.5, '/
      DATA IFS(4)/'97X,'/,IFS(5)/'2A1/'/,IFS(6)/'16X,'/
C
C--A FEW COMMONLY USED FORMAT STATEMENTS
1000  FORMAT(//4A4,1X,11HNo. of data,3X,8HSum /FO/,4X,8HSum /FC/,5X,
     2 10H<Delta**2>,5X,12H<W*Delta**2>,4X,4HR(%),3X,5HRW(%),2X,4A4,
     3 A1/)
1050  FORMAT(103X,14H-2 -1  0  1  2)
1100  FORMAT(110X,A1)
C
C--CLEAR THE CLOCK CONTROL AND FETCH THE INPUT PARAMETERS
      CALL XTIME1(2)
      IF (  KRDDPV ( ISTORE(NFL) , 8 )  .LT.  0  ) GO TO 9930
C--SET THE ORIGINAL VARIABLES FROM THE NEW INPUT ROUTINE
      DVF=STORE(NFL)
      DVS=STORE(NFL+3)
      MM4=ISTORE(NFL+1)
      MM5=ISTORE(NFL+2)
      MM1=ISTORE(NFL+4)
      MM2=ISTORE(NFL+5)
      MM3=ISTORE(NFL+6)
      LEVEL=ISTORE(NFL+7)
C--SET UP THE PLOT CONSTANTS
      NCHAR = 13
      ICENT=(NCHAR+1)/2
      ICE=IPOINT
      ADIV=3.0
      NDIV=NINT(ADIV)
      BMAX=FLOAT(NCHAR-ICENT)/ADIV
      BMIN=10.0**(-BMAX)
      BMAX=10.0**(BMAX)
C--TRANSFER THE INPUT DATA TO THE WORKING VARIABLES
      WW=DVS
      VV=DVF
      JA=MM4
      NR=MM1
C--SET UP THE DEFAULT /FO/ RANGE VARIABLE IF NECESSARY
      IF(VV-ZERO)1200,1200,1350
1200  CONTINUE
C--CHECK THE TYPE OF /FO/ RANGE TO BE USED
      IF(JA)1250,1250,1300
C--BASED ON THE SQUARE ROOT OF /FO/
1250  CONTINUE
      VV=1.
      GOTO 1350
C--BASED ON /FO/
1300  CONTINUE
      VV=2.5
C--CHECK IF ANY LAYER SCALING IS REQUIRED
1350  CONTINUE
      IF(NR)1400,1400,1450
C--NONE REQUIRED  -  USE 'H' FOR THE SCAN
1400  CONTINUE
      NR=1
      GOTO 1500
C--CHECK THAT THE INDEX IS NOT TOO LARGE
1450  CONTINUE
      IF(NR-4)1500,1400,1400
C--SET UP THE DEFAULT SIN(THETA)/LAMBDA RANGE VARIABLE
1500  CONTINUE
      IF(WW-0.0001)1550,1550,1600
1550  CONTINUE
      WW=0.04
C--SCAN ALL THE REFLECTIONS
1600  CONTINUE
      CALL XSUAA(MM5)
      IF ( IERFLG .LT. 0 ) GO TO 9900
      CALL XSCAN(-1)
C--SET UP THE RETURN VALUES FOR THE AGREEMENT ANALYSIS PRINT
      ASSIGN 1800 TO NC
      ASSIGN 3250 TO K2
C--CHECK IF ALL THE REFLECTIONS HAVE BEEN PROCESSED
      IF ( NOCC .GT. 0 ) GO TO 9910
      GO TO 6100
C
C--RETURN ADDRESS AFTER PRINTING THE FIRST AGREEMENT ANAYSIS
C  CHECK IF WE SHOULD PRINT THE CALCULATED LAYER SCALES
1800  CONTINUE
      IF(MM1)3150,3150,1850
C--PRINT RESULTS OF LAYER SCALING
1850  CONTINUE
      APD(9)=0.
      APD(10)=0.
      CALL XPRTCN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1900)
      ENDIF
1900  FORMAT(25H Results of layer scaling)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1950)NR
      ENDIF
1950  FORMAT(///5H Axis,I2)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)(NOPE(I,4),I=1,4),PN
      ENDIF
      BP=AMAX1(HMAX(NR),-HMIN(NR))
      J=NINT(BP)+1
      L=IGEN+IBASE(NR)
      ASSIGN 2150 TO K3
C--TRANSFER THE FORMAT TO THE PROPER ARRAY FOR LAYER SCALING
      DO 2000 K=7,14
      IFYY(K)=IFY(K)
2000  CONTINUE
C--SET UP THE RESET OF THE FORMAT
      CALL XSUFS(IFYY,IFN,IFH)
C--COMPUTE THE NEW LAYER SCALE FACTORS
      DO 2250 K=1,J
      I=K-1
C--CHECK THE NUMBER OF REFLS. IN THIS GROUP AND CALC. THE TOTALS IF NECE
      IF(ISTORE(L+1))2050,2050,2100
C--NO REFLECTIONS IN THIS GROUP  -  PRINT ONLY THE RANGE
2050  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFN)I,ISTORE(L+1)
      ENDIF
      GOTO 2200
C--COMPUTE THE NEW SCALE FACTOR FOR THIS INDEX VALUE
2100  CONTINUE
      STORE(L)=STORE(L)*STORE(L+7)/STORE(L+5)
      APD(9)=APD(9)+STORE(L+7)*STORE(L)
      APD(10)=APD(10)+STORE(L+5)*STORE(L)*STORE(L)
CNEW      GOTO 6150
      CALL GCOMPL
C--PRINT THE TOTALS FOR THIS GROUP OF REFLECTIONS
2150  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFYY)I,ISTORE(L+1),(STORE(I+2),I=L,M),STORE(L)
      ENDIF
2200  CONTINUE
      L=L+ISTEP
2250  CONTINUE
C--PRINT THE OVERALL TOTALS
      ASSIGN 2350 TO K1
C--SET UP THE DATA FORMAT IN 'IOUT'
      DO 2300 II=1,NCHAR
      IOUT(II)=IB
2300  CONTINUE
      ICEE=IB
      GOTO 6050
C--COMPUTE THE CORRECTION TO RETAIN THE OVERALL SCALE FACTOR CONSTANT
2350  CONTINUE
      FR=APD(9)/APD(10)*BPD(1)/BPD(3)
      L=IGEN+IBASE(NR)
C--MODIFY THE SCALES TO KEEP THE OVERALL SCALE FACTOR CONSTANT
      DO 2400 I=1,J
      STORE(L)=STORE(L)*FR
      L=L+ISTEP
2400  CONTINUE
C--SET UP THE SECOND PASS
      I=NFL
      NFL=MAXADD
      CALL XFAL06(MM2)
      IF ( IERFLG .LT. 0 ) GO TO 9900
      CALL XIRTAC(4)
      NFL=I
C--MAKE THE SECOND PASS
      CALL XSCAN(MM2)
      ASSIGN 2450 TO K2
C--CHECK IF ALL THE REFLECTIONS WERE PROCESSED
      IF ( NOCC .GT. 0 ) GO TO 9910
C
C--RETURN FROM COMPUTING THE OVERALL TOTALS AFTER THE SECOND AGREEMENT A
C  CHECK IF THE LAYER SCALES HAVE BEEN APPLIED
2450  CONTINUE
      IF(MM2)2600,2600,2500
C--TERMINATE THE REFLECTION OUTPUT
2500  CONTINUE
      CALL XLINES
      CALL XCRD(4)
      CALL XEND06
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2550)
      ENDIF
2550  FORMAT(///41H New scales applied to the data - results)
      GOTO 2700
2600  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2650)
      ENDIF
2650  FORMAT(///35H New scales not applied to the data,
     2 35H - results if they had been applied)
C--PRINT THE HEADER CAPTION
2700  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)(NOPE(I,3),I=1,4),PN
      ENDIF
      L=IGEN+IBASE(NR)
      ASSIGN 2800 TO K3
      CALL XSUFS(IFYY,IFN,IFH)
C--PASS OVER EACH GROUP
      DO 2900 K=1,J
      I=K-1
C--CHECK THE NUMBER OF REFLS. IN THIS GROUP AND CALC. THE TOTALS IF NECE
      IF(ISTORE(L+1))2750,2750,2730
CNEW                           6150
2730  CONTINUE
      CALL GCOMPL
      GO TO 2800
C--NO REFLECTIONS IN THIS GROUP  -  PRINT ONLY THE RANGE
2750  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFN)I,ISTORE(L+1)
      ENDIF
      GOTO 2850
C--PRINT THE TOTALS FOR THIS GROUP OF REFLECTIONS
2800  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFYY)I,ISTORE(L+1),(STORE(I+2),I=L,M),STORE(L)
      ENDIF
2850  CONTINUE
      L=L+ISTEP
2900  CONTINUE
C--PRINT THE TOTALS FOR ALL THE REFLECTIONS
      ASSIGN 3000 TO K1
      DO 2950 II=1,NCHAR
      IOUT(II)=IB
2950  CONTINUE
      ICEE=IB
      GOTO 6050
C--CHECK IF A SECOND AGREEMENT ANALYSIS IS TO BE PRINTED
3000  CONTINUE
      IF(MM3)3100,3100,3050
C--PRINT THE SECOND AGREEMENT ANALYSIS
3050  CONTINUE
      ASSIGN 3100 TO NC
      GOTO 3250
3100  CONTINUE
C
C--EXIT ROUTINES
3150  CONTINUE
      CALL XOPMSG ( IOPANA , IOPEND , 610 )
      CALL XTIME2(2)
      RETURN
C
C--PRINT THE RESULTS OF A FULL AGREEMENT ANALYSIS
3250  CONTINUE
      CALL XPRTCN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3300)
      ENDIF
3300  FORMAT(24H Full agreement analysis,
     2 45H  -  with plots of mean w*Delta**2 divided by,
     3 26H its overall average value)
C--CHECK IF THIS IS ON THE SCALE OF /FO/ OR /FC/
      IF(MM5)3350,3350,3450
3350  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3400)
      ENDIF
3400  FORMAT(/17H on scale of /FO/)
      ACI=SCALC
      GOTO 3550
3450  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3500)
      ENDIF
3500  FORMAT(/17H on scale of /FC/)
      ACI=1./SCALF
C--PRINT THE CURRENT SCALE FACTOR
3550  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3600)ACI
      ENDIF
3600  FORMAT(/16H Scale factor  =,F10.5)
C--WRITE OUT LIST 4
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3650)ITYPE4
      ENDIF
3650  FORMAT(//23H Weighting scheme type ,I4)
      IF(MD4)3800,3800,3700
C--PRINT THE PARAMETERS
3700  CONTINUE
      M4=L4+MD4-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3750)(STORE(I),I=L4,M4)
      ENDIF
3750  FORMAT(/21H With parameter(s) : ,6E15.6/(1H ,20X,6E15.6))
C--AGREEMENT ANALYSIS ON INDICES  -  PASS OVER H, K AND L
3800  CONTINUE
      IF(LEVEL)3820,3820,4870
3820  CONTINUE
      DO 4250 I=1,3
C--PRINT THE CURRENT INDEX TYPE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3850)I
      ENDIF
3850  FORMAT(///28H Agreement analysis on index,I2)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)(NOPE(J,3),J=1,4),PM
      ENDIF
C--FIND THE MAX. AND MIN. VALUES FOR THIS INDEX
      NX=NINT(HMIN(I))
      NY=NINT(HMAX(I))
      NZ=NY-NX+1
C--SET UP THE SWITCH FLAGS FOR THE ACCUMULATION
      ASSIGN 4100 TO K3
C--SET UP THE FORMAT SPECIFICATIONS
      CALL XSUFS(IFY,IFN,IFH)
C--PASS OVER EACH VALUE OF THIS INDEX
      DO 4200 J=1,NZ
C--CHECK IF THIS VALUE IS POSITIVE OR NEGATIVE
      IF(NX)3900,3950,3950
3900  CONTINUE
      L=IGEN+ISTEP*IABS(NX)+IBASE(I)-NW
      GOTO 4000
3950  CONTINUE
      L=IGEN+ISTEP*NX+IBASE(I)+NW
C--CHECK THE NUMBER OF REFLS. IN THIS GROUP AND CALC. THE TOTALS IF NECE
4000  CONTINUE
      IF(ISTORE(L+1))4050,4050,4030
CNEW                           6150
4030  CONTINUE
      CALL GCOMPL
      GOTO 4100
C--NO REFLECTIONS IN THIS GROUP  -  PRINT ONLY THE RANGE
4050  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFN)NX,ISTORE(L+1),ICE
      ENDIF
      GOTO 4150
C--PRINT THE TOTALS FOR THIS GROUP OF REFLECTIONS
4100  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFY)NX,ISTORE(L+1),(STORE(K+2),K=L,M),IOUT
      ENDIF
4150  CONTINUE
      NX=NX+1
C--THIS PIECE OF CODE IS DO THE JUMP BACK TO THE INNER LOOP
      IF ( NZ .EQ. J ) THEN
C
C--WRITE OUT THE TOTALS FOR EACH GROUP
        DO 4160 II=1,NCHAR
          IOUT(II)=IB
4160    CONTINUE
C--SET UP THE POINTS TO MARK
        DO 4170 II=1,NCHAR,NDIV
          IOUT(II)=ICE
4170    CONTINUE
        IOUT(ICENT)=IA
        ICEE=ICE
C--SET UP THE FORMATS
        CALL OVERFL(II)
        CALL XSUFS(IFY,IFN,IFC)
C--WRITE OUT THE BLANK LINE
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,1100)ICEE
        WRITE(NCWU,IFY)(NOPE(N2,5),N2=1,4),N,(APD(N2),N2=1,6),IOUT
      ENDIF
      ENDIF
C
C
4200  CONTINUE
C--PRINT THE FINAL CAPTION FOR THIS GROUP
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)
      ENDIF
4250  CONTINUE
C
C--AGREEEMNT ANALYSIS ON REFLECTION CLASSES
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4300)
4300  FORMAT(///41H Agreement analysis on reflection classes)
      WRITE(NCWU,1000)(NOPE(J,30),J=1,4),PM
      ENDIF
      L=ICLS
      ASSIGN 4400 TO K3
      CALL XSUFS(IFY,IFN,IFC)
C--PASS OVER EACH GROUP
      DO 4500 I=1,16
C--CHECK THE NUMBER OF REFLS. IN THIS GROUP AND CALC. THE TOTALS IF NECE
      IF(ISTORE(L+1))4350,4350,4330
CNEW                           6150
4330  CONTINUE
      CALL GCOMPL
      GOTO 4400
C--NO REFLECTIONS IN THIS GROUP  -  PRINT ONLY THE RANGE
4350  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFN)(NOPE(J,I+5),J=1,4),ISTORE(L+1),ICE
      ENDIF
      GOTO 4450
C--PRINT THE TOTALS FOR THIS GROUP OF REFLECTIONS
4400  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFY)(NOPE(J,I+5),J=1,4),ISTORE(L+1),
     2 (STORE(K+2),K=L,M),IOUT
      ENDIF
4450  CONTINUE
      L=L+NW
4500  CONTINUE
      ASSIGN 4550 TO K1
      GOTO 5900
C--PRINT THE FINAL CAPTION FOR THIS GROUP
4550  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)
C
C--AGREEEMNT ANALYSIS ON PARITY GROUPS
      WRITE(NCWU,4600)
      ENDIF
4600  FORMAT(///36H Agreement analysis on parity groups)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)(NOPE(J,4),J=1,4),PM
      ENDIF
      L=IPAR
      ASSIGN 4700 TO K3
      CALL XSUFS(IFY,IFN,IFC)
C--PASS OVER EACH GROUP
      DO 4800 I=1,8
C--CHECK THE NUMBER OF REFLS. IN THIS GROUP AND CALC. THE TOTALS IF NECE
      IF(ISTORE(L+1))4650,4650,4630
CNEW                           6150
4630  CONTINUE
      CALL GCOMPL
      GOTO 4700
C--NO REFLECTIONS IN THIS GROUP  -  PRINT ONLY THE RANGE
4650  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFN)(NOPE(J,I+21),J=1,4),ISTORE(L+1),ICE
      ENDIF
      GOTO 4750
C--PRINT THE TOTALS FOR THIS GROUP OF REFLECTIONS
4700  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFY)(NOPE(J,I+21),J=1,4),ISTORE(L+1),(STORE(K+2),K=L,
     2 M),IOUT
      ENDIF
4750  CONTINUE
      L=L+NW
4800  CONTINUE
      ASSIGN 4850 TO K1
      GOTO 5900
C--PRINT THE FINAL CAPTION FOR THIS GROUP
4850  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)
      ENDIF
C
C--AGREEMENT ANALYSIS ON /FO/
4870  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4900)
      ENDIF
      WRITE ( NCAWU , 4900 )
4900  FORMAT(///27H Agreement analysis on /FO/)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)(NOPE(J,1),J=1,4),PM
      ENDIF
      WRITE(NCAWU,4910)
4910  FORMAT ( 1X , '  Range  Number  <FO>     <FC>    ' ,
     2 ' <delsq>  <wdelsq>  R    RW  Log( <wdelsq>)' )
4920  FORMAT(1H ,F7.0,I6,2F9.0,2E10.2,2F5.0,3X,13A1)
4921  FORMAT(8H Totals ,I6,2F9.0,2E10.2,2F5.0)
      L=IGEN
      AC=0.
      NZ=0
      ASSIGN 5200 TO K3
      CALL XSUFS(IFY,IFN,IFO)
C--PASS OVER EACH GROUP
      DO 5300 I=1,10000
C--COMPUTE THE CURRENT VALUE OF /FO/ TO BE PRINTED
      ACI=AC
      IF(JA)4950,4950,5000
4950  CONTINUE
      ACI=AC*AC
C--CHECK IF WE ARE AT THE END OF THE /FO/ VALUES
5000  CONTINUE
      IF(AC-F)5050,5050,5350
C--CHECK THE NUMBER OF REFLS. IN THIS GROUP AND CALC. THE TOTALS IF NECE
5050  CONTINUE
      IF(ISTORE(L+1))5100,5100,5080
CNEW                           6150
5080  CONTINUE
      CALL GCOMPL
      GOTO 5200
C--CHECK IF THIS IS THE FIRST RANGE WITH NO REFLECTIONS IN IT
5100  CONTINUE
      IF(NZ)5250,5150,5250
C--NO REFLECTIONS IN THIS GROUP  -  PRINT ONLY THE RANGE
5150  CONTINUE
      NZ=1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFN)ACI,ICE,IB,ISTORE(L+1),ICE
      ENDIF
      WRITE(NCAWU,4920)ACI,ISTORE(L+1)
      GOTO 5250
C--PRINT THE TOTALS FOR THIS GROUP OF REFLECTIONS
5200  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFY)ACI,ICE,IB,ISTORE(L+1),(STORE(K+2),K=L,M),IOUT
      ENDIF
      WRITE(NCAWU,4920)ACI,ISTORE(L+1), STORE(L+2)/FLOAT(ISTORE(L+1)),
     1 STORE(L+3)/FLOAT(ISTORE(L+1)),
     2 (STORE(K+2),K=L+2,M) , IOUT
      NZ=0
5250  CONTINUE
      AC=AC+VV
      L=L+ISTEP
5300  CONTINUE
C--PRINT THE FINAL VALUE
5350  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFY)ACI,ICE
      ENDIF
      WRITE(NCAWU,4920)ACI
      ASSIGN 5400 TO K1
      GOTO 5900
C--PRINT THE LAST CAPTION FOR THIS GROUP
5400  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)
      ENDIF
C----- WRITE TOTALS TO MONITOR
C----- A BLANK LINE
      WRITE(NCAWU,4920)
      WRITE(NCAWU,4921)N,(APD(N2),N2=1,6)
C
C--AGREEMENT ANALYSIS ON SIN(THETA)/LAMBDA RANGES
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,5450)
      ENDIF
5450  FORMAT(///40H Agreement analysis on sin(theta)/lambda)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)(NOPE(J,2),J=1,4),PM
      ENDIF
      AC=0.
      L=IGEN+NW
      NZ=0
      ASSIGN 5650 TO K3
      CALL XSUFS(IFY,IFN,IFS)
C--PASS OVER EACH GROUP
      DO 5750 I=1,10000
      ACI=SQRT(AC)
C--CHECK IF WE HAVE REACHED THE END OF THE RANGES
      IF(AC-E)5500,5500,5800
C--CHECK THE NUMBER OF REFLS. IN THIS GROUP AND CALC. THE TOTALS IF NECE
5500  CONTINUE
      IF(ISTORE(L+1))5550,5550,5530
CNEW                           6150
5530  CONTINUE
      CALL GCOMPL
      GOTO 5650
C--CHECK IF THIS IS THE FIRST RANGE WITH NO INFORMATION IN IT
5550  CONTINUE
      IF(NZ)5700,5600,5700
C--NO REFLECTIONS IN THIS GROUP  -  PRINT ONLY THE RANGE
5600  CONTINUE
      NZ=1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFN)ACI,ICE,IB,ISTORE(L+1),ICE
      ENDIF
      GOTO 5700
C--PRINT THE TOTALS FOR THIS GROUP OF REFLECTIONS
5650  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFY)ACI,ICE,IB,ISTORE(L+1),(STORE(K+2),K=L,M),IOUT
      ENDIF
      NZ=0
5700  CONTINUE
      AC=AC+WW
      L=L+ISTEP
5750  CONTINUE
C--PRINT THE FINAL VALUE
5800  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFY)ACI,ICE
      ENDIF
      ASSIGN 5850 TO K1
      GOTO 5900
C
C--RETURN FROM THE AGREEMENT ANALYSIS PRINT ROUTINES
5850  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)
      ENDIF
      GOTONC,(1800,3100)
C
C
C--WRITE OUT THE TOTALS FOR EACH GROUP
5900  CONTINUE
      DO 5950 II=1,NCHAR
      IOUT(II)=IB
5950  CONTINUE
C--SET UP THE POINTS TO MARK
      DO 6000 II=1,NCHAR,NDIV
      IOUT(II)=ICE
6000  CONTINUE
      IOUT(ICENT)=IA
      ICEE=ICE
C--SET UP THE FORMATS
6050  CONTINUE
      CALL OVERFL(II)
      CALL XSUFS(IFY,IFN,IFC)
C--WRITE OUT THE BLANK LINE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)ICEE
      ENDIF
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,IFY)(NOPE(N2,5),N2=1,4),N,(APD(N2),N2=1,6),IOUT
      ENDIF
      GOTO K1,(2350,3000,4550,4850,5400,5850)
C
C--COMPUTE THE TOTALS FOR ALL THE REFLECTIONS
6100  CONTINUE
      IF (N .EQ. 0) THEN
        R = 0.
        RW = 0.
        SS = 0.
        APD(3) = 0.
        APD(4) = 0.
        APD(5) = 0.
        APD(6) = 0.
      ENDIF
      R=1./FLOAT(N)
      RW=SQRT(APD(5)/APD(4))*100.
      SS=APD(3)/APD(1)*100.
      APD(3)=APD(7)*R
      APD(4)=APD(5)*R
      APD(5)=SS
      APD(6)=RW
      GOTOK2,(3250,2450)
C
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPANA , IOPABN , 0 )
      GO TO 3100
9910  CONTINUE
C -- NOT ALL REFLECTIONS PROCESSED
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 ) NOCC
      ENDIF
      WRITE ( NCAWU , 9915 ) NOCC
9915  FORMAT ( 1X , I5 , ' reflections left unprocessed' )
      ISTAT = IERWRN
C -- IF A NEW LIST 6 WAS TO HAVE BEEN PRODUCED , THIS IS AN ERROR
      IF ( MM2 .GT. 0 ) ISTAT = IERERR
      CALL XERHND ( ISTAT )
      GO TO 9900
9930  CONTINUE
      CALL XOPMSG ( IOPANA , IOPCMI , 0 )
      GO TO 9900
C
C
      END
C
CODE FOR GCOMPL
      SUBROUTINE GCOMPL
C--COMPUTE THE VALUES FOR A GROUP STORED AT 'L'
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      COMMON /XWTWK/SCALF,R,RW,FOT,FCT,DFT,WDFT,E,F,AP,BP,AT,BT,AC,BC,
     2 ACI,BCI,ACT,BCT,FO,FC,VV,WW,DF,WDF,TC,T,NOCC,TFOCC,SS,S,H(3),
     3 INDEXA(3),MAXADD
      COMMON /XWTWKA/SCALC,IBASE(3),NW,ISTEP,NR,HMIN(3),HMAX(3),ITYPE,
     2 IPAR,IGEN,ICLS,JA,I,J,K,L,M,N,NX,NY,NZ,K1,K2,K3,NC,N1
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XPDS/APD(14),BPD(14)
C
      COMMON/EXPLOT/NCHAR,ICE,ICENT,BMIN,BMAX,ADIV,IOUT(13)
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
      R=1./FLOAT(ISTORE(L+1))
      SS=0.
      RW=0.
C----- CHECK IF W* /FO/ NOT TO SMALL
C--CALCULATE THE SIMPLE AND WEIGHTED R-FACTORS
      IF (STORE(L+2) .GE. .001) SS=STORE(L+4)/STORE(L+2)*100.
      IF (STORE(L+5) .GE. .001) RW=SQRT(STORE(L+6)/STORE(L+5))*100.
C--COMPUTE THE OTHER AVERAGES
      STORE(L+4)=STORE(L+8)*R
      STORE(L+5)=STORE(L+6)*R
      STORE(L+6)=SS
      STORE(L+7)=RW
C--SET THE PRINT LIMIT
      M=L+5
C--SET UP THE PLOT ARRAY
      DO 6300 II=1,NCHAR
      IOUT(II)=IB
6300  CONTINUE
      IOUT(ICENT)=ICE
C--COMPUTE THE POSITION OF THIS ENTRY
      SS=STORE(L+5)/APD(4)
C--CHECK FOR A ZERO VALUE
      IF(SS)6350,6600,6350
C--CHECK IF THE NUMBER IS TOO LARGE
6350  CONTINUE
      IF(SS-BMAX)6450,6450,6400
C--THIS NUMBER IS TOO LARGE  -  OUTPUT IT AS A '+'
6400  CONTINUE
      IOUT(NCHAR)=IPLUS
      GOTO 6600
C--CHECK IF THE NUMBER IS TOO SMALL
6450  CONTINUE
      IF(SS-BMIN)6500,6550,6550
C--THIS NUMBER IS TOO SMALL  -  OUTPUT IT AS A '-'
6500  CONTINUE
      IOUT(1)=MINUS
      GOTO 6600
C--THIS NUMBER IS IN RANGE  -  OUTPUT IT AS AN '*'
6550  CONTINUE
      II=INT(ALOG10(SS)*ADIV)+ICENT
      IOUT(II)=IA
C--RETURN TO THE CALLING ROUTINE
6600  CONTINUE
      CALL OVERFL(II)
      RETURN
      END
C

CODE FOR XSUFS
      SUBROUTINE XSUFS(IF1,IF2,IF3)
C
      DIMENSION IF1(16),IF2(16),IF3(6)
C
      CALL XMOVE(IF3(1),IF1(1),6)
      CALL XMOVE(IF3(1),IF2(1),6)
      CALL OVERFL(I)
      RETURN
      END
C
CODE FOR XSUAA
      SUBROUTINE XSUAA(MM5)
C--SET UP THE AGREEMENT ANALYSIS ROUTINES
C
C  MM5   SET TO ZERO IF THE ANALYSIS IS TO BE DONE ON THE SCALE
C        OF /FO/, ELSE TO 1
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      COMMON /XWTWK/SCALF,R,RW,FOT,FCT,DFT,WDFT,E,F,AP,BP,AT,BT,AC,BC,
     2 ACI,BCI,ACT,BCT,FO,FC,VV,WW,DF,WDF,TC,T,NOCC,TFOCC,SS,S,H(3),
     3 INDEXA(3),MAXADD
      COMMON /XWTWKA/SCALC,IBASE(3),NW,ISTEP,NR,HMIN(3),HMAX(3),ITYPE,
     2 IPAR,IGEN,ICLS,JA,I,J,K,L,M,N,NX,NY,NZ,K1,K2,K3,NC,N1
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST04/ITYPE4,ICON41,ICON42,ICON43,L4,M4,MD4,N4,
     2 L4C,M4C,MD4C,N4C,L4F,M4F,MD4F,N4F
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST23/L23M,M23M,MD23M,N23M,L23EX,M23EX,MD23EX,N23EX,
     2 L23MN,M23MN,MD23MN,N23MN,L23AC,M23AC,MD23AC,N23AC,
     3 L23IC,M23IC,MD23IC,N23IC, L23SP,M23SP,MD23SP,N23SP
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET UP THE LISTS FOR PROCESSING
      CALL XRSL
      CALL XCSAE
C--SET UP THE SCALE FACTORS
      SCALC=1.0
      SCALF=1.
C--CHECK IF THERE IS A LIST 5 STORED
      IF(KEXIST(5))1100,1100,1000
C--FETCH LIST 5 AND THEN USE THE SCALE FACTOR STORED THERE
1000  CONTINUE
      CALL XFAL05
      IF ( IERFLG .LT. 0 ) GO TO 9900
      SCALC=STORE(L5O)
      SCALF=1.
C--CHECK WHICH SCALE WE ARE TO USE
      IF(MM5)1100,1100,1050
C--SCALE OF /FC/
1050  CONTINUE
      SCALC=1.
      SCALF=1./STORE(L5O)
C--CHECK IF A LIST 23 IS ALREADY STORED
1100  CONTINUE
      ITYPE=-1
      IF(KEXIST(23))1200,1200,1150
C--LOAD LIST 23 AND FIND THE TYPE OF REFINEMENT WE ARE DOING
1150  CONTINUE
      CALL XFAL23
      IF ( IERFLG .LT. 0 ) GO TO 9900
      ITYPE=ISTORE(L23MN+1)
C--RESET THE CORE LIMTS
1200  CONTINUE
      CALL XRSL
      CALL XCSAE
C--LOAD A FEW LISTS
      CALL XFAL01
      CALL XFAL04
      CALL XFAL06(0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET UP THE NUMBER OF WORDS PER STACK ENTRY
      NW=9
C--SET UP THE NUMBER OF WORDS BETWEEN SUCCESSIVE RANGES
      ISTEP=11*NW
C--SET UP THE STEPS TO THE VARIOUS INDICES WITHIN A RANGE
      IBASE(1)=3*NW
      IBASE(2)=6*NW
      IBASE(3)=9*NW
C--SET UP THE PARITY STACK POINTER
      IPAR=NFL
C--SET UP THE REFLECTION CLASS STACK
      ICLS=IPAR+8*NW
C--SET UP THE GENERAL STACK POINTER
      IGEN=ICLS+16*NW
C--SET THE CURRENT MAXIMUM ADDRESS
      MAXADD=NFL
9900  CONTINUE
C -- NORMAL AND ERROR RETURN
      RETURN
      END
C
CODE FOR XSCAN
      SUBROUTINE XSCAN(MM2)
C--SCANS THE REFLECTIONS AND ACCUMMULATES THE NECESSARY TOTALS
C
C  MM2  THIS CONTROLS THE OUTPUT OF REFLECTIONS TO THE DISC AND THE
C       VALUES USED FOR THE LAYER SCALES
C
C       -1  LAYER SCALE FOR EACH GROUP IS 1.0
C        0  LAYER SCALE FOR EACH GROUP IS STORED, WHERE NECESSARY
C        1  LAYER SCALE FOR EACH GROUP IS STORED, WHERE NECESSARY,
C           AND SHOULD BE APPLIED TO THE STORED REFLECTIONS
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      COMMON /XWTWK/SCALF,R,RW,FOT,FCT,DFT,WDFT,E,F,AP,BP,AT,BT,AC,BC,
     2 ACI,BCI,ACT,BCT,FO,FC,VV,WW,DF,WDF,TC,T,NOCC,TFOCC,SS,S,H(3),
     3 INDEXA(3),MAXADD
      COMMON /XWTWKA/SCALC,IBASE(3),NW,ISTEP,NR,HMIN(3),HMAX(3),ITYPE,
     2 IPAR,IGEN,ICLS,JA,I,J,K,L,M,N,NX,NY,NZ,K1,K2,K3,NC,N1
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      NX=NW+NW
C----- READ/WRITE FLAG FOR KFNR
      IRWF = MAX0 ( 0 , MM2 )
      NOCC=0
C--SET THE FLAGS FOR MAX. AND MIN. /FO/ AND SIN(THETA)/LAMBDA
      E=-1000000.0
      F=-1000000.0
C--SET THE FLAGS FOR THE MAX. AND MIN. INDICES
      DO 1000 J=1,3
      HMIN(J)=1000000.0
      HMAX(J)=-1000000.0
1000  CONTINUE
C--SET UP THE GENERAL STACK IN THE REST OF THE CORE
      L=NFL
      I=(LFL-NFL)/NW
      LFL=LFL-7
      DO 1200 J=1,I
C--CHECK IF WE SHOULD PRESET THE LAYER SCALE OR LEAVE IT ALONE
      IF(MM2)1050,1100,1100
C--SET THE LAYER SCALE FACTORS TO 1.0
1050  CONTINUE
      STORE(L)=1.
1100  CONTINUE
      L=L+1
C--ZERO THE REMAINING WORDS OF THIS ENTRY
      DO 1150 K=2,NW
      STORE(L)=0.
      L=L+1
1150  CONTINUE
1200  CONTINUE
C--CLEAR THE OVERALL TOTAL ENTRIES
      DO 1250 J=1,7
      APD(J)=0.
      BPD(J)=0.
1250  CONTINUE
      N=0
      GOTO 2100
C
C--PROCESS THE LAYER SCALE INFORMATION FOR THE NEXT REFLECTION  -  FETCH
1300  CONTINUE
      H(1)=STORE(M6)
      H(2)=STORE(M6+1)
      H(3)=STORE(M6+2)
      BP=ABS(H(NR))
C--COMPUTE THE ADDRESS FOR THIS INDEX
      L=IGEN+NINT(BP)*ISTEP+IBASE(NR)
C--APPLY THE SCALE FACTOR
      STORE(M6+3)=STORE(M6+3)*STORE(L)
C--COMPUTE /FO/, /FC/ AND THE WEIGHT FOR LAYER SCALING
      FO=STORE(M6+3)*SCALF
      S=XWEIGH(STORE(M6+3),STORE(M6+4))
      FC=STORE(M6+5)*SCALC
C--COMPUTE VARIOUS DELTA FUNCTIONS
      DF=FO-FC
      N=N+1
      ACI=S*FO*FO
      ACT=DF*DF
      BCI=S*ACT
      AP=S*FO*FC
C--ADD IN THE CONTRIBUTIONS FOR THIS REFLECTION
      CALL XSUM(L)
C--ADD IN THE CONTRIBUTIONS TO THE TOTALS
      BPD(1)=BPD(1)+ACI
      BPD(2)=BPD(2)+BCI
      BPD(3)=BPD(3)+AP
C--COMPUTE THE NORMAL WEIGHT AND THE ASSOCIATED DELTAS
      S=STORE(M6+4)*STORE(M6+4)
      ACI=S*FO*FO
      ACT=DF*DF
C--CHECK IF WE ARE REFINING AGAINST /FO/ **2
      IF(ITYPE)1400,1350,1350
C--WE ARE REFINING AGINST /FO/ **2
1350  CONTINUE
      ACI=ACI*FO*FO
      ACT=FO*FO-FC*FC
      ACT=ACT*ACT
C--COMPUTE THE WEIGHTED DELTA SQUARED
1400  CONTINUE
      BCI=S*ACT
      AP=S*FO*FC
C--ADD IN OVERALL TOTALS
      APD(1)=APD(1)+FO
      APD(2)=APD(2)+FC
      APD(3)=APD(3)+ABS(DF)
      APD(4)=APD(4)+ACI
      APD(5)=APD(5)+BCI
      APD(6)=APD(6)+AP
      APD(7)=APD(7)+ACT
C--ADD IN THE TOTALS FOR THE INDICES
      L=KPOSN(1)
      CALL XSUM(L)
      L=KPOSN(2)
      CALL XSUM(L)
      L=KPOSN(3)
      CALL XSUM(L)
C--ADD IN THE TOTAL FOR THE /FO/ RANGES
      BP=FO
C--CHECK IF WE MUST SQUARE ROOT /FO/ TO DETERMINE THE RANGE
      IF(JA)1450,1450,1500
1450  CONTINUE
      BP=SQRT(FO)
C--COMPUTE THE RANGE ADDRESS
1500  CONTINUE
      L=IGEN+IFIX(BP/VV)*ISTEP
C--COMPUTE THE MAX. /FO/ VALUE
      F=AMAX1(F,BP)
      CALL XSUM(L)
C--SIN(THETA)/LAMBDA RANGES  -  COMPUTE SIN(THETA)/LAMBDA
      SS=H(1)*H(1)*STORE(L1S)+H(2)*H(2)*STORE(L1S+1)+H(3)*H(3)
     2 *STORE(L1S+2)+H(2)*H(3)*STORE(L1S+3)+H(1)*H(3)*STORE(L1S+4)+H(1)
     3 *H(2)*STORE(L1S+5)
      L=IGEN+NW+IFIX(SS/WW)*ISTEP
C--COMPUTE THE MAX. VALUE OF SIN(THETA)/LAMBDA
      E=AMAX1(E,SS)
      CALL XSUM(L)
C--TOTALS FOR THE DIFFERENT PARITY GROUPS
      L=ICLS
C--BASED ON THE PARITY OF THE INDIVIDUAL INDICES
      DO 1650 I=1,3
      M=L
C--COMPUTE THE PARITY OF THE INDEX
      J=NINT(H(I))
      INDEXA(I)=IABS(J)
      IF(J/2*2-J)1550,1600,1550
1550  CONTINUE
      M=M+NW
1600  CONTINUE
      CALL XSUM(M)
      L=L+NX
1650  CONTINUE
      J=NINT(H(1)+H(2)+H(3))
C--COMPUTE THE TOTALS BASED ON THE PARITY OF K+L, H+L AND H+K
      DO 1800 I=1,3
C--COMPUTE THE MAX. AND MIN. VALUES OF THE INDEICES
      HMAX(I)=AMAX1(H(I),HMAX(I))
      HMIN(I)=AMIN1(H(I),HMIN(I))
      K=J-NINT(H(I))
      M=L
C--COMPUTE THE PARITY OF THE REQUIRED COMBINATION
      IF(K/2*2-K)1700,1750,1700
1700  CONTINUE
      M=M+NW
1750  CONTINUE
      CALL XSUM(M)
      L=L+NX
1800  CONTINUE
      M=L
C--COMPUTE THE PARITY OF H+K+L AND ADD IN THE CONTRIBUTION
      IF(J/2*2-J)1850,1900,1850
1850  CONTINUE
      M=M+NW
1900  CONTINUE
      CALL XSUM(M)
      L=L+NX
      M=L
C--COMPUTE THE VALUE OF -H+K+L, AND THEN CHECK IF IT IS 3N
      J=J-2*NINT(H(1))
      IF(J/3*3-J)1950,2000,1950
1950  CONTINUE
      M=M+NW
2000  CONTINUE
      CALL XSUM(M)
C--TOTALS FOR THE PARITY GROUP OF THIS REFLECTION
      M=IPAR+NW*(INDEXA(1)-INDEXA(1)/2*2+(INDEXA(2)-INDEXA(2)/2*2)
     2 *2+(INDEXA(3)-INDEXA(3)/2*2)*4)
      CALL XSUM(M)
C--CHECK IF WE MUST STORE THE INFORMATION FOR THIS REFLECTION
      IF(MM2)2100,2100,2050
C--STORE THE MODIFIED REFLECTION
2050  CONTINUE
      CALL XSLR(1)
      CALL XACRT(4)
C--FETCH THE NEXT REFLECTION
2100  CONTINUE
      IF(KFNR(IRWF))2150,1300,1300
C
C--EXIT
2150  CONTINUE
      RETURN
      END
C
CODE FOR XSUM
      SUBROUTINE XSUM(NOC)
C--SUBROUTINE FOR ACCUMMULATING THE TOTALS
C
C  NOC  LOCATION OF THE ENTRY TO BE INCREMENTED
C
C--FORMAT OF THE ENTRY AT NOC :
C
C  0  LAYER SCALE FOR THIS GROUP (IF NEC.)
C  1  NUMBER OF OBSERVATIONS
C  2  SUM OF /FO/
C  3  SUM OF /FC/
C  4  SUM OF /DF/
C  5  SUM OF W* /FO/ **2
C  6  SUM OF W* /DF/ **2
C  7  SUM OF W* /FO/ * /FC/
C  8  SUM OF /DF/ **2
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      COMMON /XWTWK/SCALF,R,RW,FOT,FCT,DFT,WDFT,E,F,AP,BP,AT,BT,AC,BC,
     2 ACI,BCI,ACT,BCT,FO,FC,VV,WW,DF,WDF,TC,T,NOCC,TFOCC,SS,S,H(3),
     3 INDEXA(3),MAXADD
      COMMON /XWTWKA/SCALC,IBASE(3),NW,ISTEP,NR,HMIN(3),HMAX(3),ITYPE,
     2 IPAR,IGEN,ICLS,JA,I,J,K,L,M,N,NX,NY,NZ,K1,K2,K3,NC,N1
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK FOR A CORE OVERFLOW
      IF(NOC-LFL)1250,1000,1000
1000  CONTINUE
      NOCC=NOCC+1
C--CHECK IF WE HAVE PRINTED SUFFICIENT REFLECTIONS
      IF(NOCC-25)1050,1150,1300
C--PRINT THIS REFLECTION
1050  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)(H(I),I=1,3),FO
      ENDIF
1100  FORMAT(/3F5.0,F10.1,25H  Reflection out of range)
      GOTO 1300
C--TERMINATE THE REFLECTION PRINT
1150  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)
      ENDIF
1200  FORMAT(//20H and so on . . . . .)
      GOTO 1300
C--ADD IN THE TOTALS
1250  CONTINUE
      ISTORE(NOC+1)=ISTORE(NOC+1)+1
      STORE(NOC+2)=STORE(NOC+2)+FO
      STORE(NOC+3)=STORE(NOC+3)+FC
      STORE(NOC+4)=STORE(NOC+4)+ABS(DF)
      STORE(NOC+5)=STORE(NOC+5)+ACI
      STORE(NOC+6)=STORE(NOC+6)+BCI
      STORE(NOC+7)=STORE(NOC+7)+AP
      STORE(NOC+8)=STORE(NOC+8)+ACT
C--UPDATE THE MAXIMUM CORE ADDRESS
      MAXADD=MAX0(MAXADD,NOC+9)
1300  CONTINUE
      RETURN
      END
C
C
CODE FOR XWEIGH
      FUNCTION XWEIGH(A,B)
C
      XWEIGH=B*B
      RETURN
      END
C
CODE FOR KPOSN
      FUNCTION KPOSN(NDJW)
C--CALCULATE THE INDEX POSITION IN THE STACK
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      COMMON /XWTWK/SCALF,R,RW,FOT,FCT,DFT,WDFT,E,F,AP,BP,AT,BT,AC,BC,
     2 ACI,BCI,ACT,BCT,FO,FC,VV,WW,DF,WDF,TC,T,NOCC,TFOCC,SS,S,H(3),
     3 INDEXA(3),MAXADD
      COMMON /XWTWKA/SCALC,IBASE(3),NW,ISTEP,NR,HMIN(3),HMAX(3),ITYPE,
     2 IPAR,IGEN,ICLS,JA,I,J,K,L,M,N,NX,NY,NZ,K1,K2,K3,NC,N1
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      NI=NINT(H(NDJW))
      NJ=NW
      IF(NI)1000,1050,1050
1000  CONTINUE
      NJ=-NW
      NI=IABS(NI)
1050  CONTINUE
      KPOSN=IGEN+NI*ISTEP+IBASE(NDJW)+NJ
      RETURN
      END
C
CODE FOR XFAL04
      SUBROUTINE XFAL04
C--ROUTINE TO LOAD LIST 4 FROM THE DISC
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM04(16)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST04/ITYPE4,ICON41,ICON42,ICON43,L4,M4,MD4,N4,
     2 L4C,M4C,MD4C,N4C,L4F,M4F,MD4F,N4F
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM04(1),ITYPE4)
C
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 4
      IDIM04=16
C--LOAD THE LIST
      CALL XLDLST(4,ICOM04,IDIM04,-1)
      IF ( IERFLG .LT. 0 ) RETURN
C--SET THE TYPE OF WEIGHTING SCHEME
      ITYPE4=ISTORE(L4C)
C--SET THE TYPE OF WEIGHT MODIFICATION TO BE DONE
      ICON41=ISTORE(L4C+1)
      RETURN
      END


CRYSTALS CODE FOR READ6
CODE FOR XRD06
      SUBROUTINE XRD06(IULN)
C--READ THE PLANES, LIST 6
C
C  IULN    THE LIST TYPE THAT IS BEING INPUT AS A LIST 6.
C
C--THE REFLECTIONS ARE INPUT AND STORED ON M/T. AFTER  THIS, THEY ARE
C  READ BACK AND STORED ON THE DISC.
C
C--
      CHARACTER *80 CFORM
      DIMENSION ISTORE(131072)
      DIMENSION ICOM06(28)
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 30
      PARAMETER (IDIM30 = 32)
      DIMENSION ICOM30(IDIM30)
C
C
      CHARACTER*24 ICAPT
      DIMENSION ICOM6A(79)
      DIMENSION AA(10),YCARD1(82),YCARD2(82),IFORM(40),IY290(10)
      DIMENSION IPARTS(4),ICAD4(11),JSIGMA(1)
      DIMENSION JRATIO(1)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /UFILE/ NCUFU(10),IFLCHR(10),IFLMAX,IFLIND,NCLU,
     2 IRDLOG(10), IRDCPY(10), IRDCAT(10), IRDPAG, IRDLIN,
     3 IRDCMS(10), IRDINC(10), IRDSCR(10), IRDSRQ(10),
     4 IRDREC(10), IRDFND(10), IRDHGH(10)
      COMMON /XFLDAT/ KEYFIL(8,35), IFLUNI(35), IFLACC(35), IFLSTA(35),
     2 IFLFRM(35), IFLREA(35), IFLOPN(35), IFLLCK(35) , NFLUSD , NFLMAX
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XPCK06/I14(1),IPACKR,IPACKW,I15(1),IPHSER,IPHSEW,
     2 I31(1),JCDRAR,JCDRAW
      COMMON/XLST6A/L6IMP,M6IMP,MD6IMP,N6IMP,L6MLT,M6MLT,MD6MLT,N6MLT,
     2 L6BMP,M6BMP,MD6BMP,N6BMP,L6IB,M6IB,MD6IB,N6IB,
     3 ITYPE6,IAPPND,DENSTY,IUNIT,MEDIUM,NCARDS,NGROUP,INCREM,
     4 LIDFK,MIDFK,MDIDFK,NIDFK,LODFK,MODFK,MDODFK,NODFK,
     5 LFACT,MFACT,MDFACT,NFACT,NSCALE,N6DEAD,IFO,JFO,
     6 IPRINT,ISQ,IPHI,ITHETA,ITUBE,IPLATE,IGAUSS,IHUBER,
     7 LPHI,MPHI,MDPHI,NPHI,LPHIC,MPHIC,MDPHIC,NPHIC,
     8 LPHID,MPHID,MDPHID,NPHID,IT,IT01,NTI,IT02,ITC,IT01C,NTIC,IT02C,
     9 ITU,MITU,MDITU,NITU,IPL,MPL,MDPL,NPL,WI,RANGE,ICHECK
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON/XLST50/LR50,MR50,MDR50,NR50,LR51,MR51,MDR51,NR51,
     2 LR52,MR52,MDR52,NR52,
     3 LR60,MR60,MDR60,NR60,LR61,MR61,MDR61,NR61,LR62,MR62,MDR62,NR62,
     4 LR63,MR63,MDR63,NR63,LR64,MR64,MDR64,NR64,
     5 LR62N,MR62N,MDR62N,NR62N,LR62D,MR62D,MDR62D,NR62D,
     6 LCOM,MCOM,MDCOM,NCOM,MULT50,IDIM50,LSTOFF
      COMMON/XLST30/
     1 L30DR,M30DR,MD30DR,N30DR, L30CD,M30CD,MD30CD,N30CD,
     2 L30RF,M30RF,MD30RF,N30RF, L30IX,M30IX,MD30IX,N30IX,
     3 L30AB,M30AB,MD30AB,N30AB, L30GE,M30GE,MD30GE,N30GE,
     4 L30CL,M30CL,MD30CL,N30CL, L30SH,M30SH,MD30SH,N30SH
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM06(1),L6)
C
      EQUIVALENCE (YCARD1(1),IMAGE(1))
      EQUIVALENCE (ICOM6A(1),L6IMP)
      EQUIVALENCE (L30DR,ICOM30(1))
C
C
      DATA NCARD/82/
C
      DATA IY290(1)/'(F5.'/,IY290(2)/'0,2F'/,IY290(3)/'4.0,'/
      DATA IY290(4)/'2F9.'/,IY290(5)/'0,F4'/,IY290(6)/'.0,2'/
      DATA IY290(7)/'F6.0'/,IY290(8)/',5F8'/,IY290(9)/'.4) '/
C
      DATA NFORM/41/,NY290/9/
C
      DATA ICAD4(1)/'(5X,'/,ICAD4(2)/'3F4.'/,ICAD4(3)/'0,F9'/
      DATA ICAD4(4)/'.0,F'/,ICAD4(5)/'7.0,'/,ICAD4(6)/'F4.0'/
      DATA ICAD4(7)/',F9.'/,ICAD4(8)/'0,F4'/,ICAD4(9)/'.0,4'/
      DATA ICAD4(10)/'F7.2'/,ICAD4(11)/')   '/
C
      DATA LCAD4/11/
C
      DATA IPARTS(1)/5/,IPARTS(2)/6/,IPARTS(3)/7/,IPARTS(4)/8/
      DATA JSIGMA(1)/12/
      DATA JRATIO / 20 /
C
      DATA ICAPT / '/FO/, I or SIGMA is zero' /
C
C--SET THE TIMING FUNCTION
      CALL XTIME1(2)
C--BLANK OUT THE FORMAT ARRAY
      CALL XMVSPD(IB,IFORM(1),NFORM-1)
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 6
      IDIM06=28
C--ASSIGN THE LENGTH OF THE TEMPORARY PART OF THE COMMON BLOCK
      IDIM6A=79
C--SET THE INITIAL FORMAT CONTROL FLAG
      LFORM=1
C--SET UP AN AREA TO HOLD DETAILS OF THE DIRECTIVES FOUND ON INPUT
      LN=IULN
      IREC=1001
      KZ=KCHLFL(NR60)
C--ZERO THIS AREA
      CALL XZEROF(STORE(KZ),NR60)
C--SET UP A COMMON BLOCK FOR INPUT
      KY=IDIM06+IDIM6A
      IREC=1002
      KX=KCHLFL(KY)
C--ZERO THIS COMMON BLOCK
      CALL XZEROF(STORE(KX),KY)
C--INDICATE THAT NO CARDS HAVE BEEN READ
      NCARDS=0
C--INDICATE THAT WE ARE POCESSING NO DIRECTIVE
      IDIR=-1
C--READ THE NEXT DIRECTIVE CARD FROM THE INPUT STREAM
1000  CONTINUE
      LAST=IDIR
      IDIR=KRDNDC(ISTORE(KX),KY)
C--CHECK THE REPLY
      IF(IDIR)1550,1050,1100
C--CONTINUATION CARD  -  RESET THE POINTER
1050  CONTINUE
      IDIR=LAST
      GOTO 1150
C--NEW DIRECTIVE  -  INDICATE THAT IT HAS BEEN INPUT
1100  CONTINUE
      I=KZ+IDIR
      ISTORE(I-1)=1
C--CHECK FOR A 'FORMAT' DIRECTIVE
1150  CONTINUE
      IF(IDIR-5)1450,1200,1450
C--FORMAT STATEMENT  -  FIND THE KEYWORD/FORMAT EXPRESSION
1200  CONTINUE
      IF(KFNDNP(I))1000,1000,1250
C--COMPUTE THE LENGTH OF DATA ON THIS CARD
1250  CONTINUE
      M=LFORM
      N=LASTCH-NC+1
C--COMPUTE THE NEW MAXIMUM LENGTH OF THE FORMAT
      LFORM=LFORM+(N+NWCHAR-1)/NWCHAR
C--CHECK FOR OVERFLOW OF THE FORMAT AREA
      IF(LFORM-NFORM)1400,1400,1300
C--FORMAT STATEMNT IS TOO LONG
1300  CONTINUE
      CALL XMONTR(0)
      CALL XERHDR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1350)
      ENDIF
1350  FORMAT(30H Format statement is too large)
      GOTO 7450
C--STORE THE NEW FORMAT OR PART OF FORMAT
1400  CONTINUE
      CALL XFA4CS(IMAGE(NC),IFORM(M),N)
C--UPDATE THE POINTERS
      NC=LASTCH+1
      GOTO 1000
C--NORMAL DIRECTIVE TO BE INPUT  -  FIND THE KEYWORD
1450  CONTINUE
      IF(KFNDNP(I))1000,1000,1500
C--READ THE VALUE
1500  CONTINUE
      IF(KRDPV(ISTORE(KX),KY))1000,1450,1450
C
C--END OF THE DIRECTIVES  -  CHECK FOR ERRORS DURING THE INPUT
1550  CONTINUE
      LN=IULN
      IF(LEF)7450,1600,7450
C--PRESERVE THE CARD INPUT COMMON BLOCK
1600  CONTINUE
      CALL XMOVE(YCARD1(1),YCARD2(1),NCARD)
C--SET THE POINTERS READY FOR INPUT
      NC=LASTCH
C--STORE THE LIST 6 PART OF THE COMMON BLOCK
      CALL XMOVE(ISTORE(KX),ICOM06(1),IDIM06)
C--STORE THE TEMPORARY PART OF THE COMMON BLOCK
      I=KX+IDIM06
      CALL XMOVE(ISTORE(I),ICOM6A(1),IDIM6A)
C--SET THE NUMBER OF REJECTED REFLECTIONS TO ZERO
      N6DEAD=0
C--POINT INITIALLY TO '/FO/'
      IFO=3
C--ZERO THE CORE BUFFER
      M6=L6
      CALL XZEROF(STORE(M6),MD6)
C--BLANK OUT THE CONTROL BLOCK
      CALL XZEROF(STORE(L6P),MD6P*N6P)
C--CHECK IF THE READ KEYS HAVE BEEN INPUT
      IF(ISTORE(KZ+2))1650,1650,1750
C--NO KEYS HAVE BEEN INPUT  -  SET UP THE DEFAULTS
1650  CONTINUE
      MD6IMP=MIN0(MD6IMP,MDIDFK)
C--CHECK THAT THERE ARE SOME NUMBERS TO BE MOVED
      IF(MD6IMP)4550,4550,1700
C--MOVE THE DEFAULT KEYS ACROSS
1700  CONTINUE
      CALL XMOVE(STORE(LIDFK),STORE(L6IMP),MD6IMP)
      GOTO 1800
C--CHECK IF THERE ARE SOME INPUT KEYWORDS
1750  CONTINUE
      IF(MD6IMP)4550,4550,1800
C--CHECK IF THE PHASE HAS BEEN INPUT AS BOSS PHASES REQUIRE CONVERSION
1800  CONTINUE
      KH=KCOMP(1,IPARTS(2),ISTORE(L6IMP),MD6IMP,1)-1
C--CHECK IF THE 'SIGMA' VALUE IS BEING INPUT
      ISIGMA=KCOMP(1,JSIGMA,ISTORE(L6IMP),MD6IMP,1)
C--CHECK IF THE KEYS TO BE STORED HAVE BEEN INPUT
C -- CHECK IF 'RATIO' ( OF FO AND SIGMA ) HAS BEEN INPUT
      IRATIO = KCOMP ( 1 , JRATIO , ISTORE(L6IMP) , MD6IMP , 1 )
      IF(ISTORE(KZ+3))1850,1850,2050
C--NO STORAGE KEYS HAVE BEEN INPUT  -  SET THE DEFAULTS
1850  CONTINUE
      MD6DMP=MIN0(MD6DMP,MDODFK)
C--CHECK IF ANY OUTPUT KEYS ARE INDICATED
      IF(MD6DMP)1900,1900,2000
C--NO OUTPUT DATA
1900  CONTINUE
      CALL XERHDR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1950)
      ENDIF
1950  FORMAT(48H Insufficient output coefficients per reflection,
     2 20H have been indicated)
      GOTO 7400
C--MOVE THE DEFAULT VALUES ACROSS
2000  CONTINUE
      CALL XMOVE(STORE(LODFK),STORE(L6DMP),MD6DMP)
      GOTO 2100
C--CHECK IF ANY OUTPUT KEYS HAVE BEEN INDICATED
2050  CONTINUE
      IF(MD6DMP)1900,1900,2100
C--CHECK IF THE INDICES SHOULD BE PACKED ON OUTPUT TO THE DISC
2100  CONTINUE
      IPACKW=KCOMP(1,I14,ISTORE(L6DMP),MD6DMP,1)
C--CHECK IF THE PHASE AND THE BATCH NUMBER SHOULD BE PACKED
      IPHSEW=KCOMP(1,I15,ISTORE(L6DMP),MD6DMP,1)
C -- CHECK IF THE JCODE AND RATIO SHOULD BE PACKED TOGETHER
      JCDRAW = KCOMP ( 1 , I31 , ISTORE(L6DMP) , MD6DMP , 1 )
C--CHECK IF A AND B PARTS SHOULD BE GENERATED FROM INPUT /FC/ AND PHASE
      KD=-1
      DO 2300 I=1,4
C--CHECK IF THIS IS /FC/ AND PHASE OR THE TWO PARTS
      IF(I-2)2150,2150,2200
C--/FC/ AND PHASE MUST HAVE BEEN INPUT
2150  CONTINUE
      IF(KCOMP(1,IPARTS(I),ISTORE(L6IMP),MD6IMP,1))2350,2350,2300
C--A AND B PARTS MUST BE ABOUT TO BE STORED
2200  CONTINUE
      IF(KCOMP(1,IPARTS(I),ISTORE(L6DMP),MD6DMP,1))2350,2350,2250
C--A AND B PARTS MUST NOT HAVE BEEN INPUT
2250  CONTINUE
      IF(KCOMP(1,IPARTS(I),ISTORE(L6IMP),MD6IMP,1))2300,2300,2350
2300  CONTINUE
C--CONVERSION IS REQUIRED
      KD=1
C--CONVERT THE INPUT POINTERS TO ABSOLUTE VALUES
2350  CONTINUE
      M6IMP=L6IMP+MD6IMP-1
      DO 2400 I=L6IMP,M6IMP
      ISTORE(I)=ISTORE(I)+M6
2400  CONTINUE
C--CONVERT THE DISC POINTERS TO ABSOLUTE VALUES
      CALL XABP06(1)
C--SET THE INPUT UNIT NUMBER
      IF(IUNIT)2450,2500,2500
C--NORMAL REFLECTION INPUT CHANNEL
2450  CONTINUE
      IUNIT=NCARU
      GOTO 2550
C--DATA IN THE NORMAL INSTRUCTION CHANNEL  -  NOT USUAL
2500  CONTINUE
      IF (IEOF .LE. 0) THEN
C----- READ FROM CURRENT 'USE' FILE
        IUNIT = NCUFU(IFLIND)
      ELSE
C----- SRQ IN USE - FIND CALLING I/O UNTIT
        IUNIT = NCUFU(IFLIND-1)
      ENDIF
C--SET UP THE DEFAULT NUMBER OF REFLECTIONS PER CARD
2550  CONTINUE
      NGROUP=1
      INCREM=1
C--SET THE END POINTER FOR THE INPUT BUFFER
      M6IB=L6IB+MD6IB-1
C--INITIALISE THE REFLECTION VALUE COLLECTION
      DO 2600 I=1,MD6
      CALL XIRTAC(I)
2600  CONTINUE
      M6R=L6R
      CALL XFAL01
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CHECK IF THIS IS A SIMPLE COPY
      IF(ITYPE6-1)2800,2800,2750
C--CHECK IF THIS IS AN APPEND OPERATION
2750  CONTINUE
      IF(IAPPND)3350,2800,2800
C
C--AN APPEND IS REQUIRED
2800  CONTINUE
      I=KHUNTR(IULN,0,IADDL,IADDR,IADDD,0)
C--MOVE TO THE END OF THE RECORD CHAIN FOR THE CURRENT LIST 6
2850  CONTINUE
      IF(KCHNCB(IADDR))2850,2850,2900
C--PRESERVE THE LAST POINTER
2900  CONTINUE
      LASTPN=ISTORE(IADDR)
C--PRESERVE THE OUTPUT INDEX COMPRESS FLAG
      KW=IPACKW
C--PRESERVE THE PHASE/BATCH FLAGS
      KT=IPHSEW
C -- PRESERVE THE JCODE/RATIO FLAG
      KS = JCDRAW
C--PRESERVE THE LIST 6 COMMON BLOCK
      CALL XMOVE(ICOM06(1),ISTORE(KX),IDIM06)
C--INITIATE THE READ FROM LIST 6
      CALL XFLT06(IULN,0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--ELIMINATE THE LAST LIST 6 LOADED FROM THE CORE CHAIN
      ISTORE(IADDR)=LASTPN
C--CONVERT THE MOVE POINTERS TO POINT TO THE ORIGINAL LIST 6
      M6DMP = L6DMP + MD6DMP - 1
      DO 2950 I=L6DMP,M6DMP
      ISTORE(I)=ISTORE(I)-M6+ISTORE(KX+1)
2950  CONTINUE
C--PRESERVE THE MOVE POINTERS
      KP=L6DMP
      KQ=M6DMP
C--PRESERVE THE NEW READ FLAGS
      CALL XMOVE(ICOM06(5),ISTORE(KZ),4)
C--RESTORE THE INPUT DATA TO THE COMMON BLOCK
      CALL XMOVE(ISTORE(KX),ICOM06(1),IDIM06)
C--RESET THE OUTPUT PACKING FLAGS
      IPACKW=KW
      IPHSEW=KT
      JCDRAW = KS
C--CHECK FOR A COPY OPERATION
      IF(ITYPE6-1)3000,3000,3050
C--COPY  -  SET UP THE OUTPUT TYPE
3000  CONTINUE
      N6D=ISTORE(KZ+3)
C -- IF COPY IS TO DISC, CHECK THAT ENOUGH SPACE WILL BE AVAILABLE
      IF ( MEDIUM .GT. 0 ) I = KLSSPC ( IULN , ICOM06 , IDIM06 , 3 )
      CALL XSTR06(IULN,MEDIUM,-1,-1,0)
      GOTO 3100
C--NOW INITIALISE THE OUTPUT SEQUENCE
3050  CONTINUE
      CALL XSTR06(IULN,-1,-1,1,0)
C--RESET THE READ FLAGS
3100  CONTINUE
      CALL XMOVE(ISTORE(KZ),ICOM06(5),4)
C--LOAD THE NEXT REFLECTION  -  SET ALL THE POINTERS
3150  CONTINUE
      L6DMP=KP
      M6DMP=KQ
C--LOAD THE REFLECTION
      IF(KLDRNR(1))3300,3200,3200
C--RESET THE MOVE POINTERS
3200  CONTINUE
      L6DMP=ISTORE(KX+16)
      M6DMP=ISTORE(KX+17)
C--STORE THE REFLECTION
      CALL XSLR(1)
C--ACCUMULATE THE TOTALS
      DO 3250 I=1,MD6
      CALL XACRT(I)
3250  CONTINUE
      GOTO 3150
C--END OF THE REFLECTIONS  -  RESTORE THE COMMON BLOCK COMPLETELY
3300  CONTINUE
      L6DMP=ISTORE(KX+16)
      M6DMP=ISTORE(KX+17)
      MD6R = MD6W
      CALL XZEROF(STORE(M6),MD6)
      GOTO 3400
C
C--INITIALISE THE OUTPUT OF THE REFLECTIONS TO M/T
3350  CONTINUE
      CALL XSTR06(IULN,-1,-1,1,0)
C--RESET THE CURRENT LIST TYPE
3400  CONTINUE
      LN=IULN
      IREC=0
C--LOAD LIST 13 FOR THE TWIN DATA
      CALL XFAL13
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CHECK IF THIS CRYSTAL IS TWINNED
      IF(ISTORE(L13CD+1))3550,3500,3500
C--DATA IS FROM A TWINNED CRYSTAL  -  ALTER THE POINTER TO /FO/
3500  CONTINUE
      IFO=10
C--BRANCH ON THE TYPE OF OUTPUT
3550  CONTINUE
C----- INITIALISE THE ABSORPTION CORRECTION
      I=MABS(-1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
      LN=IULN
      GOTO(7150,3650,4300,4500,5100,6050,6050,6050,3600),ITYPE6
3600  STOP 327
C
C--FIXED FORMAT INPUT
3650  CONTINUE
      IF(DENSTY-ZERO)3700,3700,3750
C--THE NUMBER OF REFLECTIONS PER CARD IS ZERO  -  DEFAULT TO ONE
3700  CONTINUE
      DENSTY=1.
C--RECOMPUTE THE NUMBER OF REFLECTIONS PER CARD AND THE NUMBER OF CARDS
3750  CONTINUE
      NGROUP=MAX0(1,NINT(DENSTY))
      INCREM=MAX0(1,NINT(1./DENSTY))
C--RECREATE THE INPUT DATA AREA
      MD6IB=MD6IB*NGROUP
      L6IB=KCEDR(106,1,1004,MD6IB,N6IB,41)
      M6IB=L6IB+MD6IB-1
C--CHECK IF A FORMAT HAS BEEN PROVIDED
      IF(LFORM-1)3800,3800,4000
C--NO FORMAT INPUT  -  SET UP THE DEFAULT VALUE
3800  CONTINUE
      IF(ITYPE6-6)3900,3850,3900
C--THIS IS REFLECTION INPUT IN FIXED FORMAT  -  CHECK LIST 13
3850  CONTINUE
      IDIF=ISTORE(L13DT)-5
      GOTO(3900,3900,3900,3900,3900,3900,3950,3950,3900),IDIF
C--'CAD4' DATA IS ASSUMED BY DEFAULT
3900  CONTINUE
      CALL XMOVE(ICAD4(1),IFORM(1),LCAD4)
      LFORM=LCAD4
      GOTO 4000
C--'Y290' INPUT FORMAT IS THE DEFAULT TO BE USED
3950  CONTINUE
      CALL XMOVE(IY290(1),IFORM(1),NY290)
      LFORM=NY290
C--COMPRESS THE FORMAT FOR USE
4000  CONTINUE
      CALL XFCCS(IFORM(1),IFORM(1),LFORM)
C----- CONVERT TO CHARACTERS
      WRITE(CFORM, '(20A4)' ) (IFORM(IZZ), IZZ = 1, LFORM)
C--READ THE NEXT REFLECTION
4050  CONTINUE
      READ(IUNIT,CFORM,END=4200,ERR=4170) (STORE(I), I= L6IB, M6IB)
      NCARDS=NCARDS+INCREM
C--CHECK FOR BLANK ENTRY
      DO 4100 I=L6IB,M6IB
      IF(NINT(STORE(I)))4150,4100,4150
4100  CONTINUE
      GOTO 4050
C--CHECK FOR THE END OF THE REFLECTIONS
4150  CONTINUE
      IF(STORE(L6IB)+511.) 7150, 6100, 6100
C--END OF FLE DURING THE READ  -  CHECK IF THIS IS ON THE INPUT UNIT
C----- ERROR DURING READ -
4170  CONTINUE
      IF (NCARDS .LE. 0) THEN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,'(//'' Check the reflection filename, and format'')')
      ENDIF
      WRITE(NCAWU,'(//'' Check the reflection filename, and format'')')
      ELSE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU ,4171)
      ENDIF
      WRITE(NCAWU,4171)
4171  FORMAT(' Error during reading reflections'//
     1 ' They should be terminated with an h value of -512')
      END IF
      LEF = -1
      GOTO 4250
4200  CONTINUE
      IF(IUNIT-NCRU)7150,4250,7150
C--NORMAL INPUT UNIT  -  INDICATE END OF FILE
4250  CONTINUE
      IEOF=-1
      GOTO 7150
C
C--FREE FORMAT REFLECTION INPUT
4300  CONTINUE
      NW=MD6IMP-1
      IF(NW)4550,4550,4350
C--READ THE FIRST WORD OF THE NEXT REFLECTION
4350  CONTINUE
      IF(KRD06(STORE(L6IB),1,-1))7150,4400,7400
C--CHECK FOR END OF FILE
4400  CONTINUE
      IF(STORE(L6IB)+511.) 7150, 4450, 4450
C--READ THE REMAINDER OF THE DATA
4450  CONTINUE
      IF(KRD06(STORE(L6IB+1),NW,0))7400,6100,7400
C
C--THIS IS A COMPRESSED INPUT  -  COMPUTE THE NUMBER OF COEFFICIENTS
4500  CONTINUE
      NW=MD6IMP-3
C--CHECK IF ANY COEFFICIENTS ARE INDICATED
      IF(NW)4550,4550,4650
C--NO DATA
4550  CONTINUE
      CALL XERHDR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4600)
      ENDIF
4600  FORMAT(47H Insufficient input coefficients per reflection,
     2 20H Have been indicated)
      GOTO 7400
C--SET THE TRUE POINTER FOR THE MULTIPLIERS
4650  CONTINUE
      M6MLT=L6MLT+3
C--INVERT THE MULTIPLIERS
      DO 4700 I=1,NW
      AA(I)=1./STORE(M6MLT)
      M6MLT=M6MLT+1
4700  CONTINUE
C--READ THE NEXT 'KL' PAIR
4750  CONTINUE
      IF(KRD06(STORE(L6IB+1),2,0))7400,4800,7400
C--READ THE NEXT 'H' VALUE
4800  CONTINUE
      IF(KRD06(STORE(L6IB),1,0))7400,4850,7400
C--CHECK IF THIS VALUE INDICATES THE END OF THIS 'KL' PAIR
4850  CONTINUE
      IF(STORE(L6IB)-511.)4900,4900,4750
C--CHECK IF THIS VALUE OF 'H' INDICATES THE END OF THE REFLECTIONS
4900  CONTINUE
      IF(STORE(L6IB)+511.)7150,4950,4950
C--READ THE COEFFICIENTS
4950  CONTINUE
      IF(KRD06(STORE(L6IB+3),NW,0))7400,5000,7400
C--MULTIPLY UP THE COEFFICIENTS
5000  CONTINUE
      L=L6IB
      DO 5050 K=1,NW
      STORE(L+3)=STORE(L+3)*AA(K)
      L=L+1
5050  CONTINUE
      GOTO 6100
C
C--INPUT FROM A BOSS TAPE  -  READ THE TITLES AND DETAILS
5100  CONTINUE
C----- THE LINK TO THE 'BOSS' SYSTEM IS NO LONGER SUPPORTED
      GOTO 7150
C
C--REFLECTION INPUT, INCLUDING SCALING AND ABSORPTION CORRECTIONS
6050  CONTINUE
      I=MSCALE(-1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
      GOTO(7150,3650,4300,4500,5100,3650,4300,4500,3600),ITYPE6
C
C--UPDATE AND STORE THE REFLECTION
6100  CONTINUE
      L=L6IB
C--LOOP OVER EACH INPUT GROUP
      DO 7050 K=1,NGROUP
      STORE(M6+27)=1.
      STORE(M6+12)=0.
C--MOVE THE DATA FROM THE INPUT BUFFER TO THE CORE BUFFER
      DO 6150 I=L6IMP,M6IMP
      J=ISTORE(I)
      STORE(J)=STORE(L)
      L=L+1
6150  CONTINUE
C----- CHECK INDICES
      IF((ABS(STORE(M6))+ ABS(STORE(M6+1))+ ABS(STORE(M6+2)))
     1 .LE. ZERO) GOTO 7050
C--CHECK IF WE SHOULD COMPUTE SIN(THETA)/LAMBDA SQUARED
      IF(L1S)6250,6250,6200
C--COMPUTE IT
6200  CONTINUE
      STORE(M6+16)=SNTHL2(I)
C--ENSURE A MINIMUM BATCH NUMBER OF ONE
6250  CONTINUE
      STORE(M6+13)=AMAX1(STORE(M6+13),1.)
C----- ENSURE POSITIVE JCODES AND LESS THAN 10
      STORE(M6+18) = AMIN1( 9., AMAX1(0., STORE(M6+18)) )
C--ENSURE A MINIMUM SERIAL OF ZERO
      STORE(M6+19)=AMAX1(STORE(M6+19),0.)
C--CHECK IF WE SHOULD COMPUTE THE A-PART AND B-PART FROM /FC/ AND PHASE
      IF(KD)6350,6300,6300
C--COMPUTE THE PARTS
6300  CONTINUE
      STORE(M6+7)=STORE(M6+5)*COS(STORE(M6+6))
      STORE(M6+8)=STORE(M6+5)*SIN(STORE(M6+6))
C--BRANCH ON THE INPUT TYPE
6350  CONTINUE
      GOTO(6550,6550,6550,6550,6550,6450,6450,6450,6400),ITYPE6
6400  STOP 323
C--REFLECTION INPUT  -  APPLY ANY SCALES AND COEFFICIENTS
6450  CONTINUE
      IF(MSCALE(0))7050,6500,6500
C--AND NOW APPLY ANY ABSORPTION CORRECTION THAT IS REQUIRED
6500  CONTINUE
      IF(MABS(0))7050,6550,6550
C--CHECK IF WE SHOULD TAKE THE SQUARE ROOT
6550  CONTINUE
      JFO=M6+IFO
      IF(ISQ)6600,6700,6700
C--CHECK THE VALUE OF /FO/ **2 GIVEN
6600  CONTINUE
      IF(STORE(JFO))6900,6900,6650
C--/FO/ **2 IS OKAY  -  TAKE THE SQUARE ROOT
6650  CONTINUE
      STORE(JFO)=SQRT(STORE(JFO))
      STORE(M6+12)=STORE(M6+12)/(2.*STORE(JFO))
C--APPLY THE SCALE STORED IN THE 'CORRECTIONS' SLOT
6700  CONTINUE
      STORE(JFO)=STORE(JFO)*STORE(M6+27)
      STORE(M6+12)=STORE(M6+12)*STORE(M6+27)
      STORE(M6+27)=1./STORE(M6+27)
C--SEE IF WE SOULD CHECK THE VALUES OF /FO/ AND SIGMA
      IF(ICHECK)6950,6750,6750
C--CHECK THAT THE GIVEN VALUES OF /FO/ AND SIGMA ARE NOT ZERO
6750  CONTINUE
      IF(STORE(JFO)-ZERO)6900,6900,6800
C--CHECK IF 'SIGMA' HAS BEEN INPUT
6800  CONTINUE
      IF(ISIGMA)6950,6950,6850
C--CHECK SIGMA
6850  CONTINUE
      IF(STORE(M6+12)-ZERO)6900,6900,6950
C--CHECK IF THIS IS THE FIRST REJECTED REFLECTION
6900  CONTINUE
      CALL XL6RRP(N6DEAD,1000,IFO,ICAPT)
      GOTO 7050
6950  CONTINUE
C -- CALCULATE RATIO OF (FO)**2 AND SIGMA((FO)**2),IF IT HAS NOT BEEN IN
      IF ( IRATIO .LE. 0 ) THEN
        IF ( STORE(M6+12) .LE. ZERO ) THEN
          STORE(M6+20) = 0.0
        ELSE
          STORE(M6+20) = AMIN1( STORE(JFO) / (2.*STORE(M6+12)), 999.)
        ENDIF
      ENDIF
C
C -- AND NOW STORE THE REFLECTION
      CALL XSLR(1)
C--ACCUMULATE THE REFLECTION TOTALS
      DO 7000 I=1,MD6
      CALL XACRT(I)
7000  CONTINUE
7050  CONTINUE
C--BRANCH ON THE TYPE OF INPUT
       GOTO(4050,4050,4350,4800,7100,4050,4350,4800,7100),ITYPE6
7100  CONTINUE
      WRITE(NCAWU,7120)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,7120)
      ENDIF
7120  FORMAT(///' Unsupported input data format'//)
      GOTO 7400
C
C--END OF THE REFLECTION INPUT  -  STORE THEM ON THE DISC
7150  CONTINUE
      N6D=N6W
C--NO ERRORS  -  CALCULATE THE REFLECTION DETAILS
      DO 7200 I=1,MD6
      CALL XCRD(I)
7200  CONTINUE
C--TERMINATE THE OUTPUT OF THE LIST
      CALL XERT(IULN)
      CALL XLINES
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 7250 ) N6W , N6DEAD
      ENDIF
      WRITE ( NCAWU , 7250 ) N6W , N6DEAD
7250  FORMAT ( 1X , I6 , ' reflection(s) accepted' , 10X ,
     2 I6 , ' reflection(s) rejected' )
C----- IF LIST 30 IN CORE, WE WERE PROBABLY READING RAW DATA
      IF (KHUNTR (30,0, IADDL,IADDR,IADDD, -1) .EQ. 0) THEN
        STORE(L30DR) = N6W
        CALL XWLSTD ( 30, ICOM30, IDIM30, -1, -1)
      ENDIF
C
C---- PRINT CORRECTION DETAILS
      I=MABS(1)
C--CHECK FOR ANY ERRORS
      IF(LEF)7400,7300,7400
C--NO ERRORS  -  CHECK IF WE MUST OUTPUT TO DISC NOW
7300  CONTINUE
      CALL XSWP06(IULN,MEDIUM)
C
C--END OF THE INPUT  -  RESTORE THE INPUT CARD IMAGE
      CALL XMOVE(YCARD2(1),YCARD1(1),NCARD)
      GOTO 7500
C--ERROR(S) DURING INPUT  -  RESTORE THE CURRENT CARD IMAGE
7400  CONTINUE
      CALL XMOVE(YCARD2(1),YCARD1(1),NCARD)
C--PRINT THE ERROR TERMINATION MESSAGE
7450  CONTINUE
      CALL XOPMSG ( IOPLSI , IOPLSP , IULN )
      CALL XLSALT ( IULN , 0 , 0 , ILSERF , ILSSET )
C--REWIND THE M/T BEFORE WE LEAVE
      REWIND MTA
      REWIND MTB
C--CHECK IF WE HAVE BEEN READING FROM THE MAIN INPUT FILE
7500  CONTINUE
      IF(IUNIT-NCRU)7600,7550,7600
C--INPUT FROM THE MAIN CHANNEL  -  ALTER THE COUNTERS
7550  CONTINUE
      NI=NI+NCARDS
      MON=NI
C--AND NOW RETURN
7600  CONTINUE
      CALL XOPMSG ( IOPLSI , IOPLSE , IULN )
      CALL XTIME2 ( 2 )
      RETURN
C
9900  CONTINUE
C -- ERRORS
      GO TO 7400
C
      END
C
CODE FOR MSCALE
      FUNCTION MSCALE(IPOINT)
C--CONTROL ROUTINE FOR INPUT GENERATED BY THE HILGER-WATTS DATA REDUCTIO
C  PROGRAM.
C
C  IPOINT  THE CALL CONTROL VALUE :
C
C          -1  INITIALISE.
C           0  PROCESS.
C
C--RETURN VALUES OF 'MSCALE' ARE :
C
C  -1  NO REFLECTION READ.
C   0  REFLECTION READ.
C
C--
      DIMENSION ISTORE(131072)
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 30
      PARAMETER (IDIM30 = 32)
      DIMENSION ICOM30(IDIM30)
C
      CHARACTER*24 ICAPT
C
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST6A/L6IMP,M6IMP,MD6IMP,N6IMP,L6MLT,M6MLT,MD6MLT,N6MLT,
     2 L6BMP,M6BMP,MD6BMP,N6BMP,L6IB,M6IB,MD6IB,N6IB,
     3 ITYPE6,IAPPND,DENSTY,IUNIT,MEDIUM,NCARDS,NGROUP,INCREM,
     4 LIDFK,MIDFK,MDIDFK,NIDFK,LODFK,MODFK,MDODFK,NODFK,
     5 LFACT,MFACT,MDFACT,NFACT,NSCALE,N6DEAD,IFO,JFO,
     6 IPRINT,ISQ,IPHI,ITHETA,ITUBE,IPLATE,IGAUSS,IHUBER,
     7 LPHI,MPHI,MDPHI,NPHI,LPHIC,MPHIC,MDPHIC,NPHIC,
     8 LPHID,MPHID,MDPHID,NPHID,IT,IT01,NTI,IT02,ITC,IT01C,NTIC,IT02C,
     9 ITU,MITU,MDITU,NITU,IPL,MPL,MDPL,NPL,WI,RANGE,ICHECK
      COMMON/XLST27/L27,M27,MD27,N27
      COMMON/XLST30/
     1 L30DR,M30DR,MD30DR,N30DR, L30CD,M30CD,MD30CD,N30CD,
     2 L30RF,M30RF,MD30RF,N30RF, L30IX,M30IX,MD30IX,N30IX,
     3 L30AB,M30AB,MD30AB,N30AB, L30GE,M30GE,MD30GE,N30GE,
     4 L30CL,M30CL,MD30CL,N30CL, L30SH,M30SH,MD30SH,N30SH
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      EQUIVALENCE (JD,SCALE),(JE,GRAD),(IH,JF),(IK,JG)
      EQUIVALENCE (L30DR,ICOM30(1))
C
      SAVE
C
C
C
      DATA ICAPT / 'Correction is zero' /
C
C--ASSIGN THE RETURN VALUE
      MSCALE=0
C--CHECK THE CALL TYPE
      IF(IPOINT)1000,1550,1550
C--CHECK IF A LIST 27 IS PRESENT
1000  CONTINUE
      SCALE=1.0
      IF(NSCALE)1100,1100,1050
C--SCALING IS INDICATED  -  CHECK FOR A LIST 27
1050  CONTINUE
      IF(KEXIST(27))1100,1100,1250
C--NO LIST 27 THAT CAN BE USED
1100  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1150)
      ENDIF
1150  FORMAT(/16H No scales found)
      N27=-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)SCALE
      ENDIF
1200  FORMAT(/11H A scale of,F10.5,18H  has been assumed/)
      GOTO 1500
C--LOAD LIST 27 FROM THE DISC
1250  CONTINUE
      CALL XFAL27
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE POINTERS TO THE SECOND SCALE
      M27=L27+MD27
C--CHECK IF ANY SCALES ARE PRESENT TO USE
      IF(N27-2)1300,1400,1400
C--NO SCALES IN LIST 27
1300  CONTINUE
      I=0
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1350)I,I
      ENDIF
1350  FORMAT(/23H Scales exhausted after,I6,15H  reflection(s),5X,
     2 14H(At reflection,I6,1H))
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)SCALE
      ENDIF
      GOTO 1500
C--CALCULATE A FEW CONSTANTS
1400  CONTINUE
C----- LOAD DATA IF LIST 30 NOT ALREADY IN CORE
      IF (KHUNTR (30,0, IADDL,IADDR,IADDD, -1) .LT. 0) CALL XFAL30
      IF (IERFLG .LT. 0) GOTO 6520
      ATMP = -1000000.
      BTMP =  1000000.
      M27TMP = L27 + NSCALE
      DO 1510 I = 1, N27
      ATMP = MAX (ATMP, STORE(M27TMP))
      BTMP = MIN (BTMP, STORE(M27TMP))
      M27TMP = M27TMP + MD27
1510  CONTINUE
      STORE(L30CD+8) = 100. * (ATMP-BTMP)/ATMP
      CALL XWLSTD ( 30, ICOM30, IDIM30, -1, -1)
6520  CONTINUE
C
      JA=NINT(STORE(L27+3))
      JB=NINT(STORE(M27+3))
      IH=L27+NSCALE
      IK=M27+NSCALE
      GRAD=0.0
C--CHECK THE SERIAL NUMBERS OF THE FIRST TWO SCALES
      IF(JB-JA)1500,1500,1450
C--COMPUTE THE INITIAL GRADIENT
1450  CONTINUE
      GRAD=(STORE(IK)-STORE(IH))/(STORE(M27+3)-STORE(L27+3))
C--AND NOW RETURN AFTER THE INITIALISATION
1500  CONTINUE
      RETURN
C
C--APPLY THE SCALE FACTORS IF NECESSARY
1550  CONTINUE
      JC=NINT(STORE(M6+19))
C--CHECK IF THERE ARE SCALES WE CAN USE
      IF (N27) 2000, 2000, 1600
1600  CONTINUE
      IF(JA-JC)1700,1650,1750
1650  CONTINUE
      IF(JB-JC)1950,1750,1950
1700  CONTINUE
      IF(JB-JC)1750,1750,1950
C--INCREMENT THE SCALE POSITION
1750  CONTINUE
      L27=M27
      M27=L27+MD27
      N27=N27-1
C----- REMEMBER - M27 LOOKS ONE AHEAD
      IF (N27-1) 1800, 1800, 1850
1800  CONTINUE
      I=NINT(STORE(M6+19))
      JA=N6W+N6DEAD+1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1350)I,JA
      ENDIF
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)SCALE
      ENDIF
C--COMPUTE THE NEW CONSTANTS
      GOTO 2000
1850  CONTINUE
      JA=JB
      JB=NINT(STORE(M27+3))
      IH=L27+NSCALE
      IK=M27+NSCALE
      GRAD=0.0
      IF(JB-JA)1600,1600,1900
1900  CONTINUE
      GRAD=(STORE(IK)-STORE(IH))/(STORE(M27+3)-STORE(L27+3))
      GOTO 1600
C--COMPUTE THE SCALE AT THIS POINT
1950  CONTINUE
      SCALE=STORE(IH)+GRAD*(STORE(M6+19)-STORE(L27+3))
C--CALCULATE /FO/ AND THE OTHER TERMS
2000  CONTINUE
      STORE(M6+27)=SQRT(SCALE*WFACT(I))
C--CHECK THE MULTIPLIER
      IF(STORE(M6+27)-ZERO)2050,2050,1500
C--THIS MULTIPLIER IS NOT BIG ENOUGH
2050  CONTINUE
      CALL XL6RRP(N6DEAD,1000,IFO,ICAPT)
      MSCALE=-1
      GOTO 1500
9900  CONTINUE
C -- ERRORS
      MSCALE = -1
      RETURN
      END
C
CODE FOR WFACT
      FUNCTION WFACT(IN)
C--COMPUTE THE OVERALL MULTIPLIER TO CONVERT I'S TO /FO/ **2'S
C
C  IN  DUMMY ARGUMENT
C
C--THE ADDRESSES OF THE COEFFICIENTS ARE GIVEN IN THE STACK
C  AT 'LFACT', AND THERE ARE 'MDFACT' OF THEM
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST6A/L6IMP,M6IMP,MD6IMP,N6IMP,L6MLT,M6MLT,MD6MLT,N6MLT,
     2 L6BMP,M6BMP,MD6BMP,N6BMP,L6IB,M6IB,MD6IB,N6IB,
     3 ITYPE6,IAPPND,DENSTY,IUNIT,MEDIUM,NCARDS,NGROUP,INCREM,
     4 LIDFK,MIDFK,MDIDFK,NIDFK,LODFK,MODFK,MDODFK,NODFK,
     5 LFACT,MFACT,MDFACT,NFACT,NSCALE,N6DEAD,IFO,JFO,
     6 IPRINT,ISQ,IPHI,ITHETA,ITUBE,IPLATE,IGAUSS,IHUBER,
     7 LPHI,MPHI,MDPHI,NPHI,LPHIC,MPHIC,MDPHIC,NPHIC,
     8 LPHID,MPHID,MDPHID,NPHID,IT,IT01,NTI,IT02,ITC,IT01C,NTIC,IT02C,
     9 ITU,MITU,MDITU,NITU,IPL,MPL,MDPL,NPL,WI,RANGE,ICHECK
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--SET THE INITIAL VALUE
      AFACT=1.
C--CHECK IF THERE ARE ANY COEEFICIENTS REQUIRED
      IF(MDFACT)1100,1100,1000
C--LOOP OVER THE REQUIRED COEFFICIENTS
1000  CONTINUE
      MFACT=LFACT
      DO 1050 J=1,MDFACT
      K=ISTORE(MFACT)+M6
      AFACT=AFACT*STORE(K)
      MFACT=MFACT+1
1050  CONTINUE
1100  CONTINUE
      WFACT=AFACT
      RETURN
      END
C
CODE FOR KRD06
      FUNCTION KRD06(A,N,IEOFLG)
C--FREE FORMAT READ ROUTINE USED DURING THE INPUT OF LIST 6
C
C  A       THE ARRAY TO BE FILLED.
C  N       THE NUMBER OF NUMBERS TO BE READ.
C  IEOFLG  THE FLAG TO INDIATE HOW END OF FILE IS TO BE TREATED :
C
C          -1  END OF FILE IS ACCEPTABLE NOW AND CAN BE PROCESSED.
C           0  END OF FILE IS ILLEGAL HERE.
C
C--RETURN VALUES ARE :
C
C  -1  END OF FILE DETECTED BEFORE THE FIRST REFLECTION.
C   0  DATA READ OKAY.
C  +1  ERRORS HAVE OCCURRED, WHICH INCLUDE SPURIOUS CHARACTERS AND END O
C      IN THE MIDDLE OF THE DATA.
C
C--
C
      DIMENSION A(N)
C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCARDS/IMAGE(80),NC,ND,LASTCH,NI,NILAST,NS,MON,ICAT,
     2 IEOF,IHFLAG,NUSRQ,NREC,IPOSRQ,ITYPFL,INSTR,IDIRFL,IPARAM,IPARAD,
     3 NWCHAR , LCMAGE(80), IMNSRQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST6A/L6IMP,M6IMP,MD6IMP,N6IMP,L6MLT,M6MLT,MD6MLT,N6MLT,
     2 L6BMP,M6BMP,MD6BMP,N6BMP,L6IB,M6IB,MD6IB,N6IB,
     3 ITYPE6,IAPPND,DENSTY,IUNIT,MEDIUM,NCARDS,NGROUP,INCREM,
     4 LIDFK,MIDFK,MDIDFK,NIDFK,LODFK,MODFK,MDODFK,NODFK,
     5 LFACT,MFACT,MDFACT,NFACT,NSCALE,N6DEAD,IFO,JFO,
     6 IPRINT,ISQ,IPHI,ITHETA,ITUBE,IPLATE,IGAUSS,IHUBER,
     7 LPHI,MPHI,MDPHI,NPHI,LPHIC,MPHIC,MDPHIC,NPHIC,
     8 LPHID,MPHID,MDPHID,NPHID,IT,IT01,NTI,IT02,ITC,IT01C,NTIC,IT02C,
     9 ITU,MITU,MDITU,NITU,IPL,MPL,MDPL,NPL,WI,RANGE,ICHECK
C
C--MARK THE RETURN VALUE AS OKAY ORIGINALLY
      KRD06=0
C--LOOP OVER EACH NUMBER TO BE READ
      DO 1700 I=1,N
C--SEARCH FOR THE NEXT NON-BLANK CHARACTER
1000  CONTINUE
      NC=KNEQUL(NC,IB)
C--CHECK FOR END OF CARD
      IF(NC)1050,1050,1150
C--END OF THE CARD  -  READ THE NEXT
1050  CONTINUE
      READ(IUNIT,1100,END=1450)IMAGE
1100  FORMAT(80A1)
      NCARDS=NCARDS+INCREM
      NC=1
      GOTO 1000
C--READ THE NEXT NUMBER OFF THIS CARD
1150  CONTINUE
      IF(KINPUT(A(I)))1200,1700,1200
C--SPURIOUS CHARACTER IN THE DATA
1200  CONTINUE
      CALL XERHDR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1250)NCARDS,IMAGE,(IB,J=1,NC),IA
      ENDIF
1250  FORMAT(30H Spurious character on record ,I5,4H  : ,80A1/38X,81A1)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1300)
      ENDIF
1300  FORMAT(/17H Marked by an '*')
C--GENERAL ERROR RETURN FROM THIS ROUTINE
1350  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1400)LN,IUNIT
      ENDIF
1400  FORMAT(/15H Input of list ,I5,10H  on unit ,I5,7H  fails)
      KRD06=1
      GOTO 1750
C--END OF FILE DETECTED  -  CHECK IF THIS IS THE NORMAL INPUT UNIT
1450  CONTINUE
      KRD06=-1
      IF(IUNIT-NCRU)1550,1500,1550
C--NORMAL INPUT UNIT  -  FLAG END OF FILE
1500  CONTINUE
      IEOF=-1
C--CHECK IF END OF FILE IS ALLOWED HERE
1550  CONTINUE
      IF(IEOFLG)1750,1600,1600
C--ILLEGAL END OF FILE
1600  CONTINUE
      CALL XERHDR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1650)NCARDS
      ENDIF
1650  FORMAT(28H End of file detected after ,I5,
     2 41H  record(s) in the middle of a reflection)
      GOTO 1350
1700  CONTINUE
C--AND NOW RETURN
1750  CONTINUE
      RETURN
      END


CRYSTALS CODE FOR REDUCTION
CODE FOR XLP
      SUBROUTINE XLP
C--APPLICATION OF THE LP CORRECTION
C
C--VARIABLES IN USE :
C
C  A  1/(L CORRECTION)**2 AND THEN 1/LP CORRECTION
C  B  ZETA(N) SQUARED/4
C  C  POLARISATION CORRECTION
C  O  BRAGG ANGLE OF MONOCHROMATOR AND FIRST TERM IN P CORRECTION
C  P  INCIDENT ANGLE OF MONOCHROMATOR AND SECOND TERM IN P CORRECTION
C  T  SIN(THETA) SQUARED
C  U  SIN(THETA)**4
C  W  WAVELENGTH
C  Z  ZETA(1) SQUARED/4
C
C--
      DIMENSION ISTORE(131072)
C
      DIMENSION PROCS(3)
      DIMENSION AXIS(3)
      CHARACTER*24 ICAPT(3)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON/XWORK/A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,
     2 U,V,W,X,Y,Z
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      EQUIVALENCE (PROCS(1),IULN),(PROCS(2),MEDIUM),(PROCS(3),ISQ)
C
C
      DATA ICAPT / 'Sin(theta) > 1.0' , 'Impossible LP term' ,
     2 'Sin(theta) < (or =) 0.0' /
C
C--SET THE TIMING
      CALL XTIME1(2)
C--READ THE CONTROL DATA
      IF ( KRDDPV ( PROCS , 3 )  .LT. 0 ) GO TO 9910
C--FIND THE TYPE OF LIST 6
      IULN=KTYP06(IULN)
C--CLEAR THE STORE
      CALL XRSL
      CALL XCSAE
C--LOAD LIST 1
      CALL XFAL01
C--LOAD LIST 13
      CALL XFAL13
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE /FO/ SLOT
      IFO=3
      IF(ISTORE(L13CD+1))1150,1100,1100
C--THIS STRUCTURE IS TWINNED
1100  CONTINUE
      IFO=10
C--FIND THE DIFFRACTION TYPE
1150  CONTINUE
      IT=ISTORE(L13DT)
C--FIND THE WAVELENGTH AND MONOCHROMATOR DETAILS
      W=STORE(L13DC)
      O=STORE(L13DC+1)
      P=STORE(L13DC+2)
C--SET UP LIST 6 FOR PROCESSING
      CALL XFLT06(IULN,0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CHECK THE TYPE OF OUTPUT MEDIUM
      IF(MEDIUM)1300,1250,1300
C--SAME AS BEFORE  -  SET THE 'MEDIUM' FLAG
1250  CONTINUE
      MEDIUM=ISIGN(1,L6D)
C--SET UP THE OUTPUT PROCESSING
1300  CONTINUE
      CALL XSTR06(IULN,-1,0,1,0)
C--SET THE NUMBER OF REJECTED REFLECTIONS
      N=0
C--SET THE REFLECTION DETAILS INFORMATION
      DO 1350 I=1,MD6
      CALL XIRTAC(I)
1350  CONTINUE
C
C--COMPUTE THE SIN(THETA)/LAMBDA SQUARED TERMS
      X=W*W
      J=L1S+5
      DO 1400 I=L1S,J
      STORE(I)=STORE(I)*X
1400  CONTINUE
C--CHECK IF THIS IS WEISSENBERG GEOMETRY
      IF(IT-4)1450,1500,1500
C--SET THE AXIS DATA
1450  CONTINUE
      CALL XMOVE(STORE(L13AX),AXIS(1),3)
C--COMPUTE THE HEIGHT OF THE FIRST LAYER
      Z=(STORE(L1S)*STORE(L1S+1)*STORE(L1S+2)-(STORE(L1S)*STORE(L1S+3)
     2 *STORE(L1S+3)+STORE(L1S+1)*STORE(L1S+4)*STORE(L1S+4)
     3 +STORE(L1S+2)*STORE(L1S+5)*STORE(L1S+5)-STORE(L1S+3)
     4 *STORE(L1S+4)*STORE(L1S+5))*0.25)
      A=AXIS(1)*AXIS(1)*(STORE(L1S+1)*STORE(L1S+2)-STORE(L1S+3)
     2 *STORE(L1S+3)*0.25)+AXIS(2)*AXIS(2)*(STORE(L1S)*STORE(L1S+2)
     3 -STORE(L1S+4)*STORE(L1S+4)*0.25)
      B=AXIS(3)*AXIS(3)*(STORE(L1S)*STORE(L1S+1)-STORE(L1S+5)
     2 *STORE(L1S+5)*0.25)+AXIS(2)*AXIS(3)*(STORE(L1S+4)*STORE(L1S+5)
     3 *0.5-STORE(L1S)*STORE(L1S+3))
      C=AXIS(1)*AXIS(3)*(STORE(L1S+3)*STORE(L1S+5)*0.5-STORE(L1S+1)
     2 *STORE(L1S+4))+AXIS(1)*AXIS(2)*(STORE(L1S+3)*STORE(L1S+4)
     3 *0.5-STORE(L1S+2)*STORE(L1S+5))
      Z=Z/(A+B+C)
C--SET UP THE POLARISATION CONSTANTS
1500  CONTINUE
      O=O*PI/180.
      P=P*PI/180.
      A=COS(2.*O)
      A=A*A
      B=COS(P)
      B=B*B
      C=SIN(P)
      C=C*C
      D=1./(1.+A)
      O=D*(A*B+C)
      P=D*(A*C+B)
C
C--FETCH THE NEXT REFLECTION
1550  CONTINUE
      IF(KLDRNR(I))2500,1600,1600
C--CHECK IF THIS IS WEISSENBERG DATA
1600  CONTINUE
      IF(IT-4)1650,1700,1700
C--COMPUTE THE LAYER HEIGHT FOR THIS REFLECTION
1650  CONTINUE
      B=AXIS(1)*STORE(M6)+AXIS(2)*STORE(M6+1)+AXIS(3)*STORE(M6+2)
      B=B*B*Z
C--COMPUTE SIN(THETA)**2
1700  CONTINUE
      T=STORE(L1S)*STORE(M6)*STORE(M6)+STORE(L1S+1)*STORE(M6+1)
     2 *STORE(M6+1)+STORE(L1S+2)*STORE(M6+2)*STORE(M6+2)+STORE(L1S+3)
     3 *STORE(M6+1)*STORE(M6+2)+STORE(L1S+4)*STORE(M6)*STORE(M6+2)
     4 +STORE(L1S+5)*STORE(M6)*STORE(M6+1)
C--CHECK THE VALUE OF SIN(THETA)**2
      JFO=IFO+M6
      L=3
      IF(T)1800,1800,1750
1750  CONTINUE
      L=1
      IF(T-1.)1850,1850,1800
C--PRINT OUT THE ERROR MESSAGE
1800  CONTINUE
      CALL XL6RRP ( N , 100 , IFO , ICAPT(L) )
      GOTO  1550
C
C--BRANCH ON THE TYPE OF CORRECTION
1850  CONTINUE
      U=T*T
      GO TO (2300, 2350, 2400, 9915, 2450,
     1 2450 , 2450 , 2450 , 2450 , 9920 ) , IT
      CALL XERHND ( IERPRG )
C
C--COMPUTE THE POLARISATION CORRECTION AND STORE THE REFLECTION
2050  CONTINUE
      C=1.-2.*T
      C=O*C*C+P
      A=A/(C*C)
      L=2
C--CHECK THE LP TERM
      IF(A)1800,1800,2100
C--CHECK IF WE HAVE F'S STORED
2100  CONTINUE
      IF(ISQ)2200,2150,2150
C--F'S ARE STORED  -  TAKE AN INITIAL SQUARE ROOT
2150  CONTINUE
      A=SQRT(A)
C--COMPUTE THE TERMS AND STORE THEM
2200  CONTINUE
      A=SQRT(A)
      STORE(JFO)=STORE(JFO)*A
      STORE(M6+12)=STORE(M6+12)*A
      STORE(M6+27)=STORE(M6+27)/A
C--STORE THE REFLECTION
      CALL XSLR(1)
C--SET THE REFLECTION DETAILS DATA
      DO 2250 I=1,MD6
      CALL XACRT(I)
2250  CONTINUE
      GOTO 1550
C
C--NORMAL BEAM WEISSENBERG GEOMETRY
2300  CONTINUE
      A=T-U-B
      GOTO 2050
C
C--EQUI-INCLINATION WEISSENBERG GEOMETRY
2350  CONTINUE
      A=T-U-B*(1.-T)
      GOTO 2050
C
C--ANTI-EQUI-INCLINATION GEOMETRY
2400  CONTINUE
      A=T-U-B*T
      GOTO 2050
C
C--4-CIRCLE GEOMETRY
2450  CONTINUE
      A=4.*T*(1.-T)
      GOTO 2050
C
C--END OF THE TAPE  -  TERMINATE THE WRITE
2500  CONTINUE
      DO 2550 I=1,MD6
      CALL XCRD(I)
2550  CONTINUE
      N6D=N6W
      CALL XERT(IULN)
C--SWAP THE OUTPUT
      CALL XSWP06(IULN,MEDIUM)
C -- TERMINATION MESSAGES
      CALL XLINES
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2600 ) N6W , N
      ENDIF
      WRITE ( NCAWU , 2600 ) N6W , N
2600  FORMAT ( 1X , I6 , ' reflection(s) accepted' , 10X , I6 ,
     2 ' reflection(s) rejected' )
C
2610  CONTINUE
      CALL XOPMSG ( IOPLPC , IOPEND , 200 )
      CALL XTIME2(2)
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPLPC , IOPABN , 0 )
      GO TO 2610
9910  CONTINUE
C -- INPUT ERROR
      CALL XOPMSG ( IOPLPC , IOPCMI , 0 )
      GO TO 9900
9915  CONTINUE
      WRITE(NCAWU,9916)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,9916)
      ENDIF
9916  FORMAT(1X, ' Precession geometry not supperted')
9920  CONTINUE
C -- ILLEGAL DIFFRACTION GEOMETRY
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 ) IT
      ENDIF
      WRITE ( NCAWU , 9925 ) IT
9925  FORMAT ( 1X , 'Illegal diffraction geometry flag ' , I5 )
      CALL XERHND ( IERERR )
      GO TO 9900
      END
C
CODE FOR XSYST
      SUBROUTINE XSYST
C--CHECK LIST 6 FOR SYSTEMATIC ABSENCES AND COMPUTE A UNIQUE SET OF
C
C--VARIABLES USED BY THIS ROUTINE ARE :
C
C  INDICES FOR EACH REFLECTION, IF REQUIRED.
C
C  IULN    THE LIST TYPE BEING PROCESSED.
C  MEDIUM  THE OUTPUT MEDIUM FLAG :
C
C          -1  M/T
C           0  AS INPUT.
C          +1  DISC.
C
C  INDEX   FLAG TO CONTROL THE GENERATION OF UNIQUE INDICES :
C
C          -1  DO NOT GENERATE ANY NEW INDICES.
C           0  GENERATE NEW INDICES.
C
C--
      DIMENSION ISTORE(131072)
C
      DIMENSION PROCS(3)
      CHARACTER*24 ICAPT
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      EQUIVALENCE (PROCS(1),IULN),(PROCS(2),MEDIUM),(PROCS(3),INDEX)
C
C
      DATA ICAPT / 'Systematic absence' /
C
C--SET THE TIMING
      CALL XTIME1(2)
C--READ THE CONTROL DATA
      IF ( KRDDPV ( PROCS , 3 )  .LT. 0 ) GO TO 9910
C--FIND THE TYPE OF LIST 6
      IULN=KTYP06(IULN)
C--CLEAR THE STORE
      CALL XRSL
      CALL XCSAE
C--SET UP LIST 2 FOR SYSTEMATIC ABSENCE CHECKING
      CALL XFAL02
      IF ( IERFLG .LT. 0 ) GO TO 9900
      M2I=L2I+(N2I-1)*MD2I
C--LOAD LIST 13 FOR THE FRIEDEL FLAGS
      CALL XFAL13
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE /FO/ SLOT
      IFO=3
      IF(ISTORE(L13CD+1))1150,1100,1100
C--THIS STRUCTURE IS TWINNED
1100  CONTINUE
      IFO=10
C--SET THE INITIAL INDEX FLAG
1150  CONTINUE
      IN=-1
C--CHECK IF WE SHOULD GENERATE A NEW SET OF INDICES HERE
      IF(INDEX)1250,1200,1200
C--WE SHOULD GENERATE A NEW SET OF INDICES
1200  CONTINUE
      IN=ISTORE(L13CD)+2
C--SET UP LIST 6 FOR PROCESSING
1250  CONTINUE
      CALL XFLT06(IULN,0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CHECK THE TYPE OF OUTPUT MEDIUM
      IF(MEDIUM)1350,1300,1350
C--SAME AS BEFORE  -  SET THE 'MEDIUM' FLAG
1300  CONTINUE
      MEDIUM=ISIGN(1,L6D)
C--SET UP THE OUTPUT PROCESSING
1350  CONTINUE
      CALL XSTR06(IULN,-1,0,1,0)
      N=0
C--INITIALISE THE INDEX COLLECTION
      DO 1400 I=1,MD6
      CALL XIRTAC(I)
1400  CONTINUE
C
C--MAIN REFLECTION READING LOOP
1450  CONTINUE
      IF(KLDRNR(I))1700,1500,1500
C--CHECK IF THIS REFLECTION IS SYSTEMATICALLY ABSENT
1500  CONTINUE
      IF(KSYSAB(IN))1550,1600,1600
C--REFLECTION IS NOT ALLOWED  -  CHECK IF IT IS THE FIRST
1550  CONTINUE
      CALL XL6RRP(N,1000,IFO,ICAPT)
      GOTO 1450
C--STORE THE REFLECTION
1600  CONTINUE
      CALL XSLR(1)
C--ACCUMULATE THE DETAILS
      DO 1650 I=1,MD6
      CALL XACRT(I)
1650  CONTINUE
      GOTO 1450
C
C--LAST REFLECTION READ
1700  CONTINUE
      DO 1750 I=1,MD6
      CALL XCRD(I)
1750  CONTINUE
      N6D=N6W
      CALL XERT(IULN)
      CALL XSWP06(IULN,MEDIUM)
C
      CALL XLINES
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1800 ) N6W , N
      ENDIF
      WRITE ( NCAWU , 1800 ) N6W , N
1800  FORMAT ( 1X , I6 , ' reflection(s) accepted' , 10X , I6 ,
     2 ' reflection(s) rejected' )
C
1810  CONTINUE
      CALL XOPMSG ( IOPSSM , IOPEND , 200 )
      CALL XTIME2(2)
      CALL XRSL
      CALL XCSAE
      RETURN
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPSSM , IOPABN , 0 )
      GO TO 1810
9910  CONTINUE
C -- INPUT ERROR
      CALL XOPMSG ( IOPSSM , IOPCMI , 0 )
      GO TO 9900
C
      END
C
CODE FOR KSYSAB
      FUNCTION KSYSAB(IN)
C--DETECT SYSTEMATIC ABSENCES AND COLLECT CORRECT EQUIVALENTS
C
C  IN  IF 'IN' IS LESS THAN 1, A NEW SET OF INDICES IS NOT COMPUTED.
C      IF 'IN' IS 1, A NEW SET OF INDICES IS COMPUTED, BUT FRIEDEL'S
C      LAW IS NOT USED.
C      IF 'IN' IS 2, A NEW SET OF INDICES IS COMPUTED USING FRIEDEL'S LA
C
C
C--THE NEW SET OF INDICES HAS THE MAXIMUM VALUE OF 'L' FROM AMONGST THE
C  SYMMETRY EQUIVALENT SET. FROM THE REFLECTIONS WITH THIS VALUE OF 'L',
C  THOSE WITH THE MAXIMUM VALUE OF 'K' ARE CHOSEN. FROM AMONGST THESE
C  REFLECTIONS, THE ONE WITH THE LARGEST VALUE FOR 'H' IS CHOSEN.
C
C--THE NEW UNIQUE INDICES ARE PUT BACK AT 'M6', WHERE THE OLD INDICES
C  ARE FOUND ON INPUT.
C
C--
      DIMENSION ISTORE(131072)
C
      DIMENSION H(3),HG(3),HMAX(3)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF THERE ARE ANY NON-PRIMITIVE TRANSLATIONS TO LOOK FOR
      IF(N2P-1)1150,1150,1000
C--CHECK NON-PRIMITIVE CONDITIONS
1000  CONTINUE
      M2P=L2P
      DO 1100 I=1,N2P
      A=ABS(STORE(M2P)*STORE(M6)+STORE(M2P+1)*STORE(M6+1)+STORE(M2P+2)
     2 *STORE(M6+2))
      K=INT(A+0.01)
      IF(A-FLOAT(K)-0.01)1050,2100,2100
1050  CONTINUE
      M2P=M2P+3
1100  CONTINUE
1150  CONTINUE
C--SET DEFAULT VALUES FOR THE INDICES AND TRANSFORMED INDICES
      K=M6
      DO 1200 I=1,3
      H(I)=STORE(K)
      HMAX(I)=H(I)
      K=K+1
1200  CONTINUE
C--PASS THROUGH THE DIFFERENT SYMMETRY POSITIONS
      DO 1950 I=L2I,M2I,MD2I
C--CALCULATE THE TRANFORMED INDICES
      HG(1)=H(1)*STORE(I)+H(2)*STORE(I+3)+H(3)*STORE(I+6)
      HG(2)=H(1)*STORE(I+1)+H(2)*STORE(I+4)+H(3)*STORE(I+7)
      HG(3)=H(1)*STORE(I+2)+H(2)*STORE(I+5)+H(3)*STORE(I+8)
C--CHECK IF THE INDICES ARE THE SAME
      J=IC
      DO 1250 K=1,3
      IF(NINT(H(K)-HG(K)))1350,1250,1350
1250  CONTINUE
C--THE INDICES ARE THE SAME  -  CHECK THE PHASE SHIFT
1300  CONTINUE
      A=ABS(H(1)*STORE(I+9)+H(2)*STORE(I+10)+H(3)*STORE(I+11))
      K=INT(A+0.01)
      IF(A-FLOAT(K)-0.01)1350,2100,2100
C--THIS REFLECTION IS ALLOWED  -  CHECK FOR ANOTHER TEST
1350  CONTINUE
      IF(J)1500,1500,1400
C--CENTRE OF SYMMETRY  -  CHECK THE INVERTED INDICES
1400  CONTINUE
      J=J-1
      DO 1450 K=1,3
      IF(NINT(H(K)+HG(K)))1500,1450,1500
1450  CONTINUE
      GOTO 1300
C--CHECK IF WE SHOULD GENERATE A NEW SET OF INDICES
1500  CONTINUE
      IF(IN)1950,1950,1550
C--CHECK IF THESE ARE GOOD TRANSFORMS FOR OUTPUT
1550  CONTINUE
      DO 1900 J=1,IN
      IF(NINT(HG(3)-HMAX(3)))1800,1600,1700
1600  CONTINUE
      IF(NINT(HG(2)-HMAX(2)))1800,1650,1700
1650  CONTINUE
      IF(NINT(HG(1)-HMAX(1)))1800,1800,1700
1700  CONTINUE
C--THIS SET IS A BETTER SET  -  STORE THEM
      DO 1750 K=1,3
      HMAX(K)=HG(K)
1750  CONTINUE
C--INVERT THE INDICES FOR THE NEXT POSSIBLE PASS
1800  CONTINUE
      DO 1850 K=1,3
      HG(K)=-HG(K)
1850  CONTINUE
1900  CONTINUE
1950  CONTINUE
C--WRITE THE NEW INDICES BACK IN LIST 6
      K=M6
      DO 2000 I=1,3
      STORE(K)=HMAX(I)
      K=K+1
2000  CONTINUE
      KSYSAB=0
2050  CONTINUE
      RETURN
C
C--THIS IS A REJECTED REFLECTION
2100  CONTINUE
      KSYSAB=-1
      GOTO 2050
      END
C
CODE FOR WMERGE
      SUBROUTINE WMERGE
C--MAIN MERGING ROUTINES  -  READS FROM 6 AND OUTPUTS TO M/T
C  INITIALLY.
C
C  NBUF   NUMBER OF WORDS PER REFLECTION IN THE INPUT BUFFER (=MD6)
C  NTERM  NUMBER OF WORDS PER REFLECTION IN THE CORE AREA (=MD6+4)
C
C--THE FORMAT OF THE CORE AREA ENTRIES IS :
C
C  0 TO (MD6-1) CONTAIN THE INPUT VALUES FROM M/T OR TAPE. THE WORDS
C               FROM 'MD6' ONWARDS ARE ARRANGED AS FOLLOWS :
C
C  NTERM-4 JCODE AS AN INTEGER
C  NTERM-3 SERIAL NUMBER AS AN INTEGER
C  NTERM-2 'E' PARAMETER
C  NTERM-1 WEIGHT FOR THIS REFLECTION
C
C
C  DATE            VERSION     BY    CHANGE
C  ----            -------     --    ------
C  DECEMEBER 1984  4.01        PWB   CHANGE STATISTICS PRINTING, TO
C                                    INCLUDE MONITOR OUTPUT
C  MAY       1987  4.03        DJW   OUT PUT SHELDRICK MERGING R
C  MAY       1988  4.54        DJW   CHECK FINAL SUMS
C
C--
      DIMENSION ISTORE(131072)
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 30
      PARAMETER (IDIM30 = 32)
      DIMENSION ICOM30(IDIM30)
C
      DIMENSION PROCS(17)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON /XMRG/WORK(30),ISTAT(100)
      COMMON /XMRGA/IULN,MEDIUM,NSCH,NCYC,ICT,JCT,NCT,ITEMP1,ICODE,
     2 JCODE,MDCODE,NCODE,CHOP,NCHOP,IPRINT,APRINT,ISQ,IBUF,JBUF,NBUF,
     3 ITEMP2,IREF,JREF,NTERM,NREF,NEND,IFO,JFO,ITWIN,N6DEAD,N6CTMP,
     4 N6RTMP,JPRINT,NPRINT
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON/XLST30/
     1 L30DR,M30DR,MD30DR,N30DR, L30CD,M30CD,MD30CD,N30CD,
     2 L30RF,M30RF,MD30RF,N30RF, L30IX,M30IX,MD30IX,N30IX,
     3 L30AB,M30AB,MD30AB,N30AB, L30GE,M30GE,MD30GE,N30GE,
     4 L30CL,M30CL,MD30CL,N30CL, L30SH,M30SH,MD30SH,N30SH
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (L30DR,ICOM30(1))
C
      EQUIVALENCE (PROCS(1),IULN)
C
C
      SAVE
C
      DATA IVERSN / 405 /
C
C
C
C
C--SET THE TIMING
      CALL XTIME1(2)
C--READ THE CONTROL DATA
      IF ( KRDDPV ( PROCS,17 )   .LT.   0 ) GO TO 9910
C--FIND THE TYPE OF LIST 6
      IULN=KTYP06(IULN)
C--SET THE END OF THE JCODE ARRAY
      JCODE=ICODE+(NCODE-1)*MDCODE
C--SET UP LIST 6 FOR THE I/O OPERATIONS
      CALL XFLT06(IULN,0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CHECK THE TYPE OF OUTPUT MEDIUM
      IF(MEDIUM)1150,1100,1150
C--SAME AS BEFORE  -  SET THE 'MEDIUM' FLAG
1100  CONTINUE
      MEDIUM=ISIGN(1,L6D)
C--SET UP THE OUTPUT PROCESSING
1150  CONTINUE
      CALL XSTR06(IULN,-1,0,1,0)
C--PRESERVE THE NUMBER OF INPUT CONTRIBUTORS
      N6RTMP=N6R
C--ZERO THE NUMBER OF REJECTED CONTRIBUTORS
      N6CTMP=0
C--SET THE NUMBER OF REJECTED REFLECTIONS
      N6DEAD=0
C--SET THE REFLECTION DETAILS INFORMATION
      DO 1200 I=1,MD6
      CALL XIRTAC(I)
1200  CONTINUE
C--SET THE NUMBER OF PRINTED REFLECTIONS TO ZERO
      NPRINT=0
C--SET UP THE DEFAULT CONSTANTS
      NBUF=MD6
      IBUF=NFL
C--ALLOCATE SPACE FOR THE INPUT BUFFER
      LN=6
      IREC=4001
      JBUF=KCHNFL(NBUF)
C--SET UP THE LENGTH OF EACH EQUIVALENT WHILE IT IS IN CORE
      NTERM=MD6+4
C--LOAD LIST 13
      CALL XFAL13
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE /FO/ SLOT
      IFO=3
      ITWIN=-1
      IF(ISTORE(L13CD+1))1300,1250,1250
C--THIS STRUCTURE IS TWINNED
1250  CONTINUE
      IFO=10
      ITWIN=11
      IREC=4002
      ITWINL=KCHLFL(NTERM)
C--CLEAR THE INTENSITY STATISTICS AREA
1300  CONTINUE
      DO 1350 I=1,100
      ISTAT(I)=0
1350  CONTINUE
      DO 1400 I=21,28
      WORK(I)=0.
1400  CONTINUE
C--SET UP THE CORRECT WEIGHTING PARAMETERS INTERNALLY
      CALL WWT
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET UP THE INPUT BUFFER KEYS
      KA=IBUF+NBUF-1
      KB=IBUF+2
C--SET UP THE CORE BUFFER FLAGS
      IREF=NFL
      JREF=IREF
      NREF=0
      NEND=0
      IF(IPRINT)1550,1450,1450
C--PRINT THE CAPTIONS
1450  CONTINUE
      CALL XPRTCN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1500)
      ENDIF
1500  FORMAT(4X,1HH,3X,1HK,3X,1HL,2X,9HF-squared,4X,6HSigma1,4X,
     2 6HSigma2,8X,9HF-squared,5X,5HSigma,5X,5HDelta,3X,7HE-param,4X,
     3 6HWeight,3X,5HJCODE,4X,6HSerial/)
C
C--CHECK IF THERE ARE ANY REFLECTIONS
1550  CONTINUE
      IF(KLDRNR(I))3800,1700,1700
C--FETCH THE NEXT REFLECTION
1600  CONTINUE
      IF(KLDRNR(I))1650,1700,1700
C--END LIST 6 INPUT
1650  CONTINUE
      NEND=1
      GOTO 2250
C--CHECK THAT TOO MANY REFLECTIONS HAVE NOT BEEN READ
1700  CONTINUE
      IF(JREF+NTERM-LFL)1850,1850,1750
1750  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1800)
      ENDIF
1800  FORMAT(//40H Too many equivalents for the given core)
      GOTO 4300
C--TRANSFER THE REFLECTION TO THE FIRST INPUT BUFFER
1850  CONTINUE
      CALL XMOVE(STORE(M6),STORE(IBUF),NBUF)
C--FIX THE INDICES
      DO 1900 I=IBUF,KB
      ISTORE(I)=NINT(STORE(I))
1900  CONTINUE
C--FIRST REFLECTION THIS INDEX ?
      IF(NREF)1950,1950,2100
C--MOVE THE REFLECTION FROM THE INPUT TO THE CORE BUFFER
1950  CONTINUE
      KREF=JREF
      CALL XMOVE(STORE(IBUF),STORE(JREF),NBUF)
      JREF=JREF+NTERM
      NREF=NREF+1
C--CHECK IF WE HAVE /FO/ OR /FO/ **2 STORED
      IF(ISQ)2050,2000,2000
C--/FO/ STORED  -  CONVERT TO /FO/ **2
2000  CONTINUE
      JFO=KREF+IFO
      STORE(KREF+12)=2.*STORE(JFO)*STORE(KREF+12)
      STORE(JFO)=STORE(JFO)*STORE(JFO)
C--FIX THE SERIAL AND JCODE
2050  CONTINUE
      ISTORE(JREF-4)=NINT(STORE(IBUF+18))
      ISTORE(JREF-3)=NINT(STORE(IBUF+19))
C--SET THE 'E' PARAMETER
      STORE(JREF-2)=0.
C--DEFAULT THE WEIGHT TO UNITY
      STORE(JREF-1)=1.
      GOTO 1600
C--NOT THE FIRST REFLECTION  -  CHECK IF IT HAS THE SAME INDICES
2100  CONTINUE
      IF(ISTORE(IBUF)-ISTORE(IREF))2250,2150,2250
2150  CONTINUE
      IF(ISTORE(IBUF+1)-ISTORE(IREF+1))2250,2200,2250
2200  CONTINUE
      IF(ISTORE(IBUF+2)-ISTORE(IREF+2))2250,1950,2250
C
C--ALL THE REFLECTIONS WITH COMMON INDICES ARE IN CORE  -  CHECK THE JCO
2250  CONTINUE
      IF(NCODE)2700,2700,2300
C--ELIMINATE ANY REFLECTIONS WITH ZERO WEIGHT ASSIGNED TO THEIR JCODES
2300  CONTINUE
      I=IREF
      J=IREF
      K=NREF
      N6CTMP=N6CTMP+NREF
      NREF=0
C--CHECK THE NEXT CONTRIBUTING REFLECTION
2350  CONTINUE
      DO 2450 N=ICODE,JCODE,MDCODE
      L=I+NTERM
      IF(ISTORE(L-4)-ISTORE(N))2450,2400,2450
C--CHECK IF THIS JCODE HAS ZERO WEIGHT
2400  CONTINUE
      IF(STORE(N+1)-0.0001)2600,2450,2450
2450  CONTINUE
C--THIS REFLECTION IS ALLOWED  -  MOVE IT UP
      IF(I-J)2500,2550,2500
C--MOVEMENT IS NECESSARY
2500  CONTINUE
      CALL XMOVE(STORE(I),STORE(J),NTERM)
C--UPDATE THE POINTERS
2550  CONTINUE
      I=I+NTERM
      J=J+NTERM
      NREF=NREF+1
      N6CTMP=N6CTMP-1
      GOTO 2650
C--INCREMENT THE ADDRESS FOR A REJECTED REFLECTION
2600  CONTINUE
      I=I+NTERM
C--CHECK IF THERE ARE MORE REFLECTIONS TO PROCESS
2650  CONTINUE
      K=K-1
      IF(K)2700,2700,2350
C--CHECK IF THERE ARE ANY REFLECTIONS LEFT TO CONTRIBUTE
2700  CONTINUE
      IF(NREF)3700,3700,2750
C
C--ONE OR MORE THAN ONE CONTRIBUTOR
2750  CONTINUE
      KD=0
      EE=-1.
C--CHECK IF THIS IS TWINNED DATA
      IF(ITWIN)3350,2800,2800
C--REARRANGE THE DATA IN THE STACK
2800  CONTINUE
      KD=NREF
      K=IREF+ITWIN
      EE=STORE(K)
      GOTO 2950
C--MARK THE LAST LOT OF REFLECTIONS AS USED
2850  CONTINUE
      J=IREF+ITWIN
      DO 2900 I=1,NREF
      STORE(J)=-1.
      J=J+NTERM
2900  CONTINUE
      K=IREF+ITWIN
C--SEARCH FOR ANY OTHER UNUSED REFLECTIONS
2950  CONTINUE
      L=K
      NREF=0
      FE=EE
      EE=-1.
      DO 3300 I=1,KD
      IF(ABS(FE-STORE(K))-.5)3000,3150,3150
C--WE HAVE ANOTHER TO MATCH THE ORIGINAL
3000  CONTINUE
      NREF=NREF+1
C--CHECK IF THE REFLECTION NEEDS MOVING TO THE TOP
      IF(L-K)3100,3050,3100
3050  CONTINUE
      L=L+NTERM
      GOTO 3250
C--MOVE THE REFLECTION
3100  CONTINUE
      K=K-ITWIN
      L=L-ITWIN
      CALL XMOVE(STORE(L),STORE(ITWINL),NTERM)
      CALL XMOVE(STORE(K),STORE(L),NTERM)
      CALL XMOVE(STORE(ITWINL),STORE(K),NTERM)
      K=K+ITWIN+NTERM
      L=L+ITWIN+NTERM
      GOTO 3300
C--CHECK IF THIS REFLECTION HAS ALREADY BEEN MERGED
3150  CONTINUE
      IF(STORE(K))3250,3250,3200
C--RECORD ITS VALUE
3200  CONTINUE
      EE=STORE(K)
3250  CONTINUE
      K=K+NTERM
3300  CONTINUE
C
C--CALL THE MERGE ROUTINES
3350  CONTINUE
      IF(KMERGE(I))3700,3400,3400
C--OUTPUT THE REFLECTION
3400  CONTINUE
      CALL XMOVE(STORE(IREF),STORE(M6),NBUF)
      ITEMP1=M6+2
      DO 3410 I=M6,ITEMP1
      STORE(I)=FLOAT(ISTORE(I))
3410  CONTINUE
C--ASSIGN THE NEW VALUES OF /FO/ **2 AND SIGMA
      JFO=M6+IFO
      STORE(JFO)=WORK(5)
      STORE(M6+12)=WORK(NCHOP+8)
C--CHECK IF THIS IS ONLY ONE CONTRIBUTOR
      IF(NREF-1)3500,3500,3450
C--MORE THAN ONE CONTRIBUTOR  -  ZERO THE WEIGHT AND BATCH
3450  CONTINUE
      STORE(M6+4)=0.
      STORE(M6+13)=0.
C----- STORE THE MINIMUM JCODE
      STORE(M6+18) = WORK(29)
C--ZERO THE REMAINING CONSTANTS
      CALL XZEROF(STORE(M6+17),N6DTL-17)
C--CHECK IF WE MUST TAKE THE SQUARE ROOT
3500  CONTINUE
      IF(ISQ)3600,3550,3550
3550  CONTINUE
      STORE(JFO)=SQRT(STORE(JFO))
      IF (STORE(JFO) .LE. ZERO) THEN
            STORE(M6+12) = ZERO
      ELSE
      STORE(M6+12)=STORE(M6+12)/(2.*STORE(JFO))
      ENDIF
C--STORE THE REFLECTION
3600  CONTINUE
C----- COMPUTE NEW 'RATIO'
      STORE(M6+20) = STORE(JFO) / (2.* STORE(M6+12) )
      CALL XSLR(1)
C--ACCUMULATE THE REFLECTION DETAILS INFORMATION
      DO 3650 I=1,MD6
      CALL XACRT(I)
3650  CONTINUE
C--CHECK FOR ANOTHER TWIN ELEMENT
3700  CONTINUE
      IF(EE)3750,3750,2850
C--RESET THE POINTERS AND CHECK FOR THE END OF THE DATA
3750  CONTINUE
      NREF=0
      JREF=IREF
      IF(NEND)1950,1950,3800
C
C--END OF THE TAPE  -  TERMINATE THE WRITE
3800  CONTINUE
      DO 3850 I=1,MD6
      CALL XCRD(I)
3850  CONTINUE
      N6D=N6W
      CALL XERT(IULN)
C--AND NOW GENERATE THE OUTPUT FILE IF NECESSARY
      CALL XSWP06(IULN,MEDIUM)
C--PRINT THE REFLECTION TOTALS
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3900)N6RTMP,N6CTMP,N6W,N6DEAD,NPRINT,APRINT
      ENDIF
3900  FORMAT(//1H ,I5,22H  Contributor(s) input//1H ,I5,
     2 25H  Contributor(s) rejected///1H ,I5,
     3 29H  Merged reflection(s) output//1H ,I5,
     4 31H  Merged reflection(s) rejected//1H ,I5,
     5 31H  Contributor(s) deviating from,
     6 35H the weighted average by more than ,F5.1,
     7 23H  standard deviation(s) )
C--CHECK IF THERE IS ANY STATISTICAL DATA TO PRINT
      CALL XLINES
      WRITE ( NCAWU , 3905 ) N6W , N6DEAD
3905  FORMAT ( 1X , I6 , ' merged reflection(s) output' , 10X , I6 ,
     2 ' merged reflection(s) rejected' )
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4000)
      ENDIF
4000  FORMAT(///28X,3HAll,4X,12HAll weighted,2X,13HObserved only,2X,
     2 17HWeighted observed/)
      IF ((WORK(22)*WORK(26)) .LE. ZERO) THEN
      WORK(25)= 0.
      WORK(21)= 0.
      ELSE
      WORK(25)=100.*WORK(25)/WORK(26)
      WORK(21)=100.*WORK(21)/WORK(22)
      ENDIF
      IF ((WORK(23)*WORK(27)) .LE. ZERO) THEN
      WORK(28)=0.
      WORK(24)=0.
      ELSE
      WORK(28)=100.*WORK(28)/WORK(27)
      WORK(24)=100.*WORK(24)/WORK(23)
      END IF
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4050)WORK(25),WORK(28),WORK(21),WORK(24)
      ENDIF
4050  FORMAT(18H Merging R-factors,1X,F13.2,F14.2,F13.2,F19.2//)
C----- SHELDRICK MERGING R
      WORK(28) = 10. * SQRT(WORK(28))
      WORK(24) = 10. * SQRT(WORK(24))
      WRITE(NCAWU,4051) WORK(28), WORK(24)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4051) WORK(28), WORK(24)
      ENDIF
4051  FORMAT(/,28H Sheldrick merging R factors, F11.2, 14X, F13.2)
C--PRINT THE REFLECTION STATISTICS PROFILE
C----- LOAD DATA IF LIST 30 NOT ALREADY IN CORE
      IF (KHUNTR (30,0, IADDL,IADDR,IADDD, -1) .LT. 0) CALL XFAL30
      IF (KHUNTR (13,0, IADDL,IADDR,IADDD, -1) .LT. 0) CALL XFAL13
      IF (IERFLG .LT. 0) GOTO 6520
C----- MIN AND MAX INDICES, FROM L6 DETAILS
      LIX = L6DTL
      STORE(L30IX) = STORE(LIX)
      STORE(L30IX+1) = STORE(LIX+1)
      LIX = LIX + MD6DTL
      STORE(L30IX+2) = STORE(LIX)
      STORE(L30IX+3) = STORE(LIX+1)
      LIX = LIX + MD6DTL
      STORE(L30IX+4) = STORE(LIX)
      STORE(L30IX+5) = STORE(LIX+1)
      IF (ISTORE(L13CD) .EQ. -1) THEN
C------- FRIEDEL USED
            STORE(L30DR+4) = FLOAT(N6W)
            STORE(L30DR+5) = WORK(28)
      ELSE
            STORE(L30DR+2) = FLOAT(N6W)
            STORE(L30DR+3) = WORK(28)
      ENDIF
      CALL XWLSTD ( 30, ICOM30, IDIM30, -1, -1)
 6520  CONTINUE
      IF(N6D)4200,4200,4150
4150  CONTINUE
      CALL WSTAT
C--AND NOW THE TERMINATION MESSAGES
4200  CONTINUE
      CALL XOPMSG ( IOPMER , IOPEND , IVERSN )
      CALL XTIME2(2)
      RETURN
C
C--TERMINATE BECAUSE OF ERRORS
4300  CONTINUE
      CALL XERHND ( IERERR )
      GO TO 9900
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPMER , IOPABN , 0 )
      GO TO 4200
9910  CONTINUE
C -- INPUT ERRORS
      CALL XOPMSG ( IOPMER , IOPCMI , 0 )
      GO TO 9900
C
      END
C
CODE FOR WWT
      SUBROUTINE WWT
C--SET UP THE WEIGHTING SCHEME
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON /XMRG/WORK(30),ISTAT(100)
      COMMON /XMRGA/IULN,MEDIUM,NSCH,NCYC,ICT,JCT,NCT,ITEMP1,ICODE,
     2 JCODE,MDCODE,NCODE,CHOP,NCHOP,IPRINT,APRINT,ISQ,IBUF,JBUF,NBUF,
     3 ITEMP2,IREF,JREF,NTERM,NREF,NEND,IFO,JFO,ITWIN,N6DEAD,N6CTMP,
     4 N6RTMP,JPRINT,NPRINT
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--BRANCH ON THE WEIGHTING SCHEME TYPE
      GOTO(1050,1100,1050,1000),NSCH
1000  STOP 225
1050  CONTINUE
      NCYC=1
      GOTO 1300
C--GAUSSIAN WEIGHTING SCHEME
1100  CONTINUE
      IF ( NCT .NE. 6 ) GO TO 9910
      STORE(ICT)=(ALOG(STORE(ICT)))/(STORE(ICT+1)*STORE(ICT+1))
1300  CONTINUE
      RETURN
9910  CONTINUE
C -- WRONG NO. OF PARAMS.
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 ) NCT ,  NSCH
      ENDIF
      WRITE ( NCAWU , 9915 ) NCT , NSCH
9915  FORMAT ( 1X , I5 , ' is the wrong number of parameters for ' ,
     1 'weighting scheme ' , I4 )
      CALL XERHND ( IERERR )
      RETURN
      END
C
CODE FOR KMERGE
      FUNCTION KMERGE(IN)
C--ROUTINE TO COMBINE THE CONTRIBUTORS FOR ONE REFLECTION
C  TOGETHER.
C
C  IN  A DUMMY ARGUMENT.
C
C--RETURN VALUES OF 'KMERGE' ARE :
C
C  -1  REFLECTION HAS BEEN REJECTED/
C   0  REFLECTION IS READY TO OUTPUT.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON /XMRG/WORK(30),ISTAT(100)
      COMMON /XMRGA/IULN,MEDIUM,NSCH,NCYC,ICT,JCT,NCT,ITEMP1,ICODE,
     2 JCODE,MDCODE,NCODE,CHOP,NCHOP,IPRINT,APRINT,ISQ,IBUF,JBUF,NBUF,
     3 ITEMP2,IREF,JREF,NTERM,NREF,NEND,IFO,JFO,ITWIN,N6DEAD,N6CTMP,
     4 N6RTMP,JPRINT,NPRINT
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK FOR ONLY ONE REFLECTION
      IF(NREF-1)1000,1000,1050
C--ONLY ONE CONTRIBUTOR
1000  CONTINUE
      JFO=IFO+IREF
      WORK(5)=STORE(JFO)
      WORK(9)=AMAX1(0.01,STORE(IREF+12))
      WORK(10)=WORK(9)
C----- SET THE PRINT LEVEL FOR SINGLE REFLECTIONS
      JPRINT = IPRINT
      GOTO 2500
C--MORE THAN ONE REFLCTION  -  INITIAL PREPARATION
1050  CONTINUE
      GOTO(1150,1200,1250,1100),NSCH
1100  STOP 225
C--UNIT WEIGHTS
1150  CONTINUE
      ASSIGN 1700 TO LABEL
      GOTO 1350
C--GAUSSIAN WEIGHTS
1200  CONTINUE
      ASSIGN 1800 TO LABEL
      GOTO 1350
C--STATISTICAL WEIGHTS
1250  CONTINUE
      ASSIGN 1750 TO LABEL
      JREF=IREF
      DO 1300 J=1,NREF
      KREF=JREF+NTERM
      STORE(KREF-1)=1./(STORE(JREF+12)*STORE(JREF+12)+1.)
      STORE(KREF-2)=0.
      JREF=JREF+NTERM
1300  CONTINUE
      GOTO 1350
C
C--ASSIGN WEIGHTS  -  ALL CALCULATIONS ARE DONE ON THE SCALE OF /FO/ **2
1350  CONTINUE
      DO 1950 L=1,NCYC
C--WORK3 = SIGMA W* /FO/ **2
      WORK(3)=0.
C--WORK4 = SIGMA W
      WORK(4)=0.
C--WORK8 = WEIGHTED VARIANCE
      WORK(8)=0.
      JREF=IREF
      DO 1600 J=1,NREF
      KREF=JREF+NTERM
      JFO=JREF+IFO
C--CHECK IF ANY JCODES ARE TO BE SPECIALLY WEIGHTED
      IF(NCODE)1550,1550,1400
C--CHECK IF THIS REFLECTION IS ONE OF THE SPECIAL JCODES
1400  CONTINUE
      DO 1500 K=ICODE,JCODE,MDCODE
      IF(ISTORE(KREF-4)-ISTORE(K))1500,1450,1500
C--APPLY THE SPECIAL WEIGHT FOR THIS JCODE
1450  CONTINUE
      STORE(KREF-1)=STORE(K+1)
1500  CONTINUE
C--SIGMA[X(I)*W(I)]
1550  CONTINUE
      WORK(3)=WORK(3)+STORE(JFO)*STORE(KREF-1)
C--SIGMA [W(I)]
      WORK(4)=WORK(4)+STORE(KREF-1)
      WORK(8)=WORK(8)+STORE(JREF+12)*STORE(JREF+12)*STORE(KREF-1)
      JREF=KREF
1600  CONTINUE
C--WEIGHTED AVERAGE
      WORK(5)=WORK(3)/WORK(4)
      WORK(10)=SQRT(WORK(8)/WORK(4))
C--CHECK IF THIS IS THE LAST CYCLE  -  EXIT IF IT IS
      IF(L-NCYC)1650,1900,1900
1650  CONTINUE
      GOTOLABEL,(1700,1800,1750)
C--UNIT WEIGHTS
1700  GOTO 1900
C--STATISTICAL WTS
1750  GOTO 1900
C--EXPONENTIAL WEIGHTS
1800  JREF=IREF
      DO 1850 J=1,NREF
      KREF=JREF+NTERM
      JFO=JREF+IFO
C--COMPUTE THE DELTA'S
      WORK(3)=WORK(5)-STORE(JFO)
C--COMPUTE THE GAUSSIAN WEIGHT ON THE SCALE OF I'S AND THEN
C  CONVERT TO THE SCALE OF /FO/ **2'S.
      WORK(4)=STORE(ICT+2)+(STORE(ICT+3)*STORE(JREF+12)+STORE(ICT+4)
     2 *STORE(JREF+12)*SQRT(STORE(JFO)*STORE(JREF+27))+STORE(ICT+5)
     3 *STORE(JFO)*STORE(JREF+12)*STORE(JREF+27))*STORE(JREF+27)
C--KREF-2='E'
      STORE(KREF-2)=WORK(4)/STORE(JREF+27)
C--    -1=WT
      STORE(KREF-1)=0.
      ATEMP=WORK(3)*WORK(3)*STORE(ICT)/(STORE(KREF-2)*STORE(KREF-2))
C--CHECK IF THIS VALUE IS TOO SMALL TO 'EXP'
      IF(ATEMP+170.)1840,1810,1810
C--TAKE THE EXPONENTIAL
1810  CONTINUE
      STORE(KREF-1)=EXP(ATEMP)
C--UPDATE FOR THE NEXT REFLECTION
1840  CONTINUE
      JREF=KREF
1850  CONTINUE
1900  CONTINUE
1950  CONTINUE
C
C--CHECK THE NUMBER OF BAD AGREEMENTS AFTER THE FINAL CYCLE
      JPRINT=IPRINT
      JREF=IREF
      DO 2100 J=1,NREF
      JFO=JREF+IFO
      KREF=JREF+NTERM
C--CHECK THE DISCREPANCY FOR THIS CONTRIBUTOR
      IF(ABS(STORE(JFO)-WORK(5))-APRINT*WORK(10))2100,2100,2000
C--DISCREPANCY EXCEEDS 'APRINT'*E.S.D.
2000  CONTINUE
      NPRINT=NPRINT+1
C--CHECK IF THIS IS A PARTIAL PRINT
      IF(IPRINT)2100,2050,2100
C--COMPLETE PRINT REQUIRED
2050  CONTINUE
      JPRINT=1
2100  CONTINUE
      JREF=KREF
C--ACCUMULATE THE TOTALS AND DO THE PRINTING IF NECESSARY
      WORK(6)=0.
      WORK(8)=0.
C----- SET A MAXIMUM JCODE
      WORK(29) = 9.
      JREF=IREF
      DO 2450 J=1,NREF
      KREF=JREF+NTERM
      JFO=JREF+IFO
C--WORK7 = DELTA
      WORK(7)=WORK(5)-STORE(JFO)
C--WORK6 = SIGMA W*DEL.SQ
      WORK(6)=WORK(6)+WORK(7)*WORK(7)*STORE(KREF-1)
C--WORK 8 = SIGMA W*VAR
      WORK(8)=STORE(JREF+12)*STORE(JREF+12)*STORE(KREF-1)+WORK(8)
C--WORK25=21= SIGMA /DELTA/
      WORK(25)=WORK(25)+ABS(WORK(7))
C--WORK26 = 22 = SIGMA AVERAGE
      WORK(26)=WORK(26)+WORK(5)
C--WORK27 = 23 = SIGMA W AV SQ
      WORK(27)=WORK(27)+WORK(5)*WORK(5)*STORE(KREF-1)
C--CHECK IF A PRINT IS REQUIRED OF THE CONTRIBUTORS
      IF(JPRINT)2400,2400,2200
C--PRINT THE RESULTS  - PARTIAL CONTRIBUTIONS
2200  CONTINUE
      KKK=IB
      IF(ABS(STORE(JFO)-WORK(5))-APRINT*WORK(10))2300,2300,2250
C--OUTSIDE THE LIMTS
2250  CONTINUE
      KKK=IA
C--PRINT THIS CONTRIBUTOR
2300  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2350)STORE(JFO),KKK,STORE(JREF+12),WORK(7),
     2 STORE(KREF-2),STORE(KREF-1),ISTORE(KREF-4),ISTORE(KREF-3)
      ENDIF
2350  FORMAT(51X,F10.1,A1,F9.1,2F10.1,E11.2,I6,I10)
2400  CONTINUE
C----- WORK(29) IS MINIMUM JCODE
      WORK(29) = AMIN1( WORK(20), STORE(JREF+18) )
      JREF=KREF
2450  CONTINUE
C--WORK 28 = 24 = SIGMA W DELTA SQ
      WORK(28)=WORK(28)+WORK(6)
      WORK(9)=WORK(6)/WORK(4)
      WORK(10)=WORK(8)/WORK(4)
      WORK(9)=SQRT(WORK(9))
      WORK(10)=SQRT(WORK(10))
      WORK(9)=AMAX1(0.01,WORK(9))
      WORK(10)=AMAX1(0.01,WORK(10))
C
C--ALL THE DETAILS HAVE BEEN SET UP
2500  CONTINUE
      J=1
      KMERGE=0
C--CHECK FOR AN ACCEPTED REFLECTION
      IF(CHOP*WORK(NCHOP+8)-WORK(5))2550,2550,2700
C--THIS REFLECTION IS OKAY  -  ADD IN THE DEVIATION DETAILS
2550  CONTINUE
      IF(NREF-1)2750,2750,2600
C--MORE THAN ONE REFLECTION  -  ADD IN THE DEVIATION DETAILS
2600  CONTINUE
      JREF=IREF
      DO 2650 I=1,NREF
      JFO=JREF+IFO
      KREF=JREF+NTERM
      WORK(20)=WORK(5)-STORE(JFO)
      WORK(21)=WORK(21)+ABS(WORK(20))
      WORK(22)=WORK(22)+WORK(5)
      WORK(23)=WORK(23)+WORK(5)*WORK(5)*STORE(KREF-1)
      WORK(24)=WORK(24)+WORK(20)*WORK(20)*STORE(KREF-1)
      JREF=KREF
2650  CONTINUE
      GOTO 2750
C--REJECTED REFLECTION
2700  CONTINUE
      J=2
      N6DEAD=N6DEAD+1
      KMERGE=-1
C--PRINT THE TOTALS FOR THE NEW REFLECTION
2750  CONTINUE
      IF(JPRINT)2900,2900,2800
C--PRINT THE REFLECTION
2800  CONTINUE
      K=IREF+2
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2850)(ISTORE(I),I=IREF,K),WORK(5),(WORK(I),I=9,10),
     2 (IB,I=1,J)
      ENDIF
2850  FORMAT(1H ,3I4,1X,3F10.1,2A1,1X,23HUnobserved  -  rejected)
C--FIND THE STATISTICS IF NECESSARY
2900  CONTINUE
      IF(J-2)2950,3000,3000
C--COMPUTE THE POINT
2950  CONTINUE
      J=INT(AMIN1(2.*WORK(5)/WORK(NCHOP+8)+1.,100.)+.001)
      ISTAT(J)=ISTAT(J)+1
C--AND NOW RETURN
3000  CONTINUE
      RETURN
      END
C
CODE FOR WSTAT
      SUBROUTINE WSTAT
C
C--
C
      DIMENSION JSTAT(100)
C
C
      COMMON /XMRG/WORK(30),ISTAT(100)
      COMMON /XMRGA/IULN,MEDIUM,NSCH,NCYC,ICT,JCT,NCT,ITEMP1,ICODE,
     2 JCODE,MDCODE,NCODE,CHOP,NCHOP,IPRINT,APRINT,ISQ,IBUF,JBUF,NBUF,
     3 ITEMP2,IREF,JREF,NTERM,NREF,NEND,IFO,JFO,ITWIN,N6DEAD,N6CTMP,
     4 N6RTMP,JPRINT,NPRINT
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
C
C -- 'NMONIT' IS NUMBER OF CHANNELS TO DISPLAY ON MONITOR OUTPUT.
C    'MONWID' IS WIDTH OF MONITOR BAR DISPLAY
C    'IMONIT' CONTROLS WHETHER A DISPLAY IS PRODUCED ( 1 = YES, 0 = NO)
C
      DATA NCHANL / 100 / , LISWID / 80 /
      DATA NMONIT / 20 / , MONWID / 40 / , IMONIT / 1 /
C
C
C
C--PRINT THE HEADING
      CALL XPRTCN
      WRITE ( NCAWU , 995 )
995   FORMAT ( // )
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)
      ENDIF
      WRITE ( NCAWU , 1000 )
1000  FORMAT(29H  F2/Sigma(F2)  No.  %  Total,
     2 48H Remainder         Distribution of sigma levels./)
C
C -- ACCUMULATE TOTAL NUMBER OF REFLECTIONS, AND REMAINDER INFORMATION
C
      ND=0
      IAMAX = 0
      NTOT = 0
C
      DO 1050 J=1, NCHANL
      ND=ND+ISTAT(J)
      IAMAX=MAX0(IAMAX,ISTAT(J))
      IF ( J .GT. NMONIT ) NTOT = NTOT + ISTAT(J)
      JSTAT(J)=ND
1050  CONTINUE
      ND=MAX0(ND,1)
      MONMAX = MAX0 ( IAMAX , NTOT )
C
      DO 1100 J=1,100
      X=0.5*FLOAT(J)
      Y=X-0.5
      K = ( (ISTAT(J)*LISWID) / IAMAX )  + 1
      NZ=ND-JSTAT(J)
      IPER=NINT(FLOAT(ISTAT(J))*100./FLOAT(ND))
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1150)Y,X,ISTAT(J),IPER,JSTAT(J),NZ,(MINUS,L=1,K)
      ENDIF
      IF ( IMONIT .LE. 0 ) THEN
      ELSE IF ( J .LE. NMONIT ) THEN
        K = ( ( ISTAT(J) * MONWID ) / MONMAX ) + 1
        WRITE ( NCAWU , 1150 ) Y , X , ISTAT(J) , IPER , JSTAT(J) ,
     2 NZ , ( MINUS , L = 1 , K )
      ELSE IF ( J .EQ. NCHANL ) THEN
        Y = FLOAT ( NMONIT + 1 ) * 0.5
        K = ( ( MONWID * NTOT ) / MONMAX ) + 1
C
        IREM = ND - JSTAT(J)
        IPER = NINT(FLOAT(NTOT)*100./FLOAT(ND))
        WRITE ( NCAWU , 1150 ) Y , X , NTOT ,     IPER , JSTAT(J),
     2 IREM , ( MINUS , L = 1 , K )
      ENDIF
1100  CONTINUE
1150  FORMAT(1H ,F5.1,2H -,F5.1,I6,I3,2I6,1X,96A1)
      CONTINUE
      CALL XLINES
      RETURN
      END
C
CODE FOR XL6RRP
      SUBROUTINE XL6RRP(N6DEAD,N6MAX,IFO,ICAPT)
C--REJECTED REFLECTION PRINT ROUTINE FOR LIST 6.
C
C  N6DEAD  THE NUMBER OF REFLECTIONS REJECTED SO FAR.
C  N6MAX   THE MAXIMUM NUMBER OF REJECTED REFLECTIONS TO BE PRINTED.
C  IFO     THE POSITION OF /FO/ IN THE LIST 6 BUFFER  -  RANGE 0 TO
C          'MD6'-1.
C  ICAPT   A 24 CHARACTER CAPTION TO PRECEDE THE REFLECTION.
C
C--
C
      CHARACTER*(*) ICAPT
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
C
C--CHECK IF THIS IS THE FIRST REJECTED REFLECTION
      IF(N6DEAD)1000,1000,1100
C--FIRST REFLECTION  -  OUTPUT THE REJECTED REFLECTIONS CAPTION
1000  CONTINUE
      N6DEAD=0
      CALL XPRTCN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1050)
      ENDIF
1050  FORMAT(//21H Rejected reflections,10X,1HH,5X,1HK,5X,1HL,5X,
     2 9HI or /FO/,5X,5HSigma,6X,5HJCODE,4X,6HSerial/)
      GOTO 1250
C--CHECK IF TOO MANY REFLECTIONS HAVE BEEN REJECTED
1100  CONTINUE
      IF(N6DEAD-N6MAX)1250,1150,1350
1150  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)
      ENDIF
1200  FORMAT(/18H and so on . . . .)
      GOTO 1350
C--PRINT THE REJECTED REFLECTION
1250  CONTINUE
      JFO=IFO+M6
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1300)ICAPT,STORE(M6),STORE(M6+1),STORE(M6+2),
     2 STORE(JFO),STORE(M6+12),STORE(M6+18),STORE(M6+19)
      ENDIF
1300  FORMAT ( 1X, A, 2X, 3F6.0, F12.1, F11.1, F11.0, F10.0 )
C--UPDATE THE NUMBER OF REJECTED REFLECTIONS
1350  CONTINUE
      N6DEAD=N6DEAD+1
      RETURN
      END


CRYSTALS CODE FOR SFLS
CODE FOR XSFLSB
      SUBROUTINE XSFLSB (MODE)
C--MAIN CONTROL ROUTINE FOR THE S.F.L.S. ROUTINES
C
C--
C      IF MODE EQ 0, DONT READ DATA STREAM
C
C----- NOTE THAT IF STR11 IS USED DOUBLE PRECISION, LENGRP IN
C      LIST11 IN COMMAND FILE MUST BE CHANGED FROM 1 TO 2
C      FOR LHS AND RHS
C      AND I11LEN IN XPRC12
C      DOUBLE PRECISION STR11(1048576)
      DIMENSION STR11(1048576)
      DIMENSION ISTORE(131072)
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 30
      PARAMETER (IDIM30 = 32)
      DIMENSION ICOM30(IDIM30)
      DIMENSION ICOM33(24)
C
C
C
C
      DIMENSION IWORKA(52)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XUSLST/LN5,LN6
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST11/L11,M11,MD11,N11,L11R,M11R,MD11R,N11R,
     2 L11P,M11P,MD11P,N11P,L11IR,M11IR,MD11IR,N11IR
      COMMON/XDATF/NFLD,LFLD,NULD
C      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDATD/XSTR11(1048576)
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON/XLST22/L22,M22,MD22,N22,L22B,M22B,MD22B,N22B,
     2 L22CB,M22CB,MD22CB,N22CB,L22IR,M22IR,MD22IR,N22IR,
     3 L22PD,M22PD,MD22PD,N22PD
      COMMON/XLST23/L23M,M23M,MD23M,N23M,L23EX,M23EX,MD23EX,N23EX,
     2 L23MN,M23MN,MD23MN,N23MN,L23AC,M23AC,MD23AC,N23AC,
     3 L23IC,M23IC,MD23IC,N23IC, L23SP,M23SP,MD23SP,N23SP
      COMMON/XLST25/L25,M25,MD25,N25,L25I,M25I,MD25I,N25I
      COMMON/XLST30/
     1 L30DR,M30DR,MD30DR,N30DR, L30CD,M30CD,MD30CD,N30CD,
     2 L30RF,M30RF,MD30RF,N30RF, L30IX,M30IX,MD30IX,N30IX,
     3 L30AB,M30AB,MD30AB,N30AB, L30GE,M30GE,MD30GE,N30GE,
     4 L30CL,M30CL,MD30CL,N30CL, L30SH,M30SH,MD30SH,N30SH
      COMMON/XLST33/L33CD,M33CD,MD33CD,N33CD,L33SV,M33SV,MD33SV,N33SV,
     2 L33ST,M33ST,MD33ST,N33ST,L33IB,M33IB,MD33IB,N33IB,
     3 L33V,M33V,MD33V,N33V,L33CB,M33CB,MD33CB,N33CB
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
C
C
C
      COMMON /XSFWK/SCALE,R,RW,FOT,FCT,DFT,WDFT,AMINF,SFO,SFC,AP,BP,AT,
     2 BT,AC,BC,ACI,BCI,ACT,BCT,FO,FC,P,W,DF,WDF,TC,T,FOCC,TFOCC,SST,
     3 ST,A,C,S,COSP,SINP,LAYER,IBATCH,EXT,EXT1,EXT2,EXT3,FCEXT,FCEXS,
     4 PH,PK,PL,SH,SK,SL,WAVE,THETA1,THETA2,POL1,POL2,DEL,DELTA,D,B,
     5 ACONV,SCALEO,SCALEL,SCALEB,SCALES,SCALEK,SCALEG,SCALEW,PSHIFT,
     6 FRIED
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (ICOM33(1),L33CD)
      EQUIVALENCE (STR11(1),XSTR11(1))
      EQUIVALENCE (L30DR,ICOM30(1))
C
C
C
C
      EQUIVALENCE (IWORKA(1),JA)
      DATA IVERSN /707/
C
      CALL XTIME1(1)
      IF (MODE .EQ. 0) THEN
C----- WE WONT READ ANY DATA, BUT WILL SET TYPE TO 'CALC'
            NUM = 3
            GOTO 1105
      ENDIF
C--LOAD THE NEXT '#INSTRUCTION'
1000  CONTINUE
      NUM=KNXTOP(LSTOP,LSTNO,ICLASS)
C--CHECK IF WE SHOULD RETURN
      IF(NUM)1050,1050,1100
1050  CONTINUE
      RETURN
C--BRANCH ON THE TYPE OF OPERATION
1100  CONTINUE
      I=KRDDPV(ISTORE(NFL),1)
1105  CONTINUE
      CALL XZEROF(IWORKA(1),52)
      GOTO(1200,1250,1300,1350,4550,4600,1150),NUM
1150  STOP 54
C
C--'#REFINE' HAS BEEN GIVEN
1200  CONTINUE
      JB=0
      JH=-1
      GOTO 1400
C
C--'#SCALE' HAS BEEN REQUESTED
1250  CONTINUE
      JB=-1
      JH=0
      GOTO 1400
C
C--'#CALCULATE' HAS BEEN GIVEN
1300  CONTINUE
      JB=-1
      JH=-1
      GOTO 1400
C
C--'#CYCLENDS' INSTRUCTION
1350  CONTINUE
      CALL XCYCLE
      GOTO 1000
C
C--SET THE VALUES FOR A S.F.L.S. CALCULATION
1400  CONTINUE
      CALL XDUMP
C--CLEAR THE CORE
      CALL XRSL
C--LOAD LIST 13  -  THE EXPERIMENTAL CONDITIONS LIST
      CALL XFAL13
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE TWINNED/NON-TWINNED FLAG
      NB=ISTORE(L13CD+1)
C--FIND THE TYPE OF RADIATION
      NU=ISTORE(L13DT+1)
C--FETCH THE POLARISATION CONSTANTS
      WAVE=STORE(L13DC)
      THETA1=STORE(L13DC+1)
      THETA2=STORE(L13DC+2)
C--LOAD LIST 23  -  DEFINES CONDITIONS FOR S.F.L.S. CALCULATIONS
      CALL XFAL23
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE ANOMALOUS DISPERSION FLAG
      JE=ISTORE(L23M)
C--SET THE EXTINCTION FLAG
      NA=ISTORE(L23M+1)
C--SET THE LAYER SCALES APPLICATION FLAG
      NE=ISTORE(L23M+2)
C--SET THE BATCH SCALES APPLICATION FLAG
      NW=ISTORE(L23M+3)
C--SET THE PARTIAL CONTRIBUTIONS FLAG
      NC=ISTORE(L23M+4)
C--SET THE UPDATE PARTIAL CONTRIBUTIONS FLAG
      ND=ISTORE(L23M+5)
C----- SET THE ENANTIOPOLE REFINEMENT FLAG
      JL = ISTORE(L23M+6)
C--SET THE FLAG FOR REFINEMENT AGAINST /FO/ OR /FO/ **2
      NV=ISTORE(L23MN+1)
C----- CHECK IF WE  NEED REFLECTIONS (-1 IF NOT)
      IREFLS = ISTORE(L23MN+3)
C--FIND THE MINIMUM ALLOWED TEMPERATURE FACTOR
      UMIN=STORE(L23AC+8)
C----- SAVE THE TOLERANCE AND UPDATE VALUES
      STOLER = STORE(L23SP+5)
      IUPDAT = ISTORE(L23SP+1)
C--CLEAR THE CORE OUT AGAIN
      CALL XRSL
      CALL XCSAE
C----- SAVE SOME SPACE FOR THE U AXES
      IADDU = KCHLFL (4)
C--LOAD LIST 33  -  THE CONDITIONS FOR THIS S.F.L.S. CALCULATION
      CALL XFAL33
      IF ( IERFLG .LT. 0 ) GO TO 9900
      NF=-1
      JG=-1
C----- READ DOWN SOME LISTS
      CALL XFAL01
      CALL XFAL02
      CALL XFAL05
      CALL XFAL30
      IF (IERFLG .LT. 0) GOTO 9900
C
C--CHECK THAT ALL THE TEMPERATURE FACTORS ARE REASONABLE
      M5=L5
C--CHECK THAT THERE IS AT LEAST ONE ATOM IN LIST 5
      IF(N5 .LE. 0) GOTO 9940
C--LOOP OVER EACH ATOM
      A=0.0
      N=0
      DO 3300 I=1,N5
      IF (ABS(STORE(M5+3)) .LE. UISO) THEN
C--CHECK THE SMALLEST U AXIS
        CALL XEQUIV ( 1, M5, MD5, IADDU )
        IF (STORE(IADDU+1) .LT. UMIN) THEN
C--THIS ANISOTROPIC TEMPERATURE FACTOR IS NOT ALLOWED
          WRITE(NCAWU, 3110) STORE(M5),NINT(STORE(M5+1)),STORE(IADDU+1)
      IF (ISSPRT .EQ. 0) THEN
          WRITE(NCWU, 3110) STORE(M5),NINT(STORE(M5+1)),STORE(IADDU+1)
      ENDIF
3110  FORMAT(/, ' Atom ', A4, I5, ' has U-min too small, ', F8.4)
          A=AMIN1(A,STORE(IADDU+1))
          N=N+1
      STORE(M5+3) = UMIN + ZERO
        ENDIF
      ELSE
C--CHECK THE ISOTROPIC TEMPERATURE FACTOR
        IF(STORE(M5+3) .LE. UMIN) THEN
C--THIS U[ISO] VALUE IS OUT OF RANGE
      IF (ISSPRT .EQ. 0) THEN
          WRITE(NCWU, 3120) STORE(M5),NINT(STORE(M5+1)),STORE(M5+3)
      ENDIF
          WRITE(NCAWU, 3120) STORE(M5),NINT(STORE(M5+1)),STORE(M5+3)
3120  FORMAT(/, ' Atom ', A4, I5, ' has U-iso too small, ', F8.4)
          A=AMIN1(A,STORE(M5+3))
          N=N+1
      STORE(M5+3) = UMIN + ZERO
        ENDIF
      ENDIF
      M5 = M5 + MD5
3300  CONTINUE
C--CHECK IF THE T.F.'S ARE ALL OKAY
      IF (N .NE. 0) THEN
C -- INVALID TEMPERATURE FACTOR
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9935 ) N , UMIN , A
      ENDIF
      WRITE(NCAWU,9935) N, UMIN, A
9935  FORMAT (//, 1X , I6 , ' temperature factors less ' ,
     1 'than the lowest allowed value of ' , F10.5 ,
     2 /1X,' The minimum value  was ', F10.5)
      ENDIF
      IF (STORE(L5O+4)) 3310,3330,3330
3310  CONTINUE
      WRITE(NCAWU,3320) STORE(L5O+4)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3320) STORE(L5O+4)
      ENDIF
3320  FORMAT(10X,'Enantiopole parameter out of range. (',F6.3,' ) ')
C      STORE(L5O+4) = 0.
      GOTO 3340
3330  IF (STORE(L5O+4) - 1.) 3340,3340,3335
3335  CONTINUE
      WRITE(NCAWU,3320) STORE(L5O+4)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3320) STORE(L5O+4)
      ENDIF
C      STORE(L5O+4) = 1.
3340  CONTINUE
C
C----- SET THE OCCUPANCIES
      IF (IUPDAT .GE. 0)  I = KSPINI( -1, STOLER)
C----- SAVE SOME WORK SPACE
        J =NFL
        I = KCHNFL(40)
        M5 = L5
        DO 3350 I = 1, N5
          IF (IUPDAT .GE. 0) THEN
            IGSTAT =KSPGET ( STORE(J), STORE(J+10), ISTORE(J+20),
     2      STORE(J+30), MGM, M5, IUPDAT, NUPDAT)
          ELSE
            STORE(M5+13) = 1.0
          ENDIF
          M5 = M5 + MD5
3350  CONTINUE
        NFL= J
C
C--CHECK THAT THE SCALE FACTOR GIVEN IS NOT ZERO
      SCALE = STORE(L5O)
      IF (SCALE .LE. 0.000001) THEN
C--SCALE FACTOR IS UNREASONABLE  -  RESET IT TO 1.0
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,1420)
      ENDIF
        WRITE(NCAWU,1420)
1420  FORMAT(10X,' The overall scale factor has been set to 1.0' )
        SCALE = 1.
        STORE(L5O)=1.
        CALL XSTR05(5,0,-1)
      ENDIF
C----- CHECK ON THE TYPE OF MATRIX TO USE
      JK = ISTORE( M33CD + 6)
C----- SET THE STORE MAP LEVEL
      ISTAT2 = ISTORE (M33CD+3)
C----- CHECK FOR RESTRAINTS ONLY
      IF (IREFLS .LE. -1) GOTO 2350
C--CHECK ON THE TYPE OF LISTING REQUIRED
      IF(ISTORE(M33CD+2))1550,1500,1450
C--COMPLETE LISTING, INCLUDING ELEMENT CONTRIBUTIONS FOR A TWIN
1450  CONTINUE
      NF=0
C--LISTING OF EACH STRUCTURE FACTOR AS IT IS CALCULATED
1500  CONTINUE
      JG=0
1550  CONTINUE
C--CHECK IF THIS STRUCTURE IS TWINNED
      IF(NB)1700,1600,1600
C--TWINNED  -  CHECK ON THE TYPE OF OUTPUT FOR /FO/
1600  CONTINUE
      NB=0
      IF(ISTORE(M33CD+4))1700,1650,1650
C--SCALED /FOT/ IS REQUIRED
1650  CONTINUE
      NB=1
1700  CONTINUE
C--READ DOWN SOME LISTS
      CALL XFAL03
      CALL XFAL06(1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--INITIALISE THE COLLECTION OF THE DETAILS FOR /FC/ AND PHASE
      CALL XIRTAC(6)
      CALL XIRTAC(7)
      CALL XIRTAC(16)
C--SET UP DEFAULT VALUES FOR THE REFLECTION HOLDING STACK
      N12=0
      N25=1
C--CHECK IF THIS IS A TWINNED REFINEMENT
      IF(NB)1900,2000,2000
C--THIS IS NOT A TWINNED REFINEMENT
1900  CONTINUE
      NF=-1
C--CHECK IF WE ARE UPDATING THE PARTIAL DERIVATIVES
      IF(ND)2350,1950,1950
C--UPDATE  -  INITIALISE THE COLLECTION
1950  CONTINUE
      CALL XIRTAC(8)
      CALL XIRTAC(9)
      GOTO 2350
C--THIS IS A TWINNED REFINEMENT  -  SUPPRESS EXTINCTION CORRECTIONS
2000  CONTINUE
      NA=-1
C--SUPPRESS PARTIAL CONTRIBUTIONS
      NC=-1
      ND=-1
C----- SUPPRESS ENANTIOPOLE REFINEMENT
      JL = -1
C--INITIALISE THE DETAILS FOR /FO/
      CALL XIRTAC(4)
C--CHECK IF PRINTING IS BEING DONE
      IF(JG)2050,2100,2100
C--SUPPRESS ELEMENT PRINTING
2050  CONTINUE
      NF=-1
C--LOAD THE TWIN OPERATORS
2100  CONTINUE
      IF ( IERFLG .LT. 0 ) GO TO 9900
      CALL XFAL25
C--CHECK THAT THE NUMBER OF OPERATORS EQUALS THE NUMBER OF ELEMENTS
      IF ( MD5ES .NE. N25 ) GO TO 9910
C--FORM THE SQUARE ROOT OF THE ELEMENT SCALES
      LN=LN5
      IREC=1001
      M5ES=NFL
      I=KCHNFL(MD5ES)
C--SET UP THE VALUES
      J=M5ES
      K=L5ES
      DO 2300 I=1,MD5ES
      STORE(J)=SQRT(STORE(K))
      J=J+1
      K=K+1
2300  CONTINUE
2350  CONTINUE
C--CHECK ON WHETHER THERE IS A REFINEMENT TO BE DONE
      JQ=0
      IF(JB)2900,2400,2400
C--SET UP THE STORAGE LOCATIONS FOR THE PARTIAL DERIVATIVES
2400  CONTINUE
      JQ=(2-IC)*(JE+2)
      JQ=MAX0(JQ,2)
      JS=-1
C--LOAD LIST 12
      CALL XFAL12(JS,JQ,JR,JN)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE INITIAL DETAILS FOR LINKING LISTS 12 AND 5
      JA=1
      JJ=-1
C--LINK LIST 12 AND LIST 5
      IF(KSET52(0,0))2500,2450,2450
C--ANISO T.F.'S ARE STORED
2450  CONTINUE
      IF ( IERFLG .LT. 0 ) GO TO 9900
      JA=N2
      JJ=0
C--CHECK THAT THERE ARE SOME PARAMETERS TO REFINE
2500  CONTINUE
      IF ( IERFLG .LT. 0 ) GO TO 9900
      IF ( N12 .LE. 0 ) GO TO 9920
C--SET UP THE STACK FOR THE COMPLETE PARTIAL DERIVATIVES
      JO=JR
      JP=JO+N12-1
C--CHECK IF WE NEED THE L.H.S.
      IF(JK)2700,2750,2750
C--SET UP A NEW MATRIX
2700  CONTINUE
      CALL XSET11(JK,1,1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
      GOTO 2850
C--WE ONLY NEED THE R.H.S.
2750  CONTINUE
      CALL XSET11(JK,0,1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CLEAR THE R.H.S. OF THE OLD NUMBERS
      M11R=L11R+N11R-1
      DO 2800 I=L11R,M11R
      STR11(I)=0.
2800  CONTINUE
C--CHECK THAT THERE IS ROOM TO OUTPUT THE MATRIX
2850  CONTINUE
      CALL XCL11(11)
C--INITIALISE THE MATRIX ACCUMULATION ROUTINES
      CALL XSETMT(JO,L11,L11R,N12,L12B,N12B)
      GOTO 3000
C--NO REFINEMENT
2900  CONTINUE
      JJ=-1
      JA=1
C--SET THE T.F. VALUES IN LIST 5
      IF(KSET52(-1,0))3000,2950,2950
2950  CONTINUE
      IF ( IERFLG .LT. 0 ) GO TO 9900
      JA=N2
      JJ=0
C--LINK LIST 5 AND 3
3000  CONTINUE
C----- CHECK FOR RESTRAINTS ONLY
      IF (IREFLS .GE. 0) THEN
      N3=KSET53(0)+1
      IF ( IERFLG .LT. 0 ) GO TO 9900
      ENDIF
C
C----- CHECK IF REFLECTIONS SHOULD BE USED
      IF (IREFLS .LE. -1) THEN
            NT    = 0
            R     = 0.
            RW    = 0.
            WDFT  = 0.
            AMINF = 0.
            CYCNO = STORE(M33V) + 1
      ELSE
C--SET UP THE REFLECTION HOLDING STACK
      NR=4
      NY=20
      NG=NFL
C--SET THE LIST AND RECORD TYPE
      LN=25
      IREC=1001
      NH=KCHNFL(N25*(N12*(JQ+1)+NY+NR*N2I)+1)
C--PREPARE TO INITIALISE THE STACK
      NH=NG+1
      NI=NG
      NJ=(N2T-1)*NR
C--SET UP THE STACK
      DO 3550 I=1,N25
      ISTORE(NI)=NH
      NI=NH
      ISTORE(NI)=NOWT
      ISTORE(NI+1)=NH+NY
      ISTORE(NI+2)=ISTORE(NI+1)+N12-1
      ISTORE(NI+18)=ISTORE(NI+2)+1
      ISTORE(NI+19)=ISTORE(NI+18)+N12*JQ-1
      ISTORE(NI+9)=ISTORE(NI+19)+1
      ISTORE(NI+10)=ISTORE(NI+9)+NJ
      NH=ISTORE(NI+10)+NR
C--INSERT DUMMY INITIAL INDICES
      NL=ISTORE(NI+9)
      NM=ISTORE(NI+10)
      DO 3500 NN=NL,NM,NR
      STORE(NN)=-1000000.
      STORE(NN+1)=-1000000.
      STORE(NN+2)=-1000000.
      STORE(NN+3) = 0.0
3500  CONTINUE
3550  CONTINUE
C--OUTPUT AN INITIAL CAPTION
      CALL XPRTCN
C--FIND THE NUMBER OF CYCLES CALCULATED
      STORE(L6P)=STORE(L6P)+1.
      JI=NINT(STORE(L6P))
      CYCNO = STORE(L6P)
C--PRINT THE TITLE HEADING
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3600)JI
      ENDIF
3600  FORMAT(31H Structure factor least squares,5X,
     2 19H calculation number,I6/)
C--PRINT THE ALLOCATED CORE STORE IF NECESSARY
      IF(ISTAT2)3650,4050,3650
3650  CONTINUE
      CALL XPCM(1)
C--CHECK IF WE SHOULD DUMP ANY OTHER GOODIES
      IF(ISTAT2)4050,4050,3700
3700  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3750)IWORKA
      ENDIF
3750  FORMAT(1H ,13I9)
      M2=L2+MD2*N2-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3800)(STORE(I),I=L2,M2)
      ENDIF
3800  FORMAT(1H ,12F10.5)
      M2I=L2I+MD2I*N2I-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3800)(STORE(I),I=L2I,M2I)
      ENDIF
      M3=L3+MD3*N3-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3850)(STORE(I),I=L3,M3)
      ENDIF
3850  FORMAT(1H ,A4,11F10.5)
      M5=L5+MD5*(N5-1)
      DO 3950 I=L5,M5,MD5
      L=I+2
      M=I+MD5-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3900)ISTORE(I),ISTORE(I+1),(STORE(K),K=L,M)
      ENDIF
3900  FORMAT(1H ,2I4,11F9.5)
3950  CONTINUE
      IF(JB)4050,4000,4000
4000  CONTINUE
      CALL XPRINT(L22,L22+(MD22*N22)-1)
C
C
C--CALL THE CALCULATION LINK
4050  CONTINUE
      CALL XSFLSC
      ENDIF
C
C
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CHECK FOR L.S. REFINEMENT
      IF(JB)4150,4100,4100
C--STORE THE MATRIX  -  STORE THE NUMBER OF PARAMETERS
4100  CONTINUE
      STORE(L11P+23)=FLOAT(N12)
C--STORE THE NUMBER OF REFLECTIONS THAT HAVE BEEN USED
      STORE(L11P+24)=FLOAT(NT)
C--STORE THE SUM OF W*DF**2
      STORE(L11P+25)=WDFT
C--STORE THE SUM OF W* /FO/ **2
      IF (ABS (RW) .LE. ZERO) THEN
            A =1.
      ELSE
            A = 100. / RW
      ENDIF
      STORE(L11P+26)=WDFT*A*A
C--SET THE NUMBER OF DEGREES OF FREEDOM
      STORE(L11P+16)=STORE(L11P+24)-STORE(L11P+23)
C--STORE THE MINIMISATION FUNCTION
      STORE(L11P+17)=AMINF
C--OUTPUT LIST 11
      CALL XCL11(11)
      CALL XMKOWF(11,0)
      CALL XALTES(11,1)
C--TERMINATE THE OUTPUT OF LIST 6  -  STORE THE R-VALUE
4150  CONTINUE
      IF (IREFLS .LE. -1) GOTO 4355
      STORE(L6P+1)=R
C--STORE THE WEIGHTED R-VALUE
      STORE(L6P+2)=RW
C--STORE THE MINIMISATION FUNCTION
      STORE(L6P+3)=AMINF
C--COMPUTE THE REFLECTION TOTALS FOR /FC/ AND PHASE
      CALL XCRD(6)
      CALL XCRD(7)
      CALL XCRD(16)
C--CHECK FOR A TWINNED REFINEMENT
      IF(NB)4250,4200,4200
C--COMPUTE THE DETAILS FOR /FO/
4200  CONTINUE
      CALL XCRD(4)
C--CHECK IF WE HAVE UPDATED THE A AND B PARTS
4250  CONTINUE
      IF(ND)4350,4300,4300
C--UPDATE THEIR DETAILS
4300  CONTINUE
      CALL XCRD(8)
      CALL XCRD(9)
C--WRITE THE LIST TO THE DISC
4350  CONTINUE
      CALL XMONTR(-1)
      CALL XEND06
4355  CONTINUE
C--UPDATE THE DETAILS FOR LIST 33
      STORE(M33V) = CYCNO
      STORE(M33V+1)=R
      STORE(M33V+2)=RW
      STORE(M33V+3)=0.
      STORE(M33V+4)=AMINF
C--ASSIGN THE LENGTH OF THE COMMON BLOCK FOR LIST 33  -  SFLS CONTROL
      IDIM33=24
C--OUTPUT THE NEW LIST 33 TO DISC
      CALL XWLSTD(33,ICOM33,IDIM33,-1,-1)
      IF (KHUNTR (11,0, IADDL,IADDR,IADDD, -1) .EQ. 0) THEN
        IF (KHUNTR (30,0, IADDL,IADDR,IADDD, -1) .NE. 0) CALL XFAL30
C----- UPDATE LIST 30
        STORE(L30RF +0 ) = R
        STORE(L30RF +1 ) = RW
        STORE(L30RF +3 ) = MAX (STORE(L30RF +3 ), STORE(L11P+23))
        IF(STORE(L11P+23) .GT.ZERO) STORE(L30RF +2 ) = STORE(L11P+23)
        IF (STORE(L11P+16) .GT. ZERO) THEN
          STORE(L30RF +4 ) = SQRT(AMINF / STORE(L11P+16))
        ENDIF
        STORE(L30RF +8 ) = STORE(L11P+24)
        ISTORE(L30RF +12 ) = NV + 2
        CALL XWLSTD ( 30, ICOM30, IDIM30, -1, -1)
      ENDIF
C--CLEAR THE CORE
      CALL XRSL
      CALL XCSAE
C--CHECK IF THE SCALE FACTOR HAS BEEN REFINED
      IF(JH)4450,4400,4400
4400  CONTINUE
      CALL XFAL05
      IF ( IERFLG .LT. 0 ) GO TO 9900
      STORE(L5O)=SCALE
C----- SAVE SOME WORK SPACE
        J =NFL
        I = KCHNFL(40)
        M5 = L5
        DO 4420 I = 1, N5
          IF (IUPDAT .GE. 0)
     1      IGSTAT =KSPGET ( STORE(J), STORE(J+10), ISTORE(J+20),
     2      STORE(J+30), MGM, M5, IUPDAT, NUPDAT)
          M5 = M5 + MD5
4420  CONTINUE
        NFL= J
C
      CALL XSTR05(LN5,0,-1)
      CALL XRSL
      CALL XCSAE
C--PRINT THE TERMINATION MESSAGES
4450  CONTINUE
      CALL XOPMSG(IOPSFS, IOPEND, IVERSN)
      CALL XTIME2(1)
      IF (MODE .EQ. 0)  GOTO 1050
      GOTO 1000
C
C--'#END' INSTRUCTION
4550  CONTINUE
      CALL XEND
      GOTO 1000
C
C--'#TITLE' INSTRUCTION
4600  CONTINUE
      CALL XRCN
      GOTO 1000
C
9900  CONTINUE
C -- ERRORS
      IF (MODE .EQ. 0)  GOTO 1050
      GO TO 1000
9910  CONTINUE
C -- NUMBERS DON'T MATCH
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 )
      ENDIF
      WRITE ( NCAWU , 9915 )
9915  FORMAT ( 1X , 'The number of elements in lists 5 and 25 is' ,
     1 ' different' )
      CALL XERHND ( IERERR )
      GO TO 9900
9920  CONTINUE
C -- NOTHING TO REFINE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 )
      ENDIF
      WRITE ( NCAWU , 9925 )
9925  FORMAT ( 1X , 'List 12 indicates that no parameters ' ,
     1 'are to be refined' )
      CALL XERHND ( IERERR )
      GO TO 9900
9940  CONTINUE
      WRITE (NCAWU,9945)
      IF (ISSPRT .EQ. 0) THEN
      WRITE (NCWU,9945)
      ENDIF
9945  FORMAT(1X ,'LIST 5 contains no atoms')
      GOTO 9900
      END
C
CODE FOR XSFLSC
      SUBROUTINE XSFLSC
C--MAIN STRUCTURE FACTOR CALCULATION ROUTINE
C
C--USEAGE OF CONTROL VARIABLES :
C
C  JA      SET TO 1 FOR ISO ATOMS ONLY, ELSE N2
C  JB      SET TO -1 FOR NO REFINEMENT, ELSE 0
C  JC      SET TO -1 FOR ONLY CALCULATE COS, ELSE 0
C  JD      SET TO -1 FOR CENTRO, ELSE 0
C  JE      SET TO -1 FOR NO ANOMALOUS DISPERSION, ELSE 0
C  JF      CURRENT VALUE OF JB, SET FOR EACH ATOM IF JB=0
C  JG      SET TO -1 FOR NO PRINT, ELSE THE NUMBER OF LINES BEFORE PAGE
C  JH      SET TO -1 IF THE SCALE FACTOR IS NOT TO BE REFINED, ELSE 0
C  JI      CYCLE NUMBER
C  JJ      SET TO -1 IF ONLY ISO-TERMS REQUIRED, ELSE 0 (SIMILAR TO JA)
C  JK      SET TO -1 IF BOTH LEFT AND RIGHT HAND SIDES ARE NEEDED
C  JL      SET TO -1 IF ENANTIOPOLE PARAMETER NOT USED, ELSE 0
C  JN      DUMMY LOCATION FOR NON-REFINED PARAMETERS
C  JO      ADDRESS COMPLETE PARTIAL DERIVATIVES
C  JP      LAST ADDRESS COMPLETE PARTIAL DERIVATIVES
C  JQ      NUMBER OF PARTIAL DERIVATIVES PER REFLECTION (0,1,2 OR 4)
C  JR      ADDRESS PARTIAL DERIVATIVES BEFORE THEY ARE ADDED TOGETHER
C  JS      WORK VARIABLE
C  JT      WORK VARIABLES USED DURING ACCUMULATION OF PARTIAL DERIVATIVE
C  JU
C  JV
C  JW
C  JX      LOOP VARIABLE FOR EQUIVALENT POSITIONS
C  JY      LOOP VARIABLE FOR ATOMS
C  JZ
C
C  NA      SET TO -1 FOR NO EXTINCTION CORRECTION TO /FC/, ELSE 0
C  NB      SET TO -1 FOR NO TWINNED DATA, ELSE TO 0 OR 1.
C          (0 MEANS PUT /FOT/ ETC. IN /FO/, WHILE 1 OR GREATER
C           MEANS PUT THE /FO/ AND /FC/ ETC. COMPUTED FOR THE
C           ELEMENT FOR WHICH THE INDICES ARE GIVEN).
C  NC      IF GREATER THAN -1, THEN THE GIVEN PARTIAL CONTRIBUTIONS
C          ARE TO BE USED, ELSE NOT.
C  ND      IF SET TO -1, THEN NO NEW PARTIAL CONTRIBUTIONS ARE
C          OUTPUT. IF GREATER THAN -1, THE NEW /FC/ ETC. ARE STORED
C          AS THE PARTIAL CONTRIBUTIONS.
C  NE      IF GREATER THAN -1, THEN THE LAYER SCALES ARE APPLIED TO /FO/
C          ELSE NOT.
C  NF      IF GREATER THAN -1, THE CONTRIBUTORS TO EACH TWINNED REFLECTI
C          ARE PRINTED.
C  NG      ADDRESS OF THE WORD THAT HOLDS THE ADDRESS OF THE FIRST
C          BLOCK OF THE REFLECTION HOLDING STACK
C  NH      USED TO PASS THROUGH THE REFLECTION HOLDING STACK
C  NI      SIMILAR TO NH.
C  NJ      THE VALUE OF THE VARIABLE 'ELEMENTS' FOR EACH REFLECTION.
C  NK      CURRENT VALUE OF 'NJ' FOR EACH REFLECTION .
C  NL      THE ELEMENT OF THE CURRENT REFLECTION
C  NM      THE NUMBER OF REFLECTIONS IN THE STACK USED SO FAR
C  NN      SET TO 0 IF NO NEW REFLECTIONS HAVE BEEN INTRODUCED,
C          ELSE THE NUMBER OF NEW REFLECTIONS FOUND
C  NO      DUMP OF 'JO'
C  NP      DUMP OF 'JP'
C  NQ      COUNTER WHEN THE TWIN COMPONENTS ARE BEING COMBINED
C  NR      NUMBER OF WORDS PER SYMMETRY RELATED REFLECTION IN THE
C          REFLECTION HOLDING STACK.
C          THE FORMAT OF THE SYMMETRY RELATED REFLECTION ENTRIES IS :
C
C          0  H TRANSFORMED
C          1  K TRANSFORMED
C          2  L TRANSFORMED
C          3  THE PHASE SHIFT FOR THIS GROUP OF INDICES
C
C  NT      THE NUMBER OF REFLECTIONS THAT HAVE BEEN USED
C  NU      -1 FOR XRAYS, AND 0 FOR NEUTRONS  -  ONLY USED FOR EXTINCTION
C  NV      -1 FOR REFINEMENT ON /FO/, ELSE REFINEMENT ON /FO/ **2
C  NW      -1 FOR NO BATCH SCALE APPLICATION, ELSE 0.
C
C--THE FORMAT OF THE REFLECTION HOLDING STACK WHICH STARTS AT
C      'ISTORE(NG)' IS :
C
C   0  LINK TO NEXT REFLECTION OR -1000000
C   1  ADDRESS OF THE FIRST WORD OF THE DERIVATIVES W.R.T. /FC/
C   2  ADDRESS OF THE LAST WORD OF THE DERIVATIVES W.R.T. /FC/
C   3  H FOR THE CURRENT REFLECTION
C   4  K FOR THE CURRENT REFLECTION
C   5  L FOR THE CURRENT REFLECTION (ALL IN FLOATING POINT).
C   6  /FC/ FOR THE CURRENT REFLECTION
C   7  PHASE FOR THE CURRENT REFLECTION
C   8  ELEMENT NUMBER WHICH THIS REFLECTION CURRENTLY REPRESENTS.
C   9  ADDRESS OF THE FIRST WORD OF THE FIRST GROUP OF
C      EQUIVALENT INDICES FOR  THIS BLOCK. (THE REFLECTIONS ARE
C      ARE EQUIVALENT TO THOSE INDICES GIVEN IN WORDS 3 TO 5).
C  10  ADDRESS OF THE LAST GROUP OF EQUIVALENT INDICES FOR THIS
C      REFLECTION BLOCK.
C      (EACH EQUIVALENT SET OF INDICES IS 'NR' WORDS LONG).
C  11  PHASE SHIFT NECESSARY FOR THE REFLECTION CURRENTLY USING THIS BLO
C  12  1.0 IF FRIEDEL'S LAW HAS NOT BEEN USED FOR THE CURRENT REFLECTION
C  13  REAL PART OF A FOR THE ORIGINAL REFLECTION
C  14  IMAGINARY PART OF A FOR THE ORIGINAL REFLECTION
C  15  REAL PART OF B FOR THE ORIGINAL REFLECTION
C  16  IMAGINARY PART OF B FOR THE ORIGINAL REFLECTION
C  17  NOT USED
C  18  ADDRESS OF THE FIRST WORD OF THE DERIVATIVES W.R.T. A, B ETC.
C  19  ADDRESS OF THE LAST WORD OF THE DERIVATIVES W.R.T. TO A, B ETC.
C
C--THE DERIVATIVES FOLLOW THIS INFORMATION.
C
C--NORMALLY, WHEN EACH REFLECTION IS READ FROM THE DISC,
C  IT IS CHECKED AGAINST THOSE ALREADY IN THE STACK TO SEE IF ITS
C  A AND B PARTS TOGETHER WITH THEIR DERIVATIVES ARE PRESENT.
C  IF THEY ARE NOT PRESENT, THEN THESE VALUES ARE CALCULATED
C  AND THE INFORMATION SET UP IN THE BLOCK AT THE TOP OF THE STACK.
C  THIS CORRESPONDS TO THE ORIGINAL VALUES IN WORDS 13-16 AND IN THE
C  DERIVATIVES STORED FOR THE A AND B PARTS.
C  ONCE THE VALUES REQUIRED FOR THE CURRENT REFLECTION ARE PRESENT,
C  /FC/ AND ITS DERIVATIVES ARE CALCULATED.
C  (AT THIS STAGE, THE CURRENT REFLECTION MAY CORRESPOND TO THE ORIGINAL
C   REFLECTION OR MAY BE ONE OF ITS EQUIVALENTS FROM THE STACK).
C  THE DERIVATIVES ARE THEN ADDED TO THE NORMAL EQUATIONS, AFTER
C  MODIFICATION FOR EXTINCTION AND REFINEMENT AGAINST /FO/ **2 IF
C  NECESSARY.
C
C--DURING THE PROCESSING OF ONE NOMINAL REFLECTION FOR A TWIN, THE STACK
C  IS SEARCHED FOR EACH ELEMENT IN TURN. IF THE ELEMENT HAS
C  ALREADY BEEN CALCULATED, THE BLOCK IS MOVED TO THE TOP OF THE STACK
C  AND CONTROL PASSES TO THE NEXT COMPONENT. IF THE ELEMENT OR
C  COMPONENT IS NOT IN THE STACK, THE LAST BLOCK IS SWITCHED TO
C  THE TOP OF THE STACK, AND THEN ITS A AND B PARTS WITH THEIR DERIVATIV
C  COMPUTED. AT THE END, THE ELEMENT FOR WHICH THE INDICES ARE GIVEN
C  IS LEFT AT THE TOP OF THE STACK AS THIS IS ALWAYS THE LAST
C  ELEMENT PROCESSED.
C  WHEN THE A AND B PARTS HAVE BEEN  FOUND FOR ALL THE ELEMENTS, /FC/
C  AND ITS DERIVATIVES ARE CALCULATED FOR EACH ELEMENT.
C  FOLLOWING THIS, /FCT/ AND ITS DERIVATIVES ARE CALCULATED, AND THEN AD
C  TO THE NORMAL EQUATIONS.
C
C      PARTIAL DERIVATIVE STACK
C                  FLACK SYMBOL
C      0   F.COS(HX)      A      AC
C      1   F.SIN(HX)      B      BC
C      2  -F".SIN(HX)    -D      ACI
C      3   F".COS(HX)     C      BCI
C
C      FC = (A-D) + I.(B+C)
C
C
C--THE FORMAT OF THE LIST 6 BUFFER AT 'M6' IS :
C
C   0  H
C   1  K
C   2  L (ALL IN FLOATING POINT).
C   3  /FO/
C   4  WEIGHT  -  REALLY THE SQUARE ROOT OF THE WEIGHT
C   5  /FC/
C   6  PHASE
C   7  PARTIAL CONTRIBUTION FOR A.
C   8  PARTIAL CONTRIBUTION FOR B.
C   9  T-BAR  -  EXTINCTION TERM FOR THIS REFLECTION.
C  10  /FOT/  -  TOTAL /FO/ FOR A TWINNED STRUCTURE
C  11  THE ELEMENTS OF A TWINNED STRUCTURE.
C
C--USEAGE OF GENERAL VARIABLES
C
C  TC     COEFFICIENT FOR THE ISO-TEMPERATURE FACTORS
C  SST    SIN(THETA)/LAMBDA SQUARED
C  ST     SIN(THETA)/LAMBDA
C  FOCC   FORMFACTOR * SITE OCC * CHEMICAL OCC
C  T      TEMPERATURE FACTOR
C  TFOCC  T*FOCC
C  AP     A PART FOR EACH SYMMETRY POSITION FOR EACH ATOM
C  BP     B PART FOR EACH SYMMETRY POSITION FOR EACH ATOM
C  BT     TOTAL B PART FOR EACH ATOM
C  AT     TOTAL A PART FOR EACH ATOM
C  AC     TOTAL REAL A PART FOR THE REFLECTION
C  BC     TOTAL REAL B PART FOR THE REFLECTION
C  ACI    TOTAL IMAGINARY A PART FOR THE REFLECTION
C  BCI    TOTAL IMAGINARY B PART FOR THE REFLECTION
C  ACT    TOTAL A PART FOR THE RELFECTION
C  BCT    TOTAL B PART FOR THE REFLECTION
C  ACD    PARTIAL DERIVATIVE WITH RESPECT TO POLARITY PARAMETER
C  BCD    PARTIAL DERIVATIVE WRTO POLARITY PARAMETER
C  ACF    TOTAL PARTIAL DERIV WRTO POLARITY
C  ACN    TOTAL A PART FOR INVERSE STRUCTURE - USED IN ENANTIOPOLE REFIN
C  BCN    TOTAL B PART FOR INVERSE STRUCTURE - USED IN ENANTIOPOLE REFIN
C  ACE    PARTIAL DERIVATIVE FOR ENANTIOPOLE
C  ENANT  ENANTIOPOLE PARAMETER
C  APD    PARTIAL DERIVATIVES FOR  EACH ATOM WITH RESPECT TO A
C  BPD    PARTIAL DERIVATIVES FOR  EACH ATOM WITH RESPECT TO B
C  FO     SCALED FO
C  FC     FC ON ABSOLUTE SCALE
C  P      PHASE ANGLE IN RADIANS
C  W      SQUARE ROOT OF THE WEIGHT FOR THIS RELFECTION
C  DF     DIFFERENCE BETWEEN FO AND FC
C  WDF    WEIGHTED DIFFERENCE BETWEEN FO AND FC
C  FOT    SUM OF FO
C  FCT    SUM OF FC
C  DFT    SUM OF MOD(DF)
C  AMINF  MINIMIZATION FUNCTION - SUM WEIGHTED DIFFERENCE SQUARED
C  WDFT   MINIMISATION FUNCTION BASED ONLY ON /FO/.
C  RW     HAMILTON WEIGHTED R VALUE
C  R      NORMAL WEIGHTED R VALUE
C  COSP   COSINE OF THE PHASE ANGLE
C  SINP   SINE OF THE PHASE ANGLE
C  EXT    EXTINCTION PARAMETER (R*)  -  SEE LARSON IN C.C. 1970.
C  LAYER  THE INDEX OF THE CURRENT LAYER AS REQUIRED BY THE LAYER SCALES
C  IBATCH  THE BATCH OF THE CURRENT REFLECTION MINUS ONE.
C  FCEXT  FC CORRECTED FOR EXTINCTION EFFECTS.
C  FCEXS  FCEXT CORRECTED FOR THE SCALE FACTOR
C  EXT1   (1 + 2*(R*)* /FC/ **2*DELTA)
C  EXT2   (1 + (R*)* /FC/ **2*DELTA)
C  EXT3   EXT1/EXT2
C  WAVE   THE WAVELENGTH OF THE RADIATION USED TO COLLECT THE DATA
C  THETA1 THE MONOCHROMATOR BRAGG ANGLE
C  THETA2 THE ANGLE BETWEEN THE MONOCHROMATOR AND THE DIFFRACTING PLANES
C  POL1   FIRST PART OF THE POLARISATION CORRECTION
C  POL2   THE SECOND PART OF THE POLARISATION CORRECTION
C  DEL    THE FIXED PART OF DELTA
C  DELTA  THE EXTINCTION MULTILPLIER  -  SEE LARSON.
C
C  PH, PK AND PL ARE A DUMP OF THE NOMINAL INDICES FOR A TWIN.
C
C  SH, SK AND SL ARE THE INDICES OF A TWINNED REFLECTION IN THE
C        STANDARD SETTING.
C
C--THE VARIOUS SCALE FACTORS USED ARE :
C
C  SCALEO  THE OVERALL SCALE FACTOR FROM LIST 5.
C          'SCALEO' IS ASSUMED NOT TO BE ZERO.
C  SCALEL  THE LAYER SCALE FACTOR FOR THE CURRENT LAYER  -  THIS
C          SCALE MAY BE ZERO IF REQUIRED.
C  SCALEB  THE BATCH SCALE FACTOR FOR THE CURRENT REFLECTION  -  THIS
C          SCALE MAY BE ZERO IF REQUIRED.
C  SCALES  THE SCALE FACTOR TO BE USED WHEN STORING /FC/.
C          THIS EQUALS SCALEL*SCALEB, SINCE 'SCALEO' IS NOT APPLIED TO /
C  SCALEG  THE COMBINED /FC/ SCALE FACTOR (=SCALEO*SCALEL*SCALEB).
C          'SCALEG' WILL BE ZERO IF 'SCALEL' OR 'SCALEB' IS ZERO.
C  SCALEK  THE OVERALL /FO/ SCALE FACTOR (=1.0/SCALEG, UNLESS
C          'SCALEG' IS ZERO, WHEN 'SCALEK' IS SET TO 1.0).
C  SCALEW  SCALEG*W
C
C--IF 'SCALEL' IS ZERO, ITS DERIVATIVE IS CALCULATED CORRECTLY,
C  BUT ALL OTHER DERIVATIVES FOR THAT REFLECTION WILL BE ZERO.
C
C
C--ALL DERIVATIVES ARE INTIALLY COMPUTED ON THE SCALE OF /FC/, AND THEN
C  ON THE CORRECT SCALE (THAT OF /FO/) WHEN THE A AND B PARTS ARE ADDED
C  TOGETHER AND THE WEIGHTS APPLIED.
C
C--THE DERIVATIVES FOR THE OVERALL SCALE FACTORS ARE COMPUTED SEPARATELY
C  OTHER OVERALL PARAMETERS.
C
C----- PARTIAL DERIVATIVE RELATIONSHIPS
C
C      FTSQ  = (1-X)*FP**2 + X*FN**2
C      where FPSQ is for the given index, and FNSQ for its Friedel inver
C
C      dFTSQ = 2*FP*(1-X)*dFP + 2*FN*X*dFN
C
C      dFT   = (FP/FT)*(1-X)*dFP   +    (FN/FT)*dFN
C
C            COSA := (1-X)*FP/FT,       SINA := X*FN/FT
C
C      FPSQ  = Q**2 + S**2,             FNSQ = QN**2 + SN**2
C
C      dFP   = (Q/FP)*dQ + (S/FP)*dS,   dFN   = (QN/FN)*dQN + (SN/FN)*dS
C
C           COSP := Q/FP, SINP := S/FP, COSPN := QN/FN, SINPN := SN/FN
C
C            Q = A-D, S = B+C,          QN = A+D, SN = -B+C
C
C            AC := A, ACI := -D, BC := B, BCI = C
C
C            ACT := Q, BCT := S,        ACN := QN, BCN := SN
C
C      dQ/dp = dA/dp - dD/dp,           dQN/dp =  dA/dp + dD/dp
C      dS/dp = dB/dp + dC/dp,           dSN/dp = -dB/dp + dC/dp
C
C
C--
C----- NOTE THAT IF STR11 IS USED DOUBLE PRECISION, LENGRP IN
C      LIST11 IN COMMAND FILE MUST BE CHANGED FROM 1 TO 2
C      FOR LHS AND RHS
C      AND I11LEN IN XPRC12
C      DOUBLE PRECISION STR11(1048576)
      DIMENSION STR11(1048576)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDATF/NFLD,LFLD,NULD
C      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDATD/XSTR11(1048576)
C
C
      COMMON /XSFWK/SCALE,R,RW,FOT,FCT,DFT,WDFT,AMINF,SFO,SFC,AP,BP,AT,
     2 BT,AC,BC,ACI,BCI,ACT,BCT,FO,FC,P,W,DF,WDF,TC,T,FOCC,TFOCC,SST,
     3 ST,A,C,S,COSP,SINP,LAYER,IBATCH,EXT,EXT1,EXT2,EXT3,FCEXT,FCEXS,
     4 PH,PK,PL,SH,SK,SL,WAVE,THETA1,THETA2,POL1,POL2,DEL,DELTA,D,B,
     5 ACONV,SCALEO,SCALEL,SCALEB,SCALES,SCALEK,SCALEG,SCALEW,PSHIFT,
     6 FRIED
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST11/L11,M11,MD11,N11,L11R,M11R,MD11R,N11R,
     2 L11P,M11P,MD11P,N11P,L11IR,M11IR,MD11IR,N11IR
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XLST25/L25,M25,MD25,N25,L25I,M25I,MD25I,N25I
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (STR11(1),XSTR11(1))
C
C
      EQUIVALENCE (JU,UJ),(JV,VJ),(JW,WJ),(JX,XJ)
C
C
C
      DATA S0/1.570795134/
      DATA S1/-.645925832/
      DATA S2/.079500304/
      DATA S3/-.004370784/
      DATA C0/.999993249/
      DATA C1/-1.233483666/
      DATA C2/.252578000/
      DATA C3/-.019094240/
C
C----- SET PRINT COUNTER
      IENPRT = -1
C----- SET BAD R FACTOR COUNTER
      IBADR = -1
C--INITIALISE THE TIMING FUNCTION
      ACONV=1./TWOPI
      JD=-IC
      D=180.0/PI
      JC=0
C--CHECK IF THIS STRUCTURE IS CENTRO
      IF(JD)1000,1100,1100
C--CHECK IF WE ARE DOING REFINEMENT
1000  CONTINUE
      IF(JB)1050,1100,1100
C--CENTRO WITH NO REFINEMENT  -  ONLY COS TERMS NEEDED
1050  CONTINUE
      JC=-1
C--CLEAR THE VARIABLES FOR HOLDING THE OVERALL TOTALS
1100  CONTINUE
      DD=1.0/TWOPI
C----- GET THE OLD R FACTOR AND SET PRINT RATIO
      R = STORE(L6P+1) * .01 *3.
      RW=0.0
      FOT=0.0
      FCT=0.0
      DFT=0.0
      WDFT=0.0
      AMINF=0.
      SFO=0.0
      SFC=0.0
      NT=0
      ACE=0.
      ACF = 0.
C----- OVERALL SCALE
      SCALEO=STORE(L5O)
C----- ENANTIOPOLE PARAMETER
      ENANT = STORE(L5O+4)
      CENANT  =  (1.- ENANT)
C----- POLARITY PARAMETER
      ANOM = STORE(L5O+3)
C--SET UP THE EXTINCTION VARIABLE
      EXT=0.
      EXT1=1.0
      EXT2=1.0
      EXT3=1.0
      DELTA=0.
C--CHECK IF THE EXTINCTION PARAMETER IN LIST 5 SHOULD BE USED
      IF(NA)1250,1150,1150
1150  CONTINUE
      EXT=STORE(L5O+5)
      POL1=1.
      POL2=0.
      DEL=WAVE*WAVE/(STORE(L1P1+6)*STORE(L1P1+6))
C--CHECK IF WE ARE USING NEUTRONS OR XRAYS
      IF(NU)1200,1250,1250
C--WE ARE USING XRAYS
1200  CONTINUE
      DEL=DEL*WAVE*0.0794
C--SET UP THE POLARISATION CONSTANTS
      THETA2=THETA2/D
      A=COS(THETA2)
      C=SIN(THETA2)
      S=COS(THETA1/D)
      A=A*A
      C=C*C
      S=S*S
      POL1=A+C*S
1250  CONTINUE
      POL2=C+A*S
C--CHECK IF WE ARE DOING REFINEMENT IN THIS CALCULATION
      IF(JB)1650,1300,1300
C--REFINEMENT  -  SET UP CONSTANTS FOR PARTIAL DERIVATIVE ACCUMULATION
1300  CONTINUE
      IF(JD)1350,1400,1400
C--CENTRO, CHECK IF ANOMALOUS DISPERSION IS PRESENT
1350  CONTINUE
      IF(JE)1450,1500,1500
C--NON-CENTRO, CHECK IF ANOMALOUS DISPERSION IS PRESENT
1400  CONTINUE
      IF(JE)1550,1600,1600
C--CENTRO WITH NO ANOMALOUS DISPERSION
1450  CONTINUE
      ASSIGN 9750 TO IN1
      ASSIGN 10150 TO IN2
      ASSIGN 11450 TO IN3
      GOTO 1650
C--CENTRO WITH ANOMALOUS DISPERSION
1500  CONTINUE
      ASSIGN 9850 TO IN1
      ASSIGN 10250 TO IN2
      ASSIGN 11600 TO IN3
      GOTO 1650
C--NON-CENTRO WITHOUT ANOMALOUS DISPERSION
1550  CONTINUE
      ASSIGN 9950 TO IN1
      ASSIGN 10350 TO IN2
      ASSIGN 11550 TO IN3
      GOTO 1650
C--NON-CENTRO WITH ANOMALOUS DISPERSION
1600  CONTINUE
      ASSIGN 10050 TO IN1
      ASSIGN 10450 TO IN2
      ASSIGN 11700 TO IN3
C--CHECK IF A PRINT IS REQUIRED
1650  CONTINUE
      IF(JG)1800,1700,1700
1700  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1750)
      ENDIF
1750  FORMAT(///7X,1HH,5X,1HK,5X,1HL,6X,4H/FO/,5X,4H/FC/,4X,5HPhase,5X,
     2 22HDelta    SQRT(W)*Delta,2X,5H/FC'/,2X,6H/FC''/,2X,8HD/F/ **2,
     3 1X,9HT.B.R.(%),2X,7HSINTH/L/)
      JG=58
1800  CONTINUE
      NO=JO
      NP=JP
      GOTO 5800
C
C--START OF THE LOOP OVER REFLECTIONS
C
C--UPDATE THE REFLECTION COUNTER FLAG
1850  CONTINUE
      NT=NT+1
C--SET THE LAYER SCALING CONSTANTS INITIALLY
      LAYER=-1
      SCALEL=1.0
C--CHECK IF THIS SCALE IS TO BE USED
      IF(NE)1950,1900,1900
C--FIND THE LAYER NUMBER AND SET ITS VALUE
1900  CONTINUE
      LAYER=KLAYER(I)-1
      IF ( IERFLG .LT. 0 ) GO TO 19900
      M5LS=L5LS+LAYER
      SCALEL=STORE(M5LS)
C--SET THE INITIAL VALUES FOR THE BATCH SCALE FACTOR
1950  CONTINUE
      IBATCH=-1
      SCALEB=1.
C--CHECK IF THE BATCH SCALE FACTOR SHOULD BE USED
      IF(NW)2050,2000,2000
C--FIND THE BATCH NUMBER AND SET THE SCALE
2000  CONTINUE
      IBATCH=KBATCH(I)-1
      IF ( IERFLG .LT. 0 ) GO TO 19900
      M5BS=L5BS+IBATCH
      SCALEB=STORE(M5BS)
C--SET UP THE SCALE FACTORS CORRECTLY
2050  CONTINUE
      SCALEK=1.
      SCALES=SCALEL*SCALEB
      SCALEG=SCALEO*SCALES
C--CHECK IF THE SCALE IS ZERO
      IF(SCALEG-0.000001)2150,2150,2100
C--THE /FC/ SCALE FACTOR IS NOT ZERO  -  COMPUTE THE /FO/ SCALE FACTOR
2100  CONTINUE
      SCALEK=1./SCALEG
C--CLEAR THE PARTIAL CONTRIBUTION FLAGS FOR THIS REFLECTION
2150  CONTINUE
      ACT=0.0
      BCT=0.0
      ACN = 0.
      BCN = 0.
C--CHECK IF THE PARTIAL CONTRIBUTIONS ARE TO BE ADDED IN
      IF(NC)2250,2200,2200
2200  CONTINUE
      ACT=STORE(M6+7)
      BCT=STORE(M6+8)
      ACN = ACT
      BCN = BCT
C--SET UP /FO/ ETC. FOR THIS REFLECTION
2250  CONTINUE
      FO=STORE(M6+3)
      W=STORE(M6+4)
      SCALEW=SCALEG*W
C--INITIALISE THE HOLDING STACK DUMP ENTRIES
      NM=0
      NN=0
      JO=NO
      JP=NP
C--CHECK IF THIS IS TWINNED CALCULATION
      IF(NB)2300,2400,2400
C
C--CALCULATION WITHOUT TWINNING  -  BRANCH TO THE S.F. ROUTINES
2300  CONTINUE
      NL=0
      ASSIGN 2350 TO ICONT
      GOTO 6300
C--DERIVE THE TOTALS AGAINST /FC/ FROM THOSE W.R.T. A AND B
2350  CONTINUE
      NH=ISTORE(NG)
      ASSIGN 4000 TO ICONT
      GOTO 11050
C
C--THIS IS A TWINNED CALCULATION  -  PRESERVE THE NOMINAL INDICES
2400  CONTINUE
      PH=STORE(M6)
      PK=STORE(M6+1)
      PL=STORE(M6+2)
      NJ=NINT(STORE(M6+11))
C--FIND THE ELEMENT FOR WHICH THE INDICES ARE GIVEN
      NK=NJ
2450  CONTINUE
      NL=NK
      NK=NK/10
      JX=NL-NK*10
C--CHECK THAT THIS IS A VALID ELEMENT NUMBER
      IF ( JX .LE. 0 ) GO TO 19910
      IF ( JX .GT. N25 ) GO TO 19910
C--CHECK IF 'NL' HOLDS THE ELEMENT NUMBER OF THE GIVEN INDICES.
      IF(NK)2700,2700,2450
C--COMPUTE THE INDICES IN THE STANDARD REFERENCE SYSTEM
2700  CONTINUE
      M25I=L25I+(NL-1)*MD25I
      SH=STORE(M25I)*PH+STORE(M25I+1)*PK+STORE(M25I+2)*PL
      SK=STORE(M25I+3)*PH+STORE(M25I+4)*PK+STORE(M25I+5)*PL
      SL=STORE(M25I+6)*PH+STORE(M25I+7)*PK+STORE(M25I+8)*PL
C--RESET THE FLAGS FOR THIS GROUP OF TWIN ELEMENTS
      NK=NJ
C--CHECK IF THERE ARE ANY MORE ELEMENTS TO PROCESS
2750  CONTINUE
      IF(NK)3000,3000,2800
C--FETCH THE NEXT ELEMENT
2800  CONTINUE
      JX=NK
      NK=NK/10
      NL=JX-NK*10
C--COMPUTE THE INDICES FOR THIS COMPONENT
      M25=L25+(NL-1)*MD25
      STORE(M6)=STORE(M25)*SH+STORE(M25+1)*SK+STORE(M25+2)*SL
      STORE(M6+1)=STORE(M25+3)*SH+STORE(M25+4)*SK+STORE(M25+5)*SL
      STORE(M6+2)=STORE(M25+6)*SH+STORE(M25+7)*SK+STORE(M25+8)*SL
C--CHECK THAT WE HAVE NOT USED TOO MANY ELEMENTS
      IF ( NM .GE. N25 ) GO TO 19920
C--THIS ELEMENT IS OKAY  -  ENTER THE S.F.L.S MAIN LOOP
      ASSIGN 2750 TO ICONT
      GOTO 6300
C
C--END OF THIS TWINNED REFLECTION  -  WIND UP AND CALCULATE THE TOTAL VA
3000  CONTINUE
      FCEXT=0.
C--CALCULATE /FC/ AND ITS DERIVATIVES FOR EACH ELEMENT
      NH=NG
      NQ=NM
      GOTO 3450
C--ACCESS THE NEXT ELEMENT IN THE STACK
3050  CONTINUE
      NH=ISTORE(NH)
C--COMPUTE THE TOTALS AGAINST /FC/ FOR THIS ELEMENT
      ASSIGN 3100 TO ICONT
C--CLEAR THE PARTIAL CONTRIBUTIONS
      ACT=0.
      BCT=0.
C--SET THE POINTER FOR THE DERIVATIVES WITH RESPECT TO /FC/
      JO=ISTORE(NH+1)
      JP=ISTORE(NH+2)
      GOTO 11050
C--ACCUMULATE /FCT/
3100  CONTINUE
      NI=ISTORE(NH+8)
      ISTORE(NH+8)=ISTORE(NH+8)-1
      JU=L5ES+ISTORE(NH+8)
      JV=M5ES+ISTORE(NH+8)
      FCEXT=FCEXT+STORE(JU)*STORE(NH+6)*STORE(NH+6)
C--CHECK IF WE MUST PRINT THIS CONTRIBUTOR
      IF(NF)3400,3150,3200
C--CHECK IF THERE IS MORE THAN ONE CONTRIBUTOR
3150  CONTINUE
      IF(NM-1)3400,3400,3200
C--CHECK IF THIS IS THE FIRST CONTRIBUTOR
3200  CONTINUE
      IF(NQ-NM)3300,3250,3300
3250  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3350)
      ENDIF
C--PRINT THIS CONTRIBUTOR
3300  CONTINUE
      JS=NH+3
      A=STORE(NH+7)*D
      C=STORE(NH+6)*STORE(JV)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3350)(STORE(JT+3),JT=NH,JS),A,C,NI
      ENDIF
3350  FORMAT(3X,3F6.0,9X,2F9.1,22X,F12.1,I4)
C--UPDATE THE NUMBER OF ELEMENTS LEFT TO PROCESS
3400  CONTINUE
      NQ=NQ-1
C--CHECK IF THERE ARE ANY MORE ELEMENTS TO PROCESS
3450  CONTINUE
      IF(NQ)3500,3500,3050
C--COMPUTE THE OVERALL /FCT/ VALUE
3500  CONTINUE
      FC=SQRT(FCEXT)
      JO=NO
      JP=NP
C--CHECK WHICH TYPE OF /FO/ AND /FC/ WE ARE TO OUTPUT
      IF(NB)3550,3550,3600
C--OUTPUT THE TOTAL OVER ALL ELEMENTS
3550  CONTINUE
      STORE(M6+3)=STORE(M6+10)
      STORE(M6+5)=FC
      STORE(M6+6)=0.
      GOTO 3650
C--OUTPUT THE VALUES FOR THE GIVEN INDICES AND ELEMENT
3600  CONTINUE
      NH=ISTORE(NG)
      JV=ISTORE(NH+8)+M5ES
      STORE(M6+3)=STORE(M6+10)*STORE(NH+6)*STORE(JV)/FC
      STORE(M6+5)=STORE(NH+6)*STORE(JV)
      STORE(M6+6)=STORE(NH+7)
C--CALCULATE SOME NEEDED VALUES
3650  CONTINUE
      FO=STORE(M6+10)
      STORE(M6+5)=STORE(M6+5)*SCALES
      P=0.
C--ACCUMULATE THE /FO/ TOTALS
      CALL XACRT(4)
C--CHECK IF WE ARE DOING REFINEMENT
      IF(JB)4000,3700,3700
C--CALCULATE THE NECESSARY P.D.'S WITH RESPECT TO /FCT/.
3700  CONTINUE
      DO 3750 JV=JO,JP
      STORE(JV)=0.
3750  CONTINUE
C--PASS AMONGST THE VARIOUS CONTRIBUTORS
      NH=NG
      DO 3850 JU=1,NM
C--FIND THE ADDRESS OF THIS CONTRIBUTOR
      NH=ISTORE(NH)
      JV=ISTORE(NH+8)+L5ES
      A=STORE(NH+6)*STORE(JV)/FC
      JS=ISTORE(NH+1)
C--ADD IN THE DERIVATIVES
      N = JP - JO
&CYBCVD$L NODEPCHK
      DO 3800 J = 0, N
      STORE(JO+J) = STORE(JO+J) + STORE(JS+J)*A
3800  CONTINUE
3850  CONTINUE
C--ADD IN THE CONTRIBUTIONS FOR THE ELEMENT SCALE FACTORS
      M12=L12ES
      ASSIGN 3900 TO IOVR
      NH=NG
      NI=NM
C--CHECK IF THERE ANY MORE SCALES TO PROCESS
3900  CONTINUE
      IF(NI)4000,4000,3950
C--FETCH THE INFORMATION FOR THE NEXT ELEMENT SCALE FACTOR
3950  CONTINUE
      NH=ISTORE(NH)
      JX=ISTORE(NH+8)
      A=0.5*SCALEW*STORE(NH+6)*STORE(NH+6)/FC
      NI=NI-1
      GOTO 11950
C
C--FINISH OFF THIS REFLECTION  -  COMPUTE THE OVERALL TOTALS
4000  CONTINUE
      FCEXT=FC
C--CHECK IF WE SHOULD INCLUDE EXTINCTION
      IF(NA)4200,4050,4050
C--WE SHOULD INCLUDE EXTINCTION
4050  CONTINUE
      A=AMIN1(1.,WAVE*ST)
      A=ASIN(A)*2.
C----- CHECK MEAN PATH LENGTH
      PATH=STORE(M6+9)
      IF(PATH-ZERO)4055,4055,4056
4055  CONTINUE
      PATH=1.0
4056  CONTINUE
C--COMPUTE DELTA FOR NEUTRONS
      DELTA=DEL*PATH/SIN(A)
C--CHECK IF WE ARE USING XRAYS
      IF(NU)4100,4150,4150
C--WE ARE USING XRAYS
4100  CONTINUE
      A=COS(A)
      A=A*A
      DELTA=DELTA*(POL1+POL2*A*A)/(POL1+POL2*A)
C--COMPUTE THE MODIFIED /FC/
4150  CONTINUE
      EXT1=1.+2.*EXT*FC*FC*DELTA
      FCEXT=FC*(EXT1**(-.25))
      EXT2=1.0+EXT*FC*FC*DELTA
      EXT3=EXT2/(EXT1**(1.25))
C
C--COMPUTE THE VALUE OF /FC/ AFTER THE SCALE FACTOR HAS BEEN APPLIED
4200  CONTINUE
      FCEXS=FCEXT*SCALEG
C--CHECK IF THIS IS A TWINNED STRUCTURE
      IF(NB)4250,4300,4300
C--STORE FC AND PHASE IN THE LIST 6 SLOTS
4250  CONTINUE
      STORE(M6+5)=FCEXT*SCALES
      STORE(M6+6)=P
C--CHECK IF THE PARTIAL CONTRIBUTIONS ARE TO BE OUTPUT
4300  CONTINUE
      IF(ND)4400,4350,4350
C--STORE THE NEW CONTRIBUTIONS
4350  CONTINUE
      STORE(M6+7)=ACT
      STORE(M6+8)=BCT
C--ACCUMULATE THE TOTALS FOR THE NEW PARTS
      CALL XACRT(8)
      CALL XACRT(9)
C--ADD IN THE COMPUTED VALUES OF /FC/ ETC., TO THE OVERALL TOTALS
4400  CONTINUE
      A=W*FO
      S=SCALEK
      DF=FO-FCEXS
      WDF=W*DF
      FOT=FOT+FO
      FCT=FCT+FCEXS
      DFT=DFT+ABS(DF)
C--CHECK IF WE REFINING AGAINST /FO/ **2
      IF(NV)4500,4450,4450
C--COMPUTE W-DELTA FOR /FO/ **2 REFINEMENT
4450  CONTINUE
      A=FO*FO
      DF=A-FCEXS*FCEXS
      WDF=W*DF
      A=W*A
      S=SCALEK*SCALEK
C--COMPUTE THE MINIMISATION FUNCTION
4500  CONTINUE
      AMINF=AMINF+WDF*WDF
C--COMPUTE THE TERMS FOR THE WEIGHTED R-VALUE
      WDFT=WDFT+WDF*WDF
      RW=RW+A*A
C--CHECK IF A PRINT OF THE RELFECTIONS IS NEEDED
      IF(JG)4650,4550,4550
C--REFLECTION PRINT ROUTINES
4550  CONTINUE
      P=P*D
      UJ=FO*SCALEK
      VJ=WDF*S
      WJ=DF*S
      A=SQRT(AC*AC+BC*BC)
      S=SQRT(ACI*ACI+BCI*BCI)
      T=4.*(BC*BCI+AC*ACI)
      C=T*200.0/(2.*FC*FC-T)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4600)STORE(M6),STORE(M6+1),STORE(M6+2),UJ,FCEXT,P,WJ,
     2 VJ,A,S,T,C,ST
      ENDIF
4600  FORMAT(3X,3F6.0,3F9.1,E13.4,E13.4,F8.1,F8.1,F9.1,F10.1,F10.5)
      GOTO 4660
C--CHECK IF WE ARE DOING REFINEMENT
4650  CONTINUE
      UJ = FO*SCALEK
      IF ( ABS(UJ-FCEXT) .GE. R*UJ .AND. IBADR .LE. 50 ) THEN
      IF (IBADR .LT. 0) THEN
      IF (ISSPRT .EQ. 0) THEN
            WRITE(NCWU,4651)
      ENDIF
            IBADR = 0
4651        FORMAT(10X,' Bad agreements ',/
     1      /1X,'   h    k    l      Fo        Fc '/)
      ELSE IF (IBADR .LT. 25) THEN
      IF (ISSPRT .EQ. 0) THEN
            WRITE(NCWU,4652)STORE(M6),STORE(M6+1),STORE(M6+2),UJ,FCEXT
      ENDIF
4652        FORMAT(1X,3F5.0,2F9.2)
      ELSE IF (IBADR .EQ. 25) THEN
      IF (ISSPRT .EQ. 0) THEN
            WRITE(NCWU,4653)
      ENDIF
4653        FORMAT(/' And so on ------------'/)
      ENDIF
      IBADR = IBADR + 1
      ENDIF
4660  CONTINUE
      IF(JB)4700,4750,4750
C--NO REFINEMENT  -  CHECK IF WE ARE REFINING ONLY THE SCALE FACTOR
4700  CONTINUE
      IF(JH)5750,5600,5600
C
C--ADD THE CONTRIBUTIONS OF THE OVERALL PARAMETERS AND SCALE FACTORS.
C  THESE ARE COMPUTED WITH RESPECT TO 'FC' MODIFIED FOR EXTINCTION, RATH
C  THAN WITH RESPECT TO 'FC'. THIS IS WHY THEY ALL CONTAIN '1./EXT3'
C  TERM WHICH IS REMOVED LATER WHEN THE DERIVATIVES ARE MODIFIED FOR
C  EXTINCTION. THE FIRST PARAMETER IS THE OVERALL SCALE FACTOR.
4750  CONTINUE
      A=W*FCEXT*SCALES/EXT3
      JX=0
      M12=L12O
      ASSIGN 4800 TO IOVR
      GOTO 11950
C--OVERALL TEMPERATURE FACTORS NEXT
4800  CONTINUE
      JX=1
      A=W*FCEXS*TC/EXT3
      ASSIGN 4850 TO IOVR
      GOTO 11950
4850  CONTINUE
      JX=2
      ASSIGN 4855 TO IOVR
      GOTO 11950
4855  CONTINUE
C----- THE POLARITY PARAMETER
      JX=3
      A = ACF
      ASSIGN 4900 TO IOVR
      GOTO 11950
4900  CONTINUE
C--- THE ENANTIOPOLE PARAMETER - HOWARD FLACK ACTA 1983,A39,876
      JX = 4
      A = ACE
      ASSIGN 4920 TO IOVR
      GOTO 11950
4920  CONTINUE
C--NOW THE EXTINCTION PARAMETER DERIVED BY LARSON
      JX=5
      A=-0.5*SCALEW*FC*FC*FC*DELTA/EXT2
      ASSIGN 4950 TO IOVR
      GOTO 11950
C--THE LAYER SCALES  -  CHECK IF LAYER SCALES ARE BEING USED
4950  CONTINUE
      IF(LAYER)5050,5000,5000
5000  CONTINUE
      A=W*SCALEO*SCALEB*FCEXT/EXT3
      JX=LAYER
      M12=L12LS
      ASSIGN 5050 TO IOVR
      GOTO 11950
C--THE BATCH SCALES  -  CHECK IF BATCH SCALES ARE BEING USED
5050  CONTINUE
      IF(IBATCH) 5150,5100,5100
5100  CONTINUE
      A=W*SCALEO*SCALEL*FCEXT/EXT3
      JX=IBATCH
      M12=L12BS
      ASSIGN 5150 TO IOVR
      GOTO 11950
C--BRANCH ON THE TYPE OF CALCULATION THAT WE ARE DOING
5150  CONTINUE
      A=1.0
C--CHECK IF WE ARE REFINING AGAINST /FO/ OR /FO/ **2
      IF(NV)5250,5300,5300
C--REFINEMENT AGAINST /FO/  -  CHECK IF WE ARE USING EXTINCTION CORRECTI
5250  CONTINUE
      IF(NA)5500,5350,5350
C--REFINEMENT AGAINST /FO/ **2  -  COMPUTE THE CORRECTION TERM
5300  CONTINUE
      A=2.0*FCEXS
C--CHECK IF WE SHOULD APPLY THE EXTINCTION CORRECTION
      IF(NA)5400,5350,5350
C--ADD IN THE EXTINCTION CORRECTION MODIFIER
5350  CONTINUE
      A=A*EXT3
C--MODIFY THE PARTIAL DERIVATIVES FOR EXTINCTION AND REFINEMENT AGAINST
5400  CONTINUE
      DO 5450 JX=JO,JP
      STORE(JX)=STORE(JX)*A
5450  CONTINUE
C--ACCUMULATE THE RIGHT HAND SIDES
5500  CONTINUE
      CALL XADRHS(WDF)
C--CHECK IF WE MUST ACCUMULATE THE LEFT HAND SIDES
      IF(JK)5550,5750,5750
C--ACCUMULATE THE LEFT HAND SIDES
5550  CONTINUE
      CALL XADLHS
      GOTO 5750
C--COMPUTE THE TOTALS FOR REFINEMENT OF THE SCALE FACTOR ONLY
5600  CONTINUE
      A=W*SCALES*FCEXT
C--CHECK IF WE ARE REFINING AGAINST /FO/ **2
      IF(NV)5700,5650,5650
C--REFINEMENT AGAINST /FO/ **2
5650  CONTINUE
      A=A*2.0*FCEXS
C--ACCUMULATE THE TERMS FOR THE SCALE FACTOR
5700  CONTINUE
      SFO=SFO+WDF*A
      SFC=SFC+A*A
C--STORE THE LAST REFLECTION ON THE DISC
5750  CONTINUE
      CALL XSLR(1)
C--ACCUMULATE TOTALS FOR /FC/ AND THE PHASE
      CALL XACRT(6)
      CALL XACRT(7)
      CALL XACRT(16)
C--PICK UP THE NEXT REFLECTION
5800  CONTINUE
      IF(KFNR(1))5850,1850,1850
C
C--END OF THE REFLECTIONS  -  PRINT THE R-VALUES ETC.
5850  CONTINUE
      IF (NT .LE. 0) THEN
      WRITE(NCAWU,5851)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,5851)
      ENDIF
5851  FORMAT(//,
     1 ' No reflections have been used for the Structure Factor',
     2 ' calculation'//)
      R = 0.
      A = 0.
      T = 0.
      RW = 0.
      S = 0.
      ELSE
      R=DFT/FOT*100.0
C----- PATCH TO AVOID INCIPIENT DIVISION BY ZERO
      IF(RW .LE. 0) GOTO 19930
      RW=SQRT(WDFT/RW)*100.0
      A=FOT/SCALEO
      S=FCT/SCALEO
      T=DFT/SCALEO
      ENDIF
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,5900)R,RW,A,S,T
      ENDIF
5900  FORMAT(/30X,3(1H*)/29X,3(1H*)/22H R-value    Weighted R,6X,
     2 12(1H*),14X,12(1H*)/27X,13(1H*),2X,10HHERE IT IS,2X,12(1H*)/
     3 F7.2,F12.2,9X,12(1H*),14X,12(1H*)/29X,3(1H*)/30X,3(1H*)//
     4 45H Sum of /FO/    Sum of /FC/    Sum of /Delta/,
     5 25H    Minimization function//F11.1,F15.1,F16.1,34X,
     6 17H On scale of /FC/)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,5950)FOT,FCT,DFT,AMINF
      ENDIF
5950  FORMAT(/F11.1,F15.1,F16.1,E25.8,9X,17H On scale of /FO/)
C--CHECK IF WE ARE TO CALCULATE A NEW SCALE FACTOR HERE
      IF(JH)6200,6000,6000
C--CALCULATE THE NEW SCALE FACTOR
6000  CONTINUE
      BC=0.
      IF(SFC-0.000001)6100,6100,6050
6050  CONTINUE
      BC=SFO/SFC
C--STORE THE SCALE AND PRINT IT
6100  CONTINUE
      STORE(L5O)=STORE(L5O)+BC
      SCALE=STORE(L5O)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,6150) STORE(L5O), NT
      ENDIF
6150  FORMAT(/,' New scale factor (G) is ',F10.5,
     1 /10X,I6,' reflections used in refinement')
6200  CONTINUE
      WRITE(NCAWU,6255)JI,R,RW,A,S,T,FOT,FCT,DFT,AMINF,STORE(L5O),NT
6255  FORMAT(40H Results of structure factor calculation ,I5,//,
     1 1X,7HR-value,1X,10HWeighted-R,2X,8HSum /FO/,2X,
     2 8HSum /FC/,3X,5HDelta,3X,12HMinimisation,/,
     3 52X,8Hfunction,/,
     4 1X,2F7.2,///20H  On scale of /FO/  ,2F10.0,F8.0,/,
     5 20H  On scale of /FC/  ,2F10.0,F8.0,F16.0,//,
     6 16H Scale factor is ,F10.4,',', 6X,I6,' reflections used')
      JX=IABS(JB)+IABS(JH)*2+(NB+1)*4
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,6250)JI,JX
      ENDIF
6250  FORMAT(///43H Structure factor least squares calculation,I5,
     2 6H  ends,I3)
      RETURN
C
C
C--MAIN S.F.L.S. LOOP  -  CALCULATES A AND B AND THEIR DERIVATIVES
C
C  ICONT  SET TO THE RETURN ADDRESS
C  NL     ELEMENT NUMBER OF THIS REFLECTION (MAY BE SET TO 0)
C
C--CLEAR OUT A FEW CONSTANTS
6300  CONTINUE
      ISTACK=-1
      AC=0.
      BC=0.
      ACI=0.
      BCI=0.
      ACD=0.
      BCD=0.
C--SEARCH FOR THIS REFLECTION IN THE REFLECTION HOLDING STACK
      NH=NG
      JX=NM
C--FETCH THE INFORMATION FOR THE NEXT REFLECTION IN THE STACK
6350  CONTINUE
      NI=ISTORE(NH)
C--LOOP OVER THE EQUIVALENT POSITIONS STORED
      JU=ISTORE(NI+9)
      JV=ISTORE(NI+10)
      DO 6450 JW=JU,JV,NR
      PSHIFT=STORE(JW+3)
      FRIED=1.0
C--CHECK THE GIVEN INDICES
      IF(ABS(STORE(M6)-STORE(JW))+ABS(STORE(M6+1)-STORE(JW+1))
     2 +ABS(STORE(M6+2)-STORE(JW+2))-0.5)6600,6400,6400
C--USE FRIEDEL'S LAW
6400  CONTINUE
      PSHIFT=-PSHIFT
      FRIED=-1.0
      IF(ABS(STORE(M6)+STORE(JW))+ABS(STORE(M6+1)+STORE(JW+1))
     2 +ABS(STORE(M6+2)+STORE(JW+2))-0.5)6600,6450,6450
6450  CONTINUE
C--NOT THIS EQUIVALENT  -  CHECK IF THERE ARE MORE IN THE STACK
      IF(ISTORE(NI))6550,6550,6500
C--SET UP THE FLAGS FOR THE NEXT REFLECTION IN THE STACK
6500  CONTINUE
      JX=JX-1
      NH=NI
      GOTO 6350
C--THIS IS THE END OF THE STACK  -  WE MUST DO A CALCULATION HERE
6550  CONTINUE
      ISTACK=0
      NN=NN+1
      PSHIFT=0.
      FRIED=1.0
      GOTO 7050
C--REFLECTION FOUND IN THE STACK  -  CHECK IF WE HAVE USED IT BEFORE
6600  CONTINUE
      JY=NI
      IF(JX)7050,7050,6650
C--WE NEED THIS REFLECTION TWICE  -  FIND THE END BLOCK
6650  CONTINUE
      IF(ISTORE(NI))6750,6750,6700
6700  CONTINUE
      NH=NI
      NI=ISTORE(NI)
      GOTO 6650
C--DUPLICATE THE ENTRY  -  TRANSFER A, B ETC.
6750  CONTINUE
      JU=NI
      JV=JY
      DO 6800 JW=1,4
      STORE(JU+3)=STORE(JV+3)
      STORE(JU+13)=STORE(JV+13)
      JU=JU+1
      JV=JV+1
6800  CONTINUE
C--CHECK IF WE ARE DOING REFINEMENT
      IF(JB)6950,6850,6850
C--TRANSFER THE P.D.'S
6850  CONTINUE
      JX=ISTORE(NI+18)
      JU=ISTORE(JY+18)
      JV=ISTORE(JY+19)
      N = JV - JU
&CYBCVD$L NODEPCHK
      DO 6900 J = 0, N
      STORE(JX+J) = STORE(JU+J)
6900  CONTINUE
C--TRANSFER THE EQUIVALENT INDICES
6950  CONTINUE
      JX=ISTORE(NI+9)
      JU=ISTORE(JY+9)
      JV=ISTORE(JY+10)
      DO 7000 JW=JU,JV,NR
      STORE(JX)=STORE(JW)
      STORE(JX+1)=STORE(JW+1)
      STORE(JX+2)=STORE(JW+2)
      STORE(JX+3)=STORE(JW+3)
      JX=JX+NR
7000  CONTINUE
C--SWITCH THE CURRENT BLOCK TO THE TOP OF THE STACK
7050  CONTINUE
      ISTORE(NH)=ISTORE(NI)
      ISTORE(NI)=ISTORE(NG)
      ISTORE(NG)=NI
C--SET UP THE CURRENT SET OF INDICES
      STORE(NI+3)=STORE(M6)
      STORE(NI+4)=STORE(M6+1)
      STORE(NI+5)=STORE(M6+2)
      ISTORE(NI+8)=NL
      STORE(NI+11)=PSHIFT
      STORE(NI+12)=FRIED
      NM=NM+1
C--CHECK IF WE MUST CALCULATE THIS REFLECTION
      IF(ISTACK)11000,7100,7100
C
C--CALCULATE THE INFORMATION FOR THE SYMMETRY POSITIONS
7100  CONTINUE
      M2=L2
      M2T=L2T
      DO 7250 JZ=1,N2
      STORE(M2T)=STORE(M6)*STORE(M2)+STORE(M6+1)*STORE(M2+3)
     2 +STORE(M6+2)*STORE(M2+6)
      STORE(M2T+1)=STORE(M6)*STORE(M2+1)+STORE(M6+1)*STORE(M2+4)
     2 +STORE(M6+2)*STORE(M2+7)
      STORE(M2T+2)=STORE(M6)*STORE(M2+2)+STORE(M6+1)*STORE(M2+5)
     2 +STORE(M6+2)*STORE(M2+8)
C--CALCULATE THE H.T TERMS
      STORE(M2T+3)=(STORE(M6)*STORE(M2+9)+STORE(M6+1)*STORE(M2+10)
     2 +STORE(M6+2)*STORE(M2+11))*TWOPI
C--CHECK IF THE ANSIO CONTRIBUTIONS ARE REQUIRED
      IF(JA-JZ)7200,7150,7150
7150  CONTINUE
      STORE(M2T+4)=STORE(M2T)*STORE(M2T)
      STORE(M2T+5)=STORE(M2T+1)*STORE(M2T+1)
      STORE(M2T+6)=STORE(M2T+2)*STORE(M2T+2)
      STORE(M2T+7)=STORE(M2T+1)*STORE(M2T+2)
      STORE(M2T+8)=STORE(M2T)*STORE(M2T+2)
      STORE(M2T+9)=STORE(M2T)*STORE(M2T+1)
7200  CONTINUE
      STORE(M2T)=STORE(M2T)*TWOPI
      STORE(M2T+1)=STORE(M2T+1)*TWOPI
      STORE(M2T+2)=STORE(M2T+2)*TWOPI
      M2=M2+MD2
      M2T=M2T+MD2T
7250  CONTINUE
C--CALCULATE SIN(THETA)/LAMBDA SQUARED
      SST=STORE(L1S)*STORE(L2T+4)+STORE(L1S+1)*STORE(L2T+5)
     2 +STORE(L1S+2)*STORE(L2T+6)+STORE(L1S+3)*STORE(L2T+7)
     3 +STORE(L1S+4)*STORE(L2T+8)+STORE(L1S+5)*STORE(L2T+9)
      ST=SQRT(SST)
C--CALCULATE THE TEMPERATURE FACTOR COEFFICIENT
      TC=-SST*TWOPIS*4.
C--CHECK IF THE ANISO TERMS ARE REQUIRED
      IF(JJ)7400,7300,7300
7300  CONTINUE
      M2T=L2T
      DO 7350 JZ=1,N2
      STORE(M2T+4)=STORE(M2T+4)*STORE(L1A)
      STORE(M2T+5)=STORE(M2T+5)*STORE(L1A+1)
      STORE(M2T+6)=STORE(M2T+6)*STORE(L1A+2)
      STORE(M2T+7)=STORE(M2T+7)*STORE(L1A+3)
      STORE(M2T+8)=STORE(M2T+8)*STORE(L1A+4)
      STORE(M2T+9)=STORE(M2T+9)*STORE(L1A+5)
      M2T=M2T+MD2T
7350  CONTINUE
7400  CONTINUE
C
C--CALCULATE THE FORM FACTORS
      CALL XSCATT(ST)
C--COMPUTE THE RATIO OF IMAGINARY TO REAL FORM FACTORS
      M3TR=L3TR
      M3TI=L3TI
      DO 7600 JZ=1,N3
      STORE(M3TR)=STORE(M3TR)*G2
      STORE(M3TI)=STORE(M3TI)*G2
C--CHECK IF THE REAL PART IS ZERO
      IF(STORE(M3TR)-ZERO)7450,7450,7500
C--REAL PART IS ZERO  -  SO IS THE IMAGINARY NOW
7450  CONTINUE
      STORE(M3TI)=0.
      GOTO 7550
C--REAL PART IS OKAY
7500  CONTINUE
      STORE(M3TI)=STORE(M3TI)/STORE(M3TR)
C--UPDATE THE POINTERS
7550  CONTINUE
      M3TR=M3TR+MD3TR
      M3TI=M3TI+MD3TI
7600  CONTINUE
C--CHECK IF WE ARE DOING REFINEMENT
      IF(JB)7900,7650,7650
C--CLEAR THE FINAL PARTIAL DERIVATIVE AREA TO ZERO
7650  CONTINUE
      DO 7700 JZ=JO,JP
      STORE(JZ)=0.
7700  CONTINUE
C--CLEAR THE TEMPORARY PARTIAL DERIVATIVE AREAS TO ZERO
      JS=JR
      N = N12*JQ
&CYBCVD$L NODEPCHK
      DO 7800 J = 0, N-1
      STORE(JS+J) = 0.0
7800  CONTINUE
C--CLEAR THE DUMMY LOCATIONS
      JS=JN
&CYBCVD$L NODEPCHK
      DO 7850 J= 0, JQ-1
      STORE(JS+J)=0.
7850  CONTINUE
C--SET THE ATOM POINTER IN LIST 12
      M12=L12
C--CHECK IF THERE ARE ANY ATOMS TO PROCESS
7900  CONTINUE
      IF(N5)10700,10700,7950
C
C--START OF THE LOOP BASED ON THE ATOMS
7950  CONTINUE
      M5A=L5
      DO 10650 JY=1,N5
C--CLEAR THE ACCUMULATION VARIABLES
      AT=0.
      BT=0.
      JF=JB
C--CHECK IF REFINEMENT IS BEING DONE
      IF(JB)8100,8000,8000
C--CLEAR PARTIAL DERIVATIVE STACKS
8000  CONTINUE
      CALL XZEROF ( APD(1),11 )
      CALL XZEROF ( BPD(1),11 )
      JF=ISTORE(M12+1)
      L12A=ISTORE(M12+1)
      M12=ISTORE(M12)
C--PICK UP THE FORM FACTORS FOR THIS ATOM
8100  CONTINUE
      M3TR=L3TR+ISTORE(M5A)
      M3TI=L3TI+ISTORE(M5A)
      FOCC = STORE(M3TR) * STORE(M5A+2) * STORE(M5A+13)
C--CHECK THE TEMPERAURE TYPE FOR THIS ATOM
      IF(ISTORE(M5A+1))8150,8200,8200
C--CALCULATE THE ISO-TEMPERATURE FACTOR COEFFICIENTS FOR THIS ATOM
8150  CONTINUE
      T=EXP(STORE(M5A+3)*TC)
      TFOCC=T*FOCC
C
C--LOOP CYCLING OVER THE DIFFERENT EQUIVALENT POSITIONS FOR THIS ATOM
8200  CONTINUE
      M2T=L2T
      DO 9300 JX=1,N2T
C--CALCULATE H'.X+H.T
      A=STORE(M5A+4)*STORE(M2T)+STORE(M5A+5)*STORE(M2T+1)+STORE(M5A+6)
     2 *STORE(M2T+2)+STORE(M2T+3)
C--CHECK THE TEMPERATURE FACTOR TYPE
      IF(ISTORE(M5A+1))8300,8250,8250
C--CALCULATE THE ANISO-TEMPERATURE FACTOR
8250  CONTINUE
      T=EXP(STORE(M5A+7)*STORE(M2T+4)+STORE(M5A+8)*STORE(M2T+5)
     2 +STORE(M5A+9)*STORE(M2T+6)+STORE(M5A+10)*STORE(M2T+7)
     3 +STORE(M5A+11)*STORE(M2T+8)+STORE(M5A+12)*STORE(M2T+9))
      TFOCC=T*FOCC
C--CALCULATE THE SIN/COS TERMS
8300  CONTINUE
      A=A*DD
      A=4.*(A-FLOAT(INT(A)))
      IF(A)8400,8350,8450
8350  CONTINUE
      S=0.
      C=1.
      GOTO 8850
8400  CONTINUE
      A=A+4.
8450  CONTINUE
      S=1.
      IF(A-2.)8600,8500,8550
8500  CONTINUE
      S=0.
      C=-1.
      GOTO 8850
8550  CONTINUE
      S=-1.
      A=A-2.
8600  CONTINUE
      C=S
      IF(A-1.)8750,8650,8700
8650  CONTINUE
      C=0.
      GOTO 8850
8700  CONTINUE
      C=-C
      A=2.-A
8750  CONTINUE
      B=A*A
      C=C*(C0+B*(C1+B*(C2+B*C3)))
      IF(JC)8900,8800,8800
8800  CONTINUE
      S=S*A*(S0+B*(S1+B*(S2+B*S3)))
8850  CONTINUE
C--CALCULATE THE B CONTRIBUTION
      BP=S*TFOCC
      BT=BT+BP
C--CALCULATE THE A CONTRIBUTION
8900  CONTINUE
      AP=C*TFOCC
      AT=AT+AP
C--CHECK IF ANY REFINEMENT IS BEING DONE
      IF(JF)9250,8950,8950
C--CALCULATE THE PARTIAL DERIVATIVES W.R.T. A FOR X,Y AND Z
8950  CONTINUE
      APD(1)=APD(1)+T*C
      APD(3)=APD(3)-STORE(M2T)*BP
      APD(4)=APD(4)-STORE(M2T+1)*BP
      APD(5)=APD(5)-STORE(M2T+2)*BP
C--CHECK THE TEMPERATURE FACTOR TYPE
      IF(ISTORE(M5A+1))9000,9050,9050
C--CALCULATE THE PARTIAL DERIVATIVES W.R.T. A FOR U[ISO]
9000  CONTINUE
      APD(2)=APD(2)+TC*AP
C--GOTO THE NEXT PART - DEPENDS ON WHETHER THE STRUCTURE IS CENTRO
      IF(JD)9250,9100,9100
C--CALCULATE THE PARTIAL DERIVATIVES W.R.T. A FOR THE ANISO-TERMS
9050  CONTINUE
      APD(6)=APD(6)+STORE(M2T+4)*AP
      APD(7)=APD(7)+STORE(M2T+5)*AP
      APD(8)=APD(8)+STORE(M2T+6)*AP
      APD(9)=APD(9)+STORE(M2T+7)*AP
      APD(10)=APD(10)+STORE(M2T+8)*AP
      APD(11)=APD(11)+STORE(M2T+9)*AP
C--GOTO NEXT PART - DEPENDS ON WHETHER THE STRUCTURE IS CENTRO
      IF(JD)9250,9100,9100
C--CALCULATE THE PARTIAL DERIVATIVES W.R.T. B FOR X,Y AND Z
9100  CONTINUE
      BPD(1)=BPD(1)+T*S
      BPD(3)=BPD(3)+STORE(M2T)*AP
      BPD(4)=BPD(4)+STORE(M2T+1)*AP
      BPD(5)=BPD(5)+STORE(M2T+2)*AP
C--CHECK THE TEMPERATURE FACTOR TYPE
      IF(ISTORE(M5A+1))9150,9200,9200
C--CALCULATE THE PARTIAL DERIVATIVES W.R.T. B FOR U[ISO]
9150  CONTINUE
      BPD(2)=BPD(2)+TC*BP
      GOTO 9250
C--CALCULATE THE PARTIAL DERIVATIVES W.R.T. B FOR THE ANISO-TERMS
9200  CONTINUE
      BPD(6)=BPD(6)+STORE(M2T+4)*BP
      BPD(7)=BPD(7)+STORE(M2T+5)*BP
      BPD(8)=BPD(8)+STORE(M2T+6)*BP
      BPD(9)=BPD(9)+STORE(M2T+7)*BP
      BPD(10)=BPD(10)+STORE(M2T+8)*BP
      BPD(11)=BPD(11)+STORE(M2T+9)*BP
C--UPDATE THE SYMMETRY INFORMATION POINTER
9250  CONTINUE
      M2T=M2T+MD2T
9300  CONTINUE
C
C--LOOP ON EQUIVALENT POSITIONS ENDS  -  COMPUTE THE TOTALS FOR THIS ATO
      AC=AC+AT
      BC=BC+BT
C--CHECK IF ANOMALOUS DISPERSION IS BEING CONSIDERED
      IF(JE)9400,9350,9350
C--CALCULATE THE IMAGINARY PARTS
9350  CONTINUE
      AIMAG=ANOM*STORE(M3TI)
      ACI=ACI-BT*AIMAG
      BCI=BCI+AT*AIMAG
C----- ANY REFINEMENT AT ALL?
      IF (JB) 9400,9360,9360
9360  CONTINUE
C----- DERIVATIVES FOR POLARITY PARAMETER
      ACD=ACD-BT*STORE(M3TI)
      BCD=BCD+AT*STORE(M3TI)
C--CHECK IF ANY REFINEMENT IS BEING DONE
9400  CONTINUE
      IF(JF)10600,9450,9450
C--CALCULATE THE PARTIAL DERIVATIVES W.R.T. A AND B FOR OCC
9450  CONTINUE
      APD(1) = STORE(M3TR) * STORE(M5A+13) * APD(1)
      BPD(1) = STORE(M3TR) * STORE(M5A+13) * BPD(1)
C
C--START OF THE LOOPS FOR ADDING THE PARTIAL DERIVATIVES INTO THE
C  TEMPORARY STACKS
9500  CONTINUE
      M12A=ISTORE(L12A+4)
C--SET UP THE CONDITIONS OF THIS ATOM
      MD12A=ISTORE(L12A+1)
      JU=ISTORE(L12A+2)
      JV=ISTORE(L12A+3)
C--CHECK ON WHETHER THE 'WEIGHTS' FOR THIS ATOM DIFFER FROM UNITY
      IF(MD12A-2)9650,9700,9700
C--WEIGHTS ARE UNITY
9650  CONTINUE
      GOTOIN1,(9750,9850,9950,10050)
C--WEIGHTS DIFFER FROM UNITY
9700  CONTINUE
      GOTOIN2,(10150,10250,10350,10450)
C--UNITY, CENTRO AND NO ANOMALOUS DISPERSION
9750  CONTINUE
      DO 9800 JW=JU,JV,MD12A
      JT=ISTORE(JW)
      STORE(JT)=STORE(JT)+APD(M12A-1)
      M12A=M12A+1
9800  CONTINUE
      GOTO 10550
C--UNITY, CENTRO AND ANOMALOUS DISPERSION
9850  CONTINUE
      DO 9900 JW=JU,JV,MD12A
      JT=ISTORE(JW)
      STORE(JT)=STORE(JT)+APD(M12A-1)
      STORE(JT+1)=STORE(JT+1)+APD(M12A-1)*AIMAG
      M12A=M12A+1
9900  CONTINUE
      GOTO 10550
C--UNITY, NON-CENTRO AND NO ANOMALOUS DISPERSION
9950  CONTINUE
      DO 10000 JW=JU,JV,MD12A
      JT=ISTORE(JW)
      STORE(JT)=STORE(JT)+APD(M12A-1)
      STORE(JT+1)=STORE(JT+1)+BPD(M12A-1)
      M12A=M12A+1
10000 CONTINUE
      GOTO 10550
C--UNITY, NON-CENTRO AND ANOMALOUS DISPERSION
10050 CONTINUE
      DO 10100 JW=JU,JV,MD12A
      JT=ISTORE(JW)
      STORE(JT)=STORE(JT)+APD(M12A-1)
      STORE(JT+3)=STORE(JT+3)+APD(M12A-1)*AIMAG
      STORE(JT+2)=STORE(JT+2)-BPD(M12A-1)*AIMAG
      STORE(JT+1)=STORE(JT+1)+BPD(M12A-1)
      M12A=M12A+1
10100 CONTINUE
      GOTO 10550
C--NON-UNITY, CENTRO AND NO ANOMALOUS DISPERSION
10150 CONTINUE
      DO 10200 JW=JU,JV,MD12A
      JT=ISTORE(JW)
      STORE(JT)=STORE(JT)+APD(M12A-1)*STORE(JW+1)
      M12A=M12A+1
10200 CONTINUE
      GOTO 10550
C--NON-UNITY, CENTRO AND ANOMALOUS DISPERSION
10250 CONTINUE
      DO 10300 JW=JU,JV,MD12A
      A=APD(M12A-1)*STORE(JW+1)
      JT=ISTORE(JW)
      STORE(JT)=STORE(JT)+A
      STORE(JT+1)=STORE(JT+1)+A*AIMAG
      M12A=M12A+1
10300 CONTINUE
      GOTO 10550
C--NON-UNITY, NON-CENTRO AND NO ANOMALOUS DISPERSION
10350 CONTINUE
      DO 10400 JW=JU,JV,MD12A
      JT=ISTORE(JW)
      STORE(JT)=STORE(JT)+APD(M12A-1)*STORE(JW+1)
      STORE(JT+1)=STORE(JT+1)+BPD(M12A-1)*STORE(JW+1)
      M12A=M12A+1
10400 CONTINUE
      GOTO 10550
C--NON-UNITY, NON-CENTRO AND ANOMALOUS DISPERSION
10450 CONTINUE
      DO 10500 JW=JU,JV,MD12A
      JT=ISTORE(JW)
      STORE(JT)=STORE(JT)+APD(M12A-1)*STORE(JW+1)
      A=STORE(JW+1)*AIMAG
      STORE(JT+3)=STORE(JT+3)+APD(M12A-1)*A
      STORE(JT+2)=STORE(JT+2)-BPD(M12A-1)*A
      STORE(JT+1)=STORE(JT+1)+BPD(M12A-1)*STORE(JW+1)
      M12A=M12A+1
10500 CONTINUE
C--END OF PART ACCUMULATION - PASS ONTO THE NEXT IF THERE IS ONE
10550 CONTINUE
      L12A=ISTORE(L12A)
      IF(L12A)10600,10600,9500
C--END OF ATOM CYCLING LOOP
10600 CONTINUE
      M5A=M5A+MD5A
10650 CONTINUE
C
C--END OF REFLECTION HOUSEKEEPING  -  CHECK IF THIS STRUCTURE IS CENTRO
10700 CONTINUE
      IF(JD)10750,10800,10800
C--THIS IS A CENTRO STRUCTURE
10750 CONTINUE
      BC=0.
      ACI=0.
C--STORE THE RESULTS OF THIS CALCULATION IN THE STACK
10800 CONTINUE
      STORE(NI+13)=AC
      STORE(NI+14)=ACI
      STORE(NI+15)=BC
      STORE(NI+16)=BCI
C--STORE THE EQUIVALENT INDICES AND THE PHASE SHIFT
      M2I=L2I
      JU=ISTORE(NI+9)
      JV=ISTORE(NI+10)
      DO 10850 JW=JU,JV,NR
      STORE(JW)=STORE(M6)*STORE(M2I)+STORE(M6+1)*STORE(M2I+3)
     2 +STORE(M6+2)*STORE(M2I+6)
      STORE(JW+1)=STORE(M6)*STORE(M2I+1)+STORE(M6+1)*STORE(M2I+4)
     2 +STORE(M6+2)*STORE(M2I+7)
      STORE(JW+2)=STORE(M6)*STORE(M2I+2)+STORE(M6+1)*STORE(M2I+5)
     2 +STORE(M6+2)*STORE(M2I+8)
      STORE(JW+3)=-(STORE(JW)*STORE(M2I+9)+STORE(JW+1)*STORE(M2I+10)
     2 +STORE(JW+2)*STORE(M2I+11))*TWOPI
      M2I=M2I+MD2I
10850 CONTINUE
C--CHECK IF WE ARE DOING REFINEMENT
      IF(JB)11000,10900,10900
C--TRANSFER THE P.D.'S TO THE STACK
10900 CONTINUE
      JU=ISTORE(NI+18)
      JV=ISTORE(NI+19)
      JS=JR
      DO 10950 JW=JU,JV
      STORE(JW)=STORE(JS)
      JS=JS+1
10950 CONTINUE
C--BRANCH ON THE TYPE OF CALCULATION TO RETURN
11000 CONTINUE
      GOTOICONT,(2750,2350)
C
C
C--CONVERSION OF THE A AND B PARTS INTO /FC/ TERMS
C
C  ICONT  SET TO THE RETURN ADDRESS
C  JO     ADDRESS OF THE AREA FOR THE OUTPUT DERIVATIVES W.R.T. /FC/
C  JP     LAST WORD OF THE ABOVE AREA
C  NH     ADDRESS OF THIS REFLECTION IN THE STACK
C
C--FETCH A AND B ETC. FROM THE STACK
11050 CONTINUE
      AC=STORE(NH+13)
      ACI=STORE(NH+14)
      BC=STORE(NH+15)
      BCI=STORE(NH+16)
      PSHIFT=STORE(NH+11)
      FRIED=STORE(NH+12)
      ACT=AC+ACI*FRIED+ACT
      BCT=BC*FRIED+BCI+BCT
C--CHECK THE MAGNITUDE OF THE A PART
      IF(ABS(ACT)-0.001)11100,11250,11250
C--A IS ZERO, CHECK THE B PART
11100 CONTINUE
      IF(ABS(BCT)-0.001)11150,11300,11300
C--BOTH THE A AND B PARTS ARE ZERO
11150 CONTINUE
      ACT=0.000001
C--SET THE B PART TO ZERO
11200 CONTINUE
      BCT=0.
      GOTO 11350
C--A PART IS NOT ZERO  -  CHECK THE B PART
11250 CONTINUE
      IF(ABS(BCT)-0.001)11200,11350,11350
C--THE A PART IS ZERO, BUT NOT THE  BPART
11300 CONTINUE
      ACT=0.
C--COMPUTE /FC/ AND THE PHASE
11350 CONTINUE
C----- FOR THE GIVEN ENANTIOMER
      FCSQ = ACT*ACT + BCT*BCT
      FP = SQRT(FCSQ)
C------ SAVE THE TOTAL MAGNITUDE
      FC = FP
      P=AMOD(ATAN2(BCT,ACT)+PSHIFT,TWOPI)
      IF (JL) 11399,11360,11360
11360  CONTINUE
      ACN = ACN+AC-ACI*FRIED
      BCN = BCN+BCI-BC*FRIED
      IF (ABS(ACN) - .001) 11365,11365 ,11380
11365 CONTINUE
      IF (ABS(BCN) - .001) 11370,11370,11385
11370 CONTINUE
C----- BOTH PARTS ALMOST ZERO
      ACN = .000001
C----- SET B PART TO ZERO
11375 CONTINUE
      BCN = 0.0
      GOTO 11390
11380 CONTINUE
      IF(ABS(BCN) - .001) 11375,11375, 11390
11385 CONTINUE
      ACN = 0.0
11390 CONTINUE
      FNSQ = ACN*ACN + BCN*BCN
      FN = SQRT (FNSQ)
C----- DELTA .GE. 5PC AVERAGE
      IF ( ABS(FN-FP) .GE. .05*.5*(FN+FP) .AND. IENPRT .LE. 100 ) THEN
      IF (IENPRT .LT. 0) THEN
      IF (ISSPRT .EQ. 0) THEN
            WRITE(NCWU,11388)
      ENDIF
            IENPRT = 0
11388    FORMAT(35X,'Enantiomer sensitive reflections',/
     1          35X,' Delta(Fc) GT 5% Average(Fc)',/
     2         /35X,'   h    k    l      Fc+          Fo     Fc-'/)
      ENDIF
      FOZ = FO * SCALEK
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,11389) STORE(M6),STORE(M6+1),STORE(M6+2),FP,FOZ,FN
      ENDIF
      IENPRT = IENPRT +1
11389 FORMAT(35X,3F5.0,3F9.2)
      ENDIF
      PN = AMOD(ATAN2(BCN,ACN)+PSHIFT,TWOPI)
      FESQ = FCSQ * CENANT + ENANT*FNSQ
      IF (FESQ - .00001) 11391,11391,11392
11391 CONTINUE
      FESQ = .00001
11392 CONTINUE
C----- THE COMPOSITE AMPLITUDE IS A SCALAR SUM.
C----- THE PHASE HAS NO REAL MEANING.
C----- UPDATE THE TOTAL MAGNITUDE
      FC = SQRT (FESQ)
C----- THE RELATIVE CONTRIBUTIONS OF THE COMPONENTS
      COSA = CENANT * FP / FC
      SINA =  ENANT * FN / FC
      IF (ENANT - .5) 11394,11394,11393
C----- RESET THE PHASE - THE BEST WE CAN DO!
11393  CONTINUE
      P = PN
11394 CONTINUE
C----- CHECK FOR REFINEMENT
      IF (JB) 11396,11395,11395
11395 CONTINUE
      COSPN = SCALEW*ACN/FN
      SINPN = SCALEW*BCN/FN
      ACE = SCALEW * .5 *(FNSQ-FCSQ) / FC
11396 CONTINUE
C
11399 CONTINUE
      STORE(NH+6) = FC
      STORE(NH+7)=P
C--CHECK IF WE ARE DOING REFINEMENT
      IF(JB)11900,11400,11400
C
C--ROUTINES TO TRANSFER PARTIAL DERIVATIVES FROM TEMPORARY TO
C  PERMANENT STORE
11400 CONTINUE
      JS=ISTORE(NH+18)
      COSP = SCALEW * ACT / FP
      SINP = SCALEW * BCT / FP
      GOTOIN3,(11450,11550,11600,11700)
C--CENTRO WITHOUT ANOMALOUS DISPERSION
11450 CONTINUE
      N = JP-JO
&CYBCVD$L NODEPCHK
      DO 11500 J = 0, N
      STORE(JO+J) = STORE(JS+J*JQ)*COSP
11500 CONTINUE
      GOTO 11850
C--NON-CENTRO WITHOUT ANOMALOUS DISPERSION
11550 CONTINUE
      SINP=SINP*FRIED
C--NON-CENTRO WITHOUT ANOMALOUS DISPERSION OR CENTRO WITH ANOMALOUS
C  DISPERSION
11600 CONTINUE
      N = JP-JO
&CYBCVD$L NODEPCHK
      DO 11650 J = 0, N
      STORE(JO+J) = STORE(JS+J*JQ)*COSP+ STORE(JS+J*JQ+1)*SINP
11650 CONTINUE
      ACF = BCD*SINP
      IF (JL) 11680,11660,11660
11660 CONTINUE
C----- NOW MODIFY THE EXISTING DERIVATIVES
      JS = ISTORE(NH+18)
      N = JP-JO
&CYBCVD$L NODEPCHK
      DO 11670 J = 0, N
      STORE(JO+J) = STORE(JO+J)*COSA +
     1 SINA*(STORE(JS+J*JQ)*COSPN + STORE(JS+J*JQ+1)*SINPN)
11670 CONTINUE
      ACF = ACF * COSA + SINA * BCD * SINPN
11680 CONTINUE
      GOTO 11800
C--NON-CENTRO WITH ANOMALOUS DISPERSION
11700 CONTINUE
      N = JP-JO
&CYBCVD$L NODEPCHK
      DO 11750 J = 0, N
      STORE(JO+J) = (STORE(JS+J*JQ)+STORE(JS+J*JQ+2)*FRIED)*COSP
     1 + (STORE(JS+J*JQ+1)*FRIED+STORE(JS+J*JQ+3))*SINP
11750 CONTINUE
      ACF =  (ACD * COSP * FRIED) + (BCD * SINP)
      IF (JL) 11790,11760,11760
11760 CONTINUE
C----- NOW MODIFY THE EXISTING DERIVATIVES
      JS = ISTORE(NH+18)
      N = JP-JO
&CYBCVD$L NODEPCHK
      DO 11785 J = 0, N
      STORE(JO+J) = STORE(JO+J)*COSA + SINA*
     1 ((STORE(JS+J*JQ)-STORE(JS+J*JQ+2)*FRIED)*COSPN +
     2 (STORE(JS+J*JQ+3)-STORE(JS+J*JQ+1)*FRIED)*SINPN)
11785 CONTINUE
      ACF = ACF*COSA + SINA * (BCD*SINPN - ACD*COSPN*FRIED)
11790 CONTINUE
      STORE(JN+3)=0.0
      STORE(JN+2)=0.0
11800 CONTINUE
      STORE(JN+1)=0.0
11850 CONTINUE
      STORE(JN)=0.0
C--RETURN TO THE CALLING ROUTINE
11900 CONTINUE
      GOTOICONT,(3100,4000)
C
C
C--ROUTINES TO ADD P.D.'S WITH RESPECT TO /FC/ FOR THE OVERALL PARAMETER
C
C  A     THE DERIVATIVE TO BE ADDED
C  JX    ITS POSITION IN THE OVERALL PARAMETER LIST SET IN M12
C  M12   ADDRESS OF THE HEADER FOR THE PARAMETER IN LIST 12
C  IOVR  SET TO THE RETURN ADDRESS
C
C--SET UP THE LIST 12 FLAGS
11950 CONTINUE
      L12A=ISTORE(M12+1)
      IF(ISTORE(M12+1))12350,12350,12000
C--PROCESS THE NEXT PART
12000 CONTINUE
      IF(ISTORE(L12A+4)-JX)12050,12050,12300
C--THE PART STARTS LOW ENOUGH DOWN
12050 CONTINUE
      MD12A=ISTORE(L12A+1)
      JU=ISTORE(L12A+2)+(JX-ISTORE(L12A+4))*MD12A
C--CHECK IF THIS PARAMETER IS IN RANGE
      IF(JU-ISTORE(L12A+3))12100,12100,12300
C--COMPUTE THE ADDRESS OF THIS PARAMETER IN THE DERIVATIVE STACK
12100 CONTINUE
      JT=(ISTORE(JU)-JR)/JQ
C--CHECK IF THE PARAMETER HAS BEEN REFINED
      IF(JT)12300,12150,12150
12150 CONTINUE
      JT=JT+JO
C--CHECK IF THE WEIGHT IS GIVEN OR ASSUMED TO BE UNITY
      IF(MD12A-2)12200,12250,12200
C--THE WEIGHT IS UNITY
12200 CONTINUE
      STORE(JT)=STORE(JT)+A
      GOTO 12300
C--THIS WEIGHT IS GIVEN
12250 CONTINUE
      STORE(JT)=STORE(JT)+A*STORE(JU+1)
C--PASS ONTO THE NEXT PART
12300 CONTINUE
      L12A=ISTORE(L12A)
      IF(L12A)12350,12350,12000
12350 CONTINUE
      GO TO IOVR , ( 3900, 4800, 4850, 4855, 4900, 4920, 4950,
     1  5050, 5150 )
C
C
C
19900 CONTINUE
C -- ERRORS
      RETURN
19910 CONTINUE
C -- INCORRECT ELEMENT NUMBER
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 19915 ) JX , PH , PK , PL
      ENDIF
19915 FORMAT ( 1X , I5 , ' is an incorrect element number for ' ,
     1 'reflection ' , 3F5.0 )
      WRITE ( NCAWU , 19917 )
19917 FORMAT ( 1X , 'Incorrect element number ' )
      CALL XERHND ( IERERR )
      GO TO 19900
19920 CONTINUE
C -- TOO MANY ELEMENTS
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 19925 ) PH , PK , PL
      ENDIF
      WRITE ( NCAWU , 19925 ) PH , PK , PL
19925 FORMAT ( 1X , 'Too many elements given for reflection ', 3F5.0 )
      CALL XERHND ( IERERR )
      GO TO 19900
C
19930 CONTINUE
C------ SIGMA W*FO*FO .LE. ZERO ---- SUGGESTS PROBABLY NO WEIGHTS
      WRITE(NCAWU,19935)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,19935)
      ENDIF
19935 FORMAT(/,1X,'The denominator for the weighted R factor ',
     1 'is less than or equal to zero.'/
     2 ' Check that you have applied weights.')
      CALL XERHND ( IERERR )
      GOTO 19900
C
      END
C
CODE FOR KLAYER
      FUNCTION KLAYER(IN)
C--COMPUTE THE LAYER SCALE INDEX FOR THE CURRENT REFLECTION.
C
C  IN  A DUMMY ARGUMENT.
C
C--RETURN VALUES OF 'KLAYER' ARE :
C
C  -1  NO LAYER SCALES IN LIST 5.
C  >0  THE LAYER SCALE INDEX.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF THERE ARE ANY LAYER SCALES STORED
      KLAYER=-1
      IF(MD5LS)1350,1350,1000
C--COMPUTE THE INDEX VALUE
1000  CONTINUE
      A=STORE(L5LSC)*STORE(M6)+STORE(L5LSC+1)*STORE(M6+1)
     2 +STORE(L5LSC+2)*STORE(M6+2)
C--CHECK IF THE ABSOLUTE VALUE SHOULD BE TAKEN
      IF(STORE(L5LSC+4))1100,1100,1050
C--TAKE THE ABSOLUTE VALUE
1050  CONTINUE
      A=ABS(A)
C--COMPUTE THE OUTPUT INDEX
1100  CONTINUE
      I=NINT(A+STORE(L5LSC+3))
C--CHECK IF THE VALUE IS LARGE ENOUGH
      IF(I)1150,1150,1250
C--ILLEGAL LAYER SCALE VALUE
1150  CONTINUE
      CALL XERHDR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1200)STORE(M6),STORE(M6+1),STORE(M6+2),I
      ENDIF
1200  FORMAT(14H Reflection : ,3F5.0,
     2 44H  GENERATES AN ILLEGAL LAYER SCALE INDEX OF ,I4)
      WRITE ( NCAWU , 1205 )
1205  FORMAT ( 1X , 'Illegal layer scale index' )
      CALL XERHND ( IERERR )
      RETURN
C--CHECK THE MAXIMUM VALUE
1250  CONTINUE
      IF(I-MD5LS)1300,1300,1150
C--AND NOW RETURN
1300  CONTINUE
      KLAYER=I
1350  CONTINUE
      RETURN
      END
C
CODE FOR KBATCH
      FUNCTION KBATCH(IN)
C--COMPUTE THE BATCH SCALE INDEX FOR THE CURRENT REFLECTION.
C
C  IN  A DUMMY ARGUMENT.
C
C--RETURN VALUES OF 'KBATCH' ARE :
C
C  -1  NO BATCH SCALES IN LIST 5.
C  >0  THE BATCH SCALE INDEX.
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CHECK IF THERE ARE ANY BATCH SCALES STORED
      KBATCH=-1
      IF(MD5BS)1250,1250,1000
C--COMPUTE THE INDEX VALUE
1000  CONTINUE
      I=NINT(STORE(M6+13))
C--CHECK IF THE VALUE IS LARGE ENOUGH
      IF(I)1050,1050,1150
C--ILLEGAL BATCH SCALE VALUE
1050  CONTINUE
      CALL XERHDR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1100)STORE(M6),STORE(M6+1),STORE(M6+2),I
      ENDIF
1100  FORMAT(14H Reflection : ,3F5.0,
     2 44H  GENERATES AN ILLEGAL BATCH SCALE INDEX OF ,I4)
      WRITE ( NCAWU , 1205 )
1205  FORMAT ( 1X , 'Illegal batch scale index' )
      CALL XERHND ( IERERR )
      RETURN
C--CHECK THE MAXIMUM VALUE
1150  CONTINUE
      IF(I-MD5BS)1200,1200,1050
C--AND NOW RETURN
1200  CONTINUE
      KBATCH=I
1250  CONTINUE
      RETURN
      END



CRYSTALS CODE FOR SLANT
CODE FOR XTRIAL
      SUBROUTINE XTRIAL
C--MOVE A MOLECULE AROUND AND PLOT SUM(FO*FC) AT EACH POINT
C
C  AM      MINIMUM VALUE OF FO TO BE USED (ON SCALE OF FO)
C  SCALE   MAP SCALE FACTOR  -  AUTOMATIC SCALING DONE IF ZERO
C  ITHRES  VALUE BELOW WHICH ALL NUMBERS ARE PRINTED AS ZEROES
C  NX      THE NUMBER OF POINTS ALONG X TO MOVE.
C  NY      THE NUMBER OF POINTS ALONG Y TO MOVE.
C  NZ      THE NUMBER OF POINTS ALONG Z TO MOVE.
C          (THESE DIRECTIONS ARE AFTER TRANSFORMATION.)
C  BPD     LOCATIONS 7-9 CONTAIN THE INITIAL ORIGIN DISTPALCEMENT.
C  APD     THE STEP VECTOR.
C
C--
      DIMENSION ISTORE(131072)
C
      DIMENSION PROCS(26)
      DIMENSION A1(26)
      DIMENSION APD(13), BPD(13)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XWORK/A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,
     2 U,V,W,X,Y,Z
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      EQUIVALENCE (PROCS(1),APD(1))
      EQUIVALENCE (AM,BPD(1)),(SCALE,BPD(2)),(ITHRES,BPD(3))
      EQUIVALENCE (NNX,BPD(4)),(NNY,BPD(5)),(NNZ,BPD(6))
      EQUIVALENCE (A1(1),A)
C
C
      DATA NCOL/28/
C
      NW=7
C--INITIALISE THE TIMING
      CALL XTIME1(2)
C--READ THE DIRECTIVES
      ISTAT = KRDDPV ( PROCS , 26 )
      IF ( ISTAT .LT. 0 ) GO TO 9910
C--CLEAR THE CORE
1050  CONTINUE
      CALL XRSL
      CALL XCSAE
C--ASSIGN A FEW INPUT CONTROL VALUES
      NX=MAX0(1,NNX)
      NY=MAX0(1,NNY)
      NZ=MAX0(1,NNZ)
C--LOAD A FEW LISTS
      CALL XFAL01
      CALL XFAL02
      CALL XFAL03
      CALL XFAL05
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--LINK LIST 5 TO VARIOUS OTHER LISTS
      JJ=-1
      JA=1
      IF(KSET52(-1,0))1150,1100,1100
1100  CONTINUE
      IF ( IERFLG .LT. 0 ) GO TO 9900
      JJ=0
      JA=N2
1150  CONTINUE
      N3=KSET53(0)+1
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE INITIAL TRANSFORMED COORD. VALUES
      MINX=0
      MINY=0
      MINZ=0
C--APPLY THE INITIAL DISPALCEMENT
      M5=L5
      DO 1200 I=1,N5
      STORE(M5+4)=STORE(M5+4)+BPD(7)
      STORE(M5+5)=STORE(M5+5)+BPD(8)
      STORE(M5+6)=STORE(M5+6)+BPD(9)
      M5=M5+MD5
1200  CONTINUE
C--SET UP LIST 6 FORM READING
      CALL XFAL06(0)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET UP THE INITIAL REFLECTION DATA
      CALL XSFLSQ(AM,BM)
C
C--SET UP A FEW CONSTANTS FOR THE MAP
      W=1000./BM
      IF(SCALE-ZEROSQ)1300,1300,1250
1250  CONTINUE
      W=SCALE
1300  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1350)W
      ENDIF
1350  FORMAT(///13H Scale factor,E20.10)
C--CHECK THAT THERE ARE SOME REFLECTIONS
      IF(ND)1400,1400,1500
1400  CONTINUE
      CALL XERHDR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)
      ENDIF
1450  FORMAT(/15H No reflections)
      GOTO 1050
C--SET UP THE MAP AND ACCUMULATION AREAS
1500  CONTINUE
      L8=NFL
      NQ=NX*NY
      LN=8
      IREC=5001
      NO=KCHNFL(3*NQ)-1
      MD8=NY
      NP=L8+NQ
C--SET UP THE NUMBER AREA
      IREC=5002
      NS=KCHLFL(NCOL)
C
C--MAIN CALCULATION LOOP
      DO 2950 N1=1,NZ
      M8=NY-1
C--CLEAR THE MAP AREA
      DO 1550 I=L8,NP
      STORE(I)=0.
1550  CONTINUE
      NB=NA
C--PASS OVER EACH REFLECTION
      DO 2300 I1=1,ND
C--CLEAR THE REFLECTION ACCUMULATION AREA
      DO 1600 J1=NP,NO
      STORE(J1)=0.
1600  CONTINUE
      JF=NB
C--PASS OVER EACH SYMMETRY POSITION FOR EACH RELFECTION
      DO 2050 J1=1,N2
      JG=JF+6
C--INCREMENT THE COS TERMS TO THE NEW LAYER
      DO 1650 K1=JF,JG,2
      A=STORE(K1)
      STORE(K1)=STORE(JF+20)*STORE(K1)-STORE(K1+8)
      STORE(K1+8)=A
1650  CONTINUE
      A=STORE(JF)
      B=STORE(JF+2)
      C=STORE(JF+4)
      D=STORE(JF+6)
      O=STORE(JF+16)
      P=STORE(JF+18)
      L=NP
C--PASS ALONG THE X ROWS
      DO 1750 J=1,NX
      A1(7)=A1(2)
      A1(2)=A1(15)*A1(2)-A1(1)
      A1(5)=A1(2)
      A1(1)=A1(7)
      A1(7)=A1(4)
      A1(4)=A1(15)*A1(4)-A1(3)
      A1(6)=A1(4)
      A1(3)=A1(7)
      M=L+M8
C--ADD IN ALONG THE Y ROWS
      DO 1700 K=L,M
      A1(7)=A1(6)
      A1(6)=A1(16)*A1(6)-A1(5)
      A1(5)=A1(7)
      STORE(K)=STORE(K)+A1(6)
1700  CONTINUE
      L=L+MD8
1750  CONTINUE
C--CHECK IF THIS IS A NON-CENTRO STRUCTURE
      IF(IC)1800,1800,2000
C--NON-CENTRO
1800  CONTINUE
C--UPDATE THE SIN TERMS
      DO 1850 K1=JF,JG,2
      A=STORE(K1+1)
      STORE(K1+1)=STORE(JF+20)*STORE(K1+1)-STORE(K1+9)
      STORE(K1+9)=A
1850  CONTINUE
      A=STORE(JF+1)
      B=STORE(JF+3)
      C=STORE(JF+5)
      D=STORE(JF+7)
      L=NP+NQ
C--PASS ALONG THE X ROWS
      DO 1950 J=1,NX
      A1(7)=A1(2)
      A1(2)=A1(15)*A1(2)-A1(1)
      A1(5)=A1(2)
      A1(1)=A1(7)
      A1(7)=A1(4)
      A1(4)=A1(15)*A1(4)-A1(3)
      A1(6)=A1(4)
      A1(3)=A1(7)
      M=L+M8
C--ADD IN ALONG THE Y ROWS
      DO 1900 K=L,M
      A1(7)=A1(6)
      A1(6)=A1(16)*A1(6)-A1(5)
      A1(5)=A1(7)
      STORE(K)=STORE(K)+A1(6)
1900  CONTINUE
      L=L+MD8
1950  CONTINUE
2000  CONTINUE
      JF=JF+NE
2050  CONTINUE
      NB=NB+NC
C--CALCULATE THE FINAL FC AND ADD IT IN
      I=L8
      J=L8+NQ-1
      L=NP
      M=NP+NQ
      IF(IC)2100,2100,2200
C--NON-CENTRO
2100  CONTINUE
      DO 2150 K=I,J
      STORE(K)=STORE(K)+SQRT(STORE(L)*STORE(L)+STORE(M)*STORE(M))
      L=L+1
      M=M+1
2150  CONTINUE
      GOTO 2300
C--CENTRO
2200  CONTINUE
      DO 2250 K=I,J
      STORE(K)=STORE(K)+ABS(STORE(L))
      L=L+1
2250  CONTINUE
2300  CONTINUE
C
C--MAIN MAP PRINTING ROUTINES
      JA=MINY
      JB=NY
      JZ=1
      M8=L8
2400  CONTINUE
      JY=MIN0(JB,NCOL)-1
      JC=JA+JY
      CALL XPRTCN
      JD=NS-1
      DO 2450 I=JA,JC
      ISTORE(JD+1)=I
      JD=JD+1
2450  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2500)MINZ,JZ,(ISTORE(I),I=NS,JD)
      ENDIF
2500  FORMAT(10H Trial map,5X,7HSection,I4,5X,4HPart,I3///8X,28I4)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2550)(IA,I=NS,JD)
      ENDIF
2550  FORMAT(8X,28(3X,A1))
      JE=M8
      JG=MINX
      DO 2850 I=1,NX
      JF=JE+JY
      DO 2750 J=JE,JF
      STORE(J)=STORE(J)*W
      IF(STORE(J)-999.)2650,2650,2600
2600  CONTINUE
      ISTORE(J)=999
      GOTO 2750
2650  CONTINUE
      ISTORE(J)=NINT(STORE(J))
      IF(ISTORE(J)-ITHRES)2700,2750,2750
2700  CONTINUE
      ISTORE(J)=0
2750  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2800)JG,IA,IB,(ISTORE(J),J=JE,JF)
      ENDIF
2800  FORMAT(/1X,I4,1X,2A1,28I4)
      JE=JE+MD8
      JG=JG+1
2850  CONTINUE
      JZ=JZ+1
      JY=JY+1
      JA=JA+JY
      M8=M8+JY
      JB=JB-JY
C--MORE TO PRINT
      IF(JB)2900,2900,2400
2900  CONTINUE
      MINZ=MINZ+1
2950  CONTINUE
C
C
C
3000  CONTINUE
C
C -- FINAL MESSAGE
C
      CALL XOPMSG ( IOPTRI , IOPEND , 200 )
      CALL XTIME2(2)
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPTRI , IOPABN , 0 )
      GO TO 3000
9910  CONTINUE
C -- INPUT ERROR
      CALL XOPMSG ( IOPTRI , IOPCMI , 0 )
      GO TO 9900
      END
C
CODE FOR XSFLSQ
      SUBROUTINE XSFLSQ(S,U)
C--MAIN STRUCTURE FACTOR CALCULATION ROUTINE
C
C  S  MIN VALUE OF FO (ON SCALE OF FO)
C  U  MAX. VALUE OF SUM(FO*FC)
C
C--USEAGE OF CONTROL VARIABLES :
C
C  JA  SET TO 1 FOR ISO ATOMS ONLY , ELSE N2
C  JE
C  JF  USED FOR POINTERS TO THE SIN/COS TERMS FOR EACH REFLECTION
C  JG
C  JS  WORK VARIABLE
C  JT  WORK VARIABLES USED DURING ACCUMULATION OF PARTIAL DERIVATIVES
C  JU
C  JV
C  JW
C  JX  LOOP VARIABLE FOR EQUIVALENT POSITIONS
C  JY  LOOP VARIABLE FOR ATOMS
C  JZ  LOOP VARIABLE FOR THE VARIOUS SYMMETRIES
C
C--USEAGE OF GENERAL VARIABLES
C
C  TC    COEFFICIENT FOR THE ISO-TEMPERATURE FACTORS
C  SST   SIN(THETA)/LAMBDA SQUARED
C  ST    SIN(THETA)/LAMBDA
C  FOCC  FORM FACTOR MULTIPLIED BY THE OCCUPATION NUMBER
C  T     TEMPERATURE FACTOR
C  TFOCC T*FOCC
C
C--XLST07 CONTROLS THE REFLECTION STACK :
C
C  NA    ADDRESS OF THE FIRST ENTRY IN THE STACK
C  NB    CURRENT ADDRESS IN THE STACK
C  NE    NUMBER OF WORDS PER SYMMETRY POSITION IN THE REFLECTION STACK
C  ND    NUMBER OF REFLECTIONS IN THE STACK
C
C  NC   NUMBER OF WORDS PER REFLECTION IN THE STACK (=N2*NE)
C
C--THE FORMAT OF THE STACK IS :
C
C   0  SUM[ COS2PI(H'.S.X + H'.T - 2H'.S.DX - 2H'.S.DY -  H'.S.DZ) ]
C   1  SUM[ SIN2PI(H'.S.X + H'.T - 2H'.S.DX - 2H'.S.DY -  H'.S.DZ) ]
C   2  SUM[ COS2PI(H'.S.X + H'.T -  H'.S.DX - 2H'.S.DY -  H'.S.DZ) ]
C   3  SUM[ SIN2PI(H'.S.X + H'.T -  H'.S.DX - 2H'.S.DY -  H'.S.DZ) ]
C   4  SUM[ COS2PI(H'.S.X + H'.T - 2H'.S.DX -  H'.S.DY -  H'.S.DZ) ]
C   5  SUM[ SIN2PI(H'.S.X + H'.T - 2H'.S.DX -  H'.S.DY -  H'.S.DZ) ]
C   6  SUM[ COS2PI(H'.S.X + H'.T -  H'.S.DX -  H'.S.DY -  H'.S.DZ) ]
C   7  SUM[ SIN2PI(H'.S.X + H'.T -  H'.S.DX -  H'.S.DY -  H'.S.DZ) ]
C   8  SUM[ COS2PI(H'.S.X + H'.T - 2H'.S.DX - 2H'.S.DY - 2H'.S.DZ) ]
C   9  SUM[ SIN2PI(H'.S.X + H'.T - 2H'.S.DX - 2H'.S.DY - 2H'.S.DZ) ]
C  10  SUM[ COS2PI(H'.S.X + H'.T -  H'.S.DX - 2H'.S.DY - 2H'.S.DZ) ]
C  11  SUM[ SIN2PI(H'.S.X + H'.T -  H'.S.DX - 2H'.S.DY - 2H'.S.DZ) ]
C  12  SUM[ COS2PI(H'.S.X + H'.T - 2H'.S.DX -  H'.S.DY - 2H'.S.DZ) ]
C  13  SUM[ SIN2PI(H'.S.X + H'.T - 2H'.S.DX -  H'.S.DY - 2H'.S.DZ) ]
C  14  SUM[ COS2PI(H'.S.X + H'.T -  H'.S.DX -  H'.S.DY - 2H'.S.DZ) ]
C  15  SUM[ SIN2PI(H'.S.X + H'.T -  H'.S.DX -  H'.S.DY - 2H'.S.DZ) ]
C  16  H'.S.DX
C  17  2*COS2PI(H'.S.DX)
C  18  H'.S.DY
C  19  2*COS2PI(H'.S.DY)
C  20  H'.S.DZ
C  21  2*COS2PI(H'.S.DZ)
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--INITIALISE TIMING OF THIS SECTION
      CALL XTIME1(3)
      U=0.
      ND=0
      SCALE=1.0/STORE(L5O)
      NA=NFL
      NE=22
      NC=NE*N2
      NB=NA-NC
      IF(N5)1100,1100,2150
C
C--START OF THE LOOP OVER REFLECTIONS
C
1000  CONTINUE
      IF(S-STORE(M6+3))1050,1050,2150
1050  CONTINUE
      ND=ND+1
      NB=NB+NC
      IF(NB+NC-LFL)1150,1100,1100
C--NO MORE STORE AVAILABLE
1100  CONTINUE
      CALL XICA
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2250)ND
      ENDIF
      ND=0
      GOTO 2300
1150  CONTINUE
C
C--CALCULATE THE INFORMATION FOR THE SYMMETRY POSITIONS
C
      M2=L2
      M2T=L2T
      JF=NB
      DO 1400 JZ=1,N2
      STORE(M2T)=STORE(M6)*STORE(M2)+STORE(M6+1)*STORE(M2+3)
     2 +STORE(M6+2)*STORE(M2+6)
      STORE(M2T+1)=STORE(M6)*STORE(M2+1)+STORE(M6+1)*STORE(M2+4)
     2 +STORE(M6+2)*STORE(M2+7)
      STORE(M2T+2)=STORE(M6)*STORE(M2+2)+STORE(M6+1)*STORE(M2+5)
     2 +STORE(M6+2)*STORE(M2+8)
C--CALCULATE THE H.T TERMS
      STORE(M2T+3)=(STORE(M6)*STORE(M2+9)+STORE(M6+1)*STORE(M2+10)
     2 +STORE(M6+2)*STORE(M2+11))*TWOPI
C--CHECK IF THE ANSIO CONTRIBUTIONS ARE REQUIRED
      IF(JA-JZ)1250,1200,1200
1200  CONTINUE
      STORE(M2T+4)=STORE(M2T)*STORE(M2T)
      STORE(M2T+5)=STORE(M2T+1)*STORE(M2T+1)
      STORE(M2T+6)=STORE(M2T+2)*STORE(M2T+2)
      STORE(M2T+7)=STORE(M2T+1)*STORE(M2T+2)
      STORE(M2T+8)=STORE(M2T)*STORE(M2T+2)
      STORE(M2T+9)=STORE(M2T)*STORE(M2T+1)
1250  CONTINUE
      STORE(M2T)=STORE(M2T)*TWOPI
      STORE(M2T+1)=STORE(M2T+1)*TWOPI
      STORE(M2T+2)=STORE(M2T+2)*TWOPI
C--CLEAR THE ACCUMULATION AREAS FOR EACH SYMMETRY POSITION
      JG=JF+NE-1
      DO 1300 JY=JF,JG
      STORE(JY)=0.
1300  CONTINUE
C--CALCULATE THE STEP VECTORS
      JG=JF+16
      DO 1350 JY=1,7,3
      STORE(JG+1)=STORE(M2T)*APD(JY)+STORE(M2T+1)*APD(JY+1)
     2 +STORE(M2T+2)*APD(JY+2)
      STORE(JG)=2.*COS(STORE(JG+1))
      JG=JG+2
1350  CONTINUE
      JF=JF+NE
      M2=M2+MD2
      M2T=M2T+MD2T
1400  CONTINUE
C--CALCULATE SIN(THETA)/LAMBDA SQUARED
      SST=STORE(L1S)*STORE(L2T+4)+STORE(L1S+1)*STORE(L2T+5)
     2 +STORE(L1S+2)*STORE(L2T+6)+STORE(L1S+3)*STORE(L2T+7)
     3 +STORE(L1S+4)*STORE(L2T+8)+STORE(L1S+5)*STORE(L2T+9)
      ST=SQRT(SST)
C--CALCULATE THE TEMPERATURE FACTOR COEFFICIENT
      TC=-SST*TWOPIS*4.
C--CHECK IF THE ANISO TERMS ARE REQUIRED
      IF(JJ)1550,1450,1450
1450  CONTINUE
      M2T=L2T
      DO 1500 JZ=1,N2
      STORE(M2T+4)=STORE(M2T+4)*STORE(L1A)
      STORE(M2T+5)=STORE(M2T+5)*STORE(L1A+1)
      STORE(M2T+6)=STORE(M2T+6)*STORE(L1A+2)
      STORE(M2T+7)=STORE(M2T+7)*STORE(L1A+3)
      STORE(M2T+8)=STORE(M2T+8)*STORE(L1A+4)
      STORE(M2T+9)=STORE(M2T+9)*STORE(L1A+5)
      M2T=M2T+MD2T
1500  CONTINUE
1550  CONTINUE
C
C--CALCULATE THE FORM FACTORS
      CALL XSCATT(ST)
      DO 1600 JZ=1,N3
      M3TR=L3TR+JZ-1
      STORE(M3TR)=STORE(M3TR)*G2
1600  CONTINUE
C
C--LOOP OVER THE ATOMS IN THE CELL
      M5A=L5
      DO 2100 JY=1,N5
C--PICK UP THE FORM FACTORS FOR THIS ATOM
      M3TR=L3TR+ISTORE(M5A)
      FOCC=STORE(M3TR)*STORE(M5A+2)
C--CHECK THE TEMPERAURE TYPE FOR THIS ATOM
      IF(ISTORE(M5A+1))1700,1750,1750
C--CALCULATE THE ISO-TEMPERATURE FACTOR COEFFICIENTS FOR THIS ATOM
1700  CONTINUE
      T=EXP(STORE(M5A+3)*TC)
      TFOCC=T*FOCC
C
C--LOOP CYCLING OVER THE DIFFERENT EQUIVALENT POSITIONS FOR THIS ATOM
C
1750  CONTINUE
      JF=NB
      M2T=L2T
      DO 2050 JX=1,N2T
C--SET UP THE H'.DX COMPONENTS FOR THIS SYMMETRY POSITION
      XDS=STORE(JF+17)
      YDS=STORE(JF+19)
      ZDS=STORE(JF+21)
C--CALCULATE H'.X+H.T - H'.DX
      A=STORE(M5A+4)*STORE(M2T)+STORE(M5A+5)*STORE(M2T+1)+STORE(M5A+6)
     2 *STORE(M2T+2)+STORE(M2T+3)-XDS-YDS-ZDS
C--CHECK THE TEMPERATURE FACTOR TYPE
      IF(ISTORE(M5A+1))1850,1800,1800
C--CALCULATE THE ANISO-TEMPERATURE FACTOR
1800  CONTINUE
      T=EXP(STORE(M5A+7)*STORE(M2T+4)+STORE(M5A+8)*STORE(M2T+5)
     2 +STORE(M5A+9)*STORE(M2T+6)+STORE(M5A+10)*STORE(M2T+7)
     3 +STORE(M5A+11)*STORE(M2T+8)+STORE(M5A+12)*STORE(M2T+9))
      TFOCC=T*FOCC
C--CALCULATE THE SIN/COS TERMS
1850  CONTINUE
      C=TFOCC*STORE(M6+3)*SCALE
      U=U+C
      STORE(JF)=STORE(JF)+C*COS(A-XDS-YDS)
      STORE(JF+2)=STORE(JF+2)+C*COS(A-YDS)
      STORE(JF+4)=STORE(JF+4)+C*COS(A-XDS)
      STORE(JF+6)=STORE(JF+6)+C*COS(A)
      STORE(JF+8)=STORE(JF+8)+C*COS(A-XDS-YDS-ZDS)
      STORE(JF+10)=STORE(JF+10)+C*COS(A-YDS-ZDS)
      STORE(JF+12)=STORE(JF+12)+C*COS(A-XDS-ZDS)
      STORE(JF+14)=STORE(JF+14)+C*COS(A-ZDS)
      IF(IC)1900,1900,1950
C--ADD IN THE NON-CENTRO PART
1900  CONTINUE
      STORE(JF+1)=STORE(JF+1)+C*SIN(A-XDS-YDS)
      STORE(JF+3)=STORE(JF+3)+C*SIN(A-YDS)
      STORE(JF+5)=STORE(JF+5)+C*SIN(A-XDS)
      STORE(JF+7)=STORE(JF+7)+C*SIN(A)
      STORE(JF+9)=STORE(JF+9)+C*SIN(A-XDS-YDS-ZDS)
      STORE(JF+11)=STORE(JF+11)+C*SIN(A-YDS-ZDS)
      STORE(JF+13)=STORE(JF+13)+C*SIN(A-XDS-ZDS)
      STORE(JF+15)=STORE(JF+15)+C*SIN(A-ZDS)
1950  CONTINUE
C--UPDATE THE SYMMETRY INFORMATION POINTER
      M2T=M2T+MD2T
      JF=JF+NE
2050  CONTINUE
      M5A=M5A+MD5A
2100  CONTINUE
C
C--PICK UP THE NEXT REFLECTION
2150  CONTINUE
      IF(KFNR(0)) 2200,1000,1000
2200  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2250)ND
      ENDIF
2250  FORMAT(///28H Structure factors end after,I6,15H  reflection(s))
2300  CONTINUE
      CALL XTIME2(3)
      NFL=NB+NC
      RETURN
      END
C
CODE FOR XSLANT
      SUBROUTINE XSLANT
C--SLANT FOURIER SUBROUTINE
C
C  IN     TYPE OF FOURIER :
C         1  FO
C         2  FC
C         3  DF
C         4  FO PATTERSON
C         5  FC PATTERSON
C  ITHRES PRINT 0 FOR ALL VALUES LESS THAN THIS
C  SCALE  MAP SCALE FACTOR
C  IWT    WEIGHTING
C         0 FOR NO, ELSE 1
C
C--USE OF VARIABLES :
C
C  R  STEP ALONG X IN THE PLANE
C  S  STEP ALONG Y IN THE PLANE
C  U  FINAL MAP SCALE FACTOR
C  V  FC SCALE FACTOR
C  W  SUM OF F*F FOR A PATTERSON
C  X  TRANSFORMED H
C  Y  TRANSFORMED K
C  Z  TRANSFORMED L
C
C--
      DIMENSION ISTORE(131072)
C
      PARAMETER (NPROCS = 27)
      DIMENSION PROCS(NPROCS)
      DIMENSION IPROCS(NPROCS)
      DIMENSION APD(13), BPD(13)
      DIMENSION A1(26)
      DIMENSION AMIN(3)
      CHARACTER*16 CMAPTP(5)
      CHARACTER*8  WTED
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON/XTAPES/MTA,MTB,MT1,MT2,MT3,MTE
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XWORK/A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,
     2 U,V,W,X,Y,Z
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST20/L20M,M20M,MD20M,N20M,
     2 L20I,M20I,MD20I,N20I, L20V,M20V,MD20V,N20V
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      EQUIVALENCE (APD(1),PROCS(1))
      EQUIVALENCE (IN,APD(10)),(ITHRES,APD(11)),(SCALE,APD(12))
      EQUIVALENCE (IWT, APD(13))
      EQUIVALENCE (A1(1),A)
      EQUIVALENCE (PROCS(1), IPROCS(1))
      EQUIVALENCE (IMODE, PROCS(27)), (IOUTAP, PROCS(26))
C
C
      DATA NCOL/28/
C
      DATA CMAPTP / '    F-Obs map   ' , '   F-Calc map   ' ,
     2              ' Difference map ' , '  FO-Patterson  ' ,
     3              '  FC-Patterson  ' /
C
C
      NW=7
C--INITIALISE THE TIMING FUNCTION
      CALL XTIME1(1)
C--READ THE DATA
      ISTAT = KRDDPV ( PROCS, NPROCS)
      IF ( ISTAT .LT. 0 ) GO TO 9910
C--LOAD LISTS ONE AND TWO
      CALL XRSL
      CALL XCSAE
      CALL XFAL01
      CALL XFAL02
      CALL XFAL20
C----- CHECK IF WE USE THE MOLAX MATRIX -
      IF (IMODE .GE. 1) THEN
      CALL XMOVE (STORE(L20V+ IMODE * MD20V), PROCS(14), 3)
C----- COPY AND TRANSPOSE
      CALL XTRANS (STORE(L20M+ IMODE * MD20M), PROCS(1), 3, 3)
      ENDIF
      IF ( IERFLG .LT. 0 ) GO TO 9900
      L2=L2I
      M2=L2+(N2-1)*MD2
C----- SET UP AREA FOR TAPE HEADER
      ITAPE = KCHLFL(21)
C--SET UP AN AREA FOR THE NEW CALCULATED INDICES
      LN=6
      IREC=8001
      JA=NFL
      JB=KCHNFL(N2*NW)
      JADUMP = JA
      JBDUMP = JB
      IF(SCALE-ZEROSQ)1100,1100,1150
1100  CONTINUE
      SCALE=10.
1150  CONTINUE
      U=SCALE
      IF (IWT .LE. 0) THEN
            WTED = '        '
      ELSE
            WTED = 'Weighted'
      ENDIF
C--INVERT THE ROTATION MATRIX
      LN=8
      IREC=8001
      L8RI=KCHLFL(9)
      L8R=KCHLFL(9)
      CALL XMOVE(PROCS(1),STORE(L8R),9)
C----- LOOK FOR SOME SORT OF MATRIX
      IF (ABS(XDETR3(PROCS(1))) .LE. ZERO) THEN
       WRITE(NCAWU,1060) (PROCS(I), I = 1,9)
       IF (ISSPRT .EQ. 0) WRITE(NCWU,1060) (PROCS(I), I = 1,9)
1060   FORMAT (' Your matrix is probably invalid ', 3(/3F9.3))
       GOTO 9900
      ENDIF
      IF(KINV2(3,STORE(L8R),STORE(L8RI),9,0,APD(1),APD(1),9))9920 ,
     1 1300 , 9920
C--MOVE THE CENTROID AND STEPS IN X, Y AND THE Z HEIGHT
1300  CONTINUE
C----- SPACE FOR THE SECTION LIMITS
      L8T= NFL
      I = KCHNFL(12)
C--READ DOWN THE SCALE FACTOR FROM LIST 5
      V=1.
      IF(KEXIST(5))1600,1600,1550
C--LOAD THE CURRENT LIST 5
1550  CONTINUE
      CALL XFAL05
      IF ( IERFLG .LT. 0 ) GO TO 9900
      V=1./STORE(L5O)
1600  CONTINUE
C--SET UP THE INPUT OF LIST 6
      CALL XFAL06(0)
      L6DUMP = L6R
      N6DUMP = N6R
C
      CALL XMOVE(PROCS(14),STORE(L8T),12)
C----- FLOAT THE NUMBER  OF POINTS (THE INTEGER IS STILL IN ISTORE)
      PROCS(18) = FLOAT( ISTORE(L8T+4))
      PROCS(21) = FLOAT( ISTORE(L8T+7))
      PROCS(24) = FLOAT( ISTORE(L8T+10))
C
C----- WRITE THE M/T HEADER  DETAILS
      IF (IOUTAP .GT. 0) THEN
       REWIND (MT1)
       WRITE (MT1) 'INFO  DOWN, ACROSS AND SECTION '
       WRITE (MT1) 'TRAN', (STORE(I), I=L8R, L8R+8)
       WRITE (MT1) 'CELL', (STORE(I), I = L1P1, L1P1+5)
       WRITE (MT1) 'L14 ',
     1 ( STORE(I), STORE(I+2), (STORE(I)+(ISTORE(I+1)-1)*STORE(I+2)),
     1  1. , I = L8T+3, L8T+9, 3)
       WRITE (MT1) 'SIZE', ISTORE(L8T+4), ISTORE(L8T+7),
     1 ISTORE(L8T+10)
      NXNY = ISTORE(L8T+4) * ISTORE(L8T+7)
      ENDIF
C
C--CHECK THAT THERE ARE SOME REASONABLE INTERVALS
      IF(ABS(STORE(L8T+5))-0.0001)1400,1400,1350
1350  CONTINUE
      IF(ABS(STORE(L8T+8))-0.0001)1400,1400,1500
C--INCORRECT INTERVALS
1400  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)
      ENDIF
1450  FORMAT(/25H Illegal x or y divisions)
      GOTO 9910
C--COMPUTE THE NUMBER OF STEPS AND THE FIRST PONTS
1500  CONTINUE
      NX=MAX0(1,ISTORE(L8T+4))
      NY=MAX0(1,ISTORE(L8T+7))
      A=STORE(L8T+3)/ABS(STORE(L8T+5))
      MINX=NINT(A)
      A=STORE(L8T+6)/ABS(STORE(L8T+8))
      MINY=NINT(A)
C--CALCULATE THE STEPS ALONG X AND Y IN THE PLANE
      R=STORE(L8T+5)*TWOPI
      S=STORE(L8T+8)*TWOPI
C
C--SET UP THE MAP AREA
      LN=8
      IREC=8003
      L8=NFL
      MD8=NY
      M8=KCHNFL(MD8*NX)-1
      IREC=8004
      NS=KCHLFL(NCOL)
      M8DUMP = M8
      L8DUMP = L8
      NSDUMP = NS
C
C----- START LOOPING OVER SECTIONS
      DO 3300, ISECT = 1, ISTORE(L8T+10)
      ZCOORD=STORE(L8T+9)
      WRITE(NCAWU, '('' Section at z = '', F6.2)') ZCOORD
C--CALCULATE THE COORDINATES OF THE FIRST POINT
      AMIN(1)=STORE(L8T)+STORE(L8RI)*STORE(L8T+3)+STORE(L8RI+1)
     2 *STORE(L8T+6)+STORE(L8RI+2)*STORE(L8T+9)
      AMIN(2)=STORE(L8T+1)+STORE(L8RI+3)*STORE(L8T+3)+STORE(L8RI+4)
     2 *STORE(L8T+6)+STORE(L8RI+5)*STORE(L8T+9)
      AMIN(3)=STORE(L8T+2)+STORE(L8RI+6)*STORE(L8T+3)+STORE(L8RI+7)
     2 *STORE(L8T+6)+STORE(L8RI+8)*STORE(L8T+9)
      AMIN(1)=AMIN(1)*TWOPI
      AMIN(2)=AMIN(2)*TWOPI
      AMIN(3)=AMIN(3)*TWOPI
C
C--CLEAR THE MAP AREA
      M8 = M8DUMP
      L8 = L8DUMP
      NS = NSDUMP
      DO 1650 I=L8,M8
      STORE(I)=0.
1650  CONTINUE
      W=0.
C
C--START OF THE REFLECTION FETCHING LOOP
1700  CONTINUE
      IF(KFNR(0)) 2600,1750,1750
C--GENERATE THE EQUIVALENT REFLECTIONS FOR THESE INDICES
1750  CONTINUE
      JB=JA
      DO 2000 I=L2,M2,MD2
C--CALCULATE THE NEW INDICES
      STORE(JB)=STORE(M6)*STORE(I)+STORE(M6+1)*STORE(I+3)+STORE(M6+2)
     2 *STORE(I+6)
      STORE(JB+1)=STORE(M6)*STORE(I+1)+STORE(M6+1)*STORE(I+4)
     2 +STORE(M6+2)*STORE(I+7)
      STORE(JB+2)=STORE(M6)*STORE(I+2)+STORE(M6+1)*STORE(I+5)
     2 +STORE(M6+2)*STORE(I+8)
C--CHECK IF THESE INDICES HAVE BEEN FOUND BEFORE
      IF(JB-JA)1950,1950,1800
C--CYCLE THROUGH ALL THE PREVIOUS INDICES
1800  CONTINUE
      JC=JB-NW
      DO 1900 J=JA,JC,NW
      IF(ABS(STORE(J)-STORE(JB))+ABS(STORE(J+1)-STORE(JB+1))
     2 +ABS(STORE(J+2)-STORE(JB+2))-0.01)2000,2000,1850
1850  CONTINUE
      IF(ABS(STORE(J)+STORE(JB))+ABS(STORE(J+1)+STORE(JB+1))
     2 +ABS(STORE(J+2)+STORE(JB+2))-0.01)2000,2000,1900
1900  CONTINUE
C--THIS REFLECTION IS UNIQUE
1950  CONTINUE
      IF (IWT .LE. 0) THEN
            STORE(JB+3)=STORE(M6+3)*V
            STORE(JB+4)=STORE(M6+4)
            STORE(JB+5)=STORE(M6+5)
      ELSE
            STORE(JB+3)=STORE(M6+3)*V*STORE(M6+4)
            STORE(JB+4)=STORE(M6+4)
            STORE(JB+5)=STORE(M6+5)*STORE(M6+4)
      ENDIF
      STORE(JB+6)=STORE(M6+6)-TWOPI*(STORE(JB)*STORE(I+9)+STORE(JB+1)
     2 *STORE(I+10)+STORE(JB+2)*STORE(I+11))
      JB=JB+NW
2000  CONTINUE
      JB=JB-NW
C
C--MAIN LOOP FOR ADDING IN THE GENERATED REFLECTIONS
      DO 2550 I=JA,JB,NW
      GOTO(2100,2150,2200,2250,2300,2050),IN
2050  STOP 275
C--'FO' FOURIER
2100  CONTINUE
      F=STORE(I+3)
      GOTO 2400
C--'FC' FOURIER
2150  CONTINUE
      F=STORE(I+5)
      GOTO 2400
C--'DF' FOURIER
2200  CONTINUE
      F=STORE(I+3)-STORE(I+5)
      GOTO 2400
C--'FO' PATTERSON
2250  CONTINUE
      F=STORE(I+3)*STORE(I+3)
      GOTO 2350
C--'FC' PATTERSON
2300  CONTINUE
      F=STORE(I+5)*STORE(I+5)
C--ACCUMULATE THE ORIGIN FOR SCALING
2350  CONTINUE
      STORE(I+6)=0.
      W=W+F
C--CALCULATE THE TRANSFORMED INDICES
2400  CONTINUE
      X=STORE(I)*STORE(L8RI)+STORE(I+1)*STORE(L8RI+3)+STORE(I+2)
     2 *STORE(L8RI+6)
      Y=STORE(I)*STORE(L8RI+1)+STORE(I+1)*STORE(L8RI+4)+STORE(I+2)
     2 *STORE(L8RI+7)
C--COMPUTE A FEW INTIAL CONSTANTS NEEDED BEFORE ADDING INTO THE MAP
      O=X*R
      P=Y*S
      H=STORE(I)*AMIN(1)-O+STORE(I+1)*AMIN(2)-P+STORE(I+2)*AMIN(3)
     2 -STORE(I+6)
      A=F*COS(H-O-P)
      B=F*COS(H-P)
      C=F*COS(H-O)
      D=F*COS(H)
      O=2.*COS(O)
      P=2.*COS(P)
C
C--MAIN LOOP FOR ADDING INTO THE MAP
      L=L8
      M8=NY-1
C--PASS ALONG THE X ROWS
      DO 2500 J=1,NX
      A1(7)=A1(2)
      A1(2)=A1(15)*A1(2)-A1(1)
      A1(5)=A1(2)
      A1(1)=A1(7)
      A1(7)=A1(4)
      A1(4)=A1(15)*A1(4)-A1(3)
      A1(6)=A1(4)
      A1(3)=A1(7)
      M=L+M8
C--ADD IN ALONG THE Y ROWS
      DO 2450 K=L,M
      A1(7)=A1(6)
      A1(6)=A1(16)*A1(6)-A1(5)
      A1(5)=A1(7)
      STORE(K)=STORE(K)+A1(6)
2450  CONTINUE
      L=L+MD8
2500  CONTINUE
2550  CONTINUE
C--GO BACK FOR MORE REFLECTIONS
      GOTO 1700
C
C--END OF THE MAP  -  CALCULATE THE SCALE FACTORS
2600  CONTINUE
      GOTO(2700,2700,2700,2750,2750,2650),IN
2650  STOP 344
2700  CONTINUE
      W=U*2./STORE(L1P1+6)
      GOTO 2800
2750  CONTINUE
      W=999./W
C
C--MAIN MAP PRINTING ROUTINES
2800  CONTINUE
      IF (IOUTAP .GT. 0) THEN
        WRITE(MT1) NXNY, (STORE(I)*W, I= L8, L8+NXNY-1)
      ENDIF
      JA=MINY
      JB=NY
      JZ=1
      M8=L8
2850  CONTINUE
      JY=MIN0(JB,NCOL)-1
      JC=JA+JY
      CALL XPRTCN
      JD=NS-1
      DO 2900 I=JA,JC
      ISTORE(JD+1)=I
      JD=JD+1
2900  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 2950 ) WTED, CMAPTP(IN) ,
     2 ZCOORD , JZ , ( ISTORE(I) , I = NS , JD )
      ENDIF
2950  FORMAT ( 1X , A, 'Slant Fourier' , 5X , 'Map type is ' , A ,
     2 5X , 'Z =' , F7.3 , 5X , 'Part' , I3 , /// , 8X , 28I4 )
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3000)(IA,I=NS,JD)
      ENDIF
3000  FORMAT(8X,28(3X,A1))
      JE=M8
      JG=MINX
      DO 3200 I=1,NX
      JF=JE+JY
      DO 3100 J=JE,JF
      ISTORE(J)=NINT(STORE(J)*W)
      IF(ISTORE(J)-ITHRES)3050,3100,3100
3050  CONTINUE
      ISTORE(J)=ITHRES
3100  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3150)JG,IA,IB,(ISTORE(J),J=JE,JF)
      ENDIF
3150  FORMAT(/1X,I4,1X,2A1,28I4)
      JE=JE+MD8
      JG=JG+1
3200  CONTINUE
      JZ=JZ+1
      JY=JY+1
      JA=JA+JY
      M8=M8+JY
      JB=JB-JY
C--MORE TO PRINT
      IF(JB)3250,3250,2850
3250  CONTINUE
C----- GET READY FOR NEXT SECTION
      STORE(L8T+9) = STORE(L8T+9) + STORE(L8T+11)
C----- RESTORE REFLECTION ADDRESSES
      N6R = N6DUMP
      L6R = L6DUMP
C----- RESTORE NEW INDEX AREAS
      JA = JADUMP
      JB = JBDUMP
3300  CONTINUE
C
3350  CONTINUE
      CALL XOPMSG (IOPSLA, IOPEND, 201)
      CALL XTIME2(1)
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPSLA , IOPABN , 0 )
      GOTO 3350
9910  CONTINUE
C -- INPUT ERROR
      CALL XOPMSG ( IOPSLA , IOPCMI , 0 )
      GO TO 9900
9920  CONTINUE
C -- SINGULAR MATRIX
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9925 )
      ENDIF
      WRITE ( NCAWU , 9925 )
9925  FORMAT ( 1X , 'Rotation matrix is singular' )
      CALL XERHND ( IERERR )
      GO TO 9900
C
C
      END


CRYSTALS CODE FOR SOLVE
CODE FOR XSFLSE
      SUBROUTINE XSFLSE
C--GENERAL MATRIX INVERSION AND CALCULATION OF SHIFT ROUTINES.
C
C  THESE ROUTINES INVERT THE NORMAL MATRIX AND OUTPUT
C  THE CORRECTED PARAMETERS IN A LIST 24
C
C--THE ADDRESS OF THE PARAMETER GROUP SHIFT STACK IS :
C
C  JC  ADDRESS OF THE FIRST ENTRY.
C  JD  ADDRESS OF THE LAST ENTRY
C
C--THE FORMAT OF THE PARAMETER GROUP SHIFT STACKS IS AS FOLLOWS :
C
C  0  SHIFT FACTOR FOR THIS PARAMETER GROUP, COMPUTED OR FROM LIST 23
C  1  NUMBER OF PARAMETERS REFINED IN THIS GROUP
C  2  SUM OF THE CALCULATED SHIFTS
C  3  SUM OF THE CALCULATED SHIFTS SQUARED
C  4  NUMBER OF CHANGES OF SIGN COMPARED WITH THE LAST CYCLE
C
C--THIS IS REPEATED FOR THE FOLLOWING GROUPS :
C
C  OVERALL PARAMETERS
C  TYPE
C  SERIAL
C  OCC
C  U[ISO]
C  X
C  Y
C  Z
C  U[11]
C  U[22]
C  .
C  U[33]
C
C--THE FORMAT OF THE SHIFT STACK AFTER INVERSION IS :
C
C  0  ADDRESS OF THE INFORMATION FOR THE GROUP OF THIS PARAMETER
C  1  CALCULATED SHIFT
C
C--THIS FORMAT IS REPEATED FOR ALL THE REFINED PARAMETERS
C
C--
C----- NOTE THAT IF STR11 IS USED DOUBLE PRECISION, LENGRP IN
C      LIST11 IN COMMAND FILE MUST BE CHANGED FROM 1 TO 2
C      FOR LHS AND RHS
C      AND I11LEN IN XPRC12
C      DOUBLE PRECISION STR11(1048576)
      DIMENSION STR11(1048576)
C
C
      DIMENSION A1(6)
      DIMENSION ICOM11(16)
      DIMENSION ICOM12(40)
      DIMENSION ICOM24(8)
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 30
      PARAMETER (IDIM30 = 32)
      DIMENSION ICOM30(IDIM30)
      DIMENSION ICOM33(24)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XDATF/NFLD,LFLD,NULD
C      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDATD/XSTR11(1048576)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XWORK/A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,
     2 U,V,W,X,Y,Z
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST11/L11,M11,MD11,N11,L11R,M11R,MD11R,N11R,
     2 L11P,M11P,MD11P,N11P,L11IR,M11IR,MD11IR,N11IR
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XLST23/L23M,M23M,MD23M,N23M,L23EX,M23EX,MD23EX,N23EX,
     2 L23MN,M23MN,MD23MN,N23MN,L23AC,M23AC,MD23AC,N23AC,
     3 L23IC,M23IC,MD23IC,N23IC, L23SP,M23SP,MD23SP,N23SP
      COMMON/XLST24/L24,M24,MD24,N24,L24IR,M24IR,MD24IR,N24IR
      COMMON/XLST30/
     1 L30DR,M30DR,MD30DR,N30DR, L30CD,M30CD,MD30CD,N30CD,
     2 L30RF,M30RF,MD30RF,N30RF, L30IX,M30IX,MD30IX,N30IX,
     3 L30AB,M30AB,MD30AB,N30AB, L30GE,M30GE,MD30GE,N30GE,
     4 L30CL,M30CL,MD30CL,N30CL, L30SH,M30SH,MD30SH,N30SH
      COMMON/XLST33/L33CD,M33CD,MD33CD,N33CD,L33SV,M33SV,MD33SV,N33SV,
     2 L33ST,M33ST,MD33ST,N33ST,L33IB,M33IB,MD33IB,N33IB,
     3 L33V,M33V,MD33V,N33V,L33CB,M33CB,MD33CB,N33CB
      COMMON/XAPK/NWKA,NKA,LKA,COORD(2,14)
      COMMON/XOPK/NWKO,NKO,LKO,OVP(2,6)
      COMMON/XSCALE/NWSC,NSC,LSC,SCALE(2,8)
      COMMON /XLSVAL/ ILSCLN , ILSCLS , ILSCLV , ILSEXI , ILSAVI ,
     2 ILSMSG , ILSNMS , ILSERF , ILSPUF , ILSDLF , ILSOWF , ILSCUR ,
     3 ILSRTF , ILSSET , ILSCLR , ILSOVR , ILSRDY , ILSUPD , ILSRFI
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (STR11(1),XSTR11(1))
C
C
      EQUIVALENCE (A1(1),A)
      EQUIVALENCE (L11,ICOM11(1))
      EQUIVALENCE (L12,ICOM12(1))
      EQUIVALENCE (L30DR,ICOM30(1))
      EQUIVALENCE (ICOM24(1),L24)
      EQUIVALENCE (ICOM33(1),L33CD)
C
C
C
      DATA MW/6/
C
C----- SET THE PRINT THRESHOLDS
      DATA RMAX/3./, SOESD/1./, CCOEF/.8/, RMSSM/ .3/
C
      DATA IVERSN /402/
C
C
C--INITIALISE THE TIMING FUNCTION
      CALL XTIME1(2)
C--READ ANY OTHER PARAMETERS
      IF ( KRDDPV ( ISTORE(NFL),1 )   .LT.   0 ) GO TO 9900
C----- METHOD = 0 FOR CHOLESKI, ELSE 1
      METHOD = ISTORE(NFL)
C--CLEAR THE CORE
      CALL XCSAE
      CALL XRSL
C--LOAD THE CONTROL LISTS
      CALL XFAL23
C--ASSIGN THE LENGTH OF THE COMMON BLOCK FOR LIST 33  -  SFLS CONTROL
      IDIM33=24
      CALL XFAL33
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--PRINT OUT THE PAGE HEADING
      CALL XPRTCN
      I=NINT(STORE(M33V))
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1000)I
      ENDIF
      WRITE(NCAWU,1000)I
1000  FORMAT(33H Matrix inversion and calculation,
     2 41H of the shifts for S.F.L.S. cycle number ,I5)
C--FIND THE 'MAP' PARAMETER
      ISTAT2=ISTORE(M33CD+3)
C----- FIND THE 'PRINT' LEVEL
      ILEVEL=ISTORE(M33CD+7)
      IF (ILEVEL .GE. 0) THEN
      WRITE(NCAWU,3555)
      WRITE(NCAWU,1020) RMAX, SOESD
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3555)
      WRITE(NCWU,1020) RMAX, SOESD
      ENDIF
1020  FORMAT(' Parameters for which the shift ratio exceeds ',F5.2,
     1 ' (SRATIO)',
     2 /      '            and/or the shift-over-esd exceeds ',F5.2,
     3 ' (S/ESD)',
     4 /      '            and/or there is a relatively large shift.',
     5 /' Parameters marked COMPOSITE contain derivatives from ',
     6  'other physical parameters'/)
      ENDIF
C----- SET THE EIGENVALUE FILTERS
      AUGFAC = STORE(M33CD+9)
      FILTER = STORE(M33CD+10)
      DISCRM = STORE(M33CD+11)
C--FIND THE NEW MATRIX FLAG
      JK=ISTORE(M33CD+6)
C--SET UP THE SHIFT AREA
      LN=24
      IREC=1001
      NMW=MD33ST-1
      JC=KCHLFL(MW*NMW)
      JD=JC+(NMW-1)*MW
C--FIND THE POINTERS TO THE SHIFT INFORMATION
      JA=M33ST+1
      JB=M33SV+1
C--SET UP THE PARAMETER GROUP SHIFT LOCATIONS
      DO 1150 I=JC,JD,MW
      STORE(I)=1.
      STORE(I+1)=0.
      STORE(I+2)=0.
      STORE(I+3)=0.
      STORE(I+4)=0.
      STORE(I+5) = 0.
C--CHECK IF A SHIFT FACTOR HAS BEEN GIVEN IN LIST 23
      IF(ISTORE(JA))1050,1100,1100
C--MOVE THE SHIFT FACTOR FROM LIST 23
1050  CONTINUE
      STORE(I)=STORE(JB)
C--INCREMENT THE POINTERS
1100  CONTINUE
      JA=JA+1
      JB=JB+1
1150  CONTINUE
C--LOAD A FEW MORE LISTS
      CALL XFAL01
      CALL XFAL05
      IF (METHOD .EQ. 1) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,1151)  AUGFAC, FILTER, DISCRM
      ENDIF
        WRITE(NCAWU,1151)  AUGFAC, FILTER, DISCRM
1151  FORMAT(1X, ' Eigen filters ', 3(G10.4,3X) )
      ENDIF
C--FORM THE ABSOLUTE LIST 12
      JQ=2
      JS=1
      CALL XFAL12(JS,JQ,JR,JN)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET UP THE POINTER TO THE RESULTS AREA
      JO=JN
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 12
      IDIM12=40
C--LINK LISTS 5 AND 12
      I=KSET52(0,-1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--LOAD THE MATRIX
C----- CLEAR THE MATRIX AREA
      IULN = 11
      CALL XIN11
C--SET THE DIMENSION OF THE CONTROL BLOCK FOR LIST 11
      IDIM11=16
C----- LOAD THE LIST 11 HEADERS
      CALL XLDLST(IULN, ICOM11, IDIM11, 0)
      IF (IERFLG .LT. 0) GOTO 9900
C----- SAVE THE DISK BUFFER ADDRESSES
      M11S  = L11
      M11RS  = L11R
C--SET UP THE ANSWERS AREA
      LN=11
      KO=KADD11(1001,MD11,N12+1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--CHECK FOR AN OLD LIST 24, AND LOAD IT IF POSSIBLE
      L24=NOWT
      MD24=0
      KE=24
      IF(KEXIST(KE))1250,1250,1200
C--AN OLD LIST 24 IS ACCESSIBLE  -  BRING IT DOWN
1200  CONTINUE
      CALL XFAL24
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE NUMBER OF SINGULARITIES TO ZERO INITIALLY
1250  CONTINUE
      JA=0
      JB=JO
      IF(ISTAT2)1300,1350,1300
C--PRINT THE ALLOCATED STORE
1300  CONTINUE
      CALL XPCM(1)
C--SET A FEW LIST 11 CONSTANTS
1350  CONTINUE
      D=STORE(L11P+17)
      IF ( ABS( STORE(L11P + 16)) .LE. ZERO) THEN
            WRITE( NCAWU,1351)
      IF (ISSPRT .EQ. 0) THEN
            WRITE( NCWU,1351)
      ENDIF
1351      FORMAT(//,
     1 ' Insufficient data to properly define variables',/
     2 '          No of observations = ',I10,/
     3 '             No of variables = ',I10,/)
            E = 0.
      ELSE
      E=D/STORE(L11P+16)
C--CHECK THAT THE NUMBER OF DEGREES OF FREEDOM IS POSITIVE
      IF(E)1400,1500,1500
C--NUMBER OF DEGREES IF FREEDOM IS NEGATIVE
1400  CONTINUE
      CALL XERHDR(0)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)STORE(L11P+16)
      ENDIF
      WRITE(NCAWU,1450) STORE(L11P+16)
1450  FORMAT(35H Ill-conditioned problem  -  number,
     2 26H of degrees of freedom is ,F6.0)
      E=0.
      ENDIF
C--CHECK THE TYPE OF LIST 11
1500  CONTINUE
      F=0.0
      JP=ISTORE(L11P+15)
C--CHECK IF THE MATRIX IS OF AN ACCEPTABLE TYPE
      IF ( IABS(JP) .NE. 1 ) GO TO 9910
C--CHECK IF THE DUMMY OVERALL TEMPERATURE FACTOR HAS BEEN REFINED
      IF (KPARAM(1,L12O,M12,M12O,0,L5O)) 1700, 1700, 1750
C--NO REFINEMENT
1700  CONTINUE
      STORE(L11P+22)=0.
      GOTO 1900
C--REFINEMENT  -  CHECK THE MATRIX TYPE
1750  CONTINUE
      IF(JP)1900,1900,1800
C--CALCULATE THE CORRECTION FOR THE DUMMY OVERALL TEMPERATURE FACTOR
C  IGNORING THE SCALE FACTOR INTERACTION
1800  CONTINUE
C----- RESERVE SPACE FOR AND GET DIAGONAL ELEMENT AND VECTOR TERM
      L11C = KADD11 (-101, MD11, 2)
      JY=KBLCK(ISTORE(M12O))
      CALL XDOWNF ( JY, XSTR11(MD11*L11C+1-MD11), MD11)
      JX=L11R+ISTORE(M12O)-1
      CALL XDOWNF ( JX, XSTR11(MD11*L11C+1), MD11)
      STORE(L11P+22) = XSTR11(L11C+1) / XSTR11(L11C)
C--CHECK IF A 'WEIGHT' IS TO BE APPLIED
      IF(ISTORE(M12+1)-1)1850,1900,1850
1850  CONTINUE
      STORE(L11P+22)=STORE(L11P+22)*STORE(M12O+1)
1900  CONTINUE
C----- SAVE THE FREE ADDRESSES IN THE MATRIX WORK AREA
      LFLDS = LFLD
      NFLDS = NFLD
      M12B=L12B
      JT=1
      M24=L24
C
C
C----- WE ARE GOING TO START UPDATING LIST 11
      CALL XLSALT ( IULN , 0 , 0 , ILSOWF , ILSUPD )
C--BEGIN THE INVERSION  -  A BLOCK AT A TIME
C----- SET THE RUNNING ADDRESS FOR STEPPING THROUGH THE MATRIX
      M11DB = M11S
      M11RDB = M11RS
C
      DO 3500 JZ=1,N12B
C---- RESET MATRIX AREA
      LFLD = LFLDS
      NFLD = NFLDS
C----- INDICATE WE MAY NEED A CAPTION LATER
      ICAPT = 0
C--INVERT THE  MATRIX BLOCK IF IT IS NECESSARY
      JY=ISTORE(M12B+1)
      NELEM = (JY*(JY+1))/2
C
      IF ( (JP .LE. 0) .OR.(METHOD .EQ. 0) ) THEN
C-----  RE-USE OF MSTRIX OR CHOLESKI - GET SOME CORE FOR THE UPPER TRIAN
            L11C = KADD11(-101,MD11,NELEM)
      ELSE
C-----  GET SOME CORE FOR THE FULL MATRIX
            L11C = KADD11( -101, MD11, JY*JY)
C----- ALLOCATE SPACE FOR EIGEN VALUES
            IVAL = KADD11( 1012, MD11, JY)
C----- ALLOCATE SPACE FOR SCALE VECTOR
            ISCL = KADD11( 1013, MD11, JY)
C----- ALLOCATE SPACE FOR EGENVECTORS
            IVEC = KADD11( 1014, MD11, JY*JY)
C----- ALLOCATE WORK SPACE
            IWRK = KADD11( 1015, MD11, 5*JY)
            IF ( IERFLG .LT. 0 ) GO TO 9900
      ENDIF
      M11 = L11C
      INM = L11C
C--BRING DOWN THE MATRIX - REMEMBER MD11 INDICATES SINGLE OR DOUBLE PREC
      CALL XDOWNF (M11DB, XSTR11 (MD11*L11C-MD11+1), MD11*NELEM)
      IF (JP .GT. 0 ) THEN
C----- CHOOSE INVERTOR
        IF (METHOD .LE. 0) THEN
            CALL XCHOLS(JY, L11C, KO)
        ELSE
C----- EXPAND  LOWER TRIANGLE OF FULL SQUARE
            CALL XMTCVT (INM, JY, 1, MD11)
            CALL XFILTR
     1      (STR11(INM), STR11(IVAL), STR11(IVEC), STR11(ISCL),
     2      STR11(IWRK), JY, AUGFAC, FILTER, DISCRM, ILEVEL  )
C----- COMPRESS INVERTED MATRIX
            CALL XMTCVT (INM, JY, 2, MD11)
        ENDIF
      ENDIF
2050  CONTINUE
      L11RC = KADD11(-102,MD11R, JY)
      M11R=L11RC
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--BRING DOWN THE VECTOR
      CALL XDOWNF (M11RDB, XSTR11 (MD11R*L11RC-MD11R+1), MD11R*JY)
      CALL XSOLVE(JY, L11C, M11R, KO)
C--SPREAD OUT THE NEW SHIFTS TO ALLOW THE STORAGE OF OTHER DATA
      JV=JO+JY+JY-2
      JW=KO+JY-1
      DO 2100 JU=1,JY
      STORE(JV)=STR11(JW)
      ISTORE(JV+1)=NOWT
      JV=JV-2
      JW=JW-1
2100  CONTINUE
      JQ=M11
C--SEARCH THROUGH THE ATOMIC PARAMETERS FOR EACH OF THE
C  LEAST SQUARES PARAMETERS IN TURN
C
C----- SET UP THE START ADDRESSES
      M5 = L5 - MD5
      M12 = L12O
      L12A = NOWT
      JS = 0
C
C
      DO 3450 JX=1,JY
      S=0.0
      C=0.
C----- LOOK FOR PATAMETER 'JT'
      IHIT = KFLSP (JT, JS, JR, JO, JX, JC, JQ, JZ, ICAPT,
     1 E, C, A, S, RMAX, SOESD, ILEVEL, MW)
      IF (IHIT .EQ. 0) GOTO  3450
C--PARAMETER HAS BEEN FOUND  -  CALCULATE THE RESULTS
C----- SUM OF SQUARES SHIFT / ESD
      F=F+S*S
C----- IF SINGULAR, INCREMENT COUNTER
      IF (A .LT. ZEROSQ) JA = JA + 1
C
C--STORE THE SHIFT INFORMATION FOR THIS COORDINATE
      JD=ISTORE(JO+1)
      STORE(JD+1)=STORE(JD+1)+1.
      STORE(JD+2)=STORE(JD+2)+STORE(JO)
      STORE(JD+3)=STORE(JD+3)+STORE(JO)*STORE(JO)
      STORE(JD+5) = AMAX1(STORE(JD+5), ABS(STORE(JO)) )
C--CHECK IF THE SIGN HAS CHANGED COMPARED WITH THE LAST CYCLE
      IF(C)3350,3400,3400
C--THE SIGN HAS CHANGED
3350  CONTINUE
      STORE(JD+4)=STORE(JD+4)+1.
C--UPDATE THE ADDRESS AND CONTROL FLAGS
3400  CONTINUE
      JO=JO+2
      JQ=JQ+JY-JX+1
      JT=JT+1
      M24=M24+MD24
3450  CONTINUE
C----- PUT THE GOODIES BACK ON THE DISK
      CALL XUPF (M11DB, XSTR11 (MD11*L11C-MD11+1), MD11*NELEM)
      CALL XUPF (M11RDB, XSTR11 (MD11R*L11RC-MD11R+1), MD11R*JY)
C--CHANGE TO THE NEXT BLOCK - UPDATE DISK ADDRESSES
      M11DB = M11DB +((ISTORE(M12B+1)+1)*ISTORE(M12B+1))/2
      M11RDB = M11RDB+ISTORE(M12B+1)
      M12B=M12B+MD12B
3500  CONTINUE
C
C
C
C--PRINT THE OVERALL STATISTICS
      ICONVG = 0
      WRITE(NCAWU,3550)F,JA
3550  FORMAT(/5X,'Sum of the squares of the ratios',
     2 ' (Shift/E.S.D.)  =',F11.2,/5X,4HWith,I4,'  singularities')
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3550)F,JA
      WRITE(NCWU,3555)
      ENDIF
C----- RMS SHIFT/ESD
      RMSS=SQRT(F/STORE(L11P+23))
      IF(RMSS-1) 3556,3556,3559
3556  CONTINUE
3554  FORMAT(/' The rms (shift/esd) is ',F10.6,'.'/,
     1 ' Do you need to continue refinement?')
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,3554)RMSS
      ENDIF
      WRITE(NCAWU,3554)RMSS
      IF(RMSS -  RMSSM) 3557, 3557, 3559
3557  CONTINUE
      ICONVG = 1
      WRITE( NCAWU,3558) RMSSM
      IF (ISSPRT .EQ. 0) THEN
      WRITE( NCWU,3558) RMSSM
      ENDIF
3558  FORMAT(' The rms (shift/esd) is less than the target (',
     1 F10.6,' ).',/
     2 '           The refinement has probably converged.'/)
3559  CONTINUE
3555  FORMAT(/ ' The SHIFT RATIO is the shift calculated for this',
     2 ' cycle',/,' divided by the corresponding',
     3 ' shift for the last cycle.')
      ISTORE(L11P+15)=-1
C----- NOW WRITE BACK THE HEADER INDICATING THAT WE ARE UPDATING IT
C----- RESTORE THE DISK ADDRESSES
      L11 = M11S
      L11R = M11RS
      ISTAT = KLSCHK ( IULN , 0 , 0 , ILSEXI , ILSNMS , I , IERNOP )
      IF ( ISTAT .GT. 0 ) CALL XLSALT ( IULN , 0 , 0 , ILSOWF , ILSUPD )
      CALL XWLSTD(IULN,ICOM11,IDIM11,-1,0)
      CALL XMKOWF(11,0)
      CALL XALTES(11,1)
C
C--UPDATE THE LIST 23 ON THE DISC AND CHECK TERMINATIONS
      JD=JC+(NMW-1)*MW
C----- CHECK FOR TOO MANY SINGULARITIES
      IF (JA .LE. ISTORE(L23MN)) THEN
C----- SINGULARITY SITUATION IS OKAY
        IF (JA .GT. 0 ) THEN
            WRITE(NCAWU, 3650) JA, ISTORE(L23MN)
3650        FORMAT( ' The number of singularities, ', I4,
     1 ' is within the permited limit ', I4)
            IF ( ISSPRT .EQ. 0 ) THEN
              WRITE(NCWU, 3650) JA, ISTORE(L23MN)
            ENDIF
            JA=0
        ENDIF
      ELSE
            WRITE(NCAWU, 3651) JA, ISTORE(L23MN)
3651        FORMAT( ' The number of singularities, ', I4,
     1 ' exceeds the permited limit ', I4/
     2 ' Terminating after this cycle')
            IF ( ISSPRT .EQ. 0 ) THEN
              WRITE(NCWU, 3651) JA, ISTORE(L23MN)
            ENDIF
      ENDIF
C--UPDATE THE VALUES OF THE VARIOUS DETERMINED FUNCTIONS
3700  CONTINUE
      STORE(M33V+3)=F
      JU=1
C--CHECK IF THIS IS THE FIRST CYCLE TO SEE IF DIFFERENCES CAN BE CALCULA
      IF(ISTORE(L33CB+1))3800,3800,3750
C--CHECK IF THE LAST CYCLE INVOLVED REFINEMENT
3750  CONTINUE
      IF(ISTORE(M33CD-1)-1)3800,3850,3800
C--NO REFINEMENT LAST TIME
3800  CONTINUE
      JU=-1
C--CHECK IF SINGULARITIES ALREADY INDICATE TERMINATION
3850  CONTINUE
C--CHECK THE CONDITIONS THAT MUST BE MET BY ALL CYCLES
3900  CONTINUE
      M23AC=L23AC
      JE=M33V
      JG=2
      JF=MD23AC/JG
      I = 0
      J = 0
      DO 4050 I=1,JF
C--CHECK THE MINIMUM VALUE
      IF(STORE(M23AC)-STORE(JE+1))3950,3950,4300
C--CHECK THE MAXIMUM VALUE
3950  CONTINUE
      IF(STORE(M23AC+1)-STORE(JE+1))4300,4000,4000
C--UPDATE FOR THE NEXT CONDITION
4000  CONTINUE
      JE=JE+1
      M23AC=M23AC+JG
4050  CONTINUE
      I = 0
C--CHECK IF WE SHOULD CHECK INTER-CYCLE CONDITIONS
      IF(JU)4400,4400,4100
C--LOOP OVER THE INTER-CYCLE CONDITIONS
4100  CONTINUE
      M23IC=L23IC
      JH=M33V-MD33V
      JE=M33V
C--LOOP OVER EACH
      DO 4250 J = 1, JF
      A=STORE(JH+1)-STORE(JE+1)
C--CHECK THE MIMIMUM
      IF(STORE(M23IC)-A)4150,4150,4300
C--CHECK THE MAXIMUM
4150  CONTINUE
      IF(STORE(M23IC+1)-A)4300,4200,4200
C--UPDATE
4200  CONTINUE
      JE=JE+1
      JH=JH+1
      M23IC=M23IC+JG
4250  CONTINUE
      J = 0
C--ALL OKAY  -  BRANCH OUT
      GOTO 4400
C--ONE OR MORE TERMINATION CONDITIONS HAVE BEEN SATISFIED
4300  CONTINUE
      ISTORE(L33CB)=N33IB
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4350) I,J
      ENDIF
      WRITE(NCAWU,4350) I,J
4350  FORMAT(/' ***** Terminating after this cycle ',
     2 ' ***** LIST 23 condition.' /,
     3 ' All-cycle condition No ', I4, 'Inter-cycle condition No ',I4)
C--REWRITE LIST 23 TO THE DISC
4400  CONTINUE
      IF ((ICONVG .EQ. 1) .OR. ( JA .NE. 0)) ISTORE(L33CB) = N33IB
      CALL XWLSTD(33,ICOM33,IDIM33,-1,-1)
      CALL XDUMP
C
C--START OF SHIFT STATISTICS PART
      D=1./AMAX1(ZEROSQ,STORE(L11P+26))
      E=1./AMAX1(ZEROSQ,STORE(L11P+29))
C--CALCULATE THE HAMILTON WEIGHTED R-VALUES
      A=100.*SQRT(STORE(L11P+25)*D)
      B=100.*SQRT(STORE(L11P+28)*E)
      IF ((STORE(L11P+26) + STORE(L11P+29)) .LE. ZERO) THEN
            C = 0.
      ELSE
      C=100.*SQRT((STORE(L11P+25)+STORE(L11P+28))/(STORE(L11P+26)
     2 +STORE(L11P+29)))
      ENDIF
C--DETERMINE THE NUMBER OF OBSERVATIONS ETC.
      I=NINT(STORE(L11P+23))
      J=NINT(STORE(L11P+24))
      K=NINT(STORE(L11P+27))
      L=J+K
      M=NINT(STORE(L11P+16))
C--PRINT THE HEADING AND THE VARIOUS DETAILS AMASSED
      CALL XPRTCN
      IF (C .LE. ZERO) THEN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4448)
      WRITE(NCWU,4447)
      ENDIF
      WRITE(NCAWU,4449)
      WRITE(NCAWU,4447)
4447  FORMAT(/,1X ,' You have used neither restraints nor reflections'/)
      ENDIF
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4448)
      WRITE(NCWU,4450)I,M,J,K,L,STORE(L11P+25),STORE(L11P+28),
     2 STORE(L11P+17),A,B,C
      WRITE(NCWU,4448)
      ENDIF
C
      WRITE(NCAWU,4449)
      WRITE(NCAWU,4450)I,M,J,K,L,STORE(L11P+25),STORE(L11P+28),
     2 STORE(L11P+17),A,B,C
      WRITE(NCAWU,4449)
4448  FORMAT(//60(2H *)//)
4449  FORMAT(//40(2H *)//)
4450  FORMAT( 15H Statistics for,I6,26H  least squares parameters/
     1 /43X,7HGiving ,I6,20H  Degrees of freedom///
     2 33X,11HReflections,7X,11H Restraints,10X,6HTotals//
     3 23H Number of observations,3I18,/
     4 /22H Minimisation function,E23.7,2E18.7//
     5 26H Hamilton weighted R-value,F16.3,2F18.3)
C----- UPDATE LIST 30
      CALL XFAL30
      STORE(L30RF +1 ) = A
      STORE(L30RF +2 ) = STORE(L11P+23)
      STORE(L30RF +3 ) = MAX( STORE(L30RF+3), STORE(L11P+23))
      STORE(L30RF +4 ) = SQRT(STORE(L11P+17) / STORE(L11P+16))
      STORE(L30RF +7 ) = RMSS
      STORE(L30RF +8 ) = STORE(L11P+24)
      IF (STORE(L11P+24) .GT. ZERO) STORE(L30RF +9 ) = STORE(L11P+25)
      IF (STORE(L11P+27) .GT. ZERO) STORE(L30RF +10 ) = STORE(L11P+28)
      IF (C .GT. ZERO)              STORE(L30RF +11 ) = STORE(L11P+17)
      CALL XWLSTD ( 30, ICOM30, IDIM30, -1, -1)
C--OUTPUT THE INFORMATION FOR THE CALCULATED SHIFTS
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4500)
      ENDIF
4500  FORMAT(////18H Calculated shifts)
C--COMPUTE THE TOTALS TO BE PRINTED
      Y=0.
      Z=0.
      DO 4550 I=JC,JD,MW
      Y=Y+STORE(I+1)
      STORE(I+1)=1./AMAX1(STORE(I+1),1.)
      STORE(I+2)=STORE(I+2)*STORE(I+1)
      STORE(I+3)=SQRT(STORE(I+3)*STORE(I+1))
      Z=Z+STORE(I+4)
      STORE(I+4)=STORE(I+4)*STORE(I+1)*100.
4550  CONTINUE
C--CONVERT THE POSN. COORDS. TO ANGSTROM
      JF=JC+5*MW
      JG=L1P1
      DO 4600 I=1,3
      A1(I)=STORE(JF+2)*STORE(JG)
      A1(I+3)=STORE(JF+3)*STORE(JG)
      JF=JF+MW
      JG=JG+1
4600  CONTINUE
      JE=JC+3*MW
C--PRINT THE RESULTS
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4650)STORE(JC+2),(STORE(I+2),I=JE,JD,MW),(A1(I),I=1,3)
     2 ,STORE(JC+3),(STORE(I+3),I=JE,JD,MW),(A1(I),I=4,6)
4650  FORMAT(/13X,7HOverall,4X,3HOcc,5X,6HU[iso],4X,1HX,8X,1HY,8X,1HZ,
     2 7X,5HU[11],4X,5HU[22],4X,5HU[33],4X,5HU[23],4X,5HU[13],4X,
     3 5HU[12]//11H Mean      ,12F9.5/38X,3F9.5//11H R.M.S.    ,12F9.5/
     4 38X,3F9.5,A1//11H Multiplier,12F9.5///14H Shifts for X,,
     5 49H Y and Z are expressed in fractions and angstrom./)
      WRITE(NCWU,4660) STORE(JC+5),(STORE(I+5),I=JE,JD,MW),
     1 STORE(JC),(STORE(I),I=JE,JD,MW)
      ENDIF
4660  FORMAT(/11H Maximum   ,12F9.5,
     1       //6H Shift,
     2       /11H factor    ,12F9.5)
C--CHECK IF WE MUST PRINT THE SIGN CHANGE INFORMATION
      IF(M24)4800,4800,4700
4700  CONTINUE
      Z=Z/Y*100.
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,4750)STORE(JC+4),(STORE(I+4),I=JE,JD,MW),Z
      ENDIF
4750  FORMAT(/10H Reversals,12F9.2///
     2 44H Reversals is the percentage of shifts whose,
     3 41H signs have changed since the last cycle,,8H and is ,F6.2,
     4 20H for all parameters.)
C--COMPUTE THE SHIFT FACTORS TO APPLY IF ANY
4800  CONTINUE
      J=M33ST+1
      K=M33SV+1
C--STORE THE SHIFTS INFORMATION IN ANGSTROM FOR X, Y AND Z
      JF=JC+5*MW
      DO 4850 I=4,6
      STORE(JF+3)=A1(I)
      JF=JF+MW
4850  CONTINUE
C--SEE IF THE SHIFTS HAVE TO BE CALCULATED
      DO 5100 I=JC,JD,MW
      IF(ISTORE(J))5050,4900,4950
C--CHECK IF THE R.M.S. VALUE IS TOO LARGE
4900  CONTINUE
      IF(STORE(K)-STORE(I+3))4950,5050,5050
C--CALCULATE THE NEW SHIFT FACTOR
4950  CONTINUE
      IF(STORE(I+3)-ZEROSQ)5050,5050,5000
5000  CONTINUE
      STORE(I)=STORE(K)/STORE(I+3)
C--COMPUTE THE NEW TOTALS AFTER THE NEW SHIFT FACTOR HAS BEEN APPLIED
5050  CONTINUE
      STORE(I+2)=STORE(I+2)*STORE(I)
      STORE(I+3)=STORE(I+3)*STORE(I)
      J=J+1
      K=K+1
5100  CONTINUE
C--SHUFFLE THE RESULTS FOR X, Y AND Z
      JF=JC+5*MW
      JG=L1P1
      DO 5150 I=1,3
      A1(I)=STORE(JF+2)*STORE(JG)
      A1(I+3)=STORE(JF+3)
      STORE(JF+3)=STORE(JF+3)/STORE(JG)
      JF=JF+MW
      JG=JG+1
5150  CONTINUE
C--PREPARE THE LIST 24 FOR OUTPUT
      CALL XCSAE
      N24=N12
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 24
      IDIM24=8
      CALL XCELST(24,ICOM24,IDIM24)
C--SET UP THE SHIFTS IN THE OUTPUT AREA
      J=L24
      K=L24+(N24-1)*MD24
      DO 5250 I=J,K,MD24
C--SET THE CALCULATED SHIFT
      STORE(I)=STORE(JB)
C--COMPUTE THE APPLIED SHIFT
      L=ISTORE(JB+1)
      STORE(I+1)=STORE(JB)*STORE(L)
      JB=JB+2
5250  CONTINUE
      CALL XWLSTD(24,ICOM24,IDIM24,-1,0)
C----- PRINT LARGE CORRELATION COEFFICIENTS
      CALL XPR11L(CCOEF)
5275  CONTINUE
C
      CALL XOPMSG( IOPINV, IOPEND, IVERSN)
C
      CALL XTIME2(2)
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPINV , IOPABN , 0 )
      GO TO 5275
9910  CONTINUE
C -- LIST 11 WRONG TYPE
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 9915 )
      ENDIF
      WRITE ( NCAWU , 9915 )
9915  FORMAT ( 1X , 'List 11 is the wrong type' )
      CALL XERHND ( IERERR )
      GO TO 9900
C
      END
C
C
C
CODE FOR XFILTR
      SUBROUTINE XFILTR (A, B, C, U, W, M, AUGFAC, FILTER, DISC, ILEVEL)
C----- INVERT NORMAL MATRIX BY EIGENVALUE FILTERING
C
C      N.x = y
C      N = V.D.V'
C      N-1 = V.D-1.V'
C      x = N-1. y
C
C      THIS IS NOT AS EFFICIENT AS SOLVING THE EQUATIONS DIRECTLY FROM
C      EIGEN FACTORS (SEE BELOW), BUT IS NECESSARY IF WE NEED TO SAVE
C      THE INVERSE FOR THE ESDS.
C      N.x = y
C      V.D.V'.x = y
C      D.V'.x = V'. y      (V' = V-1)
C      V'.x = D-1.V'. y
C      x = V.D-1.V'. y
C
C----- A(M,M) NORMAL MATRIX - UPPER TRIANGLE USED AS WORK SPACE, LOWER
C             RETURNED UNCHANGED.
C----- B(M)   EIGENVALUES
C----- C(M,M) EIGENVECTORS
C----- U(M)   SCALING VECTOR
C----- W(5*M) WORK AREA
C----- AUGFAC AUGMENTATION (MARQUARDT) FACTOR    E.G. 0.0000
C----- FILTER FILTER LEVEL                       E.G. 0.00005
C----- DISC   DISCONTINUITY VALUE                E.G. 100
C----- ILEVEL MONITOR LEVEL -1 OFF,  2 HIGH
C
      DIMENSION A(M,M), B(M), C(M,M), U(M), W(5*M)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
C
C
C PRE-SCALE NORMAL MATRIX.
C GET INVERSE DIAGONAL SCALING MATRIX U FROM NORMAL MATRIX.
C THE ELEMENTS ARE 1./SQRT(DIAGONAL ELEMENT OF NORMAL MATRIX)
C
      DO 10 I=1,M
        U(I)=1.0
        IF (ABS(A(I,I)) .GT. ZERO) U(I)=1.0 / SQRT(A(I,I))
10    CONTINUE
C
C SCALE MATRIX BY U
C
      DO 20 J=1, M
        UJ=U(J)
        DO 30 K=1,J
          A(J,K) = A(J,K) * U(K) * UJ
30      CONTINUE
20    CONTINUE
C
C-----  EA06C RETURNS EIGENVECTORS AND EIGENVALUES
C
      CALL EA06C(A, B, C, M, M, M, W)
C
C
      IF (ILEVEL .GE.2) THEN
        WRITE (NCAWU,1000)
      IF (ISSPRT .EQ. 0) THEN
        WRITE (NCWU,1000)
      ENDIF
1000  FORMAT(/,' Eigen values of Normal matrix')
      IF (ISSPRT .EQ. 0) THEN
        WRITE (NCWU, 1010) (B(I),I=1,M)
      ENDIF
        WRITE (NCAWU, 1010) (B(I),I=1,M)
1010  FORMAT((1X,10F8.3/))
      IF (ISSPRT .EQ. 0) THEN
        WRITE (NCWU,1020)
      ENDIF
1020  FORMAT(/ , ' Eigen vectors of Normal Matrix' )
        DO 1040 J = 1, M
      IF (ISSPRT .EQ. 0) THEN
          WRITE (NCWU,1030) J
      ENDIF
      IF (ISSPRT .EQ. 0) THEN
          WRITE (NCWU, 1015) (C(I,J),I=1,M)
      ENDIF
1030  FORMAT (/, ' Column ', I5)
1015  FORMAT((1X,20F6.2/))
1040  CONTINUE
      ENDIF
C
C                  EIGENVALUE FILTERING
C
C----- SEE IF THERE IS A DISCONTINUITY IN THE MAGNITUDES OF THE
C      EIGENVALUES. IF THERE IS, SET ALL THE SMALL ONES TO ZERO.
C
C
C----- FIND LARGEST AND SMALLEST
      Y = B(1)
      Z = B(1)
      II = 1
      IK = 1
      DO 100 I = 2, M
       IF ( B(I) .GT. Y ) THEN
         II = I
         Y = B(II)
       ELSE IF (B(I) .LT. Z) THEN
         IK = I
         Z = B(II)
       ENDIF
100   CONTINUE
C
C----- FIND NEXT LARGEST
      DO 120 J = 1, M
         X = Z
         IJ = IK
         DO 110 I = 1, M
           IF( (B(I).GT.X) .AND. (B(I).LT.Y) )  THEN
             X = B(I)
             IJ = I
           ENDIF
110      CONTINUE
C-----   LOOK FOR A DISCONTINUITY
         IF ( Y .GT. (DISC * X)) THEN
C-----   RESET ALL SMALLER TO ZERO AND EXIT LOOP
      IF (ISSPRT .EQ. 0) THEN
         WRITE(NCWU,111) II, Y, IJ, X
      ENDIF
         WRITE(NCAWU,111) II, Y, IJ, X
111      FORMAT(1X,' Discontinuity in eigenvector list ',/,
     1    12X, 2(I5, G11.4,4X))
           DO 115 K = 1, M
             IF(B(K) .LE. X ) THEN
      IF (ISSPRT .EQ. 0) THEN
                  WRITE(NCWU,112)  K, B(K)
      ENDIF
                  WRITE(NCAWU,112)  K, B(K)
 112              FORMAT(1X,' Zeroing eigen value ',I5,4X, G11.4,
     1            ' Eigen vectors are: ')
                  B(K) = 0.0
      IF (ISSPRT .EQ. 0) THEN
                  WRITE (NCWU, 1015) (C(I,K),I=1,M)
      ENDIF
             END IF
115        CONTINUE
           GOTO 130
         ELSE
C-----     EXCHANGE SMALLER
           Y = X
           II = IJ
         ENDIF
120    CONTINUE
130    CONTINUE
C
C------ INVERT DIAGONAL MATRIX, REJECTING LOW EIGENVALUES AND
C------ AUGMENTING OTHERS.
C
      DO 40 I=1,M
        IF(B(I) .GT. FILTER) THEN
              B(I) = 1.0 / (B(I) + AUGFAC)
        ELSE
              B(I) = 0.0
        ENDIF
40    CONTINUE
C
C----- TRANSPOSE 'C' TO INCREASE EFFICIENCY OF INNER LOOP LATER
       DO 55 J = 1,M
              DO 50  I = J, M
                X = C(J,I)
                C(J,I) = C(I,J)
                C(I,J) = X
50            CONTINUE
55       CONTINUE
C
C----- FORM       N-1 = U.V.D-1.V'.U'
C
      DO 80 J = 1, M
        UJ = U(J)
        DO 70 I = 1, M
          SUM = 0.0
          DO 60 K = 1,M
            SUM =  SUM + ( B(K) * C(K,I) * C(K,J) )
60        CONTINUE
         A(I,J) = SUM * U(I) * UJ
70      CONTINUE
80    CONTINUE
C
      RETURN
      END
CODE FOR XMTCVT
      SUBROUTINE XMTCVT(IADD, N, ITYPE, ILEN)
C
C----- ILEN LENGTH OF REPRESENTATION OF VALUE (MD11)
C      IF ITYPE = 1
C----- EXPAND A LOWER TRIANGLE STARTING AT IADD AND STORED BY COLUMNS
C      INTO LOWER HALF OF SQUARE SYMETRIC MATRIX STARTING AT SAME ADDRES
C      ELSE
C----- CONTRACT A SQUARE MATRIX INTO A LOWER TRIANGLE
C
C----- NOTE THAT IF STR11 IS USED DOUBLE PRECISION, LENGRP IN
C      LIST11 IN COMMAND FILE MUST BE CHANGED FROM 1 TO 2
C      FOR LHS AND RHS
C      AND I11LEN IN XPRC12
C      DOUBLE PRECISION STR11(1048576)
      DIMENSION STR11(1048576)
      COMMON/XDATF/NFLD,LFLD,NULD
C      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDATD/XSTR11(1048576)
      EQUIVALENCE (STR11(1),XSTR11(1))
C
C
C
      JADD = IADD - 1
      DO 10 L = 2, N
      IF (ITYPE .EQ. 1) THEN
            M = N - L + 2
      ELSE
            M = L
      ENDIF
C---- NUMBER OF ITEMS IN COLUMN M
            NIM = N - M + 1
C----- ADDRESS OG LAST ELEMENT OF COLUMN M OF LOWER TRIANGLE
            ITL = JADD + M* (2*N - M +1) /2
C----- ADDRESS OF DIAGONAL ELEMENT OF COLUMN M OF LOWER TRIANGLE
            ITD = ITL - NIM + 1
C----- ADDRESS OF LAST ELEMENT IN COLUMN M IN SQUARE MATRIX
            ISL = JADD + M * N
C----- ADDRESS OF FIRST ELEMENT IN COLUMN M IN SQUARE MATRIX
            ISF = ISL - N + 1
C----- ADDRESS OF DIAGONAL ELEMENT IN COLUMN M IN SQUARE MATRIX
            ISD = ISL - NIM + 1
C----- MOVE THE COLUMN ALONG
      IF (ITYPE .EQ. 1) THEN
            CALL XMOVE (XSTR11(ITD), XSTR11(ISD), NIM*ILEN)
      ELSE
            CALL XMOVE (XSTR11(ISD), XSTR11(ITD), NIM*ILEN)
      ENDIF
10    CONTINUE
C
      END
C
CODE FOR KFLSP
      FUNCTION KFLSP (JT, JS, JR, JO, JX, JC, JQ, JZ, ICAPT,
     1 E, C, A, S, RMAX, SOESD, ILEVEL, MW)
C
C----- FIND A LEAST SQUARES PARAMETER IN LIST 5 AND LIST 12
C      AND OUTPUT DETAILS
C      RETURN VALUE GT ZERO IF SUCCESSFULL
C
C      JT            ABSOLUTE L.S. PARAMETER NO.
C      JS            PHYSICAL PARAMETER NO FROM WHICH TO START SEARCH
C      JR            SINGULARITY SYMBOL
C      JO            SHIFT ADDRESS
C      JX            RELATIVE PARAMETER NO
C      JC            SHIFT DETAILS ADDRESS
C      JQ            ADDRESS IN LIST 11
C      JZ             BLOCK NUMBER
C      ICAPT          CAPTION FLAG
C      E             SIG W DELSQ / N-M
C      C             SHIFT RATIO
C      A             ESD
C      S             SHIFT/ESD
C      ILEVEL        MONITORING LEVEL
C      MW            NO OF ITEMS PER ENTRY IN SHIFT DETAILS
C
C------ ALL EXCEPT JT ARE UPDATED BY THIS ROUTINE
C
      CHARACTER *6 FLAG, JQUEST, IBLANK, SRATIO, IOESD,  TOOBIG
C----- NOTE THAT IF STR11 IS USED DOUBLE PRECISION, LENGRP IN
C      LIST11 IN COMMAND FILE MUST BE CHANGED FROM 1 TO 2
C      FOR LHS AND RHS
C      AND I11LEN IN XPRC12
C      DOUBLE PRECISION STR11(1048576)
      DIMENSION STR11(1048576)
      DIMENSION ICOM12(40)
      DIMENSION ISTORE(131072)
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      DIMENSION IP(4)
      DIMENSION PARVAL(13)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XLST24/L24,M24,MD24,N24,L24IR,M24IR,MD24IR,N24IR
      COMMON/XDATF/NFLD,LFLD,NULD
C      COMMON/XDATD/XSTR11(1048576)
      COMMON/XDATD/XSTR11(1048576)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XAPK/NWKA,NKA,LKA,COORD(2,14)
      COMMON/XOPK/NWKO,NKO,LKO,OVP(2,6)
      COMMON/XSCALE/NWSC,NSC,LSC,SCALE(2,8)
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (STR11(1),XSTR11(1))
      EQUIVALENCE (L12,ICOM12(1))
      DATA IQUEST /'????'/
      DATA JQUEST /'??????'/, IBLANK /'      '/
      DATA SRATIO /'SRATIO'/, IOESD  /'S/ESD '/
      DATA TOOBIG /'LARGE '/
C----- MAXIMUM SHIFT VALUES
      DATA PARVAL /0.,0.,1.,.05,.25,.25,.25,.05,.05,.05,.05,.05,.05/
C
      KFLSP = 0
      IHIT = 0
C----- SET A BLANK
      JR = IB
      FLAG = IBLANK
C----- SET MONITORING FLAGS
      IPRINT = 0
      IF (ILEVEL .GT. 0) THEN
            ITYPE = 1
      ELSE
            ITYPE = 0
      ENDIF
C----- SAVE THE INITIAL VALUES
      IP(1) = M5
      IP(2) = M12
      IP(3) = L12A
      IP(4) = JS
2150  CONTINUE
C--CHECK IF THIS GROUP CONTAINS ANY REFINED PARAMETERS
      IF(ISTORE(M12+1))3250,3250,2200
C--COMPUTE THE ADDRESS OF THE FIRST PART FOR THIS GROUP
2200  CONTINUE
      L12A=ISTORE(M12+1)
C--CHECK IF THIS PART CONTAINS ANY REFINABLE PARAMETERS
2250  CONTINUE
      IF(ISTORE(L12A+3))3200,2300,2300
C--SET UP THE CONSTANTS TO PASS THROUGH THIS PART
2300  CONTINUE
      MD12A=ISTORE(L12A+1)
      JU=ISTORE(L12A+2)
      JV=ISTORE(L12A+3)
      JS=ISTORE(L12A+4)+1
C--SEARCH THIS PART OF THIS ATOM
      DO 3150 JW=JU,JV,MD12A
C--CHECK IF THIS IS THE PARAMETER THAT WE ARE SEARCHING FOR
      IF(JT-ISTORE(JW))3100,2350,3100
C
2350  CONTINUE
C------ A HIT
      IHIT = IHIT + 1
      IF ( IHIT .EQ. 1 ) THEN
C---------  SAVE THE HIT VALUES
            IP(1) = M5
            IP(2) = M12
            IP(3) = L12
            IP(4) = JS
            KFLSP = JW
C---------  COMPUTE ESD
            A=STR11(JQ)
            A=SQRT(A*E)
C--CHECK IF WE ARE USING AN OLD LIST 24
            IF(M24 .GT. 0) THEN
C---------- USING AN OLD LIST 24 - CHECK THAT SHIFT IS NOT SINGULAR
C---------- COMPUTE THE RATIO OF THE TWO SHIFTS
            IF (ABS(STORE(M24)) .GT. ZEROSQ) C = STORE(JO) / STORE(M24)
            ENDIF
C--IF THIS PARAMETER IS NOT SINGULAR,  COMPUTE THE SHIFT/E.S.D. RATIO
            IF ( A .GT. ZEROSQ) THEN
                  S = STORE(JO) / A
            ELSE
C----------  IT IS SINGULAR
                  JR = IQUEST
                  FLAG = JQUEST
                  ITYPE = 1
            ENDIF
C--------- THE SHIFT RATIO
            IF (ABS (C) .GT. RMAX) THEN
                  ITYPE = 1
                  FLAG = SRATIO
            ENDIF
C--------- THE SHIFT / ESD
            IF (ABS (S) .GT. SOESD) THEN
                  ITYPE = 1
                  FLAG = IOESD
            ENDIF
            IF (ITYPE .NE. 1) THEN
C------------- CHECK IF SHIFT TOO BIG
                  IF((M12 .NE. L12O) .AND. (M12 .NE. L12LS) .AND.
     1            (M12 .NE. L12ES) .AND. (M12 .NE. L12BS)) THEN
C------------- ATOMIC PARAMETER
                  IF (JS .GE. 5 .AND. JS .LE. 7) THEN
                        IF (ABS( STORE(JO) ) * STORE( L1P1 + JS -4 )
     1                      .GT. PARVAL(JS) ) THEN
                                    ITYPE=1
                                    FLAG = TOOBIG
                        ENDIF
                  ELSE
                        IF (ABS(STORE(JO)) .GT. PARVAL(JS)) THEN
                                    ITYPE = 1
                                    FLAG = TOOBIG
                        ENDIF
                  ENDIF
                  ELSE
                        IF (M12 .EQ. L12O) THEN
C------------- AN OVERALL PARAMETER
                              M5G = L5O
                        ELSE IF (M12 .EQ. L12LS) THEN
C------------- LAYER SCALE
                              M5G = L5LS
                        ELSE IF (M12 .EQ. L12ES) THEN
C------------  ELEMENT SCALES
                              M5G = L5ES
                        ELSE IF (M12 .EQ. L12BS) THEN
C------------  BATCH SCALE
                              M5G = L5BS
                        ELSE IF (M12 .EQ. L12CL) THEN
C------------  CELL PARAM
                              M5G = L5CL
                        ELSE IF (M12 .EQ. L12PR) THEN
C------------  PROFILE PARAM
                              M5G = L5PR
                        ELSE
C------------  EXTINCTION PARAM
                              M5G = L5EX
                        ENDIF
                        IF(ABS(STORE(JO)) .GT. .1*STORE(M5G-1+JS))
     1                  THEN
                            ITYPE = 1
                            FLAG = TOOBIG
                        ENDIF
                  ENDIF
            ENDIF
C--------- NOW ADJUST THE PRINT LEVEL IF NECESSARY
            IF ( ITYPE .EQ. 1 ) IPRINT = 1
      ENDIF
C
      IF (ICAPT .EQ. 0) THEN
        IF (IPRINT .EQ. 1) THEN
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,1950)JZ
      ENDIF
1950    FORMAT(/6H Block,I4/8X,6HParam.,4X,11HRel. param.,4X,
     2  11HCalc. shift,4X,11HShift ratio,4X,6HE.S.D.,5X,12HShift/E.S.D.,
     3  4X,4HType,3X,6HSerial,4X,10HCoordinate/)
        ICAPT = 1
        ENDIF
        IF (ITYPE .EQ. 1) THEN
        WRITE(NCAWU,1952) JZ
1952    FORMAT(6H Block,4X,I4,
     1  /10X,5HParam,5H RELP,10H Calcshift,1X,10HShiftRatio,
     2  9H   ESD    ,10HShift/ESD ,5H Type,7H Serial)
        ICAPT = 1
        ENDIF
      ENDIF
C
C--CHECK IF THIS IS AN OVERALL PARAMETER
      IF(M12-L12O)2800,2700,2800
C--PRINT FOR OVERALL PARAMETERS
2700  CONTINUE
      IF (IHIT .EQ. 1) ISTORE(JO+1) = JC
      IF ((IPRINT .EQ. 1 ) .AND. (ISSPRT .EQ. 0) ) THEN
       WRITE(NCWU,2750)FLAG,JT,JX,STORE(JO),C,A,S,(OVP(JRR,JS),JRR=1,2)
      ENDIF
      IF (ITYPE .EQ. 1 )
     1 WRITE(NCAWU,2790)FLAG,JT,JX,STORE(JO),C,A,S,(OVP(JRR,JS),JRR=1,2)
2750  FORMAT(1X,A6,I5,I12,F18.5,F13.2,F13.5,F14.2,26X,2A4,I3)
2790  FORMAT(1X,A6,1X,2I5,2(F10.4,F10.2),12X,2A4,I3)
      GOTO 3300
C
C--CHECK IF THIS A SCALE OR GENERAL PARAMETER
2800  CONTINUE
      NB=17
      DO 2950 NA=1,NSC
      IF(ICOM12(NB)-M12)2900,2850,2900
C
C--LAYER OR ELEMENT BATCH OR PARAMETER PRINT
2850  CONTINUE
      IF (IHIT .EQ. 1) ISTORE(JO+1) = JC
      IF ((IPRINT .EQ. 1 ) .AND. (ISSPRT .EQ. 0) ) THEN
       WRITE(NCWU,2750)FLAG,JT,JX,STORE(JO),C,A,S,
     2 (SCALE(NC,NA+2),NC=1,2),JS
      ENDIF
      IF (ITYPE .EQ. 1)
     1 WRITE(NCAWU,2790)FLAG,JT,JX,STORE(JO),C,A,S,
     2 (SCALE(NC,NA+2),NC=1,2),JS
      GOTO 3300
C--UPDATE FOR THE NEXT SCALE
2900  CONTINUE
      NB=NB+4
2950  CONTINUE
C
C--PRINT FOR ATOMS
      JD=JC+MW*JS
      IF (IHIT .EQ. 1) THEN
            ISTORE(JO+1) = JD
            IF ( (IPRINT .EQ. 1) .AND. (ISSPRT .EQ. 0)) THEN
             WRITE(NCWU,3050)FLAG,JT,JX,STORE(JO),C,A,S,STORE(M5),
     2       STORE(M5+1),(COORD(JRR,JS),JRR=1,NWKA)
            ENDIF
            IF (ITYPE .EQ. 1)
     1       WRITE(NCAWU,3090)FLAG,JT,JX,STORE(JO),C,A,S,STORE(M5),
     2       STORE(M5+1),(COORD(JRR,JS),JRR=1,NWKA)
3050  FORMAT(1X,A6,I5,I12,F18.5,F13.2,F13.5,F14.2,8X,A4,F7.0,7X,3A4)
3090  FORMAT(1X,A6,1X,2I5,2(F10.4,F10.2),1X,A4,F6.0,1X,3A4)
      ELSE IF (IHIT .EQ. 2) THEN
      IF (ISSPRT .EQ. 0) THEN
            IF (IPRINT .EQ. 1) WRITE(NCWU,3051)
      ENDIF
            IF (ITYPE .EQ. 1) WRITE(NCAWU,3091)
3051  FORMAT(1X,107X,'Composite',/)
3091  FORMAT(1X,69X,'Composite',/)
      ENDIF
      GOTO 3300
C
C
3300  CONTINUE
C
C
C
C--INCREMENT TO THE NEXT PARAMETER OF THIS PART
3100  CONTINUE
      JS=JS+1
3150  CONTINUE
C--CHANGE PARTS FOR THIS ATOM OR GROUP
3200  CONTINUE
      L12A=ISTORE(L12A)
C--CHECK IF THERE ARE ANY MORE PARTS FOR THIS ATOM OR GROUP
      IF(L12A)3250,3250,2250
C--MOVE TO THE NEXT GROUP OR ATOM
3250  CONTINUE
      M5=M5+MD5
      M12=ISTORE(M12)
      IF (M12 .LE. 0)   THEN
C----- RESTORE VALUES FROM INITIAL HIT
            M5  = IP(1)
            M12 = IP(2)
            L12 = IP(3)
            JS  = IP(4)
            RETURN
      ELSE
            GOTO 2150
      ENDIF
      END
CODE FOR XSFLSG
      SUBROUTINE XSFLSG
C--SOLUTION ROUTINES
C
C--THESE ROUTINES READ DOWN LIST 24 FROM THE DISC AND APPLY
C  THE RESULTS
C
C--
      DIMENSION ISTORE(131072)
      DIMENSION ICOM05(40)
      DIMENSION ICOM12(40)
C--SET THE DIMENSION OF THE COMMON BLOCK FOR LIST 30
      PARAMETER (IDIM30 = 32)
      DIMENSION ICOM30(IDIM30)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLISTI/L0,M0,MD0,N0,LN,LSN,IREC,LEF,LSTLEF,MAPS
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XPDS/APD(14),BPD(14)
C
C
      COMMON /XWORK/F,BC(11),IBC(14)
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XCHARS/IB,IH,NUMB(10),IPLUS,MINUS,IA,ISLASH,IEXP,
     2 ILB,IRB,ICOMMA,IEQUAL,IPOINT,ISEMIC,IQ,IX(3)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST11/L11,M11,MD11,N11,L11R,M11R,MD11R,N11R,
     2 L11P,M11P,MD11P,N11P,L11IR,M11IR,MD11IR,N11IR
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XLST30/
     1 L30DR,M30DR,MD30DR,N30DR, L30CD,M30CD,MD30CD,N30CD,
     2 L30RF,M30RF,MD30RF,N30RF, L30IX,M30IX,MD30IX,N30IX,
     3 L30AB,M30AB,MD30AB,N30AB, L30GE,M30GE,MD30GE,N30GE,
     4 L30CL,M30CL,MD30CL,N30CL, L30SH,M30SH,MD30SH,N30SH
      COMMON/XLST23/L23M,M23M,MD23M,N23M,L23EX,M23EX,MD23EX,N23EX,
     2 L23MN,M23MN,MD23MN,N23MN,L23AC,M23AC,MD23AC,N23AC,
     3 L23IC,M23IC,MD23IC,N23IC, L23SP,M23SP,MD23SP,N23SP
      COMMON/XLST24/L24,M24,MD24,N24,L24IR,M24IR,MD24IR,N24IR
      COMMON/XLST33/L33CD,M33CD,MD33CD,N33CD,L33SV,M33SV,MD33SV,N33SV,
     2 L33ST,M33ST,MD33ST,N33ST,L33IB,M33IB,MD33IB,N33IB,
     3 L33V,M33V,MD33V,N33V,L33CB,M33CB,MD33CB,N33CB
      COMMON/XAPK/NWKA,NKA,LKA,COORD(2,14)
      COMMON/XOPK/NWKO,NKO,LKO,OVP(2,6)
      COMMON/XSCALE/NWSC,NSC,LSC,SCALE(2,8)
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
      EQUIVALENCE (L5,ICOM05(1))
      EQUIVALENCE (L12,ICOM12(1))
      EQUIVALENCE (L30DR,ICOM30(1))
C
C
      DATA IVERSN / 300 /
C
C
C--INITIALISE THE TIMING ROUTINES
      CALL XTIME1(2)
C--READ THE CONTROL DATA FOR THIS ROUTINE
      IF ( KRDDPV ( ISTORE(NFL),1 )   .LT.   0 ) GO TO 9910
      IPRINT=ISTORE(NFL)
C--LOAD LIST 33 TO FIND THE PRINT VARIABLE
      CALL XFAL33
      IF ( IERFLG .LT. 0 ) GO TO 9900
      ISTAT2=ISTORE(M33CD+3)
C----- FIND THE LISTING LEVEL
      ILEVEL=ISTORE(M33CD+7)
C----- LOAD LIST 23 TO GET UMIN
      CALL XFAL23
C--FIND THE MINIMUM ALLOWED TEMPERATURE FACTOR
      UMIN=STORE(L23AC+8)
C----- SAVE THE TOLERANCE AND UPDATE VALUES
      STOLER = STORE(L23SP+5)
      IUPDAT = ISTORE(L23SP+1)
C--CLEAR THE CORE
      CALL XCSAE
      CALL XRSL
C----- SAVE SOME SPACE FOR THE U AXES
      IADDU = KCHLFL (4)
C--LOAD A FEW LISTS
      CALL XFAL01
      CALL XFAL05
      IF ( IERFLG .LT. 0 ) GO TO 9900
C----- SET THE OCCUPANCIES
      IF (IUPDAT .GE. 0) THEN
        I = KSPINI( -1, STOLER)
C----- SAVE SOME WORK SPACE
        J =NFL
        I = KCHNFL(40)
        M5 = L5
        DO 1160 I = 1, N5
          IF (IUPDAT .GE. 0)
     1      IGSTAT =KSPGET ( STORE(J), STORE(J+10), ISTORE(J+20),
     2      STORE(J+30), MGM, M5, IUPDAT, NUPDAT)
          M5 = M5 + MD5
1160  CONTINUE
        NFL= J
      ENDIF
C
C
C--LOOP OVER EACH ATOM CHECKING TEMPERATURE FACTORS
C--CHECK THAT THERE IS AT LEAST ONE ATOM IN LIST 5
      IF (N5 .LE. 0) GOTO 6050
      M5=L5
      DO 6300 I=1,N5
      IF (ABS(STORE(M5+3)) .LE. UISO) THEN
C--CHECK THE SMALLEST U AXIS
            CALL XEQUIV ( 1, M5, MD5, IADDU )
            IF (STORE(IADDU+1) .LT. UMIN) THEN
C--THIS ANISOTROPIC TEMPERATURE FACTOR IS NOT ALLOWED
                  STORE(M5+3) = UMIN + ZERO
            ENDIF
      ELSE
C--CHECK THE ISOTROPIC TEMPERATURE FACTOR
            IF(STORE(M5+3) .LE. UMIN) THEN
C--THIS U[ISO] VALUE IS OUT OF RANGE
                  STORE(M5+3) = UMIN + ZERO
            ENDIF
      ENDIF
      M5 = M5 + MD5
6300  CONTINUE
6050  CONTINUE
C--FORM THE ABSOLUTE LIST 12
      JQ=0
      JS=1
      CALL XFAL12(JS,JQ,JR,JN)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--LINK LIST 5 AND 12
      I=KSET52(0,-1)
C--SET A PRINT CONTROL VARIABLE
      IF ( IERFLG .LT. 0 ) GO TO 9900
      JA=2
C--CHECK IF THE E.S.D.'S ETC. ARE TO BE PRINTED
      IF(IPRINT)1100,1150,1100
C--ONLY PRINT THE PARAMETERS
1100  CONTINUE
      JA=1
C--BRING DOWN THE MATRIX
1150  CONTINUE
      CALL XFAL11(1,1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--FETCH A FEW CONSTANTS FROM THE MATRIX
      F=STORE(L11P+17)/STORE(L11P+16)
      B=STORE(L11P+22)
      IF(ISTAT2)1200,1250,1200
C--PRINT THE ALLOCATED STORE
1200  CONTINUE
      CALL XPCM(1)
C--PRINT OUT A FEW CAPTIONS
1250  CONTINUE
      CALL XPRTCN
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1300)(IB,I=1,JA)
      ENDIF
1300  FORMAT(48H Generation and output of the new parameter list//
     2 10H Format : ,5X,14HNew coordinate,2A1/15X,13HApplied shift/15X,
     3 17HCalculated E.S.D./15X,18HE.S.D. in angstrom)
C--BRING DOWN THE SHIFT LIST
      CALL XFAL24
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--SET THE POINTER FOR THE ACCUMULATION OF THE E.S.D. DATA
      JS=NFL
C
C--SET UP THE FORMAT AND BEGIN THE APPLICATION OF THE SHIFTS
      DO 1350 I=1,MD5O
      BC(I)=0.0
1350  CONTINUE
C--OUTPUT THE RESULTS FOR THE OVERALL PARMAETERS
      M12=L12O
      CALL XAPPLY(L5O,MD5O,1)
      IF ( IERFLG .LT. 0 ) GO TO 9900
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1400)MD5O
      ENDIF
C----- SAVE THE 'FLACK' INFORMATION IN LIST 30
      IF (BPD(5) .GE. ZERO) THEN
        IF (  KEXIST ( 30 ) .GE. 1 )   CALL XFAL30
        IF (KHUNTR (30,0, IADDL,IADDR,IADDD, -1) .EQ. 0) THEN
            IF( MD30GE .GE. 6) THEN
              STORE(L30GE+6) = STORE(L5O+4)
              STORE(L30GE+7) = BPD(5)
              CALL XWLSTD ( 30, ICOM30, IDIM30, -1, -1)
            ENDIF
        ENDIF
      ENDIF
1400  FORMAT(///1H ,I2,22H  Overall parameter(s)/)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)((OVP(I,J),I=1,2),J=1,NKO)
      ENDIF
1450  FORMAT(3H   ,5(1X,2A4),5X,2A4,5X,6(1X,2A4))
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)
      ENDIF
      J=L5O+MD5O-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1500)(STORE(I),I=L5O,J)
      ENDIF
1500  FORMAT(2X,5F9.5,E15.5,3X,6F9.5)
C--CHECK IF ALL THE INFORMATION IS TO BE PRINTED
      IF(IPRINT)1700,1550,1700
C--PRINT THE E.S.D.'S AND SHIFTS
1550  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1500)(APD(I),I=1,MD5O)
      ENDIF
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1500)(BPD(I),I=1,MD5O)
      ENDIF
C--CHECK ON THE DUMMY OVERALL TEMPERATURE FACTOR
      IF(KPARAM(1,L12O,L12A,M12A,0,L5O)) 1700, 1700, 1600
C--CALCULATE THE NECESSARY CORRECTION TERM
1600  CONTINUE
      JX=(ISTORE(M12A)-1)*MD24+L24
      B=STORE(JX+1)-B
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1650)B
      ENDIF
1650  FORMAT(/46H Correction to isotropic temperature factor = ,F9.5)
      GOTO 1900
1700  CONTINUE
C--CHECK ON THE OVERALL TEMPERATURE FACTOR
      IF(KPARAM(2,L12O,L12A,M12A,0,L5O)) 1900, 1900, 1750
C--CHECK IF THERE ARE ANY ATOMS IN LIST 5
1750  CONTINUE
      IF(N5)1900,1900,1800
C--APPLY THE NEW VALUE TO ALL THE ATOMS
1800  CONTINUE
      M5=L5
      DO 1850 JX=1,N5
      STORE(M5+3)=STORE(L5O+2)
      M5=M5+MD5
1850  CONTINUE
C--CHECK ON THE LAYER, ELEMENT AND BATCH SCALE FACTORS
1900  CONTINUE
      J=17
      K=17
C--LOOP OVER EACH TYPE OF SCALE FACTOR
      DO 2100 I=1,NSC
      IF(ICOM05(J+2))2050,2050,1950
C--PRINT A CAPTION
1950  CONTINUE
      IF (I .LE. 3) THEN
      IF (ISSPRT .EQ. 0) THEN
            WRITE(NCWU,2000)ICOM05(J+2),(SCALE(L,I+2),L=1,2)
      ENDIF
      ELSE
      IF (ISSPRT .EQ. 0) THEN
            WRITE(NCWU,2001)ICOM05(J+2),(SCALE(L,I+2),L=1,2)
      ENDIF
      ENDIF
2000  FORMAT(///1H ,I2,2X,2A4, ' Scale Factors')
2001  FORMAT(///1H ,I2,2X,2A4, ' Parameters')
C--SET THE POINTERS TO THE SCALES OF INTEREST
      M5A=ICOM05(J)
      MD5A=ICOM05(J+2)
      M12=ICOM12(K)
C--APPLY THE SHIFT DATA
      CALL XAPSCL(1,IPRINT)
      IF ( IERFLG .LT. 0 ) GO TO 9900
C--UPDATE FOR THE NEXT TYPE OF SCALE
2050  CONTINUE
      J=J+4
      K=K+4
2100  CONTINUE
C
C--WRITE THE CAPTION FOR THE ATOMS
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2150)N5
      ENDIF
2150  FORMAT(///1H ,I5,9H  atom(s)/)
C--CHECK IF THERE ARE ANY ATOMS IN LIST 5
      IF(N5)2950,2950,2200
C--THERE ARE SOME ATOMS  -  PRINT THE PARAMETER TYPES
2200  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2250)((COORD(I,J),I=1,2),J=1,NKA)
      ENDIF
2250  FORMAT(3H   , 14(1X,2A4))
C--SET UP THE CONSTANTS INVOLVING THE DUMMY TEMPERATURE CORRECTION
      JY=L1C
      DO 2300 JX=1,3
      BC(JX)=0.0
      BC(JX+2)=0.0
      BC(JX+5)=B
      BC(JX+8)=B*STORE(JY)
      JY=JY+1
2300  CONTINUE
      BC(2)=B
      M5=L5
      M12=L12
      M5A=L5+2
C--MAIN LOOP FOR PROCESSING THE ATOMS
      DO 2900 I=1,N5
      MD5A=M5+NKA-1
      N5A=NKA-2
      U=STORE(M5+3)
      CALL XAPPLY(M5A,N5A,-1)
C--CHECK WHETHER ISO- OR ANISO- PRINT IS REQUIRED
C----- ISO OR ANISO ATOM - TO FIND NUMBER OF KEYS
C---- SET NUMBER TO ISO
      IKEY=5
      IF(ABS(U)-UISO)2302,2303,2303
2302  CONTINUE
C----- ANISO
      IKEY=11
2303  CONTINUE
C----- CHECK LISTING LEVEL
      IF(ILEVEL) 2305,2305,2330
2305  CONTINUE
C----- CHECK IF ANY PARAMETER HAS AN ESD
      DO 2320 J=1,IKEY
      IF(BPD(J)-.000001)2320,2320,2330
2320  CONTINUE
C----- ALL ESD TOO SMALL- NO NEED TO PRINT
      GOTO 2850
2330  CONTINUE
C----- WE NEED A PRINT
      IF(ABS(U)-UISO)2550,2350,2350
C--ISO- PRINT
2350  CONTINUE
      MD5A=M5+6
      N5A=5
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2400)(STORE(J),J=M5,MD5A)
      ENDIF
2400  FORMAT(/5X,A4,F9.0,1X,11F9.5)
C--CHECK IF THE E.S.D.'S ETC. ARE TO BE PRINTED
      IF(IPRINT)2850,2450,2850
C--PRINT THE SHIFTS AND E.S.D.'S
2450  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2500)(APD(J),J=1,N5A)
      ENDIF
2500  FORMAT(19X,11F9.5)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2500)(BPD(J),J=1,N5A)
      ENDIF
      GOTO 2750
C--ANISO- PRINT
2550  CONTINUE
      MD5A=M5+2
      N5A=M5+NKA-3
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2600)(STORE(J),J=M5,MD5A),(STORE(J+2),J=MD5A,N5A)
      ENDIF
2600  FORMAT(/5X,A4,F9.0,1X,F9.5,9X,10F9.5)
C--CHECK IF THE E.S.D.'S ARE TO BE PRINTED
      IF(IPRINT)2850,2650,2850
2650  CONTINUE
      N5A=NKA-2
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2700)APD(1),(APD(J-2),J=5,NKA)
      ENDIF
2700  FORMAT(19X,F9.5,9X,10F9.5)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2700)BPD(1),(BPD(J-2),J=5,NKA)
      ENDIF
C--PRINT THE POSITIONAL E.S.D.'S IN ANGSTROM
2750  CONTINUE
      BPD(3)=BPD(3)*STORE(L1P1)
      BPD(4)=BPD(4)*STORE(L1P1+1)
      BPD(5)=BPD(5)*STORE(L1P1+2)
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,2800)(BPD(J),J=3,5)
      ENDIF
2800  FORMAT(37X,3F9.5)
C--UPDATE FOR THE NEXT ATOM
2850  CONTINUE
      M12=ISTORE(M12)
      M5=M5+MD5
      M5A=M5A+MD5
2900  CONTINUE
C--END OF THE UPDATING  -  PREPARE TO OUTPUT A NEW LIST 5
2950  CONTINUE
C--SET THE LENGTH OF THE COMMON BLOCK FOR LIST 5
      IDIM05=40
C--OUTPUT THE NEW LIST 5
      CALL XWLSTD(5,ICOM05,IDIM05,0,-1)
C----- CHECK THE ANISO TFS
C----- SET THE AUXILLIARY LIST 5 ADDRESSES
      L5A=L5
      N5A=N5
      MD5A=MD5
      M5A=M5
      CALL XPRAXI( -1, 1, 0, L5A, MD5A, N5A, 0, 0)
2975  CONTINUE
      CALL XOPMSG ( IOPGNP , IOPEND , IVERSN )
      CALL XTIME2(2)
      RETURN
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPGNP , IOPABN , 0 )
      GO TO 2975
9910  CONTINUE
      CALL XOPMSG ( IOPGNP , IOPCMI , 0 )
      GO TO 9900
C
      END
C
CODE FOR XAPSCL
      SUBROUTINE XAPSCL(IFIRST,IPRINT)
C--CALCULATE AND APPLY THE SHIFTS FOR LAYER OF ELEMENT SCALES
C
C  IFIRST  THE NUMBER OF THE FIRST SCALE THAT CAN BE USED
C  IPRINT  IF NOT ZERO, THEN ONLY THE NEW PARAMETERS ARE PRINTED.
C
C--VARIOUS CONTROL VARIABLES MUST BE SET :
C
C  M5A     ADDRESS OF THE FIRST SCALE
C  MD5A    THE NUMBER OF SCALES
C  M12     ADDRESS OF THE GROUP HEADER FOR THE SCALES
C
C--
      DIMENSION ISTORE(131072)
C
C
      DIMENSION BBC(14)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
C
      COMMON /XWORK/F,BC(11),IBC(14)
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST11/L11,M11,MD11,N11,L11R,M11R,MD11R,N11R,
     2 L11P,M11P,MD11P,N11P,L11IR,M11IR,MD11IR,N11IR
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XLST24/L24,M24,MD24,N24,L24IR,M24IR,MD24IR,N24IR
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
      EQUIVALENCE (BBC(1),IBC(1))
C
C--SET THE REFINEMENT POINTER TO INDICATE THAT REFINEMENT IS BEING DONE
      ND=0
C--CHECK IF THIS GROUP CONTAINS ANY PARTS
      IF(ISTORE(M12+1))1000,1000,1050
C--NO REFINEMENT FOR THIS PARAMETER GROUP
1000  CONTINUE
      ND=-1
1050  CONTINUE
      NA=IFIRST
      NB=0
C--CHECK IF THERE ARE ANY MORE SCALES TO LOOK AT
1100  CONTINUE
      IF(MD5A)1150,1150,1200
1150  CONTINUE
      RETURN
C--ALTER THE ADDRESSES FOR EACH OF THE PARTS
1200  CONTINUE
      L12A=ISTORE(M12+1)
C--CHECK IF THERE ARE ANY PARTS TO PROCESS
      IF(ND)1350,1250,1250
1250  CONTINUE
      ISTORE(L12A+2)=ISTORE(L12A+2)+NB*ISTORE(L12A+1)
      ISTORE(L12A+4)=ISTORE(L12A+4)+NB
C--CHECK IF THERE ANY MORE PARTS
      IF(ISTORE(L12A))1350,1350,1300
1300  CONTINUE
      L12A=ISTORE(L12A)
      GOTO 1250
C--CALCULATE THE NUMBER OF SCALES HERE AND OUTPUT A CAPTION
1350  CONTINUE
      NC=MIN0(MD5A,11)
      DO 1400 I=1,NC
      IBC(I)=NA+I-1
      APD(I)=0.
      BPD(I)=0.
1400  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1450)(IBC(I),I=1,NC)
      ENDIF
1450  FORMAT(//1H ,I6,10I9)
C--CHECK IF ANY MORE SCALES HAVE BEEN REFINED
      IF(ND)1700,1500,1500
1500  CONTINUE
      L12A=ISTORE(M12+1)
      IF(ISTORE(L12A+2)-ISTORE(L12A+3))1550,1550,1700
1550  CONTINUE
      DO 1600 I=1,NC
      BBC(I)=BC(I)
      BC(I)=0.
1600  CONTINUE
      NE=1-NB
      CALL XAPPLY(M5A,NC,NE)
      IF ( IERFLG .LT. 0 ) GO TO 9900
      DO 1650 I=1,NC
      BC(I)=BBC(I)
1650  CONTINUE
C--PRINT THE RESULTS
1700  CONTINUE
      NE=M5A+NC-1
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1750)(STORE(I),I=M5A,NE)
      ENDIF
1750  FORMAT(/2X,11F9.5)
C--CHECK IF THE E.S.D.'S ETC. ARE TO BE PRINTED
      IF(IPRINT)1900,1800,1900
C--PRINT THE SHIFTS AND E.S.D.'S
1800  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1850)(APD(I),I=1,NC)
      ENDIF
      IF (ISSPRT .EQ. 0) THEN
      WRITE(NCWU,1850)(BPD(I),I=1,NC)
      ENDIF
1850  FORMAT(2X,11F9.5)
C--UPDATE FOR THE NEXT ROW
1900  CONTINUE
      MD5A=MD5A-NC
      M5A=M5A+NC
      NA=NA+NC
      L12A=ISTORE(M12+1)
C--CHECK IF THE LIST 12 NEEDS RESTORING
      IF(ND)2050,1950,1950
1950  CONTINUE
      ISTORE(L12A+2)=ISTORE(L12A+2)-NB*ISTORE(L12A+1)
      ISTORE(L12A+4)=ISTORE(L12A+4)-NB
C--CHECK IF THERE ARE ANY MORE PARTS
      IF(ISTORE(L12A))2050,2050,2000
2000  CONTINUE
      L12A=ISTORE(L12A)
      GOTO 1950
2050  CONTINUE
      NB=NB+NC
      GOTO 1100
9900  CONTINUE
C -- ERRORS
      RETURN
C
      END
C
CODE FOR XAPPLY
      SUBROUTINE XAPPLY(LP,NPAR,IBIAS)
C--APPLY THE CALCULATED SHIFTS
C
C  APD    LOCATION OF THE APPLIED SHIFTS
C  BPD    LOCATION OF THE E.S.D.'S
C  LP     LOCATION OF THE PARAMETERS TO BE CORRECTED
C  NPAR   NUMBER OF PARAMETERS TO BE CORRECTED
C  IBIAS  RELATIVE VALUE TO OBTAIN THE FIRST VALUE IN LOCATION 1 OF APD
C
C--'BC' IS USED TO STORE THE CORRECTIONS TO THE T.F.'S
C
C  THE FOLLOWING VARIABLES ARE USED :
C
C  L24 SET ON ENTRY
C  JP
C
C  JR
C  JS  SET ON ENTRY FOR WORK SPACE
C  JT
C  JU
C  .
C  .
C  JZ
C
C--REQUIRES M12 SET ON ENTRY
C
C--
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
C
C
      COMMON /XWORK/F,BC(11),IBC(14)
      COMMON/XWORKA/JA,JB,JC,JD,JE,JF,JG,JH,JI,JJ,JK,JL,JM,JN,
     2 JO,JP,JQ,JR,JS,JT,JU,JV,JW,JX,JY,JZ,NA,NB,NC,ND,NE,NF,NG,NH,
     3 NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,NV,NW,NX,NY,NZ
      COMMON/XPDS/APD(14),BPD(14)
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST11/L11,M11,MD11,N11,L11R,M11R,MD11R,N11R,
     2 L11P,M11P,MD11P,N11P,L11IR,M11IR,MD11IR,N11IR
      COMMON/XLST12/L12,M12,MD12,N12, L12A,M12A,MD12A,N12A,
     2 L12B,M12B,MD12B,N12B, L12O,M12O,MD12O,N12O,
     3 L12LS,M12LS,MD12LS,N12LS, L12ES,M12ES,MD12ES,N12ES,
     4 L12BS,M12BS,MD12BS,N12BS, L12CL,M12CL,MD12CL,N12CL,
     5 L12PR,M12PR,MD12PR,N12PR, L12EX,M12EX,MD12EX,N12EX
      COMMON/XLST24/L24,M24,MD24,N24,L24IR,M24IR,MD24IR,N24IR
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C--CLEAR THE TEMPORARY STORAGE
C
      DO 1000 JX=1,NPAR
      APD(JX)=0.0
      BPD(JX)=0.0
1000  CONTINUE
C--CHECK IF ANY COORDINATES HAVE BEEN REFINED
      IF(ISTORE(M12+1))1100,1100,1050
1050  CONTINUE
      L12A=ISTORE(M12+1)
      IF(ISTORE(L12A+3))1100,1150,1150
1100  CONTINUE
      RETURN
1150  CONTINUE
      MD12A=ISTORE(L12A+1)
      JU=ISTORE(L12A+2)
      JV=ISTORE(L12A+3)
      JT=ISTORE(L12A+4)
      JP=JT+IBIAS
C--SEARCH FOR THE CONTRIBUTIONS TO EACH PARAMETER IN TURN
      DO 1850 JW=JU,JV,MD12A
      IF(ISTORE(JW))1800,1800,1200
1200  CONTINUE
      APD(JP)=BC(JP)
      JX=JW
      JY=L12A
      JR=JS
      JZ=0
C--CHECK IF THIS PART FOR THIS PARAMETER HAS BEEN REFINED
1250  CONTINUE
      IF(ISTORE(JX))1550,1550,1300
C--CHECK IF THERE IS ENOUGH CORE FOR THIS CONTRIBUTOR
1300  CONTINUE
      IF ( JR + 4 - LFL )  1400 , 1400 , 9910
C--ADD THE CONTRIBUTIONS INTO THE STACK
1400  CONTINUE
      ISTORE(JR)=ISTORE(JX)
      ISTORE(JR+2)=KBLCK(ISTORE(JR))
      ISTORE(JR+1)=M12B
      STORE(JR+3)=1.
      IF(ISTORE(JY+1)-1)1450,1500,1450
1450  CONTINUE
      STORE(JR+3)=STORE(JX+1)
1500  CONTINUE
      JR=JR+4
      JZ=JZ+1
C--CALCULATE THE CONTRIBUTION OF THIS PART TO THE SHIFT
      JX=(ISTORE(JX)-1)*MD24+L24
      APD(JP)=APD(JP)+STORE(JX+1)*STORE(JR-1)
C--CARRY ONTO THE NEXT PART
1550  CONTINUE
      JY=ISTORE(JY)
      IF(JY)1700,1700,1600
C--MOVE ONTO THE NEXT PART  -  CHECK FOR REFINEMENT OF THIS PARAMETER
1600  CONTINUE
      JX=ISTORE(JY+2)+ISTORE(JY+1)*(JT-ISTORE(JY+4))
      IF(JX-ISTORE(JY+2))1550,1250,1650
1650  CONTINUE
      IF(ISTORE(JY+3)-JX)1550,1250,1250
C--NO MORE PARTS  -  CHECK IF THIS PARAMETER HAS BEEN REFINED
1700  CONTINUE
      IF(JZ)1800,1800,1750
C--CALCULATE THE E.S.D.
1750  CONTINUE
      BPD(JP)=XVAR(JS,JZ,4,JR)
      BPD(JP)=SQRT(BPD(JP)*F)
1800  CONTINUE
      JT=JT+1
      JP=JP+1
1850  CONTINUE
C--APPLY THE SHIFTS
      JX=LP
      DO 1900 JY=1,NPAR
      STORE(JX)=STORE(JX)+APD(JY)
      JX=JX+1
1900  CONTINUE
      GOTO 1100
C
9900  CONTINUE
C -- ERRORS
      RETURN
9910  CONTINUE
C -- CORE OVEFLOW
      CALL XICA
      CALL XERHND ( IERERR )
      GO TO 9900
C
      END
CRYSTALS CODE FOR SUMMARY
CODE FOR XSMMRY
      SUBROUTINE XSMMRY
C
C -- SUBROUTINE TO SUMMARISE DATA
C
C -- THIS ROUTINE IMPLEMENTS THE CRYSTALS 'SUMMARY' AND 'DISPLAY'
C    INSTRUCTIONS
C
C      VERSION
C      1.00      NOVEMBER 1984         PWB   INITIAL VERSION FOR LISTS
C                                            5 AND 6
C      1.01      DECEMBER 1984         PWB   ADD LISTS 1, 2, 3, 4, 13,
C                                            14, 23, 27, 28, 29
C      1.02      JANUARY 1985          PWB   ADD LISTS 12 AND 16
C      2.00      JANUARY 1985          PWB   REORGANISE TO USE 'KSUMLN'
C      2.01      JANUARY 1985          PWB   ADD 'EVERYTHING'
C
C
      PARAMETER ( NSMTYP = 50 )
      DIMENSION ISMTYP(NSMTYP)
C --
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
      COMMON /XOPVAL/ IOPCRY , IOPPUR , IOPLPC , IOPSSM , IOPMER ,
     2 IOPABS , IOPCOR , IOPREF , IOPFOU , IOPWEI , IOPANA , IOPTFC ,
     3 IOPMOD , IOPLSM , IOPHYD , IOPLSI , IOPLSC , IOPLEX , IOPL12 ,
     4 IOPL16 , IOPCHK , IOPCPR , IOPSOR , IOPREO , IOPSFS , IOPPCH ,
     5 IOPDIS , IOPTOR , IOPPRA , IOPTLS , IOPAXS , IOPPPR , IOPREG ,
     6 IOPSIM , IOPTRI , IOPSLA , IOPFPL , IOPDAB , IOPDSP , IOPINV ,
     7 IOPGNP , IOPP22 , IOPSCP , IOPSGP , IOPQCK , IOPCMP
      COMMON /XOPMVL/ IOPABN , IOPCMI , IOPEND , IOPPRC , IOPSPC ,
     2 IOPLSP , IOPINT , IOPLSE , IOPVER
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C----- SEE ALSO KSUMLN - FOR THE SAME DATA - SHOULD IT BE IN BLOCK DATA?
      DATA ISMTYP /  1 ,  2 ,  3 ,  4 ,  5 ,     6 ,  0 ,  0 ,  0 , 10 ,
     2               0 , 12 , 13 , 14 ,  0 ,    16 , 17 ,  0 ,  0 ,  0 ,
     3               0 ,  0 , 23 ,  0 ,  0 ,     0 , 27 , 28 , 29 , 30 ,
     4               0 ,  0 ,  0 ,  0 ,  0 ,     0 ,  0 ,  0 ,  0 ,  0 ,
     5               0 ,  0 ,  0 ,  0 ,  0 ,     0 ,  0 ,  0 ,  0 ,  0 /
C
      DATA IVERSN / 201 /
C
      DATA ICOMSZ / 3 /
C
C
C -- SET THE TIMING AND READ THE CONSTANTS
C
      CALL XTIME1 ( 2 )
      CALL XCSAE
C
C -- ALLOCATE SPACE TO HOLD RETURN VALUES FROM INPUT
      ICOMBF = KSTALL ( ICOMSZ )
      I = KRDDPV ( ISTORE(ICOMBF) , ICOMSZ )
      IF ( I .LT. 0 ) GO TO 9910
C
C -- SET LIST TYPE AND LISTING LEVEL FLAG
C
        ITYPE = ISTORE(ICOMBF)
        LEVEL = ISTORE(ICOMBF+1)
C
C -- CHECK REQUEST
      IF ( ISTORE(ICOMBF+2) .LE. 0 ) THEN
C
C -- SPECIFIC LIST SUMMARY REQUIRED.
        ISTAT = KSUMLN ( ITYPE , LEVEL , 1 )
        IF ( ISTAT .LE. 0 ) GO TO 9900
      ELSE
C -- 'EVERYTHING'
        DO 2100 I = 1 , NSMTYP
          IF ( ISMTYP(I)  .GT. 0 ) THEN
            IF ( KEXIST(I) .GT. 0 ) THEN
              ISTAT = KSUMLN ( I , LEVEL , 1 )
            ENDIF
          ENDIF
2100    CONTINUE
      ENDIF
C
C
9000  CONTINUE
C -- FINAL MESSAGE
      CALL XOPMSG ( IOPDSP , IOPEND , IVERSN )
      CALL XTIME2 ( 2 )
C
      CALL XRSL
      CALL XCSAE
C
      RETURN
C
C
C
9900  CONTINUE
C -- ERRORS
      CALL XOPMSG ( IOPDSP , IOPABN , 0 )
      GO TO 9000
9910  CONTINUE
C -- INPUT ERRORS
      CALL XOPMSG ( IOPDSP , IOPCMI , 0 )
      GO TO 9900
C
C
      END
C
C
C
C
C
CODE FOR KSUMLN
      FUNCTION KSUMLN ( LSTYPE , LEVEL , LOADLN )
C
C -- SUBROUTINE PRODIVING LINK TO SUMMARY CODE
C
C -- INPUT
C      LSTYPE      LIST TYPE TO SUMMARISE
C      LEVEL       LEVEL OF SUMMARY ( ONLY FOR TYPE = 5 )
C      LOADLN      LOAD LIST BEFORE PRODUCING SUMMARY
C                    0 DO NOT LOAD LIST. A SUITABLE LIST HAS ALREADY
C                      BEEN LOADED
C                    1 LOAD LIST
C
C -- RETURN VALUE :-
C      -VE      ERROR PRODUCING SUMMARY. THE LIST CANNOT BE
C               SUMMARISED
C      +VE      SUCCESS
C
      PARAMETER ( NSMTYP = 50 )
      DIMENSION ISMTYP(NSMTYP)
C
      PARAMETER (NLTYPE = 31)
      CHARACTER*32 CLTYPE(NLTYPE)
      DIMENSION LLTYPE(NLTYPE)
C
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
      COMMON/XLST04/ITYPE4,ICON41,ICON42,ICON43,L4,M4,MD4,N4,
     2 L4C,M4C,MD4C,N4C,L4F,M4F,MD4F,N4F
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON/XLST14/L14,M14,MD14,N14, L14O,M14O,MD14O,N14O,
     2 L14SC,M14SC,MD14SC,N14SC, L14P,M14P,MD14P,N14P
      COMMON/XLST23/L23M,M23M,MD23M,N23M,L23EX,M23EX,MD23EX,N23EX,
     2 L23MN,M23MN,MD23MN,N23MN,L23AC,M23AC,MD23AC,N23AC,
     3 L23IC,M23IC,MD23IC,N23IC, L23SP,M23SP,MD23SP,N23SP
      COMMON/XLST27/L27,M27,MD27,N27
      COMMON/XLST28/L28MN,M28MN,MD28MN,N28MN,L28CN,M28CN,MD28CN,N28CN,
     2 L28MX,M28MX,MD28MX,N28MX,L28CX,M28CX,MD28CX,N28CX,
     3 L28RC,M28RC,MD28RC,N28RC,I28SPC(8),L28OM,M28OM,MD28OM,N28OM,
     4 L28CD,M28CD,MD28CD,N28CD, L28SK,M28SK,MD28SK,N28SK
      COMMON/XLST29/L29,M29,MD29,N29
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON /XERVAL/ IERNOP,IERSFL,IERWRN,IERERR,IERSEV,IERCAT,
     2 IERPRG,IERABO,IERUNW
C
C
C -- THE ARRAY 'ISMTYP' INDICATES WHETHER A SUMMARY IS AVAILABLE, AND
C    WHICH STRING FROM 'CLTYPE' SHOULD BE USED TO DESCRIBE THE DATA
C
C      1 - 9 , 10 - 19 , 20 - 29 , 30 - 39 , 40 - 49 , 50
C
C----- SEE ALSO KSUMLN - FOR THE SAME DATA - SHOULD IT BE IN BLOCK DATA?
      DATA ISMTYP /  1 ,  2 ,  3 ,  4 ,  5 ,     6 ,  0 ,  0 ,  0 , 10 ,
     2               0 , 12 , 13 , 14 ,  0 ,    16 , 17 ,  0 ,  0 ,  0 ,
     3               0 ,  0 , 23 ,  0 ,  0 ,     0 , 27 , 28 , 29 , 30 ,
     4               0 ,  0 ,  0 ,  0 ,  0 ,     0 ,  0 ,  0 ,  0 ,  0 ,
     5               0 ,  0 ,  0 ,  0 ,  0 ,     0 ,  0 ,  0 ,  0 ,  0 /
C
C
      DATA CLTYPE / 'Cell parameters', 'Symmetry',
     2 'Scattering factors', 'Weighting scheme', 'Parameters',
     3 'Reflection data', 3*'*', 'Peaks', '*', 'Refinement directives',
     4 'Diffraction conditions', 'Asymmetric section', '*',
     4 'Restraints', 'Special restraints', 5*'*',
     5 'S.F. modifications', 3*'*', 'Raw data scale factors',
     6 'Reflection selection conditions', 'Elemental properties',
     7 'General details', '*' /
C
      DATA LLTYPE / 15, 8,
     2 18, 16, 10,
     3 15, 1, 1, 1,  5, 1,  21,
     4 22, 18, 1,
     4 10, 18, 1, 1, 1, 1, 1,
     5 18, 1, 1, 1, 22,
     6 31, 20, 15,
     7 1 /
C
C
C
C -- CHECK TYPE NUMBER
C
      IF ( LSTYPE .LE. 0 ) GO TO 9910
      IF ( LSTYPE.GT. NSMTYP ) GO TO 9910
C
      INTLTP = ISMTYP(LSTYPE)
      IF ( INTLTP .LE. 0 ) GO TO 9920
C
C -- LOAD LIST IF REQUIRED
C
      IF ( LOADLN .GT. 0 ) THEN
C
        IF ( LSTYPE .EQ. 1 ) THEN
          CALL XFAL01
        ELSE IF ( LSTYPE .EQ. 2 ) THEN
          CALL XFAL02
        ELSE IF ( LSTYPE .EQ. 3 ) THEN
          CALL XFAL03
        ELSE IF ( LSTYPE .EQ. 4 ) THEN
          CALL XFAL04
        ELSE IF ( LSTYPE .EQ. 5 ) THEN
          CALL XLDR05 ( LSTYPE )
        ELSE IF ( LSTYPE .EQ. 6 ) THEN
            CALL XFAL01
          CALL XFAL06 ( 0 )
        ELSE IF ( LSTYPE .EQ. 10 ) THEN
          CALL XLDR05 ( LSTYPE )
        ELSE IF ( LSTYPE .EQ. 13 ) THEN
          CALL XFAL13
        ELSE IF ( LSTYPE .EQ. 14 ) THEN
          CALL XFAL14
        ELSE IF ( LSTYPE .EQ. 23 ) THEN
          CALL XFAL23
        ELSE IF ( LSTYPE .EQ. 27 ) THEN
          CALL XFAL27
        ELSE IF ( LSTYPE .EQ. 28 ) THEN
          CALL XFAL28
        ELSE IF ( LSTYPE .EQ. 29 ) THEN
          CALL XFAL29
        ELSE IF ( LSTYPE .EQ. 30 ) THEN
          CALL XFAL30
        ENDIF
C
        IF ( IERFLG .LT. 0 ) GO TO 9900
      ENDIF
C
C -- PRODUCE SUMMARY
C
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1005 ) LSTYPE , CLTYPE(INTLTP)(1:LLTYPE(INTLTP))
      ENDIF
      WRITE ( NCAWU , 1005 ) LSTYPE , CLTYPE(INTLTP)(1:LLTYPE(INTLTP))
1005  FORMAT ( / , 1X , 'Summary of contents of list ' , I4 ,
     2 ' ( ' , A , ' )' , / )
C
C
      IF ( LSTYPE .EQ. 1 ) THEN
        CALL XSUM01
      ELSE IF ( LSTYPE .EQ. 2 ) THEN
        CALL XSUM02
      ELSE IF ( LSTYPE .EQ. 3 ) THEN
        CALL XSUM03
      ELSE IF ( LSTYPE .EQ. 4 ) THEN
        CALL XSUM04
      ELSE IF ( LSTYPE .EQ. 5 ) THEN
        CALL XSUM05 ( LSTYPE , LEVEL )
      ELSE IF ( LSTYPE .EQ. 6 ) THEN
        CALL XSUM06
      ELSE IF ( LSTYPE .EQ. 10 ) THEN
        CALL XSUM05 ( LSTYPE , LEVEL )
      ELSE IF ( LSTYPE .EQ. 12 ) THEN
        CALL XPRTLX ( LSTYPE , -1 )
      ELSE IF ( LSTYPE .EQ. 13 ) THEN
        CALL XSUM13
      ELSE IF ( LSTYPE .EQ. 14 ) THEN
        CALL XSUM14
      ELSE IF ( LSTYPE .EQ. 16 ) THEN
        CALL XPRTLX ( LSTYPE , -1 )
      ELSE IF ( LSTYPE .EQ. 17 ) THEN
        CALL XPRTLX ( LSTYPE , -1 )
      ELSE IF ( LSTYPE .EQ. 23 ) THEN
        CALL XSUM23
      ELSE IF ( LSTYPE .EQ. 27 ) THEN
        CALL XSUM27
      ELSE IF ( LSTYPE .EQ. 28 ) THEN
        CALL XSUM28
      ELSE IF ( LSTYPE .EQ. 29 ) THEN
        CALL XSUM29
      ELSE IF ( LSTYPE .EQ. 30 ) THEN
        CALL XSUM30
      ENDIF
C
      IERFLG = 1
C
C
      KSUMLN = 1
      RETURN
C
C
9900  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 9905 ) LSTYPE
      ENDIF
      WRITE ( NCAWU , 9905 ) LSTYPE
9905  FORMAT ( 1X , 'Summary of list type ' , I4 , ' abandoned' )
      KSUMLN = -1
      RETURN
9910  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 9915 ) LSTYPE
      ENDIF
      WRITE ( NCAWU , 9915 ) LSTYPE
9915  FORMAT ( 1X , 'Illegal list number for summary - ' , I12 )
      CALL XERHND ( IERWRN )
      GO TO 9900
9920  CONTINUE
C -- NO PROVISON FOR SUMMARY OF THIS LIST
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 9925 ) LSTYPE
      ENDIF
      WRITE ( NCAWU , 9925 ) LSTYPE
9925  FORMAT ( 1X , 'No summary of list type ' , I5 , ' is available' )
      CALL XERHND ( IERWRN )
      GO TO 9900
C

      END
C
C
C
C
C
CODE FOR XSUM01
      SUBROUTINE XSUM01
C
C -- ROUTINE TO DISPLAY SUMMARY OF LIST 1
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST01/L1P1,M1P1,MD1P1,N1P1,L1P2,M1P2,MD1P2,N1P2,
     2 L1M1,M1M1,MD1M1,N1M1,L1M2,M1M2,MD1M2,N1M2,
     3 L1O1,M1O1,MD1O1,N1O1,L1O2,M1O2,MD1O2,N1O2,
     4 L1S,M1S,MD1S,N1S,L1A,M1A,MD1A,N1A,L1C,M1C,MD1C,N1C
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
C
C
C -- BEGIN OUTPUT
C
C -- CONVERT ANGLES TO DEGREES
C
      CALL XMULTR ( STORE(L1P1+3) , RTD , STORE(L1P1+3) , 3 )
C
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1015 ) ( STORE(J) , J = L1P1 , L1P1 + 5 )
      ENDIF
      WRITE ( NCAWU , 1015 ) ( STORE(J) , J = L1P1 , L1P1 + 5 )
1015  FORMAT ( 1X , 'Real cell parameters : ' , //,
     2 1X, 'a =     ',F9.4, '    b =    ',F9.4, '    c =     ',F9.4, /,
     3 1X, 'alpha = ',F9.4, '    beta = ',F9.4, '    gamma = ',F9.4,//)
C
C
      RETURN
      END
C
C
C
C
C
CODE FOR XSUM02
      SUBROUTINE XSUM02
C
C -- ROUTINE TO DISPLAY SUMMARY OF LIST 2
C
      CHARACTER*32 OPERAT
      CHARACTER*16 LATTIC(7)
      CHARACTER*4 CNOT
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST02/IC,IL,G2,T2,L2C,M2C,MD2C,N2C,L2,M2,MD2,N2,
     2 L2I,M2I,MD2I,N2I,L2T,M2T,MD2T,N2T,L2P,M2P,MD2P,N2P,
     3 L2SG,M2SG,MD2SG,N2SG
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      DATA LATTIC / 'primitive' , 'body centered' , 'rhombohedral' ,
     2 'face centered' , 'A centered' , 'B centered' , 'C centered' /
      DATA CNOT / ' not' /
C
C
C -- BEGIN OUTPUT
C
C -- GET CENTRO AND LATTICE TYPE FLAGS
C
      ICENTR = NINT ( STORE(L2C) )
      LATTYP = NINT ( STORE(L2C+1) )
C
      LENCEN = 1
      IF ( ICENTR .LE. 0 ) LENCEN = 4
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1015 ) CNOT(1:LENCEN)
      ENDIF
      WRITE ( NCAWU , 1015 ) CNOT(1:LENCEN)
1015  FORMAT ( 1X , 'The structure is' , A , ' centrosymmetric' )
C
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1025 ) LATTIC(LATTYP)
      ENDIF
      WRITE ( NCAWU , 1025 ) LATTIC(LATTYP)
1025  FORMAT ( 1X , 'The lattice type is : ' , A )
C
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1035 ) N2
      ENDIF
      WRITE ( NCAWU , 1035 ) N2
1035  FORMAT ( 1X , 'There are ' , I3 , ' symmetry operators' , / )
C
C -- DISPLAY EACH SYMMETRY OPERATOR
C
      DO 2000 I = L2 , M2 , MD2
        CALL XSUMOP ( STORE(I) , STORE(L2P) , OPERAT , LENGTH )
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 1105 ) OPERAT(1:LENGTH)
        ENDIF
        WRITE ( NCAWU , 1105 ) OPERAT(1:LENGTH)
1105    FORMAT ( 11X , A )
C
2000  CONTINUE
C
C----- DISPLAY SPACE GROUP SYMBOL
      J  = L2SG + MD2SG - 1
      WRITE(NCAWU,2100) (ISTORE(I), I = L2SG, J)
      IF (ISSPRT .EQ. 0) THEN
       WRITE(NCWU,2100) (ISTORE(I), I = L2SG, J)
      ENDIF
2100  FORMAT(' Space group symbol is ', 2X, 4(A4,1X)/)
C
      RETURN
      END
C
C
C
C
C
CODE FOR XSUM03
      SUBROUTINE XSUM03
C
C -- ROUTINE TO DISPLAY SUMMARY OF LIST 3
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST03/L3,M3,MD3,N3,L3TR,M3TR,MD3TR,N3TR,
     2 L3TI,M3TI,MD3TI,N3TI
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
C
C
C -- BEGIN OUTPUT
C
      IF ( N3 .GT. 0 ) THEN
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 1015 )
        ENDIF
        WRITE ( NCAWU , 1015 )
1015    FORMAT ( 1X , 'Scattering factors are known for :- ' , / )
C
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 1025 ) ( STORE(J) , J = L3 , M3 , MD3 )
        ENDIF
        WRITE ( NCAWU , 1025 ) ( STORE(J) , J = L3 , M3 , MD3 )
1025    FORMAT ( 11X , 15A4 )
      ELSE
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 1035 )
        ENDIF
        WRITE ( NCAWU , 1035 )
1035    FORMAT ( 1X , 'No scattering factors stored in list 3' )
      ENDIF
C
C
      RETURN
      END
C
C
C
C
C
CODE FOR XSUM04
      SUBROUTINE XSUM04
C
C -- ROUTINE TO DISPLAY SUMMARY OF LIST 4
C
C -- THE EXPRESSIONS FOR THE WEIGHTS ARE CONSTRUCTED FROM THE
C    STRINGS CONTAINED IN 'CRESLT' AND 'CEXPRS' INDEXED BY
C    'IRESLT' AND 'IEXPRS'.
C
      PARAMETER ( MAXSCH = 16 )
      DIMENSION IEXPRS(2,MAXSCH)
      DIMENSION IRESLT(MAXSCH)
C
      CHARACTER*32 CSNAME(MAXSCH)
      DIMENSION    LNNAME(MAXSCH)
C
      CHARACTER*64 CFORMS(14)
      CHARACTER*8 CRESLT(2)
      CHARACTER*11 CEXPRS
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST04/ITYPE4,ICON41,ICON42,ICON43,L4,M4,MD4,N4,
     2 L4C,M4C,MD4C,N4C,L4F,M4F,MD4F,N4F
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      DATA CFORMS /
     1 'FO/P(1), FO < P(1) or FO = P(1)' ,
     2 'P(1)/FO, FO > P(1)' ,
     3 '1.0 , FO < P(1) or FO = P(1)' ,
     4 'P(1)/FO, FO > P(1)' ,
     5 '1/(1 + [(FO - P(2))/P(1)]**2)' ,
     6 '1/[P(1) + FO + P(2)*FO**2 + . . + P(NP)*FO**NP]' ,
     7 '(Data with the key WEIGHT in list 6)' ,
     8 '1/(Data with the key SIGMA(/FO/) in list 6)' ,
     9 '1.0' ,
     + '1.0/[A[0]*T[0]''(X)+A[1]*T[1]''(X) ... +A[NP-1]*T[NP-1]''(X)]',
     1 '[SIN(theta)/lambda]**P(1)' ,
     2 '[weight] * exp[8*(p(1)/p(2))*(pi*s)**2]' ,
     3 '[weight] * [1-(deltaF/6*sigmaF)**2]**2 ' ,
     4 '1.0 / [P(1)*FO**2 + P(2)*SIGMA(/FO/)**2 + P(3)]' /
C
      DATA IEXPRS / 1 , 2 , 3 , 4 , 5 , 0 , 6 , 0 , 7 , 0 ,
     2 7 , 0 , 8 , 0 , 8 , 0 , 9 , 0 , 10 , 0 , 10 , 0 , 11 , 0 ,
     3 12, 0, 13, 0, 13, 0, 14, 0 /
C
C
      DATA CRESLT / 'W' , 'SQRT(W)' /
      DATA IRESLT / 2 , 2 , 1 , 1 , 1 , 2 , 1 , 2 , 1 , 1 ,
     2 1, 1, 1, 1, 1, 1 /
C
      DATA CSNAME / '( Modified Hughes )' , '( Hughes )' , ' ' ,
     2 '( Cruickshank )' , ' ' ,
     3 ' ' , ' ' , ' ' , '( Unit weights )' ,
     4 '( Chebychev polynomial )' , '( Chebychev polynomial )' ,
     5 ' ' , '( Dunitz and Seiler )', '( Tukey and Prince )',
     6 '( Tukey and Prince )', '( Sheldrick )' /
      DATA LNNAME / 19 , 10 , 1 ,
     2 15 , 1 ,
     3 1 , 1 , 1 , 16 ,
     4 24 , 24 ,
     5 1, 21, 20, 20, 13 /
      DATA CEXPRS / 'expressions' /
      DATA LENEXP / 11 /
C
C
C
C
C -- BEGIN OUTPUT
C
      ITYPE = ISTORE(L4C)
      IFOTYP = ISTORE(L4C+1)
C
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1015 ) ITYPE , CSNAME(ITYPE)(1:LNNAME(ITYPE))
      ENDIF
      WRITE ( NCAWU , 1015 ) ITYPE , CSNAME(ITYPE)(1:LNNAME(ITYPE))
1015  FORMAT ( 1X , 'Weighting scheme type ' , I3 , 2X , A , // )
C
      LENGTH = LENEXP
      IF ( IEXPRS(2,ITYPE) .LE. 0 ) LENGTH = LENGTH - 1
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1016 ) CEXPRS(1:LENGTH)
      ENDIF
      WRITE ( NCAWU , 1016 ) CEXPRS(1:LENGTH)
1016  FORMAT ( 1X , 'Weights are calculated from ' ,
     2 'the following ' , A , ' :-' / )
C
      DO 1018 I = 1 , 2
        ITEXT = IEXPRS(I,ITYPE)
        IF ( ITEXT .GT. 0 ) THEN
          IF (ISSPRT .EQ. 0) THEN
           WRITE ( NCWU , 1017 ) CRESLT(IRESLT(ITYPE)) , CFORMS(ITEXT)
          ENDIF
          WRITE ( NCAWU , 1017 ) CRESLT(IRESLT(ITYPE)) , CFORMS(ITEXT)
1017      FORMAT ( 1X , A , ' = ' , A )
        ENDIF
1018  CONTINUE
C
      IF (MD4 .GT. 0) THEN
        M4 = L4 + MD4 -1
        IF (ISSPRT .EQ. 0) THEN
          WRITE ( NCWU , 1025 )
        ENDIF
        WRITE ( NCAWU , 1025 )
1025    FORMAT ( / , 1X , 'Using parameters :- ' , / )
C
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 1035 ) ( STORE(J) , J = L4 , M4 )
        ENDIF
        WRITE ( NCAWU , 1035 ) ( STORE(J) , J = L4 , M4 )
1035    FORMAT ( 5X , 6G12.3 )
C
      ENDIF
C
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1045 ) STORE(L4F+1)
      ENDIF
      WRITE ( NCAWU , 1045 ) STORE(L4F+1)
1045  FORMAT ( / , 1X , 'The maximum weight is ' , G12.5 )
C
C
      RETURN
      END
C
C
C
C
C
CODE FOR XSUM05
      SUBROUTINE XSUM05 ( ITYPE , LEVEL )
C
C -- ROUTINE TO DISPLAY SUMMARY OF LIST 5 OR 10
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST05/L5,M5,MD5,N5, L5A,M5A,MD5A,N5A,
     2 L5LSC,M5LSC,MD5LSC,N5LSC, L5O,M5O,MD5O,N5O,
     3 L5LS,M5LS,MD5LS,N5LS, L5ES,M5ES,MD5ES,N5ES,
     4 L5BS,M5BS,MD5BS,N5BS, L5CL,M5CL,MD5CL,N5CL,
     5 L5PR,M5PR,MD5PR,N5PR, L5EX,M5EX,MD5EX,N5EX
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
      DATA ICNTSZ / 5 /
C
C
C -- ALLOCATE MONITOR OUTPUT CONTROL AREA
      ICONTR = KSTALL ( ICNTSZ )
      CALL XZEROF ( ISTORE(ICONTR) , ICNTSZ )
C
C -- BEGIN OUTPUT
C
C -- OUTPUT ATOMS AND OVERALL PARAMETERS
C
      CALL XMDMON ( L5,MD5,N5,1,1, 1,LEVEL,0,1,1,ISTORE(ICONTR) )
C
      CALL XMDMON ( L5O,1,MD5O,1,2, 1,LEVEL,0,1,1,ISTORE(ICONTR) )
C
C -- OUTPUT SCALE FACTORS OR A SUITABLE ALTERNATIVE MESSAGE IF THERE
C    ARE NONE
C
      IF ( ( MD5LS +MD5BS +MD5ES +MD5CL + MD5PR +MD5EX )
     1 .LE. 0 ) THEN
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 1065 )
        ENDIF
        WRITE ( NCAWU , 1065 )
1065    FORMAT ( 1X , 'There are no layer, element, or batch scales'/
     1 1X, 'There are no special overall parameters' )
      ELSE
        CALL XMDMON (L5LS,1,MD5LS,1,3, 1,LEVEL,0,1,1,ISTORE(ICONTR))
        CALL XMDMON (L5ES,1,MD5ES,1,4, 1,LEVEL,0,1,1,ISTORE(ICONTR))
        CALL XMDMON (L5BS,1,MD5BS,1,5, 1,LEVEL,0,1,1,ISTORE(ICONTR))
        CALL XMDMON (L5CL,1,MD5CL,1,6, 1,LEVEL,0,1,1,ISTORE(ICONTR))
        CALL XMDMON (L5PR,1,MD5PR,1,7, 1,LEVEL,0,1,1,ISTORE(ICONTR))
        CALL XMDMON (L5EX,1,MD5EX,1,8, 1,LEVEL,0,1,1,ISTORE(ICONTR))
      ENDIF
C
      CALL XSTRLL ( ICONTR )
      RETURN
      END
C
C
C
C
C
CODE FOR XSUM06
      SUBROUTINE XSUM06
C
C -- ROUTINE TO DISPLAY SUMMARY OF LIST 6
C
      CHARACTER *8 CNAME(35)
      DIMENSION KEY(35)
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST06/L6,M6,MD6,N6,L6R,M6R,MD6R,N6R,L6W,M6W,MD6W,N6W,
     2 L6D,M6D,MD6D,N6D,L6DMP,M6DMP,MD6DMP,N6DMP,
     3 L6P,M6P,MD6P,N6P,L6DTL,M6DTL,MD6DTL,N6DTL
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
      DATA KEY/ 1, 2, 3, 4, 5, 6, 0, 0, 0, 0,
     1          0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     1          0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     1          0, 0, 0, 0, 0 /
C
      DATA CNAME/ 'H','K','L','Fo','Weight','Fc',6*' ',
     1 'Sigma',3*' ','Sth/L**2','Fo/Fc',17*' '/
C
C
C----- PRINT SOME OVER-ALL DETAILS
C--PRINT THE DETAILS RECORD
      WRITE(NCAWU,1550)
      IF (ISSPRT .EQ. 0) THEN
       WRITE(NCWU,1550)
      ENDIF
1550  FORMAT(9H Quantity,12X,7HMinimum,8X,7HMaximum,7X,10HMean value,
     2 4X,12HR.M.S. value/)
C--LOOP OVER EACH DETAIL STORED
      M6DTL=L6DTL
      DO 1850 I=2,N6DTL
      IF (KEY(I-1) .EQ. 0) GOTO 1800
C--CHECK IF THIS DETAIL IS SET
      IF(STORE(M6DTL+3)-ZERO)1600,1700,1700
C--NOT SET  -  PRINT THE CAPTION AND IGNORE IT
1600  CONTINUE
      WRITE(NCAWU,1650) CNAME(I-1)
      IF (ISSPRT .EQ. 0) THEN
       WRITE(NCWU,1650) CNAME(I-1)
      ENDIF
1650  FORMAT(6H      ,A, 4X,20HNo details available)
      GOTO 1800
C--PRINT THE DETAILS
1700  CONTINUE
      K=M6DTL+MD6DTL-1
      IF (ISSPRT .EQ. 0) THEN
       WRITE(NCWU,1750) CNAME(I-1), (STORE(J),J=M6DTL,K)
      ENDIF
      WRITE(NCAWU,1750) CNAME(I-1), (STORE(J),J=M6DTL,K)
1750  FORMAT(6H      ,A,2X,6E15.6)
C--UPDATE FOR THE NEXT PARAMETER
1800  CONTINUE
      M6DTL=M6DTL+MD6DTL
1850  CONTINUE
C
C -- SCAN LIST 6 FOR ACCEPTED REFLECTIONS
C
      N6ACC = 0
1100  CONTINUE
        ISTAT = KFNR ( 0 )
        IF ( ISTAT .LT. 0 ) GO TO 1200
C
        N6ACC = N6ACC + 1
        GO TO 1100
C
C
C -- BEGIN OUTPUT
C
1200  CONTINUE
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1215 ) N6D , N6ACC
      ENDIF
      WRITE ( NCAWU , 1215 ) N6D, N6ACC
1215  FORMAT ( 1X , 'List 6 contains ' , I5 , ' reflections' ,/,
     1 8X , 'of which ' , I5 , ' are accepted by LIST 28' ,/)
C
C
C -- PRINT THE R VALUE ETC.
      J = NINT(STORE(L6P))
      M6P = L6P+2
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1235 ) J , ( STORE(I+1) , I=L6P,M6P )
      ENDIF
      WRITE ( NCAWU , 1235 ) J , ( STORE(I+1) , I=L6P,M6P )
1235  FORMAT ( / , 1X , 'After ' , I5 ,
     2 ' structure factor/refinement calculation(s) ' , / ,
     3 1X , 'R = ' , F6.2 , 5X , 'Weighted R = ' , F6.2 ,
     4 5X , 'Minimisation function = ' , E15.6 )
C
C
      RETURN
      END
C
C
C
C
C
CODE FOR XSUM13
      SUBROUTINE XSUM13
C
C -- ROUTINE TO DISPLAY SUMMARY OF LIST 13
C
      PARAMETER ( NCRYST = 2 , NSPRED = 2 , NGEOMY = 9 , NRADTN = 2 )
      CHARACTER*30 CCRYST(NCRYST)
      CHARACTER*10 CSPRED(NSPRED)
      CHARACTER*10 CGEOMY(NGEOMY)
      CHARACTER*8 CRADTN(NRADTN)
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST13/L13CD,M13CD,MD13CD,N13CD,L13DT,M13DT,MD13DT,N13DT,
     2 L13DC,M13DC,MD13DC,N13DC,L132R,M132R,MD132R,N132R,
     3 L133R,M133R,MD133R,N133R,L13RL,M13RL,MD13RL,N13RL,
     4 L13RC,M13RC,MD13RC,N13RC,L13OM,M13OM,MD13OM,N13OM,
     5 L13AX,M13AX,MD13AX,N13AX
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      DATA CCRYST / 'Friedel''s Law is assumed' ,
     2 'The crystal is twinned' /
      DATA CSPRED / 'Gaussian' , 'Lorentzian' /
      DATA CGEOMY / 'NORMAL' , 'EQUI' , 'ANTI' , 'PRECESSION' ,
     2 'UNKNOWN' , 'CAD4' , 'ROLLETT' , 'Y290' , 'KAPPA' /
      DATA CRADTN / 'X-rays' , 'neutrons' /
C
C
C
C
C -- BEGIN OUTPUT
C
      IND13 = L13CD
      DO 1100 I = 1 , NCRYST
        IF ( ISTORE(IND13) .GE. 0 ) THEN
          IF (ISSPRT .EQ. 0) THEN
            WRITE ( NCWU , 1025 ) CCRYST(I)
          ENDIF
          WRITE ( NCAWU , 1025 ) CCRYST(I)
1025      FORMAT ( 11X , A )
        ENDIF
        IND13 = IND13 + 1
1100  CONTINUE
C
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1105 ) CSPRED(ISTORE(L13CD+2))
      ENDIF
      WRITE ( NCAWU , 1105 ) CSPRED(ISTORE(L13CD+2))
1105  FORMAT ( 11X , 'The spread is assumed to be ' , A , / )
C
C
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1125 ) CGEOMY(ISTORE(L13DT))
       WRITE ( NCWU , 1135 ) CRADTN(ISTORE(L13DT+1)+2)
      ENDIF
      WRITE ( NCAWU , 1125 ) CGEOMY(ISTORE(L13DT))
1125  FORMAT ( 11X , 'The diffraction geometry is ' , A )
      WRITE ( NCAWU , 1135 ) CRADTN(ISTORE(L13DT+1)+2)
1135  FORMAT ( 11X , 'Data was collected with ' , A )
C
C
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1145 ) STORE(L13DC)
      ENDIF
      WRITE ( NCAWU , 1145 ) STORE(L13DC)
1145  FORMAT ( 11X , 'The wavelength is ' , F12.5 )
C
C
      RETURN
      END
C
C
C
C
C
CODE FOR XSUM14
      SUBROUTINE XSUM14
C
C -- ROUTINE TO DISPLAY SUMMARY OF LIST 14
C
      PARAMETER ( NAXIS = 3 , NDIVTP = 2 )
      CHARACTER*1 CAXIS(NAXIS)
      CHARACTER*7 CDIREC(NAXIS)
      CHARACTER*11 CDIVTP(NDIVTP)
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST14/L14,M14,MD14,N14, L14O,M14O,MD14O,N14O,
     2 L14SC,M14SC,MD14SC,N14SC, L14P,M14P,MD14P,N14P
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      DATA CAXIS / 'X' , 'Y' , 'Z' /
      DATA CDIREC / 'down' , 'across' , 'through' /
      DATA CDIVTP / 'Angstrom' , 'Division(s)' /
C
C
C
C -- BEGIN OUTPUT
C
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1015 )
      ENDIF
      WRITE ( NCAWU , 1015 )
1015  FORMAT ( 1X , 'Orientation of map is :- ' )
C
      IF (ISSPRT .EQ. 0) THEN
      WRITE ( NCWU , 1025 ) ( CDIREC(J) , CAXIS(ISTORE(L14O+J-1)) ,
     2                         J = 1 , NAXIS )
      ENDIF
      WRITE ( NCAWU , 1025 ) ( CDIREC(J) , CAXIS(ISTORE(L14O+J-1)) ,
     2                         J = 1 , NAXIS )
1025  FORMAT ( 11X , 3 ( A , 1X , A , 2X ) )
C
C
      IF (ISSPRT .EQ. 0) THEN
       WRITE ( NCWU , 1035 ) STORE(L14SC)
      ENDIF
      WRITE ( NCAWU , 1035 ) STORE(L14SC)
1035  FORMAT ( / , 11X , 'The map scale factor is ' , F10.5 , / )
C
C
      IND14 = L14
      DO 1400 I = 1 , N14
C
        IF ( ABS(STORE(IND14+3)) .LE. ZERO ) THEN
          IDIV = 1
        ELSE
          IDIV = 2
        ENDIF
C
      IF (ISSPRT .EQ. 0) THEN
        WRITE ( NCWU , 1305 ) CAXIS(I), STORE(IND14), STORE(IND14+2),
     2                          STORE(IND14+1) , CDIVTP(IDIV)
      ENDIF
        WRITE ( NCAWU , 1305 ) CAXIS(I), STORE(IND14), STORE(IND14+2),
     2                          STORE(IND14+1) , CDIVTP(IDIV)
1305  FORMAT ( 11X , 'The ' , A , ' axis runs from ' , F7.2 ,
     2 ' to ' , F7.2 , ' in steps of ' , F8.4 , 1X , A )
C
        IF ( IDIV .EQ. 2 ) THEN
      IF (ISSPRT .EQ. 0) THEN
          WRITE ( NCWU , 1315 ) CAXIS(I) , STORE(IND14+3)
      ENDIF
          WRITE ( NCAWU , 1315 ) CAXIS(I) , STORE(IND14+3)
1315      FORMAT ( 11X , 'The ' , A , ' axis is divided into ' ,
     2             F8.4 , ' divisions' )
        ENDIF
C
        IND14 = IND14 + MD14
1400  CONTINUE
C
C
      END
C
C
C
C
C
CODE FOR XSUM23
      SUBROUTINE XSUM23
C
C -- ROUTINE TO DISPLAY SUMMARY OF LIST 23
C
      PARAMETER (NMODFC = 7, NMODMN = 3, MMODSP = 5, NMODSP = 2)
      CHARACTER *34 CMODFC(NMODFC) , CMODMN(NMODMN)
      CHARACTER *13  CHARSP(MMODSP,NMODSP), CSP1(NMODSP)
C
      LOGICAL LHEADR
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST23/L23M,M23M,MD23M,N23M,L23EX,M23EX,MD23EX,N23EX,
     2 L23MN,M23MN,MD23MN,N23MN,L23AC,M23AC,MD23AC,N23AC,
     3 L23IC,M23IC,MD23IC,N23IC, L23SP,M23SP,MD23SP,N23SP
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      DATA CMODFC / 'Anomalous scattering' , 'Extinction parameter' ,
     2 'Layer scale factors' , 'Batch scales factors' ,
     3 'Uses stored partial contributions',
     3 'Updates stored contributions' , 'Enantiopole parameter' /
C
      DATA CMODMN(1) / 'Refinement against /F0/ **2' /
      DATA CMODMN(2) / 'Restraints applied' /
      DATA CMODMN(3) / 'Reflections used' /
C
      DATA CHARSP / 'Nothing', 'Warnings', 'Origin fixing',
     1 'Restraints ', 'Constraints ',
     2 ' Nothing', ' Occupancies', ' Parameters',
     3 ' ', ' '/
      DATA CSP1 /' issued', ' updated'/
C
C
C
C -- BEGIN OUTPUT
C
      LHEADR = .FALSE.
C
      IND23 = L23M
      DO 1000 I = 1, NMODFC
        IF ( ISTORE(IND23) .GE. 0 ) THEN
          IF ( .NOT. LHEADR ) THEN
            IF (ISSPRT .EQ. 0) THEN
             WRITE ( NCWU , 1105 )
            ENDIF
            WRITE ( NCAWU , 1105 )
1105        FORMAT ( 1X, 'Modifications applied to /FO/ and /FC/ :-',/)
            LHEADR = .TRUE.
          ENDIF
          IF (ISSPRT .EQ. 0) THEN
            WRITE ( NCWU , 1115 ) CMODFC(I)
          ENDIF
          WRITE ( NCAWU , 1115 ) CMODFC(I)
1115      FORMAT ( 11X , A )
        ENDIF
        IND23 = IND23 + 1
1000  CONTINUE
C
      IF ( LHEADR ) THEN
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 1125 )
        ENDIF
        WRITE ( NCAWU , 1125 )
1125    FORMAT ( 1X )
      ELSE
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 1135 )
        ENDIF
        WRITE ( NCAWU , 1135 )
1135    FORMAT ( 1X , 'No modifications to /FO/ and /FC/' , / )
      ENDIF
C
      LHEADR = .FALSE.
      IF (ISSPRT .EQ. 0) THEN
       WRITE(NCWU,2000) ISTORE(L23MN)
      ENDIF
      WRITE(NCAWU,2000) ISTORE(L23MN)
2000  FORMAT(1X,'Refinement terminated if more than ',I4,
     1 ' singularities'/)
C
      IND23 = L23MN + 1
      DO 2100 I = 1 , NMODMN
        IF ( ISTORE(IND23) .GE. 0 ) THEN
          IF ( .NOT. LHEADR ) THEN
            IF (ISSPRT .EQ. 0) THEN
             WRITE ( NCWU , 2005 )
            ENDIF
            WRITE ( NCAWU , 2005 )
2005        FORMAT ( 1X, 'Conditions applied to minimisation ' ,
     2                    'function :-' , / )
            LHEADR = .TRUE.
          ENDIF
          IF (ISSPRT .EQ. 0) THEN
           WRITE ( NCWU , 1115 ) CMODMN(I)
          ENDIF
          WRITE ( NCAWU , 1115 ) CMODMN(I)
        ENDIF
        IND23 = IND23 + 1
2100  CONTINUE
C
      IF ( LHEADR ) THEN
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 2105 )
        ENDIF
        WRITE ( NCAWU , 2105 )
2105    FORMAT ( 1X )
      ELSE
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 2115 )
        ENDIF
        WRITE ( NCAWU , 2115 )
2115    FORMAT ( 1X , 'No conditions on minimisation function' , / )
      ENDIF
C
C
C
C
      I = KHUNTR( 23, 106, IADDL, IADDR, IADDD, -1)
      IF ( I .EQ. 0) THEN
C----- THIS IS A NEW FORMAT LIST 23
        LHEADR = .FALSE.
C
C
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 3105 )
        ENDIF
        WRITE ( NCAWU , 3105 )
3105    FORMAT ( 1X, 'Treatment of atoms on SPECIAL positions:-',/)
C
        IND23 = L23SP
        DO 3000 I = 1, NMODSP
           J = ISTORE(IND23)+2
           IF (ISSPRT .EQ. 0) THEN
            WRITE ( NCWU  , 3115 ) CHARSP(J,I), CSP1(I)
           ENDIF
           WRITE ( NCAWU , 3115 ) CHARSP(J,I), CSP1(I)
3115       FORMAT ( 11X , A, A )
           IND23 = IND23+1
3000    CONTINUE
        WRITE(NCAWU,'('' Tolerance for coincidence = '', G10.5)')
     1 STORE(L23SP+5)
      IF (ISSPRT .EQ. 0) THEN
        WRITE(NCWU,'('' Tolerance for coincidence = '', G10.5)')
     1 STORE(L23SP+5)
      ENDIF
C
      ELSE
        WRITE(NCAWU,3120)
        IF (ISSPRT .EQ. 0) THEN
         WRITE(NCWU,3120)
        ENDIF
3120    FORMAT(//,1X, 'This is an old format LIST 23 - Input a new one')
      ENDIF
      RETURN
      END
C
C
C
C
C
CODE FOR XSUM27
      SUBROUTINE XSUM27
C
C -- ROUTINE TO DISPLAY SUMMARY OF LIST 27
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST27/L27,M27,MD27,N27
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
C
C
C -- BEGIN OUTPUT
C
C
       IF (ISSPRT .EQ. 0) THEN
        WRITE ( NCWU , 1015 ) N27
       ENDIF
       WRITE ( NCAWU , 1015 ) N27
1015  FORMAT ( 1X , I5 , ' scale factors are known' , / )
C
C
      RETURN
      END
C
C
C
C
C
CODE FOR XSUM28
      SUBROUTINE XSUM28
C
C -- ROUTINE TO DISPLAY SUMMARY OF LIST 28
C
      LOGICAL LHEADR
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST28/L28MN,M28MN,MD28MN,N28MN,L28CN,M28CN,MD28CN,N28CN,
     2 L28MX,M28MX,MD28MX,N28MX,L28CX,M28CX,MD28CX,N28CX,
     3 L28RC,M28RC,MD28RC,N28RC,I28SPC(8),L28OM,M28OM,MD28OM,N28OM,
     4 L28CD,M28CD,MD28CD,N28CD, L28SK,M28SK,MD28SK,N28SK
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
C
C -- BEGIN OUTPUT
      IF (MD28SK .GT. 1 ) THEN
        I = MD28SK-1
        IF (ISSPRT .EQ. 0) THEN
         WRITE(NCWU,500) I, MD28SK
        ENDIF
        WRITE(NCAWU,500) I, MD28SK
500     FORMAT (11X,I4, ' out of ', I4,' reflections will be skipped'/)
      ENDIF
C
      LHEADR = (( N28MN + N28MX + N28RC + N28OM +N28CD) .NE. 0 )
C
      IF ( LHEADR ) THEN
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 1015 )
        ENDIF
        WRITE ( NCAWU , 1015 )
1015    FORMAT ( 1X , 'Reflections are selected by the following ' ,
     2                  'conditions :-' , / )
C
        IF ( N28MN .GT. 0 ) THEN
          INDNAM = L28CN
          DO 1200 I = L28MN , M28MN , MD28MN
          IF (ISSPRT .EQ. 0) THEN
            WRITE ( NCWU , 1105 ) ( ISTORE(J) ,
     2                              J = INDNAM , INDNAM + 2 ) ,
     3                            STORE(I+1)
          ENDIF
            WRITE ( NCAWU , 1105 ) ( ISTORE(J) ,
     2                              J = INDNAM , INDNAM + 2 ) ,
     3                            STORE(I+1)
1105        FORMAT ( 11X , 'Minimum value of ' , 3A4 , ' is ' , F10.5 )
            INDNAM = INDNAM + MD28CN
1200      CONTINUE
        ENDIF
C
        IF ( N28MX .GT. 0 ) THEN
          INDNAM = L28CX
          DO 1400 I = L28MX , M28MX , MD28MX
            IF (ISSPRT .EQ. 0) THEN
             WRITE ( NCWU , 1305 ) ( ISTORE(J) ,
     2                              J = INDNAM , INDNAM + 2 ) ,
     3                            STORE(I+1)
            ENDIF
            WRITE ( NCAWU , 1305 ) ( ISTORE(J) ,
     2                              J = INDNAM , INDNAM + 2 ) ,
     3                            STORE(I+1)
1305        FORMAT ( 11X , 'Maximum value of ' , 3A4 , ' is ' , F10.5 )
            INDNAM = INDNAM + MD28CX
1400      CONTINUE
        ENDIF
C
        IF ( N28RC .GT. 0 ) THEN
          DO 1600 I = L28RC , M28RC , MD28RC
            IF (ISSPRT .EQ. 0) THEN
            WRITE ( NCWU , 1505 ) ( STORE(J) , J = I , I + MD28RC - 1)
            ENDIF
            WRITE ( NCAWU , 1505 ) ( STORE(J) , J = I , I + MD28RC - 1)
1505        FORMAT ( 11X , F6.2 , ' h + ' , F6.2 , ' k + ' ,
     2 F6.2 , ' l must lie in range ' , F6.2 , ' to ' , F6.2 )
1600      CONTINUE
        ENDIF
C
C
        IF ( N28CD .GT. 0 ) THEN
          DO 1850 I = L28CD , M28CD , MD28CD
          IF (ISSPRT .EQ. 0) THEN
            WRITE ( NCWU , 1855 ) ( STORE(J) , J = I , I + MD28CD - 1)
          ENDIF
            WRITE ( NCAWU , 1855 ) ( STORE(J) , J = I , I + MD28CD - 1)
1855        FORMAT ( 7X , F6.2 , ' h + ' , F6.2 , ' k + ' ,
     2 F6.2 , ' l + ' , F6.2 , ' divided by ' , F6.2 ,
     3 ' must be integer'/ )
1850      CONTINUE
        ENDIF
C
        IF ( N28OM .GT. 0 ) THEN
          DO 1800 I = L28OM , M28OM , MD28OM
          IF (ISSPRT .EQ. 0) THEN
            WRITE ( NCWU , 1705 ) ( NINT(STORE(J)), J = I, I+MD28OM-1 )
          ENDIF
            WRITE ( NCAWU, 1705 ) ( NINT(STORE(J)), J = I, I+MD28OM-1 )
1705        FORMAT ( 11X , 'Reflection ' , 3I4 , '  omitted' )
1800      CONTINUE
        ENDIF
C
      ELSE
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 2005 )
        ENDIF
        WRITE ( NCAWU , 2005 )
2005    FORMAT ( 1X , 'Reflections are not subject to restrictions' )
      ENDIF
C
C
      RETURN
      END
C
C
C
C
C
CODE FOR XSUM29
      SUBROUTINE XSUM29
C
C -- ROUTINE TO DISPLAY SUMMARY OF LIST 29
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST29/L29,M29,MD29,N29
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
C
C
C -- BEGIN OUTPUT
C
      IF ( N29 .GT. 0 ) THEN
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 1015 )
        ENDIF
        WRITE ( NCAWU , 1015 )
1015    FORMAT ( 1X , 'Type                 Radius              ' ,
     2 '  Number        Mu      Atomic' , /
     3         1X , '      Covalent  Van der Waals     Ionic  ' ,
     4 '                        weight' )
C
        DO 2000 I = L29 , M29 , MD29
        IF (ISSPRT .EQ. 0) THEN
          WRITE ( NCWU , 1105 ) ( STORE(J) , J = I , I + MD29 - 1 )
        ENDIF
          WRITE ( NCAWU , 1105 ) ( STORE(J) , J = I , I + MD29 - 1 )
1105      FORMAT ( 1X , A4 , 2X , F8.4 , 2X , F13.4 , 2X , F8.4 , 2X ,
     2 F8.3 , 2X , F8.1 , 2X , F10.4 )
2000    CONTINUE
      ELSE
        IF (ISSPRT .EQ. 0) THEN
         WRITE ( NCWU , 2005 )
        ENDIF
        WRITE ( NCAWU , 2005 )
2005    FORMAT ( 1X , 'No element details stored in list 29' )
      ENDIF
C
      RETURN
      END
C
C
C
CODE FOR XSUM30
      SUBROUTINE XSUM30
C
C----- NUMBER OF RECORDS IN COMMON BLOCK
      PARAMETER (MAXBLK = 6)
C----- NUMBER (MAX) OF KEYS IN EACH BLOCK
      PARAMETER (MAXKEY = 13)
      CHARACTER *16 CTYPE(8)
      CHARACTER *25  CKEY(MAXKEY,MAXBLK)
      CHARACTER *80 CLINE, CLOW
C
      CHARACTER *15 CINSTR, CDIR,  CPARAM, CVALUE, CDEF,
     1              CILOW,  CDLOW, CPLOW,  CVLOW,  CDFLOW
C
      DIMENSION IPOINT(32)
C
C
      DIMENSION ISTORE(131072)
C
      COMMON/XDATC/NFL,LFL,NUL
      COMMON/XDATA/STORE(131072)
      COMMON/XLST30/
     1 L30DR,M30DR,MD30DR,N30DR, L30CD,M30CD,MD30CD,N30CD,
     2 L30RF,M30RF,MD30RF,N30RF, L30IX,M30IX,MD30IX,N30IX,
     3 L30AB,M30AB,MD30AB,N30AB, L30GE,M30GE,MD30GE,N30GE,
     4 L30CL,M30CL,MD30CL,N30CL, L30SH,M30SH,MD30SH,N30SH
      COMMON/XUNITS/NCRU,NCRRU,NCWU,NCPU,IPAGE(5),NCARU,NCAWU,
     1 IQUN,JQUN,IERFLG ,IUSFLG,NCSU,NCEXTR,NCQUE,NCCBU,
     2 NCFPU1, NCFPU2, NUCOM
      COMMON /XSSVAL/ ISSISS , ISSVER , ISSMAC(2) , ISSOPS(2) ,
     2 ISSDAT(4) , ISSSEG , ISSOLD , ISSNEW , ISSCIF , ISSFNF ,
     3 ISSREA , ISSWRI , ISSBFS , ISSNBF , ISSPAG , ISSRLI ,
     4 ISSBLI , ISSWLI , ISSRLF , ISSBLF , ISSWLF , ISSPRG(2) ,
     5 ISSLSM , ISSSPD , ISSTIM , ISSL11 , ISSLNM , ISSINI ,
     6 ISSSTA , ISSBAN , ISSSFI , ISSDAR , ISSTML , ISSFLC,
     7 ISSMSG , ISSPRT , ISSEOF , ISSERF , ISSOKF , ISSSCR,
     8 ISSUNK , ISSGEN , ISSFLM , ISSPAS
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      EQUIVALENCE (STORE(1),ISTORE(1))
C
      EQUIVALENCE (L30DR, IPOINT(1))
C
C
      DATA CTYPE /
     1 'OBSERVATIONS', 'CONDITIONS', 'REFINEMENT', 'INDICES',
     2 'ABSORPTION', 'GENERAL', 'COLOUR', 'SHAPE' /
C
      DATA CKEY /
     1 'Total measured', '*', 'No. merged with Friedel',
     2 'R merged with Friedel',  'No. merged no Friedel',
     3 'R merged no Friedel', 7*'*',
C
     1 'Smallest dimension', 'Medium dimension', 'Maximum Dimension',
     2 'No of orienting refs', 'Theta min orienting refs',
     3 'Theta max orienting refs', 'Temperature',
     4 'No of standards', 'Percent decay', 4*'*',
C
     1 'R', 'Rw', 'No. param last cycle', 'Max param refined', 'S',
     2 'Del rho min','Del rho max','max RMS shift','Reflections used',
     3 'Fo min function', 'Restraint min func', 'Total min func','*',
C
     1 'Hmin', 'Hmax', 'Kmin', 'Kmax', 'Lmin', 'Lmax', 'Theta min',
     2 'Theta max', 5*'*',
C
     1 4*'*', 'empirical min', 'Empirical max', 'DIFABS min',
     2 'DIFABS max', 5*'*',
C
     1 'Dobs', 'Dcalc', 'Fooo', 'Mu', 'M', 'Z', 'Flack',
     2 'Flack esd', 5*'*'/
C
C
C
1000    FORMAT ( 1X , 'No ', A,  ' details stored in list 30' )
C
      CALL XPRTCN
C
      DO 5000 J = 1, MAXBLK
      I = 4 * (J-1) +1
      L30 = IPOINT(I)
      MD30 = IPOINT(I+2)
      IF ( MD30 .GT. 0 ) THEN
        IF (ISSPRT .EQ. 0) THEN
         WRITE(NCWU, '(/1X,A/)') CTYPE(J)
        ENDIF
         WRITE(NCAWU, '(/1X,A/)') CTYPE(J)
         DO 3000 K = 1, MD30
          N = K - 2 *(K/2)
            IF (N .EQ. 1) THEN
C----- ODD ITEMS - IF '*' THEN LOOP
              CLINE(1:80) = ' '
              IF (CKEY(K,J) .EQ. '*') GOTO 3000
              WRITE ( CLINE( 1:40) , 1010 ) CKEY(K,J),STORE(K-1+L30)
1010          FORMAT (1X, A, G14.7)
            ELSE
C----- EVEN ITEMS - DONT SAVE '*', BUT PRINT FIRST PART
              IF (CKEY(K,J) .NE. '*')
     1        WRITE ( CLINE(41:80) , 1010 ) CKEY(K,J),STORE(K-1+L30)
              IF (ISSPRT .EQ. 0) THEN
                WRITE (NCWU, '(A)') CLINE
              ENDIF
              WRITE (NCAWU, '(A)') CLINE
            ENDIF
3000     CONTINUE
C----- FINISHED ON AN ODD ITEM, SO MUST PRINT
        IF (N .EQ. 1)  THEN
        IF (ISSPRT .EQ. 0) THEN
            WRITE (NCWU, '(A)') CLINE
        ENDIF
            WRITE (NCAWU, '(A)') CLINE
        ENDIF
3010    CONTINUE
C
        IF ( J .EQ. 2 ) THEN
C----- PARAMETER 10 ON DIRECTIVE 2 IS A CHARACTER STRING
          IPARAM  = 10
          IDIR = 2
          IVAL = ISTORE( L30 +10 -1)
          GOTO 3020
        ELSE IF ( J .EQ. 3 ) THEN
C----- PARAMETER 13 ON DIRECTIVE 3 IS A CHARACTER STRING
          IPARAM  = 13
          IDIR = 3
          IVAL = ISTORE( L30 +13 -1)
          GOTO 3020
        ELSE IF ( J .EQ. 5 ) THEN
C----- PARAMETER 9 ON DIRECTIVE 5 IS A CHARACTER STRING
          IPARAM  = 9
          IDIR = 5
          IVAL = ISTORE( L30AB +9 -1)
          GOTO 3020
        ENDIF
        GOTO 3040
3020    CONTINUE
	IZZZ= KGVAL(CINSTR, CDIR, CPARAM, CVALUE, CDEF,
     1                    33, IDIR, IPARAM, IVAL, JVAL, VAL, JTYPE)
        CLINE(1:80) = ' '
        WRITE(CLINE,1020) CPARAM, CVALUE
        CALL XCCLWC ( CLINE(2:), CLOW(2:))
        CLOW(1:1) = CLINE(1:1)
        IF (ISSPRT .EQ. 0) WRITE(NCWU,1021) CLOW
        WRITE(NCAWU, 1021) CLOW
1020    FORMAT ( A, 3X,A)
1021    FORMAT ( 1X , A)
3040    CONTINUE
      ELSE
        IF (ISSPRT .EQ. 0) THEN
           WRITE ( NCWU , 1000 ) CTYPE(J)
        ENDIF
          WRITE ( NCAWU , 1000 ) CTYPE(J)
      ENDIF
5000  CONTINUE
C
C----- THERE REMAIN SOME PURE TEXT ITEMS
      DO 6000 J = 7,8
      I = 4 * (J-1) +1
      L30 = IPOINT(I)
      MD30 = IPOINT(I+2)
      IF ( MD30 .GT. 0 ) THEN
        CLINE(1:80) = ' '
        WRITE(CLINE,'(A,3X,8A4)') CTYPE(J),
     1 (ISTORE(K), K = L30, L30 + MD30 -1)
        CALL XCCLWC ( CLINE(2:), CLOW(2:))
        CLOW(1:1) = CLINE(1:1)
        IF (ISSPRT .EQ. 0) THEN
            WRITE(NCWU,1021) CLOW
        ENDIF
        WRITE(NCAWU, 1021) CLOW
      ENDIF
6000  CONTINUE
      RETURN
      END
C
C
C
CODE FOR XSUMOP
      SUBROUTINE XSUMOP ( OPER , XLATT , TEXT , LENGTH )
C
C -- CONVERT MATRIX FORM OF SYMMETRY OPERATOR TO TEXT
C
C -- INPUT :-
C
C      OPER        SYMMETRY OPERATOR IN MATRIX FORM
C      XLATT       LATTICE TRANSLATION TO ADD. THIS CAN BE USED
C                  TO GENERATE ALL OPERATORS NEEDED IF THE LATTICE
C                  TYPE CANNOT BE USED TO DO THIS. ( I.E. SNOOPI
C                  DOES NOT UNDERSTAND LATTICE TYPES, SO OPERATORS
C                  EXPLICITLY INCLUDING THE EFFECT OF CENTERING MUST BE
C                  GENERATED )
C
C -- OUTPUT :-
C      TEXT        TEXT REPRESENTATION OF OPERATOR IN FORM
C                    X,Y,Z  OR  X,Y,Z+1/2  ETC.
C      LENGTH      USEABLE LENGTH OF TEXT
C
      DIMENSION OPER(3,4) , XLATT(3)
      CHARACTER*(*) TEXT
C
      CHARACTER*1 AXIS(3)
      CHARACTER*3 CTRANS
C
      COMMON/XCONST/NOWT,PI,TWOPI,TWOPIS,RTD,DTR,
     2 UISO,ZERO,ZEROSQ,VALUE,VALUSQ
C
      DATA AXIS / 'X' , 'Y' , 'Z' /
C
C
C
C
C -- CLEAR TEXT BUFFER
C
      TEXT = ' '
      LENGTH = 0
C
C -- SCAN EACH COMPONENT
C
      DO 2000 I = 1 , 3
        IF ( I .NE. 1 ) THEN
          LENGTH = LENGTH + 1
          TEXT(LENGTH:LENGTH) = ','
        ENDIF
C
C -- DETERMINE 'X' , 'Y' , 'Z' PART
C
      IFIRST = 1
C
        DO 1900 J = 1 , 3
          IOPER = NINT ( OPER(J,I) )
          IF ( IOPER .EQ. 0 ) GO TO 1900
          IF ( IOPER .LT. 0 ) THEN
            LENGTH = LENGTH + 1
            TEXT(LENGTH:LENGTH) = '-'
          ELSE IF ( IFIRST .LE. 0 ) THEN
            LENGTH = LENGTH + 1
            TEXT(LENGTH:LENGTH) = '+'
          ENDIF
          LENGTH = LENGTH + 1
          TEXT(LENGTH:LENGTH) = AXIS(J)
          IFIRST = 0
1900    CONTINUE
C
C -- DETERMINE TRANSLATIONAL PART, BUT ONLY FOR NON-INTEGRAL
C    TRANSLATIONS
C
        TRANS = OPER(I,4) + XLATT(I)
        IF ( ABS( TRANS - REAL(NINT(TRANS)) ) .LE. ZERO ) GO TO 2000
C
C -- CONVERT TRANSLATION TO RATIO OF TWO WHOLE NUMBERS
C
        XMULT = 1.
        FAC = 1.
1950    CONTINUE
        IF ( ABS ( TRANS - REAL ( NINT ( TRANS ) ) ) .GT. ZERO ) THEN
          FAC = FAC + 1.0
          TRANS = TRANS * FAC
          XMULT = XMULT * FAC
          GO TO 1950
        ENDIF
C
C -- CONVERT RATIO FOUND TO PAIR OF INTEGERS, AND REMOVE COMMON FACTORS
C
        ITRANS = NINT ( TRANS )
        IMULT = NINT ( XMULT )
        IFAC = 2
1970    CONTINUE
        IF ( ( IFAC * ( ITRANS / IFAC ) .EQ. ITRANS  ) .AND.
     2       ( IFAC * ( IMULT / IFAC ) .EQ. IMULT )    ) THEN
          ITRANS = ITRANS / IFAC
          IMULT = IMULT / IFAC
          IFAC = IFAC + 1
          IF ( IFAC .LE. NINT ( FAC ) ) GO TO 1970
        ENDIF
C
C -- ADD TRANSLATIONAL COMPONENT TO OUTPUT STRING. ( NUMERATOR MUST
C    BE PRECEDED BY A PLUS OR MINUS SIGN, HENCE FORMAT 'SP' )
C
        WRITE ( CTRANS , '(SP,I3)' ) ITRANS
        DO 1980 J = 1 , 3
          IF ( CTRANS(J:J) .NE. ' ' ) THEN
            LENGTH = LENGTH + 1
            TEXT(LENGTH:LENGTH) = CTRANS(J:J)
          ENDIF
1980    CONTINUE
C
        LENGTH = LENGTH + 1
        TEXT(LENGTH:LENGTH) = '/'
C
        WRITE ( CTRANS , '(I3)' ) IMULT
        DO 1990 J = 1 , 3
          IF ( CTRANS(J:J) .NE. ' ' ) THEN
            LENGTH = LENGTH + 1
            TEXT(LENGTH:LENGTH) = CTRANS(J:J)
          ENDIF
1990    CONTINUE
C
C
2000  CONTINUE
C
C
      RETURN
      END


